# Asterix specifications

# This file is generated, DO NOT EDIT!
# For more details, see:
#     - https://github.com/zoranbosnjak/asterix-specs

from asterix.base import *

asterix_specs_ref = "git:ffe15c54a0c7bfc7799ec7798e85148d586b1318"
asterix_specs_date = "2024-08-26T11:50:15+02:00"
code_generator_version = "0.1.0"

# Asterix types

Content_0_Arg: TypeAlias = int
class Content_0(ContentRaw):
    pass

RuleContent_0_Arg: TypeAlias = Content_0_Arg
class RuleContent_0(RuleContentContextFree):
    cv_content = Content_0

    @property
    def content(self) -> Content_0:
        return self._get_content() # type: ignore

Variation_164_Arg: TypeAlias = RuleContent_0_Arg
class Variation_164(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_164_Arg) -> "Variation_164":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_158_Arg: TypeAlias = Variation_164_Arg
class RuleVariation_158(RuleVariationContextFree):
    cv_variation = Variation_164

    @classmethod
    def create(cls, arg : RuleVariation_158_Arg) -> "RuleVariation_158":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_164:
        return self.arg # type: ignore

NonSpare_1645_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_1645(NonSpare):
    cv_name = "SAC"
    cv_title = "System Area Code"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_1645_Arg) -> "NonSpare_1645":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_852_Arg: TypeAlias = NonSpare_1645_Arg
class Item_852(Item):
    cv_non_spare = NonSpare_1645

    @classmethod
    def create(cls, arg : Item_852_Arg) -> "Item_852":
        return cls._create(arg) # type: ignore

NonSpare_1700_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_1700(NonSpare):
    cv_name = "SIC"
    cv_title = "System Identification Code"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_1700_Arg) -> "NonSpare_1700":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_883_Arg: TypeAlias = NonSpare_1700_Arg
class Item_883(Item):
    cv_non_spare = NonSpare_1700

    @classmethod
    def create(cls, arg : Item_883_Arg) -> "Item_883":
        return cls._create(arg) # type: ignore

Variation_1186_Arg_Group = Tuple[Union[RuleVariation_158_Arg, Tuple[Literal["SAC"], RuleVariation_158_Arg]], Union[RuleVariation_158_Arg, Tuple[Literal["SIC"], RuleVariation_158_Arg]]]
Variation_1186_Arg: TypeAlias = Union[int, Variation_1186_Arg_Group]
class Variation_1186(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_852, 8), (Item_883, 8)]
    cv_items_dict = {"SAC": RuleVariation_158, "SIC": RuleVariation_158}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAC"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIC"]) -> RuleVariation_158:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAC"], Literal["SIC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAC"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["SIC"]) -> RuleVariation_158:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1186_Arg) -> 'Variation_1186':
        return cls._create(arg) # type: ignore

RuleVariation_1135_Arg: TypeAlias = Variation_1186_Arg
class RuleVariation_1135(RuleVariationContextFree):
    cv_variation = Variation_1186

    @classmethod
    def create(cls, arg : RuleVariation_1135_Arg) -> "RuleVariation_1135":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1186:
        return self.arg # type: ignore

NonSpare_35_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_35(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_35_Arg) -> "NonSpare_35":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_35(UapItem):
    cv_non_spare = NonSpare_35

Content_426_Arg: TypeAlias = int
class Content_426(ContentTable):
    cv_values = {0: "Plot", 1: "Track"}

RuleContent_426_Arg: TypeAlias = Content_426_Arg
class RuleContent_426(RuleContentContextFree):
    cv_content = Content_426

    @property
    def content(self) -> Content_426:
        return self._get_content() # type: ignore

Variation_71_Arg: TypeAlias = RuleContent_426_Arg
class Variation_71(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_426

    @classmethod
    def create(cls, arg : Variation_71_Arg) -> "Variation_71":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_426:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_426:
        return self.rule.content

RuleVariation_71_Arg: TypeAlias = Variation_71_Arg
class RuleVariation_71(RuleVariationContextFree):
    cv_variation = Variation_71

    @classmethod
    def create(cls, arg : RuleVariation_71_Arg) -> "RuleVariation_71":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_71:
        return self.arg # type: ignore

Content_18_Arg: TypeAlias = int
class Content_18(ContentTable):
    cv_values = {0: "Actual plot or track", 1: "Simulated plot or track"}

RuleContent_18_Arg: TypeAlias = Content_18_Arg
class RuleContent_18(RuleContentContextFree):
    cv_content = Content_18

    @property
    def content(self) -> Content_18:
        return self._get_content() # type: ignore

Variation_401_Arg: TypeAlias = RuleContent_18_Arg
class Variation_401(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_18

    @classmethod
    def create(cls, arg : Variation_401_Arg) -> "Variation_401":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_18:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_18:
        return self.rule.content

RuleVariation_390_Arg: TypeAlias = Variation_401_Arg
class RuleVariation_390(RuleVariationContextFree):
    cv_variation = Variation_401

    @classmethod
    def create(cls, arg : RuleVariation_390_Arg) -> "RuleVariation_390":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_401:
        return self.arg # type: ignore

Content_346_Arg: TypeAlias = int
class Content_346(ContentTable):
    cv_values = {0: "No detection", 1: "Sole primary detection", 2: "Sole secondary detection", 3: "Combined primary and secondary detection"}

RuleContent_346_Arg: TypeAlias = Content_346_Arg
class RuleContent_346(RuleContentContextFree):
    cv_content = Content_346

    @property
    def content(self) -> Content_346:
        return self._get_content() # type: ignore

Variation_590_Arg: TypeAlias = RuleContent_346_Arg
class Variation_590(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_346

    @classmethod
    def create(cls, arg : Variation_590_Arg) -> "Variation_590":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_346:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_346:
        return self.rule.content

RuleVariation_579_Arg: TypeAlias = Variation_590_Arg
class RuleVariation_579(RuleVariationContextFree):
    cv_variation = Variation_590

    @classmethod
    def create(cls, arg : RuleVariation_579_Arg) -> "RuleVariation_579":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_590:
        return self.arg # type: ignore

Content_482_Arg: TypeAlias = int
class Content_482(ContentTable):
    cv_values = {0: "Target report from antenna 1", 1: "Target report from antenna 2"}

RuleContent_482_Arg: TypeAlias = Content_482_Arg
class RuleContent_482(RuleContentContextFree):
    cv_content = Content_482

    @property
    def content(self) -> Content_482:
        return self._get_content() # type: ignore

Variation_751_Arg: TypeAlias = RuleContent_482_Arg
class Variation_751(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_482

    @classmethod
    def create(cls, arg : Variation_751_Arg) -> "Variation_751":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_482:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_482:
        return self.rule.content

RuleVariation_740_Arg: TypeAlias = Variation_751_Arg
class RuleVariation_740(RuleVariationContextFree):
    cv_variation = Variation_751

    @classmethod
    def create(cls, arg : RuleVariation_740_Arg) -> "RuleVariation_740":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_751:
        return self.arg # type: ignore

Content_151_Arg: TypeAlias = int
class Content_151(ContentTable):
    cv_values = {0: "Default", 1: "Special Position Identification"}

RuleContent_151_Arg: TypeAlias = Content_151_Arg
class RuleContent_151(RuleContentContextFree):
    cv_content = Content_151

    @property
    def content(self) -> Content_151:
        return self._get_content() # type: ignore

Variation_835_Arg: TypeAlias = RuleContent_151_Arg
class Variation_835(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_151

    @classmethod
    def create(cls, arg : Variation_835_Arg) -> "Variation_835":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_151:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_151:
        return self.rule.content

RuleVariation_805_Arg: TypeAlias = Variation_835_Arg
class RuleVariation_805(RuleVariationContextFree):
    cv_variation = Variation_835

    @classmethod
    def create(cls, arg : RuleVariation_805_Arg) -> "RuleVariation_805":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_835:
        return self.arg # type: ignore

Content_139_Arg: TypeAlias = int
class Content_139(ContentTable):
    cv_values = {0: "Default", 1: "Plot or track from a fixed transponder"}

RuleContent_139_Arg: TypeAlias = Content_139_Arg
class RuleContent_139(RuleContentContextFree):
    cv_content = Content_139

    @property
    def content(self) -> Content_139:
        return self._get_content() # type: ignore

Variation_914_Arg: TypeAlias = RuleContent_139_Arg
class Variation_914(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_139

    @classmethod
    def create(cls, arg : Variation_914_Arg) -> "Variation_914":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_139:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_139:
        return self.rule.content

RuleVariation_884_Arg: TypeAlias = Variation_914_Arg
class RuleVariation_884(RuleVariationContextFree):
    cv_variation = Variation_914

    @classmethod
    def create(cls, arg : RuleVariation_884_Arg) -> "RuleVariation_884":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_914:
        return self.arg # type: ignore

Content_155_Arg: TypeAlias = int
class Content_155(ContentTable):
    cv_values = {0: "Default", 1: "Test target indicator"}

RuleContent_155_Arg: TypeAlias = Content_155_Arg
class RuleContent_155(RuleContentContextFree):
    cv_content = Content_155

    @property
    def content(self) -> Content_155:
        return self._get_content() # type: ignore

Variation_35_Arg: TypeAlias = RuleContent_155_Arg
class Variation_35(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_155

    @classmethod
    def create(cls, arg : Variation_35_Arg) -> "Variation_35":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_155:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_155:
        return self.rule.content

RuleVariation_35_Arg: TypeAlias = Variation_35_Arg
class RuleVariation_35(RuleVariationContextFree):
    cv_variation = Variation_35

    @classmethod
    def create(cls, arg : RuleVariation_35_Arg) -> "RuleVariation_35":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_35:
        return self.arg # type: ignore

Content_158_Arg: TypeAlias = int
class Content_158(ContentTable):
    cv_values = {0: "Default", 1: "Unlawful interference (code 7500)", 2: "Radio-communication failure (code 7600)", 3: "Emergency (code 7700)"}

RuleContent_158_Arg: TypeAlias = Content_158_Arg
class RuleContent_158(RuleContentContextFree):
    cv_content = Content_158

    @property
    def content(self) -> Content_158:
        return self._get_content() # type: ignore

Variation_465_Arg: TypeAlias = RuleContent_158_Arg
class Variation_465(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_158

    @classmethod
    def create(cls, arg : Variation_465_Arg) -> "Variation_465":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_158:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_158:
        return self.rule.content

RuleVariation_454_Arg: TypeAlias = Variation_465_Arg
class RuleVariation_454(RuleVariationContextFree):
    cv_variation = Variation_465

    @classmethod
    def create(cls, arg : RuleVariation_454_Arg) -> "RuleVariation_454":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_465:
        return self.arg # type: ignore

Content_116_Arg: TypeAlias = int
class Content_116(ContentTable):
    cv_values = {0: "Default", 1: "Military emergency"}

RuleContent_116_Arg: TypeAlias = Content_116_Arg
class RuleContent_116(RuleContentContextFree):
    cv_content = Content_116

    @property
    def content(self) -> Content_116:
        return self._get_content() # type: ignore

Variation_624_Arg: TypeAlias = RuleContent_116_Arg
class Variation_624(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_116

    @classmethod
    def create(cls, arg : Variation_624_Arg) -> "Variation_624":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_116:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_116:
        return self.rule.content

RuleVariation_613_Arg: TypeAlias = Variation_624_Arg
class RuleVariation_613(RuleVariationContextFree):
    cv_variation = Variation_624

    @classmethod
    def create(cls, arg : RuleVariation_613_Arg) -> "RuleVariation_613":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_624:
        return self.arg # type: ignore

Content_117_Arg: TypeAlias = int
class Content_117(ContentTable):
    cv_values = {0: "Default", 1: "Military identification"}

RuleContent_117_Arg: TypeAlias = Content_117_Arg
class RuleContent_117(RuleContentContextFree):
    cv_content = Content_117

    @property
    def content(self) -> Content_117:
        return self._get_content() # type: ignore

Variation_705_Arg: TypeAlias = RuleContent_117_Arg
class Variation_705(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_117

    @classmethod
    def create(cls, arg : Variation_705_Arg) -> "Variation_705":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_117:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_117:
        return self.rule.content

RuleVariation_694_Arg: TypeAlias = Variation_705_Arg
class RuleVariation_694(RuleVariationContextFree):
    cv_variation = Variation_705

    @classmethod
    def create(cls, arg : RuleVariation_694_Arg) -> "RuleVariation_694":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_705:
        return self.arg # type: ignore

NonSpare_1948_Arg: TypeAlias = RuleVariation_71_Arg
class NonSpare_1948(NonSpare):
    cv_name = "TYP"
    cv_title = ""
    cv_rule = RuleVariation_71

    @classmethod
    def create(cls, arg : NonSpare_1948_Arg) -> "NonSpare_1948":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_71:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_71:
        return self.rule.variation

Item_1068_Arg: TypeAlias = NonSpare_1948_Arg
class Item_1068(Item):
    cv_non_spare = NonSpare_1948

    @classmethod
    def create(cls, arg : Item_1068_Arg) -> "Item_1068":
        return cls._create(arg) # type: ignore

NonSpare_1716_Arg: TypeAlias = RuleVariation_390_Arg
class NonSpare_1716(NonSpare):
    cv_name = "SIM"
    cv_title = ""
    cv_rule = RuleVariation_390

    @classmethod
    def create(cls, arg : NonSpare_1716_Arg) -> "NonSpare_1716":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_390:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_401:
        return self.rule.variation

Item_897_Arg: TypeAlias = NonSpare_1716_Arg
class Item_897(Item):
    cv_non_spare = NonSpare_1716

    @classmethod
    def create(cls, arg : Item_897_Arg) -> "Item_897":
        return cls._create(arg) # type: ignore

NonSpare_1758_Arg: TypeAlias = RuleVariation_579_Arg
class NonSpare_1758(NonSpare):
    cv_name = "SSRPSR"
    cv_title = "Radar Detection in Last Antenna Scan"
    cv_rule = RuleVariation_579

    @classmethod
    def create(cls, arg : NonSpare_1758_Arg) -> "NonSpare_1758":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_579:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_590:
        return self.rule.variation

Item_929_Arg: TypeAlias = NonSpare_1758_Arg
class Item_929(Item):
    cv_non_spare = NonSpare_1758

    @classmethod
    def create(cls, arg : Item_929_Arg) -> "Item_929":
        return cls._create(arg) # type: ignore

NonSpare_606_Arg: TypeAlias = RuleVariation_740_Arg
class NonSpare_606(NonSpare):
    cv_name = "ANT"
    cv_title = ""
    cv_rule = RuleVariation_740

    @classmethod
    def create(cls, arg : NonSpare_606_Arg) -> "NonSpare_606":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_740:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_751:
        return self.rule.variation

Item_74_Arg: TypeAlias = NonSpare_606_Arg
class Item_74(Item):
    cv_non_spare = NonSpare_606

    @classmethod
    def create(cls, arg : Item_74_Arg) -> "Item_74":
        return cls._create(arg) # type: ignore

NonSpare_1731_Arg: TypeAlias = RuleVariation_805_Arg
class NonSpare_1731(NonSpare):
    cv_name = "SPI"
    cv_title = ""
    cv_rule = RuleVariation_805

    @classmethod
    def create(cls, arg : NonSpare_1731_Arg) -> "NonSpare_1731":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_805:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_835:
        return self.rule.variation

Item_910_Arg: TypeAlias = NonSpare_1731_Arg
class Item_910(Item):
    cv_non_spare = NonSpare_1731

    @classmethod
    def create(cls, arg : Item_910_Arg) -> "Item_910":
        return cls._create(arg) # type: ignore

NonSpare_1529_Arg: TypeAlias = RuleVariation_884_Arg
class NonSpare_1529(NonSpare):
    cv_name = "RAB"
    cv_title = ""
    cv_rule = RuleVariation_884

    @classmethod
    def create(cls, arg : NonSpare_1529_Arg) -> "NonSpare_1529":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_884:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_914:
        return self.rule.variation

Item_765_Arg: TypeAlias = NonSpare_1529_Arg
class Item_765(Item):
    cv_non_spare = NonSpare_1529

    @classmethod
    def create(cls, arg : Item_765_Arg) -> "Item_765":
        return cls._create(arg) # type: ignore

NonSpare_1924_Arg: TypeAlias = RuleVariation_35_Arg
class NonSpare_1924(NonSpare):
    cv_name = "TST"
    cv_title = ""
    cv_rule = RuleVariation_35

    @classmethod
    def create(cls, arg : NonSpare_1924_Arg) -> "NonSpare_1924":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_35:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_35:
        return self.rule.variation

Item_1047_Arg: TypeAlias = NonSpare_1924_Arg
class Item_1047(Item):
    cv_non_spare = NonSpare_1924

    @classmethod
    def create(cls, arg : Item_1047_Arg) -> "Item_1047":
        return cls._create(arg) # type: ignore

NonSpare_894_Arg: TypeAlias = RuleVariation_454_Arg
class NonSpare_894(NonSpare):
    cv_name = "DS1DS2"
    cv_title = "Radar Detection in Last Antenna Scan"
    cv_rule = RuleVariation_454

    @classmethod
    def create(cls, arg : NonSpare_894_Arg) -> "NonSpare_894":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_454:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_465:
        return self.rule.variation

Item_273_Arg: TypeAlias = NonSpare_894_Arg
class Item_273(Item):
    cv_non_spare = NonSpare_894

    @classmethod
    def create(cls, arg : Item_273_Arg) -> "Item_273":
        return cls._create(arg) # type: ignore

NonSpare_1255_Arg: TypeAlias = RuleVariation_613_Arg
class NonSpare_1255(NonSpare):
    cv_name = "ME"
    cv_title = ""
    cv_rule = RuleVariation_613

    @classmethod
    def create(cls, arg : NonSpare_1255_Arg) -> "NonSpare_1255":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_613:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_624:
        return self.rule.variation

Item_539_Arg: TypeAlias = NonSpare_1255_Arg
class Item_539(Item):
    cv_non_spare = NonSpare_1255

    @classmethod
    def create(cls, arg : Item_539_Arg) -> "Item_539":
        return cls._create(arg) # type: ignore

NonSpare_1273_Arg: TypeAlias = RuleVariation_694_Arg
class NonSpare_1273(NonSpare):
    cv_name = "MI"
    cv_title = ""
    cv_rule = RuleVariation_694

    @classmethod
    def create(cls, arg : NonSpare_1273_Arg) -> "NonSpare_1273":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_694:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_705:
        return self.rule.variation

Item_546_Arg: TypeAlias = NonSpare_1273_Arg
class Item_546(Item):
    cv_non_spare = NonSpare_1273

    @classmethod
    def create(cls, arg : Item_546_Arg) -> "Item_546":
        return cls._create(arg) # type: ignore

Item_24_Arg: TypeAlias = int
class Item_24(Spare):
    cv_bit_offset8 = 5
    cv_bit_size = 2

Variation_1380_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_71_Arg, Tuple[Literal["TYP"], RuleVariation_71_Arg]], Union[RuleVariation_390_Arg, Tuple[Literal["SIM"], RuleVariation_390_Arg]], Union[RuleVariation_579_Arg, Tuple[Literal["SSRPSR"], RuleVariation_579_Arg]], Union[RuleVariation_740_Arg, Tuple[Literal["ANT"], RuleVariation_740_Arg]], Union[RuleVariation_805_Arg, Tuple[Literal["SPI"], RuleVariation_805_Arg]], Union[RuleVariation_884_Arg, Tuple[Literal["RAB"], RuleVariation_884_Arg]], None]]
Variation_1380_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_35_Arg, Tuple[Literal["TST"], RuleVariation_35_Arg]], Union[RuleVariation_454_Arg, Tuple[Literal["DS1DS2"], RuleVariation_454_Arg]], Union[RuleVariation_613_Arg, Tuple[Literal["ME"], RuleVariation_613_Arg]], Union[RuleVariation_694_Arg, Tuple[Literal["MI"], RuleVariation_694_Arg]], int, None]]
Variation_1380_Arg: TypeAlias = Union[
    Tuple[Variation_1380_Arg_Group_1],
    Tuple[Variation_1380_Arg_Group_1, Variation_1380_Arg_Group_2],
]
class Variation_1380(Extended):
    cv_items_list = [[(Item_1068, 1), (Item_897, 1), (Item_929, 2), (Item_74, 1), (Item_910, 1), (Item_765, 1), None], [(Item_1047, 1), (Item_273, 2), (Item_539, 1), (Item_546, 1), (Item_24, 2), None]]

    @classmethod
    def create(cls, arg : Variation_1380_Arg) -> 'Variation_1380':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_71:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> RuleVariation_390:
        ...
    @overload
    def get_item(self, key : Literal["SSRPSR"]) -> RuleVariation_579:
        ...
    @overload
    def get_item(self, key : Literal["ANT"]) -> RuleVariation_740:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> RuleVariation_805:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_884:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_35]:
        ...
    @overload
    def get_item(self, key : Literal["DS1DS2"]) -> Optional[RuleVariation_454]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_613]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_694]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1303_Arg: TypeAlias = Variation_1380_Arg
class RuleVariation_1303(RuleVariationContextFree):
    cv_variation = Variation_1380

    @classmethod
    def create(cls, arg : RuleVariation_1303_Arg) -> "RuleVariation_1303":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1380:
        return self.arg # type: ignore

NonSpare_86_Arg: TypeAlias = RuleVariation_1303_Arg
class NonSpare_86(NonSpare):
    cv_name = "020"
    cv_title = "Target Report Descriptor"
    cv_rule = RuleVariation_1303

    @classmethod
    def create(cls, arg : NonSpare_86_Arg) -> "NonSpare_86":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1303:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1380:
        return self.rule.variation

class UapItem_86(UapItem):
    cv_non_spare = NonSpare_86

Content_765_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
class Content_765(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 7.8125e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

RuleContent_764_Arg: TypeAlias = Content_765_Arg
class RuleContent_764(RuleContentContextFree):
    cv_content = Content_765

    @property
    def content(self) -> Content_765:
        return self._get_content() # type: ignore

Variation_330_Arg: TypeAlias = RuleContent_764_Arg
class Variation_330(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_764

    @classmethod
    def create(cls, arg : Variation_330_Arg) -> "Variation_330":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_764:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_765:
        return self.rule.content

RuleVariation_323_Arg: TypeAlias = Variation_330_Arg
class RuleVariation_323(RuleVariationContextFree):
    cv_variation = Variation_330

    @classmethod
    def create(cls, arg : RuleVariation_323_Arg) -> "RuleVariation_323":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_330:
        return self.arg # type: ignore

NonSpare_1579_Arg: TypeAlias = RuleVariation_323_Arg
class NonSpare_1579(NonSpare):
    cv_name = "RHO"
    cv_title = ""
    cv_rule = RuleVariation_323

    @classmethod
    def create(cls, arg : NonSpare_1579_Arg) -> "NonSpare_1579":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_323:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_330:
        return self.rule.variation

Item_810_Arg: TypeAlias = NonSpare_1579_Arg
class Item_810(Item):
    cv_non_spare = NonSpare_1579

    @classmethod
    def create(cls, arg : Item_810_Arg) -> "Item_810":
        return cls._create(arg) # type: ignore

Content_790_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_790(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 5.4931640625e-3
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_789_Arg: TypeAlias = Content_790_Arg
class RuleContent_789(RuleContentContextFree):
    cv_content = Content_790

    @property
    def content(self) -> Content_790:
        return self._get_content() # type: ignore

Variation_341_Arg: TypeAlias = RuleContent_789_Arg
class Variation_341(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_789

    @classmethod
    def create(cls, arg : Variation_341_Arg) -> "Variation_341":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_789:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_790:
        return self.rule.content

RuleVariation_334_Arg: TypeAlias = Variation_341_Arg
class RuleVariation_334(RuleVariationContextFree):
    cv_variation = Variation_341

    @classmethod
    def create(cls, arg : RuleVariation_334_Arg) -> "RuleVariation_334":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_341:
        return self.arg # type: ignore

NonSpare_1847_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_1847(NonSpare):
    cv_name = "THETA"
    cv_title = ""
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_1847_Arg) -> "NonSpare_1847":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Item_991_Arg: TypeAlias = NonSpare_1847_Arg
class Item_991(Item):
    cv_non_spare = NonSpare_1847

    @classmethod
    def create(cls, arg : Item_991_Arg) -> "Item_991":
        return cls._create(arg) # type: ignore

Variation_1172_Arg_Group = Tuple[Union[RuleVariation_323_Arg, Tuple[Literal["RHO"], RuleVariation_323_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["THETA"], RuleVariation_334_Arg]]]
Variation_1172_Arg: TypeAlias = Union[int, Variation_1172_Arg_Group]
class Variation_1172(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_810, 16), (Item_991, 16)]
    cv_items_dict = {"RHO": RuleVariation_323, "THETA": RuleVariation_334}

    @overload
    @classmethod
    def spec(cls, key : Literal["RHO"]) -> RuleVariation_323:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["THETA"]) -> RuleVariation_334:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RHO"], Literal["THETA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RHO"]) -> RuleVariation_323:
        ...
    @overload
    def get_item(self, key : Literal["THETA"]) -> RuleVariation_334:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1172_Arg) -> 'Variation_1172':
        return cls._create(arg) # type: ignore

RuleVariation_1124_Arg: TypeAlias = Variation_1172_Arg
class RuleVariation_1124(RuleVariationContextFree):
    cv_variation = Variation_1172

    @classmethod
    def create(cls, arg : RuleVariation_1124_Arg) -> "RuleVariation_1124":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1172:
        return self.arg # type: ignore

NonSpare_136_Arg: TypeAlias = RuleVariation_1124_Arg
class NonSpare_136(NonSpare):
    cv_name = "040"
    cv_title = "Measured Position in Polar Co-ordinates"
    cv_rule = RuleVariation_1124

    @classmethod
    def create(cls, arg : NonSpare_136_Arg) -> "NonSpare_136":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1124:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1172:
        return self.rule.variation

class UapItem_136(UapItem):
    cv_non_spare = NonSpare_136

Content_56_Arg: TypeAlias = int
class Content_56(ContentTable):
    cv_values = {0: "Code validated", 1: "Code not validated"}

RuleContent_56_Arg: TypeAlias = Content_56_Arg
class RuleContent_56(RuleContentContextFree):
    cv_content = Content_56

    @property
    def content(self) -> Content_56:
        return self._get_content() # type: ignore

Variation_15_Arg: TypeAlias = RuleContent_56_Arg
class Variation_15(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_56

    @classmethod
    def create(cls, arg : Variation_15_Arg) -> "Variation_15":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_56:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_56:
        return self.rule.content

RuleVariation_15_Arg: TypeAlias = Variation_15_Arg
class RuleVariation_15(RuleVariationContextFree):
    cv_variation = Variation_15

    @classmethod
    def create(cls, arg : RuleVariation_15_Arg) -> "RuleVariation_15":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_15:
        return self.arg # type: ignore

NonSpare_1981_Arg: TypeAlias = RuleVariation_15_Arg
class NonSpare_1981(NonSpare):
    cv_name = "V"
    cv_title = ""
    cv_rule = RuleVariation_15

    @classmethod
    def create(cls, arg : NonSpare_1981_Arg) -> "NonSpare_1981":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_15:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_15:
        return self.rule.variation

Item_1099_Arg: TypeAlias = NonSpare_1981_Arg
class Item_1099(Item):
    cv_non_spare = NonSpare_1981

    @classmethod
    def create(cls, arg : Item_1099_Arg) -> "Item_1099":
        return cls._create(arg) # type: ignore

Content_97_Arg: TypeAlias = int
class Content_97(ContentTable):
    cv_values = {0: "Default", 1: "Garbled code"}

RuleContent_97_Arg: TypeAlias = Content_97_Arg
class RuleContent_97(RuleContentContextFree):
    cv_content = Content_97

    @property
    def content(self) -> Content_97:
        return self._get_content() # type: ignore

Variation_405_Arg: TypeAlias = RuleContent_97_Arg
class Variation_405(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_97

    @classmethod
    def create(cls, arg : Variation_405_Arg) -> "Variation_405":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_97:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_97:
        return self.rule.content

RuleVariation_394_Arg: TypeAlias = Variation_405_Arg
class RuleVariation_394(RuleVariationContextFree):
    cv_variation = Variation_405

    @classmethod
    def create(cls, arg : RuleVariation_394_Arg) -> "RuleVariation_394":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_405:
        return self.arg # type: ignore

NonSpare_1001_Arg: TypeAlias = RuleVariation_394_Arg
class NonSpare_1001(NonSpare):
    cv_name = "G"
    cv_title = ""
    cv_rule = RuleVariation_394

    @classmethod
    def create(cls, arg : NonSpare_1001_Arg) -> "NonSpare_1001":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_394:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_405:
        return self.rule.variation

Item_353_Arg: TypeAlias = NonSpare_1001_Arg
class Item_353(Item):
    cv_non_spare = NonSpare_1001

    @classmethod
    def create(cls, arg : Item_353_Arg) -> "Item_353":
        return cls._create(arg) # type: ignore

Content_290_Arg: TypeAlias = int
class Content_290(ContentTable):
    cv_values = {0: "Mode-3/A code derived from the reply of the transponder", 1: "Smoothed Mode-3/A code as provided by a local tracker"}

RuleContent_290_Arg: TypeAlias = Content_290_Arg
class RuleContent_290(RuleContentContextFree):
    cv_content = Content_290

    @property
    def content(self) -> Content_290:
        return self._get_content() # type: ignore

Variation_552_Arg: TypeAlias = RuleContent_290_Arg
class Variation_552(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_290

    @classmethod
    def create(cls, arg : Variation_552_Arg) -> "Variation_552":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_290:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_290:
        return self.rule.content

RuleVariation_541_Arg: TypeAlias = Variation_552_Arg
class RuleVariation_541(RuleVariationContextFree):
    cv_variation = Variation_552

    @classmethod
    def create(cls, arg : RuleVariation_541_Arg) -> "RuleVariation_541":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_552:
        return self.arg # type: ignore

NonSpare_1134_Arg: TypeAlias = RuleVariation_541_Arg
class NonSpare_1134(NonSpare):
    cv_name = "L"
    cv_title = ""
    cv_rule = RuleVariation_541

    @classmethod
    def create(cls, arg : NonSpare_1134_Arg) -> "NonSpare_1134":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_541:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_552:
        return self.rule.variation

Item_452_Arg: TypeAlias = NonSpare_1134_Arg
class Item_452(Item):
    cv_non_spare = NonSpare_1134

    @classmethod
    def create(cls, arg : Item_452_Arg) -> "Item_452":
        return cls._create(arg) # type: ignore

Item_16_Arg: TypeAlias = int
class Item_16(Spare):
    cv_bit_offset8 = 3
    cv_bit_size = 1

Content_608_Arg: TypeAlias = Union[int, str]
class Content_608(ContentString):
    cv_string_type = StringOctal

RuleContent_608_Arg: TypeAlias = Content_608_Arg
class RuleContent_608(RuleContentContextFree):
    cv_content = Content_608

    @property
    def content(self) -> Content_608:
        return self._get_content() # type: ignore

Variation_806_Arg: TypeAlias = RuleContent_608_Arg
class Variation_806(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 12
    cv_rule = RuleContent_608

    @classmethod
    def create(cls, arg : Variation_806_Arg) -> "Variation_806":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_608:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_608:
        return self.rule.content

RuleVariation_776_Arg: TypeAlias = Variation_806_Arg
class RuleVariation_776(RuleVariationContextFree):
    cv_variation = Variation_806

    @classmethod
    def create(cls, arg : RuleVariation_776_Arg) -> "RuleVariation_776":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_806:
        return self.arg # type: ignore

NonSpare_1300_Arg: TypeAlias = RuleVariation_776_Arg
class NonSpare_1300(NonSpare):
    cv_name = "MODE3A"
    cv_title = "Mode-3/A Reply in Octal Representation"
    cv_rule = RuleVariation_776

    @classmethod
    def create(cls, arg : NonSpare_1300_Arg) -> "NonSpare_1300":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_776:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_806:
        return self.rule.variation

Item_572_Arg: TypeAlias = NonSpare_1300_Arg
class Item_572(Item):
    cv_non_spare = NonSpare_1300

    @classmethod
    def create(cls, arg : Item_572_Arg) -> "Item_572":
        return cls._create(arg) # type: ignore

Variation_1259_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_541_Arg, Tuple[Literal["L"], RuleVariation_541_Arg]], int, Union[RuleVariation_776_Arg, Tuple[Literal["MODE3A"], RuleVariation_776_Arg]]]
Variation_1259_Arg: TypeAlias = Union[int, Variation_1259_Arg_Group]
class Variation_1259(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1099, 1), (Item_353, 1), (Item_452, 1), (Item_16, 1), (Item_572, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "L": RuleVariation_541, "MODE3A": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_541:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_541:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1259_Arg) -> 'Variation_1259':
        return cls._create(arg) # type: ignore

RuleVariation_1189_Arg: TypeAlias = Variation_1259_Arg
class RuleVariation_1189(RuleVariationContextFree):
    cv_variation = Variation_1259

    @classmethod
    def create(cls, arg : RuleVariation_1189_Arg) -> "RuleVariation_1189":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1259:
        return self.arg # type: ignore

NonSpare_209_Arg: TypeAlias = RuleVariation_1189_Arg
class NonSpare_209(NonSpare):
    cv_name = "070"
    cv_title = "Mode-3/A Code in Octal Representation"
    cv_rule = RuleVariation_1189

    @classmethod
    def create(cls, arg : NonSpare_209_Arg) -> "NonSpare_209":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1189:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1259:
        return self.rule.variation

class UapItem_209(UapItem):
    cv_non_spare = NonSpare_209

Content_650_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["FL"]]]
class Content_650(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.25
    cv_unit = "FL"

    def as_quantity(self, cv_unit : Optional[Literal["FL"]] = None) -> float:
        return self._as_quantity()

RuleContent_650_Arg: TypeAlias = Content_650_Arg
class RuleContent_650(RuleContentContextFree):
    cv_content = Content_650

    @property
    def content(self) -> Content_650:
        return self._get_content() # type: ignore

Variation_606_Arg: TypeAlias = RuleContent_650_Arg
class Variation_606(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_650

    @classmethod
    def create(cls, arg : Variation_606_Arg) -> "Variation_606":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_650:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_650:
        return self.rule.content

RuleVariation_595_Arg: TypeAlias = Variation_606_Arg
class RuleVariation_595(RuleVariationContextFree):
    cv_variation = Variation_606

    @classmethod
    def create(cls, arg : RuleVariation_595_Arg) -> "RuleVariation_595":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_606:
        return self.arg # type: ignore

NonSpare_1061_Arg: TypeAlias = RuleVariation_595_Arg
class NonSpare_1061(NonSpare):
    cv_name = "HGT"
    cv_title = "Mode-C HEIGHT"
    cv_rule = RuleVariation_595

    @classmethod
    def create(cls, arg : NonSpare_1061_Arg) -> "NonSpare_1061":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_595:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_606:
        return self.rule.variation

Item_393_Arg: TypeAlias = NonSpare_1061_Arg
class Item_393(Item):
    cv_non_spare = NonSpare_1061

    @classmethod
    def create(cls, arg : Item_393_Arg) -> "Item_393":
        return cls._create(arg) # type: ignore

Variation_1251_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_595_Arg, Tuple[Literal["HGT"], RuleVariation_595_Arg]]]
Variation_1251_Arg: TypeAlias = Union[int, Variation_1251_Arg_Group]
class Variation_1251(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1099, 1), (Item_353, 1), (Item_393, 14)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "HGT": RuleVariation_595}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HGT"]) -> RuleVariation_595:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["HGT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["HGT"]) -> RuleVariation_595:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1251_Arg) -> 'Variation_1251':
        return cls._create(arg) # type: ignore

RuleVariation_1181_Arg: TypeAlias = Variation_1251_Arg
class RuleVariation_1181(RuleVariationContextFree):
    cv_variation = Variation_1251

    @classmethod
    def create(cls, arg : RuleVariation_1181_Arg) -> "RuleVariation_1181":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1251:
        return self.arg # type: ignore

NonSpare_249_Arg: TypeAlias = RuleVariation_1181_Arg
class NonSpare_249(NonSpare):
    cv_name = "090"
    cv_title = "Mode-C Code in Binary Representation"
    cv_rule = RuleVariation_1181

    @classmethod
    def create(cls, arg : NonSpare_249_Arg) -> "NonSpare_249":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1181:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1251:
        return self.rule.variation

class UapItem_249(UapItem):
    cv_non_spare = NonSpare_249

Variation_149_Arg: TypeAlias = RuleContent_0_Arg
class Variation_149(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_149_Arg) -> "Variation_149":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

Variation_1446_Arg: TypeAlias = List[Variation_149_Arg]
class Variation_1446(Repetitive):
    cv_rep_bytes = None
    cv_variation = Variation_149

    @classmethod
    def create(cls, arg : Variation_1446_Arg) -> 'Variation_1446':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_149]:
        return self._get_list() # type: ignore

RuleVariation_1369_Arg: TypeAlias = Variation_1446_Arg
class RuleVariation_1369(RuleVariationContextFree):
    cv_variation = Variation_1446

    @classmethod
    def create(cls, arg : RuleVariation_1369_Arg) -> "RuleVariation_1369":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1446:
        return self.arg # type: ignore

NonSpare_307_Arg: TypeAlias = RuleVariation_1369_Arg
class NonSpare_307(NonSpare):
    cv_name = "130"
    cv_title = "Radar Plot Characteristics"
    cv_rule = RuleVariation_1369

    @classmethod
    def create(cls, arg : NonSpare_307_Arg) -> "NonSpare_307":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1369:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1446:
        return self.rule.variation

class UapItem_307(UapItem):
    cv_non_spare = NonSpare_307

Content_767_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
class Content_767(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 7.8125e-3
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

RuleContent_766_Arg: TypeAlias = Content_767_Arg
class RuleContent_766(RuleContentContextFree):
    cv_content = Content_767

    @property
    def content(self) -> Content_767:
        return self._get_content() # type: ignore

Variation_332_Arg: TypeAlias = RuleContent_766_Arg
class Variation_332(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_766

    @classmethod
    def create(cls, arg : Variation_332_Arg) -> "Variation_332":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_766:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_767:
        return self.rule.content

RuleVariation_325_Arg: TypeAlias = Variation_332_Arg
class RuleVariation_325(RuleVariationContextFree):
    cv_variation = Variation_332

    @classmethod
    def create(cls, arg : RuleVariation_325_Arg) -> "RuleVariation_325":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_332:
        return self.arg # type: ignore

NonSpare_332_Arg: TypeAlias = RuleVariation_325_Arg
class NonSpare_332(NonSpare):
    cv_name = "141"
    cv_title = "Truncated Time of Day"
    cv_rule = RuleVariation_325

    @classmethod
    def create(cls, arg : NonSpare_332_Arg) -> "NonSpare_332":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_325:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_332:
        return self.rule.variation

class UapItem_332(UapItem):
    cv_non_spare = NonSpare_332

Content_284_Arg: TypeAlias = int
class Content_284(ContentTable):
    cv_values = {0: "Mode-2 code as derived from the reply of the transponder", 1: "Smoothed Mode-2 code as provided by a local tracker"}

RuleContent_284_Arg: TypeAlias = Content_284_Arg
class RuleContent_284(RuleContentContextFree):
    cv_content = Content_284

    @property
    def content(self) -> Content_284:
        return self._get_content() # type: ignore

Variation_546_Arg: TypeAlias = RuleContent_284_Arg
class Variation_546(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_284

    @classmethod
    def create(cls, arg : Variation_546_Arg) -> "Variation_546":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_284:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_284:
        return self.rule.content

RuleVariation_535_Arg: TypeAlias = Variation_546_Arg
class RuleVariation_535(RuleVariationContextFree):
    cv_variation = Variation_546

    @classmethod
    def create(cls, arg : RuleVariation_535_Arg) -> "RuleVariation_535":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_546:
        return self.arg # type: ignore

NonSpare_1128_Arg: TypeAlias = RuleVariation_535_Arg
class NonSpare_1128(NonSpare):
    cv_name = "L"
    cv_title = ""
    cv_rule = RuleVariation_535

    @classmethod
    def create(cls, arg : NonSpare_1128_Arg) -> "NonSpare_1128":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_535:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_546:
        return self.rule.variation

Item_446_Arg: TypeAlias = NonSpare_1128_Arg
class Item_446(Item):
    cv_non_spare = NonSpare_1128

    @classmethod
    def create(cls, arg : Item_446_Arg) -> "Item_446":
        return cls._create(arg) # type: ignore

NonSpare_1294_Arg: TypeAlias = RuleVariation_776_Arg
class NonSpare_1294(NonSpare):
    cv_name = "MODE2"
    cv_title = "Mode-2 Code in Octal Representation"
    cv_rule = RuleVariation_776

    @classmethod
    def create(cls, arg : NonSpare_1294_Arg) -> "NonSpare_1294":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_776:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_806:
        return self.rule.variation

Item_566_Arg: TypeAlias = NonSpare_1294_Arg
class Item_566(Item):
    cv_non_spare = NonSpare_1294

    @classmethod
    def create(cls, arg : Item_566_Arg) -> "Item_566":
        return cls._create(arg) # type: ignore

Variation_1254_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_535_Arg, Tuple[Literal["L"], RuleVariation_535_Arg]], int, Union[RuleVariation_776_Arg, Tuple[Literal["MODE2"], RuleVariation_776_Arg]]]
Variation_1254_Arg: TypeAlias = Union[int, Variation_1254_Arg_Group]
class Variation_1254(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1099, 1), (Item_353, 1), (Item_446, 1), (Item_16, 1), (Item_566, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "L": RuleVariation_535, "MODE2": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_535:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE2"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_535:
        ...
    @overload
    def get_item(self, key : Literal["MODE2"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1254_Arg) -> 'Variation_1254':
        return cls._create(arg) # type: ignore

RuleVariation_1184_Arg: TypeAlias = Variation_1254_Arg
class RuleVariation_1184(RuleVariationContextFree):
    cv_variation = Variation_1254

    @classmethod
    def create(cls, arg : RuleVariation_1184_Arg) -> "RuleVariation_1184":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1254:
        return self.arg # type: ignore

NonSpare_171_Arg: TypeAlias = RuleVariation_1184_Arg
class NonSpare_171(NonSpare):
    cv_name = "050"
    cv_title = "Mode-2 Code in Octal Representation"
    cv_rule = RuleVariation_1184

    @classmethod
    def create(cls, arg : NonSpare_171_Arg) -> "NonSpare_171":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1184:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1254:
        return self.rule.variation

class UapItem_171(UapItem):
    cv_non_spare = NonSpare_171

Content_678_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM/s"]]]
class Content_678(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 3.90625e-3
    cv_unit = "NM/s"

    def as_quantity(self, cv_unit : Optional[Literal["NM/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_678_Arg: TypeAlias = Content_678_Arg
class RuleContent_678(RuleContentContextFree):
    cv_content = Content_678

    @property
    def content(self) -> Content_678:
        return self._get_content() # type: ignore

Variation_216_Arg: TypeAlias = RuleContent_678_Arg
class Variation_216(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_678

    @classmethod
    def create(cls, arg : Variation_216_Arg) -> "Variation_216":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_678:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_678:
        return self.rule.content

RuleVariation_209_Arg: TypeAlias = Variation_216_Arg
class RuleVariation_209(RuleVariationContextFree):
    cv_variation = Variation_216

    @classmethod
    def create(cls, arg : RuleVariation_209_Arg) -> "RuleVariation_209":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_216:
        return self.arg # type: ignore

NonSpare_295_Arg: TypeAlias = RuleVariation_209_Arg
class NonSpare_295(NonSpare):
    cv_name = "120"
    cv_title = "Measured Radial Doppler Speed"
    cv_rule = RuleVariation_209

    @classmethod
    def create(cls, arg : NonSpare_295_Arg) -> "NonSpare_295":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_209:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_216:
        return self.rule.variation

class UapItem_295(UapItem):
    cv_non_spare = NonSpare_295

Content_622_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["dBm"]]]
class Content_622(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.0
    cv_unit = "dBm"

    def as_quantity(self, cv_unit : Optional[Literal["dBm"]] = None) -> float:
        return self._as_quantity()

RuleContent_622_Arg: TypeAlias = Content_622_Arg
class RuleContent_622(RuleContentContextFree):
    cv_content = Content_622

    @property
    def content(self) -> Content_622:
        return self._get_content() # type: ignore

Variation_206_Arg: TypeAlias = RuleContent_622_Arg
class Variation_206(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_622

    @classmethod
    def create(cls, arg : Variation_206_Arg) -> "Variation_206":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_622:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_622:
        return self.rule.content

RuleVariation_199_Arg: TypeAlias = Variation_206_Arg
class RuleVariation_199(RuleVariationContextFree):
    cv_variation = Variation_206

    @classmethod
    def create(cls, arg : RuleVariation_199_Arg) -> "RuleVariation_199":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_206:
        return self.arg # type: ignore

NonSpare_311_Arg: TypeAlias = RuleVariation_199_Arg
class NonSpare_311(NonSpare):
    cv_name = "131"
    cv_title = "Received Power"
    cv_rule = RuleVariation_199

    @classmethod
    def create(cls, arg : NonSpare_311_Arg) -> "NonSpare_311":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_199:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_206:
        return self.rule.variation

class UapItem_311(UapItem):
    cv_non_spare = NonSpare_311

Item_3_Arg: TypeAlias = int
class Item_3(Spare):
    cv_bit_offset8 = 0
    cv_bit_size = 4

Content_226_Arg: TypeAlias = int
class Content_226(ContentTable):
    cv_values = {0: "High quality pulse A4", 1: "Low quality pulse A4"}

RuleContent_226_Arg: TypeAlias = Content_226_Arg
class RuleContent_226(RuleContentContextFree):
    cv_content = Content_226

    @property
    def content(self) -> Content_226:
        return self._get_content() # type: ignore

Variation_723_Arg: TypeAlias = RuleContent_226_Arg
class Variation_723(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_226

    @classmethod
    def create(cls, arg : Variation_723_Arg) -> "Variation_723":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_226:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_226:
        return self.rule.content

RuleVariation_712_Arg: TypeAlias = Variation_723_Arg
class RuleVariation_712(RuleVariationContextFree):
    cv_variation = Variation_723

    @classmethod
    def create(cls, arg : RuleVariation_712_Arg) -> "RuleVariation_712":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_723:
        return self.arg # type: ignore

NonSpare_1487_Arg: TypeAlias = RuleVariation_712_Arg
class NonSpare_1487(NonSpare):
    cv_name = "QA4"
    cv_title = ""
    cv_rule = RuleVariation_712

    @classmethod
    def create(cls, arg : NonSpare_1487_Arg) -> "NonSpare_1487":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_712:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_723:
        return self.rule.variation

Item_726_Arg: TypeAlias = NonSpare_1487_Arg
class Item_726(Item):
    cv_non_spare = NonSpare_1487

    @classmethod
    def create(cls, arg : Item_726_Arg) -> "Item_726":
        return cls._create(arg) # type: ignore

Content_225_Arg: TypeAlias = int
class Content_225(ContentTable):
    cv_values = {0: "High quality pulse A2", 1: "Low quality pulse A2"}

RuleContent_225_Arg: TypeAlias = Content_225_Arg
class RuleContent_225(RuleContentContextFree):
    cv_content = Content_225

    @property
    def content(self) -> Content_225:
        return self._get_content() # type: ignore

Variation_850_Arg: TypeAlias = RuleContent_225_Arg
class Variation_850(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_225

    @classmethod
    def create(cls, arg : Variation_850_Arg) -> "Variation_850":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_225:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_225:
        return self.rule.content

RuleVariation_820_Arg: TypeAlias = Variation_850_Arg
class RuleVariation_820(RuleVariationContextFree):
    cv_variation = Variation_850

    @classmethod
    def create(cls, arg : RuleVariation_820_Arg) -> "RuleVariation_820":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_850:
        return self.arg # type: ignore

NonSpare_1482_Arg: TypeAlias = RuleVariation_820_Arg
class NonSpare_1482(NonSpare):
    cv_name = "QA2"
    cv_title = ""
    cv_rule = RuleVariation_820

    @classmethod
    def create(cls, arg : NonSpare_1482_Arg) -> "NonSpare_1482":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_820:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_850:
        return self.rule.variation

Item_721_Arg: TypeAlias = NonSpare_1482_Arg
class Item_721(Item):
    cv_non_spare = NonSpare_1482

    @classmethod
    def create(cls, arg : Item_721_Arg) -> "Item_721":
        return cls._create(arg) # type: ignore

Content_224_Arg: TypeAlias = int
class Content_224(ContentTable):
    cv_values = {0: "High quality pulse A1", 1: "Low quality pulse A1"}

RuleContent_224_Arg: TypeAlias = Content_224_Arg
class RuleContent_224(RuleContentContextFree):
    cv_content = Content_224

    @property
    def content(self) -> Content_224:
        return self._get_content() # type: ignore

Variation_926_Arg: TypeAlias = RuleContent_224_Arg
class Variation_926(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_224

    @classmethod
    def create(cls, arg : Variation_926_Arg) -> "Variation_926":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_224:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_224:
        return self.rule.content

RuleVariation_896_Arg: TypeAlias = Variation_926_Arg
class RuleVariation_896(RuleVariationContextFree):
    cv_variation = Variation_926

    @classmethod
    def create(cls, arg : RuleVariation_896_Arg) -> "RuleVariation_896":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_926:
        return self.arg # type: ignore

NonSpare_1479_Arg: TypeAlias = RuleVariation_896_Arg
class NonSpare_1479(NonSpare):
    cv_name = "QA1"
    cv_title = ""
    cv_rule = RuleVariation_896

    @classmethod
    def create(cls, arg : NonSpare_1479_Arg) -> "NonSpare_1479":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_896:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_926:
        return self.rule.variation

Item_718_Arg: TypeAlias = NonSpare_1479_Arg
class Item_718(Item):
    cv_non_spare = NonSpare_1479

    @classmethod
    def create(cls, arg : Item_718_Arg) -> "Item_718":
        return cls._create(arg) # type: ignore

Content_229_Arg: TypeAlias = int
class Content_229(ContentTable):
    cv_values = {0: "High quality pulse B4", 1: "Low quality pulse B4"}

RuleContent_229_Arg: TypeAlias = Content_229_Arg
class RuleContent_229(RuleContentContextFree):
    cv_content = Content_229

    @property
    def content(self) -> Content_229:
        return self._get_content() # type: ignore

Variation_975_Arg: TypeAlias = RuleContent_229_Arg
class Variation_975(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_229

    @classmethod
    def create(cls, arg : Variation_975_Arg) -> "Variation_975":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_229:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_229:
        return self.rule.content

RuleVariation_945_Arg: TypeAlias = Variation_975_Arg
class RuleVariation_945(RuleVariationContextFree):
    cv_variation = Variation_975

    @classmethod
    def create(cls, arg : RuleVariation_945_Arg) -> "RuleVariation_945":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_975:
        return self.arg # type: ignore

NonSpare_1498_Arg: TypeAlias = RuleVariation_945_Arg
class NonSpare_1498(NonSpare):
    cv_name = "QB4"
    cv_title = ""
    cv_rule = RuleVariation_945

    @classmethod
    def create(cls, arg : NonSpare_1498_Arg) -> "NonSpare_1498":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_945:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_975:
        return self.rule.variation

Item_737_Arg: TypeAlias = NonSpare_1498_Arg
class Item_737(Item):
    cv_non_spare = NonSpare_1498

    @classmethod
    def create(cls, arg : Item_737_Arg) -> "Item_737":
        return cls._create(arg) # type: ignore

Content_228_Arg: TypeAlias = int
class Content_228(ContentTable):
    cv_values = {0: "High quality pulse B2", 1: "Low quality pulse B2"}

RuleContent_228_Arg: TypeAlias = Content_228_Arg
class RuleContent_228(RuleContentContextFree):
    cv_content = Content_228

    @property
    def content(self) -> Content_228:
        return self._get_content() # type: ignore

Variation_45_Arg: TypeAlias = RuleContent_228_Arg
class Variation_45(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_228

    @classmethod
    def create(cls, arg : Variation_45_Arg) -> "Variation_45":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_228:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_228:
        return self.rule.content

RuleVariation_45_Arg: TypeAlias = Variation_45_Arg
class RuleVariation_45(RuleVariationContextFree):
    cv_variation = Variation_45

    @classmethod
    def create(cls, arg : RuleVariation_45_Arg) -> "RuleVariation_45":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_45:
        return self.arg # type: ignore

NonSpare_1493_Arg: TypeAlias = RuleVariation_45_Arg
class NonSpare_1493(NonSpare):
    cv_name = "QB2"
    cv_title = ""
    cv_rule = RuleVariation_45

    @classmethod
    def create(cls, arg : NonSpare_1493_Arg) -> "NonSpare_1493":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_45:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_45:
        return self.rule.variation

Item_732_Arg: TypeAlias = NonSpare_1493_Arg
class Item_732(Item):
    cv_non_spare = NonSpare_1493

    @classmethod
    def create(cls, arg : Item_732_Arg) -> "Item_732":
        return cls._create(arg) # type: ignore

Content_227_Arg: TypeAlias = int
class Content_227(ContentTable):
    cv_values = {0: "High quality pulse B1", 1: "Low quality pulse B1"}

RuleContent_227_Arg: TypeAlias = Content_227_Arg
class RuleContent_227(RuleContentContextFree):
    cv_content = Content_227

    @property
    def content(self) -> Content_227:
        return self._get_content() # type: ignore

Variation_430_Arg: TypeAlias = RuleContent_227_Arg
class Variation_430(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_227

    @classmethod
    def create(cls, arg : Variation_430_Arg) -> "Variation_430":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_227:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_227:
        return self.rule.content

RuleVariation_419_Arg: TypeAlias = Variation_430_Arg
class RuleVariation_419(RuleVariationContextFree):
    cv_variation = Variation_430

    @classmethod
    def create(cls, arg : RuleVariation_419_Arg) -> "RuleVariation_419":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_430:
        return self.arg # type: ignore

NonSpare_1489_Arg: TypeAlias = RuleVariation_419_Arg
class NonSpare_1489(NonSpare):
    cv_name = "QB1"
    cv_title = ""
    cv_rule = RuleVariation_419

    @classmethod
    def create(cls, arg : NonSpare_1489_Arg) -> "NonSpare_1489":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_419:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_430:
        return self.rule.variation

Item_728_Arg: TypeAlias = NonSpare_1489_Arg
class Item_728(Item):
    cv_non_spare = NonSpare_1489

    @classmethod
    def create(cls, arg : Item_728_Arg) -> "Item_728":
        return cls._create(arg) # type: ignore

Content_232_Arg: TypeAlias = int
class Content_232(ContentTable):
    cv_values = {0: "High quality pulse C4", 1: "Low quality pulse C4"}

RuleContent_232_Arg: TypeAlias = Content_232_Arg
class RuleContent_232(RuleContentContextFree):
    cv_content = Content_232

    @property
    def content(self) -> Content_232:
        return self._get_content() # type: ignore

Variation_535_Arg: TypeAlias = RuleContent_232_Arg
class Variation_535(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_232

    @classmethod
    def create(cls, arg : Variation_535_Arg) -> "Variation_535":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_232:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_232:
        return self.rule.content

RuleVariation_524_Arg: TypeAlias = Variation_535_Arg
class RuleVariation_524(RuleVariationContextFree):
    cv_variation = Variation_535

    @classmethod
    def create(cls, arg : RuleVariation_524_Arg) -> "RuleVariation_524":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_535:
        return self.arg # type: ignore

NonSpare_1506_Arg: TypeAlias = RuleVariation_524_Arg
class NonSpare_1506(NonSpare):
    cv_name = "QC4"
    cv_title = ""
    cv_rule = RuleVariation_524

    @classmethod
    def create(cls, arg : NonSpare_1506_Arg) -> "NonSpare_1506":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_524:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_535:
        return self.rule.variation

Item_745_Arg: TypeAlias = NonSpare_1506_Arg
class Item_745(Item):
    cv_non_spare = NonSpare_1506

    @classmethod
    def create(cls, arg : Item_745_Arg) -> "Item_745":
        return cls._create(arg) # type: ignore

Content_231_Arg: TypeAlias = int
class Content_231(ContentTable):
    cv_values = {0: "High quality pulse C2", 1: "Low quality pulse C2"}

RuleContent_231_Arg: TypeAlias = Content_231_Arg
class RuleContent_231(RuleContentContextFree):
    cv_content = Content_231

    @property
    def content(self) -> Content_231:
        return self._get_content() # type: ignore

Variation_639_Arg: TypeAlias = RuleContent_231_Arg
class Variation_639(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_231

    @classmethod
    def create(cls, arg : Variation_639_Arg) -> "Variation_639":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_231:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_231:
        return self.rule.content

RuleVariation_628_Arg: TypeAlias = Variation_639_Arg
class RuleVariation_628(RuleVariationContextFree):
    cv_variation = Variation_639

    @classmethod
    def create(cls, arg : RuleVariation_628_Arg) -> "RuleVariation_628":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_639:
        return self.arg # type: ignore

NonSpare_1502_Arg: TypeAlias = RuleVariation_628_Arg
class NonSpare_1502(NonSpare):
    cv_name = "QC2"
    cv_title = ""
    cv_rule = RuleVariation_628

    @classmethod
    def create(cls, arg : NonSpare_1502_Arg) -> "NonSpare_1502":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_628:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_639:
        return self.rule.variation

Item_741_Arg: TypeAlias = NonSpare_1502_Arg
class Item_741(Item):
    cv_non_spare = NonSpare_1502

    @classmethod
    def create(cls, arg : Item_741_Arg) -> "Item_741":
        return cls._create(arg) # type: ignore

Content_230_Arg: TypeAlias = int
class Content_230(ContentTable):
    cv_values = {0: "High quality pulse C1", 1: "Low quality pulse C1"}

RuleContent_230_Arg: TypeAlias = Content_230_Arg
class RuleContent_230(RuleContentContextFree):
    cv_content = Content_230

    @property
    def content(self) -> Content_230:
        return self._get_content() # type: ignore

Variation_725_Arg: TypeAlias = RuleContent_230_Arg
class Variation_725(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_230

    @classmethod
    def create(cls, arg : Variation_725_Arg) -> "Variation_725":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_230:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_230:
        return self.rule.content

RuleVariation_714_Arg: TypeAlias = Variation_725_Arg
class RuleVariation_714(RuleVariationContextFree):
    cv_variation = Variation_725

    @classmethod
    def create(cls, arg : RuleVariation_714_Arg) -> "RuleVariation_714":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_725:
        return self.arg # type: ignore

NonSpare_1500_Arg: TypeAlias = RuleVariation_714_Arg
class NonSpare_1500(NonSpare):
    cv_name = "QC1"
    cv_title = ""
    cv_rule = RuleVariation_714

    @classmethod
    def create(cls, arg : NonSpare_1500_Arg) -> "NonSpare_1500":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_714:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_725:
        return self.rule.variation

Item_739_Arg: TypeAlias = NonSpare_1500_Arg
class Item_739(Item):
    cv_non_spare = NonSpare_1500

    @classmethod
    def create(cls, arg : Item_739_Arg) -> "Item_739":
        return cls._create(arg) # type: ignore

Content_235_Arg: TypeAlias = int
class Content_235(ContentTable):
    cv_values = {0: "High quality pulse D4", 1: "Low quality pulse D4"}

RuleContent_235_Arg: TypeAlias = Content_235_Arg
class RuleContent_235(RuleContentContextFree):
    cv_content = Content_235

    @property
    def content(self) -> Content_235:
        return self._get_content() # type: ignore

Variation_853_Arg: TypeAlias = RuleContent_235_Arg
class Variation_853(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_235

    @classmethod
    def create(cls, arg : Variation_853_Arg) -> "Variation_853":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_235:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_235:
        return self.rule.content

RuleVariation_823_Arg: TypeAlias = Variation_853_Arg
class RuleVariation_823(RuleVariationContextFree):
    cv_variation = Variation_853

    @classmethod
    def create(cls, arg : RuleVariation_823_Arg) -> "RuleVariation_823":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_853:
        return self.arg # type: ignore

NonSpare_1514_Arg: TypeAlias = RuleVariation_823_Arg
class NonSpare_1514(NonSpare):
    cv_name = "QD4"
    cv_title = ""
    cv_rule = RuleVariation_823

    @classmethod
    def create(cls, arg : NonSpare_1514_Arg) -> "NonSpare_1514":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_823:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_853:
        return self.rule.variation

Item_753_Arg: TypeAlias = NonSpare_1514_Arg
class Item_753(Item):
    cv_non_spare = NonSpare_1514

    @classmethod
    def create(cls, arg : Item_753_Arg) -> "Item_753":
        return cls._create(arg) # type: ignore

Content_234_Arg: TypeAlias = int
class Content_234(ContentTable):
    cv_values = {0: "High quality pulse D2", 1: "Low quality pulse D2"}

RuleContent_234_Arg: TypeAlias = Content_234_Arg
class RuleContent_234(RuleContentContextFree):
    cv_content = Content_234

    @property
    def content(self) -> Content_234:
        return self._get_content() # type: ignore

Variation_930_Arg: TypeAlias = RuleContent_234_Arg
class Variation_930(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_234

    @classmethod
    def create(cls, arg : Variation_930_Arg) -> "Variation_930":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_234:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_234:
        return self.rule.content

RuleVariation_900_Arg: TypeAlias = Variation_930_Arg
class RuleVariation_900(RuleVariationContextFree):
    cv_variation = Variation_930

    @classmethod
    def create(cls, arg : RuleVariation_900_Arg) -> "RuleVariation_900":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_930:
        return self.arg # type: ignore

NonSpare_1512_Arg: TypeAlias = RuleVariation_900_Arg
class NonSpare_1512(NonSpare):
    cv_name = "QD2"
    cv_title = ""
    cv_rule = RuleVariation_900

    @classmethod
    def create(cls, arg : NonSpare_1512_Arg) -> "NonSpare_1512":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_900:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_930:
        return self.rule.variation

Item_751_Arg: TypeAlias = NonSpare_1512_Arg
class Item_751(Item):
    cv_non_spare = NonSpare_1512

    @classmethod
    def create(cls, arg : Item_751_Arg) -> "Item_751":
        return cls._create(arg) # type: ignore

Content_233_Arg: TypeAlias = int
class Content_233(ContentTable):
    cv_values = {0: "High quality pulse D1", 1: "Low quality pulse D1"}

RuleContent_233_Arg: TypeAlias = Content_233_Arg
class RuleContent_233(RuleContentContextFree):
    cv_content = Content_233

    @property
    def content(self) -> Content_233:
        return self._get_content() # type: ignore

Variation_976_Arg: TypeAlias = RuleContent_233_Arg
class Variation_976(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_233

    @classmethod
    def create(cls, arg : Variation_976_Arg) -> "Variation_976":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_233:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_233:
        return self.rule.content

RuleVariation_946_Arg: TypeAlias = Variation_976_Arg
class RuleVariation_946(RuleVariationContextFree):
    cv_variation = Variation_976

    @classmethod
    def create(cls, arg : RuleVariation_946_Arg) -> "RuleVariation_946":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_976:
        return self.arg # type: ignore

NonSpare_1509_Arg: TypeAlias = RuleVariation_946_Arg
class NonSpare_1509(NonSpare):
    cv_name = "QD1"
    cv_title = ""
    cv_rule = RuleVariation_946

    @classmethod
    def create(cls, arg : NonSpare_1509_Arg) -> "NonSpare_1509":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_946:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_976:
        return self.rule.variation

Item_748_Arg: TypeAlias = NonSpare_1509_Arg
class Item_748(Item):
    cv_non_spare = NonSpare_1509

    @classmethod
    def create(cls, arg : Item_748_Arg) -> "Item_748":
        return cls._create(arg) # type: ignore

Variation_1029_Arg_Group = Tuple[int, Union[RuleVariation_712_Arg, Tuple[Literal["QA4"], RuleVariation_712_Arg]], Union[RuleVariation_820_Arg, Tuple[Literal["QA2"], RuleVariation_820_Arg]], Union[RuleVariation_896_Arg, Tuple[Literal["QA1"], RuleVariation_896_Arg]], Union[RuleVariation_945_Arg, Tuple[Literal["QB4"], RuleVariation_945_Arg]], Union[RuleVariation_45_Arg, Tuple[Literal["QB2"], RuleVariation_45_Arg]], Union[RuleVariation_419_Arg, Tuple[Literal["QB1"], RuleVariation_419_Arg]], Union[RuleVariation_524_Arg, Tuple[Literal["QC4"], RuleVariation_524_Arg]], Union[RuleVariation_628_Arg, Tuple[Literal["QC2"], RuleVariation_628_Arg]], Union[RuleVariation_714_Arg, Tuple[Literal["QC1"], RuleVariation_714_Arg]], Union[RuleVariation_823_Arg, Tuple[Literal["QD4"], RuleVariation_823_Arg]], Union[RuleVariation_900_Arg, Tuple[Literal["QD2"], RuleVariation_900_Arg]], Union[RuleVariation_946_Arg, Tuple[Literal["QD1"], RuleVariation_946_Arg]]]
Variation_1029_Arg: TypeAlias = Union[int, Variation_1029_Arg_Group]
class Variation_1029(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_726, 1), (Item_721, 1), (Item_718, 1), (Item_737, 1), (Item_732, 1), (Item_728, 1), (Item_745, 1), (Item_741, 1), (Item_739, 1), (Item_753, 1), (Item_751, 1), (Item_748, 1)]
    cv_items_dict = {"QA4": RuleVariation_712, "QA2": RuleVariation_820, "QA1": RuleVariation_896, "QB4": RuleVariation_945, "QB2": RuleVariation_45, "QB1": RuleVariation_419, "QC4": RuleVariation_524, "QC2": RuleVariation_628, "QC1": RuleVariation_714, "QD4": RuleVariation_823, "QD2": RuleVariation_900, "QD1": RuleVariation_946}

    @overload
    @classmethod
    def spec(cls, key : Literal["QA4"]) -> RuleVariation_712:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA2"]) -> RuleVariation_820:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA1"]) -> RuleVariation_896:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB4"]) -> RuleVariation_945:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB2"]) -> RuleVariation_45:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB1"]) -> RuleVariation_419:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC4"]) -> RuleVariation_524:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC2"]) -> RuleVariation_628:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC1"]) -> RuleVariation_714:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD4"]) -> RuleVariation_823:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD2"]) -> RuleVariation_900:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD1"]) -> RuleVariation_946:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["QA4"], Literal["QA2"], Literal["QA1"], Literal["QB4"], Literal["QB2"], Literal["QB1"], Literal["QC4"], Literal["QC2"], Literal["QC1"], Literal["QD4"], Literal["QD2"], Literal["QD1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["QA4"]) -> RuleVariation_712:
        ...
    @overload
    def get_item(self, key : Literal["QA2"]) -> RuleVariation_820:
        ...
    @overload
    def get_item(self, key : Literal["QA1"]) -> RuleVariation_896:
        ...
    @overload
    def get_item(self, key : Literal["QB4"]) -> RuleVariation_945:
        ...
    @overload
    def get_item(self, key : Literal["QB2"]) -> RuleVariation_45:
        ...
    @overload
    def get_item(self, key : Literal["QB1"]) -> RuleVariation_419:
        ...
    @overload
    def get_item(self, key : Literal["QC4"]) -> RuleVariation_524:
        ...
    @overload
    def get_item(self, key : Literal["QC2"]) -> RuleVariation_628:
        ...
    @overload
    def get_item(self, key : Literal["QC1"]) -> RuleVariation_714:
        ...
    @overload
    def get_item(self, key : Literal["QD4"]) -> RuleVariation_823:
        ...
    @overload
    def get_item(self, key : Literal["QD2"]) -> RuleVariation_900:
        ...
    @overload
    def get_item(self, key : Literal["QD1"]) -> RuleVariation_946:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1029_Arg) -> 'Variation_1029':
        return cls._create(arg) # type: ignore

RuleVariation_997_Arg: TypeAlias = Variation_1029_Arg
class RuleVariation_997(RuleVariationContextFree):
    cv_variation = Variation_1029

    @classmethod
    def create(cls, arg : RuleVariation_997_Arg) -> "RuleVariation_997":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1029:
        return self.arg # type: ignore

NonSpare_229_Arg: TypeAlias = RuleVariation_997_Arg
class NonSpare_229(NonSpare):
    cv_name = "080"
    cv_title = "Mode-3/A Code Confidence Indicator"
    cv_rule = RuleVariation_997

    @classmethod
    def create(cls, arg : NonSpare_229_Arg) -> "NonSpare_229":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_997:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1029:
        return self.rule.variation

class UapItem_229(UapItem):
    cv_non_spare = NonSpare_229

Item_12_Arg: TypeAlias = int
class Item_12(Spare):
    cv_bit_offset8 = 2
    cv_bit_size = 2

Variation_805_Arg: TypeAlias = RuleContent_0_Arg
class Variation_805(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 12
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_805_Arg) -> "Variation_805":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_775_Arg: TypeAlias = Variation_805_Arg
class RuleVariation_775(RuleVariationContextFree):
    cv_variation = Variation_805

    @classmethod
    def create(cls, arg : RuleVariation_775_Arg) -> "RuleVariation_775":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_805:
        return self.arg # type: ignore

NonSpare_1301_Arg: TypeAlias = RuleVariation_775_Arg
class NonSpare_1301(NonSpare):
    cv_name = "MODEC"
    cv_title = "Mode-C Reply in Gray Notation"
    cv_rule = RuleVariation_775

    @classmethod
    def create(cls, arg : NonSpare_1301_Arg) -> "NonSpare_1301":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_775:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_805:
        return self.rule.variation

Item_573_Arg: TypeAlias = NonSpare_1301_Arg
class Item_573(Item):
    cv_non_spare = NonSpare_1301

    @classmethod
    def create(cls, arg : Item_573_Arg) -> "Item_573":
        return cls._create(arg) # type: ignore

Variation_849_Arg: TypeAlias = RuleContent_224_Arg
class Variation_849(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_224

    @classmethod
    def create(cls, arg : Variation_849_Arg) -> "Variation_849":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_224:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_224:
        return self.rule.content

RuleVariation_819_Arg: TypeAlias = Variation_849_Arg
class RuleVariation_819(RuleVariationContextFree):
    cv_variation = Variation_849

    @classmethod
    def create(cls, arg : RuleVariation_819_Arg) -> "RuleVariation_819":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_849:
        return self.arg # type: ignore

NonSpare_1478_Arg: TypeAlias = RuleVariation_819_Arg
class NonSpare_1478(NonSpare):
    cv_name = "QA1"
    cv_title = ""
    cv_rule = RuleVariation_819

    @classmethod
    def create(cls, arg : NonSpare_1478_Arg) -> "NonSpare_1478":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_819:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_849:
        return self.rule.variation

Item_717_Arg: TypeAlias = NonSpare_1478_Arg
class Item_717(Item):
    cv_non_spare = NonSpare_1478

    @classmethod
    def create(cls, arg : Item_717_Arg) -> "Item_717":
        return cls._create(arg) # type: ignore

Variation_929_Arg: TypeAlias = RuleContent_231_Arg
class Variation_929(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_231

    @classmethod
    def create(cls, arg : Variation_929_Arg) -> "Variation_929":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_231:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_231:
        return self.rule.content

RuleVariation_899_Arg: TypeAlias = Variation_929_Arg
class RuleVariation_899(RuleVariationContextFree):
    cv_variation = Variation_929

    @classmethod
    def create(cls, arg : RuleVariation_899_Arg) -> "RuleVariation_899":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_929:
        return self.arg # type: ignore

NonSpare_1503_Arg: TypeAlias = RuleVariation_899_Arg
class NonSpare_1503(NonSpare):
    cv_name = "QC2"
    cv_title = ""
    cv_rule = RuleVariation_899

    @classmethod
    def create(cls, arg : NonSpare_1503_Arg) -> "NonSpare_1503":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_899:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_929:
        return self.rule.variation

Item_742_Arg: TypeAlias = NonSpare_1503_Arg
class Item_742(Item):
    cv_non_spare = NonSpare_1503

    @classmethod
    def create(cls, arg : Item_742_Arg) -> "Item_742":
        return cls._create(arg) # type: ignore

Variation_973_Arg: TypeAlias = RuleContent_225_Arg
class Variation_973(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_225

    @classmethod
    def create(cls, arg : Variation_973_Arg) -> "Variation_973":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_225:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_225:
        return self.rule.content

RuleVariation_943_Arg: TypeAlias = Variation_973_Arg
class RuleVariation_943(RuleVariationContextFree):
    cv_variation = Variation_973

    @classmethod
    def create(cls, arg : RuleVariation_943_Arg) -> "RuleVariation_943":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_973:
        return self.arg # type: ignore

NonSpare_1483_Arg: TypeAlias = RuleVariation_943_Arg
class NonSpare_1483(NonSpare):
    cv_name = "QA2"
    cv_title = ""
    cv_rule = RuleVariation_943

    @classmethod
    def create(cls, arg : NonSpare_1483_Arg) -> "NonSpare_1483":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_943:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_973:
        return self.rule.variation

Item_722_Arg: TypeAlias = NonSpare_1483_Arg
class Item_722(Item):
    cv_non_spare = NonSpare_1483

    @classmethod
    def create(cls, arg : Item_722_Arg) -> "Item_722":
        return cls._create(arg) # type: ignore

Variation_46_Arg: TypeAlias = RuleContent_232_Arg
class Variation_46(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_232

    @classmethod
    def create(cls, arg : Variation_46_Arg) -> "Variation_46":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_232:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_232:
        return self.rule.content

RuleVariation_46_Arg: TypeAlias = Variation_46_Arg
class RuleVariation_46(RuleVariationContextFree):
    cv_variation = Variation_46

    @classmethod
    def create(cls, arg : RuleVariation_46_Arg) -> "RuleVariation_46":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_46:
        return self.arg # type: ignore

NonSpare_1505_Arg: TypeAlias = RuleVariation_46_Arg
class NonSpare_1505(NonSpare):
    cv_name = "QC4"
    cv_title = ""
    cv_rule = RuleVariation_46

    @classmethod
    def create(cls, arg : NonSpare_1505_Arg) -> "NonSpare_1505":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_46:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_46:
        return self.rule.variation

Item_744_Arg: TypeAlias = NonSpare_1505_Arg
class Item_744(Item):
    cv_non_spare = NonSpare_1505

    @classmethod
    def create(cls, arg : Item_744_Arg) -> "Item_744":
        return cls._create(arg) # type: ignore

Variation_429_Arg: TypeAlias = RuleContent_226_Arg
class Variation_429(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_226

    @classmethod
    def create(cls, arg : Variation_429_Arg) -> "Variation_429":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_226:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_226:
        return self.rule.content

RuleVariation_418_Arg: TypeAlias = Variation_429_Arg
class RuleVariation_418(RuleVariationContextFree):
    cv_variation = Variation_429

    @classmethod
    def create(cls, arg : RuleVariation_418_Arg) -> "RuleVariation_418":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_429:
        return self.arg # type: ignore

NonSpare_1485_Arg: TypeAlias = RuleVariation_418_Arg
class NonSpare_1485(NonSpare):
    cv_name = "QA4"
    cv_title = ""
    cv_rule = RuleVariation_418

    @classmethod
    def create(cls, arg : NonSpare_1485_Arg) -> "NonSpare_1485":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_418:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_429:
        return self.rule.variation

Item_724_Arg: TypeAlias = NonSpare_1485_Arg
class Item_724(Item):
    cv_non_spare = NonSpare_1485

    @classmethod
    def create(cls, arg : Item_724_Arg) -> "Item_724":
        return cls._create(arg) # type: ignore

Variation_534_Arg: TypeAlias = RuleContent_227_Arg
class Variation_534(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_227

    @classmethod
    def create(cls, arg : Variation_534_Arg) -> "Variation_534":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_227:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_227:
        return self.rule.content

RuleVariation_523_Arg: TypeAlias = Variation_534_Arg
class RuleVariation_523(RuleVariationContextFree):
    cv_variation = Variation_534

    @classmethod
    def create(cls, arg : RuleVariation_523_Arg) -> "RuleVariation_523":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_534:
        return self.arg # type: ignore

NonSpare_1490_Arg: TypeAlias = RuleVariation_523_Arg
class NonSpare_1490(NonSpare):
    cv_name = "QB1"
    cv_title = ""
    cv_rule = RuleVariation_523

    @classmethod
    def create(cls, arg : NonSpare_1490_Arg) -> "NonSpare_1490":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_523:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_534:
        return self.rule.variation

Item_729_Arg: TypeAlias = NonSpare_1490_Arg
class Item_729(Item):
    cv_non_spare = NonSpare_1490

    @classmethod
    def create(cls, arg : Item_729_Arg) -> "Item_729":
        return cls._create(arg) # type: ignore

Variation_640_Arg: TypeAlias = RuleContent_233_Arg
class Variation_640(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_233

    @classmethod
    def create(cls, arg : Variation_640_Arg) -> "Variation_640":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_233:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_233:
        return self.rule.content

RuleVariation_629_Arg: TypeAlias = Variation_640_Arg
class RuleVariation_629(RuleVariationContextFree):
    cv_variation = Variation_640

    @classmethod
    def create(cls, arg : RuleVariation_629_Arg) -> "RuleVariation_629":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_640:
        return self.arg # type: ignore

NonSpare_1508_Arg: TypeAlias = RuleVariation_629_Arg
class NonSpare_1508(NonSpare):
    cv_name = "QD1"
    cv_title = ""
    cv_rule = RuleVariation_629

    @classmethod
    def create(cls, arg : NonSpare_1508_Arg) -> "NonSpare_1508":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_629:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_640:
        return self.rule.variation

Item_747_Arg: TypeAlias = NonSpare_1508_Arg
class Item_747(Item):
    cv_non_spare = NonSpare_1508

    @classmethod
    def create(cls, arg : Item_747_Arg) -> "Item_747":
        return cls._create(arg) # type: ignore

Variation_724_Arg: TypeAlias = RuleContent_228_Arg
class Variation_724(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_228

    @classmethod
    def create(cls, arg : Variation_724_Arg) -> "Variation_724":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_228:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_228:
        return self.rule.content

RuleVariation_713_Arg: TypeAlias = Variation_724_Arg
class RuleVariation_713(RuleVariationContextFree):
    cv_variation = Variation_724

    @classmethod
    def create(cls, arg : RuleVariation_713_Arg) -> "RuleVariation_713":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_724:
        return self.arg # type: ignore

NonSpare_1494_Arg: TypeAlias = RuleVariation_713_Arg
class NonSpare_1494(NonSpare):
    cv_name = "QB2"
    cv_title = ""
    cv_rule = RuleVariation_713

    @classmethod
    def create(cls, arg : NonSpare_1494_Arg) -> "NonSpare_1494":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_713:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_724:
        return self.rule.variation

Item_733_Arg: TypeAlias = NonSpare_1494_Arg
class Item_733(Item):
    cv_non_spare = NonSpare_1494

    @classmethod
    def create(cls, arg : Item_733_Arg) -> "Item_733":
        return cls._create(arg) # type: ignore

Variation_852_Arg: TypeAlias = RuleContent_234_Arg
class Variation_852(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_234

    @classmethod
    def create(cls, arg : Variation_852_Arg) -> "Variation_852":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_234:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_234:
        return self.rule.content

RuleVariation_822_Arg: TypeAlias = Variation_852_Arg
class RuleVariation_822(RuleVariationContextFree):
    cv_variation = Variation_852

    @classmethod
    def create(cls, arg : RuleVariation_822_Arg) -> "RuleVariation_822":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_852:
        return self.arg # type: ignore

NonSpare_1511_Arg: TypeAlias = RuleVariation_822_Arg
class NonSpare_1511(NonSpare):
    cv_name = "QD2"
    cv_title = ""
    cv_rule = RuleVariation_822

    @classmethod
    def create(cls, arg : NonSpare_1511_Arg) -> "NonSpare_1511":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_822:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_852:
        return self.rule.variation

Item_750_Arg: TypeAlias = NonSpare_1511_Arg
class Item_750(Item):
    cv_non_spare = NonSpare_1511

    @classmethod
    def create(cls, arg : Item_750_Arg) -> "Item_750":
        return cls._create(arg) # type: ignore

Variation_928_Arg: TypeAlias = RuleContent_229_Arg
class Variation_928(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_229

    @classmethod
    def create(cls, arg : Variation_928_Arg) -> "Variation_928":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_229:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_229:
        return self.rule.content

RuleVariation_898_Arg: TypeAlias = Variation_928_Arg
class RuleVariation_898(RuleVariationContextFree):
    cv_variation = Variation_928

    @classmethod
    def create(cls, arg : RuleVariation_898_Arg) -> "RuleVariation_898":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_928:
        return self.arg # type: ignore

NonSpare_1497_Arg: TypeAlias = RuleVariation_898_Arg
class NonSpare_1497(NonSpare):
    cv_name = "QB4"
    cv_title = ""
    cv_rule = RuleVariation_898

    @classmethod
    def create(cls, arg : NonSpare_1497_Arg) -> "NonSpare_1497":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_898:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_928:
        return self.rule.variation

Item_736_Arg: TypeAlias = NonSpare_1497_Arg
class Item_736(Item):
    cv_non_spare = NonSpare_1497

    @classmethod
    def create(cls, arg : Item_736_Arg) -> "Item_736":
        return cls._create(arg) # type: ignore

Variation_977_Arg: TypeAlias = RuleContent_235_Arg
class Variation_977(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_235

    @classmethod
    def create(cls, arg : Variation_977_Arg) -> "Variation_977":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_235:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_235:
        return self.rule.content

RuleVariation_947_Arg: TypeAlias = Variation_977_Arg
class RuleVariation_947(RuleVariationContextFree):
    cv_variation = Variation_977

    @classmethod
    def create(cls, arg : RuleVariation_947_Arg) -> "RuleVariation_947":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_977:
        return self.arg # type: ignore

NonSpare_1515_Arg: TypeAlias = RuleVariation_947_Arg
class NonSpare_1515(NonSpare):
    cv_name = "QD4"
    cv_title = ""
    cv_rule = RuleVariation_947

    @classmethod
    def create(cls, arg : NonSpare_1515_Arg) -> "NonSpare_1515":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_947:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_977:
        return self.rule.variation

Item_754_Arg: TypeAlias = NonSpare_1515_Arg
class Item_754(Item):
    cv_non_spare = NonSpare_1515

    @classmethod
    def create(cls, arg : Item_754_Arg) -> "Item_754":
        return cls._create(arg) # type: ignore

Variation_1246_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], int, Union[RuleVariation_775_Arg, Tuple[Literal["MODEC"], RuleVariation_775_Arg]], int, Union[RuleVariation_714_Arg, Tuple[Literal["QC1"], RuleVariation_714_Arg]], Union[RuleVariation_819_Arg, Tuple[Literal["QA1"], RuleVariation_819_Arg]], Union[RuleVariation_899_Arg, Tuple[Literal["QC2"], RuleVariation_899_Arg]], Union[RuleVariation_943_Arg, Tuple[Literal["QA2"], RuleVariation_943_Arg]], Union[RuleVariation_46_Arg, Tuple[Literal["QC4"], RuleVariation_46_Arg]], Union[RuleVariation_418_Arg, Tuple[Literal["QA4"], RuleVariation_418_Arg]], Union[RuleVariation_523_Arg, Tuple[Literal["QB1"], RuleVariation_523_Arg]], Union[RuleVariation_629_Arg, Tuple[Literal["QD1"], RuleVariation_629_Arg]], Union[RuleVariation_713_Arg, Tuple[Literal["QB2"], RuleVariation_713_Arg]], Union[RuleVariation_822_Arg, Tuple[Literal["QD2"], RuleVariation_822_Arg]], Union[RuleVariation_898_Arg, Tuple[Literal["QB4"], RuleVariation_898_Arg]], Union[RuleVariation_947_Arg, Tuple[Literal["QD4"], RuleVariation_947_Arg]]]
Variation_1246_Arg: TypeAlias = Union[int, Variation_1246_Arg_Group]
class Variation_1246(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1099, 1), (Item_353, 1), (Item_12, 2), (Item_573, 12), (Item_3, 4), (Item_739, 1), (Item_717, 1), (Item_742, 1), (Item_722, 1), (Item_744, 1), (Item_724, 1), (Item_729, 1), (Item_747, 1), (Item_733, 1), (Item_750, 1), (Item_736, 1), (Item_754, 1)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "MODEC": RuleVariation_775, "QC1": RuleVariation_714, "QA1": RuleVariation_819, "QC2": RuleVariation_899, "QA2": RuleVariation_943, "QC4": RuleVariation_46, "QA4": RuleVariation_418, "QB1": RuleVariation_523, "QD1": RuleVariation_629, "QB2": RuleVariation_713, "QD2": RuleVariation_822, "QB4": RuleVariation_898, "QD4": RuleVariation_947}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODEC"]) -> RuleVariation_775:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC1"]) -> RuleVariation_714:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA1"]) -> RuleVariation_819:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC2"]) -> RuleVariation_899:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA2"]) -> RuleVariation_943:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC4"]) -> RuleVariation_46:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA4"]) -> RuleVariation_418:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB1"]) -> RuleVariation_523:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD1"]) -> RuleVariation_629:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB2"]) -> RuleVariation_713:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD2"]) -> RuleVariation_822:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB4"]) -> RuleVariation_898:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD4"]) -> RuleVariation_947:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["MODEC"], Literal["QC1"], Literal["QA1"], Literal["QC2"], Literal["QA2"], Literal["QC4"], Literal["QA4"], Literal["QB1"], Literal["QD1"], Literal["QB2"], Literal["QD2"], Literal["QB4"], Literal["QD4"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["MODEC"]) -> RuleVariation_775:
        ...
    @overload
    def get_item(self, key : Literal["QC1"]) -> RuleVariation_714:
        ...
    @overload
    def get_item(self, key : Literal["QA1"]) -> RuleVariation_819:
        ...
    @overload
    def get_item(self, key : Literal["QC2"]) -> RuleVariation_899:
        ...
    @overload
    def get_item(self, key : Literal["QA2"]) -> RuleVariation_943:
        ...
    @overload
    def get_item(self, key : Literal["QC4"]) -> RuleVariation_46:
        ...
    @overload
    def get_item(self, key : Literal["QA4"]) -> RuleVariation_418:
        ...
    @overload
    def get_item(self, key : Literal["QB1"]) -> RuleVariation_523:
        ...
    @overload
    def get_item(self, key : Literal["QD1"]) -> RuleVariation_629:
        ...
    @overload
    def get_item(self, key : Literal["QB2"]) -> RuleVariation_713:
        ...
    @overload
    def get_item(self, key : Literal["QD2"]) -> RuleVariation_822:
        ...
    @overload
    def get_item(self, key : Literal["QB4"]) -> RuleVariation_898:
        ...
    @overload
    def get_item(self, key : Literal["QD4"]) -> RuleVariation_947:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1246_Arg) -> 'Variation_1246':
        return cls._create(arg) # type: ignore

RuleVariation_1176_Arg: TypeAlias = Variation_1246_Arg
class RuleVariation_1176(RuleVariationContextFree):
    cv_variation = Variation_1246

    @classmethod
    def create(cls, arg : RuleVariation_1176_Arg) -> "RuleVariation_1176":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1246:
        return self.arg # type: ignore

NonSpare_270_Arg: TypeAlias = RuleVariation_1176_Arg
class NonSpare_270(NonSpare):
    cv_name = "100"
    cv_title = "Mode-C Code and Code Confidence Indicator"
    cv_rule = RuleVariation_1176

    @classmethod
    def create(cls, arg : NonSpare_270_Arg) -> "NonSpare_270":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1176:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1246:
        return self.rule.variation

class UapItem_270(UapItem):
    cv_non_spare = NonSpare_270

NonSpare_186_Arg: TypeAlias = RuleVariation_997_Arg
class NonSpare_186(NonSpare):
    cv_name = "060"
    cv_title = "Mode-2 Code Confidence Indicator"
    cv_rule = RuleVariation_997

    @classmethod
    def create(cls, arg : NonSpare_186_Arg) -> "NonSpare_186":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_997:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1029:
        return self.rule.variation

class UapItem_186(UapItem):
    cv_non_spare = NonSpare_186

Content_375_Arg: TypeAlias = int
class Content_375(ContentTable):
    cv_values = {0: "No warning nor error condition", 1: "Garbled reply", 2: "Reflection", 3: "Sidelobe reply", 4: "Split plot", 5: "Second time around reply", 6: "Angels", 7: "Terrestrial vehicles", 64: "Possible wrong code in Mode-3/A", 65: "Possible wrong altitude information, transmitted when the Code C credibility check fails together with the Mode-C code in binary notation", 66: "Possible phantom MSSR plot", 80: "Fixed PSR plot", 81: "Slow PSR plot", 82: "Low quality PSR plot"}

RuleContent_375_Arg: TypeAlias = Content_375_Arg
class RuleContent_375(RuleContentContextFree):
    cv_content = Content_375

    @property
    def content(self) -> Content_375:
        return self._get_content() # type: ignore

Variation_151_Arg: TypeAlias = RuleContent_375_Arg
class Variation_151(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_375

    @classmethod
    def create(cls, arg : Variation_151_Arg) -> "Variation_151":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_375:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_375:
        return self.rule.content

Variation_1447_Arg: TypeAlias = List[Variation_151_Arg]
class Variation_1447(Repetitive):
    cv_rep_bytes = None
    cv_variation = Variation_151

    @classmethod
    def create(cls, arg : Variation_1447_Arg) -> 'Variation_1447':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_151]:
        return self._get_list() # type: ignore

RuleVariation_1370_Arg: TypeAlias = Variation_1447_Arg
class RuleVariation_1370(RuleVariationContextFree):
    cv_variation = Variation_1447

    @classmethod
    def create(cls, arg : RuleVariation_1370_Arg) -> "RuleVariation_1370":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1447:
        return self.arg # type: ignore

NonSpare_115_Arg: TypeAlias = RuleVariation_1370_Arg
class NonSpare_115(NonSpare):
    cv_name = "030"
    cv_title = "Warning/Error Conditions"
    cv_rule = RuleVariation_1370

    @classmethod
    def create(cls, arg : NonSpare_115_Arg) -> "NonSpare_115":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1370:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1447:
        return self.rule.variation

class UapItem_115(UapItem):
    cv_non_spare = NonSpare_115

Content_166_Arg: TypeAlias = int
class Content_166(ContentTable):
    cv_values = {0: "Default", 1: "X-pulse received in Mode-3/A reply"}

RuleContent_166_Arg: TypeAlias = Content_166_Arg
class RuleContent_166(RuleContentContextFree):
    cv_content = Content_166

    @property
    def content(self) -> Content_166:
        return self._get_content() # type: ignore

Variation_36_Arg: TypeAlias = RuleContent_166_Arg
class Variation_36(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_166

    @classmethod
    def create(cls, arg : Variation_36_Arg) -> "Variation_36":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_166:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_166:
        return self.rule.content

RuleVariation_36_Arg: TypeAlias = Variation_36_Arg
class RuleVariation_36(RuleVariationContextFree):
    cv_variation = Variation_36

    @classmethod
    def create(cls, arg : RuleVariation_36_Arg) -> "RuleVariation_36":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_36:
        return self.arg # type: ignore

NonSpare_2103_Arg: TypeAlias = RuleVariation_36_Arg
class NonSpare_2103(NonSpare):
    cv_name = "XA"
    cv_title = ""
    cv_rule = RuleVariation_36

    @classmethod
    def create(cls, arg : NonSpare_2103_Arg) -> "NonSpare_2103":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_36:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_36:
        return self.rule.variation

Item_1210_Arg: TypeAlias = NonSpare_2103_Arg
class Item_1210(Item):
    cv_non_spare = NonSpare_2103

    @classmethod
    def create(cls, arg : Item_1210_Arg) -> "Item_1210":
        return cls._create(arg) # type: ignore

Item_7_Arg: TypeAlias = int
class Item_7(Spare):
    cv_bit_offset8 = 1
    cv_bit_size = 1

Content_167_Arg: TypeAlias = int
class Content_167(ContentTable):
    cv_values = {0: "Default", 1: "X-pulse received in Mode-C reply"}

RuleContent_167_Arg: TypeAlias = Content_167_Arg
class RuleContent_167(RuleContentContextFree):
    cv_content = Content_167

    @property
    def content(self) -> Content_167:
        return self._get_content() # type: ignore

Variation_522_Arg: TypeAlias = RuleContent_167_Arg
class Variation_522(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_167

    @classmethod
    def create(cls, arg : Variation_522_Arg) -> "Variation_522":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_167:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_167:
        return self.rule.content

RuleVariation_511_Arg: TypeAlias = Variation_522_Arg
class RuleVariation_511(RuleVariationContextFree):
    cv_variation = Variation_522

    @classmethod
    def create(cls, arg : RuleVariation_511_Arg) -> "RuleVariation_511":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_522:
        return self.arg # type: ignore

NonSpare_2104_Arg: TypeAlias = RuleVariation_511_Arg
class NonSpare_2104(NonSpare):
    cv_name = "XC"
    cv_title = ""
    cv_rule = RuleVariation_511

    @classmethod
    def create(cls, arg : NonSpare_2104_Arg) -> "NonSpare_2104":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_511:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_522:
        return self.rule.variation

Item_1211_Arg: TypeAlias = NonSpare_2104_Arg
class Item_1211(Item):
    cv_non_spare = NonSpare_2104

    @classmethod
    def create(cls, arg : Item_1211_Arg) -> "Item_1211":
        return cls._create(arg) # type: ignore

Item_17_Arg: TypeAlias = int
class Item_17(Spare):
    cv_bit_offset8 = 3
    cv_bit_size = 2

Content_165_Arg: TypeAlias = int
class Content_165(ContentTable):
    cv_values = {0: "Default", 1: "X-pulse received in Mode-2 reply"}

RuleContent_165_Arg: TypeAlias = Content_165_Arg
class RuleContent_165(RuleContentContextFree):
    cv_content = Content_165

    @property
    def content(self) -> Content_165:
        return self._get_content() # type: ignore

Variation_839_Arg: TypeAlias = RuleContent_165_Arg
class Variation_839(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_165

    @classmethod
    def create(cls, arg : Variation_839_Arg) -> "Variation_839":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_165:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_165:
        return self.rule.content

RuleVariation_809_Arg: TypeAlias = Variation_839_Arg
class RuleVariation_809(RuleVariationContextFree):
    cv_variation = Variation_839

    @classmethod
    def create(cls, arg : RuleVariation_809_Arg) -> "RuleVariation_809":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_839:
        return self.arg # type: ignore

NonSpare_2097_Arg: TypeAlias = RuleVariation_809_Arg
class NonSpare_2097(NonSpare):
    cv_name = "X2"
    cv_title = ""
    cv_rule = RuleVariation_809

    @classmethod
    def create(cls, arg : NonSpare_2097_Arg) -> "NonSpare_2097":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_809:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_839:
        return self.rule.variation

Item_1204_Arg: TypeAlias = NonSpare_2097_Arg
class Item_1204(Item):
    cv_non_spare = NonSpare_2097

    @classmethod
    def create(cls, arg : Item_1204_Arg) -> "Item_1204":
        return cls._create(arg) # type: ignore

Item_27_Arg: TypeAlias = int
class Item_27(Spare):
    cv_bit_offset8 = 6
    cv_bit_size = 2

Variation_1313_Arg_Group = Tuple[Union[RuleVariation_36_Arg, Tuple[Literal["XA"], RuleVariation_36_Arg]], int, Union[RuleVariation_511_Arg, Tuple[Literal["XC"], RuleVariation_511_Arg]], int, Union[RuleVariation_809_Arg, Tuple[Literal["X2"], RuleVariation_809_Arg]], int]
Variation_1313_Arg: TypeAlias = Union[int, Variation_1313_Arg_Group]
class Variation_1313(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1210, 1), (Item_7, 1), (Item_1211, 1), (Item_17, 2), (Item_1204, 1), (Item_27, 2)]
    cv_items_dict = {"XA": RuleVariation_36, "XC": RuleVariation_511, "X2": RuleVariation_809}

    @overload
    @classmethod
    def spec(cls, key : Literal["XA"]) -> RuleVariation_36:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XC"]) -> RuleVariation_511:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X2"]) -> RuleVariation_809:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["XA"], Literal["XC"], Literal["X2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["XA"]) -> RuleVariation_36:
        ...
    @overload
    def get_item(self, key : Literal["XC"]) -> RuleVariation_511:
        ...
    @overload
    def get_item(self, key : Literal["X2"]) -> RuleVariation_809:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1313_Arg) -> 'Variation_1313':
        return cls._create(arg) # type: ignore

RuleVariation_1238_Arg: TypeAlias = Variation_1313_Arg
class RuleVariation_1238(RuleVariationContextFree):
    cv_variation = Variation_1313

    @classmethod
    def create(cls, arg : RuleVariation_1238_Arg) -> "RuleVariation_1238":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1313:
        return self.arg # type: ignore

NonSpare_341_Arg: TypeAlias = RuleVariation_1238_Arg
class NonSpare_341(NonSpare):
    cv_name = "150"
    cv_title = "Presence of X-Pulse"
    cv_rule = RuleVariation_1238

    @classmethod
    def create(cls, arg : NonSpare_341_Arg) -> "NonSpare_341":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1238:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1313:
        return self.rule.variation

class UapItem_341(UapItem):
    cv_non_spare = NonSpare_341

class UapItem_544(UapItemSpare):
    pass

Variation_1455_Arg: TypeAlias = bytes
class Variation_1455(Explicit):
    cv_explicit_type = SpecialPurpose

    @classmethod
    def create(cls, arg : Variation_1455_Arg) -> 'Variation_1455':
        return cls._create(arg) # type: ignore

RuleVariation_1378_Arg: TypeAlias = Variation_1455_Arg
class RuleVariation_1378(RuleVariationContextFree):
    cv_variation = Variation_1455

    @classmethod
    def create(cls, arg : RuleVariation_1378_Arg) -> "RuleVariation_1378":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1455:
        return self.arg # type: ignore

NonSpare_1723_Arg: TypeAlias = RuleVariation_1378_Arg
class NonSpare_1723(NonSpare):
    cv_name = "SP"
    cv_title = "Special Purpose Field"
    cv_rule = RuleVariation_1378

    @classmethod
    def create(cls, arg : NonSpare_1723_Arg) -> "NonSpare_1723":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1378:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1455:
        return self.rule.variation

class UapItem_543(UapItem):
    cv_non_spare = NonSpare_1723

class UapItem_545(UapItemRFS):
    pass

Record_17_Arg = TypedDict('Record_17_Arg', {
    "010": NonSpare_35_Arg,
    "020": NonSpare_86_Arg,
    "040": NonSpare_136_Arg,
    "070": NonSpare_209_Arg,
    "090": NonSpare_249_Arg,
    "130": NonSpare_307_Arg,
    "141": NonSpare_332_Arg,
    "050": NonSpare_171_Arg,
    "120": NonSpare_295_Arg,
    "131": NonSpare_311_Arg,
    "080": NonSpare_229_Arg,
    "100": NonSpare_270_Arg,
    "060": NonSpare_186_Arg,
    "030": NonSpare_115_Arg,
    "150": NonSpare_341_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
Record_17_Union = Union[
    Tuple[Literal["010"], NonSpare_35_Arg],
    Tuple[Literal["020"], NonSpare_86_Arg],
    Tuple[Literal["040"], NonSpare_136_Arg],
    Tuple[Literal["070"], NonSpare_209_Arg],
    Tuple[Literal["090"], NonSpare_249_Arg],
    Tuple[Literal["130"], NonSpare_307_Arg],
    Tuple[Literal["141"], NonSpare_332_Arg],
    Tuple[Literal["050"], NonSpare_171_Arg],
    Tuple[Literal["120"], NonSpare_295_Arg],
    Tuple[Literal["131"], NonSpare_311_Arg],
    Tuple[Literal["080"], NonSpare_229_Arg],
    Tuple[Literal["100"], NonSpare_270_Arg],
    Tuple[Literal["060"], NonSpare_186_Arg],
    Tuple[Literal["030"], NonSpare_115_Arg],
    Tuple[Literal["150"], NonSpare_341_Arg],
    Tuple[Literal["SP"], NonSpare_1723_Arg],
]
class Record_17(Record):
    cv_fspec_max_bytes = 3
    cv_items_list = [UapItem_35, UapItem_86, UapItem_136, UapItem_209, UapItem_249, UapItem_307, UapItem_332, UapItem_171, UapItem_295, UapItem_311, UapItem_229, UapItem_270, UapItem_186, UapItem_115, UapItem_341, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_543, UapItem_545]
    cv_items_dict = {"010": NonSpare_35, "020": NonSpare_86, "040": NonSpare_136, "070": NonSpare_209, "090": NonSpare_249, "130": NonSpare_307, "141": NonSpare_332, "050": NonSpare_171, "120": NonSpare_295, "131": NonSpare_311, "080": NonSpare_229, "100": NonSpare_270, "060": NonSpare_186, "030": NonSpare_115, "150": NonSpare_341, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_35:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_86:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_136:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_209:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_249:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_307:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["141"]) -> NonSpare_332:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_171:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_295:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_311:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_229:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_270:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_186:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_115:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_341:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["020"], Literal["040"], Literal["070"], Literal["090"], Literal["130"], Literal["141"], Literal["050"], Literal["120"], Literal["131"], Literal["080"], Literal["100"], Literal["060"], Literal["030"], Literal["150"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_35]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_86]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_136]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_209]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_249]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_307]:
        ...
    @overload
    def get_item(self, key : Literal["141"]) -> Optional[NonSpare_332]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_171]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_295]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_311]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_229]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_270]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_186]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_115]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_341]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_35_Arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_86_Arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_136_Arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_209_Arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_249_Arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_307_Arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["141"], val : NonSpare_332_Arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_171_Arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_295_Arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_311_Arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_229_Arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_270_Arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_186_Arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_115_Arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_341_Arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_17':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["141"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_17':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @overload
    def get_rfs_item(self, arg : Literal["010"]) -> List[NonSpare_35]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["020"]) -> List[NonSpare_86]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["040"]) -> List[NonSpare_136]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["070"]) -> List[NonSpare_209]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["090"]) -> List[NonSpare_249]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["130"]) -> List[NonSpare_307]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["141"]) -> List[NonSpare_332]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["050"]) -> List[NonSpare_171]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["120"]) -> List[NonSpare_295]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["131"]) -> List[NonSpare_311]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["080"]) -> List[NonSpare_229]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["100"]) -> List[NonSpare_270]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["060"]) -> List[NonSpare_186]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["030"]) -> List[NonSpare_115]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["150"]) -> List[NonSpare_341]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["SP"]) -> List[NonSpare_1723]:
        ...
    def get_rfs_item(self, arg : Any) -> Any:
        return self._get_rfs_item(arg)

    @classmethod
    def create(cls, arg : Record_17_Arg, rfs : Optional[List[Record_17_Union]] = None) -> 'Record_17':
        return cls._create(arg, rfs) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_17", Bits]]:
        return cls._parse(bs) # type: ignore

Variation_251_Arg: TypeAlias = RuleContent_0_Arg
class Variation_251(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_251_Arg) -> "Variation_251":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_244_Arg: TypeAlias = Variation_251_Arg
class RuleVariation_244(RuleVariationContextFree):
    cv_variation = Variation_251

    @classmethod
    def create(cls, arg : RuleVariation_244_Arg) -> "RuleVariation_244":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_251:
        return self.arg # type: ignore

NonSpare_361_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_361(NonSpare):
    cv_name = "161"
    cv_title = "Track Plot Number"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_361_Arg) -> "NonSpare_361":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

class UapItem_361(UapItem):
    cv_non_spare = NonSpare_361

Content_671_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
class Content_671(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.5625e-2
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

RuleContent_671_Arg: TypeAlias = Content_671_Arg
class RuleContent_671(RuleContentContextFree):
    cv_content = Content_671

    @property
    def content(self) -> Content_671:
        return self._get_content() # type: ignore

Variation_282_Arg: TypeAlias = RuleContent_671_Arg
class Variation_282(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_671

    @classmethod
    def create(cls, arg : Variation_282_Arg) -> "Variation_282":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_671:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_671:
        return self.rule.content

RuleVariation_275_Arg: TypeAlias = Variation_282_Arg
class RuleVariation_275(RuleVariationContextFree):
    cv_variation = Variation_282

    @classmethod
    def create(cls, arg : RuleVariation_275_Arg) -> "RuleVariation_275":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_282:
        return self.arg # type: ignore

NonSpare_2089_Arg: TypeAlias = RuleVariation_275_Arg
class NonSpare_2089(NonSpare):
    cv_name = "X"
    cv_title = "X-Component"
    cv_rule = RuleVariation_275

    @classmethod
    def create(cls, arg : NonSpare_2089_Arg) -> "NonSpare_2089":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_275:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_282:
        return self.rule.variation

Item_1196_Arg: TypeAlias = NonSpare_2089_Arg
class Item_1196(Item):
    cv_non_spare = NonSpare_2089

    @classmethod
    def create(cls, arg : Item_1196_Arg) -> "Item_1196":
        return cls._create(arg) # type: ignore

NonSpare_2143_Arg: TypeAlias = RuleVariation_275_Arg
class NonSpare_2143(NonSpare):
    cv_name = "Y"
    cv_title = "Y-Component"
    cv_rule = RuleVariation_275

    @classmethod
    def create(cls, arg : NonSpare_2143_Arg) -> "NonSpare_2143":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_275:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_282:
        return self.rule.variation

Item_1247_Arg: TypeAlias = NonSpare_2143_Arg
class Item_1247(Item):
    cv_non_spare = NonSpare_2143

    @classmethod
    def create(cls, arg : Item_1247_Arg) -> "Item_1247":
        return cls._create(arg) # type: ignore

Variation_1306_Arg_Group = Tuple[Union[RuleVariation_275_Arg, Tuple[Literal["X"], RuleVariation_275_Arg]], Union[RuleVariation_275_Arg, Tuple[Literal["Y"], RuleVariation_275_Arg]]]
Variation_1306_Arg: TypeAlias = Union[int, Variation_1306_Arg_Group]
class Variation_1306(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1196, 16), (Item_1247, 16)]
    cv_items_dict = {"X": RuleVariation_275, "Y": RuleVariation_275}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_275:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_275:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_275:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_275:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1306_Arg) -> 'Variation_1306':
        return cls._create(arg) # type: ignore

RuleVariation_1234_Arg: TypeAlias = Variation_1306_Arg
class RuleVariation_1234(RuleVariationContextFree):
    cv_variation = Variation_1306

    @classmethod
    def create(cls, arg : RuleVariation_1234_Arg) -> "RuleVariation_1234":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1306:
        return self.arg # type: ignore

NonSpare_157_Arg: TypeAlias = RuleVariation_1234_Arg
class NonSpare_157(NonSpare):
    cv_name = "042"
    cv_title = "Calculated Position in Cartesian Co-ordinates"
    cv_rule = RuleVariation_1234

    @classmethod
    def create(cls, arg : NonSpare_157_Arg) -> "NonSpare_157":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1234:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1306:
        return self.rule.variation

class UapItem_157(UapItem):
    cv_non_spare = NonSpare_157

Content_775_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM/s"]]]
class Content_775(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 6.103515625e-5
    cv_unit = "NM/s"

    def as_quantity(self, cv_unit : Optional[Literal["NM/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_774_Arg: TypeAlias = Content_775_Arg
class RuleContent_774(RuleContentContextFree):
    cv_content = Content_775

    @property
    def content(self) -> Content_775:
        return self._get_content() # type: ignore

Variation_336_Arg: TypeAlias = RuleContent_774_Arg
class Variation_336(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_774

    @classmethod
    def create(cls, arg : Variation_336_Arg) -> "Variation_336":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_774:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_775:
        return self.rule.content

RuleVariation_329_Arg: TypeAlias = Variation_336_Arg
class RuleVariation_329(RuleVariationContextFree):
    cv_variation = Variation_336

    @classmethod
    def create(cls, arg : RuleVariation_329_Arg) -> "RuleVariation_329":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_336:
        return self.arg # type: ignore

NonSpare_1033_Arg: TypeAlias = RuleVariation_329_Arg
class NonSpare_1033(NonSpare):
    cv_name = "GSP"
    cv_title = "Calculated Groundspeed"
    cv_rule = RuleVariation_329

    @classmethod
    def create(cls, arg : NonSpare_1033_Arg) -> "NonSpare_1033":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_329:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_336:
        return self.rule.variation

Item_373_Arg: TypeAlias = NonSpare_1033_Arg
class Item_373(Item):
    cv_non_spare = NonSpare_1033

    @classmethod
    def create(cls, arg : Item_373_Arg) -> "Item_373":
        return cls._create(arg) # type: ignore

NonSpare_1053_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_1053(NonSpare):
    cv_name = "HDG"
    cv_title = "Calculated Heading"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_1053_Arg) -> "NonSpare_1053":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Item_387_Arg: TypeAlias = NonSpare_1053_Arg
class Item_387(Item):
    cv_non_spare = NonSpare_1053

    @classmethod
    def create(cls, arg : Item_387_Arg) -> "Item_387":
        return cls._create(arg) # type: ignore

Variation_1109_Arg_Group = Tuple[Union[RuleVariation_329_Arg, Tuple[Literal["GSP"], RuleVariation_329_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["HDG"], RuleVariation_334_Arg]]]
Variation_1109_Arg: TypeAlias = Union[int, Variation_1109_Arg_Group]
class Variation_1109(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_373, 16), (Item_387, 16)]
    cv_items_dict = {"GSP": RuleVariation_329, "HDG": RuleVariation_334}

    @overload
    @classmethod
    def spec(cls, key : Literal["GSP"]) -> RuleVariation_329:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HDG"]) -> RuleVariation_334:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GSP"], Literal["HDG"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GSP"]) -> RuleVariation_329:
        ...
    @overload
    def get_item(self, key : Literal["HDG"]) -> RuleVariation_334:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1109_Arg) -> 'Variation_1109':
        return cls._create(arg) # type: ignore

RuleVariation_1067_Arg: TypeAlias = Variation_1109_Arg
class RuleVariation_1067(RuleVariationContextFree):
    cv_variation = Variation_1109

    @classmethod
    def create(cls, arg : RuleVariation_1067_Arg) -> "RuleVariation_1067":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1109:
        return self.arg # type: ignore

NonSpare_384_Arg: TypeAlias = RuleVariation_1067_Arg
class NonSpare_384(NonSpare):
    cv_name = "200"
    cv_title = "Calculated Track Velocity in Polar Co-ordinates"
    cv_rule = RuleVariation_1067

    @classmethod
    def create(cls, arg : NonSpare_384_Arg) -> "NonSpare_384":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1067:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1109:
        return self.rule.variation

class UapItem_384(UapItem):
    cv_non_spare = NonSpare_384

Content_61_Arg: TypeAlias = int
class Content_61(ContentTable):
    cv_values = {0: "Confirmed Track", 1: "Track in initialisation phase"}

RuleContent_61_Arg: TypeAlias = Content_61_Arg
class RuleContent_61(RuleContentContextFree):
    cv_content = Content_61

    @property
    def content(self) -> Content_61:
        return self._get_content() # type: ignore

Variation_17_Arg: TypeAlias = RuleContent_61_Arg
class Variation_17(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_61

    @classmethod
    def create(cls, arg : Variation_17_Arg) -> "Variation_17":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_61:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_61:
        return self.rule.content

RuleVariation_17_Arg: TypeAlias = Variation_17_Arg
class RuleVariation_17(RuleVariationContextFree):
    cv_variation = Variation_17

    @classmethod
    def create(cls, arg : RuleVariation_17_Arg) -> "RuleVariation_17":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_17:
        return self.arg # type: ignore

Content_429_Arg: TypeAlias = int
class Content_429(ContentTable):
    cv_values = {0: "Primary track", 1: "SSR/Combined track"}

RuleContent_429_Arg: TypeAlias = Content_429_Arg
class RuleContent_429(RuleContentContextFree):
    cv_content = Content_429

    @property
    def content(self) -> Content_429:
        return self._get_content() # type: ignore

Variation_447_Arg: TypeAlias = RuleContent_429_Arg
class Variation_447(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_429

    @classmethod
    def create(cls, arg : Variation_447_Arg) -> "Variation_447":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_429:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_429:
        return self.rule.content

RuleVariation_436_Arg: TypeAlias = Variation_447_Arg
class RuleVariation_436(RuleVariationContextFree):
    cv_variation = Variation_447

    @classmethod
    def create(cls, arg : RuleVariation_436_Arg) -> "RuleVariation_436":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_447:
        return self.arg # type: ignore

Content_84_Arg: TypeAlias = int
class Content_84(ContentTable):
    cv_values = {0: "Default", 1: "Aircraft manoeuvring"}

RuleContent_84_Arg: TypeAlias = Content_84_Arg
class RuleContent_84(RuleContentContextFree):
    cv_content = Content_84

    @property
    def content(self) -> Content_84:
        return self._get_content() # type: ignore

Variation_512_Arg: TypeAlias = RuleContent_84_Arg
class Variation_512(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_84

    @classmethod
    def create(cls, arg : Variation_512_Arg) -> "Variation_512":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_84:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_84:
        return self.rule.content

RuleVariation_501_Arg: TypeAlias = Variation_512_Arg
class RuleVariation_501(RuleVariationContextFree):
    cv_variation = Variation_512

    @classmethod
    def create(cls, arg : RuleVariation_501_Arg) -> "RuleVariation_501":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_512:
        return self.arg # type: ignore

Content_94_Arg: TypeAlias = int
class Content_94(ContentTable):
    cv_values = {0: "Default", 1: "Doubtful plot to track association"}

RuleContent_94_Arg: TypeAlias = Content_94_Arg
class RuleContent_94(RuleContentContextFree):
    cv_content = Content_94

    @property
    def content(self) -> Content_94:
        return self._get_content() # type: ignore

Variation_618_Arg: TypeAlias = RuleContent_94_Arg
class Variation_618(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_94

    @classmethod
    def create(cls, arg : Variation_618_Arg) -> "Variation_618":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_94:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_94:
        return self.rule.content

RuleVariation_607_Arg: TypeAlias = Variation_618_Arg
class RuleVariation_607(RuleVariationContextFree):
    cv_variation = Variation_618

    @classmethod
    def create(cls, arg : RuleVariation_607_Arg) -> "RuleVariation_607":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_618:
        return self.arg # type: ignore

Content_431_Arg: TypeAlias = int
class Content_431(ContentTable):
    cv_values = {0: "RDP Chain 1", 1: "RDP Chain 2"}

RuleContent_431_Arg: TypeAlias = Content_431_Arg
class RuleContent_431(RuleContentContextFree):
    cv_content = Content_431

    @property
    def content(self) -> Content_431:
        return self._get_content() # type: ignore

Variation_743_Arg: TypeAlias = RuleContent_431_Arg
class Variation_743(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_431

    @classmethod
    def create(cls, arg : Variation_743_Arg) -> "Variation_743":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_431:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_431:
        return self.rule.content

RuleVariation_732_Arg: TypeAlias = Variation_743_Arg
class RuleVariation_732(RuleVariationContextFree):
    cv_variation = Variation_743

    @classmethod
    def create(cls, arg : RuleVariation_732_Arg) -> "RuleVariation_732":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_743:
        return self.arg # type: ignore

Content_99_Arg: TypeAlias = int
class Content_99(ContentTable):
    cv_values = {0: "Default", 1: "Ghost track"}

RuleContent_99_Arg: TypeAlias = Content_99_Arg
class RuleContent_99(RuleContentContextFree):
    cv_content = Content_99

    @property
    def content(self) -> Content_99:
        return self._get_content() # type: ignore

Variation_909_Arg: TypeAlias = RuleContent_99_Arg
class Variation_909(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_99

    @classmethod
    def create(cls, arg : Variation_909_Arg) -> "Variation_909":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_99:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_99:
        return self.rule.content

RuleVariation_879_Arg: TypeAlias = Variation_909_Arg
class RuleVariation_879(RuleVariationContextFree):
    cv_variation = Variation_909

    @classmethod
    def create(cls, arg : RuleVariation_879_Arg) -> "RuleVariation_879":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_909:
        return self.arg # type: ignore

Content_112_Arg: TypeAlias = int
class Content_112(ContentTable):
    cv_values = {0: "Default", 1: "Last report for a track"}

RuleContent_112_Arg: TypeAlias = Content_112_Arg
class RuleContent_112(RuleContentContextFree):
    cv_content = Content_112

    @property
    def content(self) -> Content_112:
        return self._get_content() # type: ignore

Variation_31_Arg: TypeAlias = RuleContent_112_Arg
class Variation_31(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_112

    @classmethod
    def create(cls, arg : Variation_31_Arg) -> "Variation_31":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_112:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_112:
        return self.rule.content

RuleVariation_31_Arg: TypeAlias = Variation_31_Arg
class RuleVariation_31(RuleVariationContextFree):
    cv_variation = Variation_31

    @classmethod
    def create(cls, arg : RuleVariation_31_Arg) -> "RuleVariation_31":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_31:
        return self.arg # type: ignore

NonSpare_784_Arg: TypeAlias = RuleVariation_17_Arg
class NonSpare_784(NonSpare):
    cv_name = "CON"
    cv_title = ""
    cv_rule = RuleVariation_17

    @classmethod
    def create(cls, arg : NonSpare_784_Arg) -> "NonSpare_784":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_17:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_17:
        return self.rule.variation

Item_189_Arg: TypeAlias = NonSpare_784_Arg
class Item_189(Item):
    cv_non_spare = NonSpare_784

    @classmethod
    def create(cls, arg : Item_189_Arg) -> "Item_189":
        return cls._create(arg) # type: ignore

NonSpare_1534_Arg: TypeAlias = RuleVariation_436_Arg
class NonSpare_1534(NonSpare):
    cv_name = "RAD"
    cv_title = ""
    cv_rule = RuleVariation_436

    @classmethod
    def create(cls, arg : NonSpare_1534_Arg) -> "NonSpare_1534":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_436:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_447:
        return self.rule.variation

Item_770_Arg: TypeAlias = NonSpare_1534_Arg
class Item_770(Item):
    cv_non_spare = NonSpare_1534

    @classmethod
    def create(cls, arg : Item_770_Arg) -> "Item_770":
        return cls._create(arg) # type: ignore

NonSpare_1219_Arg: TypeAlias = RuleVariation_501_Arg
class NonSpare_1219(NonSpare):
    cv_name = "MAN"
    cv_title = ""
    cv_rule = RuleVariation_501

    @classmethod
    def create(cls, arg : NonSpare_1219_Arg) -> "NonSpare_1219":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_501:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_512:
        return self.rule.variation

Item_524_Arg: TypeAlias = NonSpare_1219_Arg
class Item_524(Item):
    cv_non_spare = NonSpare_1219

    @classmethod
    def create(cls, arg : Item_524_Arg) -> "Item_524":
        return cls._create(arg) # type: ignore

NonSpare_886_Arg: TypeAlias = RuleVariation_607_Arg
class NonSpare_886(NonSpare):
    cv_name = "DOU"
    cv_title = ""
    cv_rule = RuleVariation_607

    @classmethod
    def create(cls, arg : NonSpare_886_Arg) -> "NonSpare_886":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_607:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_618:
        return self.rule.variation

Item_267_Arg: TypeAlias = NonSpare_886_Arg
class Item_267(Item):
    cv_non_spare = NonSpare_886

    @classmethod
    def create(cls, arg : Item_267_Arg) -> "Item_267":
        return cls._create(arg) # type: ignore

NonSpare_1550_Arg: TypeAlias = RuleVariation_732_Arg
class NonSpare_1550(NonSpare):
    cv_name = "RDPC"
    cv_title = "Radar Data Processing Chain"
    cv_rule = RuleVariation_732

    @classmethod
    def create(cls, arg : NonSpare_1550_Arg) -> "NonSpare_1550":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_732:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_743:
        return self.rule.variation

Item_784_Arg: TypeAlias = NonSpare_1550_Arg
class Item_784(Item):
    cv_non_spare = NonSpare_1550

    @classmethod
    def create(cls, arg : Item_784_Arg) -> "Item_784":
        return cls._create(arg) # type: ignore

Item_23_Arg: TypeAlias = int
class Item_23(Spare):
    cv_bit_offset8 = 5
    cv_bit_size = 1

NonSpare_1028_Arg: TypeAlias = RuleVariation_879_Arg
class NonSpare_1028(NonSpare):
    cv_name = "GHO"
    cv_title = ""
    cv_rule = RuleVariation_879

    @classmethod
    def create(cls, arg : NonSpare_1028_Arg) -> "NonSpare_1028":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_879:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_909:
        return self.rule.variation

Item_369_Arg: TypeAlias = NonSpare_1028_Arg
class Item_369(Item):
    cv_non_spare = NonSpare_1028

    @classmethod
    def create(cls, arg : Item_369_Arg) -> "Item_369":
        return cls._create(arg) # type: ignore

NonSpare_1905_Arg: TypeAlias = RuleVariation_31_Arg
class NonSpare_1905(NonSpare):
    cv_name = "TRE"
    cv_title = ""
    cv_rule = RuleVariation_31

    @classmethod
    def create(cls, arg : NonSpare_1905_Arg) -> "NonSpare_1905":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_31:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_31:
        return self.rule.variation

Item_1032_Arg: TypeAlias = NonSpare_1905_Arg
class Item_1032(Item):
    cv_non_spare = NonSpare_1905

    @classmethod
    def create(cls, arg : Item_1032_Arg) -> "Item_1032":
        return cls._create(arg) # type: ignore

Item_9_Arg: TypeAlias = int
class Item_9(Spare):
    cv_bit_offset8 = 1
    cv_bit_size = 6

Variation_1347_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_17_Arg, Tuple[Literal["CON"], RuleVariation_17_Arg]], Union[RuleVariation_436_Arg, Tuple[Literal["RAD"], RuleVariation_436_Arg]], Union[RuleVariation_501_Arg, Tuple[Literal["MAN"], RuleVariation_501_Arg]], Union[RuleVariation_607_Arg, Tuple[Literal["DOU"], RuleVariation_607_Arg]], Union[RuleVariation_732_Arg, Tuple[Literal["RDPC"], RuleVariation_732_Arg]], int, Union[RuleVariation_879_Arg, Tuple[Literal["GHO"], RuleVariation_879_Arg]], None]]
Variation_1347_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_31_Arg, Tuple[Literal["TRE"], RuleVariation_31_Arg]], int, None]]
Variation_1347_Arg: TypeAlias = Union[
    Tuple[Variation_1347_Arg_Group_1],
    Tuple[Variation_1347_Arg_Group_1, Variation_1347_Arg_Group_2],
]
class Variation_1347(Extended):
    cv_items_list = [[(Item_189, 1), (Item_770, 1), (Item_524, 1), (Item_267, 1), (Item_784, 1), (Item_23, 1), (Item_369, 1), None], [(Item_1032, 1), (Item_9, 6), None]]

    @classmethod
    def create(cls, arg : Variation_1347_Arg) -> 'Variation_1347':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["CON"]) -> RuleVariation_17:
        ...
    @overload
    def get_item(self, key : Literal["RAD"]) -> RuleVariation_436:
        ...
    @overload
    def get_item(self, key : Literal["MAN"]) -> RuleVariation_501:
        ...
    @overload
    def get_item(self, key : Literal["DOU"]) -> RuleVariation_607:
        ...
    @overload
    def get_item(self, key : Literal["RDPC"]) -> RuleVariation_732:
        ...
    @overload
    def get_item(self, key : Literal["GHO"]) -> RuleVariation_879:
        ...
    @overload
    def get_item(self, key : Literal["TRE"]) -> Optional[RuleVariation_31]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1270_Arg: TypeAlias = Variation_1347_Arg
class RuleVariation_1270(RuleVariationContextFree):
    cv_variation = Variation_1347

    @classmethod
    def create(cls, arg : RuleVariation_1270_Arg) -> "RuleVariation_1270":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1347:
        return self.arg # type: ignore

NonSpare_373_Arg: TypeAlias = RuleVariation_1270_Arg
class NonSpare_373(NonSpare):
    cv_name = "170"
    cv_title = "Track Status"
    cv_rule = RuleVariation_1270

    @classmethod
    def create(cls, arg : NonSpare_373_Arg) -> "NonSpare_373":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1270:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1347:
        return self.rule.variation

class UapItem_373(UapItem):
    cv_non_spare = NonSpare_373

NonSpare_412_Arg: TypeAlias = RuleVariation_1369_Arg
class NonSpare_412(NonSpare):
    cv_name = "210"
    cv_title = "Track Quality"
    cv_rule = RuleVariation_1369

    @classmethod
    def create(cls, arg : NonSpare_412_Arg) -> "NonSpare_412":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1369:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1446:
        return self.rule.variation

class UapItem_412(UapItem):
    cv_non_spare = NonSpare_412

Record_18_Arg = TypedDict('Record_18_Arg', {
    "010": NonSpare_35_Arg,
    "020": NonSpare_86_Arg,
    "161": NonSpare_361_Arg,
    "040": NonSpare_136_Arg,
    "042": NonSpare_157_Arg,
    "200": NonSpare_384_Arg,
    "070": NonSpare_209_Arg,
    "090": NonSpare_249_Arg,
    "141": NonSpare_332_Arg,
    "130": NonSpare_307_Arg,
    "131": NonSpare_311_Arg,
    "120": NonSpare_295_Arg,
    "170": NonSpare_373_Arg,
    "210": NonSpare_412_Arg,
    "050": NonSpare_171_Arg,
    "080": NonSpare_229_Arg,
    "100": NonSpare_270_Arg,
    "060": NonSpare_186_Arg,
    "030": NonSpare_115_Arg,
    "SP": NonSpare_1723_Arg,
    "150": NonSpare_341_Arg,
}, total=False)
Record_18_Union = Union[
    Tuple[Literal["010"], NonSpare_35_Arg],
    Tuple[Literal["020"], NonSpare_86_Arg],
    Tuple[Literal["161"], NonSpare_361_Arg],
    Tuple[Literal["040"], NonSpare_136_Arg],
    Tuple[Literal["042"], NonSpare_157_Arg],
    Tuple[Literal["200"], NonSpare_384_Arg],
    Tuple[Literal["070"], NonSpare_209_Arg],
    Tuple[Literal["090"], NonSpare_249_Arg],
    Tuple[Literal["141"], NonSpare_332_Arg],
    Tuple[Literal["130"], NonSpare_307_Arg],
    Tuple[Literal["131"], NonSpare_311_Arg],
    Tuple[Literal["120"], NonSpare_295_Arg],
    Tuple[Literal["170"], NonSpare_373_Arg],
    Tuple[Literal["210"], NonSpare_412_Arg],
    Tuple[Literal["050"], NonSpare_171_Arg],
    Tuple[Literal["080"], NonSpare_229_Arg],
    Tuple[Literal["100"], NonSpare_270_Arg],
    Tuple[Literal["060"], NonSpare_186_Arg],
    Tuple[Literal["030"], NonSpare_115_Arg],
    Tuple[Literal["SP"], NonSpare_1723_Arg],
    Tuple[Literal["150"], NonSpare_341_Arg],
]
class Record_18(Record):
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_35, UapItem_86, UapItem_361, UapItem_136, UapItem_157, UapItem_384, UapItem_209, UapItem_249, UapItem_332, UapItem_307, UapItem_311, UapItem_295, UapItem_373, UapItem_412, UapItem_171, UapItem_229, UapItem_270, UapItem_186, UapItem_115, UapItem_543, UapItem_545, UapItem_341]
    cv_items_dict = {"010": NonSpare_35, "020": NonSpare_86, "161": NonSpare_361, "040": NonSpare_136, "042": NonSpare_157, "200": NonSpare_384, "070": NonSpare_209, "090": NonSpare_249, "141": NonSpare_332, "130": NonSpare_307, "131": NonSpare_311, "120": NonSpare_295, "170": NonSpare_373, "210": NonSpare_412, "050": NonSpare_171, "080": NonSpare_229, "100": NonSpare_270, "060": NonSpare_186, "030": NonSpare_115, "SP": NonSpare_1723, "150": NonSpare_341}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_35:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_86:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_361:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_136:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_157:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_384:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_209:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_249:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["141"]) -> NonSpare_332:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_307:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_311:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_295:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_373:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_412:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_171:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_229:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_270:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_186:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_115:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_341:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["020"], Literal["161"], Literal["040"], Literal["042"], Literal["200"], Literal["070"], Literal["090"], Literal["141"], Literal["130"], Literal["131"], Literal["120"], Literal["170"], Literal["210"], Literal["050"], Literal["080"], Literal["100"], Literal["060"], Literal["030"], Literal["SP"], Literal["150"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_35]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_86]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_361]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_136]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_157]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_384]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_209]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_249]:
        ...
    @overload
    def get_item(self, key : Literal["141"]) -> Optional[NonSpare_332]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_307]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_311]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_295]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_373]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_412]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_171]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_229]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_270]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_186]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_115]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_341]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_35_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_86_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_361_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_136_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_157_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_384_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_209_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_249_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["141"], val : NonSpare_332_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_307_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_311_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_295_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_373_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_412_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_171_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_229_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_270_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_186_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_115_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_341_Arg) -> 'Record_18':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["141"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_18':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @overload
    def get_rfs_item(self, arg : Literal["010"]) -> List[NonSpare_35]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["020"]) -> List[NonSpare_86]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["161"]) -> List[NonSpare_361]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["040"]) -> List[NonSpare_136]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["042"]) -> List[NonSpare_157]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["200"]) -> List[NonSpare_384]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["070"]) -> List[NonSpare_209]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["090"]) -> List[NonSpare_249]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["141"]) -> List[NonSpare_332]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["130"]) -> List[NonSpare_307]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["131"]) -> List[NonSpare_311]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["120"]) -> List[NonSpare_295]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["170"]) -> List[NonSpare_373]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["210"]) -> List[NonSpare_412]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["050"]) -> List[NonSpare_171]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["080"]) -> List[NonSpare_229]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["100"]) -> List[NonSpare_270]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["060"]) -> List[NonSpare_186]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["030"]) -> List[NonSpare_115]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["SP"]) -> List[NonSpare_1723]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["150"]) -> List[NonSpare_341]:
        ...
    def get_rfs_item(self, arg : Any) -> Any:
        return self._get_rfs_item(arg)

    @classmethod
    def create(cls, arg : Record_18_Arg, rfs : Optional[List[Record_18_Union]] = None) -> 'Record_18':
        return cls._create(arg, rfs) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_18", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_47_Arg: TypeAlias = Union[Record_17, Record_18]
class Uap_47(UapMultiple):
    cv_uaps = {"plot": Record_17, "track": Record_18}
    cv_selector = (["020", "TYP"], {0: "plot", 1: "track"})

    @overload
    @classmethod
    def spec(cls, key : Literal["plot"]) -> Record_17:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["track"]) -> Record_18:
        ...
    @classmethod
    def spec(cls, key : Any) -> Any:
        return cls._spec(key)

    @overload
    @classmethod
    def parse(cls, uap : Literal["plot"], bs : Bits) -> Union[ValueError, List[Record_17]]:
        ...
    @overload
    @classmethod
    def parse(cls, uap : Literal["track"], bs : Bits) -> Union[ValueError, List[Record_18]]:
        ...
    @classmethod
    def parse(cls, uap : str, bs : Bits) -> Any:
        return cls._parse(uap, bs)

    @classmethod
    def parse_any_uap(cls, bs : Bits) -> List[List[Uap_47_Arg]]:
        return cls._parse_any_uap(bs)

class Asterix_0(AstCat):
    cv_category = 1
    cv_edition = (1, 2)
    cv_uap = Uap_47

    @classmethod
    def create(cls, records : List[Uap_47_Arg]) -> "Asterix_0":
        return cls._create(records) # type: ignore

NonSpare_36_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_36(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_36_Arg) -> "NonSpare_36":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_36(UapItem):
    cv_non_spare = NonSpare_36

Record_24_Arg = TypedDict('Record_24_Arg', {
    "010": NonSpare_36_Arg,
    "020": NonSpare_86_Arg,
    "040": NonSpare_136_Arg,
    "070": NonSpare_209_Arg,
    "090": NonSpare_249_Arg,
    "130": NonSpare_307_Arg,
    "141": NonSpare_332_Arg,
    "050": NonSpare_171_Arg,
    "120": NonSpare_295_Arg,
    "131": NonSpare_311_Arg,
    "080": NonSpare_229_Arg,
    "100": NonSpare_270_Arg,
    "060": NonSpare_186_Arg,
    "030": NonSpare_115_Arg,
    "150": NonSpare_341_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
Record_24_Union = Union[
    Tuple[Literal["010"], NonSpare_36_Arg],
    Tuple[Literal["020"], NonSpare_86_Arg],
    Tuple[Literal["040"], NonSpare_136_Arg],
    Tuple[Literal["070"], NonSpare_209_Arg],
    Tuple[Literal["090"], NonSpare_249_Arg],
    Tuple[Literal["130"], NonSpare_307_Arg],
    Tuple[Literal["141"], NonSpare_332_Arg],
    Tuple[Literal["050"], NonSpare_171_Arg],
    Tuple[Literal["120"], NonSpare_295_Arg],
    Tuple[Literal["131"], NonSpare_311_Arg],
    Tuple[Literal["080"], NonSpare_229_Arg],
    Tuple[Literal["100"], NonSpare_270_Arg],
    Tuple[Literal["060"], NonSpare_186_Arg],
    Tuple[Literal["030"], NonSpare_115_Arg],
    Tuple[Literal["150"], NonSpare_341_Arg],
    Tuple[Literal["SP"], NonSpare_1723_Arg],
]
class Record_24(Record):
    cv_fspec_max_bytes = 3
    cv_items_list = [UapItem_36, UapItem_86, UapItem_136, UapItem_209, UapItem_249, UapItem_307, UapItem_332, UapItem_171, UapItem_295, UapItem_311, UapItem_229, UapItem_270, UapItem_186, UapItem_115, UapItem_341, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_543, UapItem_545]
    cv_items_dict = {"010": NonSpare_36, "020": NonSpare_86, "040": NonSpare_136, "070": NonSpare_209, "090": NonSpare_249, "130": NonSpare_307, "141": NonSpare_332, "050": NonSpare_171, "120": NonSpare_295, "131": NonSpare_311, "080": NonSpare_229, "100": NonSpare_270, "060": NonSpare_186, "030": NonSpare_115, "150": NonSpare_341, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_36:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_86:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_136:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_209:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_249:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_307:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["141"]) -> NonSpare_332:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_171:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_295:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_311:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_229:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_270:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_186:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_115:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_341:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["020"], Literal["040"], Literal["070"], Literal["090"], Literal["130"], Literal["141"], Literal["050"], Literal["120"], Literal["131"], Literal["080"], Literal["100"], Literal["060"], Literal["030"], Literal["150"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_36]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_86]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_136]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_209]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_249]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_307]:
        ...
    @overload
    def get_item(self, key : Literal["141"]) -> Optional[NonSpare_332]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_171]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_295]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_311]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_229]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_270]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_186]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_115]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_341]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_36_Arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_86_Arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_136_Arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_209_Arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_249_Arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_307_Arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["141"], val : NonSpare_332_Arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_171_Arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_295_Arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_311_Arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_229_Arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_270_Arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_186_Arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_115_Arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_341_Arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_24':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["141"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_24':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @overload
    def get_rfs_item(self, arg : Literal["010"]) -> List[NonSpare_36]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["020"]) -> List[NonSpare_86]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["040"]) -> List[NonSpare_136]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["070"]) -> List[NonSpare_209]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["090"]) -> List[NonSpare_249]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["130"]) -> List[NonSpare_307]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["141"]) -> List[NonSpare_332]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["050"]) -> List[NonSpare_171]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["120"]) -> List[NonSpare_295]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["131"]) -> List[NonSpare_311]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["080"]) -> List[NonSpare_229]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["100"]) -> List[NonSpare_270]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["060"]) -> List[NonSpare_186]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["030"]) -> List[NonSpare_115]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["150"]) -> List[NonSpare_341]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["SP"]) -> List[NonSpare_1723]:
        ...
    def get_rfs_item(self, arg : Any) -> Any:
        return self._get_rfs_item(arg)

    @classmethod
    def create(cls, arg : Record_24_Arg, rfs : Optional[List[Record_24_Union]] = None) -> 'Record_24':
        return cls._create(arg, rfs) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_24", Bits]]:
        return cls._parse(bs) # type: ignore

Record_25_Arg = TypedDict('Record_25_Arg', {
    "010": NonSpare_36_Arg,
    "020": NonSpare_86_Arg,
    "161": NonSpare_361_Arg,
    "040": NonSpare_136_Arg,
    "042": NonSpare_157_Arg,
    "200": NonSpare_384_Arg,
    "070": NonSpare_209_Arg,
    "090": NonSpare_249_Arg,
    "141": NonSpare_332_Arg,
    "130": NonSpare_307_Arg,
    "131": NonSpare_311_Arg,
    "120": NonSpare_295_Arg,
    "170": NonSpare_373_Arg,
    "210": NonSpare_412_Arg,
    "050": NonSpare_171_Arg,
    "080": NonSpare_229_Arg,
    "100": NonSpare_270_Arg,
    "060": NonSpare_186_Arg,
    "030": NonSpare_115_Arg,
    "SP": NonSpare_1723_Arg,
    "150": NonSpare_341_Arg,
}, total=False)
Record_25_Union = Union[
    Tuple[Literal["010"], NonSpare_36_Arg],
    Tuple[Literal["020"], NonSpare_86_Arg],
    Tuple[Literal["161"], NonSpare_361_Arg],
    Tuple[Literal["040"], NonSpare_136_Arg],
    Tuple[Literal["042"], NonSpare_157_Arg],
    Tuple[Literal["200"], NonSpare_384_Arg],
    Tuple[Literal["070"], NonSpare_209_Arg],
    Tuple[Literal["090"], NonSpare_249_Arg],
    Tuple[Literal["141"], NonSpare_332_Arg],
    Tuple[Literal["130"], NonSpare_307_Arg],
    Tuple[Literal["131"], NonSpare_311_Arg],
    Tuple[Literal["120"], NonSpare_295_Arg],
    Tuple[Literal["170"], NonSpare_373_Arg],
    Tuple[Literal["210"], NonSpare_412_Arg],
    Tuple[Literal["050"], NonSpare_171_Arg],
    Tuple[Literal["080"], NonSpare_229_Arg],
    Tuple[Literal["100"], NonSpare_270_Arg],
    Tuple[Literal["060"], NonSpare_186_Arg],
    Tuple[Literal["030"], NonSpare_115_Arg],
    Tuple[Literal["SP"], NonSpare_1723_Arg],
    Tuple[Literal["150"], NonSpare_341_Arg],
]
class Record_25(Record):
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_36, UapItem_86, UapItem_361, UapItem_136, UapItem_157, UapItem_384, UapItem_209, UapItem_249, UapItem_332, UapItem_307, UapItem_311, UapItem_295, UapItem_373, UapItem_412, UapItem_171, UapItem_229, UapItem_270, UapItem_186, UapItem_115, UapItem_543, UapItem_545, UapItem_341]
    cv_items_dict = {"010": NonSpare_36, "020": NonSpare_86, "161": NonSpare_361, "040": NonSpare_136, "042": NonSpare_157, "200": NonSpare_384, "070": NonSpare_209, "090": NonSpare_249, "141": NonSpare_332, "130": NonSpare_307, "131": NonSpare_311, "120": NonSpare_295, "170": NonSpare_373, "210": NonSpare_412, "050": NonSpare_171, "080": NonSpare_229, "100": NonSpare_270, "060": NonSpare_186, "030": NonSpare_115, "SP": NonSpare_1723, "150": NonSpare_341}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_36:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_86:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_361:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_136:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_157:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_384:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_209:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_249:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["141"]) -> NonSpare_332:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_307:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_311:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_295:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_373:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_412:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_171:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_229:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_270:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_186:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_115:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_341:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["020"], Literal["161"], Literal["040"], Literal["042"], Literal["200"], Literal["070"], Literal["090"], Literal["141"], Literal["130"], Literal["131"], Literal["120"], Literal["170"], Literal["210"], Literal["050"], Literal["080"], Literal["100"], Literal["060"], Literal["030"], Literal["SP"], Literal["150"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_36]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_86]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_361]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_136]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_157]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_384]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_209]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_249]:
        ...
    @overload
    def get_item(self, key : Literal["141"]) -> Optional[NonSpare_332]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_307]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_311]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_295]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_373]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_412]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_171]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_229]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_270]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_186]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_115]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_341]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_36_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_86_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_361_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_136_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_157_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_384_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_209_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_249_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["141"], val : NonSpare_332_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_307_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_311_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_295_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_373_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_412_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_171_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_229_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_270_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_186_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_115_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_341_Arg) -> 'Record_25':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["141"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_25':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @overload
    def get_rfs_item(self, arg : Literal["010"]) -> List[NonSpare_36]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["020"]) -> List[NonSpare_86]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["161"]) -> List[NonSpare_361]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["040"]) -> List[NonSpare_136]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["042"]) -> List[NonSpare_157]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["200"]) -> List[NonSpare_384]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["070"]) -> List[NonSpare_209]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["090"]) -> List[NonSpare_249]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["141"]) -> List[NonSpare_332]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["130"]) -> List[NonSpare_307]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["131"]) -> List[NonSpare_311]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["120"]) -> List[NonSpare_295]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["170"]) -> List[NonSpare_373]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["210"]) -> List[NonSpare_412]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["050"]) -> List[NonSpare_171]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["080"]) -> List[NonSpare_229]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["100"]) -> List[NonSpare_270]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["060"]) -> List[NonSpare_186]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["030"]) -> List[NonSpare_115]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["SP"]) -> List[NonSpare_1723]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["150"]) -> List[NonSpare_341]:
        ...
    def get_rfs_item(self, arg : Any) -> Any:
        return self._get_rfs_item(arg)

    @classmethod
    def create(cls, arg : Record_25_Arg, rfs : Optional[List[Record_25_Union]] = None) -> 'Record_25':
        return cls._create(arg, rfs) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_25", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_48_Arg: TypeAlias = Union[Record_24, Record_25]
class Uap_48(UapMultiple):
    cv_uaps = {"plot": Record_24, "track": Record_25}
    cv_selector = (["020", "TYP"], {0: "plot", 1: "track"})

    @overload
    @classmethod
    def spec(cls, key : Literal["plot"]) -> Record_24:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["track"]) -> Record_25:
        ...
    @classmethod
    def spec(cls, key : Any) -> Any:
        return cls._spec(key)

    @overload
    @classmethod
    def parse(cls, uap : Literal["plot"], bs : Bits) -> Union[ValueError, List[Record_24]]:
        ...
    @overload
    @classmethod
    def parse(cls, uap : Literal["track"], bs : Bits) -> Union[ValueError, List[Record_25]]:
        ...
    @classmethod
    def parse(cls, uap : str, bs : Bits) -> Any:
        return cls._parse(uap, bs)

    @classmethod
    def parse_any_uap(cls, bs : Bits) -> List[List[Uap_48_Arg]]:
        return cls._parse_any_uap(bs)

class Asterix_1(AstCat):
    cv_category = 1
    cv_edition = (1, 3)
    cv_uap = Uap_48

    @classmethod
    def create(cls, records : List[Uap_48_Arg]) -> "Asterix_1":
        return cls._create(records) # type: ignore

class Asterix_2(AstCat):
    cv_category = 1
    cv_edition = (1, 4)
    cv_uap = Uap_48

    @classmethod
    def create(cls, records : List[Uap_48_Arg]) -> "Asterix_2":
        return cls._create(records) # type: ignore

NonSpare_46_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_46(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_46_Arg) -> "NonSpare_46":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_46(UapItem):
    cv_non_spare = NonSpare_46

Content_587_Arg: TypeAlias = int
class Content_587(ContentTable):
    cv_values = {1: "North marker message", 2: "Sector crossing message", 3: "South marker message", 8: "Activation of blind zone filtering", 9: "Stop of blind zone filtering"}

RuleContent_587_Arg: TypeAlias = Content_587_Arg
class RuleContent_587(RuleContentContextFree):
    cv_content = Content_587

    @property
    def content(self) -> Content_587:
        return self._get_content() # type: ignore

Variation_188_Arg: TypeAlias = RuleContent_587_Arg
class Variation_188(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_587

    @classmethod
    def create(cls, arg : Variation_188_Arg) -> "Variation_188":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_587:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_587:
        return self.rule.content

RuleVariation_181_Arg: TypeAlias = Variation_188_Arg
class RuleVariation_181(RuleVariationContextFree):
    cv_variation = Variation_188

    @classmethod
    def create(cls, arg : RuleVariation_181_Arg) -> "RuleVariation_181":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_188:
        return self.arg # type: ignore

NonSpare_6_Arg: TypeAlias = RuleVariation_181_Arg
class NonSpare_6(NonSpare):
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule = RuleVariation_181

    @classmethod
    def create(cls, arg : NonSpare_6_Arg) -> "NonSpare_6":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_181:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_188:
        return self.rule.variation

class UapItem_6(UapItem):
    cv_non_spare = NonSpare_6

Content_787_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_787(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.40625
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_786_Arg: TypeAlias = Content_787_Arg
class RuleContent_786(RuleContentContextFree):
    cv_content = Content_787

    @property
    def content(self) -> Content_787:
        return self._get_content() # type: ignore

Variation_241_Arg: TypeAlias = RuleContent_786_Arg
class Variation_241(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_786

    @classmethod
    def create(cls, arg : Variation_241_Arg) -> "Variation_241":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_786:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_787:
        return self.rule.content

RuleVariation_234_Arg: TypeAlias = Variation_241_Arg
class RuleVariation_234(RuleVariationContextFree):
    cv_variation = Variation_241

    @classmethod
    def create(cls, arg : RuleVariation_234_Arg) -> "RuleVariation_234":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_241:
        return self.arg # type: ignore

NonSpare_80_Arg: TypeAlias = RuleVariation_234_Arg
class NonSpare_80(NonSpare):
    cv_name = "020"
    cv_title = "Sector Number"
    cv_rule = RuleVariation_234

    @classmethod
    def create(cls, arg : NonSpare_80_Arg) -> "NonSpare_80":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_234:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_241:
        return self.rule.variation

class UapItem_80(UapItem):
    cv_non_spare = NonSpare_80

Variation_368_Arg: TypeAlias = RuleContent_766_Arg
class Variation_368(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_766

    @classmethod
    def create(cls, arg : Variation_368_Arg) -> "Variation_368":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_766:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_767:
        return self.rule.content

RuleVariation_361_Arg: TypeAlias = Variation_368_Arg
class RuleVariation_361(RuleVariationContextFree):
    cv_variation = Variation_368

    @classmethod
    def create(cls, arg : RuleVariation_361_Arg) -> "RuleVariation_361":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_368:
        return self.arg # type: ignore

NonSpare_107_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_107(NonSpare):
    cv_name = "030"
    cv_title = "Time of Day"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_107_Arg) -> "NonSpare_107":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_107(UapItem):
    cv_non_spare = NonSpare_107

NonSpare_150_Arg: TypeAlias = RuleVariation_325_Arg
class NonSpare_150(NonSpare):
    cv_name = "041"
    cv_title = "Antenna Rotation Speed"
    cv_rule = RuleVariation_325

    @classmethod
    def create(cls, arg : NonSpare_150_Arg) -> "NonSpare_150":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_325:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_332:
        return self.rule.variation

class UapItem_150(UapItem):
    cv_non_spare = NonSpare_150

NonSpare_177_Arg: TypeAlias = RuleVariation_1369_Arg
class NonSpare_177(NonSpare):
    cv_name = "050"
    cv_title = "Station Configuration Status"
    cv_rule = RuleVariation_1369

    @classmethod
    def create(cls, arg : NonSpare_177_Arg) -> "NonSpare_177":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1369:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1446:
        return self.rule.variation

class UapItem_177(UapItem):
    cv_non_spare = NonSpare_177

NonSpare_194_Arg: TypeAlias = RuleVariation_1369_Arg
class NonSpare_194(NonSpare):
    cv_name = "060"
    cv_title = "Station Processing Mode"
    cv_rule = RuleVariation_1369

    @classmethod
    def create(cls, arg : NonSpare_194_Arg) -> "NonSpare_194":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1369:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1446:
        return self.rule.variation

class UapItem_194(UapItem):
    cv_non_spare = NonSpare_194

Content_69_Arg: TypeAlias = int
class Content_69(ContentTable):
    cv_values = {0: "Counter for antenna 1", 1: "Counter for antenna 2"}

RuleContent_69_Arg: TypeAlias = Content_69_Arg
class RuleContent_69(RuleContentContextFree):
    cv_content = Content_69

    @property
    def content(self) -> Content_69:
        return self._get_content() # type: ignore

Variation_21_Arg: TypeAlias = RuleContent_69_Arg
class Variation_21(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_69

    @classmethod
    def create(cls, arg : Variation_21_Arg) -> "Variation_21":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_69:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_69:
        return self.rule.content

RuleVariation_21_Arg: TypeAlias = Variation_21_Arg
class RuleVariation_21(RuleVariationContextFree):
    cv_variation = Variation_21

    @classmethod
    def create(cls, arg : RuleVariation_21_Arg) -> "RuleVariation_21":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_21:
        return self.arg # type: ignore

NonSpare_543_Arg: TypeAlias = RuleVariation_21_Arg
class NonSpare_543(NonSpare):
    cv_name = "A"
    cv_title = "Aerial Identification"
    cv_rule = RuleVariation_21

    @classmethod
    def create(cls, arg : NonSpare_543_Arg) -> "NonSpare_543":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_21:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_21:
        return self.rule.variation

Item_33_Arg: TypeAlias = NonSpare_543_Arg
class Item_33(Item):
    cv_non_spare = NonSpare_543

    @classmethod
    def create(cls, arg : Item_33_Arg) -> "Item_33":
        return cls._create(arg) # type: ignore

Content_592_Arg: TypeAlias = int
class Content_592(ContentTable):
    cv_values = {1: "Sole primary plots", 2: "Sole SSR plots", 3: "Combined plots"}

RuleContent_592_Arg: TypeAlias = Content_592_Arg
class RuleContent_592(RuleContentContextFree):
    cv_content = Content_592

    @property
    def content(self) -> Content_592:
        return self._get_content() # type: ignore

Variation_488_Arg: TypeAlias = RuleContent_592_Arg
class Variation_488(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 5
    cv_rule = RuleContent_592

    @classmethod
    def create(cls, arg : Variation_488_Arg) -> "Variation_488":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_592:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_592:
        return self.rule.content

RuleVariation_477_Arg: TypeAlias = Variation_488_Arg
class RuleVariation_477(RuleVariationContextFree):
    cv_variation = Variation_488

    @classmethod
    def create(cls, arg : RuleVariation_477_Arg) -> "RuleVariation_477":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_488:
        return self.arg # type: ignore

NonSpare_1105_Arg: TypeAlias = RuleVariation_477_Arg
class NonSpare_1105(NonSpare):
    cv_name = "IDENT"
    cv_title = ""
    cv_rule = RuleVariation_477

    @classmethod
    def create(cls, arg : NonSpare_1105_Arg) -> "NonSpare_1105":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_477:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_488:
        return self.rule.variation

Item_428_Arg: TypeAlias = NonSpare_1105_Arg
class Item_428(Item):
    cv_non_spare = NonSpare_1105

    @classmethod
    def create(cls, arg : Item_428_Arg) -> "Item_428":
        return cls._create(arg) # type: ignore

Content_610_Arg: TypeAlias = int
class Content_610(ContentInteger):
    cv_signedness = Unsigned

RuleContent_610_Arg: TypeAlias = Content_610_Arg
class RuleContent_610(RuleContentContextFree):
    cv_content = Content_610

    @property
    def content(self) -> Content_610:
        return self._get_content() # type: ignore

Variation_964_Arg: TypeAlias = RuleContent_610_Arg
class Variation_964(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 10
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_964_Arg) -> "Variation_964":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_934_Arg: TypeAlias = Variation_964_Arg
class RuleVariation_934(RuleVariationContextFree):
    cv_variation = Variation_964

    @classmethod
    def create(cls, arg : RuleVariation_934_Arg) -> "RuleVariation_934":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_964:
        return self.arg # type: ignore

NonSpare_794_Arg: TypeAlias = RuleVariation_934_Arg
class NonSpare_794(NonSpare):
    cv_name = "COUNTER"
    cv_title = ""
    cv_rule = RuleVariation_934

    @classmethod
    def create(cls, arg : NonSpare_794_Arg) -> "NonSpare_794":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_934:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_964:
        return self.rule.variation

Item_199_Arg: TypeAlias = NonSpare_794_Arg
class Item_199(Item):
    cv_non_spare = NonSpare_794

    @classmethod
    def create(cls, arg : Item_199_Arg) -> "Item_199":
        return cls._create(arg) # type: ignore

Variation_1041_Arg_Group = Tuple[Union[RuleVariation_21_Arg, Tuple[Literal["A"], RuleVariation_21_Arg]], Union[RuleVariation_477_Arg, Tuple[Literal["IDENT"], RuleVariation_477_Arg]], Union[RuleVariation_934_Arg, Tuple[Literal["COUNTER"], RuleVariation_934_Arg]]]
Variation_1041_Arg: TypeAlias = Union[int, Variation_1041_Arg_Group]
class Variation_1041(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_33, 1), (Item_428, 5), (Item_199, 10)]
    cv_items_dict = {"A": RuleVariation_21, "IDENT": RuleVariation_477, "COUNTER": RuleVariation_934}

    @overload
    @classmethod
    def spec(cls, key : Literal["A"]) -> RuleVariation_21:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IDENT"]) -> RuleVariation_477:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COUNTER"]) -> RuleVariation_934:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["A"], Literal["IDENT"], Literal["COUNTER"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["A"]) -> RuleVariation_21:
        ...
    @overload
    def get_item(self, key : Literal["IDENT"]) -> RuleVariation_477:
        ...
    @overload
    def get_item(self, key : Literal["COUNTER"]) -> RuleVariation_934:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1041_Arg) -> 'Variation_1041':
        return cls._create(arg) # type: ignore

Variation_1401_Arg: TypeAlias = List[Variation_1041_Arg]
class Variation_1401(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1041

    @classmethod
    def create(cls, arg : Variation_1401_Arg) -> 'Variation_1401':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1041]:
        return self._get_list() # type: ignore

RuleVariation_1324_Arg: TypeAlias = Variation_1401_Arg
class RuleVariation_1324(RuleVariationContextFree):
    cv_variation = Variation_1401

    @classmethod
    def create(cls, arg : RuleVariation_1324_Arg) -> "RuleVariation_1324":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1401:
        return self.arg # type: ignore

NonSpare_212_Arg: TypeAlias = RuleVariation_1324_Arg
class NonSpare_212(NonSpare):
    cv_name = "070"
    cv_title = "Plot Count Values"
    cv_rule = RuleVariation_1324

    @classmethod
    def create(cls, arg : NonSpare_212_Arg) -> "NonSpare_212":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1324:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1401:
        return self.rule.variation

class UapItem_212(UapItem):
    cv_non_spare = NonSpare_212

Content_764_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
class Content_764(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 7.8125e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

RuleContent_763_Arg: TypeAlias = Content_764_Arg
class RuleContent_763(RuleContentContextFree):
    cv_content = Content_764

    @property
    def content(self) -> Content_764:
        return self._get_content() # type: ignore

Variation_329_Arg: TypeAlias = RuleContent_763_Arg
class Variation_329(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_763

    @classmethod
    def create(cls, arg : Variation_329_Arg) -> "Variation_329":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_763:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_764:
        return self.rule.content

RuleVariation_322_Arg: TypeAlias = Variation_329_Arg
class RuleVariation_322(RuleVariationContextFree):
    cv_variation = Variation_329

    @classmethod
    def create(cls, arg : RuleVariation_322_Arg) -> "RuleVariation_322":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_329:
        return self.arg # type: ignore

NonSpare_1604_Arg: TypeAlias = RuleVariation_322_Arg
class NonSpare_1604(NonSpare):
    cv_name = "RS"
    cv_title = "Rho Start"
    cv_rule = RuleVariation_322

    @classmethod
    def create(cls, arg : NonSpare_1604_Arg) -> "NonSpare_1604":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_322:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_329:
        return self.rule.variation

Item_828_Arg: TypeAlias = NonSpare_1604_Arg
class Item_828(Item):
    cv_non_spare = NonSpare_1604

    @classmethod
    def create(cls, arg : Item_828_Arg) -> "Item_828":
        return cls._create(arg) # type: ignore

NonSpare_1559_Arg: TypeAlias = RuleVariation_322_Arg
class NonSpare_1559(NonSpare):
    cv_name = "RE"
    cv_title = "Rho End"
    cv_rule = RuleVariation_322

    @classmethod
    def create(cls, arg : NonSpare_1559_Arg) -> "NonSpare_1559":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_322:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_329:
        return self.rule.variation

Item_790_Arg: TypeAlias = NonSpare_1559_Arg
class Item_790(Item):
    cv_non_spare = NonSpare_1559

    @classmethod
    def create(cls, arg : Item_790_Arg) -> "Item_790":
        return cls._create(arg) # type: ignore

NonSpare_1917_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_1917(NonSpare):
    cv_name = "TS"
    cv_title = "Theta Start"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_1917_Arg) -> "NonSpare_1917":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Item_1040_Arg: TypeAlias = NonSpare_1917_Arg
class Item_1040(Item):
    cv_non_spare = NonSpare_1917

    @classmethod
    def create(cls, arg : Item_1040_Arg) -> "Item_1040":
        return cls._create(arg) # type: ignore

NonSpare_1844_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_1844(NonSpare):
    cv_name = "TE"
    cv_title = "Theta End"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_1844_Arg) -> "NonSpare_1844":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Item_989_Arg: TypeAlias = NonSpare_1844_Arg
class Item_989(Item):
    cv_non_spare = NonSpare_1844

    @classmethod
    def create(cls, arg : Item_989_Arg) -> "Item_989":
        return cls._create(arg) # type: ignore

Variation_1179_Arg_Group = Tuple[Union[RuleVariation_322_Arg, Tuple[Literal["RS"], RuleVariation_322_Arg]], Union[RuleVariation_322_Arg, Tuple[Literal["RE"], RuleVariation_322_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["TS"], RuleVariation_334_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["TE"], RuleVariation_334_Arg]]]
Variation_1179_Arg: TypeAlias = Union[int, Variation_1179_Arg_Group]
class Variation_1179(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_828, 16), (Item_790, 16), (Item_1040, 16), (Item_989, 16)]
    cv_items_dict = {"RS": RuleVariation_322, "RE": RuleVariation_322, "TS": RuleVariation_334, "TE": RuleVariation_334}

    @overload
    @classmethod
    def spec(cls, key : Literal["RS"]) -> RuleVariation_322:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> RuleVariation_322:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TS"]) -> RuleVariation_334:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TE"]) -> RuleVariation_334:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RS"], Literal["RE"], Literal["TS"], Literal["TE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RS"]) -> RuleVariation_322:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> RuleVariation_322:
        ...
    @overload
    def get_item(self, key : Literal["TS"]) -> RuleVariation_334:
        ...
    @overload
    def get_item(self, key : Literal["TE"]) -> RuleVariation_334:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1179_Arg) -> 'Variation_1179':
        return cls._create(arg) # type: ignore

RuleVariation_1130_Arg: TypeAlias = Variation_1179_Arg
class RuleVariation_1130(RuleVariationContextFree):
    cv_variation = Variation_1179

    @classmethod
    def create(cls, arg : RuleVariation_1130_Arg) -> "RuleVariation_1130":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1179:
        return self.arg # type: ignore

NonSpare_265_Arg: TypeAlias = RuleVariation_1130_Arg
class NonSpare_265(NonSpare):
    cv_name = "100"
    cv_title = "Dynamic Window Type 1"
    cv_rule = RuleVariation_1130

    @classmethod
    def create(cls, arg : NonSpare_265_Arg) -> "NonSpare_265":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1130:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1179:
        return self.rule.variation

class UapItem_265(UapItem):
    cv_non_spare = NonSpare_265

Content_674_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
class Content_674(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 7.8125e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

RuleContent_674_Arg: TypeAlias = Content_674_Arg
class RuleContent_674(RuleContentContextFree):
    cv_content = Content_674

    @property
    def content(self) -> Content_674:
        return self._get_content() # type: ignore

Variation_213_Arg: TypeAlias = RuleContent_674_Arg
class Variation_213(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_674

    @classmethod
    def create(cls, arg : Variation_213_Arg) -> "Variation_213":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_674:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_674:
        return self.rule.content

RuleVariation_206_Arg: TypeAlias = Variation_213_Arg
class RuleVariation_206(RuleVariationContextFree):
    cv_variation = Variation_213

    @classmethod
    def create(cls, arg : RuleVariation_206_Arg) -> "RuleVariation_206":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_213:
        return self.arg # type: ignore

NonSpare_1555_Arg: TypeAlias = RuleVariation_206_Arg
class NonSpare_1555(NonSpare):
    cv_name = "RE"
    cv_title = "Range Error"
    cv_rule = RuleVariation_206

    @classmethod
    def create(cls, arg : NonSpare_1555_Arg) -> "NonSpare_1555":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_206:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_213:
        return self.rule.variation

Item_787_Arg: TypeAlias = NonSpare_1555_Arg
class Item_787(Item):
    cv_non_spare = NonSpare_1555

    @classmethod
    def create(cls, arg : Item_787_Arg) -> "Item_787":
        return cls._create(arg) # type: ignore

Content_705_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_705(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 2.197265625e-2
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_705_Arg: TypeAlias = Content_705_Arg
class RuleContent_705(RuleContentContextFree):
    cv_content = Content_705

    @property
    def content(self) -> Content_705:
        return self._get_content() # type: ignore

Variation_218_Arg: TypeAlias = RuleContent_705_Arg
class Variation_218(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_705

    @classmethod
    def create(cls, arg : Variation_218_Arg) -> "Variation_218":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_705:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_705:
        return self.rule.content

RuleVariation_211_Arg: TypeAlias = Variation_218_Arg
class RuleVariation_211(RuleVariationContextFree):
    cv_variation = Variation_218

    @classmethod
    def create(cls, arg : RuleVariation_211_Arg) -> "RuleVariation_211":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_218:
        return self.arg # type: ignore

NonSpare_574_Arg: TypeAlias = RuleVariation_211_Arg
class NonSpare_574(NonSpare):
    cv_name = "AE"
    cv_title = "Azimuth Error"
    cv_rule = RuleVariation_211

    @classmethod
    def create(cls, arg : NonSpare_574_Arg) -> "NonSpare_574":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_211:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_218:
        return self.rule.variation

Item_49_Arg: TypeAlias = NonSpare_574_Arg
class Item_49(Item):
    cv_non_spare = NonSpare_574

    @classmethod
    def create(cls, arg : Item_49_Arg) -> "Item_49":
        return cls._create(arg) # type: ignore

Variation_1165_Arg_Group = Tuple[Union[RuleVariation_206_Arg, Tuple[Literal["RE"], RuleVariation_206_Arg]], Union[RuleVariation_211_Arg, Tuple[Literal["AE"], RuleVariation_211_Arg]]]
Variation_1165_Arg: TypeAlias = Union[int, Variation_1165_Arg_Group]
class Variation_1165(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_787, 8), (Item_49, 8)]
    cv_items_dict = {"RE": RuleVariation_206, "AE": RuleVariation_211}

    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> RuleVariation_206:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AE"]) -> RuleVariation_211:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RE"], Literal["AE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RE"]) -> RuleVariation_206:
        ...
    @overload
    def get_item(self, key : Literal["AE"]) -> RuleVariation_211:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1165_Arg) -> 'Variation_1165':
        return cls._create(arg) # type: ignore

RuleVariation_1117_Arg: TypeAlias = Variation_1165_Arg
class RuleVariation_1117(RuleVariationContextFree):
    cv_variation = Variation_1165

    @classmethod
    def create(cls, arg : RuleVariation_1117_Arg) -> "RuleVariation_1117":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1165:
        return self.arg # type: ignore

NonSpare_240_Arg: TypeAlias = RuleVariation_1117_Arg
class NonSpare_240(NonSpare):
    cv_name = "090"
    cv_title = "Collimation Error"
    cv_rule = RuleVariation_1117

    @classmethod
    def create(cls, arg : NonSpare_240_Arg) -> "NonSpare_240":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1117:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1165:
        return self.rule.variation

class UapItem_240(UapItem):
    cv_non_spare = NonSpare_240

NonSpare_238_Arg: TypeAlias = RuleVariation_1369_Arg
class NonSpare_238(NonSpare):
    cv_name = "080"
    cv_title = "Warning/Error Conditions"
    cv_rule = RuleVariation_1369

    @classmethod
    def create(cls, arg : NonSpare_238_Arg) -> "NonSpare_238":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1369:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1446:
        return self.rule.variation

class UapItem_238(UapItem):
    cv_non_spare = NonSpare_238

Record_45_Arg = TypedDict('Record_45_Arg', {
    "010": NonSpare_46_Arg,
    "000": NonSpare_6_Arg,
    "020": NonSpare_80_Arg,
    "030": NonSpare_107_Arg,
    "041": NonSpare_150_Arg,
    "050": NonSpare_177_Arg,
    "060": NonSpare_194_Arg,
    "070": NonSpare_212_Arg,
    "100": NonSpare_265_Arg,
    "090": NonSpare_240_Arg,
    "080": NonSpare_238_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
Record_45_Union = Union[
    Tuple[Literal["010"], NonSpare_46_Arg],
    Tuple[Literal["000"], NonSpare_6_Arg],
    Tuple[Literal["020"], NonSpare_80_Arg],
    Tuple[Literal["030"], NonSpare_107_Arg],
    Tuple[Literal["041"], NonSpare_150_Arg],
    Tuple[Literal["050"], NonSpare_177_Arg],
    Tuple[Literal["060"], NonSpare_194_Arg],
    Tuple[Literal["070"], NonSpare_212_Arg],
    Tuple[Literal["100"], NonSpare_265_Arg],
    Tuple[Literal["090"], NonSpare_240_Arg],
    Tuple[Literal["080"], NonSpare_238_Arg],
    Tuple[Literal["SP"], NonSpare_1723_Arg],
]
class Record_45(Record):
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_46, UapItem_6, UapItem_80, UapItem_107, UapItem_150, UapItem_177, UapItem_194, UapItem_212, UapItem_265, UapItem_240, UapItem_238, UapItem_544, UapItem_543, UapItem_545]
    cv_items_dict = {"010": NonSpare_46, "000": NonSpare_6, "020": NonSpare_80, "030": NonSpare_107, "041": NonSpare_150, "050": NonSpare_177, "060": NonSpare_194, "070": NonSpare_212, "100": NonSpare_265, "090": NonSpare_240, "080": NonSpare_238, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_46:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_6:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_80:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_107:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_150:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_177:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_194:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_212:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_265:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_240:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_238:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["020"], Literal["030"], Literal["041"], Literal["050"], Literal["060"], Literal["070"], Literal["100"], Literal["090"], Literal["080"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_46]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_6]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_80]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_107]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_150]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_177]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_194]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_212]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_265]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_240]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_238]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_46_Arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_6_Arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_80_Arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_107_Arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_150_Arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_177_Arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_194_Arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_212_Arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_265_Arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_240_Arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_238_Arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_45':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_45':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @overload
    def get_rfs_item(self, arg : Literal["010"]) -> List[NonSpare_46]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["000"]) -> List[NonSpare_6]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["020"]) -> List[NonSpare_80]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["030"]) -> List[NonSpare_107]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["041"]) -> List[NonSpare_150]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["050"]) -> List[NonSpare_177]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["060"]) -> List[NonSpare_194]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["070"]) -> List[NonSpare_212]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["100"]) -> List[NonSpare_265]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["090"]) -> List[NonSpare_240]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["080"]) -> List[NonSpare_238]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["SP"]) -> List[NonSpare_1723]:
        ...
    def get_rfs_item(self, arg : Any) -> Any:
        return self._get_rfs_item(arg)

    @classmethod
    def create(cls, arg : Record_45_Arg, rfs : Optional[List[Record_45_Union]] = None) -> 'Record_45':
        return cls._create(arg, rfs) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_45", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_41_Arg: TypeAlias = Record_45
class Uap_41(UapSingle):
    cv_record = Record_45

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_45]]:
        return cls._parse(bs)

class Asterix_3(AstCat):
    cv_category = 2
    cv_edition = (1, 0)
    cv_uap = Uap_41

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_41_Arg]) -> "Asterix_3":
        return cls._create(records) # type: ignore

NonSpare_37_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_37(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_37_Arg) -> "NonSpare_37":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_37(UapItem):
    cv_non_spare = NonSpare_37

Record_26_Arg = TypedDict('Record_26_Arg', {
    "010": NonSpare_37_Arg,
    "000": NonSpare_6_Arg,
    "020": NonSpare_80_Arg,
    "030": NonSpare_107_Arg,
    "041": NonSpare_150_Arg,
    "050": NonSpare_177_Arg,
    "060": NonSpare_194_Arg,
    "070": NonSpare_212_Arg,
    "100": NonSpare_265_Arg,
    "090": NonSpare_240_Arg,
    "080": NonSpare_238_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
Record_26_Union = Union[
    Tuple[Literal["010"], NonSpare_37_Arg],
    Tuple[Literal["000"], NonSpare_6_Arg],
    Tuple[Literal["020"], NonSpare_80_Arg],
    Tuple[Literal["030"], NonSpare_107_Arg],
    Tuple[Literal["041"], NonSpare_150_Arg],
    Tuple[Literal["050"], NonSpare_177_Arg],
    Tuple[Literal["060"], NonSpare_194_Arg],
    Tuple[Literal["070"], NonSpare_212_Arg],
    Tuple[Literal["100"], NonSpare_265_Arg],
    Tuple[Literal["090"], NonSpare_240_Arg],
    Tuple[Literal["080"], NonSpare_238_Arg],
    Tuple[Literal["SP"], NonSpare_1723_Arg],
]
class Record_26(Record):
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_37, UapItem_6, UapItem_80, UapItem_107, UapItem_150, UapItem_177, UapItem_194, UapItem_212, UapItem_265, UapItem_240, UapItem_238, UapItem_544, UapItem_543, UapItem_545]
    cv_items_dict = {"010": NonSpare_37, "000": NonSpare_6, "020": NonSpare_80, "030": NonSpare_107, "041": NonSpare_150, "050": NonSpare_177, "060": NonSpare_194, "070": NonSpare_212, "100": NonSpare_265, "090": NonSpare_240, "080": NonSpare_238, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_37:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_6:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_80:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_107:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_150:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_177:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_194:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_212:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_265:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_240:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_238:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["020"], Literal["030"], Literal["041"], Literal["050"], Literal["060"], Literal["070"], Literal["100"], Literal["090"], Literal["080"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_37]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_6]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_80]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_107]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_150]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_177]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_194]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_212]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_265]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_240]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_238]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_37_Arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_6_Arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_80_Arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_107_Arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_150_Arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_177_Arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_194_Arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_212_Arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_265_Arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_240_Arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_238_Arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_26':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_26':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @overload
    def get_rfs_item(self, arg : Literal["010"]) -> List[NonSpare_37]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["000"]) -> List[NonSpare_6]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["020"]) -> List[NonSpare_80]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["030"]) -> List[NonSpare_107]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["041"]) -> List[NonSpare_150]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["050"]) -> List[NonSpare_177]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["060"]) -> List[NonSpare_194]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["070"]) -> List[NonSpare_212]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["100"]) -> List[NonSpare_265]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["090"]) -> List[NonSpare_240]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["080"]) -> List[NonSpare_238]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["SP"]) -> List[NonSpare_1723]:
        ...
    def get_rfs_item(self, arg : Any) -> Any:
        return self._get_rfs_item(arg)

    @classmethod
    def create(cls, arg : Record_26_Arg, rfs : Optional[List[Record_26_Union]] = None) -> 'Record_26':
        return cls._create(arg, rfs) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_26", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_22_Arg: TypeAlias = Record_26
class Uap_22(UapSingle):
    cv_record = Record_26

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_26]]:
        return cls._parse(bs)

class Asterix_4(AstCat):
    cv_category = 2
    cv_edition = (1, 1)
    cv_uap = Uap_22

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_22_Arg]) -> "Asterix_4":
        return cls._create(records) # type: ignore

NonSpare_33_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_33(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_33_Arg) -> "NonSpare_33":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_33(UapItem):
    cv_non_spare = NonSpare_33

Content_573_Arg: TypeAlias = int
class Content_573(ContentTable):
    cv_values = {1: "Alive Message (AM)", 2: "Route Adherence Monitor Longitudinal Deviation (RAMLD)", 3: "Route Adherence Monitor Heading Deviation (RAMHD)", 4: "Minimum Safe Altitude Warning (MSAW)", 5: "Area Proximity Warning (APW)", 6: "Clearance Level Adherence Monitor (CLAM)", 7: "Short Term Conflict Alert (STCA)", 8: "Approach Path Monitor (APM)", 9: "RIMCAS Arrival / Landing Monitor (ALM)", 10: "RIMCAS Arrival / Departure Wrong Runway Alert (WRA)", 11: "RIMCAS Arrival / Departure Opposite Traffic Alert (OTA)", 12: "RIMCAS Departure Monitor (RDM)", 13: "RIMCAS Runway / Taxiway Crossing Monitor (RCM)", 14: "RIMCAS Taxiway Separation Monitor (TSM)", 15: "RIMCAS Unauthorized Taxiway Movement Monitor(UTMM)", 16: "RIMCAS Stop Bar Overrun Alert (SBOA)", 17: "End Of Conflict (EOC)", 18: "ACAS Resolution Advisory (ACASRA)", 19: "Near Term Conflict Alert (NTCA)", 20: "Downlinked Barometric Pressure Setting Monitor (DBPSM)", 21: "Speed Adherence Monitor (SAM)", 22: "Outside Controlled Airspace Tool (OCAT)", 23: "Vertical Conflict Detection (VCD)", 24: "Vertical Rate Adherence Monitor (VRAM)", 25: "Cleared Heading Adherence Monitor (CHAM)", 26: "Downlinked Selected Altitude Monitor (DSAM)", 27: "Holding Adherence Monitor (HAM)", 28: "Vertical Path Monitor (VPM)", 29: "RIMCAS Taxiway Traffic Alert (TTA)", 30: "RIMCAS Arrival/Departure Close Runway Alert (CRA)", 31: "RIMCAS Arrival/Departure Aircraft Separation Monitor (ASM)", 32: "RIMCAS ILS Area Violation Monitor (IAVM)", 33: "Final Target Distance Indicator (FTD)", 34: "Initial Target Distance Indicator (ITD)", 35: "Wake Vortex Indicator Infringement Alert (IIA)", 36: "Sequence Warning (SQW)", 37: "Catch Up Warning (CUW)", 38: "Conflicting ATC Clearances (CATC)", 39: "No ATC Clearance (NOCLR)", 40: "Aircraft Not Moving despite ATC Clearance (NOMOV)", 41: "Aircraft leaving/entering the aerodrome area without proper handover (NOH)", 42: "Wrong Runway or Taxiway Type (WRTY)", 43: "Stand Occupied (STOCC)", 44: "Ongoing Alert (ONGOING)", 97: "Lost Track Warning (LTW)", 98: "Holding Volume Infringement (HVI)", 99: "Airspace Infringement Warning (AIW)"}

RuleContent_573_Arg: TypeAlias = Content_573_Arg
class RuleContent_573(RuleContentContextFree):
    cv_content = Content_573

    @property
    def content(self) -> Content_573:
        return self._get_content() # type: ignore

Variation_178_Arg: TypeAlias = RuleContent_573_Arg
class Variation_178(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_573

    @classmethod
    def create(cls, arg : Variation_178_Arg) -> "Variation_178":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_573:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_573:
        return self.rule.content

RuleVariation_171_Arg: TypeAlias = Variation_178_Arg
class RuleVariation_171(RuleVariationContextFree):
    cv_variation = Variation_178

    @classmethod
    def create(cls, arg : RuleVariation_171_Arg) -> "RuleVariation_171":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_178:
        return self.arg # type: ignore

NonSpare_2_Arg: TypeAlias = RuleVariation_171_Arg
class NonSpare_2(NonSpare):
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule = RuleVariation_171

    @classmethod
    def create(cls, arg : NonSpare_2_Arg) -> "NonSpare_2":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_171:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_178:
        return self.rule.variation

class UapItem_2(UapItem):
    cv_non_spare = NonSpare_2

Variation_1421_Arg: TypeAlias = List[Variation_1186_Arg]
class Variation_1421(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1186

    @classmethod
    def create(cls, arg : Variation_1421_Arg) -> 'Variation_1421':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1186]:
        return self._get_list() # type: ignore

RuleVariation_1344_Arg: TypeAlias = Variation_1421_Arg
class RuleVariation_1344(RuleVariationContextFree):
    cv_variation = Variation_1421

    @classmethod
    def create(cls, arg : RuleVariation_1344_Arg) -> "RuleVariation_1344":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1421:
        return self.arg # type: ignore

NonSpare_57_Arg: TypeAlias = RuleVariation_1344_Arg
class NonSpare_57(NonSpare):
    cv_name = "015"
    cv_title = "SDPS Identifier"
    cv_rule = RuleVariation_1344

    @classmethod
    def create(cls, arg : NonSpare_57_Arg) -> "NonSpare_57":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1344:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1421:
        return self.rule.variation

class UapItem_57(UapItem):
    cv_non_spare = NonSpare_57

NonSpare_92_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_92(NonSpare):
    cv_name = "020"
    cv_title = "Time of Message"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_92_Arg) -> "NonSpare_92":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_92(UapItem):
    cv_non_spare = NonSpare_92

NonSpare_134_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_134(NonSpare):
    cv_name = "040"
    cv_title = "Alert Identifier"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_134_Arg) -> "NonSpare_134":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

class UapItem_134(UapItem):
    cv_non_spare = NonSpare_134

Variation_771_Arg: TypeAlias = RuleContent_0_Arg
class Variation_771(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_771_Arg) -> "Variation_771":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_760_Arg: TypeAlias = Variation_771_Arg
class RuleVariation_760(RuleVariationContextFree):
    cv_variation = Variation_771

    @classmethod
    def create(cls, arg : RuleVariation_760_Arg) -> "RuleVariation_760":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_771:
        return self.arg # type: ignore

NonSpare_1774_Arg: TypeAlias = RuleVariation_760_Arg
class NonSpare_1774(NonSpare):
    cv_name = "STAT"
    cv_title = "Status of the Alert"
    cv_rule = RuleVariation_760

    @classmethod
    def create(cls, arg : NonSpare_1774_Arg) -> "NonSpare_1774":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_760:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_771:
        return self.rule.variation

Item_941_Arg: TypeAlias = NonSpare_1774_Arg
class Item_941(Item):
    cv_non_spare = NonSpare_1774

    @classmethod
    def create(cls, arg : Item_941_Arg) -> "Item_941":
        return cls._create(arg) # type: ignore

Item_29_Arg: TypeAlias = int
class Item_29(Spare):
    cv_bit_offset8 = 7
    cv_bit_size = 1

Variation_1030_Arg_Group = Tuple[int, Union[RuleVariation_760_Arg, Tuple[Literal["STAT"], RuleVariation_760_Arg]], int]
Variation_1030_Arg: TypeAlias = Union[int, Variation_1030_Arg_Group]
class Variation_1030(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_3, 4), (Item_941, 3), (Item_29, 1)]
    cv_items_dict = {"STAT": RuleVariation_760}

    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_760:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["STAT"]) -> RuleVariation_760:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1030_Arg) -> 'Variation_1030':
        return cls._create(arg) # type: ignore

RuleVariation_998_Arg: TypeAlias = Variation_1030_Arg
class RuleVariation_998(RuleVariationContextFree):
    cv_variation = Variation_1030

    @classmethod
    def create(cls, arg : RuleVariation_998_Arg) -> "RuleVariation_998":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1030:
        return self.arg # type: ignore

NonSpare_161_Arg: TypeAlias = RuleVariation_998_Arg
class NonSpare_161(NonSpare):
    cv_name = "045"
    cv_title = "Alert Status"
    cv_rule = RuleVariation_998

    @classmethod
    def create(cls, arg : NonSpare_161_Arg) -> "NonSpare_161":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_998:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1030:
        return self.rule.variation

class UapItem_161(UapItem):
    cv_non_spare = NonSpare_161

Content_114_Arg: TypeAlias = int
class Content_114(ContentTable):
    cv_values = {0: "Default", 1: "MRVA function"}

RuleContent_114_Arg: TypeAlias = Content_114_Arg
class RuleContent_114(RuleContentContextFree):
    cv_content = Content_114

    @property
    def content(self) -> Content_114:
        return self._get_content() # type: ignore

Variation_32_Arg: TypeAlias = RuleContent_114_Arg
class Variation_32(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_114

    @classmethod
    def create(cls, arg : Variation_32_Arg) -> "Variation_32":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_114:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_114:
        return self.rule.content

RuleVariation_32_Arg: TypeAlias = Variation_32_Arg
class RuleVariation_32(RuleVariationContextFree):
    cv_variation = Variation_32

    @classmethod
    def create(cls, arg : RuleVariation_32_Arg) -> "RuleVariation_32":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_32:
        return self.arg # type: ignore

Content_141_Arg: TypeAlias = int
class Content_141(ContentTable):
    cv_values = {0: "Default", 1: "RAMLD function"}

RuleContent_141_Arg: TypeAlias = Content_141_Arg
class RuleContent_141(RuleContentContextFree):
    cv_content = Content_141

    @property
    def content(self) -> Content_141:
        return self._get_content() # type: ignore

Variation_414_Arg: TypeAlias = RuleContent_141_Arg
class Variation_414(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_141

    @classmethod
    def create(cls, arg : Variation_414_Arg) -> "Variation_414":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_141:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_141:
        return self.rule.content

RuleVariation_403_Arg: TypeAlias = Variation_414_Arg
class RuleVariation_403(RuleVariationContextFree):
    cv_variation = Variation_414

    @classmethod
    def create(cls, arg : RuleVariation_403_Arg) -> "RuleVariation_403":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_414:
        return self.arg # type: ignore

Content_140_Arg: TypeAlias = int
class Content_140(ContentTable):
    cv_values = {0: "Default", 1: "RAMHD function"}

RuleContent_140_Arg: TypeAlias = Content_140_Arg
class RuleContent_140(RuleContentContextFree):
    cv_content = Content_140

    @property
    def content(self) -> Content_140:
        return self._get_content() # type: ignore

Variation_521_Arg: TypeAlias = RuleContent_140_Arg
class Variation_521(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_140

    @classmethod
    def create(cls, arg : Variation_521_Arg) -> "Variation_521":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_140:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_140:
        return self.rule.content

RuleVariation_510_Arg: TypeAlias = Variation_521_Arg
class RuleVariation_510(RuleVariationContextFree):
    cv_variation = Variation_521

    @classmethod
    def create(cls, arg : RuleVariation_510_Arg) -> "RuleVariation_510":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_521:
        return self.arg # type: ignore

Content_115_Arg: TypeAlias = int
class Content_115(ContentTable):
    cv_values = {0: "Default", 1: "MSAW function"}

RuleContent_115_Arg: TypeAlias = Content_115_Arg
class RuleContent_115(RuleContentContextFree):
    cv_content = Content_115

    @property
    def content(self) -> Content_115:
        return self._get_content() # type: ignore

Variation_623_Arg: TypeAlias = RuleContent_115_Arg
class Variation_623(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_115

    @classmethod
    def create(cls, arg : Variation_623_Arg) -> "Variation_623":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_115:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_115:
        return self.rule.content

RuleVariation_612_Arg: TypeAlias = Variation_623_Arg
class RuleVariation_612(RuleVariationContextFree):
    cv_variation = Variation_623

    @classmethod
    def create(cls, arg : RuleVariation_612_Arg) -> "RuleVariation_612":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_623:
        return self.arg # type: ignore

Content_82_Arg: TypeAlias = int
class Content_82(ContentTable):
    cv_values = {0: "Default", 1: "APW function"}

RuleContent_82_Arg: TypeAlias = Content_82_Arg
class RuleContent_82(RuleContentContextFree):
    cv_content = Content_82

    @property
    def content(self) -> Content_82:
        return self._get_content() # type: ignore

Variation_702_Arg: TypeAlias = RuleContent_82_Arg
class Variation_702(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_82

    @classmethod
    def create(cls, arg : Variation_702_Arg) -> "Variation_702":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_82:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_82:
        return self.rule.content

RuleVariation_691_Arg: TypeAlias = Variation_702_Arg
class RuleVariation_691(RuleVariationContextFree):
    cv_variation = Variation_702

    @classmethod
    def create(cls, arg : RuleVariation_691_Arg) -> "RuleVariation_691":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_702:
        return self.arg # type: ignore

Content_87_Arg: TypeAlias = int
class Content_87(ContentTable):
    cv_values = {0: "Default", 1: "CLAM function"}

RuleContent_87_Arg: TypeAlias = Content_87_Arg
class RuleContent_87(RuleContentContextFree):
    cv_content = Content_87

    @property
    def content(self) -> Content_87:
        return self._get_content() # type: ignore

Variation_827_Arg: TypeAlias = RuleContent_87_Arg
class Variation_827(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_87

    @classmethod
    def create(cls, arg : Variation_827_Arg) -> "Variation_827":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_87:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_87:
        return self.rule.content

RuleVariation_797_Arg: TypeAlias = Variation_827_Arg
class RuleVariation_797(RuleVariationContextFree):
    cv_variation = Variation_827

    @classmethod
    def create(cls, arg : RuleVariation_797_Arg) -> "RuleVariation_797":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_827:
        return self.arg # type: ignore

Content_149_Arg: TypeAlias = int
class Content_149(ContentTable):
    cv_values = {0: "Default", 1: "STCA function"}

RuleContent_149_Arg: TypeAlias = Content_149_Arg
class RuleContent_149(RuleContentContextFree):
    cv_content = Content_149

    @property
    def content(self) -> Content_149:
        return self._get_content() # type: ignore

Variation_916_Arg: TypeAlias = RuleContent_149_Arg
class Variation_916(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_149

    @classmethod
    def create(cls, arg : Variation_916_Arg) -> "Variation_916":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_149:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_149:
        return self.rule.content

RuleVariation_886_Arg: TypeAlias = Variation_916_Arg
class RuleVariation_886(RuleVariationContextFree):
    cv_variation = Variation_916

    @classmethod
    def create(cls, arg : RuleVariation_886_Arg) -> "RuleVariation_886":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_916:
        return self.arg # type: ignore

Content_81_Arg: TypeAlias = int
class Content_81(ContentTable):
    cv_values = {0: "Default", 1: "APM function"}

RuleContent_81_Arg: TypeAlias = Content_81_Arg
class RuleContent_81(RuleContentContextFree):
    cv_content = Content_81

    @property
    def content(self) -> Content_81:
        return self._get_content() # type: ignore

Variation_24_Arg: TypeAlias = RuleContent_81_Arg
class Variation_24(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_81

    @classmethod
    def create(cls, arg : Variation_24_Arg) -> "Variation_24":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_81:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_81:
        return self.rule.content

RuleVariation_24_Arg: TypeAlias = Variation_24_Arg
class RuleVariation_24(RuleVariationContextFree):
    cv_variation = Variation_24

    @classmethod
    def create(cls, arg : RuleVariation_24_Arg) -> "RuleVariation_24":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_24:
        return self.arg # type: ignore

Content_142_Arg: TypeAlias = int
class Content_142(ContentTable):
    cv_values = {0: "Default", 1: "RIMCA function"}

RuleContent_142_Arg: TypeAlias = Content_142_Arg
class RuleContent_142(RuleContentContextFree):
    cv_content = Content_142

    @property
    def content(self) -> Content_142:
        return self._get_content() # type: ignore

Variation_415_Arg: TypeAlias = RuleContent_142_Arg
class Variation_415(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_142

    @classmethod
    def create(cls, arg : Variation_415_Arg) -> "Variation_415":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_142:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_142:
        return self.rule.content

RuleVariation_404_Arg: TypeAlias = Variation_415_Arg
class RuleVariation_404(RuleVariationContextFree):
    cv_variation = Variation_415

    @classmethod
    def create(cls, arg : RuleVariation_404_Arg) -> "RuleVariation_404":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_415:
        return self.arg # type: ignore

Content_79_Arg: TypeAlias = int
class Content_79(ContentTable):
    cv_values = {0: "Default", 1: "ACAS RA function"}

RuleContent_79_Arg: TypeAlias = Content_79_Arg
class RuleContent_79(RuleContentContextFree):
    cv_content = Content_79

    @property
    def content(self) -> Content_79:
        return self._get_content() # type: ignore

Variation_511_Arg: TypeAlias = RuleContent_79_Arg
class Variation_511(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_79

    @classmethod
    def create(cls, arg : Variation_511_Arg) -> "Variation_511":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_79:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_79:
        return self.rule.content

RuleVariation_500_Arg: TypeAlias = Variation_511_Arg
class RuleVariation_500(RuleVariationContextFree):
    cv_variation = Variation_511

    @classmethod
    def create(cls, arg : RuleVariation_500_Arg) -> "RuleVariation_500":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_511:
        return self.arg # type: ignore

Content_132_Arg: TypeAlias = int
class Content_132(ContentTable):
    cv_values = {0: "Default", 1: "NTCA function"}

RuleContent_132_Arg: TypeAlias = Content_132_Arg
class RuleContent_132(RuleContentContextFree):
    cv_content = Content_132

    @property
    def content(self) -> Content_132:
        return self._get_content() # type: ignore

Variation_628_Arg: TypeAlias = RuleContent_132_Arg
class Variation_628(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_132

    @classmethod
    def create(cls, arg : Variation_628_Arg) -> "Variation_628":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_132:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_132:
        return self.rule.content

RuleVariation_617_Arg: TypeAlias = Variation_628_Arg
class RuleVariation_617(RuleVariationContextFree):
    cv_variation = Variation_628

    @classmethod
    def create(cls, arg : RuleVariation_617_Arg) -> "RuleVariation_617":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_628:
        return self.arg # type: ignore

Content_152_Arg: TypeAlias = int
class Content_152(ContentTable):
    cv_values = {0: "Default", 1: "System degraded"}

RuleContent_152_Arg: TypeAlias = Content_152_Arg
class RuleContent_152(RuleContentContextFree):
    cv_content = Content_152

    @property
    def content(self) -> Content_152:
        return self._get_content() # type: ignore

Variation_708_Arg: TypeAlias = RuleContent_152_Arg
class Variation_708(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_152

    @classmethod
    def create(cls, arg : Variation_708_Arg) -> "Variation_708":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_152:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_152:
        return self.rule.content

RuleVariation_697_Arg: TypeAlias = Variation_708_Arg
class RuleVariation_697(RuleVariationContextFree):
    cv_variation = Variation_708

    @classmethod
    def create(cls, arg : RuleVariation_697_Arg) -> "RuleVariation_697":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_708:
        return self.arg # type: ignore

Content_135_Arg: TypeAlias = int
class Content_135(ContentTable):
    cv_values = {0: "Default", 1: "Overflow error"}

RuleContent_135_Arg: TypeAlias = Content_135_Arg
class RuleContent_135(RuleContentContextFree):
    cv_content = Content_135

    @property
    def content(self) -> Content_135:
        return self._get_content() # type: ignore

Variation_831_Arg: TypeAlias = RuleContent_135_Arg
class Variation_831(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_135

    @classmethod
    def create(cls, arg : Variation_831_Arg) -> "Variation_831":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_135:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_135:
        return self.rule.content

RuleVariation_801_Arg: TypeAlias = Variation_831_Arg
class RuleVariation_801(RuleVariationContextFree):
    cv_variation = Variation_831

    @classmethod
    def create(cls, arg : RuleVariation_801_Arg) -> "RuleVariation_801":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_831:
        return self.arg # type: ignore

Content_137_Arg: TypeAlias = int
class Content_137(ContentTable):
    cv_values = {0: "Default", 1: "Overload error"}

RuleContent_137_Arg: TypeAlias = Content_137_Arg
class RuleContent_137(RuleContentContextFree):
    cv_content = Content_137

    @property
    def content(self) -> Content_137:
        return self._get_content() # type: ignore

Variation_913_Arg: TypeAlias = RuleContent_137_Arg
class Variation_913(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_137

    @classmethod
    def create(cls, arg : Variation_913_Arg) -> "Variation_913":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_137:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_137:
        return self.rule.content

RuleVariation_883_Arg: TypeAlias = Variation_913_Arg
class RuleVariation_883(RuleVariationContextFree):
    cv_variation = Variation_913

    @classmethod
    def create(cls, arg : RuleVariation_883_Arg) -> "RuleVariation_883":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_913:
        return self.arg # type: ignore

Content_80_Arg: TypeAlias = int
class Content_80(ContentTable):
    cv_values = {0: "Default", 1: "AIW function"}

RuleContent_80_Arg: TypeAlias = Content_80_Arg
class RuleContent_80(RuleContentContextFree):
    cv_content = Content_80

    @property
    def content(self) -> Content_80:
        return self._get_content() # type: ignore

Variation_23_Arg: TypeAlias = RuleContent_80_Arg
class Variation_23(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_80

    @classmethod
    def create(cls, arg : Variation_23_Arg) -> "Variation_23":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_80:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_80:
        return self.rule.content

RuleVariation_23_Arg: TypeAlias = Variation_23_Arg
class RuleVariation_23(RuleVariationContextFree):
    cv_variation = Variation_23

    @classmethod
    def create(cls, arg : RuleVariation_23_Arg) -> "RuleVariation_23":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_23:
        return self.arg # type: ignore

Content_138_Arg: TypeAlias = int
class Content_138(ContentTable):
    cv_values = {0: "Default", 1: "PAIW function"}

RuleContent_138_Arg: TypeAlias = Content_138_Arg
class RuleContent_138(RuleContentContextFree):
    cv_content = Content_138

    @property
    def content(self) -> Content_138:
        return self._get_content() # type: ignore

Variation_413_Arg: TypeAlias = RuleContent_138_Arg
class Variation_413(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_138

    @classmethod
    def create(cls, arg : Variation_413_Arg) -> "Variation_413":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_138:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_138:
        return self.rule.content

RuleVariation_402_Arg: TypeAlias = Variation_413_Arg
class RuleVariation_402(RuleVariationContextFree):
    cv_variation = Variation_413

    @classmethod
    def create(cls, arg : RuleVariation_402_Arg) -> "RuleVariation_402":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_413:
        return self.arg # type: ignore

Content_133_Arg: TypeAlias = int
class Content_133(ContentTable):
    cv_values = {0: "Default", 1: "OCAT function"}

RuleContent_133_Arg: TypeAlias = Content_133_Arg
class RuleContent_133(RuleContentContextFree):
    cv_content = Content_133

    @property
    def content(self) -> Content_133:
        return self._get_content() # type: ignore

Variation_519_Arg: TypeAlias = RuleContent_133_Arg
class Variation_519(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_133

    @classmethod
    def create(cls, arg : Variation_519_Arg) -> "Variation_519":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_133:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_133:
        return self.rule.content

RuleVariation_508_Arg: TypeAlias = Variation_519_Arg
class RuleVariation_508(RuleVariationContextFree):
    cv_variation = Variation_519

    @classmethod
    def create(cls, arg : RuleVariation_508_Arg) -> "RuleVariation_508":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_519:
        return self.arg # type: ignore

Content_147_Arg: TypeAlias = int
class Content_147(ContentTable):
    cv_values = {0: "Default", 1: "SAM function"}

RuleContent_147_Arg: TypeAlias = Content_147_Arg
class RuleContent_147(RuleContentContextFree):
    cv_content = Content_147

    @property
    def content(self) -> Content_147:
        return self._get_content() # type: ignore

Variation_629_Arg: TypeAlias = RuleContent_147_Arg
class Variation_629(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_147

    @classmethod
    def create(cls, arg : Variation_629_Arg) -> "Variation_629":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_147:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_147:
        return self.rule.content

RuleVariation_618_Arg: TypeAlias = Variation_629_Arg
class RuleVariation_618(RuleVariationContextFree):
    cv_variation = Variation_629

    @classmethod
    def create(cls, arg : RuleVariation_618_Arg) -> "RuleVariation_618":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_629:
        return self.arg # type: ignore

Content_159_Arg: TypeAlias = int
class Content_159(ContentTable):
    cv_values = {0: "Default", 1: "VCD function"}

RuleContent_159_Arg: TypeAlias = Content_159_Arg
class RuleContent_159(RuleContentContextFree):
    cv_content = Content_159

    @property
    def content(self) -> Content_159:
        return self._get_content() # type: ignore

Variation_709_Arg: TypeAlias = RuleContent_159_Arg
class Variation_709(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_159

    @classmethod
    def create(cls, arg : Variation_709_Arg) -> "Variation_709":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_159:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_159:
        return self.rule.content

RuleVariation_698_Arg: TypeAlias = Variation_709_Arg
class RuleVariation_698(RuleVariationContextFree):
    cv_variation = Variation_709

    @classmethod
    def create(cls, arg : RuleVariation_698_Arg) -> "RuleVariation_698":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_709:
        return self.arg # type: ignore

Content_86_Arg: TypeAlias = int
class Content_86(ContentTable):
    cv_values = {0: "Default", 1: "CHAM function"}

RuleContent_86_Arg: TypeAlias = Content_86_Arg
class RuleContent_86(RuleContentContextFree):
    cv_content = Content_86

    @property
    def content(self) -> Content_86:
        return self._get_content() # type: ignore

Variation_826_Arg: TypeAlias = RuleContent_86_Arg
class Variation_826(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_86

    @classmethod
    def create(cls, arg : Variation_826_Arg) -> "Variation_826":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_86:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_86:
        return self.rule.content

RuleVariation_796_Arg: TypeAlias = Variation_826_Arg
class RuleVariation_796(RuleVariationContextFree):
    cv_variation = Variation_826

    @classmethod
    def create(cls, arg : RuleVariation_796_Arg) -> "RuleVariation_796":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_826:
        return self.arg # type: ignore

Content_93_Arg: TypeAlias = int
class Content_93(ContentTable):
    cv_values = {0: "Default", 1: "DSAM function"}

RuleContent_93_Arg: TypeAlias = Content_93_Arg
class RuleContent_93(RuleContentContextFree):
    cv_content = Content_93

    @property
    def content(self) -> Content_93:
        return self._get_content() # type: ignore

Variation_907_Arg: TypeAlias = RuleContent_93_Arg
class Variation_907(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_93

    @classmethod
    def create(cls, arg : Variation_907_Arg) -> "Variation_907":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_93:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_93:
        return self.rule.content

RuleVariation_877_Arg: TypeAlias = Variation_907_Arg
class RuleVariation_877(RuleVariationContextFree):
    cv_variation = Variation_907

    @classmethod
    def create(cls, arg : RuleVariation_877_Arg) -> "RuleVariation_877":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_907:
        return self.arg # type: ignore

Content_90_Arg: TypeAlias = int
class Content_90(ContentTable):
    cv_values = {0: "Default", 1: "DBPSM ARR sub-function"}

RuleContent_90_Arg: TypeAlias = Content_90_Arg
class RuleContent_90(RuleContentContextFree):
    cv_content = Content_90

    @property
    def content(self) -> Content_90:
        return self._get_content() # type: ignore

Variation_27_Arg: TypeAlias = RuleContent_90_Arg
class Variation_27(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_90

    @classmethod
    def create(cls, arg : Variation_27_Arg) -> "Variation_27":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_90:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_90:
        return self.rule.content

RuleVariation_27_Arg: TypeAlias = Variation_27_Arg
class RuleVariation_27(RuleVariationContextFree):
    cv_variation = Variation_27

    @classmethod
    def create(cls, arg : RuleVariation_27_Arg) -> "RuleVariation_27":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_27:
        return self.arg # type: ignore

Content_91_Arg: TypeAlias = int
class Content_91(ContentTable):
    cv_values = {0: "Default", 1: "DBPSM DEP sub-function"}

RuleContent_91_Arg: TypeAlias = Content_91_Arg
class RuleContent_91(RuleContentContextFree):
    cv_content = Content_91

    @property
    def content(self) -> Content_91:
        return self._get_content() # type: ignore

Variation_404_Arg: TypeAlias = RuleContent_91_Arg
class Variation_404(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_91

    @classmethod
    def create(cls, arg : Variation_404_Arg) -> "Variation_404":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_91:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_91:
        return self.rule.content

RuleVariation_393_Arg: TypeAlias = Variation_404_Arg
class RuleVariation_393(RuleVariationContextFree):
    cv_variation = Variation_404

    @classmethod
    def create(cls, arg : RuleVariation_393_Arg) -> "RuleVariation_393":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_404:
        return self.arg # type: ignore

Content_92_Arg: TypeAlias = int
class Content_92(ContentTable):
    cv_values = {0: "Default", 1: "DBPSM TL sub-function"}

RuleContent_92_Arg: TypeAlias = Content_92_Arg
class RuleContent_92(RuleContentContextFree):
    cv_content = Content_92

    @property
    def content(self) -> Content_92:
        return self._get_content() # type: ignore

Variation_513_Arg: TypeAlias = RuleContent_92_Arg
class Variation_513(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_92

    @classmethod
    def create(cls, arg : Variation_513_Arg) -> "Variation_513":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_92:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_92:
        return self.rule.content

RuleVariation_502_Arg: TypeAlias = Variation_513_Arg
class RuleVariation_502(RuleVariationContextFree):
    cv_variation = Variation_513

    @classmethod
    def create(cls, arg : RuleVariation_502_Arg) -> "RuleVariation_502":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_513:
        return self.arg # type: ignore

Content_161_Arg: TypeAlias = int
class Content_161(ContentTable):
    cv_values = {0: "Default", 1: "VRAM CRM sub-function"}

RuleContent_161_Arg: TypeAlias = Content_161_Arg
class RuleContent_161(RuleContentContextFree):
    cv_content = Content_161

    @property
    def content(self) -> Content_161:
        return self._get_content() # type: ignore

Variation_631_Arg: TypeAlias = RuleContent_161_Arg
class Variation_631(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_161

    @classmethod
    def create(cls, arg : Variation_631_Arg) -> "Variation_631":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_161:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_161:
        return self.rule.content

RuleVariation_620_Arg: TypeAlias = Variation_631_Arg
class RuleVariation_620(RuleVariationContextFree):
    cv_variation = Variation_631

    @classmethod
    def create(cls, arg : RuleVariation_620_Arg) -> "RuleVariation_620":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_631:
        return self.arg # type: ignore

Content_163_Arg: TypeAlias = int
class Content_163(ContentTable):
    cv_values = {0: "Default", 1: "VRAM VTM sub-function"}

RuleContent_163_Arg: TypeAlias = Content_163_Arg
class RuleContent_163(RuleContentContextFree):
    cv_content = Content_163

    @property
    def content(self) -> Content_163:
        return self._get_content() # type: ignore

Variation_711_Arg: TypeAlias = RuleContent_163_Arg
class Variation_711(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_163

    @classmethod
    def create(cls, arg : Variation_711_Arg) -> "Variation_711":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_163:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_163:
        return self.rule.content

RuleVariation_700_Arg: TypeAlias = Variation_711_Arg
class RuleVariation_700(RuleVariationContextFree):
    cv_variation = Variation_711

    @classmethod
    def create(cls, arg : RuleVariation_700_Arg) -> "RuleVariation_700":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_711:
        return self.arg # type: ignore

Content_162_Arg: TypeAlias = int
class Content_162(ContentTable):
    cv_values = {0: "Default", 1: "VRAM VRM sub-function"}

RuleContent_162_Arg: TypeAlias = Content_162_Arg
class RuleContent_162(RuleContentContextFree):
    cv_content = Content_162

    @property
    def content(self) -> Content_162:
        return self._get_content() # type: ignore

Variation_838_Arg: TypeAlias = RuleContent_162_Arg
class Variation_838(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_162

    @classmethod
    def create(cls, arg : Variation_838_Arg) -> "Variation_838":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_162:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_162:
        return self.rule.content

RuleVariation_808_Arg: TypeAlias = Variation_838_Arg
class RuleVariation_808(RuleVariationContextFree):
    cv_variation = Variation_838

    @classmethod
    def create(cls, arg : RuleVariation_808_Arg) -> "RuleVariation_808":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_838:
        return self.arg # type: ignore

Content_101_Arg: TypeAlias = int
class Content_101(ContentTable):
    cv_values = {0: "Default", 1: "HAM HD sub-function"}

RuleContent_101_Arg: TypeAlias = Content_101_Arg
class RuleContent_101(RuleContentContextFree):
    cv_content = Content_101

    @property
    def content(self) -> Content_101:
        return self._get_content() # type: ignore

Variation_910_Arg: TypeAlias = RuleContent_101_Arg
class Variation_910(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_101

    @classmethod
    def create(cls, arg : Variation_910_Arg) -> "Variation_910":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_101:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_101:
        return self.rule.content

RuleVariation_880_Arg: TypeAlias = Variation_910_Arg
class RuleVariation_880(RuleVariationContextFree):
    cv_variation = Variation_910

    @classmethod
    def create(cls, arg : RuleVariation_880_Arg) -> "RuleVariation_880":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_910:
        return self.arg # type: ignore

Content_102_Arg: TypeAlias = int
class Content_102(ContentTable):
    cv_values = {0: "Default", 1: "HAM RD sub-function"}

RuleContent_102_Arg: TypeAlias = Content_102_Arg
class RuleContent_102(RuleContentContextFree):
    cv_content = Content_102

    @property
    def content(self) -> Content_102:
        return self._get_content() # type: ignore

Variation_29_Arg: TypeAlias = RuleContent_102_Arg
class Variation_29(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_102

    @classmethod
    def create(cls, arg : Variation_29_Arg) -> "Variation_29":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_102:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_102:
        return self.rule.content

RuleVariation_29_Arg: TypeAlias = Variation_29_Arg
class RuleVariation_29(RuleVariationContextFree):
    cv_variation = Variation_29

    @classmethod
    def create(cls, arg : RuleVariation_29_Arg) -> "RuleVariation_29":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_29:
        return self.arg # type: ignore

Content_103_Arg: TypeAlias = int
class Content_103(ContentTable):
    cv_values = {0: "Default", 1: "HAM VD sub-function"}

RuleContent_103_Arg: TypeAlias = Content_103_Arg
class RuleContent_103(RuleContentContextFree):
    cv_content = Content_103

    @property
    def content(self) -> Content_103:
        return self._get_content() # type: ignore

Variation_407_Arg: TypeAlias = RuleContent_103_Arg
class Variation_407(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_103

    @classmethod
    def create(cls, arg : Variation_407_Arg) -> "Variation_407":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_103:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_103:
        return self.rule.content

RuleVariation_396_Arg: TypeAlias = Variation_407_Arg
class RuleVariation_396(RuleVariationContextFree):
    cv_variation = Variation_407

    @classmethod
    def create(cls, arg : RuleVariation_396_Arg) -> "RuleVariation_396":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_407:
        return self.arg # type: ignore

Content_104_Arg: TypeAlias = int
class Content_104(ContentTable):
    cv_values = {0: "Default", 1: "HVI function"}

RuleContent_104_Arg: TypeAlias = Content_104_Arg
class RuleContent_104(RuleContentContextFree):
    cv_content = Content_104

    @property
    def content(self) -> Content_104:
        return self._get_content() # type: ignore

Variation_515_Arg: TypeAlias = RuleContent_104_Arg
class Variation_515(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_104

    @classmethod
    def create(cls, arg : Variation_515_Arg) -> "Variation_515":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_104:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_104:
        return self.rule.content

RuleVariation_504_Arg: TypeAlias = Variation_515_Arg
class RuleVariation_504(RuleVariationContextFree):
    cv_variation = Variation_515

    @classmethod
    def create(cls, arg : RuleVariation_504_Arg) -> "RuleVariation_504":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_515:
        return self.arg # type: ignore

Content_111_Arg: TypeAlias = int
class Content_111(ContentTable):
    cv_values = {0: "Default", 1: "LTW function"}

RuleContent_111_Arg: TypeAlias = Content_111_Arg
class RuleContent_111(RuleContentContextFree):
    cv_content = Content_111

    @property
    def content(self) -> Content_111:
        return self._get_content() # type: ignore

Variation_622_Arg: TypeAlias = RuleContent_111_Arg
class Variation_622(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_111

    @classmethod
    def create(cls, arg : Variation_622_Arg) -> "Variation_622":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_111:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_111:
        return self.rule.content

RuleVariation_611_Arg: TypeAlias = Variation_622_Arg
class RuleVariation_611(RuleVariationContextFree):
    cv_variation = Variation_622

    @classmethod
    def create(cls, arg : RuleVariation_611_Arg) -> "RuleVariation_611":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_622:
        return self.arg # type: ignore

Content_160_Arg: TypeAlias = int
class Content_160(ContentTable):
    cv_values = {0: "Default", 1: "VPM function"}

RuleContent_160_Arg: TypeAlias = Content_160_Arg
class RuleContent_160(RuleContentContextFree):
    cv_content = Content_160

    @property
    def content(self) -> Content_160:
        return self._get_content() # type: ignore

Variation_710_Arg: TypeAlias = RuleContent_160_Arg
class Variation_710(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_160

    @classmethod
    def create(cls, arg : Variation_710_Arg) -> "Variation_710":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_160:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_160:
        return self.rule.content

RuleVariation_699_Arg: TypeAlias = Variation_710_Arg
class RuleVariation_699(RuleVariationContextFree):
    cv_variation = Variation_710

    @classmethod
    def create(cls, arg : RuleVariation_699_Arg) -> "RuleVariation_699":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_710:
        return self.arg # type: ignore

Content_153_Arg: TypeAlias = int
class Content_153(ContentTable):
    cv_values = {0: "Default", 1: "TTA function"}

RuleContent_153_Arg: TypeAlias = Content_153_Arg
class RuleContent_153(RuleContentContextFree):
    cv_content = Content_153

    @property
    def content(self) -> Content_153:
        return self._get_content() # type: ignore

Variation_836_Arg: TypeAlias = RuleContent_153_Arg
class Variation_836(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_153

    @classmethod
    def create(cls, arg : Variation_836_Arg) -> "Variation_836":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_153:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_153:
        return self.rule.content

RuleVariation_806_Arg: TypeAlias = Variation_836_Arg
class RuleVariation_806(RuleVariationContextFree):
    cv_variation = Variation_836

    @classmethod
    def create(cls, arg : RuleVariation_806_Arg) -> "RuleVariation_806":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_836:
        return self.arg # type: ignore

Content_88_Arg: TypeAlias = int
class Content_88(ContentTable):
    cv_values = {0: "Default", 1: "CRA function"}

RuleContent_88_Arg: TypeAlias = Content_88_Arg
class RuleContent_88(RuleContentContextFree):
    cv_content = Content_88

    @property
    def content(self) -> Content_88:
        return self._get_content() # type: ignore

Variation_905_Arg: TypeAlias = RuleContent_88_Arg
class Variation_905(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_88

    @classmethod
    def create(cls, arg : Variation_905_Arg) -> "Variation_905":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_88:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_88:
        return self.rule.content

RuleVariation_875_Arg: TypeAlias = Variation_905_Arg
class RuleVariation_875(RuleVariationContextFree):
    cv_variation = Variation_905

    @classmethod
    def create(cls, arg : RuleVariation_875_Arg) -> "RuleVariation_875":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_905:
        return self.arg # type: ignore

Content_83_Arg: TypeAlias = int
class Content_83(ContentTable):
    cv_values = {0: "Default", 1: "ASM sub-function"}

RuleContent_83_Arg: TypeAlias = Content_83_Arg
class RuleContent_83(RuleContentContextFree):
    cv_content = Content_83

    @property
    def content(self) -> Content_83:
        return self._get_content() # type: ignore

Variation_25_Arg: TypeAlias = RuleContent_83_Arg
class Variation_25(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_83

    @classmethod
    def create(cls, arg : Variation_25_Arg) -> "Variation_25":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_83:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_83:
        return self.rule.content

RuleVariation_25_Arg: TypeAlias = Variation_25_Arg
class RuleVariation_25(RuleVariationContextFree):
    cv_variation = Variation_25

    @classmethod
    def create(cls, arg : RuleVariation_25_Arg) -> "RuleVariation_25":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_25:
        return self.arg # type: ignore

Content_106_Arg: TypeAlias = int
class Content_106(ContentTable):
    cv_values = {0: "Default", 1: "IAVM sub-function"}

RuleContent_106_Arg: TypeAlias = Content_106_Arg
class RuleContent_106(RuleContentContextFree):
    cv_content = Content_106

    @property
    def content(self) -> Content_106:
        return self._get_content() # type: ignore

Variation_408_Arg: TypeAlias = RuleContent_106_Arg
class Variation_408(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_106

    @classmethod
    def create(cls, arg : Variation_408_Arg) -> "Variation_408":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_106:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_106:
        return self.rule.content

RuleVariation_397_Arg: TypeAlias = Variation_408_Arg
class RuleVariation_397(RuleVariationContextFree):
    cv_variation = Variation_408

    @classmethod
    def create(cls, arg : RuleVariation_397_Arg) -> "RuleVariation_397":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_408:
        return self.arg # type: ignore

Content_96_Arg: TypeAlias = int
class Content_96(ContentTable):
    cv_values = {0: "Default", 1: "FTD Function"}

RuleContent_96_Arg: TypeAlias = Content_96_Arg
class RuleContent_96(RuleContentContextFree):
    cv_content = Content_96

    @property
    def content(self) -> Content_96:
        return self._get_content() # type: ignore

Variation_514_Arg: TypeAlias = RuleContent_96_Arg
class Variation_514(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_96

    @classmethod
    def create(cls, arg : Variation_514_Arg) -> "Variation_514":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_96:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_96:
        return self.rule.content

RuleVariation_503_Arg: TypeAlias = Variation_514_Arg
class RuleVariation_503(RuleVariationContextFree):
    cv_variation = Variation_514

    @classmethod
    def create(cls, arg : RuleVariation_503_Arg) -> "RuleVariation_503":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_514:
        return self.arg # type: ignore

Content_108_Arg: TypeAlias = int
class Content_108(ContentTable):
    cv_values = {0: "Default", 1: "ITD function"}

RuleContent_108_Arg: TypeAlias = Content_108_Arg
class RuleContent_108(RuleContentContextFree):
    cv_content = Content_108

    @property
    def content(self) -> Content_108:
        return self._get_content() # type: ignore

Variation_620_Arg: TypeAlias = RuleContent_108_Arg
class Variation_620(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_108

    @classmethod
    def create(cls, arg : Variation_620_Arg) -> "Variation_620":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_108:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_108:
        return self.rule.content

RuleVariation_609_Arg: TypeAlias = Variation_620_Arg
class RuleVariation_609(RuleVariationContextFree):
    cv_variation = Variation_620

    @classmethod
    def create(cls, arg : RuleVariation_609_Arg) -> "RuleVariation_609":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_620:
        return self.arg # type: ignore

Content_107_Arg: TypeAlias = int
class Content_107(ContentTable):
    cv_values = {0: "Default", 1: "IIA function"}

RuleContent_107_Arg: TypeAlias = Content_107_Arg
class RuleContent_107(RuleContentContextFree):
    cv_content = Content_107

    @property
    def content(self) -> Content_107:
        return self._get_content() # type: ignore

Variation_704_Arg: TypeAlias = RuleContent_107_Arg
class Variation_704(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_107

    @classmethod
    def create(cls, arg : Variation_704_Arg) -> "Variation_704":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_107:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_107:
        return self.rule.content

RuleVariation_693_Arg: TypeAlias = Variation_704_Arg
class RuleVariation_693(RuleVariationContextFree):
    cv_variation = Variation_704

    @classmethod
    def create(cls, arg : RuleVariation_693_Arg) -> "RuleVariation_693":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_704:
        return self.arg # type: ignore

Content_148_Arg: TypeAlias = int
class Content_148(ContentTable):
    cv_values = {0: "Default", 1: "SQW function"}

RuleContent_148_Arg: TypeAlias = Content_148_Arg
class RuleContent_148(RuleContentContextFree):
    cv_content = Content_148

    @property
    def content(self) -> Content_148:
        return self._get_content() # type: ignore

Variation_833_Arg: TypeAlias = RuleContent_148_Arg
class Variation_833(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_148

    @classmethod
    def create(cls, arg : Variation_833_Arg) -> "Variation_833":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_148:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_148:
        return self.rule.content

RuleVariation_803_Arg: TypeAlias = Variation_833_Arg
class RuleVariation_803(RuleVariationContextFree):
    cv_variation = Variation_833

    @classmethod
    def create(cls, arg : RuleVariation_803_Arg) -> "RuleVariation_803":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_833:
        return self.arg # type: ignore

Content_89_Arg: TypeAlias = int
class Content_89(ContentTable):
    cv_values = {0: "Default", 1: "CUW function"}

RuleContent_89_Arg: TypeAlias = Content_89_Arg
class RuleContent_89(RuleContentContextFree):
    cv_content = Content_89

    @property
    def content(self) -> Content_89:
        return self._get_content() # type: ignore

Variation_906_Arg: TypeAlias = RuleContent_89_Arg
class Variation_906(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_89

    @classmethod
    def create(cls, arg : Variation_906_Arg) -> "Variation_906":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_89:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_89:
        return self.rule.content

RuleVariation_876_Arg: TypeAlias = Variation_906_Arg
class RuleVariation_876(RuleVariationContextFree):
    cv_variation = Variation_906

    @classmethod
    def create(cls, arg : RuleVariation_876_Arg) -> "RuleVariation_876":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_906:
        return self.arg # type: ignore

Content_85_Arg: TypeAlias = int
class Content_85(ContentTable):
    cv_values = {0: "Default", 1: "CATC function"}

RuleContent_85_Arg: TypeAlias = Content_85_Arg
class RuleContent_85(RuleContentContextFree):
    cv_content = Content_85

    @property
    def content(self) -> Content_85:
        return self._get_content() # type: ignore

Variation_26_Arg: TypeAlias = RuleContent_85_Arg
class Variation_26(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_85

    @classmethod
    def create(cls, arg : Variation_26_Arg) -> "Variation_26":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_85:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_85:
        return self.rule.content

RuleVariation_26_Arg: TypeAlias = Variation_26_Arg
class RuleVariation_26(RuleVariationContextFree):
    cv_variation = Variation_26

    @classmethod
    def create(cls, arg : RuleVariation_26_Arg) -> "RuleVariation_26":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_26:
        return self.arg # type: ignore

Content_129_Arg: TypeAlias = int
class Content_129(ContentTable):
    cv_values = {0: "Default", 1: "NOCLR sub-function"}

RuleContent_129_Arg: TypeAlias = Content_129_Arg
class RuleContent_129(RuleContentContextFree):
    cv_content = Content_129

    @property
    def content(self) -> Content_129:
        return self._get_content() # type: ignore

Variation_412_Arg: TypeAlias = RuleContent_129_Arg
class Variation_412(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_129

    @classmethod
    def create(cls, arg : Variation_412_Arg) -> "Variation_412":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_129:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_129:
        return self.rule.content

RuleVariation_401_Arg: TypeAlias = Variation_412_Arg
class RuleVariation_401(RuleVariationContextFree):
    cv_variation = Variation_412

    @classmethod
    def create(cls, arg : RuleVariation_401_Arg) -> "RuleVariation_401":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_412:
        return self.arg # type: ignore

Content_131_Arg: TypeAlias = int
class Content_131(ContentTable):
    cv_values = {0: "Default", 1: "NOMOV Function"}

RuleContent_131_Arg: TypeAlias = Content_131_Arg
class RuleContent_131(RuleContentContextFree):
    cv_content = Content_131

    @property
    def content(self) -> Content_131:
        return self._get_content() # type: ignore

Variation_518_Arg: TypeAlias = RuleContent_131_Arg
class Variation_518(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_131

    @classmethod
    def create(cls, arg : Variation_518_Arg) -> "Variation_518":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_131:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_131:
        return self.rule.content

RuleVariation_507_Arg: TypeAlias = Variation_518_Arg
class RuleVariation_507(RuleVariationContextFree):
    cv_variation = Variation_518

    @classmethod
    def create(cls, arg : RuleVariation_507_Arg) -> "RuleVariation_507":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_518:
        return self.arg # type: ignore

Content_130_Arg: TypeAlias = int
class Content_130(ContentTable):
    cv_values = {0: "Default", 1: "NOH function"}

RuleContent_130_Arg: TypeAlias = Content_130_Arg
class RuleContent_130(RuleContentContextFree):
    cv_content = Content_130

    @property
    def content(self) -> Content_130:
        return self._get_content() # type: ignore

Variation_627_Arg: TypeAlias = RuleContent_130_Arg
class Variation_627(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_130

    @classmethod
    def create(cls, arg : Variation_627_Arg) -> "Variation_627":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_130:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_130:
        return self.rule.content

RuleVariation_616_Arg: TypeAlias = Variation_627_Arg
class RuleVariation_616(RuleVariationContextFree):
    cv_variation = Variation_627

    @classmethod
    def create(cls, arg : RuleVariation_616_Arg) -> "RuleVariation_616":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_627:
        return self.arg # type: ignore

Content_164_Arg: TypeAlias = int
class Content_164(ContentTable):
    cv_values = {0: "Default", 1: "WRTY function"}

RuleContent_164_Arg: TypeAlias = Content_164_Arg
class RuleContent_164(RuleContentContextFree):
    cv_content = Content_164

    @property
    def content(self) -> Content_164:
        return self._get_content() # type: ignore

Variation_712_Arg: TypeAlias = RuleContent_164_Arg
class Variation_712(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_164

    @classmethod
    def create(cls, arg : Variation_712_Arg) -> "Variation_712":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_164:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_164:
        return self.rule.content

RuleVariation_701_Arg: TypeAlias = Variation_712_Arg
class RuleVariation_701(RuleVariationContextFree):
    cv_variation = Variation_712

    @classmethod
    def create(cls, arg : RuleVariation_701_Arg) -> "RuleVariation_701":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_712:
        return self.arg # type: ignore

Content_150_Arg: TypeAlias = int
class Content_150(ContentTable):
    cv_values = {0: "Default", 1: "STOCC function"}

RuleContent_150_Arg: TypeAlias = Content_150_Arg
class RuleContent_150(RuleContentContextFree):
    cv_content = Content_150

    @property
    def content(self) -> Content_150:
        return self._get_content() # type: ignore

Variation_834_Arg: TypeAlias = RuleContent_150_Arg
class Variation_834(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_150

    @classmethod
    def create(cls, arg : Variation_834_Arg) -> "Variation_834":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_150:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_150:
        return self.rule.content

RuleVariation_804_Arg: TypeAlias = Variation_834_Arg
class RuleVariation_804(RuleVariationContextFree):
    cv_variation = Variation_834

    @classmethod
    def create(cls, arg : RuleVariation_804_Arg) -> "RuleVariation_804":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_834:
        return self.arg # type: ignore

Content_134_Arg: TypeAlias = int
class Content_134(ContentTable):
    cv_values = {0: "Default", 1: "ONGOING function"}

RuleContent_134_Arg: TypeAlias = Content_134_Arg
class RuleContent_134(RuleContentContextFree):
    cv_content = Content_134

    @property
    def content(self) -> Content_134:
        return self._get_content() # type: ignore

Variation_912_Arg: TypeAlias = RuleContent_134_Arg
class Variation_912(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_134

    @classmethod
    def create(cls, arg : Variation_912_Arg) -> "Variation_912":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_134:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_134:
        return self.rule.content

RuleVariation_882_Arg: TypeAlias = Variation_912_Arg
class RuleVariation_882(RuleVariationContextFree):
    cv_variation = Variation_912

    @classmethod
    def create(cls, arg : RuleVariation_882_Arg) -> "RuleVariation_882":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_912:
        return self.arg # type: ignore

NonSpare_1309_Arg: TypeAlias = RuleVariation_32_Arg
class NonSpare_1309(NonSpare):
    cv_name = "MRVA"
    cv_title = ""
    cv_rule = RuleVariation_32

    @classmethod
    def create(cls, arg : NonSpare_1309_Arg) -> "NonSpare_1309":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_32:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_32:
        return self.rule.variation

Item_581_Arg: TypeAlias = NonSpare_1309_Arg
class Item_581(Item):
    cv_non_spare = NonSpare_1309

    @classmethod
    def create(cls, arg : Item_581_Arg) -> "Item_581":
        return cls._create(arg) # type: ignore

NonSpare_1537_Arg: TypeAlias = RuleVariation_403_Arg
class NonSpare_1537(NonSpare):
    cv_name = "RAMLD"
    cv_title = ""
    cv_rule = RuleVariation_403

    @classmethod
    def create(cls, arg : NonSpare_1537_Arg) -> "NonSpare_1537":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_403:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_414:
        return self.rule.variation

Item_773_Arg: TypeAlias = NonSpare_1537_Arg
class Item_773(Item):
    cv_non_spare = NonSpare_1537

    @classmethod
    def create(cls, arg : Item_773_Arg) -> "Item_773":
        return cls._create(arg) # type: ignore

NonSpare_1536_Arg: TypeAlias = RuleVariation_510_Arg
class NonSpare_1536(NonSpare):
    cv_name = "RAMHD"
    cv_title = ""
    cv_rule = RuleVariation_510

    @classmethod
    def create(cls, arg : NonSpare_1536_Arg) -> "NonSpare_1536":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_510:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_521:
        return self.rule.variation

Item_772_Arg: TypeAlias = NonSpare_1536_Arg
class Item_772(Item):
    cv_non_spare = NonSpare_1536

    @classmethod
    def create(cls, arg : Item_772_Arg) -> "Item_772":
        return cls._create(arg) # type: ignore

NonSpare_1314_Arg: TypeAlias = RuleVariation_612_Arg
class NonSpare_1314(NonSpare):
    cv_name = "MSAW"
    cv_title = ""
    cv_rule = RuleVariation_612

    @classmethod
    def create(cls, arg : NonSpare_1314_Arg) -> "NonSpare_1314":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_612:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_623:
        return self.rule.variation

Item_584_Arg: TypeAlias = NonSpare_1314_Arg
class Item_584(Item):
    cv_non_spare = NonSpare_1314

    @classmethod
    def create(cls, arg : Item_584_Arg) -> "Item_584":
        return cls._create(arg) # type: ignore

NonSpare_614_Arg: TypeAlias = RuleVariation_691_Arg
class NonSpare_614(NonSpare):
    cv_name = "APW"
    cv_title = ""
    cv_rule = RuleVariation_691

    @classmethod
    def create(cls, arg : NonSpare_614_Arg) -> "NonSpare_614":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_691:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_702:
        return self.rule.variation

Item_78_Arg: TypeAlias = NonSpare_614_Arg
class Item_78(Item):
    cv_non_spare = NonSpare_614

    @classmethod
    def create(cls, arg : Item_78_Arg) -> "Item_78":
        return cls._create(arg) # type: ignore

NonSpare_736_Arg: TypeAlias = RuleVariation_797_Arg
class NonSpare_736(NonSpare):
    cv_name = "CLAM"
    cv_title = ""
    cv_rule = RuleVariation_797

    @classmethod
    def create(cls, arg : NonSpare_736_Arg) -> "NonSpare_736":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_797:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_827:
        return self.rule.variation

Item_161_Arg: TypeAlias = NonSpare_736_Arg
class Item_161(Item):
    cv_non_spare = NonSpare_736

    @classmethod
    def create(cls, arg : Item_161_Arg) -> "Item_161":
        return cls._create(arg) # type: ignore

NonSpare_1778_Arg: TypeAlias = RuleVariation_886_Arg
class NonSpare_1778(NonSpare):
    cv_name = "STCA"
    cv_title = ""
    cv_rule = RuleVariation_886

    @classmethod
    def create(cls, arg : NonSpare_1778_Arg) -> "NonSpare_1778":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_886:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_916:
        return self.rule.variation

Item_945_Arg: TypeAlias = NonSpare_1778_Arg
class Item_945(Item):
    cv_non_spare = NonSpare_1778

    @classmethod
    def create(cls, arg : Item_945_Arg) -> "Item_945":
        return cls._create(arg) # type: ignore

NonSpare_613_Arg: TypeAlias = RuleVariation_24_Arg
class NonSpare_613(NonSpare):
    cv_name = "APM"
    cv_title = ""
    cv_rule = RuleVariation_24

    @classmethod
    def create(cls, arg : NonSpare_613_Arg) -> "NonSpare_613":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_24:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_24:
        return self.rule.variation

Item_77_Arg: TypeAlias = NonSpare_613_Arg
class Item_77(Item):
    cv_non_spare = NonSpare_613

    @classmethod
    def create(cls, arg : Item_77_Arg) -> "Item_77":
        return cls._create(arg) # type: ignore

NonSpare_1587_Arg: TypeAlias = RuleVariation_404_Arg
class NonSpare_1587(NonSpare):
    cv_name = "RIMCA"
    cv_title = ""
    cv_rule = RuleVariation_404

    @classmethod
    def create(cls, arg : NonSpare_1587_Arg) -> "NonSpare_1587":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_404:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_415:
        return self.rule.variation

Item_818_Arg: TypeAlias = NonSpare_1587_Arg
class Item_818(Item):
    cv_non_spare = NonSpare_1587

    @classmethod
    def create(cls, arg : Item_818_Arg) -> "Item_818":
        return cls._create(arg) # type: ignore

NonSpare_555_Arg: TypeAlias = RuleVariation_500_Arg
class NonSpare_555(NonSpare):
    cv_name = "ACASRA"
    cv_title = ""
    cv_rule = RuleVariation_500

    @classmethod
    def create(cls, arg : NonSpare_555_Arg) -> "NonSpare_555":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_500:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_511:
        return self.rule.variation

Item_40_Arg: TypeAlias = NonSpare_555_Arg
class Item_40(Item):
    cv_non_spare = NonSpare_555

    @classmethod
    def create(cls, arg : Item_40_Arg) -> "Item_40":
        return cls._create(arg) # type: ignore

NonSpare_1372_Arg: TypeAlias = RuleVariation_617_Arg
class NonSpare_1372(NonSpare):
    cv_name = "NTCA"
    cv_title = ""
    cv_rule = RuleVariation_617

    @classmethod
    def create(cls, arg : NonSpare_1372_Arg) -> "NonSpare_1372":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_617:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_628:
        return self.rule.variation

Item_637_Arg: TypeAlias = NonSpare_1372_Arg
class Item_637(Item):
    cv_non_spare = NonSpare_1372

    @classmethod
    def create(cls, arg : Item_637_Arg) -> "Item_637":
        return cls._create(arg) # type: ignore

NonSpare_875_Arg: TypeAlias = RuleVariation_697_Arg
class NonSpare_875(NonSpare):
    cv_name = "DG"
    cv_title = ""
    cv_rule = RuleVariation_697

    @classmethod
    def create(cls, arg : NonSpare_875_Arg) -> "NonSpare_875":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_697:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_708:
        return self.rule.variation

Item_258_Arg: TypeAlias = NonSpare_875_Arg
class Item_258(Item):
    cv_non_spare = NonSpare_875

    @classmethod
    def create(cls, arg : Item_258_Arg) -> "Item_258":
        return cls._create(arg) # type: ignore

NonSpare_1386_Arg: TypeAlias = RuleVariation_801_Arg
class NonSpare_1386(NonSpare):
    cv_name = "OF"
    cv_title = ""
    cv_rule = RuleVariation_801

    @classmethod
    def create(cls, arg : NonSpare_1386_Arg) -> "NonSpare_1386":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_801:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_831:
        return self.rule.variation

Item_651_Arg: TypeAlias = NonSpare_1386_Arg
class Item_651(Item):
    cv_non_spare = NonSpare_1386

    @classmethod
    def create(cls, arg : Item_651_Arg) -> "Item_651":
        return cls._create(arg) # type: ignore

NonSpare_1387_Arg: TypeAlias = RuleVariation_883_Arg
class NonSpare_1387(NonSpare):
    cv_name = "OL"
    cv_title = ""
    cv_rule = RuleVariation_883

    @classmethod
    def create(cls, arg : NonSpare_1387_Arg) -> "NonSpare_1387":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_883:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_913:
        return self.rule.variation

Item_652_Arg: TypeAlias = NonSpare_1387_Arg
class Item_652(Item):
    cv_non_spare = NonSpare_1387

    @classmethod
    def create(cls, arg : Item_652_Arg) -> "Item_652":
        return cls._create(arg) # type: ignore

NonSpare_584_Arg: TypeAlias = RuleVariation_23_Arg
class NonSpare_584(NonSpare):
    cv_name = "AIW"
    cv_title = ""
    cv_rule = RuleVariation_23

    @classmethod
    def create(cls, arg : NonSpare_584_Arg) -> "NonSpare_584":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_23:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_23:
        return self.rule.variation

Item_56_Arg: TypeAlias = NonSpare_584_Arg
class Item_56(Item):
    cv_non_spare = NonSpare_584

    @classmethod
    def create(cls, arg : Item_56_Arg) -> "Item_56":
        return cls._create(arg) # type: ignore

NonSpare_1411_Arg: TypeAlias = RuleVariation_402_Arg
class NonSpare_1411(NonSpare):
    cv_name = "PAIW"
    cv_title = ""
    cv_rule = RuleVariation_402

    @classmethod
    def create(cls, arg : NonSpare_1411_Arg) -> "NonSpare_1411":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_402:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_413:
        return self.rule.variation

Item_674_Arg: TypeAlias = NonSpare_1411_Arg
class Item_674(Item):
    cv_non_spare = NonSpare_1411

    @classmethod
    def create(cls, arg : Item_674_Arg) -> "Item_674":
        return cls._create(arg) # type: ignore

NonSpare_1380_Arg: TypeAlias = RuleVariation_508_Arg
class NonSpare_1380(NonSpare):
    cv_name = "OCAT"
    cv_title = ""
    cv_rule = RuleVariation_508

    @classmethod
    def create(cls, arg : NonSpare_1380_Arg) -> "NonSpare_1380":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_508:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_519:
        return self.rule.variation

Item_645_Arg: TypeAlias = NonSpare_1380_Arg
class Item_645(Item):
    cv_non_spare = NonSpare_1380

    @classmethod
    def create(cls, arg : Item_645_Arg) -> "Item_645":
        return cls._create(arg) # type: ignore

NonSpare_1651_Arg: TypeAlias = RuleVariation_618_Arg
class NonSpare_1651(NonSpare):
    cv_name = "SAM"
    cv_title = ""
    cv_rule = RuleVariation_618

    @classmethod
    def create(cls, arg : NonSpare_1651_Arg) -> "NonSpare_1651":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_618:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_629:
        return self.rule.variation

Item_855_Arg: TypeAlias = NonSpare_1651_Arg
class Item_855(Item):
    cv_non_spare = NonSpare_1651

    @classmethod
    def create(cls, arg : Item_855_Arg) -> "Item_855":
        return cls._create(arg) # type: ignore

NonSpare_2018_Arg: TypeAlias = RuleVariation_698_Arg
class NonSpare_2018(NonSpare):
    cv_name = "VCD"
    cv_title = ""
    cv_rule = RuleVariation_698

    @classmethod
    def create(cls, arg : NonSpare_2018_Arg) -> "NonSpare_2018":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_698:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_709:
        return self.rule.variation

Item_1134_Arg: TypeAlias = NonSpare_2018_Arg
class Item_1134(Item):
    cv_non_spare = NonSpare_2018

    @classmethod
    def create(cls, arg : Item_1134_Arg) -> "Item_1134":
        return cls._create(arg) # type: ignore

NonSpare_726_Arg: TypeAlias = RuleVariation_796_Arg
class NonSpare_726(NonSpare):
    cv_name = "CHAM"
    cv_title = ""
    cv_rule = RuleVariation_796

    @classmethod
    def create(cls, arg : NonSpare_726_Arg) -> "NonSpare_726":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_796:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_826:
        return self.rule.variation

Item_154_Arg: TypeAlias = NonSpare_726_Arg
class Item_154(Item):
    cv_non_spare = NonSpare_726

    @classmethod
    def create(cls, arg : Item_154_Arg) -> "Item_154":
        return cls._create(arg) # type: ignore

NonSpare_895_Arg: TypeAlias = RuleVariation_877_Arg
class NonSpare_895(NonSpare):
    cv_name = "DSAM"
    cv_title = ""
    cv_rule = RuleVariation_877

    @classmethod
    def create(cls, arg : NonSpare_895_Arg) -> "NonSpare_895":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_877:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_907:
        return self.rule.variation

Item_274_Arg: TypeAlias = NonSpare_895_Arg
class Item_274(Item):
    cv_non_spare = NonSpare_895

    @classmethod
    def create(cls, arg : Item_274_Arg) -> "Item_274":
        return cls._create(arg) # type: ignore

NonSpare_857_Arg: TypeAlias = RuleVariation_27_Arg
class NonSpare_857(NonSpare):
    cv_name = "DBPSMARR"
    cv_title = ""
    cv_rule = RuleVariation_27

    @classmethod
    def create(cls, arg : NonSpare_857_Arg) -> "NonSpare_857":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_27:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_27:
        return self.rule.variation

Item_241_Arg: TypeAlias = NonSpare_857_Arg
class Item_241(Item):
    cv_non_spare = NonSpare_857

    @classmethod
    def create(cls, arg : Item_241_Arg) -> "Item_241":
        return cls._create(arg) # type: ignore

NonSpare_859_Arg: TypeAlias = RuleVariation_393_Arg
class NonSpare_859(NonSpare):
    cv_name = "DBPSMDEP"
    cv_title = ""
    cv_rule = RuleVariation_393

    @classmethod
    def create(cls, arg : NonSpare_859_Arg) -> "NonSpare_859":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_393:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_404:
        return self.rule.variation

Item_243_Arg: TypeAlias = NonSpare_859_Arg
class Item_243(Item):
    cv_non_spare = NonSpare_859

    @classmethod
    def create(cls, arg : Item_243_Arg) -> "Item_243":
        return cls._create(arg) # type: ignore

NonSpare_861_Arg: TypeAlias = RuleVariation_502_Arg
class NonSpare_861(NonSpare):
    cv_name = "DBPSMTL"
    cv_title = ""
    cv_rule = RuleVariation_502

    @classmethod
    def create(cls, arg : NonSpare_861_Arg) -> "NonSpare_861":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_502:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_513:
        return self.rule.variation

Item_245_Arg: TypeAlias = NonSpare_861_Arg
class Item_245(Item):
    cv_non_spare = NonSpare_861

    @classmethod
    def create(cls, arg : Item_245_Arg) -> "Item_245":
        return cls._create(arg) # type: ignore

NonSpare_2030_Arg: TypeAlias = RuleVariation_620_Arg
class NonSpare_2030(NonSpare):
    cv_name = "VRAMCRM"
    cv_title = ""
    cv_rule = RuleVariation_620

    @classmethod
    def create(cls, arg : NonSpare_2030_Arg) -> "NonSpare_2030":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_620:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_631:
        return self.rule.variation

Item_1145_Arg: TypeAlias = NonSpare_2030_Arg
class Item_1145(Item):
    cv_non_spare = NonSpare_2030

    @classmethod
    def create(cls, arg : Item_1145_Arg) -> "Item_1145":
        return cls._create(arg) # type: ignore

NonSpare_2033_Arg: TypeAlias = RuleVariation_700_Arg
class NonSpare_2033(NonSpare):
    cv_name = "VRAMVTM"
    cv_title = ""
    cv_rule = RuleVariation_700

    @classmethod
    def create(cls, arg : NonSpare_2033_Arg) -> "NonSpare_2033":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_700:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_711:
        return self.rule.variation

Item_1148_Arg: TypeAlias = NonSpare_2033_Arg
class Item_1148(Item):
    cv_non_spare = NonSpare_2033

    @classmethod
    def create(cls, arg : Item_1148_Arg) -> "Item_1148":
        return cls._create(arg) # type: ignore

NonSpare_2032_Arg: TypeAlias = RuleVariation_808_Arg
class NonSpare_2032(NonSpare):
    cv_name = "VRAMVRM"
    cv_title = ""
    cv_rule = RuleVariation_808

    @classmethod
    def create(cls, arg : NonSpare_2032_Arg) -> "NonSpare_2032":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_808:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_838:
        return self.rule.variation

Item_1147_Arg: TypeAlias = NonSpare_2032_Arg
class Item_1147(Item):
    cv_non_spare = NonSpare_2032

    @classmethod
    def create(cls, arg : Item_1147_Arg) -> "Item_1147":
        return cls._create(arg) # type: ignore

NonSpare_1046_Arg: TypeAlias = RuleVariation_880_Arg
class NonSpare_1046(NonSpare):
    cv_name = "HAMHD"
    cv_title = ""
    cv_rule = RuleVariation_880

    @classmethod
    def create(cls, arg : NonSpare_1046_Arg) -> "NonSpare_1046":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_880:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_910:
        return self.rule.variation

Item_380_Arg: TypeAlias = NonSpare_1046_Arg
class Item_380(Item):
    cv_non_spare = NonSpare_1046

    @classmethod
    def create(cls, arg : Item_380_Arg) -> "Item_380":
        return cls._create(arg) # type: ignore

NonSpare_1048_Arg: TypeAlias = RuleVariation_29_Arg
class NonSpare_1048(NonSpare):
    cv_name = "HAMRD"
    cv_title = ""
    cv_rule = RuleVariation_29

    @classmethod
    def create(cls, arg : NonSpare_1048_Arg) -> "NonSpare_1048":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_29:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_29:
        return self.rule.variation

Item_382_Arg: TypeAlias = NonSpare_1048_Arg
class Item_382(Item):
    cv_non_spare = NonSpare_1048

    @classmethod
    def create(cls, arg : Item_382_Arg) -> "Item_382":
        return cls._create(arg) # type: ignore

NonSpare_1050_Arg: TypeAlias = RuleVariation_396_Arg
class NonSpare_1050(NonSpare):
    cv_name = "HAMVD"
    cv_title = ""
    cv_rule = RuleVariation_396

    @classmethod
    def create(cls, arg : NonSpare_1050_Arg) -> "NonSpare_1050":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_396:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_407:
        return self.rule.variation

Item_384_Arg: TypeAlias = NonSpare_1050_Arg
class Item_384(Item):
    cv_non_spare = NonSpare_1050

    @classmethod
    def create(cls, arg : Item_384_Arg) -> "Item_384":
        return cls._create(arg) # type: ignore

NonSpare_1077_Arg: TypeAlias = RuleVariation_504_Arg
class NonSpare_1077(NonSpare):
    cv_name = "HVI"
    cv_title = ""
    cv_rule = RuleVariation_504

    @classmethod
    def create(cls, arg : NonSpare_1077_Arg) -> "NonSpare_1077":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_504:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_515:
        return self.rule.variation

Item_405_Arg: TypeAlias = NonSpare_1077_Arg
class Item_405(Item):
    cv_non_spare = NonSpare_1077

    @classmethod
    def create(cls, arg : Item_405_Arg) -> "Item_405":
        return cls._create(arg) # type: ignore

NonSpare_1192_Arg: TypeAlias = RuleVariation_611_Arg
class NonSpare_1192(NonSpare):
    cv_name = "LTW"
    cv_title = ""
    cv_rule = RuleVariation_611

    @classmethod
    def create(cls, arg : NonSpare_1192_Arg) -> "NonSpare_1192":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_611:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_622:
        return self.rule.variation

Item_506_Arg: TypeAlias = NonSpare_1192_Arg
class Item_506(Item):
    cv_non_spare = NonSpare_1192

    @classmethod
    def create(cls, arg : Item_506_Arg) -> "Item_506":
        return cls._create(arg) # type: ignore

NonSpare_2028_Arg: TypeAlias = RuleVariation_699_Arg
class NonSpare_2028(NonSpare):
    cv_name = "VPM"
    cv_title = ""
    cv_rule = RuleVariation_699

    @classmethod
    def create(cls, arg : NonSpare_2028_Arg) -> "NonSpare_2028":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_699:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_710:
        return self.rule.variation

Item_1143_Arg: TypeAlias = NonSpare_2028_Arg
class Item_1143(Item):
    cv_non_spare = NonSpare_2028

    @classmethod
    def create(cls, arg : Item_1143_Arg) -> "Item_1143":
        return cls._create(arg) # type: ignore

NonSpare_1937_Arg: TypeAlias = RuleVariation_806_Arg
class NonSpare_1937(NonSpare):
    cv_name = "TTA"
    cv_title = ""
    cv_rule = RuleVariation_806

    @classmethod
    def create(cls, arg : NonSpare_1937_Arg) -> "NonSpare_1937":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_806:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_836:
        return self.rule.variation

Item_1058_Arg: TypeAlias = NonSpare_1937_Arg
class Item_1058(Item):
    cv_non_spare = NonSpare_1937

    @classmethod
    def create(cls, arg : Item_1058_Arg) -> "Item_1058":
        return cls._create(arg) # type: ignore

NonSpare_820_Arg: TypeAlias = RuleVariation_875_Arg
class NonSpare_820(NonSpare):
    cv_name = "CRA"
    cv_title = ""
    cv_rule = RuleVariation_875

    @classmethod
    def create(cls, arg : NonSpare_820_Arg) -> "NonSpare_820":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_875:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_905:
        return self.rule.variation

Item_212_Arg: TypeAlias = NonSpare_820_Arg
class Item_212(Item):
    cv_non_spare = NonSpare_820

    @classmethod
    def create(cls, arg : Item_212_Arg) -> "Item_212":
        return cls._create(arg) # type: ignore

NonSpare_632_Arg: TypeAlias = RuleVariation_25_Arg
class NonSpare_632(NonSpare):
    cv_name = "ASM"
    cv_title = ""
    cv_rule = RuleVariation_25

    @classmethod
    def create(cls, arg : NonSpare_632_Arg) -> "NonSpare_632":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_25:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_25:
        return self.rule.variation

Item_86_Arg: TypeAlias = NonSpare_632_Arg
class Item_86(Item):
    cv_non_spare = NonSpare_632

    @classmethod
    def create(cls, arg : Item_86_Arg) -> "Item_86":
        return cls._create(arg) # type: ignore

NonSpare_1097_Arg: TypeAlias = RuleVariation_397_Arg
class NonSpare_1097(NonSpare):
    cv_name = "IAVM"
    cv_title = ""
    cv_rule = RuleVariation_397

    @classmethod
    def create(cls, arg : NonSpare_1097_Arg) -> "NonSpare_1097":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_397:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_408:
        return self.rule.variation

Item_421_Arg: TypeAlias = NonSpare_1097_Arg
class Item_421(Item):
    cv_non_spare = NonSpare_1097

    @classmethod
    def create(cls, arg : Item_421_Arg) -> "Item_421":
        return cls._create(arg) # type: ignore

NonSpare_997_Arg: TypeAlias = RuleVariation_503_Arg
class NonSpare_997(NonSpare):
    cv_name = "FTD"
    cv_title = ""
    cv_rule = RuleVariation_503

    @classmethod
    def create(cls, arg : NonSpare_997_Arg) -> "NonSpare_997":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_503:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_514:
        return self.rule.variation

Item_349_Arg: TypeAlias = NonSpare_997_Arg
class Item_349(Item):
    cv_non_spare = NonSpare_997

    @classmethod
    def create(cls, arg : Item_349_Arg) -> "Item_349":
        return cls._create(arg) # type: ignore

NonSpare_1120_Arg: TypeAlias = RuleVariation_609_Arg
class NonSpare_1120(NonSpare):
    cv_name = "ITD"
    cv_title = ""
    cv_rule = RuleVariation_609

    @classmethod
    def create(cls, arg : NonSpare_1120_Arg) -> "NonSpare_1120":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_609:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_620:
        return self.rule.variation

Item_438_Arg: TypeAlias = NonSpare_1120_Arg
class Item_438(Item):
    cv_non_spare = NonSpare_1120

    @classmethod
    def create(cls, arg : Item_438_Arg) -> "Item_438":
        return cls._create(arg) # type: ignore

NonSpare_1111_Arg: TypeAlias = RuleVariation_693_Arg
class NonSpare_1111(NonSpare):
    cv_name = "IIA"
    cv_title = ""
    cv_rule = RuleVariation_693

    @classmethod
    def create(cls, arg : NonSpare_1111_Arg) -> "NonSpare_1111":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_693:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_704:
        return self.rule.variation

Item_431_Arg: TypeAlias = NonSpare_1111_Arg
class Item_431(Item):
    cv_non_spare = NonSpare_1111

    @classmethod
    def create(cls, arg : Item_431_Arg) -> "Item_431":
        return cls._create(arg) # type: ignore

NonSpare_1735_Arg: TypeAlias = RuleVariation_803_Arg
class NonSpare_1735(NonSpare):
    cv_name = "SQW"
    cv_title = ""
    cv_rule = RuleVariation_803

    @classmethod
    def create(cls, arg : NonSpare_1735_Arg) -> "NonSpare_1735":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_803:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_833:
        return self.rule.variation

Item_914_Arg: TypeAlias = NonSpare_1735_Arg
class Item_914(Item):
    cv_non_spare = NonSpare_1735

    @classmethod
    def create(cls, arg : Item_914_Arg) -> "Item_914":
        return cls._create(arg) # type: ignore

NonSpare_843_Arg: TypeAlias = RuleVariation_876_Arg
class NonSpare_843(NonSpare):
    cv_name = "CUW"
    cv_title = ""
    cv_rule = RuleVariation_876

    @classmethod
    def create(cls, arg : NonSpare_843_Arg) -> "NonSpare_843":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_876:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_906:
        return self.rule.variation

Item_230_Arg: TypeAlias = NonSpare_843_Arg
class Item_230(Item):
    cv_non_spare = NonSpare_843

    @classmethod
    def create(cls, arg : Item_230_Arg) -> "Item_230":
        return cls._create(arg) # type: ignore

NonSpare_701_Arg: TypeAlias = RuleVariation_26_Arg
class NonSpare_701(NonSpare):
    cv_name = "CATC"
    cv_title = ""
    cv_rule = RuleVariation_26

    @classmethod
    def create(cls, arg : NonSpare_701_Arg) -> "NonSpare_701":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_26:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_26:
        return self.rule.variation

Item_136_Arg: TypeAlias = NonSpare_701_Arg
class Item_136(Item):
    cv_non_spare = NonSpare_701

    @classmethod
    def create(cls, arg : Item_136_Arg) -> "Item_136":
        return cls._create(arg) # type: ignore

NonSpare_1354_Arg: TypeAlias = RuleVariation_401_Arg
class NonSpare_1354(NonSpare):
    cv_name = "NOCLR"
    cv_title = ""
    cv_rule = RuleVariation_401

    @classmethod
    def create(cls, arg : NonSpare_1354_Arg) -> "NonSpare_1354":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_401:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_412:
        return self.rule.variation

Item_620_Arg: TypeAlias = NonSpare_1354_Arg
class Item_620(Item):
    cv_non_spare = NonSpare_1354

    @classmethod
    def create(cls, arg : Item_620_Arg) -> "Item_620":
        return cls._create(arg) # type: ignore

NonSpare_1367_Arg: TypeAlias = RuleVariation_507_Arg
class NonSpare_1367(NonSpare):
    cv_name = "NOMOV"
    cv_title = ""
    cv_rule = RuleVariation_507

    @classmethod
    def create(cls, arg : NonSpare_1367_Arg) -> "NonSpare_1367":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_507:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_518:
        return self.rule.variation

Item_633_Arg: TypeAlias = NonSpare_1367_Arg
class Item_633(Item):
    cv_non_spare = NonSpare_1367

    @classmethod
    def create(cls, arg : Item_633_Arg) -> "Item_633":
        return cls._create(arg) # type: ignore

NonSpare_1362_Arg: TypeAlias = RuleVariation_616_Arg
class NonSpare_1362(NonSpare):
    cv_name = "NOH"
    cv_title = ""
    cv_rule = RuleVariation_616

    @classmethod
    def create(cls, arg : NonSpare_1362_Arg) -> "NonSpare_1362":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_616:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_627:
        return self.rule.variation

Item_628_Arg: TypeAlias = NonSpare_1362_Arg
class Item_628(Item):
    cv_non_spare = NonSpare_1362

    @classmethod
    def create(cls, arg : Item_628_Arg) -> "Item_628":
        return cls._create(arg) # type: ignore

NonSpare_2054_Arg: TypeAlias = RuleVariation_701_Arg
class NonSpare_2054(NonSpare):
    cv_name = "WRTY"
    cv_title = ""
    cv_rule = RuleVariation_701

    @classmethod
    def create(cls, arg : NonSpare_2054_Arg) -> "NonSpare_2054":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_701:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_712:
        return self.rule.variation

Item_1164_Arg: TypeAlias = NonSpare_2054_Arg
class Item_1164(Item):
    cv_non_spare = NonSpare_2054

    @classmethod
    def create(cls, arg : Item_1164_Arg) -> "Item_1164":
        return cls._create(arg) # type: ignore

NonSpare_1785_Arg: TypeAlias = RuleVariation_804_Arg
class NonSpare_1785(NonSpare):
    cv_name = "STOCC"
    cv_title = ""
    cv_rule = RuleVariation_804

    @classmethod
    def create(cls, arg : NonSpare_1785_Arg) -> "NonSpare_1785":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_804:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_834:
        return self.rule.variation

Item_951_Arg: TypeAlias = NonSpare_1785_Arg
class Item_951(Item):
    cv_non_spare = NonSpare_1785

    @classmethod
    def create(cls, arg : Item_951_Arg) -> "Item_951":
        return cls._create(arg) # type: ignore

NonSpare_1389_Arg: TypeAlias = RuleVariation_882_Arg
class NonSpare_1389(NonSpare):
    cv_name = "ONGOING"
    cv_title = ""
    cv_rule = RuleVariation_882

    @classmethod
    def create(cls, arg : NonSpare_1389_Arg) -> "NonSpare_1389":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_882:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_912:
        return self.rule.variation

Item_654_Arg: TypeAlias = NonSpare_1389_Arg
class Item_654(Item):
    cv_non_spare = NonSpare_1389

    @classmethod
    def create(cls, arg : Item_654_Arg) -> "Item_654":
        return cls._create(arg) # type: ignore

Variation_1364_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_32_Arg, Tuple[Literal["MRVA"], RuleVariation_32_Arg]], Union[RuleVariation_403_Arg, Tuple[Literal["RAMLD"], RuleVariation_403_Arg]], Union[RuleVariation_510_Arg, Tuple[Literal["RAMHD"], RuleVariation_510_Arg]], Union[RuleVariation_612_Arg, Tuple[Literal["MSAW"], RuleVariation_612_Arg]], Union[RuleVariation_691_Arg, Tuple[Literal["APW"], RuleVariation_691_Arg]], Union[RuleVariation_797_Arg, Tuple[Literal["CLAM"], RuleVariation_797_Arg]], Union[RuleVariation_886_Arg, Tuple[Literal["STCA"], RuleVariation_886_Arg]], None]]
Variation_1364_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_24_Arg, Tuple[Literal["APM"], RuleVariation_24_Arg]], Union[RuleVariation_404_Arg, Tuple[Literal["RIMCA"], RuleVariation_404_Arg]], Union[RuleVariation_500_Arg, Tuple[Literal["ACASRA"], RuleVariation_500_Arg]], Union[RuleVariation_617_Arg, Tuple[Literal["NTCA"], RuleVariation_617_Arg]], Union[RuleVariation_697_Arg, Tuple[Literal["DG"], RuleVariation_697_Arg]], Union[RuleVariation_801_Arg, Tuple[Literal["OF"], RuleVariation_801_Arg]], Union[RuleVariation_883_Arg, Tuple[Literal["OL"], RuleVariation_883_Arg]], None]]
Variation_1364_Arg_Group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_23_Arg, Tuple[Literal["AIW"], RuleVariation_23_Arg]], Union[RuleVariation_402_Arg, Tuple[Literal["PAIW"], RuleVariation_402_Arg]], Union[RuleVariation_508_Arg, Tuple[Literal["OCAT"], RuleVariation_508_Arg]], Union[RuleVariation_618_Arg, Tuple[Literal["SAM"], RuleVariation_618_Arg]], Union[RuleVariation_698_Arg, Tuple[Literal["VCD"], RuleVariation_698_Arg]], Union[RuleVariation_796_Arg, Tuple[Literal["CHAM"], RuleVariation_796_Arg]], Union[RuleVariation_877_Arg, Tuple[Literal["DSAM"], RuleVariation_877_Arg]], None]]
Variation_1364_Arg_Group_4: TypeAlias = Union[int, Tuple[Union[RuleVariation_27_Arg, Tuple[Literal["DBPSMARR"], RuleVariation_27_Arg]], Union[RuleVariation_393_Arg, Tuple[Literal["DBPSMDEP"], RuleVariation_393_Arg]], Union[RuleVariation_502_Arg, Tuple[Literal["DBPSMTL"], RuleVariation_502_Arg]], Union[RuleVariation_620_Arg, Tuple[Literal["VRAMCRM"], RuleVariation_620_Arg]], Union[RuleVariation_700_Arg, Tuple[Literal["VRAMVTM"], RuleVariation_700_Arg]], Union[RuleVariation_808_Arg, Tuple[Literal["VRAMVRM"], RuleVariation_808_Arg]], Union[RuleVariation_880_Arg, Tuple[Literal["HAMHD"], RuleVariation_880_Arg]], None]]
Variation_1364_Arg_Group_5: TypeAlias = Union[int, Tuple[Union[RuleVariation_29_Arg, Tuple[Literal["HAMRD"], RuleVariation_29_Arg]], Union[RuleVariation_396_Arg, Tuple[Literal["HAMVD"], RuleVariation_396_Arg]], Union[RuleVariation_504_Arg, Tuple[Literal["HVI"], RuleVariation_504_Arg]], Union[RuleVariation_611_Arg, Tuple[Literal["LTW"], RuleVariation_611_Arg]], Union[RuleVariation_699_Arg, Tuple[Literal["VPM"], RuleVariation_699_Arg]], Union[RuleVariation_806_Arg, Tuple[Literal["TTA"], RuleVariation_806_Arg]], Union[RuleVariation_875_Arg, Tuple[Literal["CRA"], RuleVariation_875_Arg]], None]]
Variation_1364_Arg_Group_6: TypeAlias = Union[int, Tuple[Union[RuleVariation_25_Arg, Tuple[Literal["ASM"], RuleVariation_25_Arg]], Union[RuleVariation_397_Arg, Tuple[Literal["IAVM"], RuleVariation_397_Arg]], Union[RuleVariation_503_Arg, Tuple[Literal["FTD"], RuleVariation_503_Arg]], Union[RuleVariation_609_Arg, Tuple[Literal["ITD"], RuleVariation_609_Arg]], Union[RuleVariation_693_Arg, Tuple[Literal["IIA"], RuleVariation_693_Arg]], Union[RuleVariation_803_Arg, Tuple[Literal["SQW"], RuleVariation_803_Arg]], Union[RuleVariation_876_Arg, Tuple[Literal["CUW"], RuleVariation_876_Arg]], None]]
Variation_1364_Arg_Group_7: TypeAlias = Union[int, Tuple[Union[RuleVariation_26_Arg, Tuple[Literal["CATC"], RuleVariation_26_Arg]], Union[RuleVariation_401_Arg, Tuple[Literal["NOCLR"], RuleVariation_401_Arg]], Union[RuleVariation_507_Arg, Tuple[Literal["NOMOV"], RuleVariation_507_Arg]], Union[RuleVariation_616_Arg, Tuple[Literal["NOH"], RuleVariation_616_Arg]], Union[RuleVariation_701_Arg, Tuple[Literal["WRTY"], RuleVariation_701_Arg]], Union[RuleVariation_804_Arg, Tuple[Literal["STOCC"], RuleVariation_804_Arg]], Union[RuleVariation_882_Arg, Tuple[Literal["ONGOING"], RuleVariation_882_Arg]], None]]
Variation_1364_Arg: TypeAlias = Union[
    Tuple[Variation_1364_Arg_Group_1],
    Tuple[Variation_1364_Arg_Group_1, Variation_1364_Arg_Group_2],
    Tuple[Variation_1364_Arg_Group_1, Variation_1364_Arg_Group_2, Variation_1364_Arg_Group_3],
    Tuple[Variation_1364_Arg_Group_1, Variation_1364_Arg_Group_2, Variation_1364_Arg_Group_3, Variation_1364_Arg_Group_4],
    Tuple[Variation_1364_Arg_Group_1, Variation_1364_Arg_Group_2, Variation_1364_Arg_Group_3, Variation_1364_Arg_Group_4, Variation_1364_Arg_Group_5],
    Tuple[Variation_1364_Arg_Group_1, Variation_1364_Arg_Group_2, Variation_1364_Arg_Group_3, Variation_1364_Arg_Group_4, Variation_1364_Arg_Group_5, Variation_1364_Arg_Group_6],
    Tuple[Variation_1364_Arg_Group_1, Variation_1364_Arg_Group_2, Variation_1364_Arg_Group_3, Variation_1364_Arg_Group_4, Variation_1364_Arg_Group_5, Variation_1364_Arg_Group_6, Variation_1364_Arg_Group_7],
]
class Variation_1364(Extended):
    cv_items_list = [[(Item_581, 1), (Item_773, 1), (Item_772, 1), (Item_584, 1), (Item_78, 1), (Item_161, 1), (Item_945, 1), None], [(Item_77, 1), (Item_818, 1), (Item_40, 1), (Item_637, 1), (Item_258, 1), (Item_651, 1), (Item_652, 1), None], [(Item_56, 1), (Item_674, 1), (Item_645, 1), (Item_855, 1), (Item_1134, 1), (Item_154, 1), (Item_274, 1), None], [(Item_241, 1), (Item_243, 1), (Item_245, 1), (Item_1145, 1), (Item_1148, 1), (Item_1147, 1), (Item_380, 1), None], [(Item_382, 1), (Item_384, 1), (Item_405, 1), (Item_506, 1), (Item_1143, 1), (Item_1058, 1), (Item_212, 1), None], [(Item_86, 1), (Item_421, 1), (Item_349, 1), (Item_438, 1), (Item_431, 1), (Item_914, 1), (Item_230, 1), None], [(Item_136, 1), (Item_620, 1), (Item_633, 1), (Item_628, 1), (Item_1164, 1), (Item_951, 1), (Item_654, 1), None]]

    @classmethod
    def create(cls, arg : Variation_1364_Arg) -> 'Variation_1364':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MRVA"]) -> RuleVariation_32:
        ...
    @overload
    def get_item(self, key : Literal["RAMLD"]) -> RuleVariation_403:
        ...
    @overload
    def get_item(self, key : Literal["RAMHD"]) -> RuleVariation_510:
        ...
    @overload
    def get_item(self, key : Literal["MSAW"]) -> RuleVariation_612:
        ...
    @overload
    def get_item(self, key : Literal["APW"]) -> RuleVariation_691:
        ...
    @overload
    def get_item(self, key : Literal["CLAM"]) -> RuleVariation_797:
        ...
    @overload
    def get_item(self, key : Literal["STCA"]) -> RuleVariation_886:
        ...
    @overload
    def get_item(self, key : Literal["APM"]) -> Optional[RuleVariation_24]:
        ...
    @overload
    def get_item(self, key : Literal["RIMCA"]) -> Optional[RuleVariation_404]:
        ...
    @overload
    def get_item(self, key : Literal["ACASRA"]) -> Optional[RuleVariation_500]:
        ...
    @overload
    def get_item(self, key : Literal["NTCA"]) -> Optional[RuleVariation_617]:
        ...
    @overload
    def get_item(self, key : Literal["DG"]) -> Optional[RuleVariation_697]:
        ...
    @overload
    def get_item(self, key : Literal["OF"]) -> Optional[RuleVariation_801]:
        ...
    @overload
    def get_item(self, key : Literal["OL"]) -> Optional[RuleVariation_883]:
        ...
    @overload
    def get_item(self, key : Literal["AIW"]) -> Optional[RuleVariation_23]:
        ...
    @overload
    def get_item(self, key : Literal["PAIW"]) -> Optional[RuleVariation_402]:
        ...
    @overload
    def get_item(self, key : Literal["OCAT"]) -> Optional[RuleVariation_508]:
        ...
    @overload
    def get_item(self, key : Literal["SAM"]) -> Optional[RuleVariation_618]:
        ...
    @overload
    def get_item(self, key : Literal["VCD"]) -> Optional[RuleVariation_698]:
        ...
    @overload
    def get_item(self, key : Literal["CHAM"]) -> Optional[RuleVariation_796]:
        ...
    @overload
    def get_item(self, key : Literal["DSAM"]) -> Optional[RuleVariation_877]:
        ...
    @overload
    def get_item(self, key : Literal["DBPSMARR"]) -> Optional[RuleVariation_27]:
        ...
    @overload
    def get_item(self, key : Literal["DBPSMDEP"]) -> Optional[RuleVariation_393]:
        ...
    @overload
    def get_item(self, key : Literal["DBPSMTL"]) -> Optional[RuleVariation_502]:
        ...
    @overload
    def get_item(self, key : Literal["VRAMCRM"]) -> Optional[RuleVariation_620]:
        ...
    @overload
    def get_item(self, key : Literal["VRAMVTM"]) -> Optional[RuleVariation_700]:
        ...
    @overload
    def get_item(self, key : Literal["VRAMVRM"]) -> Optional[RuleVariation_808]:
        ...
    @overload
    def get_item(self, key : Literal["HAMHD"]) -> Optional[RuleVariation_880]:
        ...
    @overload
    def get_item(self, key : Literal["HAMRD"]) -> Optional[RuleVariation_29]:
        ...
    @overload
    def get_item(self, key : Literal["HAMVD"]) -> Optional[RuleVariation_396]:
        ...
    @overload
    def get_item(self, key : Literal["HVI"]) -> Optional[RuleVariation_504]:
        ...
    @overload
    def get_item(self, key : Literal["LTW"]) -> Optional[RuleVariation_611]:
        ...
    @overload
    def get_item(self, key : Literal["VPM"]) -> Optional[RuleVariation_699]:
        ...
    @overload
    def get_item(self, key : Literal["TTA"]) -> Optional[RuleVariation_806]:
        ...
    @overload
    def get_item(self, key : Literal["CRA"]) -> Optional[RuleVariation_875]:
        ...
    @overload
    def get_item(self, key : Literal["ASM"]) -> Optional[RuleVariation_25]:
        ...
    @overload
    def get_item(self, key : Literal["IAVM"]) -> Optional[RuleVariation_397]:
        ...
    @overload
    def get_item(self, key : Literal["FTD"]) -> Optional[RuleVariation_503]:
        ...
    @overload
    def get_item(self, key : Literal["ITD"]) -> Optional[RuleVariation_609]:
        ...
    @overload
    def get_item(self, key : Literal["IIA"]) -> Optional[RuleVariation_693]:
        ...
    @overload
    def get_item(self, key : Literal["SQW"]) -> Optional[RuleVariation_803]:
        ...
    @overload
    def get_item(self, key : Literal["CUW"]) -> Optional[RuleVariation_876]:
        ...
    @overload
    def get_item(self, key : Literal["CATC"]) -> Optional[RuleVariation_26]:
        ...
    @overload
    def get_item(self, key : Literal["NOCLR"]) -> Optional[RuleVariation_401]:
        ...
    @overload
    def get_item(self, key : Literal["NOMOV"]) -> Optional[RuleVariation_507]:
        ...
    @overload
    def get_item(self, key : Literal["NOH"]) -> Optional[RuleVariation_616]:
        ...
    @overload
    def get_item(self, key : Literal["WRTY"]) -> Optional[RuleVariation_701]:
        ...
    @overload
    def get_item(self, key : Literal["STOCC"]) -> Optional[RuleVariation_804]:
        ...
    @overload
    def get_item(self, key : Literal["ONGOING"]) -> Optional[RuleVariation_882]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1287_Arg: TypeAlias = Variation_1364_Arg
class RuleVariation_1287(RuleVariationContextFree):
    cv_variation = Variation_1364

    @classmethod
    def create(cls, arg : RuleVariation_1287_Arg) -> "RuleVariation_1287":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1364:
        return self.arg # type: ignore

NonSpare_192_Arg: TypeAlias = RuleVariation_1287_Arg
class NonSpare_192(NonSpare):
    cv_name = "060"
    cv_title = "Safety Net Function and System Status"
    cv_rule = RuleVariation_1287

    @classmethod
    def create(cls, arg : NonSpare_192_Arg) -> "NonSpare_192":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1287:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1364:
        return self.rule.variation

class UapItem_192(UapItem):
    cv_non_spare = NonSpare_192

NonSpare_112_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_112(NonSpare):
    cv_name = "030"
    cv_title = "Track Number 1"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_112_Arg) -> "NonSpare_112":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

class UapItem_112(UapItem):
    cv_non_spare = NonSpare_112

Content_606_Arg: TypeAlias = Union[int, str]
class Content_606(ContentString):
    cv_string_type = StringAscii

RuleContent_606_Arg: TypeAlias = Content_606_Arg
class RuleContent_606(RuleContentContextFree):
    cv_content = Content_606

    @property
    def content(self) -> Content_606:
        return self._get_content() # type: ignore

Variation_391_Arg: TypeAlias = RuleContent_606_Arg
class Variation_391(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_rule = RuleContent_606

    @classmethod
    def create(cls, arg : Variation_391_Arg) -> "Variation_391":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_606:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_606:
        return self.rule.content

RuleVariation_383_Arg: TypeAlias = Variation_391_Arg
class RuleVariation_383(RuleVariationContextFree):
    cv_variation = Variation_391

    @classmethod
    def create(cls, arg : RuleVariation_383_Arg) -> "RuleVariation_383":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_391:
        return self.arg # type: ignore

NonSpare_581_Arg: TypeAlias = RuleVariation_383_Arg
class NonSpare_581(NonSpare):
    cv_name = "AI1"
    cv_title = "Aircraft Identifier (in 7 Characters) of Aircraft 1 Involved in the Conflict"
    cv_rule = RuleVariation_383

    @classmethod
    def create(cls, arg : NonSpare_581_Arg) -> "NonSpare_581":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

NonSpare_1298_Arg: TypeAlias = RuleVariation_776_Arg
class NonSpare_1298(NonSpare):
    cv_name = "MODE3A"
    cv_title = "Mode-3/A Code (Converted Into Octal Representation) of Aircraft 1 Involved in the Conflict"
    cv_rule = RuleVariation_776

    @classmethod
    def create(cls, arg : NonSpare_1298_Arg) -> "NonSpare_1298":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_776:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_806:
        return self.rule.variation

Item_570_Arg: TypeAlias = NonSpare_1298_Arg
class Item_570(Item):
    cv_non_spare = NonSpare_1298

    @classmethod
    def create(cls, arg : Item_570_Arg) -> "Item_570":
        return cls._create(arg) # type: ignore

Variation_1024_Arg_Group = Tuple[int, Union[RuleVariation_776_Arg, Tuple[Literal["MODE3A"], RuleVariation_776_Arg]]]
Variation_1024_Arg: TypeAlias = Union[int, Variation_1024_Arg_Group]
class Variation_1024(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_570, 12)]
    cv_items_dict = {"MODE3A": RuleVariation_776}

    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_776:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_776:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1024_Arg) -> 'Variation_1024':
        return cls._create(arg) # type: ignore

RuleVariation_993_Arg: TypeAlias = Variation_1024_Arg
class RuleVariation_993(RuleVariationContextFree):
    cv_variation = Variation_1024

    @classmethod
    def create(cls, arg : RuleVariation_993_Arg) -> "RuleVariation_993":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1024:
        return self.arg # type: ignore

NonSpare_1204_Arg: TypeAlias = RuleVariation_993_Arg
class NonSpare_1204(NonSpare):
    cv_name = "M31"
    cv_title = "Mode 3/A Code Aircraft 1"
    cv_rule = RuleVariation_993

    @classmethod
    def create(cls, arg : NonSpare_1204_Arg) -> "NonSpare_1204":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_993:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1024:
        return self.rule.variation

Content_696_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_696(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 5.364418029785156e-6
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_696_Arg: TypeAlias = Content_696_Arg
class RuleContent_696(RuleContentContextFree):
    cv_content = Content_696

    @property
    def content(self) -> Content_696:
        return self._get_content() # type: ignore

Variation_376_Arg: TypeAlias = RuleContent_696_Arg
class Variation_376(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_696

    @classmethod
    def create(cls, arg : Variation_376_Arg) -> "Variation_376":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_696:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_696:
        return self.rule.content

RuleVariation_369_Arg: TypeAlias = Variation_376_Arg
class RuleVariation_369(RuleVariationContextFree):
    cv_variation = Variation_376

    @classmethod
    def create(cls, arg : RuleVariation_369_Arg) -> "RuleVariation_369":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_376:
        return self.arg # type: ignore

NonSpare_1140_Arg: TypeAlias = RuleVariation_369_Arg
class NonSpare_1140(NonSpare):
    cv_name = "LAT"
    cv_title = "In WGS-84 in Two’s Complement"
    cv_rule = RuleVariation_369

    @classmethod
    def create(cls, arg : NonSpare_1140_Arg) -> "NonSpare_1140":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_369:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_376:
        return self.rule.variation

Item_458_Arg: TypeAlias = NonSpare_1140_Arg
class Item_458(Item):
    cv_non_spare = NonSpare_1140

    @classmethod
    def create(cls, arg : Item_458_Arg) -> "Item_458":
        return cls._create(arg) # type: ignore

Content_695_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_695(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 5.364418029785156e-6
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_695_Arg: TypeAlias = Content_695_Arg
class RuleContent_695(RuleContentContextFree):
    cv_content = Content_695

    @property
    def content(self) -> Content_695:
        return self._get_content() # type: ignore

Variation_375_Arg: TypeAlias = RuleContent_695_Arg
class Variation_375(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_695

    @classmethod
    def create(cls, arg : Variation_375_Arg) -> "Variation_375":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_695:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_695:
        return self.rule.content

RuleVariation_368_Arg: TypeAlias = Variation_375_Arg
class RuleVariation_368(RuleVariationContextFree):
    cv_variation = Variation_375

    @classmethod
    def create(cls, arg : RuleVariation_368_Arg) -> "RuleVariation_368":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_375:
        return self.arg # type: ignore

NonSpare_1168_Arg: TypeAlias = RuleVariation_368_Arg
class NonSpare_1168(NonSpare):
    cv_name = "LON"
    cv_title = "In WGS-84 in Two’s Complement"
    cv_rule = RuleVariation_368

    @classmethod
    def create(cls, arg : NonSpare_1168_Arg) -> "NonSpare_1168":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_368:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_375:
        return self.rule.variation

Item_484_Arg: TypeAlias = NonSpare_1168_Arg
class Item_484(Item):
    cv_non_spare = NonSpare_1168

    @classmethod
    def create(cls, arg : Item_484_Arg) -> "Item_484":
        return cls._create(arg) # type: ignore

Content_631_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
class Content_631(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 25.0
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

RuleContent_631_Arg: TypeAlias = Content_631_Arg
class RuleContent_631(RuleContentContextFree):
    cv_content = Content_631

    @property
    def content(self) -> Content_631:
        return self._get_content() # type: ignore

Variation_261_Arg: TypeAlias = RuleContent_631_Arg
class Variation_261(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_631

    @classmethod
    def create(cls, arg : Variation_261_Arg) -> "Variation_261":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_631:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_631:
        return self.rule.content

RuleVariation_254_Arg: TypeAlias = Variation_261_Arg
class RuleVariation_254(RuleVariationContextFree):
    cv_variation = Variation_261

    @classmethod
    def create(cls, arg : RuleVariation_254_Arg) -> "RuleVariation_254":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_261:
        return self.arg # type: ignore

NonSpare_591_Arg: TypeAlias = RuleVariation_254_Arg
class NonSpare_591(NonSpare):
    cv_name = "ALT"
    cv_title = "Altitude of Predicted Conflict"
    cv_rule = RuleVariation_254

    @classmethod
    def create(cls, arg : NonSpare_591_Arg) -> "NonSpare_591":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_254:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_261:
        return self.rule.variation

Item_63_Arg: TypeAlias = NonSpare_591_Arg
class Item_63(Item):
    cv_non_spare = NonSpare_591

    @classmethod
    def create(cls, arg : Item_63_Arg) -> "Item_63":
        return cls._create(arg) # type: ignore

Variation_1120_Arg_Group = Tuple[Union[RuleVariation_369_Arg, Tuple[Literal["LAT"], RuleVariation_369_Arg]], Union[RuleVariation_368_Arg, Tuple[Literal["LON"], RuleVariation_368_Arg]], Union[RuleVariation_254_Arg, Tuple[Literal["ALT"], RuleVariation_254_Arg]]]
Variation_1120_Arg: TypeAlias = Union[int, Variation_1120_Arg_Group]
class Variation_1120(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 80
    cv_items_list = [(Item_458, 32), (Item_484, 32), (Item_63, 16)]
    cv_items_dict = {"LAT": RuleVariation_369, "LON": RuleVariation_368, "ALT": RuleVariation_254}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_369:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_368:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_254:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_369:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_368:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_254:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1120_Arg) -> 'Variation_1120':
        return cls._create(arg) # type: ignore

RuleVariation_1077_Arg: TypeAlias = Variation_1120_Arg
class RuleVariation_1077(RuleVariationContextFree):
    cv_variation = Variation_1120

    @classmethod
    def create(cls, arg : RuleVariation_1077_Arg) -> "RuleVariation_1077":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1120:
        return self.arg # type: ignore

NonSpare_816_Arg: TypeAlias = RuleVariation_1077_Arg
class NonSpare_816(NonSpare):
    cv_name = "CPW"
    cv_title = "Predicted Conflict Position Target 1 in WGS-84 Coordinates"
    cv_rule = RuleVariation_1077

    @classmethod
    def create(cls, arg : NonSpare_816_Arg) -> "NonSpare_816":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1077:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1120:
        return self.rule.variation

Content_636_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_636(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.5
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_636_Arg: TypeAlias = Content_636_Arg
class RuleContent_636(RuleContentContextFree):
    cv_content = Content_636

    @property
    def content(self) -> Content_636:
        return self._get_content() # type: ignore

Variation_350_Arg: TypeAlias = RuleContent_636_Arg
class Variation_350(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_636

    @classmethod
    def create(cls, arg : Variation_350_Arg) -> "Variation_350":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_636:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_636:
        return self.rule.content

RuleVariation_343_Arg: TypeAlias = Variation_350_Arg
class RuleVariation_343(RuleVariationContextFree):
    cv_variation = Variation_350

    @classmethod
    def create(cls, arg : RuleVariation_343_Arg) -> "RuleVariation_343":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_350:
        return self.arg # type: ignore

NonSpare_2083_Arg: TypeAlias = RuleVariation_343_Arg
class NonSpare_2083(NonSpare):
    cv_name = "X"
    cv_title = "Starting X-position of the Conflict"
    cv_rule = RuleVariation_343

    @classmethod
    def create(cls, arg : NonSpare_2083_Arg) -> "NonSpare_2083":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_343:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_350:
        return self.rule.variation

Item_1190_Arg: TypeAlias = NonSpare_2083_Arg
class Item_1190(Item):
    cv_non_spare = NonSpare_2083

    @classmethod
    def create(cls, arg : Item_1190_Arg) -> "Item_1190":
        return cls._create(arg) # type: ignore

NonSpare_2136_Arg: TypeAlias = RuleVariation_343_Arg
class NonSpare_2136(NonSpare):
    cv_name = "Y"
    cv_title = "Starting Y-position of the Conflict"
    cv_rule = RuleVariation_343

    @classmethod
    def create(cls, arg : NonSpare_2136_Arg) -> "NonSpare_2136":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_343:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_350:
        return self.rule.variation

Item_1240_Arg: TypeAlias = NonSpare_2136_Arg
class Item_1240(Item):
    cv_non_spare = NonSpare_2136

    @classmethod
    def create(cls, arg : Item_1240_Arg) -> "Item_1240":
        return cls._create(arg) # type: ignore

NonSpare_2154_Arg: TypeAlias = RuleVariation_254_Arg
class NonSpare_2154(NonSpare):
    cv_name = "Z"
    cv_title = "Starting Z-position of the Conflict"
    cv_rule = RuleVariation_254

    @classmethod
    def create(cls, arg : NonSpare_2154_Arg) -> "NonSpare_2154":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_254:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_261:
        return self.rule.variation

Item_1258_Arg: TypeAlias = NonSpare_2154_Arg
class Item_1258(Item):
    cv_non_spare = NonSpare_2154

    @classmethod
    def create(cls, arg : Item_1258_Arg) -> "Item_1258":
        return cls._create(arg) # type: ignore

Variation_1300_Arg_Group = Tuple[Union[RuleVariation_343_Arg, Tuple[Literal["X"], RuleVariation_343_Arg]], Union[RuleVariation_343_Arg, Tuple[Literal["Y"], RuleVariation_343_Arg]], Union[RuleVariation_254_Arg, Tuple[Literal["Z"], RuleVariation_254_Arg]]]
Variation_1300_Arg: TypeAlias = Union[int, Variation_1300_Arg_Group]
class Variation_1300(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_1190, 24), (Item_1240, 24), (Item_1258, 16)]
    cv_items_dict = {"X": RuleVariation_343, "Y": RuleVariation_343, "Z": RuleVariation_254}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_343:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_343:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Z"]) -> RuleVariation_254:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"], Literal["Z"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_343:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_343:
        ...
    @overload
    def get_item(self, key : Literal["Z"]) -> RuleVariation_254:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1300_Arg) -> 'Variation_1300':
        return cls._create(arg) # type: ignore

RuleVariation_1230_Arg: TypeAlias = Variation_1300_Arg
class RuleVariation_1230(RuleVariationContextFree):
    cv_variation = Variation_1300

    @classmethod
    def create(cls, arg : RuleVariation_1230_Arg) -> "RuleVariation_1230":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1300:
        return self.arg # type: ignore

NonSpare_811_Arg: TypeAlias = RuleVariation_1230_Arg
class NonSpare_811(NonSpare):
    cv_name = "CPC"
    cv_title = "Predicted Conflict Position for the Aircraft 1 Involved in the Conflict"
    cv_rule = RuleVariation_1230

    @classmethod
    def create(cls, arg : NonSpare_811_Arg) -> "NonSpare_811":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1230:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1300:
        return self.rule.variation

NonSpare_1935_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_1935(NonSpare):
    cv_name = "TT1"
    cv_title = "Time to Runway Threshold for First Approaching Aircraft in a RIMCA"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_1935_Arg) -> "NonSpare_1935":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

Content_729_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_729(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.5
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_729_Arg: TypeAlias = Content_729_Arg
class RuleContent_729(RuleContentContextFree):
    cv_content = Content_729

    @property
    def content(self) -> Content_729:
        return self._get_content() # type: ignore

Variation_309_Arg: TypeAlias = RuleContent_729_Arg
class Variation_309(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_729

    @classmethod
    def create(cls, arg : Variation_309_Arg) -> "Variation_309":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_729:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_729:
        return self.rule.content

RuleVariation_302_Arg: TypeAlias = Variation_309_Arg
class RuleVariation_302(RuleVariationContextFree):
    cv_variation = Variation_309

    @classmethod
    def create(cls, arg : RuleVariation_302_Arg) -> "RuleVariation_302":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_309:
        return self.arg # type: ignore

NonSpare_897_Arg: TypeAlias = RuleVariation_302_Arg
class NonSpare_897(NonSpare):
    cv_name = "DT1"
    cv_title = "Distance to Runway Threshold for Aircraft 1 Involved in a RIMCA"
    cv_rule = RuleVariation_302

    @classmethod
    def create(cls, arg : NonSpare_897_Arg) -> "NonSpare_897":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_302:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_309:
        return self.rule.variation

Content_546_Arg: TypeAlias = int
class Content_546(ContentTable):
    cv_values = {0: "Unknown", 1: "General Air Traffic", 2: "Operational Air Traffic", 3: "Not applicable"}

RuleContent_546_Arg: TypeAlias = Content_546_Arg
class RuleContent_546(RuleContentContextFree):
    cv_content = Content_546

    @property
    def content(self) -> Content_546:
        return self._get_content() # type: ignore

Variation_115_Arg: TypeAlias = RuleContent_546_Arg
class Variation_115(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_546

    @classmethod
    def create(cls, arg : Variation_115_Arg) -> "Variation_115":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_546:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_546:
        return self.rule.content

RuleVariation_115_Arg: TypeAlias = Variation_115_Arg
class RuleVariation_115(RuleVariationContextFree):
    cv_variation = Variation_115

    @classmethod
    def create(cls, arg : RuleVariation_115_Arg) -> "RuleVariation_115":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_115:
        return self.arg # type: ignore

Content_244_Arg: TypeAlias = int
class Content_244(ContentTable):
    cv_values = {0: "Instrument Flight Rules", 1: "Visual Flight rules", 2: "Not applicable", 3: "Controlled Visual Flight Rules"}

RuleContent_244_Arg: TypeAlias = Content_244_Arg
class RuleContent_244(RuleContentContextFree):
    cv_content = Content_244

    @property
    def content(self) -> Content_244:
        return self._get_content() # type: ignore

Variation_589_Arg: TypeAlias = RuleContent_244_Arg
class Variation_589(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_244

    @classmethod
    def create(cls, arg : Variation_589_Arg) -> "Variation_589":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_244:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_244:
        return self.rule.content

RuleVariation_578_Arg: TypeAlias = Variation_589_Arg
class RuleVariation_578(RuleVariationContextFree):
    cv_variation = Variation_589

    @classmethod
    def create(cls, arg : RuleVariation_578_Arg) -> "RuleVariation_578":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_589:
        return self.arg # type: ignore

Content_539_Arg: TypeAlias = int
class Content_539(ContentTable):
    cv_values = {0: "Unknown", 1: "Approved", 2: "Exempt", 3: "Not Approved"}

RuleContent_539_Arg: TypeAlias = Content_539_Arg
class RuleContent_539(RuleContentContextFree):
    cv_content = Content_539

    @property
    def content(self) -> Content_539:
        return self._get_content() # type: ignore

Variation_766_Arg: TypeAlias = RuleContent_539_Arg
class Variation_766(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_539

    @classmethod
    def create(cls, arg : Variation_766_Arg) -> "Variation_766":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_539:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_539:
        return self.rule.content

RuleVariation_755_Arg: TypeAlias = Variation_766_Arg
class RuleVariation_755(RuleVariationContextFree):
    cv_variation = Variation_766

    @classmethod
    def create(cls, arg : RuleVariation_755_Arg) -> "RuleVariation_755":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_766:
        return self.arg # type: ignore

Content_381_Arg: TypeAlias = int
class Content_381(ContentTable):
    cv_values = {0: "Normal Priority Flight", 1: "High Priority Flight"}

RuleContent_381_Arg: TypeAlias = Content_381_Arg
class RuleContent_381(RuleContentContextFree):
    cv_content = Content_381

    @property
    def content(self) -> Content_381:
        return self._get_content() # type: ignore

Variation_939_Arg: TypeAlias = RuleContent_381_Arg
class Variation_939(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_381

    @classmethod
    def create(cls, arg : Variation_939_Arg) -> "Variation_939":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_381:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_381:
        return self.rule.content

RuleVariation_909_Arg: TypeAlias = Variation_939_Arg
class RuleVariation_909(RuleVariationContextFree):
    cv_variation = Variation_939

    @classmethod
    def create(cls, arg : RuleVariation_909_Arg) -> "RuleVariation_909":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_939:
        return self.arg # type: ignore

Content_261_Arg: TypeAlias = int
class Content_261(ContentTable):
    cv_values = {0: "Maintaining", 1: "Climbing", 2: "Descending", 3: "Invalid"}

RuleContent_261_Arg: TypeAlias = Content_261_Arg
class RuleContent_261(RuleContentContextFree):
    cv_content = Content_261

    @property
    def content(self) -> Content_261:
        return self._get_content() # type: ignore

Variation_103_Arg: TypeAlias = RuleContent_261_Arg
class Variation_103(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_261

    @classmethod
    def create(cls, arg : Variation_103_Arg) -> "Variation_103":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_261:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_261:
        return self.rule.content

RuleVariation_103_Arg: TypeAlias = Variation_103_Arg
class RuleVariation_103(RuleVariationContextFree):
    cv_variation = Variation_103

    @classmethod
    def create(cls, arg : RuleVariation_103_Arg) -> "RuleVariation_103":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_103:
        return self.arg # type: ignore

Content_376_Arg: TypeAlias = int
class Content_376(ContentTable):
    cv_values = {0: "Non primary target", 1: "Primary target"}

RuleContent_376_Arg: TypeAlias = Content_376_Arg
class RuleContent_376(RuleContentContextFree):
    cv_content = Content_376

    @property
    def content(self) -> Content_376:
        return self._get_content() # type: ignore

Variation_562_Arg: TypeAlias = RuleContent_376_Arg
class Variation_562(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_376

    @classmethod
    def create(cls, arg : Variation_562_Arg) -> "Variation_562":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_376:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_376:
        return self.rule.content

RuleVariation_551_Arg: TypeAlias = Variation_562_Arg
class RuleVariation_551(RuleVariationContextFree):
    cv_variation = Variation_562

    @classmethod
    def create(cls, arg : RuleVariation_551_Arg) -> "RuleVariation_551":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_562:
        return self.arg # type: ignore

Content_100_Arg: TypeAlias = int
class Content_100(ContentTable):
    cv_values = {0: "Default", 1: "Ground Vehicle"}

RuleContent_100_Arg: TypeAlias = Content_100_Arg
class RuleContent_100(RuleContentContextFree):
    cv_content = Content_100

    @property
    def content(self) -> Content_100:
        return self._get_content() # type: ignore

Variation_619_Arg: TypeAlias = RuleContent_100_Arg
class Variation_619(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_100

    @classmethod
    def create(cls, arg : Variation_619_Arg) -> "Variation_619":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_100:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_100:
        return self.rule.content

RuleVariation_608_Arg: TypeAlias = Variation_619_Arg
class RuleVariation_608(RuleVariationContextFree):
    cv_variation = Variation_619

    @classmethod
    def create(cls, arg : RuleVariation_608_Arg) -> "RuleVariation_608":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_619:
        return self.arg # type: ignore

NonSpare_1018_Arg: TypeAlias = RuleVariation_115_Arg
class NonSpare_1018(NonSpare):
    cv_name = "GATOAT"
    cv_title = "Identification of Conflict Categories Definition Table"
    cv_rule = RuleVariation_115

    @classmethod
    def create(cls, arg : NonSpare_1018_Arg) -> "NonSpare_1018":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_115:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_115:
        return self.rule.variation

Item_362_Arg: TypeAlias = NonSpare_1018_Arg
class Item_362(Item):
    cv_non_spare = NonSpare_1018

    @classmethod
    def create(cls, arg : Item_362_Arg) -> "Item_362":
        return cls._create(arg) # type: ignore

NonSpare_987_Arg: TypeAlias = RuleVariation_578_Arg
class NonSpare_987(NonSpare):
    cv_name = "FR1FR2"
    cv_title = "Flight Rules"
    cv_rule = RuleVariation_578

    @classmethod
    def create(cls, arg : NonSpare_987_Arg) -> "NonSpare_987":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_578:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_589:
        return self.rule.variation

Item_342_Arg: TypeAlias = NonSpare_987_Arg
class Item_342(Item):
    cv_non_spare = NonSpare_987

    @classmethod
    def create(cls, arg : Item_342_Arg) -> "Item_342":
        return cls._create(arg) # type: ignore

NonSpare_1628_Arg: TypeAlias = RuleVariation_755_Arg
class NonSpare_1628(NonSpare):
    cv_name = "RVSM"
    cv_title = ""
    cv_rule = RuleVariation_755

    @classmethod
    def create(cls, arg : NonSpare_1628_Arg) -> "NonSpare_1628":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_755:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_766:
        return self.rule.variation

Item_839_Arg: TypeAlias = NonSpare_1628_Arg
class Item_839(Item):
    cv_non_spare = NonSpare_1628

    @classmethod
    def create(cls, arg : Item_839_Arg) -> "Item_839":
        return cls._create(arg) # type: ignore

NonSpare_1069_Arg: TypeAlias = RuleVariation_909_Arg
class NonSpare_1069(NonSpare):
    cv_name = "HPR"
    cv_title = ""
    cv_rule = RuleVariation_909

    @classmethod
    def create(cls, arg : NonSpare_1069_Arg) -> "NonSpare_1069":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_909:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_939:
        return self.rule.variation

Item_399_Arg: TypeAlias = NonSpare_1069_Arg
class Item_399(Item):
    cv_non_spare = NonSpare_1069

    @classmethod
    def create(cls, arg : Item_399_Arg) -> "Item_399":
        return cls._create(arg) # type: ignore

NonSpare_709_Arg: TypeAlias = RuleVariation_103_Arg
class NonSpare_709(NonSpare):
    cv_name = "CDM"
    cv_title = "Climbing/Descending Mode"
    cv_rule = RuleVariation_103

    @classmethod
    def create(cls, arg : NonSpare_709_Arg) -> "NonSpare_709":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_103:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_103:
        return self.rule.variation

Item_141_Arg: TypeAlias = NonSpare_709_Arg
class Item_141(Item):
    cv_non_spare = NonSpare_709

    @classmethod
    def create(cls, arg : Item_141_Arg) -> "Item_141":
        return cls._create(arg) # type: ignore

NonSpare_1455_Arg: TypeAlias = RuleVariation_551_Arg
class NonSpare_1455(NonSpare):
    cv_name = "PRI"
    cv_title = ""
    cv_rule = RuleVariation_551

    @classmethod
    def create(cls, arg : NonSpare_1455_Arg) -> "NonSpare_1455":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_551:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_562:
        return self.rule.variation

Item_704_Arg: TypeAlias = NonSpare_1455_Arg
class Item_704(Item):
    cv_non_spare = NonSpare_1455

    @classmethod
    def create(cls, arg : Item_704_Arg) -> "Item_704":
        return cls._create(arg) # type: ignore

NonSpare_1038_Arg: TypeAlias = RuleVariation_608_Arg
class NonSpare_1038(NonSpare):
    cv_name = "GV"
    cv_title = ""
    cv_rule = RuleVariation_608

    @classmethod
    def create(cls, arg : NonSpare_1038_Arg) -> "NonSpare_1038":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_608:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_619:
        return self.rule.variation

Item_377_Arg: TypeAlias = NonSpare_1038_Arg
class Item_377(Item):
    cv_non_spare = NonSpare_1038

    @classmethod
    def create(cls, arg : Item_377_Arg) -> "Item_377":
        return cls._create(arg) # type: ignore

Item_21_Arg: TypeAlias = int
class Item_21(Spare):
    cv_bit_offset8 = 4
    cv_bit_size = 3

Variation_1354_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_115_Arg, Tuple[Literal["GATOAT"], RuleVariation_115_Arg]], Union[RuleVariation_578_Arg, Tuple[Literal["FR1FR2"], RuleVariation_578_Arg]], Union[RuleVariation_755_Arg, Tuple[Literal["RVSM"], RuleVariation_755_Arg]], Union[RuleVariation_909_Arg, Tuple[Literal["HPR"], RuleVariation_909_Arg]], None]]
Variation_1354_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_103_Arg, Tuple[Literal["CDM"], RuleVariation_103_Arg]], Union[RuleVariation_551_Arg, Tuple[Literal["PRI"], RuleVariation_551_Arg]], Union[RuleVariation_608_Arg, Tuple[Literal["GV"], RuleVariation_608_Arg]], int, None]]
Variation_1354_Arg: TypeAlias = Union[
    Tuple[Variation_1354_Arg_Group_1],
    Tuple[Variation_1354_Arg_Group_1, Variation_1354_Arg_Group_2],
]
class Variation_1354(Extended):
    cv_items_list = [[(Item_362, 2), (Item_342, 2), (Item_839, 2), (Item_399, 1), None], [(Item_141, 2), (Item_704, 1), (Item_377, 1), (Item_21, 3), None]]

    @classmethod
    def create(cls, arg : Variation_1354_Arg) -> 'Variation_1354':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["GATOAT"]) -> RuleVariation_115:
        ...
    @overload
    def get_item(self, key : Literal["FR1FR2"]) -> RuleVariation_578:
        ...
    @overload
    def get_item(self, key : Literal["RVSM"]) -> RuleVariation_755:
        ...
    @overload
    def get_item(self, key : Literal["HPR"]) -> RuleVariation_909:
        ...
    @overload
    def get_item(self, key : Literal["CDM"]) -> Optional[RuleVariation_103]:
        ...
    @overload
    def get_item(self, key : Literal["PRI"]) -> Optional[RuleVariation_551]:
        ...
    @overload
    def get_item(self, key : Literal["GV"]) -> Optional[RuleVariation_608]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1277_Arg: TypeAlias = Variation_1354_Arg
class RuleVariation_1277(RuleVariationContextFree):
    cv_variation = Variation_1354

    @classmethod
    def create(cls, arg : RuleVariation_1277_Arg) -> "RuleVariation_1277":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1354:
        return self.arg # type: ignore

NonSpare_553_Arg: TypeAlias = RuleVariation_1277_Arg
class NonSpare_553(NonSpare):
    cv_name = "AC1"
    cv_title = "Characteristics of Aircraft 1 Involved in the Conflict"
    cv_rule = RuleVariation_1277

    @classmethod
    def create(cls, arg : NonSpare_553_Arg) -> "NonSpare_553":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1277:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1354:
        return self.rule.variation

Variation_388_Arg: TypeAlias = RuleContent_606_Arg
class Variation_388(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_rule = RuleContent_606

    @classmethod
    def create(cls, arg : Variation_388_Arg) -> "Variation_388":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_606:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_606:
        return self.rule.content

RuleVariation_380_Arg: TypeAlias = Variation_388_Arg
class RuleVariation_380(RuleVariationContextFree):
    cv_variation = Variation_388

    @classmethod
    def create(cls, arg : RuleVariation_380_Arg) -> "RuleVariation_380":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_388:
        return self.arg # type: ignore

NonSpare_1312_Arg: TypeAlias = RuleVariation_380_Arg
class NonSpare_1312(NonSpare):
    cv_name = "MS1"
    cv_title = "Aircraft Identification Downloaded from Aircraft 1 Involved in the Conflict If Equipped with a Mode-S Transponder"
    cv_rule = RuleVariation_380

    @classmethod
    def create(cls, arg : NonSpare_1312_Arg) -> "NonSpare_1312":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_380:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_388:
        return self.rule.variation

Item_4_Arg: TypeAlias = int
class Item_4(Spare):
    cv_bit_offset8 = 0
    cv_bit_size = 5

Content_707_Arg: TypeAlias = Union[int, float, Tuple[float, Literal[""]]]
class Content_707(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = ""

    def as_quantity(self, cv_unit : Optional[Literal[""]] = None) -> float:
        return self._as_quantity()

RuleContent_707_Arg: TypeAlias = Content_707_Arg
class RuleContent_707(RuleContentContextFree):
    cv_content = Content_707

    @property
    def content(self) -> Content_707:
        return self._get_content() # type: ignore

Variation_895_Arg: TypeAlias = RuleContent_707_Arg
class Variation_895(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 27
    cv_rule = RuleContent_707

    @classmethod
    def create(cls, arg : Variation_895_Arg) -> "Variation_895":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_707:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_707:
        return self.rule.content

RuleVariation_865_Arg: TypeAlias = Variation_895_Arg
class RuleVariation_865(RuleVariationContextFree):
    cv_variation = Variation_895

    @classmethod
    def create(cls, arg : RuleVariation_865_Arg) -> "RuleVariation_865":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_895:
        return self.arg # type: ignore

NonSpare_1343_Arg: TypeAlias = RuleVariation_865_Arg
class NonSpare_1343(NonSpare):
    cv_name = "NBR"
    cv_title = ""
    cv_rule = RuleVariation_865

    @classmethod
    def create(cls, arg : NonSpare_1343_Arg) -> "NonSpare_1343":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_865:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_895:
        return self.rule.variation

Item_609_Arg: TypeAlias = NonSpare_1343_Arg
class Item_609(Item):
    cv_non_spare = NonSpare_1343

    @classmethod
    def create(cls, arg : Item_609_Arg) -> "Item_609":
        return cls._create(arg) # type: ignore

Variation_1035_Arg_Group = Tuple[int, Union[RuleVariation_865_Arg, Tuple[Literal["NBR"], RuleVariation_865_Arg]]]
Variation_1035_Arg: TypeAlias = Union[int, Variation_1035_Arg_Group]
class Variation_1035(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_4, 5), (Item_609, 27)]
    cv_items_dict = {"NBR": RuleVariation_865}

    @classmethod
    def spec(cls, key : Literal["NBR"]) -> RuleVariation_865:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["NBR"]) -> RuleVariation_865:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1035_Arg) -> 'Variation_1035':
        return cls._create(arg) # type: ignore

RuleVariation_1003_Arg: TypeAlias = Variation_1035_Arg
class RuleVariation_1003(RuleVariationContextFree):
    cv_variation = Variation_1035

    @classmethod
    def create(cls, arg : RuleVariation_1003_Arg) -> "RuleVariation_1003":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1035:
        return self.arg # type: ignore

NonSpare_978_Arg: TypeAlias = RuleVariation_1003_Arg
class NonSpare_978(NonSpare):
    cv_name = "FP1"
    cv_title = "Number of the Flight Plan Correlated to Aircraft 1 Involved in the Conflict"
    cv_rule = RuleVariation_1003

    @classmethod
    def create(cls, arg : NonSpare_978_Arg) -> "NonSpare_978":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1003:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1035:
        return self.rule.variation

Content_749_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["FL"]]]
class Content_749(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.25
    cv_unit = "FL"

    def as_quantity(self, cv_unit : Optional[Literal["FL"]] = None) -> float:
        return self._as_quantity()

RuleContent_748_Arg: TypeAlias = Content_749_Arg
class RuleContent_748(RuleContentContextFree):
    cv_content = Content_749

    @property
    def content(self) -> Content_749:
        return self._get_content() # type: ignore

Variation_319_Arg: TypeAlias = RuleContent_748_Arg
class Variation_319(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_748

    @classmethod
    def create(cls, arg : Variation_319_Arg) -> "Variation_319":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_748:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_749:
        return self.rule.content

RuleVariation_312_Arg: TypeAlias = Variation_319_Arg
class RuleVariation_312(RuleVariationContextFree):
    cv_variation = Variation_319

    @classmethod
    def create(cls, arg : RuleVariation_312_Arg) -> "RuleVariation_312":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_319:
        return self.arg # type: ignore

NonSpare_718_Arg: TypeAlias = RuleVariation_312_Arg
class NonSpare_718(NonSpare):
    cv_name = "CF1"
    cv_title = "Cleared Flight Level for Aircraft 1 Involved in the Conflict"
    cv_rule = RuleVariation_312

    @classmethod
    def create(cls, arg : NonSpare_718_Arg) -> "NonSpare_718":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_312:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_319:
        return self.rule.variation

Variation_1460_Arg = TypedDict('Variation_1460_Arg', {
    "AI1": NonSpare_581_Arg,
    "M31": NonSpare_1204_Arg,
    "CPW": NonSpare_816_Arg,
    "CPC": NonSpare_811_Arg,
    "TT1": NonSpare_1935_Arg,
    "DT1": NonSpare_897_Arg,
    "AC1": NonSpare_553_Arg,
    "MS1": NonSpare_1312_Arg,
    "FP1": NonSpare_978_Arg,
    "CF1": NonSpare_718_Arg,
}, total=False)
class Variation_1460(Compound):
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_581, NonSpare_1204, NonSpare_816, NonSpare_811, NonSpare_1935, NonSpare_897, NonSpare_553, NonSpare_1312, NonSpare_978, NonSpare_718]
    cv_items_dict = {"AI1": NonSpare_581, "M31": NonSpare_1204, "CPW": NonSpare_816, "CPC": NonSpare_811, "TT1": NonSpare_1935, "DT1": NonSpare_897, "AC1": NonSpare_553, "MS1": NonSpare_1312, "FP1": NonSpare_978, "CF1": NonSpare_718}

    @overload
    @classmethod
    def spec(cls, key : Literal["AI1"]) -> NonSpare_581:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M31"]) -> NonSpare_1204:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPW"]) -> NonSpare_816:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPC"]) -> NonSpare_811:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TT1"]) -> NonSpare_1935:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DT1"]) -> NonSpare_897:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AC1"]) -> NonSpare_553:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MS1"]) -> NonSpare_1312:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FP1"]) -> NonSpare_978:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CF1"]) -> NonSpare_718:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AI1"], Literal["M31"], Literal["CPW"], Literal["CPC"], Literal["TT1"], Literal["DT1"], Literal["AC1"], Literal["MS1"], Literal["FP1"], Literal["CF1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AI1"]) -> Optional[NonSpare_581]:
        ...
    @overload
    def get_item(self, key : Literal["M31"]) -> Optional[NonSpare_1204]:
        ...
    @overload
    def get_item(self, key : Literal["CPW"]) -> Optional[NonSpare_816]:
        ...
    @overload
    def get_item(self, key : Literal["CPC"]) -> Optional[NonSpare_811]:
        ...
    @overload
    def get_item(self, key : Literal["TT1"]) -> Optional[NonSpare_1935]:
        ...
    @overload
    def get_item(self, key : Literal["DT1"]) -> Optional[NonSpare_897]:
        ...
    @overload
    def get_item(self, key : Literal["AC1"]) -> Optional[NonSpare_553]:
        ...
    @overload
    def get_item(self, key : Literal["MS1"]) -> Optional[NonSpare_1312]:
        ...
    @overload
    def get_item(self, key : Literal["FP1"]) -> Optional[NonSpare_978]:
        ...
    @overload
    def get_item(self, key : Literal["CF1"]) -> Optional[NonSpare_718]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["AI1"], val : NonSpare_581_Arg) -> "Variation_1460":
        ...
    @overload
    def set_item(self, key : Literal["M31"], val : NonSpare_1204_Arg) -> "Variation_1460":
        ...
    @overload
    def set_item(self, key : Literal["CPW"], val : NonSpare_816_Arg) -> "Variation_1460":
        ...
    @overload
    def set_item(self, key : Literal["CPC"], val : NonSpare_811_Arg) -> "Variation_1460":
        ...
    @overload
    def set_item(self, key : Literal["TT1"], val : NonSpare_1935_Arg) -> "Variation_1460":
        ...
    @overload
    def set_item(self, key : Literal["DT1"], val : NonSpare_897_Arg) -> "Variation_1460":
        ...
    @overload
    def set_item(self, key : Literal["AC1"], val : NonSpare_553_Arg) -> "Variation_1460":
        ...
    @overload
    def set_item(self, key : Literal["MS1"], val : NonSpare_1312_Arg) -> "Variation_1460":
        ...
    @overload
    def set_item(self, key : Literal["FP1"], val : NonSpare_978_Arg) -> "Variation_1460":
        ...
    @overload
    def set_item(self, key : Literal["CF1"], val : NonSpare_718_Arg) -> "Variation_1460":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["AI1"]) -> "Variation_1460":
        ...
    @overload
    def del_item(self, key : Literal["M31"]) -> "Variation_1460":
        ...
    @overload
    def del_item(self, key : Literal["CPW"]) -> "Variation_1460":
        ...
    @overload
    def del_item(self, key : Literal["CPC"]) -> "Variation_1460":
        ...
    @overload
    def del_item(self, key : Literal["TT1"]) -> "Variation_1460":
        ...
    @overload
    def del_item(self, key : Literal["DT1"]) -> "Variation_1460":
        ...
    @overload
    def del_item(self, key : Literal["AC1"]) -> "Variation_1460":
        ...
    @overload
    def del_item(self, key : Literal["MS1"]) -> "Variation_1460":
        ...
    @overload
    def del_item(self, key : Literal["FP1"]) -> "Variation_1460":
        ...
    @overload
    def del_item(self, key : Literal["CF1"]) -> "Variation_1460":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1460_Arg) -> 'Variation_1460':
        return cls._create(arg) # type: ignore

RuleVariation_1383_Arg: TypeAlias = Variation_1460_Arg
class RuleVariation_1383(RuleVariationContextFree):
    cv_variation = Variation_1460

    @classmethod
    def create(cls, arg : RuleVariation_1383_Arg) -> "RuleVariation_1383":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1460:
        return self.arg # type: ignore

NonSpare_365_Arg: TypeAlias = RuleVariation_1383_Arg
class NonSpare_365(NonSpare):
    cv_name = "170"
    cv_title = "Aircraft Identification and Characteristics 1"
    cv_rule = RuleVariation_1383

    @classmethod
    def create(cls, arg : NonSpare_365_Arg) -> "NonSpare_365":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1460:
        return self.rule.variation

class UapItem_365(UapItem):
    cv_non_spare = NonSpare_365

Content_66_Arg: TypeAlias = int
class Content_66(ContentTable):
    cv_values = {0: "Conflict not predicted to occur in military airspace", 1: "Conflict predicted to occur in military airspace"}

RuleContent_66_Arg: TypeAlias = Content_66_Arg
class RuleContent_66(RuleContentContextFree):
    cv_content = Content_66

    @property
    def content(self) -> Content_66:
        return self._get_content() # type: ignore

Variation_20_Arg: TypeAlias = RuleContent_66_Arg
class Variation_20(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_66

    @classmethod
    def create(cls, arg : Variation_20_Arg) -> "Variation_20":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_66:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_66:
        return self.rule.content

RuleVariation_20_Arg: TypeAlias = Variation_20_Arg
class RuleVariation_20(RuleVariationContextFree):
    cv_variation = Variation_20

    @classmethod
    def create(cls, arg : RuleVariation_20_Arg) -> "RuleVariation_20":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_20:
        return self.arg # type: ignore

Content_65_Arg: TypeAlias = int
class Content_65(ContentTable):
    cv_values = {0: "Conflict not predicted to occur in civil airspace", 1: "Conflict predicted to occur in civil airspace"}

RuleContent_65_Arg: TypeAlias = Content_65_Arg
class RuleContent_65(RuleContentContextFree):
    cv_content = Content_65

    @property
    def content(self) -> Content_65:
        return self._get_content() # type: ignore

Variation_402_Arg: TypeAlias = RuleContent_65_Arg
class Variation_402(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_65

    @classmethod
    def create(cls, arg : Variation_402_Arg) -> "Variation_402":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_65:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_65:
        return self.rule.content

RuleVariation_391_Arg: TypeAlias = Variation_402_Arg
class RuleVariation_391(RuleVariationContextFree):
    cv_variation = Variation_402

    @classmethod
    def create(cls, arg : RuleVariation_391_Arg) -> "RuleVariation_391":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_402:
        return self.arg # type: ignore

Content_25_Arg: TypeAlias = int
class Content_25(ContentTable):
    cv_values = {0: "Aircraft are not fast diverging laterally at current time", 1: "Aircraft are fast diverging laterally at current time"}

RuleContent_25_Arg: TypeAlias = Content_25_Arg
class RuleContent_25(RuleContentContextFree):
    cv_content = Content_25

    @property
    def content(self) -> Content_25:
        return self._get_content() # type: ignore

Variation_506_Arg: TypeAlias = RuleContent_25_Arg
class Variation_506(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_25

    @classmethod
    def create(cls, arg : Variation_506_Arg) -> "Variation_506":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_25:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_25:
        return self.rule.content

RuleVariation_495_Arg: TypeAlias = Variation_506_Arg
class RuleVariation_495(RuleVariationContextFree):
    cv_variation = Variation_506

    @classmethod
    def create(cls, arg : RuleVariation_495_Arg) -> "RuleVariation_495":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_506:
        return self.arg # type: ignore

Content_26_Arg: TypeAlias = int
class Content_26(ContentTable):
    cv_values = {0: "Aircraft are not fast diverging vertically at current time", 1: "Aircraft are fast diverging vertically at current time"}

RuleContent_26_Arg: TypeAlias = Content_26_Arg
class RuleContent_26(RuleContentContextFree):
    cv_content = Content_26

    @property
    def content(self) -> Content_26:
        return self._get_content() # type: ignore

Variation_613_Arg: TypeAlias = RuleContent_26_Arg
class Variation_613(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_26

    @classmethod
    def create(cls, arg : Variation_613_Arg) -> "Variation_613":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_26:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_26:
        return self.rule.content

RuleVariation_602_Arg: TypeAlias = Variation_613_Arg
class RuleVariation_602(RuleVariationContextFree):
    cv_variation = Variation_613

    @classmethod
    def create(cls, arg : RuleVariation_602_Arg) -> "RuleVariation_602":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_613:
        return self.arg # type: ignore

Content_268_Arg: TypeAlias = int
class Content_268(ContentTable):
    cv_values = {0: "Minor separation infringement", 1: "Major separation infringement"}

RuleContent_268_Arg: TypeAlias = Content_268_Arg
class RuleContent_268(RuleContentContextFree):
    cv_content = Content_268

    @property
    def content(self) -> Content_268:
        return self._get_content() # type: ignore

Variation_729_Arg: TypeAlias = RuleContent_268_Arg
class Variation_729(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_268

    @classmethod
    def create(cls, arg : Variation_729_Arg) -> "Variation_729":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_268:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_268:
        return self.rule.content

RuleVariation_718_Arg: TypeAlias = Variation_729_Arg
class RuleVariation_718(RuleVariationContextFree):
    cv_variation = Variation_729

    @classmethod
    def create(cls, arg : RuleVariation_718_Arg) -> "RuleVariation_718":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_729:
        return self.arg # type: ignore

Content_28_Arg: TypeAlias = int
class Content_28(ContentTable):
    cv_values = {0: "Aircraft have not crossed at starting time of conflict", 1: "Aircraft have crossed at starting time of conflict"}

RuleContent_28_Arg: TypeAlias = Content_28_Arg
class RuleContent_28(RuleContentContextFree):
    cv_content = Content_28

    @property
    def content(self) -> Content_28:
        return self._get_content() # type: ignore

Variation_818_Arg: TypeAlias = RuleContent_28_Arg
class Variation_818(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_28

    @classmethod
    def create(cls, arg : Variation_818_Arg) -> "Variation_818":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_28:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_28:
        return self.rule.content

RuleVariation_788_Arg: TypeAlias = Variation_818_Arg
class RuleVariation_788(RuleVariationContextFree):
    cv_variation = Variation_818

    @classmethod
    def create(cls, arg : RuleVariation_788_Arg) -> "RuleVariation_788":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_818:
        return self.arg # type: ignore

Content_24_Arg: TypeAlias = int
class Content_24(ContentTable):
    cv_values = {0: "Aircraft are not diverging at starting time of conflict", 1: "Aircraft are diverging at starting time of conflict"}

RuleContent_24_Arg: TypeAlias = Content_24_Arg
class RuleContent_24(RuleContentContextFree):
    cv_content = Content_24

    @property
    def content(self) -> Content_24:
        return self._get_content() # type: ignore

Variation_899_Arg: TypeAlias = RuleContent_24_Arg
class Variation_899(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_24

    @classmethod
    def create(cls, arg : Variation_899_Arg) -> "Variation_899":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_24:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_24:
        return self.rule.content

RuleVariation_869_Arg: TypeAlias = Variation_899_Arg
class RuleVariation_869(RuleVariationContextFree):
    cv_variation = Variation_899

    @classmethod
    def create(cls, arg : RuleVariation_869_Arg) -> "RuleVariation_869":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_899:
        return self.arg # type: ignore

Content_145_Arg: TypeAlias = int
class Content_145(ContentTable):
    cv_values = {0: "Default", 1: "Runway/Runway Crossing"}

RuleContent_145_Arg: TypeAlias = Content_145_Arg
class RuleContent_145(RuleContentContextFree):
    cv_content = Content_145

    @property
    def content(self) -> Content_145:
        return self._get_content() # type: ignore

Variation_34_Arg: TypeAlias = RuleContent_145_Arg
class Variation_34(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_145

    @classmethod
    def create(cls, arg : Variation_34_Arg) -> "Variation_34":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_145:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_145:
        return self.rule.content

RuleVariation_34_Arg: TypeAlias = Variation_34_Arg
class RuleVariation_34(RuleVariationContextFree):
    cv_variation = Variation_34

    @classmethod
    def create(cls, arg : RuleVariation_34_Arg) -> "RuleVariation_34":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_34:
        return self.arg # type: ignore

Content_146_Arg: TypeAlias = int
class Content_146(ContentTable):
    cv_values = {0: "Default", 1: "Runway/Taxiway Crossing"}

RuleContent_146_Arg: TypeAlias = Content_146_Arg
class RuleContent_146(RuleContentContextFree):
    cv_content = Content_146

    @property
    def content(self) -> Content_146:
        return self._get_content() # type: ignore

Variation_416_Arg: TypeAlias = RuleContent_146_Arg
class Variation_416(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_146

    @classmethod
    def create(cls, arg : Variation_416_Arg) -> "Variation_416":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_146:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_146:
        return self.rule.content

RuleVariation_405_Arg: TypeAlias = Variation_416_Arg
class RuleVariation_405(RuleVariationContextFree):
    cv_variation = Variation_416

    @classmethod
    def create(cls, arg : RuleVariation_405_Arg) -> "RuleVariation_405":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_416:
        return self.arg # type: ignore

Content_127_Arg: TypeAlias = int
class Content_127(ContentTable):
    cv_values = {0: "Default", 1: "Msg Type 4 (MSAW) indicates MRVA"}

RuleContent_127_Arg: TypeAlias = Content_127_Arg
class RuleContent_127(RuleContentContextFree):
    cv_content = Content_127

    @property
    def content(self) -> Content_127:
        return self._get_content() # type: ignore

Variation_517_Arg: TypeAlias = RuleContent_127_Arg
class Variation_517(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_127

    @classmethod
    def create(cls, arg : Variation_517_Arg) -> "Variation_517":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_127:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_127:
        return self.rule.content

RuleVariation_506_Arg: TypeAlias = Variation_517_Arg
class RuleVariation_506(RuleVariationContextFree):
    cv_variation = Variation_517

    @classmethod
    def create(cls, arg : RuleVariation_506_Arg) -> "RuleVariation_506":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_517:
        return self.arg # type: ignore

Content_121_Arg: TypeAlias = int
class Content_121(ContentTable):
    cv_values = {0: "Default", 1: "Msg Type 25 (VRAM) indicates CRM"}

RuleContent_121_Arg: TypeAlias = Content_121_Arg
class RuleContent_121(RuleContentContextFree):
    cv_content = Content_121

    @property
    def content(self) -> Content_121:
        return self._get_content() # type: ignore

Variation_626_Arg: TypeAlias = RuleContent_121_Arg
class Variation_626(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_121

    @classmethod
    def create(cls, arg : Variation_626_Arg) -> "Variation_626":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_121:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_121:
        return self.rule.content

RuleVariation_615_Arg: TypeAlias = Variation_626_Arg
class RuleVariation_615(RuleVariationContextFree):
    cv_variation = Variation_626

    @classmethod
    def create(cls, arg : RuleVariation_615_Arg) -> "RuleVariation_615":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_626:
        return self.arg # type: ignore

Content_122_Arg: TypeAlias = int
class Content_122(ContentTable):
    cv_values = {0: "Default", 1: "Msg Type 25 (VRAM) indicates VRM"}

RuleContent_122_Arg: TypeAlias = Content_122_Arg
class RuleContent_122(RuleContentContextFree):
    cv_content = Content_122

    @property
    def content(self) -> Content_122:
        return self._get_content() # type: ignore

Variation_707_Arg: TypeAlias = RuleContent_122_Arg
class Variation_707(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_122

    @classmethod
    def create(cls, arg : Variation_707_Arg) -> "Variation_707":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_122:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_122:
        return self.rule.content

RuleVariation_696_Arg: TypeAlias = Variation_707_Arg
class RuleVariation_696(RuleVariationContextFree):
    cv_variation = Variation_707

    @classmethod
    def create(cls, arg : RuleVariation_696_Arg) -> "RuleVariation_696":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_707:
        return self.arg # type: ignore

Content_123_Arg: TypeAlias = int
class Content_123(ContentTable):
    cv_values = {0: "Default", 1: "Msg Type 25 (VRAM) indicates VTM"}

RuleContent_123_Arg: TypeAlias = Content_123_Arg
class RuleContent_123(RuleContentContextFree):
    cv_content = Content_123

    @property
    def content(self) -> Content_123:
        return self._get_content() # type: ignore

Variation_829_Arg: TypeAlias = RuleContent_123_Arg
class Variation_829(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_123

    @classmethod
    def create(cls, arg : Variation_829_Arg) -> "Variation_829":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_123:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_123:
        return self.rule.content

RuleVariation_799_Arg: TypeAlias = Variation_829_Arg
class RuleVariation_799(RuleVariationContextFree):
    cv_variation = Variation_829

    @classmethod
    def create(cls, arg : RuleVariation_799_Arg) -> "RuleVariation_799":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_829:
        return self.arg # type: ignore

Content_124_Arg: TypeAlias = int
class Content_124(ContentTable):
    cv_values = {0: "Default", 1: "Msg Type 29 (HAM) indicates HD"}

RuleContent_124_Arg: TypeAlias = Content_124_Arg
class RuleContent_124(RuleContentContextFree):
    cv_content = Content_124

    @property
    def content(self) -> Content_124:
        return self._get_content() # type: ignore

Variation_911_Arg: TypeAlias = RuleContent_124_Arg
class Variation_911(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_124

    @classmethod
    def create(cls, arg : Variation_911_Arg) -> "Variation_911":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_124:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_124:
        return self.rule.content

RuleVariation_881_Arg: TypeAlias = Variation_911_Arg
class RuleVariation_881(RuleVariationContextFree):
    cv_variation = Variation_911

    @classmethod
    def create(cls, arg : RuleVariation_881_Arg) -> "RuleVariation_881":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_911:
        return self.arg # type: ignore

Content_125_Arg: TypeAlias = int
class Content_125(ContentTable):
    cv_values = {0: "Default", 1: "Msg Type 29 (HAM) indicates RD"}

RuleContent_125_Arg: TypeAlias = Content_125_Arg
class RuleContent_125(RuleContentContextFree):
    cv_content = Content_125

    @property
    def content(self) -> Content_125:
        return self._get_content() # type: ignore

Variation_33_Arg: TypeAlias = RuleContent_125_Arg
class Variation_33(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_125

    @classmethod
    def create(cls, arg : Variation_33_Arg) -> "Variation_33":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_125:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_125:
        return self.rule.content

RuleVariation_33_Arg: TypeAlias = Variation_33_Arg
class RuleVariation_33(RuleVariationContextFree):
    cv_variation = Variation_33

    @classmethod
    def create(cls, arg : RuleVariation_33_Arg) -> "RuleVariation_33":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_33:
        return self.arg # type: ignore

Content_126_Arg: TypeAlias = int
class Content_126(ContentTable):
    cv_values = {0: "Default", 1: "Msg Type 29 (HAM) indicates VD"}

RuleContent_126_Arg: TypeAlias = Content_126_Arg
class RuleContent_126(RuleContentContextFree):
    cv_content = Content_126

    @property
    def content(self) -> Content_126:
        return self._get_content() # type: ignore

Variation_411_Arg: TypeAlias = RuleContent_126_Arg
class Variation_411(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_126

    @classmethod
    def create(cls, arg : Variation_411_Arg) -> "Variation_411":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_126:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_126:
        return self.rule.content

RuleVariation_400_Arg: TypeAlias = Variation_411_Arg
class RuleVariation_400(RuleVariationContextFree):
    cv_variation = Variation_411

    @classmethod
    def create(cls, arg : RuleVariation_400_Arg) -> "RuleVariation_400":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_411:
        return self.arg # type: ignore

Content_118_Arg: TypeAlias = int
class Content_118(ContentTable):
    cv_values = {0: "Default", 1: "Msg Type 20 (DBPSM) indicates ARR"}

RuleContent_118_Arg: TypeAlias = Content_118_Arg
class RuleContent_118(RuleContentContextFree):
    cv_content = Content_118

    @property
    def content(self) -> Content_118:
        return self._get_content() # type: ignore

Variation_516_Arg: TypeAlias = RuleContent_118_Arg
class Variation_516(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_118

    @classmethod
    def create(cls, arg : Variation_516_Arg) -> "Variation_516":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_118:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_118:
        return self.rule.content

RuleVariation_505_Arg: TypeAlias = Variation_516_Arg
class RuleVariation_505(RuleVariationContextFree):
    cv_variation = Variation_516

    @classmethod
    def create(cls, arg : RuleVariation_505_Arg) -> "RuleVariation_505":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_516:
        return self.arg # type: ignore

Content_119_Arg: TypeAlias = int
class Content_119(ContentTable):
    cv_values = {0: "Default", 1: "Msg Type 20 (DBPSM) indicates DEP"}

RuleContent_119_Arg: TypeAlias = Content_119_Arg
class RuleContent_119(RuleContentContextFree):
    cv_content = Content_119

    @property
    def content(self) -> Content_119:
        return self._get_content() # type: ignore

Variation_625_Arg: TypeAlias = RuleContent_119_Arg
class Variation_625(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_119

    @classmethod
    def create(cls, arg : Variation_625_Arg) -> "Variation_625":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_119:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_119:
        return self.rule.content

RuleVariation_614_Arg: TypeAlias = Variation_625_Arg
class RuleVariation_614(RuleVariationContextFree):
    cv_variation = Variation_625

    @classmethod
    def create(cls, arg : RuleVariation_614_Arg) -> "RuleVariation_614":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_625:
        return self.arg # type: ignore

Content_120_Arg: TypeAlias = int
class Content_120(ContentTable):
    cv_values = {0: "Default", 1: "Msg Type 20 (DBPSM) indicates above TL"}

RuleContent_120_Arg: TypeAlias = Content_120_Arg
class RuleContent_120(RuleContentContextFree):
    cv_content = Content_120

    @property
    def content(self) -> Content_120:
        return self._get_content() # type: ignore

Variation_706_Arg: TypeAlias = RuleContent_120_Arg
class Variation_706(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_120

    @classmethod
    def create(cls, arg : Variation_706_Arg) -> "Variation_706":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_120:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_120:
        return self.rule.content

RuleVariation_695_Arg: TypeAlias = Variation_706_Arg
class RuleVariation_695(RuleVariationContextFree):
    cv_variation = Variation_706

    @classmethod
    def create(cls, arg : RuleVariation_695_Arg) -> "RuleVariation_695":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_706:
        return self.arg # type: ignore

Content_128_Arg: TypeAlias = int
class Content_128(ContentTable):
    cv_values = {0: "Default", 1: "Msg Type 99 (AIW) indicates pAIW Alert"}

RuleContent_128_Arg: TypeAlias = Content_128_Arg
class RuleContent_128(RuleContentContextFree):
    cv_content = Content_128

    @property
    def content(self) -> Content_128:
        return self._get_content() # type: ignore

Variation_830_Arg: TypeAlias = RuleContent_128_Arg
class Variation_830(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_128

    @classmethod
    def create(cls, arg : Variation_830_Arg) -> "Variation_830":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_128:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_128:
        return self.rule.content

RuleVariation_800_Arg: TypeAlias = Variation_830_Arg
class RuleVariation_800(RuleVariationContextFree):
    cv_variation = Variation_830

    @classmethod
    def create(cls, arg : RuleVariation_800_Arg) -> "RuleVariation_800":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_830:
        return self.arg # type: ignore

NonSpare_1220_Arg: TypeAlias = RuleVariation_20_Arg
class NonSpare_1220(NonSpare):
    cv_name = "MAS"
    cv_title = "Conflict Location in Military Airspace"
    cv_rule = RuleVariation_20

    @classmethod
    def create(cls, arg : NonSpare_1220_Arg) -> "NonSpare_1220":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_20:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_20:
        return self.rule.variation

Item_525_Arg: TypeAlias = NonSpare_1220_Arg
class Item_525(Item):
    cv_non_spare = NonSpare_1220

    @classmethod
    def create(cls, arg : Item_525_Arg) -> "Item_525":
        return cls._create(arg) # type: ignore

NonSpare_699_Arg: TypeAlias = RuleVariation_391_Arg
class NonSpare_699(NonSpare):
    cv_name = "CAS"
    cv_title = "Conflict Location in Civil Airspace"
    cv_rule = RuleVariation_391

    @classmethod
    def create(cls, arg : NonSpare_699_Arg) -> "NonSpare_699":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_391:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_402:
        return self.rule.variation

Item_134_Arg: TypeAlias = NonSpare_699_Arg
class Item_134(Item):
    cv_non_spare = NonSpare_699

    @classmethod
    def create(cls, arg : Item_134_Arg) -> "Item_134":
        return cls._create(arg) # type: ignore

NonSpare_968_Arg: TypeAlias = RuleVariation_495_Arg
class NonSpare_968(NonSpare):
    cv_name = "FLD"
    cv_title = "Fast Lateral Divergence"
    cv_rule = RuleVariation_495

    @classmethod
    def create(cls, arg : NonSpare_968_Arg) -> "NonSpare_968":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_495:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_506:
        return self.rule.variation

Item_330_Arg: TypeAlias = NonSpare_968_Arg
class Item_330(Item):
    cv_non_spare = NonSpare_968

    @classmethod
    def create(cls, arg : Item_330_Arg) -> "Item_330":
        return cls._create(arg) # type: ignore

NonSpare_1000_Arg: TypeAlias = RuleVariation_602_Arg
class NonSpare_1000(NonSpare):
    cv_name = "FVD"
    cv_title = "Fast Vertical Divergence"
    cv_rule = RuleVariation_602

    @classmethod
    def create(cls, arg : NonSpare_1000_Arg) -> "NonSpare_1000":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_602:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_613:
        return self.rule.variation

Item_352_Arg: TypeAlias = NonSpare_1000_Arg
class Item_352(Item):
    cv_non_spare = NonSpare_1000

    @classmethod
    def create(cls, arg : Item_352_Arg) -> "Item_352":
        return cls._create(arg) # type: ignore

NonSpare_1966_Arg: TypeAlias = RuleVariation_718_Arg
class NonSpare_1966(NonSpare):
    cv_name = "TYPE"
    cv_title = "Type of Separation Infringement"
    cv_rule = RuleVariation_718

    @classmethod
    def create(cls, arg : NonSpare_1966_Arg) -> "NonSpare_1966":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_718:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_729:
        return self.rule.variation

Item_1085_Arg: TypeAlias = NonSpare_1966_Arg
class Item_1085(Item):
    cv_non_spare = NonSpare_1966

    @classmethod
    def create(cls, arg : Item_1085_Arg) -> "Item_1085":
        return cls._create(arg) # type: ignore

NonSpare_821_Arg: TypeAlias = RuleVariation_788_Arg
class NonSpare_821(NonSpare):
    cv_name = "CROSS"
    cv_title = "Crossing Test"
    cv_rule = RuleVariation_788

    @classmethod
    def create(cls, arg : NonSpare_821_Arg) -> "NonSpare_821":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_788:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_818:
        return self.rule.variation

Item_213_Arg: TypeAlias = NonSpare_821_Arg
class Item_213(Item):
    cv_non_spare = NonSpare_821

    @classmethod
    def create(cls, arg : Item_213_Arg) -> "Item_213":
        return cls._create(arg) # type: ignore

NonSpare_878_Arg: TypeAlias = RuleVariation_869_Arg
class NonSpare_878(NonSpare):
    cv_name = "DIV"
    cv_title = "Divergence Test"
    cv_rule = RuleVariation_869

    @classmethod
    def create(cls, arg : NonSpare_878_Arg) -> "NonSpare_878":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_869:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_899:
        return self.rule.variation

Item_261_Arg: TypeAlias = NonSpare_878_Arg
class Item_261(Item):
    cv_non_spare = NonSpare_878

    @classmethod
    def create(cls, arg : Item_261_Arg) -> "Item_261":
        return cls._create(arg) # type: ignore

NonSpare_1601_Arg: TypeAlias = RuleVariation_34_Arg
class NonSpare_1601(NonSpare):
    cv_name = "RRC"
    cv_title = "Runway/Runway Crossing in RIMCAS"
    cv_rule = RuleVariation_34

    @classmethod
    def create(cls, arg : NonSpare_1601_Arg) -> "NonSpare_1601":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_34:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_34:
        return self.rule.variation

Item_825_Arg: TypeAlias = NonSpare_1601_Arg
class Item_825(Item):
    cv_non_spare = NonSpare_1601

    @classmethod
    def create(cls, arg : Item_825_Arg) -> "Item_825":
        return cls._create(arg) # type: ignore

NonSpare_1623_Arg: TypeAlias = RuleVariation_405_Arg
class NonSpare_1623(NonSpare):
    cv_name = "RTC"
    cv_title = "Runway/Taxiway Crossing in RIMCAS"
    cv_rule = RuleVariation_405

    @classmethod
    def create(cls, arg : NonSpare_1623_Arg) -> "NonSpare_1623":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_405:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_416:
        return self.rule.variation

Item_835_Arg: TypeAlias = NonSpare_1623_Arg
class Item_835(Item):
    cv_non_spare = NonSpare_1623

    @classmethod
    def create(cls, arg : Item_835_Arg) -> "Item_835":
        return cls._create(arg) # type: ignore

NonSpare_1310_Arg: TypeAlias = RuleVariation_506_Arg
class NonSpare_1310(NonSpare):
    cv_name = "MRVA"
    cv_title = ""
    cv_rule = RuleVariation_506

    @classmethod
    def create(cls, arg : NonSpare_1310_Arg) -> "NonSpare_1310":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_506:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_517:
        return self.rule.variation

Item_582_Arg: TypeAlias = NonSpare_1310_Arg
class Item_582(Item):
    cv_non_spare = NonSpare_1310

    @classmethod
    def create(cls, arg : Item_582_Arg) -> "Item_582":
        return cls._create(arg) # type: ignore

NonSpare_2029_Arg: TypeAlias = RuleVariation_615_Arg
class NonSpare_2029(NonSpare):
    cv_name = "VRAMCRM"
    cv_title = ""
    cv_rule = RuleVariation_615

    @classmethod
    def create(cls, arg : NonSpare_2029_Arg) -> "NonSpare_2029":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_615:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_626:
        return self.rule.variation

Item_1144_Arg: TypeAlias = NonSpare_2029_Arg
class Item_1144(Item):
    cv_non_spare = NonSpare_2029

    @classmethod
    def create(cls, arg : Item_1144_Arg) -> "Item_1144":
        return cls._create(arg) # type: ignore

NonSpare_2031_Arg: TypeAlias = RuleVariation_696_Arg
class NonSpare_2031(NonSpare):
    cv_name = "VRAMVRM"
    cv_title = ""
    cv_rule = RuleVariation_696

    @classmethod
    def create(cls, arg : NonSpare_2031_Arg) -> "NonSpare_2031":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_696:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_707:
        return self.rule.variation

Item_1146_Arg: TypeAlias = NonSpare_2031_Arg
class Item_1146(Item):
    cv_non_spare = NonSpare_2031

    @classmethod
    def create(cls, arg : Item_1146_Arg) -> "Item_1146":
        return cls._create(arg) # type: ignore

NonSpare_2034_Arg: TypeAlias = RuleVariation_799_Arg
class NonSpare_2034(NonSpare):
    cv_name = "VRAMVTM"
    cv_title = ""
    cv_rule = RuleVariation_799

    @classmethod
    def create(cls, arg : NonSpare_2034_Arg) -> "NonSpare_2034":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_799:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_829:
        return self.rule.variation

Item_1149_Arg: TypeAlias = NonSpare_2034_Arg
class Item_1149(Item):
    cv_non_spare = NonSpare_2034

    @classmethod
    def create(cls, arg : Item_1149_Arg) -> "Item_1149":
        return cls._create(arg) # type: ignore

NonSpare_1047_Arg: TypeAlias = RuleVariation_881_Arg
class NonSpare_1047(NonSpare):
    cv_name = "HAMHD"
    cv_title = ""
    cv_rule = RuleVariation_881

    @classmethod
    def create(cls, arg : NonSpare_1047_Arg) -> "NonSpare_1047":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_881:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_911:
        return self.rule.variation

Item_381_Arg: TypeAlias = NonSpare_1047_Arg
class Item_381(Item):
    cv_non_spare = NonSpare_1047

    @classmethod
    def create(cls, arg : Item_381_Arg) -> "Item_381":
        return cls._create(arg) # type: ignore

NonSpare_1049_Arg: TypeAlias = RuleVariation_33_Arg
class NonSpare_1049(NonSpare):
    cv_name = "HAMRD"
    cv_title = ""
    cv_rule = RuleVariation_33

    @classmethod
    def create(cls, arg : NonSpare_1049_Arg) -> "NonSpare_1049":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_33:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_33:
        return self.rule.variation

Item_383_Arg: TypeAlias = NonSpare_1049_Arg
class Item_383(Item):
    cv_non_spare = NonSpare_1049

    @classmethod
    def create(cls, arg : Item_383_Arg) -> "Item_383":
        return cls._create(arg) # type: ignore

NonSpare_1051_Arg: TypeAlias = RuleVariation_400_Arg
class NonSpare_1051(NonSpare):
    cv_name = "HAMVD"
    cv_title = ""
    cv_rule = RuleVariation_400

    @classmethod
    def create(cls, arg : NonSpare_1051_Arg) -> "NonSpare_1051":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_400:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_411:
        return self.rule.variation

Item_385_Arg: TypeAlias = NonSpare_1051_Arg
class Item_385(Item):
    cv_non_spare = NonSpare_1051

    @classmethod
    def create(cls, arg : Item_385_Arg) -> "Item_385":
        return cls._create(arg) # type: ignore

NonSpare_858_Arg: TypeAlias = RuleVariation_505_Arg
class NonSpare_858(NonSpare):
    cv_name = "DBPSMARR"
    cv_title = ""
    cv_rule = RuleVariation_505

    @classmethod
    def create(cls, arg : NonSpare_858_Arg) -> "NonSpare_858":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_505:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_516:
        return self.rule.variation

Item_242_Arg: TypeAlias = NonSpare_858_Arg
class Item_242(Item):
    cv_non_spare = NonSpare_858

    @classmethod
    def create(cls, arg : Item_242_Arg) -> "Item_242":
        return cls._create(arg) # type: ignore

NonSpare_860_Arg: TypeAlias = RuleVariation_614_Arg
class NonSpare_860(NonSpare):
    cv_name = "DBPSMDEP"
    cv_title = ""
    cv_rule = RuleVariation_614

    @classmethod
    def create(cls, arg : NonSpare_860_Arg) -> "NonSpare_860":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_614:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_625:
        return self.rule.variation

Item_244_Arg: TypeAlias = NonSpare_860_Arg
class Item_244(Item):
    cv_non_spare = NonSpare_860

    @classmethod
    def create(cls, arg : Item_244_Arg) -> "Item_244":
        return cls._create(arg) # type: ignore

NonSpare_862_Arg: TypeAlias = RuleVariation_695_Arg
class NonSpare_862(NonSpare):
    cv_name = "DBPSMTL"
    cv_title = ""
    cv_rule = RuleVariation_695

    @classmethod
    def create(cls, arg : NonSpare_862_Arg) -> "NonSpare_862":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_695:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_706:
        return self.rule.variation

Item_246_Arg: TypeAlias = NonSpare_862_Arg
class Item_246(Item):
    cv_non_spare = NonSpare_862

    @classmethod
    def create(cls, arg : Item_246_Arg) -> "Item_246":
        return cls._create(arg) # type: ignore

NonSpare_585_Arg: TypeAlias = RuleVariation_800_Arg
class NonSpare_585(NonSpare):
    cv_name = "AIW"
    cv_title = ""
    cv_rule = RuleVariation_800

    @classmethod
    def create(cls, arg : NonSpare_585_Arg) -> "NonSpare_585":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_800:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_830:
        return self.rule.variation

Item_57_Arg: TypeAlias = NonSpare_585_Arg
class Item_57(Item):
    cv_non_spare = NonSpare_585

    @classmethod
    def create(cls, arg : Item_57_Arg) -> "Item_57":
        return cls._create(arg) # type: ignore

Item_26_Arg: TypeAlias = int
class Item_26(Spare):
    cv_bit_offset8 = 6
    cv_bit_size = 1

Variation_1356_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_20_Arg, Tuple[Literal["MAS"], RuleVariation_20_Arg]], Union[RuleVariation_391_Arg, Tuple[Literal["CAS"], RuleVariation_391_Arg]], Union[RuleVariation_495_Arg, Tuple[Literal["FLD"], RuleVariation_495_Arg]], Union[RuleVariation_602_Arg, Tuple[Literal["FVD"], RuleVariation_602_Arg]], Union[RuleVariation_718_Arg, Tuple[Literal["TYPE"], RuleVariation_718_Arg]], Union[RuleVariation_788_Arg, Tuple[Literal["CROSS"], RuleVariation_788_Arg]], Union[RuleVariation_869_Arg, Tuple[Literal["DIV"], RuleVariation_869_Arg]], None]]
Variation_1356_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_34_Arg, Tuple[Literal["RRC"], RuleVariation_34_Arg]], Union[RuleVariation_405_Arg, Tuple[Literal["RTC"], RuleVariation_405_Arg]], Union[RuleVariation_506_Arg, Tuple[Literal["MRVA"], RuleVariation_506_Arg]], Union[RuleVariation_615_Arg, Tuple[Literal["VRAMCRM"], RuleVariation_615_Arg]], Union[RuleVariation_696_Arg, Tuple[Literal["VRAMVRM"], RuleVariation_696_Arg]], Union[RuleVariation_799_Arg, Tuple[Literal["VRAMVTM"], RuleVariation_799_Arg]], Union[RuleVariation_881_Arg, Tuple[Literal["HAMHD"], RuleVariation_881_Arg]], None]]
Variation_1356_Arg_Group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_33_Arg, Tuple[Literal["HAMRD"], RuleVariation_33_Arg]], Union[RuleVariation_400_Arg, Tuple[Literal["HAMVD"], RuleVariation_400_Arg]], Union[RuleVariation_505_Arg, Tuple[Literal["DBPSMARR"], RuleVariation_505_Arg]], Union[RuleVariation_614_Arg, Tuple[Literal["DBPSMDEP"], RuleVariation_614_Arg]], Union[RuleVariation_695_Arg, Tuple[Literal["DBPSMTL"], RuleVariation_695_Arg]], Union[RuleVariation_800_Arg, Tuple[Literal["AIW"], RuleVariation_800_Arg]], int, None]]
Variation_1356_Arg: TypeAlias = Union[
    Tuple[Variation_1356_Arg_Group_1],
    Tuple[Variation_1356_Arg_Group_1, Variation_1356_Arg_Group_2],
    Tuple[Variation_1356_Arg_Group_1, Variation_1356_Arg_Group_2, Variation_1356_Arg_Group_3],
]
class Variation_1356(Extended):
    cv_items_list = [[(Item_525, 1), (Item_134, 1), (Item_330, 1), (Item_352, 1), (Item_1085, 1), (Item_213, 1), (Item_261, 1), None], [(Item_825, 1), (Item_835, 1), (Item_582, 1), (Item_1144, 1), (Item_1146, 1), (Item_1149, 1), (Item_381, 1), None], [(Item_383, 1), (Item_385, 1), (Item_242, 1), (Item_244, 1), (Item_246, 1), (Item_57, 1), (Item_26, 1), None]]

    @classmethod
    def create(cls, arg : Variation_1356_Arg) -> 'Variation_1356':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MAS"]) -> RuleVariation_20:
        ...
    @overload
    def get_item(self, key : Literal["CAS"]) -> RuleVariation_391:
        ...
    @overload
    def get_item(self, key : Literal["FLD"]) -> RuleVariation_495:
        ...
    @overload
    def get_item(self, key : Literal["FVD"]) -> RuleVariation_602:
        ...
    @overload
    def get_item(self, key : Literal["TYPE"]) -> RuleVariation_718:
        ...
    @overload
    def get_item(self, key : Literal["CROSS"]) -> RuleVariation_788:
        ...
    @overload
    def get_item(self, key : Literal["DIV"]) -> RuleVariation_869:
        ...
    @overload
    def get_item(self, key : Literal["RRC"]) -> Optional[RuleVariation_34]:
        ...
    @overload
    def get_item(self, key : Literal["RTC"]) -> Optional[RuleVariation_405]:
        ...
    @overload
    def get_item(self, key : Literal["MRVA"]) -> Optional[RuleVariation_506]:
        ...
    @overload
    def get_item(self, key : Literal["VRAMCRM"]) -> Optional[RuleVariation_615]:
        ...
    @overload
    def get_item(self, key : Literal["VRAMVRM"]) -> Optional[RuleVariation_696]:
        ...
    @overload
    def get_item(self, key : Literal["VRAMVTM"]) -> Optional[RuleVariation_799]:
        ...
    @overload
    def get_item(self, key : Literal["HAMHD"]) -> Optional[RuleVariation_881]:
        ...
    @overload
    def get_item(self, key : Literal["HAMRD"]) -> Optional[RuleVariation_33]:
        ...
    @overload
    def get_item(self, key : Literal["HAMVD"]) -> Optional[RuleVariation_400]:
        ...
    @overload
    def get_item(self, key : Literal["DBPSMARR"]) -> Optional[RuleVariation_505]:
        ...
    @overload
    def get_item(self, key : Literal["DBPSMDEP"]) -> Optional[RuleVariation_614]:
        ...
    @overload
    def get_item(self, key : Literal["DBPSMTL"]) -> Optional[RuleVariation_695]:
        ...
    @overload
    def get_item(self, key : Literal["AIW"]) -> Optional[RuleVariation_800]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1279_Arg: TypeAlias = Variation_1356_Arg
class RuleVariation_1279(RuleVariationContextFree):
    cv_variation = Variation_1356

    @classmethod
    def create(cls, arg : RuleVariation_1279_Arg) -> "RuleVariation_1279":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1356:
        return self.arg # type: ignore

NonSpare_739_Arg: TypeAlias = RuleVariation_1279_Arg
class NonSpare_739(NonSpare):
    cv_name = "CN"
    cv_title = "Conflict Nature"
    cv_rule = RuleVariation_1279

    @classmethod
    def create(cls, arg : NonSpare_739_Arg) -> "NonSpare_739":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1279:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1356:
        return self.rule.variation

Variation_131_Arg: TypeAlias = RuleContent_0_Arg
class Variation_131(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_131_Arg) -> "Variation_131":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_131_Arg: TypeAlias = Variation_131_Arg
class RuleVariation_131(RuleVariationContextFree):
    cv_variation = Variation_131

    @classmethod
    def create(cls, arg : RuleVariation_131_Arg) -> "RuleVariation_131":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_131:
        return self.arg # type: ignore

NonSpare_1854_Arg: TypeAlias = RuleVariation_131_Arg
class NonSpare_1854(NonSpare):
    cv_name = "TID"
    cv_title = "Identification of Conflict Categories Definition Table"
    cv_rule = RuleVariation_131

    @classmethod
    def create(cls, arg : NonSpare_1854_Arg) -> "NonSpare_1854":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_131:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_131:
        return self.rule.variation

Item_996_Arg: TypeAlias = NonSpare_1854_Arg
class Item_996(Item):
    cv_non_spare = NonSpare_1854

    @classmethod
    def create(cls, arg : Item_996_Arg) -> "Item_996":
        return cls._create(arg) # type: ignore

Content_11_Arg: TypeAlias = int
class Content_11(ContentTable):
    cv_values = {0: "APW Low Severity", 1: "APW Medium Severity", 2: "APW High Severity"}

RuleContent_11_Arg: TypeAlias = Content_11_Arg
class RuleContent_11(RuleContentContextFree):
    cv_content = Content_11

    @property
    def content(self) -> Content_11:
        return self._get_content() # type: ignore

Variation_774_Arg: TypeAlias = RuleContent_11_Arg
class Variation_774(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_11

    @classmethod
    def create(cls, arg : Variation_774_Arg) -> "Variation_774":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_11:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_11:
        return self.rule.content

Content_581_Arg: TypeAlias = int
class Content_581(ContentTable):
    cv_values = {1: "Major seperation infringement and not (crossed and diverging)", 2: "Minor seperation infringement and not (crossed and diverging)", 3: "Major seperation infringement and (crossed and diverging)", 4: "Minor seperation infringement and (crossed and diverging)"}

RuleContent_581_Arg: TypeAlias = Content_581_Arg
class RuleContent_581(RuleContentContextFree):
    cv_content = Content_581

    @property
    def content(self) -> Content_581:
        return self._get_content() # type: ignore

Variation_795_Arg: TypeAlias = RuleContent_581_Arg
class Variation_795(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_581

    @classmethod
    def create(cls, arg : Variation_795_Arg) -> "Variation_795":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_581:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_581:
        return self.rule.content

Content_211_Arg: TypeAlias = int
class Content_211(ContentTable):
    cv_values = {0: "Filter not set", 1: "Filter set"}

RuleContent_211_Arg: TypeAlias = Content_211_Arg
class RuleContent_211(RuleContentContextFree):
    cv_content = Content_211

    @property
    def content(self) -> Content_211:
        return self._get_content() # type: ignore

Variation_721_Arg: TypeAlias = RuleContent_211_Arg
class Variation_721(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_211

    @classmethod
    def create(cls, arg : Variation_721_Arg) -> "Variation_721":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_211:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_211:
        return self.rule.content

RuleVariation_710_Arg: TypeAlias = Variation_721_Arg
class RuleVariation_710(RuleVariationContextFree):
    cv_variation = Variation_721

    @classmethod
    def create(cls, arg : RuleVariation_710_Arg) -> "RuleVariation_710":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_721:
        return self.arg # type: ignore

NonSpare_1187_Arg: TypeAlias = RuleVariation_710_Arg
class NonSpare_1187(NonSpare):
    cv_name = "LPF"
    cv_title = "Linear Prediction Filter"
    cv_rule = RuleVariation_710

    @classmethod
    def create(cls, arg : NonSpare_1187_Arg) -> "NonSpare_1187":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_710:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_721:
        return self.rule.variation

Item_501_Arg: TypeAlias = NonSpare_1187_Arg
class Item_501(Item):
    cv_non_spare = NonSpare_1187

    @classmethod
    def create(cls, arg : Item_501_Arg) -> "Item_501":
        return cls._create(arg) # type: ignore

Variation_848_Arg: TypeAlias = RuleContent_211_Arg
class Variation_848(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_211

    @classmethod
    def create(cls, arg : Variation_848_Arg) -> "Variation_848":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_211:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_211:
        return self.rule.content

RuleVariation_818_Arg: TypeAlias = Variation_848_Arg
class RuleVariation_818(RuleVariationContextFree):
    cv_variation = Variation_848

    @classmethod
    def create(cls, arg : RuleVariation_818_Arg) -> "RuleVariation_818":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_848:
        return self.arg # type: ignore

NonSpare_812_Arg: TypeAlias = RuleVariation_818_Arg
class NonSpare_812(NonSpare):
    cv_name = "CPF"
    cv_title = "Current Proximity Filter"
    cv_rule = RuleVariation_818

    @classmethod
    def create(cls, arg : NonSpare_812_Arg) -> "NonSpare_812":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_818:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_848:
        return self.rule.variation

Item_207_Arg: TypeAlias = NonSpare_812_Arg
class Item_207(Item):
    cv_non_spare = NonSpare_812

    @classmethod
    def create(cls, arg : Item_207_Arg) -> "Item_207":
        return cls._create(arg) # type: ignore

Variation_924_Arg: TypeAlias = RuleContent_211_Arg
class Variation_924(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_211

    @classmethod
    def create(cls, arg : Variation_924_Arg) -> "Variation_924":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_211:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_211:
        return self.rule.content

RuleVariation_894_Arg: TypeAlias = Variation_924_Arg
class RuleVariation_894(RuleVariationContextFree):
    cv_variation = Variation_924

    @classmethod
    def create(cls, arg : RuleVariation_894_Arg) -> "RuleVariation_894":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_924:
        return self.arg # type: ignore

NonSpare_1269_Arg: TypeAlias = RuleVariation_894_Arg
class NonSpare_1269(NonSpare):
    cv_name = "MHF"
    cv_title = "Manoeuvre Hazard Filter"
    cv_rule = RuleVariation_894

    @classmethod
    def create(cls, arg : NonSpare_1269_Arg) -> "NonSpare_1269":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_894:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_924:
        return self.rule.variation

Item_545_Arg: TypeAlias = NonSpare_1269_Arg
class Item_545(Item):
    cv_non_spare = NonSpare_1269

    @classmethod
    def create(cls, arg : Item_545_Arg) -> "Item_545":
        return cls._create(arg) # type: ignore

Variation_1329_Arg_Group = Tuple[Union[RuleVariation_710_Arg, Tuple[Literal["LPF"], RuleVariation_710_Arg]], Union[RuleVariation_818_Arg, Tuple[Literal["CPF"], RuleVariation_818_Arg]], Union[RuleVariation_894_Arg, Tuple[Literal["MHF"], RuleVariation_894_Arg]]]
Variation_1329_Arg: TypeAlias = Union[int, Variation_1329_Arg_Group]
class Variation_1329(Group):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_items_list = [(Item_501, 1), (Item_207, 1), (Item_545, 1)]
    cv_items_dict = {"LPF": RuleVariation_710, "CPF": RuleVariation_818, "MHF": RuleVariation_894}

    @overload
    @classmethod
    def spec(cls, key : Literal["LPF"]) -> RuleVariation_710:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPF"]) -> RuleVariation_818:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MHF"]) -> RuleVariation_894:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LPF"], Literal["CPF"], Literal["MHF"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LPF"]) -> RuleVariation_710:
        ...
    @overload
    def get_item(self, key : Literal["CPF"]) -> RuleVariation_818:
        ...
    @overload
    def get_item(self, key : Literal["MHF"]) -> RuleVariation_894:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1329_Arg) -> 'Variation_1329':
        return cls._create(arg) # type: ignore

Content_456_Arg: TypeAlias = int
class Content_456(ContentTable):
    cv_values = {0: "Stage One Alert", 1: "Stage Two Alert"}

RuleContent_456_Arg: TypeAlias = Content_456_Arg
class RuleContent_456(RuleContentContextFree):
    cv_content = Content_456

    @property
    def content(self) -> Content_456:
        return self._get_content() # type: ignore

Variation_748_Arg: TypeAlias = RuleContent_456_Arg
class Variation_748(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_456

    @classmethod
    def create(cls, arg : Variation_748_Arg) -> "Variation_748":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_456:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_456:
        return self.rule.content

RuleVariation_737_Arg: TypeAlias = Variation_748_Arg
class RuleVariation_737(RuleVariationContextFree):
    cv_variation = Variation_748

    @classmethod
    def create(cls, arg : RuleVariation_737_Arg) -> "RuleVariation_737":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_748:
        return self.arg # type: ignore

NonSpare_1540_Arg: TypeAlias = RuleVariation_737_Arg
class NonSpare_1540(NonSpare):
    cv_name = "RAS"
    cv_title = "RIMCAS Alert Stage"
    cv_rule = RuleVariation_737

    @classmethod
    def create(cls, arg : NonSpare_1540_Arg) -> "NonSpare_1540":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_737:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_748:
        return self.rule.variation

Item_774_Arg: TypeAlias = NonSpare_1540_Arg
class Item_774(Item):
    cv_non_spare = NonSpare_1540

    @classmethod
    def create(cls, arg : Item_774_Arg) -> "Item_774":
        return cls._create(arg) # type: ignore

Variation_1330_Arg_Group = Tuple[Union[RuleVariation_737_Arg, Tuple[Literal["RAS"], RuleVariation_737_Arg]], int]
Variation_1330_Arg: TypeAlias = Union[int, Variation_1330_Arg_Group]
class Variation_1330(Group):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_items_list = [(Item_774, 1), (Item_24, 2)]
    cv_items_dict = {"RAS": RuleVariation_737}

    @classmethod
    def spec(cls, key : Literal["RAS"]) -> RuleVariation_737:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["RAS"]) -> RuleVariation_737:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1330_Arg) -> 'Variation_1330':
        return cls._create(arg) # type: ignore

Content_4_Arg: TypeAlias = int
class Content_4(ContentTable):
    cv_values = {0: "2 aircraft, same taxiway, opposite direction", 1: "Aircraft entering wrong direction", 2: "Aircraft entering wrong taxiway", 3: "Speed violation"}

RuleContent_4_Arg: TypeAlias = Content_4_Arg
class RuleContent_4(RuleContentContextFree):
    cv_content = Content_4

    @property
    def content(self) -> Content_4:
        return self._get_content() # type: ignore

Variation_773_Arg: TypeAlias = RuleContent_4_Arg
class Variation_773(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_4

    @classmethod
    def create(cls, arg : Variation_773_Arg) -> "Variation_773":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_4:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_4:
        return self.rule.content

Content_555_Arg: TypeAlias = int
class Content_555(ContentTable):
    cv_values = {0: "VRM Slow Climb", 1: "VRM Slow Descent"}

RuleContent_555_Arg: TypeAlias = Content_555_Arg
class RuleContent_555(RuleContentContextFree):
    cv_content = Content_555

    @property
    def content(self) -> Content_555:
        return self._get_content() # type: ignore

Variation_792_Arg: TypeAlias = RuleContent_555_Arg
class Variation_792(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_555

    @classmethod
    def create(cls, arg : Variation_792_Arg) -> "Variation_792":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_555:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_555:
        return self.rule.content

Content_556_Arg: TypeAlias = int
class Content_556(ContentTable):
    cv_values = {0: "VTM Fast Climb", 1: "VTM Fast Descent"}

RuleContent_556_Arg: TypeAlias = Content_556_Arg
class RuleContent_556(RuleContentContextFree):
    cv_content = Content_556

    @property
    def content(self) -> Content_556:
        return self._get_content() # type: ignore

Variation_793_Arg: TypeAlias = RuleContent_556_Arg
class Variation_793(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_556

    @classmethod
    def create(cls, arg : Variation_793_Arg) -> "Variation_793":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_556:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_556:
        return self.rule.content

Content_561_Arg: TypeAlias = int
class Content_561(ContentTable):
    cv_values = {0: "Vertical manoeuvre deviation prior to reaching its expected level", 1: "Vertical manoeuvre deviation past its expected level"}

RuleContent_561_Arg: TypeAlias = Content_561_Arg
class RuleContent_561(RuleContentContextFree):
    cv_content = Content_561

    @property
    def content(self) -> Content_561:
        return self._get_content() # type: ignore

Variation_794_Arg: TypeAlias = RuleContent_561_Arg
class Variation_794(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_561

    @classmethod
    def create(cls, arg : Variation_794_Arg) -> "Variation_794":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_561:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_561:
        return self.rule.content

Content_455_Arg: TypeAlias = int
class Content_455(ContentTable):
    cv_values = {0: "Slow Descent", 1: "Fast Descent", 2: "Slow Climb", 3: "Fast Climb"}

RuleContent_455_Arg: TypeAlias = Content_455_Arg
class RuleContent_455(RuleContentContextFree):
    cv_content = Content_455

    @property
    def content(self) -> Content_455:
        return self._get_content() # type: ignore

Variation_787_Arg: TypeAlias = RuleContent_455_Arg
class Variation_787(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_455

    @classmethod
    def create(cls, arg : Variation_787_Arg) -> "Variation_787":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_455:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_455:
        return self.rule.content

Content_12_Arg: TypeAlias = int
class Content_12(ContentTable):
    cv_values = {0: "Above", 1: "Below"}

RuleContent_12_Arg: TypeAlias = Content_12_Arg
class RuleContent_12(RuleContentContextFree):
    cv_content = Content_12

    @property
    def content(self) -> Content_12:
        return self._get_content() # type: ignore

Variation_775_Arg: TypeAlias = RuleContent_12_Arg
class Variation_775(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_12

    @classmethod
    def create(cls, arg : Variation_775_Arg) -> "Variation_775":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_12:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_12:
        return self.rule.content

Content_475_Arg: TypeAlias = int
class Content_475(ContentTable):
    cv_values = {0: "Table - Single RWY Operation", 1: "MRS - Single RWY Operation", 2: "ROT - Single RWY Operation", 3: "GAP - Single RWY Operation", 4: "Table - Parallel RWY Operation", 5: "MRS - Parallel RWY Operation", 6: "ROT - Parallel RWY Operation", 7: "GAP - Parallel RWY Operation"}

RuleContent_475_Arg: TypeAlias = Content_475_Arg
class RuleContent_475(RuleContentContextFree):
    cv_content = Content_475

    @property
    def content(self) -> Content_475:
        return self._get_content() # type: ignore

Variation_788_Arg: TypeAlias = RuleContent_475_Arg
class Variation_788(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_475

    @classmethod
    def create(cls, arg : Variation_788_Arg) -> "Variation_788":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_475:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_475:
        return self.rule.content

Content_207_Arg: TypeAlias = int
class Content_207(ContentTable):
    cv_values = {0: "End of Alert", 1: "Planned Alert", 2: "Alert on TABLE Indicator", 3: "Alert on MRS Indicator", 4: "Alert on ROT Indicator", 5: "Alert on GAP Indicator"}

RuleContent_207_Arg: TypeAlias = Content_207_Arg
class RuleContent_207(RuleContentContextFree):
    cv_content = Content_207

    @property
    def content(self) -> Content_207:
        return self._get_content() # type: ignore

Variation_779_Arg: TypeAlias = RuleContent_207_Arg
class Variation_779(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_207

    @classmethod
    def create(cls, arg : Variation_779_Arg) -> "Variation_779":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_207:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_207:
        return self.rule.content

Content_255_Arg: TypeAlias = int
class Content_255(ContentTable):
    cv_values = {0: "Line-Up vs. Line-Up", 1: "Line-Up vs. Cross or Enter", 2: "Line-Up vs. Take-Off", 3: "Line-Up vs. Landing"}

RuleContent_255_Arg: TypeAlias = Content_255_Arg
class RuleContent_255(RuleContentContextFree):
    cv_content = Content_255

    @property
    def content(self) -> Content_255:
        return self._get_content() # type: ignore

Variation_781_Arg: TypeAlias = RuleContent_255_Arg
class Variation_781(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_255

    @classmethod
    def create(cls, arg : Variation_781_Arg) -> "Variation_781":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_255:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_255:
        return self.rule.content

Content_70_Arg: TypeAlias = int
class Content_70(ContentTable):
    cv_values = {0: "Cross or Enter  vs. Line-Up", 1: "Cross or Enter  vs. Cross or Enter", 2: "Cross or Enter  vs. Take-Off", 3: "Cross or Enter  vs. Landing"}

RuleContent_70_Arg: TypeAlias = Content_70_Arg
class RuleContent_70(RuleContentContextFree):
    cv_content = Content_70

    @property
    def content(self) -> Content_70:
        return self._get_content() # type: ignore

Variation_778_Arg: TypeAlias = RuleContent_70_Arg
class Variation_778(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_70

    @classmethod
    def create(cls, arg : Variation_778_Arg) -> "Variation_778":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_70:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_70:
        return self.rule.content

Content_476_Arg: TypeAlias = int
class Content_476(ContentTable):
    cv_values = {0: "Take-Off vs. Line-Up", 1: "Take-Off vs. Cross or Enter", 2: "Take-Off vs. Take-Off", 3: "Take-Off vs. Landing"}

RuleContent_476_Arg: TypeAlias = Content_476_Arg
class RuleContent_476(RuleContentContextFree):
    cv_content = Content_476

    @property
    def content(self) -> Content_476:
        return self._get_content() # type: ignore

Variation_789_Arg: TypeAlias = RuleContent_476_Arg
class Variation_789(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_476

    @classmethod
    def create(cls, arg : Variation_789_Arg) -> "Variation_789":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_476:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_476:
        return self.rule.content

Content_252_Arg: TypeAlias = int
class Content_252(ContentTable):
    cv_values = {0: "Landing vs. Line-Up", 1: "Landing vs. Cross or Enter", 2: "Landing vs. Take-Off", 3: "Landing vs. Landing"}

RuleContent_252_Arg: TypeAlias = Content_252_Arg
class RuleContent_252(RuleContentContextFree):
    cv_content = Content_252

    @property
    def content(self) -> Content_252:
        return self._get_content() # type: ignore

Variation_780_Arg: TypeAlias = RuleContent_252_Arg
class Variation_780(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_252

    @classmethod
    def create(cls, arg : Variation_780_Arg) -> "Variation_780":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_252:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_252:
        return self.rule.content

Content_430_Arg: TypeAlias = int
class Content_430(ContentTable):
    cv_values = {0: "Push-Back vs. Push-Back", 1: "Push-Back vs. Taxi"}

RuleContent_430_Arg: TypeAlias = Content_430_Arg
class RuleContent_430(RuleContentContextFree):
    cv_content = Content_430

    @property
    def content(self) -> Content_430:
        return self._get_content() # type: ignore

Variation_786_Arg: TypeAlias = RuleContent_430_Arg
class Variation_786(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_430

    @classmethod
    def create(cls, arg : Variation_786_Arg) -> "Variation_786":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_430:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_430:
        return self.rule.content

Content_483_Arg: TypeAlias = int
class Content_483(ContentTable):
    cv_values = {0: "Taxi vs. Push-Back", 1: "TAxi vs. Taxi"}

RuleContent_483_Arg: TypeAlias = Content_483_Arg
class RuleContent_483(RuleContentContextFree):
    cv_content = Content_483

    @property
    def content(self) -> Content_483:
        return self._get_content() # type: ignore

Variation_790_Arg: TypeAlias = RuleContent_483_Arg
class Variation_790(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_483

    @classmethod
    def create(cls, arg : Variation_790_Arg) -> "Variation_790":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_483:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_483:
        return self.rule.content

Content_312_Arg: TypeAlias = int
class Content_312(ContentTable):
    cv_values = {0: "No Push-Back Clearance", 1: "No Taxi Clearance", 2: "No Line-Up Clearance", 3: "No Crossing Clearance", 4: "No Enter Clearance", 5: "No Take-Off Clearance", 6: "Landing Clearance"}

RuleContent_312_Arg: TypeAlias = Content_312_Arg
class RuleContent_312(RuleContentContextFree):
    cv_content = Content_312

    @property
    def content(self) -> Content_312:
        return self._get_content() # type: ignore

Variation_782_Arg: TypeAlias = RuleContent_312_Arg
class Variation_782(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_312

    @classmethod
    def create(cls, arg : Variation_782_Arg) -> "Variation_782":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_312:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_312:
        return self.rule.content

Content_21_Arg: TypeAlias = int
class Content_21(ContentTable):
    cv_values = {0: "After Push-Back Clearance", 1: "After Taxi Clearance", 2: "After Line-Up Clearance", 3: "After Crossing Clearance", 4: "After Enter Clearance", 5: "After Take-Off Clearance", 6: "Stationary on Runway", 7: "Stationary on Taxiway"}

RuleContent_21_Arg: TypeAlias = Content_21_Arg
class RuleContent_21(RuleContentContextFree):
    cv_content = Content_21

    @property
    def content(self) -> Content_21:
        return self._get_content() # type: ignore

Variation_777_Arg: TypeAlias = RuleContent_21_Arg
class Variation_777(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_21

    @classmethod
    def create(cls, arg : Variation_777_Arg) -> "Variation_777":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_21:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_21:
        return self.rule.content

Content_341_Arg: TypeAlias = int
class Content_341(ContentTable):
    cv_values = {0: "No contact (receiving ATSU)", 1: "No transfer (leaving ATSU)"}

RuleContent_341_Arg: TypeAlias = Content_341_Arg
class RuleContent_341(RuleContentContextFree):
    cv_content = Content_341

    @property
    def content(self) -> Content_341:
        return self._get_content() # type: ignore

Variation_783_Arg: TypeAlias = RuleContent_341_Arg
class Variation_783(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_341

    @classmethod
    def create(cls, arg : Variation_783_Arg) -> "Variation_783":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_341:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_341:
        return self.rule.content

RuleVariation_1434_Arg: TypeAlias = Union[
    Variation_771_Arg,
    Variation_774_Arg,
    Variation_795_Arg,
    Variation_1329_Arg,
    Variation_1330_Arg,
    Variation_1330_Arg,
    Variation_1330_Arg,
    Variation_1330_Arg,
    Variation_1330_Arg,
    Variation_1330_Arg,
    Variation_1330_Arg,
    Variation_1330_Arg,
    Variation_773_Arg,
    Variation_792_Arg,
    Variation_793_Arg,
    Variation_794_Arg,
    Variation_787_Arg,
    Variation_775_Arg,
    Variation_788_Arg,
    Variation_788_Arg,
    Variation_779_Arg,
    Variation_781_Arg,
    Variation_778_Arg,
    Variation_789_Arg,
    Variation_780_Arg,
    Variation_786_Arg,
    Variation_790_Arg,
    Variation_782_Arg,
    Variation_777_Arg,
    Variation_783_Arg,
]
class RuleVariation_1434(RuleVariationDependent):
    cv_depends_on = [["000"], ["120", "CC", "TID"]]
    cv_default_variation = Variation_771
    cv_cases = [
        ([5, 1], Variation_774),
        ([7, 0], Variation_795),
        ([7, 1], Variation_1329),
        ([9, 2], Variation_1330),
        ([10, 2], Variation_1330),
        ([11, 2], Variation_1330),
        ([12, 2], Variation_1330),
        ([13, 2], Variation_1330),
        ([14, 2], Variation_1330),
        ([15, 2], Variation_1330),
        ([16, 2], Variation_1330),
        ([15, 1], Variation_773),
        ([24, 1], Variation_792),
        ([24, 2], Variation_793),
        ([26, 1], Variation_794),
        ([27, 1], Variation_787),
        ([27, 2], Variation_775),
        ([33, 1], Variation_788),
        ([34, 1], Variation_788),
        ([35, 1], Variation_779),
        ([38, 0], Variation_781),
        ([38, 1], Variation_778),
        ([38, 2], Variation_789),
        ([38, 3], Variation_780),
        ([38, 4], Variation_786),
        ([38, 5], Variation_790),
        ([39, 1], Variation_782),
        ([40, 1], Variation_777),
        ([41, 1], Variation_783),
    ]

    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[5], Literal[1]]) -> Variation_774:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[7], Literal[0]]) -> Variation_795:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[7], Literal[1]]) -> Variation_1329:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[9], Literal[2]]) -> Variation_1330:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[10], Literal[2]]) -> Variation_1330:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[11], Literal[2]]) -> Variation_1330:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[12], Literal[2]]) -> Variation_1330:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[13], Literal[2]]) -> Variation_1330:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[14], Literal[2]]) -> Variation_1330:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[15], Literal[2]]) -> Variation_1330:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[16], Literal[2]]) -> Variation_1330:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[15], Literal[1]]) -> Variation_773:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[24], Literal[1]]) -> Variation_792:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[24], Literal[2]]) -> Variation_793:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[26], Literal[1]]) -> Variation_794:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[27], Literal[1]]) -> Variation_787:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[27], Literal[2]]) -> Variation_775:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[33], Literal[1]]) -> Variation_788:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[34], Literal[1]]) -> Variation_788:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[35], Literal[1]]) -> Variation_779:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[0]]) -> Variation_781:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[1]]) -> Variation_778:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[2]]) -> Variation_789:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[3]]) -> Variation_780:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[4]]) -> Variation_786:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[5]]) -> Variation_790:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[39], Literal[1]]) -> Variation_782:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[40], Literal[1]]) -> Variation_777:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[41], Literal[1]]) -> Variation_783:
        ...

    @classmethod
    def variation(cls, key : Any) -> Any:
        return cls._variation(key)

    @classmethod
    def create(cls, arg : RuleVariation_1434_Arg) -> "RuleVariation_1434":
        return cls._create(arg) # type: ignore

NonSpare_810_Arg: TypeAlias = RuleVariation_1434_Arg
class NonSpare_810(NonSpare):
    cv_name = "CPC"
    cv_title = "Conflict Properties Class"
    cv_rule = RuleVariation_1434

    @classmethod
    def create(cls, arg : NonSpare_810_Arg) -> "NonSpare_810":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1434:
        return self.arg # type: ignore

Item_206_Arg: TypeAlias = NonSpare_810_Arg
class Item_206(Item):
    cv_non_spare = NonSpare_810

    @classmethod
    def create(cls, arg : Item_206_Arg) -> "Item_206":
        return cls._create(arg) # type: ignore

Content_251_Arg: TypeAlias = int
class Content_251(ContentTable):
    cv_values = {0: "LOW", 1: "HIGH"}

RuleContent_251_Arg: TypeAlias = Content_251_Arg
class RuleContent_251(RuleContentContextFree):
    cv_content = Content_251

    @property
    def content(self) -> Content_251:
        return self._get_content() # type: ignore

Variation_979_Arg: TypeAlias = RuleContent_251_Arg
class Variation_979(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_251

    @classmethod
    def create(cls, arg : Variation_979_Arg) -> "Variation_979":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_251:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_251:
        return self.rule.content

RuleVariation_949_Arg: TypeAlias = Variation_979_Arg
class RuleVariation_949(RuleVariationContextFree):
    cv_variation = Variation_979

    @classmethod
    def create(cls, arg : RuleVariation_949_Arg) -> "RuleVariation_949":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_979:
        return self.arg # type: ignore

NonSpare_826_Arg: TypeAlias = RuleVariation_949_Arg
class NonSpare_826(NonSpare):
    cv_name = "CS"
    cv_title = "Conflict Severity"
    cv_rule = RuleVariation_949

    @classmethod
    def create(cls, arg : NonSpare_826_Arg) -> "NonSpare_826":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_949:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_979:
        return self.rule.variation

Item_217_Arg: TypeAlias = NonSpare_826_Arg
class Item_217(Item):
    cv_non_spare = NonSpare_826

    @classmethod
    def create(cls, arg : Item_217_Arg) -> "Item_217":
        return cls._create(arg) # type: ignore

Variation_1218_Arg_Group = Tuple[Union[RuleVariation_131_Arg, Tuple[Literal["TID"], RuleVariation_131_Arg]], Union[RuleVariation_1434_Arg, Tuple[Literal["CPC"], RuleVariation_1434_Arg]], Union[RuleVariation_949_Arg, Tuple[Literal["CS"], RuleVariation_949_Arg]]]
Variation_1218_Arg: TypeAlias = Union[int, Variation_1218_Arg_Group]
class Variation_1218(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_996, 4), (Item_206, 3), (Item_217, 1)]
    cv_items_dict = {"TID": RuleVariation_131, "CPC": RuleVariation_1434, "CS": RuleVariation_949}

    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> RuleVariation_131:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPC"]) -> RuleVariation_1434:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CS"]) -> RuleVariation_949:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TID"], Literal["CPC"], Literal["CS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TID"]) -> RuleVariation_131:
        ...
    @overload
    def get_item(self, key : Literal["CPC"]) -> RuleVariation_1434:
        ...
    @overload
    def get_item(self, key : Literal["CS"]) -> RuleVariation_949:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1218_Arg) -> 'Variation_1218':
        return cls._create(arg) # type: ignore

RuleVariation_1159_Arg: TypeAlias = Variation_1218_Arg
class RuleVariation_1159(RuleVariationContextFree):
    cv_variation = Variation_1218

    @classmethod
    def create(cls, arg : RuleVariation_1159_Arg) -> "RuleVariation_1159":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1218:
        return self.arg # type: ignore

NonSpare_704_Arg: TypeAlias = RuleVariation_1159_Arg
class NonSpare_704(NonSpare):
    cv_name = "CC"
    cv_title = "Conflict Classification"
    cv_rule = RuleVariation_1159

    @classmethod
    def create(cls, arg : NonSpare_704_Arg) -> "NonSpare_704":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1218:
        return self.rule.variation

Content_728_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["%"]]]
class Content_728(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.5
    cv_unit = "%"

    def as_quantity(self, cv_unit : Optional[Literal["%"]] = None) -> float:
        return self._as_quantity()

RuleContent_728_Arg: TypeAlias = Content_728_Arg
class RuleContent_728(RuleContentContextFree):
    cv_content = Content_728

    @property
    def content(self) -> Content_728:
        return self._get_content() # type: ignore

Variation_224_Arg: TypeAlias = RuleContent_728_Arg
class Variation_224(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_728

    @classmethod
    def create(cls, arg : Variation_224_Arg) -> "Variation_224":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_728:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_728:
        return self.rule.content

RuleVariation_217_Arg: TypeAlias = Variation_224_Arg
class RuleVariation_217(RuleVariationContextFree):
    cv_variation = Variation_224

    @classmethod
    def create(cls, arg : RuleVariation_217_Arg) -> "RuleVariation_217":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_224:
        return self.arg # type: ignore

NonSpare_808_Arg: TypeAlias = RuleVariation_217_Arg
class NonSpare_808(NonSpare):
    cv_name = "CP"
    cv_title = "Conflict Probability"
    cv_rule = RuleVariation_217

    @classmethod
    def create(cls, arg : NonSpare_808_Arg) -> "NonSpare_808":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_217:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_224:
        return self.rule.variation

NonSpare_706_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_706(NonSpare):
    cv_name = "CD"
    cv_title = "Conflict Duration"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_706_Arg) -> "NonSpare_706":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

Variation_1470_Arg = TypedDict('Variation_1470_Arg', {
    "CN": NonSpare_739_Arg,
    "CC": NonSpare_704_Arg,
    "CP": NonSpare_808_Arg,
    "CD": NonSpare_706_Arg,
}, total=False)
class Variation_1470(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_739, NonSpare_704, NonSpare_808, NonSpare_706]
    cv_items_dict = {"CN": NonSpare_739, "CC": NonSpare_704, "CP": NonSpare_808, "CD": NonSpare_706}

    @overload
    @classmethod
    def spec(cls, key : Literal["CN"]) -> NonSpare_739:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CC"]) -> NonSpare_704:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CP"]) -> NonSpare_808:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CD"]) -> NonSpare_706:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CN"], Literal["CC"], Literal["CP"], Literal["CD"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CN"]) -> Optional[NonSpare_739]:
        ...
    @overload
    def get_item(self, key : Literal["CC"]) -> Optional[NonSpare_704]:
        ...
    @overload
    def get_item(self, key : Literal["CP"]) -> Optional[NonSpare_808]:
        ...
    @overload
    def get_item(self, key : Literal["CD"]) -> Optional[NonSpare_706]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["CN"], val : NonSpare_739_Arg) -> "Variation_1470":
        ...
    @overload
    def set_item(self, key : Literal["CC"], val : NonSpare_704_Arg) -> "Variation_1470":
        ...
    @overload
    def set_item(self, key : Literal["CP"], val : NonSpare_808_Arg) -> "Variation_1470":
        ...
    @overload
    def set_item(self, key : Literal["CD"], val : NonSpare_706_Arg) -> "Variation_1470":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["CN"]) -> "Variation_1470":
        ...
    @overload
    def del_item(self, key : Literal["CC"]) -> "Variation_1470":
        ...
    @overload
    def del_item(self, key : Literal["CP"]) -> "Variation_1470":
        ...
    @overload
    def del_item(self, key : Literal["CD"]) -> "Variation_1470":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1470_Arg) -> 'Variation_1470':
        return cls._create(arg) # type: ignore

RuleVariation_1393_Arg: TypeAlias = Variation_1470_Arg
class RuleVariation_1393(RuleVariationContextFree):
    cv_variation = Variation_1470

    @classmethod
    def create(cls, arg : RuleVariation_1393_Arg) -> "RuleVariation_1393":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1470:
        return self.arg # type: ignore

NonSpare_293_Arg: TypeAlias = RuleVariation_1393_Arg
class NonSpare_293(NonSpare):
    cv_name = "120"
    cv_title = "Conflict Characteristics"
    cv_rule = RuleVariation_1393

    @classmethod
    def create(cls, arg : NonSpare_293_Arg) -> "NonSpare_293":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1393:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1470:
        return self.rule.variation

class UapItem_293(UapItem):
    cv_non_spare = NonSpare_293

NonSpare_1827_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_1827(NonSpare):
    cv_name = "TC"
    cv_title = "Time to Conflict"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_1827_Arg) -> "NonSpare_1827":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

NonSpare_1831_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_1831(NonSpare):
    cv_name = "TCA"
    cv_title = "Time to Closest Approach"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_1831_Arg) -> "NonSpare_1831":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

Variation_364_Arg: TypeAlias = RuleContent_729_Arg
class Variation_364(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_729

    @classmethod
    def create(cls, arg : Variation_364_Arg) -> "Variation_364":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_729:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_729:
        return self.rule.content

RuleVariation_357_Arg: TypeAlias = Variation_364_Arg
class RuleVariation_357(RuleVariationContextFree):
    cv_variation = Variation_364

    @classmethod
    def create(cls, arg : RuleVariation_357_Arg) -> "RuleVariation_357":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_364:
        return self.arg # type: ignore

NonSpare_731_Arg: TypeAlias = RuleVariation_357_Arg
class NonSpare_731(NonSpare):
    cv_name = "CHS"
    cv_title = "Current Horizontal Separation"
    cv_rule = RuleVariation_357

    @classmethod
    def create(cls, arg : NonSpare_731_Arg) -> "NonSpare_731":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_357:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_364:
        return self.rule.variation

NonSpare_1272_Arg: TypeAlias = RuleVariation_302_Arg
class NonSpare_1272(NonSpare):
    cv_name = "MHS"
    cv_title = "Estimated Minimum Horizontal Separation"
    cv_rule = RuleVariation_302

    @classmethod
    def create(cls, arg : NonSpare_1272_Arg) -> "NonSpare_1272":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_302:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_309:
        return self.rule.variation

Content_726_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
class Content_726(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 25.0
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

RuleContent_726_Arg: TypeAlias = Content_726_Arg
class RuleContent_726(RuleContentContextFree):
    cv_content = Content_726

    @property
    def content(self) -> Content_726:
        return self._get_content() # type: ignore

Variation_308_Arg: TypeAlias = RuleContent_726_Arg
class Variation_308(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_726

    @classmethod
    def create(cls, arg : Variation_308_Arg) -> "Variation_308":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_726:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_726:
        return self.rule.content

RuleVariation_301_Arg: TypeAlias = Variation_308_Arg
class RuleVariation_301(RuleVariationContextFree):
    cv_variation = Variation_308

    @classmethod
    def create(cls, arg : RuleVariation_301_Arg) -> "RuleVariation_301":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_308:
        return self.arg # type: ignore

NonSpare_845_Arg: TypeAlias = RuleVariation_301_Arg
class NonSpare_845(NonSpare):
    cv_name = "CVS"
    cv_title = "Current Vertical Separation"
    cv_rule = RuleVariation_301

    @classmethod
    def create(cls, arg : NonSpare_845_Arg) -> "NonSpare_845":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_301:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_308:
        return self.rule.variation

NonSpare_1332_Arg: TypeAlias = RuleVariation_301_Arg
class NonSpare_1332(NonSpare):
    cv_name = "MVS"
    cv_title = "Estimated Minimum Vertical Separation"
    cv_rule = RuleVariation_301

    @classmethod
    def create(cls, arg : NonSpare_1332_Arg) -> "NonSpare_1332":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_301:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_308:
        return self.rule.variation

Variation_1505_Arg = TypedDict('Variation_1505_Arg', {
    "TC": NonSpare_1827_Arg,
    "TCA": NonSpare_1831_Arg,
    "CHS": NonSpare_731_Arg,
    "MHS": NonSpare_1272_Arg,
    "CVS": NonSpare_845_Arg,
    "MVS": NonSpare_1332_Arg,
}, total=False)
class Variation_1505(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1827, NonSpare_1831, NonSpare_731, NonSpare_1272, NonSpare_845, NonSpare_1332]
    cv_items_dict = {"TC": NonSpare_1827, "TCA": NonSpare_1831, "CHS": NonSpare_731, "MHS": NonSpare_1272, "CVS": NonSpare_845, "MVS": NonSpare_1332}

    @overload
    @classmethod
    def spec(cls, key : Literal["TC"]) -> NonSpare_1827:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TCA"]) -> NonSpare_1831:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CHS"]) -> NonSpare_731:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MHS"]) -> NonSpare_1272:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CVS"]) -> NonSpare_845:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MVS"]) -> NonSpare_1332:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TC"], Literal["TCA"], Literal["CHS"], Literal["MHS"], Literal["CVS"], Literal["MVS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TC"]) -> Optional[NonSpare_1827]:
        ...
    @overload
    def get_item(self, key : Literal["TCA"]) -> Optional[NonSpare_1831]:
        ...
    @overload
    def get_item(self, key : Literal["CHS"]) -> Optional[NonSpare_731]:
        ...
    @overload
    def get_item(self, key : Literal["MHS"]) -> Optional[NonSpare_1272]:
        ...
    @overload
    def get_item(self, key : Literal["CVS"]) -> Optional[NonSpare_845]:
        ...
    @overload
    def get_item(self, key : Literal["MVS"]) -> Optional[NonSpare_1332]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["TC"], val : NonSpare_1827_Arg) -> "Variation_1505":
        ...
    @overload
    def set_item(self, key : Literal["TCA"], val : NonSpare_1831_Arg) -> "Variation_1505":
        ...
    @overload
    def set_item(self, key : Literal["CHS"], val : NonSpare_731_Arg) -> "Variation_1505":
        ...
    @overload
    def set_item(self, key : Literal["MHS"], val : NonSpare_1272_Arg) -> "Variation_1505":
        ...
    @overload
    def set_item(self, key : Literal["CVS"], val : NonSpare_845_Arg) -> "Variation_1505":
        ...
    @overload
    def set_item(self, key : Literal["MVS"], val : NonSpare_1332_Arg) -> "Variation_1505":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["TC"]) -> "Variation_1505":
        ...
    @overload
    def del_item(self, key : Literal["TCA"]) -> "Variation_1505":
        ...
    @overload
    def del_item(self, key : Literal["CHS"]) -> "Variation_1505":
        ...
    @overload
    def del_item(self, key : Literal["MHS"]) -> "Variation_1505":
        ...
    @overload
    def del_item(self, key : Literal["CVS"]) -> "Variation_1505":
        ...
    @overload
    def del_item(self, key : Literal["MVS"]) -> "Variation_1505":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1505_Arg) -> 'Variation_1505':
        return cls._create(arg) # type: ignore

RuleVariation_1428_Arg: TypeAlias = Variation_1505_Arg
class RuleVariation_1428(RuleVariationContextFree):
    cv_variation = Variation_1505

    @classmethod
    def create(cls, arg : RuleVariation_1428_Arg) -> "RuleVariation_1428":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1505:
        return self.arg # type: ignore

NonSpare_200_Arg: TypeAlias = RuleVariation_1428_Arg
class NonSpare_200(NonSpare):
    cv_name = "070"
    cv_title = "Conflict Timing and Separation"
    cv_rule = RuleVariation_1428

    @classmethod
    def create(cls, arg : NonSpare_200_Arg) -> "NonSpare_200":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1428:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1505:
        return self.rule.variation

class UapItem_200(UapItem):
    cv_non_spare = NonSpare_200

Content_630_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
class Content_630(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 25.0
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

RuleContent_630_Arg: TypeAlias = Content_630_Arg
class RuleContent_630(RuleContentContextFree):
    cv_content = Content_630

    @property
    def content(self) -> Content_630:
        return self._get_content() # type: ignore

Variation_260_Arg: TypeAlias = RuleContent_630_Arg
class Variation_260(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_630

    @classmethod
    def create(cls, arg : Variation_260_Arg) -> "Variation_260":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_630:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_630:
        return self.rule.content

RuleVariation_253_Arg: TypeAlias = Variation_260_Arg
class RuleVariation_253(RuleVariationContextFree):
    cv_variation = Variation_260

    @classmethod
    def create(cls, arg : RuleVariation_253_Arg) -> "RuleVariation_253":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_260:
        return self.arg # type: ignore

NonSpare_226_Arg: TypeAlias = RuleVariation_253_Arg
class NonSpare_226(NonSpare):
    cv_name = "076"
    cv_title = "Vertical Deviation"
    cv_rule = RuleVariation_253

    @classmethod
    def create(cls, arg : NonSpare_226_Arg) -> "NonSpare_226":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_253:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_260:
        return self.rule.variation

class UapItem_226(UapItem):
    cv_non_spare = NonSpare_226

Content_635_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_635(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 32.0
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_635_Arg: TypeAlias = Content_635_Arg
class RuleContent_635(RuleContentContextFree):
    cv_content = Content_635

    @property
    def content(self) -> Content_635:
        return self._get_content() # type: ignore

Variation_262_Arg: TypeAlias = RuleContent_635_Arg
class Variation_262(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_635

    @classmethod
    def create(cls, arg : Variation_262_Arg) -> "Variation_262":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_635:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_635:
        return self.rule.content

RuleVariation_255_Arg: TypeAlias = Variation_262_Arg
class RuleVariation_255(RuleVariationContextFree):
    cv_variation = Variation_262

    @classmethod
    def create(cls, arg : RuleVariation_255_Arg) -> "RuleVariation_255":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_262:
        return self.arg # type: ignore

NonSpare_221_Arg: TypeAlias = RuleVariation_255_Arg
class NonSpare_221(NonSpare):
    cv_name = "074"
    cv_title = "Longitudinal Deviation"
    cv_rule = RuleVariation_255

    @classmethod
    def create(cls, arg : NonSpare_221_Arg) -> "NonSpare_221":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_255:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_262:
        return self.rule.variation

class UapItem_221(UapItem):
    cv_non_spare = NonSpare_221

NonSpare_224_Arg: TypeAlias = RuleVariation_343_Arg
class NonSpare_224(NonSpare):
    cv_name = "075"
    cv_title = "Transversal Distance Deviation"
    cv_rule = RuleVariation_343

    @classmethod
    def create(cls, arg : NonSpare_224_Arg) -> "NonSpare_224":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_343:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_350:
        return self.rule.variation

class UapItem_224(UapItem):
    cv_non_spare = NonSpare_224

Content_607_Arg: TypeAlias = Union[int, str]
class Content_607(ContentString):
    cv_string_type = StringICAO

RuleContent_607_Arg: TypeAlias = Content_607_Arg
class RuleContent_607(RuleContentContextFree):
    cv_content = Content_607

    @property
    def content(self) -> Content_607:
        return self._get_content() # type: ignore

Variation_389_Arg: TypeAlias = RuleContent_607_Arg
class Variation_389(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_rule = RuleContent_607

    @classmethod
    def create(cls, arg : Variation_389_Arg) -> "Variation_389":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_607:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_607:
        return self.rule.content

RuleVariation_381_Arg: TypeAlias = Variation_389_Arg
class RuleVariation_381(RuleVariationContextFree):
    cv_variation = Variation_389

    @classmethod
    def create(cls, arg : RuleVariation_381_Arg) -> "RuleVariation_381":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_389:
        return self.arg # type: ignore

NonSpare_605_Arg: TypeAlias = RuleVariation_381_Arg
class NonSpare_605(NonSpare):
    cv_name = "AN"
    cv_title = "Area Name"
    cv_rule = RuleVariation_381

    @classmethod
    def create(cls, arg : NonSpare_605_Arg) -> "NonSpare_605":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_381:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_389:
        return self.rule.variation

NonSpare_698_Arg: TypeAlias = RuleVariation_383_Arg
class NonSpare_698(NonSpare):
    cv_name = "CAN"
    cv_title = "Crossing Area Name"
    cv_rule = RuleVariation_383

    @classmethod
    def create(cls, arg : NonSpare_698_Arg) -> "NonSpare_698":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

NonSpare_1619_Arg: TypeAlias = RuleVariation_383_Arg
class NonSpare_1619(NonSpare):
    cv_name = "RT1"
    cv_title = "Runway/Taxiway Designator 1"
    cv_rule = RuleVariation_383

    @classmethod
    def create(cls, arg : NonSpare_1619_Arg) -> "NonSpare_1619":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

NonSpare_1620_Arg: TypeAlias = RuleVariation_383_Arg
class NonSpare_1620(NonSpare):
    cv_name = "RT2"
    cv_title = "Runway/Taxiway Designator 2"
    cv_rule = RuleVariation_383

    @classmethod
    def create(cls, arg : NonSpare_1620_Arg) -> "NonSpare_1620":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

NonSpare_1655_Arg: TypeAlias = RuleVariation_383_Arg
class NonSpare_1655(NonSpare):
    cv_name = "SB"
    cv_title = "Stop Bar Designator"
    cv_rule = RuleVariation_383

    @classmethod
    def create(cls, arg : NonSpare_1655_Arg) -> "NonSpare_1655":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

NonSpare_1004_Arg: TypeAlias = RuleVariation_383_Arg
class NonSpare_1004(NonSpare):
    cv_name = "G"
    cv_title = "Gate Designator"
    cv_rule = RuleVariation_383

    @classmethod
    def create(cls, arg : NonSpare_1004_Arg) -> "NonSpare_1004":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

Variation_1463_Arg = TypedDict('Variation_1463_Arg', {
    "AN": NonSpare_605_Arg,
    "CAN": NonSpare_698_Arg,
    "RT1": NonSpare_1619_Arg,
    "RT2": NonSpare_1620_Arg,
    "SB": NonSpare_1655_Arg,
    "G": NonSpare_1004_Arg,
}, total=False)
class Variation_1463(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_605, NonSpare_698, NonSpare_1619, NonSpare_1620, NonSpare_1655, NonSpare_1004]
    cv_items_dict = {"AN": NonSpare_605, "CAN": NonSpare_698, "RT1": NonSpare_1619, "RT2": NonSpare_1620, "SB": NonSpare_1655, "G": NonSpare_1004}

    @overload
    @classmethod
    def spec(cls, key : Literal["AN"]) -> NonSpare_605:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CAN"]) -> NonSpare_698:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RT1"]) -> NonSpare_1619:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RT2"]) -> NonSpare_1620:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SB"]) -> NonSpare_1655:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> NonSpare_1004:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AN"], Literal["CAN"], Literal["RT1"], Literal["RT2"], Literal["SB"], Literal["G"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AN"]) -> Optional[NonSpare_605]:
        ...
    @overload
    def get_item(self, key : Literal["CAN"]) -> Optional[NonSpare_698]:
        ...
    @overload
    def get_item(self, key : Literal["RT1"]) -> Optional[NonSpare_1619]:
        ...
    @overload
    def get_item(self, key : Literal["RT2"]) -> Optional[NonSpare_1620]:
        ...
    @overload
    def get_item(self, key : Literal["SB"]) -> Optional[NonSpare_1655]:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> Optional[NonSpare_1004]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["AN"], val : NonSpare_605_Arg) -> "Variation_1463":
        ...
    @overload
    def set_item(self, key : Literal["CAN"], val : NonSpare_698_Arg) -> "Variation_1463":
        ...
    @overload
    def set_item(self, key : Literal["RT1"], val : NonSpare_1619_Arg) -> "Variation_1463":
        ...
    @overload
    def set_item(self, key : Literal["RT2"], val : NonSpare_1620_Arg) -> "Variation_1463":
        ...
    @overload
    def set_item(self, key : Literal["SB"], val : NonSpare_1655_Arg) -> "Variation_1463":
        ...
    @overload
    def set_item(self, key : Literal["G"], val : NonSpare_1004_Arg) -> "Variation_1463":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["AN"]) -> "Variation_1463":
        ...
    @overload
    def del_item(self, key : Literal["CAN"]) -> "Variation_1463":
        ...
    @overload
    def del_item(self, key : Literal["RT1"]) -> "Variation_1463":
        ...
    @overload
    def del_item(self, key : Literal["RT2"]) -> "Variation_1463":
        ...
    @overload
    def del_item(self, key : Literal["SB"]) -> "Variation_1463":
        ...
    @overload
    def del_item(self, key : Literal["G"]) -> "Variation_1463":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1463_Arg) -> 'Variation_1463':
        return cls._create(arg) # type: ignore

RuleVariation_1386_Arg: TypeAlias = Variation_1463_Arg
class RuleVariation_1386(RuleVariationContextFree):
    cv_variation = Variation_1463

    @classmethod
    def create(cls, arg : RuleVariation_1386_Arg) -> "RuleVariation_1386":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1463:
        return self.arg # type: ignore

NonSpare_263_Arg: TypeAlias = RuleVariation_1386_Arg
class NonSpare_263(NonSpare):
    cv_name = "100"
    cv_title = "Area Definition"
    cv_rule = RuleVariation_1386

    @classmethod
    def create(cls, arg : NonSpare_263_Arg) -> "NonSpare_263":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1386:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1463:
        return self.rule.variation

class UapItem_263(UapItem):
    cv_non_spare = NonSpare_263

NonSpare_128_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_128(NonSpare):
    cv_name = "035"
    cv_title = "Track Number 2"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_128_Arg) -> "NonSpare_128":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

class UapItem_128(UapItem):
    cv_non_spare = NonSpare_128

NonSpare_582_Arg: TypeAlias = RuleVariation_383_Arg
class NonSpare_582(NonSpare):
    cv_name = "AI2"
    cv_title = "Aircraft Identifier (in 7 Characters) of Aircraft 2 Involved in the Conflict"
    cv_rule = RuleVariation_383

    @classmethod
    def create(cls, arg : NonSpare_582_Arg) -> "NonSpare_582":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

NonSpare_1299_Arg: TypeAlias = RuleVariation_776_Arg
class NonSpare_1299(NonSpare):
    cv_name = "MODE3A"
    cv_title = "Mode-3/A Code (Converted Into Octal Representation) of Aircraft 2 Involved in the Conflict"
    cv_rule = RuleVariation_776

    @classmethod
    def create(cls, arg : NonSpare_1299_Arg) -> "NonSpare_1299":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_776:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_806:
        return self.rule.variation

Item_571_Arg: TypeAlias = NonSpare_1299_Arg
class Item_571(Item):
    cv_non_spare = NonSpare_1299

    @classmethod
    def create(cls, arg : Item_571_Arg) -> "Item_571":
        return cls._create(arg) # type: ignore

Variation_1025_Arg_Group = Tuple[int, Union[RuleVariation_776_Arg, Tuple[Literal["MODE3A"], RuleVariation_776_Arg]]]
Variation_1025_Arg: TypeAlias = Union[int, Variation_1025_Arg_Group]
class Variation_1025(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_571, 12)]
    cv_items_dict = {"MODE3A": RuleVariation_776}

    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_776:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_776:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1025_Arg) -> 'Variation_1025':
        return cls._create(arg) # type: ignore

RuleVariation_994_Arg: TypeAlias = Variation_1025_Arg
class RuleVariation_994(RuleVariationContextFree):
    cv_variation = Variation_1025

    @classmethod
    def create(cls, arg : RuleVariation_994_Arg) -> "RuleVariation_994":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1025:
        return self.arg # type: ignore

NonSpare_1205_Arg: TypeAlias = RuleVariation_994_Arg
class NonSpare_1205(NonSpare):
    cv_name = "M32"
    cv_title = "Mode 3/A Code Aircraft 2"
    cv_rule = RuleVariation_994

    @classmethod
    def create(cls, arg : NonSpare_1205_Arg) -> "NonSpare_1205":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_994:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1025:
        return self.rule.variation

NonSpare_817_Arg: TypeAlias = RuleVariation_1077_Arg
class NonSpare_817(NonSpare):
    cv_name = "CPW"
    cv_title = "Predicted Conflict Position Target 2 in WGS-84 Coordinates"
    cv_rule = RuleVariation_1077

    @classmethod
    def create(cls, arg : NonSpare_817_Arg) -> "NonSpare_817":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1077:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1120:
        return self.rule.variation

NonSpare_814_Arg: TypeAlias = RuleVariation_1230_Arg
class NonSpare_814(NonSpare):
    cv_name = "CPL"
    cv_title = "Predicted Conflict Position for the Aircraft 2 Involved in the Conflict"
    cv_rule = RuleVariation_1230

    @classmethod
    def create(cls, arg : NonSpare_814_Arg) -> "NonSpare_814":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1230:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1300:
        return self.rule.variation

NonSpare_1936_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_1936(NonSpare):
    cv_name = "TT2"
    cv_title = "Time to Runway Threshold for Second Approaching Aircraft in a RIMCA"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_1936_Arg) -> "NonSpare_1936":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

NonSpare_898_Arg: TypeAlias = RuleVariation_302_Arg
class NonSpare_898(NonSpare):
    cv_name = "DT2"
    cv_title = "Distance to Runway Threshold for Aircraft 2 Involved in a RIMCA"
    cv_rule = RuleVariation_302

    @classmethod
    def create(cls, arg : NonSpare_898_Arg) -> "NonSpare_898":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_302:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_309:
        return self.rule.variation

NonSpare_554_Arg: TypeAlias = RuleVariation_1277_Arg
class NonSpare_554(NonSpare):
    cv_name = "AC2"
    cv_title = "Characteristics of Aircraft 2 Involved in the Conflict"
    cv_rule = RuleVariation_1277

    @classmethod
    def create(cls, arg : NonSpare_554_Arg) -> "NonSpare_554":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1277:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1354:
        return self.rule.variation

NonSpare_1313_Arg: TypeAlias = RuleVariation_380_Arg
class NonSpare_1313(NonSpare):
    cv_name = "MS2"
    cv_title = "Aircraft Identification Downloaded From Aircraft 2 Involved in the Conflict If Eequipped With a Mode-S Transponder"
    cv_rule = RuleVariation_380

    @classmethod
    def create(cls, arg : NonSpare_1313_Arg) -> "NonSpare_1313":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_380:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_388:
        return self.rule.variation

NonSpare_979_Arg: TypeAlias = RuleVariation_1003_Arg
class NonSpare_979(NonSpare):
    cv_name = "FP2"
    cv_title = "Number of the Flight Plan Correlated to Aircraft 2 Involved in the Conflict"
    cv_rule = RuleVariation_1003

    @classmethod
    def create(cls, arg : NonSpare_979_Arg) -> "NonSpare_979":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1003:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1035:
        return self.rule.variation

NonSpare_719_Arg: TypeAlias = RuleVariation_312_Arg
class NonSpare_719(NonSpare):
    cv_name = "CF2"
    cv_title = "Cleared Flight Level for Aircraft 2 Involved in the Conflict"
    cv_rule = RuleVariation_312

    @classmethod
    def create(cls, arg : NonSpare_719_Arg) -> "NonSpare_719":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_312:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_319:
        return self.rule.variation

Variation_1461_Arg = TypedDict('Variation_1461_Arg', {
    "AI2": NonSpare_582_Arg,
    "M32": NonSpare_1205_Arg,
    "CPW": NonSpare_817_Arg,
    "CPL": NonSpare_814_Arg,
    "TT2": NonSpare_1936_Arg,
    "DT2": NonSpare_898_Arg,
    "AC2": NonSpare_554_Arg,
    "MS2": NonSpare_1313_Arg,
    "FP2": NonSpare_979_Arg,
    "CF2": NonSpare_719_Arg,
}, total=False)
class Variation_1461(Compound):
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_582, NonSpare_1205, NonSpare_817, NonSpare_814, NonSpare_1936, NonSpare_898, NonSpare_554, NonSpare_1313, NonSpare_979, NonSpare_719]
    cv_items_dict = {"AI2": NonSpare_582, "M32": NonSpare_1205, "CPW": NonSpare_817, "CPL": NonSpare_814, "TT2": NonSpare_1936, "DT2": NonSpare_898, "AC2": NonSpare_554, "MS2": NonSpare_1313, "FP2": NonSpare_979, "CF2": NonSpare_719}

    @overload
    @classmethod
    def spec(cls, key : Literal["AI2"]) -> NonSpare_582:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M32"]) -> NonSpare_1205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPW"]) -> NonSpare_817:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPL"]) -> NonSpare_814:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TT2"]) -> NonSpare_1936:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DT2"]) -> NonSpare_898:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AC2"]) -> NonSpare_554:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MS2"]) -> NonSpare_1313:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FP2"]) -> NonSpare_979:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CF2"]) -> NonSpare_719:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AI2"], Literal["M32"], Literal["CPW"], Literal["CPL"], Literal["TT2"], Literal["DT2"], Literal["AC2"], Literal["MS2"], Literal["FP2"], Literal["CF2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AI2"]) -> Optional[NonSpare_582]:
        ...
    @overload
    def get_item(self, key : Literal["M32"]) -> Optional[NonSpare_1205]:
        ...
    @overload
    def get_item(self, key : Literal["CPW"]) -> Optional[NonSpare_817]:
        ...
    @overload
    def get_item(self, key : Literal["CPL"]) -> Optional[NonSpare_814]:
        ...
    @overload
    def get_item(self, key : Literal["TT2"]) -> Optional[NonSpare_1936]:
        ...
    @overload
    def get_item(self, key : Literal["DT2"]) -> Optional[NonSpare_898]:
        ...
    @overload
    def get_item(self, key : Literal["AC2"]) -> Optional[NonSpare_554]:
        ...
    @overload
    def get_item(self, key : Literal["MS2"]) -> Optional[NonSpare_1313]:
        ...
    @overload
    def get_item(self, key : Literal["FP2"]) -> Optional[NonSpare_979]:
        ...
    @overload
    def get_item(self, key : Literal["CF2"]) -> Optional[NonSpare_719]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["AI2"], val : NonSpare_582_Arg) -> "Variation_1461":
        ...
    @overload
    def set_item(self, key : Literal["M32"], val : NonSpare_1205_Arg) -> "Variation_1461":
        ...
    @overload
    def set_item(self, key : Literal["CPW"], val : NonSpare_817_Arg) -> "Variation_1461":
        ...
    @overload
    def set_item(self, key : Literal["CPL"], val : NonSpare_814_Arg) -> "Variation_1461":
        ...
    @overload
    def set_item(self, key : Literal["TT2"], val : NonSpare_1936_Arg) -> "Variation_1461":
        ...
    @overload
    def set_item(self, key : Literal["DT2"], val : NonSpare_898_Arg) -> "Variation_1461":
        ...
    @overload
    def set_item(self, key : Literal["AC2"], val : NonSpare_554_Arg) -> "Variation_1461":
        ...
    @overload
    def set_item(self, key : Literal["MS2"], val : NonSpare_1313_Arg) -> "Variation_1461":
        ...
    @overload
    def set_item(self, key : Literal["FP2"], val : NonSpare_979_Arg) -> "Variation_1461":
        ...
    @overload
    def set_item(self, key : Literal["CF2"], val : NonSpare_719_Arg) -> "Variation_1461":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["AI2"]) -> "Variation_1461":
        ...
    @overload
    def del_item(self, key : Literal["M32"]) -> "Variation_1461":
        ...
    @overload
    def del_item(self, key : Literal["CPW"]) -> "Variation_1461":
        ...
    @overload
    def del_item(self, key : Literal["CPL"]) -> "Variation_1461":
        ...
    @overload
    def del_item(self, key : Literal["TT2"]) -> "Variation_1461":
        ...
    @overload
    def del_item(self, key : Literal["DT2"]) -> "Variation_1461":
        ...
    @overload
    def del_item(self, key : Literal["AC2"]) -> "Variation_1461":
        ...
    @overload
    def del_item(self, key : Literal["MS2"]) -> "Variation_1461":
        ...
    @overload
    def del_item(self, key : Literal["FP2"]) -> "Variation_1461":
        ...
    @overload
    def del_item(self, key : Literal["CF2"]) -> "Variation_1461":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1461_Arg) -> 'Variation_1461':
        return cls._create(arg) # type: ignore

RuleVariation_1384_Arg: TypeAlias = Variation_1461_Arg
class RuleVariation_1384(RuleVariationContextFree):
    cv_variation = Variation_1461

    @classmethod
    def create(cls, arg : RuleVariation_1384_Arg) -> "RuleVariation_1384":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1461:
        return self.arg # type: ignore

NonSpare_377_Arg: TypeAlias = RuleVariation_1384_Arg
class NonSpare_377(NonSpare):
    cv_name = "171"
    cv_title = "Aircraft Identification and Characteristics 2"
    cv_rule = RuleVariation_1384

    @classmethod
    def create(cls, arg : NonSpare_377_Arg) -> "NonSpare_377":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1384:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1461:
        return self.rule.variation

class UapItem_377(UapItem):
    cv_non_spare = NonSpare_377

NonSpare_714_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_714(NonSpare):
    cv_name = "CEN"
    cv_title = ""
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_714_Arg) -> "NonSpare_714":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_146_Arg: TypeAlias = NonSpare_714_Arg
class Item_146(Item):
    cv_non_spare = NonSpare_714

    @classmethod
    def create(cls, arg : Item_146_Arg) -> "Item_146":
        return cls._create(arg) # type: ignore

NonSpare_1433_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_1433(NonSpare):
    cv_name = "POS"
    cv_title = ""
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_1433_Arg) -> "NonSpare_1433":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_688_Arg: TypeAlias = NonSpare_1433_Arg
class Item_688(Item):
    cv_non_spare = NonSpare_1433

    @classmethod
    def create(cls, arg : Item_688_Arg) -> "Item_688":
        return cls._create(arg) # type: ignore

Variation_1062_Arg_Group = Tuple[Union[RuleVariation_158_Arg, Tuple[Literal["CEN"], RuleVariation_158_Arg]], Union[RuleVariation_158_Arg, Tuple[Literal["POS"], RuleVariation_158_Arg]]]
Variation_1062_Arg: TypeAlias = Union[int, Variation_1062_Arg_Group]
class Variation_1062(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_146, 8), (Item_688, 8)]
    cv_items_dict = {"CEN": RuleVariation_158, "POS": RuleVariation_158}

    @overload
    @classmethod
    def spec(cls, key : Literal["CEN"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> RuleVariation_158:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CEN"], Literal["POS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CEN"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> RuleVariation_158:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1062_Arg) -> 'Variation_1062':
        return cls._create(arg) # type: ignore

Variation_1406_Arg: TypeAlias = List[Variation_1062_Arg]
class Variation_1406(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1062

    @classmethod
    def create(cls, arg : Variation_1406_Arg) -> 'Variation_1406':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1062]:
        return self._get_list() # type: ignore

RuleVariation_1329_Arg: TypeAlias = Variation_1406_Arg
class RuleVariation_1329(RuleVariationContextFree):
    cv_variation = Variation_1406

    @classmethod
    def create(cls, arg : RuleVariation_1329_Arg) -> "RuleVariation_1329":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1406:
        return self.arg # type: ignore

NonSpare_282_Arg: TypeAlias = RuleVariation_1329_Arg
class NonSpare_282(NonSpare):
    cv_name = "110"
    cv_title = "FDPS Sector Control Identification"
    cv_rule = RuleVariation_1329

    @classmethod
    def create(cls, arg : NonSpare_282_Arg) -> "NonSpare_282":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1329:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1406:
        return self.rule.variation

class UapItem_282(UapItem):
    cv_non_spare = NonSpare_282

Variation_1454_Arg: TypeAlias = bytes
class Variation_1454(Explicit):
    cv_explicit_type = ReservedExpansion

    @classmethod
    def create(cls, arg : Variation_1454_Arg) -> 'Variation_1454':
        return cls._create(arg) # type: ignore

RuleVariation_1377_Arg: TypeAlias = Variation_1454_Arg
class RuleVariation_1377(RuleVariationContextFree):
    cv_variation = Variation_1454

    @classmethod
    def create(cls, arg : RuleVariation_1377_Arg) -> "RuleVariation_1377":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1454:
        return self.arg # type: ignore

NonSpare_1558_Arg: TypeAlias = RuleVariation_1377_Arg
class NonSpare_1558(NonSpare):
    cv_name = "RE"
    cv_title = "Reserved Expansion Field"
    cv_rule = RuleVariation_1377

    @classmethod
    def create(cls, arg : NonSpare_1558_Arg) -> "NonSpare_1558":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1377:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1454:
        return self.rule.variation

class UapItem_542(UapItem):
    cv_non_spare = NonSpare_1558

Record_13_Arg = TypedDict('Record_13_Arg', {
    "010": NonSpare_33_Arg,
    "000": NonSpare_2_Arg,
    "015": NonSpare_57_Arg,
    "020": NonSpare_92_Arg,
    "040": NonSpare_134_Arg,
    "045": NonSpare_161_Arg,
    "060": NonSpare_192_Arg,
    "030": NonSpare_112_Arg,
    "170": NonSpare_365_Arg,
    "120": NonSpare_293_Arg,
    "070": NonSpare_200_Arg,
    "076": NonSpare_226_Arg,
    "074": NonSpare_221_Arg,
    "075": NonSpare_224_Arg,
    "100": NonSpare_263_Arg,
    "035": NonSpare_128_Arg,
    "171": NonSpare_377_Arg,
    "110": NonSpare_282_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_13(Record):
    cv_fspec_max_bytes = 3
    cv_items_list = [UapItem_33, UapItem_2, UapItem_57, UapItem_92, UapItem_134, UapItem_161, UapItem_192, UapItem_112, UapItem_365, UapItem_293, UapItem_200, UapItem_226, UapItem_221, UapItem_224, UapItem_263, UapItem_128, UapItem_377, UapItem_282, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_33, "000": NonSpare_2, "015": NonSpare_57, "020": NonSpare_92, "040": NonSpare_134, "045": NonSpare_161, "060": NonSpare_192, "030": NonSpare_112, "170": NonSpare_365, "120": NonSpare_293, "070": NonSpare_200, "076": NonSpare_226, "074": NonSpare_221, "075": NonSpare_224, "100": NonSpare_263, "035": NonSpare_128, "171": NonSpare_377, "110": NonSpare_282, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_33:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_2:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_57:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_92:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_134:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["045"]) -> NonSpare_161:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_192:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_112:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_365:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_293:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_200:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["076"]) -> NonSpare_226:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["074"]) -> NonSpare_221:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["075"]) -> NonSpare_224:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_263:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["035"]) -> NonSpare_128:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["171"]) -> NonSpare_377:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_282:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["015"], Literal["020"], Literal["040"], Literal["045"], Literal["060"], Literal["030"], Literal["170"], Literal["120"], Literal["070"], Literal["076"], Literal["074"], Literal["075"], Literal["100"], Literal["035"], Literal["171"], Literal["110"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_33]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_2]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_57]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_92]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_134]:
        ...
    @overload
    def get_item(self, key : Literal["045"]) -> Optional[NonSpare_161]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_192]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_112]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_365]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_293]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_200]:
        ...
    @overload
    def get_item(self, key : Literal["076"]) -> Optional[NonSpare_226]:
        ...
    @overload
    def get_item(self, key : Literal["074"]) -> Optional[NonSpare_221]:
        ...
    @overload
    def get_item(self, key : Literal["075"]) -> Optional[NonSpare_224]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_263]:
        ...
    @overload
    def get_item(self, key : Literal["035"]) -> Optional[NonSpare_128]:
        ...
    @overload
    def get_item(self, key : Literal["171"]) -> Optional[NonSpare_377]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_282]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_33_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_2_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_57_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_92_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_134_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["045"], val : NonSpare_161_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_192_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_112_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_365_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_293_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_200_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["076"], val : NonSpare_226_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["074"], val : NonSpare_221_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["075"], val : NonSpare_224_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_263_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["035"], val : NonSpare_128_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["171"], val : NonSpare_377_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_282_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_13':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["045"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["076"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["074"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["075"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["035"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["171"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_13':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_13_Arg) -> 'Record_13':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_13", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_13_Arg: TypeAlias = Record_13
class Uap_13(UapSingle):
    cv_record = Record_13

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_13]]:
        return cls._parse(bs)

class Asterix_5(AstCat):
    cv_category = 4
    cv_edition = (1, 12)
    cv_uap = Uap_13

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_13_Arg]) -> "Asterix_5":
        return cls._create(records) # type: ignore

Content_589_Arg: TypeAlias = int
class Content_589(ContentTable):
    cv_values = {1: "Polar vector", 2: "Cartesian vector of start point/length", 3: "Contour record", 4: "Cartesian start point and end point vector", 254: "SOP message", 255: "EOP message"}

RuleContent_589_Arg: TypeAlias = Content_589_Arg
class RuleContent_589(RuleContentContextFree):
    cv_content = Content_589

    @property
    def content(self) -> Content_589:
        return self._get_content() # type: ignore

Variation_190_Arg: TypeAlias = RuleContent_589_Arg
class Variation_190(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_589

    @classmethod
    def create(cls, arg : Variation_190_Arg) -> "Variation_190":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_589:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_589:
        return self.rule.content

RuleVariation_183_Arg: TypeAlias = Variation_190_Arg
class RuleVariation_183(RuleVariationContextFree):
    cv_variation = Variation_190

    @classmethod
    def create(cls, arg : RuleVariation_183_Arg) -> "RuleVariation_183":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_190:
        return self.arg # type: ignore

NonSpare_7_Arg: TypeAlias = RuleVariation_183_Arg
class NonSpare_7(NonSpare):
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule = RuleVariation_183

    @classmethod
    def create(cls, arg : NonSpare_7_Arg) -> "NonSpare_7":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_183:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_190:
        return self.rule.variation

class UapItem_7(UapItem):
    cv_non_spare = NonSpare_7

Content_257_Arg: TypeAlias = int
class Content_257(ContentTable):
    cv_values = {0: "Local Coordinates", 1: "System Coordinates"}

RuleContent_257_Arg: TypeAlias = Content_257_Arg
class RuleContent_257(RuleContentContextFree):
    cv_content = Content_257

    @property
    def content(self) -> Content_257:
        return self._get_content() # type: ignore

Variation_51_Arg: TypeAlias = RuleContent_257_Arg
class Variation_51(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_257

    @classmethod
    def create(cls, arg : Variation_51_Arg) -> "Variation_51":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_257:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_257:
        return self.rule.content

RuleVariation_51_Arg: TypeAlias = Variation_51_Arg
class RuleVariation_51(RuleVariationContextFree):
    cv_variation = Variation_51

    @classmethod
    def create(cls, arg : RuleVariation_51_Arg) -> "RuleVariation_51":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_51:
        return self.arg # type: ignore

Variation_485_Arg: TypeAlias = RuleContent_610_Arg
class Variation_485(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 3
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_485_Arg) -> "Variation_485":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_474_Arg: TypeAlias = Variation_485_Arg
class RuleVariation_474(RuleVariationContextFree):
    cv_variation = Variation_485

    @classmethod
    def create(cls, arg : RuleVariation_474_Arg) -> "RuleVariation_474":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_485:
        return self.arg # type: ignore

Content_2_Arg: TypeAlias = int
class Content_2(ContentTable):
    cv_values = {0: "0°", 1: "22.5°", 2: "45°", 3: "67.5°", 4: "90°", 5: "112.5°", 6: "135°", 7: "157.5°"}

RuleContent_2_Arg: TypeAlias = Content_2_Arg
class RuleContent_2(RuleContentContextFree):
    cv_content = Content_2

    @property
    def content(self) -> Content_2:
        return self._get_content() # type: ignore

Variation_772_Arg: TypeAlias = RuleContent_2_Arg
class Variation_772(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_2

    @classmethod
    def create(cls, arg : Variation_772_Arg) -> "Variation_772":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_2:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_2:
        return self.rule.content

RuleVariation_761_Arg: TypeAlias = Variation_772_Arg
class RuleVariation_761(RuleVariationContextFree):
    cv_variation = Variation_772

    @classmethod
    def create(cls, arg : RuleVariation_761_Arg) -> "RuleVariation_761":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_772:
        return self.arg # type: ignore

Content_156_Arg: TypeAlias = int
class Content_156(ContentTable):
    cv_values = {0: "Default", 1: "Test vector"}

RuleContent_156_Arg: TypeAlias = Content_156_Arg
class RuleContent_156(RuleContentContextFree):
    cv_content = Content_156

    @property
    def content(self) -> Content_156:
        return self._get_content() # type: ignore

Variation_837_Arg: TypeAlias = RuleContent_156_Arg
class Variation_837(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_156

    @classmethod
    def create(cls, arg : Variation_837_Arg) -> "Variation_837":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_156:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_156:
        return self.rule.content

RuleVariation_807_Arg: TypeAlias = Variation_837_Arg
class RuleVariation_807(RuleVariationContextFree):
    cv_variation = Variation_837

    @classmethod
    def create(cls, arg : RuleVariation_807_Arg) -> "RuleVariation_807":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_837:
        return self.arg # type: ignore

Content_95_Arg: TypeAlias = int
class Content_95(ContentTable):
    cv_values = {0: "Default", 1: "Error condition encountered"}

RuleContent_95_Arg: TypeAlias = Content_95_Arg
class RuleContent_95(RuleContentContextFree):
    cv_content = Content_95

    @property
    def content(self) -> Content_95:
        return self._get_content() # type: ignore

Variation_908_Arg: TypeAlias = RuleContent_95_Arg
class Variation_908(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_95

    @classmethod
    def create(cls, arg : Variation_908_Arg) -> "Variation_908":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_95:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_95:
        return self.rule.content

RuleVariation_878_Arg: TypeAlias = Variation_908_Arg
class RuleVariation_878(RuleVariationContextFree):
    cv_variation = Variation_908

    @classmethod
    def create(cls, arg : RuleVariation_878_Arg) -> "RuleVariation_878":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_908:
        return self.arg # type: ignore

NonSpare_1392_Arg: TypeAlias = RuleVariation_51_Arg
class NonSpare_1392(NonSpare):
    cv_name = "ORG"
    cv_title = ""
    cv_rule = RuleVariation_51

    @classmethod
    def create(cls, arg : NonSpare_1392_Arg) -> "NonSpare_1392":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_51:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_51:
        return self.rule.variation

Item_657_Arg: TypeAlias = NonSpare_1392_Arg
class Item_657(Item):
    cv_non_spare = NonSpare_1392

    @classmethod
    def create(cls, arg : Item_657_Arg) -> "Item_657":
        return cls._create(arg) # type: ignore

NonSpare_1079_Arg: TypeAlias = RuleVariation_474_Arg
class NonSpare_1079(NonSpare):
    cv_name = "I"
    cv_title = "Intensity Level"
    cv_rule = RuleVariation_474

    @classmethod
    def create(cls, arg : NonSpare_1079_Arg) -> "NonSpare_1079":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_474:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_485:
        return self.rule.variation

Item_407_Arg: TypeAlias = NonSpare_1079_Arg
class Item_407(Item):
    cv_non_spare = NonSpare_1079

    @classmethod
    def create(cls, arg : Item_407_Arg) -> "Item_407":
        return cls._create(arg) # type: ignore

NonSpare_1637_Arg: TypeAlias = RuleVariation_761_Arg
class NonSpare_1637(NonSpare):
    cv_name = "S"
    cv_title = "Shading Orientation with Respect to North"
    cv_rule = RuleVariation_761

    @classmethod
    def create(cls, arg : NonSpare_1637_Arg) -> "NonSpare_1637":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_761:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_772:
        return self.rule.variation

Item_846_Arg: TypeAlias = NonSpare_1637_Arg
class Item_846(Item):
    cv_non_spare = NonSpare_1637

    @classmethod
    def create(cls, arg : Item_846_Arg) -> "Item_846":
        return cls._create(arg) # type: ignore

NonSpare_1927_Arg: TypeAlias = RuleVariation_807_Arg
class NonSpare_1927(NonSpare):
    cv_name = "TST"
    cv_title = ""
    cv_rule = RuleVariation_807

    @classmethod
    def create(cls, arg : NonSpare_1927_Arg) -> "NonSpare_1927":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_807:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_837:
        return self.rule.variation

Item_1050_Arg: TypeAlias = NonSpare_1927_Arg
class Item_1050(Item):
    cv_non_spare = NonSpare_1927

    @classmethod
    def create(cls, arg : Item_1050_Arg) -> "Item_1050":
        return cls._create(arg) # type: ignore

NonSpare_948_Arg: TypeAlias = RuleVariation_878_Arg
class NonSpare_948(NonSpare):
    cv_name = "ER"
    cv_title = ""
    cv_rule = RuleVariation_878

    @classmethod
    def create(cls, arg : NonSpare_948_Arg) -> "NonSpare_948":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_878:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_908:
        return self.rule.variation

Item_315_Arg: TypeAlias = NonSpare_948_Arg
class Item_315(Item):
    cv_non_spare = NonSpare_948

    @classmethod
    def create(cls, arg : Item_315_Arg) -> "Item_315":
        return cls._create(arg) # type: ignore

Variation_1371_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_51_Arg, Tuple[Literal["ORG"], RuleVariation_51_Arg]], Union[RuleVariation_474_Arg, Tuple[Literal["I"], RuleVariation_474_Arg]], Union[RuleVariation_761_Arg, Tuple[Literal["S"], RuleVariation_761_Arg]], None]]
Variation_1371_Arg_Group_2: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_807_Arg, Tuple[Literal["TST"], RuleVariation_807_Arg]], Union[RuleVariation_878_Arg, Tuple[Literal["ER"], RuleVariation_878_Arg]], None]]
Variation_1371_Arg: TypeAlias = Union[
    Tuple[Variation_1371_Arg_Group_1],
    Tuple[Variation_1371_Arg_Group_1, Variation_1371_Arg_Group_2],
]
class Variation_1371(Extended):
    cv_items_list = [[(Item_657, 1), (Item_407, 3), (Item_846, 3), None], [(Item_4, 5), (Item_1050, 1), (Item_315, 1), None]]

    @classmethod
    def create(cls, arg : Variation_1371_Arg) -> 'Variation_1371':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["ORG"]) -> RuleVariation_51:
        ...
    @overload
    def get_item(self, key : Literal["I"]) -> RuleVariation_474:
        ...
    @overload
    def get_item(self, key : Literal["S"]) -> RuleVariation_761:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_807]:
        ...
    @overload
    def get_item(self, key : Literal["ER"]) -> Optional[RuleVariation_878]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1294_Arg: TypeAlias = Variation_1371_Arg
class RuleVariation_1294(RuleVariationContextFree):
    cv_variation = Variation_1371

    @classmethod
    def create(cls, arg : RuleVariation_1294_Arg) -> "RuleVariation_1294":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1371:
        return self.arg # type: ignore

NonSpare_94_Arg: TypeAlias = RuleVariation_1294_Arg
class NonSpare_94(NonSpare):
    cv_name = "020"
    cv_title = "Vector Qualifier"
    cv_rule = RuleVariation_1294

    @classmethod
    def create(cls, arg : NonSpare_94_Arg) -> "NonSpare_94":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1294:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1371:
        return self.rule.variation

class UapItem_94(UapItem):
    cv_non_spare = NonSpare_94

Content_609_Arg: TypeAlias = int
class Content_609(ContentInteger):
    cv_signedness = Signed

RuleContent_609_Arg: TypeAlias = Content_609_Arg
class RuleContent_609(RuleContentContextFree):
    cv_content = Content_609

    @property
    def content(self) -> Content_609:
        return self._get_content() # type: ignore

Variation_202_Arg: TypeAlias = RuleContent_609_Arg
class Variation_202(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_609

    @classmethod
    def create(cls, arg : Variation_202_Arg) -> "Variation_202":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_609:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_609:
        return self.rule.content

RuleVariation_195_Arg: TypeAlias = Variation_202_Arg
class RuleVariation_195(RuleVariationContextFree):
    cv_variation = Variation_202

    @classmethod
    def create(cls, arg : RuleVariation_195_Arg) -> "RuleVariation_195":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_202:
        return self.arg # type: ignore

NonSpare_2087_Arg: TypeAlias = RuleVariation_195_Arg
class NonSpare_2087(NonSpare):
    cv_name = "X"
    cv_title = "X-Component"
    cv_rule = RuleVariation_195

    @classmethod
    def create(cls, arg : NonSpare_2087_Arg) -> "NonSpare_2087":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_195:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_202:
        return self.rule.variation

Item_1194_Arg: TypeAlias = NonSpare_2087_Arg
class Item_1194(Item):
    cv_non_spare = NonSpare_2087

    @classmethod
    def create(cls, arg : Item_1194_Arg) -> "Item_1194":
        return cls._create(arg) # type: ignore

NonSpare_2141_Arg: TypeAlias = RuleVariation_195_Arg
class NonSpare_2141(NonSpare):
    cv_name = "Y"
    cv_title = "Y-Component"
    cv_rule = RuleVariation_195

    @classmethod
    def create(cls, arg : NonSpare_2141_Arg) -> "NonSpare_2141":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_195:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_202:
        return self.rule.variation

Item_1245_Arg: TypeAlias = NonSpare_2141_Arg
class Item_1245(Item):
    cv_non_spare = NonSpare_2141

    @classmethod
    def create(cls, arg : Item_1245_Arg) -> "Item_1245":
        return cls._create(arg) # type: ignore

Variation_203_Arg: TypeAlias = RuleContent_610_Arg
class Variation_203(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_203_Arg) -> "Variation_203":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_196_Arg: TypeAlias = Variation_203_Arg
class RuleVariation_196(RuleVariationContextFree):
    cv_variation = Variation_203

    @classmethod
    def create(cls, arg : RuleVariation_196_Arg) -> "RuleVariation_196":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_203:
        return self.arg # type: ignore

NonSpare_1160_Arg: TypeAlias = RuleVariation_196_Arg
class NonSpare_1160(NonSpare):
    cv_name = "LENGTH"
    cv_title = "Length"
    cv_rule = RuleVariation_196

    @classmethod
    def create(cls, arg : NonSpare_1160_Arg) -> "NonSpare_1160":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_203:
        return self.rule.variation

Item_476_Arg: TypeAlias = NonSpare_1160_Arg
class Item_476(Item):
    cv_non_spare = NonSpare_1160

    @classmethod
    def create(cls, arg : Item_476_Arg) -> "Item_476":
        return cls._create(arg) # type: ignore

Variation_1304_Arg_Group = Tuple[Union[RuleVariation_195_Arg, Tuple[Literal["X"], RuleVariation_195_Arg]], Union[RuleVariation_195_Arg, Tuple[Literal["Y"], RuleVariation_195_Arg]], Union[RuleVariation_196_Arg, Tuple[Literal["LENGTH"], RuleVariation_196_Arg]]]
Variation_1304_Arg: TypeAlias = Union[int, Variation_1304_Arg_Group]
class Variation_1304(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_1194, 8), (Item_1245, 8), (Item_476, 8)]
    cv_items_dict = {"X": RuleVariation_195, "Y": RuleVariation_195, "LENGTH": RuleVariation_196}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_195:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_195:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LENGTH"]) -> RuleVariation_196:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"], Literal["LENGTH"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_195:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_195:
        ...
    @overload
    def get_item(self, key : Literal["LENGTH"]) -> RuleVariation_196:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1304_Arg) -> 'Variation_1304':
        return cls._create(arg) # type: ignore

Variation_1442_Arg: TypeAlias = List[Variation_1304_Arg]
class Variation_1442(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1304

    @classmethod
    def create(cls, arg : Variation_1442_Arg) -> 'Variation_1442':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1304]:
        return self._get_list() # type: ignore

RuleVariation_1365_Arg: TypeAlias = Variation_1442_Arg
class RuleVariation_1365(RuleVariationContextFree):
    cv_variation = Variation_1442

    @classmethod
    def create(cls, arg : RuleVariation_1365_Arg) -> "RuleVariation_1365":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1442:
        return self.arg # type: ignore

NonSpare_131_Arg: TypeAlias = RuleVariation_1365_Arg
class NonSpare_131(NonSpare):
    cv_name = "036"
    cv_title = "Sequence of Cartesian Vectors in SPF Notation"
    cv_rule = RuleVariation_1365

    @classmethod
    def create(cls, arg : NonSpare_131_Arg) -> "NonSpare_131":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1365:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1442:
        return self.rule.variation

class UapItem_131(UapItem):
    cv_non_spare = NonSpare_131

NonSpare_1788_Arg: TypeAlias = RuleVariation_196_Arg
class NonSpare_1788(NonSpare):
    cv_name = "STR"
    cv_title = "Start Range"
    cv_rule = RuleVariation_196

    @classmethod
    def create(cls, arg : NonSpare_1788_Arg) -> "NonSpare_1788":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_203:
        return self.rule.variation

Item_954_Arg: TypeAlias = NonSpare_1788_Arg
class Item_954(Item):
    cv_non_spare = NonSpare_1788

    @classmethod
    def create(cls, arg : Item_954_Arg) -> "Item_954":
        return cls._create(arg) # type: ignore

NonSpare_927_Arg: TypeAlias = RuleVariation_196_Arg
class NonSpare_927(NonSpare):
    cv_name = "ENDR"
    cv_title = "End Range"
    cv_rule = RuleVariation_196

    @classmethod
    def create(cls, arg : NonSpare_927_Arg) -> "NonSpare_927":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_203:
        return self.rule.variation

Item_294_Arg: TypeAlias = NonSpare_927_Arg
class Item_294(Item):
    cv_non_spare = NonSpare_927

    @classmethod
    def create(cls, arg : Item_294_Arg) -> "Item_294":
        return cls._create(arg) # type: ignore

NonSpare_657_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_657(NonSpare):
    cv_name = "AZ"
    cv_title = "Azimuth"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_657_Arg) -> "NonSpare_657":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Item_105_Arg: TypeAlias = NonSpare_657_Arg
class Item_105(Item):
    cv_non_spare = NonSpare_657

    @classmethod
    def create(cls, arg : Item_105_Arg) -> "Item_105":
        return cls._create(arg) # type: ignore

Variation_1213_Arg_Group = Tuple[Union[RuleVariation_196_Arg, Tuple[Literal["STR"], RuleVariation_196_Arg]], Union[RuleVariation_196_Arg, Tuple[Literal["ENDR"], RuleVariation_196_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["AZ"], RuleVariation_334_Arg]]]
Variation_1213_Arg: TypeAlias = Union[int, Variation_1213_Arg_Group]
class Variation_1213(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_954, 8), (Item_294, 8), (Item_105, 16)]
    cv_items_dict = {"STR": RuleVariation_196, "ENDR": RuleVariation_196, "AZ": RuleVariation_334}

    @overload
    @classmethod
    def spec(cls, key : Literal["STR"]) -> RuleVariation_196:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ENDR"]) -> RuleVariation_196:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AZ"]) -> RuleVariation_334:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["STR"], Literal["ENDR"], Literal["AZ"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["STR"]) -> RuleVariation_196:
        ...
    @overload
    def get_item(self, key : Literal["ENDR"]) -> RuleVariation_196:
        ...
    @overload
    def get_item(self, key : Literal["AZ"]) -> RuleVariation_334:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1213_Arg) -> 'Variation_1213':
        return cls._create(arg) # type: ignore

Variation_1426_Arg: TypeAlias = List[Variation_1213_Arg]
class Variation_1426(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1213

    @classmethod
    def create(cls, arg : Variation_1426_Arg) -> 'Variation_1426':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1213]:
        return self._get_list() # type: ignore

RuleVariation_1349_Arg: TypeAlias = Variation_1426_Arg
class RuleVariation_1349(RuleVariationContextFree):
    cv_variation = Variation_1426

    @classmethod
    def create(cls, arg : RuleVariation_1349_Arg) -> "RuleVariation_1349":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1426:
        return self.arg # type: ignore

NonSpare_126_Arg: TypeAlias = RuleVariation_1349_Arg
class NonSpare_126(NonSpare):
    cv_name = "034"
    cv_title = "Sequence of Polar Vectors in SPF Notation"
    cv_rule = RuleVariation_1349

    @classmethod
    def create(cls, arg : NonSpare_126_Arg) -> "NonSpare_126":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1349:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1426:
        return self.rule.variation

class UapItem_126(UapItem):
    cv_non_spare = NonSpare_126

Variation_480_Arg: TypeAlias = RuleContent_0_Arg
class Variation_480(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 3
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_480_Arg) -> "Variation_480":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_469_Arg: TypeAlias = Variation_480_Arg
class RuleVariation_469(RuleVariationContextFree):
    cv_variation = Variation_480

    @classmethod
    def create(cls, arg : RuleVariation_469_Arg) -> "RuleVariation_469":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_480:
        return self.arg # type: ignore

NonSpare_1078_Arg: TypeAlias = RuleVariation_469_Arg
class NonSpare_1078(NonSpare):
    cv_name = "I"
    cv_title = "Intensity Level"
    cv_rule = RuleVariation_469

    @classmethod
    def create(cls, arg : NonSpare_1078_Arg) -> "NonSpare_1078":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_469:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_480:
        return self.rule.variation

Item_406_Arg: TypeAlias = NonSpare_1078_Arg
class Item_406(Item):
    cv_non_spare = NonSpare_1078

    @classmethod
    def create(cls, arg : Item_406_Arg) -> "Item_406":
        return cls._create(arg) # type: ignore

Item_20_Arg: TypeAlias = int
class Item_20(Spare):
    cv_bit_offset8 = 4
    cv_bit_size = 2

Content_245_Arg: TypeAlias = int
class Content_245(ContentTable):
    cv_values = {0: "Intermediate record of a contour", 1: "Last record of a contour of at least two records", 2: "First record of a contour of at least two records", 3: "First and only record, fully defining a contour"}

RuleContent_245_Arg: TypeAlias = Content_245_Arg
class RuleContent_245(RuleContentContextFree):
    cv_content = Content_245

    @property
    def content(self) -> Content_245:
        return self._get_content() # type: ignore

Variation_958_Arg: TypeAlias = RuleContent_245_Arg
class Variation_958(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 2
    cv_rule = RuleContent_245

    @classmethod
    def create(cls, arg : Variation_958_Arg) -> "Variation_958":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_245:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_245:
        return self.rule.content

RuleVariation_928_Arg: TypeAlias = Variation_958_Arg
class RuleVariation_928(RuleVariationContextFree):
    cv_variation = Variation_958

    @classmethod
    def create(cls, arg : RuleVariation_928_Arg) -> "RuleVariation_928":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_958:
        return self.arg # type: ignore

NonSpare_996_Arg: TypeAlias = RuleVariation_928_Arg
class NonSpare_996(NonSpare):
    cv_name = "FSTLST"
    cv_title = ""
    cv_rule = RuleVariation_928

    @classmethod
    def create(cls, arg : NonSpare_996_Arg) -> "NonSpare_996":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_928:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_958:
        return self.rule.variation

Item_348_Arg: TypeAlias = NonSpare_996_Arg
class Item_348(Item):
    cv_non_spare = NonSpare_996

    @classmethod
    def create(cls, arg : Item_348_Arg) -> "Item_348":
        return cls._create(arg) # type: ignore

NonSpare_828_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_828(NonSpare):
    cv_name = "CSN"
    cv_title = "Contour Serial Number"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_828_Arg) -> "NonSpare_828":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_218_Arg: TypeAlias = NonSpare_828_Arg
class Item_218(Item):
    cv_non_spare = NonSpare_828

    @classmethod
    def create(cls, arg : Item_218_Arg) -> "Item_218":
        return cls._create(arg) # type: ignore

Variation_1150_Arg_Group = Tuple[Union[RuleVariation_51_Arg, Tuple[Literal["ORG"], RuleVariation_51_Arg]], Union[RuleVariation_469_Arg, Tuple[Literal["I"], RuleVariation_469_Arg]], int, Union[RuleVariation_928_Arg, Tuple[Literal["FSTLST"], RuleVariation_928_Arg]], Union[RuleVariation_158_Arg, Tuple[Literal["CSN"], RuleVariation_158_Arg]]]
Variation_1150_Arg: TypeAlias = Union[int, Variation_1150_Arg_Group]
class Variation_1150(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_657, 1), (Item_406, 3), (Item_20, 2), (Item_348, 2), (Item_218, 8)]
    cv_items_dict = {"ORG": RuleVariation_51, "I": RuleVariation_469, "FSTLST": RuleVariation_928, "CSN": RuleVariation_158}

    @overload
    @classmethod
    def spec(cls, key : Literal["ORG"]) -> RuleVariation_51:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I"]) -> RuleVariation_469:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FSTLST"]) -> RuleVariation_928:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CSN"]) -> RuleVariation_158:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ORG"], Literal["I"], Literal["FSTLST"], Literal["CSN"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ORG"]) -> RuleVariation_51:
        ...
    @overload
    def get_item(self, key : Literal["I"]) -> RuleVariation_469:
        ...
    @overload
    def get_item(self, key : Literal["FSTLST"]) -> RuleVariation_928:
        ...
    @overload
    def get_item(self, key : Literal["CSN"]) -> RuleVariation_158:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1150_Arg) -> 'Variation_1150':
        return cls._create(arg) # type: ignore

RuleVariation_1104_Arg: TypeAlias = Variation_1150_Arg
class RuleVariation_1104(RuleVariationContextFree):
    cv_variation = Variation_1150

    @classmethod
    def create(cls, arg : RuleVariation_1104_Arg) -> "RuleVariation_1104":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1150:
        return self.arg # type: ignore

NonSpare_135_Arg: TypeAlias = RuleVariation_1104_Arg
class NonSpare_135(NonSpare):
    cv_name = "040"
    cv_title = "Contour Identifier"
    cv_rule = RuleVariation_1104

    @classmethod
    def create(cls, arg : NonSpare_135_Arg) -> "NonSpare_135":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1104:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1150:
        return self.rule.variation

class UapItem_135(UapItem):
    cv_non_spare = NonSpare_135

NonSpare_2094_Arg: TypeAlias = RuleVariation_195_Arg
class NonSpare_2094(NonSpare):
    cv_name = "X1"
    cv_title = ""
    cv_rule = RuleVariation_195

    @classmethod
    def create(cls, arg : NonSpare_2094_Arg) -> "NonSpare_2094":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_195:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_202:
        return self.rule.variation

Item_1201_Arg: TypeAlias = NonSpare_2094_Arg
class Item_1201(Item):
    cv_non_spare = NonSpare_2094

    @classmethod
    def create(cls, arg : Item_1201_Arg) -> "Item_1201":
        return cls._create(arg) # type: ignore

NonSpare_2148_Arg: TypeAlias = RuleVariation_195_Arg
class NonSpare_2148(NonSpare):
    cv_name = "Y1"
    cv_title = ""
    cv_rule = RuleVariation_195

    @classmethod
    def create(cls, arg : NonSpare_2148_Arg) -> "NonSpare_2148":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_195:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_202:
        return self.rule.variation

Item_1252_Arg: TypeAlias = NonSpare_2148_Arg
class Item_1252(Item):
    cv_non_spare = NonSpare_2148

    @classmethod
    def create(cls, arg : Item_1252_Arg) -> "Item_1252":
        return cls._create(arg) # type: ignore

Variation_1311_Arg_Group = Tuple[Union[RuleVariation_195_Arg, Tuple[Literal["X1"], RuleVariation_195_Arg]], Union[RuleVariation_195_Arg, Tuple[Literal["Y1"], RuleVariation_195_Arg]]]
Variation_1311_Arg: TypeAlias = Union[int, Variation_1311_Arg_Group]
class Variation_1311(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1201, 8), (Item_1252, 8)]
    cv_items_dict = {"X1": RuleVariation_195, "Y1": RuleVariation_195}

    @overload
    @classmethod
    def spec(cls, key : Literal["X1"]) -> RuleVariation_195:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y1"]) -> RuleVariation_195:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X1"], Literal["Y1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X1"]) -> RuleVariation_195:
        ...
    @overload
    def get_item(self, key : Literal["Y1"]) -> RuleVariation_195:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1311_Arg) -> 'Variation_1311':
        return cls._create(arg) # type: ignore

Variation_1444_Arg: TypeAlias = List[Variation_1311_Arg]
class Variation_1444(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1311

    @classmethod
    def create(cls, arg : Variation_1444_Arg) -> 'Variation_1444':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1311]:
        return self._get_list() # type: ignore

RuleVariation_1367_Arg: TypeAlias = Variation_1444_Arg
class RuleVariation_1367(RuleVariationContextFree):
    cv_variation = Variation_1444

    @classmethod
    def create(cls, arg : RuleVariation_1367_Arg) -> "RuleVariation_1367":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1444:
        return self.arg # type: ignore

NonSpare_175_Arg: TypeAlias = RuleVariation_1367_Arg
class NonSpare_175(NonSpare):
    cv_name = "050"
    cv_title = "Sequence of Contour Points in SPF Notation"
    cv_rule = RuleVariation_1367

    @classmethod
    def create(cls, arg : NonSpare_175_Arg) -> "NonSpare_175":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1367:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1444:
        return self.rule.variation

class UapItem_175(UapItem):
    cv_non_spare = NonSpare_175

NonSpare_255_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_255(NonSpare):
    cv_name = "090"
    cv_title = "Time of Day"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_255_Arg) -> "NonSpare_255":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_255(UapItem):
    cv_non_spare = NonSpare_255

Variation_145_Arg: TypeAlias = RuleContent_609_Arg
class Variation_145(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 5
    cv_rule = RuleContent_609

    @classmethod
    def create(cls, arg : Variation_145_Arg) -> "Variation_145":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_609:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_609:
        return self.rule.content

RuleVariation_145_Arg: TypeAlias = Variation_145_Arg
class RuleVariation_145(RuleVariationContextFree):
    cv_variation = Variation_145

    @classmethod
    def create(cls, arg : RuleVariation_145_Arg) -> "RuleVariation_145":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_145:
        return self.arg # type: ignore

Variation_886_Arg: TypeAlias = RuleContent_0_Arg
class Variation_886(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 3
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_886_Arg) -> "Variation_886":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_856_Arg: TypeAlias = Variation_886_Arg
class RuleVariation_856(RuleVariationContextFree):
    cv_variation = Variation_886

    @classmethod
    def create(cls, arg : RuleVariation_856_Arg) -> "RuleVariation_856":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_886:
        return self.arg # type: ignore

Variation_249_Arg: TypeAlias = RuleContent_0_Arg
class Variation_249(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 15
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_249_Arg) -> "Variation_249":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_242_Arg: TypeAlias = Variation_249_Arg
class RuleVariation_242(RuleVariationContextFree):
    cv_variation = Variation_249

    @classmethod
    def create(cls, arg : RuleVariation_242_Arg) -> "RuleVariation_242":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_249:
        return self.arg # type: ignore

NonSpare_960_Arg: TypeAlias = RuleVariation_145_Arg
class NonSpare_960(NonSpare):
    cv_name = "F"
    cv_title = "Scaling Factor"
    cv_rule = RuleVariation_145

    @classmethod
    def create(cls, arg : NonSpare_960_Arg) -> "NonSpare_960":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_145:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_145:
        return self.rule.variation

Item_324_Arg: TypeAlias = NonSpare_960_Arg
class Item_324(Item):
    cv_non_spare = NonSpare_960

    @classmethod
    def create(cls, arg : Item_324_Arg) -> "Item_324":
        return cls._create(arg) # type: ignore

NonSpare_1521_Arg: TypeAlias = RuleVariation_856_Arg
class NonSpare_1521(NonSpare):
    cv_name = "R"
    cv_title = "Current Reduction Stage in Use"
    cv_rule = RuleVariation_856

    @classmethod
    def create(cls, arg : NonSpare_1521_Arg) -> "NonSpare_1521":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_856:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_886:
        return self.rule.variation

Item_759_Arg: TypeAlias = NonSpare_1521_Arg
class Item_759(Item):
    cv_non_spare = NonSpare_1521

    @classmethod
    def create(cls, arg : Item_759_Arg) -> "Item_759":
        return cls._create(arg) # type: ignore

NonSpare_1477_Arg: TypeAlias = RuleVariation_242_Arg
class NonSpare_1477(NonSpare):
    cv_name = "Q"
    cv_title = "Processing Parameters"
    cv_rule = RuleVariation_242

    @classmethod
    def create(cls, arg : NonSpare_1477_Arg) -> "NonSpare_1477":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_242:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_249:
        return self.rule.variation

Item_716_Arg: TypeAlias = NonSpare_1477_Arg
class Item_716(Item):
    cv_non_spare = NonSpare_1477

    @classmethod
    def create(cls, arg : Item_716_Arg) -> "Item_716":
        return cls._create(arg) # type: ignore

Variation_1351_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_145_Arg, Tuple[Literal["F"], RuleVariation_145_Arg]], Union[RuleVariation_856_Arg, Tuple[Literal["R"], RuleVariation_856_Arg]], Union[RuleVariation_242_Arg, Tuple[Literal["Q"], RuleVariation_242_Arg]], None]]
Variation_1351_Arg: TypeAlias = Union[
    Tuple[Variation_1351_Arg_Group_1],
]
class Variation_1351(Extended):
    cv_items_list = [[(Item_324, 5), (Item_759, 3), (Item_716, 15), None]]

    @classmethod
    def create(cls, arg : Variation_1351_Arg) -> 'Variation_1351':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["F"]) -> RuleVariation_145:
        ...
    @overload
    def get_item(self, key : Literal["R"]) -> RuleVariation_856:
        ...
    @overload
    def get_item(self, key : Literal["Q"]) -> RuleVariation_242:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1274_Arg: TypeAlias = Variation_1351_Arg
class RuleVariation_1274(RuleVariationContextFree):
    cv_variation = Variation_1351

    @classmethod
    def create(cls, arg : RuleVariation_1274_Arg) -> "RuleVariation_1274":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1351:
        return self.arg # type: ignore

NonSpare_271_Arg: TypeAlias = RuleVariation_1274_Arg
class NonSpare_271(NonSpare):
    cv_name = "100"
    cv_title = "Processing Status"
    cv_rule = RuleVariation_1274

    @classmethod
    def create(cls, arg : NonSpare_271_Arg) -> "NonSpare_271":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1274:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1351:
        return self.rule.variation

class UapItem_271(UapItem):
    cv_non_spare = NonSpare_271

NonSpare_287_Arg: TypeAlias = RuleVariation_1369_Arg
class NonSpare_287(NonSpare):
    cv_name = "110"
    cv_title = "Station Configuration Status"
    cv_rule = RuleVariation_1369

    @classmethod
    def create(cls, arg : NonSpare_287_Arg) -> "NonSpare_287":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1369:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1446:
        return self.rule.variation

class UapItem_287(UapItem):
    cv_non_spare = NonSpare_287

Variation_254_Arg: TypeAlias = RuleContent_610_Arg
class Variation_254(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_254_Arg) -> "Variation_254":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_247_Arg: TypeAlias = Variation_254_Arg
class RuleVariation_247(RuleVariationContextFree):
    cv_variation = Variation_254

    @classmethod
    def create(cls, arg : RuleVariation_247_Arg) -> "RuleVariation_247":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_254:
        return self.arg # type: ignore

NonSpare_299_Arg: TypeAlias = RuleVariation_247_Arg
class NonSpare_299(NonSpare):
    cv_name = "120"
    cv_title = "Total Number of Items Constituting One Weather Picture"
    cv_rule = RuleVariation_247

    @classmethod
    def create(cls, arg : NonSpare_299_Arg) -> "NonSpare_299":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_247:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_254:
        return self.rule.variation

class UapItem_299(UapItem):
    cv_non_spare = NonSpare_299

NonSpare_2096_Arg: TypeAlias = RuleVariation_195_Arg
class NonSpare_2096(NonSpare):
    cv_name = "X1"
    cv_title = "X1-Component"
    cv_rule = RuleVariation_195

    @classmethod
    def create(cls, arg : NonSpare_2096_Arg) -> "NonSpare_2096":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_195:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_202:
        return self.rule.variation

Item_1203_Arg: TypeAlias = NonSpare_2096_Arg
class Item_1203(Item):
    cv_non_spare = NonSpare_2096

    @classmethod
    def create(cls, arg : Item_1203_Arg) -> "Item_1203":
        return cls._create(arg) # type: ignore

NonSpare_2149_Arg: TypeAlias = RuleVariation_195_Arg
class NonSpare_2149(NonSpare):
    cv_name = "Y1"
    cv_title = "Y1-Component"
    cv_rule = RuleVariation_195

    @classmethod
    def create(cls, arg : NonSpare_2149_Arg) -> "NonSpare_2149":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_195:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_202:
        return self.rule.variation

Item_1253_Arg: TypeAlias = NonSpare_2149_Arg
class Item_1253(Item):
    cv_non_spare = NonSpare_2149

    @classmethod
    def create(cls, arg : Item_1253_Arg) -> "Item_1253":
        return cls._create(arg) # type: ignore

NonSpare_2100_Arg: TypeAlias = RuleVariation_195_Arg
class NonSpare_2100(NonSpare):
    cv_name = "X2"
    cv_title = "X2-Component"
    cv_rule = RuleVariation_195

    @classmethod
    def create(cls, arg : NonSpare_2100_Arg) -> "NonSpare_2100":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_195:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_202:
        return self.rule.variation

Item_1207_Arg: TypeAlias = NonSpare_2100_Arg
class Item_1207(Item):
    cv_non_spare = NonSpare_2100

    @classmethod
    def create(cls, arg : Item_1207_Arg) -> "Item_1207":
        return cls._create(arg) # type: ignore

NonSpare_2151_Arg: TypeAlias = RuleVariation_195_Arg
class NonSpare_2151(NonSpare):
    cv_name = "Y2"
    cv_title = "Y2-Component"
    cv_rule = RuleVariation_195

    @classmethod
    def create(cls, arg : NonSpare_2151_Arg) -> "NonSpare_2151":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_195:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_202:
        return self.rule.variation

Item_1255_Arg: TypeAlias = NonSpare_2151_Arg
class Item_1255(Item):
    cv_non_spare = NonSpare_2151

    @classmethod
    def create(cls, arg : Item_1255_Arg) -> "Item_1255":
        return cls._create(arg) # type: ignore

Variation_1312_Arg_Group = Tuple[Union[RuleVariation_195_Arg, Tuple[Literal["X1"], RuleVariation_195_Arg]], Union[RuleVariation_195_Arg, Tuple[Literal["Y1"], RuleVariation_195_Arg]], Union[RuleVariation_195_Arg, Tuple[Literal["X2"], RuleVariation_195_Arg]], Union[RuleVariation_195_Arg, Tuple[Literal["Y2"], RuleVariation_195_Arg]]]
Variation_1312_Arg: TypeAlias = Union[int, Variation_1312_Arg_Group]
class Variation_1312(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1203, 8), (Item_1253, 8), (Item_1207, 8), (Item_1255, 8)]
    cv_items_dict = {"X1": RuleVariation_195, "Y1": RuleVariation_195, "X2": RuleVariation_195, "Y2": RuleVariation_195}

    @overload
    @classmethod
    def spec(cls, key : Literal["X1"]) -> RuleVariation_195:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y1"]) -> RuleVariation_195:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X2"]) -> RuleVariation_195:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y2"]) -> RuleVariation_195:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X1"], Literal["Y1"], Literal["X2"], Literal["Y2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X1"]) -> RuleVariation_195:
        ...
    @overload
    def get_item(self, key : Literal["Y1"]) -> RuleVariation_195:
        ...
    @overload
    def get_item(self, key : Literal["X2"]) -> RuleVariation_195:
        ...
    @overload
    def get_item(self, key : Literal["Y2"]) -> RuleVariation_195:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1312_Arg) -> 'Variation_1312':
        return cls._create(arg) # type: ignore

Variation_1445_Arg: TypeAlias = List[Variation_1312_Arg]
class Variation_1445(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1312

    @classmethod
    def create(cls, arg : Variation_1445_Arg) -> 'Variation_1445':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1312]:
        return self._get_list() # type: ignore

RuleVariation_1368_Arg: TypeAlias = Variation_1445_Arg
class RuleVariation_1368(RuleVariationContextFree):
    cv_variation = Variation_1445

    @classmethod
    def create(cls, arg : RuleVariation_1368_Arg) -> "RuleVariation_1368":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1445:
        return self.arg # type: ignore

NonSpare_133_Arg: TypeAlias = RuleVariation_1368_Arg
class NonSpare_133(NonSpare):
    cv_name = "038"
    cv_title = "Sequence of Weather Vectors in SPF Notation"
    cv_rule = RuleVariation_1368

    @classmethod
    def create(cls, arg : NonSpare_133_Arg) -> "NonSpare_133":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1368:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1445:
        return self.rule.variation

class UapItem_133(UapItem):
    cv_non_spare = NonSpare_133

Record_19_Arg = TypedDict('Record_19_Arg', {
    "010": NonSpare_36_Arg,
    "000": NonSpare_7_Arg,
    "020": NonSpare_94_Arg,
    "036": NonSpare_131_Arg,
    "034": NonSpare_126_Arg,
    "040": NonSpare_135_Arg,
    "050": NonSpare_175_Arg,
    "090": NonSpare_255_Arg,
    "100": NonSpare_271_Arg,
    "110": NonSpare_287_Arg,
    "120": NonSpare_299_Arg,
    "038": NonSpare_133_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
Record_19_Union = Union[
    Tuple[Literal["010"], NonSpare_36_Arg],
    Tuple[Literal["000"], NonSpare_7_Arg],
    Tuple[Literal["020"], NonSpare_94_Arg],
    Tuple[Literal["036"], NonSpare_131_Arg],
    Tuple[Literal["034"], NonSpare_126_Arg],
    Tuple[Literal["040"], NonSpare_135_Arg],
    Tuple[Literal["050"], NonSpare_175_Arg],
    Tuple[Literal["090"], NonSpare_255_Arg],
    Tuple[Literal["100"], NonSpare_271_Arg],
    Tuple[Literal["110"], NonSpare_287_Arg],
    Tuple[Literal["120"], NonSpare_299_Arg],
    Tuple[Literal["038"], NonSpare_133_Arg],
    Tuple[Literal["SP"], NonSpare_1723_Arg],
]
class Record_19(Record):
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_36, UapItem_7, UapItem_94, UapItem_131, UapItem_126, UapItem_135, UapItem_175, UapItem_255, UapItem_271, UapItem_287, UapItem_299, UapItem_133, UapItem_543, UapItem_545]
    cv_items_dict = {"010": NonSpare_36, "000": NonSpare_7, "020": NonSpare_94, "036": NonSpare_131, "034": NonSpare_126, "040": NonSpare_135, "050": NonSpare_175, "090": NonSpare_255, "100": NonSpare_271, "110": NonSpare_287, "120": NonSpare_299, "038": NonSpare_133, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_36:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_7:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_94:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["036"]) -> NonSpare_131:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["034"]) -> NonSpare_126:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_135:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_175:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_255:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_271:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_287:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_299:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["038"]) -> NonSpare_133:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["020"], Literal["036"], Literal["034"], Literal["040"], Literal["050"], Literal["090"], Literal["100"], Literal["110"], Literal["120"], Literal["038"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_36]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_7]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_94]:
        ...
    @overload
    def get_item(self, key : Literal["036"]) -> Optional[NonSpare_131]:
        ...
    @overload
    def get_item(self, key : Literal["034"]) -> Optional[NonSpare_126]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_135]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_175]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_255]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_271]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_287]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_299]:
        ...
    @overload
    def get_item(self, key : Literal["038"]) -> Optional[NonSpare_133]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_36_Arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_7_Arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_94_Arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["036"], val : NonSpare_131_Arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["034"], val : NonSpare_126_Arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_135_Arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_175_Arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_255_Arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_271_Arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_287_Arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_299_Arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["038"], val : NonSpare_133_Arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_19':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["036"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["034"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["038"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_19':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @overload
    def get_rfs_item(self, arg : Literal["010"]) -> List[NonSpare_36]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["000"]) -> List[NonSpare_7]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["020"]) -> List[NonSpare_94]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["036"]) -> List[NonSpare_131]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["034"]) -> List[NonSpare_126]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["040"]) -> List[NonSpare_135]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["050"]) -> List[NonSpare_175]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["090"]) -> List[NonSpare_255]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["100"]) -> List[NonSpare_271]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["110"]) -> List[NonSpare_287]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["120"]) -> List[NonSpare_299]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["038"]) -> List[NonSpare_133]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["SP"]) -> List[NonSpare_1723]:
        ...
    def get_rfs_item(self, arg : Any) -> Any:
        return self._get_rfs_item(arg)

    @classmethod
    def create(cls, arg : Record_19_Arg, rfs : Optional[List[Record_19_Union]] = None) -> 'Record_19':
        return cls._create(arg, rfs) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_19", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_17_Arg: TypeAlias = Record_19
class Uap_17(UapSingle):
    cv_record = Record_19

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_19]]:
        return cls._parse(bs)

class Asterix_6(AstCat):
    cv_category = 8
    cv_edition = (1, 2)
    cv_uap = Uap_17

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_17_Arg]) -> "Asterix_6":
        return cls._create(records) # type: ignore

class Asterix_7(AstCat):
    cv_category = 8
    cv_edition = (1, 3)
    cv_uap = Uap_17

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_17_Arg]) -> "Asterix_7":
        return cls._create(records) # type: ignore

Content_602_Arg: TypeAlias = int
class Content_602(ContentTable):
    cv_values = {2: "Cartesian vector", 253: "Intermediate-update-step message", 254: "Start-of-picture message", 255: "End-of-picture message"}

RuleContent_602_Arg: TypeAlias = Content_602_Arg
class RuleContent_602(RuleContentContextFree):
    cv_content = Content_602

    @property
    def content(self) -> Content_602:
        return self._get_content() # type: ignore

Variation_199_Arg: TypeAlias = RuleContent_602_Arg
class Variation_199(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_602

    @classmethod
    def create(cls, arg : Variation_199_Arg) -> "Variation_199":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_602:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_602:
        return self.rule.content

RuleVariation_192_Arg: TypeAlias = Variation_199_Arg
class RuleVariation_192(RuleVariationContextFree):
    cv_variation = Variation_199

    @classmethod
    def create(cls, arg : RuleVariation_192_Arg) -> "RuleVariation_192":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_199:
        return self.arg # type: ignore

NonSpare_15_Arg: TypeAlias = RuleVariation_192_Arg
class NonSpare_15(NonSpare):
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule = RuleVariation_192

    @classmethod
    def create(cls, arg : NonSpare_15_Arg) -> "NonSpare_15":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_192:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_199:
        return self.rule.variation

class UapItem_15(UapItem):
    cv_non_spare = NonSpare_15

Variation_1370_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_51_Arg, Tuple[Literal["ORG"], RuleVariation_51_Arg]], Union[RuleVariation_474_Arg, Tuple[Literal["I"], RuleVariation_474_Arg]], Union[RuleVariation_761_Arg, Tuple[Literal["S"], RuleVariation_761_Arg]], None]]
Variation_1370_Arg: TypeAlias = Union[
    Tuple[Variation_1370_Arg_Group_1],
]
class Variation_1370(Extended):
    cv_items_list = [[(Item_657, 1), (Item_407, 3), (Item_846, 3), None]]

    @classmethod
    def create(cls, arg : Variation_1370_Arg) -> 'Variation_1370':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["ORG"]) -> RuleVariation_51:
        ...
    @overload
    def get_item(self, key : Literal["I"]) -> RuleVariation_474:
        ...
    @overload
    def get_item(self, key : Literal["S"]) -> RuleVariation_761:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1293_Arg: TypeAlias = Variation_1370_Arg
class RuleVariation_1293(RuleVariationContextFree):
    cv_variation = Variation_1370

    @classmethod
    def create(cls, arg : RuleVariation_1293_Arg) -> "RuleVariation_1293":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1370:
        return self.arg # type: ignore

NonSpare_93_Arg: TypeAlias = RuleVariation_1293_Arg
class NonSpare_93(NonSpare):
    cv_name = "020"
    cv_title = "Vector Qualifier"
    cv_rule = RuleVariation_1293

    @classmethod
    def create(cls, arg : NonSpare_93_Arg) -> "NonSpare_93":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1293:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1370:
        return self.rule.variation

class UapItem_93(UapItem):
    cv_non_spare = NonSpare_93

Variation_253_Arg: TypeAlias = RuleContent_609_Arg
class Variation_253(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_609

    @classmethod
    def create(cls, arg : Variation_253_Arg) -> "Variation_253":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_609:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_609:
        return self.rule.content

RuleVariation_246_Arg: TypeAlias = Variation_253_Arg
class RuleVariation_246(RuleVariationContextFree):
    cv_variation = Variation_253

    @classmethod
    def create(cls, arg : RuleVariation_246_Arg) -> "RuleVariation_246":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_253:
        return self.arg # type: ignore

NonSpare_2091_Arg: TypeAlias = RuleVariation_246_Arg
class NonSpare_2091(NonSpare):
    cv_name = "X"
    cv_title = "X-coordinate"
    cv_rule = RuleVariation_246

    @classmethod
    def create(cls, arg : NonSpare_2091_Arg) -> "NonSpare_2091":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

Item_1198_Arg: TypeAlias = NonSpare_2091_Arg
class Item_1198(Item):
    cv_non_spare = NonSpare_2091

    @classmethod
    def create(cls, arg : Item_1198_Arg) -> "Item_1198":
        return cls._create(arg) # type: ignore

NonSpare_2145_Arg: TypeAlias = RuleVariation_246_Arg
class NonSpare_2145(NonSpare):
    cv_name = "Y"
    cv_title = "Y-coordinate"
    cv_rule = RuleVariation_246

    @classmethod
    def create(cls, arg : NonSpare_2145_Arg) -> "NonSpare_2145":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

Item_1249_Arg: TypeAlias = NonSpare_2145_Arg
class Item_1249(Item):
    cv_non_spare = NonSpare_2145

    @classmethod
    def create(cls, arg : Item_1249_Arg) -> "Item_1249":
        return cls._create(arg) # type: ignore

NonSpare_1136_Arg: TypeAlias = RuleVariation_247_Arg
class NonSpare_1136(NonSpare):
    cv_name = "L"
    cv_title = "Vector Length"
    cv_rule = RuleVariation_247

    @classmethod
    def create(cls, arg : NonSpare_1136_Arg) -> "NonSpare_1136":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_247:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_254:
        return self.rule.variation

Item_454_Arg: TypeAlias = NonSpare_1136_Arg
class Item_454(Item):
    cv_non_spare = NonSpare_1136

    @classmethod
    def create(cls, arg : Item_454_Arg) -> "Item_454":
        return cls._create(arg) # type: ignore

Variation_1309_Arg_Group = Tuple[Union[RuleVariation_246_Arg, Tuple[Literal["X"], RuleVariation_246_Arg]], Union[RuleVariation_246_Arg, Tuple[Literal["Y"], RuleVariation_246_Arg]], Union[RuleVariation_247_Arg, Tuple[Literal["L"], RuleVariation_247_Arg]]]
Variation_1309_Arg: TypeAlias = Union[int, Variation_1309_Arg_Group]
class Variation_1309(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_1198, 16), (Item_1249, 16), (Item_454, 16)]
    cv_items_dict = {"X": RuleVariation_246, "Y": RuleVariation_246, "L": RuleVariation_247}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_246:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_246:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_247:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"], Literal["L"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_246:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_246:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_247:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1309_Arg) -> 'Variation_1309':
        return cls._create(arg) # type: ignore

Variation_1443_Arg: TypeAlias = List[Variation_1309_Arg]
class Variation_1443(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1309

    @classmethod
    def create(cls, arg : Variation_1443_Arg) -> 'Variation_1443':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1309]:
        return self._get_list() # type: ignore

RuleVariation_1366_Arg: TypeAlias = Variation_1443_Arg
class RuleVariation_1366(RuleVariationContextFree):
    cv_variation = Variation_1443

    @classmethod
    def create(cls, arg : RuleVariation_1366_Arg) -> "RuleVariation_1366":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1443:
        return self.arg # type: ignore

NonSpare_105_Arg: TypeAlias = RuleVariation_1366_Arg
class NonSpare_105(NonSpare):
    cv_name = "030"
    cv_title = "Sequence of Cartesian Vectors"
    cv_rule = RuleVariation_1366

    @classmethod
    def create(cls, arg : NonSpare_105_Arg) -> "NonSpare_105":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1366:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1443:
        return self.rule.variation

class UapItem_105(UapItem):
    cv_non_spare = NonSpare_105

Variation_148_Arg: TypeAlias = RuleContent_610_Arg
class Variation_148(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 6
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_148_Arg) -> "Variation_148":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_148_Arg: TypeAlias = Variation_148_Arg
class RuleVariation_148(RuleVariationContextFree):
    cv_variation = Variation_148

    @classmethod
    def create(cls, arg : RuleVariation_148_Arg) -> "RuleVariation_148":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_148:
        return self.arg # type: ignore

NonSpare_1720_Arg: TypeAlias = RuleVariation_148_Arg
class NonSpare_1720(NonSpare):
    cv_name = "SN"
    cv_title = "Step Number"
    cv_rule = RuleVariation_148

    @classmethod
    def create(cls, arg : NonSpare_1720_Arg) -> "NonSpare_1720":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_148:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_148:
        return self.rule.variation

Item_901_Arg: TypeAlias = NonSpare_1720_Arg
class Item_901(Item):
    cv_non_spare = NonSpare_1720

    @classmethod
    def create(cls, arg : Item_901_Arg) -> "Item_901":
        return cls._create(arg) # type: ignore

Variation_1374_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_148_Arg, Tuple[Literal["SN"], RuleVariation_148_Arg]], int, None]]
Variation_1374_Arg: TypeAlias = Union[
    Tuple[Variation_1374_Arg_Group_1],
]
class Variation_1374(Extended):
    cv_items_list = [[(Item_901, 6), (Item_26, 1), None]]

    @classmethod
    def create(cls, arg : Variation_1374_Arg) -> 'Variation_1374':
        return cls._create(arg) # type: ignore

    @overload # type: ignore
    def get_item(self, key : Literal["SN"]) -> RuleVariation_148:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1297_Arg: TypeAlias = Variation_1374_Arg
class RuleVariation_1297(RuleVariationContextFree):
    cv_variation = Variation_1374

    @classmethod
    def create(cls, arg : RuleVariation_1297_Arg) -> "RuleVariation_1297":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1374:
        return self.arg # type: ignore

NonSpare_195_Arg: TypeAlias = RuleVariation_1297_Arg
class NonSpare_195(NonSpare):
    cv_name = "060"
    cv_title = "Synchronisation/Control Signal"
    cv_rule = RuleVariation_1297

    @classmethod
    def create(cls, arg : NonSpare_195_Arg) -> "NonSpare_195":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1297:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1374:
        return self.rule.variation

class UapItem_195(UapItem):
    cv_non_spare = NonSpare_195

NonSpare_217_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_217(NonSpare):
    cv_name = "070"
    cv_title = "Time of Day"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_217_Arg) -> "NonSpare_217":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_217(UapItem):
    cv_non_spare = NonSpare_217

NonSpare_230_Arg: TypeAlias = RuleVariation_1274_Arg
class NonSpare_230(NonSpare):
    cv_name = "080"
    cv_title = "Processing Status"
    cv_rule = RuleVariation_1274

    @classmethod
    def create(cls, arg : NonSpare_230_Arg) -> "NonSpare_230":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1274:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1351:
        return self.rule.variation

class UapItem_230(UapItem):
    cv_non_spare = NonSpare_230

NonSpare_1644_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_1644(NonSpare):
    cv_name = "SAC"
    cv_title = "SAC of Radar Concerned"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_1644_Arg) -> "NonSpare_1644":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_851_Arg: TypeAlias = NonSpare_1644_Arg
class Item_851(Item):
    cv_non_spare = NonSpare_1644

    @classmethod
    def create(cls, arg : Item_851_Arg) -> "Item_851":
        return cls._create(arg) # type: ignore

NonSpare_1699_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_1699(NonSpare):
    cv_name = "SIC"
    cv_title = "SIC of Radar Concerned"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_1699_Arg) -> "NonSpare_1699":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_882_Arg: TypeAlias = NonSpare_1699_Arg
class Item_882(Item):
    cv_non_spare = NonSpare_1699

    @classmethod
    def create(cls, arg : Item_882_Arg) -> "Item_882":
        return cls._create(arg) # type: ignore

Item_2_Arg: TypeAlias = int
class Item_2(Spare):
    cv_bit_offset8 = 0
    cv_bit_size = 3

Variation_611_Arg: TypeAlias = RuleContent_0_Arg
class Variation_611(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_611_Arg) -> "Variation_611":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_600_Arg: TypeAlias = Variation_611_Arg
class RuleVariation_600(RuleVariationContextFree):
    cv_variation = Variation_611

    @classmethod
    def create(cls, arg : RuleVariation_600_Arg) -> "RuleVariation_600":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_611:
        return self.arg # type: ignore

NonSpare_807_Arg: TypeAlias = RuleVariation_600_Arg
class NonSpare_807(NonSpare):
    cv_name = "CP"
    cv_title = "Circular Polarisation"
    cv_rule = RuleVariation_600

    @classmethod
    def create(cls, arg : NonSpare_807_Arg) -> "NonSpare_807":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_600:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_611:
        return self.rule.variation

Item_205_Arg: TypeAlias = NonSpare_807_Arg
class Item_205(Item):
    cv_non_spare = NonSpare_807

    @classmethod
    def create(cls, arg : Item_205_Arg) -> "Item_205":
        return cls._create(arg) # type: ignore

Variation_696_Arg: TypeAlias = RuleContent_0_Arg
class Variation_696(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_696_Arg) -> "Variation_696":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_685_Arg: TypeAlias = Variation_696_Arg
class RuleVariation_685(RuleVariationContextFree):
    cv_variation = Variation_696

    @classmethod
    def create(cls, arg : RuleVariation_685_Arg) -> "RuleVariation_685":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_696:
        return self.arg # type: ignore

NonSpare_2053_Arg: TypeAlias = RuleVariation_685_Arg
class NonSpare_2053(NonSpare):
    cv_name = "WO"
    cv_title = "Weather Channel Overload"
    cv_rule = RuleVariation_685

    @classmethod
    def create(cls, arg : NonSpare_2053_Arg) -> "NonSpare_2053":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_685:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_696:
        return self.rule.variation

Item_1163_Arg: TypeAlias = NonSpare_2053_Arg
class Item_1163(Item):
    cv_non_spare = NonSpare_2053

    @classmethod
    def create(cls, arg : Item_1163_Arg) -> "Item_1163":
        return cls._create(arg) # type: ignore

NonSpare_1523_Arg: TypeAlias = RuleVariation_856_Arg
class NonSpare_1523(NonSpare):
    cv_name = "R"
    cv_title = "Reduction Step in Use By Radar  Concerned"
    cv_rule = RuleVariation_856

    @classmethod
    def create(cls, arg : NonSpare_1523_Arg) -> "NonSpare_1523":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_856:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_886:
        return self.rule.variation

Item_760_Arg: TypeAlias = NonSpare_1523_Arg
class Item_760(Item):
    cv_non_spare = NonSpare_1523

    @classmethod
    def create(cls, arg : Item_760_Arg) -> "Item_760":
        return cls._create(arg) # type: ignore

Variation_1185_Arg_Group = Tuple[Union[RuleVariation_158_Arg, Tuple[Literal["SAC"], RuleVariation_158_Arg]], Union[RuleVariation_158_Arg, Tuple[Literal["SIC"], RuleVariation_158_Arg]], int, Union[RuleVariation_600_Arg, Tuple[Literal["CP"], RuleVariation_600_Arg]], Union[RuleVariation_685_Arg, Tuple[Literal["WO"], RuleVariation_685_Arg]], Union[RuleVariation_856_Arg, Tuple[Literal["R"], RuleVariation_856_Arg]]]
Variation_1185_Arg: TypeAlias = Union[int, Variation_1185_Arg_Group]
class Variation_1185(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_851, 8), (Item_882, 8), (Item_2, 3), (Item_205, 1), (Item_1163, 1), (Item_760, 3)]
    cv_items_dict = {"SAC": RuleVariation_158, "SIC": RuleVariation_158, "CP": RuleVariation_600, "WO": RuleVariation_685, "R": RuleVariation_856}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAC"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIC"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CP"]) -> RuleVariation_600:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WO"]) -> RuleVariation_685:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["R"]) -> RuleVariation_856:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAC"], Literal["SIC"], Literal["CP"], Literal["WO"], Literal["R"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAC"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["SIC"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["CP"]) -> RuleVariation_600:
        ...
    @overload
    def get_item(self, key : Literal["WO"]) -> RuleVariation_685:
        ...
    @overload
    def get_item(self, key : Literal["R"]) -> RuleVariation_856:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1185_Arg) -> 'Variation_1185':
        return cls._create(arg) # type: ignore

Variation_1420_Arg: TypeAlias = List[Variation_1185_Arg]
class Variation_1420(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1185

    @classmethod
    def create(cls, arg : Variation_1420_Arg) -> 'Variation_1420':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1185]:
        return self._get_list() # type: ignore

RuleVariation_1343_Arg: TypeAlias = Variation_1420_Arg
class RuleVariation_1343(RuleVariationContextFree):
    cv_variation = Variation_1420

    @classmethod
    def create(cls, arg : RuleVariation_1343_Arg) -> "RuleVariation_1343":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1420:
        return self.arg # type: ignore

NonSpare_253_Arg: TypeAlias = RuleVariation_1343_Arg
class NonSpare_253(NonSpare):
    cv_name = "090"
    cv_title = "Radar Configuration and Status"
    cv_rule = RuleVariation_1343

    @classmethod
    def create(cls, arg : NonSpare_253_Arg) -> "NonSpare_253":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1343:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1420:
        return self.rule.variation

class UapItem_253(UapItem):
    cv_non_spare = NonSpare_253

NonSpare_275_Arg: TypeAlias = RuleVariation_247_Arg
class NonSpare_275(NonSpare):
    cv_name = "100"
    cv_title = "Vector Count"
    cv_rule = RuleVariation_247

    @classmethod
    def create(cls, arg : NonSpare_275_Arg) -> "NonSpare_275":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_247:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_254:
        return self.rule.variation

class UapItem_275(UapItem):
    cv_non_spare = NonSpare_275

Record_20_Arg = TypedDict('Record_20_Arg', {
    "010": NonSpare_36_Arg,
    "000": NonSpare_15_Arg,
    "020": NonSpare_93_Arg,
    "030": NonSpare_105_Arg,
    "060": NonSpare_195_Arg,
    "070": NonSpare_217_Arg,
    "080": NonSpare_230_Arg,
    "090": NonSpare_253_Arg,
    "100": NonSpare_275_Arg,
}, total=False)
class Record_20(Record):
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_36, UapItem_15, UapItem_93, UapItem_105, UapItem_195, UapItem_217, UapItem_230, UapItem_253, UapItem_275]
    cv_items_dict = {"010": NonSpare_36, "000": NonSpare_15, "020": NonSpare_93, "030": NonSpare_105, "060": NonSpare_195, "070": NonSpare_217, "080": NonSpare_230, "090": NonSpare_253, "100": NonSpare_275}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_36:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_93:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_105:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_195:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_217:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_230:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_253:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_275:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["020"], Literal["030"], Literal["060"], Literal["070"], Literal["080"], Literal["090"], Literal["100"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_36]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_15]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_93]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_105]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_195]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_217]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_230]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_253]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_275]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_36_Arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_15_Arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_93_Arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_105_Arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_195_Arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_217_Arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_230_Arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_253_Arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_275_Arg) -> 'Record_20':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_20':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_20_Arg) -> 'Record_20':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_20", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_18_Arg: TypeAlias = Record_20
class Uap_18(UapSingle):
    cv_record = Record_20

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_20]]:
        return cls._parse(bs)

class Asterix_8(AstCat):
    cv_category = 9
    cv_edition = (2, 1)
    cv_uap = Uap_18

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_18_Arg]) -> "Asterix_8":
        return cls._create(records) # type: ignore

NonSpare_42_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_42(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_42_Arg) -> "NonSpare_42":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_42(UapItem):
    cv_non_spare = NonSpare_42

Content_596_Arg: TypeAlias = int
class Content_596(ContentTable):
    cv_values = {1: "Target Report", 2: "Start of Update Cycle", 3: "Periodic Status Message", 4: "Event-triggered Status Message"}

RuleContent_596_Arg: TypeAlias = Content_596_Arg
class RuleContent_596(RuleContentContextFree):
    cv_content = Content_596

    @property
    def content(self) -> Content_596:
        return self._get_content() # type: ignore

Variation_196_Arg: TypeAlias = RuleContent_596_Arg
class Variation_196(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_596

    @classmethod
    def create(cls, arg : Variation_196_Arg) -> "Variation_196":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_596:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_596:
        return self.rule.content

RuleVariation_189_Arg: TypeAlias = Variation_196_Arg
class RuleVariation_189(RuleVariationContextFree):
    cv_variation = Variation_196

    @classmethod
    def create(cls, arg : RuleVariation_189_Arg) -> "RuleVariation_189":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_196:
        return self.arg # type: ignore

NonSpare_12_Arg: TypeAlias = RuleVariation_189_Arg
class NonSpare_12(NonSpare):
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule = RuleVariation_189

    @classmethod
    def create(cls, arg : NonSpare_12_Arg) -> "NonSpare_12":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_189:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_196:
        return self.rule.variation

class UapItem_12(UapItem):
    cv_non_spare = NonSpare_12

Content_449_Arg: TypeAlias = int
class Content_449(ContentTable):
    cv_values = {0: "SSR multilateration", 1: "Mode S multilateration", 2: "ADS-B", 3: "PSR", 4: "Magnetic Loop System", 5: "HF multilateration", 6: "Not defined", 7: "Other types"}

RuleContent_449_Arg: TypeAlias = Content_449_Arg
class RuleContent_449(RuleContentContextFree):
    cv_content = Content_449

    @property
    def content(self) -> Content_449:
        return self._get_content() # type: ignore

Variation_130_Arg: TypeAlias = RuleContent_449_Arg
class Variation_130(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_449

    @classmethod
    def create(cls, arg : Variation_130_Arg) -> "Variation_130":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_449:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_449:
        return self.rule.content

RuleVariation_130_Arg: TypeAlias = Variation_130_Arg
class RuleVariation_130(RuleVariationContextFree):
    cv_variation = Variation_130

    @classmethod
    def create(cls, arg : RuleVariation_130_Arg) -> "RuleVariation_130":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_130:
        return self.arg # type: ignore

Content_350_Arg: TypeAlias = int
class Content_350(ContentTable):
    cv_values = {0: "No differential correction (ADS-B)", 1: "Differential correction (ADS-B)"}

RuleContent_350_Arg: TypeAlias = Content_350_Arg
class RuleContent_350(RuleContentContextFree):
    cv_content = Content_350

    @property
    def content(self) -> Content_350:
        return self._get_content() # type: ignore

Variation_649_Arg: TypeAlias = RuleContent_350_Arg
class Variation_649(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_350

    @classmethod
    def create(cls, arg : Variation_649_Arg) -> "Variation_649":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_350:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_350:
        return self.rule.content

RuleVariation_638_Arg: TypeAlias = Variation_649_Arg
class RuleVariation_638(RuleVariationContextFree):
    cv_variation = Variation_649

    @classmethod
    def create(cls, arg : RuleVariation_638_Arg) -> "RuleVariation_638":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_649:
        return self.arg # type: ignore

Content_53_Arg: TypeAlias = int
class Content_53(ContentTable):
    cv_values = {0: "Chain 1", 1: "Chain 2"}

RuleContent_53_Arg: TypeAlias = Content_53_Arg
class RuleContent_53(RuleContentContextFree):
    cv_content = Content_53

    @property
    def content(self) -> Content_53:
        return self._get_content() # type: ignore

Variation_700_Arg: TypeAlias = RuleContent_53_Arg
class Variation_700(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_53

    @classmethod
    def create(cls, arg : Variation_700_Arg) -> "Variation_700":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_53:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_53:
        return self.rule.content

RuleVariation_689_Arg: TypeAlias = Variation_700_Arg
class RuleVariation_689(RuleVariationContextFree):
    cv_variation = Variation_700

    @classmethod
    def create(cls, arg : RuleVariation_689_Arg) -> "RuleVariation_689":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_700:
        return self.arg # type: ignore

Content_519_Arg: TypeAlias = int
class Content_519(ContentTable):
    cv_values = {0: "Transponder Ground bit not set", 1: "Transponder Ground bit set"}

RuleContent_519_Arg: TypeAlias = Content_519_Arg
class RuleContent_519(RuleContentContextFree):
    cv_content = Content_519

    @property
    def content(self) -> Content_519:
        return self._get_content() # type: ignore

Variation_872_Arg: TypeAlias = RuleContent_519_Arg
class Variation_872(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_519

    @classmethod
    def create(cls, arg : Variation_872_Arg) -> "Variation_872":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_519:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_519:
        return self.rule.content

RuleVariation_842_Arg: TypeAlias = Variation_872_Arg
class RuleVariation_842(RuleVariationContextFree):
    cv_variation = Variation_872

    @classmethod
    def create(cls, arg : RuleVariation_842_Arg) -> "RuleVariation_842":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_872:
        return self.arg # type: ignore

Content_304_Arg: TypeAlias = int
class Content_304(ContentTable):
    cv_values = {0: "No Corrupted reply in multilateration", 1: "Corrupted replies in multilateration"}

RuleContent_304_Arg: TypeAlias = Content_304_Arg
class RuleContent_304(RuleContentContextFree):
    cv_content = Content_304

    @property
    def content(self) -> Content_304:
        return self._get_content() # type: ignore

Variation_937_Arg: TypeAlias = RuleContent_304_Arg
class Variation_937(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_304

    @classmethod
    def create(cls, arg : Variation_937_Arg) -> "Variation_937":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_304:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_304:
        return self.rule.content

RuleVariation_907_Arg: TypeAlias = Variation_937_Arg
class RuleVariation_907(RuleVariationContextFree):
    cv_variation = Variation_937

    @classmethod
    def create(cls, arg : RuleVariation_907_Arg) -> "RuleVariation_907":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_937:
        return self.arg # type: ignore

Content_19_Arg: TypeAlias = int
class Content_19(ContentTable):
    cv_values = {0: "Actual target report", 1: "Simulated target report"}

RuleContent_19_Arg: TypeAlias = Content_19_Arg
class RuleContent_19(RuleContentContextFree):
    cv_content = Content_19

    @property
    def content(self) -> Content_19:
        return self._get_content() # type: ignore

Variation_5_Arg: TypeAlias = RuleContent_19_Arg
class Variation_5(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_19

    @classmethod
    def create(cls, arg : Variation_5_Arg) -> "Variation_5":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_19:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_19:
        return self.rule.content

RuleVariation_5_Arg: TypeAlias = Variation_5_Arg
class RuleVariation_5(RuleVariationContextFree):
    cv_variation = Variation_5

    @classmethod
    def create(cls, arg : RuleVariation_5_Arg) -> "RuleVariation_5":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_5:
        return self.arg # type: ignore

Content_154_Arg: TypeAlias = int
class Content_154(ContentTable):
    cv_values = {0: "Default", 1: "Test Target"}

RuleContent_154_Arg: TypeAlias = Content_154_Arg
class RuleContent_154(RuleContentContextFree):
    cv_content = Content_154

    @property
    def content(self) -> Content_154:
        return self._get_content() # type: ignore

Variation_417_Arg: TypeAlias = RuleContent_154_Arg
class Variation_417(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_154

    @classmethod
    def create(cls, arg : Variation_417_Arg) -> "Variation_417":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_154:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_154:
        return self.rule.content

RuleVariation_406_Arg: TypeAlias = Variation_417_Arg
class RuleVariation_406(RuleVariationContextFree):
    cv_variation = Variation_417

    @classmethod
    def create(cls, arg : RuleVariation_406_Arg) -> "RuleVariation_406":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_417:
        return self.arg # type: ignore

Content_440_Arg: TypeAlias = int
class Content_440(ContentTable):
    cv_values = {0: "Report from target transponder", 1: "Report from field monitor (fixed transponder)"}

RuleContent_440_Arg: TypeAlias = Content_440_Arg
class RuleContent_440(RuleContentContextFree):
    cv_content = Content_440

    @property
    def content(self) -> Content_440:
        return self._get_content() # type: ignore

Variation_571_Arg: TypeAlias = RuleContent_440_Arg
class Variation_571(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_440

    @classmethod
    def create(cls, arg : Variation_571_Arg) -> "Variation_571":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_440:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_440:
        return self.rule.content

RuleVariation_560_Arg: TypeAlias = Variation_571_Arg
class RuleVariation_560(RuleVariationContextFree):
    cv_variation = Variation_571

    @classmethod
    def create(cls, arg : RuleVariation_560_Arg) -> "RuleVariation_560":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_571:
        return self.arg # type: ignore

Content_531_Arg: TypeAlias = int
class Content_531(ContentTable):
    cv_values = {0: "Undetermined", 1: "Loop start", 2: "Loop finish"}

RuleContent_531_Arg: TypeAlias = Content_531_Arg
class RuleContent_531(RuleContentContextFree):
    cv_content = Content_531

    @property
    def content(self) -> Content_531:
        return self._get_content() # type: ignore

Variation_679_Arg: TypeAlias = RuleContent_531_Arg
class Variation_679(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_rule = RuleContent_531

    @classmethod
    def create(cls, arg : Variation_679_Arg) -> "Variation_679":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_531:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_531:
        return self.rule.content

RuleVariation_668_Arg: TypeAlias = Variation_679_Arg
class RuleVariation_668(RuleVariationContextFree):
    cv_variation = Variation_679

    @classmethod
    def create(cls, arg : RuleVariation_668_Arg) -> "RuleVariation_668":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_679:
        return self.arg # type: ignore

Content_530_Arg: TypeAlias = int
class Content_530(ContentTable):
    cv_values = {0: "Undetermined", 1: "Aircraft", 2: "Ground vehicle", 3: "Helicopter"}

RuleContent_530_Arg: TypeAlias = Content_530_Arg
class RuleContent_530(RuleContentContextFree):
    cv_content = Content_530

    @property
    def content(self) -> Content_530:
        return self._get_content() # type: ignore

Variation_884_Arg: TypeAlias = RuleContent_530_Arg
class Variation_884(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_530

    @classmethod
    def create(cls, arg : Variation_884_Arg) -> "Variation_884":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_530:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_530:
        return self.rule.content

RuleVariation_854_Arg: TypeAlias = Variation_884_Arg
class RuleVariation_854(RuleVariationContextFree):
    cv_variation = Variation_884

    @classmethod
    def create(cls, arg : RuleVariation_854_Arg) -> "RuleVariation_854":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_884:
        return self.arg # type: ignore

Content_13_Arg: TypeAlias = int
class Content_13(ContentTable):
    cv_values = {0: "Absence of SPI", 1: "Special Position Identification"}

RuleContent_13_Arg: TypeAlias = Content_13_Arg
class RuleContent_13(RuleContentContextFree):
    cv_content = Content_13

    @property
    def content(self) -> Content_13:
        return self._get_content() # type: ignore

Variation_3_Arg: TypeAlias = RuleContent_13_Arg
class Variation_3(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_13

    @classmethod
    def create(cls, arg : Variation_3_Arg) -> "Variation_3":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_13:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_13:
        return self.rule.content

RuleVariation_3_Arg: TypeAlias = Variation_3_Arg
class RuleVariation_3(RuleVariationContextFree):
    cv_variation = Variation_3

    @classmethod
    def create(cls, arg : RuleVariation_3_Arg) -> "RuleVariation_3":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_3:
        return self.arg # type: ignore

NonSpare_1951_Arg: TypeAlias = RuleVariation_130_Arg
class NonSpare_1951(NonSpare):
    cv_name = "TYP"
    cv_title = ""
    cv_rule = RuleVariation_130

    @classmethod
    def create(cls, arg : NonSpare_1951_Arg) -> "NonSpare_1951":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_130:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_130:
        return self.rule.variation

Item_1071_Arg: TypeAlias = NonSpare_1951_Arg
class Item_1071(Item):
    cv_non_spare = NonSpare_1951

    @classmethod
    def create(cls, arg : Item_1071_Arg) -> "Item_1071":
        return cls._create(arg) # type: ignore

NonSpare_867_Arg: TypeAlias = RuleVariation_638_Arg
class NonSpare_867(NonSpare):
    cv_name = "DCR"
    cv_title = ""
    cv_rule = RuleVariation_638

    @classmethod
    def create(cls, arg : NonSpare_867_Arg) -> "NonSpare_867":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_638:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_649:
        return self.rule.variation

Item_251_Arg: TypeAlias = NonSpare_867_Arg
class Item_251(Item):
    cv_non_spare = NonSpare_867

    @classmethod
    def create(cls, arg : Item_251_Arg) -> "Item_251":
        return cls._create(arg) # type: ignore

NonSpare_728_Arg: TypeAlias = RuleVariation_689_Arg
class NonSpare_728(NonSpare):
    cv_name = "CHN"
    cv_title = ""
    cv_rule = RuleVariation_689

    @classmethod
    def create(cls, arg : NonSpare_728_Arg) -> "NonSpare_728":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_689:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_700:
        return self.rule.variation

Item_156_Arg: TypeAlias = NonSpare_728_Arg
class Item_156(Item):
    cv_non_spare = NonSpare_728

    @classmethod
    def create(cls, arg : Item_156_Arg) -> "Item_156":
        return cls._create(arg) # type: ignore

NonSpare_1021_Arg: TypeAlias = RuleVariation_842_Arg
class NonSpare_1021(NonSpare):
    cv_name = "GBS"
    cv_title = ""
    cv_rule = RuleVariation_842

    @classmethod
    def create(cls, arg : NonSpare_1021_Arg) -> "NonSpare_1021":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_842:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_872:
        return self.rule.variation

Item_365_Arg: TypeAlias = NonSpare_1021_Arg
class Item_365(Item):
    cv_non_spare = NonSpare_1021

    @classmethod
    def create(cls, arg : Item_365_Arg) -> "Item_365":
        return cls._create(arg) # type: ignore

NonSpare_823_Arg: TypeAlias = RuleVariation_907_Arg
class NonSpare_823(NonSpare):
    cv_name = "CRT"
    cv_title = ""
    cv_rule = RuleVariation_907

    @classmethod
    def create(cls, arg : NonSpare_823_Arg) -> "NonSpare_823":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_907:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_937:
        return self.rule.variation

Item_215_Arg: TypeAlias = NonSpare_823_Arg
class Item_215(Item):
    cv_non_spare = NonSpare_823

    @classmethod
    def create(cls, arg : Item_215_Arg) -> "Item_215":
        return cls._create(arg) # type: ignore

NonSpare_1714_Arg: TypeAlias = RuleVariation_5_Arg
class NonSpare_1714(NonSpare):
    cv_name = "SIM"
    cv_title = ""
    cv_rule = RuleVariation_5

    @classmethod
    def create(cls, arg : NonSpare_1714_Arg) -> "NonSpare_1714":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_5:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_5:
        return self.rule.variation

Item_895_Arg: TypeAlias = NonSpare_1714_Arg
class Item_895(Item):
    cv_non_spare = NonSpare_1714

    @classmethod
    def create(cls, arg : Item_895_Arg) -> "Item_895":
        return cls._create(arg) # type: ignore

NonSpare_1926_Arg: TypeAlias = RuleVariation_406_Arg
class NonSpare_1926(NonSpare):
    cv_name = "TST"
    cv_title = ""
    cv_rule = RuleVariation_406

    @classmethod
    def create(cls, arg : NonSpare_1926_Arg) -> "NonSpare_1926":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_406:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_417:
        return self.rule.variation

Item_1049_Arg: TypeAlias = NonSpare_1926_Arg
class Item_1049(Item):
    cv_non_spare = NonSpare_1926

    @classmethod
    def create(cls, arg : Item_1049_Arg) -> "Item_1049":
        return cls._create(arg) # type: ignore

NonSpare_1527_Arg: TypeAlias = RuleVariation_560_Arg
class NonSpare_1527(NonSpare):
    cv_name = "RAB"
    cv_title = ""
    cv_rule = RuleVariation_560

    @classmethod
    def create(cls, arg : NonSpare_1527_Arg) -> "NonSpare_1527":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_560:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_571:
        return self.rule.variation

Item_763_Arg: TypeAlias = NonSpare_1527_Arg
class Item_763(Item):
    cv_non_spare = NonSpare_1527

    @classmethod
    def create(cls, arg : Item_763_Arg) -> "Item_763":
        return cls._create(arg) # type: ignore

NonSpare_1184_Arg: TypeAlias = RuleVariation_668_Arg
class NonSpare_1184(NonSpare):
    cv_name = "LOP"
    cv_title = ""
    cv_rule = RuleVariation_668

    @classmethod
    def create(cls, arg : NonSpare_1184_Arg) -> "NonSpare_1184":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_668:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_679:
        return self.rule.variation

Item_500_Arg: TypeAlias = NonSpare_1184_Arg
class Item_500(Item):
    cv_non_spare = NonSpare_1184

    @classmethod
    def create(cls, arg : Item_500_Arg) -> "Item_500":
        return cls._create(arg) # type: ignore

NonSpare_1880_Arg: TypeAlias = RuleVariation_854_Arg
class NonSpare_1880(NonSpare):
    cv_name = "TOT"
    cv_title = ""
    cv_rule = RuleVariation_854

    @classmethod
    def create(cls, arg : NonSpare_1880_Arg) -> "NonSpare_1880":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_854:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_884:
        return self.rule.variation

Item_1009_Arg: TypeAlias = NonSpare_1880_Arg
class Item_1009(Item):
    cv_non_spare = NonSpare_1880

    @classmethod
    def create(cls, arg : Item_1009_Arg) -> "Item_1009":
        return cls._create(arg) # type: ignore

NonSpare_1727_Arg: TypeAlias = RuleVariation_3_Arg
class NonSpare_1727(NonSpare):
    cv_name = "SPI"
    cv_title = ""
    cv_rule = RuleVariation_3

    @classmethod
    def create(cls, arg : NonSpare_1727_Arg) -> "NonSpare_1727":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_3:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_3:
        return self.rule.variation

Item_906_Arg: TypeAlias = NonSpare_1727_Arg
class Item_906(Item):
    cv_non_spare = NonSpare_1727

    @classmethod
    def create(cls, arg : Item_906_Arg) -> "Item_906":
        return cls._create(arg) # type: ignore

Variation_1384_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_130_Arg, Tuple[Literal["TYP"], RuleVariation_130_Arg]], Union[RuleVariation_638_Arg, Tuple[Literal["DCR"], RuleVariation_638_Arg]], Union[RuleVariation_689_Arg, Tuple[Literal["CHN"], RuleVariation_689_Arg]], Union[RuleVariation_842_Arg, Tuple[Literal["GBS"], RuleVariation_842_Arg]], Union[RuleVariation_907_Arg, Tuple[Literal["CRT"], RuleVariation_907_Arg]], None]]
Variation_1384_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_5_Arg, Tuple[Literal["SIM"], RuleVariation_5_Arg]], Union[RuleVariation_406_Arg, Tuple[Literal["TST"], RuleVariation_406_Arg]], Union[RuleVariation_560_Arg, Tuple[Literal["RAB"], RuleVariation_560_Arg]], Union[RuleVariation_668_Arg, Tuple[Literal["LOP"], RuleVariation_668_Arg]], Union[RuleVariation_854_Arg, Tuple[Literal["TOT"], RuleVariation_854_Arg]], None]]
Variation_1384_Arg_Group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_3_Arg, Tuple[Literal["SPI"], RuleVariation_3_Arg]], int, None]]
Variation_1384_Arg: TypeAlias = Union[
    Tuple[Variation_1384_Arg_Group_1],
    Tuple[Variation_1384_Arg_Group_1, Variation_1384_Arg_Group_2],
    Tuple[Variation_1384_Arg_Group_1, Variation_1384_Arg_Group_2, Variation_1384_Arg_Group_3],
]
class Variation_1384(Extended):
    cv_items_list = [[(Item_1071, 3), (Item_251, 1), (Item_156, 1), (Item_365, 1), (Item_215, 1), None], [(Item_895, 1), (Item_1049, 1), (Item_763, 1), (Item_500, 2), (Item_1009, 2), None], [(Item_906, 1), (Item_9, 6), None]]

    @classmethod
    def create(cls, arg : Variation_1384_Arg) -> 'Variation_1384':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_130:
        ...
    @overload
    def get_item(self, key : Literal["DCR"]) -> RuleVariation_638:
        ...
    @overload
    def get_item(self, key : Literal["CHN"]) -> RuleVariation_689:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> RuleVariation_842:
        ...
    @overload
    def get_item(self, key : Literal["CRT"]) -> RuleVariation_907:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_5]:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_406]:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> Optional[RuleVariation_560]:
        ...
    @overload
    def get_item(self, key : Literal["LOP"]) -> Optional[RuleVariation_668]:
        ...
    @overload
    def get_item(self, key : Literal["TOT"]) -> Optional[RuleVariation_854]:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> Optional[RuleVariation_3]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1307_Arg: TypeAlias = Variation_1384_Arg
class RuleVariation_1307(RuleVariationContextFree):
    cv_variation = Variation_1384

    @classmethod
    def create(cls, arg : RuleVariation_1307_Arg) -> "RuleVariation_1307":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1384:
        return self.arg # type: ignore

NonSpare_90_Arg: TypeAlias = RuleVariation_1307_Arg
class NonSpare_90(NonSpare):
    cv_name = "020"
    cv_title = "Target Report Descriptor"
    cv_rule = RuleVariation_1307

    @classmethod
    def create(cls, arg : NonSpare_90_Arg) -> "NonSpare_90":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1307:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1384:
        return self.rule.variation

class UapItem_90(UapItem):
    cv_non_spare = NonSpare_90

NonSpare_326_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_326(NonSpare):
    cv_name = "140"
    cv_title = "Time of Day"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_326_Arg) -> "NonSpare_326":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_326(UapItem):
    cv_non_spare = NonSpare_326

Content_702_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_702(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 8.381903171539307e-8
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_702_Arg: TypeAlias = Content_702_Arg
class RuleContent_702(RuleContentContextFree):
    cv_content = Content_702

    @property
    def content(self) -> Content_702:
        return self._get_content() # type: ignore

Variation_381_Arg: TypeAlias = RuleContent_702_Arg
class Variation_381(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_702

    @classmethod
    def create(cls, arg : Variation_381_Arg) -> "Variation_381":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_702:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_702:
        return self.rule.content

RuleVariation_374_Arg: TypeAlias = Variation_381_Arg
class RuleVariation_374(RuleVariationContextFree):
    cv_variation = Variation_381

    @classmethod
    def create(cls, arg : RuleVariation_374_Arg) -> "RuleVariation_374":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_381:
        return self.arg # type: ignore

NonSpare_1146_Arg: TypeAlias = RuleVariation_374_Arg
class NonSpare_1146(NonSpare):
    cv_name = "LAT"
    cv_title = "Latitude"
    cv_rule = RuleVariation_374

    @classmethod
    def create(cls, arg : NonSpare_1146_Arg) -> "NonSpare_1146":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_374:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_381:
        return self.rule.variation

Item_464_Arg: TypeAlias = NonSpare_1146_Arg
class Item_464(Item):
    cv_non_spare = NonSpare_1146

    @classmethod
    def create(cls, arg : Item_464_Arg) -> "Item_464":
        return cls._create(arg) # type: ignore

Content_700_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_700(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 8.381903171539307e-8
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_700_Arg: TypeAlias = Content_700_Arg
class RuleContent_700(RuleContentContextFree):
    cv_content = Content_700

    @property
    def content(self) -> Content_700:
        return self._get_content() # type: ignore

Variation_379_Arg: TypeAlias = RuleContent_700_Arg
class Variation_379(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_700

    @classmethod
    def create(cls, arg : Variation_379_Arg) -> "Variation_379":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_700:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_700:
        return self.rule.content

RuleVariation_372_Arg: TypeAlias = Variation_379_Arg
class RuleVariation_372(RuleVariationContextFree):
    cv_variation = Variation_379

    @classmethod
    def create(cls, arg : RuleVariation_372_Arg) -> "RuleVariation_372":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_379:
        return self.arg # type: ignore

NonSpare_1175_Arg: TypeAlias = RuleVariation_372_Arg
class NonSpare_1175(NonSpare):
    cv_name = "LON"
    cv_title = "Longitude"
    cv_rule = RuleVariation_372

    @classmethod
    def create(cls, arg : NonSpare_1175_Arg) -> "NonSpare_1175":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_372:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_379:
        return self.rule.variation

Item_491_Arg: TypeAlias = NonSpare_1175_Arg
class Item_491(Item):
    cv_non_spare = NonSpare_1175

    @classmethod
    def create(cls, arg : Item_491_Arg) -> "Item_491":
        return cls._create(arg) # type: ignore

Variation_1125_Arg_Group = Tuple[Union[RuleVariation_374_Arg, Tuple[Literal["LAT"], RuleVariation_374_Arg]], Union[RuleVariation_372_Arg, Tuple[Literal["LON"], RuleVariation_372_Arg]]]
Variation_1125_Arg: TypeAlias = Union[int, Variation_1125_Arg_Group]
class Variation_1125(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_464, 32), (Item_491, 32)]
    cv_items_dict = {"LAT": RuleVariation_374, "LON": RuleVariation_372}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_374:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_372:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_374:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_372:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1125_Arg) -> 'Variation_1125':
        return cls._create(arg) # type: ignore

RuleVariation_1082_Arg: TypeAlias = Variation_1125_Arg
class RuleVariation_1082(RuleVariationContextFree):
    cv_variation = Variation_1125

    @classmethod
    def create(cls, arg : RuleVariation_1082_Arg) -> "RuleVariation_1082":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1125:
        return self.arg # type: ignore

NonSpare_153_Arg: TypeAlias = RuleVariation_1082_Arg
class NonSpare_153(NonSpare):
    cv_name = "041"
    cv_title = "Position in WGS-84 Co-ordinates"
    cv_rule = RuleVariation_1082

    @classmethod
    def create(cls, arg : NonSpare_153_Arg) -> "NonSpare_153":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1082:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1125:
        return self.rule.variation

class UapItem_153(UapItem):
    cv_non_spare = NonSpare_153

Content_717_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_717(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_717_Arg: TypeAlias = Content_717_Arg
class RuleContent_717(RuleContentContextFree):
    cv_content = Content_717

    @property
    def content(self) -> Content_717:
        return self._get_content() # type: ignore

Variation_303_Arg: TypeAlias = RuleContent_717_Arg
class Variation_303(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_717

    @classmethod
    def create(cls, arg : Variation_303_Arg) -> "Variation_303":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_717:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_717:
        return self.rule.content

RuleVariation_296_Arg: TypeAlias = Variation_303_Arg
class RuleVariation_296(RuleVariationContextFree):
    cv_variation = Variation_303

    @classmethod
    def create(cls, arg : RuleVariation_296_Arg) -> "RuleVariation_296":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_303:
        return self.arg # type: ignore

NonSpare_1582_Arg: TypeAlias = RuleVariation_296_Arg
class NonSpare_1582(NonSpare):
    cv_name = "RHO"
    cv_title = "RHO"
    cv_rule = RuleVariation_296

    @classmethod
    def create(cls, arg : NonSpare_1582_Arg) -> "NonSpare_1582":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_296:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_303:
        return self.rule.variation

Item_813_Arg: TypeAlias = NonSpare_1582_Arg
class Item_813(Item):
    cv_non_spare = NonSpare_1582

    @classmethod
    def create(cls, arg : Item_813_Arg) -> "Item_813":
        return cls._create(arg) # type: ignore

NonSpare_1846_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_1846(NonSpare):
    cv_name = "TH"
    cv_title = "Theta"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_1846_Arg) -> "NonSpare_1846":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Item_990_Arg: TypeAlias = NonSpare_1846_Arg
class Item_990(Item):
    cv_non_spare = NonSpare_1846

    @classmethod
    def create(cls, arg : Item_990_Arg) -> "Item_990":
        return cls._create(arg) # type: ignore

Variation_1175_Arg_Group = Tuple[Union[RuleVariation_296_Arg, Tuple[Literal["RHO"], RuleVariation_296_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["TH"], RuleVariation_334_Arg]]]
Variation_1175_Arg: TypeAlias = Union[int, Variation_1175_Arg_Group]
class Variation_1175(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_813, 16), (Item_990, 16)]
    cv_items_dict = {"RHO": RuleVariation_296, "TH": RuleVariation_334}

    @overload
    @classmethod
    def spec(cls, key : Literal["RHO"]) -> RuleVariation_296:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TH"]) -> RuleVariation_334:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RHO"], Literal["TH"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RHO"]) -> RuleVariation_296:
        ...
    @overload
    def get_item(self, key : Literal["TH"]) -> RuleVariation_334:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1175_Arg) -> 'Variation_1175':
        return cls._create(arg) # type: ignore

RuleVariation_1127_Arg: TypeAlias = Variation_1175_Arg
class RuleVariation_1127(RuleVariationContextFree):
    cv_variation = Variation_1175

    @classmethod
    def create(cls, arg : RuleVariation_1127_Arg) -> "RuleVariation_1127":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1175:
        return self.arg # type: ignore

NonSpare_138_Arg: TypeAlias = RuleVariation_1127_Arg
class NonSpare_138(NonSpare):
    cv_name = "040"
    cv_title = "Measured Position in Polar Co-ordinates"
    cv_rule = RuleVariation_1127

    @classmethod
    def create(cls, arg : NonSpare_138_Arg) -> "NonSpare_138":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1127:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1175:
        return self.rule.variation

class UapItem_138(UapItem):
    cv_non_spare = NonSpare_138

Content_624_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_624(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.0
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_624_Arg: TypeAlias = Content_624_Arg
class RuleContent_624(RuleContentContextFree):
    cv_content = Content_624

    @property
    def content(self) -> Content_624:
        return self._get_content() # type: ignore

Variation_257_Arg: TypeAlias = RuleContent_624_Arg
class Variation_257(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_624

    @classmethod
    def create(cls, arg : Variation_257_Arg) -> "Variation_257":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_624:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_624:
        return self.rule.content

RuleVariation_250_Arg: TypeAlias = Variation_257_Arg
class RuleVariation_250(RuleVariationContextFree):
    cv_variation = Variation_257

    @classmethod
    def create(cls, arg : RuleVariation_250_Arg) -> "RuleVariation_250":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_257:
        return self.arg # type: ignore

NonSpare_2085_Arg: TypeAlias = RuleVariation_250_Arg
class NonSpare_2085(NonSpare):
    cv_name = "X"
    cv_title = "X Coordinate"
    cv_rule = RuleVariation_250

    @classmethod
    def create(cls, arg : NonSpare_2085_Arg) -> "NonSpare_2085":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_250:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_257:
        return self.rule.variation

Item_1192_Arg: TypeAlias = NonSpare_2085_Arg
class Item_1192(Item):
    cv_non_spare = NonSpare_2085

    @classmethod
    def create(cls, arg : Item_1192_Arg) -> "Item_1192":
        return cls._create(arg) # type: ignore

NonSpare_2139_Arg: TypeAlias = RuleVariation_250_Arg
class NonSpare_2139(NonSpare):
    cv_name = "Y"
    cv_title = "Y Coordinate"
    cv_rule = RuleVariation_250

    @classmethod
    def create(cls, arg : NonSpare_2139_Arg) -> "NonSpare_2139":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_250:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_257:
        return self.rule.variation

Item_1243_Arg: TypeAlias = NonSpare_2139_Arg
class Item_1243(Item):
    cv_non_spare = NonSpare_2139

    @classmethod
    def create(cls, arg : Item_1243_Arg) -> "Item_1243":
        return cls._create(arg) # type: ignore

Variation_1302_Arg_Group = Tuple[Union[RuleVariation_250_Arg, Tuple[Literal["X"], RuleVariation_250_Arg]], Union[RuleVariation_250_Arg, Tuple[Literal["Y"], RuleVariation_250_Arg]]]
Variation_1302_Arg: TypeAlias = Union[int, Variation_1302_Arg_Group]
class Variation_1302(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1192, 16), (Item_1243, 16)]
    cv_items_dict = {"X": RuleVariation_250, "Y": RuleVariation_250}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_250:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_250:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_250:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_250:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1302_Arg) -> 'Variation_1302':
        return cls._create(arg) # type: ignore

RuleVariation_1231_Arg: TypeAlias = Variation_1302_Arg
class RuleVariation_1231(RuleVariationContextFree):
    cv_variation = Variation_1302

    @classmethod
    def create(cls, arg : RuleVariation_1231_Arg) -> "RuleVariation_1231":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1302:
        return self.arg # type: ignore

NonSpare_159_Arg: TypeAlias = RuleVariation_1231_Arg
class NonSpare_159(NonSpare):
    cv_name = "042"
    cv_title = "Position in Cartesian Co-ordinates"
    cv_rule = RuleVariation_1231

    @classmethod
    def create(cls, arg : NonSpare_159_Arg) -> "NonSpare_159":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1231:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1302:
        return self.rule.variation

class UapItem_159(UapItem):
    cv_non_spare = NonSpare_159

Content_777_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM/s"]]]
class Content_777(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 6.103515625e-5
    cv_unit = "NM/s"

    def as_quantity(self, cv_unit : Optional[Literal["NM/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_776_Arg: TypeAlias = Content_777_Arg
class RuleContent_776(RuleContentContextFree):
    cv_content = Content_777

    @property
    def content(self) -> Content_777:
        return self._get_content() # type: ignore

Variation_337_Arg: TypeAlias = RuleContent_776_Arg
class Variation_337(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_776

    @classmethod
    def create(cls, arg : Variation_337_Arg) -> "Variation_337":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_776:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_777:
        return self.rule.content

RuleVariation_330_Arg: TypeAlias = Variation_337_Arg
class RuleVariation_330(RuleVariationContextFree):
    cv_variation = Variation_337

    @classmethod
    def create(cls, arg : RuleVariation_330_Arg) -> "RuleVariation_330":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_337:
        return self.arg # type: ignore

NonSpare_1034_Arg: TypeAlias = RuleVariation_330_Arg
class NonSpare_1034(NonSpare):
    cv_name = "GSP"
    cv_title = "Ground Speed"
    cv_rule = RuleVariation_330

    @classmethod
    def create(cls, arg : NonSpare_1034_Arg) -> "NonSpare_1034":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_330:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_337:
        return self.rule.variation

Item_374_Arg: TypeAlias = NonSpare_1034_Arg
class Item_374(Item):
    cv_non_spare = NonSpare_1034

    @classmethod
    def create(cls, arg : Item_374_Arg) -> "Item_374":
        return cls._create(arg) # type: ignore

NonSpare_1893_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_1893(NonSpare):
    cv_name = "TRA"
    cv_title = "Track Angle"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_1893_Arg) -> "NonSpare_1893":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Item_1022_Arg: TypeAlias = NonSpare_1893_Arg
class Item_1022(Item):
    cv_non_spare = NonSpare_1893

    @classmethod
    def create(cls, arg : Item_1022_Arg) -> "Item_1022":
        return cls._create(arg) # type: ignore

Variation_1110_Arg_Group = Tuple[Union[RuleVariation_330_Arg, Tuple[Literal["GSP"], RuleVariation_330_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["TRA"], RuleVariation_334_Arg]]]
Variation_1110_Arg: TypeAlias = Union[int, Variation_1110_Arg_Group]
class Variation_1110(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_374, 16), (Item_1022, 16)]
    cv_items_dict = {"GSP": RuleVariation_330, "TRA": RuleVariation_334}

    @overload
    @classmethod
    def spec(cls, key : Literal["GSP"]) -> RuleVariation_330:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRA"]) -> RuleVariation_334:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GSP"], Literal["TRA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GSP"]) -> RuleVariation_330:
        ...
    @overload
    def get_item(self, key : Literal["TRA"]) -> RuleVariation_334:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1110_Arg) -> 'Variation_1110':
        return cls._create(arg) # type: ignore

RuleVariation_1068_Arg: TypeAlias = Variation_1110_Arg
class RuleVariation_1068(RuleVariationContextFree):
    cv_variation = Variation_1110

    @classmethod
    def create(cls, arg : RuleVariation_1068_Arg) -> "RuleVariation_1068":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1110:
        return self.arg # type: ignore

NonSpare_386_Arg: TypeAlias = RuleVariation_1068_Arg
class NonSpare_386(NonSpare):
    cv_name = "200"
    cv_title = "Calculated Track Velocity in Polar Co-ordinates"
    cv_rule = RuleVariation_1068

    @classmethod
    def create(cls, arg : NonSpare_386_Arg) -> "NonSpare_386":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1068:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1110:
        return self.rule.variation

class UapItem_386(UapItem):
    cv_non_spare = NonSpare_386

Content_666_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
class Content_666(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 6.25e-2
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_666_Arg: TypeAlias = Content_666_Arg
class RuleContent_666(RuleContentContextFree):
    cv_content = Content_666

    @property
    def content(self) -> Content_666:
        return self._get_content() # type: ignore

Variation_280_Arg: TypeAlias = RuleContent_666_Arg
class Variation_280(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_666

    @classmethod
    def create(cls, arg : Variation_280_Arg) -> "Variation_280":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_666:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_666:
        return self.rule.content

RuleVariation_273_Arg: TypeAlias = Variation_280_Arg
class RuleVariation_273(RuleVariationContextFree):
    cv_variation = Variation_280

    @classmethod
    def create(cls, arg : RuleVariation_273_Arg) -> "RuleVariation_273":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_280:
        return self.arg # type: ignore

NonSpare_2042_Arg: TypeAlias = RuleVariation_273_Arg
class NonSpare_2042(NonSpare):
    cv_name = "VX"
    cv_title = "X Velocity"
    cv_rule = RuleVariation_273

    @classmethod
    def create(cls, arg : NonSpare_2042_Arg) -> "NonSpare_2042":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_273:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_280:
        return self.rule.variation

Item_1154_Arg: TypeAlias = NonSpare_2042_Arg
class Item_1154(Item):
    cv_non_spare = NonSpare_2042

    @classmethod
    def create(cls, arg : Item_1154_Arg) -> "Item_1154":
        return cls._create(arg) # type: ignore

NonSpare_2047_Arg: TypeAlias = RuleVariation_273_Arg
class NonSpare_2047(NonSpare):
    cv_name = "VY"
    cv_title = "Y Velocity"
    cv_rule = RuleVariation_273

    @classmethod
    def create(cls, arg : NonSpare_2047_Arg) -> "NonSpare_2047":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_273:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_280:
        return self.rule.variation

Item_1159_Arg: TypeAlias = NonSpare_2047_Arg
class Item_1159(Item):
    cv_non_spare = NonSpare_2047

    @classmethod
    def create(cls, arg : Item_1159_Arg) -> "Item_1159":
        return cls._create(arg) # type: ignore

Variation_1276_Arg_Group = Tuple[Union[RuleVariation_273_Arg, Tuple[Literal["VX"], RuleVariation_273_Arg]], Union[RuleVariation_273_Arg, Tuple[Literal["VY"], RuleVariation_273_Arg]]]
Variation_1276_Arg: TypeAlias = Union[int, Variation_1276_Arg_Group]
class Variation_1276(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1154, 16), (Item_1159, 16)]
    cv_items_dict = {"VX": RuleVariation_273, "VY": RuleVariation_273}

    @overload
    @classmethod
    def spec(cls, key : Literal["VX"]) -> RuleVariation_273:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VY"]) -> RuleVariation_273:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VX"], Literal["VY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VX"]) -> RuleVariation_273:
        ...
    @overload
    def get_item(self, key : Literal["VY"]) -> RuleVariation_273:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1276_Arg) -> 'Variation_1276':
        return cls._create(arg) # type: ignore

RuleVariation_1206_Arg: TypeAlias = Variation_1276_Arg
class RuleVariation_1206(RuleVariationContextFree):
    cv_variation = Variation_1276

    @classmethod
    def create(cls, arg : RuleVariation_1206_Arg) -> "RuleVariation_1206":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1276:
        return self.arg # type: ignore

NonSpare_399_Arg: TypeAlias = RuleVariation_1206_Arg
class NonSpare_399(NonSpare):
    cv_name = "202"
    cv_title = "Calculated Track Velocity in Cartesian Co-ordinates"
    cv_rule = RuleVariation_1206

    @classmethod
    def create(cls, arg : NonSpare_399_Arg) -> "NonSpare_399":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1206:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1276:
        return self.rule.variation

class UapItem_399(UapItem):
    cv_non_spare = NonSpare_399

NonSpare_1910_Arg: TypeAlias = RuleVariation_775_Arg
class NonSpare_1910(NonSpare):
    cv_name = "TRK"
    cv_title = "Track Number"
    cv_rule = RuleVariation_775

    @classmethod
    def create(cls, arg : NonSpare_1910_Arg) -> "NonSpare_1910":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_775:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_805:
        return self.rule.variation

Item_1035_Arg: TypeAlias = NonSpare_1910_Arg
class Item_1035(Item):
    cv_non_spare = NonSpare_1910

    @classmethod
    def create(cls, arg : Item_1035_Arg) -> "Item_1035":
        return cls._create(arg) # type: ignore

Variation_1031_Arg_Group = Tuple[int, Union[RuleVariation_775_Arg, Tuple[Literal["TRK"], RuleVariation_775_Arg]]]
Variation_1031_Arg: TypeAlias = Union[int, Variation_1031_Arg_Group]
class Variation_1031(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_1035, 12)]
    cv_items_dict = {"TRK": RuleVariation_775}

    @classmethod
    def spec(cls, key : Literal["TRK"]) -> RuleVariation_775:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["TRK"]) -> RuleVariation_775:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1031_Arg) -> 'Variation_1031':
        return cls._create(arg) # type: ignore

RuleVariation_999_Arg: TypeAlias = Variation_1031_Arg
class RuleVariation_999(RuleVariationContextFree):
    cv_variation = Variation_1031

    @classmethod
    def create(cls, arg : RuleVariation_999_Arg) -> "RuleVariation_999":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1031:
        return self.arg # type: ignore

NonSpare_357_Arg: TypeAlias = RuleVariation_999_Arg
class NonSpare_357(NonSpare):
    cv_name = "161"
    cv_title = "Track Number"
    cv_rule = RuleVariation_999

    @classmethod
    def create(cls, arg : NonSpare_357_Arg) -> "NonSpare_357":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_999:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1031:
        return self.rule.variation

class UapItem_357(UapItem):
    cv_non_spare = NonSpare_357

Content_63_Arg: TypeAlias = int
class Content_63(ContentTable):
    cv_values = {0: "Confirmed track", 1: "Track in initialisation phase"}

RuleContent_63_Arg: TypeAlias = Content_63_Arg
class RuleContent_63(RuleContentContextFree):
    cv_content = Content_63

    @property
    def content(self) -> Content_63:
        return self._get_content() # type: ignore

Variation_18_Arg: TypeAlias = RuleContent_63_Arg
class Variation_18(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_63

    @classmethod
    def create(cls, arg : Variation_18_Arg) -> "Variation_18":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_63:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_63:
        return self.rule.content

RuleVariation_18_Arg: TypeAlias = Variation_18_Arg
class RuleVariation_18(RuleVariationContextFree):
    cv_variation = Variation_18

    @classmethod
    def create(cls, arg : RuleVariation_18_Arg) -> "RuleVariation_18":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_18:
        return self.arg # type: ignore

Variation_409_Arg: TypeAlias = RuleContent_112_Arg
class Variation_409(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_112

    @classmethod
    def create(cls, arg : Variation_409_Arg) -> "Variation_409":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_112:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_112:
        return self.rule.content

RuleVariation_398_Arg: TypeAlias = Variation_409_Arg
class RuleVariation_398(RuleVariationContextFree):
    cv_variation = Variation_409

    @classmethod
    def create(cls, arg : RuleVariation_398_Arg) -> "RuleVariation_398":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_409:
        return self.arg # type: ignore

Content_359_Arg: TypeAlias = int
class Content_359(ContentTable):
    cv_values = {0: "No extrapolation", 1: "Predictable extrapolation due to sensor refresh period (see NOTE)", 2: "Predictable extrapolation in masked area", 3: "Extrapolation due to unpredictable absence of detection"}

RuleContent_359_Arg: TypeAlias = Content_359_Arg
class RuleContent_359(RuleContentContextFree):
    cv_content = Content_359

    @property
    def content(self) -> Content_359:
        return self._get_content() # type: ignore

Variation_591_Arg: TypeAlias = RuleContent_359_Arg
class Variation_591(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_359

    @classmethod
    def create(cls, arg : Variation_591_Arg) -> "Variation_591":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_359:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_359:
        return self.rule.content

RuleVariation_580_Arg: TypeAlias = Variation_591_Arg
class RuleVariation_580(RuleVariationContextFree):
    cv_variation = Variation_591

    @classmethod
    def create(cls, arg : RuleVariation_580_Arg) -> "RuleVariation_580":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_591:
        return self.arg # type: ignore

Content_105_Arg: TypeAlias = int
class Content_105(ContentTable):
    cv_values = {0: "Default", 1: "Horizontal manoeuvre"}

RuleContent_105_Arg: TypeAlias = Content_105_Arg
class RuleContent_105(RuleContentContextFree):
    cv_content = Content_105

    @property
    def content(self) -> Content_105:
        return self._get_content() # type: ignore

Variation_703_Arg: TypeAlias = RuleContent_105_Arg
class Variation_703(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_105

    @classmethod
    def create(cls, arg : Variation_703_Arg) -> "Variation_703":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_105:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_105:
        return self.rule.content

RuleVariation_692_Arg: TypeAlias = Variation_703_Arg
class RuleVariation_692(RuleVariationContextFree):
    cv_variation = Variation_703

    @classmethod
    def create(cls, arg : RuleVariation_692_Arg) -> "RuleVariation_692":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_703:
        return self.arg # type: ignore

Content_513_Arg: TypeAlias = int
class Content_513(ContentTable):
    cv_values = {0: "Tracking performed in 'Sensor Plane', i.e. neither slant range correction nor projection was applied", 1: "Slant range correction and a suitable projection technique are used to track in a 2D.reference plane, tangential to the earth model at the Sensor Site co-ordinates"}

RuleContent_513_Arg: TypeAlias = Content_513_Arg
class RuleContent_513(RuleContentContextFree):
    cv_content = Content_513

    @property
    def content(self) -> Content_513:
        return self._get_content() # type: ignore

Variation_871_Arg: TypeAlias = RuleContent_513_Arg
class Variation_871(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_513

    @classmethod
    def create(cls, arg : Variation_871_Arg) -> "Variation_871":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_513:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_513:
        return self.rule.content

RuleVariation_841_Arg: TypeAlias = Variation_871_Arg
class RuleVariation_841(RuleVariationContextFree):
    cv_variation = Variation_871

    @classmethod
    def create(cls, arg : RuleVariation_841_Arg) -> "RuleVariation_841":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_871:
        return self.arg # type: ignore

Content_266_Arg: TypeAlias = int
class Content_266(ContentTable):
    cv_values = {0: "Measured position", 1: "Smoothed position"}

RuleContent_266_Arg: TypeAlias = Content_266_Arg
class RuleContent_266(RuleContentContextFree):
    cv_content = Content_266

    @property
    def content(self) -> Content_266:
        return self._get_content() # type: ignore

Variation_934_Arg: TypeAlias = RuleContent_266_Arg
class Variation_934(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_266

    @classmethod
    def create(cls, arg : Variation_934_Arg) -> "Variation_934":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_266:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_266:
        return self.rule.content

RuleVariation_904_Arg: TypeAlias = Variation_934_Arg
class RuleVariation_904(RuleVariationContextFree):
    cv_variation = Variation_934

    @classmethod
    def create(cls, arg : RuleVariation_904_Arg) -> "RuleVariation_904":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_934:
        return self.arg # type: ignore

Content_552_Arg: TypeAlias = int
class Content_552(ContentTable):
    cv_values = {0: "Unknown type of movement", 1: "Taking-off", 2: "Landing", 3: "Other types of movement"}

RuleContent_552_Arg: TypeAlias = Content_552_Arg
class RuleContent_552(RuleContentContextFree):
    cv_content = Content_552

    @property
    def content(self) -> Content_552:
        return self._get_content() # type: ignore

Variation_116_Arg: TypeAlias = RuleContent_552_Arg
class Variation_116(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_552

    @classmethod
    def create(cls, arg : Variation_116_Arg) -> "Variation_116":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_552:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_552:
        return self.rule.content

RuleVariation_116_Arg: TypeAlias = Variation_116_Arg
class RuleVariation_116(RuleVariationContextFree):
    cv_variation = Variation_116

    @classmethod
    def create(cls, arg : RuleVariation_116_Arg) -> "RuleVariation_116":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_116:
        return self.arg # type: ignore

Content_351_Arg: TypeAlias = int
class Content_351(ContentTable):
    cv_values = {0: "No doubt", 1: "Doubtful correlation (undetermined reason)", 2: "Doubtful correlation in clutter", 3: "Loss of accuracy", 4: "Loss of accuracy in clutter", 5: "Unstable track", 6: "Previously coasted"}

RuleContent_351_Arg: TypeAlias = Content_351_Arg
class RuleContent_351(RuleContentContextFree):
    cv_content = Content_351

    @property
    def content(self) -> Content_351:
        return self._get_content() # type: ignore

Variation_597_Arg: TypeAlias = RuleContent_351_Arg
class Variation_597(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 3
    cv_rule = RuleContent_351

    @classmethod
    def create(cls, arg : Variation_597_Arg) -> "Variation_597":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_351:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_351:
        return self.rule.content

RuleVariation_586_Arg: TypeAlias = Variation_597_Arg
class RuleVariation_586(RuleVariationContextFree):
    cv_variation = Variation_597

    @classmethod
    def create(cls, arg : RuleVariation_586_Arg) -> "RuleVariation_586":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_597:
        return self.arg # type: ignore

Content_267_Arg: TypeAlias = int
class Content_267(ContentTable):
    cv_values = {0: "Merge or split indication undetermined", 1: "Track merged by association to plot", 2: "Track merged by non-association to plot", 3: "Split track"}

RuleContent_267_Arg: TypeAlias = Content_267_Arg
class RuleContent_267(RuleContentContextFree):
    cv_content = Content_267

    @property
    def content(self) -> Content_267:
        return self._get_content() # type: ignore

Variation_876_Arg: TypeAlias = RuleContent_267_Arg
class Variation_876(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_267

    @classmethod
    def create(cls, arg : Variation_876_Arg) -> "Variation_876":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_267:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_267:
        return self.rule.content

RuleVariation_846_Arg: TypeAlias = Variation_876_Arg
class RuleVariation_846(RuleVariationContextFree):
    cv_variation = Variation_876

    @classmethod
    def create(cls, arg : RuleVariation_846_Arg) -> "RuleVariation_846":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_876:
        return self.arg # type: ignore

Variation_28_Arg: TypeAlias = RuleContent_99_Arg
class Variation_28(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_99

    @classmethod
    def create(cls, arg : Variation_28_Arg) -> "Variation_28":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_99:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_99:
        return self.rule.content

RuleVariation_28_Arg: TypeAlias = Variation_28_Arg
class RuleVariation_28(RuleVariationContextFree):
    cv_variation = Variation_28

    @classmethod
    def create(cls, arg : RuleVariation_28_Arg) -> "RuleVariation_28":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_28:
        return self.arg # type: ignore

NonSpare_740_Arg: TypeAlias = RuleVariation_18_Arg
class NonSpare_740(NonSpare):
    cv_name = "CNF"
    cv_title = ""
    cv_rule = RuleVariation_18

    @classmethod
    def create(cls, arg : NonSpare_740_Arg) -> "NonSpare_740":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_18:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_18:
        return self.rule.variation

Item_164_Arg: TypeAlias = NonSpare_740_Arg
class Item_164(Item):
    cv_non_spare = NonSpare_740

    @classmethod
    def create(cls, arg : Item_164_Arg) -> "Item_164":
        return cls._create(arg) # type: ignore

NonSpare_1906_Arg: TypeAlias = RuleVariation_398_Arg
class NonSpare_1906(NonSpare):
    cv_name = "TRE"
    cv_title = ""
    cv_rule = RuleVariation_398

    @classmethod
    def create(cls, arg : NonSpare_1906_Arg) -> "NonSpare_1906":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_398:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_409:
        return self.rule.variation

Item_1033_Arg: TypeAlias = NonSpare_1906_Arg
class Item_1033(Item):
    cv_non_spare = NonSpare_1906

    @classmethod
    def create(cls, arg : Item_1033_Arg) -> "Item_1033":
        return cls._create(arg) # type: ignore

NonSpare_834_Arg: TypeAlias = RuleVariation_580_Arg
class NonSpare_834(NonSpare):
    cv_name = "CST"
    cv_title = ""
    cv_rule = RuleVariation_580

    @classmethod
    def create(cls, arg : NonSpare_834_Arg) -> "NonSpare_834":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_580:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_591:
        return self.rule.variation

Item_223_Arg: TypeAlias = NonSpare_834_Arg
class Item_223(Item):
    cv_non_spare = NonSpare_834

    @classmethod
    def create(cls, arg : Item_223_Arg) -> "Item_223":
        return cls._create(arg) # type: ignore

NonSpare_1214_Arg: TypeAlias = RuleVariation_692_Arg
class NonSpare_1214(NonSpare):
    cv_name = "MAH"
    cv_title = ""
    cv_rule = RuleVariation_692

    @classmethod
    def create(cls, arg : NonSpare_1214_Arg) -> "NonSpare_1214":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_692:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_703:
        return self.rule.variation

Item_520_Arg: TypeAlias = NonSpare_1214_Arg
class Item_520(Item):
    cv_non_spare = NonSpare_1214

    @classmethod
    def create(cls, arg : Item_520_Arg) -> "Item_520":
        return cls._create(arg) # type: ignore

NonSpare_1832_Arg: TypeAlias = RuleVariation_841_Arg
class NonSpare_1832(NonSpare):
    cv_name = "TCC"
    cv_title = ""
    cv_rule = RuleVariation_841

    @classmethod
    def create(cls, arg : NonSpare_1832_Arg) -> "NonSpare_1832":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_841:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_871:
        return self.rule.variation

Item_977_Arg: TypeAlias = NonSpare_1832_Arg
class Item_977(Item):
    cv_non_spare = NonSpare_1832

    @classmethod
    def create(cls, arg : Item_977_Arg) -> "Item_977":
        return cls._create(arg) # type: ignore

NonSpare_1780_Arg: TypeAlias = RuleVariation_904_Arg
class NonSpare_1780(NonSpare):
    cv_name = "STH"
    cv_title = ""
    cv_rule = RuleVariation_904

    @classmethod
    def create(cls, arg : NonSpare_1780_Arg) -> "NonSpare_1780":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_904:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_934:
        return self.rule.variation

Item_946_Arg: TypeAlias = NonSpare_1780_Arg
class Item_946(Item):
    cv_non_spare = NonSpare_1780

    @classmethod
    def create(cls, arg : Item_946_Arg) -> "Item_946":
        return cls._create(arg) # type: ignore

NonSpare_1876_Arg: TypeAlias = RuleVariation_116_Arg
class NonSpare_1876(NonSpare):
    cv_name = "TOM"
    cv_title = ""
    cv_rule = RuleVariation_116

    @classmethod
    def create(cls, arg : NonSpare_1876_Arg) -> "NonSpare_1876":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_116:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_116:
        return self.rule.variation

Item_1007_Arg: TypeAlias = NonSpare_1876_Arg
class Item_1007(Item):
    cv_non_spare = NonSpare_1876

    @classmethod
    def create(cls, arg : Item_1007_Arg) -> "Item_1007":
        return cls._create(arg) # type: ignore

NonSpare_885_Arg: TypeAlias = RuleVariation_586_Arg
class NonSpare_885(NonSpare):
    cv_name = "DOU"
    cv_title = ""
    cv_rule = RuleVariation_586

    @classmethod
    def create(cls, arg : NonSpare_885_Arg) -> "NonSpare_885":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_586:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_597:
        return self.rule.variation

Item_266_Arg: TypeAlias = NonSpare_885_Arg
class Item_266(Item):
    cv_non_spare = NonSpare_885

    @classmethod
    def create(cls, arg : Item_266_Arg) -> "Item_266":
        return cls._create(arg) # type: ignore

NonSpare_1308_Arg: TypeAlias = RuleVariation_846_Arg
class NonSpare_1308(NonSpare):
    cv_name = "MRS"
    cv_title = ""
    cv_rule = RuleVariation_846

    @classmethod
    def create(cls, arg : NonSpare_1308_Arg) -> "NonSpare_1308":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_846:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_876:
        return self.rule.variation

Item_580_Arg: TypeAlias = NonSpare_1308_Arg
class Item_580(Item):
    cv_non_spare = NonSpare_1308

    @classmethod
    def create(cls, arg : Item_580_Arg) -> "Item_580":
        return cls._create(arg) # type: ignore

NonSpare_1027_Arg: TypeAlias = RuleVariation_28_Arg
class NonSpare_1027(NonSpare):
    cv_name = "GHO"
    cv_title = ""
    cv_rule = RuleVariation_28

    @classmethod
    def create(cls, arg : NonSpare_1027_Arg) -> "NonSpare_1027":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_28:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_28:
        return self.rule.variation

Item_368_Arg: TypeAlias = NonSpare_1027_Arg
class Item_368(Item):
    cv_non_spare = NonSpare_1027

    @classmethod
    def create(cls, arg : Item_368_Arg) -> "Item_368":
        return cls._create(arg) # type: ignore

Variation_1343_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_18_Arg, Tuple[Literal["CNF"], RuleVariation_18_Arg]], Union[RuleVariation_398_Arg, Tuple[Literal["TRE"], RuleVariation_398_Arg]], Union[RuleVariation_580_Arg, Tuple[Literal["CST"], RuleVariation_580_Arg]], Union[RuleVariation_692_Arg, Tuple[Literal["MAH"], RuleVariation_692_Arg]], Union[RuleVariation_841_Arg, Tuple[Literal["TCC"], RuleVariation_841_Arg]], Union[RuleVariation_904_Arg, Tuple[Literal["STH"], RuleVariation_904_Arg]], None]]
Variation_1343_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_116_Arg, Tuple[Literal["TOM"], RuleVariation_116_Arg]], Union[RuleVariation_586_Arg, Tuple[Literal["DOU"], RuleVariation_586_Arg]], Union[RuleVariation_846_Arg, Tuple[Literal["MRS"], RuleVariation_846_Arg]], None]]
Variation_1343_Arg_Group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_28_Arg, Tuple[Literal["GHO"], RuleVariation_28_Arg]], int, None]]
Variation_1343_Arg: TypeAlias = Union[
    Tuple[Variation_1343_Arg_Group_1],
    Tuple[Variation_1343_Arg_Group_1, Variation_1343_Arg_Group_2],
    Tuple[Variation_1343_Arg_Group_1, Variation_1343_Arg_Group_2, Variation_1343_Arg_Group_3],
]
class Variation_1343(Extended):
    cv_items_list = [[(Item_164, 1), (Item_1033, 1), (Item_223, 2), (Item_520, 1), (Item_977, 1), (Item_946, 1), None], [(Item_1007, 2), (Item_266, 3), (Item_580, 2), None], [(Item_368, 1), (Item_9, 6), None]]

    @classmethod
    def create(cls, arg : Variation_1343_Arg) -> 'Variation_1343':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_18:
        ...
    @overload
    def get_item(self, key : Literal["TRE"]) -> RuleVariation_398:
        ...
    @overload
    def get_item(self, key : Literal["CST"]) -> RuleVariation_580:
        ...
    @overload
    def get_item(self, key : Literal["MAH"]) -> RuleVariation_692:
        ...
    @overload
    def get_item(self, key : Literal["TCC"]) -> RuleVariation_841:
        ...
    @overload
    def get_item(self, key : Literal["STH"]) -> RuleVariation_904:
        ...
    @overload
    def get_item(self, key : Literal["TOM"]) -> Optional[RuleVariation_116]:
        ...
    @overload
    def get_item(self, key : Literal["DOU"]) -> Optional[RuleVariation_586]:
        ...
    @overload
    def get_item(self, key : Literal["MRS"]) -> Optional[RuleVariation_846]:
        ...
    @overload
    def get_item(self, key : Literal["GHO"]) -> Optional[RuleVariation_28]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1266_Arg: TypeAlias = Variation_1343_Arg
class RuleVariation_1266(RuleVariationContextFree):
    cv_variation = Variation_1343

    @classmethod
    def create(cls, arg : RuleVariation_1266_Arg) -> "RuleVariation_1266":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1343:
        return self.arg # type: ignore

NonSpare_369_Arg: TypeAlias = RuleVariation_1266_Arg
class NonSpare_369(NonSpare):
    cv_name = "170"
    cv_title = "Track Status"
    cv_rule = RuleVariation_1266

    @classmethod
    def create(cls, arg : NonSpare_369_Arg) -> "NonSpare_369":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1266:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1343:
        return self.rule.variation

class UapItem_369(UapItem):
    cv_non_spare = NonSpare_369

NonSpare_1982_Arg: TypeAlias = RuleVariation_15_Arg
class NonSpare_1982(NonSpare):
    cv_name = "V"
    cv_title = "Validated"
    cv_rule = RuleVariation_15

    @classmethod
    def create(cls, arg : NonSpare_1982_Arg) -> "NonSpare_1982":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_15:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_15:
        return self.rule.variation

Item_1100_Arg: TypeAlias = NonSpare_1982_Arg
class Item_1100(Item):
    cv_non_spare = NonSpare_1982

    @classmethod
    def create(cls, arg : Item_1100_Arg) -> "Item_1100":
        return cls._create(arg) # type: ignore

NonSpare_1003_Arg: TypeAlias = RuleVariation_394_Arg
class NonSpare_1003(NonSpare):
    cv_name = "G"
    cv_title = "Garbled"
    cv_rule = RuleVariation_394

    @classmethod
    def create(cls, arg : NonSpare_1003_Arg) -> "NonSpare_1003":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_394:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_405:
        return self.rule.variation

Item_355_Arg: TypeAlias = NonSpare_1003_Arg
class Item_355(Item):
    cv_non_spare = NonSpare_1003

    @classmethod
    def create(cls, arg : Item_355_Arg) -> "Item_355":
        return cls._create(arg) # type: ignore

Content_288_Arg: TypeAlias = int
class Content_288(ContentTable):
    cv_values = {0: "Mode-3/A code derived from the reply of the transponder", 1: "Mode-3/A code not extracted during the last scan"}

RuleContent_288_Arg: TypeAlias = Content_288_Arg
class RuleContent_288(RuleContentContextFree):
    cv_content = Content_288

    @property
    def content(self) -> Content_288:
        return self._get_content() # type: ignore

Variation_550_Arg: TypeAlias = RuleContent_288_Arg
class Variation_550(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_288

    @classmethod
    def create(cls, arg : Variation_550_Arg) -> "Variation_550":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_288:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_288:
        return self.rule.content

RuleVariation_539_Arg: TypeAlias = Variation_550_Arg
class RuleVariation_539(RuleVariationContextFree):
    cv_variation = Variation_550

    @classmethod
    def create(cls, arg : RuleVariation_539_Arg) -> "RuleVariation_539":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_550:
        return self.arg # type: ignore

NonSpare_1132_Arg: TypeAlias = RuleVariation_539_Arg
class NonSpare_1132(NonSpare):
    cv_name = "L"
    cv_title = ""
    cv_rule = RuleVariation_539

    @classmethod
    def create(cls, arg : NonSpare_1132_Arg) -> "NonSpare_1132":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_539:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_550:
        return self.rule.variation

Item_450_Arg: TypeAlias = NonSpare_1132_Arg
class Item_450(Item):
    cv_non_spare = NonSpare_1132

    @classmethod
    def create(cls, arg : Item_450_Arg) -> "Item_450":
        return cls._create(arg) # type: ignore

Variation_1268_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_539_Arg, Tuple[Literal["L"], RuleVariation_539_Arg]], int, Union[RuleVariation_776_Arg, Tuple[Literal["MODE3A"], RuleVariation_776_Arg]]]
Variation_1268_Arg: TypeAlias = Union[int, Variation_1268_Arg_Group]
class Variation_1268(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1100, 1), (Item_355, 1), (Item_450, 1), (Item_16, 1), (Item_572, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "L": RuleVariation_539, "MODE3A": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_539:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_539:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1268_Arg) -> 'Variation_1268':
        return cls._create(arg) # type: ignore

RuleVariation_1198_Arg: TypeAlias = Variation_1268_Arg
class RuleVariation_1198(RuleVariationContextFree):
    cv_variation = Variation_1268

    @classmethod
    def create(cls, arg : RuleVariation_1198_Arg) -> "RuleVariation_1198":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1268:
        return self.arg # type: ignore

NonSpare_189_Arg: TypeAlias = RuleVariation_1198_Arg
class NonSpare_189(NonSpare):
    cv_name = "060"
    cv_title = "Mode-3/A Code in Octal Representation"
    cv_rule = RuleVariation_1198

    @classmethod
    def create(cls, arg : NonSpare_189_Arg) -> "NonSpare_189":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1198:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1268:
        return self.rule.variation

class UapItem_189(UapItem):
    cv_non_spare = NonSpare_189

Variation_347_Arg: TypeAlias = RuleContent_0_Arg
class Variation_347(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_347_Arg) -> "Variation_347":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_340_Arg: TypeAlias = Variation_347_Arg
class RuleVariation_340(RuleVariationContextFree):
    cv_variation = Variation_347

    @classmethod
    def create(cls, arg : RuleVariation_340_Arg) -> "RuleVariation_340":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_347:
        return self.arg # type: ignore

NonSpare_421_Arg: TypeAlias = RuleVariation_340_Arg
class NonSpare_421(NonSpare):
    cv_name = "220"
    cv_title = "Target Address"
    cv_rule = RuleVariation_340

    @classmethod
    def create(cls, arg : NonSpare_421_Arg) -> "NonSpare_421":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_340:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_347:
        return self.rule.variation

class UapItem_421(UapItem):
    cv_non_spare = NonSpare_421

Content_51_Arg: TypeAlias = int
class Content_51(ContentTable):
    cv_values = {0: "Callsign or registration downlinked from transponder", 1: "Callsign not downlinked from transponder", 2: "Registration not downlinked from transponder"}

RuleContent_51_Arg: TypeAlias = Content_51_Arg
class RuleContent_51(RuleContentContextFree):
    cv_content = Content_51

    @property
    def content(self) -> Content_51:
        return self._get_content() # type: ignore

Variation_97_Arg: TypeAlias = RuleContent_51_Arg
class Variation_97(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_51

    @classmethod
    def create(cls, arg : Variation_97_Arg) -> "Variation_97":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_51:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_51:
        return self.rule.content

RuleVariation_97_Arg: TypeAlias = Variation_97_Arg
class RuleVariation_97(RuleVariationContextFree):
    cv_variation = Variation_97

    @classmethod
    def create(cls, arg : RuleVariation_97_Arg) -> "RuleVariation_97":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_97:
        return self.arg # type: ignore

NonSpare_1782_Arg: TypeAlias = RuleVariation_97_Arg
class NonSpare_1782(NonSpare):
    cv_name = "STI"
    cv_title = ""
    cv_rule = RuleVariation_97

    @classmethod
    def create(cls, arg : NonSpare_1782_Arg) -> "NonSpare_1782":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_97:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_97:
        return self.rule.variation

Item_948_Arg: TypeAlias = NonSpare_1782_Arg
class Item_948(Item):
    cv_non_spare = NonSpare_1782

    @classmethod
    def create(cls, arg : Item_948_Arg) -> "Item_948":
        return cls._create(arg) # type: ignore

Item_15_Arg: TypeAlias = int
class Item_15(Spare):
    cv_bit_offset8 = 2
    cv_bit_size = 6

NonSpare_729_Arg: TypeAlias = RuleVariation_381_Arg
class NonSpare_729(NonSpare):
    cv_name = "CHR"
    cv_title = "Characters 1-8 (Coded on 6 Bits Each) Defining Target Identification"
    cv_rule = RuleVariation_381

    @classmethod
    def create(cls, arg : NonSpare_729_Arg) -> "NonSpare_729":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_381:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_389:
        return self.rule.variation

Item_157_Arg: TypeAlias = NonSpare_729_Arg
class Item_157(Item):
    cv_non_spare = NonSpare_729

    @classmethod
    def create(cls, arg : Item_157_Arg) -> "Item_157":
        return cls._create(arg) # type: ignore

Variation_1210_Arg_Group = Tuple[Union[RuleVariation_97_Arg, Tuple[Literal["STI"], RuleVariation_97_Arg]], int, Union[RuleVariation_381_Arg, Tuple[Literal["CHR"], RuleVariation_381_Arg]]]
Variation_1210_Arg: TypeAlias = Union[int, Variation_1210_Arg_Group]
class Variation_1210(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_items_list = [(Item_948, 2), (Item_15, 6), (Item_157, 48)]
    cv_items_dict = {"STI": RuleVariation_97, "CHR": RuleVariation_381}

    @overload
    @classmethod
    def spec(cls, key : Literal["STI"]) -> RuleVariation_97:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CHR"]) -> RuleVariation_381:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["STI"], Literal["CHR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["STI"]) -> RuleVariation_97:
        ...
    @overload
    def get_item(self, key : Literal["CHR"]) -> RuleVariation_381:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1210_Arg) -> 'Variation_1210':
        return cls._create(arg) # type: ignore

RuleVariation_1155_Arg: TypeAlias = Variation_1210_Arg
class RuleVariation_1155(RuleVariationContextFree):
    cv_variation = Variation_1210

    @classmethod
    def create(cls, arg : RuleVariation_1155_Arg) -> "RuleVariation_1155":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1210:
        return self.arg # type: ignore

NonSpare_436_Arg: TypeAlias = RuleVariation_1155_Arg
class NonSpare_436(NonSpare):
    cv_name = "245"
    cv_title = "Target Identification"
    cv_rule = RuleVariation_1155

    @classmethod
    def create(cls, arg : NonSpare_436_Arg) -> "NonSpare_436":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1155:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1210:
        return self.rule.variation

class UapItem_436(UapItem):
    cv_non_spare = NonSpare_436

Variation_390_Arg: TypeAlias = RuleContent_0_Arg
class Variation_390(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_390_Arg) -> "Variation_390":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_382_Arg: TypeAlias = Variation_390_Arg
class RuleVariation_382(RuleVariationContextFree):
    cv_variation = Variation_390

    @classmethod
    def create(cls, arg : RuleVariation_382_Arg) -> "RuleVariation_382":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_390:
        return self.arg # type: ignore

NonSpare_1225_Arg: TypeAlias = RuleVariation_382_Arg
class NonSpare_1225(NonSpare):
    cv_name = "MBDATA"
    cv_title = ""
    cv_rule = RuleVariation_382

    @classmethod
    def create(cls, arg : NonSpare_1225_Arg) -> "NonSpare_1225":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_382:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_390:
        return self.rule.variation

Item_527_Arg: TypeAlias = NonSpare_1225_Arg
class Item_527(Item):
    cv_non_spare = NonSpare_1225

    @classmethod
    def create(cls, arg : Item_527_Arg) -> "Item_527":
        return cls._create(arg) # type: ignore

NonSpare_669_Arg: TypeAlias = RuleVariation_131_Arg
class NonSpare_669(NonSpare):
    cv_name = "BDS1"
    cv_title = ""
    cv_rule = RuleVariation_131

    @classmethod
    def create(cls, arg : NonSpare_669_Arg) -> "NonSpare_669":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_131:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_131:
        return self.rule.variation

Item_114_Arg: TypeAlias = NonSpare_669_Arg
class Item_114(Item):
    cv_non_spare = NonSpare_669

    @classmethod
    def create(cls, arg : Item_114_Arg) -> "Item_114":
        return cls._create(arg) # type: ignore

Variation_796_Arg: TypeAlias = RuleContent_0_Arg
class Variation_796(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 4
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_796_Arg) -> "Variation_796":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_766_Arg: TypeAlias = Variation_796_Arg
class RuleVariation_766(RuleVariationContextFree):
    cv_variation = Variation_796

    @classmethod
    def create(cls, arg : RuleVariation_766_Arg) -> "RuleVariation_766":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_796:
        return self.arg # type: ignore

NonSpare_671_Arg: TypeAlias = RuleVariation_766_Arg
class NonSpare_671(NonSpare):
    cv_name = "BDS2"
    cv_title = ""
    cv_rule = RuleVariation_766

    @classmethod
    def create(cls, arg : NonSpare_671_Arg) -> "NonSpare_671":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_766:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_796:
        return self.rule.variation

Item_116_Arg: TypeAlias = NonSpare_671_Arg
class Item_116(Item):
    cv_non_spare = NonSpare_671

    @classmethod
    def create(cls, arg : Item_116_Arg) -> "Item_116":
        return cls._create(arg) # type: ignore

Variation_1136_Arg_Group = Tuple[Union[RuleVariation_382_Arg, Tuple[Literal["MBDATA"], RuleVariation_382_Arg]], Union[RuleVariation_131_Arg, Tuple[Literal["BDS1"], RuleVariation_131_Arg]], Union[RuleVariation_766_Arg, Tuple[Literal["BDS2"], RuleVariation_766_Arg]]]
Variation_1136_Arg: TypeAlias = Union[int, Variation_1136_Arg_Group]
class Variation_1136(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_527, 56), (Item_114, 4), (Item_116, 4)]
    cv_items_dict = {"MBDATA": RuleVariation_382, "BDS1": RuleVariation_131, "BDS2": RuleVariation_766}

    @overload
    @classmethod
    def spec(cls, key : Literal["MBDATA"]) -> RuleVariation_382:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BDS1"]) -> RuleVariation_131:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BDS2"]) -> RuleVariation_766:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MBDATA"], Literal["BDS1"], Literal["BDS2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MBDATA"]) -> RuleVariation_382:
        ...
    @overload
    def get_item(self, key : Literal["BDS1"]) -> RuleVariation_131:
        ...
    @overload
    def get_item(self, key : Literal["BDS2"]) -> RuleVariation_766:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1136_Arg) -> 'Variation_1136':
        return cls._create(arg) # type: ignore

Variation_1413_Arg: TypeAlias = List[Variation_1136_Arg]
class Variation_1413(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1136

    @classmethod
    def create(cls, arg : Variation_1413_Arg) -> 'Variation_1413':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1136]:
        return self._get_list() # type: ignore

RuleVariation_1336_Arg: TypeAlias = Variation_1413_Arg
class RuleVariation_1336(RuleVariationContextFree):
    cv_variation = Variation_1413

    @classmethod
    def create(cls, arg : RuleVariation_1336_Arg) -> "RuleVariation_1336":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1413:
        return self.arg # type: ignore

NonSpare_443_Arg: TypeAlias = RuleVariation_1336_Arg
class NonSpare_443(NonSpare):
    cv_name = "250"
    cv_title = "Mode S MB Data"
    cv_rule = RuleVariation_1336

    @classmethod
    def create(cls, arg : NonSpare_443_Arg) -> "NonSpare_443":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1413:
        return self.rule.variation

class UapItem_443(UapItem):
    cv_non_spare = NonSpare_443

Content_535_Arg: TypeAlias = int
class Content_535(ContentTable):
    cv_values = {0: "Unknown", 1: "ATC equipment maintenance", 2: "Airport maintenance", 3: "Fire", 4: "Bird scarer", 5: "Snow plough", 6: "Runway sweeper", 7: "Emergency", 8: "Police", 9: "Bus", 10: "Tug (push/tow)", 11: "Grass cutter", 12: "Fuel", 13: "Baggage", 14: "Catering", 15: "Aircraft maintenance", 16: "Flyco (follow me)"}

RuleContent_535_Arg: TypeAlias = Content_535_Arg
class RuleContent_535(RuleContentContextFree):
    cv_content = Content_535

    @property
    def content(self) -> Content_535:
        return self._get_content() # type: ignore

Variation_176_Arg: TypeAlias = RuleContent_535_Arg
class Variation_176(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_535

    @classmethod
    def create(cls, arg : Variation_176_Arg) -> "Variation_176":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_535:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_535:
        return self.rule.content

RuleVariation_169_Arg: TypeAlias = Variation_176_Arg
class RuleVariation_169(RuleVariationContextFree):
    cv_variation = Variation_176

    @classmethod
    def create(cls, arg : RuleVariation_169_Arg) -> "RuleVariation_169":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_176:
        return self.arg # type: ignore

NonSpare_472_Arg: TypeAlias = RuleVariation_169_Arg
class NonSpare_472(NonSpare):
    cv_name = "300"
    cv_title = "Vehicle Fleet Identification"
    cv_rule = RuleVariation_169

    @classmethod
    def create(cls, arg : NonSpare_472_Arg) -> "NonSpare_472":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_169:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_176:
        return self.rule.variation

class UapItem_472(UapItem):
    cv_non_spare = NonSpare_472

NonSpare_966_Arg: TypeAlias = RuleVariation_595_Arg
class NonSpare_966(NonSpare):
    cv_name = "FL"
    cv_title = "Flight Level"
    cv_rule = RuleVariation_595

    @classmethod
    def create(cls, arg : NonSpare_966_Arg) -> "NonSpare_966":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_595:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_606:
        return self.rule.variation

Item_329_Arg: TypeAlias = NonSpare_966_Arg
class Item_329(Item):
    cv_non_spare = NonSpare_966

    @classmethod
    def create(cls, arg : Item_329_Arg) -> "Item_329":
        return cls._create(arg) # type: ignore

Variation_1264_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_595_Arg, Tuple[Literal["FL"], RuleVariation_595_Arg]]]
Variation_1264_Arg: TypeAlias = Union[int, Variation_1264_Arg_Group]
class Variation_1264(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1100, 1), (Item_355, 1), (Item_329, 14)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "FL": RuleVariation_595}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FL"]) -> RuleVariation_595:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["FL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["FL"]) -> RuleVariation_595:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1264_Arg) -> 'Variation_1264':
        return cls._create(arg) # type: ignore

RuleVariation_1194_Arg: TypeAlias = Variation_1264_Arg
class RuleVariation_1194(RuleVariationContextFree):
    cv_variation = Variation_1264

    @classmethod
    def create(cls, arg : RuleVariation_1194_Arg) -> "RuleVariation_1194":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1264:
        return self.arg # type: ignore

NonSpare_246_Arg: TypeAlias = RuleVariation_1194_Arg
class NonSpare_246(NonSpare):
    cv_name = "090"
    cv_title = "Flight Level in Binary Representation"
    cv_rule = RuleVariation_1194

    @classmethod
    def create(cls, arg : NonSpare_246_Arg) -> "NonSpare_246":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1194:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1264:
        return self.rule.variation

class UapItem_246(UapItem):
    cv_non_spare = NonSpare_246

Content_682_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
class Content_682(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 6.25
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

RuleContent_682_Arg: TypeAlias = Content_682_Arg
class RuleContent_682(RuleContentContextFree):
    cv_content = Content_682

    @property
    def content(self) -> Content_682:
        return self._get_content() # type: ignore

Variation_288_Arg: TypeAlias = RuleContent_682_Arg
class Variation_288(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_682

    @classmethod
    def create(cls, arg : Variation_288_Arg) -> "Variation_288":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_682:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_682:
        return self.rule.content

RuleVariation_281_Arg: TypeAlias = Variation_288_Arg
class RuleVariation_281(RuleVariationContextFree):
    cv_variation = Variation_288

    @classmethod
    def create(cls, arg : RuleVariation_281_Arg) -> "RuleVariation_281":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_288:
        return self.arg # type: ignore

NonSpare_256_Arg: TypeAlias = RuleVariation_281_Arg
class NonSpare_256(NonSpare):
    cv_name = "091"
    cv_title = "Measured Height"
    cv_rule = RuleVariation_281

    @classmethod
    def create(cls, arg : NonSpare_256_Arg) -> "NonSpare_256":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_281:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_288:
        return self.rule.variation

class UapItem_256(UapItem):
    cv_non_spare = NonSpare_256

Content_716_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_716(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_716_Arg: TypeAlias = Content_716_Arg
class RuleContent_716(RuleContentContextFree):
    cv_content = Content_716

    @property
    def content(self) -> Content_716:
        return self._get_content() # type: ignore

Variation_160_Arg: TypeAlias = RuleContent_716_Arg
class Variation_160(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_716

    @classmethod
    def create(cls, arg : Variation_160_Arg) -> "Variation_160":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_716:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_716:
        return self.rule.content

RuleVariation_154_Arg: TypeAlias = Variation_160_Arg
class RuleVariation_154(RuleVariationContextFree):
    cv_variation = Variation_160

    @classmethod
    def create(cls, arg : RuleVariation_154_Arg) -> "RuleVariation_154":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_160:
        return self.arg # type: ignore

Content_786_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_786(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 2.8125
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_785_Arg: TypeAlias = Content_786_Arg
class RuleContent_785(RuleContentContextFree):
    cv_content = Content_786

    @property
    def content(self) -> Content_786:
        return self._get_content() # type: ignore

Variation_163_Arg: TypeAlias = RuleContent_785_Arg
class Variation_163(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_785

    @classmethod
    def create(cls, arg : Variation_163_Arg) -> "Variation_163":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_785:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_786:
        return self.rule.content

RuleVariation_157_Arg: TypeAlias = Variation_163_Arg
class RuleVariation_157(RuleVariationContextFree):
    cv_variation = Variation_163

    @classmethod
    def create(cls, arg : RuleVariation_157_Arg) -> "RuleVariation_157":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_163:
        return self.arg # type: ignore

NonSpare_1159_Arg: TypeAlias = RuleVariation_154_Arg
class NonSpare_1159(NonSpare):
    cv_name = "LENGTH"
    cv_title = "Length"
    cv_rule = RuleVariation_154

    @classmethod
    def create(cls, arg : NonSpare_1159_Arg) -> "NonSpare_1159":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_154:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_160:
        return self.rule.variation

Item_475_Arg: TypeAlias = NonSpare_1159_Arg
class Item_475(Item):
    cv_non_spare = NonSpare_1159

    @classmethod
    def create(cls, arg : Item_475_Arg) -> "Item_475":
        return cls._create(arg) # type: ignore

NonSpare_1393_Arg: TypeAlias = RuleVariation_157_Arg
class NonSpare_1393(NonSpare):
    cv_name = "ORIENTATION"
    cv_title = "Orientation"
    cv_rule = RuleVariation_157

    @classmethod
    def create(cls, arg : NonSpare_1393_Arg) -> "NonSpare_1393":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_157:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_163:
        return self.rule.variation

Item_658_Arg: TypeAlias = NonSpare_1393_Arg
class Item_658(Item):
    cv_non_spare = NonSpare_1393

    @classmethod
    def create(cls, arg : Item_658_Arg) -> "Item_658":
        return cls._create(arg) # type: ignore

NonSpare_2052_Arg: TypeAlias = RuleVariation_154_Arg
class NonSpare_2052(NonSpare):
    cv_name = "WIDTH"
    cv_title = "Width"
    cv_rule = RuleVariation_154

    @classmethod
    def create(cls, arg : NonSpare_2052_Arg) -> "NonSpare_2052":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_154:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_160:
        return self.rule.variation

Item_1162_Arg: TypeAlias = NonSpare_2052_Arg
class Item_1162(Item):
    cv_non_spare = NonSpare_2052

    @classmethod
    def create(cls, arg : Item_1162_Arg) -> "Item_1162":
        return cls._create(arg) # type: ignore

Variation_1355_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_154_Arg, Tuple[Literal["LENGTH"], RuleVariation_154_Arg]], None]]
Variation_1355_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_157_Arg, Tuple[Literal["ORIENTATION"], RuleVariation_157_Arg]], None]]
Variation_1355_Arg_Group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_154_Arg, Tuple[Literal["WIDTH"], RuleVariation_154_Arg]], None]]
Variation_1355_Arg: TypeAlias = Union[
    Tuple[Variation_1355_Arg_Group_1],
    Tuple[Variation_1355_Arg_Group_1, Variation_1355_Arg_Group_2],
    Tuple[Variation_1355_Arg_Group_1, Variation_1355_Arg_Group_2, Variation_1355_Arg_Group_3],
]
class Variation_1355(Extended):
    cv_items_list = [[(Item_475, 7), None], [(Item_658, 7), None], [(Item_1162, 7), None]]

    @classmethod
    def create(cls, arg : Variation_1355_Arg) -> 'Variation_1355':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["LENGTH"]) -> RuleVariation_154:
        ...
    @overload
    def get_item(self, key : Literal["ORIENTATION"]) -> Optional[RuleVariation_157]:
        ...
    @overload
    def get_item(self, key : Literal["WIDTH"]) -> Optional[RuleVariation_154]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1278_Arg: TypeAlias = Variation_1355_Arg
class RuleVariation_1278(RuleVariationContextFree):
    cv_variation = Variation_1355

    @classmethod
    def create(cls, arg : RuleVariation_1278_Arg) -> "RuleVariation_1278":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1355:
        return self.arg # type: ignore

NonSpare_456_Arg: TypeAlias = RuleVariation_1278_Arg
class NonSpare_456(NonSpare):
    cv_name = "270"
    cv_title = "Target Size and Orientation"
    cv_rule = RuleVariation_1278

    @classmethod
    def create(cls, arg : NonSpare_456_Arg) -> "NonSpare_456":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1278:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1355:
        return self.rule.variation

class UapItem_456(UapItem):
    cv_non_spare = NonSpare_456

Content_409_Arg: TypeAlias = int
class Content_409(ContentTable):
    cv_values = {0: "Operational", 1: "Degraded", 2: "NOGO"}

RuleContent_409_Arg: TypeAlias = Content_409_Arg
class RuleContent_409(RuleContentContextFree):
    cv_content = Content_409

    @property
    def content(self) -> Content_409:
        return self._get_content() # type: ignore

Variation_107_Arg: TypeAlias = RuleContent_409_Arg
class Variation_107(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_409

    @classmethod
    def create(cls, arg : Variation_107_Arg) -> "Variation_107":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_409:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_409:
        return self.rule.content

RuleVariation_107_Arg: TypeAlias = Variation_107_Arg
class RuleVariation_107(RuleVariationContextFree):
    cv_variation = Variation_107

    @classmethod
    def create(cls, arg : RuleVariation_107_Arg) -> "RuleVariation_107":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_107:
        return self.arg # type: ignore

NonSpare_1360_Arg: TypeAlias = RuleVariation_107_Arg
class NonSpare_1360(NonSpare):
    cv_name = "NOGO"
    cv_title = "Operational Release Status of the System"
    cv_rule = RuleVariation_107

    @classmethod
    def create(cls, arg : NonSpare_1360_Arg) -> "NonSpare_1360":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_107:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_107:
        return self.rule.variation

Item_626_Arg: TypeAlias = NonSpare_1360_Arg
class Item_626(Item):
    cv_non_spare = NonSpare_1360

    @classmethod
    def create(cls, arg : Item_626_Arg) -> "Item_626":
        return cls._create(arg) # type: ignore

Content_367_Arg: TypeAlias = int
class Content_367(ContentTable):
    cv_values = {0: "No overload", 1: "Overload"}

RuleContent_367_Arg: TypeAlias = Content_367_Arg
class RuleContent_367(RuleContentContextFree):
    cv_content = Content_367

    @property
    def content(self) -> Content_367:
        return self._get_content() # type: ignore

Variation_561_Arg: TypeAlias = RuleContent_367_Arg
class Variation_561(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_367

    @classmethod
    def create(cls, arg : Variation_561_Arg) -> "Variation_561":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_367:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_367:
        return self.rule.content

RuleVariation_550_Arg: TypeAlias = Variation_561_Arg
class RuleVariation_550(RuleVariationContextFree):
    cv_variation = Variation_561

    @classmethod
    def create(cls, arg : RuleVariation_550_Arg) -> "RuleVariation_550":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_561:
        return self.arg # type: ignore

NonSpare_1400_Arg: TypeAlias = RuleVariation_550_Arg
class NonSpare_1400(NonSpare):
    cv_name = "OVL"
    cv_title = "Overload Indicator"
    cv_rule = RuleVariation_550

    @classmethod
    def create(cls, arg : NonSpare_1400_Arg) -> "NonSpare_1400":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_550:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_561:
        return self.rule.variation

Item_664_Arg: TypeAlias = NonSpare_1400_Arg
class Item_664(Item):
    cv_non_spare = NonSpare_1400

    @classmethod
    def create(cls, arg : Item_664_Arg) -> "Item_664":
        return cls._create(arg) # type: ignore

Content_557_Arg: TypeAlias = int
class Content_557(ContentTable):
    cv_values = {0: "Valid", 1: "Invalid"}

RuleContent_557_Arg: TypeAlias = Content_557_Arg
class RuleContent_557(RuleContentContextFree):
    cv_content = Content_557

    @property
    def content(self) -> Content_557:
        return self._get_content() # type: ignore

Variation_670_Arg: TypeAlias = RuleContent_557_Arg
class Variation_670(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_557

    @classmethod
    def create(cls, arg : Variation_670_Arg) -> "Variation_670":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_557:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_557:
        return self.rule.content

RuleVariation_659_Arg: TypeAlias = Variation_670_Arg
class RuleVariation_659(RuleVariationContextFree):
    cv_variation = Variation_670

    @classmethod
    def create(cls, arg : RuleVariation_659_Arg) -> "RuleVariation_659":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_670:
        return self.arg # type: ignore

NonSpare_1932_Arg: TypeAlias = RuleVariation_659_Arg
class NonSpare_1932(NonSpare):
    cv_name = "TSV"
    cv_title = "Time Source Validity"
    cv_rule = RuleVariation_659

    @classmethod
    def create(cls, arg : NonSpare_1932_Arg) -> "NonSpare_1932":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_659:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_670:
        return self.rule.variation

Item_1055_Arg: TypeAlias = NonSpare_1932_Arg
class Item_1055(Item):
    cv_non_spare = NonSpare_1932

    @classmethod
    def create(cls, arg : Item_1055_Arg) -> "Item_1055":
        return cls._create(arg) # type: ignore

Content_380_Arg: TypeAlias = int
class Content_380(ContentTable):
    cv_values = {0: "Normal Operation", 1: "Diversity degraded"}

RuleContent_380_Arg: TypeAlias = Content_380_Arg
class RuleContent_380(RuleContentContextFree):
    cv_content = Content_380

    @property
    def content(self) -> Content_380:
        return self._get_content() # type: ignore

Variation_739_Arg: TypeAlias = RuleContent_380_Arg
class Variation_739(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_380

    @classmethod
    def create(cls, arg : Variation_739_Arg) -> "Variation_739":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_380:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_380:
        return self.rule.content

RuleVariation_728_Arg: TypeAlias = Variation_739_Arg
class RuleVariation_728(RuleVariationContextFree):
    cv_variation = Variation_739

    @classmethod
    def create(cls, arg : RuleVariation_728_Arg) -> "RuleVariation_728":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_739:
        return self.arg # type: ignore

NonSpare_877_Arg: TypeAlias = RuleVariation_728_Arg
class NonSpare_877(NonSpare):
    cv_name = "DIV"
    cv_title = ""
    cv_rule = RuleVariation_728

    @classmethod
    def create(cls, arg : NonSpare_877_Arg) -> "NonSpare_877":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_728:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_739:
        return self.rule.variation

Item_260_Arg: TypeAlias = NonSpare_877_Arg
class Item_260(Item):
    cv_non_spare = NonSpare_877

    @classmethod
    def create(cls, arg : Item_260_Arg) -> "Item_260":
        return cls._create(arg) # type: ignore

Content_485_Arg: TypeAlias = int
class Content_485(ContentTable):
    cv_values = {0: "Test Target Operative", 1: "Test Target Failure"}

RuleContent_485_Arg: TypeAlias = Content_485_Arg
class RuleContent_485(RuleContentContextFree):
    cv_content = Content_485

    @property
    def content(self) -> Content_485:
        return self._get_content() # type: ignore

Variation_869_Arg: TypeAlias = RuleContent_485_Arg
class Variation_869(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_485

    @classmethod
    def create(cls, arg : Variation_869_Arg) -> "Variation_869":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_485:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_485:
        return self.rule.content

RuleVariation_839_Arg: TypeAlias = Variation_869_Arg
class RuleVariation_839(RuleVariationContextFree):
    cv_variation = Variation_869

    @classmethod
    def create(cls, arg : RuleVariation_839_Arg) -> "RuleVariation_839":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_869:
        return self.arg # type: ignore

NonSpare_1939_Arg: TypeAlias = RuleVariation_839_Arg
class NonSpare_1939(NonSpare):
    cv_name = "TTF"
    cv_title = ""
    cv_rule = RuleVariation_839

    @classmethod
    def create(cls, arg : NonSpare_1939_Arg) -> "NonSpare_1939":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_839:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_869:
        return self.rule.variation

Item_1060_Arg: TypeAlias = NonSpare_1939_Arg
class Item_1060(Item):
    cv_non_spare = NonSpare_1939

    @classmethod
    def create(cls, arg : Item_1060_Arg) -> "Item_1060":
        return cls._create(arg) # type: ignore

Variation_1147_Arg_Group = Tuple[Union[RuleVariation_107_Arg, Tuple[Literal["NOGO"], RuleVariation_107_Arg]], Union[RuleVariation_550_Arg, Tuple[Literal["OVL"], RuleVariation_550_Arg]], Union[RuleVariation_659_Arg, Tuple[Literal["TSV"], RuleVariation_659_Arg]], Union[RuleVariation_728_Arg, Tuple[Literal["DIV"], RuleVariation_728_Arg]], Union[RuleVariation_839_Arg, Tuple[Literal["TTF"], RuleVariation_839_Arg]], int]
Variation_1147_Arg: TypeAlias = Union[int, Variation_1147_Arg_Group]
class Variation_1147(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_626, 2), (Item_664, 1), (Item_1055, 1), (Item_260, 1), (Item_1060, 1), (Item_27, 2)]
    cv_items_dict = {"NOGO": RuleVariation_107, "OVL": RuleVariation_550, "TSV": RuleVariation_659, "DIV": RuleVariation_728, "TTF": RuleVariation_839}

    @overload
    @classmethod
    def spec(cls, key : Literal["NOGO"]) -> RuleVariation_107:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVL"]) -> RuleVariation_550:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TSV"]) -> RuleVariation_659:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DIV"]) -> RuleVariation_728:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TTF"]) -> RuleVariation_839:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["NOGO"], Literal["OVL"], Literal["TSV"], Literal["DIV"], Literal["TTF"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["NOGO"]) -> RuleVariation_107:
        ...
    @overload
    def get_item(self, key : Literal["OVL"]) -> RuleVariation_550:
        ...
    @overload
    def get_item(self, key : Literal["TSV"]) -> RuleVariation_659:
        ...
    @overload
    def get_item(self, key : Literal["DIV"]) -> RuleVariation_728:
        ...
    @overload
    def get_item(self, key : Literal["TTF"]) -> RuleVariation_839:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1147_Arg) -> 'Variation_1147':
        return cls._create(arg) # type: ignore

RuleVariation_1101_Arg: TypeAlias = Variation_1147_Arg
class RuleVariation_1101(RuleVariationContextFree):
    cv_variation = Variation_1147

    @classmethod
    def create(cls, arg : RuleVariation_1101_Arg) -> "RuleVariation_1101":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1147:
        return self.arg # type: ignore

NonSpare_518_Arg: TypeAlias = RuleVariation_1101_Arg
class NonSpare_518(NonSpare):
    cv_name = "550"
    cv_title = "System Status"
    cv_rule = RuleVariation_1101

    @classmethod
    def create(cls, arg : NonSpare_518_Arg) -> "NonSpare_518":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1101:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1147:
        return self.rule.variation

class UapItem_517(UapItem):
    cv_non_spare = NonSpare_518

Content_109_Arg: TypeAlias = int
class Content_109(ContentTable):
    cv_values = {0: "Default", 1: "In Trouble"}

RuleContent_109_Arg: TypeAlias = Content_109_Arg
class RuleContent_109(RuleContentContextFree):
    cv_content = Content_109

    @property
    def content(self) -> Content_109:
        return self._get_content() # type: ignore

Variation_30_Arg: TypeAlias = RuleContent_109_Arg
class Variation_30(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_109

    @classmethod
    def create(cls, arg : Variation_30_Arg) -> "Variation_30":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_109:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_109:
        return self.rule.content

RuleVariation_30_Arg: TypeAlias = Variation_30_Arg
class RuleVariation_30(RuleVariationContextFree):
    cv_variation = Variation_30

    @classmethod
    def create(cls, arg : RuleVariation_30_Arg) -> "RuleVariation_30":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_30:
        return self.arg # type: ignore

NonSpare_1899_Arg: TypeAlias = RuleVariation_30_Arg
class NonSpare_1899(NonSpare):
    cv_name = "TRB"
    cv_title = ""
    cv_rule = RuleVariation_30

    @classmethod
    def create(cls, arg : NonSpare_1899_Arg) -> "NonSpare_1899":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_30:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_30:
        return self.rule.variation

Item_1028_Arg: TypeAlias = NonSpare_1899_Arg
class Item_1028(Item):
    cv_non_spare = NonSpare_1899

    @classmethod
    def create(cls, arg : Item_1028_Arg) -> "Item_1028":
        return cls._create(arg) # type: ignore

Content_599_Arg: TypeAlias = int
class Content_599(ContentTable):
    cv_values = {1: "Towing aircraft", 2: "“Follow me” operation", 3: "Runway check", 4: "Emergency operation (fire, medical...)", 5: "Work in progress (maintenance, birds scarer, sweepers...)"}

RuleContent_599_Arg: TypeAlias = Content_599_Arg
class RuleContent_599(RuleContentContextFree):
    cv_content = Content_599

    @property
    def content(self) -> Content_599:
        return self._get_content() # type: ignore

Variation_493_Arg: TypeAlias = RuleContent_599_Arg
class Variation_493(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 7
    cv_rule = RuleContent_599

    @classmethod
    def create(cls, arg : Variation_493_Arg) -> "Variation_493":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_599:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_599:
        return self.rule.content

RuleVariation_482_Arg: TypeAlias = Variation_493_Arg
class RuleVariation_482(RuleVariationContextFree):
    cv_variation = Variation_493

    @classmethod
    def create(cls, arg : RuleVariation_482_Arg) -> "RuleVariation_482":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_493:
        return self.arg # type: ignore

NonSpare_1321_Arg: TypeAlias = RuleVariation_482_Arg
class NonSpare_1321(NonSpare):
    cv_name = "MSG"
    cv_title = ""
    cv_rule = RuleVariation_482

    @classmethod
    def create(cls, arg : NonSpare_1321_Arg) -> "NonSpare_1321":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_482:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_493:
        return self.rule.variation

Item_591_Arg: TypeAlias = NonSpare_1321_Arg
class Item_591(Item):
    cv_non_spare = NonSpare_1321

    @classmethod
    def create(cls, arg : Item_591_Arg) -> "Item_591":
        return cls._create(arg) # type: ignore

Variation_1224_Arg_Group = Tuple[Union[RuleVariation_30_Arg, Tuple[Literal["TRB"], RuleVariation_30_Arg]], Union[RuleVariation_482_Arg, Tuple[Literal["MSG"], RuleVariation_482_Arg]]]
Variation_1224_Arg: TypeAlias = Union[int, Variation_1224_Arg_Group]
class Variation_1224(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1028, 1), (Item_591, 7)]
    cv_items_dict = {"TRB": RuleVariation_30, "MSG": RuleVariation_482}

    @overload
    @classmethod
    def spec(cls, key : Literal["TRB"]) -> RuleVariation_30:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSG"]) -> RuleVariation_482:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TRB"], Literal["MSG"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TRB"]) -> RuleVariation_30:
        ...
    @overload
    def get_item(self, key : Literal["MSG"]) -> RuleVariation_482:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1224_Arg) -> 'Variation_1224':
        return cls._create(arg) # type: ignore

RuleVariation_1163_Arg: TypeAlias = Variation_1224_Arg
class RuleVariation_1163(RuleVariationContextFree):
    cv_variation = Variation_1224

    @classmethod
    def create(cls, arg : RuleVariation_1163_Arg) -> "RuleVariation_1163":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1224:
        return self.arg # type: ignore

NonSpare_474_Arg: TypeAlias = RuleVariation_1163_Arg
class NonSpare_474(NonSpare):
    cv_name = "310"
    cv_title = "Pre-programmed Message"
    cv_rule = RuleVariation_1163

    @classmethod
    def create(cls, arg : NonSpare_474_Arg) -> "NonSpare_474":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1163:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1224:
        return self.rule.variation

class UapItem_474(UapItem):
    cv_non_spare = NonSpare_474

Content_752_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_752(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.25
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_751_Arg: TypeAlias = Content_752_Arg
class RuleContent_751(RuleContentContextFree):
    cv_content = Content_752

    @property
    def content(self) -> Content_752:
        return self._get_content() # type: ignore

Variation_230_Arg: TypeAlias = RuleContent_751_Arg
class Variation_230(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_751

    @classmethod
    def create(cls, arg : Variation_230_Arg) -> "Variation_230":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_751:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_752:
        return self.rule.content

RuleVariation_223_Arg: TypeAlias = Variation_230_Arg
class RuleVariation_223(RuleVariationContextFree):
    cv_variation = Variation_230

    @classmethod
    def create(cls, arg : RuleVariation_223_Arg) -> "RuleVariation_223":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_230:
        return self.arg # type: ignore

NonSpare_872_Arg: TypeAlias = RuleVariation_223_Arg
class NonSpare_872(NonSpare):
    cv_name = "DEVX"
    cv_title = "Standard Deviation of X Component"
    cv_rule = RuleVariation_223

    @classmethod
    def create(cls, arg : NonSpare_872_Arg) -> "NonSpare_872":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_223:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_230:
        return self.rule.variation

Item_255_Arg: TypeAlias = NonSpare_872_Arg
class Item_255(Item):
    cv_non_spare = NonSpare_872

    @classmethod
    def create(cls, arg : Item_255_Arg) -> "Item_255":
        return cls._create(arg) # type: ignore

NonSpare_873_Arg: TypeAlias = RuleVariation_223_Arg
class NonSpare_873(NonSpare):
    cv_name = "DEVY"
    cv_title = "Standard Deviation of Y Component"
    cv_rule = RuleVariation_223

    @classmethod
    def create(cls, arg : NonSpare_873_Arg) -> "NonSpare_873":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_223:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_230:
        return self.rule.variation

Item_256_Arg: TypeAlias = NonSpare_873_Arg
class Item_256(Item):
    cv_non_spare = NonSpare_873

    @classmethod
    def create(cls, arg : Item_256_Arg) -> "Item_256":
        return cls._create(arg) # type: ignore

Content_655_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_655(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.25
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_655_Arg: TypeAlias = Content_655_Arg
class RuleContent_655(RuleContentContextFree):
    cv_content = Content_655

    @property
    def content(self) -> Content_655:
        return self._get_content() # type: ignore

Variation_273_Arg: TypeAlias = RuleContent_655_Arg
class Variation_273(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_655

    @classmethod
    def create(cls, arg : Variation_273_Arg) -> "Variation_273":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_655:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_655:
        return self.rule.content

RuleVariation_266_Arg: TypeAlias = Variation_273_Arg
class RuleVariation_266(RuleVariationContextFree):
    cv_variation = Variation_273

    @classmethod
    def create(cls, arg : RuleVariation_266_Arg) -> "RuleVariation_266":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_273:
        return self.arg # type: ignore

NonSpare_806_Arg: TypeAlias = RuleVariation_266_Arg
class NonSpare_806(NonSpare):
    cv_name = "COVXY"
    cv_title = "Covariance in Two’s Complement Form"
    cv_rule = RuleVariation_266

    @classmethod
    def create(cls, arg : NonSpare_806_Arg) -> "NonSpare_806":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_266:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_273:
        return self.rule.variation

Item_204_Arg: TypeAlias = NonSpare_806_Arg
class Item_204(Item):
    cv_non_spare = NonSpare_806

    @classmethod
    def create(cls, arg : Item_204_Arg) -> "Item_204":
        return cls._create(arg) # type: ignore

Variation_1080_Arg_Group = Tuple[Union[RuleVariation_223_Arg, Tuple[Literal["DEVX"], RuleVariation_223_Arg]], Union[RuleVariation_223_Arg, Tuple[Literal["DEVY"], RuleVariation_223_Arg]], Union[RuleVariation_266_Arg, Tuple[Literal["COVXY"], RuleVariation_266_Arg]]]
Variation_1080_Arg: TypeAlias = Union[int, Variation_1080_Arg_Group]
class Variation_1080(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_255, 8), (Item_256, 8), (Item_204, 16)]
    cv_items_dict = {"DEVX": RuleVariation_223, "DEVY": RuleVariation_223, "COVXY": RuleVariation_266}

    @overload
    @classmethod
    def spec(cls, key : Literal["DEVX"]) -> RuleVariation_223:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DEVY"]) -> RuleVariation_223:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVXY"]) -> RuleVariation_266:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["DEVX"], Literal["DEVY"], Literal["COVXY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["DEVX"]) -> RuleVariation_223:
        ...
    @overload
    def get_item(self, key : Literal["DEVY"]) -> RuleVariation_223:
        ...
    @overload
    def get_item(self, key : Literal["COVXY"]) -> RuleVariation_266:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1080_Arg) -> 'Variation_1080':
        return cls._create(arg) # type: ignore

RuleVariation_1040_Arg: TypeAlias = Variation_1080_Arg
class RuleVariation_1040(RuleVariationContextFree):
    cv_variation = Variation_1080

    @classmethod
    def create(cls, arg : RuleVariation_1040_Arg) -> "RuleVariation_1040":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1080:
        return self.arg # type: ignore

NonSpare_513_Arg: TypeAlias = RuleVariation_1040_Arg
class NonSpare_513(NonSpare):
    cv_name = "500"
    cv_title = "Standard Deviation of Position"
    cv_rule = RuleVariation_1040

    @classmethod
    def create(cls, arg : NonSpare_513_Arg) -> "NonSpare_513":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1040:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1080:
        return self.rule.variation

class UapItem_512(UapItem):
    cv_non_spare = NonSpare_513

Content_625_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_625(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.0
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_625_Arg: TypeAlias = Content_625_Arg
class RuleContent_625(RuleContentContextFree):
    cv_content = Content_625

    @property
    def content(self) -> Content_625:
        return self._get_content() # type: ignore

Variation_208_Arg: TypeAlias = RuleContent_625_Arg
class Variation_208(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_625

    @classmethod
    def create(cls, arg : Variation_208_Arg) -> "Variation_208":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_625:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_625:
        return self.rule.content

RuleVariation_201_Arg: TypeAlias = Variation_208_Arg
class RuleVariation_201(RuleVariationContextFree):
    cv_variation = Variation_208

    @classmethod
    def create(cls, arg : RuleVariation_201_Arg) -> "RuleVariation_201":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_208:
        return self.arg # type: ignore

NonSpare_890_Arg: TypeAlias = RuleVariation_201_Arg
class NonSpare_890(NonSpare):
    cv_name = "DRHO"
    cv_title = ""
    cv_rule = RuleVariation_201

    @classmethod
    def create(cls, arg : NonSpare_890_Arg) -> "NonSpare_890":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_201:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_208:
        return self.rule.variation

Item_269_Arg: TypeAlias = NonSpare_890_Arg
class Item_269(Item):
    cv_non_spare = NonSpare_890

    @classmethod
    def create(cls, arg : Item_269_Arg) -> "Item_269":
        return cls._create(arg) # type: ignore

Content_681_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_681(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.15
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_681_Arg: TypeAlias = Content_681_Arg
class RuleContent_681(RuleContentContextFree):
    cv_content = Content_681

    @property
    def content(self) -> Content_681:
        return self._get_content() # type: ignore

Variation_217_Arg: TypeAlias = RuleContent_681_Arg
class Variation_217(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_681

    @classmethod
    def create(cls, arg : Variation_217_Arg) -> "Variation_217":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_681:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_681:
        return self.rule.content

RuleVariation_210_Arg: TypeAlias = Variation_217_Arg
class RuleVariation_210(RuleVariationContextFree):
    cv_variation = Variation_217

    @classmethod
    def create(cls, arg : RuleVariation_210_Arg) -> "RuleVariation_210":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_217:
        return self.arg # type: ignore

NonSpare_901_Arg: TypeAlias = RuleVariation_210_Arg
class NonSpare_901(NonSpare):
    cv_name = "DTHETA"
    cv_title = ""
    cv_rule = RuleVariation_210

    @classmethod
    def create(cls, arg : NonSpare_901_Arg) -> "NonSpare_901":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_210:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_217:
        return self.rule.variation

Item_277_Arg: TypeAlias = NonSpare_901_Arg
class Item_277(Item):
    cv_non_spare = NonSpare_901

    @classmethod
    def create(cls, arg : Item_277_Arg) -> "Item_277":
        return cls._create(arg) # type: ignore

Variation_1082_Arg_Group = Tuple[Union[RuleVariation_201_Arg, Tuple[Literal["DRHO"], RuleVariation_201_Arg]], Union[RuleVariation_210_Arg, Tuple[Literal["DTHETA"], RuleVariation_210_Arg]]]
Variation_1082_Arg: TypeAlias = Union[int, Variation_1082_Arg_Group]
class Variation_1082(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_269, 8), (Item_277, 8)]
    cv_items_dict = {"DRHO": RuleVariation_201, "DTHETA": RuleVariation_210}

    @overload
    @classmethod
    def spec(cls, key : Literal["DRHO"]) -> RuleVariation_201:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DTHETA"]) -> RuleVariation_210:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["DRHO"], Literal["DTHETA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["DRHO"]) -> RuleVariation_201:
        ...
    @overload
    def get_item(self, key : Literal["DTHETA"]) -> RuleVariation_210:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1082_Arg) -> 'Variation_1082':
        return cls._create(arg) # type: ignore

Variation_1410_Arg: TypeAlias = List[Variation_1082_Arg]
class Variation_1410(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1082

    @classmethod
    def create(cls, arg : Variation_1410_Arg) -> 'Variation_1410':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1082]:
        return self._get_list() # type: ignore

RuleVariation_1333_Arg: TypeAlias = Variation_1410_Arg
class RuleVariation_1333(RuleVariationContextFree):
    cv_variation = Variation_1410

    @classmethod
    def create(cls, arg : RuleVariation_1333_Arg) -> "RuleVariation_1333":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1410:
        return self.arg # type: ignore

NonSpare_462_Arg: TypeAlias = RuleVariation_1333_Arg
class NonSpare_462(NonSpare):
    cv_name = "280"
    cv_title = "Presence"
    cv_rule = RuleVariation_1333

    @classmethod
    def create(cls, arg : NonSpare_462_Arg) -> "NonSpare_462":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1333:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1410:
        return self.rule.variation

class UapItem_462(UapItem):
    cv_non_spare = NonSpare_462

NonSpare_309_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_309(NonSpare):
    cv_name = "131"
    cv_title = "Amplitude of Primary Plot"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_309_Arg) -> "NonSpare_309":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_309(UapItem):
    cv_non_spare = NonSpare_309

Content_668_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
class Content_668(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 6.25e-2
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

RuleContent_668_Arg: TypeAlias = Content_668_Arg
class RuleContent_668(RuleContentContextFree):
    cv_content = Content_668

    @property
    def content(self) -> Content_668:
        return self._get_content() # type: ignore

Variation_211_Arg: TypeAlias = RuleContent_668_Arg
class Variation_211(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_668

    @classmethod
    def create(cls, arg : Variation_211_Arg) -> "Variation_211":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_668:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_668:
        return self.rule.content

RuleVariation_204_Arg: TypeAlias = Variation_211_Arg
class RuleVariation_204(RuleVariationContextFree):
    cv_variation = Variation_211

    @classmethod
    def create(cls, arg : RuleVariation_204_Arg) -> "RuleVariation_204":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_211:
        return self.arg # type: ignore

NonSpare_652_Arg: TypeAlias = RuleVariation_204_Arg
class NonSpare_652(NonSpare):
    cv_name = "AX"
    cv_title = "X Acceleration"
    cv_rule = RuleVariation_204

    @classmethod
    def create(cls, arg : NonSpare_652_Arg) -> "NonSpare_652":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_204:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_211:
        return self.rule.variation

Item_100_Arg: TypeAlias = NonSpare_652_Arg
class Item_100(Item):
    cv_non_spare = NonSpare_652

    @classmethod
    def create(cls, arg : Item_100_Arg) -> "Item_100":
        return cls._create(arg) # type: ignore

NonSpare_656_Arg: TypeAlias = RuleVariation_204_Arg
class NonSpare_656(NonSpare):
    cv_name = "AY"
    cv_title = "Y Acceleration"
    cv_rule = RuleVariation_204

    @classmethod
    def create(cls, arg : NonSpare_656_Arg) -> "NonSpare_656":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_204:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_211:
        return self.rule.variation

Item_104_Arg: TypeAlias = NonSpare_656_Arg
class Item_104(Item):
    cv_non_spare = NonSpare_656

    @classmethod
    def create(cls, arg : Item_104_Arg) -> "Item_104":
        return cls._create(arg) # type: ignore

Variation_1054_Arg_Group = Tuple[Union[RuleVariation_204_Arg, Tuple[Literal["AX"], RuleVariation_204_Arg]], Union[RuleVariation_204_Arg, Tuple[Literal["AY"], RuleVariation_204_Arg]]]
Variation_1054_Arg: TypeAlias = Union[int, Variation_1054_Arg_Group]
class Variation_1054(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_100, 8), (Item_104, 8)]
    cv_items_dict = {"AX": RuleVariation_204, "AY": RuleVariation_204}

    @overload
    @classmethod
    def spec(cls, key : Literal["AX"]) -> RuleVariation_204:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AY"]) -> RuleVariation_204:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AX"], Literal["AY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AX"]) -> RuleVariation_204:
        ...
    @overload
    def get_item(self, key : Literal["AY"]) -> RuleVariation_204:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1054_Arg) -> 'Variation_1054':
        return cls._create(arg) # type: ignore

RuleVariation_1021_Arg: TypeAlias = Variation_1054_Arg
class RuleVariation_1021(RuleVariationContextFree):
    cv_variation = Variation_1054

    @classmethod
    def create(cls, arg : RuleVariation_1021_Arg) -> "RuleVariation_1021":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1054:
        return self.arg # type: ignore

NonSpare_404_Arg: TypeAlias = RuleVariation_1021_Arg
class NonSpare_404(NonSpare):
    cv_name = "210"
    cv_title = "Calculated Acceleration"
    cv_rule = RuleVariation_1021

    @classmethod
    def create(cls, arg : NonSpare_404_Arg) -> "NonSpare_404":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1021:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1054:
        return self.rule.variation

class UapItem_404(UapItem):
    cv_non_spare = NonSpare_404

Record_37_Arg = TypedDict('Record_37_Arg', {
    "010": NonSpare_42_Arg,
    "000": NonSpare_12_Arg,
    "020": NonSpare_90_Arg,
    "140": NonSpare_326_Arg,
    "041": NonSpare_153_Arg,
    "040": NonSpare_138_Arg,
    "042": NonSpare_159_Arg,
    "200": NonSpare_386_Arg,
    "202": NonSpare_399_Arg,
    "161": NonSpare_357_Arg,
    "170": NonSpare_369_Arg,
    "060": NonSpare_189_Arg,
    "220": NonSpare_421_Arg,
    "245": NonSpare_436_Arg,
    "250": NonSpare_443_Arg,
    "300": NonSpare_472_Arg,
    "090": NonSpare_246_Arg,
    "091": NonSpare_256_Arg,
    "270": NonSpare_456_Arg,
    "550": NonSpare_518_Arg,
    "310": NonSpare_474_Arg,
    "500": NonSpare_513_Arg,
    "280": NonSpare_462_Arg,
    "131": NonSpare_309_Arg,
    "210": NonSpare_404_Arg,
    "SP": NonSpare_1723_Arg,
    "RE": NonSpare_1558_Arg,
}, total=False)
class Record_37(Record):
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_42, UapItem_12, UapItem_90, UapItem_326, UapItem_153, UapItem_138, UapItem_159, UapItem_386, UapItem_399, UapItem_357, UapItem_369, UapItem_189, UapItem_421, UapItem_436, UapItem_443, UapItem_472, UapItem_246, UapItem_256, UapItem_456, UapItem_517, UapItem_474, UapItem_512, UapItem_462, UapItem_309, UapItem_404, UapItem_544, UapItem_543, UapItem_542]
    cv_items_dict = {"010": NonSpare_42, "000": NonSpare_12, "020": NonSpare_90, "140": NonSpare_326, "041": NonSpare_153, "040": NonSpare_138, "042": NonSpare_159, "200": NonSpare_386, "202": NonSpare_399, "161": NonSpare_357, "170": NonSpare_369, "060": NonSpare_189, "220": NonSpare_421, "245": NonSpare_436, "250": NonSpare_443, "300": NonSpare_472, "090": NonSpare_246, "091": NonSpare_256, "270": NonSpare_456, "550": NonSpare_518, "310": NonSpare_474, "500": NonSpare_513, "280": NonSpare_462, "131": NonSpare_309, "210": NonSpare_404, "SP": NonSpare_1723, "RE": NonSpare_1558}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_42:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_12:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_90:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_326:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_153:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_138:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_386:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["202"]) -> NonSpare_399:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_357:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_369:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_189:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_421:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_436:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_443:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_472:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_246:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["091"]) -> NonSpare_256:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["270"]) -> NonSpare_456:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["550"]) -> NonSpare_518:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["310"]) -> NonSpare_474:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_513:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["280"]) -> NonSpare_462:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_309:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_404:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["020"], Literal["140"], Literal["041"], Literal["040"], Literal["042"], Literal["200"], Literal["202"], Literal["161"], Literal["170"], Literal["060"], Literal["220"], Literal["245"], Literal["250"], Literal["300"], Literal["090"], Literal["091"], Literal["270"], Literal["550"], Literal["310"], Literal["500"], Literal["280"], Literal["131"], Literal["210"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_42]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_12]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_90]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_326]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_153]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_138]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_159]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_386]:
        ...
    @overload
    def get_item(self, key : Literal["202"]) -> Optional[NonSpare_399]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_357]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_369]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_189]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_421]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_436]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_443]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_472]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_246]:
        ...
    @overload
    def get_item(self, key : Literal["091"]) -> Optional[NonSpare_256]:
        ...
    @overload
    def get_item(self, key : Literal["270"]) -> Optional[NonSpare_456]:
        ...
    @overload
    def get_item(self, key : Literal["550"]) -> Optional[NonSpare_518]:
        ...
    @overload
    def get_item(self, key : Literal["310"]) -> Optional[NonSpare_474]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_513]:
        ...
    @overload
    def get_item(self, key : Literal["280"]) -> Optional[NonSpare_462]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_309]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_404]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_42_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_12_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_90_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_326_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_153_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_138_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_159_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_386_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["202"], val : NonSpare_399_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_357_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_369_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_189_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_421_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_436_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_443_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_472_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_246_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["091"], val : NonSpare_256_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["270"], val : NonSpare_456_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["550"], val : NonSpare_518_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["310"], val : NonSpare_474_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_513_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["280"], val : NonSpare_462_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_309_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_404_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_37':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["202"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["091"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["270"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["550"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["310"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["280"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_37':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_37_Arg) -> 'Record_37':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_37", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_33_Arg: TypeAlias = Record_37
class Uap_33(UapSingle):
    cv_record = Record_37

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_37]]:
        return cls._parse(bs)

class Asterix_9(AstCat):
    cv_category = 10
    cv_edition = (1, 1)
    cv_uap = Uap_33

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_33_Arg]) -> "Asterix_9":
        return cls._create(records) # type: ignore

NonSpare_1646_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_1646(NonSpare):
    cv_name = "SAC"
    cv_title = "System Area Code Fixed to Zero"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_1646_Arg) -> "NonSpare_1646":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_853_Arg: TypeAlias = NonSpare_1646_Arg
class Item_853(Item):
    cv_non_spare = NonSpare_1646

    @classmethod
    def create(cls, arg : Item_853_Arg) -> "Item_853":
        return cls._create(arg) # type: ignore

Variation_1190_Arg_Group = Tuple[Union[RuleVariation_158_Arg, Tuple[Literal["SAC"], RuleVariation_158_Arg]], Union[RuleVariation_158_Arg, Tuple[Literal["SIC"], RuleVariation_158_Arg]]]
Variation_1190_Arg: TypeAlias = Union[int, Variation_1190_Arg_Group]
class Variation_1190(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_853, 8), (Item_883, 8)]
    cv_items_dict = {"SAC": RuleVariation_158, "SIC": RuleVariation_158}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAC"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIC"]) -> RuleVariation_158:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAC"], Literal["SIC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAC"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["SIC"]) -> RuleVariation_158:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1190_Arg) -> 'Variation_1190':
        return cls._create(arg) # type: ignore

RuleVariation_1137_Arg: TypeAlias = Variation_1190_Arg
class RuleVariation_1137(RuleVariationContextFree):
    cv_variation = Variation_1190

    @classmethod
    def create(cls, arg : RuleVariation_1137_Arg) -> "RuleVariation_1137":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1190:
        return self.arg # type: ignore

NonSpare_47_Arg: TypeAlias = RuleVariation_1137_Arg
class NonSpare_47(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1137

    @classmethod
    def create(cls, arg : NonSpare_47_Arg) -> "NonSpare_47":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1137:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1190:
        return self.rule.variation

class UapItem_47(UapItem):
    cv_non_spare = NonSpare_47

Content_597_Arg: TypeAlias = int
class Content_597(ContentTable):
    cv_values = {1: "Target reports, flight plan data and basic alerts", 2: "Manual attachment of flight plan to track", 3: "Manual detachment of flight plan to track", 4: "Insertion of flight plan data", 5: "Suppression of flight plan data", 6: "Modification of flight plan data", 7: "Holdbar status"}

RuleContent_597_Arg: TypeAlias = Content_597_Arg
class RuleContent_597(RuleContentContextFree):
    cv_content = Content_597

    @property
    def content(self) -> Content_597:
        return self._get_content() # type: ignore

Variation_197_Arg: TypeAlias = RuleContent_597_Arg
class Variation_197(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_597

    @classmethod
    def create(cls, arg : Variation_197_Arg) -> "Variation_197":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_597:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_597:
        return self.rule.content

RuleVariation_190_Arg: TypeAlias = Variation_197_Arg
class RuleVariation_190(RuleVariationContextFree):
    cv_variation = Variation_197

    @classmethod
    def create(cls, arg : RuleVariation_190_Arg) -> "RuleVariation_190":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_197:
        return self.arg # type: ignore

NonSpare_13_Arg: TypeAlias = RuleVariation_190_Arg
class NonSpare_13(NonSpare):
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule = RuleVariation_190

    @classmethod
    def create(cls, arg : NonSpare_13_Arg) -> "NonSpare_13":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_190:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_197:
        return self.rule.variation

class UapItem_13(UapItem):
    cv_non_spare = NonSpare_13

NonSpare_61_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_61(NonSpare):
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_61_Arg) -> "NonSpare_61":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_61(UapItem):
    cv_non_spare = NonSpare_61

NonSpare_331_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_331(NonSpare):
    cv_name = "140"
    cv_title = "Time of Track Information"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_331_Arg) -> "NonSpare_331":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_331(UapItem):
    cv_non_spare = NonSpare_331

NonSpare_1150_Arg: TypeAlias = RuleVariation_374_Arg
class NonSpare_1150(NonSpare):
    cv_name = "LAT"
    cv_title = "Latitude in WGS-84 in Two's Complement"
    cv_rule = RuleVariation_374

    @classmethod
    def create(cls, arg : NonSpare_1150_Arg) -> "NonSpare_1150":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_374:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_381:
        return self.rule.variation

Item_468_Arg: TypeAlias = NonSpare_1150_Arg
class Item_468(Item):
    cv_non_spare = NonSpare_1150

    @classmethod
    def create(cls, arg : Item_468_Arg) -> "Item_468":
        return cls._create(arg) # type: ignore

NonSpare_1179_Arg: TypeAlias = RuleVariation_372_Arg
class NonSpare_1179(NonSpare):
    cv_name = "LON"
    cv_title = "Longitude in WGS-84 in Two's Complement"
    cv_rule = RuleVariation_372

    @classmethod
    def create(cls, arg : NonSpare_1179_Arg) -> "NonSpare_1179":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_372:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_379:
        return self.rule.variation

Item_495_Arg: TypeAlias = NonSpare_1179_Arg
class Item_495(Item):
    cv_non_spare = NonSpare_1179

    @classmethod
    def create(cls, arg : Item_495_Arg) -> "Item_495":
        return cls._create(arg) # type: ignore

Variation_1129_Arg_Group = Tuple[Union[RuleVariation_374_Arg, Tuple[Literal["LAT"], RuleVariation_374_Arg]], Union[RuleVariation_372_Arg, Tuple[Literal["LON"], RuleVariation_372_Arg]]]
Variation_1129_Arg: TypeAlias = Union[int, Variation_1129_Arg_Group]
class Variation_1129(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_468, 32), (Item_495, 32)]
    cv_items_dict = {"LAT": RuleVariation_374, "LON": RuleVariation_372}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_374:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_372:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_374:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_372:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1129_Arg) -> 'Variation_1129':
        return cls._create(arg) # type: ignore

RuleVariation_1086_Arg: TypeAlias = Variation_1129_Arg
class RuleVariation_1086(RuleVariationContextFree):
    cv_variation = Variation_1129

    @classmethod
    def create(cls, arg : RuleVariation_1086_Arg) -> "RuleVariation_1086":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1129:
        return self.arg # type: ignore

NonSpare_154_Arg: TypeAlias = RuleVariation_1086_Arg
class NonSpare_154(NonSpare):
    cv_name = "041"
    cv_title = "Position in WGS-84 Coordinates"
    cv_rule = RuleVariation_1086

    @classmethod
    def create(cls, arg : NonSpare_154_Arg) -> "NonSpare_154":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1086:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1129:
        return self.rule.variation

class UapItem_154(UapItem):
    cv_non_spare = NonSpare_154

NonSpare_2088_Arg: TypeAlias = RuleVariation_250_Arg
class NonSpare_2088(NonSpare):
    cv_name = "X"
    cv_title = "X-Component"
    cv_rule = RuleVariation_250

    @classmethod
    def create(cls, arg : NonSpare_2088_Arg) -> "NonSpare_2088":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_250:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_257:
        return self.rule.variation

Item_1195_Arg: TypeAlias = NonSpare_2088_Arg
class Item_1195(Item):
    cv_non_spare = NonSpare_2088

    @classmethod
    def create(cls, arg : Item_1195_Arg) -> "Item_1195":
        return cls._create(arg) # type: ignore

NonSpare_2142_Arg: TypeAlias = RuleVariation_250_Arg
class NonSpare_2142(NonSpare):
    cv_name = "Y"
    cv_title = "Y-Component"
    cv_rule = RuleVariation_250

    @classmethod
    def create(cls, arg : NonSpare_2142_Arg) -> "NonSpare_2142":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_250:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_257:
        return self.rule.variation

Item_1246_Arg: TypeAlias = NonSpare_2142_Arg
class Item_1246(Item):
    cv_non_spare = NonSpare_2142

    @classmethod
    def create(cls, arg : Item_1246_Arg) -> "Item_1246":
        return cls._create(arg) # type: ignore

Variation_1305_Arg_Group = Tuple[Union[RuleVariation_250_Arg, Tuple[Literal["X"], RuleVariation_250_Arg]], Union[RuleVariation_250_Arg, Tuple[Literal["Y"], RuleVariation_250_Arg]]]
Variation_1305_Arg: TypeAlias = Union[int, Variation_1305_Arg_Group]
class Variation_1305(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1195, 16), (Item_1246, 16)]
    cv_items_dict = {"X": RuleVariation_250, "Y": RuleVariation_250}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_250:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_250:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_250:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_250:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1305_Arg) -> 'Variation_1305':
        return cls._create(arg) # type: ignore

RuleVariation_1233_Arg: TypeAlias = Variation_1305_Arg
class RuleVariation_1233(RuleVariationContextFree):
    cv_variation = Variation_1305

    @classmethod
    def create(cls, arg : RuleVariation_1233_Arg) -> "RuleVariation_1233":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1305:
        return self.arg # type: ignore

NonSpare_156_Arg: TypeAlias = RuleVariation_1233_Arg
class NonSpare_156(NonSpare):
    cv_name = "042"
    cv_title = "Calculated Position in Cartesian Co-ordinates"
    cv_rule = RuleVariation_1233

    @classmethod
    def create(cls, arg : NonSpare_156_Arg) -> "NonSpare_156":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1233:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1305:
        return self.rule.variation

class UapItem_156(UapItem):
    cv_non_spare = NonSpare_156

Content_659_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
class Content_659(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.25
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_659_Arg: TypeAlias = Content_659_Arg
class RuleContent_659(RuleContentContextFree):
    cv_content = Content_659

    @property
    def content(self) -> Content_659:
        return self._get_content() # type: ignore

Variation_277_Arg: TypeAlias = RuleContent_659_Arg
class Variation_277(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_659

    @classmethod
    def create(cls, arg : Variation_277_Arg) -> "Variation_277":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_659:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_659:
        return self.rule.content

RuleVariation_270_Arg: TypeAlias = Variation_277_Arg
class RuleVariation_270(RuleVariationContextFree):
    cv_variation = Variation_277

    @classmethod
    def create(cls, arg : RuleVariation_270_Arg) -> "RuleVariation_270":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_277:
        return self.arg # type: ignore

NonSpare_2041_Arg: TypeAlias = RuleVariation_270_Arg
class NonSpare_2041(NonSpare):
    cv_name = "VX"
    cv_title = "Vx"
    cv_rule = RuleVariation_270

    @classmethod
    def create(cls, arg : NonSpare_2041_Arg) -> "NonSpare_2041":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_270:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_277:
        return self.rule.variation

Item_1153_Arg: TypeAlias = NonSpare_2041_Arg
class Item_1153(Item):
    cv_non_spare = NonSpare_2041

    @classmethod
    def create(cls, arg : Item_1153_Arg) -> "Item_1153":
        return cls._create(arg) # type: ignore

NonSpare_2046_Arg: TypeAlias = RuleVariation_270_Arg
class NonSpare_2046(NonSpare):
    cv_name = "VY"
    cv_title = "Vy"
    cv_rule = RuleVariation_270

    @classmethod
    def create(cls, arg : NonSpare_2046_Arg) -> "NonSpare_2046":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_270:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_277:
        return self.rule.variation

Item_1158_Arg: TypeAlias = NonSpare_2046_Arg
class Item_1158(Item):
    cv_non_spare = NonSpare_2046

    @classmethod
    def create(cls, arg : Item_1158_Arg) -> "Item_1158":
        return cls._create(arg) # type: ignore

Variation_1275_Arg_Group = Tuple[Union[RuleVariation_270_Arg, Tuple[Literal["VX"], RuleVariation_270_Arg]], Union[RuleVariation_270_Arg, Tuple[Literal["VY"], RuleVariation_270_Arg]]]
Variation_1275_Arg: TypeAlias = Union[int, Variation_1275_Arg_Group]
class Variation_1275(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1153, 16), (Item_1158, 16)]
    cv_items_dict = {"VX": RuleVariation_270, "VY": RuleVariation_270}

    @overload
    @classmethod
    def spec(cls, key : Literal["VX"]) -> RuleVariation_270:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VY"]) -> RuleVariation_270:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VX"], Literal["VY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VX"]) -> RuleVariation_270:
        ...
    @overload
    def get_item(self, key : Literal["VY"]) -> RuleVariation_270:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1275_Arg) -> 'Variation_1275':
        return cls._create(arg) # type: ignore

RuleVariation_1205_Arg: TypeAlias = Variation_1275_Arg
class RuleVariation_1205(RuleVariationContextFree):
    cv_variation = Variation_1275

    @classmethod
    def create(cls, arg : RuleVariation_1205_Arg) -> "RuleVariation_1205":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1275:
        return self.arg # type: ignore

NonSpare_401_Arg: TypeAlias = RuleVariation_1205_Arg
class NonSpare_401(NonSpare):
    cv_name = "202"
    cv_title = "Calculated Track Velocity in Cartesian Coordinates"
    cv_rule = RuleVariation_1205

    @classmethod
    def create(cls, arg : NonSpare_401_Arg) -> "NonSpare_401":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1275:
        return self.rule.variation

class UapItem_401(UapItem):
    cv_non_spare = NonSpare_401

Content_662_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
class Content_662(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.25
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

RuleContent_662_Arg: TypeAlias = Content_662_Arg
class RuleContent_662(RuleContentContextFree):
    cv_content = Content_662

    @property
    def content(self) -> Content_662:
        return self._get_content() # type: ignore

Variation_210_Arg: TypeAlias = RuleContent_662_Arg
class Variation_210(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_662

    @classmethod
    def create(cls, arg : Variation_210_Arg) -> "Variation_210":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_662:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_662:
        return self.rule.content

RuleVariation_203_Arg: TypeAlias = Variation_210_Arg
class RuleVariation_203(RuleVariationContextFree):
    cv_variation = Variation_210

    @classmethod
    def create(cls, arg : RuleVariation_203_Arg) -> "RuleVariation_203":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_210:
        return self.arg # type: ignore

NonSpare_651_Arg: TypeAlias = RuleVariation_203_Arg
class NonSpare_651(NonSpare):
    cv_name = "AX"
    cv_title = "Ax"
    cv_rule = RuleVariation_203

    @classmethod
    def create(cls, arg : NonSpare_651_Arg) -> "NonSpare_651":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_203:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_210:
        return self.rule.variation

Item_99_Arg: TypeAlias = NonSpare_651_Arg
class Item_99(Item):
    cv_non_spare = NonSpare_651

    @classmethod
    def create(cls, arg : Item_99_Arg) -> "Item_99":
        return cls._create(arg) # type: ignore

NonSpare_655_Arg: TypeAlias = RuleVariation_203_Arg
class NonSpare_655(NonSpare):
    cv_name = "AY"
    cv_title = "Ay"
    cv_rule = RuleVariation_203

    @classmethod
    def create(cls, arg : NonSpare_655_Arg) -> "NonSpare_655":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_203:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_210:
        return self.rule.variation

Item_103_Arg: TypeAlias = NonSpare_655_Arg
class Item_103(Item):
    cv_non_spare = NonSpare_655

    @classmethod
    def create(cls, arg : Item_103_Arg) -> "Item_103":
        return cls._create(arg) # type: ignore

Variation_1053_Arg_Group = Tuple[Union[RuleVariation_203_Arg, Tuple[Literal["AX"], RuleVariation_203_Arg]], Union[RuleVariation_203_Arg, Tuple[Literal["AY"], RuleVariation_203_Arg]]]
Variation_1053_Arg: TypeAlias = Union[int, Variation_1053_Arg_Group]
class Variation_1053(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_99, 8), (Item_103, 8)]
    cv_items_dict = {"AX": RuleVariation_203, "AY": RuleVariation_203}

    @overload
    @classmethod
    def spec(cls, key : Literal["AX"]) -> RuleVariation_203:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AY"]) -> RuleVariation_203:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AX"], Literal["AY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AX"]) -> RuleVariation_203:
        ...
    @overload
    def get_item(self, key : Literal["AY"]) -> RuleVariation_203:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1053_Arg) -> 'Variation_1053':
        return cls._create(arg) # type: ignore

RuleVariation_1020_Arg: TypeAlias = Variation_1053_Arg
class RuleVariation_1020(RuleVariationContextFree):
    cv_variation = Variation_1053

    @classmethod
    def create(cls, arg : RuleVariation_1020_Arg) -> "RuleVariation_1020":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1053:
        return self.arg # type: ignore

NonSpare_403_Arg: TypeAlias = RuleVariation_1020_Arg
class NonSpare_403(NonSpare):
    cv_name = "210"
    cv_title = "Calculated Acceleration"
    cv_rule = RuleVariation_1020

    @classmethod
    def create(cls, arg : NonSpare_403_Arg) -> "NonSpare_403":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1020:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1053:
        return self.rule.variation

class UapItem_403(UapItem):
    cv_non_spare = NonSpare_403

NonSpare_1290_Arg: TypeAlias = RuleVariation_776_Arg
class NonSpare_1290(NonSpare):
    cv_name = "MOD3A"
    cv_title = "Mode-3/A Reply in Octal Representation"
    cv_rule = RuleVariation_776

    @classmethod
    def create(cls, arg : NonSpare_1290_Arg) -> "NonSpare_1290":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_776:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_806:
        return self.rule.variation

Item_562_Arg: TypeAlias = NonSpare_1290_Arg
class Item_562(Item):
    cv_non_spare = NonSpare_1290

    @classmethod
    def create(cls, arg : Item_562_Arg) -> "Item_562":
        return cls._create(arg) # type: ignore

Variation_1021_Arg_Group = Tuple[int, Union[RuleVariation_776_Arg, Tuple[Literal["MOD3A"], RuleVariation_776_Arg]]]
Variation_1021_Arg: TypeAlias = Union[int, Variation_1021_Arg_Group]
class Variation_1021(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_562, 12)]
    cv_items_dict = {"MOD3A": RuleVariation_776}

    @classmethod
    def spec(cls, key : Literal["MOD3A"]) -> RuleVariation_776:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["MOD3A"]) -> RuleVariation_776:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1021_Arg) -> 'Variation_1021':
        return cls._create(arg) # type: ignore

RuleVariation_990_Arg: TypeAlias = Variation_1021_Arg
class RuleVariation_990(RuleVariationContextFree):
    cv_variation = Variation_1021

    @classmethod
    def create(cls, arg : RuleVariation_990_Arg) -> "RuleVariation_990":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1021:
        return self.arg # type: ignore

NonSpare_188_Arg: TypeAlias = RuleVariation_990_Arg
class NonSpare_188(NonSpare):
    cv_name = "060"
    cv_title = "Mode-3/A Code in Octal Representation"
    cv_rule = RuleVariation_990

    @classmethod
    def create(cls, arg : NonSpare_188_Arg) -> "NonSpare_188":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_990:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1021:
        return self.rule.variation

class UapItem_188(UapItem):
    cv_non_spare = NonSpare_188

NonSpare_1855_Arg: TypeAlias = RuleVariation_381_Arg
class NonSpare_1855(NonSpare):
    cv_name = "TID"
    cv_title = "Target Identification"
    cv_rule = RuleVariation_381

    @classmethod
    def create(cls, arg : NonSpare_1855_Arg) -> "NonSpare_1855":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_381:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_389:
        return self.rule.variation

Item_997_Arg: TypeAlias = NonSpare_1855_Arg
class Item_997(Item):
    cv_non_spare = NonSpare_1855

    @classmethod
    def create(cls, arg : Item_997_Arg) -> "Item_997":
        return cls._create(arg) # type: ignore

Variation_1211_Arg_Group = Tuple[Union[RuleVariation_97_Arg, Tuple[Literal["STI"], RuleVariation_97_Arg]], int, Union[RuleVariation_381_Arg, Tuple[Literal["TID"], RuleVariation_381_Arg]]]
Variation_1211_Arg: TypeAlias = Union[int, Variation_1211_Arg_Group]
class Variation_1211(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_items_list = [(Item_948, 2), (Item_15, 6), (Item_997, 48)]
    cv_items_dict = {"STI": RuleVariation_97, "TID": RuleVariation_381}

    @overload
    @classmethod
    def spec(cls, key : Literal["STI"]) -> RuleVariation_97:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> RuleVariation_381:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["STI"], Literal["TID"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["STI"]) -> RuleVariation_97:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> RuleVariation_381:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1211_Arg) -> 'Variation_1211':
        return cls._create(arg) # type: ignore

RuleVariation_1156_Arg: TypeAlias = Variation_1211_Arg
class RuleVariation_1156(RuleVariationContextFree):
    cv_variation = Variation_1211

    @classmethod
    def create(cls, arg : RuleVariation_1156_Arg) -> "RuleVariation_1156":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1211:
        return self.arg # type: ignore

NonSpare_437_Arg: TypeAlias = RuleVariation_1156_Arg
class NonSpare_437(NonSpare):
    cv_name = "245"
    cv_title = "Target Identification"
    cv_rule = RuleVariation_1156

    @classmethod
    def create(cls, arg : NonSpare_437_Arg) -> "NonSpare_437":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1156:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1211:
        return self.rule.variation

class UapItem_437(UapItem):
    cv_non_spare = NonSpare_437

Content_795_Arg: TypeAlias = int
class Content_795(ContentBds):
    cv_bds_type = BdsWithAddress

RuleContent_794_Arg: TypeAlias = Content_795_Arg
class RuleContent_794(RuleContentContextFree):
    cv_content = Content_795

    @property
    def content(self) -> Content_795:
        return self._get_content() # type: ignore

Variation_394_Arg: TypeAlias = RuleContent_794_Arg
class Variation_394(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_rule = RuleContent_794

    @classmethod
    def create(cls, arg : Variation_394_Arg) -> "Variation_394":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_794:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_795:
        return self.rule.content

Variation_1396_Arg: TypeAlias = List[Variation_394_Arg]
class Variation_1396(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_394

    @classmethod
    def create(cls, arg : Variation_1396_Arg) -> 'Variation_1396':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_394]:
        return self._get_list() # type: ignore

RuleVariation_1319_Arg: TypeAlias = Variation_1396_Arg
class RuleVariation_1319(RuleVariationContextFree):
    cv_variation = Variation_1396

    @classmethod
    def create(cls, arg : RuleVariation_1319_Arg) -> "RuleVariation_1319":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1396:
        return self.arg # type: ignore

NonSpare_1221_Arg: TypeAlias = RuleVariation_1319_Arg
class NonSpare_1221(NonSpare):
    cv_name = "MB"
    cv_title = "BDS"
    cv_rule = RuleVariation_1319

    @classmethod
    def create(cls, arg : NonSpare_1221_Arg) -> "NonSpare_1221":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1319:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1396:
        return self.rule.variation

NonSpare_566_Arg: TypeAlias = RuleVariation_340_Arg
class NonSpare_566(NonSpare):
    cv_name = "ADR"
    cv_title = "24 Bits Aircraft Address"
    cv_rule = RuleVariation_340

    @classmethod
    def create(cls, arg : NonSpare_566_Arg) -> "NonSpare_566":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_340:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_347:
        return self.rule.variation

Content_337_Arg: TypeAlias = int
class Content_337(ContentTable):
    cv_values = {0: "No communications capability (surveillance only)", 1: "Comm. A and Comm. B capability", 2: "Comm. A, Comm. B and Uplink ELM", 3: "Comm. A, Comm. B, Uplink ELM and Downlink ELM", 4: "Level 5 Transponder capability", 5: "Not assigned", 6: "Not assigned", 7: "Not assigned"}

RuleContent_337_Arg: TypeAlias = Content_337_Arg
class RuleContent_337(RuleContentContextFree):
    cv_content = Content_337

    @property
    def content(self) -> Content_337:
        return self._get_content() # type: ignore

Variation_123_Arg: TypeAlias = RuleContent_337_Arg
class Variation_123(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_337

    @classmethod
    def create(cls, arg : Variation_123_Arg) -> "Variation_123":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_337:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_337:
        return self.rule.content

RuleVariation_123_Arg: TypeAlias = Variation_123_Arg
class RuleVariation_123(RuleVariationContextFree):
    cv_variation = Variation_123

    @classmethod
    def create(cls, arg : RuleVariation_123_Arg) -> "RuleVariation_123":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_123:
        return self.arg # type: ignore

NonSpare_778_Arg: TypeAlias = RuleVariation_123_Arg
class NonSpare_778(NonSpare):
    cv_name = "COM"
    cv_title = "Communications Capability of the Transponder"
    cv_rule = RuleVariation_123

    @classmethod
    def create(cls, arg : NonSpare_778_Arg) -> "NonSpare_778":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_123:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_123:
        return self.rule.variation

Item_187_Arg: TypeAlias = NonSpare_778_Arg
class Item_187(Item):
    cv_non_spare = NonSpare_778

    @classmethod
    def create(cls, arg : Item_187_Arg) -> "Item_187":
        return cls._create(arg) # type: ignore

Content_318_Arg: TypeAlias = int
class Content_318(ContentTable):
    cv_values = {0: "No alert, no SPI, aircraft airborne", 1: "No alert, no SPI, aircraft on ground", 2: "Alert, no SPI, aircraft airborne", 3: "Alert, no SPI, aircraft on ground", 4: "Alert, SPI, aircraft airborne or on ground", 5: "No alert, SPI, aircraft airborne or on ground", 6: "General Emergency", 7: "Lifeguard / medical", 8: "Minimum fuel", 9: "No communications", 10: "Unlawful"}

RuleContent_318_Arg: TypeAlias = Content_318_Arg
class RuleContent_318(RuleContentContextFree):
    cv_content = Content_318

    @property
    def content(self) -> Content_318:
        return self._get_content() # type: ignore

Variation_689_Arg: TypeAlias = RuleContent_318_Arg
class Variation_689(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 4
    cv_rule = RuleContent_318

    @classmethod
    def create(cls, arg : Variation_689_Arg) -> "Variation_689":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_318:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_318:
        return self.rule.content

RuleVariation_678_Arg: TypeAlias = Variation_689_Arg
class RuleVariation_678(RuleVariationContextFree):
    cv_variation = Variation_689

    @classmethod
    def create(cls, arg : RuleVariation_678_Arg) -> "RuleVariation_678":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_689:
        return self.arg # type: ignore

NonSpare_1770_Arg: TypeAlias = RuleVariation_678_Arg
class NonSpare_1770(NonSpare):
    cv_name = "STAT"
    cv_title = "Flight Status"
    cv_rule = RuleVariation_678

    @classmethod
    def create(cls, arg : NonSpare_1770_Arg) -> "NonSpare_1770":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_678:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_689:
        return self.rule.variation

Item_937_Arg: TypeAlias = NonSpare_1770_Arg
class Item_937(Item):
    cv_non_spare = NonSpare_1770

    @classmethod
    def create(cls, arg : Item_937_Arg) -> "Item_937":
        return cls._create(arg) # type: ignore

Content_302_Arg: TypeAlias = int
class Content_302(ContentTable):
    cv_values = {0: "No", 1: "Yes"}

RuleContent_302_Arg: TypeAlias = Content_302_Arg
class RuleContent_302(RuleContentContextFree):
    cv_content = Content_302

    @property
    def content(self) -> Content_302:
        return self._get_content() # type: ignore

Variation_55_Arg: TypeAlias = RuleContent_302_Arg
class Variation_55(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_302

    @classmethod
    def create(cls, arg : Variation_55_Arg) -> "Variation_55":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_302:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_302:
        return self.rule.content

RuleVariation_55_Arg: TypeAlias = Variation_55_Arg
class RuleVariation_55(RuleVariationContextFree):
    cv_variation = Variation_55

    @classmethod
    def create(cls, arg : RuleVariation_55_Arg) -> "RuleVariation_55":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_55:
        return self.arg # type: ignore

NonSpare_1747_Arg: TypeAlias = RuleVariation_55_Arg
class NonSpare_1747(NonSpare):
    cv_name = "SSC"
    cv_title = "Specific Service Capability"
    cv_rule = RuleVariation_55

    @classmethod
    def create(cls, arg : NonSpare_1747_Arg) -> "NonSpare_1747":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_55:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_55:
        return self.rule.variation

Item_923_Arg: TypeAlias = NonSpare_1747_Arg
class Item_923(Item):
    cv_non_spare = NonSpare_1747

    @classmethod
    def create(cls, arg : Item_923_Arg) -> "Item_923":
        return cls._create(arg) # type: ignore

Content_3_Arg: TypeAlias = int
class Content_3(ContentTable):
    cv_values = {0: "100 ft resolution", 1: "25 ft resolution"}

RuleContent_3_Arg: TypeAlias = Content_3_Arg
class RuleContent_3(RuleContentContextFree):
    cv_content = Content_3

    @property
    def content(self) -> Content_3:
        return self._get_content() # type: ignore

Variation_399_Arg: TypeAlias = RuleContent_3_Arg
class Variation_399(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_3

    @classmethod
    def create(cls, arg : Variation_399_Arg) -> "Variation_399":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_3:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_3:
        return self.rule.content

RuleVariation_388_Arg: TypeAlias = Variation_399_Arg
class RuleVariation_388(RuleVariationContextFree):
    cv_variation = Variation_399

    @classmethod
    def create(cls, arg : RuleVariation_388_Arg) -> "RuleVariation_388":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_399:
        return self.arg # type: ignore

NonSpare_621_Arg: TypeAlias = RuleVariation_388_Arg
class NonSpare_621(NonSpare):
    cv_name = "ARC"
    cv_title = "Altitude Reporting Capability"
    cv_rule = RuleVariation_388

    @classmethod
    def create(cls, arg : NonSpare_621_Arg) -> "NonSpare_621":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_388:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_399:
        return self.rule.variation

Item_81_Arg: TypeAlias = NonSpare_621_Arg
class Item_81(Item):
    cv_non_spare = NonSpare_621

    @classmethod
    def create(cls, arg : Item_81_Arg) -> "Item_81":
        return cls._create(arg) # type: ignore

Variation_555_Arg: TypeAlias = RuleContent_302_Arg
class Variation_555(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_302

    @classmethod
    def create(cls, arg : Variation_555_Arg) -> "Variation_555":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_302:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_302:
        return self.rule.content

RuleVariation_544_Arg: TypeAlias = Variation_555_Arg
class RuleVariation_544(RuleVariationContextFree):
    cv_variation = Variation_555

    @classmethod
    def create(cls, arg : RuleVariation_544_Arg) -> "RuleVariation_544":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_555:
        return self.arg # type: ignore

NonSpare_583_Arg: TypeAlias = RuleVariation_544_Arg
class NonSpare_583(NonSpare):
    cv_name = "AIC"
    cv_title = "Aircraft Identification Capability"
    cv_rule = RuleVariation_544

    @classmethod
    def create(cls, arg : NonSpare_583_Arg) -> "NonSpare_583":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_544:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_555:
        return self.rule.variation

Item_55_Arg: TypeAlias = NonSpare_583_Arg
class Item_55(Item):
    cv_non_spare = NonSpare_583

    @classmethod
    def create(cls, arg : Item_55_Arg) -> "Item_55":
        return cls._create(arg) # type: ignore

NonSpare_663_Arg: TypeAlias = RuleVariation_600_Arg
class NonSpare_663(NonSpare):
    cv_name = "B1A"
    cv_title = "BDS 1,0 Bit 16"
    cv_rule = RuleVariation_600

    @classmethod
    def create(cls, arg : NonSpare_663_Arg) -> "NonSpare_663":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_600:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_611:
        return self.rule.variation

Item_108_Arg: TypeAlias = NonSpare_663_Arg
class Item_108(Item):
    cv_non_spare = NonSpare_663

    @classmethod
    def create(cls, arg : Item_108_Arg) -> "Item_108":
        return cls._create(arg) # type: ignore

NonSpare_664_Arg: TypeAlias = RuleVariation_766_Arg
class NonSpare_664(NonSpare):
    cv_name = "B1B"
    cv_title = "BDS 1,0 Bit 37/40"
    cv_rule = RuleVariation_766

    @classmethod
    def create(cls, arg : NonSpare_664_Arg) -> "NonSpare_664":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_766:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_796:
        return self.rule.variation

Item_109_Arg: TypeAlias = NonSpare_664_Arg
class Item_109(Item):
    cv_non_spare = NonSpare_664

    @classmethod
    def create(cls, arg : Item_109_Arg) -> "Item_109":
        return cls._create(arg) # type: ignore

NonSpare_550_Arg: TypeAlias = RuleVariation_55_Arg
class NonSpare_550(NonSpare):
    cv_name = "AC"
    cv_title = "ACAS Operational"
    cv_rule = RuleVariation_55

    @classmethod
    def create(cls, arg : NonSpare_550_Arg) -> "NonSpare_550":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_55:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_55:
        return self.rule.variation

Item_37_Arg: TypeAlias = NonSpare_550_Arg
class Item_37(Item):
    cv_non_spare = NonSpare_550

    @classmethod
    def create(cls, arg : Item_37_Arg) -> "Item_37":
        return cls._create(arg) # type: ignore

Variation_437_Arg: TypeAlias = RuleContent_302_Arg
class Variation_437(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_302

    @classmethod
    def create(cls, arg : Variation_437_Arg) -> "Variation_437":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_302:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_302:
        return self.rule.content

RuleVariation_426_Arg: TypeAlias = Variation_437_Arg
class RuleVariation_426(RuleVariationContextFree):
    cv_variation = Variation_437

    @classmethod
    def create(cls, arg : RuleVariation_426_Arg) -> "RuleVariation_426":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_437:
        return self.arg # type: ignore

NonSpare_1287_Arg: TypeAlias = RuleVariation_426_Arg
class NonSpare_1287(NonSpare):
    cv_name = "MN"
    cv_title = "Multiple Navigational Aids Operating"
    cv_rule = RuleVariation_426

    @classmethod
    def create(cls, arg : NonSpare_1287_Arg) -> "NonSpare_1287":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_426:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_437:
        return self.rule.variation

Item_559_Arg: TypeAlias = NonSpare_1287_Arg
class Item_559(Item):
    cv_non_spare = NonSpare_1287

    @classmethod
    def create(cls, arg : Item_559_Arg) -> "Item_559":
        return cls._create(arg) # type: ignore

Content_569_Arg: TypeAlias = int
class Content_569(ContentTable):
    cv_values = {0: "Yes", 1: "No"}

RuleContent_569_Arg: TypeAlias = Content_569_Arg
class RuleContent_569(RuleContentContextFree):
    cv_content = Content_569

    @property
    def content(self) -> Content_569:
        return self._get_content() # type: ignore

Variation_582_Arg: TypeAlias = RuleContent_569_Arg
class Variation_582(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_569

    @classmethod
    def create(cls, arg : Variation_582_Arg) -> "Variation_582":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_569:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_569:
        return self.rule.content

RuleVariation_571_Arg: TypeAlias = Variation_582_Arg
class RuleVariation_571(RuleVariationContextFree):
    cv_variation = Variation_582

    @classmethod
    def create(cls, arg : RuleVariation_571_Arg) -> "RuleVariation_571":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_582:
        return self.arg # type: ignore

NonSpare_864_Arg: TypeAlias = RuleVariation_571_Arg
class NonSpare_864(NonSpare):
    cv_name = "DC"
    cv_title = "Differential Correction"
    cv_rule = RuleVariation_571

    @classmethod
    def create(cls, arg : NonSpare_864_Arg) -> "NonSpare_864":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_571:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_582:
        return self.rule.variation

Item_248_Arg: TypeAlias = NonSpare_864_Arg
class Item_248(Item):
    cv_non_spare = NonSpare_864

    @classmethod
    def create(cls, arg : Item_248_Arg) -> "Item_248":
        return cls._create(arg) # type: ignore

Item_19_Arg: TypeAlias = int
class Item_19(Spare):
    cv_bit_offset8 = 3
    cv_bit_size = 5

Variation_1075_Arg_Group = Tuple[Union[RuleVariation_123_Arg, Tuple[Literal["COM"], RuleVariation_123_Arg]], Union[RuleVariation_678_Arg, Tuple[Literal["STAT"], RuleVariation_678_Arg]], int, Union[RuleVariation_55_Arg, Tuple[Literal["SSC"], RuleVariation_55_Arg]], Union[RuleVariation_388_Arg, Tuple[Literal["ARC"], RuleVariation_388_Arg]], Union[RuleVariation_544_Arg, Tuple[Literal["AIC"], RuleVariation_544_Arg]], Union[RuleVariation_600_Arg, Tuple[Literal["B1A"], RuleVariation_600_Arg]], Union[RuleVariation_766_Arg, Tuple[Literal["B1B"], RuleVariation_766_Arg]], Union[RuleVariation_55_Arg, Tuple[Literal["AC"], RuleVariation_55_Arg]], Union[RuleVariation_426_Arg, Tuple[Literal["MN"], RuleVariation_426_Arg]], Union[RuleVariation_571_Arg, Tuple[Literal["DC"], RuleVariation_571_Arg]], int]
Variation_1075_Arg: TypeAlias = Union[int, Variation_1075_Arg_Group]
class Variation_1075(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_187, 3), (Item_937, 4), (Item_29, 1), (Item_923, 1), (Item_81, 1), (Item_55, 1), (Item_108, 1), (Item_109, 4), (Item_37, 1), (Item_559, 1), (Item_248, 1), (Item_19, 5)]
    cv_items_dict = {"COM": RuleVariation_123, "STAT": RuleVariation_678, "SSC": RuleVariation_55, "ARC": RuleVariation_388, "AIC": RuleVariation_544, "B1A": RuleVariation_600, "B1B": RuleVariation_766, "AC": RuleVariation_55, "MN": RuleVariation_426, "DC": RuleVariation_571}

    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> RuleVariation_123:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_678:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSC"]) -> RuleVariation_55:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> RuleVariation_388:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AIC"]) -> RuleVariation_544:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1A"]) -> RuleVariation_600:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1B"]) -> RuleVariation_766:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AC"]) -> RuleVariation_55:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MN"]) -> RuleVariation_426:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DC"]) -> RuleVariation_571:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COM"], Literal["STAT"], Literal["SSC"], Literal["ARC"], Literal["AIC"], Literal["B1A"], Literal["B1B"], Literal["AC"], Literal["MN"], Literal["DC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COM"]) -> RuleVariation_123:
        ...
    @overload
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_678:
        ...
    @overload
    def get_item(self, key : Literal["SSC"]) -> RuleVariation_55:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_388:
        ...
    @overload
    def get_item(self, key : Literal["AIC"]) -> RuleVariation_544:
        ...
    @overload
    def get_item(self, key : Literal["B1A"]) -> RuleVariation_600:
        ...
    @overload
    def get_item(self, key : Literal["B1B"]) -> RuleVariation_766:
        ...
    @overload
    def get_item(self, key : Literal["AC"]) -> RuleVariation_55:
        ...
    @overload
    def get_item(self, key : Literal["MN"]) -> RuleVariation_426:
        ...
    @overload
    def get_item(self, key : Literal["DC"]) -> RuleVariation_571:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1075_Arg) -> 'Variation_1075':
        return cls._create(arg) # type: ignore

RuleVariation_1035_Arg: TypeAlias = Variation_1075_Arg
class RuleVariation_1035(RuleVariationContextFree):
    cv_variation = Variation_1075

    @classmethod
    def create(cls, arg : RuleVariation_1035_Arg) -> "RuleVariation_1035":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1075:
        return self.arg # type: ignore

NonSpare_782_Arg: TypeAlias = RuleVariation_1035_Arg
class NonSpare_782(NonSpare):
    cv_name = "COMACAS"
    cv_title = "Communications/ACAS Capability and Flight Status"
    cv_rule = RuleVariation_1035

    @classmethod
    def create(cls, arg : NonSpare_782_Arg) -> "NonSpare_782":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1035:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1075:
        return self.rule.variation

Variation_372_Arg: TypeAlias = RuleContent_606_Arg
class Variation_372(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_606

    @classmethod
    def create(cls, arg : Variation_372_Arg) -> "Variation_372":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_606:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_606:
        return self.rule.content

RuleVariation_365_Arg: TypeAlias = Variation_372_Arg
class RuleVariation_365(RuleVariationContextFree):
    cv_variation = Variation_372

    @classmethod
    def create(cls, arg : RuleVariation_365_Arg) -> "RuleVariation_365":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_372:
        return self.arg # type: ignore

NonSpare_561_Arg: TypeAlias = RuleVariation_365_Arg
class NonSpare_561(NonSpare):
    cv_name = "ACT"
    cv_title = "Aircraft Derived Aircraft Type"
    cv_rule = RuleVariation_365

    @classmethod
    def create(cls, arg : NonSpare_561_Arg) -> "NonSpare_561":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_365:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_372:
        return self.rule.variation

Content_578_Arg: TypeAlias = int
class Content_578(ContentTable):
    cv_values = {1: "Light aircraft <= 7000 kg", 2: "Reserved", 3: "7000 kg &lt; medium aircraft &lt; 136000 kg", 4: "Reserved", 5: "136000 kg <= heavy aircraft", 6: "Highly manoeuvrable (5g acceleration capability) and high speed (&gt;400 knots cruise)", 7: "Reserved", 8: "Reserved", 9: "Reserved", 10: "Rotocraft", 11: "Glider / sailplane", 12: "Lighter-than-air", 13: "Unmanned aerial vehicle", 14: "Space / transatmospheric vehicle", 15: "Ultralight / handglider / paraglider", 16: "Parachutist / skydiver", 17: "Reserved", 18: "Reserved", 19: "Reserved", 20: "Surface emergency vehicle", 21: "Surface service vehicle", 22: "Fixed ground or tethered obstruction", 23: "Reserved", 24: "Reserved"}

RuleContent_578_Arg: TypeAlias = Content_578_Arg
class RuleContent_578(RuleContentContextFree):
    cv_content = Content_578

    @property
    def content(self) -> Content_578:
        return self._get_content() # type: ignore

Variation_181_Arg: TypeAlias = RuleContent_578_Arg
class Variation_181(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_578

    @classmethod
    def create(cls, arg : Variation_181_Arg) -> "Variation_181":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_578:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_578:
        return self.rule.content

RuleVariation_174_Arg: TypeAlias = Variation_181_Arg
class RuleVariation_174(RuleVariationContextFree):
    cv_variation = Variation_181

    @classmethod
    def create(cls, arg : RuleVariation_174_Arg) -> "RuleVariation_174":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_181:
        return self.arg # type: ignore

NonSpare_911_Arg: TypeAlias = RuleVariation_174_Arg
class NonSpare_911(NonSpare):
    cv_name = "ECAT"
    cv_title = "Emitter Category"
    cv_rule = RuleVariation_174

    @classmethod
    def create(cls, arg : NonSpare_911_Arg) -> "NonSpare_911":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_174:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_181:
        return self.rule.variation

Content_553_Arg: TypeAlias = int
class Content_553(ContentTable):
    cv_values = {0: "VDL Mode 4 available", 1: "VDL Mode 4 not available"}

RuleContent_553_Arg: TypeAlias = Content_553_Arg
class RuleContent_553(RuleContentContextFree):
    cv_content = Content_553

    @property
    def content(self) -> Content_553:
        return self._get_content() # type: ignore

Variation_94_Arg: TypeAlias = RuleContent_553_Arg
class Variation_94(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_553

    @classmethod
    def create(cls, arg : Variation_94_Arg) -> "Variation_94":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_553:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_553:
        return self.rule.content

RuleVariation_94_Arg: TypeAlias = Variation_94_Arg
class RuleVariation_94(RuleVariationContextFree):
    cv_variation = Variation_94

    @classmethod
    def create(cls, arg : RuleVariation_94_Arg) -> "RuleVariation_94":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_94:
        return self.arg # type: ignore

NonSpare_2020_Arg: TypeAlias = RuleVariation_94_Arg
class NonSpare_2020(NonSpare):
    cv_name = "VDL"
    cv_title = "VDL Mode 4"
    cv_rule = RuleVariation_94

    @classmethod
    def create(cls, arg : NonSpare_2020_Arg) -> "NonSpare_2020":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_94:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_94:
        return self.rule.variation

Item_1135_Arg: TypeAlias = NonSpare_2020_Arg
class Item_1135(Item):
    cv_non_spare = NonSpare_2020

    @classmethod
    def create(cls, arg : Item_1135_Arg) -> "Item_1135":
        return cls._create(arg) # type: ignore

Content_280_Arg: TypeAlias = int
class Content_280(ContentTable):
    cv_values = {0: "Mode S available", 1: "Mode S not available"}

RuleContent_280_Arg: TypeAlias = Content_280_Arg
class RuleContent_280(RuleContentContextFree):
    cv_content = Content_280

    @property
    def content(self) -> Content_280:
        return self._get_content() # type: ignore

Variation_435_Arg: TypeAlias = RuleContent_280_Arg
class Variation_435(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_280

    @classmethod
    def create(cls, arg : Variation_435_Arg) -> "Variation_435":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_280:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_280:
        return self.rule.content

RuleVariation_424_Arg: TypeAlias = Variation_435_Arg
class RuleVariation_424(RuleVariationContextFree):
    cv_variation = Variation_435

    @classmethod
    def create(cls, arg : RuleVariation_424_Arg) -> "RuleVariation_424":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_435:
        return self.arg # type: ignore

NonSpare_1250_Arg: TypeAlias = RuleVariation_424_Arg
class NonSpare_1250(NonSpare):
    cv_name = "MDS"
    cv_title = "Mode S"
    cv_rule = RuleVariation_424

    @classmethod
    def create(cls, arg : NonSpare_1250_Arg) -> "NonSpare_1250":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_424:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_435:
        return self.rule.variation

Item_537_Arg: TypeAlias = NonSpare_1250_Arg
class Item_537(Item):
    cv_non_spare = NonSpare_1250

    @classmethod
    def create(cls, arg : Item_537_Arg) -> "Item_537":
        return cls._create(arg) # type: ignore

Content_526_Arg: TypeAlias = int
class Content_526(ContentTable):
    cv_values = {0: "UAT available", 1: "UAT not available"}

RuleContent_526_Arg: TypeAlias = Content_526_Arg
class RuleContent_526(RuleContentContextFree):
    cv_content = Content_526

    @property
    def content(self) -> Content_526:
        return self._get_content() # type: ignore

Variation_580_Arg: TypeAlias = RuleContent_526_Arg
class Variation_580(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_526

    @classmethod
    def create(cls, arg : Variation_580_Arg) -> "Variation_580":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_526:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_526:
        return self.rule.content

RuleVariation_569_Arg: TypeAlias = Variation_580_Arg
class RuleVariation_569(RuleVariationContextFree):
    cv_variation = Variation_580

    @classmethod
    def create(cls, arg : RuleVariation_569_Arg) -> "RuleVariation_569":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_580:
        return self.arg # type: ignore

NonSpare_1970_Arg: TypeAlias = RuleVariation_569_Arg
class NonSpare_1970(NonSpare):
    cv_name = "UAT"
    cv_title = "UAT"
    cv_rule = RuleVariation_569

    @classmethod
    def create(cls, arg : NonSpare_1970_Arg) -> "NonSpare_1970":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_569:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_580:
        return self.rule.variation

Item_1088_Arg: TypeAlias = NonSpare_1970_Arg
class Item_1088(Item):
    cv_non_spare = NonSpare_1970

    @classmethod
    def create(cls, arg : Item_1088_Arg) -> "Item_1088":
        return cls._create(arg) # type: ignore

Variation_1271_Arg_Group = Tuple[Union[RuleVariation_94_Arg, Tuple[Literal["VDL"], RuleVariation_94_Arg]], Union[RuleVariation_424_Arg, Tuple[Literal["MDS"], RuleVariation_424_Arg]], Union[RuleVariation_569_Arg, Tuple[Literal["UAT"], RuleVariation_569_Arg]], int]
Variation_1271_Arg: TypeAlias = Union[int, Variation_1271_Arg_Group]
class Variation_1271(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1135, 1), (Item_537, 1), (Item_1088, 1), (Item_19, 5)]
    cv_items_dict = {"VDL": RuleVariation_94, "MDS": RuleVariation_424, "UAT": RuleVariation_569}

    @overload
    @classmethod
    def spec(cls, key : Literal["VDL"]) -> RuleVariation_94:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDS"]) -> RuleVariation_424:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["UAT"]) -> RuleVariation_569:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VDL"], Literal["MDS"], Literal["UAT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VDL"]) -> RuleVariation_94:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> RuleVariation_424:
        ...
    @overload
    def get_item(self, key : Literal["UAT"]) -> RuleVariation_569:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1271_Arg) -> 'Variation_1271':
        return cls._create(arg) # type: ignore

RuleVariation_1201_Arg: TypeAlias = Variation_1271_Arg
class RuleVariation_1201(RuleVariationContextFree):
    cv_variation = Variation_1271

    @classmethod
    def create(cls, arg : RuleVariation_1201_Arg) -> "RuleVariation_1201":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1271:
        return self.arg # type: ignore

NonSpare_648_Arg: TypeAlias = RuleVariation_1201_Arg
class NonSpare_648(NonSpare):
    cv_name = "AVTECH"
    cv_title = "Available Technologies"
    cv_rule = RuleVariation_1201

    @classmethod
    def create(cls, arg : NonSpare_648_Arg) -> "NonSpare_648":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1201:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1271:
        return self.rule.variation

Variation_1484_Arg = TypedDict('Variation_1484_Arg', {
    "MB": NonSpare_1221_Arg,
    "ADR": NonSpare_566_Arg,
    "COMACAS": NonSpare_782_Arg,
    "ACT": NonSpare_561_Arg,
    "ECAT": NonSpare_911_Arg,
    "AVTECH": NonSpare_648_Arg,
}, total=False)
class Variation_1484(Compound):
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1221, NonSpare_566, None, NonSpare_782, None, None, None, NonSpare_561, NonSpare_911, None, NonSpare_648]
    cv_items_dict = {"MB": NonSpare_1221, "ADR": NonSpare_566, "COMACAS": NonSpare_782, "ACT": NonSpare_561, "ECAT": NonSpare_911, "AVTECH": NonSpare_648}

    @overload
    @classmethod
    def spec(cls, key : Literal["MB"]) -> NonSpare_1221:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADR"]) -> NonSpare_566:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COMACAS"]) -> NonSpare_782:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ACT"]) -> NonSpare_561:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ECAT"]) -> NonSpare_911:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AVTECH"]) -> NonSpare_648:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MB"], Literal["ADR"], Literal["COMACAS"], Literal["ACT"], Literal["ECAT"], Literal["AVTECH"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MB"]) -> Optional[NonSpare_1221]:
        ...
    @overload
    def get_item(self, key : Literal["ADR"]) -> Optional[NonSpare_566]:
        ...
    @overload
    def get_item(self, key : Literal["COMACAS"]) -> Optional[NonSpare_782]:
        ...
    @overload
    def get_item(self, key : Literal["ACT"]) -> Optional[NonSpare_561]:
        ...
    @overload
    def get_item(self, key : Literal["ECAT"]) -> Optional[NonSpare_911]:
        ...
    @overload
    def get_item(self, key : Literal["AVTECH"]) -> Optional[NonSpare_648]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["MB"], val : NonSpare_1221_Arg) -> "Variation_1484":
        ...
    @overload
    def set_item(self, key : Literal["ADR"], val : NonSpare_566_Arg) -> "Variation_1484":
        ...
    @overload
    def set_item(self, key : Literal["COMACAS"], val : NonSpare_782_Arg) -> "Variation_1484":
        ...
    @overload
    def set_item(self, key : Literal["ACT"], val : NonSpare_561_Arg) -> "Variation_1484":
        ...
    @overload
    def set_item(self, key : Literal["ECAT"], val : NonSpare_911_Arg) -> "Variation_1484":
        ...
    @overload
    def set_item(self, key : Literal["AVTECH"], val : NonSpare_648_Arg) -> "Variation_1484":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["MB"]) -> "Variation_1484":
        ...
    @overload
    def del_item(self, key : Literal["ADR"]) -> "Variation_1484":
        ...
    @overload
    def del_item(self, key : Literal["COMACAS"]) -> "Variation_1484":
        ...
    @overload
    def del_item(self, key : Literal["ACT"]) -> "Variation_1484":
        ...
    @overload
    def del_item(self, key : Literal["ECAT"]) -> "Variation_1484":
        ...
    @overload
    def del_item(self, key : Literal["AVTECH"]) -> "Variation_1484":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1484_Arg) -> 'Variation_1484':
        return cls._create(arg) # type: ignore

RuleVariation_1407_Arg: TypeAlias = Variation_1484_Arg
class RuleVariation_1407(RuleVariationContextFree):
    cv_variation = Variation_1484

    @classmethod
    def create(cls, arg : RuleVariation_1407_Arg) -> "RuleVariation_1407":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1484:
        return self.arg # type: ignore

NonSpare_484_Arg: TypeAlias = RuleVariation_1407_Arg
class NonSpare_484(NonSpare):
    cv_name = "380"
    cv_title = "Mode-S / ADS-B Related Data"
    cv_rule = RuleVariation_1407

    @classmethod
    def create(cls, arg : NonSpare_484_Arg) -> "NonSpare_484":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1407:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1484:
        return self.rule.variation

class UapItem_484(UapItem):
    cv_non_spare = NonSpare_484

Item_0_Arg: TypeAlias = int
class Item_0(Spare):
    cv_bit_offset8 = 0
    cv_bit_size = 1

Variation_496_Arg: TypeAlias = RuleContent_0_Arg
class Variation_496(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 15
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_496_Arg) -> "Variation_496":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_485_Arg: TypeAlias = Variation_496_Arg
class RuleVariation_485(RuleVariationContextFree):
    cv_variation = Variation_496

    @classmethod
    def create(cls, arg : RuleVariation_485_Arg) -> "RuleVariation_485":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_496:
        return self.arg # type: ignore

NonSpare_998_Arg: TypeAlias = RuleVariation_485_Arg
class NonSpare_998(NonSpare):
    cv_name = "FTN"
    cv_title = "Fusion Track Number"
    cv_rule = RuleVariation_485

    @classmethod
    def create(cls, arg : NonSpare_998_Arg) -> "NonSpare_998":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_485:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_496:
        return self.rule.variation

Item_350_Arg: TypeAlias = NonSpare_998_Arg
class Item_350(Item):
    cv_non_spare = NonSpare_998

    @classmethod
    def create(cls, arg : Item_350_Arg) -> "Item_350":
        return cls._create(arg) # type: ignore

Variation_992_Arg_Group = Tuple[int, Union[RuleVariation_485_Arg, Tuple[Literal["FTN"], RuleVariation_485_Arg]]]
Variation_992_Arg: TypeAlias = Union[int, Variation_992_Arg_Group]
class Variation_992(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_0, 1), (Item_350, 15)]
    cv_items_dict = {"FTN": RuleVariation_485}

    @classmethod
    def spec(cls, key : Literal["FTN"]) -> RuleVariation_485:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["FTN"]) -> RuleVariation_485:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_992_Arg) -> 'Variation_992':
        return cls._create(arg) # type: ignore

RuleVariation_962_Arg: TypeAlias = Variation_992_Arg
class RuleVariation_962(RuleVariationContextFree):
    cv_variation = Variation_992

    @classmethod
    def create(cls, arg : RuleVariation_962_Arg) -> "RuleVariation_962":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_992:
        return self.arg # type: ignore

NonSpare_356_Arg: TypeAlias = RuleVariation_962_Arg
class NonSpare_356(NonSpare):
    cv_name = "161"
    cv_title = "Track Number"
    cv_rule = RuleVariation_962

    @classmethod
    def create(cls, arg : NonSpare_356_Arg) -> "NonSpare_356":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_962:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_992:
        return self.rule.variation

class UapItem_356(UapItem):
    cv_non_spare = NonSpare_356

Content_296_Arg: TypeAlias = int
class Content_296(ContentTable):
    cv_values = {0: "Multisensor Track", 1: "Monosensor Track"}

RuleContent_296_Arg: TypeAlias = Content_296_Arg
class RuleContent_296(RuleContentContextFree):
    cv_content = Content_296

    @property
    def content(self) -> Content_296:
        return self._get_content() # type: ignore

Variation_53_Arg: TypeAlias = RuleContent_296_Arg
class Variation_53(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_296

    @classmethod
    def create(cls, arg : Variation_53_Arg) -> "Variation_53":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_296:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_296:
        return self.rule.content

RuleVariation_53_Arg: TypeAlias = Variation_53_Arg
class RuleVariation_53(RuleVariationContextFree):
    cv_variation = Variation_53

    @classmethod
    def create(cls, arg : RuleVariation_53_Arg) -> "RuleVariation_53":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_53:
        return self.arg # type: ignore

Content_520_Arg: TypeAlias = int
class Content_520(ContentTable):
    cv_values = {0: "Transponder Ground bit not set or unknown", 1: "Transponder Ground bit set"}

RuleContent_520_Arg: TypeAlias = Content_520_Arg
class RuleContent_520(RuleContentContextFree):
    cv_content = Content_520

    @property
    def content(self) -> Content_520:
        return self._get_content() # type: ignore

Variation_459_Arg: TypeAlias = RuleContent_520_Arg
class Variation_459(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_520

    @classmethod
    def create(cls, arg : Variation_459_Arg) -> "Variation_459":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_520:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_520:
        return self.rule.content

RuleVariation_448_Arg: TypeAlias = Variation_459_Arg
class RuleVariation_448(RuleVariationContextFree):
    cv_variation = Variation_459

    @classmethod
    def create(cls, arg : RuleVariation_448_Arg) -> "RuleVariation_448":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_459:
        return self.arg # type: ignore

Content_45_Arg: TypeAlias = int
class Content_45(ContentTable):
    cv_values = {0: "Barometric altitude (Mode C) more reliable", 1: "Geometric altitude more reliable"}

RuleContent_45_Arg: TypeAlias = Content_45_Arg
class RuleContent_45(RuleContentContextFree):
    cv_content = Content_45

    @property
    def content(self) -> Content_45:
        return self._get_content() # type: ignore

Variation_508_Arg: TypeAlias = RuleContent_45_Arg
class Variation_508(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_45

    @classmethod
    def create(cls, arg : Variation_508_Arg) -> "Variation_508":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_45:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_45:
        return self.rule.content

RuleVariation_497_Arg: TypeAlias = Variation_508_Arg
class RuleVariation_497(RuleVariationContextFree):
    cv_variation = Variation_508

    @classmethod
    def create(cls, arg : RuleVariation_497_Arg) -> "RuleVariation_497":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_508:
        return self.arg # type: ignore

Content_370_Arg: TypeAlias = int
class Content_370(ContentTable):
    cv_values = {0: "No source", 1: "GPS", 2: "3d radar", 3: "Triangulation", 4: "Height from coverage", 5: "Speed look-up table", 6: "Default height", 7: "Multilateration"}

RuleContent_370_Arg: TypeAlias = Content_370_Arg
class RuleContent_370(RuleContentContextFree):
    cv_content = Content_370

    @property
    def content(self) -> Content_370:
        return self._get_content() # type: ignore

Variation_687_Arg: TypeAlias = RuleContent_370_Arg
class Variation_687(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 3
    cv_rule = RuleContent_370

    @classmethod
    def create(cls, arg : Variation_687_Arg) -> "Variation_687":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_370:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_370:
        return self.rule.content

RuleVariation_676_Arg: TypeAlias = Variation_687_Arg
class RuleVariation_676(RuleVariationContextFree):
    cv_variation = Variation_687

    @classmethod
    def create(cls, arg : RuleVariation_676_Arg) -> "RuleVariation_676":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_687:
        return self.arg # type: ignore

Content_62_Arg: TypeAlias = int
class Content_62(ContentTable):
    cv_values = {0: "Confirmed track", 1: "Tentative track"}

RuleContent_62_Arg: TypeAlias = Content_62_Arg
class RuleContent_62(RuleContentContextFree):
    cv_content = Content_62

    @property
    def content(self) -> Content_62:
        return self._get_content() # type: ignore

Variation_904_Arg: TypeAlias = RuleContent_62_Arg
class Variation_904(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_62

    @classmethod
    def create(cls, arg : Variation_904_Arg) -> "Variation_904":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_62:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_62:
        return self.rule.content

RuleVariation_874_Arg: TypeAlias = Variation_904_Arg
class RuleVariation_874(RuleVariationContextFree):
    cv_variation = Variation_904

    @classmethod
    def create(cls, arg : RuleVariation_874_Arg) -> "RuleVariation_874":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_904:
        return self.arg # type: ignore

Content_17_Arg: TypeAlias = int
class Content_17(ContentTable):
    cv_values = {0: "Actual Track", 1: "Simulated track"}

RuleContent_17_Arg: TypeAlias = Content_17_Arg
class RuleContent_17(RuleContentContextFree):
    cv_content = Content_17

    @property
    def content(self) -> Content_17:
        return self._get_content() # type: ignore

Variation_4_Arg: TypeAlias = RuleContent_17_Arg
class Variation_4(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_17

    @classmethod
    def create(cls, arg : Variation_4_Arg) -> "Variation_4":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_17:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_17:
        return self.rule.content

RuleVariation_4_Arg: TypeAlias = Variation_4_Arg
class RuleVariation_4(RuleVariationContextFree):
    cv_variation = Variation_4

    @classmethod
    def create(cls, arg : RuleVariation_4_Arg) -> "RuleVariation_4":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_4:
        return self.arg # type: ignore

Content_195_Arg: TypeAlias = int
class Content_195(ContentTable):
    cv_values = {0: "Default value", 1: "Track service end (i.e. last message transmitted to the user for the track)"}

RuleContent_195_Arg: TypeAlias = Content_195_Arg
class RuleContent_195(RuleContentContextFree):
    cv_content = Content_195

    @property
    def content(self) -> Content_195:
        return self._get_content() # type: ignore

Variation_422_Arg: TypeAlias = RuleContent_195_Arg
class Variation_422(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_195

    @classmethod
    def create(cls, arg : Variation_422_Arg) -> "Variation_422":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_195:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_195:
        return self.rule.content

RuleVariation_411_Arg: TypeAlias = Variation_422_Arg
class RuleVariation_411(RuleVariationContextFree):
    cv_variation = Variation_422

    @classmethod
    def create(cls, arg : RuleVariation_411_Arg) -> "RuleVariation_411":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_422:
        return self.arg # type: ignore

Content_194_Arg: TypeAlias = int
class Content_194(ContentTable):
    cv_values = {0: "Default value", 1: "Track service begin (i.e. first message transmitted to the user for the track)"}

RuleContent_194_Arg: TypeAlias = Content_194_Arg
class RuleContent_194(RuleContentContextFree):
    cv_content = Content_194

    @property
    def content(self) -> Content_194:
        return self._get_content() # type: ignore

Variation_529_Arg: TypeAlias = RuleContent_194_Arg
class Variation_529(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_194

    @classmethod
    def create(cls, arg : Variation_529_Arg) -> "Variation_529":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_194:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_194:
        return self.rule.content

RuleVariation_518_Arg: TypeAlias = Variation_529_Arg
class RuleVariation_518(RuleVariationContextFree):
    cv_variation = Variation_529

    @classmethod
    def create(cls, arg : RuleVariation_518_Arg) -> "RuleVariation_518":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_529:
        return self.arg # type: ignore

Content_309_Arg: TypeAlias = int
class Content_309(ContentTable):
    cv_values = {0: "No Mode 4 interrogationt", 1: "Friendly target", 2: "Unknown target", 3: "No reply"}

RuleContent_309_Arg: TypeAlias = Content_309_Arg
class RuleContent_309(RuleContentContextFree):
    cv_content = Content_309

    @property
    def content(self) -> Content_309:
        return self._get_content() # type: ignore

Variation_676_Arg: TypeAlias = RuleContent_309_Arg
class Variation_676(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_rule = RuleContent_309

    @classmethod
    def create(cls, arg : Variation_676_Arg) -> "Variation_676":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_309:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_309:
        return self.rule.content

RuleVariation_665_Arg: TypeAlias = Variation_676_Arg
class RuleVariation_665(RuleVariationContextFree):
    cv_variation = Variation_676

    @classmethod
    def create(cls, arg : RuleVariation_665_Arg) -> "RuleVariation_665":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_676:
        return self.arg # type: ignore

Content_187_Arg: TypeAlias = int
class Content_187(ContentTable):
    cv_values = {0: "Default value", 1: "Military Emergency present in the last report received from a sensor capable of decoding this data"}

RuleContent_187_Arg: TypeAlias = Content_187_Arg
class RuleContent_187(RuleContentContextFree):
    cv_content = Content_187

    @property
    def content(self) -> Content_187:
        return self._get_content() # type: ignore

Variation_842_Arg: TypeAlias = RuleContent_187_Arg
class Variation_842(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_187

    @classmethod
    def create(cls, arg : Variation_842_Arg) -> "Variation_842":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_187:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_187:
        return self.rule.content

RuleVariation_812_Arg: TypeAlias = Variation_842_Arg
class RuleVariation_812(RuleVariationContextFree):
    cv_variation = Variation_842

    @classmethod
    def create(cls, arg : RuleVariation_812_Arg) -> "RuleVariation_812":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_842:
        return self.arg # type: ignore

Content_208_Arg: TypeAlias = int
class Content_208(ContentTable):
    cv_values = {0: "End of Data Item", 1: "Military Identification present in the last report received from a sensor capable of decoding this data"}

RuleContent_208_Arg: TypeAlias = Content_208_Arg
class RuleContent_208(RuleContentContextFree):
    cv_content = Content_208

    @property
    def content(self) -> Content_208:
        return self._get_content() # type: ignore

Variation_923_Arg: TypeAlias = RuleContent_208_Arg
class Variation_923(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_208

    @classmethod
    def create(cls, arg : Variation_923_Arg) -> "Variation_923":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_208:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_208:
        return self.rule.content

RuleVariation_893_Arg: TypeAlias = Variation_923_Arg
class RuleVariation_893(RuleVariationContextFree):
    cv_variation = Variation_923

    @classmethod
    def create(cls, arg : RuleVariation_893_Arg) -> "RuleVariation_893":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_923:
        return self.arg # type: ignore

Content_511_Arg: TypeAlias = int
class Content_511(ContentTable):
    cv_values = {0: "Track not resulting from amalgamation process", 1: "Track resulting from amalgamation process"}

RuleContent_511_Arg: TypeAlias = Content_511_Arg
class RuleContent_511(RuleContentContextFree):
    cv_content = Content_511

    @property
    def content(self) -> Content_511:
        return self._get_content() # type: ignore

Variation_89_Arg: TypeAlias = RuleContent_511_Arg
class Variation_89(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_511

    @classmethod
    def create(cls, arg : Variation_89_Arg) -> "Variation_89":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_511:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_511:
        return self.rule.content

RuleVariation_89_Arg: TypeAlias = Variation_89_Arg
class RuleVariation_89(RuleVariationContextFree):
    cv_variation = Variation_89

    @classmethod
    def create(cls, arg : RuleVariation_89_Arg) -> "RuleVariation_89":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_89:
        return self.arg # type: ignore

Content_189_Arg: TypeAlias = int
class Content_189(ContentTable):
    cv_values = {0: "Default value", 1: "SPI present in the last report received from a sensor capable of decoding this data"}

RuleContent_189_Arg: TypeAlias = Content_189_Arg
class RuleContent_189(RuleContentContextFree):
    cv_content = Content_189

    @property
    def content(self) -> Content_189:
        return self._get_content() # type: ignore

Variation_421_Arg: TypeAlias = RuleContent_189_Arg
class Variation_421(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_189

    @classmethod
    def create(cls, arg : Variation_421_Arg) -> "Variation_421":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_189:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_189:
        return self.rule.content

RuleVariation_410_Arg: TypeAlias = Variation_421_Arg
class RuleVariation_410(RuleVariationContextFree):
    cv_variation = Variation_421

    @classmethod
    def create(cls, arg : RuleVariation_410_Arg) -> "RuleVariation_410":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_421:
        return self.arg # type: ignore

Content_178_Arg: TypeAlias = int
class Content_178(ContentTable):
    cv_values = {0: "Default value", 1: "Age of the last received track update is higher than system dependent threshold (coasting)"}

RuleContent_178_Arg: TypeAlias = Content_178_Arg
class RuleContent_178(RuleContentContextFree):
    cv_content = Content_178

    @property
    def content(self) -> Content_178:
        return self._get_content() # type: ignore

Variation_526_Arg: TypeAlias = RuleContent_178_Arg
class Variation_526(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_178

    @classmethod
    def create(cls, arg : Variation_526_Arg) -> "Variation_526":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_178:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_178:
        return self.rule.content

RuleVariation_515_Arg: TypeAlias = Variation_526_Arg
class RuleVariation_515(RuleVariationContextFree):
    cv_variation = Variation_526

    @classmethod
    def create(cls, arg : RuleVariation_515_Arg) -> "RuleVariation_515":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_526:
        return self.arg # type: ignore

Content_397_Arg: TypeAlias = int
class Content_397(ContentTable):
    cv_values = {0: "Not flight-plan correlated", 1: "Flight plan correlated"}

RuleContent_397_Arg: TypeAlias = Content_397_Arg
class RuleContent_397(RuleContentContextFree):
    cv_content = Content_397

    @property
    def content(self) -> Content_397:
        return self._get_content() # type: ignore

Variation_655_Arg: TypeAlias = RuleContent_397_Arg
class Variation_655(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_397

    @classmethod
    def create(cls, arg : Variation_655_Arg) -> "Variation_655":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_397:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_397:
        return self.rule.content

RuleVariation_644_Arg: TypeAlias = Variation_655_Arg
class RuleVariation_644(RuleVariationContextFree):
    cv_variation = Variation_655

    @classmethod
    def create(cls, arg : RuleVariation_644_Arg) -> "RuleVariation_644":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_655:
        return self.arg # type: ignore

Content_171_Arg: TypeAlias = int
class Content_171(ContentTable):
    cv_values = {0: "Default value", 1: "ADS-B data inconsistent with other surveillance information"}

RuleContent_171_Arg: TypeAlias = Content_171_Arg
class RuleContent_171(RuleContentContextFree):
    cv_content = Content_171

    @property
    def content(self) -> Content_171:
        return self._get_content() # type: ignore

Variation_713_Arg: TypeAlias = RuleContent_171_Arg
class Variation_713(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_171

    @classmethod
    def create(cls, arg : Variation_713_Arg) -> "Variation_713":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_171:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_171:
        return self.rule.content

RuleVariation_702_Arg: TypeAlias = Variation_713_Arg
class RuleVariation_702(RuleVariationContextFree):
    cv_variation = Variation_713

    @classmethod
    def create(cls, arg : RuleVariation_702_Arg) -> "RuleVariation_702":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_713:
        return self.arg # type: ignore

NonSpare_1303_Arg: TypeAlias = RuleVariation_53_Arg
class NonSpare_1303(NonSpare):
    cv_name = "MON"
    cv_title = ""
    cv_rule = RuleVariation_53

    @classmethod
    def create(cls, arg : NonSpare_1303_Arg) -> "NonSpare_1303":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_53:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_53:
        return self.rule.variation

Item_575_Arg: TypeAlias = NonSpare_1303_Arg
class Item_575(Item):
    cv_non_spare = NonSpare_1303

    @classmethod
    def create(cls, arg : Item_575_Arg) -> "Item_575":
        return cls._create(arg) # type: ignore

NonSpare_1019_Arg: TypeAlias = RuleVariation_448_Arg
class NonSpare_1019(NonSpare):
    cv_name = "GBS"
    cv_title = ""
    cv_rule = RuleVariation_448

    @classmethod
    def create(cls, arg : NonSpare_1019_Arg) -> "NonSpare_1019":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_448:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_459:
        return self.rule.variation

Item_363_Arg: TypeAlias = NonSpare_1019_Arg
class Item_363(Item):
    cv_non_spare = NonSpare_1019

    @classmethod
    def create(cls, arg : Item_363_Arg) -> "Item_363":
        return cls._create(arg) # type: ignore

NonSpare_1306_Arg: TypeAlias = RuleVariation_497_Arg
class NonSpare_1306(NonSpare):
    cv_name = "MRH"
    cv_title = ""
    cv_rule = RuleVariation_497

    @classmethod
    def create(cls, arg : NonSpare_1306_Arg) -> "NonSpare_1306":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_497:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_508:
        return self.rule.variation

Item_578_Arg: TypeAlias = NonSpare_1306_Arg
class Item_578(Item):
    cv_non_spare = NonSpare_1306

    @classmethod
    def create(cls, arg : Item_578_Arg) -> "Item_578":
        return cls._create(arg) # type: ignore

NonSpare_1739_Arg: TypeAlias = RuleVariation_676_Arg
class NonSpare_1739(NonSpare):
    cv_name = "SRC"
    cv_title = ""
    cv_rule = RuleVariation_676

    @classmethod
    def create(cls, arg : NonSpare_1739_Arg) -> "NonSpare_1739":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_676:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_687:
        return self.rule.variation

Item_918_Arg: TypeAlias = NonSpare_1739_Arg
class Item_918(Item):
    cv_non_spare = NonSpare_1739

    @classmethod
    def create(cls, arg : Item_918_Arg) -> "Item_918":
        return cls._create(arg) # type: ignore

NonSpare_742_Arg: TypeAlias = RuleVariation_874_Arg
class NonSpare_742(NonSpare):
    cv_name = "CNF"
    cv_title = ""
    cv_rule = RuleVariation_874

    @classmethod
    def create(cls, arg : NonSpare_742_Arg) -> "NonSpare_742":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_874:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_904:
        return self.rule.variation

Item_166_Arg: TypeAlias = NonSpare_742_Arg
class Item_166(Item):
    cv_non_spare = NonSpare_742

    @classmethod
    def create(cls, arg : Item_166_Arg) -> "Item_166":
        return cls._create(arg) # type: ignore

NonSpare_1713_Arg: TypeAlias = RuleVariation_4_Arg
class NonSpare_1713(NonSpare):
    cv_name = "SIM"
    cv_title = ""
    cv_rule = RuleVariation_4

    @classmethod
    def create(cls, arg : NonSpare_1713_Arg) -> "NonSpare_1713":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_4:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_4:
        return self.rule.variation

Item_894_Arg: TypeAlias = NonSpare_1713_Arg
class Item_894(Item):
    cv_non_spare = NonSpare_1713

    @classmethod
    def create(cls, arg : Item_894_Arg) -> "Item_894":
        return cls._create(arg) # type: ignore

NonSpare_1921_Arg: TypeAlias = RuleVariation_411_Arg
class NonSpare_1921(NonSpare):
    cv_name = "TSE"
    cv_title = ""
    cv_rule = RuleVariation_411

    @classmethod
    def create(cls, arg : NonSpare_1921_Arg) -> "NonSpare_1921":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_411:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_422:
        return self.rule.variation

Item_1044_Arg: TypeAlias = NonSpare_1921_Arg
class Item_1044(Item):
    cv_non_spare = NonSpare_1921

    @classmethod
    def create(cls, arg : Item_1044_Arg) -> "Item_1044":
        return cls._create(arg) # type: ignore

NonSpare_1919_Arg: TypeAlias = RuleVariation_518_Arg
class NonSpare_1919(NonSpare):
    cv_name = "TSB"
    cv_title = ""
    cv_rule = RuleVariation_518

    @classmethod
    def create(cls, arg : NonSpare_1919_Arg) -> "NonSpare_1919":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_518:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_529:
        return self.rule.variation

Item_1042_Arg: TypeAlias = NonSpare_1919_Arg
class Item_1042(Item):
    cv_non_spare = NonSpare_1919

    @classmethod
    def create(cls, arg : Item_1042_Arg) -> "Item_1042":
        return cls._create(arg) # type: ignore

NonSpare_988_Arg: TypeAlias = RuleVariation_665_Arg
class NonSpare_988(NonSpare):
    cv_name = "FRIFOE"
    cv_title = ""
    cv_rule = RuleVariation_665

    @classmethod
    def create(cls, arg : NonSpare_988_Arg) -> "NonSpare_988":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_665:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_676:
        return self.rule.variation

Item_343_Arg: TypeAlias = NonSpare_988_Arg
class Item_343(Item):
    cv_non_spare = NonSpare_988

    @classmethod
    def create(cls, arg : Item_343_Arg) -> "Item_343":
        return cls._create(arg) # type: ignore

NonSpare_1258_Arg: TypeAlias = RuleVariation_812_Arg
class NonSpare_1258(NonSpare):
    cv_name = "ME"
    cv_title = ""
    cv_rule = RuleVariation_812

    @classmethod
    def create(cls, arg : NonSpare_1258_Arg) -> "NonSpare_1258":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_812:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_842:
        return self.rule.variation

Item_542_Arg: TypeAlias = NonSpare_1258_Arg
class Item_542(Item):
    cv_non_spare = NonSpare_1258

    @classmethod
    def create(cls, arg : Item_542_Arg) -> "Item_542":
        return cls._create(arg) # type: ignore

NonSpare_1276_Arg: TypeAlias = RuleVariation_893_Arg
class NonSpare_1276(NonSpare):
    cv_name = "MI"
    cv_title = ""
    cv_rule = RuleVariation_893

    @classmethod
    def create(cls, arg : NonSpare_1276_Arg) -> "NonSpare_1276":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_893:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_923:
        return self.rule.variation

Item_549_Arg: TypeAlias = NonSpare_1276_Arg
class Item_549(Item):
    cv_non_spare = NonSpare_1276

    @classmethod
    def create(cls, arg : Item_549_Arg) -> "Item_549":
        return cls._create(arg) # type: ignore

NonSpare_602_Arg: TypeAlias = RuleVariation_89_Arg
class NonSpare_602(NonSpare):
    cv_name = "AMA"
    cv_title = ""
    cv_rule = RuleVariation_89

    @classmethod
    def create(cls, arg : NonSpare_602_Arg) -> "NonSpare_602":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_89:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_89:
        return self.rule.variation

Item_71_Arg: TypeAlias = NonSpare_602_Arg
class Item_71(Item):
    cv_non_spare = NonSpare_602

    @classmethod
    def create(cls, arg : Item_71_Arg) -> "Item_71":
        return cls._create(arg) # type: ignore

NonSpare_1729_Arg: TypeAlias = RuleVariation_410_Arg
class NonSpare_1729(NonSpare):
    cv_name = "SPI"
    cv_title = ""
    cv_rule = RuleVariation_410

    @classmethod
    def create(cls, arg : NonSpare_1729_Arg) -> "NonSpare_1729":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_410:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_421:
        return self.rule.variation

Item_908_Arg: TypeAlias = NonSpare_1729_Arg
class Item_908(Item):
    cv_non_spare = NonSpare_1729

    @classmethod
    def create(cls, arg : Item_908_Arg) -> "Item_908":
        return cls._create(arg) # type: ignore

NonSpare_831_Arg: TypeAlias = RuleVariation_515_Arg
class NonSpare_831(NonSpare):
    cv_name = "CST"
    cv_title = ""
    cv_rule = RuleVariation_515

    @classmethod
    def create(cls, arg : NonSpare_831_Arg) -> "NonSpare_831":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_515:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_526:
        return self.rule.variation

Item_220_Arg: TypeAlias = NonSpare_831_Arg
class Item_220(Item):
    cv_non_spare = NonSpare_831

    @classmethod
    def create(cls, arg : Item_220_Arg) -> "Item_220":
        return cls._create(arg) # type: ignore

NonSpare_980_Arg: TypeAlias = RuleVariation_644_Arg
class NonSpare_980(NonSpare):
    cv_name = "FPC"
    cv_title = ""
    cv_rule = RuleVariation_644

    @classmethod
    def create(cls, arg : NonSpare_980_Arg) -> "NonSpare_980":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_644:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_655:
        return self.rule.variation

Item_336_Arg: TypeAlias = NonSpare_980_Arg
class Item_336(Item):
    cv_non_spare = NonSpare_980

    @classmethod
    def create(cls, arg : Item_336_Arg) -> "Item_336":
        return cls._create(arg) # type: ignore

NonSpare_575_Arg: TypeAlias = RuleVariation_702_Arg
class NonSpare_575(NonSpare):
    cv_name = "AFF"
    cv_title = ""
    cv_rule = RuleVariation_702

    @classmethod
    def create(cls, arg : NonSpare_575_Arg) -> "NonSpare_575":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_702:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_713:
        return self.rule.variation

Item_50_Arg: TypeAlias = NonSpare_575_Arg
class Item_50(Item):
    cv_non_spare = NonSpare_575

    @classmethod
    def create(cls, arg : Item_50_Arg) -> "Item_50":
        return cls._create(arg) # type: ignore

Variation_1359_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_53_Arg, Tuple[Literal["MON"], RuleVariation_53_Arg]], Union[RuleVariation_448_Arg, Tuple[Literal["GBS"], RuleVariation_448_Arg]], Union[RuleVariation_497_Arg, Tuple[Literal["MRH"], RuleVariation_497_Arg]], Union[RuleVariation_676_Arg, Tuple[Literal["SRC"], RuleVariation_676_Arg]], Union[RuleVariation_874_Arg, Tuple[Literal["CNF"], RuleVariation_874_Arg]], None]]
Variation_1359_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_4_Arg, Tuple[Literal["SIM"], RuleVariation_4_Arg]], Union[RuleVariation_411_Arg, Tuple[Literal["TSE"], RuleVariation_411_Arg]], Union[RuleVariation_518_Arg, Tuple[Literal["TSB"], RuleVariation_518_Arg]], Union[RuleVariation_665_Arg, Tuple[Literal["FRIFOE"], RuleVariation_665_Arg]], Union[RuleVariation_812_Arg, Tuple[Literal["ME"], RuleVariation_812_Arg]], Union[RuleVariation_893_Arg, Tuple[Literal["MI"], RuleVariation_893_Arg]], None]]
Variation_1359_Arg_Group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_89_Arg, Tuple[Literal["AMA"], RuleVariation_89_Arg]], Union[RuleVariation_410_Arg, Tuple[Literal["SPI"], RuleVariation_410_Arg]], Union[RuleVariation_515_Arg, Tuple[Literal["CST"], RuleVariation_515_Arg]], Union[RuleVariation_644_Arg, Tuple[Literal["FPC"], RuleVariation_644_Arg]], Union[RuleVariation_702_Arg, Tuple[Literal["AFF"], RuleVariation_702_Arg]], int, None]]
Variation_1359_Arg: TypeAlias = Union[
    Tuple[Variation_1359_Arg_Group_1],
    Tuple[Variation_1359_Arg_Group_1, Variation_1359_Arg_Group_2],
    Tuple[Variation_1359_Arg_Group_1, Variation_1359_Arg_Group_2, Variation_1359_Arg_Group_3],
]
class Variation_1359(Extended):
    cv_items_list = [[(Item_575, 1), (Item_363, 1), (Item_578, 1), (Item_918, 3), (Item_166, 1), None], [(Item_894, 1), (Item_1044, 1), (Item_1042, 1), (Item_343, 2), (Item_542, 1), (Item_549, 1), None], [(Item_71, 1), (Item_908, 1), (Item_220, 1), (Item_336, 1), (Item_50, 1), (Item_24, 2), None]]

    @classmethod
    def create(cls, arg : Variation_1359_Arg) -> 'Variation_1359':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MON"]) -> RuleVariation_53:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> RuleVariation_448:
        ...
    @overload
    def get_item(self, key : Literal["MRH"]) -> RuleVariation_497:
        ...
    @overload
    def get_item(self, key : Literal["SRC"]) -> RuleVariation_676:
        ...
    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_874:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_4]:
        ...
    @overload
    def get_item(self, key : Literal["TSE"]) -> Optional[RuleVariation_411]:
        ...
    @overload
    def get_item(self, key : Literal["TSB"]) -> Optional[RuleVariation_518]:
        ...
    @overload
    def get_item(self, key : Literal["FRIFOE"]) -> Optional[RuleVariation_665]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_812]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_893]:
        ...
    @overload
    def get_item(self, key : Literal["AMA"]) -> Optional[RuleVariation_89]:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> Optional[RuleVariation_410]:
        ...
    @overload
    def get_item(self, key : Literal["CST"]) -> Optional[RuleVariation_515]:
        ...
    @overload
    def get_item(self, key : Literal["FPC"]) -> Optional[RuleVariation_644]:
        ...
    @overload
    def get_item(self, key : Literal["AFF"]) -> Optional[RuleVariation_702]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1282_Arg: TypeAlias = Variation_1359_Arg
class RuleVariation_1282(RuleVariationContextFree):
    cv_variation = Variation_1359

    @classmethod
    def create(cls, arg : RuleVariation_1282_Arg) -> "RuleVariation_1282":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1359:
        return self.arg # type: ignore

NonSpare_374_Arg: TypeAlias = RuleVariation_1282_Arg
class NonSpare_374(NonSpare):
    cv_name = "170"
    cv_title = "Track Status"
    cv_rule = RuleVariation_1282

    @classmethod
    def create(cls, arg : NonSpare_374_Arg) -> "NonSpare_374":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1282:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1359:
        return self.rule.variation

class UapItem_374(UapItem):
    cv_non_spare = NonSpare_374

Content_756_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
class Content_756(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.25
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

RuleContent_755_Arg: TypeAlias = Content_756_Arg
class RuleContent_755(RuleContentContextFree):
    cv_content = Content_756

    @property
    def content(self) -> Content_756:
        return self._get_content() # type: ignore

Variation_233_Arg: TypeAlias = RuleContent_755_Arg
class Variation_233(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_755

    @classmethod
    def create(cls, arg : Variation_233_Arg) -> "Variation_233":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_755:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_756:
        return self.rule.content

RuleVariation_226_Arg: TypeAlias = Variation_233_Arg
class RuleVariation_226(RuleVariationContextFree):
    cv_variation = Variation_233

    @classmethod
    def create(cls, arg : RuleVariation_226_Arg) -> "RuleVariation_226":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_233:
        return self.arg # type: ignore

NonSpare_1464_Arg: TypeAlias = RuleVariation_226_Arg
class NonSpare_1464(NonSpare):
    cv_name = "PSR"
    cv_title = "Age of The Last Primary Detection Used to Update the Track"
    cv_rule = RuleVariation_226

    @classmethod
    def create(cls, arg : NonSpare_1464_Arg) -> "NonSpare_1464":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

NonSpare_1751_Arg: TypeAlias = RuleVariation_226_Arg
class NonSpare_1751(NonSpare):
    cv_name = "SSR"
    cv_title = "Age of the Last Secondary Detection Used to Update the Track"
    cv_rule = RuleVariation_226

    @classmethod
    def create(cls, arg : NonSpare_1751_Arg) -> "NonSpare_1751":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

NonSpare_1242_Arg: TypeAlias = RuleVariation_226_Arg
class NonSpare_1242(NonSpare):
    cv_name = "MDA"
    cv_title = "Age of the Last Mode A Detection Used to Update the Track"
    cv_rule = RuleVariation_226

    @classmethod
    def create(cls, arg : NonSpare_1242_Arg) -> "NonSpare_1242":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

NonSpare_1264_Arg: TypeAlias = RuleVariation_226_Arg
class NonSpare_1264(NonSpare):
    cv_name = "MFL"
    cv_title = "Age of the Last Mode C Detection Used to Update the Track"
    cv_rule = RuleVariation_226

    @classmethod
    def create(cls, arg : NonSpare_1264_Arg) -> "NonSpare_1264":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

NonSpare_1248_Arg: TypeAlias = RuleVariation_226_Arg
class NonSpare_1248(NonSpare):
    cv_name = "MDS"
    cv_title = "Age of the Last Mode S Detection Used to Update the Track"
    cv_rule = RuleVariation_226

    @classmethod
    def create(cls, arg : NonSpare_1248_Arg) -> "NonSpare_1248":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

Variation_324_Arg: TypeAlias = RuleContent_755_Arg
class Variation_324(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_755

    @classmethod
    def create(cls, arg : Variation_324_Arg) -> "Variation_324":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_755:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_756:
        return self.rule.content

RuleVariation_317_Arg: TypeAlias = Variation_324_Arg
class RuleVariation_317(RuleVariationContextFree):
    cv_variation = Variation_324

    @classmethod
    def create(cls, arg : RuleVariation_317_Arg) -> "RuleVariation_317":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_324:
        return self.arg # type: ignore

NonSpare_572_Arg: TypeAlias = RuleVariation_317_Arg
class NonSpare_572(NonSpare):
    cv_name = "ADS"
    cv_title = "Age of the Last ADS Report Used to Update the Track"
    cv_rule = RuleVariation_317

    @classmethod
    def create(cls, arg : NonSpare_572_Arg) -> "NonSpare_572":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_317:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_324:
        return self.rule.variation

NonSpare_562_Arg: TypeAlias = RuleVariation_226_Arg
class NonSpare_562(NonSpare):
    cv_name = "ADB"
    cv_title = "Age of the Last ADS-B Report Used to Update the Track"
    cv_rule = RuleVariation_226

    @classmethod
    def create(cls, arg : NonSpare_562_Arg) -> "NonSpare_562":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

NonSpare_1231_Arg: TypeAlias = RuleVariation_226_Arg
class NonSpare_1231(NonSpare):
    cv_name = "MD1"
    cv_title = "Age of the Last Valid Mode 1 Used to Update the Track"
    cv_rule = RuleVariation_226

    @classmethod
    def create(cls, arg : NonSpare_1231_Arg) -> "NonSpare_1231":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

NonSpare_1233_Arg: TypeAlias = RuleVariation_226_Arg
class NonSpare_1233(NonSpare):
    cv_name = "MD2"
    cv_title = "Age of the Last Mode 2 Used to Update the Track"
    cv_rule = RuleVariation_226

    @classmethod
    def create(cls, arg : NonSpare_1233_Arg) -> "NonSpare_1233":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

NonSpare_1185_Arg: TypeAlias = RuleVariation_226_Arg
class NonSpare_1185(NonSpare):
    cv_name = "LOP"
    cv_title = "Age of the Last Magentic Loop Detection"
    cv_rule = RuleVariation_226

    @classmethod
    def create(cls, arg : NonSpare_1185_Arg) -> "NonSpare_1185":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

NonSpare_1908_Arg: TypeAlias = RuleVariation_226_Arg
class NonSpare_1908(NonSpare):
    cv_name = "TRK"
    cv_title = "Actual Track Age Since First Occurrence"
    cv_rule = RuleVariation_226

    @classmethod
    def create(cls, arg : NonSpare_1908_Arg) -> "NonSpare_1908":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

NonSpare_1327_Arg: TypeAlias = RuleVariation_226_Arg
class NonSpare_1327(NonSpare):
    cv_name = "MUL"
    cv_title = "Age of the Last Multilateration Detection"
    cv_rule = RuleVariation_226

    @classmethod
    def create(cls, arg : NonSpare_1327_Arg) -> "NonSpare_1327":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

Variation_1490_Arg = TypedDict('Variation_1490_Arg', {
    "PSR": NonSpare_1464_Arg,
    "SSR": NonSpare_1751_Arg,
    "MDA": NonSpare_1242_Arg,
    "MFL": NonSpare_1264_Arg,
    "MDS": NonSpare_1248_Arg,
    "ADS": NonSpare_572_Arg,
    "ADB": NonSpare_562_Arg,
    "MD1": NonSpare_1231_Arg,
    "MD2": NonSpare_1233_Arg,
    "LOP": NonSpare_1185_Arg,
    "TRK": NonSpare_1908_Arg,
    "MUL": NonSpare_1327_Arg,
}, total=False)
class Variation_1490(Compound):
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1464, NonSpare_1751, NonSpare_1242, NonSpare_1264, NonSpare_1248, NonSpare_572, NonSpare_562, NonSpare_1231, NonSpare_1233, NonSpare_1185, NonSpare_1908, NonSpare_1327]
    cv_items_dict = {"PSR": NonSpare_1464, "SSR": NonSpare_1751, "MDA": NonSpare_1242, "MFL": NonSpare_1264, "MDS": NonSpare_1248, "ADS": NonSpare_572, "ADB": NonSpare_562, "MD1": NonSpare_1231, "MD2": NonSpare_1233, "LOP": NonSpare_1185, "TRK": NonSpare_1908, "MUL": NonSpare_1327}

    @overload
    @classmethod
    def spec(cls, key : Literal["PSR"]) -> NonSpare_1464:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSR"]) -> NonSpare_1751:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDA"]) -> NonSpare_1242:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MFL"]) -> NonSpare_1264:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDS"]) -> NonSpare_1248:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADS"]) -> NonSpare_572:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADB"]) -> NonSpare_562:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MD1"]) -> NonSpare_1231:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MD2"]) -> NonSpare_1233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LOP"]) -> NonSpare_1185:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRK"]) -> NonSpare_1908:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MUL"]) -> NonSpare_1327:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PSR"], Literal["SSR"], Literal["MDA"], Literal["MFL"], Literal["MDS"], Literal["ADS"], Literal["ADB"], Literal["MD1"], Literal["MD2"], Literal["LOP"], Literal["TRK"], Literal["MUL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[NonSpare_1464]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[NonSpare_1751]:
        ...
    @overload
    def get_item(self, key : Literal["MDA"]) -> Optional[NonSpare_1242]:
        ...
    @overload
    def get_item(self, key : Literal["MFL"]) -> Optional[NonSpare_1264]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[NonSpare_1248]:
        ...
    @overload
    def get_item(self, key : Literal["ADS"]) -> Optional[NonSpare_572]:
        ...
    @overload
    def get_item(self, key : Literal["ADB"]) -> Optional[NonSpare_562]:
        ...
    @overload
    def get_item(self, key : Literal["MD1"]) -> Optional[NonSpare_1231]:
        ...
    @overload
    def get_item(self, key : Literal["MD2"]) -> Optional[NonSpare_1233]:
        ...
    @overload
    def get_item(self, key : Literal["LOP"]) -> Optional[NonSpare_1185]:
        ...
    @overload
    def get_item(self, key : Literal["TRK"]) -> Optional[NonSpare_1908]:
        ...
    @overload
    def get_item(self, key : Literal["MUL"]) -> Optional[NonSpare_1327]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["PSR"], val : NonSpare_1464_Arg) -> "Variation_1490":
        ...
    @overload
    def set_item(self, key : Literal["SSR"], val : NonSpare_1751_Arg) -> "Variation_1490":
        ...
    @overload
    def set_item(self, key : Literal["MDA"], val : NonSpare_1242_Arg) -> "Variation_1490":
        ...
    @overload
    def set_item(self, key : Literal["MFL"], val : NonSpare_1264_Arg) -> "Variation_1490":
        ...
    @overload
    def set_item(self, key : Literal["MDS"], val : NonSpare_1248_Arg) -> "Variation_1490":
        ...
    @overload
    def set_item(self, key : Literal["ADS"], val : NonSpare_572_Arg) -> "Variation_1490":
        ...
    @overload
    def set_item(self, key : Literal["ADB"], val : NonSpare_562_Arg) -> "Variation_1490":
        ...
    @overload
    def set_item(self, key : Literal["MD1"], val : NonSpare_1231_Arg) -> "Variation_1490":
        ...
    @overload
    def set_item(self, key : Literal["MD2"], val : NonSpare_1233_Arg) -> "Variation_1490":
        ...
    @overload
    def set_item(self, key : Literal["LOP"], val : NonSpare_1185_Arg) -> "Variation_1490":
        ...
    @overload
    def set_item(self, key : Literal["TRK"], val : NonSpare_1908_Arg) -> "Variation_1490":
        ...
    @overload
    def set_item(self, key : Literal["MUL"], val : NonSpare_1327_Arg) -> "Variation_1490":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["PSR"]) -> "Variation_1490":
        ...
    @overload
    def del_item(self, key : Literal["SSR"]) -> "Variation_1490":
        ...
    @overload
    def del_item(self, key : Literal["MDA"]) -> "Variation_1490":
        ...
    @overload
    def del_item(self, key : Literal["MFL"]) -> "Variation_1490":
        ...
    @overload
    def del_item(self, key : Literal["MDS"]) -> "Variation_1490":
        ...
    @overload
    def del_item(self, key : Literal["ADS"]) -> "Variation_1490":
        ...
    @overload
    def del_item(self, key : Literal["ADB"]) -> "Variation_1490":
        ...
    @overload
    def del_item(self, key : Literal["MD1"]) -> "Variation_1490":
        ...
    @overload
    def del_item(self, key : Literal["MD2"]) -> "Variation_1490":
        ...
    @overload
    def del_item(self, key : Literal["LOP"]) -> "Variation_1490":
        ...
    @overload
    def del_item(self, key : Literal["TRK"]) -> "Variation_1490":
        ...
    @overload
    def del_item(self, key : Literal["MUL"]) -> "Variation_1490":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1490_Arg) -> 'Variation_1490':
        return cls._create(arg) # type: ignore

RuleVariation_1413_Arg: TypeAlias = Variation_1490_Arg
class RuleVariation_1413(RuleVariationContextFree):
    cv_variation = Variation_1490

    @classmethod
    def create(cls, arg : RuleVariation_1413_Arg) -> "RuleVariation_1413":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1490:
        return self.arg # type: ignore

NonSpare_463_Arg: TypeAlias = RuleVariation_1413_Arg
class NonSpare_463(NonSpare):
    cv_name = "290"
    cv_title = "System Track Update Ages"
    cv_rule = RuleVariation_1413

    @classmethod
    def create(cls, arg : NonSpare_463_Arg) -> "NonSpare_463":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1413:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1490:
        return self.rule.variation

class UapItem_463(UapItem):
    cv_non_spare = NonSpare_463

Content_549_Arg: TypeAlias = int
class Content_549(ContentTable):
    cv_values = {0: "Unknown", 1: "On stand", 2: "Taxiing for departure", 3: "Taxiing for arrival", 4: "Runway for departure", 5: "Runway for arrival", 6: "Hold for departure", 7: "Hold for arrival", 8: "Push back", 9: "On finals"}

RuleContent_549_Arg: TypeAlias = Content_549_Arg
class RuleContent_549(RuleContentContextFree):
    cv_content = Content_549

    @property
    def content(self) -> Content_549:
        return self._get_content() # type: ignore

Variation_177_Arg: TypeAlias = RuleContent_549_Arg
class Variation_177(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_549

    @classmethod
    def create(cls, arg : Variation_177_Arg) -> "Variation_177":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_549:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_549:
        return self.rule.content

RuleVariation_170_Arg: TypeAlias = Variation_177_Arg
class RuleVariation_170(RuleVariationContextFree):
    cv_variation = Variation_177

    @classmethod
    def create(cls, arg : RuleVariation_170_Arg) -> "RuleVariation_170":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_177:
        return self.arg # type: ignore

NonSpare_501_Arg: TypeAlias = RuleVariation_170_Arg
class NonSpare_501(NonSpare):
    cv_name = "430"
    cv_title = "Phase of Flight"
    cv_rule = RuleVariation_170

    @classmethod
    def create(cls, arg : NonSpare_501_Arg) -> "NonSpare_501":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_170:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_177:
        return self.rule.variation

class UapItem_500(UapItem):
    cv_non_spare = NonSpare_501

Content_654_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["FL"]]]
class Content_654(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.25
    cv_unit = "FL"

    def as_quantity(self, cv_unit : Optional[Literal["FL"]] = None) -> float:
        return self._as_quantity()

RuleContent_654_Arg: TypeAlias = Content_654_Arg
class RuleContent_654(RuleContentContextFree):
    cv_content = Content_654

    @property
    def content(self) -> Content_654:
        return self._get_content() # type: ignore

Variation_272_Arg: TypeAlias = RuleContent_654_Arg
class Variation_272(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_654

    @classmethod
    def create(cls, arg : Variation_272_Arg) -> "Variation_272":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_654:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_654:
        return self.rule.content

RuleVariation_265_Arg: TypeAlias = Variation_272_Arg
class RuleVariation_265(RuleVariationContextFree):
    cv_variation = Variation_272

    @classmethod
    def create(cls, arg : RuleVariation_265_Arg) -> "RuleVariation_265":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_272:
        return self.arg # type: ignore

NonSpare_248_Arg: TypeAlias = RuleVariation_265_Arg
class NonSpare_248(NonSpare):
    cv_name = "090"
    cv_title = "Measured Flight Level"
    cv_rule = RuleVariation_265

    @classmethod
    def create(cls, arg : NonSpare_248_Arg) -> "NonSpare_248":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_265:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_272:
        return self.rule.variation

class UapItem_248(UapItem):
    cv_non_spare = NonSpare_248

Content_314_Arg: TypeAlias = int
class Content_314(ContentTable):
    cv_values = {0: "No QNH correction applied", 1: "QNH correction applied"}

RuleContent_314_Arg: TypeAlias = Content_314_Arg
class RuleContent_314(RuleContentContextFree):
    cv_content = Content_314

    @property
    def content(self) -> Content_314:
        return self._get_content() # type: ignore

Variation_58_Arg: TypeAlias = RuleContent_314_Arg
class Variation_58(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_314

    @classmethod
    def create(cls, arg : Variation_58_Arg) -> "Variation_58":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_314:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_314:
        return self.rule.content

RuleVariation_58_Arg: TypeAlias = Variation_58_Arg
class RuleVariation_58(RuleVariationContextFree):
    cv_variation = Variation_58

    @classmethod
    def create(cls, arg : RuleVariation_58_Arg) -> "RuleVariation_58":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_58:
        return self.arg # type: ignore

NonSpare_1520_Arg: TypeAlias = RuleVariation_58_Arg
class NonSpare_1520(NonSpare):
    cv_name = "QNH"
    cv_title = "QNH Correction Applied"
    cv_rule = RuleVariation_58

    @classmethod
    def create(cls, arg : NonSpare_1520_Arg) -> "NonSpare_1520":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_58:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_58:
        return self.rule.variation

Item_758_Arg: TypeAlias = NonSpare_1520_Arg
class Item_758(Item):
    cv_non_spare = NonSpare_1520

    @classmethod
    def create(cls, arg : Item_758_Arg) -> "Item_758":
        return cls._create(arg) # type: ignore

Content_652_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["FL"]]]
class Content_652(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.25
    cv_unit = "FL"

    def as_quantity(self, cv_unit : Optional[Literal["FL"]] = None) -> float:
        return self._as_quantity()

RuleContent_652_Arg: TypeAlias = Content_652_Arg
class RuleContent_652(RuleContentContextFree):
    cv_content = Content_652

    @property
    def content(self) -> Content_652:
        return self._get_content() # type: ignore

Variation_497_Arg: TypeAlias = RuleContent_652_Arg
class Variation_497(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 15
    cv_rule = RuleContent_652

    @classmethod
    def create(cls, arg : Variation_497_Arg) -> "Variation_497":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_652:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_652:
        return self.rule.content

RuleVariation_486_Arg: TypeAlias = Variation_497_Arg
class RuleVariation_486(RuleVariationContextFree):
    cv_variation = Variation_497

    @classmethod
    def create(cls, arg : RuleVariation_486_Arg) -> "RuleVariation_486":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_497:
        return self.arg # type: ignore

NonSpare_840_Arg: TypeAlias = RuleVariation_486_Arg
class NonSpare_840(NonSpare):
    cv_name = "CTBA"
    cv_title = "Calculated Track Barometric Altitude"
    cv_rule = RuleVariation_486

    @classmethod
    def create(cls, arg : NonSpare_840_Arg) -> "NonSpare_840":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_486:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_497:
        return self.rule.variation

Item_228_Arg: TypeAlias = NonSpare_840_Arg
class Item_228(Item):
    cv_non_spare = NonSpare_840

    @classmethod
    def create(cls, arg : Item_228_Arg) -> "Item_228":
        return cls._create(arg) # type: ignore

Variation_1162_Arg_Group = Tuple[Union[RuleVariation_58_Arg, Tuple[Literal["QNH"], RuleVariation_58_Arg]], Union[RuleVariation_486_Arg, Tuple[Literal["CTBA"], RuleVariation_486_Arg]]]
Variation_1162_Arg: TypeAlias = Union[int, Variation_1162_Arg_Group]
class Variation_1162(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_758, 1), (Item_228, 15)]
    cv_items_dict = {"QNH": RuleVariation_58, "CTBA": RuleVariation_486}

    @overload
    @classmethod
    def spec(cls, key : Literal["QNH"]) -> RuleVariation_58:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CTBA"]) -> RuleVariation_486:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["QNH"], Literal["CTBA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["QNH"]) -> RuleVariation_58:
        ...
    @overload
    def get_item(self, key : Literal["CTBA"]) -> RuleVariation_486:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1162_Arg) -> 'Variation_1162':
        return cls._create(arg) # type: ignore

RuleVariation_1114_Arg: TypeAlias = Variation_1162_Arg
class RuleVariation_1114(RuleVariationContextFree):
    cv_variation = Variation_1162

    @classmethod
    def create(cls, arg : RuleVariation_1114_Arg) -> "RuleVariation_1114":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1162:
        return self.arg # type: ignore

NonSpare_261_Arg: TypeAlias = RuleVariation_1114_Arg
class NonSpare_261(NonSpare):
    cv_name = "093"
    cv_title = "Calculated Track Barometric Altitude"
    cv_rule = RuleVariation_1114

    @classmethod
    def create(cls, arg : NonSpare_261_Arg) -> "NonSpare_261":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1114:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1162:
        return self.rule.variation

class UapItem_261(UapItem):
    cv_non_spare = NonSpare_261

Content_684_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
class Content_684(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 6.25
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

RuleContent_684_Arg: TypeAlias = Content_684_Arg
class RuleContent_684(RuleContentContextFree):
    cv_content = Content_684

    @property
    def content(self) -> Content_684:
        return self._get_content() # type: ignore

Variation_290_Arg: TypeAlias = RuleContent_684_Arg
class Variation_290(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_684

    @classmethod
    def create(cls, arg : Variation_290_Arg) -> "Variation_290":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_684:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_684:
        return self.rule.content

RuleVariation_283_Arg: TypeAlias = Variation_290_Arg
class RuleVariation_283(RuleVariationContextFree):
    cv_variation = Variation_290

    @classmethod
    def create(cls, arg : RuleVariation_283_Arg) -> "RuleVariation_283":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_290:
        return self.arg # type: ignore

NonSpare_258_Arg: TypeAlias = RuleVariation_283_Arg
class NonSpare_258(NonSpare):
    cv_name = "092"
    cv_title = "Calculated Track Geometric Altitude"
    cv_rule = RuleVariation_283

    @classmethod
    def create(cls, arg : NonSpare_258_Arg) -> "NonSpare_258":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_283:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_290:
        return self.rule.variation

class UapItem_258(UapItem):
    cv_non_spare = NonSpare_258

Content_686_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft/min"]]]
class Content_686(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 6.25
    cv_unit = "ft/min"

    def as_quantity(self, cv_unit : Optional[Literal["ft/min"]] = None) -> float:
        return self._as_quantity()

RuleContent_686_Arg: TypeAlias = Content_686_Arg
class RuleContent_686(RuleContentContextFree):
    cv_content = Content_686

    @property
    def content(self) -> Content_686:
        return self._get_content() # type: ignore

Variation_292_Arg: TypeAlias = RuleContent_686_Arg
class Variation_292(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_686

    @classmethod
    def create(cls, arg : Variation_292_Arg) -> "Variation_292":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_686:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_686:
        return self.rule.content

RuleVariation_285_Arg: TypeAlias = Variation_292_Arg
class RuleVariation_285(RuleVariationContextFree):
    cv_variation = Variation_292

    @classmethod
    def create(cls, arg : RuleVariation_285_Arg) -> "RuleVariation_285":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_292:
        return self.arg # type: ignore

NonSpare_413_Arg: TypeAlias = RuleVariation_285_Arg
class NonSpare_413(NonSpare):
    cv_name = "215"
    cv_title = "Calculated Rate Of Climb/Descent"
    cv_rule = RuleVariation_285

    @classmethod
    def create(cls, arg : NonSpare_413_Arg) -> "NonSpare_413":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_285:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_292:
        return self.rule.variation

class UapItem_413(UapItem):
    cv_non_spare = NonSpare_413

NonSpare_459_Arg: TypeAlias = RuleVariation_1278_Arg
class NonSpare_459(NonSpare):
    cv_name = "270"
    cv_title = "Target Size and Orientation"
    cv_rule = RuleVariation_1278

    @classmethod
    def create(cls, arg : NonSpare_459_Arg) -> "NonSpare_459":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1278:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1355:
        return self.rule.variation

class UapItem_459(UapItem):
    cv_non_spare = NonSpare_459

NonSpare_1701_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_1701(NonSpare):
    cv_name = "SIC"
    cv_title = "System Identity Code"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_1701_Arg) -> "NonSpare_1701":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_884_Arg: TypeAlias = NonSpare_1701_Arg
class Item_884(Item):
    cv_non_spare = NonSpare_1701

    @classmethod
    def create(cls, arg : Item_884_Arg) -> "Item_884":
        return cls._create(arg) # type: ignore

Variation_1189_Arg_Group = Tuple[Union[RuleVariation_158_Arg, Tuple[Literal["SAC"], RuleVariation_158_Arg]], Union[RuleVariation_158_Arg, Tuple[Literal["SIC"], RuleVariation_158_Arg]]]
Variation_1189_Arg: TypeAlias = Union[int, Variation_1189_Arg_Group]
class Variation_1189(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_852, 8), (Item_884, 8)]
    cv_items_dict = {"SAC": RuleVariation_158, "SIC": RuleVariation_158}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAC"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIC"]) -> RuleVariation_158:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAC"], Literal["SIC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAC"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["SIC"]) -> RuleVariation_158:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1189_Arg) -> 'Variation_1189':
        return cls._create(arg) # type: ignore

RuleVariation_1136_Arg: TypeAlias = Variation_1189_Arg
class RuleVariation_1136(RuleVariationContextFree):
    cv_variation = Variation_1189

    @classmethod
    def create(cls, arg : RuleVariation_1136_Arg) -> "RuleVariation_1136":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1189:
        return self.arg # type: ignore

NonSpare_982_Arg: TypeAlias = RuleVariation_1136_Arg
class NonSpare_982(NonSpare):
    cv_name = "FPPSID"
    cv_title = "FPPS Identification Tag"
    cv_rule = RuleVariation_1136

    @classmethod
    def create(cls, arg : NonSpare_982_Arg) -> "NonSpare_982":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1136:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1189:
        return self.rule.variation

NonSpare_827_Arg: TypeAlias = RuleVariation_383_Arg
class NonSpare_827(NonSpare):
    cv_name = "CSN"
    cv_title = "Callsign"
    cv_rule = RuleVariation_383

    @classmethod
    def create(cls, arg : NonSpare_827_Arg) -> "NonSpare_827":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

Content_425_Arg: TypeAlias = int
class Content_425(ContentTable):
    cv_values = {0: "Plan number", 1: "Unit 1 internal flight number", 2: "Unit 2 internal flight number", 3: "Unit 3 internal flight number"}

RuleContent_425_Arg: TypeAlias = Content_425_Arg
class RuleContent_425(RuleContentContextFree):
    cv_content = Content_425

    @property
    def content(self) -> Content_425:
        return self._get_content() # type: ignore

Variation_111_Arg: TypeAlias = RuleContent_425_Arg
class Variation_111(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_425

    @classmethod
    def create(cls, arg : Variation_111_Arg) -> "Variation_111":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_425:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_425:
        return self.rule.content

RuleVariation_111_Arg: TypeAlias = Variation_111_Arg
class RuleVariation_111(RuleVariationContextFree):
    cv_variation = Variation_111

    @classmethod
    def create(cls, arg : RuleVariation_111_Arg) -> "RuleVariation_111":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_111:
        return self.arg # type: ignore

NonSpare_1956_Arg: TypeAlias = RuleVariation_111_Arg
class NonSpare_1956(NonSpare):
    cv_name = "TYP"
    cv_title = "IFPS Flight ID Type"
    cv_rule = RuleVariation_111

    @classmethod
    def create(cls, arg : NonSpare_1956_Arg) -> "NonSpare_1956":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_111:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_111:
        return self.rule.variation

Item_1075_Arg: TypeAlias = NonSpare_1956_Arg
class Item_1075(Item):
    cv_non_spare = NonSpare_1956

    @classmethod
    def create(cls, arg : Item_1075_Arg) -> "Item_1075":
        return cls._create(arg) # type: ignore

Item_13_Arg: TypeAlias = int
class Item_13(Spare):
    cv_bit_offset8 = 2
    cv_bit_size = 3

Variation_893_Arg: TypeAlias = RuleContent_0_Arg
class Variation_893(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 27
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_893_Arg) -> "Variation_893":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_863_Arg: TypeAlias = Variation_893_Arg
class RuleVariation_863(RuleVariationContextFree):
    cv_variation = Variation_893

    @classmethod
    def create(cls, arg : RuleVariation_863_Arg) -> "RuleVariation_863":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_893:
        return self.arg # type: ignore

NonSpare_1344_Arg: TypeAlias = RuleVariation_863_Arg
class NonSpare_1344(NonSpare):
    cv_name = "NBR"
    cv_title = "IFPS Flight ID Number"
    cv_rule = RuleVariation_863

    @classmethod
    def create(cls, arg : NonSpare_1344_Arg) -> "NonSpare_1344":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_863:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_893:
        return self.rule.variation

Item_610_Arg: TypeAlias = NonSpare_1344_Arg
class Item_610(Item):
    cv_non_spare = NonSpare_1344

    @classmethod
    def create(cls, arg : Item_610_Arg) -> "Item_610":
        return cls._create(arg) # type: ignore

Variation_1230_Arg_Group = Tuple[Union[RuleVariation_111_Arg, Tuple[Literal["TYP"], RuleVariation_111_Arg]], int, Union[RuleVariation_863_Arg, Tuple[Literal["NBR"], RuleVariation_863_Arg]]]
Variation_1230_Arg: TypeAlias = Union[int, Variation_1230_Arg_Group]
class Variation_1230(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1075, 2), (Item_13, 3), (Item_610, 27)]
    cv_items_dict = {"TYP": RuleVariation_111, "NBR": RuleVariation_863}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_111:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NBR"]) -> RuleVariation_863:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["NBR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_111:
        ...
    @overload
    def get_item(self, key : Literal["NBR"]) -> RuleVariation_863:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1230_Arg) -> 'Variation_1230':
        return cls._create(arg) # type: ignore

RuleVariation_1167_Arg: TypeAlias = Variation_1230_Arg
class RuleVariation_1167(RuleVariationContextFree):
    cv_variation = Variation_1230

    @classmethod
    def create(cls, arg : RuleVariation_1167_Arg) -> "RuleVariation_1167":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1230:
        return self.arg # type: ignore

NonSpare_1110_Arg: TypeAlias = RuleVariation_1167_Arg
class NonSpare_1110(NonSpare):
    cv_name = "IFPSFLIGHTID"
    cv_title = "IFPS_FLIGHT_ID"
    cv_rule = RuleVariation_1167

    @classmethod
    def create(cls, arg : NonSpare_1110_Arg) -> "NonSpare_1110":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1167:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1230:
        return self.rule.variation

NonSpare_1017_Arg: TypeAlias = RuleVariation_115_Arg
class NonSpare_1017(NonSpare):
    cv_name = "GATOAT"
    cv_title = "Flight Type"
    cv_rule = RuleVariation_115

    @classmethod
    def create(cls, arg : NonSpare_1017_Arg) -> "NonSpare_1017":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_115:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_115:
        return self.rule.variation

Item_361_Arg: TypeAlias = NonSpare_1017_Arg
class Item_361(Item):
    cv_non_spare = NonSpare_1017

    @classmethod
    def create(cls, arg : Item_361_Arg) -> "Item_361":
        return cls._create(arg) # type: ignore

NonSpare_1630_Arg: TypeAlias = RuleVariation_755_Arg
class NonSpare_1630(NonSpare):
    cv_name = "RVSM"
    cv_title = "RVSM"
    cv_rule = RuleVariation_755

    @classmethod
    def create(cls, arg : NonSpare_1630_Arg) -> "NonSpare_1630":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_755:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_766:
        return self.rule.variation

Item_841_Arg: TypeAlias = NonSpare_1630_Arg
class Item_841(Item):
    cv_non_spare = NonSpare_1630

    @classmethod
    def create(cls, arg : Item_841_Arg) -> "Item_841":
        return cls._create(arg) # type: ignore

NonSpare_1071_Arg: TypeAlias = RuleVariation_909_Arg
class NonSpare_1071(NonSpare):
    cv_name = "HPR"
    cv_title = "Flight Priority"
    cv_rule = RuleVariation_909

    @classmethod
    def create(cls, arg : NonSpare_1071_Arg) -> "NonSpare_1071":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_909:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_939:
        return self.rule.variation

Item_401_Arg: TypeAlias = NonSpare_1071_Arg
class Item_401(Item):
    cv_non_spare = NonSpare_1071

    @classmethod
    def create(cls, arg : Item_401_Arg) -> "Item_401":
        return cls._create(arg) # type: ignore

Variation_1107_Arg_Group = Tuple[Union[RuleVariation_115_Arg, Tuple[Literal["GATOAT"], RuleVariation_115_Arg]], Union[RuleVariation_578_Arg, Tuple[Literal["FR1FR2"], RuleVariation_578_Arg]], Union[RuleVariation_755_Arg, Tuple[Literal["RVSM"], RuleVariation_755_Arg]], Union[RuleVariation_909_Arg, Tuple[Literal["HPR"], RuleVariation_909_Arg]], int]
Variation_1107_Arg: TypeAlias = Union[int, Variation_1107_Arg_Group]
class Variation_1107(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_361, 2), (Item_342, 2), (Item_841, 2), (Item_401, 1), (Item_29, 1)]
    cv_items_dict = {"GATOAT": RuleVariation_115, "FR1FR2": RuleVariation_578, "RVSM": RuleVariation_755, "HPR": RuleVariation_909}

    @overload
    @classmethod
    def spec(cls, key : Literal["GATOAT"]) -> RuleVariation_115:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FR1FR2"]) -> RuleVariation_578:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RVSM"]) -> RuleVariation_755:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HPR"]) -> RuleVariation_909:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GATOAT"], Literal["FR1FR2"], Literal["RVSM"], Literal["HPR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GATOAT"]) -> RuleVariation_115:
        ...
    @overload
    def get_item(self, key : Literal["FR1FR2"]) -> RuleVariation_578:
        ...
    @overload
    def get_item(self, key : Literal["RVSM"]) -> RuleVariation_755:
        ...
    @overload
    def get_item(self, key : Literal["HPR"]) -> RuleVariation_909:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1107_Arg) -> 'Variation_1107':
        return cls._create(arg) # type: ignore

RuleVariation_1065_Arg: TypeAlias = Variation_1107_Arg
class RuleVariation_1065(RuleVariationContextFree):
    cv_variation = Variation_1107

    @classmethod
    def create(cls, arg : RuleVariation_1065_Arg) -> "RuleVariation_1065":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1107:
        return self.arg # type: ignore

NonSpare_970_Arg: TypeAlias = RuleVariation_1065_Arg
class NonSpare_970(NonSpare):
    cv_name = "FLIGHTCAT"
    cv_title = "Flight Category"
    cv_rule = RuleVariation_1065

    @classmethod
    def create(cls, arg : NonSpare_970_Arg) -> "NonSpare_970":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1065:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1107:
        return self.rule.variation

NonSpare_1872_Arg: TypeAlias = RuleVariation_365_Arg
class NonSpare_1872(NonSpare):
    cv_name = "TOA"
    cv_title = "Type of Aircraft"
    cv_rule = RuleVariation_365

    @classmethod
    def create(cls, arg : NonSpare_1872_Arg) -> "NonSpare_1872":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_365:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_372:
        return self.rule.variation

Content_605_Arg: TypeAlias = int
class Content_605(ContentTable):
    cv_values = {76: "Light", 77: "Medium", 72: "Heavy", 74: "Super"}

RuleContent_605_Arg: TypeAlias = Content_605_Arg
class RuleContent_605(RuleContentContextFree):
    cv_content = Content_605

    @property
    def content(self) -> Content_605:
        return self._get_content() # type: ignore

Variation_200_Arg: TypeAlias = RuleContent_605_Arg
class Variation_200(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_605

    @classmethod
    def create(cls, arg : Variation_200_Arg) -> "Variation_200":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_605:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_605:
        return self.rule.content

RuleVariation_193_Arg: TypeAlias = Variation_200_Arg
class RuleVariation_193(RuleVariationContextFree):
    cv_variation = Variation_200

    @classmethod
    def create(cls, arg : RuleVariation_193_Arg) -> "RuleVariation_193":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_200:
        return self.arg # type: ignore

NonSpare_2059_Arg: TypeAlias = RuleVariation_193_Arg
class NonSpare_2059(NonSpare):
    cv_name = "WTC"
    cv_title = "Wake Turbulence Category"
    cv_rule = RuleVariation_193

    @classmethod
    def create(cls, arg : NonSpare_2059_Arg) -> "NonSpare_2059":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_193:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_200:
        return self.rule.variation

NonSpare_563_Arg: TypeAlias = RuleVariation_365_Arg
class NonSpare_563(NonSpare):
    cv_name = "ADEP"
    cv_title = "Departure Airport"
    cv_rule = RuleVariation_365

    @classmethod
    def create(cls, arg : NonSpare_563_Arg) -> "NonSpare_563":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_365:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_372:
        return self.rule.variation

NonSpare_564_Arg: TypeAlias = RuleVariation_365_Arg
class NonSpare_564(NonSpare):
    cv_name = "ADES"
    cv_title = "Destination Airport"
    cv_rule = RuleVariation_365

    @classmethod
    def create(cls, arg : NonSpare_564_Arg) -> "NonSpare_564":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_365:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_372:
        return self.rule.variation

Variation_348_Arg: TypeAlias = RuleContent_606_Arg
class Variation_348(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_606

    @classmethod
    def create(cls, arg : Variation_348_Arg) -> "Variation_348":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_606:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_606:
        return self.rule.content

RuleVariation_341_Arg: TypeAlias = Variation_348_Arg
class RuleVariation_341(RuleVariationContextFree):
    cv_variation = Variation_348

    @classmethod
    def create(cls, arg : RuleVariation_341_Arg) -> "RuleVariation_341":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_348:
        return self.arg # type: ignore

NonSpare_1634_Arg: TypeAlias = RuleVariation_341_Arg
class NonSpare_1634(NonSpare):
    cv_name = "RWY"
    cv_title = "Runway Designation"
    cv_rule = RuleVariation_341

    @classmethod
    def create(cls, arg : NonSpare_1634_Arg) -> "NonSpare_1634":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_341:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_348:
        return self.rule.variation

NonSpare_720_Arg: TypeAlias = RuleVariation_312_Arg
class NonSpare_720(NonSpare):
    cv_name = "CFL"
    cv_title = "Current Cleared Flight Level"
    cv_rule = RuleVariation_312

    @classmethod
    def create(cls, arg : NonSpare_720_Arg) -> "NonSpare_720":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_312:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_319:
        return self.rule.variation

NonSpare_717_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_717(NonSpare):
    cv_name = "CENTRE"
    cv_title = "8-bit Group Identification Code"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_717_Arg) -> "NonSpare_717":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_149_Arg: TypeAlias = NonSpare_717_Arg
class Item_149(Item):
    cv_non_spare = NonSpare_717

    @classmethod
    def create(cls, arg : Item_149_Arg) -> "Item_149":
        return cls._create(arg) # type: ignore

NonSpare_1442_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_1442(NonSpare):
    cv_name = "POSITION"
    cv_title = "8-bit Control Position Identification Code"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_1442_Arg) -> "NonSpare_1442":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_691_Arg: TypeAlias = NonSpare_1442_Arg
class Item_691(Item):
    cv_non_spare = NonSpare_1442

    @classmethod
    def create(cls, arg : Item_691_Arg) -> "Item_691":
        return cls._create(arg) # type: ignore

Variation_1065_Arg_Group = Tuple[Union[RuleVariation_158_Arg, Tuple[Literal["CENTRE"], RuleVariation_158_Arg]], Union[RuleVariation_158_Arg, Tuple[Literal["POSITION"], RuleVariation_158_Arg]]]
Variation_1065_Arg: TypeAlias = Union[int, Variation_1065_Arg_Group]
class Variation_1065(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_149, 8), (Item_691, 8)]
    cv_items_dict = {"CENTRE": RuleVariation_158, "POSITION": RuleVariation_158}

    @overload
    @classmethod
    def spec(cls, key : Literal["CENTRE"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POSITION"]) -> RuleVariation_158:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CENTRE"], Literal["POSITION"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CENTRE"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["POSITION"]) -> RuleVariation_158:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1065_Arg) -> 'Variation_1065':
        return cls._create(arg) # type: ignore

RuleVariation_1027_Arg: TypeAlias = Variation_1065_Arg
class RuleVariation_1027(RuleVariationContextFree):
    cv_variation = Variation_1065

    @classmethod
    def create(cls, arg : RuleVariation_1027_Arg) -> "RuleVariation_1027":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1065:
        return self.arg # type: ignore

NonSpare_705_Arg: TypeAlias = RuleVariation_1027_Arg
class NonSpare_705(NonSpare):
    cv_name = "CCP"
    cv_title = "Current Control Position"
    cv_rule = RuleVariation_1027

    @classmethod
    def create(cls, arg : NonSpare_705_Arg) -> "NonSpare_705":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1027:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1065:
        return self.rule.variation

Content_453_Arg: TypeAlias = int
class Content_453(ContentTable):
    cv_values = {0: "Scheduled off-block time", 1: "Estimated off-block time", 2: "Estimated take-off time", 3: "Actual off-block time", 4: "Predicted time at runway hold", 5: "Actual time at runway hold", 6: "Actual line-up time", 7: "Actual take-off time", 8: "Estimated time of arrival", 9: "Predicted landing time", 10: "Actual landing time", 11: "Actual time off runway", 12: "Predicted time to gate", 13: "Actual on-block time"}

RuleContent_453_Arg: TypeAlias = Content_453_Arg
class RuleContent_453(RuleContentContextFree):
    cv_content = Content_453

    @property
    def content(self) -> Content_453:
        return self._get_content() # type: ignore

Variation_144_Arg: TypeAlias = RuleContent_453_Arg
class Variation_144(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 5
    cv_rule = RuleContent_453

    @classmethod
    def create(cls, arg : Variation_144_Arg) -> "Variation_144":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_453:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_453:
        return self.rule.content

RuleVariation_144_Arg: TypeAlias = Variation_144_Arg
class RuleVariation_144(RuleVariationContextFree):
    cv_variation = Variation_144

    @classmethod
    def create(cls, arg : RuleVariation_144_Arg) -> "RuleVariation_144":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_144:
        return self.arg # type: ignore

NonSpare_1959_Arg: TypeAlias = RuleVariation_144_Arg
class NonSpare_1959(NonSpare):
    cv_name = "TYP"
    cv_title = "Time Type"
    cv_rule = RuleVariation_144

    @classmethod
    def create(cls, arg : NonSpare_1959_Arg) -> "NonSpare_1959":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_144:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_144:
        return self.rule.variation

Item_1078_Arg: TypeAlias = NonSpare_1959_Arg
class Item_1078(Item):
    cv_non_spare = NonSpare_1959

    @classmethod
    def create(cls, arg : Item_1078_Arg) -> "Item_1078":
        return cls._create(arg) # type: ignore

Content_507_Arg: TypeAlias = int
class Content_507(ContentTable):
    cv_values = {0: "Today", 1: "Yesterday", 2: "Tomorrow"}

RuleContent_507_Arg: TypeAlias = Content_507_Arg
class RuleContent_507(RuleContentContextFree):
    cv_content = Content_507

    @property
    def content(self) -> Content_507:
        return self._get_content() # type: ignore

Variation_881_Arg: TypeAlias = RuleContent_507_Arg
class Variation_881(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_507

    @classmethod
    def create(cls, arg : Variation_881_Arg) -> "Variation_881":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_507:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_507:
        return self.rule.content

RuleVariation_851_Arg: TypeAlias = Variation_881_Arg
class RuleVariation_851(RuleVariationContextFree):
    cv_variation = Variation_881

    @classmethod
    def create(cls, arg : RuleVariation_851_Arg) -> "RuleVariation_851":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_881:
        return self.arg # type: ignore

NonSpare_856_Arg: TypeAlias = RuleVariation_851_Arg
class NonSpare_856(NonSpare):
    cv_name = "DAY"
    cv_title = "Day"
    cv_rule = RuleVariation_851

    @classmethod
    def create(cls, arg : NonSpare_856_Arg) -> "NonSpare_856":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_851:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_881:
        return self.rule.variation

Item_240_Arg: TypeAlias = NonSpare_856_Arg
class Item_240(Item):
    cv_non_spare = NonSpare_856

    @classmethod
    def create(cls, arg : Item_240_Arg) -> "Item_240":
        return cls._create(arg) # type: ignore

Item_30_Arg: TypeAlias = int
class Item_30(Spare):
    cv_bit_offset8 = 7
    cv_bit_size = 4

Content_615_Arg: TypeAlias = int
class Content_615(ContentInteger):
    cv_signedness = Unsigned

RuleContent_615_Arg: TypeAlias = Content_615_Arg
class RuleContent_615(RuleContentContextFree):
    cv_content = Content_615

    @property
    def content(self) -> Content_615:
        return self._get_content() # type: ignore

Variation_693_Arg: TypeAlias = RuleContent_615_Arg
class Variation_693(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 5
    cv_rule = RuleContent_615

    @classmethod
    def create(cls, arg : Variation_693_Arg) -> "Variation_693":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_615:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_615:
        return self.rule.content

RuleVariation_682_Arg: TypeAlias = Variation_693_Arg
class RuleVariation_682(RuleVariationContextFree):
    cv_variation = Variation_693

    @classmethod
    def create(cls, arg : RuleVariation_682_Arg) -> "RuleVariation_682":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_693:
        return self.arg # type: ignore

NonSpare_1067_Arg: TypeAlias = RuleVariation_682_Arg
class NonSpare_1067(NonSpare):
    cv_name = "HOR"
    cv_title = "Hours, from 0 to 23"
    cv_rule = RuleVariation_682

    @classmethod
    def create(cls, arg : NonSpare_1067_Arg) -> "NonSpare_1067":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_682:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_693:
        return self.rule.variation

Item_398_Arg: TypeAlias = NonSpare_1067_Arg
class Item_398(Item):
    cv_non_spare = NonSpare_1067

    @classmethod
    def create(cls, arg : Item_398_Arg) -> "Item_398":
        return cls._create(arg) # type: ignore

Item_1_Arg: TypeAlias = int
class Item_1(Spare):
    cv_bit_offset8 = 0
    cv_bit_size = 2

Content_616_Arg: TypeAlias = int
class Content_616(ContentInteger):
    cv_signedness = Unsigned

RuleContent_616_Arg: TypeAlias = Content_616_Arg
class RuleContent_616(RuleContentContextFree):
    cv_content = Content_616

    @property
    def content(self) -> Content_616:
        return self._get_content() # type: ignore

Variation_600_Arg: TypeAlias = RuleContent_616_Arg
class Variation_600(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 6
    cv_rule = RuleContent_616

    @classmethod
    def create(cls, arg : Variation_600_Arg) -> "Variation_600":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_616:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_616:
        return self.rule.content

RuleVariation_589_Arg: TypeAlias = Variation_600_Arg
class RuleVariation_589(RuleVariationContextFree):
    cv_variation = Variation_600

    @classmethod
    def create(cls, arg : RuleVariation_589_Arg) -> "RuleVariation_589":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_600:
        return self.arg # type: ignore

NonSpare_1280_Arg: TypeAlias = RuleVariation_589_Arg
class NonSpare_1280(NonSpare):
    cv_name = "MIN"
    cv_title = "Minutes, from 0 to 59"
    cv_rule = RuleVariation_589

    @classmethod
    def create(cls, arg : NonSpare_1280_Arg) -> "NonSpare_1280":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_589:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_600:
        return self.rule.variation

Item_553_Arg: TypeAlias = NonSpare_1280_Arg
class Item_553(Item):
    cv_non_spare = NonSpare_1280

    @classmethod
    def create(cls, arg : Item_553_Arg) -> "Item_553":
        return cls._create(arg) # type: ignore

Content_454_Arg: TypeAlias = int
class Content_454(ContentTable):
    cv_values = {0: "Seconds available", 1: "Seconds not available"}

RuleContent_454_Arg: TypeAlias = Content_454_Arg
class RuleContent_454(RuleContentContextFree):
    cv_content = Content_454

    @property
    def content(self) -> Content_454:
        return self._get_content() # type: ignore

Variation_74_Arg: TypeAlias = RuleContent_454_Arg
class Variation_74(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_454

    @classmethod
    def create(cls, arg : Variation_74_Arg) -> "Variation_74":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_454:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_454:
        return self.rule.content

RuleVariation_74_Arg: TypeAlias = Variation_74_Arg
class RuleVariation_74(RuleVariationContextFree):
    cv_variation = Variation_74

    @classmethod
    def create(cls, arg : RuleVariation_74_Arg) -> "RuleVariation_74":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_74:
        return self.arg # type: ignore

NonSpare_646_Arg: TypeAlias = RuleVariation_74_Arg
class NonSpare_646(NonSpare):
    cv_name = "AVS"
    cv_title = "Seconds Available"
    cv_rule = RuleVariation_74

    @classmethod
    def create(cls, arg : NonSpare_646_Arg) -> "NonSpare_646":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_74:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_74:
        return self.rule.variation

Item_95_Arg: TypeAlias = NonSpare_646_Arg
class Item_95(Item):
    cv_non_spare = NonSpare_646

    @classmethod
    def create(cls, arg : Item_95_Arg) -> "Item_95":
        return cls._create(arg) # type: ignore

NonSpare_1691_Arg: TypeAlias = RuleVariation_589_Arg
class NonSpare_1691(NonSpare):
    cv_name = "SEC"
    cv_title = "Seconds, from 0 to 59"
    cv_rule = RuleVariation_589

    @classmethod
    def create(cls, arg : NonSpare_1691_Arg) -> "NonSpare_1691":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_589:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_600:
        return self.rule.variation

Item_876_Arg: TypeAlias = NonSpare_1691_Arg
class Item_876(Item):
    cv_non_spare = NonSpare_1691

    @classmethod
    def create(cls, arg : Item_876_Arg) -> "Item_876":
        return cls._create(arg) # type: ignore

Variation_1233_Arg_Group = Tuple[Union[RuleVariation_144_Arg, Tuple[Literal["TYP"], RuleVariation_144_Arg]], Union[RuleVariation_851_Arg, Tuple[Literal["DAY"], RuleVariation_851_Arg]], int, Union[RuleVariation_682_Arg, Tuple[Literal["HOR"], RuleVariation_682_Arg]], int, Union[RuleVariation_589_Arg, Tuple[Literal["MIN"], RuleVariation_589_Arg]], Union[RuleVariation_74_Arg, Tuple[Literal["AVS"], RuleVariation_74_Arg]], int, Union[RuleVariation_589_Arg, Tuple[Literal["SEC"], RuleVariation_589_Arg]]]
Variation_1233_Arg: TypeAlias = Union[int, Variation_1233_Arg_Group]
class Variation_1233(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1078, 5), (Item_240, 2), (Item_30, 4), (Item_398, 5), (Item_1, 2), (Item_553, 6), (Item_95, 1), (Item_7, 1), (Item_876, 6)]
    cv_items_dict = {"TYP": RuleVariation_144, "DAY": RuleVariation_851, "HOR": RuleVariation_682, "MIN": RuleVariation_589, "AVS": RuleVariation_74, "SEC": RuleVariation_589}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_144:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DAY"]) -> RuleVariation_851:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HOR"]) -> RuleVariation_682:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MIN"]) -> RuleVariation_589:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AVS"]) -> RuleVariation_74:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SEC"]) -> RuleVariation_589:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["DAY"], Literal["HOR"], Literal["MIN"], Literal["AVS"], Literal["SEC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_144:
        ...
    @overload
    def get_item(self, key : Literal["DAY"]) -> RuleVariation_851:
        ...
    @overload
    def get_item(self, key : Literal["HOR"]) -> RuleVariation_682:
        ...
    @overload
    def get_item(self, key : Literal["MIN"]) -> RuleVariation_589:
        ...
    @overload
    def get_item(self, key : Literal["AVS"]) -> RuleVariation_74:
        ...
    @overload
    def get_item(self, key : Literal["SEC"]) -> RuleVariation_589:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1233_Arg) -> 'Variation_1233':
        return cls._create(arg) # type: ignore

Variation_1434_Arg: TypeAlias = List[Variation_1233_Arg]
class Variation_1434(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1233

    @classmethod
    def create(cls, arg : Variation_1434_Arg) -> 'Variation_1434':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1233]:
        return self._get_list() # type: ignore

RuleVariation_1357_Arg: TypeAlias = Variation_1434_Arg
class RuleVariation_1357(RuleVariationContextFree):
    cv_variation = Variation_1434

    @classmethod
    def create(cls, arg : RuleVariation_1357_Arg) -> "RuleVariation_1357":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1434:
        return self.arg # type: ignore

NonSpare_1873_Arg: TypeAlias = RuleVariation_1357_Arg
class NonSpare_1873(NonSpare):
    cv_name = "TOD"
    cv_title = "Time of Departure"
    cv_rule = RuleVariation_1357

    @classmethod
    def create(cls, arg : NonSpare_1873_Arg) -> "NonSpare_1873":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1357:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1434:
        return self.rule.variation

NonSpare_633_Arg: TypeAlias = RuleVariation_380_Arg
class NonSpare_633(NonSpare):
    cv_name = "AST"
    cv_title = "Aircraft Stand"
    cv_rule = RuleVariation_380

    @classmethod
    def create(cls, arg : NonSpare_633_Arg) -> "NonSpare_633":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_380:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_388:
        return self.rule.variation

Content_204_Arg: TypeAlias = int
class Content_204(ContentTable):
    cv_values = {0: "Empty", 1: "Occupied", 2: "Unknown"}

RuleContent_204_Arg: TypeAlias = Content_204_Arg
class RuleContent_204(RuleContentContextFree):
    cv_content = Content_204

    @property
    def content(self) -> Content_204:
        return self._get_content() # type: ignore

Variation_101_Arg: TypeAlias = RuleContent_204_Arg
class Variation_101(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_204

    @classmethod
    def create(cls, arg : Variation_101_Arg) -> "Variation_101":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_204:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_204:
        return self.rule.content

RuleVariation_101_Arg: TypeAlias = Variation_101_Arg
class RuleVariation_101(RuleVariationContextFree):
    cv_variation = Variation_101

    @classmethod
    def create(cls, arg : RuleVariation_101_Arg) -> "RuleVariation_101":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_101:
        return self.arg # type: ignore

NonSpare_924_Arg: TypeAlias = RuleVariation_101_Arg
class NonSpare_924(NonSpare):
    cv_name = "EMP"
    cv_title = "Stand Empty"
    cv_rule = RuleVariation_101

    @classmethod
    def create(cls, arg : NonSpare_924_Arg) -> "NonSpare_924":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_101:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_101:
        return self.rule.variation

Item_291_Arg: TypeAlias = NonSpare_924_Arg
class Item_291(Item):
    cv_non_spare = NonSpare_924

    @classmethod
    def create(cls, arg : Item_291_Arg) -> "Item_291":
        return cls._create(arg) # type: ignore

Content_43_Arg: TypeAlias = int
class Content_43(ContentTable):
    cv_values = {0: "Available", 1: "Not available", 2: "Unknown"}

RuleContent_43_Arg: TypeAlias = Content_43_Arg
class RuleContent_43(RuleContentContextFree):
    cv_content = Content_43

    @property
    def content(self) -> Content_43:
        return self._get_content() # type: ignore

Variation_585_Arg: TypeAlias = RuleContent_43_Arg
class Variation_585(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_43

    @classmethod
    def create(cls, arg : Variation_585_Arg) -> "Variation_585":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_43:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_43:
        return self.rule.content

RuleVariation_574_Arg: TypeAlias = Variation_585_Arg
class RuleVariation_574(RuleVariationContextFree):
    cv_variation = Variation_585

    @classmethod
    def create(cls, arg : RuleVariation_574_Arg) -> "RuleVariation_574":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_585:
        return self.arg # type: ignore

NonSpare_644_Arg: TypeAlias = RuleVariation_574_Arg
class NonSpare_644(NonSpare):
    cv_name = "AVL"
    cv_title = "Stand Available"
    cv_rule = RuleVariation_574

    @classmethod
    def create(cls, arg : NonSpare_644_Arg) -> "NonSpare_644":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_574:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_585:
        return self.rule.variation

Item_93_Arg: TypeAlias = NonSpare_644_Arg
class Item_93(Item):
    cv_non_spare = NonSpare_644

    @classmethod
    def create(cls, arg : Item_93_Arg) -> "Item_93":
        return cls._create(arg) # type: ignore

Item_22_Arg: TypeAlias = int
class Item_22(Spare):
    cv_bit_offset8 = 4
    cv_bit_size = 4

Variation_1084_Arg_Group = Tuple[Union[RuleVariation_101_Arg, Tuple[Literal["EMP"], RuleVariation_101_Arg]], Union[RuleVariation_574_Arg, Tuple[Literal["AVL"], RuleVariation_574_Arg]], int]
Variation_1084_Arg: TypeAlias = Union[int, Variation_1084_Arg_Group]
class Variation_1084(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_291, 2), (Item_93, 2), (Item_22, 4)]
    cv_items_dict = {"EMP": RuleVariation_101, "AVL": RuleVariation_574}

    @overload
    @classmethod
    def spec(cls, key : Literal["EMP"]) -> RuleVariation_101:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AVL"]) -> RuleVariation_574:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EMP"], Literal["AVL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EMP"]) -> RuleVariation_101:
        ...
    @overload
    def get_item(self, key : Literal["AVL"]) -> RuleVariation_574:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1084_Arg) -> 'Variation_1084':
        return cls._create(arg) # type: ignore

RuleVariation_1042_Arg: TypeAlias = Variation_1084_Arg
class RuleVariation_1042(RuleVariationContextFree):
    cv_variation = Variation_1084

    @classmethod
    def create(cls, arg : RuleVariation_1042_Arg) -> "RuleVariation_1042":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1084:
        return self.arg # type: ignore

NonSpare_1791_Arg: TypeAlias = RuleVariation_1042_Arg
class NonSpare_1791(NonSpare):
    cv_name = "STS"
    cv_title = "Stand Status"
    cv_rule = RuleVariation_1042

    @classmethod
    def create(cls, arg : NonSpare_1791_Arg) -> "NonSpare_1791":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1042:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1084:
        return self.rule.variation

Variation_1478_Arg = TypedDict('Variation_1478_Arg', {
    "FPPSID": NonSpare_982_Arg,
    "CSN": NonSpare_827_Arg,
    "IFPSFLIGHTID": NonSpare_1110_Arg,
    "FLIGHTCAT": NonSpare_970_Arg,
    "TOA": NonSpare_1872_Arg,
    "WTC": NonSpare_2059_Arg,
    "ADEP": NonSpare_563_Arg,
    "ADES": NonSpare_564_Arg,
    "RWY": NonSpare_1634_Arg,
    "CFL": NonSpare_720_Arg,
    "CCP": NonSpare_705_Arg,
    "TOD": NonSpare_1873_Arg,
    "AST": NonSpare_633_Arg,
    "STS": NonSpare_1791_Arg,
}, total=False)
class Variation_1478(Compound):
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_982, NonSpare_827, NonSpare_1110, NonSpare_970, NonSpare_1872, NonSpare_2059, NonSpare_563, NonSpare_564, NonSpare_1634, NonSpare_720, NonSpare_705, NonSpare_1873, NonSpare_633, NonSpare_1791]
    cv_items_dict = {"FPPSID": NonSpare_982, "CSN": NonSpare_827, "IFPSFLIGHTID": NonSpare_1110, "FLIGHTCAT": NonSpare_970, "TOA": NonSpare_1872, "WTC": NonSpare_2059, "ADEP": NonSpare_563, "ADES": NonSpare_564, "RWY": NonSpare_1634, "CFL": NonSpare_720, "CCP": NonSpare_705, "TOD": NonSpare_1873, "AST": NonSpare_633, "STS": NonSpare_1791}

    @overload
    @classmethod
    def spec(cls, key : Literal["FPPSID"]) -> NonSpare_982:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CSN"]) -> NonSpare_827:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IFPSFLIGHTID"]) -> NonSpare_1110:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FLIGHTCAT"]) -> NonSpare_970:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOA"]) -> NonSpare_1872:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WTC"]) -> NonSpare_2059:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADEP"]) -> NonSpare_563:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADES"]) -> NonSpare_564:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RWY"]) -> NonSpare_1634:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CFL"]) -> NonSpare_720:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CCP"]) -> NonSpare_705:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOD"]) -> NonSpare_1873:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AST"]) -> NonSpare_633:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STS"]) -> NonSpare_1791:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["FPPSID"], Literal["CSN"], Literal["IFPSFLIGHTID"], Literal["FLIGHTCAT"], Literal["TOA"], Literal["WTC"], Literal["ADEP"], Literal["ADES"], Literal["RWY"], Literal["CFL"], Literal["CCP"], Literal["TOD"], Literal["AST"], Literal["STS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["FPPSID"]) -> Optional[NonSpare_982]:
        ...
    @overload
    def get_item(self, key : Literal["CSN"]) -> Optional[NonSpare_827]:
        ...
    @overload
    def get_item(self, key : Literal["IFPSFLIGHTID"]) -> Optional[NonSpare_1110]:
        ...
    @overload
    def get_item(self, key : Literal["FLIGHTCAT"]) -> Optional[NonSpare_970]:
        ...
    @overload
    def get_item(self, key : Literal["TOA"]) -> Optional[NonSpare_1872]:
        ...
    @overload
    def get_item(self, key : Literal["WTC"]) -> Optional[NonSpare_2059]:
        ...
    @overload
    def get_item(self, key : Literal["ADEP"]) -> Optional[NonSpare_563]:
        ...
    @overload
    def get_item(self, key : Literal["ADES"]) -> Optional[NonSpare_564]:
        ...
    @overload
    def get_item(self, key : Literal["RWY"]) -> Optional[NonSpare_1634]:
        ...
    @overload
    def get_item(self, key : Literal["CFL"]) -> Optional[NonSpare_720]:
        ...
    @overload
    def get_item(self, key : Literal["CCP"]) -> Optional[NonSpare_705]:
        ...
    @overload
    def get_item(self, key : Literal["TOD"]) -> Optional[NonSpare_1873]:
        ...
    @overload
    def get_item(self, key : Literal["AST"]) -> Optional[NonSpare_633]:
        ...
    @overload
    def get_item(self, key : Literal["STS"]) -> Optional[NonSpare_1791]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["FPPSID"], val : NonSpare_982_Arg) -> "Variation_1478":
        ...
    @overload
    def set_item(self, key : Literal["CSN"], val : NonSpare_827_Arg) -> "Variation_1478":
        ...
    @overload
    def set_item(self, key : Literal["IFPSFLIGHTID"], val : NonSpare_1110_Arg) -> "Variation_1478":
        ...
    @overload
    def set_item(self, key : Literal["FLIGHTCAT"], val : NonSpare_970_Arg) -> "Variation_1478":
        ...
    @overload
    def set_item(self, key : Literal["TOA"], val : NonSpare_1872_Arg) -> "Variation_1478":
        ...
    @overload
    def set_item(self, key : Literal["WTC"], val : NonSpare_2059_Arg) -> "Variation_1478":
        ...
    @overload
    def set_item(self, key : Literal["ADEP"], val : NonSpare_563_Arg) -> "Variation_1478":
        ...
    @overload
    def set_item(self, key : Literal["ADES"], val : NonSpare_564_Arg) -> "Variation_1478":
        ...
    @overload
    def set_item(self, key : Literal["RWY"], val : NonSpare_1634_Arg) -> "Variation_1478":
        ...
    @overload
    def set_item(self, key : Literal["CFL"], val : NonSpare_720_Arg) -> "Variation_1478":
        ...
    @overload
    def set_item(self, key : Literal["CCP"], val : NonSpare_705_Arg) -> "Variation_1478":
        ...
    @overload
    def set_item(self, key : Literal["TOD"], val : NonSpare_1873_Arg) -> "Variation_1478":
        ...
    @overload
    def set_item(self, key : Literal["AST"], val : NonSpare_633_Arg) -> "Variation_1478":
        ...
    @overload
    def set_item(self, key : Literal["STS"], val : NonSpare_1791_Arg) -> "Variation_1478":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["FPPSID"]) -> "Variation_1478":
        ...
    @overload
    def del_item(self, key : Literal["CSN"]) -> "Variation_1478":
        ...
    @overload
    def del_item(self, key : Literal["IFPSFLIGHTID"]) -> "Variation_1478":
        ...
    @overload
    def del_item(self, key : Literal["FLIGHTCAT"]) -> "Variation_1478":
        ...
    @overload
    def del_item(self, key : Literal["TOA"]) -> "Variation_1478":
        ...
    @overload
    def del_item(self, key : Literal["WTC"]) -> "Variation_1478":
        ...
    @overload
    def del_item(self, key : Literal["ADEP"]) -> "Variation_1478":
        ...
    @overload
    def del_item(self, key : Literal["ADES"]) -> "Variation_1478":
        ...
    @overload
    def del_item(self, key : Literal["RWY"]) -> "Variation_1478":
        ...
    @overload
    def del_item(self, key : Literal["CFL"]) -> "Variation_1478":
        ...
    @overload
    def del_item(self, key : Literal["CCP"]) -> "Variation_1478":
        ...
    @overload
    def del_item(self, key : Literal["TOD"]) -> "Variation_1478":
        ...
    @overload
    def del_item(self, key : Literal["AST"]) -> "Variation_1478":
        ...
    @overload
    def del_item(self, key : Literal["STS"]) -> "Variation_1478":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1478_Arg) -> 'Variation_1478':
        return cls._create(arg) # type: ignore

RuleVariation_1401_Arg: TypeAlias = Variation_1478_Arg
class RuleVariation_1401(RuleVariationContextFree):
    cv_variation = Variation_1478

    @classmethod
    def create(cls, arg : RuleVariation_1401_Arg) -> "RuleVariation_1401":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1478:
        return self.arg # type: ignore

NonSpare_487_Arg: TypeAlias = RuleVariation_1401_Arg
class NonSpare_487(NonSpare):
    cv_name = "390"
    cv_title = "Flight Plan Related Data"
    cv_rule = RuleVariation_1401

    @classmethod
    def create(cls, arg : NonSpare_487_Arg) -> "NonSpare_487":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1401:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1478:
        return self.rule.variation

class UapItem_487(UapItem):
    cv_non_spare = NonSpare_487

Content_214_Arg: TypeAlias = int
class Content_214(ContentTable):
    cv_values = {0: "Flyco (follow me)", 1: "ATC equipment maintenance", 2: "Airport maintenance", 3: "Fire", 4: "Bird scarer", 5: "Snow plough", 6: "Runway sweeper", 7: "Emergency", 8: "Police", 9: "Bus", 10: "Tug (push/tow)", 11: "Grass cutter", 12: "Fuel", 13: "Baggage", 14: "Catering", 15: "Aircraft maintenance", 16: "Unknown"}

RuleContent_214_Arg: TypeAlias = Content_214_Arg
class RuleContent_214(RuleContentContextFree):
    cv_content = Content_214

    @property
    def content(self) -> Content_214:
        return self._get_content() # type: ignore

Variation_166_Arg: TypeAlias = RuleContent_214_Arg
class Variation_166(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_214

    @classmethod
    def create(cls, arg : Variation_166_Arg) -> "Variation_166":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_214:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_214:
        return self.rule.content

RuleVariation_160_Arg: TypeAlias = Variation_166_Arg
class RuleVariation_160(RuleVariationContextFree):
    cv_variation = Variation_166

    @classmethod
    def create(cls, arg : RuleVariation_160_Arg) -> "RuleVariation_160":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_166:
        return self.arg # type: ignore

NonSpare_471_Arg: TypeAlias = RuleVariation_160_Arg
class NonSpare_471(NonSpare):
    cv_name = "300"
    cv_title = "Vehicle Fleet Identification"
    cv_rule = RuleVariation_160

    @classmethod
    def create(cls, arg : NonSpare_471_Arg) -> "NonSpare_471":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_160:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_166:
        return self.rule.variation

class UapItem_471(UapItem):
    cv_non_spare = NonSpare_471

NonSpare_1900_Arg: TypeAlias = RuleVariation_30_Arg
class NonSpare_1900(NonSpare):
    cv_name = "TRB"
    cv_title = "In Trouble"
    cv_rule = RuleVariation_30

    @classmethod
    def create(cls, arg : NonSpare_1900_Arg) -> "NonSpare_1900":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_30:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_30:
        return self.rule.variation

Item_1029_Arg: TypeAlias = NonSpare_1900_Arg
class Item_1029(Item):
    cv_non_spare = NonSpare_1900

    @classmethod
    def create(cls, arg : Item_1029_Arg) -> "Item_1029":
        return cls._create(arg) # type: ignore

Content_598_Arg: TypeAlias = int
class Content_598(ContentTable):
    cv_values = {1: "Towing aircraft", 2: "FOLLOW-ME operation", 3: "Runway check", 4: "Emergency operation (fire, medical...)", 5: "Work in progress (maintenance, birds scarer, sweepers...)"}

RuleContent_598_Arg: TypeAlias = Content_598_Arg
class RuleContent_598(RuleContentContextFree):
    cv_content = Content_598

    @property
    def content(self) -> Content_598:
        return self._get_content() # type: ignore

Variation_492_Arg: TypeAlias = RuleContent_598_Arg
class Variation_492(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 7
    cv_rule = RuleContent_598

    @classmethod
    def create(cls, arg : Variation_492_Arg) -> "Variation_492":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_598:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_598:
        return self.rule.content

RuleVariation_481_Arg: TypeAlias = Variation_492_Arg
class RuleVariation_481(RuleVariationContextFree):
    cv_variation = Variation_492

    @classmethod
    def create(cls, arg : RuleVariation_481_Arg) -> "RuleVariation_481":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_492:
        return self.arg # type: ignore

NonSpare_1322_Arg: TypeAlias = RuleVariation_481_Arg
class NonSpare_1322(NonSpare):
    cv_name = "MSG"
    cv_title = "Message"
    cv_rule = RuleVariation_481

    @classmethod
    def create(cls, arg : NonSpare_1322_Arg) -> "NonSpare_1322":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_481:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_492:
        return self.rule.variation

Item_592_Arg: TypeAlias = NonSpare_1322_Arg
class Item_592(Item):
    cv_non_spare = NonSpare_1322

    @classmethod
    def create(cls, arg : Item_592_Arg) -> "Item_592":
        return cls._create(arg) # type: ignore

Variation_1225_Arg_Group = Tuple[Union[RuleVariation_30_Arg, Tuple[Literal["TRB"], RuleVariation_30_Arg]], Union[RuleVariation_481_Arg, Tuple[Literal["MSG"], RuleVariation_481_Arg]]]
Variation_1225_Arg: TypeAlias = Union[int, Variation_1225_Arg_Group]
class Variation_1225(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1029, 1), (Item_592, 7)]
    cv_items_dict = {"TRB": RuleVariation_30, "MSG": RuleVariation_481}

    @overload
    @classmethod
    def spec(cls, key : Literal["TRB"]) -> RuleVariation_30:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSG"]) -> RuleVariation_481:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TRB"], Literal["MSG"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TRB"]) -> RuleVariation_30:
        ...
    @overload
    def get_item(self, key : Literal["MSG"]) -> RuleVariation_481:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1225_Arg) -> 'Variation_1225':
        return cls._create(arg) # type: ignore

RuleVariation_1164_Arg: TypeAlias = Variation_1225_Arg
class RuleVariation_1164(RuleVariationContextFree):
    cv_variation = Variation_1225

    @classmethod
    def create(cls, arg : RuleVariation_1164_Arg) -> "RuleVariation_1164":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1225:
        return self.arg # type: ignore

NonSpare_475_Arg: TypeAlias = RuleVariation_1164_Arg
class NonSpare_475(NonSpare):
    cv_name = "310"
    cv_title = "Pre-programmed Message"
    cv_rule = RuleVariation_1164

    @classmethod
    def create(cls, arg : NonSpare_475_Arg) -> "NonSpare_475":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1164:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1225:
        return self.rule.variation

class UapItem_475(UapItem):
    cv_non_spare = NonSpare_475

NonSpare_2080_Arg: TypeAlias = RuleVariation_223_Arg
class NonSpare_2080(NonSpare):
    cv_name = "X"
    cv_title = "Estimated Accuracy of the Calculated Position of X Component"
    cv_rule = RuleVariation_223

    @classmethod
    def create(cls, arg : NonSpare_2080_Arg) -> "NonSpare_2080":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_223:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_230:
        return self.rule.variation

Item_1187_Arg: TypeAlias = NonSpare_2080_Arg
class Item_1187(Item):
    cv_non_spare = NonSpare_2080

    @classmethod
    def create(cls, arg : Item_1187_Arg) -> "Item_1187":
        return cls._create(arg) # type: ignore

NonSpare_2133_Arg: TypeAlias = RuleVariation_223_Arg
class NonSpare_2133(NonSpare):
    cv_name = "Y"
    cv_title = "Estimated Accuracy of the Calculated Position of Y Component"
    cv_rule = RuleVariation_223

    @classmethod
    def create(cls, arg : NonSpare_2133_Arg) -> "NonSpare_2133":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_223:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_230:
        return self.rule.variation

Item_1237_Arg: TypeAlias = NonSpare_2133_Arg
class Item_1237(Item):
    cv_non_spare = NonSpare_2133

    @classmethod
    def create(cls, arg : Item_1237_Arg) -> "Item_1237":
        return cls._create(arg) # type: ignore

Variation_1297_Arg_Group = Tuple[Union[RuleVariation_223_Arg, Tuple[Literal["X"], RuleVariation_223_Arg]], Union[RuleVariation_223_Arg, Tuple[Literal["Y"], RuleVariation_223_Arg]]]
Variation_1297_Arg: TypeAlias = Union[int, Variation_1297_Arg_Group]
class Variation_1297(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1187, 8), (Item_1237, 8)]
    cv_items_dict = {"X": RuleVariation_223, "Y": RuleVariation_223}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_223:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_223:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_223:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_223:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1297_Arg) -> 'Variation_1297':
        return cls._create(arg) # type: ignore

RuleVariation_1227_Arg: TypeAlias = Variation_1297_Arg
class RuleVariation_1227(RuleVariationContextFree):
    cv_variation = Variation_1297

    @classmethod
    def create(cls, arg : RuleVariation_1227_Arg) -> "RuleVariation_1227":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1297:
        return self.arg # type: ignore

NonSpare_611_Arg: TypeAlias = RuleVariation_1227_Arg
class NonSpare_611(NonSpare):
    cv_name = "APC"
    cv_title = "Estimated Accuracy Of Track Position (Cartesian)"
    cv_rule = RuleVariation_1227

    @classmethod
    def create(cls, arg : NonSpare_611_Arg) -> "NonSpare_611":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1297:
        return self.rule.variation

Content_699_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_699(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 8.381903171539307e-8
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_699_Arg: TypeAlias = Content_699_Arg
class RuleContent_699(RuleContentContextFree):
    cv_content = Content_699

    @property
    def content(self) -> Content_699:
        return self._get_content() # type: ignore

Variation_296_Arg: TypeAlias = RuleContent_699_Arg
class Variation_296(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_699

    @classmethod
    def create(cls, arg : Variation_296_Arg) -> "Variation_296":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_699:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_699:
        return self.rule.content

RuleVariation_289_Arg: TypeAlias = Variation_296_Arg
class RuleVariation_289(RuleVariationContextFree):
    cv_variation = Variation_296

    @classmethod
    def create(cls, arg : RuleVariation_289_Arg) -> "RuleVariation_289":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_296:
        return self.arg # type: ignore

NonSpare_1139_Arg: TypeAlias = RuleVariation_289_Arg
class NonSpare_1139(NonSpare):
    cv_name = "LAT"
    cv_title = "APW Latitude Component Accuracy"
    cv_rule = RuleVariation_289

    @classmethod
    def create(cls, arg : NonSpare_1139_Arg) -> "NonSpare_1139":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_289:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_296:
        return self.rule.variation

Item_457_Arg: TypeAlias = NonSpare_1139_Arg
class Item_457(Item):
    cv_non_spare = NonSpare_1139

    @classmethod
    def create(cls, arg : Item_457_Arg) -> "Item_457":
        return cls._create(arg) # type: ignore

NonSpare_1167_Arg: TypeAlias = RuleVariation_289_Arg
class NonSpare_1167(NonSpare):
    cv_name = "LON"
    cv_title = "APW Longitude Component Accuracy"
    cv_rule = RuleVariation_289

    @classmethod
    def create(cls, arg : NonSpare_1167_Arg) -> "NonSpare_1167":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_289:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_296:
        return self.rule.variation

Item_483_Arg: TypeAlias = NonSpare_1167_Arg
class Item_483(Item):
    cv_non_spare = NonSpare_1167

    @classmethod
    def create(cls, arg : Item_483_Arg) -> "Item_483":
        return cls._create(arg) # type: ignore

Variation_1119_Arg_Group = Tuple[Union[RuleVariation_289_Arg, Tuple[Literal["LAT"], RuleVariation_289_Arg]], Union[RuleVariation_289_Arg, Tuple[Literal["LON"], RuleVariation_289_Arg]]]
Variation_1119_Arg: TypeAlias = Union[int, Variation_1119_Arg_Group]
class Variation_1119(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_457, 16), (Item_483, 16)]
    cv_items_dict = {"LAT": RuleVariation_289, "LON": RuleVariation_289}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_289:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_289:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_289:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_289:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1119_Arg) -> 'Variation_1119':
        return cls._create(arg) # type: ignore

RuleVariation_1076_Arg: TypeAlias = Variation_1119_Arg
class RuleVariation_1076(RuleVariationContextFree):
    cv_variation = Variation_1119

    @classmethod
    def create(cls, arg : RuleVariation_1076_Arg) -> "RuleVariation_1076":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1119:
        return self.arg # type: ignore

NonSpare_616_Arg: TypeAlias = RuleVariation_1076_Arg
class NonSpare_616(NonSpare):
    cv_name = "APW"
    cv_title = "Estimated Accuracy Of Track Position (WGS84)"
    cv_rule = RuleVariation_1076

    @classmethod
    def create(cls, arg : NonSpare_616_Arg) -> "NonSpare_616":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1076:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1119:
        return self.rule.variation

Variation_263_Arg: TypeAlias = RuleContent_636_Arg
class Variation_263(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_636

    @classmethod
    def create(cls, arg : Variation_263_Arg) -> "Variation_263":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_636:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_636:
        return self.rule.content

RuleVariation_256_Arg: TypeAlias = Variation_263_Arg
class RuleVariation_256(RuleVariationContextFree):
    cv_variation = Variation_263

    @classmethod
    def create(cls, arg : RuleVariation_256_Arg) -> "RuleVariation_256":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_263:
        return self.arg # type: ignore

NonSpare_635_Arg: TypeAlias = RuleVariation_256_Arg
class NonSpare_635(NonSpare):
    cv_name = "ATH"
    cv_title = "Estimated Accuracy Of Track Height"
    cv_rule = RuleVariation_256

    @classmethod
    def create(cls, arg : NonSpare_635_Arg) -> "NonSpare_635":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_256:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_263:
        return self.rule.variation

Content_735_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
class Content_735(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.1
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_735_Arg: TypeAlias = Content_735_Arg
class RuleContent_735(RuleContentContextFree):
    cv_content = Content_735

    @property
    def content(self) -> Content_735:
        return self._get_content() # type: ignore

Variation_226_Arg: TypeAlias = RuleContent_735_Arg
class Variation_226(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_735

    @classmethod
    def create(cls, arg : Variation_226_Arg) -> "Variation_226":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_735:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_735:
        return self.rule.content

RuleVariation_219_Arg: TypeAlias = Variation_226_Arg
class RuleVariation_219(RuleVariationContextFree):
    cv_variation = Variation_226

    @classmethod
    def create(cls, arg : RuleVariation_219_Arg) -> "RuleVariation_219":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_226:
        return self.arg # type: ignore

NonSpare_2081_Arg: TypeAlias = RuleVariation_219_Arg
class NonSpare_2081(NonSpare):
    cv_name = "X"
    cv_title = "Estimated Accuracy of the Calculated Velocity of X Component"
    cv_rule = RuleVariation_219

    @classmethod
    def create(cls, arg : NonSpare_2081_Arg) -> "NonSpare_2081":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_219:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_226:
        return self.rule.variation

Item_1188_Arg: TypeAlias = NonSpare_2081_Arg
class Item_1188(Item):
    cv_non_spare = NonSpare_2081

    @classmethod
    def create(cls, arg : Item_1188_Arg) -> "Item_1188":
        return cls._create(arg) # type: ignore

NonSpare_2134_Arg: TypeAlias = RuleVariation_219_Arg
class NonSpare_2134(NonSpare):
    cv_name = "Y"
    cv_title = "Estimated Accuracy of the Calculated Velocity of Y Component"
    cv_rule = RuleVariation_219

    @classmethod
    def create(cls, arg : NonSpare_2134_Arg) -> "NonSpare_2134":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_219:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_226:
        return self.rule.variation

Item_1238_Arg: TypeAlias = NonSpare_2134_Arg
class Item_1238(Item):
    cv_non_spare = NonSpare_2134

    @classmethod
    def create(cls, arg : Item_1238_Arg) -> "Item_1238":
        return cls._create(arg) # type: ignore

Variation_1298_Arg_Group = Tuple[Union[RuleVariation_219_Arg, Tuple[Literal["X"], RuleVariation_219_Arg]], Union[RuleVariation_219_Arg, Tuple[Literal["Y"], RuleVariation_219_Arg]]]
Variation_1298_Arg: TypeAlias = Union[int, Variation_1298_Arg_Group]
class Variation_1298(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1188, 8), (Item_1238, 8)]
    cv_items_dict = {"X": RuleVariation_219, "Y": RuleVariation_219}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_219:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_219:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_219:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_219:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1298_Arg) -> 'Variation_1298':
        return cls._create(arg) # type: ignore

RuleVariation_1228_Arg: TypeAlias = Variation_1298_Arg
class RuleVariation_1228(RuleVariationContextFree):
    cv_variation = Variation_1298

    @classmethod
    def create(cls, arg : RuleVariation_1228_Arg) -> "RuleVariation_1228":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1298:
        return self.arg # type: ignore

NonSpare_642_Arg: TypeAlias = RuleVariation_1228_Arg
class NonSpare_642(NonSpare):
    cv_name = "AVC"
    cv_title = "Estimated Accuracy Of Track Velocity (Cartesian)"
    cv_rule = RuleVariation_1228

    @classmethod
    def create(cls, arg : NonSpare_642_Arg) -> "NonSpare_642":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1298:
        return self.rule.variation

Content_639_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
class Content_639(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.1
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_639_Arg: TypeAlias = Content_639_Arg
class RuleContent_639(RuleContentContextFree):
    cv_content = Content_639

    @property
    def content(self) -> Content_639:
        return self._get_content() # type: ignore

Variation_264_Arg: TypeAlias = RuleContent_639_Arg
class Variation_264(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_639

    @classmethod
    def create(cls, arg : Variation_264_Arg) -> "Variation_264":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_639:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_639:
        return self.rule.content

RuleVariation_257_Arg: TypeAlias = Variation_264_Arg
class RuleVariation_257(RuleVariationContextFree):
    cv_variation = Variation_264

    @classmethod
    def create(cls, arg : RuleVariation_257_Arg) -> "RuleVariation_257":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_264:
        return self.arg # type: ignore

NonSpare_624_Arg: TypeAlias = RuleVariation_257_Arg
class NonSpare_624(NonSpare):
    cv_name = "ARC"
    cv_title = "Estimated Accuracy Of Rate Of Climb / Descent"
    cv_rule = RuleVariation_257

    @classmethod
    def create(cls, arg : NonSpare_624_Arg) -> "NonSpare_624":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_257:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_264:
        return self.rule.variation

Content_743_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
class Content_743(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0e-2
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

RuleContent_743_Arg: TypeAlias = Content_743_Arg
class RuleContent_743(RuleContentContextFree):
    cv_content = Content_743

    @property
    def content(self) -> Content_743:
        return self._get_content() # type: ignore

Variation_228_Arg: TypeAlias = RuleContent_743_Arg
class Variation_228(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_743

    @classmethod
    def create(cls, arg : Variation_228_Arg) -> "Variation_228":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_743:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_743:
        return self.rule.content

RuleVariation_221_Arg: TypeAlias = Variation_228_Arg
class RuleVariation_221(RuleVariationContextFree):
    cv_variation = Variation_228

    @classmethod
    def create(cls, arg : RuleVariation_221_Arg) -> "RuleVariation_221":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_228:
        return self.arg # type: ignore

NonSpare_2079_Arg: TypeAlias = RuleVariation_221_Arg
class NonSpare_2079(NonSpare):
    cv_name = "X"
    cv_title = "Estimated Accuracy Of Acceleration of X Component"
    cv_rule = RuleVariation_221

    @classmethod
    def create(cls, arg : NonSpare_2079_Arg) -> "NonSpare_2079":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_221:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_228:
        return self.rule.variation

Item_1186_Arg: TypeAlias = NonSpare_2079_Arg
class Item_1186(Item):
    cv_non_spare = NonSpare_2079

    @classmethod
    def create(cls, arg : Item_1186_Arg) -> "Item_1186":
        return cls._create(arg) # type: ignore

NonSpare_2132_Arg: TypeAlias = RuleVariation_221_Arg
class NonSpare_2132(NonSpare):
    cv_name = "Y"
    cv_title = "Estimated Accuracy Of Acceleration of Y Component"
    cv_rule = RuleVariation_221

    @classmethod
    def create(cls, arg : NonSpare_2132_Arg) -> "NonSpare_2132":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_221:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_228:
        return self.rule.variation

Item_1236_Arg: TypeAlias = NonSpare_2132_Arg
class Item_1236(Item):
    cv_non_spare = NonSpare_2132

    @classmethod
    def create(cls, arg : Item_1236_Arg) -> "Item_1236":
        return cls._create(arg) # type: ignore

Variation_1296_Arg_Group = Tuple[Union[RuleVariation_221_Arg, Tuple[Literal["X"], RuleVariation_221_Arg]], Union[RuleVariation_221_Arg, Tuple[Literal["Y"], RuleVariation_221_Arg]]]
Variation_1296_Arg: TypeAlias = Union[int, Variation_1296_Arg_Group]
class Variation_1296(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1186, 8), (Item_1236, 8)]
    cv_items_dict = {"X": RuleVariation_221, "Y": RuleVariation_221}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_221:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_221:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_221:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_221:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1296_Arg) -> 'Variation_1296':
        return cls._create(arg) # type: ignore

RuleVariation_1226_Arg: TypeAlias = Variation_1296_Arg
class RuleVariation_1226(RuleVariationContextFree):
    cv_variation = Variation_1296

    @classmethod
    def create(cls, arg : RuleVariation_1226_Arg) -> "RuleVariation_1226":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1296:
        return self.arg # type: ignore

NonSpare_547_Arg: TypeAlias = RuleVariation_1226_Arg
class NonSpare_547(NonSpare):
    cv_name = "AAC"
    cv_title = "Estimated Accuracy Of Acceleration (Cartesian)"
    cv_rule = RuleVariation_1226

    @classmethod
    def create(cls, arg : NonSpare_547_Arg) -> "NonSpare_547":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1296:
        return self.rule.variation

Variation_1467_Arg = TypedDict('Variation_1467_Arg', {
    "APC": NonSpare_611_Arg,
    "APW": NonSpare_616_Arg,
    "ATH": NonSpare_635_Arg,
    "AVC": NonSpare_642_Arg,
    "ARC": NonSpare_624_Arg,
    "AAC": NonSpare_547_Arg,
}, total=False)
class Variation_1467(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_611, NonSpare_616, NonSpare_635, NonSpare_642, NonSpare_624, NonSpare_547]
    cv_items_dict = {"APC": NonSpare_611, "APW": NonSpare_616, "ATH": NonSpare_635, "AVC": NonSpare_642, "ARC": NonSpare_624, "AAC": NonSpare_547}

    @overload
    @classmethod
    def spec(cls, key : Literal["APC"]) -> NonSpare_611:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["APW"]) -> NonSpare_616:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ATH"]) -> NonSpare_635:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AVC"]) -> NonSpare_642:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> NonSpare_624:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AAC"]) -> NonSpare_547:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["APC"], Literal["APW"], Literal["ATH"], Literal["AVC"], Literal["ARC"], Literal["AAC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["APC"]) -> Optional[NonSpare_611]:
        ...
    @overload
    def get_item(self, key : Literal["APW"]) -> Optional[NonSpare_616]:
        ...
    @overload
    def get_item(self, key : Literal["ATH"]) -> Optional[NonSpare_635]:
        ...
    @overload
    def get_item(self, key : Literal["AVC"]) -> Optional[NonSpare_642]:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> Optional[NonSpare_624]:
        ...
    @overload
    def get_item(self, key : Literal["AAC"]) -> Optional[NonSpare_547]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["APC"], val : NonSpare_611_Arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["APW"], val : NonSpare_616_Arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["ATH"], val : NonSpare_635_Arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["AVC"], val : NonSpare_642_Arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["ARC"], val : NonSpare_624_Arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["AAC"], val : NonSpare_547_Arg) -> "Variation_1467":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["APC"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["APW"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["ATH"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["AVC"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["ARC"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["AAC"]) -> "Variation_1467":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1467_Arg) -> 'Variation_1467':
        return cls._create(arg) # type: ignore

RuleVariation_1390_Arg: TypeAlias = Variation_1467_Arg
class RuleVariation_1390(RuleVariationContextFree):
    cv_variation = Variation_1467

    @classmethod
    def create(cls, arg : RuleVariation_1390_Arg) -> "RuleVariation_1390":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1467:
        return self.arg # type: ignore

NonSpare_511_Arg: TypeAlias = RuleVariation_1390_Arg
class NonSpare_511(NonSpare):
    cv_name = "500"
    cv_title = "Estimated Accuracies"
    cv_rule = RuleVariation_1390

    @classmethod
    def create(cls, arg : NonSpare_511_Arg) -> "NonSpare_511":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1390:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1467:
        return self.rule.variation

class UapItem_510(UapItem):
    cv_non_spare = NonSpare_511

Content_31_Arg: TypeAlias = int
class Content_31(ContentTable):
    cv_values = {0: "Alert acknowledged", 1: "Alert not acknowledged"}

RuleContent_31_Arg: TypeAlias = Content_31_Arg
class RuleContent_31(RuleContentContextFree):
    cv_content = Content_31

    @property
    def content(self) -> Content_31:
        return self._get_content() # type: ignore

Variation_11_Arg: TypeAlias = RuleContent_31_Arg
class Variation_11(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_31

    @classmethod
    def create(cls, arg : Variation_11_Arg) -> "Variation_11":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_31:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_31:
        return self.rule.content

RuleVariation_11_Arg: TypeAlias = Variation_11_Arg
class RuleVariation_11(RuleVariationContextFree):
    cv_variation = Variation_11

    @classmethod
    def create(cls, arg : RuleVariation_11_Arg) -> "RuleVariation_11":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_11:
        return self.arg # type: ignore

NonSpare_557_Arg: TypeAlias = RuleVariation_11_Arg
class NonSpare_557(NonSpare):
    cv_name = "ACK"
    cv_title = "Alert Acknowleged"
    cv_rule = RuleVariation_11

    @classmethod
    def create(cls, arg : NonSpare_557_Arg) -> "NonSpare_557":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_11:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_11:
        return self.rule.variation

Item_42_Arg: TypeAlias = NonSpare_557_Arg
class Item_42(Item):
    cv_non_spare = NonSpare_557

    @classmethod
    def create(cls, arg : Item_42_Arg) -> "Item_42":
        return cls._create(arg) # type: ignore

Content_206_Arg: TypeAlias = int
class Content_206(ContentTable):
    cv_values = {0: "End fo alert", 1: "Pre-alarm", 2: "Severe alert"}

RuleContent_206_Arg: TypeAlias = Content_206_Arg
class RuleContent_206(RuleContentContextFree):
    cv_content = Content_206

    @property
    def content(self) -> Content_206:
        return self._get_content() # type: ignore

Variation_466_Arg: TypeAlias = RuleContent_206_Arg
class Variation_466(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_206

    @classmethod
    def create(cls, arg : Variation_466_Arg) -> "Variation_466":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_206:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_206:
        return self.rule.content

RuleVariation_455_Arg: TypeAlias = Variation_466_Arg
class RuleVariation_455(RuleVariationContextFree):
    cv_variation = Variation_466

    @classmethod
    def create(cls, arg : RuleVariation_455_Arg) -> "RuleVariation_455":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_466:
        return self.arg # type: ignore

NonSpare_1806_Arg: TypeAlias = RuleVariation_455_Arg
class NonSpare_1806(NonSpare):
    cv_name = "SVR"
    cv_title = "Alert Severity"
    cv_rule = RuleVariation_455

    @classmethod
    def create(cls, arg : NonSpare_1806_Arg) -> "NonSpare_1806":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_455:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_466:
        return self.rule.variation

Item_964_Arg: TypeAlias = NonSpare_1806_Arg
class Item_964(Item):
    cv_non_spare = NonSpare_1806

    @classmethod
    def create(cls, arg : Item_964_Arg) -> "Item_964":
        return cls._create(arg) # type: ignore

NonSpare_634_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_634(NonSpare):
    cv_name = "AT"
    cv_title = "Alert Type"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_634_Arg) -> "NonSpare_634":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_87_Arg: TypeAlias = NonSpare_634_Arg
class Item_87(Item):
    cv_non_spare = NonSpare_634

    @classmethod
    def create(cls, arg : Item_87_Arg) -> "Item_87":
        return cls._create(arg) # type: ignore

NonSpare_604_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_604(NonSpare):
    cv_name = "AN"
    cv_title = "Alert Number"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_604_Arg) -> "NonSpare_604":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_73_Arg: TypeAlias = NonSpare_604_Arg
class Item_73(Item):
    cv_non_spare = NonSpare_604

    @classmethod
    def create(cls, arg : Item_73_Arg) -> "Item_73":
        return cls._create(arg) # type: ignore

Variation_1044_Arg_Group = Tuple[Union[RuleVariation_11_Arg, Tuple[Literal["ACK"], RuleVariation_11_Arg]], Union[RuleVariation_455_Arg, Tuple[Literal["SVR"], RuleVariation_455_Arg]], int, Union[RuleVariation_158_Arg, Tuple[Literal["AT"], RuleVariation_158_Arg]], Union[RuleVariation_158_Arg, Tuple[Literal["AN"], RuleVariation_158_Arg]]]
Variation_1044_Arg: TypeAlias = Union[int, Variation_1044_Arg_Group]
class Variation_1044(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_42, 1), (Item_964, 2), (Item_19, 5), (Item_87, 8), (Item_73, 8)]
    cv_items_dict = {"ACK": RuleVariation_11, "SVR": RuleVariation_455, "AT": RuleVariation_158, "AN": RuleVariation_158}

    @overload
    @classmethod
    def spec(cls, key : Literal["ACK"]) -> RuleVariation_11:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SVR"]) -> RuleVariation_455:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AT"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AN"]) -> RuleVariation_158:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ACK"], Literal["SVR"], Literal["AT"], Literal["AN"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ACK"]) -> RuleVariation_11:
        ...
    @overload
    def get_item(self, key : Literal["SVR"]) -> RuleVariation_455:
        ...
    @overload
    def get_item(self, key : Literal["AT"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["AN"]) -> RuleVariation_158:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1044_Arg) -> 'Variation_1044':
        return cls._create(arg) # type: ignore

RuleVariation_1011_Arg: TypeAlias = Variation_1044_Arg
class RuleVariation_1011(RuleVariationContextFree):
    cv_variation = Variation_1044

    @classmethod
    def create(cls, arg : RuleVariation_1011_Arg) -> "RuleVariation_1011":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1044:
        return self.arg # type: ignore

NonSpare_523_Arg: TypeAlias = RuleVariation_1011_Arg
class NonSpare_523(NonSpare):
    cv_name = "600"
    cv_title = "Alert Messages"
    cv_rule = RuleVariation_1011

    @classmethod
    def create(cls, arg : NonSpare_523_Arg) -> "NonSpare_523":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1011:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1044:
        return self.rule.variation

class UapItem_522(UapItem):
    cv_non_spare = NonSpare_523

NonSpare_999_Arg: TypeAlias = RuleVariation_775_Arg
class NonSpare_999(NonSpare):
    cv_name = "FTN"
    cv_title = "Fusion Track Number"
    cv_rule = RuleVariation_775

    @classmethod
    def create(cls, arg : NonSpare_999_Arg) -> "NonSpare_999":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_775:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_805:
        return self.rule.variation

Item_351_Arg: TypeAlias = NonSpare_999_Arg
class Item_351(Item):
    cv_non_spare = NonSpare_999

    @classmethod
    def create(cls, arg : Item_351_Arg) -> "Item_351":
        return cls._create(arg) # type: ignore

Variation_1019_Arg_Group = Tuple[int, Union[RuleVariation_775_Arg, Tuple[Literal["FTN"], RuleVariation_775_Arg]]]
Variation_1019_Arg: TypeAlias = Union[int, Variation_1019_Arg_Group]
class Variation_1019(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_351, 12)]
    cv_items_dict = {"FTN": RuleVariation_775}

    @classmethod
    def spec(cls, key : Literal["FTN"]) -> RuleVariation_775:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["FTN"]) -> RuleVariation_775:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1019_Arg) -> 'Variation_1019':
        return cls._create(arg) # type: ignore

Variation_1399_Arg: TypeAlias = List[Variation_1019_Arg]
class Variation_1399(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1019

    @classmethod
    def create(cls, arg : Variation_1399_Arg) -> 'Variation_1399':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1019]:
        return self._get_list() # type: ignore

RuleVariation_1322_Arg: TypeAlias = Variation_1399_Arg
class RuleVariation_1322(RuleVariationContextFree):
    cv_variation = Variation_1399

    @classmethod
    def create(cls, arg : RuleVariation_1322_Arg) -> "RuleVariation_1322":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1399:
        return self.arg # type: ignore

NonSpare_531_Arg: TypeAlias = RuleVariation_1322_Arg
class NonSpare_531(NonSpare):
    cv_name = "605"
    cv_title = "Tracks in Alert"
    cv_rule = RuleVariation_1322

    @classmethod
    def create(cls, arg : NonSpare_531_Arg) -> "NonSpare_531":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1322:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1399:
        return self.rule.variation

class UapItem_530(UapItem):
    cv_non_spare = NonSpare_531

NonSpare_683_Arg: TypeAlias = RuleVariation_131_Arg
class NonSpare_683(NonSpare):
    cv_name = "BKN"
    cv_title = "Bank Number"
    cv_rule = RuleVariation_131

    @classmethod
    def create(cls, arg : NonSpare_683_Arg) -> "NonSpare_683":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_131:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_131:
        return self.rule.variation

Item_127_Arg: TypeAlias = NonSpare_683_Arg
class Item_127(Item):
    cv_non_spare = NonSpare_683

    @classmethod
    def create(cls, arg : Item_127_Arg) -> "Item_127":
        return cls._create(arg) # type: ignore

Content_242_Arg: TypeAlias = int
class Content_242(ContentTable):
    cv_values = {0: "Indicator on", 1: "Indicator off"}

RuleContent_242_Arg: TypeAlias = Content_242_Arg
class RuleContent_242(RuleContentContextFree):
    cv_content = Content_242

    @property
    def content(self) -> Content_242:
        return self._get_content() # type: ignore

Variation_726_Arg: TypeAlias = RuleContent_242_Arg
class Variation_726(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_242

    @classmethod
    def create(cls, arg : Variation_726_Arg) -> "Variation_726":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_242:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_242:
        return self.rule.content

RuleVariation_715_Arg: TypeAlias = Variation_726_Arg
class RuleVariation_715(RuleVariationContextFree):
    cv_variation = Variation_726

    @classmethod
    def create(cls, arg : RuleVariation_715_Arg) -> "RuleVariation_715":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_726:
        return self.arg # type: ignore

NonSpare_1080_Arg: TypeAlias = RuleVariation_715_Arg
class NonSpare_1080(NonSpare):
    cv_name = "I1"
    cv_title = "Indicator 1"
    cv_rule = RuleVariation_715

    @classmethod
    def create(cls, arg : NonSpare_1080_Arg) -> "NonSpare_1080":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_715:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_726:
        return self.rule.variation

Item_408_Arg: TypeAlias = NonSpare_1080_Arg
class Item_408(Item):
    cv_non_spare = NonSpare_1080

    @classmethod
    def create(cls, arg : Item_408_Arg) -> "Item_408":
        return cls._create(arg) # type: ignore

Variation_854_Arg: TypeAlias = RuleContent_242_Arg
class Variation_854(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_242

    @classmethod
    def create(cls, arg : Variation_854_Arg) -> "Variation_854":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_242:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_242:
        return self.rule.content

RuleVariation_824_Arg: TypeAlias = Variation_854_Arg
class RuleVariation_824(RuleVariationContextFree):
    cv_variation = Variation_854

    @classmethod
    def create(cls, arg : RuleVariation_824_Arg) -> "RuleVariation_824":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_854:
        return self.arg # type: ignore

NonSpare_1084_Arg: TypeAlias = RuleVariation_824_Arg
class NonSpare_1084(NonSpare):
    cv_name = "I2"
    cv_title = "Indicator 2"
    cv_rule = RuleVariation_824

    @classmethod
    def create(cls, arg : NonSpare_1084_Arg) -> "NonSpare_1084":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_824:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_854:
        return self.rule.variation

Item_412_Arg: TypeAlias = NonSpare_1084_Arg
class Item_412(Item):
    cv_non_spare = NonSpare_1084

    @classmethod
    def create(cls, arg : Item_412_Arg) -> "Item_412":
        return cls._create(arg) # type: ignore

Variation_932_Arg: TypeAlias = RuleContent_242_Arg
class Variation_932(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_242

    @classmethod
    def create(cls, arg : Variation_932_Arg) -> "Variation_932":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_242:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_242:
        return self.rule.content

RuleVariation_902_Arg: TypeAlias = Variation_932_Arg
class RuleVariation_902(RuleVariationContextFree):
    cv_variation = Variation_932

    @classmethod
    def create(cls, arg : RuleVariation_902_Arg) -> "RuleVariation_902":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_932:
        return self.arg # type: ignore

NonSpare_1085_Arg: TypeAlias = RuleVariation_902_Arg
class NonSpare_1085(NonSpare):
    cv_name = "I3"
    cv_title = "Indicator 3"
    cv_rule = RuleVariation_902

    @classmethod
    def create(cls, arg : NonSpare_1085_Arg) -> "NonSpare_1085":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_902:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_932:
        return self.rule.variation

Item_413_Arg: TypeAlias = NonSpare_1085_Arg
class Item_413(Item):
    cv_non_spare = NonSpare_1085

    @classmethod
    def create(cls, arg : Item_413_Arg) -> "Item_413":
        return cls._create(arg) # type: ignore

Variation_978_Arg: TypeAlias = RuleContent_242_Arg
class Variation_978(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_242

    @classmethod
    def create(cls, arg : Variation_978_Arg) -> "Variation_978":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_242:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_242:
        return self.rule.content

RuleVariation_948_Arg: TypeAlias = Variation_978_Arg
class RuleVariation_948(RuleVariationContextFree):
    cv_variation = Variation_978

    @classmethod
    def create(cls, arg : RuleVariation_948_Arg) -> "RuleVariation_948":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_978:
        return self.arg # type: ignore

NonSpare_1086_Arg: TypeAlias = RuleVariation_948_Arg
class NonSpare_1086(NonSpare):
    cv_name = "I4"
    cv_title = "Indicator 4"
    cv_rule = RuleVariation_948

    @classmethod
    def create(cls, arg : NonSpare_1086_Arg) -> "NonSpare_1086":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_948:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_978:
        return self.rule.variation

Item_414_Arg: TypeAlias = NonSpare_1086_Arg
class Item_414(Item):
    cv_non_spare = NonSpare_1086

    @classmethod
    def create(cls, arg : Item_414_Arg) -> "Item_414":
        return cls._create(arg) # type: ignore

Variation_49_Arg: TypeAlias = RuleContent_242_Arg
class Variation_49(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_242

    @classmethod
    def create(cls, arg : Variation_49_Arg) -> "Variation_49":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_242:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_242:
        return self.rule.content

RuleVariation_49_Arg: TypeAlias = Variation_49_Arg
class RuleVariation_49(RuleVariationContextFree):
    cv_variation = Variation_49

    @classmethod
    def create(cls, arg : RuleVariation_49_Arg) -> "RuleVariation_49":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_49:
        return self.arg # type: ignore

NonSpare_1087_Arg: TypeAlias = RuleVariation_49_Arg
class NonSpare_1087(NonSpare):
    cv_name = "I5"
    cv_title = "Indicator 5"
    cv_rule = RuleVariation_49

    @classmethod
    def create(cls, arg : NonSpare_1087_Arg) -> "NonSpare_1087":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_49:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_49:
        return self.rule.variation

Item_415_Arg: TypeAlias = NonSpare_1087_Arg
class Item_415(Item):
    cv_non_spare = NonSpare_1087

    @classmethod
    def create(cls, arg : Item_415_Arg) -> "Item_415":
        return cls._create(arg) # type: ignore

Variation_431_Arg: TypeAlias = RuleContent_242_Arg
class Variation_431(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_242

    @classmethod
    def create(cls, arg : Variation_431_Arg) -> "Variation_431":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_242:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_242:
        return self.rule.content

RuleVariation_420_Arg: TypeAlias = Variation_431_Arg
class RuleVariation_420(RuleVariationContextFree):
    cv_variation = Variation_431

    @classmethod
    def create(cls, arg : RuleVariation_420_Arg) -> "RuleVariation_420":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_431:
        return self.arg # type: ignore

NonSpare_1088_Arg: TypeAlias = RuleVariation_420_Arg
class NonSpare_1088(NonSpare):
    cv_name = "I6"
    cv_title = "Indicator 6"
    cv_rule = RuleVariation_420

    @classmethod
    def create(cls, arg : NonSpare_1088_Arg) -> "NonSpare_1088":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_420:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_431:
        return self.rule.variation

Item_416_Arg: TypeAlias = NonSpare_1088_Arg
class Item_416(Item):
    cv_non_spare = NonSpare_1088

    @classmethod
    def create(cls, arg : Item_416_Arg) -> "Item_416":
        return cls._create(arg) # type: ignore

Variation_537_Arg: TypeAlias = RuleContent_242_Arg
class Variation_537(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_242

    @classmethod
    def create(cls, arg : Variation_537_Arg) -> "Variation_537":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_242:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_242:
        return self.rule.content

RuleVariation_526_Arg: TypeAlias = Variation_537_Arg
class RuleVariation_526(RuleVariationContextFree):
    cv_variation = Variation_537

    @classmethod
    def create(cls, arg : RuleVariation_526_Arg) -> "RuleVariation_526":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_537:
        return self.arg # type: ignore

NonSpare_1089_Arg: TypeAlias = RuleVariation_526_Arg
class NonSpare_1089(NonSpare):
    cv_name = "I7"
    cv_title = "Indicator 7"
    cv_rule = RuleVariation_526

    @classmethod
    def create(cls, arg : NonSpare_1089_Arg) -> "NonSpare_1089":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_526:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_537:
        return self.rule.variation

Item_417_Arg: TypeAlias = NonSpare_1089_Arg
class Item_417(Item):
    cv_non_spare = NonSpare_1089

    @classmethod
    def create(cls, arg : Item_417_Arg) -> "Item_417":
        return cls._create(arg) # type: ignore

Variation_642_Arg: TypeAlias = RuleContent_242_Arg
class Variation_642(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_242

    @classmethod
    def create(cls, arg : Variation_642_Arg) -> "Variation_642":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_242:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_242:
        return self.rule.content

RuleVariation_631_Arg: TypeAlias = Variation_642_Arg
class RuleVariation_631(RuleVariationContextFree):
    cv_variation = Variation_642

    @classmethod
    def create(cls, arg : RuleVariation_631_Arg) -> "RuleVariation_631":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_642:
        return self.arg # type: ignore

NonSpare_1090_Arg: TypeAlias = RuleVariation_631_Arg
class NonSpare_1090(NonSpare):
    cv_name = "I8"
    cv_title = "Indicator 8"
    cv_rule = RuleVariation_631

    @classmethod
    def create(cls, arg : NonSpare_1090_Arg) -> "NonSpare_1090":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_631:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_642:
        return self.rule.variation

Item_418_Arg: TypeAlias = NonSpare_1090_Arg
class Item_418(Item):
    cv_non_spare = NonSpare_1090

    @classmethod
    def create(cls, arg : Item_418_Arg) -> "Item_418":
        return cls._create(arg) # type: ignore

NonSpare_1091_Arg: TypeAlias = RuleVariation_715_Arg
class NonSpare_1091(NonSpare):
    cv_name = "I9"
    cv_title = "Indicator 9"
    cv_rule = RuleVariation_715

    @classmethod
    def create(cls, arg : NonSpare_1091_Arg) -> "NonSpare_1091":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_715:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_726:
        return self.rule.variation

Item_419_Arg: TypeAlias = NonSpare_1091_Arg
class Item_419(Item):
    cv_non_spare = NonSpare_1091

    @classmethod
    def create(cls, arg : Item_419_Arg) -> "Item_419":
        return cls._create(arg) # type: ignore

NonSpare_1081_Arg: TypeAlias = RuleVariation_824_Arg
class NonSpare_1081(NonSpare):
    cv_name = "I10"
    cv_title = "Indicator 10"
    cv_rule = RuleVariation_824

    @classmethod
    def create(cls, arg : NonSpare_1081_Arg) -> "NonSpare_1081":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_824:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_854:
        return self.rule.variation

Item_409_Arg: TypeAlias = NonSpare_1081_Arg
class Item_409(Item):
    cv_non_spare = NonSpare_1081

    @classmethod
    def create(cls, arg : Item_409_Arg) -> "Item_409":
        return cls._create(arg) # type: ignore

NonSpare_1082_Arg: TypeAlias = RuleVariation_902_Arg
class NonSpare_1082(NonSpare):
    cv_name = "I11"
    cv_title = "Indicator 11"
    cv_rule = RuleVariation_902

    @classmethod
    def create(cls, arg : NonSpare_1082_Arg) -> "NonSpare_1082":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_902:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_932:
        return self.rule.variation

Item_410_Arg: TypeAlias = NonSpare_1082_Arg
class Item_410(Item):
    cv_non_spare = NonSpare_1082

    @classmethod
    def create(cls, arg : Item_410_Arg) -> "Item_410":
        return cls._create(arg) # type: ignore

NonSpare_1083_Arg: TypeAlias = RuleVariation_948_Arg
class NonSpare_1083(NonSpare):
    cv_name = "I12"
    cv_title = "Indicator 12"
    cv_rule = RuleVariation_948

    @classmethod
    def create(cls, arg : NonSpare_1083_Arg) -> "NonSpare_1083":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_948:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_978:
        return self.rule.variation

Item_411_Arg: TypeAlias = NonSpare_1083_Arg
class Item_411(Item):
    cv_non_spare = NonSpare_1083

    @classmethod
    def create(cls, arg : Item_411_Arg) -> "Item_411":
        return cls._create(arg) # type: ignore

Variation_1057_Arg_Group = Tuple[Union[RuleVariation_131_Arg, Tuple[Literal["BKN"], RuleVariation_131_Arg]], Union[RuleVariation_715_Arg, Tuple[Literal["I1"], RuleVariation_715_Arg]], Union[RuleVariation_824_Arg, Tuple[Literal["I2"], RuleVariation_824_Arg]], Union[RuleVariation_902_Arg, Tuple[Literal["I3"], RuleVariation_902_Arg]], Union[RuleVariation_948_Arg, Tuple[Literal["I4"], RuleVariation_948_Arg]], Union[RuleVariation_49_Arg, Tuple[Literal["I5"], RuleVariation_49_Arg]], Union[RuleVariation_420_Arg, Tuple[Literal["I6"], RuleVariation_420_Arg]], Union[RuleVariation_526_Arg, Tuple[Literal["I7"], RuleVariation_526_Arg]], Union[RuleVariation_631_Arg, Tuple[Literal["I8"], RuleVariation_631_Arg]], Union[RuleVariation_715_Arg, Tuple[Literal["I9"], RuleVariation_715_Arg]], Union[RuleVariation_824_Arg, Tuple[Literal["I10"], RuleVariation_824_Arg]], Union[RuleVariation_902_Arg, Tuple[Literal["I11"], RuleVariation_902_Arg]], Union[RuleVariation_948_Arg, Tuple[Literal["I12"], RuleVariation_948_Arg]]]
Variation_1057_Arg: TypeAlias = Union[int, Variation_1057_Arg_Group]
class Variation_1057(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_127, 4), (Item_408, 1), (Item_412, 1), (Item_413, 1), (Item_414, 1), (Item_415, 1), (Item_416, 1), (Item_417, 1), (Item_418, 1), (Item_419, 1), (Item_409, 1), (Item_410, 1), (Item_411, 1)]
    cv_items_dict = {"BKN": RuleVariation_131, "I1": RuleVariation_715, "I2": RuleVariation_824, "I3": RuleVariation_902, "I4": RuleVariation_948, "I5": RuleVariation_49, "I6": RuleVariation_420, "I7": RuleVariation_526, "I8": RuleVariation_631, "I9": RuleVariation_715, "I10": RuleVariation_824, "I11": RuleVariation_902, "I12": RuleVariation_948}

    @overload
    @classmethod
    def spec(cls, key : Literal["BKN"]) -> RuleVariation_131:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I1"]) -> RuleVariation_715:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I2"]) -> RuleVariation_824:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I3"]) -> RuleVariation_902:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I4"]) -> RuleVariation_948:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I5"]) -> RuleVariation_49:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I6"]) -> RuleVariation_420:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I7"]) -> RuleVariation_526:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I8"]) -> RuleVariation_631:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I9"]) -> RuleVariation_715:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I10"]) -> RuleVariation_824:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I11"]) -> RuleVariation_902:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I12"]) -> RuleVariation_948:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["BKN"], Literal["I1"], Literal["I2"], Literal["I3"], Literal["I4"], Literal["I5"], Literal["I6"], Literal["I7"], Literal["I8"], Literal["I9"], Literal["I10"], Literal["I11"], Literal["I12"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["BKN"]) -> RuleVariation_131:
        ...
    @overload
    def get_item(self, key : Literal["I1"]) -> RuleVariation_715:
        ...
    @overload
    def get_item(self, key : Literal["I2"]) -> RuleVariation_824:
        ...
    @overload
    def get_item(self, key : Literal["I3"]) -> RuleVariation_902:
        ...
    @overload
    def get_item(self, key : Literal["I4"]) -> RuleVariation_948:
        ...
    @overload
    def get_item(self, key : Literal["I5"]) -> RuleVariation_49:
        ...
    @overload
    def get_item(self, key : Literal["I6"]) -> RuleVariation_420:
        ...
    @overload
    def get_item(self, key : Literal["I7"]) -> RuleVariation_526:
        ...
    @overload
    def get_item(self, key : Literal["I8"]) -> RuleVariation_631:
        ...
    @overload
    def get_item(self, key : Literal["I9"]) -> RuleVariation_715:
        ...
    @overload
    def get_item(self, key : Literal["I10"]) -> RuleVariation_824:
        ...
    @overload
    def get_item(self, key : Literal["I11"]) -> RuleVariation_902:
        ...
    @overload
    def get_item(self, key : Literal["I12"]) -> RuleVariation_948:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1057_Arg) -> 'Variation_1057':
        return cls._create(arg) # type: ignore

Variation_1404_Arg: TypeAlias = List[Variation_1057_Arg]
class Variation_1404(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1057

    @classmethod
    def create(cls, arg : Variation_1404_Arg) -> 'Variation_1404':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1057]:
        return self._get_list() # type: ignore

RuleVariation_1327_Arg: TypeAlias = Variation_1404_Arg
class RuleVariation_1327(RuleVariationContextFree):
    cv_variation = Variation_1404

    @classmethod
    def create(cls, arg : RuleVariation_1327_Arg) -> "RuleVariation_1327":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1404:
        return self.arg # type: ignore

NonSpare_535_Arg: TypeAlias = RuleVariation_1327_Arg
class NonSpare_535(NonSpare):
    cv_name = "610"
    cv_title = "Holdbar Status"
    cv_rule = RuleVariation_1327

    @classmethod
    def create(cls, arg : NonSpare_535_Arg) -> "NonSpare_535":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1327:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1404:
        return self.rule.variation

class UapItem_534(UapItem):
    cv_non_spare = NonSpare_535

Record_47_Arg = TypedDict('Record_47_Arg', {
    "010": NonSpare_47_Arg,
    "000": NonSpare_13_Arg,
    "015": NonSpare_61_Arg,
    "140": NonSpare_331_Arg,
    "041": NonSpare_154_Arg,
    "042": NonSpare_156_Arg,
    "202": NonSpare_401_Arg,
    "210": NonSpare_403_Arg,
    "060": NonSpare_188_Arg,
    "245": NonSpare_437_Arg,
    "380": NonSpare_484_Arg,
    "161": NonSpare_356_Arg,
    "170": NonSpare_374_Arg,
    "290": NonSpare_463_Arg,
    "430": NonSpare_501_Arg,
    "090": NonSpare_248_Arg,
    "093": NonSpare_261_Arg,
    "092": NonSpare_258_Arg,
    "215": NonSpare_413_Arg,
    "270": NonSpare_459_Arg,
    "390": NonSpare_487_Arg,
    "300": NonSpare_471_Arg,
    "310": NonSpare_475_Arg,
    "500": NonSpare_511_Arg,
    "600": NonSpare_523_Arg,
    "605": NonSpare_531_Arg,
    "610": NonSpare_535_Arg,
    "SP": NonSpare_1723_Arg,
    "RE": NonSpare_1558_Arg,
}, total=False)
class Record_47(Record):
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_47, UapItem_13, UapItem_61, UapItem_331, UapItem_154, UapItem_156, UapItem_401, UapItem_403, UapItem_188, UapItem_437, UapItem_484, UapItem_356, UapItem_374, UapItem_463, UapItem_500, UapItem_248, UapItem_261, UapItem_258, UapItem_413, UapItem_459, UapItem_487, UapItem_471, UapItem_475, UapItem_510, UapItem_522, UapItem_530, UapItem_534, UapItem_543, UapItem_542]
    cv_items_dict = {"010": NonSpare_47, "000": NonSpare_13, "015": NonSpare_61, "140": NonSpare_331, "041": NonSpare_154, "042": NonSpare_156, "202": NonSpare_401, "210": NonSpare_403, "060": NonSpare_188, "245": NonSpare_437, "380": NonSpare_484, "161": NonSpare_356, "170": NonSpare_374, "290": NonSpare_463, "430": NonSpare_501, "090": NonSpare_248, "093": NonSpare_261, "092": NonSpare_258, "215": NonSpare_413, "270": NonSpare_459, "390": NonSpare_487, "300": NonSpare_471, "310": NonSpare_475, "500": NonSpare_511, "600": NonSpare_523, "605": NonSpare_531, "610": NonSpare_535, "SP": NonSpare_1723, "RE": NonSpare_1558}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_47:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_13:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_61:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_331:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_154:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_156:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["202"]) -> NonSpare_401:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_403:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_188:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_437:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["380"]) -> NonSpare_484:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_356:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_374:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["290"]) -> NonSpare_463:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["430"]) -> NonSpare_501:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_248:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["093"]) -> NonSpare_261:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["092"]) -> NonSpare_258:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["215"]) -> NonSpare_413:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["270"]) -> NonSpare_459:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["390"]) -> NonSpare_487:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_471:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["310"]) -> NonSpare_475:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_511:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["600"]) -> NonSpare_523:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["605"]) -> NonSpare_531:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["610"]) -> NonSpare_535:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["015"], Literal["140"], Literal["041"], Literal["042"], Literal["202"], Literal["210"], Literal["060"], Literal["245"], Literal["380"], Literal["161"], Literal["170"], Literal["290"], Literal["430"], Literal["090"], Literal["093"], Literal["092"], Literal["215"], Literal["270"], Literal["390"], Literal["300"], Literal["310"], Literal["500"], Literal["600"], Literal["605"], Literal["610"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_47]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_13]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_61]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_331]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_154]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_156]:
        ...
    @overload
    def get_item(self, key : Literal["202"]) -> Optional[NonSpare_401]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_403]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_188]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_437]:
        ...
    @overload
    def get_item(self, key : Literal["380"]) -> Optional[NonSpare_484]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_356]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_374]:
        ...
    @overload
    def get_item(self, key : Literal["290"]) -> Optional[NonSpare_463]:
        ...
    @overload
    def get_item(self, key : Literal["430"]) -> Optional[NonSpare_501]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_248]:
        ...
    @overload
    def get_item(self, key : Literal["093"]) -> Optional[NonSpare_261]:
        ...
    @overload
    def get_item(self, key : Literal["092"]) -> Optional[NonSpare_258]:
        ...
    @overload
    def get_item(self, key : Literal["215"]) -> Optional[NonSpare_413]:
        ...
    @overload
    def get_item(self, key : Literal["270"]) -> Optional[NonSpare_459]:
        ...
    @overload
    def get_item(self, key : Literal["390"]) -> Optional[NonSpare_487]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_471]:
        ...
    @overload
    def get_item(self, key : Literal["310"]) -> Optional[NonSpare_475]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_511]:
        ...
    @overload
    def get_item(self, key : Literal["600"]) -> Optional[NonSpare_523]:
        ...
    @overload
    def get_item(self, key : Literal["605"]) -> Optional[NonSpare_531]:
        ...
    @overload
    def get_item(self, key : Literal["610"]) -> Optional[NonSpare_535]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_47_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_13_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_61_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_331_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_154_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_156_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["202"], val : NonSpare_401_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_403_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_188_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_437_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["380"], val : NonSpare_484_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_356_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_374_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["290"], val : NonSpare_463_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["430"], val : NonSpare_501_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_248_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["093"], val : NonSpare_261_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["092"], val : NonSpare_258_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["215"], val : NonSpare_413_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["270"], val : NonSpare_459_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["390"], val : NonSpare_487_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_471_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["310"], val : NonSpare_475_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_511_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["600"], val : NonSpare_523_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["605"], val : NonSpare_531_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["610"], val : NonSpare_535_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_47':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["202"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["380"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["290"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["430"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["093"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["092"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["215"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["270"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["390"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["310"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["600"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["605"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["610"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_47':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_47_Arg) -> 'Record_47':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_47", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_43_Arg: TypeAlias = Record_47
class Uap_43(UapSingle):
    cv_record = Record_47

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_47]]:
        return cls._parse(bs)

class Asterix_10(AstCat):
    cv_category = 11
    cv_edition = (1, 2)
    cv_uap = Uap_43

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_43_Arg]) -> "Asterix_10":
        return cls._create(records) # type: ignore

NonSpare_330_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_330(NonSpare):
    cv_name = "140"
    cv_title = "Time of Track Information"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_330_Arg) -> "NonSpare_330":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_330(UapItem):
    cv_non_spare = NonSpare_330

NonSpare_187_Arg: TypeAlias = RuleVariation_990_Arg
class NonSpare_187(NonSpare):
    cv_name = "060"
    cv_title = "Mode-3/A Code in Octal Representation"
    cv_rule = RuleVariation_990

    @classmethod
    def create(cls, arg : NonSpare_187_Arg) -> "NonSpare_187":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_990:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1021:
        return self.rule.variation

class UapItem_187(UapItem):
    cv_non_spare = NonSpare_187

Content_319_Arg: TypeAlias = int
class Content_319(ContentTable):
    cv_values = {0: "No alert, no SPI, aircraft airborne", 1: "No alert, no SPI, aircraft on ground", 2: "Alert, no SPI, aircraft airborne", 3: "Alert, no SPI, aircraft on ground", 4: "Alert, SPI, aircraft airborne or on ground", 5: "No alert, SPI, aircraft airborne or on ground", 6: "General Emergency", 7: "Lifeguard / medical", 8: "Minimum fuel", 9: "No communications", 10: "Unlawful interference"}

RuleContent_319_Arg: TypeAlias = Content_319_Arg
class RuleContent_319(RuleContentContextFree):
    cv_content = Content_319

    @property
    def content(self) -> Content_319:
        return self._get_content() # type: ignore

Variation_690_Arg: TypeAlias = RuleContent_319_Arg
class Variation_690(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 4
    cv_rule = RuleContent_319

    @classmethod
    def create(cls, arg : Variation_690_Arg) -> "Variation_690":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_319:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_319:
        return self.rule.content

RuleVariation_679_Arg: TypeAlias = Variation_690_Arg
class RuleVariation_679(RuleVariationContextFree):
    cv_variation = Variation_690

    @classmethod
    def create(cls, arg : RuleVariation_679_Arg) -> "RuleVariation_679":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_690:
        return self.arg # type: ignore

NonSpare_1771_Arg: TypeAlias = RuleVariation_679_Arg
class NonSpare_1771(NonSpare):
    cv_name = "STAT"
    cv_title = "Flight Status"
    cv_rule = RuleVariation_679

    @classmethod
    def create(cls, arg : NonSpare_1771_Arg) -> "NonSpare_1771":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_679:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_690:
        return self.rule.variation

Item_938_Arg: TypeAlias = NonSpare_1771_Arg
class Item_938(Item):
    cv_non_spare = NonSpare_1771

    @classmethod
    def create(cls, arg : Item_938_Arg) -> "Item_938":
        return cls._create(arg) # type: ignore

Variation_1076_Arg_Group = Tuple[Union[RuleVariation_123_Arg, Tuple[Literal["COM"], RuleVariation_123_Arg]], Union[RuleVariation_679_Arg, Tuple[Literal["STAT"], RuleVariation_679_Arg]], int, Union[RuleVariation_55_Arg, Tuple[Literal["SSC"], RuleVariation_55_Arg]], Union[RuleVariation_388_Arg, Tuple[Literal["ARC"], RuleVariation_388_Arg]], Union[RuleVariation_544_Arg, Tuple[Literal["AIC"], RuleVariation_544_Arg]], Union[RuleVariation_600_Arg, Tuple[Literal["B1A"], RuleVariation_600_Arg]], Union[RuleVariation_766_Arg, Tuple[Literal["B1B"], RuleVariation_766_Arg]], Union[RuleVariation_55_Arg, Tuple[Literal["AC"], RuleVariation_55_Arg]], Union[RuleVariation_426_Arg, Tuple[Literal["MN"], RuleVariation_426_Arg]], Union[RuleVariation_571_Arg, Tuple[Literal["DC"], RuleVariation_571_Arg]], int]
Variation_1076_Arg: TypeAlias = Union[int, Variation_1076_Arg_Group]
class Variation_1076(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_187, 3), (Item_938, 4), (Item_29, 1), (Item_923, 1), (Item_81, 1), (Item_55, 1), (Item_108, 1), (Item_109, 4), (Item_37, 1), (Item_559, 1), (Item_248, 1), (Item_19, 5)]
    cv_items_dict = {"COM": RuleVariation_123, "STAT": RuleVariation_679, "SSC": RuleVariation_55, "ARC": RuleVariation_388, "AIC": RuleVariation_544, "B1A": RuleVariation_600, "B1B": RuleVariation_766, "AC": RuleVariation_55, "MN": RuleVariation_426, "DC": RuleVariation_571}

    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> RuleVariation_123:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_679:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSC"]) -> RuleVariation_55:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> RuleVariation_388:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AIC"]) -> RuleVariation_544:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1A"]) -> RuleVariation_600:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1B"]) -> RuleVariation_766:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AC"]) -> RuleVariation_55:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MN"]) -> RuleVariation_426:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DC"]) -> RuleVariation_571:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COM"], Literal["STAT"], Literal["SSC"], Literal["ARC"], Literal["AIC"], Literal["B1A"], Literal["B1B"], Literal["AC"], Literal["MN"], Literal["DC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COM"]) -> RuleVariation_123:
        ...
    @overload
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_679:
        ...
    @overload
    def get_item(self, key : Literal["SSC"]) -> RuleVariation_55:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_388:
        ...
    @overload
    def get_item(self, key : Literal["AIC"]) -> RuleVariation_544:
        ...
    @overload
    def get_item(self, key : Literal["B1A"]) -> RuleVariation_600:
        ...
    @overload
    def get_item(self, key : Literal["B1B"]) -> RuleVariation_766:
        ...
    @overload
    def get_item(self, key : Literal["AC"]) -> RuleVariation_55:
        ...
    @overload
    def get_item(self, key : Literal["MN"]) -> RuleVariation_426:
        ...
    @overload
    def get_item(self, key : Literal["DC"]) -> RuleVariation_571:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1076_Arg) -> 'Variation_1076':
        return cls._create(arg) # type: ignore

RuleVariation_1036_Arg: TypeAlias = Variation_1076_Arg
class RuleVariation_1036(RuleVariationContextFree):
    cv_variation = Variation_1076

    @classmethod
    def create(cls, arg : RuleVariation_1036_Arg) -> "RuleVariation_1036":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1076:
        return self.arg # type: ignore

NonSpare_783_Arg: TypeAlias = RuleVariation_1036_Arg
class NonSpare_783(NonSpare):
    cv_name = "COMACAS"
    cv_title = "Communications/ACAS Capability and Flight Status"
    cv_rule = RuleVariation_1036

    @classmethod
    def create(cls, arg : NonSpare_783_Arg) -> "NonSpare_783":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1036:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1076:
        return self.rule.variation

Variation_1485_Arg = TypedDict('Variation_1485_Arg', {
    "MB": NonSpare_1221_Arg,
    "ADR": NonSpare_566_Arg,
    "COMACAS": NonSpare_783_Arg,
    "ACT": NonSpare_561_Arg,
    "ECAT": NonSpare_911_Arg,
    "AVTECH": NonSpare_648_Arg,
}, total=False)
class Variation_1485(Compound):
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1221, NonSpare_566, None, NonSpare_783, None, None, None, NonSpare_561, NonSpare_911, None, NonSpare_648]
    cv_items_dict = {"MB": NonSpare_1221, "ADR": NonSpare_566, "COMACAS": NonSpare_783, "ACT": NonSpare_561, "ECAT": NonSpare_911, "AVTECH": NonSpare_648}

    @overload
    @classmethod
    def spec(cls, key : Literal["MB"]) -> NonSpare_1221:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADR"]) -> NonSpare_566:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COMACAS"]) -> NonSpare_783:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ACT"]) -> NonSpare_561:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ECAT"]) -> NonSpare_911:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AVTECH"]) -> NonSpare_648:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MB"], Literal["ADR"], Literal["COMACAS"], Literal["ACT"], Literal["ECAT"], Literal["AVTECH"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MB"]) -> Optional[NonSpare_1221]:
        ...
    @overload
    def get_item(self, key : Literal["ADR"]) -> Optional[NonSpare_566]:
        ...
    @overload
    def get_item(self, key : Literal["COMACAS"]) -> Optional[NonSpare_783]:
        ...
    @overload
    def get_item(self, key : Literal["ACT"]) -> Optional[NonSpare_561]:
        ...
    @overload
    def get_item(self, key : Literal["ECAT"]) -> Optional[NonSpare_911]:
        ...
    @overload
    def get_item(self, key : Literal["AVTECH"]) -> Optional[NonSpare_648]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["MB"], val : NonSpare_1221_Arg) -> "Variation_1485":
        ...
    @overload
    def set_item(self, key : Literal["ADR"], val : NonSpare_566_Arg) -> "Variation_1485":
        ...
    @overload
    def set_item(self, key : Literal["COMACAS"], val : NonSpare_783_Arg) -> "Variation_1485":
        ...
    @overload
    def set_item(self, key : Literal["ACT"], val : NonSpare_561_Arg) -> "Variation_1485":
        ...
    @overload
    def set_item(self, key : Literal["ECAT"], val : NonSpare_911_Arg) -> "Variation_1485":
        ...
    @overload
    def set_item(self, key : Literal["AVTECH"], val : NonSpare_648_Arg) -> "Variation_1485":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["MB"]) -> "Variation_1485":
        ...
    @overload
    def del_item(self, key : Literal["ADR"]) -> "Variation_1485":
        ...
    @overload
    def del_item(self, key : Literal["COMACAS"]) -> "Variation_1485":
        ...
    @overload
    def del_item(self, key : Literal["ACT"]) -> "Variation_1485":
        ...
    @overload
    def del_item(self, key : Literal["ECAT"]) -> "Variation_1485":
        ...
    @overload
    def del_item(self, key : Literal["AVTECH"]) -> "Variation_1485":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1485_Arg) -> 'Variation_1485':
        return cls._create(arg) # type: ignore

RuleVariation_1408_Arg: TypeAlias = Variation_1485_Arg
class RuleVariation_1408(RuleVariationContextFree):
    cv_variation = Variation_1485

    @classmethod
    def create(cls, arg : RuleVariation_1408_Arg) -> "RuleVariation_1408":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1485:
        return self.arg # type: ignore

NonSpare_485_Arg: TypeAlias = RuleVariation_1408_Arg
class NonSpare_485(NonSpare):
    cv_name = "380"
    cv_title = "Mode-S / ADS-B Related Data"
    cv_rule = RuleVariation_1408

    @classmethod
    def create(cls, arg : NonSpare_485_Arg) -> "NonSpare_485":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1408:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1485:
        return self.rule.variation

class UapItem_485(UapItem):
    cv_non_spare = NonSpare_485

Content_176_Arg: TypeAlias = int
class Content_176(ContentTable):
    cv_values = {0: "Default value", 1: "Age of the last received PSR track update is higher than system dependent threshold"}

RuleContent_176_Arg: TypeAlias = Content_176_Arg
class RuleContent_176(RuleContentContextFree):
    cv_content = Content_176

    @property
    def content(self) -> Content_176:
        return self._get_content() # type: ignore

Variation_418_Arg: TypeAlias = RuleContent_176_Arg
class Variation_418(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_176

    @classmethod
    def create(cls, arg : Variation_418_Arg) -> "Variation_418":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_176:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_176:
        return self.rule.content

RuleVariation_407_Arg: TypeAlias = Variation_418_Arg
class RuleVariation_407(RuleVariationContextFree):
    cv_variation = Variation_418

    @classmethod
    def create(cls, arg : RuleVariation_407_Arg) -> "RuleVariation_407":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_418:
        return self.arg # type: ignore

Content_177_Arg: TypeAlias = int
class Content_177(ContentTable):
    cv_values = {0: "Default value", 1: "Age of the last received SSR track update is higher than system dependent threshold"}

RuleContent_177_Arg: TypeAlias = Content_177_Arg
class RuleContent_177(RuleContentContextFree):
    cv_content = Content_177

    @property
    def content(self) -> Content_177:
        return self._get_content() # type: ignore

Variation_525_Arg: TypeAlias = RuleContent_177_Arg
class Variation_525(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_177

    @classmethod
    def create(cls, arg : Variation_525_Arg) -> "Variation_525":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_177:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_177:
        return self.rule.content

RuleVariation_514_Arg: TypeAlias = Variation_525_Arg
class RuleVariation_514(RuleVariationContextFree):
    cv_variation = Variation_525

    @classmethod
    def create(cls, arg : RuleVariation_514_Arg) -> "RuleVariation_514":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_525:
        return self.arg # type: ignore

Content_175_Arg: TypeAlias = int
class Content_175(ContentTable):
    cv_values = {0: "Default value", 1: "Age of the last received Mode S track update is higher than system dependent threshold"}

RuleContent_175_Arg: TypeAlias = Content_175_Arg
class RuleContent_175(RuleContentContextFree):
    cv_content = Content_175

    @property
    def content(self) -> Content_175:
        return self._get_content() # type: ignore

Variation_632_Arg: TypeAlias = RuleContent_175_Arg
class Variation_632(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_175

    @classmethod
    def create(cls, arg : Variation_632_Arg) -> "Variation_632":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_175:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_175:
        return self.rule.content

RuleVariation_621_Arg: TypeAlias = Variation_632_Arg
class RuleVariation_621(RuleVariationContextFree):
    cv_variation = Variation_632

    @classmethod
    def create(cls, arg : RuleVariation_621_Arg) -> "RuleVariation_621":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_632:
        return self.arg # type: ignore

Content_172_Arg: TypeAlias = int
class Content_172(ContentTable):
    cv_values = {0: "Default value", 1: "Age of the last received ADS track update is higher than system dependent threshold"}

RuleContent_172_Arg: TypeAlias = Content_172_Arg
class RuleContent_172(RuleContentContextFree):
    cv_content = Content_172

    @property
    def content(self) -> Content_172:
        return self._get_content() # type: ignore

Variation_714_Arg: TypeAlias = RuleContent_172_Arg
class Variation_714(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_172

    @classmethod
    def create(cls, arg : Variation_714_Arg) -> "Variation_714":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_172:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_172:
        return self.rule.content

RuleVariation_703_Arg: TypeAlias = Variation_714_Arg
class RuleVariation_703(RuleVariationContextFree):
    cv_variation = Variation_714

    @classmethod
    def create(cls, arg : RuleVariation_703_Arg) -> "RuleVariation_703":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_714:
        return self.arg # type: ignore

Content_191_Arg: TypeAlias = int
class Content_191(ContentTable):
    cv_values = {0: "Default value", 1: "Special Used Code (Mode A codes to be defined in the system to mark a track with special interest)"}

RuleContent_191_Arg: TypeAlias = Content_191_Arg
class RuleContent_191(RuleContentContextFree):
    cv_content = Content_191

    @property
    def content(self) -> Content_191:
        return self._get_content() # type: ignore

Variation_844_Arg: TypeAlias = RuleContent_191_Arg
class Variation_844(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_191

    @classmethod
    def create(cls, arg : Variation_844_Arg) -> "Variation_844":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_191:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_191:
        return self.rule.content

RuleVariation_814_Arg: TypeAlias = Variation_844_Arg
class RuleVariation_814(RuleVariationContextFree):
    cv_variation = Variation_844

    @classmethod
    def create(cls, arg : RuleVariation_814_Arg) -> "RuleVariation_814":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_844:
        return self.arg # type: ignore

Content_180_Arg: TypeAlias = int
class Content_180(ContentTable):
    cv_values = {0: "Default value", 1: "Assigned Mode A Code Conflict (same individual Mode A Code assigned to another track)"}

RuleContent_180_Arg: TypeAlias = Content_180_Arg
class RuleContent_180(RuleContentContextFree):
    cv_content = Content_180

    @property
    def content(self) -> Content_180:
        return self._get_content() # type: ignore

Variation_921_Arg: TypeAlias = RuleContent_180_Arg
class Variation_921(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_180

    @classmethod
    def create(cls, arg : Variation_921_Arg) -> "Variation_921":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_180:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_180:
        return self.rule.content

RuleVariation_891_Arg: TypeAlias = Variation_921_Arg
class RuleVariation_891(RuleVariationContextFree):
    cv_variation = Variation_921

    @classmethod
    def create(cls, arg : RuleVariation_891_Arg) -> "RuleVariation_891":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_921:
        return self.arg # type: ignore

NonSpare_1462_Arg: TypeAlias = RuleVariation_407_Arg
class NonSpare_1462(NonSpare):
    cv_name = "PSR"
    cv_title = ""
    cv_rule = RuleVariation_407

    @classmethod
    def create(cls, arg : NonSpare_1462_Arg) -> "NonSpare_1462":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_407:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_418:
        return self.rule.variation

Item_709_Arg: TypeAlias = NonSpare_1462_Arg
class Item_709(Item):
    cv_non_spare = NonSpare_1462

    @classmethod
    def create(cls, arg : Item_709_Arg) -> "Item_709":
        return cls._create(arg) # type: ignore

NonSpare_1749_Arg: TypeAlias = RuleVariation_514_Arg
class NonSpare_1749(NonSpare):
    cv_name = "SSR"
    cv_title = ""
    cv_rule = RuleVariation_514

    @classmethod
    def create(cls, arg : NonSpare_1749_Arg) -> "NonSpare_1749":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_514:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_525:
        return self.rule.variation

Item_925_Arg: TypeAlias = NonSpare_1749_Arg
class Item_925(Item):
    cv_non_spare = NonSpare_1749

    @classmethod
    def create(cls, arg : Item_925_Arg) -> "Item_925":
        return cls._create(arg) # type: ignore

NonSpare_1246_Arg: TypeAlias = RuleVariation_621_Arg
class NonSpare_1246(NonSpare):
    cv_name = "MDS"
    cv_title = ""
    cv_rule = RuleVariation_621

    @classmethod
    def create(cls, arg : NonSpare_1246_Arg) -> "NonSpare_1246":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_621:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_632:
        return self.rule.variation

Item_535_Arg: TypeAlias = NonSpare_1246_Arg
class Item_535(Item):
    cv_non_spare = NonSpare_1246

    @classmethod
    def create(cls, arg : Item_535_Arg) -> "Item_535":
        return cls._create(arg) # type: ignore

NonSpare_568_Arg: TypeAlias = RuleVariation_703_Arg
class NonSpare_568(NonSpare):
    cv_name = "ADS"
    cv_title = ""
    cv_rule = RuleVariation_703

    @classmethod
    def create(cls, arg : NonSpare_568_Arg) -> "NonSpare_568":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_703:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_714:
        return self.rule.variation

Item_45_Arg: TypeAlias = NonSpare_568_Arg
class Item_45(Item):
    cv_non_spare = NonSpare_568

    @classmethod
    def create(cls, arg : Item_45_Arg) -> "Item_45":
        return cls._create(arg) # type: ignore

NonSpare_1798_Arg: TypeAlias = RuleVariation_814_Arg
class NonSpare_1798(NonSpare):
    cv_name = "SUC"
    cv_title = ""
    cv_rule = RuleVariation_814

    @classmethod
    def create(cls, arg : NonSpare_1798_Arg) -> "NonSpare_1798":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_814:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_844:
        return self.rule.variation

Item_960_Arg: TypeAlias = NonSpare_1798_Arg
class Item_960(Item):
    cv_non_spare = NonSpare_1798

    @classmethod
    def create(cls, arg : Item_960_Arg) -> "Item_960":
        return cls._create(arg) # type: ignore

NonSpare_546_Arg: TypeAlias = RuleVariation_891_Arg
class NonSpare_546(NonSpare):
    cv_name = "AAC"
    cv_title = ""
    cv_rule = RuleVariation_891

    @classmethod
    def create(cls, arg : NonSpare_546_Arg) -> "NonSpare_546":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_891:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_921:
        return self.rule.variation

Item_35_Arg: TypeAlias = NonSpare_546_Arg
class Item_35(Item):
    cv_non_spare = NonSpare_546

    @classmethod
    def create(cls, arg : Item_35_Arg) -> "Item_35":
        return cls._create(arg) # type: ignore

Variation_1360_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_53_Arg, Tuple[Literal["MON"], RuleVariation_53_Arg]], Union[RuleVariation_448_Arg, Tuple[Literal["GBS"], RuleVariation_448_Arg]], Union[RuleVariation_497_Arg, Tuple[Literal["MRH"], RuleVariation_497_Arg]], Union[RuleVariation_676_Arg, Tuple[Literal["SRC"], RuleVariation_676_Arg]], Union[RuleVariation_874_Arg, Tuple[Literal["CNF"], RuleVariation_874_Arg]], None]]
Variation_1360_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_4_Arg, Tuple[Literal["SIM"], RuleVariation_4_Arg]], Union[RuleVariation_411_Arg, Tuple[Literal["TSE"], RuleVariation_411_Arg]], Union[RuleVariation_518_Arg, Tuple[Literal["TSB"], RuleVariation_518_Arg]], Union[RuleVariation_665_Arg, Tuple[Literal["FRIFOE"], RuleVariation_665_Arg]], Union[RuleVariation_812_Arg, Tuple[Literal["ME"], RuleVariation_812_Arg]], Union[RuleVariation_893_Arg, Tuple[Literal["MI"], RuleVariation_893_Arg]], None]]
Variation_1360_Arg_Group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_89_Arg, Tuple[Literal["AMA"], RuleVariation_89_Arg]], Union[RuleVariation_410_Arg, Tuple[Literal["SPI"], RuleVariation_410_Arg]], Union[RuleVariation_515_Arg, Tuple[Literal["CST"], RuleVariation_515_Arg]], Union[RuleVariation_644_Arg, Tuple[Literal["FPC"], RuleVariation_644_Arg]], Union[RuleVariation_702_Arg, Tuple[Literal["AFF"], RuleVariation_702_Arg]], int, None]]
Variation_1360_Arg_Group_4: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_407_Arg, Tuple[Literal["PSR"], RuleVariation_407_Arg]], Union[RuleVariation_514_Arg, Tuple[Literal["SSR"], RuleVariation_514_Arg]], Union[RuleVariation_621_Arg, Tuple[Literal["MDS"], RuleVariation_621_Arg]], Union[RuleVariation_703_Arg, Tuple[Literal["ADS"], RuleVariation_703_Arg]], Union[RuleVariation_814_Arg, Tuple[Literal["SUC"], RuleVariation_814_Arg]], Union[RuleVariation_891_Arg, Tuple[Literal["AAC"], RuleVariation_891_Arg]], None]]
Variation_1360_Arg: TypeAlias = Union[
    Tuple[Variation_1360_Arg_Group_1],
    Tuple[Variation_1360_Arg_Group_1, Variation_1360_Arg_Group_2],
    Tuple[Variation_1360_Arg_Group_1, Variation_1360_Arg_Group_2, Variation_1360_Arg_Group_3],
    Tuple[Variation_1360_Arg_Group_1, Variation_1360_Arg_Group_2, Variation_1360_Arg_Group_3, Variation_1360_Arg_Group_4],
]
class Variation_1360(Extended):
    cv_items_list = [[(Item_575, 1), (Item_363, 1), (Item_578, 1), (Item_918, 3), (Item_166, 1), None], [(Item_894, 1), (Item_1044, 1), (Item_1042, 1), (Item_343, 2), (Item_542, 1), (Item_549, 1), None], [(Item_71, 1), (Item_908, 1), (Item_220, 1), (Item_336, 1), (Item_50, 1), (Item_24, 2), None], [(Item_0, 1), (Item_709, 1), (Item_925, 1), (Item_535, 1), (Item_45, 1), (Item_960, 1), (Item_35, 1), None]]

    @classmethod
    def create(cls, arg : Variation_1360_Arg) -> 'Variation_1360':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MON"]) -> RuleVariation_53:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> RuleVariation_448:
        ...
    @overload
    def get_item(self, key : Literal["MRH"]) -> RuleVariation_497:
        ...
    @overload
    def get_item(self, key : Literal["SRC"]) -> RuleVariation_676:
        ...
    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_874:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_4]:
        ...
    @overload
    def get_item(self, key : Literal["TSE"]) -> Optional[RuleVariation_411]:
        ...
    @overload
    def get_item(self, key : Literal["TSB"]) -> Optional[RuleVariation_518]:
        ...
    @overload
    def get_item(self, key : Literal["FRIFOE"]) -> Optional[RuleVariation_665]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_812]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_893]:
        ...
    @overload
    def get_item(self, key : Literal["AMA"]) -> Optional[RuleVariation_89]:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> Optional[RuleVariation_410]:
        ...
    @overload
    def get_item(self, key : Literal["CST"]) -> Optional[RuleVariation_515]:
        ...
    @overload
    def get_item(self, key : Literal["FPC"]) -> Optional[RuleVariation_644]:
        ...
    @overload
    def get_item(self, key : Literal["AFF"]) -> Optional[RuleVariation_702]:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[RuleVariation_407]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[RuleVariation_514]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[RuleVariation_621]:
        ...
    @overload
    def get_item(self, key : Literal["ADS"]) -> Optional[RuleVariation_703]:
        ...
    @overload
    def get_item(self, key : Literal["SUC"]) -> Optional[RuleVariation_814]:
        ...
    @overload
    def get_item(self, key : Literal["AAC"]) -> Optional[RuleVariation_891]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1283_Arg: TypeAlias = Variation_1360_Arg
class RuleVariation_1283(RuleVariationContextFree):
    cv_variation = Variation_1360

    @classmethod
    def create(cls, arg : RuleVariation_1283_Arg) -> "RuleVariation_1283":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1360:
        return self.arg # type: ignore

NonSpare_375_Arg: TypeAlias = RuleVariation_1283_Arg
class NonSpare_375(NonSpare):
    cv_name = "170"
    cv_title = "Track Status"
    cv_rule = RuleVariation_1283

    @classmethod
    def create(cls, arg : NonSpare_375_Arg) -> "NonSpare_375":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1283:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1360:
        return self.rule.variation

class UapItem_375(UapItem):
    cv_non_spare = NonSpare_375

NonSpare_1465_Arg: TypeAlias = RuleVariation_226_Arg
class NonSpare_1465(NonSpare):
    cv_name = "PSR"
    cv_title = "Age of the Last Primary Report Used to Update the Track"
    cv_rule = RuleVariation_226

    @classmethod
    def create(cls, arg : NonSpare_1465_Arg) -> "NonSpare_1465":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

NonSpare_1752_Arg: TypeAlias = RuleVariation_226_Arg
class NonSpare_1752(NonSpare):
    cv_name = "SSR"
    cv_title = "Age of the Last Secondary Report Used to Update the Track"
    cv_rule = RuleVariation_226

    @classmethod
    def create(cls, arg : NonSpare_1752_Arg) -> "NonSpare_1752":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

NonSpare_1243_Arg: TypeAlias = RuleVariation_226_Arg
class NonSpare_1243(NonSpare):
    cv_name = "MDA"
    cv_title = "Age of the Last Valid Mode A Report Used to Update the Track"
    cv_rule = RuleVariation_226

    @classmethod
    def create(cls, arg : NonSpare_1243_Arg) -> "NonSpare_1243":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

NonSpare_1265_Arg: TypeAlias = RuleVariation_226_Arg
class NonSpare_1265(NonSpare):
    cv_name = "MFL"
    cv_title = "Age of the Last Valid and Credible Mode C Used to Update the Track"
    cv_rule = RuleVariation_226

    @classmethod
    def create(cls, arg : NonSpare_1265_Arg) -> "NonSpare_1265":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

NonSpare_1249_Arg: TypeAlias = RuleVariation_226_Arg
class NonSpare_1249(NonSpare):
    cv_name = "MDS"
    cv_title = "Age of the Last Mode S Report Used to Update the Track"
    cv_rule = RuleVariation_226

    @classmethod
    def create(cls, arg : NonSpare_1249_Arg) -> "NonSpare_1249":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

NonSpare_1234_Arg: TypeAlias = RuleVariation_226_Arg
class NonSpare_1234(NonSpare):
    cv_name = "MD2"
    cv_title = "Age of the Last Valid Mode 2 Used to Update the Track"
    cv_rule = RuleVariation_226

    @classmethod
    def create(cls, arg : NonSpare_1234_Arg) -> "NonSpare_1234":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

Variation_1491_Arg = TypedDict('Variation_1491_Arg', {
    "PSR": NonSpare_1465_Arg,
    "SSR": NonSpare_1752_Arg,
    "MDA": NonSpare_1243_Arg,
    "MFL": NonSpare_1265_Arg,
    "MDS": NonSpare_1249_Arg,
    "ADS": NonSpare_572_Arg,
    "ADB": NonSpare_562_Arg,
    "MD1": NonSpare_1231_Arg,
    "MD2": NonSpare_1234_Arg,
    "LOP": NonSpare_1185_Arg,
    "TRK": NonSpare_1908_Arg,
    "MUL": NonSpare_1327_Arg,
}, total=False)
class Variation_1491(Compound):
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1465, NonSpare_1752, NonSpare_1243, NonSpare_1265, NonSpare_1249, NonSpare_572, NonSpare_562, NonSpare_1231, NonSpare_1234, NonSpare_1185, NonSpare_1908, NonSpare_1327]
    cv_items_dict = {"PSR": NonSpare_1465, "SSR": NonSpare_1752, "MDA": NonSpare_1243, "MFL": NonSpare_1265, "MDS": NonSpare_1249, "ADS": NonSpare_572, "ADB": NonSpare_562, "MD1": NonSpare_1231, "MD2": NonSpare_1234, "LOP": NonSpare_1185, "TRK": NonSpare_1908, "MUL": NonSpare_1327}

    @overload
    @classmethod
    def spec(cls, key : Literal["PSR"]) -> NonSpare_1465:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSR"]) -> NonSpare_1752:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDA"]) -> NonSpare_1243:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MFL"]) -> NonSpare_1265:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDS"]) -> NonSpare_1249:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADS"]) -> NonSpare_572:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADB"]) -> NonSpare_562:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MD1"]) -> NonSpare_1231:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MD2"]) -> NonSpare_1234:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LOP"]) -> NonSpare_1185:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRK"]) -> NonSpare_1908:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MUL"]) -> NonSpare_1327:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PSR"], Literal["SSR"], Literal["MDA"], Literal["MFL"], Literal["MDS"], Literal["ADS"], Literal["ADB"], Literal["MD1"], Literal["MD2"], Literal["LOP"], Literal["TRK"], Literal["MUL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[NonSpare_1465]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[NonSpare_1752]:
        ...
    @overload
    def get_item(self, key : Literal["MDA"]) -> Optional[NonSpare_1243]:
        ...
    @overload
    def get_item(self, key : Literal["MFL"]) -> Optional[NonSpare_1265]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[NonSpare_1249]:
        ...
    @overload
    def get_item(self, key : Literal["ADS"]) -> Optional[NonSpare_572]:
        ...
    @overload
    def get_item(self, key : Literal["ADB"]) -> Optional[NonSpare_562]:
        ...
    @overload
    def get_item(self, key : Literal["MD1"]) -> Optional[NonSpare_1231]:
        ...
    @overload
    def get_item(self, key : Literal["MD2"]) -> Optional[NonSpare_1234]:
        ...
    @overload
    def get_item(self, key : Literal["LOP"]) -> Optional[NonSpare_1185]:
        ...
    @overload
    def get_item(self, key : Literal["TRK"]) -> Optional[NonSpare_1908]:
        ...
    @overload
    def get_item(self, key : Literal["MUL"]) -> Optional[NonSpare_1327]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["PSR"], val : NonSpare_1465_Arg) -> "Variation_1491":
        ...
    @overload
    def set_item(self, key : Literal["SSR"], val : NonSpare_1752_Arg) -> "Variation_1491":
        ...
    @overload
    def set_item(self, key : Literal["MDA"], val : NonSpare_1243_Arg) -> "Variation_1491":
        ...
    @overload
    def set_item(self, key : Literal["MFL"], val : NonSpare_1265_Arg) -> "Variation_1491":
        ...
    @overload
    def set_item(self, key : Literal["MDS"], val : NonSpare_1249_Arg) -> "Variation_1491":
        ...
    @overload
    def set_item(self, key : Literal["ADS"], val : NonSpare_572_Arg) -> "Variation_1491":
        ...
    @overload
    def set_item(self, key : Literal["ADB"], val : NonSpare_562_Arg) -> "Variation_1491":
        ...
    @overload
    def set_item(self, key : Literal["MD1"], val : NonSpare_1231_Arg) -> "Variation_1491":
        ...
    @overload
    def set_item(self, key : Literal["MD2"], val : NonSpare_1234_Arg) -> "Variation_1491":
        ...
    @overload
    def set_item(self, key : Literal["LOP"], val : NonSpare_1185_Arg) -> "Variation_1491":
        ...
    @overload
    def set_item(self, key : Literal["TRK"], val : NonSpare_1908_Arg) -> "Variation_1491":
        ...
    @overload
    def set_item(self, key : Literal["MUL"], val : NonSpare_1327_Arg) -> "Variation_1491":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["PSR"]) -> "Variation_1491":
        ...
    @overload
    def del_item(self, key : Literal["SSR"]) -> "Variation_1491":
        ...
    @overload
    def del_item(self, key : Literal["MDA"]) -> "Variation_1491":
        ...
    @overload
    def del_item(self, key : Literal["MFL"]) -> "Variation_1491":
        ...
    @overload
    def del_item(self, key : Literal["MDS"]) -> "Variation_1491":
        ...
    @overload
    def del_item(self, key : Literal["ADS"]) -> "Variation_1491":
        ...
    @overload
    def del_item(self, key : Literal["ADB"]) -> "Variation_1491":
        ...
    @overload
    def del_item(self, key : Literal["MD1"]) -> "Variation_1491":
        ...
    @overload
    def del_item(self, key : Literal["MD2"]) -> "Variation_1491":
        ...
    @overload
    def del_item(self, key : Literal["LOP"]) -> "Variation_1491":
        ...
    @overload
    def del_item(self, key : Literal["TRK"]) -> "Variation_1491":
        ...
    @overload
    def del_item(self, key : Literal["MUL"]) -> "Variation_1491":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1491_Arg) -> 'Variation_1491':
        return cls._create(arg) # type: ignore

RuleVariation_1414_Arg: TypeAlias = Variation_1491_Arg
class RuleVariation_1414(RuleVariationContextFree):
    cv_variation = Variation_1491

    @classmethod
    def create(cls, arg : RuleVariation_1414_Arg) -> "RuleVariation_1414":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1491:
        return self.arg # type: ignore

NonSpare_464_Arg: TypeAlias = RuleVariation_1414_Arg
class NonSpare_464(NonSpare):
    cv_name = "290"
    cv_title = "System Track Update Ages"
    cv_rule = RuleVariation_1414

    @classmethod
    def create(cls, arg : NonSpare_464_Arg) -> "NonSpare_464":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1414:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1491:
        return self.rule.variation

class UapItem_464(UapItem):
    cv_non_spare = NonSpare_464

Content_313_Arg: TypeAlias = int
class Content_313(ContentTable):
    cv_values = {0: "No QNH Correction Applied", 1: "QNH Correction Applied"}

RuleContent_313_Arg: TypeAlias = Content_313_Arg
class RuleContent_313(RuleContentContextFree):
    cv_content = Content_313

    @property
    def content(self) -> Content_313:
        return self._get_content() # type: ignore

Variation_57_Arg: TypeAlias = RuleContent_313_Arg
class Variation_57(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_313

    @classmethod
    def create(cls, arg : Variation_57_Arg) -> "Variation_57":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_313:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_313:
        return self.rule.content

RuleVariation_57_Arg: TypeAlias = Variation_57_Arg
class RuleVariation_57(RuleVariationContextFree):
    cv_variation = Variation_57

    @classmethod
    def create(cls, arg : RuleVariation_57_Arg) -> "RuleVariation_57":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_57:
        return self.arg # type: ignore

NonSpare_1519_Arg: TypeAlias = RuleVariation_57_Arg
class NonSpare_1519(NonSpare):
    cv_name = "QNH"
    cv_title = "QNH Correction Applied"
    cv_rule = RuleVariation_57

    @classmethod
    def create(cls, arg : NonSpare_1519_Arg) -> "NonSpare_1519":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_57:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_57:
        return self.rule.variation

Item_757_Arg: TypeAlias = NonSpare_1519_Arg
class Item_757(Item):
    cv_non_spare = NonSpare_1519

    @classmethod
    def create(cls, arg : Item_757_Arg) -> "Item_757":
        return cls._create(arg) # type: ignore

Variation_1161_Arg_Group = Tuple[Union[RuleVariation_57_Arg, Tuple[Literal["QNH"], RuleVariation_57_Arg]], Union[RuleVariation_486_Arg, Tuple[Literal["CTBA"], RuleVariation_486_Arg]]]
Variation_1161_Arg: TypeAlias = Union[int, Variation_1161_Arg_Group]
class Variation_1161(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_757, 1), (Item_228, 15)]
    cv_items_dict = {"QNH": RuleVariation_57, "CTBA": RuleVariation_486}

    @overload
    @classmethod
    def spec(cls, key : Literal["QNH"]) -> RuleVariation_57:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CTBA"]) -> RuleVariation_486:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["QNH"], Literal["CTBA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["QNH"]) -> RuleVariation_57:
        ...
    @overload
    def get_item(self, key : Literal["CTBA"]) -> RuleVariation_486:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1161_Arg) -> 'Variation_1161':
        return cls._create(arg) # type: ignore

RuleVariation_1113_Arg: TypeAlias = Variation_1161_Arg
class RuleVariation_1113(RuleVariationContextFree):
    cv_variation = Variation_1161

    @classmethod
    def create(cls, arg : RuleVariation_1113_Arg) -> "RuleVariation_1113":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1161:
        return self.arg # type: ignore

NonSpare_260_Arg: TypeAlias = RuleVariation_1113_Arg
class NonSpare_260(NonSpare):
    cv_name = "093"
    cv_title = "Calculated Track Barometric Altitude"
    cv_rule = RuleVariation_1113

    @classmethod
    def create(cls, arg : NonSpare_260_Arg) -> "NonSpare_260":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1113:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1161:
        return self.rule.variation

class UapItem_260(UapItem):
    cv_non_spare = NonSpare_260

NonSpare_458_Arg: TypeAlias = RuleVariation_1278_Arg
class NonSpare_458(NonSpare):
    cv_name = "270"
    cv_title = "Target Size and Orientation"
    cv_rule = RuleVariation_1278

    @classmethod
    def create(cls, arg : NonSpare_458_Arg) -> "NonSpare_458":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1278:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1355:
        return self.rule.variation

class UapItem_458(UapItem):
    cv_non_spare = NonSpare_458

Content_243_Arg: TypeAlias = int
class Content_243(ContentTable):
    cv_values = {0: "Instrument Flight Rules", 1: "Visual Flight Rules", 2: "Not applicable", 3: "Controlled Visual Flight Rules"}

RuleContent_243_Arg: TypeAlias = Content_243_Arg
class RuleContent_243(RuleContentContextFree):
    cv_content = Content_243

    @property
    def content(self) -> Content_243:
        return self._get_content() # type: ignore

Variation_588_Arg: TypeAlias = RuleContent_243_Arg
class Variation_588(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_243

    @classmethod
    def create(cls, arg : Variation_588_Arg) -> "Variation_588":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_243:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_243:
        return self.rule.content

RuleVariation_577_Arg: TypeAlias = Variation_588_Arg
class RuleVariation_577(RuleVariationContextFree):
    cv_variation = Variation_588

    @classmethod
    def create(cls, arg : RuleVariation_577_Arg) -> "RuleVariation_577":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_588:
        return self.arg # type: ignore

NonSpare_986_Arg: TypeAlias = RuleVariation_577_Arg
class NonSpare_986(NonSpare):
    cv_name = "FR1FR2"
    cv_title = "Flight Rules"
    cv_rule = RuleVariation_577

    @classmethod
    def create(cls, arg : NonSpare_986_Arg) -> "NonSpare_986":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_577:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_588:
        return self.rule.variation

Item_341_Arg: TypeAlias = NonSpare_986_Arg
class Item_341(Item):
    cv_non_spare = NonSpare_986

    @classmethod
    def create(cls, arg : Item_341_Arg) -> "Item_341":
        return cls._create(arg) # type: ignore

Variation_1106_Arg_Group = Tuple[Union[RuleVariation_115_Arg, Tuple[Literal["GATOAT"], RuleVariation_115_Arg]], Union[RuleVariation_577_Arg, Tuple[Literal["FR1FR2"], RuleVariation_577_Arg]], Union[RuleVariation_755_Arg, Tuple[Literal["RVSM"], RuleVariation_755_Arg]], Union[RuleVariation_909_Arg, Tuple[Literal["HPR"], RuleVariation_909_Arg]], int]
Variation_1106_Arg: TypeAlias = Union[int, Variation_1106_Arg_Group]
class Variation_1106(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_361, 2), (Item_341, 2), (Item_841, 2), (Item_401, 1), (Item_29, 1)]
    cv_items_dict = {"GATOAT": RuleVariation_115, "FR1FR2": RuleVariation_577, "RVSM": RuleVariation_755, "HPR": RuleVariation_909}

    @overload
    @classmethod
    def spec(cls, key : Literal["GATOAT"]) -> RuleVariation_115:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FR1FR2"]) -> RuleVariation_577:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RVSM"]) -> RuleVariation_755:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HPR"]) -> RuleVariation_909:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GATOAT"], Literal["FR1FR2"], Literal["RVSM"], Literal["HPR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GATOAT"]) -> RuleVariation_115:
        ...
    @overload
    def get_item(self, key : Literal["FR1FR2"]) -> RuleVariation_577:
        ...
    @overload
    def get_item(self, key : Literal["RVSM"]) -> RuleVariation_755:
        ...
    @overload
    def get_item(self, key : Literal["HPR"]) -> RuleVariation_909:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1106_Arg) -> 'Variation_1106':
        return cls._create(arg) # type: ignore

RuleVariation_1064_Arg: TypeAlias = Variation_1106_Arg
class RuleVariation_1064(RuleVariationContextFree):
    cv_variation = Variation_1106

    @classmethod
    def create(cls, arg : RuleVariation_1064_Arg) -> "RuleVariation_1064":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1106:
        return self.arg # type: ignore

NonSpare_969_Arg: TypeAlias = RuleVariation_1064_Arg
class NonSpare_969(NonSpare):
    cv_name = "FLIGHTCAT"
    cv_title = "Flight Category"
    cv_rule = RuleVariation_1064

    @classmethod
    def create(cls, arg : NonSpare_969_Arg) -> "NonSpare_969":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1064:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1106:
        return self.rule.variation

Variation_1477_Arg = TypedDict('Variation_1477_Arg', {
    "FPPSID": NonSpare_982_Arg,
    "CSN": NonSpare_827_Arg,
    "IFPSFLIGHTID": NonSpare_1110_Arg,
    "FLIGHTCAT": NonSpare_969_Arg,
    "TOA": NonSpare_1872_Arg,
    "WTC": NonSpare_2059_Arg,
    "ADEP": NonSpare_563_Arg,
    "ADES": NonSpare_564_Arg,
    "RWY": NonSpare_1634_Arg,
    "CFL": NonSpare_720_Arg,
    "CCP": NonSpare_705_Arg,
    "TOD": NonSpare_1873_Arg,
    "AST": NonSpare_633_Arg,
    "STS": NonSpare_1791_Arg,
}, total=False)
class Variation_1477(Compound):
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_982, NonSpare_827, NonSpare_1110, NonSpare_969, NonSpare_1872, NonSpare_2059, NonSpare_563, NonSpare_564, NonSpare_1634, NonSpare_720, NonSpare_705, NonSpare_1873, NonSpare_633, NonSpare_1791]
    cv_items_dict = {"FPPSID": NonSpare_982, "CSN": NonSpare_827, "IFPSFLIGHTID": NonSpare_1110, "FLIGHTCAT": NonSpare_969, "TOA": NonSpare_1872, "WTC": NonSpare_2059, "ADEP": NonSpare_563, "ADES": NonSpare_564, "RWY": NonSpare_1634, "CFL": NonSpare_720, "CCP": NonSpare_705, "TOD": NonSpare_1873, "AST": NonSpare_633, "STS": NonSpare_1791}

    @overload
    @classmethod
    def spec(cls, key : Literal["FPPSID"]) -> NonSpare_982:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CSN"]) -> NonSpare_827:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IFPSFLIGHTID"]) -> NonSpare_1110:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FLIGHTCAT"]) -> NonSpare_969:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOA"]) -> NonSpare_1872:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WTC"]) -> NonSpare_2059:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADEP"]) -> NonSpare_563:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADES"]) -> NonSpare_564:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RWY"]) -> NonSpare_1634:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CFL"]) -> NonSpare_720:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CCP"]) -> NonSpare_705:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOD"]) -> NonSpare_1873:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AST"]) -> NonSpare_633:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STS"]) -> NonSpare_1791:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["FPPSID"], Literal["CSN"], Literal["IFPSFLIGHTID"], Literal["FLIGHTCAT"], Literal["TOA"], Literal["WTC"], Literal["ADEP"], Literal["ADES"], Literal["RWY"], Literal["CFL"], Literal["CCP"], Literal["TOD"], Literal["AST"], Literal["STS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["FPPSID"]) -> Optional[NonSpare_982]:
        ...
    @overload
    def get_item(self, key : Literal["CSN"]) -> Optional[NonSpare_827]:
        ...
    @overload
    def get_item(self, key : Literal["IFPSFLIGHTID"]) -> Optional[NonSpare_1110]:
        ...
    @overload
    def get_item(self, key : Literal["FLIGHTCAT"]) -> Optional[NonSpare_969]:
        ...
    @overload
    def get_item(self, key : Literal["TOA"]) -> Optional[NonSpare_1872]:
        ...
    @overload
    def get_item(self, key : Literal["WTC"]) -> Optional[NonSpare_2059]:
        ...
    @overload
    def get_item(self, key : Literal["ADEP"]) -> Optional[NonSpare_563]:
        ...
    @overload
    def get_item(self, key : Literal["ADES"]) -> Optional[NonSpare_564]:
        ...
    @overload
    def get_item(self, key : Literal["RWY"]) -> Optional[NonSpare_1634]:
        ...
    @overload
    def get_item(self, key : Literal["CFL"]) -> Optional[NonSpare_720]:
        ...
    @overload
    def get_item(self, key : Literal["CCP"]) -> Optional[NonSpare_705]:
        ...
    @overload
    def get_item(self, key : Literal["TOD"]) -> Optional[NonSpare_1873]:
        ...
    @overload
    def get_item(self, key : Literal["AST"]) -> Optional[NonSpare_633]:
        ...
    @overload
    def get_item(self, key : Literal["STS"]) -> Optional[NonSpare_1791]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["FPPSID"], val : NonSpare_982_Arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["CSN"], val : NonSpare_827_Arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["IFPSFLIGHTID"], val : NonSpare_1110_Arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["FLIGHTCAT"], val : NonSpare_969_Arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["TOA"], val : NonSpare_1872_Arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["WTC"], val : NonSpare_2059_Arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["ADEP"], val : NonSpare_563_Arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["ADES"], val : NonSpare_564_Arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["RWY"], val : NonSpare_1634_Arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["CFL"], val : NonSpare_720_Arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["CCP"], val : NonSpare_705_Arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["TOD"], val : NonSpare_1873_Arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["AST"], val : NonSpare_633_Arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["STS"], val : NonSpare_1791_Arg) -> "Variation_1477":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["FPPSID"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["CSN"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["IFPSFLIGHTID"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["FLIGHTCAT"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["TOA"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["WTC"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["ADEP"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["ADES"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["RWY"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["CFL"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["CCP"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["TOD"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["AST"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["STS"]) -> "Variation_1477":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1477_Arg) -> 'Variation_1477':
        return cls._create(arg) # type: ignore

RuleVariation_1400_Arg: TypeAlias = Variation_1477_Arg
class RuleVariation_1400(RuleVariationContextFree):
    cv_variation = Variation_1477

    @classmethod
    def create(cls, arg : RuleVariation_1400_Arg) -> "RuleVariation_1400":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1477:
        return self.arg # type: ignore

NonSpare_486_Arg: TypeAlias = RuleVariation_1400_Arg
class NonSpare_486(NonSpare):
    cv_name = "390"
    cv_title = "Flight Plan Related Data"
    cv_rule = RuleVariation_1400

    @classmethod
    def create(cls, arg : NonSpare_486_Arg) -> "NonSpare_486":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1400:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1477:
        return self.rule.variation

class UapItem_486(UapItem):
    cv_non_spare = NonSpare_486

Record_46_Arg = TypedDict('Record_46_Arg', {
    "010": NonSpare_47_Arg,
    "000": NonSpare_13_Arg,
    "015": NonSpare_61_Arg,
    "140": NonSpare_330_Arg,
    "041": NonSpare_154_Arg,
    "042": NonSpare_156_Arg,
    "202": NonSpare_401_Arg,
    "210": NonSpare_403_Arg,
    "060": NonSpare_187_Arg,
    "245": NonSpare_437_Arg,
    "380": NonSpare_485_Arg,
    "161": NonSpare_356_Arg,
    "170": NonSpare_375_Arg,
    "290": NonSpare_464_Arg,
    "430": NonSpare_501_Arg,
    "090": NonSpare_248_Arg,
    "093": NonSpare_260_Arg,
    "092": NonSpare_258_Arg,
    "215": NonSpare_413_Arg,
    "270": NonSpare_458_Arg,
    "390": NonSpare_486_Arg,
    "300": NonSpare_471_Arg,
    "310": NonSpare_475_Arg,
    "500": NonSpare_511_Arg,
    "600": NonSpare_523_Arg,
    "605": NonSpare_531_Arg,
    "610": NonSpare_535_Arg,
    "SP": NonSpare_1723_Arg,
    "RE": NonSpare_1558_Arg,
}, total=False)
class Record_46(Record):
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_47, UapItem_13, UapItem_61, UapItem_330, UapItem_154, UapItem_156, UapItem_401, UapItem_403, UapItem_187, UapItem_437, UapItem_485, UapItem_356, UapItem_375, UapItem_464, UapItem_500, UapItem_248, UapItem_260, UapItem_258, UapItem_413, UapItem_458, UapItem_486, UapItem_471, UapItem_475, UapItem_510, UapItem_522, UapItem_530, UapItem_534, UapItem_543, UapItem_542]
    cv_items_dict = {"010": NonSpare_47, "000": NonSpare_13, "015": NonSpare_61, "140": NonSpare_330, "041": NonSpare_154, "042": NonSpare_156, "202": NonSpare_401, "210": NonSpare_403, "060": NonSpare_187, "245": NonSpare_437, "380": NonSpare_485, "161": NonSpare_356, "170": NonSpare_375, "290": NonSpare_464, "430": NonSpare_501, "090": NonSpare_248, "093": NonSpare_260, "092": NonSpare_258, "215": NonSpare_413, "270": NonSpare_458, "390": NonSpare_486, "300": NonSpare_471, "310": NonSpare_475, "500": NonSpare_511, "600": NonSpare_523, "605": NonSpare_531, "610": NonSpare_535, "SP": NonSpare_1723, "RE": NonSpare_1558}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_47:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_13:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_61:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_330:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_154:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_156:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["202"]) -> NonSpare_401:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_403:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_187:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_437:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["380"]) -> NonSpare_485:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_356:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_375:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["290"]) -> NonSpare_464:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["430"]) -> NonSpare_501:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_248:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["093"]) -> NonSpare_260:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["092"]) -> NonSpare_258:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["215"]) -> NonSpare_413:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["270"]) -> NonSpare_458:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["390"]) -> NonSpare_486:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_471:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["310"]) -> NonSpare_475:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_511:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["600"]) -> NonSpare_523:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["605"]) -> NonSpare_531:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["610"]) -> NonSpare_535:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["015"], Literal["140"], Literal["041"], Literal["042"], Literal["202"], Literal["210"], Literal["060"], Literal["245"], Literal["380"], Literal["161"], Literal["170"], Literal["290"], Literal["430"], Literal["090"], Literal["093"], Literal["092"], Literal["215"], Literal["270"], Literal["390"], Literal["300"], Literal["310"], Literal["500"], Literal["600"], Literal["605"], Literal["610"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_47]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_13]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_61]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_330]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_154]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_156]:
        ...
    @overload
    def get_item(self, key : Literal["202"]) -> Optional[NonSpare_401]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_403]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_187]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_437]:
        ...
    @overload
    def get_item(self, key : Literal["380"]) -> Optional[NonSpare_485]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_356]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_375]:
        ...
    @overload
    def get_item(self, key : Literal["290"]) -> Optional[NonSpare_464]:
        ...
    @overload
    def get_item(self, key : Literal["430"]) -> Optional[NonSpare_501]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_248]:
        ...
    @overload
    def get_item(self, key : Literal["093"]) -> Optional[NonSpare_260]:
        ...
    @overload
    def get_item(self, key : Literal["092"]) -> Optional[NonSpare_258]:
        ...
    @overload
    def get_item(self, key : Literal["215"]) -> Optional[NonSpare_413]:
        ...
    @overload
    def get_item(self, key : Literal["270"]) -> Optional[NonSpare_458]:
        ...
    @overload
    def get_item(self, key : Literal["390"]) -> Optional[NonSpare_486]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_471]:
        ...
    @overload
    def get_item(self, key : Literal["310"]) -> Optional[NonSpare_475]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_511]:
        ...
    @overload
    def get_item(self, key : Literal["600"]) -> Optional[NonSpare_523]:
        ...
    @overload
    def get_item(self, key : Literal["605"]) -> Optional[NonSpare_531]:
        ...
    @overload
    def get_item(self, key : Literal["610"]) -> Optional[NonSpare_535]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_47_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_13_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_61_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_330_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_154_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_156_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["202"], val : NonSpare_401_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_403_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_187_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_437_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["380"], val : NonSpare_485_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_356_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_375_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["290"], val : NonSpare_464_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["430"], val : NonSpare_501_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_248_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["093"], val : NonSpare_260_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["092"], val : NonSpare_258_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["215"], val : NonSpare_413_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["270"], val : NonSpare_458_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["390"], val : NonSpare_486_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_471_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["310"], val : NonSpare_475_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_511_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["600"], val : NonSpare_523_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["605"], val : NonSpare_531_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["610"], val : NonSpare_535_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_46':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["202"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["380"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["290"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["430"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["093"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["092"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["215"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["270"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["390"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["310"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["600"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["605"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["610"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_46':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_46_Arg) -> 'Record_46':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_46", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_42_Arg: TypeAlias = Record_46
class Uap_42(UapSingle):
    cv_record = Record_46

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_46]]:
        return cls._parse(bs)

class Asterix_11(AstCat):
    cv_category = 11
    cv_edition = (1, 3)
    cv_uap = Uap_42

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_42_Arg]) -> "Asterix_11":
        return cls._create(records) # type: ignore

NonSpare_39_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_39(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_39_Arg) -> "NonSpare_39":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_39(UapItem):
    cv_non_spare = NonSpare_39

Content_582_Arg: TypeAlias = int
class Content_582(ContentTable):
    cv_values = {1: "Measurement Plot", 2: "Measurement Track", 3: "Sensor Centric Plot", 4: "Sensor Centric Track", 5: "Track End Message"}

RuleContent_582_Arg: TypeAlias = Content_582_Arg
class RuleContent_582(RuleContentContextFree):
    cv_content = Content_582

    @property
    def content(self) -> Content_582:
        return self._get_content() # type: ignore

Variation_157_Arg: TypeAlias = RuleContent_582_Arg
class Variation_157(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_582

    @classmethod
    def create(cls, arg : Variation_157_Arg) -> "Variation_157":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_582:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_582:
        return self.rule.content

RuleVariation_151_Arg: TypeAlias = Variation_157_Arg
class RuleVariation_151(RuleVariationContextFree):
    cv_variation = Variation_157

    @classmethod
    def create(cls, arg : RuleVariation_151_Arg) -> "RuleVariation_151":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_157:
        return self.arg # type: ignore

NonSpare_1324_Arg: TypeAlias = RuleVariation_151_Arg
class NonSpare_1324(NonSpare):
    cv_name = "MT"
    cv_title = "Message Type"
    cv_rule = RuleVariation_151

    @classmethod
    def create(cls, arg : NonSpare_1324_Arg) -> "NonSpare_1324":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_151:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_157:
        return self.rule.variation

Item_594_Arg: TypeAlias = NonSpare_1324_Arg
class Item_594(Item):
    cv_non_spare = NonSpare_1324

    @classmethod
    def create(cls, arg : Item_594_Arg) -> "Item_594":
        return cls._create(arg) # type: ignore

Content_423_Arg: TypeAlias = int
class Content_423(ContentTable):
    cv_values = {0: "Periodic Report", 1: "Event Driven Report"}

RuleContent_423_Arg: TypeAlias = Content_423_Arg
class RuleContent_423(RuleContentContextFree):
    cv_content = Content_423

    @property
    def content(self) -> Content_423:
        return self._get_content() # type: ignore

Variation_983_Arg: TypeAlias = RuleContent_423_Arg
class Variation_983(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_423

    @classmethod
    def create(cls, arg : Variation_983_Arg) -> "Variation_983":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_423:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_423:
        return self.rule.content

RuleVariation_953_Arg: TypeAlias = Variation_983_Arg
class RuleVariation_953(RuleVariationContextFree):
    cv_variation = Variation_983

    @classmethod
    def create(cls, arg : RuleVariation_953_Arg) -> "RuleVariation_953":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_983:
        return self.arg # type: ignore

NonSpare_1576_Arg: TypeAlias = RuleVariation_953_Arg
class NonSpare_1576(NonSpare):
    cv_name = "RG"
    cv_title = "Report Generation"
    cv_rule = RuleVariation_953

    @classmethod
    def create(cls, arg : NonSpare_1576_Arg) -> "NonSpare_1576":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_953:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_983:
        return self.rule.variation

Item_807_Arg: TypeAlias = NonSpare_1576_Arg
class Item_807(Item):
    cv_non_spare = NonSpare_1576

    @classmethod
    def create(cls, arg : Item_807_Arg) -> "Item_807":
        return cls._create(arg) # type: ignore

Variation_1139_Arg_Group = Tuple[Union[RuleVariation_151_Arg, Tuple[Literal["MT"], RuleVariation_151_Arg]], Union[RuleVariation_953_Arg, Tuple[Literal["RG"], RuleVariation_953_Arg]]]
Variation_1139_Arg: TypeAlias = Union[int, Variation_1139_Arg_Group]
class Variation_1139(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_594, 7), (Item_807, 1)]
    cv_items_dict = {"MT": RuleVariation_151, "RG": RuleVariation_953}

    @overload
    @classmethod
    def spec(cls, key : Literal["MT"]) -> RuleVariation_151:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RG"]) -> RuleVariation_953:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MT"], Literal["RG"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MT"]) -> RuleVariation_151:
        ...
    @overload
    def get_item(self, key : Literal["RG"]) -> RuleVariation_953:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1139_Arg) -> 'Variation_1139':
        return cls._create(arg) # type: ignore

RuleVariation_1093_Arg: TypeAlias = Variation_1139_Arg
class RuleVariation_1093(RuleVariationContextFree):
    cv_variation = Variation_1139

    @classmethod
    def create(cls, arg : RuleVariation_1093_Arg) -> "RuleVariation_1093":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1139:
        return self.arg # type: ignore

NonSpare_16_Arg: TypeAlias = RuleVariation_1093_Arg
class NonSpare_16(NonSpare):
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule = RuleVariation_1093

    @classmethod
    def create(cls, arg : NonSpare_16_Arg) -> "NonSpare_16":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1093:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1139:
        return self.rule.variation

class UapItem_16(UapItem):
    cv_non_spare = NonSpare_16

NonSpare_59_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_59(NonSpare):
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_59_Arg) -> "NonSpare_59":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_59(UapItem):
    cv_non_spare = NonSpare_59

Content_295_Arg: TypeAlias = int
class Content_295(ContentTable):
    cv_values = {0: "Mono-Static Sensor", 1: "Multi-Static Sensor", 2: "Other", 3: "Unknown"}

RuleContent_295_Arg: TypeAlias = Content_295_Arg
class RuleContent_295(RuleContentContextFree):
    cv_content = Content_295

    @property
    def content(self) -> Content_295:
        return self._get_content() # type: ignore

Variation_104_Arg: TypeAlias = RuleContent_295_Arg
class Variation_104(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_295

    @classmethod
    def create(cls, arg : Variation_104_Arg) -> "Variation_104":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_295:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_295:
        return self.rule.content

RuleVariation_104_Arg: TypeAlias = Variation_104_Arg
class RuleVariation_104(RuleVariationContextFree):
    cv_variation = Variation_104

    @classmethod
    def create(cls, arg : RuleVariation_104_Arg) -> "RuleVariation_104":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_104:
        return self.arg # type: ignore

Content_16_Arg: TypeAlias = int
class Content_16(ContentTable):
    cv_values = {0: "Actual Target Report", 1: "Reference Target", 2: "Synthetic Target", 3: "Simulated / Replayed Target"}

RuleContent_16_Arg: TypeAlias = Content_16_Arg
class RuleContent_16(RuleContentContextFree):
    cv_content = Content_16

    @property
    def content(self) -> Content_16:
        return self._get_content() # type: ignore

Variation_584_Arg: TypeAlias = RuleContent_16_Arg
class Variation_584(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_16

    @classmethod
    def create(cls, arg : Variation_584_Arg) -> "Variation_584":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_16:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_16:
        return self.rule.content

RuleVariation_573_Arg: TypeAlias = Variation_584_Arg
class RuleVariation_573(RuleVariationContextFree):
    cv_variation = Variation_584

    @classmethod
    def create(cls, arg : RuleVariation_573_Arg) -> "RuleVariation_573":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_584:
        return self.arg # type: ignore

Content_545_Arg: TypeAlias = int
class Content_545(ContentTable):
    cv_values = {0: "Unknown", 1: "Forward", 2: "Backward", 3: "Static"}

RuleContent_545_Arg: TypeAlias = Content_545_Arg
class RuleContent_545(RuleContentContextFree):
    cv_content = Content_545

    @property
    def content(self) -> Content_545:
        return self._get_content() # type: ignore

Variation_769_Arg: TypeAlias = RuleContent_545_Arg
class Variation_769(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_545

    @classmethod
    def create(cls, arg : Variation_769_Arg) -> "Variation_769":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_545:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_545:
        return self.rule.content

RuleVariation_758_Arg: TypeAlias = Variation_769_Arg
class RuleVariation_758(RuleVariationContextFree):
    cv_variation = Variation_769

    @classmethod
    def create(cls, arg : RuleVariation_758_Arg) -> "RuleVariation_758":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_769:
        return self.arg # type: ignore

NonSpare_1302_Arg: TypeAlias = RuleVariation_104_Arg
class NonSpare_1302(NonSpare):
    cv_name = "MOMU"
    cv_title = "Mono-Static Target Report or Multi-Static Target Report"
    cv_rule = RuleVariation_104

    @classmethod
    def create(cls, arg : NonSpare_1302_Arg) -> "NonSpare_1302":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_104:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_104:
        return self.rule.variation

Item_574_Arg: TypeAlias = NonSpare_1302_Arg
class Item_574(Item):
    cv_non_spare = NonSpare_1302

    @classmethod
    def create(cls, arg : Item_574_Arg) -> "Item_574":
        return cls._create(arg) # type: ignore

NonSpare_1938_Arg: TypeAlias = RuleVariation_573_Arg
class NonSpare_1938(NonSpare):
    cv_name = "TTAX"
    cv_title = "Target Taxonomy"
    cv_rule = RuleVariation_573

    @classmethod
    def create(cls, arg : NonSpare_1938_Arg) -> "NonSpare_1938":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_573:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_584:
        return self.rule.variation

Item_1059_Arg: TypeAlias = NonSpare_1938_Arg
class Item_1059(Item):
    cv_non_spare = NonSpare_1938

    @classmethod
    def create(cls, arg : Item_1059_Arg) -> "Item_1059":
        return cls._create(arg) # type: ignore

NonSpare_1658_Arg: TypeAlias = RuleVariation_758_Arg
class NonSpare_1658(NonSpare):
    cv_name = "SCD"
    cv_title = "Scanning Direction"
    cv_rule = RuleVariation_758

    @classmethod
    def create(cls, arg : NonSpare_1658_Arg) -> "NonSpare_1658":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_758:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_769:
        return self.rule.variation

Item_859_Arg: TypeAlias = NonSpare_1658_Arg
class Item_859(Item):
    cv_non_spare = NonSpare_1658

    @classmethod
    def create(cls, arg : Item_859_Arg) -> "Item_859":
        return cls._create(arg) # type: ignore

Variation_1358_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_104_Arg, Tuple[Literal["MOMU"], RuleVariation_104_Arg]], Union[RuleVariation_573_Arg, Tuple[Literal["TTAX"], RuleVariation_573_Arg]], Union[RuleVariation_758_Arg, Tuple[Literal["SCD"], RuleVariation_758_Arg]], int, None]]
Variation_1358_Arg: TypeAlias = Union[
    Tuple[Variation_1358_Arg_Group_1],
]
class Variation_1358(Extended):
    cv_items_list = [[(Item_574, 2), (Item_1059, 2), (Item_859, 2), (Item_26, 1), None]]

    @classmethod
    def create(cls, arg : Variation_1358_Arg) -> 'Variation_1358':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MOMU"]) -> RuleVariation_104:
        ...
    @overload
    def get_item(self, key : Literal["TTAX"]) -> RuleVariation_573:
        ...
    @overload
    def get_item(self, key : Literal["SCD"]) -> RuleVariation_758:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1281_Arg: TypeAlias = Variation_1358_Arg
class RuleVariation_1281(RuleVariationContextFree):
    cv_variation = Variation_1358

    @classmethod
    def create(cls, arg : RuleVariation_1281_Arg) -> "RuleVariation_1281":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1358:
        return self.arg # type: ignore

NonSpare_84_Arg: TypeAlias = RuleVariation_1281_Arg
class NonSpare_84(NonSpare):
    cv_name = "020"
    cv_title = "Target Report Descriptor"
    cv_rule = RuleVariation_1281

    @classmethod
    def create(cls, arg : NonSpare_84_Arg) -> "NonSpare_84":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1281:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1358:
        return self.rule.variation

class UapItem_84(UapItem):
    cv_non_spare = NonSpare_84

NonSpare_114_Arg: TypeAlias = RuleVariation_1369_Arg
class NonSpare_114(NonSpare):
    cv_name = "030"
    cv_title = "Warning/Error Conditions"
    cv_rule = RuleVariation_1369

    @classmethod
    def create(cls, arg : NonSpare_114_Arg) -> "NonSpare_114":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1369:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1446:
        return self.rule.variation

class UapItem_114(UapItem):
    cv_non_spare = NonSpare_114

Content_768_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
class Content_768(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 7.8125e-3
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

RuleContent_767_Arg: TypeAlias = Content_768_Arg
class RuleContent_767(RuleContentContextFree):
    cv_content = Content_768

    @property
    def content(self) -> Content_768:
        return self._get_content() # type: ignore

Variation_369_Arg: TypeAlias = RuleContent_767_Arg
class Variation_369(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_767

    @classmethod
    def create(cls, arg : Variation_369_Arg) -> "Variation_369":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_767:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_768:
        return self.rule.content

RuleVariation_362_Arg: TypeAlias = Variation_369_Arg
class RuleVariation_362(RuleVariationContextFree):
    cv_variation = Variation_369

    @classmethod
    def create(cls, arg : RuleVariation_362_Arg) -> "RuleVariation_362":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_369:
        return self.arg # type: ignore

NonSpare_334_Arg: TypeAlias = RuleVariation_362_Arg
class NonSpare_334(NonSpare):
    cv_name = "145"
    cv_title = "Time of Applicability"
    cv_rule = RuleVariation_362

    @classmethod
    def create(cls, arg : NonSpare_334_Arg) -> "NonSpare_334":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_362:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_369:
        return self.rule.variation

class UapItem_334(UapItem):
    cv_non_spare = NonSpare_334

Content_618_Arg: TypeAlias = int
class Content_618(ContentInteger):
    cv_signedness = Unsigned

RuleContent_618_Arg: TypeAlias = Content_618_Arg
class RuleContent_618(RuleContentContextFree):
    cv_content = Content_618

    @property
    def content(self) -> Content_618:
        return self._get_content() # type: ignore

Variation_255_Arg: TypeAlias = RuleContent_618_Arg
class Variation_255(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_618

    @classmethod
    def create(cls, arg : Variation_255_Arg) -> "Variation_255":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_618:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_618:
        return self.rule.content

RuleVariation_248_Arg: TypeAlias = Variation_255_Arg
class RuleVariation_248(RuleVariationContextFree):
    cv_variation = Variation_255

    @classmethod
    def create(cls, arg : RuleVariation_248_Arg) -> "RuleVariation_248":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_255:
        return self.arg # type: ignore

NonSpare_362_Arg: TypeAlias = RuleVariation_248_Arg
class NonSpare_362(NonSpare):
    cv_name = "161"
    cv_title = "Track/Plot Number"
    cv_rule = RuleVariation_248

    @classmethod
    def create(cls, arg : NonSpare_362_Arg) -> "NonSpare_362":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_248:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_255:
        return self.rule.variation

class UapItem_362(UapItem):
    cv_non_spare = NonSpare_362

Content_480_Arg: TypeAlias = int
class Content_480(ContentTable):
    cv_values = {0: "Target not in Blind Zone", 1: "Target in Blind Zone"}

RuleContent_480_Arg: TypeAlias = Content_480_Arg
class RuleContent_480(RuleContentContextFree):
    cv_content = Content_480

    @property
    def content(self) -> Content_480:
        return self._get_content() # type: ignore

Variation_82_Arg: TypeAlias = RuleContent_480_Arg
class Variation_82(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_480

    @classmethod
    def create(cls, arg : Variation_82_Arg) -> "Variation_82":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_480:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_480:
        return self.rule.content

RuleVariation_82_Arg: TypeAlias = Variation_82_Arg
class RuleVariation_82(RuleVariationContextFree):
    cv_variation = Variation_82

    @classmethod
    def create(cls, arg : RuleVariation_82_Arg) -> "RuleVariation_82":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_82:
        return self.arg # type: ignore

Content_479_Arg: TypeAlias = int
class Content_479(ContentTable):
    cv_values = {0: "Target not in Blanked Zone", 1: "Target in Blanked Zone"}

RuleContent_479_Arg: TypeAlias = Content_479_Arg
class RuleContent_479(RuleContentContextFree):
    cv_content = Content_479

    @property
    def content(self) -> Content_479:
        return self._get_content() # type: ignore

Variation_452_Arg: TypeAlias = RuleContent_479_Arg
class Variation_452(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_479

    @classmethod
    def create(cls, arg : Variation_452_Arg) -> "Variation_452":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_479:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_479:
        return self.rule.content

RuleVariation_441_Arg: TypeAlias = Variation_452_Arg
class RuleVariation_441(RuleVariationContextFree):
    cv_variation = Variation_452

    @classmethod
    def create(cls, arg : RuleVariation_441_Arg) -> "RuleVariation_441":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_452:
        return self.arg # type: ignore

Content_509_Arg: TypeAlias = int
class Content_509(ContentTable):
    cv_values = {0: "Track Alive", 1: "Track Terminated by User Request"}

RuleContent_509_Arg: TypeAlias = Content_509_Arg
class RuleContent_509(RuleContentContextFree):
    cv_content = Content_509

    @property
    def content(self) -> Content_509:
        return self._get_content() # type: ignore

Variation_579_Arg: TypeAlias = RuleContent_509_Arg
class Variation_579(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_509

    @classmethod
    def create(cls, arg : Variation_579_Arg) -> "Variation_579":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_509:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_509:
        return self.rule.content

RuleVariation_568_Arg: TypeAlias = Variation_579_Arg
class RuleVariation_568(RuleVariationContextFree):
    cv_variation = Variation_579

    @classmethod
    def create(cls, arg : RuleVariation_568_Arg) -> "RuleVariation_568":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_579:
        return self.arg # type: ignore

Content_396_Arg: TypeAlias = int
class Content_396(ContentTable):
    cv_values = {0: "Not extrapolated", 1: "Extrapolated"}

RuleContent_396_Arg: TypeAlias = Content_396_Arg
class RuleContent_396(RuleContentContextFree):
    cv_content = Content_396

    @property
    def content(self) -> Content_396:
        return self._get_content() # type: ignore

Variation_740_Arg: TypeAlias = RuleContent_396_Arg
class Variation_740(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_396

    @classmethod
    def create(cls, arg : Variation_740_Arg) -> "Variation_740":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_396:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_396:
        return self.rule.content

RuleVariation_729_Arg: TypeAlias = Variation_740_Arg
class RuleVariation_729(RuleVariationContextFree):
    cv_variation = Variation_740

    @classmethod
    def create(cls, arg : RuleVariation_729_Arg) -> "RuleVariation_729":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_740:
        return self.arg # type: ignore

Variation_863_Arg: TypeAlias = RuleContent_396_Arg
class Variation_863(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_396

    @classmethod
    def create(cls, arg : Variation_863_Arg) -> "Variation_863":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_396:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_396:
        return self.rule.content

RuleVariation_833_Arg: TypeAlias = Variation_863_Arg
class RuleVariation_833(RuleVariationContextFree):
    cv_variation = Variation_863

    @classmethod
    def create(cls, arg : RuleVariation_833_Arg) -> "RuleVariation_833":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_863:
        return self.arg # type: ignore

Content_60_Arg: TypeAlias = int
class Content_60(ContentTable):
    cv_values = {0: "Confirmed Track", 1: "Tentative Track"}

RuleContent_60_Arg: TypeAlias = Content_60_Arg
class RuleContent_60(RuleContentContextFree):
    cv_content = Content_60

    @property
    def content(self) -> Content_60:
        return self._get_content() # type: ignore

Variation_903_Arg: TypeAlias = RuleContent_60_Arg
class Variation_903(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_60

    @classmethod
    def create(cls, arg : Variation_903_Arg) -> "Variation_903":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_60:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_60:
        return self.rule.content

RuleVariation_873_Arg: TypeAlias = Variation_903_Arg
class RuleVariation_873(RuleVariationContextFree):
    cv_variation = Variation_903

    @classmethod
    def create(cls, arg : RuleVariation_873_Arg) -> "RuleVariation_873":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_903:
        return self.arg # type: ignore

NonSpare_682_Arg: TypeAlias = RuleVariation_82_Arg
class NonSpare_682(NonSpare):
    cv_name = "BIZ"
    cv_title = ""
    cv_rule = RuleVariation_82

    @classmethod
    def create(cls, arg : NonSpare_682_Arg) -> "NonSpare_682":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_82:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_82:
        return self.rule.variation

Item_126_Arg: TypeAlias = NonSpare_682_Arg
class Item_126(Item):
    cv_non_spare = NonSpare_682

    @classmethod
    def create(cls, arg : Item_126_Arg) -> "Item_126":
        return cls._create(arg) # type: ignore

NonSpare_668_Arg: TypeAlias = RuleVariation_441_Arg
class NonSpare_668(NonSpare):
    cv_name = "BAZ"
    cv_title = ""
    cv_rule = RuleVariation_441

    @classmethod
    def create(cls, arg : NonSpare_668_Arg) -> "NonSpare_668":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_441:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_452:
        return self.rule.variation

Item_113_Arg: TypeAlias = NonSpare_668_Arg
class Item_113(Item):
    cv_non_spare = NonSpare_668

    @classmethod
    def create(cls, arg : Item_113_Arg) -> "Item_113":
        return cls._create(arg) # type: ignore

NonSpare_1944_Arg: TypeAlias = RuleVariation_568_Arg
class NonSpare_1944(NonSpare):
    cv_name = "TUR"
    cv_title = ""
    cv_rule = RuleVariation_568

    @classmethod
    def create(cls, arg : NonSpare_1944_Arg) -> "NonSpare_1944":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_568:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_579:
        return self.rule.variation

Item_1065_Arg: TypeAlias = NonSpare_1944_Arg
class Item_1065(Item):
    cv_non_spare = NonSpare_1944

    @classmethod
    def create(cls, arg : Item_1065_Arg) -> "Item_1065":
        return cls._create(arg) # type: ignore

NonSpare_838_Arg: TypeAlias = RuleVariation_729_Arg
class NonSpare_838(NonSpare):
    cv_name = "CSTP"
    cv_title = "Coasted - Position"
    cv_rule = RuleVariation_729

    @classmethod
    def create(cls, arg : NonSpare_838_Arg) -> "NonSpare_838":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_729:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_740:
        return self.rule.variation

Item_226_Arg: TypeAlias = NonSpare_838_Arg
class Item_226(Item):
    cv_non_spare = NonSpare_838

    @classmethod
    def create(cls, arg : Item_226_Arg) -> "Item_226":
        return cls._create(arg) # type: ignore

NonSpare_837_Arg: TypeAlias = RuleVariation_833_Arg
class NonSpare_837(NonSpare):
    cv_name = "CSTH"
    cv_title = "Coasted – Height"
    cv_rule = RuleVariation_833

    @classmethod
    def create(cls, arg : NonSpare_837_Arg) -> "NonSpare_837":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_833:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_863:
        return self.rule.variation

Item_225_Arg: TypeAlias = NonSpare_837_Arg
class Item_225(Item):
    cv_non_spare = NonSpare_837

    @classmethod
    def create(cls, arg : Item_225_Arg) -> "Item_225":
        return cls._create(arg) # type: ignore

NonSpare_744_Arg: TypeAlias = RuleVariation_873_Arg
class NonSpare_744(NonSpare):
    cv_name = "CNF"
    cv_title = "Confirmed vs. Tentative Track"
    cv_rule = RuleVariation_873

    @classmethod
    def create(cls, arg : NonSpare_744_Arg) -> "NonSpare_744":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_873:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_903:
        return self.rule.variation

Item_168_Arg: TypeAlias = NonSpare_744_Arg
class Item_168(Item):
    cv_non_spare = NonSpare_744

    @classmethod
    def create(cls, arg : Item_168_Arg) -> "Item_168":
        return cls._create(arg) # type: ignore

Variation_1342_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_82_Arg, Tuple[Literal["BIZ"], RuleVariation_82_Arg]], Union[RuleVariation_441_Arg, Tuple[Literal["BAZ"], RuleVariation_441_Arg]], Union[RuleVariation_568_Arg, Tuple[Literal["TUR"], RuleVariation_568_Arg]], int, Union[RuleVariation_729_Arg, Tuple[Literal["CSTP"], RuleVariation_729_Arg]], Union[RuleVariation_833_Arg, Tuple[Literal["CSTH"], RuleVariation_833_Arg]], Union[RuleVariation_873_Arg, Tuple[Literal["CNF"], RuleVariation_873_Arg]], None]]
Variation_1342_Arg: TypeAlias = Union[
    Tuple[Variation_1342_Arg_Group_1],
]
class Variation_1342(Extended):
    cv_items_list = [[(Item_126, 1), (Item_113, 1), (Item_1065, 1), (Item_16, 1), (Item_226, 1), (Item_225, 1), (Item_168, 1), None]]

    @classmethod
    def create(cls, arg : Variation_1342_Arg) -> 'Variation_1342':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["BIZ"]) -> RuleVariation_82:
        ...
    @overload
    def get_item(self, key : Literal["BAZ"]) -> RuleVariation_441:
        ...
    @overload
    def get_item(self, key : Literal["TUR"]) -> RuleVariation_568:
        ...
    @overload
    def get_item(self, key : Literal["CSTP"]) -> RuleVariation_729:
        ...
    @overload
    def get_item(self, key : Literal["CSTH"]) -> RuleVariation_833:
        ...
    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_873:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1265_Arg: TypeAlias = Variation_1342_Arg
class RuleVariation_1265(RuleVariationContextFree):
    cv_variation = Variation_1342

    @classmethod
    def create(cls, arg : RuleVariation_1265_Arg) -> "RuleVariation_1265":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1342:
        return self.arg # type: ignore

NonSpare_376_Arg: TypeAlias = RuleVariation_1265_Arg
class NonSpare_376(NonSpare):
    cv_name = "170"
    cv_title = "Track/Plot Status"
    cv_rule = RuleVariation_1265

    @classmethod
    def create(cls, arg : NonSpare_376_Arg) -> "NonSpare_376":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1265:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1342:
        return self.rule.variation

class UapItem_376(UapItem):
    cv_non_spare = NonSpare_376

Content_769_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
class Content_769(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 7.8125e-3
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

RuleContent_768_Arg: TypeAlias = Content_769_Arg
class RuleContent_768(RuleContentContextFree):
    cv_content = Content_769

    @property
    def content(self) -> Content_769:
        return self._get_content() # type: ignore

Variation_609_Arg: TypeAlias = RuleContent_768_Arg
class Variation_609(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_768

    @classmethod
    def create(cls, arg : Variation_609_Arg) -> "Variation_609":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_768:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_769:
        return self.rule.content

RuleVariation_598_Arg: TypeAlias = Variation_609_Arg
class RuleVariation_598(RuleVariationContextFree):
    cv_variation = Variation_609

    @classmethod
    def create(cls, arg : RuleVariation_598_Arg) -> "RuleVariation_598":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_609:
        return self.arg # type: ignore

NonSpare_1979_Arg: TypeAlias = RuleVariation_598_Arg
class NonSpare_1979(NonSpare):
    cv_name = "UPD"
    cv_title = "Update Period"
    cv_rule = RuleVariation_598

    @classmethod
    def create(cls, arg : NonSpare_1979_Arg) -> "NonSpare_1979":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_598:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_609:
        return self.rule.variation

Item_1097_Arg: TypeAlias = NonSpare_1979_Arg
class Item_1097(Item):
    cv_non_spare = NonSpare_1979

    @classmethod
    def create(cls, arg : Item_1097_Arg) -> "Item_1097":
        return cls._create(arg) # type: ignore

Variation_1006_Arg_Group = Tuple[int, Union[RuleVariation_598_Arg, Tuple[Literal["UPD"], RuleVariation_598_Arg]]]
Variation_1006_Arg: TypeAlias = Union[int, Variation_1006_Arg_Group]
class Variation_1006(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1, 2), (Item_1097, 14)]
    cv_items_dict = {"UPD": RuleVariation_598}

    @classmethod
    def spec(cls, key : Literal["UPD"]) -> RuleVariation_598:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["UPD"]) -> RuleVariation_598:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1006_Arg) -> 'Variation_1006':
        return cls._create(arg) # type: ignore

RuleVariation_976_Arg: TypeAlias = Variation_1006_Arg
class RuleVariation_976(RuleVariationContextFree):
    cv_variation = Variation_1006

    @classmethod
    def create(cls, arg : RuleVariation_976_Arg) -> "RuleVariation_976":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1006:
        return self.arg # type: ignore

NonSpare_179_Arg: TypeAlias = RuleVariation_976_Arg
class NonSpare_179(NonSpare):
    cv_name = "050"
    cv_title = "Update Period"
    cv_rule = RuleVariation_976

    @classmethod
    def create(cls, arg : NonSpare_179_Arg) -> "NonSpare_179":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_976:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1006:
        return self.rule.variation

class UapItem_179(UapItem):
    cv_non_spare = NonSpare_179

Content_740_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_740(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0e-2
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_740_Arg: TypeAlias = Content_740_Arg
class RuleContent_740(RuleContentContextFree):
    cv_content = Content_740

    @property
    def content(self) -> Content_740:
        return self._get_content() # type: ignore

Variation_313_Arg: TypeAlias = RuleContent_740_Arg
class Variation_313(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_740

    @classmethod
    def create(cls, arg : Variation_313_Arg) -> "Variation_313":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_740:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_740:
        return self.rule.content

RuleVariation_306_Arg: TypeAlias = Variation_313_Arg
class RuleVariation_306(RuleVariationContextFree):
    cv_variation = Variation_313

    @classmethod
    def create(cls, arg : RuleVariation_306_Arg) -> "RuleVariation_306":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_313:
        return self.arg # type: ignore

NonSpare_1158_Arg: TypeAlias = RuleVariation_306_Arg
class NonSpare_1158(NonSpare):
    cv_name = "LEN"
    cv_title = "Target Length"
    cv_rule = RuleVariation_306

    @classmethod
    def create(cls, arg : NonSpare_1158_Arg) -> "NonSpare_1158":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_306:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_313:
        return self.rule.variation

NonSpare_2051_Arg: TypeAlias = RuleVariation_306_Arg
class NonSpare_2051(NonSpare):
    cv_name = "WDT"
    cv_title = "Target Width"
    cv_rule = RuleVariation_306

    @classmethod
    def create(cls, arg : NonSpare_2051_Arg) -> "NonSpare_2051":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_306:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_313:
        return self.rule.variation

NonSpare_1062_Arg: TypeAlias = RuleVariation_306_Arg
class NonSpare_1062(NonSpare):
    cv_name = "HGT"
    cv_title = "Target Height"
    cv_rule = RuleVariation_306

    @classmethod
    def create(cls, arg : NonSpare_1062_Arg) -> "NonSpare_1062":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_306:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_313:
        return self.rule.variation

Content_793_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_793(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 5.4931640625e-3
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_792_Arg: TypeAlias = Content_793_Arg
class RuleContent_792(RuleContentContextFree):
    cv_content = Content_793

    @property
    def content(self) -> Content_793:
        return self._get_content() # type: ignore

Variation_344_Arg: TypeAlias = RuleContent_792_Arg
class Variation_344(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_792

    @classmethod
    def create(cls, arg : Variation_344_Arg) -> "Variation_344":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_792:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_793:
        return self.rule.content

RuleVariation_337_Arg: TypeAlias = Variation_344_Arg
class RuleVariation_337(RuleVariationContextFree):
    cv_variation = Variation_344

    @classmethod
    def create(cls, arg : RuleVariation_337_Arg) -> "RuleVariation_337":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_344:
        return self.arg # type: ignore

NonSpare_1395_Arg: TypeAlias = RuleVariation_337_Arg
class NonSpare_1395(NonSpare):
    cv_name = "ORT"
    cv_title = "Target Orientation"
    cv_rule = RuleVariation_337

    @classmethod
    def create(cls, arg : NonSpare_1395_Arg) -> "NonSpare_1395":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_337:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_344:
        return self.rule.variation

Variation_1483_Arg = TypedDict('Variation_1483_Arg', {
    "LEN": NonSpare_1158_Arg,
    "WDT": NonSpare_2051_Arg,
    "HGT": NonSpare_1062_Arg,
    "ORT": NonSpare_1395_Arg,
}, total=False)
class Variation_1483(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1158, NonSpare_2051, NonSpare_1062, NonSpare_1395]
    cv_items_dict = {"LEN": NonSpare_1158, "WDT": NonSpare_2051, "HGT": NonSpare_1062, "ORT": NonSpare_1395}

    @overload
    @classmethod
    def spec(cls, key : Literal["LEN"]) -> NonSpare_1158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WDT"]) -> NonSpare_2051:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HGT"]) -> NonSpare_1062:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ORT"]) -> NonSpare_1395:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LEN"], Literal["WDT"], Literal["HGT"], Literal["ORT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LEN"]) -> Optional[NonSpare_1158]:
        ...
    @overload
    def get_item(self, key : Literal["WDT"]) -> Optional[NonSpare_2051]:
        ...
    @overload
    def get_item(self, key : Literal["HGT"]) -> Optional[NonSpare_1062]:
        ...
    @overload
    def get_item(self, key : Literal["ORT"]) -> Optional[NonSpare_1395]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["LEN"], val : NonSpare_1158_Arg) -> "Variation_1483":
        ...
    @overload
    def set_item(self, key : Literal["WDT"], val : NonSpare_2051_Arg) -> "Variation_1483":
        ...
    @overload
    def set_item(self, key : Literal["HGT"], val : NonSpare_1062_Arg) -> "Variation_1483":
        ...
    @overload
    def set_item(self, key : Literal["ORT"], val : NonSpare_1395_Arg) -> "Variation_1483":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["LEN"]) -> "Variation_1483":
        ...
    @overload
    def del_item(self, key : Literal["WDT"]) -> "Variation_1483":
        ...
    @overload
    def del_item(self, key : Literal["HGT"]) -> "Variation_1483":
        ...
    @overload
    def del_item(self, key : Literal["ORT"]) -> "Variation_1483":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1483_Arg) -> 'Variation_1483':
        return cls._create(arg) # type: ignore

RuleVariation_1406_Arg: TypeAlias = Variation_1483_Arg
class RuleVariation_1406(RuleVariationContextFree):
    cv_variation = Variation_1483

    @classmethod
    def create(cls, arg : RuleVariation_1406_Arg) -> "RuleVariation_1406":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1483:
        return self.arg # type: ignore

NonSpare_455_Arg: TypeAlias = RuleVariation_1406_Arg
class NonSpare_455(NonSpare):
    cv_name = "270"
    cv_title = "Target Size & Orientation"
    cv_rule = RuleVariation_1406

    @classmethod
    def create(cls, arg : NonSpare_455_Arg) -> "NonSpare_455":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1406:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1483:
        return self.rule.variation

class UapItem_455(UapItem):
    cv_non_spare = NonSpare_455

Variation_244_Arg: TypeAlias = RuleContent_610_Arg
class Variation_244(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 9
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_244_Arg) -> "Variation_244":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_237_Arg: TypeAlias = Variation_244_Arg
class RuleVariation_237(RuleVariationContextFree):
    cv_variation = Variation_244

    @classmethod
    def create(cls, arg : RuleVariation_237_Arg) -> "RuleVariation_237":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_244:
        return self.arg # type: ignore

NonSpare_737_Arg: TypeAlias = RuleVariation_237_Arg
class NonSpare_737(NonSpare):
    cv_name = "CLS"
    cv_title = "Classification"
    cv_rule = RuleVariation_237

    @classmethod
    def create(cls, arg : NonSpare_737_Arg) -> "NonSpare_737":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_237:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_244:
        return self.rule.variation

Item_162_Arg: TypeAlias = NonSpare_737_Arg
class Item_162(Item):
    cv_non_spare = NonSpare_737

    @classmethod
    def create(cls, arg : Item_162_Arg) -> "Item_162":
        return cls._create(arg) # type: ignore

Variation_494_Arg: TypeAlias = RuleContent_610_Arg
class Variation_494(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 7
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_494_Arg) -> "Variation_494":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_483_Arg: TypeAlias = Variation_494_Arg
class RuleVariation_483(RuleVariationContextFree):
    cv_variation = Variation_494

    @classmethod
    def create(cls, arg : RuleVariation_483_Arg) -> "RuleVariation_483":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_494:
        return self.arg # type: ignore

NonSpare_1448_Arg: TypeAlias = RuleVariation_483_Arg
class NonSpare_1448(NonSpare):
    cv_name = "PRB"
    cv_title = "Probability"
    cv_rule = RuleVariation_483

    @classmethod
    def create(cls, arg : NonSpare_1448_Arg) -> "NonSpare_1448":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_483:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_494:
        return self.rule.variation

Item_697_Arg: TypeAlias = NonSpare_1448_Arg
class Item_697(Item):
    cv_non_spare = NonSpare_1448

    @classmethod
    def create(cls, arg : Item_697_Arg) -> "Item_697":
        return cls._create(arg) # type: ignore

Variation_1067_Arg_Group = Tuple[Union[RuleVariation_237_Arg, Tuple[Literal["CLS"], RuleVariation_237_Arg]], Union[RuleVariation_483_Arg, Tuple[Literal["PRB"], RuleVariation_483_Arg]]]
Variation_1067_Arg: TypeAlias = Union[int, Variation_1067_Arg_Group]
class Variation_1067(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_162, 9), (Item_697, 7)]
    cv_items_dict = {"CLS": RuleVariation_237, "PRB": RuleVariation_483}

    @overload
    @classmethod
    def spec(cls, key : Literal["CLS"]) -> RuleVariation_237:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PRB"]) -> RuleVariation_483:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CLS"], Literal["PRB"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CLS"]) -> RuleVariation_237:
        ...
    @overload
    def get_item(self, key : Literal["PRB"]) -> RuleVariation_483:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1067_Arg) -> 'Variation_1067':
        return cls._create(arg) # type: ignore

Variation_1408_Arg: TypeAlias = List[Variation_1067_Arg]
class Variation_1408(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1067

    @classmethod
    def create(cls, arg : Variation_1408_Arg) -> 'Variation_1408':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1067]:
        return self._get_list() # type: ignore

RuleVariation_1331_Arg: TypeAlias = Variation_1408_Arg
class RuleVariation_1331(RuleVariationContextFree):
    cv_variation = Variation_1408

    @classmethod
    def create(cls, arg : RuleVariation_1331_Arg) -> "RuleVariation_1331":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1408:
        return self.arg # type: ignore

NonSpare_469_Arg: TypeAlias = RuleVariation_1331_Arg
class NonSpare_469(NonSpare):
    cv_name = "300"
    cv_title = "Object Classification"
    cv_rule = RuleVariation_1331

    @classmethod
    def create(cls, arg : NonSpare_469_Arg) -> "NonSpare_469":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1331:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1408:
        return self.rule.variation

class UapItem_469(UapItem):
    cv_non_spare = NonSpare_469

NonSpare_1420_Arg: TypeAlias = RuleVariation_247_Arg
class NonSpare_1420(NonSpare):
    cv_name = "PID"
    cv_title = "Pair Identifier"
    cv_rule = RuleVariation_247

    @classmethod
    def create(cls, arg : NonSpare_1420_Arg) -> "NonSpare_1420":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_247:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_254:
        return self.rule.variation

Item_680_Arg: TypeAlias = NonSpare_1420_Arg
class Item_680(Item):
    cv_non_spare = NonSpare_1420

    @classmethod
    def create(cls, arg : Item_680_Arg) -> "Item_680":
        return cls._create(arg) # type: ignore

Variation_349_Arg: TypeAlias = RuleContent_610_Arg
class Variation_349(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_349_Arg) -> "Variation_349":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_342_Arg: TypeAlias = Variation_349_Arg
class RuleVariation_342(RuleVariationContextFree):
    cv_variation = Variation_349

    @classmethod
    def create(cls, arg : RuleVariation_342_Arg) -> "RuleVariation_342":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_349:
        return self.arg # type: ignore

NonSpare_1388_Arg: TypeAlias = RuleVariation_342_Arg
class NonSpare_1388(NonSpare):
    cv_name = "ON"
    cv_title = "Observation Number"
    cv_rule = RuleVariation_342

    @classmethod
    def create(cls, arg : NonSpare_1388_Arg) -> "NonSpare_1388":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_342:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_349:
        return self.rule.variation

Item_653_Arg: TypeAlias = NonSpare_1388_Arg
class Item_653(Item):
    cv_non_spare = NonSpare_1388

    @classmethod
    def create(cls, arg : Item_653_Arg) -> "Item_653":
        return cls._create(arg) # type: ignore

Variation_1152_Arg_Group = Tuple[Union[RuleVariation_247_Arg, Tuple[Literal["PID"], RuleVariation_247_Arg]], Union[RuleVariation_342_Arg, Tuple[Literal["ON"], RuleVariation_342_Arg]]]
Variation_1152_Arg: TypeAlias = Union[int, Variation_1152_Arg_Group]
class Variation_1152(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_items_list = [(Item_680, 16), (Item_653, 24)]
    cv_items_dict = {"PID": RuleVariation_247, "ON": RuleVariation_342}

    @overload
    @classmethod
    def spec(cls, key : Literal["PID"]) -> RuleVariation_247:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ON"]) -> RuleVariation_342:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PID"], Literal["ON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PID"]) -> RuleVariation_247:
        ...
    @overload
    def get_item(self, key : Literal["ON"]) -> RuleVariation_342:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1152_Arg) -> 'Variation_1152':
        return cls._create(arg) # type: ignore

RuleVariation_1105_Arg: TypeAlias = Variation_1152_Arg
class RuleVariation_1105(RuleVariationContextFree):
    cv_variation = Variation_1152

    @classmethod
    def create(cls, arg : RuleVariation_1105_Arg) -> "RuleVariation_1105":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1152:
        return self.arg # type: ignore

NonSpare_493_Arg: TypeAlias = RuleVariation_1105_Arg
class NonSpare_493(NonSpare):
    cv_name = "400"
    cv_title = "Measurement Identifier"
    cv_rule = RuleVariation_1105

    @classmethod
    def create(cls, arg : NonSpare_493_Arg) -> "NonSpare_493":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1105:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1152:
        return self.rule.variation

class UapItem_492(UapItem):
    cv_non_spare = NonSpare_493

Content_701_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_701(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 8.381903171539307e-8
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_701_Arg: TypeAlias = Content_701_Arg
class RuleContent_701(RuleContentContextFree):
    cv_content = Content_701

    @property
    def content(self) -> Content_701:
        return self._get_content() # type: ignore

Variation_380_Arg: TypeAlias = RuleContent_701_Arg
class Variation_380(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_701

    @classmethod
    def create(cls, arg : Variation_380_Arg) -> "Variation_380":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_701:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_701:
        return self.rule.content

RuleVariation_373_Arg: TypeAlias = Variation_380_Arg
class RuleVariation_373(RuleVariationContextFree):
    cv_variation = Variation_380

    @classmethod
    def create(cls, arg : RuleVariation_373_Arg) -> "RuleVariation_373":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_380:
        return self.arg # type: ignore

NonSpare_1153_Arg: TypeAlias = RuleVariation_373_Arg
class NonSpare_1153(NonSpare):
    cv_name = "LATITUDE"
    cv_title = ""
    cv_rule = RuleVariation_373

    @classmethod
    def create(cls, arg : NonSpare_1153_Arg) -> "NonSpare_1153":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_373:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_380:
        return self.rule.variation

Item_471_Arg: TypeAlias = NonSpare_1153_Arg
class Item_471(Item):
    cv_non_spare = NonSpare_1153

    @classmethod
    def create(cls, arg : Item_471_Arg) -> "Item_471":
        return cls._create(arg) # type: ignore

NonSpare_1183_Arg: TypeAlias = RuleVariation_372_Arg
class NonSpare_1183(NonSpare):
    cv_name = "LONGITUDE"
    cv_title = ""
    cv_rule = RuleVariation_372

    @classmethod
    def create(cls, arg : NonSpare_1183_Arg) -> "NonSpare_1183":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_372:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_379:
        return self.rule.variation

Item_499_Arg: TypeAlias = NonSpare_1183_Arg
class Item_499(Item):
    cv_non_spare = NonSpare_1183

    @classmethod
    def create(cls, arg : Item_499_Arg) -> "Item_499":
        return cls._create(arg) # type: ignore

Variation_1131_Arg_Group = Tuple[Union[RuleVariation_373_Arg, Tuple[Literal["LATITUDE"], RuleVariation_373_Arg]], Union[RuleVariation_372_Arg, Tuple[Literal["LONGITUDE"], RuleVariation_372_Arg]]]
Variation_1131_Arg: TypeAlias = Union[int, Variation_1131_Arg_Group]
class Variation_1131(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_471, 32), (Item_499, 32)]
    cv_items_dict = {"LATITUDE": RuleVariation_373, "LONGITUDE": RuleVariation_372}

    @overload
    @classmethod
    def spec(cls, key : Literal["LATITUDE"]) -> RuleVariation_373:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LONGITUDE"]) -> RuleVariation_372:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LATITUDE"], Literal["LONGITUDE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LATITUDE"]) -> RuleVariation_373:
        ...
    @overload
    def get_item(self, key : Literal["LONGITUDE"]) -> RuleVariation_372:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1131_Arg) -> 'Variation_1131':
        return cls._create(arg) # type: ignore

RuleVariation_1088_Arg: TypeAlias = Variation_1131_Arg
class RuleVariation_1088(RuleVariationContextFree):
    cv_variation = Variation_1131

    @classmethod
    def create(cls, arg : RuleVariation_1088_Arg) -> "RuleVariation_1088":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1131:
        return self.arg # type: ignore

NonSpare_1408_Arg: TypeAlias = RuleVariation_1088_Arg
class NonSpare_1408(NonSpare):
    cv_name = "P84"
    cv_title = "Horizontal Position in WGS-84 Coordinates"
    cv_rule = RuleVariation_1088

    @classmethod
    def create(cls, arg : NonSpare_1408_Arg) -> "NonSpare_1408":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1088:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1131:
        return self.rule.variation

Content_730_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_730(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.5
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_730_Arg: TypeAlias = Content_730_Arg
class RuleContent_730(RuleContentContextFree):
    cv_content = Content_730

    @property
    def content(self) -> Content_730:
        return self._get_content() # type: ignore

Variation_310_Arg: TypeAlias = RuleContent_730_Arg
class Variation_310(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_730

    @classmethod
    def create(cls, arg : Variation_310_Arg) -> "Variation_310":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_730:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_730:
        return self.rule.content

RuleVariation_303_Arg: TypeAlias = Variation_310_Arg
class RuleVariation_303(RuleVariationContextFree):
    cv_variation = Variation_310

    @classmethod
    def create(cls, arg : RuleVariation_303_Arg) -> "RuleVariation_303":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_310:
        return self.arg # type: ignore

NonSpare_1609_Arg: TypeAlias = RuleVariation_303_Arg
class NonSpare_1609(NonSpare):
    cv_name = "RSHPX"
    cv_title = ""
    cv_rule = RuleVariation_303

    @classmethod
    def create(cls, arg : NonSpare_1609_Arg) -> "NonSpare_1609":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_303:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_310:
        return self.rule.variation

Item_830_Arg: TypeAlias = NonSpare_1609_Arg
class Item_830(Item):
    cv_non_spare = NonSpare_1609

    @classmethod
    def create(cls, arg : Item_830_Arg) -> "Item_830":
        return cls._create(arg) # type: ignore

NonSpare_1610_Arg: TypeAlias = RuleVariation_303_Arg
class NonSpare_1610(NonSpare):
    cv_name = "RSHPY"
    cv_title = ""
    cv_rule = RuleVariation_303

    @classmethod
    def create(cls, arg : NonSpare_1610_Arg) -> "NonSpare_1610":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_303:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_310:
        return self.rule.variation

Item_831_Arg: TypeAlias = NonSpare_1610_Arg
class Item_831(Item):
    cv_non_spare = NonSpare_1610

    @classmethod
    def create(cls, arg : Item_831_Arg) -> "Item_831":
        return cls._create(arg) # type: ignore

Content_673_Arg: TypeAlias = Union[int, float, Tuple[float, Literal[""]]]
class Content_673(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 7.8125e-3
    cv_unit = ""

    def as_quantity(self, cv_unit : Optional[Literal[""]] = None) -> float:
        return self._as_quantity()

RuleContent_673_Arg: TypeAlias = Content_673_Arg
class RuleContent_673(RuleContentContextFree):
    cv_content = Content_673

    @property
    def content(self) -> Content_673:
        return self._get_content() # type: ignore

Variation_212_Arg: TypeAlias = RuleContent_673_Arg
class Variation_212(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_673

    @classmethod
    def create(cls, arg : Variation_212_Arg) -> "Variation_212":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_673:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_673:
        return self.rule.content

RuleVariation_205_Arg: TypeAlias = Variation_212_Arg
class RuleVariation_205(RuleVariationContextFree):
    cv_variation = Variation_212

    @classmethod
    def create(cls, arg : RuleVariation_205_Arg) -> "RuleVariation_205":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_212:
        return self.arg # type: ignore

NonSpare_789_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_789(NonSpare):
    cv_name = "CORSHPXY"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_789_Arg) -> "NonSpare_789":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_194_Arg: TypeAlias = NonSpare_789_Arg
class Item_194(Item):
    cv_non_spare = NonSpare_789

    @classmethod
    def create(cls, arg : Item_194_Arg) -> "Item_194":
        return cls._create(arg) # type: ignore

Variation_1180_Arg_Group = Tuple[Union[RuleVariation_303_Arg, Tuple[Literal["RSHPX"], RuleVariation_303_Arg]], Union[RuleVariation_303_Arg, Tuple[Literal["RSHPY"], RuleVariation_303_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["CORSHPXY"], RuleVariation_205_Arg]]]
Variation_1180_Arg: TypeAlias = Union[int, Variation_1180_Arg_Group]
class Variation_1180(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_items_list = [(Item_830, 16), (Item_831, 16), (Item_194, 8)]
    cv_items_dict = {"RSHPX": RuleVariation_303, "RSHPY": RuleVariation_303, "CORSHPXY": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["RSHPX"]) -> RuleVariation_303:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSHPY"]) -> RuleVariation_303:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CORSHPXY"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RSHPX"], Literal["RSHPY"], Literal["CORSHPXY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RSHPX"]) -> RuleVariation_303:
        ...
    @overload
    def get_item(self, key : Literal["RSHPY"]) -> RuleVariation_303:
        ...
    @overload
    def get_item(self, key : Literal["CORSHPXY"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1180_Arg) -> 'Variation_1180':
        return cls._create(arg) # type: ignore

RuleVariation_1131_Arg: TypeAlias = Variation_1180_Arg
class RuleVariation_1131(RuleVariationContextFree):
    cv_variation = Variation_1180

    @classmethod
    def create(cls, arg : RuleVariation_1131_Arg) -> "RuleVariation_1131":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1180:
        return self.arg # type: ignore

NonSpare_1072_Arg: TypeAlias = RuleVariation_1131_Arg
class NonSpare_1072(NonSpare):
    cv_name = "HPR"
    cv_title = "Horizontal Position Resolution"
    cv_rule = RuleVariation_1131

    @classmethod
    def create(cls, arg : NonSpare_1072_Arg) -> "NonSpare_1072":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1131:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1180:
        return self.rule.variation

Content_753_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_753(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.25
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_752_Arg: TypeAlias = Content_753_Arg
class RuleContent_752(RuleContentContextFree):
    cv_content = Content_753

    @property
    def content(self) -> Content_753:
        return self._get_content() # type: ignore

Variation_323_Arg: TypeAlias = RuleContent_752_Arg
class Variation_323(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_752

    @classmethod
    def create(cls, arg : Variation_323_Arg) -> "Variation_323":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_752:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_753:
        return self.rule.content

RuleVariation_316_Arg: TypeAlias = Variation_323_Arg
class RuleVariation_316(RuleVariationContextFree):
    cv_variation = Variation_323

    @classmethod
    def create(cls, arg : RuleVariation_316_Arg) -> "RuleVariation_316":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_323:
        return self.arg # type: ignore

NonSpare_1676_Arg: TypeAlias = RuleVariation_316_Arg
class NonSpare_1676(NonSpare):
    cv_name = "SDHPX"
    cv_title = ""
    cv_rule = RuleVariation_316

    @classmethod
    def create(cls, arg : NonSpare_1676_Arg) -> "NonSpare_1676":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_316:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_323:
        return self.rule.variation

Item_867_Arg: TypeAlias = NonSpare_1676_Arg
class Item_867(Item):
    cv_non_spare = NonSpare_1676

    @classmethod
    def create(cls, arg : Item_867_Arg) -> "Item_867":
        return cls._create(arg) # type: ignore

NonSpare_1677_Arg: TypeAlias = RuleVariation_316_Arg
class NonSpare_1677(NonSpare):
    cv_name = "SDHPY"
    cv_title = ""
    cv_rule = RuleVariation_316

    @classmethod
    def create(cls, arg : NonSpare_1677_Arg) -> "NonSpare_1677":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_316:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_323:
        return self.rule.variation

Item_868_Arg: TypeAlias = NonSpare_1677_Arg
class Item_868(Item):
    cv_non_spare = NonSpare_1677

    @classmethod
    def create(cls, arg : Item_868_Arg) -> "Item_868":
        return cls._create(arg) # type: ignore

NonSpare_791_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_791(NonSpare):
    cv_name = "COSDHPXY"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_791_Arg) -> "NonSpare_791":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_196_Arg: TypeAlias = NonSpare_791_Arg
class Item_196(Item):
    cv_non_spare = NonSpare_791

    @classmethod
    def create(cls, arg : Item_196_Arg) -> "Item_196":
        return cls._create(arg) # type: ignore

Variation_1199_Arg_Group = Tuple[Union[RuleVariation_316_Arg, Tuple[Literal["SDHPX"], RuleVariation_316_Arg]], Union[RuleVariation_316_Arg, Tuple[Literal["SDHPY"], RuleVariation_316_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["COSDHPXY"], RuleVariation_205_Arg]]]
Variation_1199_Arg: TypeAlias = Union[int, Variation_1199_Arg_Group]
class Variation_1199(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_items_list = [(Item_867, 16), (Item_868, 16), (Item_196, 8)]
    cv_items_dict = {"SDHPX": RuleVariation_316, "SDHPY": RuleVariation_316, "COSDHPXY": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["SDHPX"]) -> RuleVariation_316:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDHPY"]) -> RuleVariation_316:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COSDHPXY"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SDHPX"], Literal["SDHPY"], Literal["COSDHPXY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SDHPX"]) -> RuleVariation_316:
        ...
    @overload
    def get_item(self, key : Literal["SDHPY"]) -> RuleVariation_316:
        ...
    @overload
    def get_item(self, key : Literal["COSDHPXY"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1199_Arg) -> 'Variation_1199':
        return cls._create(arg) # type: ignore

RuleVariation_1144_Arg: TypeAlias = Variation_1199_Arg
class RuleVariation_1144(RuleVariationContextFree):
    cv_variation = Variation_1199

    @classmethod
    def create(cls, arg : RuleVariation_1144_Arg) -> "RuleVariation_1144":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1199:
        return self.arg # type: ignore

NonSpare_1068_Arg: TypeAlias = RuleVariation_1144_Arg
class NonSpare_1068(NonSpare):
    cv_name = "HPP"
    cv_title = "Horizontal Position Precision"
    cv_rule = RuleVariation_1144

    @classmethod
    def create(cls, arg : NonSpare_1068_Arg) -> "NonSpare_1068":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1144:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1199:
        return self.rule.variation

Variation_1487_Arg = TypedDict('Variation_1487_Arg', {
    "P84": NonSpare_1408_Arg,
    "HPR": NonSpare_1072_Arg,
    "HPP": NonSpare_1068_Arg,
}, total=False)
class Variation_1487(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1408, NonSpare_1072, NonSpare_1068]
    cv_items_dict = {"P84": NonSpare_1408, "HPR": NonSpare_1072, "HPP": NonSpare_1068}

    @overload
    @classmethod
    def spec(cls, key : Literal["P84"]) -> NonSpare_1408:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HPR"]) -> NonSpare_1072:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HPP"]) -> NonSpare_1068:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["P84"], Literal["HPR"], Literal["HPP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["P84"]) -> Optional[NonSpare_1408]:
        ...
    @overload
    def get_item(self, key : Literal["HPR"]) -> Optional[NonSpare_1072]:
        ...
    @overload
    def get_item(self, key : Literal["HPP"]) -> Optional[NonSpare_1068]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["P84"], val : NonSpare_1408_Arg) -> "Variation_1487":
        ...
    @overload
    def set_item(self, key : Literal["HPR"], val : NonSpare_1072_Arg) -> "Variation_1487":
        ...
    @overload
    def set_item(self, key : Literal["HPP"], val : NonSpare_1068_Arg) -> "Variation_1487":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["P84"]) -> "Variation_1487":
        ...
    @overload
    def del_item(self, key : Literal["HPR"]) -> "Variation_1487":
        ...
    @overload
    def del_item(self, key : Literal["HPP"]) -> "Variation_1487":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1487_Arg) -> 'Variation_1487':
        return cls._create(arg) # type: ignore

RuleVariation_1410_Arg: TypeAlias = Variation_1487_Arg
class RuleVariation_1410(RuleVariationContextFree):
    cv_variation = Variation_1487

    @classmethod
    def create(cls, arg : RuleVariation_1410_Arg) -> "RuleVariation_1410":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1487:
        return self.arg # type: ignore

NonSpare_524_Arg: TypeAlias = RuleVariation_1410_Arg
class NonSpare_524(NonSpare):
    cv_name = "600"
    cv_title = "Horizontal Position Information"
    cv_rule = RuleVariation_1410

    @classmethod
    def create(cls, arg : NonSpare_524_Arg) -> "NonSpare_524":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1410:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1487:
        return self.rule.variation

class UapItem_523(UapItem):
    cv_non_spare = NonSpare_524

Content_642_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_642(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.0e-2
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_642_Arg: TypeAlias = Content_642_Arg
class RuleContent_642(RuleContentContextFree):
    cv_content = Content_642

    @property
    def content(self) -> Content_642:
        return self._get_content() # type: ignore

Variation_354_Arg: TypeAlias = RuleContent_642_Arg
class Variation_354(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_642

    @classmethod
    def create(cls, arg : Variation_354_Arg) -> "Variation_354":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_642:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_642:
        return self.rule.content

RuleVariation_347_Arg: TypeAlias = Variation_354_Arg
class RuleVariation_347(RuleVariationContextFree):
    cv_variation = Variation_354

    @classmethod
    def create(cls, arg : RuleVariation_347_Arg) -> "RuleVariation_347":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_354:
        return self.arg # type: ignore

NonSpare_1025_Arg: TypeAlias = RuleVariation_347_Arg
class NonSpare_1025(NonSpare):
    cv_name = "GH"
    cv_title = "Geometric Height (WGS-84)"
    cv_rule = RuleVariation_347

    @classmethod
    def create(cls, arg : NonSpare_1025_Arg) -> "NonSpare_1025":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_347:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_354:
        return self.rule.variation

Content_741_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_741(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0e-2
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_741_Arg: TypeAlias = Content_741_Arg
class RuleContent_741(RuleContentContextFree):
    cv_content = Content_741

    @property
    def content(self) -> Content_741:
        return self._get_content() # type: ignore

Variation_367_Arg: TypeAlias = RuleContent_741_Arg
class Variation_367(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_741

    @classmethod
    def create(cls, arg : Variation_367_Arg) -> "Variation_367":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_741:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_741:
        return self.rule.content

RuleVariation_360_Arg: TypeAlias = Variation_367_Arg
class RuleVariation_360(RuleVariationContextFree):
    cv_variation = Variation_367

    @classmethod
    def create(cls, arg : RuleVariation_360_Arg) -> "RuleVariation_360":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_367:
        return self.arg # type: ignore

NonSpare_1608_Arg: TypeAlias = RuleVariation_360_Arg
class NonSpare_1608(NonSpare):
    cv_name = "RSGH"
    cv_title = "Geometric Height Resolution"
    cv_rule = RuleVariation_360

    @classmethod
    def create(cls, arg : NonSpare_1608_Arg) -> "NonSpare_1608":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_360:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_367:
        return self.rule.variation

NonSpare_1673_Arg: TypeAlias = RuleVariation_360_Arg
class NonSpare_1673(NonSpare):
    cv_name = "SDGH"
    cv_title = "Geometric Height Precision"
    cv_rule = RuleVariation_360

    @classmethod
    def create(cls, arg : NonSpare_1673_Arg) -> "NonSpare_1673":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_360:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_367:
        return self.rule.variation

Content_725_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_725(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 16.0
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_725_Arg: TypeAlias = Content_725_Arg
class RuleContent_725(RuleContentContextFree):
    cv_content = Content_725

    @property
    def content(self) -> Content_725:
        return self._get_content() # type: ignore

Variation_246_Arg: TypeAlias = RuleContent_725_Arg
class Variation_246(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 12
    cv_rule = RuleContent_725

    @classmethod
    def create(cls, arg : Variation_246_Arg) -> "Variation_246":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_725:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_725:
        return self.rule.content

RuleVariation_239_Arg: TypeAlias = Variation_246_Arg
class RuleVariation_239(RuleVariationContextFree):
    cv_variation = Variation_246

    @classmethod
    def create(cls, arg : RuleVariation_239_Arg) -> "RuleVariation_239":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_246:
        return self.arg # type: ignore

NonSpare_1974_Arg: TypeAlias = RuleVariation_239_Arg
class NonSpare_1974(NonSpare):
    cv_name = "UCI6"
    cv_title = ""
    cv_rule = RuleVariation_239

    @classmethod
    def create(cls, arg : NonSpare_1974_Arg) -> "NonSpare_1974":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_239:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_246:
        return self.rule.variation

Item_1092_Arg: TypeAlias = NonSpare_1974_Arg
class Item_1092(Item):
    cv_non_spare = NonSpare_1974

    @classmethod
    def create(cls, arg : Item_1092_Arg) -> "Item_1092":
        return cls._create(arg) # type: ignore

Variation_808_Arg: TypeAlias = RuleContent_725_Arg
class Variation_808(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 12
    cv_rule = RuleContent_725

    @classmethod
    def create(cls, arg : Variation_808_Arg) -> "Variation_808":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_725:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_725:
        return self.rule.content

RuleVariation_778_Arg: TypeAlias = Variation_808_Arg
class RuleVariation_778(RuleVariationContextFree):
    cv_variation = Variation_808

    @classmethod
    def create(cls, arg : RuleVariation_778_Arg) -> "RuleVariation_778":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_808:
        return self.arg # type: ignore

NonSpare_1154_Arg: TypeAlias = RuleVariation_778_Arg
class NonSpare_1154(NonSpare):
    cv_name = "LCI6"
    cv_title = ""
    cv_rule = RuleVariation_778

    @classmethod
    def create(cls, arg : NonSpare_1154_Arg) -> "NonSpare_1154":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_778:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_808:
        return self.rule.variation

Item_472_Arg: TypeAlias = NonSpare_1154_Arg
class Item_472(Item):
    cv_non_spare = NonSpare_1154

    @classmethod
    def create(cls, arg : Item_472_Arg) -> "Item_472":
        return cls._create(arg) # type: ignore

Variation_1240_Arg_Group = Tuple[Union[RuleVariation_239_Arg, Tuple[Literal["UCI6"], RuleVariation_239_Arg]], Union[RuleVariation_778_Arg, Tuple[Literal["LCI6"], RuleVariation_778_Arg]]]
Variation_1240_Arg: TypeAlias = Union[int, Variation_1240_Arg_Group]
class Variation_1240(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_1092, 12), (Item_472, 12)]
    cv_items_dict = {"UCI6": RuleVariation_239, "LCI6": RuleVariation_778}

    @overload
    @classmethod
    def spec(cls, key : Literal["UCI6"]) -> RuleVariation_239:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LCI6"]) -> RuleVariation_778:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["UCI6"], Literal["LCI6"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["UCI6"]) -> RuleVariation_239:
        ...
    @overload
    def get_item(self, key : Literal["LCI6"]) -> RuleVariation_778:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1240_Arg) -> 'Variation_1240':
        return cls._create(arg) # type: ignore

RuleVariation_1170_Arg: TypeAlias = Variation_1240_Arg
class RuleVariation_1170(RuleVariationContextFree):
    cv_variation = Variation_1240

    @classmethod
    def create(cls, arg : RuleVariation_1170_Arg) -> "RuleVariation_1170":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1240:
        return self.arg # type: ignore

NonSpare_732_Arg: TypeAlias = RuleVariation_1170_Arg
class NonSpare_732(NonSpare):
    cv_name = "CI6"
    cv_title = "Confidence Interval for Geometric Height (67%)"
    cv_rule = RuleVariation_1170

    @classmethod
    def create(cls, arg : NonSpare_732_Arg) -> "NonSpare_732":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1170:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1240:
        return self.rule.variation

NonSpare_1975_Arg: TypeAlias = RuleVariation_239_Arg
class NonSpare_1975(NonSpare):
    cv_name = "UCI9"
    cv_title = ""
    cv_rule = RuleVariation_239

    @classmethod
    def create(cls, arg : NonSpare_1975_Arg) -> "NonSpare_1975":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_239:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_246:
        return self.rule.variation

Item_1093_Arg: TypeAlias = NonSpare_1975_Arg
class Item_1093(Item):
    cv_non_spare = NonSpare_1975

    @classmethod
    def create(cls, arg : Item_1093_Arg) -> "Item_1093":
        return cls._create(arg) # type: ignore

NonSpare_1155_Arg: TypeAlias = RuleVariation_778_Arg
class NonSpare_1155(NonSpare):
    cv_name = "LCI9"
    cv_title = ""
    cv_rule = RuleVariation_778

    @classmethod
    def create(cls, arg : NonSpare_1155_Arg) -> "NonSpare_1155":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_778:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_808:
        return self.rule.variation

Item_473_Arg: TypeAlias = NonSpare_1155_Arg
class Item_473(Item):
    cv_non_spare = NonSpare_1155

    @classmethod
    def create(cls, arg : Item_473_Arg) -> "Item_473":
        return cls._create(arg) # type: ignore

Variation_1241_Arg_Group = Tuple[Union[RuleVariation_239_Arg, Tuple[Literal["UCI9"], RuleVariation_239_Arg]], Union[RuleVariation_778_Arg, Tuple[Literal["LCI9"], RuleVariation_778_Arg]]]
Variation_1241_Arg: TypeAlias = Union[int, Variation_1241_Arg_Group]
class Variation_1241(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_1093, 12), (Item_473, 12)]
    cv_items_dict = {"UCI9": RuleVariation_239, "LCI9": RuleVariation_778}

    @overload
    @classmethod
    def spec(cls, key : Literal["UCI9"]) -> RuleVariation_239:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LCI9"]) -> RuleVariation_778:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["UCI9"], Literal["LCI9"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["UCI9"]) -> RuleVariation_239:
        ...
    @overload
    def get_item(self, key : Literal["LCI9"]) -> RuleVariation_778:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1241_Arg) -> 'Variation_1241':
        return cls._create(arg) # type: ignore

RuleVariation_1171_Arg: TypeAlias = Variation_1241_Arg
class RuleVariation_1171(RuleVariationContextFree):
    cv_variation = Variation_1241

    @classmethod
    def create(cls, arg : RuleVariation_1171_Arg) -> "RuleVariation_1171":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1241:
        return self.arg # type: ignore

NonSpare_733_Arg: TypeAlias = RuleVariation_1171_Arg
class NonSpare_733(NonSpare):
    cv_name = "CI9"
    cv_title = "Confidence Interval for Geometric Height (95%)"
    cv_rule = RuleVariation_1171

    @classmethod
    def create(cls, arg : NonSpare_733_Arg) -> "NonSpare_733":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1171:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1241:
        return self.rule.variation

NonSpare_2062_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2062(NonSpare):
    cv_name = "X"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2062_Arg) -> "NonSpare_2062":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1169_Arg: TypeAlias = NonSpare_2062_Arg
class Item_1169(Item):
    cv_non_spare = NonSpare_2062

    @classmethod
    def create(cls, arg : Item_1169_Arg) -> "Item_1169":
        return cls._create(arg) # type: ignore

NonSpare_2115_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2115(NonSpare):
    cv_name = "Y"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2115_Arg) -> "NonSpare_2115":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1219_Arg: TypeAlias = NonSpare_2115_Arg
class Item_1219(Item):
    cv_non_spare = NonSpare_2115

    @classmethod
    def create(cls, arg : Item_1219_Arg) -> "Item_1219":
        return cls._create(arg) # type: ignore

Variation_1279_Arg_Group = Tuple[Union[RuleVariation_205_Arg, Tuple[Literal["X"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["Y"], RuleVariation_205_Arg]]]
Variation_1279_Arg: TypeAlias = Union[int, Variation_1279_Arg_Group]
class Variation_1279(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1169, 8), (Item_1219, 8)]
    cv_items_dict = {"X": RuleVariation_205, "Y": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1279_Arg) -> 'Variation_1279':
        return cls._create(arg) # type: ignore

RuleVariation_1209_Arg: TypeAlias = Variation_1279_Arg
class RuleVariation_1209(RuleVariationContextFree):
    cv_variation = Variation_1279

    @classmethod
    def create(cls, arg : RuleVariation_1209_Arg) -> "RuleVariation_1209":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1279:
        return self.arg # type: ignore

NonSpare_756_Arg: TypeAlias = RuleVariation_1209_Arg
class NonSpare_756(NonSpare):
    cv_name = "COGHHP"
    cv_title = "Correlation of Geometric Height and Horizontal Position"
    cv_rule = RuleVariation_1209

    @classmethod
    def create(cls, arg : NonSpare_756_Arg) -> "NonSpare_756":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1209:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1279:
        return self.rule.variation

NonSpare_2063_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2063(NonSpare):
    cv_name = "X"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2063_Arg) -> "NonSpare_2063":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1170_Arg: TypeAlias = NonSpare_2063_Arg
class Item_1170(Item):
    cv_non_spare = NonSpare_2063

    @classmethod
    def create(cls, arg : Item_1170_Arg) -> "Item_1170":
        return cls._create(arg) # type: ignore

NonSpare_2116_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2116(NonSpare):
    cv_name = "Y"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2116_Arg) -> "NonSpare_2116":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1220_Arg: TypeAlias = NonSpare_2116_Arg
class Item_1220(Item):
    cv_non_spare = NonSpare_2116

    @classmethod
    def create(cls, arg : Item_1220_Arg) -> "Item_1220":
        return cls._create(arg) # type: ignore

Variation_1280_Arg_Group = Tuple[Union[RuleVariation_205_Arg, Tuple[Literal["X"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["Y"], RuleVariation_205_Arg]]]
Variation_1280_Arg: TypeAlias = Union[int, Variation_1280_Arg_Group]
class Variation_1280(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1170, 8), (Item_1220, 8)]
    cv_items_dict = {"X": RuleVariation_205, "Y": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1280_Arg) -> 'Variation_1280':
        return cls._create(arg) # type: ignore

RuleVariation_1210_Arg: TypeAlias = Variation_1280_Arg
class RuleVariation_1210(RuleVariationContextFree):
    cv_variation = Variation_1280

    @classmethod
    def create(cls, arg : RuleVariation_1210_Arg) -> "RuleVariation_1210":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1280:
        return self.arg # type: ignore

NonSpare_757_Arg: TypeAlias = RuleVariation_1210_Arg
class NonSpare_757(NonSpare):
    cv_name = "COGHHV"
    cv_title = "Correlation of Geometric Height and Horizontal Velocity"
    cv_rule = RuleVariation_1210

    @classmethod
    def create(cls, arg : NonSpare_757_Arg) -> "NonSpare_757":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1210:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1280:
        return self.rule.variation

NonSpare_2061_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2061(NonSpare):
    cv_name = "X"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2061_Arg) -> "NonSpare_2061":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1168_Arg: TypeAlias = NonSpare_2061_Arg
class Item_1168(Item):
    cv_non_spare = NonSpare_2061

    @classmethod
    def create(cls, arg : Item_1168_Arg) -> "Item_1168":
        return cls._create(arg) # type: ignore

NonSpare_2114_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2114(NonSpare):
    cv_name = "Y"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2114_Arg) -> "NonSpare_2114":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1218_Arg: TypeAlias = NonSpare_2114_Arg
class Item_1218(Item):
    cv_non_spare = NonSpare_2114

    @classmethod
    def create(cls, arg : Item_1218_Arg) -> "Item_1218":
        return cls._create(arg) # type: ignore

Variation_1278_Arg_Group = Tuple[Union[RuleVariation_205_Arg, Tuple[Literal["X"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["Y"], RuleVariation_205_Arg]]]
Variation_1278_Arg: TypeAlias = Union[int, Variation_1278_Arg_Group]
class Variation_1278(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1168, 8), (Item_1218, 8)]
    cv_items_dict = {"X": RuleVariation_205, "Y": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1278_Arg) -> 'Variation_1278':
        return cls._create(arg) # type: ignore

RuleVariation_1208_Arg: TypeAlias = Variation_1278_Arg
class RuleVariation_1208(RuleVariationContextFree):
    cv_variation = Variation_1278

    @classmethod
    def create(cls, arg : RuleVariation_1208_Arg) -> "RuleVariation_1208":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1278:
        return self.arg # type: ignore

NonSpare_755_Arg: TypeAlias = RuleVariation_1208_Arg
class NonSpare_755(NonSpare):
    cv_name = "COGHHA"
    cv_title = "Correlation of Geometric Height and Horizontal Acceleration"
    cv_rule = RuleVariation_1208

    @classmethod
    def create(cls, arg : NonSpare_755_Arg) -> "NonSpare_755":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1208:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1278:
        return self.rule.variation

Variation_1479_Arg = TypedDict('Variation_1479_Arg', {
    "GH": NonSpare_1025_Arg,
    "RSGH": NonSpare_1608_Arg,
    "SDGH": NonSpare_1673_Arg,
    "CI6": NonSpare_732_Arg,
    "CI9": NonSpare_733_Arg,
    "COGHHP": NonSpare_756_Arg,
    "COGHHV": NonSpare_757_Arg,
    "COGHHA": NonSpare_755_Arg,
}, total=False)
class Variation_1479(Compound):
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1025, NonSpare_1608, NonSpare_1673, NonSpare_732, NonSpare_733, NonSpare_756, NonSpare_757, NonSpare_755]
    cv_items_dict = {"GH": NonSpare_1025, "RSGH": NonSpare_1608, "SDGH": NonSpare_1673, "CI6": NonSpare_732, "CI9": NonSpare_733, "COGHHP": NonSpare_756, "COGHHV": NonSpare_757, "COGHHA": NonSpare_755}

    @overload
    @classmethod
    def spec(cls, key : Literal["GH"]) -> NonSpare_1025:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSGH"]) -> NonSpare_1608:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDGH"]) -> NonSpare_1673:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CI6"]) -> NonSpare_732:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CI9"]) -> NonSpare_733:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COGHHP"]) -> NonSpare_756:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COGHHV"]) -> NonSpare_757:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COGHHA"]) -> NonSpare_755:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GH"], Literal["RSGH"], Literal["SDGH"], Literal["CI6"], Literal["CI9"], Literal["COGHHP"], Literal["COGHHV"], Literal["COGHHA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GH"]) -> Optional[NonSpare_1025]:
        ...
    @overload
    def get_item(self, key : Literal["RSGH"]) -> Optional[NonSpare_1608]:
        ...
    @overload
    def get_item(self, key : Literal["SDGH"]) -> Optional[NonSpare_1673]:
        ...
    @overload
    def get_item(self, key : Literal["CI6"]) -> Optional[NonSpare_732]:
        ...
    @overload
    def get_item(self, key : Literal["CI9"]) -> Optional[NonSpare_733]:
        ...
    @overload
    def get_item(self, key : Literal["COGHHP"]) -> Optional[NonSpare_756]:
        ...
    @overload
    def get_item(self, key : Literal["COGHHV"]) -> Optional[NonSpare_757]:
        ...
    @overload
    def get_item(self, key : Literal["COGHHA"]) -> Optional[NonSpare_755]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["GH"], val : NonSpare_1025_Arg) -> "Variation_1479":
        ...
    @overload
    def set_item(self, key : Literal["RSGH"], val : NonSpare_1608_Arg) -> "Variation_1479":
        ...
    @overload
    def set_item(self, key : Literal["SDGH"], val : NonSpare_1673_Arg) -> "Variation_1479":
        ...
    @overload
    def set_item(self, key : Literal["CI6"], val : NonSpare_732_Arg) -> "Variation_1479":
        ...
    @overload
    def set_item(self, key : Literal["CI9"], val : NonSpare_733_Arg) -> "Variation_1479":
        ...
    @overload
    def set_item(self, key : Literal["COGHHP"], val : NonSpare_756_Arg) -> "Variation_1479":
        ...
    @overload
    def set_item(self, key : Literal["COGHHV"], val : NonSpare_757_Arg) -> "Variation_1479":
        ...
    @overload
    def set_item(self, key : Literal["COGHHA"], val : NonSpare_755_Arg) -> "Variation_1479":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["GH"]) -> "Variation_1479":
        ...
    @overload
    def del_item(self, key : Literal["RSGH"]) -> "Variation_1479":
        ...
    @overload
    def del_item(self, key : Literal["SDGH"]) -> "Variation_1479":
        ...
    @overload
    def del_item(self, key : Literal["CI6"]) -> "Variation_1479":
        ...
    @overload
    def del_item(self, key : Literal["CI9"]) -> "Variation_1479":
        ...
    @overload
    def del_item(self, key : Literal["COGHHP"]) -> "Variation_1479":
        ...
    @overload
    def del_item(self, key : Literal["COGHHV"]) -> "Variation_1479":
        ...
    @overload
    def del_item(self, key : Literal["COGHHA"]) -> "Variation_1479":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1479_Arg) -> 'Variation_1479':
        return cls._create(arg) # type: ignore

RuleVariation_1402_Arg: TypeAlias = Variation_1479_Arg
class RuleVariation_1402(RuleVariationContextFree):
    cv_variation = Variation_1479

    @classmethod
    def create(cls, arg : RuleVariation_1402_Arg) -> "RuleVariation_1402":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1479:
        return self.arg # type: ignore

NonSpare_527_Arg: TypeAlias = RuleVariation_1402_Arg
class NonSpare_527(NonSpare):
    cv_name = "601"
    cv_title = "Geometric Height Information"
    cv_rule = RuleVariation_1402

    @classmethod
    def create(cls, arg : NonSpare_527_Arg) -> "NonSpare_527":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1402:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1479:
        return self.rule.variation

class UapItem_526(UapItem):
    cv_non_spare = NonSpare_527

Content_644_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
class Content_644(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.0e-2
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_644_Arg: TypeAlias = Content_644_Arg
class RuleContent_644(RuleContentContextFree):
    cv_content = Content_644

    @property
    def content(self) -> Content_644:
        return self._get_content() # type: ignore

Variation_346_Arg: TypeAlias = RuleContent_644_Arg
class Variation_346(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 20
    cv_rule = RuleContent_644

    @classmethod
    def create(cls, arg : Variation_346_Arg) -> "Variation_346":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_644:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_644:
        return self.rule.content

RuleVariation_339_Arg: TypeAlias = Variation_346_Arg
class RuleVariation_339(RuleVariationContextFree):
    cv_variation = Variation_346

    @classmethod
    def create(cls, arg : RuleVariation_339_Arg) -> "RuleVariation_339":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_346:
        return self.arg # type: ignore

NonSpare_2074_Arg: TypeAlias = RuleVariation_339_Arg
class NonSpare_2074(NonSpare):
    cv_name = "X"
    cv_title = ""
    cv_rule = RuleVariation_339

    @classmethod
    def create(cls, arg : NonSpare_2074_Arg) -> "NonSpare_2074":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_339:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_346:
        return self.rule.variation

Item_1181_Arg: TypeAlias = NonSpare_2074_Arg
class Item_1181(Item):
    cv_non_spare = NonSpare_2074

    @classmethod
    def create(cls, arg : Item_1181_Arg) -> "Item_1181":
        return cls._create(arg) # type: ignore

Variation_812_Arg: TypeAlias = RuleContent_644_Arg
class Variation_812(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 20
    cv_rule = RuleContent_644

    @classmethod
    def create(cls, arg : Variation_812_Arg) -> "Variation_812":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_644:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_644:
        return self.rule.content

RuleVariation_782_Arg: TypeAlias = Variation_812_Arg
class RuleVariation_782(RuleVariationContextFree):
    cv_variation = Variation_812

    @classmethod
    def create(cls, arg : RuleVariation_782_Arg) -> "RuleVariation_782":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_812:
        return self.arg # type: ignore

NonSpare_2127_Arg: TypeAlias = RuleVariation_782_Arg
class NonSpare_2127(NonSpare):
    cv_name = "Y"
    cv_title = ""
    cv_rule = RuleVariation_782

    @classmethod
    def create(cls, arg : NonSpare_2127_Arg) -> "NonSpare_2127":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_782:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_812:
        return self.rule.variation

Item_1231_Arg: TypeAlias = NonSpare_2127_Arg
class Item_1231(Item):
    cv_non_spare = NonSpare_2127

    @classmethod
    def create(cls, arg : Item_1231_Arg) -> "Item_1231":
        return cls._create(arg) # type: ignore

Variation_1291_Arg_Group = Tuple[Union[RuleVariation_339_Arg, Tuple[Literal["X"], RuleVariation_339_Arg]], Union[RuleVariation_782_Arg, Tuple[Literal["Y"], RuleVariation_782_Arg]]]
Variation_1291_Arg: TypeAlias = Union[int, Variation_1291_Arg_Group]
class Variation_1291(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_items_list = [(Item_1181, 20), (Item_1231, 20)]
    cv_items_dict = {"X": RuleVariation_339, "Y": RuleVariation_782}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_339:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_782:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_339:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_782:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1291_Arg) -> 'Variation_1291':
        return cls._create(arg) # type: ignore

RuleVariation_1221_Arg: TypeAlias = Variation_1291_Arg
class RuleVariation_1221(RuleVariationContextFree):
    cv_variation = Variation_1291

    @classmethod
    def create(cls, arg : RuleVariation_1221_Arg) -> "RuleVariation_1221":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1291:
        return self.arg # type: ignore

NonSpare_1076_Arg: TypeAlias = RuleVariation_1221_Arg
class NonSpare_1076(NonSpare):
    cv_name = "HV"
    cv_title = "Horizontal Velocity Vector"
    cv_rule = RuleVariation_1221

    @classmethod
    def create(cls, arg : NonSpare_1076_Arg) -> "NonSpare_1076":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1221:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1291:
        return self.rule.variation

Content_742_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
class Content_742(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0e-2
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_742_Arg: TypeAlias = Content_742_Arg
class RuleContent_742(RuleContentContextFree):
    cv_content = Content_742

    @property
    def content(self) -> Content_742:
        return self._get_content() # type: ignore

Variation_314_Arg: TypeAlias = RuleContent_742_Arg
class Variation_314(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_742

    @classmethod
    def create(cls, arg : Variation_314_Arg) -> "Variation_314":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_742:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_742:
        return self.rule.content

RuleVariation_307_Arg: TypeAlias = Variation_314_Arg
class RuleVariation_307(RuleVariationContextFree):
    cv_variation = Variation_314

    @classmethod
    def create(cls, arg : RuleVariation_307_Arg) -> "RuleVariation_307":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_314:
        return self.arg # type: ignore

NonSpare_2072_Arg: TypeAlias = RuleVariation_307_Arg
class NonSpare_2072(NonSpare):
    cv_name = "X"
    cv_title = ""
    cv_rule = RuleVariation_307

    @classmethod
    def create(cls, arg : NonSpare_2072_Arg) -> "NonSpare_2072":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_307:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_314:
        return self.rule.variation

Item_1179_Arg: TypeAlias = NonSpare_2072_Arg
class Item_1179(Item):
    cv_non_spare = NonSpare_2072

    @classmethod
    def create(cls, arg : Item_1179_Arg) -> "Item_1179":
        return cls._create(arg) # type: ignore

NonSpare_2123_Arg: TypeAlias = RuleVariation_307_Arg
class NonSpare_2123(NonSpare):
    cv_name = "Y"
    cv_title = ""
    cv_rule = RuleVariation_307

    @classmethod
    def create(cls, arg : NonSpare_2123_Arg) -> "NonSpare_2123":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_307:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_314:
        return self.rule.variation

Item_1227_Arg: TypeAlias = NonSpare_2123_Arg
class Item_1227(Item):
    cv_non_spare = NonSpare_2123

    @classmethod
    def create(cls, arg : Item_1227_Arg) -> "Item_1227":
        return cls._create(arg) # type: ignore

NonSpare_790_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_790(NonSpare):
    cv_name = "CORSHVXY"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_790_Arg) -> "NonSpare_790":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_195_Arg: TypeAlias = NonSpare_790_Arg
class Item_195(Item):
    cv_non_spare = NonSpare_790

    @classmethod
    def create(cls, arg : Item_195_Arg) -> "Item_195":
        return cls._create(arg) # type: ignore

Variation_1289_Arg_Group = Tuple[Union[RuleVariation_307_Arg, Tuple[Literal["X"], RuleVariation_307_Arg]], Union[RuleVariation_307_Arg, Tuple[Literal["Y"], RuleVariation_307_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["CORSHVXY"], RuleVariation_205_Arg]]]
Variation_1289_Arg: TypeAlias = Union[int, Variation_1289_Arg_Group]
class Variation_1289(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_items_list = [(Item_1179, 16), (Item_1227, 16), (Item_195, 8)]
    cv_items_dict = {"X": RuleVariation_307, "Y": RuleVariation_307, "CORSHVXY": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_307:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_307:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CORSHVXY"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"], Literal["CORSHVXY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_307:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_307:
        ...
    @overload
    def get_item(self, key : Literal["CORSHVXY"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1289_Arg) -> 'Variation_1289':
        return cls._create(arg) # type: ignore

RuleVariation_1219_Arg: TypeAlias = Variation_1289_Arg
class RuleVariation_1219(RuleVariationContextFree):
    cv_variation = Variation_1289

    @classmethod
    def create(cls, arg : RuleVariation_1219_Arg) -> "RuleVariation_1219":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1289:
        return self.arg # type: ignore

NonSpare_1611_Arg: TypeAlias = RuleVariation_1219_Arg
class NonSpare_1611(NonSpare):
    cv_name = "RSHV"
    cv_title = "Horizontal Velocity Resolution"
    cv_rule = RuleVariation_1219

    @classmethod
    def create(cls, arg : NonSpare_1611_Arg) -> "NonSpare_1611":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1219:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1289:
        return self.rule.variation

NonSpare_2073_Arg: TypeAlias = RuleVariation_307_Arg
class NonSpare_2073(NonSpare):
    cv_name = "X"
    cv_title = ""
    cv_rule = RuleVariation_307

    @classmethod
    def create(cls, arg : NonSpare_2073_Arg) -> "NonSpare_2073":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_307:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_314:
        return self.rule.variation

Item_1180_Arg: TypeAlias = NonSpare_2073_Arg
class Item_1180(Item):
    cv_non_spare = NonSpare_2073

    @classmethod
    def create(cls, arg : Item_1180_Arg) -> "Item_1180":
        return cls._create(arg) # type: ignore

NonSpare_2124_Arg: TypeAlias = RuleVariation_307_Arg
class NonSpare_2124(NonSpare):
    cv_name = "Y"
    cv_title = ""
    cv_rule = RuleVariation_307

    @classmethod
    def create(cls, arg : NonSpare_2124_Arg) -> "NonSpare_2124":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_307:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_314:
        return self.rule.variation

Item_1228_Arg: TypeAlias = NonSpare_2124_Arg
class Item_1228(Item):
    cv_non_spare = NonSpare_2124

    @classmethod
    def create(cls, arg : Item_1228_Arg) -> "Item_1228":
        return cls._create(arg) # type: ignore

NonSpare_771_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_771(NonSpare):
    cv_name = "COHVXY"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_771_Arg) -> "NonSpare_771":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_183_Arg: TypeAlias = NonSpare_771_Arg
class Item_183(Item):
    cv_non_spare = NonSpare_771

    @classmethod
    def create(cls, arg : Item_183_Arg) -> "Item_183":
        return cls._create(arg) # type: ignore

Variation_1290_Arg_Group = Tuple[Union[RuleVariation_307_Arg, Tuple[Literal["X"], RuleVariation_307_Arg]], Union[RuleVariation_307_Arg, Tuple[Literal["Y"], RuleVariation_307_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["COHVXY"], RuleVariation_205_Arg]]]
Variation_1290_Arg: TypeAlias = Union[int, Variation_1290_Arg_Group]
class Variation_1290(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_items_list = [(Item_1180, 16), (Item_1228, 16), (Item_183, 8)]
    cv_items_dict = {"X": RuleVariation_307, "Y": RuleVariation_307, "COHVXY": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_307:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_307:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHVXY"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"], Literal["COHVXY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_307:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_307:
        ...
    @overload
    def get_item(self, key : Literal["COHVXY"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1290_Arg) -> 'Variation_1290':
        return cls._create(arg) # type: ignore

RuleVariation_1220_Arg: TypeAlias = Variation_1290_Arg
class RuleVariation_1220(RuleVariationContextFree):
    cv_variation = Variation_1290

    @classmethod
    def create(cls, arg : RuleVariation_1220_Arg) -> "RuleVariation_1220":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1290:
        return self.arg # type: ignore

NonSpare_1678_Arg: TypeAlias = RuleVariation_1220_Arg
class NonSpare_1678(NonSpare):
    cv_name = "SDHV"
    cv_title = "Horizontal Velocity Precision"
    cv_rule = RuleVariation_1220

    @classmethod
    def create(cls, arg : NonSpare_1678_Arg) -> "NonSpare_1678":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1290:
        return self.rule.variation

NonSpare_769_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_769(NonSpare):
    cv_name = "COHVXHPX"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_769_Arg) -> "NonSpare_769":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_181_Arg: TypeAlias = NonSpare_769_Arg
class Item_181(Item):
    cv_non_spare = NonSpare_769

    @classmethod
    def create(cls, arg : Item_181_Arg) -> "Item_181":
        return cls._create(arg) # type: ignore

NonSpare_770_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_770(NonSpare):
    cv_name = "COHVXHPY"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_770_Arg) -> "NonSpare_770":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_182_Arg: TypeAlias = NonSpare_770_Arg
class Item_182(Item):
    cv_non_spare = NonSpare_770

    @classmethod
    def create(cls, arg : Item_182_Arg) -> "Item_182":
        return cls._create(arg) # type: ignore

NonSpare_772_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_772(NonSpare):
    cv_name = "COHVYHPX"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_772_Arg) -> "NonSpare_772":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_184_Arg: TypeAlias = NonSpare_772_Arg
class Item_184(Item):
    cv_non_spare = NonSpare_772

    @classmethod
    def create(cls, arg : Item_184_Arg) -> "Item_184":
        return cls._create(arg) # type: ignore

NonSpare_773_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_773(NonSpare):
    cv_name = "COHVYHPY"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_773_Arg) -> "NonSpare_773":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_185_Arg: TypeAlias = NonSpare_773_Arg
class Item_185(Item):
    cv_non_spare = NonSpare_773

    @classmethod
    def create(cls, arg : Item_185_Arg) -> "Item_185":
        return cls._create(arg) # type: ignore

Variation_1070_Arg_Group = Tuple[Union[RuleVariation_205_Arg, Tuple[Literal["COHVXHPX"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["COHVXHPY"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["COHVYHPX"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["COHVYHPY"], RuleVariation_205_Arg]]]
Variation_1070_Arg: TypeAlias = Union[int, Variation_1070_Arg_Group]
class Variation_1070(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_181, 8), (Item_182, 8), (Item_184, 8), (Item_185, 8)]
    cv_items_dict = {"COHVXHPX": RuleVariation_205, "COHVXHPY": RuleVariation_205, "COHVYHPX": RuleVariation_205, "COHVYHPY": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["COHVXHPX"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHVXHPY"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHVYHPX"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHVYHPY"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COHVXHPX"], Literal["COHVXHPY"], Literal["COHVYHPX"], Literal["COHVYHPY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COHVXHPX"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["COHVXHPY"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["COHVYHPX"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["COHVYHPY"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1070_Arg) -> 'Variation_1070':
        return cls._create(arg) # type: ignore

RuleVariation_1030_Arg: TypeAlias = Variation_1070_Arg
class RuleVariation_1030(RuleVariationContextFree):
    cv_variation = Variation_1070

    @classmethod
    def create(cls, arg : RuleVariation_1030_Arg) -> "RuleVariation_1030":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1070:
        return self.arg # type: ignore

NonSpare_768_Arg: TypeAlias = RuleVariation_1030_Arg
class NonSpare_768(NonSpare):
    cv_name = "COHVHP"
    cv_title = "Correlation of Horizontal Velocity and Horizontal Position"
    cv_rule = RuleVariation_1030

    @classmethod
    def create(cls, arg : NonSpare_768_Arg) -> "NonSpare_768":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1030:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1070:
        return self.rule.variation

Variation_1481_Arg = TypedDict('Variation_1481_Arg', {
    "HV": NonSpare_1076_Arg,
    "RSHV": NonSpare_1611_Arg,
    "SDHV": NonSpare_1678_Arg,
    "COHVHP": NonSpare_768_Arg,
}, total=False)
class Variation_1481(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1076, NonSpare_1611, NonSpare_1678, NonSpare_768]
    cv_items_dict = {"HV": NonSpare_1076, "RSHV": NonSpare_1611, "SDHV": NonSpare_1678, "COHVHP": NonSpare_768}

    @overload
    @classmethod
    def spec(cls, key : Literal["HV"]) -> NonSpare_1076:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSHV"]) -> NonSpare_1611:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDHV"]) -> NonSpare_1678:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHVHP"]) -> NonSpare_768:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["HV"], Literal["RSHV"], Literal["SDHV"], Literal["COHVHP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["HV"]) -> Optional[NonSpare_1076]:
        ...
    @overload
    def get_item(self, key : Literal["RSHV"]) -> Optional[NonSpare_1611]:
        ...
    @overload
    def get_item(self, key : Literal["SDHV"]) -> Optional[NonSpare_1678]:
        ...
    @overload
    def get_item(self, key : Literal["COHVHP"]) -> Optional[NonSpare_768]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["HV"], val : NonSpare_1076_Arg) -> "Variation_1481":
        ...
    @overload
    def set_item(self, key : Literal["RSHV"], val : NonSpare_1611_Arg) -> "Variation_1481":
        ...
    @overload
    def set_item(self, key : Literal["SDHV"], val : NonSpare_1678_Arg) -> "Variation_1481":
        ...
    @overload
    def set_item(self, key : Literal["COHVHP"], val : NonSpare_768_Arg) -> "Variation_1481":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["HV"]) -> "Variation_1481":
        ...
    @overload
    def del_item(self, key : Literal["RSHV"]) -> "Variation_1481":
        ...
    @overload
    def del_item(self, key : Literal["SDHV"]) -> "Variation_1481":
        ...
    @overload
    def del_item(self, key : Literal["COHVHP"]) -> "Variation_1481":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1481_Arg) -> 'Variation_1481':
        return cls._create(arg) # type: ignore

RuleVariation_1404_Arg: TypeAlias = Variation_1481_Arg
class RuleVariation_1404(RuleVariationContextFree):
    cv_variation = Variation_1481

    @classmethod
    def create(cls, arg : RuleVariation_1404_Arg) -> "RuleVariation_1404":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1481:
        return self.arg # type: ignore

NonSpare_528_Arg: TypeAlias = RuleVariation_1404_Arg
class NonSpare_528(NonSpare):
    cv_name = "602"
    cv_title = "Horizontal Velocity Information"
    cv_rule = RuleVariation_1404

    @classmethod
    def create(cls, arg : NonSpare_528_Arg) -> "NonSpare_528":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1404:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1481:
        return self.rule.variation

class UapItem_527(UapItem):
    cv_non_spare = NonSpare_528

Content_667_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
class Content_667(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 6.25e-2
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

RuleContent_667_Arg: TypeAlias = Content_667_Arg
class RuleContent_667(RuleContentContextFree):
    cv_content = Content_667

    @property
    def content(self) -> Content_667:
        return self._get_content() # type: ignore

Variation_245_Arg: TypeAlias = RuleContent_667_Arg
class Variation_245(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 12
    cv_rule = RuleContent_667

    @classmethod
    def create(cls, arg : Variation_245_Arg) -> "Variation_245":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_667:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_667:
        return self.rule.content

RuleVariation_238_Arg: TypeAlias = Variation_245_Arg
class RuleVariation_238(RuleVariationContextFree):
    cv_variation = Variation_245

    @classmethod
    def create(cls, arg : RuleVariation_238_Arg) -> "RuleVariation_238":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_245:
        return self.arg # type: ignore

NonSpare_2070_Arg: TypeAlias = RuleVariation_238_Arg
class NonSpare_2070(NonSpare):
    cv_name = "X"
    cv_title = ""
    cv_rule = RuleVariation_238

    @classmethod
    def create(cls, arg : NonSpare_2070_Arg) -> "NonSpare_2070":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_238:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_245:
        return self.rule.variation

Item_1177_Arg: TypeAlias = NonSpare_2070_Arg
class Item_1177(Item):
    cv_non_spare = NonSpare_2070

    @classmethod
    def create(cls, arg : Item_1177_Arg) -> "Item_1177":
        return cls._create(arg) # type: ignore

Variation_807_Arg: TypeAlias = RuleContent_667_Arg
class Variation_807(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 12
    cv_rule = RuleContent_667

    @classmethod
    def create(cls, arg : Variation_807_Arg) -> "Variation_807":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_667:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_667:
        return self.rule.content

RuleVariation_777_Arg: TypeAlias = Variation_807_Arg
class RuleVariation_777(RuleVariationContextFree):
    cv_variation = Variation_807

    @classmethod
    def create(cls, arg : RuleVariation_777_Arg) -> "RuleVariation_777":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_807:
        return self.arg # type: ignore

NonSpare_2125_Arg: TypeAlias = RuleVariation_777_Arg
class NonSpare_2125(NonSpare):
    cv_name = "Y"
    cv_title = ""
    cv_rule = RuleVariation_777

    @classmethod
    def create(cls, arg : NonSpare_2125_Arg) -> "NonSpare_2125":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_777:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_807:
        return self.rule.variation

Item_1229_Arg: TypeAlias = NonSpare_2125_Arg
class Item_1229(Item):
    cv_non_spare = NonSpare_2125

    @classmethod
    def create(cls, arg : Item_1229_Arg) -> "Item_1229":
        return cls._create(arg) # type: ignore

Variation_1287_Arg_Group = Tuple[Union[RuleVariation_238_Arg, Tuple[Literal["X"], RuleVariation_238_Arg]], Union[RuleVariation_777_Arg, Tuple[Literal["Y"], RuleVariation_777_Arg]]]
Variation_1287_Arg: TypeAlias = Union[int, Variation_1287_Arg_Group]
class Variation_1287(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_1177, 12), (Item_1229, 12)]
    cv_items_dict = {"X": RuleVariation_238, "Y": RuleVariation_777}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_238:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_777:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_238:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_777:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1287_Arg) -> 'Variation_1287':
        return cls._create(arg) # type: ignore

RuleVariation_1217_Arg: TypeAlias = Variation_1287_Arg
class RuleVariation_1217(RuleVariationContextFree):
    cv_variation = Variation_1287

    @classmethod
    def create(cls, arg : RuleVariation_1217_Arg) -> "RuleVariation_1217":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1287:
        return self.arg # type: ignore

NonSpare_1045_Arg: TypeAlias = RuleVariation_1217_Arg
class NonSpare_1045(NonSpare):
    cv_name = "HA"
    cv_title = "Horizontal Acceleration Vector"
    cv_rule = RuleVariation_1217

    @classmethod
    def create(cls, arg : NonSpare_1045_Arg) -> "NonSpare_1045":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1217:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1287:
        return self.rule.variation

Content_760_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
class Content_760(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 6.25e-2
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

RuleContent_759_Arg: TypeAlias = Content_760_Arg
class RuleContent_759(RuleContentContextFree):
    cv_content = Content_760

    @property
    def content(self) -> Content_760:
        return self._get_content() # type: ignore

Variation_247_Arg: TypeAlias = RuleContent_759_Arg
class Variation_247(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 12
    cv_rule = RuleContent_759

    @classmethod
    def create(cls, arg : Variation_247_Arg) -> "Variation_247":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_759:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_760:
        return self.rule.content

RuleVariation_240_Arg: TypeAlias = Variation_247_Arg
class RuleVariation_240(RuleVariationContextFree):
    cv_variation = Variation_247

    @classmethod
    def create(cls, arg : RuleVariation_240_Arg) -> "RuleVariation_240":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_247:
        return self.arg # type: ignore

NonSpare_2071_Arg: TypeAlias = RuleVariation_240_Arg
class NonSpare_2071(NonSpare):
    cv_name = "X"
    cv_title = ""
    cv_rule = RuleVariation_240

    @classmethod
    def create(cls, arg : NonSpare_2071_Arg) -> "NonSpare_2071":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_240:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_247:
        return self.rule.variation

Item_1178_Arg: TypeAlias = NonSpare_2071_Arg
class Item_1178(Item):
    cv_non_spare = NonSpare_2071

    @classmethod
    def create(cls, arg : Item_1178_Arg) -> "Item_1178":
        return cls._create(arg) # type: ignore

Variation_811_Arg: TypeAlias = RuleContent_759_Arg
class Variation_811(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 12
    cv_rule = RuleContent_759

    @classmethod
    def create(cls, arg : Variation_811_Arg) -> "Variation_811":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_759:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_760:
        return self.rule.content

RuleVariation_781_Arg: TypeAlias = Variation_811_Arg
class RuleVariation_781(RuleVariationContextFree):
    cv_variation = Variation_811

    @classmethod
    def create(cls, arg : RuleVariation_781_Arg) -> "RuleVariation_781":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_811:
        return self.arg # type: ignore

NonSpare_2126_Arg: TypeAlias = RuleVariation_781_Arg
class NonSpare_2126(NonSpare):
    cv_name = "Y"
    cv_title = ""
    cv_rule = RuleVariation_781

    @classmethod
    def create(cls, arg : NonSpare_2126_Arg) -> "NonSpare_2126":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_781:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_811:
        return self.rule.variation

Item_1230_Arg: TypeAlias = NonSpare_2126_Arg
class Item_1230(Item):
    cv_non_spare = NonSpare_2126

    @classmethod
    def create(cls, arg : Item_1230_Arg) -> "Item_1230":
        return cls._create(arg) # type: ignore

NonSpare_764_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_764(NonSpare):
    cv_name = "COHAXY"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_764_Arg) -> "NonSpare_764":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_177_Arg: TypeAlias = NonSpare_764_Arg
class Item_177(Item):
    cv_non_spare = NonSpare_764

    @classmethod
    def create(cls, arg : Item_177_Arg) -> "Item_177":
        return cls._create(arg) # type: ignore

Variation_1288_Arg_Group = Tuple[Union[RuleVariation_240_Arg, Tuple[Literal["X"], RuleVariation_240_Arg]], Union[RuleVariation_781_Arg, Tuple[Literal["Y"], RuleVariation_781_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["COHAXY"], RuleVariation_205_Arg]]]
Variation_1288_Arg: TypeAlias = Union[int, Variation_1288_Arg_Group]
class Variation_1288(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1178, 12), (Item_1230, 12), (Item_177, 8)]
    cv_items_dict = {"X": RuleVariation_240, "Y": RuleVariation_781, "COHAXY": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_240:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_781:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHAXY"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"], Literal["COHAXY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_240:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_781:
        ...
    @overload
    def get_item(self, key : Literal["COHAXY"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1288_Arg) -> 'Variation_1288':
        return cls._create(arg) # type: ignore

RuleVariation_1218_Arg: TypeAlias = Variation_1288_Arg
class RuleVariation_1218(RuleVariationContextFree):
    cv_variation = Variation_1288

    @classmethod
    def create(cls, arg : RuleVariation_1218_Arg) -> "RuleVariation_1218":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1288:
        return self.arg # type: ignore

NonSpare_1675_Arg: TypeAlias = RuleVariation_1218_Arg
class NonSpare_1675(NonSpare):
    cv_name = "SDHA"
    cv_title = "Horizontal Acceleration Precision"
    cv_rule = RuleVariation_1218

    @classmethod
    def create(cls, arg : NonSpare_1675_Arg) -> "NonSpare_1675":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1218:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1288:
        return self.rule.variation

NonSpare_760_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_760(NonSpare):
    cv_name = "COHAXHPX"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_760_Arg) -> "NonSpare_760":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_173_Arg: TypeAlias = NonSpare_760_Arg
class Item_173(Item):
    cv_non_spare = NonSpare_760

    @classmethod
    def create(cls, arg : Item_173_Arg) -> "Item_173":
        return cls._create(arg) # type: ignore

NonSpare_761_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_761(NonSpare):
    cv_name = "COHAXHPY"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_761_Arg) -> "NonSpare_761":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_174_Arg: TypeAlias = NonSpare_761_Arg
class Item_174(Item):
    cv_non_spare = NonSpare_761

    @classmethod
    def create(cls, arg : Item_174_Arg) -> "Item_174":
        return cls._create(arg) # type: ignore

NonSpare_765_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_765(NonSpare):
    cv_name = "COHAYHPX"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_765_Arg) -> "NonSpare_765":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_178_Arg: TypeAlias = NonSpare_765_Arg
class Item_178(Item):
    cv_non_spare = NonSpare_765

    @classmethod
    def create(cls, arg : Item_178_Arg) -> "Item_178":
        return cls._create(arg) # type: ignore

NonSpare_745_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_745(NonSpare):
    cv_name = "COAYHPY"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_745_Arg) -> "NonSpare_745":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_169_Arg: TypeAlias = NonSpare_745_Arg
class Item_169(Item):
    cv_non_spare = NonSpare_745

    @classmethod
    def create(cls, arg : Item_169_Arg) -> "Item_169":
        return cls._create(arg) # type: ignore

Variation_1068_Arg_Group = Tuple[Union[RuleVariation_205_Arg, Tuple[Literal["COHAXHPX"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["COHAXHPY"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["COHAYHPX"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["COAYHPY"], RuleVariation_205_Arg]]]
Variation_1068_Arg: TypeAlias = Union[int, Variation_1068_Arg_Group]
class Variation_1068(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_173, 8), (Item_174, 8), (Item_178, 8), (Item_169, 8)]
    cv_items_dict = {"COHAXHPX": RuleVariation_205, "COHAXHPY": RuleVariation_205, "COHAYHPX": RuleVariation_205, "COAYHPY": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["COHAXHPX"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHAXHPY"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHAYHPX"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COAYHPY"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COHAXHPX"], Literal["COHAXHPY"], Literal["COHAYHPX"], Literal["COAYHPY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COHAXHPX"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["COHAXHPY"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["COHAYHPX"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["COAYHPY"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1068_Arg) -> 'Variation_1068':
        return cls._create(arg) # type: ignore

RuleVariation_1028_Arg: TypeAlias = Variation_1068_Arg
class RuleVariation_1028(RuleVariationContextFree):
    cv_variation = Variation_1068

    @classmethod
    def create(cls, arg : RuleVariation_1028_Arg) -> "RuleVariation_1028":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1068:
        return self.arg # type: ignore

NonSpare_758_Arg: TypeAlias = RuleVariation_1028_Arg
class NonSpare_758(NonSpare):
    cv_name = "COHAHP"
    cv_title = "Correlation of Horizontal Acceleration and Horizontal Position"
    cv_rule = RuleVariation_1028

    @classmethod
    def create(cls, arg : NonSpare_758_Arg) -> "NonSpare_758":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1028:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1068:
        return self.rule.variation

NonSpare_762_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_762(NonSpare):
    cv_name = "COHAXHVX"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_762_Arg) -> "NonSpare_762":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_175_Arg: TypeAlias = NonSpare_762_Arg
class Item_175(Item):
    cv_non_spare = NonSpare_762

    @classmethod
    def create(cls, arg : Item_175_Arg) -> "Item_175":
        return cls._create(arg) # type: ignore

NonSpare_763_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_763(NonSpare):
    cv_name = "COHAXHVY"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_763_Arg) -> "NonSpare_763":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_176_Arg: TypeAlias = NonSpare_763_Arg
class Item_176(Item):
    cv_non_spare = NonSpare_763

    @classmethod
    def create(cls, arg : Item_176_Arg) -> "Item_176":
        return cls._create(arg) # type: ignore

NonSpare_766_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_766(NonSpare):
    cv_name = "COHAYHVX"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_766_Arg) -> "NonSpare_766":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_179_Arg: TypeAlias = NonSpare_766_Arg
class Item_179(Item):
    cv_non_spare = NonSpare_766

    @classmethod
    def create(cls, arg : Item_179_Arg) -> "Item_179":
        return cls._create(arg) # type: ignore

NonSpare_767_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_767(NonSpare):
    cv_name = "COHAYHVY"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_767_Arg) -> "NonSpare_767":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_180_Arg: TypeAlias = NonSpare_767_Arg
class Item_180(Item):
    cv_non_spare = NonSpare_767

    @classmethod
    def create(cls, arg : Item_180_Arg) -> "Item_180":
        return cls._create(arg) # type: ignore

Variation_1069_Arg_Group = Tuple[Union[RuleVariation_205_Arg, Tuple[Literal["COHAXHVX"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["COHAXHVY"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["COHAYHVX"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["COHAYHVY"], RuleVariation_205_Arg]]]
Variation_1069_Arg: TypeAlias = Union[int, Variation_1069_Arg_Group]
class Variation_1069(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_175, 8), (Item_176, 8), (Item_179, 8), (Item_180, 8)]
    cv_items_dict = {"COHAXHVX": RuleVariation_205, "COHAXHVY": RuleVariation_205, "COHAYHVX": RuleVariation_205, "COHAYHVY": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["COHAXHVX"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHAXHVY"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHAYHVX"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHAYHVY"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COHAXHVX"], Literal["COHAXHVY"], Literal["COHAYHVX"], Literal["COHAYHVY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COHAXHVX"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["COHAXHVY"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["COHAYHVX"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["COHAYHVY"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1069_Arg) -> 'Variation_1069':
        return cls._create(arg) # type: ignore

RuleVariation_1029_Arg: TypeAlias = Variation_1069_Arg
class RuleVariation_1029(RuleVariationContextFree):
    cv_variation = Variation_1069

    @classmethod
    def create(cls, arg : RuleVariation_1029_Arg) -> "RuleVariation_1029":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1069:
        return self.arg # type: ignore

NonSpare_759_Arg: TypeAlias = RuleVariation_1029_Arg
class NonSpare_759(NonSpare):
    cv_name = "COHAHV"
    cv_title = "Correlation of Horizontal Acceleration and Horizontal Velocity"
    cv_rule = RuleVariation_1029

    @classmethod
    def create(cls, arg : NonSpare_759_Arg) -> "NonSpare_759":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1029:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1069:
        return self.rule.variation

Variation_1480_Arg = TypedDict('Variation_1480_Arg', {
    "HA": NonSpare_1045_Arg,
    "SDHA": NonSpare_1675_Arg,
    "COHAHP": NonSpare_758_Arg,
    "COHAHV": NonSpare_759_Arg,
}, total=False)
class Variation_1480(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1045, NonSpare_1675, NonSpare_758, NonSpare_759]
    cv_items_dict = {"HA": NonSpare_1045, "SDHA": NonSpare_1675, "COHAHP": NonSpare_758, "COHAHV": NonSpare_759}

    @overload
    @classmethod
    def spec(cls, key : Literal["HA"]) -> NonSpare_1045:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDHA"]) -> NonSpare_1675:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHAHP"]) -> NonSpare_758:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHAHV"]) -> NonSpare_759:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["HA"], Literal["SDHA"], Literal["COHAHP"], Literal["COHAHV"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["HA"]) -> Optional[NonSpare_1045]:
        ...
    @overload
    def get_item(self, key : Literal["SDHA"]) -> Optional[NonSpare_1675]:
        ...
    @overload
    def get_item(self, key : Literal["COHAHP"]) -> Optional[NonSpare_758]:
        ...
    @overload
    def get_item(self, key : Literal["COHAHV"]) -> Optional[NonSpare_759]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["HA"], val : NonSpare_1045_Arg) -> "Variation_1480":
        ...
    @overload
    def set_item(self, key : Literal["SDHA"], val : NonSpare_1675_Arg) -> "Variation_1480":
        ...
    @overload
    def set_item(self, key : Literal["COHAHP"], val : NonSpare_758_Arg) -> "Variation_1480":
        ...
    @overload
    def set_item(self, key : Literal["COHAHV"], val : NonSpare_759_Arg) -> "Variation_1480":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["HA"]) -> "Variation_1480":
        ...
    @overload
    def del_item(self, key : Literal["SDHA"]) -> "Variation_1480":
        ...
    @overload
    def del_item(self, key : Literal["COHAHP"]) -> "Variation_1480":
        ...
    @overload
    def del_item(self, key : Literal["COHAHV"]) -> "Variation_1480":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1480_Arg) -> 'Variation_1480':
        return cls._create(arg) # type: ignore

RuleVariation_1403_Arg: TypeAlias = Variation_1480_Arg
class RuleVariation_1403(RuleVariationContextFree):
    cv_variation = Variation_1480

    @classmethod
    def create(cls, arg : RuleVariation_1403_Arg) -> "RuleVariation_1403":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1480:
        return self.arg # type: ignore

NonSpare_529_Arg: TypeAlias = RuleVariation_1403_Arg
class NonSpare_529(NonSpare):
    cv_name = "603"
    cv_title = "Horizontal Acceleration Information"
    cv_rule = RuleVariation_1403

    @classmethod
    def create(cls, arg : NonSpare_529_Arg) -> "NonSpare_529":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1403:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1480:
        return self.rule.variation

class UapItem_528(UapItem):
    cv_non_spare = NonSpare_529

Content_643_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
class Content_643(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.0e-2
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_643_Arg: TypeAlias = Content_643_Arg
class RuleContent_643(RuleContentContextFree):
    cv_content = Content_643

    @property
    def content(self) -> Content_643:
        return self._get_content() # type: ignore

Variation_355_Arg: TypeAlias = RuleContent_643_Arg
class Variation_355(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_643

    @classmethod
    def create(cls, arg : Variation_355_Arg) -> "Variation_355":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_643:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_643:
        return self.rule.content

RuleVariation_348_Arg: TypeAlias = Variation_355_Arg
class RuleVariation_348(RuleVariationContextFree):
    cv_variation = Variation_355

    @classmethod
    def create(cls, arg : RuleVariation_348_Arg) -> "RuleVariation_348":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_355:
        return self.arg # type: ignore

NonSpare_2037_Arg: TypeAlias = RuleVariation_348_Arg
class NonSpare_2037(NonSpare):
    cv_name = "VV"
    cv_title = "Vertical Velocity"
    cv_rule = RuleVariation_348

    @classmethod
    def create(cls, arg : NonSpare_2037_Arg) -> "NonSpare_2037":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_348:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_355:
        return self.rule.variation

NonSpare_1618_Arg: TypeAlias = RuleVariation_307_Arg
class NonSpare_1618(NonSpare):
    cv_name = "RSVV"
    cv_title = "Vertical Velocity Resolution"
    cv_rule = RuleVariation_307

    @classmethod
    def create(cls, arg : NonSpare_1618_Arg) -> "NonSpare_1618":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_307:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_314:
        return self.rule.variation

NonSpare_1687_Arg: TypeAlias = RuleVariation_307_Arg
class NonSpare_1687(NonSpare):
    cv_name = "SDVV"
    cv_title = ""
    cv_rule = RuleVariation_307

    @classmethod
    def create(cls, arg : NonSpare_1687_Arg) -> "NonSpare_1687":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_307:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_314:
        return self.rule.variation

Item_873_Arg: TypeAlias = NonSpare_1687_Arg
class Item_873(Item):
    cv_non_spare = NonSpare_1687

    @classmethod
    def create(cls, arg : Item_873_Arg) -> "Item_873":
        return cls._create(arg) # type: ignore

NonSpare_802_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_802(NonSpare):
    cv_name = "COVVGH"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_802_Arg) -> "NonSpare_802":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_203_Arg: TypeAlias = NonSpare_802_Arg
class Item_203(Item):
    cv_non_spare = NonSpare_802

    @classmethod
    def create(cls, arg : Item_203_Arg) -> "Item_203":
        return cls._create(arg) # type: ignore

Variation_1203_Arg_Group = Tuple[Union[RuleVariation_307_Arg, Tuple[Literal["SDVV"], RuleVariation_307_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["COVVGH"], RuleVariation_205_Arg]]]
Variation_1203_Arg: TypeAlias = Union[int, Variation_1203_Arg_Group]
class Variation_1203(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_873, 16), (Item_203, 8)]
    cv_items_dict = {"SDVV": RuleVariation_307, "COVVGH": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["SDVV"]) -> RuleVariation_307:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVVGH"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SDVV"], Literal["COVVGH"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SDVV"]) -> RuleVariation_307:
        ...
    @overload
    def get_item(self, key : Literal["COVVGH"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1203_Arg) -> 'Variation_1203':
        return cls._create(arg) # type: ignore

RuleVariation_1148_Arg: TypeAlias = Variation_1203_Arg
class RuleVariation_1148(RuleVariationContextFree):
    cv_variation = Variation_1203

    @classmethod
    def create(cls, arg : RuleVariation_1148_Arg) -> "RuleVariation_1148":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1203:
        return self.arg # type: ignore

NonSpare_1688_Arg: TypeAlias = RuleVariation_1148_Arg
class NonSpare_1688(NonSpare):
    cv_name = "SDVV"
    cv_title = "Vertical Velocity Precision"
    cv_rule = RuleVariation_1148

    @classmethod
    def create(cls, arg : NonSpare_1688_Arg) -> "NonSpare_1688":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1148:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1203:
        return self.rule.variation

NonSpare_2067_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2067(NonSpare):
    cv_name = "X"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2067_Arg) -> "NonSpare_2067":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1174_Arg: TypeAlias = NonSpare_2067_Arg
class Item_1174(Item):
    cv_non_spare = NonSpare_2067

    @classmethod
    def create(cls, arg : Item_1174_Arg) -> "Item_1174":
        return cls._create(arg) # type: ignore

NonSpare_2121_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2121(NonSpare):
    cv_name = "Y"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2121_Arg) -> "NonSpare_2121":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1225_Arg: TypeAlias = NonSpare_2121_Arg
class Item_1225(Item):
    cv_non_spare = NonSpare_2121

    @classmethod
    def create(cls, arg : Item_1225_Arg) -> "Item_1225":
        return cls._create(arg) # type: ignore

Variation_1284_Arg_Group = Tuple[Union[RuleVariation_205_Arg, Tuple[Literal["X"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["Y"], RuleVariation_205_Arg]]]
Variation_1284_Arg: TypeAlias = Union[int, Variation_1284_Arg_Group]
class Variation_1284(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1174, 8), (Item_1225, 8)]
    cv_items_dict = {"X": RuleVariation_205, "Y": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1284_Arg) -> 'Variation_1284':
        return cls._create(arg) # type: ignore

RuleVariation_1214_Arg: TypeAlias = Variation_1284_Arg
class RuleVariation_1214(RuleVariationContextFree):
    cv_variation = Variation_1284

    @classmethod
    def create(cls, arg : RuleVariation_1214_Arg) -> "RuleVariation_1214":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1284:
        return self.arg # type: ignore

NonSpare_804_Arg: TypeAlias = RuleVariation_1214_Arg
class NonSpare_804(NonSpare):
    cv_name = "COVVHP"
    cv_title = "Correlation of Vertical Velocity and Horizontal Position"
    cv_rule = RuleVariation_1214

    @classmethod
    def create(cls, arg : NonSpare_804_Arg) -> "NonSpare_804":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1214:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1284:
        return self.rule.variation

NonSpare_2068_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2068(NonSpare):
    cv_name = "X"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2068_Arg) -> "NonSpare_2068":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1175_Arg: TypeAlias = NonSpare_2068_Arg
class Item_1175(Item):
    cv_non_spare = NonSpare_2068

    @classmethod
    def create(cls, arg : Item_1175_Arg) -> "Item_1175":
        return cls._create(arg) # type: ignore

NonSpare_2122_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2122(NonSpare):
    cv_name = "Y"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2122_Arg) -> "NonSpare_2122":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1226_Arg: TypeAlias = NonSpare_2122_Arg
class Item_1226(Item):
    cv_non_spare = NonSpare_2122

    @classmethod
    def create(cls, arg : Item_1226_Arg) -> "Item_1226":
        return cls._create(arg) # type: ignore

Variation_1285_Arg_Group = Tuple[Union[RuleVariation_205_Arg, Tuple[Literal["X"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["Y"], RuleVariation_205_Arg]]]
Variation_1285_Arg: TypeAlias = Union[int, Variation_1285_Arg_Group]
class Variation_1285(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1175, 8), (Item_1226, 8)]
    cv_items_dict = {"X": RuleVariation_205, "Y": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1285_Arg) -> 'Variation_1285':
        return cls._create(arg) # type: ignore

RuleVariation_1215_Arg: TypeAlias = Variation_1285_Arg
class RuleVariation_1215(RuleVariationContextFree):
    cv_variation = Variation_1285

    @classmethod
    def create(cls, arg : RuleVariation_1215_Arg) -> "RuleVariation_1215":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1285:
        return self.arg # type: ignore

NonSpare_805_Arg: TypeAlias = RuleVariation_1215_Arg
class NonSpare_805(NonSpare):
    cv_name = "COVVHV"
    cv_title = "Correlation of Vertical Velocity and Horizontal Velocity"
    cv_rule = RuleVariation_1215

    @classmethod
    def create(cls, arg : NonSpare_805_Arg) -> "NonSpare_805":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1215:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1285:
        return self.rule.variation

NonSpare_2069_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2069(NonSpare):
    cv_name = "X"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2069_Arg) -> "NonSpare_2069":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1176_Arg: TypeAlias = NonSpare_2069_Arg
class Item_1176(Item):
    cv_non_spare = NonSpare_2069

    @classmethod
    def create(cls, arg : Item_1176_Arg) -> "Item_1176":
        return cls._create(arg) # type: ignore

NonSpare_2120_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2120(NonSpare):
    cv_name = "Y"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2120_Arg) -> "NonSpare_2120":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1224_Arg: TypeAlias = NonSpare_2120_Arg
class Item_1224(Item):
    cv_non_spare = NonSpare_2120

    @classmethod
    def create(cls, arg : Item_1224_Arg) -> "Item_1224":
        return cls._create(arg) # type: ignore

Variation_1286_Arg_Group = Tuple[Union[RuleVariation_205_Arg, Tuple[Literal["X"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["Y"], RuleVariation_205_Arg]]]
Variation_1286_Arg: TypeAlias = Union[int, Variation_1286_Arg_Group]
class Variation_1286(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1176, 8), (Item_1224, 8)]
    cv_items_dict = {"X": RuleVariation_205, "Y": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1286_Arg) -> 'Variation_1286':
        return cls._create(arg) # type: ignore

RuleVariation_1216_Arg: TypeAlias = Variation_1286_Arg
class RuleVariation_1216(RuleVariationContextFree):
    cv_variation = Variation_1286

    @classmethod
    def create(cls, arg : RuleVariation_1216_Arg) -> "RuleVariation_1216":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1286:
        return self.arg # type: ignore

NonSpare_803_Arg: TypeAlias = RuleVariation_1216_Arg
class NonSpare_803(NonSpare):
    cv_name = "COVVHA"
    cv_title = "Correlation of Vertical Velocity and Horizontal Acceleration"
    cv_rule = RuleVariation_1216

    @classmethod
    def create(cls, arg : NonSpare_803_Arg) -> "NonSpare_803":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1216:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1286:
        return self.rule.variation

Variation_1509_Arg = TypedDict('Variation_1509_Arg', {
    "VV": NonSpare_2037_Arg,
    "RSVV": NonSpare_1618_Arg,
    "SDVV": NonSpare_1688_Arg,
    "COVVHP": NonSpare_804_Arg,
    "COVVHV": NonSpare_805_Arg,
    "COVVHA": NonSpare_803_Arg,
}, total=False)
class Variation_1509(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_2037, NonSpare_1618, NonSpare_1688, NonSpare_804, NonSpare_805, NonSpare_803]
    cv_items_dict = {"VV": NonSpare_2037, "RSVV": NonSpare_1618, "SDVV": NonSpare_1688, "COVVHP": NonSpare_804, "COVVHV": NonSpare_805, "COVVHA": NonSpare_803}

    @overload
    @classmethod
    def spec(cls, key : Literal["VV"]) -> NonSpare_2037:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSVV"]) -> NonSpare_1618:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDVV"]) -> NonSpare_1688:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVVHP"]) -> NonSpare_804:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVVHV"]) -> NonSpare_805:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVVHA"]) -> NonSpare_803:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VV"], Literal["RSVV"], Literal["SDVV"], Literal["COVVHP"], Literal["COVVHV"], Literal["COVVHA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VV"]) -> Optional[NonSpare_2037]:
        ...
    @overload
    def get_item(self, key : Literal["RSVV"]) -> Optional[NonSpare_1618]:
        ...
    @overload
    def get_item(self, key : Literal["SDVV"]) -> Optional[NonSpare_1688]:
        ...
    @overload
    def get_item(self, key : Literal["COVVHP"]) -> Optional[NonSpare_804]:
        ...
    @overload
    def get_item(self, key : Literal["COVVHV"]) -> Optional[NonSpare_805]:
        ...
    @overload
    def get_item(self, key : Literal["COVVHA"]) -> Optional[NonSpare_803]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["VV"], val : NonSpare_2037_Arg) -> "Variation_1509":
        ...
    @overload
    def set_item(self, key : Literal["RSVV"], val : NonSpare_1618_Arg) -> "Variation_1509":
        ...
    @overload
    def set_item(self, key : Literal["SDVV"], val : NonSpare_1688_Arg) -> "Variation_1509":
        ...
    @overload
    def set_item(self, key : Literal["COVVHP"], val : NonSpare_804_Arg) -> "Variation_1509":
        ...
    @overload
    def set_item(self, key : Literal["COVVHV"], val : NonSpare_805_Arg) -> "Variation_1509":
        ...
    @overload
    def set_item(self, key : Literal["COVVHA"], val : NonSpare_803_Arg) -> "Variation_1509":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["VV"]) -> "Variation_1509":
        ...
    @overload
    def del_item(self, key : Literal["RSVV"]) -> "Variation_1509":
        ...
    @overload
    def del_item(self, key : Literal["SDVV"]) -> "Variation_1509":
        ...
    @overload
    def del_item(self, key : Literal["COVVHP"]) -> "Variation_1509":
        ...
    @overload
    def del_item(self, key : Literal["COVVHV"]) -> "Variation_1509":
        ...
    @overload
    def del_item(self, key : Literal["COVVHA"]) -> "Variation_1509":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1509_Arg) -> 'Variation_1509':
        return cls._create(arg) # type: ignore

RuleVariation_1432_Arg: TypeAlias = Variation_1509_Arg
class RuleVariation_1432(RuleVariationContextFree):
    cv_variation = Variation_1509

    @classmethod
    def create(cls, arg : RuleVariation_1432_Arg) -> "RuleVariation_1432":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1509:
        return self.arg # type: ignore

NonSpare_530_Arg: TypeAlias = RuleVariation_1432_Arg
class NonSpare_530(NonSpare):
    cv_name = "604"
    cv_title = "Vertical Velocity Information"
    cv_rule = RuleVariation_1432

    @classmethod
    def create(cls, arg : NonSpare_530_Arg) -> "NonSpare_530":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1432:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1509:
        return self.rule.variation

class UapItem_529(UapItem):
    cv_non_spare = NonSpare_530

Content_645_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
class Content_645(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.0e-2
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

RuleContent_645_Arg: TypeAlias = Content_645_Arg
class RuleContent_645(RuleContentContextFree):
    cv_content = Content_645

    @property
    def content(self) -> Content_645:
        return self._get_content() # type: ignore

Variation_266_Arg: TypeAlias = RuleContent_645_Arg
class Variation_266(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_645

    @classmethod
    def create(cls, arg : Variation_266_Arg) -> "Variation_266":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_645:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_645:
        return self.rule.content

RuleVariation_259_Arg: TypeAlias = Variation_266_Arg
class RuleVariation_259(RuleVariationContextFree):
    cv_variation = Variation_266

    @classmethod
    def create(cls, arg : RuleVariation_259_Arg) -> "RuleVariation_259":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_266:
        return self.arg # type: ignore

NonSpare_1985_Arg: TypeAlias = RuleVariation_259_Arg
class NonSpare_1985(NonSpare):
    cv_name = "VA"
    cv_title = "Vertical Acceleration"
    cv_rule = RuleVariation_259

    @classmethod
    def create(cls, arg : NonSpare_1985_Arg) -> "NonSpare_1985":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_259:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_266:
        return self.rule.variation

Content_744_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
class Content_744(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0e-2
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

RuleContent_744_Arg: TypeAlias = Content_744_Arg
class RuleContent_744(RuleContentContextFree):
    cv_content = Content_744

    @property
    def content(self) -> Content_744:
        return self._get_content() # type: ignore

Variation_315_Arg: TypeAlias = RuleContent_744_Arg
class Variation_315(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_744

    @classmethod
    def create(cls, arg : Variation_315_Arg) -> "Variation_315":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_744:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_744:
        return self.rule.content

RuleVariation_308_Arg: TypeAlias = Variation_315_Arg
class RuleVariation_308(RuleVariationContextFree):
    cv_variation = Variation_315

    @classmethod
    def create(cls, arg : RuleVariation_308_Arg) -> "RuleVariation_308":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_315:
        return self.arg # type: ignore

NonSpare_1686_Arg: TypeAlias = RuleVariation_308_Arg
class NonSpare_1686(NonSpare):
    cv_name = "SDVA"
    cv_title = ""
    cv_rule = RuleVariation_308

    @classmethod
    def create(cls, arg : NonSpare_1686_Arg) -> "NonSpare_1686":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_308:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_315:
        return self.rule.variation

Item_872_Arg: TypeAlias = NonSpare_1686_Arg
class Item_872(Item):
    cv_non_spare = NonSpare_1686

    @classmethod
    def create(cls, arg : Item_872_Arg) -> "Item_872":
        return cls._create(arg) # type: ignore

NonSpare_796_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_796(NonSpare):
    cv_name = "COVAGH"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_796_Arg) -> "NonSpare_796":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_200_Arg: TypeAlias = NonSpare_796_Arg
class Item_200(Item):
    cv_non_spare = NonSpare_796

    @classmethod
    def create(cls, arg : Item_200_Arg) -> "Item_200":
        return cls._create(arg) # type: ignore

NonSpare_800_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_800(NonSpare):
    cv_name = "COVAVV"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_800_Arg) -> "NonSpare_800":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_201_Arg: TypeAlias = NonSpare_800_Arg
class Item_201(Item):
    cv_non_spare = NonSpare_800

    @classmethod
    def create(cls, arg : Item_201_Arg) -> "Item_201":
        return cls._create(arg) # type: ignore

Variation_1202_Arg_Group = Tuple[Union[RuleVariation_308_Arg, Tuple[Literal["SDVA"], RuleVariation_308_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["COVAGH"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["COVAVV"], RuleVariation_205_Arg]]]
Variation_1202_Arg: TypeAlias = Union[int, Variation_1202_Arg_Group]
class Variation_1202(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_872, 16), (Item_200, 8), (Item_201, 8)]
    cv_items_dict = {"SDVA": RuleVariation_308, "COVAGH": RuleVariation_205, "COVAVV": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["SDVA"]) -> RuleVariation_308:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVAGH"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVAVV"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SDVA"], Literal["COVAGH"], Literal["COVAVV"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SDVA"]) -> RuleVariation_308:
        ...
    @overload
    def get_item(self, key : Literal["COVAGH"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["COVAVV"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1202_Arg) -> 'Variation_1202':
        return cls._create(arg) # type: ignore

RuleVariation_1147_Arg: TypeAlias = Variation_1202_Arg
class RuleVariation_1147(RuleVariationContextFree):
    cv_variation = Variation_1202

    @classmethod
    def create(cls, arg : RuleVariation_1147_Arg) -> "RuleVariation_1147":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1202:
        return self.arg # type: ignore

NonSpare_1617_Arg: TypeAlias = RuleVariation_1147_Arg
class NonSpare_1617(NonSpare):
    cv_name = "RSVA"
    cv_title = "Vertical Acceleration Precision"
    cv_rule = RuleVariation_1147

    @classmethod
    def create(cls, arg : NonSpare_1617_Arg) -> "NonSpare_1617":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1147:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1202:
        return self.rule.variation

NonSpare_2065_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2065(NonSpare):
    cv_name = "X"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2065_Arg) -> "NonSpare_2065":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1172_Arg: TypeAlias = NonSpare_2065_Arg
class Item_1172(Item):
    cv_non_spare = NonSpare_2065

    @classmethod
    def create(cls, arg : Item_1172_Arg) -> "Item_1172":
        return cls._create(arg) # type: ignore

NonSpare_2118_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2118(NonSpare):
    cv_name = "Y"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2118_Arg) -> "NonSpare_2118":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1222_Arg: TypeAlias = NonSpare_2118_Arg
class Item_1222(Item):
    cv_non_spare = NonSpare_2118

    @classmethod
    def create(cls, arg : Item_1222_Arg) -> "Item_1222":
        return cls._create(arg) # type: ignore

Variation_1282_Arg_Group = Tuple[Union[RuleVariation_205_Arg, Tuple[Literal["X"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["Y"], RuleVariation_205_Arg]]]
Variation_1282_Arg: TypeAlias = Union[int, Variation_1282_Arg_Group]
class Variation_1282(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1172, 8), (Item_1222, 8)]
    cv_items_dict = {"X": RuleVariation_205, "Y": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1282_Arg) -> 'Variation_1282':
        return cls._create(arg) # type: ignore

RuleVariation_1212_Arg: TypeAlias = Variation_1282_Arg
class RuleVariation_1212(RuleVariationContextFree):
    cv_variation = Variation_1282

    @classmethod
    def create(cls, arg : RuleVariation_1212_Arg) -> "RuleVariation_1212":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1282:
        return self.arg # type: ignore

NonSpare_798_Arg: TypeAlias = RuleVariation_1212_Arg
class NonSpare_798(NonSpare):
    cv_name = "COVAHP"
    cv_title = "Correlation of Vertical Acceleration and Horizontal Position"
    cv_rule = RuleVariation_1212

    @classmethod
    def create(cls, arg : NonSpare_798_Arg) -> "NonSpare_798":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1212:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1282:
        return self.rule.variation

NonSpare_2066_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2066(NonSpare):
    cv_name = "X"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2066_Arg) -> "NonSpare_2066":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1173_Arg: TypeAlias = NonSpare_2066_Arg
class Item_1173(Item):
    cv_non_spare = NonSpare_2066

    @classmethod
    def create(cls, arg : Item_1173_Arg) -> "Item_1173":
        return cls._create(arg) # type: ignore

NonSpare_2119_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2119(NonSpare):
    cv_name = "Y"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2119_Arg) -> "NonSpare_2119":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1223_Arg: TypeAlias = NonSpare_2119_Arg
class Item_1223(Item):
    cv_non_spare = NonSpare_2119

    @classmethod
    def create(cls, arg : Item_1223_Arg) -> "Item_1223":
        return cls._create(arg) # type: ignore

Variation_1283_Arg_Group = Tuple[Union[RuleVariation_205_Arg, Tuple[Literal["X"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["Y"], RuleVariation_205_Arg]]]
Variation_1283_Arg: TypeAlias = Union[int, Variation_1283_Arg_Group]
class Variation_1283(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1173, 8), (Item_1223, 8)]
    cv_items_dict = {"X": RuleVariation_205, "Y": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1283_Arg) -> 'Variation_1283':
        return cls._create(arg) # type: ignore

RuleVariation_1213_Arg: TypeAlias = Variation_1283_Arg
class RuleVariation_1213(RuleVariationContextFree):
    cv_variation = Variation_1283

    @classmethod
    def create(cls, arg : RuleVariation_1213_Arg) -> "RuleVariation_1213":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1283:
        return self.arg # type: ignore

NonSpare_799_Arg: TypeAlias = RuleVariation_1213_Arg
class NonSpare_799(NonSpare):
    cv_name = "COVAHV"
    cv_title = "Correlation of Vertical Acceleration and Horizontal Velocity"
    cv_rule = RuleVariation_1213

    @classmethod
    def create(cls, arg : NonSpare_799_Arg) -> "NonSpare_799":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1213:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1283:
        return self.rule.variation

NonSpare_2064_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2064(NonSpare):
    cv_name = "X"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2064_Arg) -> "NonSpare_2064":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1171_Arg: TypeAlias = NonSpare_2064_Arg
class Item_1171(Item):
    cv_non_spare = NonSpare_2064

    @classmethod
    def create(cls, arg : Item_1171_Arg) -> "Item_1171":
        return cls._create(arg) # type: ignore

NonSpare_2117_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_2117(NonSpare):
    cv_name = "Y"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_2117_Arg) -> "NonSpare_2117":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_1221_Arg: TypeAlias = NonSpare_2117_Arg
class Item_1221(Item):
    cv_non_spare = NonSpare_2117

    @classmethod
    def create(cls, arg : Item_1221_Arg) -> "Item_1221":
        return cls._create(arg) # type: ignore

Variation_1281_Arg_Group = Tuple[Union[RuleVariation_205_Arg, Tuple[Literal["X"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["Y"], RuleVariation_205_Arg]]]
Variation_1281_Arg: TypeAlias = Union[int, Variation_1281_Arg_Group]
class Variation_1281(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1171, 8), (Item_1221, 8)]
    cv_items_dict = {"X": RuleVariation_205, "Y": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1281_Arg) -> 'Variation_1281':
        return cls._create(arg) # type: ignore

RuleVariation_1211_Arg: TypeAlias = Variation_1281_Arg
class RuleVariation_1211(RuleVariationContextFree):
    cv_variation = Variation_1281

    @classmethod
    def create(cls, arg : RuleVariation_1211_Arg) -> "RuleVariation_1211":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1281:
        return self.arg # type: ignore

NonSpare_797_Arg: TypeAlias = RuleVariation_1211_Arg
class NonSpare_797(NonSpare):
    cv_name = "COVAHA"
    cv_title = "Correlation of Vertical Acceleration and Horizontal Acceleration"
    cv_rule = RuleVariation_1211

    @classmethod
    def create(cls, arg : NonSpare_797_Arg) -> "NonSpare_797":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1211:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1281:
        return self.rule.variation

Variation_1508_Arg = TypedDict('Variation_1508_Arg', {
    "VA": NonSpare_1985_Arg,
    "RSVA": NonSpare_1617_Arg,
    "COVAHP": NonSpare_798_Arg,
    "COVAHV": NonSpare_799_Arg,
    "COVAHA": NonSpare_797_Arg,
}, total=False)
class Variation_1508(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1985, NonSpare_1617, NonSpare_798, NonSpare_799, NonSpare_797]
    cv_items_dict = {"VA": NonSpare_1985, "RSVA": NonSpare_1617, "COVAHP": NonSpare_798, "COVAHV": NonSpare_799, "COVAHA": NonSpare_797}

    @overload
    @classmethod
    def spec(cls, key : Literal["VA"]) -> NonSpare_1985:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSVA"]) -> NonSpare_1617:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVAHP"]) -> NonSpare_798:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVAHV"]) -> NonSpare_799:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVAHA"]) -> NonSpare_797:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VA"], Literal["RSVA"], Literal["COVAHP"], Literal["COVAHV"], Literal["COVAHA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VA"]) -> Optional[NonSpare_1985]:
        ...
    @overload
    def get_item(self, key : Literal["RSVA"]) -> Optional[NonSpare_1617]:
        ...
    @overload
    def get_item(self, key : Literal["COVAHP"]) -> Optional[NonSpare_798]:
        ...
    @overload
    def get_item(self, key : Literal["COVAHV"]) -> Optional[NonSpare_799]:
        ...
    @overload
    def get_item(self, key : Literal["COVAHA"]) -> Optional[NonSpare_797]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["VA"], val : NonSpare_1985_Arg) -> "Variation_1508":
        ...
    @overload
    def set_item(self, key : Literal["RSVA"], val : NonSpare_1617_Arg) -> "Variation_1508":
        ...
    @overload
    def set_item(self, key : Literal["COVAHP"], val : NonSpare_798_Arg) -> "Variation_1508":
        ...
    @overload
    def set_item(self, key : Literal["COVAHV"], val : NonSpare_799_Arg) -> "Variation_1508":
        ...
    @overload
    def set_item(self, key : Literal["COVAHA"], val : NonSpare_797_Arg) -> "Variation_1508":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["VA"]) -> "Variation_1508":
        ...
    @overload
    def del_item(self, key : Literal["RSVA"]) -> "Variation_1508":
        ...
    @overload
    def del_item(self, key : Literal["COVAHP"]) -> "Variation_1508":
        ...
    @overload
    def del_item(self, key : Literal["COVAHV"]) -> "Variation_1508":
        ...
    @overload
    def del_item(self, key : Literal["COVAHA"]) -> "Variation_1508":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1508_Arg) -> 'Variation_1508':
        return cls._create(arg) # type: ignore

RuleVariation_1431_Arg: TypeAlias = Variation_1508_Arg
class RuleVariation_1431(RuleVariationContextFree):
    cv_variation = Variation_1508

    @classmethod
    def create(cls, arg : RuleVariation_1431_Arg) -> "RuleVariation_1431":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1508:
        return self.arg # type: ignore

NonSpare_532_Arg: TypeAlias = RuleVariation_1431_Arg
class NonSpare_532(NonSpare):
    cv_name = "605"
    cv_title = "Vertical Velocity Information"
    cv_rule = RuleVariation_1431

    @classmethod
    def create(cls, arg : NonSpare_532_Arg) -> "NonSpare_532":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1431:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1508:
        return self.rule.variation

class UapItem_531(UapItem):
    cv_non_spare = NonSpare_532

Variation_386_Arg: TypeAlias = RuleContent_0_Arg
class Variation_386(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_386_Arg) -> "Variation_386":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

Variation_1395_Arg: TypeAlias = List[Variation_386_Arg]
class Variation_1395(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_386

    @classmethod
    def create(cls, arg : Variation_1395_Arg) -> 'Variation_1395':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_386]:
        return self._get_list() # type: ignore

RuleVariation_1318_Arg: TypeAlias = Variation_1395_Arg
class RuleVariation_1318(RuleVariationContextFree):
    cv_variation = Variation_1395

    @classmethod
    def create(cls, arg : RuleVariation_1318_Arg) -> "RuleVariation_1318":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1395:
        return self.arg # type: ignore

NonSpare_507_Arg: TypeAlias = RuleVariation_1318_Arg
class NonSpare_507(NonSpare):
    cv_name = "480"
    cv_title = "Associations"
    cv_rule = RuleVariation_1318

    @classmethod
    def create(cls, arg : NonSpare_507_Arg) -> "NonSpare_507":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1318:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1395:
        return self.rule.variation

class UapItem_506(UapItem):
    cv_non_spare = NonSpare_507

Content_638_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_638(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.1
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_638_Arg: TypeAlias = Content_638_Arg
class RuleContent_638(RuleContentContextFree):
    cv_content = Content_638

    @property
    def content(self) -> Content_638:
        return self._get_content() # type: ignore

Variation_352_Arg: TypeAlias = RuleContent_638_Arg
class Variation_352(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_638

    @classmethod
    def create(cls, arg : Variation_352_Arg) -> "Variation_352":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_638:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_638:
        return self.rule.content

RuleVariation_345_Arg: TypeAlias = Variation_352_Arg
class RuleVariation_345(RuleVariationContextFree):
    cv_variation = Variation_352

    @classmethod
    def create(cls, arg : RuleVariation_345_Arg) -> "RuleVariation_345":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_352:
        return self.arg # type: ignore

NonSpare_1522_Arg: TypeAlias = RuleVariation_345_Arg
class NonSpare_1522(NonSpare):
    cv_name = "R"
    cv_title = "Range"
    cv_rule = RuleVariation_345

    @classmethod
    def create(cls, arg : NonSpare_1522_Arg) -> "NonSpare_1522":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_345:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_352:
        return self.rule.variation

Content_734_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_734(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.1
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_734_Arg: TypeAlias = Content_734_Arg
class RuleContent_734(RuleContentContextFree):
    cv_content = Content_734

    @property
    def content(self) -> Content_734:
        return self._get_content() # type: ignore

Variation_365_Arg: TypeAlias = RuleContent_734_Arg
class Variation_365(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_734

    @classmethod
    def create(cls, arg : Variation_365_Arg) -> "Variation_365":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_734:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_734:
        return self.rule.content

RuleVariation_358_Arg: TypeAlias = Variation_365_Arg
class RuleVariation_358(RuleVariationContextFree):
    cv_variation = Variation_365

    @classmethod
    def create(cls, arg : RuleVariation_358_Arg) -> "RuleVariation_358":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_365:
        return self.arg # type: ignore

NonSpare_1614_Arg: TypeAlias = RuleVariation_358_Arg
class NonSpare_1614(NonSpare):
    cv_name = "RSR"
    cv_title = "Range Resolution"
    cv_rule = RuleVariation_358

    @classmethod
    def create(cls, arg : NonSpare_1614_Arg) -> "NonSpare_1614":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_358:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_365:
        return self.rule.variation

NonSpare_1680_Arg: TypeAlias = RuleVariation_358_Arg
class NonSpare_1680(NonSpare):
    cv_name = "SDR"
    cv_title = "Range Precision"
    cv_rule = RuleVariation_358

    @classmethod
    def create(cls, arg : NonSpare_1680_Arg) -> "NonSpare_1680":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_358:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_365:
        return self.rule.variation

Content_640_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
class Content_640(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.1
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_640_Arg: TypeAlias = Content_640_Arg
class RuleContent_640(RuleContentContextFree):
    cv_content = Content_640

    @property
    def content(self) -> Content_640:
        return self._get_content() # type: ignore

Variation_353_Arg: TypeAlias = RuleContent_640_Arg
class Variation_353(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_640

    @classmethod
    def create(cls, arg : Variation_353_Arg) -> "Variation_353":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_640:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_640:
        return self.rule.content

RuleVariation_346_Arg: TypeAlias = Variation_353_Arg
class RuleVariation_346(RuleVariationContextFree):
    cv_variation = Variation_353

    @classmethod
    def create(cls, arg : RuleVariation_346_Arg) -> "RuleVariation_346":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_353:
        return self.arg # type: ignore

NonSpare_1600_Arg: TypeAlias = RuleVariation_346_Arg
class NonSpare_1600(NonSpare):
    cv_name = "RR"
    cv_title = "Range Rate"
    cv_rule = RuleVariation_346

    @classmethod
    def create(cls, arg : NonSpare_1600_Arg) -> "NonSpare_1600":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_346:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_353:
        return self.rule.variation

Content_736_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
class Content_736(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.1
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_736_Arg: TypeAlias = Content_736_Arg
class RuleContent_736(RuleContentContextFree):
    cv_content = Content_736

    @property
    def content(self) -> Content_736:
        return self._get_content() # type: ignore

Variation_366_Arg: TypeAlias = RuleContent_736_Arg
class Variation_366(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_736

    @classmethod
    def create(cls, arg : Variation_366_Arg) -> "Variation_366":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_736:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_736:
        return self.rule.content

RuleVariation_359_Arg: TypeAlias = Variation_366_Arg
class RuleVariation_359(RuleVariationContextFree):
    cv_variation = Variation_366

    @classmethod
    def create(cls, arg : RuleVariation_359_Arg) -> "RuleVariation_359":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_366:
        return self.arg # type: ignore

NonSpare_1615_Arg: TypeAlias = RuleVariation_359_Arg
class NonSpare_1615(NonSpare):
    cv_name = "RSRR"
    cv_title = "Range Rate Resolution"
    cv_rule = RuleVariation_359

    @classmethod
    def create(cls, arg : NonSpare_1615_Arg) -> "NonSpare_1615":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_359:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_366:
        return self.rule.variation

NonSpare_1683_Arg: TypeAlias = RuleVariation_359_Arg
class NonSpare_1683(NonSpare):
    cv_name = "SDRR"
    cv_title = ""
    cv_rule = RuleVariation_359

    @classmethod
    def create(cls, arg : NonSpare_1683_Arg) -> "NonSpare_1683":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_359:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_366:
        return self.rule.variation

Item_870_Arg: TypeAlias = NonSpare_1683_Arg
class Item_870(Item):
    cv_non_spare = NonSpare_1683

    @classmethod
    def create(cls, arg : Item_870_Arg) -> "Item_870":
        return cls._create(arg) # type: ignore

NonSpare_788_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_788(NonSpare):
    cv_name = "CORRR"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_788_Arg) -> "NonSpare_788":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_193_Arg: TypeAlias = NonSpare_788_Arg
class Item_193(Item):
    cv_non_spare = NonSpare_788

    @classmethod
    def create(cls, arg : Item_193_Arg) -> "Item_193":
        return cls._create(arg) # type: ignore

Variation_1201_Arg_Group = Tuple[Union[RuleVariation_359_Arg, Tuple[Literal["SDRR"], RuleVariation_359_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["CORRR"], RuleVariation_205_Arg]]]
Variation_1201_Arg: TypeAlias = Union[int, Variation_1201_Arg_Group]
class Variation_1201(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_870, 24), (Item_193, 8)]
    cv_items_dict = {"SDRR": RuleVariation_359, "CORRR": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["SDRR"]) -> RuleVariation_359:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CORRR"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SDRR"], Literal["CORRR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SDRR"]) -> RuleVariation_359:
        ...
    @overload
    def get_item(self, key : Literal["CORRR"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1201_Arg) -> 'Variation_1201':
        return cls._create(arg) # type: ignore

RuleVariation_1146_Arg: TypeAlias = Variation_1201_Arg
class RuleVariation_1146(RuleVariationContextFree):
    cv_variation = Variation_1201

    @classmethod
    def create(cls, arg : RuleVariation_1146_Arg) -> "RuleVariation_1146":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1201:
        return self.arg # type: ignore

NonSpare_1684_Arg: TypeAlias = RuleVariation_1146_Arg
class NonSpare_1684(NonSpare):
    cv_name = "SDRR"
    cv_title = "Range Rate Precision"
    cv_rule = RuleVariation_1146

    @classmethod
    def create(cls, arg : NonSpare_1684_Arg) -> "NonSpare_1684":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1146:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1201:
        return self.rule.variation

Content_672_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
class Content_672(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.5625e-2
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

RuleContent_672_Arg: TypeAlias = Content_672_Arg
class RuleContent_672(RuleContentContextFree):
    cv_content = Content_672

    @property
    def content(self) -> Content_672:
        return self._get_content() # type: ignore

Variation_283_Arg: TypeAlias = RuleContent_672_Arg
class Variation_283(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_672

    @classmethod
    def create(cls, arg : Variation_283_Arg) -> "Variation_283":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_672:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_672:
        return self.rule.content

RuleVariation_276_Arg: TypeAlias = Variation_283_Arg
class RuleVariation_276(RuleVariationContextFree):
    cv_variation = Variation_283

    @classmethod
    def create(cls, arg : RuleVariation_276_Arg) -> "RuleVariation_276":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_283:
        return self.arg # type: ignore

NonSpare_1524_Arg: TypeAlias = RuleVariation_276_Arg
class NonSpare_1524(NonSpare):
    cv_name = "RA"
    cv_title = "Range Acceleration"
    cv_rule = RuleVariation_276

    @classmethod
    def create(cls, arg : NonSpare_1524_Arg) -> "NonSpare_1524":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_276:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_283:
        return self.rule.variation

Content_766_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
class Content_766(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 7.8125e-3
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

RuleContent_765_Arg: TypeAlias = Content_766_Arg
class RuleContent_765(RuleContentContextFree):
    cv_content = Content_766

    @property
    def content(self) -> Content_766:
        return self._get_content() # type: ignore

Variation_331_Arg: TypeAlias = RuleContent_765_Arg
class Variation_331(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_765

    @classmethod
    def create(cls, arg : Variation_331_Arg) -> "Variation_331":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_765:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_766:
        return self.rule.content

RuleVariation_324_Arg: TypeAlias = Variation_331_Arg
class RuleVariation_324(RuleVariationContextFree):
    cv_variation = Variation_331

    @classmethod
    def create(cls, arg : RuleVariation_324_Arg) -> "RuleVariation_324":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_331:
        return self.arg # type: ignore

NonSpare_1681_Arg: TypeAlias = RuleVariation_324_Arg
class NonSpare_1681(NonSpare):
    cv_name = "SDRA"
    cv_title = ""
    cv_rule = RuleVariation_324

    @classmethod
    def create(cls, arg : NonSpare_1681_Arg) -> "NonSpare_1681":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_324:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_331:
        return self.rule.variation

Item_869_Arg: TypeAlias = NonSpare_1681_Arg
class Item_869(Item):
    cv_non_spare = NonSpare_1681

    @classmethod
    def create(cls, arg : Item_869_Arg) -> "Item_869":
        return cls._create(arg) # type: ignore

NonSpare_786_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_786(NonSpare):
    cv_name = "CORAR"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_786_Arg) -> "NonSpare_786":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_191_Arg: TypeAlias = NonSpare_786_Arg
class Item_191(Item):
    cv_non_spare = NonSpare_786

    @classmethod
    def create(cls, arg : Item_191_Arg) -> "Item_191":
        return cls._create(arg) # type: ignore

NonSpare_787_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_787(NonSpare):
    cv_name = "CORARR"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_787_Arg) -> "NonSpare_787":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_192_Arg: TypeAlias = NonSpare_787_Arg
class Item_192(Item):
    cv_non_spare = NonSpare_787

    @classmethod
    def create(cls, arg : Item_192_Arg) -> "Item_192":
        return cls._create(arg) # type: ignore

Variation_1200_Arg_Group = Tuple[Union[RuleVariation_324_Arg, Tuple[Literal["SDRA"], RuleVariation_324_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["CORAR"], RuleVariation_205_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["CORARR"], RuleVariation_205_Arg]]]
Variation_1200_Arg: TypeAlias = Union[int, Variation_1200_Arg_Group]
class Variation_1200(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_869, 16), (Item_191, 8), (Item_192, 8)]
    cv_items_dict = {"SDRA": RuleVariation_324, "CORAR": RuleVariation_205, "CORARR": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["SDRA"]) -> RuleVariation_324:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CORAR"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CORARR"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SDRA"], Literal["CORAR"], Literal["CORARR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SDRA"]) -> RuleVariation_324:
        ...
    @overload
    def get_item(self, key : Literal["CORAR"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["CORARR"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1200_Arg) -> 'Variation_1200':
        return cls._create(arg) # type: ignore

RuleVariation_1145_Arg: TypeAlias = Variation_1200_Arg
class RuleVariation_1145(RuleVariationContextFree):
    cv_variation = Variation_1200

    @classmethod
    def create(cls, arg : RuleVariation_1145_Arg) -> "RuleVariation_1145":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1200:
        return self.arg # type: ignore

NonSpare_1682_Arg: TypeAlias = RuleVariation_1145_Arg
class NonSpare_1682(NonSpare):
    cv_name = "SDRA"
    cv_title = "Range Acceleration Precision"
    cv_rule = RuleVariation_1145

    @classmethod
    def create(cls, arg : NonSpare_1682_Arg) -> "NonSpare_1682":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1145:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1200:
        return self.rule.variation

Variation_1494_Arg = TypedDict('Variation_1494_Arg', {
    "R": NonSpare_1522_Arg,
    "RSR": NonSpare_1614_Arg,
    "SDR": NonSpare_1680_Arg,
    "RR": NonSpare_1600_Arg,
    "RSRR": NonSpare_1615_Arg,
    "SDRR": NonSpare_1684_Arg,
    "RA": NonSpare_1524_Arg,
    "SDRA": NonSpare_1682_Arg,
}, total=False)
class Variation_1494(Compound):
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1522, NonSpare_1614, NonSpare_1680, NonSpare_1600, NonSpare_1615, NonSpare_1684, NonSpare_1524, NonSpare_1682]
    cv_items_dict = {"R": NonSpare_1522, "RSR": NonSpare_1614, "SDR": NonSpare_1680, "RR": NonSpare_1600, "RSRR": NonSpare_1615, "SDRR": NonSpare_1684, "RA": NonSpare_1524, "SDRA": NonSpare_1682}

    @overload
    @classmethod
    def spec(cls, key : Literal["R"]) -> NonSpare_1522:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSR"]) -> NonSpare_1614:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDR"]) -> NonSpare_1680:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RR"]) -> NonSpare_1600:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSRR"]) -> NonSpare_1615:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDRR"]) -> NonSpare_1684:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RA"]) -> NonSpare_1524:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDRA"]) -> NonSpare_1682:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["R"], Literal["RSR"], Literal["SDR"], Literal["RR"], Literal["RSRR"], Literal["SDRR"], Literal["RA"], Literal["SDRA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["R"]) -> Optional[NonSpare_1522]:
        ...
    @overload
    def get_item(self, key : Literal["RSR"]) -> Optional[NonSpare_1614]:
        ...
    @overload
    def get_item(self, key : Literal["SDR"]) -> Optional[NonSpare_1680]:
        ...
    @overload
    def get_item(self, key : Literal["RR"]) -> Optional[NonSpare_1600]:
        ...
    @overload
    def get_item(self, key : Literal["RSRR"]) -> Optional[NonSpare_1615]:
        ...
    @overload
    def get_item(self, key : Literal["SDRR"]) -> Optional[NonSpare_1684]:
        ...
    @overload
    def get_item(self, key : Literal["RA"]) -> Optional[NonSpare_1524]:
        ...
    @overload
    def get_item(self, key : Literal["SDRA"]) -> Optional[NonSpare_1682]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["R"], val : NonSpare_1522_Arg) -> "Variation_1494":
        ...
    @overload
    def set_item(self, key : Literal["RSR"], val : NonSpare_1614_Arg) -> "Variation_1494":
        ...
    @overload
    def set_item(self, key : Literal["SDR"], val : NonSpare_1680_Arg) -> "Variation_1494":
        ...
    @overload
    def set_item(self, key : Literal["RR"], val : NonSpare_1600_Arg) -> "Variation_1494":
        ...
    @overload
    def set_item(self, key : Literal["RSRR"], val : NonSpare_1615_Arg) -> "Variation_1494":
        ...
    @overload
    def set_item(self, key : Literal["SDRR"], val : NonSpare_1684_Arg) -> "Variation_1494":
        ...
    @overload
    def set_item(self, key : Literal["RA"], val : NonSpare_1524_Arg) -> "Variation_1494":
        ...
    @overload
    def set_item(self, key : Literal["SDRA"], val : NonSpare_1682_Arg) -> "Variation_1494":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["R"]) -> "Variation_1494":
        ...
    @overload
    def del_item(self, key : Literal["RSR"]) -> "Variation_1494":
        ...
    @overload
    def del_item(self, key : Literal["SDR"]) -> "Variation_1494":
        ...
    @overload
    def del_item(self, key : Literal["RR"]) -> "Variation_1494":
        ...
    @overload
    def del_item(self, key : Literal["RSRR"]) -> "Variation_1494":
        ...
    @overload
    def del_item(self, key : Literal["SDRR"]) -> "Variation_1494":
        ...
    @overload
    def del_item(self, key : Literal["RA"]) -> "Variation_1494":
        ...
    @overload
    def del_item(self, key : Literal["SDRA"]) -> "Variation_1494":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1494_Arg) -> 'Variation_1494':
        return cls._create(arg) # type: ignore

RuleVariation_1417_Arg: TypeAlias = Variation_1494_Arg
class RuleVariation_1417(RuleVariationContextFree):
    cv_variation = Variation_1494

    @classmethod
    def create(cls, arg : RuleVariation_1417_Arg) -> "RuleVariation_1417":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1494:
        return self.arg # type: ignore

NonSpare_537_Arg: TypeAlias = RuleVariation_1417_Arg
class NonSpare_537(NonSpare):
    cv_name = "625"
    cv_title = "Range Information"
    cv_rule = RuleVariation_1417

    @classmethod
    def create(cls, arg : NonSpare_537_Arg) -> "NonSpare_537":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1417:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1494:
        return self.rule.variation

class UapItem_536(UapItem):
    cv_non_spare = NonSpare_537

NonSpare_907_Arg: TypeAlias = RuleVariation_348_Arg
class NonSpare_907(NonSpare):
    cv_name = "DV"
    cv_title = "Doppler Velocity"
    cv_rule = RuleVariation_348

    @classmethod
    def create(cls, arg : NonSpare_907_Arg) -> "NonSpare_907":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_348:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_355:
        return self.rule.variation

Content_761_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
class Content_761(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.5625e-2
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_760_Arg: TypeAlias = Content_761_Arg
class RuleContent_760(RuleContentContextFree):
    cv_content = Content_761

    @property
    def content(self) -> Content_761:
        return self._get_content() # type: ignore

Variation_326_Arg: TypeAlias = RuleContent_760_Arg
class Variation_326(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_760

    @classmethod
    def create(cls, arg : Variation_326_Arg) -> "Variation_326":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_760:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_761:
        return self.rule.content

RuleVariation_319_Arg: TypeAlias = Variation_326_Arg
class RuleVariation_319(RuleVariationContextFree):
    cv_variation = Variation_326

    @classmethod
    def create(cls, arg : RuleVariation_319_Arg) -> "RuleVariation_319":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_326:
        return self.arg # type: ignore

NonSpare_1669_Arg: TypeAlias = RuleVariation_319_Arg
class NonSpare_1669(NonSpare):
    cv_name = "SDDV"
    cv_title = "Precision of Doppler Velocity"
    cv_rule = RuleVariation_319

    @classmethod
    def create(cls, arg : NonSpare_1669_Arg) -> "NonSpare_1669":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_319:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_326:
        return self.rule.variation

NonSpare_851_Arg: TypeAlias = RuleVariation_276_Arg
class NonSpare_851(NonSpare):
    cv_name = "DA"
    cv_title = "Doppler Acceleration"
    cv_rule = RuleVariation_276

    @classmethod
    def create(cls, arg : NonSpare_851_Arg) -> "NonSpare_851":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_276:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_283:
        return self.rule.variation

Content_762_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
class Content_762(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.5625e-2
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

RuleContent_761_Arg: TypeAlias = Content_762_Arg
class RuleContent_761(RuleContentContextFree):
    cv_content = Content_762

    @property
    def content(self) -> Content_762:
        return self._get_content() # type: ignore

Variation_327_Arg: TypeAlias = RuleContent_761_Arg
class Variation_327(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_761

    @classmethod
    def create(cls, arg : Variation_327_Arg) -> "Variation_327":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_761:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_762:
        return self.rule.content

RuleVariation_320_Arg: TypeAlias = Variation_327_Arg
class RuleVariation_320(RuleVariationContextFree):
    cv_variation = Variation_327

    @classmethod
    def create(cls, arg : RuleVariation_320_Arg) -> "RuleVariation_320":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_327:
        return self.arg # type: ignore

NonSpare_1667_Arg: TypeAlias = RuleVariation_320_Arg
class NonSpare_1667(NonSpare):
    cv_name = "SDDA"
    cv_title = ""
    cv_rule = RuleVariation_320

    @classmethod
    def create(cls, arg : NonSpare_1667_Arg) -> "NonSpare_1667":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_320:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_327:
        return self.rule.variation

Item_865_Arg: TypeAlias = NonSpare_1667_Arg
class Item_865(Item):
    cv_non_spare = NonSpare_1667

    @classmethod
    def create(cls, arg : Item_865_Arg) -> "Item_865":
        return cls._create(arg) # type: ignore

NonSpare_747_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_747(NonSpare):
    cv_name = "CODADV"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_747_Arg) -> "NonSpare_747":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_171_Arg: TypeAlias = NonSpare_747_Arg
class Item_171(Item):
    cv_non_spare = NonSpare_747

    @classmethod
    def create(cls, arg : Item_171_Arg) -> "Item_171":
        return cls._create(arg) # type: ignore

Variation_1197_Arg_Group = Tuple[Union[RuleVariation_320_Arg, Tuple[Literal["SDDA"], RuleVariation_320_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["CODADV"], RuleVariation_205_Arg]]]
Variation_1197_Arg: TypeAlias = Union[int, Variation_1197_Arg_Group]
class Variation_1197(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_865, 16), (Item_171, 8)]
    cv_items_dict = {"SDDA": RuleVariation_320, "CODADV": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["SDDA"]) -> RuleVariation_320:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CODADV"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SDDA"], Literal["CODADV"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SDDA"]) -> RuleVariation_320:
        ...
    @overload
    def get_item(self, key : Literal["CODADV"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1197_Arg) -> 'Variation_1197':
        return cls._create(arg) # type: ignore

RuleVariation_1142_Arg: TypeAlias = Variation_1197_Arg
class RuleVariation_1142(RuleVariationContextFree):
    cv_variation = Variation_1197

    @classmethod
    def create(cls, arg : RuleVariation_1142_Arg) -> "RuleVariation_1142":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1197:
        return self.arg # type: ignore

NonSpare_1668_Arg: TypeAlias = RuleVariation_1142_Arg
class NonSpare_1668(NonSpare):
    cv_name = "SDDA"
    cv_title = "Precision of Doppler Acceleration"
    cv_rule = RuleVariation_1142

    @classmethod
    def create(cls, arg : NonSpare_1668_Arg) -> "NonSpare_1668":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1142:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1197:
        return self.rule.variation

NonSpare_751_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_751(NonSpare):
    cv_name = "CODVR"
    cv_title = "Correlation of Doppler Velocity and Range"
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_751_Arg) -> "NonSpare_751":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

NonSpare_753_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_753(NonSpare):
    cv_name = "CODVRR"
    cv_title = "Correlation of Doppler Velocity and Range Rate"
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_753_Arg) -> "NonSpare_753":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

NonSpare_752_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_752(NonSpare):
    cv_name = "CODVRA"
    cv_title = "Correlation of Doppler Velocity and Range Acceleration"
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_752_Arg) -> "NonSpare_752":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

NonSpare_748_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_748(NonSpare):
    cv_name = "CODAR"
    cv_title = "Correlation of Doppler Acceleration and Range"
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_748_Arg) -> "NonSpare_748":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

NonSpare_750_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_750(NonSpare):
    cv_name = "CODARR"
    cv_title = "Correlation of Doppler Acceleration and Range Rate"
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_750_Arg) -> "NonSpare_750":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

NonSpare_749_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_749(NonSpare):
    cv_name = "CODARA"
    cv_title = "Correlation of Doppler Acceleration and Range Acceleration"
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_749_Arg) -> "NonSpare_749":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Variation_1475_Arg = TypedDict('Variation_1475_Arg', {
    "DV": NonSpare_907_Arg,
    "SDDV": NonSpare_1669_Arg,
    "DA": NonSpare_851_Arg,
    "SDDA": NonSpare_1668_Arg,
    "CODVR": NonSpare_751_Arg,
    "CODVRR": NonSpare_753_Arg,
    "CODVRA": NonSpare_752_Arg,
    "CODAR": NonSpare_748_Arg,
    "CODARR": NonSpare_750_Arg,
    "CODARA": NonSpare_749_Arg,
}, total=False)
class Variation_1475(Compound):
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_907, NonSpare_1669, NonSpare_851, NonSpare_1668, NonSpare_751, NonSpare_753, NonSpare_752, NonSpare_748, NonSpare_750, NonSpare_749]
    cv_items_dict = {"DV": NonSpare_907, "SDDV": NonSpare_1669, "DA": NonSpare_851, "SDDA": NonSpare_1668, "CODVR": NonSpare_751, "CODVRR": NonSpare_753, "CODVRA": NonSpare_752, "CODAR": NonSpare_748, "CODARR": NonSpare_750, "CODARA": NonSpare_749}

    @overload
    @classmethod
    def spec(cls, key : Literal["DV"]) -> NonSpare_907:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDDV"]) -> NonSpare_1669:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DA"]) -> NonSpare_851:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDDA"]) -> NonSpare_1668:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CODVR"]) -> NonSpare_751:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CODVRR"]) -> NonSpare_753:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CODVRA"]) -> NonSpare_752:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CODAR"]) -> NonSpare_748:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CODARR"]) -> NonSpare_750:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CODARA"]) -> NonSpare_749:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["DV"], Literal["SDDV"], Literal["DA"], Literal["SDDA"], Literal["CODVR"], Literal["CODVRR"], Literal["CODVRA"], Literal["CODAR"], Literal["CODARR"], Literal["CODARA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["DV"]) -> Optional[NonSpare_907]:
        ...
    @overload
    def get_item(self, key : Literal["SDDV"]) -> Optional[NonSpare_1669]:
        ...
    @overload
    def get_item(self, key : Literal["DA"]) -> Optional[NonSpare_851]:
        ...
    @overload
    def get_item(self, key : Literal["SDDA"]) -> Optional[NonSpare_1668]:
        ...
    @overload
    def get_item(self, key : Literal["CODVR"]) -> Optional[NonSpare_751]:
        ...
    @overload
    def get_item(self, key : Literal["CODVRR"]) -> Optional[NonSpare_753]:
        ...
    @overload
    def get_item(self, key : Literal["CODVRA"]) -> Optional[NonSpare_752]:
        ...
    @overload
    def get_item(self, key : Literal["CODAR"]) -> Optional[NonSpare_748]:
        ...
    @overload
    def get_item(self, key : Literal["CODARR"]) -> Optional[NonSpare_750]:
        ...
    @overload
    def get_item(self, key : Literal["CODARA"]) -> Optional[NonSpare_749]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["DV"], val : NonSpare_907_Arg) -> "Variation_1475":
        ...
    @overload
    def set_item(self, key : Literal["SDDV"], val : NonSpare_1669_Arg) -> "Variation_1475":
        ...
    @overload
    def set_item(self, key : Literal["DA"], val : NonSpare_851_Arg) -> "Variation_1475":
        ...
    @overload
    def set_item(self, key : Literal["SDDA"], val : NonSpare_1668_Arg) -> "Variation_1475":
        ...
    @overload
    def set_item(self, key : Literal["CODVR"], val : NonSpare_751_Arg) -> "Variation_1475":
        ...
    @overload
    def set_item(self, key : Literal["CODVRR"], val : NonSpare_753_Arg) -> "Variation_1475":
        ...
    @overload
    def set_item(self, key : Literal["CODVRA"], val : NonSpare_752_Arg) -> "Variation_1475":
        ...
    @overload
    def set_item(self, key : Literal["CODAR"], val : NonSpare_748_Arg) -> "Variation_1475":
        ...
    @overload
    def set_item(self, key : Literal["CODARR"], val : NonSpare_750_Arg) -> "Variation_1475":
        ...
    @overload
    def set_item(self, key : Literal["CODARA"], val : NonSpare_749_Arg) -> "Variation_1475":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["DV"]) -> "Variation_1475":
        ...
    @overload
    def del_item(self, key : Literal["SDDV"]) -> "Variation_1475":
        ...
    @overload
    def del_item(self, key : Literal["DA"]) -> "Variation_1475":
        ...
    @overload
    def del_item(self, key : Literal["SDDA"]) -> "Variation_1475":
        ...
    @overload
    def del_item(self, key : Literal["CODVR"]) -> "Variation_1475":
        ...
    @overload
    def del_item(self, key : Literal["CODVRR"]) -> "Variation_1475":
        ...
    @overload
    def del_item(self, key : Literal["CODVRA"]) -> "Variation_1475":
        ...
    @overload
    def del_item(self, key : Literal["CODAR"]) -> "Variation_1475":
        ...
    @overload
    def del_item(self, key : Literal["CODARR"]) -> "Variation_1475":
        ...
    @overload
    def del_item(self, key : Literal["CODARA"]) -> "Variation_1475":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1475_Arg) -> 'Variation_1475':
        return cls._create(arg) # type: ignore

RuleVariation_1398_Arg: TypeAlias = Variation_1475_Arg
class RuleVariation_1398(RuleVariationContextFree):
    cv_variation = Variation_1475

    @classmethod
    def create(cls, arg : RuleVariation_1398_Arg) -> "RuleVariation_1398":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1475:
        return self.arg # type: ignore

NonSpare_538_Arg: TypeAlias = RuleVariation_1398_Arg
class NonSpare_538(NonSpare):
    cv_name = "626"
    cv_title = "Doppler Information"
    cv_rule = RuleVariation_1398

    @classmethod
    def create(cls, arg : NonSpare_538_Arg) -> "NonSpare_538":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1398:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1475:
        return self.rule.variation

class UapItem_537(UapItem):
    cv_non_spare = NonSpare_538

Content_792_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_792(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 5.4931640625e-3
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_791_Arg: TypeAlias = Content_792_Arg
class RuleContent_791(RuleContentContextFree):
    cv_content = Content_792

    @property
    def content(self) -> Content_792:
        return self._get_content() # type: ignore

Variation_343_Arg: TypeAlias = RuleContent_791_Arg
class Variation_343(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_791

    @classmethod
    def create(cls, arg : Variation_343_Arg) -> "Variation_343":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_791:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_792:
        return self.rule.content

RuleVariation_336_Arg: TypeAlias = Variation_343_Arg
class RuleVariation_336(RuleVariationContextFree):
    cv_variation = Variation_343

    @classmethod
    def create(cls, arg : RuleVariation_336_Arg) -> "RuleVariation_336":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_343:
        return self.arg # type: ignore

NonSpare_658_Arg: TypeAlias = RuleVariation_336_Arg
class NonSpare_658(NonSpare):
    cv_name = "AZ"
    cv_title = "Azimuth"
    cv_rule = RuleVariation_336

    @classmethod
    def create(cls, arg : NonSpare_658_Arg) -> "NonSpare_658":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

Content_783_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_783(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 6.866455078125e-4
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_782_Arg: TypeAlias = Content_783_Arg
class RuleContent_782(RuleContentContextFree):
    cv_content = Content_783

    @property
    def content(self) -> Content_783:
        return self._get_content() # type: ignore

Variation_338_Arg: TypeAlias = RuleContent_782_Arg
class Variation_338(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_782

    @classmethod
    def create(cls, arg : Variation_338_Arg) -> "Variation_338":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_782:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_783:
        return self.rule.content

RuleVariation_331_Arg: TypeAlias = Variation_338_Arg
class RuleVariation_331(RuleVariationContextFree):
    cv_variation = Variation_338

    @classmethod
    def create(cls, arg : RuleVariation_331_Arg) -> "RuleVariation_331":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_338:
        return self.arg # type: ignore

NonSpare_1606_Arg: TypeAlias = RuleVariation_331_Arg
class NonSpare_1606(NonSpare):
    cv_name = "RSAZ"
    cv_title = "Azimuth Resolution"
    cv_rule = RuleVariation_331

    @classmethod
    def create(cls, arg : NonSpare_1606_Arg) -> "NonSpare_1606":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_331:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_338:
        return self.rule.variation

NonSpare_1664_Arg: TypeAlias = RuleVariation_331_Arg
class NonSpare_1664(NonSpare):
    cv_name = "SDASZ"
    cv_title = "Standard Deviation of Azimuth"
    cv_rule = RuleVariation_331

    @classmethod
    def create(cls, arg : NonSpare_1664_Arg) -> "NonSpare_1664":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_331:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_338:
        return self.rule.variation

Content_687_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_687(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 2.74658203125e-3
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_687_Arg: TypeAlias = Content_687_Arg
class RuleContent_687(RuleContentContextFree):
    cv_content = Content_687

    @property
    def content(self) -> Content_687:
        return self._get_content() # type: ignore

Variation_293_Arg: TypeAlias = RuleContent_687_Arg
class Variation_293(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_687

    @classmethod
    def create(cls, arg : Variation_293_Arg) -> "Variation_293":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_687:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_687:
        return self.rule.content

RuleVariation_286_Arg: TypeAlias = Variation_293_Arg
class RuleVariation_286(RuleVariationContextFree):
    cv_variation = Variation_293

    @classmethod
    def create(cls, arg : RuleVariation_286_Arg) -> "RuleVariation_286":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_293:
        return self.arg # type: ignore

NonSpare_662_Arg: TypeAlias = RuleVariation_286_Arg
class NonSpare_662(NonSpare):
    cv_name = "AZR"
    cv_title = "Azimuth Rate"
    cv_rule = RuleVariation_286

    @classmethod
    def create(cls, arg : NonSpare_662_Arg) -> "NonSpare_662":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_286:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_293:
        return self.rule.variation

NonSpare_1665_Arg: TypeAlias = RuleVariation_331_Arg
class NonSpare_1665(NonSpare):
    cv_name = "SDAZR"
    cv_title = ""
    cv_rule = RuleVariation_331

    @classmethod
    def create(cls, arg : NonSpare_1665_Arg) -> "NonSpare_1665":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_331:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_338:
        return self.rule.variation

Item_864_Arg: TypeAlias = NonSpare_1665_Arg
class Item_864(Item):
    cv_non_spare = NonSpare_1665

    @classmethod
    def create(cls, arg : Item_864_Arg) -> "Item_864":
        return cls._create(arg) # type: ignore

NonSpare_746_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_746(NonSpare):
    cv_name = "COAZRAZ"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_746_Arg) -> "NonSpare_746":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_170_Arg: TypeAlias = NonSpare_746_Arg
class Item_170(Item):
    cv_non_spare = NonSpare_746

    @classmethod
    def create(cls, arg : Item_170_Arg) -> "Item_170":
        return cls._create(arg) # type: ignore

Variation_1196_Arg_Group = Tuple[Union[RuleVariation_331_Arg, Tuple[Literal["SDAZR"], RuleVariation_331_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["COAZRAZ"], RuleVariation_205_Arg]]]
Variation_1196_Arg: TypeAlias = Union[int, Variation_1196_Arg_Group]
class Variation_1196(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_864, 16), (Item_170, 8)]
    cv_items_dict = {"SDAZR": RuleVariation_331, "COAZRAZ": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["SDAZR"]) -> RuleVariation_331:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COAZRAZ"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SDAZR"], Literal["COAZRAZ"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SDAZR"]) -> RuleVariation_331:
        ...
    @overload
    def get_item(self, key : Literal["COAZRAZ"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1196_Arg) -> 'Variation_1196':
        return cls._create(arg) # type: ignore

RuleVariation_1141_Arg: TypeAlias = Variation_1196_Arg
class RuleVariation_1141(RuleVariationContextFree):
    cv_variation = Variation_1196

    @classmethod
    def create(cls, arg : RuleVariation_1141_Arg) -> "RuleVariation_1141":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1196:
        return self.arg # type: ignore

NonSpare_1666_Arg: TypeAlias = RuleVariation_1141_Arg
class NonSpare_1666(NonSpare):
    cv_name = "SDAZR"
    cv_title = "Standard Deviation of Azimuth Rate"
    cv_rule = RuleVariation_1141

    @classmethod
    def create(cls, arg : NonSpare_1666_Arg) -> "NonSpare_1666":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1141:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1196:
        return self.rule.variation

NonSpare_1636_Arg: TypeAlias = RuleVariation_337_Arg
class NonSpare_1636(NonSpare):
    cv_name = "S"
    cv_title = ""
    cv_rule = RuleVariation_337

    @classmethod
    def create(cls, arg : NonSpare_1636_Arg) -> "NonSpare_1636":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_337:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_344:
        return self.rule.variation

Item_845_Arg: TypeAlias = NonSpare_1636_Arg
class Item_845(Item):
    cv_non_spare = NonSpare_1636

    @classmethod
    def create(cls, arg : Item_845_Arg) -> "Item_845":
        return cls._create(arg) # type: ignore

NonSpare_909_Arg: TypeAlias = RuleVariation_337_Arg
class NonSpare_909(NonSpare):
    cv_name = "E"
    cv_title = ""
    cv_rule = RuleVariation_337

    @classmethod
    def create(cls, arg : NonSpare_909_Arg) -> "NonSpare_909":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_337:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_344:
        return self.rule.variation

Item_284_Arg: TypeAlias = NonSpare_909_Arg
class Item_284(Item):
    cv_non_spare = NonSpare_909

    @classmethod
    def create(cls, arg : Item_284_Arg) -> "Item_284":
        return cls._create(arg) # type: ignore

Variation_1184_Arg_Group = Tuple[Union[RuleVariation_337_Arg, Tuple[Literal["S"], RuleVariation_337_Arg]], Union[RuleVariation_337_Arg, Tuple[Literal["E"], RuleVariation_337_Arg]]]
Variation_1184_Arg: TypeAlias = Union[int, Variation_1184_Arg_Group]
class Variation_1184(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_845, 16), (Item_284, 16)]
    cv_items_dict = {"S": RuleVariation_337, "E": RuleVariation_337}

    @overload
    @classmethod
    def spec(cls, key : Literal["S"]) -> RuleVariation_337:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["E"]) -> RuleVariation_337:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["S"], Literal["E"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["S"]) -> RuleVariation_337:
        ...
    @overload
    def get_item(self, key : Literal["E"]) -> RuleVariation_337:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1184_Arg) -> 'Variation_1184':
        return cls._create(arg) # type: ignore

RuleVariation_1134_Arg: TypeAlias = Variation_1184_Arg
class RuleVariation_1134(RuleVariationContextFree):
    cv_variation = Variation_1184

    @classmethod
    def create(cls, arg : RuleVariation_1134_Arg) -> "RuleVariation_1134":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1184:
        return self.arg # type: ignore

NonSpare_660_Arg: TypeAlias = RuleVariation_1134_Arg
class NonSpare_660(NonSpare):
    cv_name = "AZEX"
    cv_title = "Azimuth Extent"
    cv_rule = RuleVariation_1134

    @classmethod
    def create(cls, arg : NonSpare_660_Arg) -> "NonSpare_660":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1134:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1184:
        return self.rule.variation

Variation_1468_Arg = TypedDict('Variation_1468_Arg', {
    "AZ": NonSpare_658_Arg,
    "RSAZ": NonSpare_1606_Arg,
    "SDASZ": NonSpare_1664_Arg,
    "AZR": NonSpare_662_Arg,
    "SDAZR": NonSpare_1666_Arg,
    "AZEX": NonSpare_660_Arg,
}, total=False)
class Variation_1468(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_658, NonSpare_1606, NonSpare_1664, NonSpare_662, NonSpare_1666, NonSpare_660]
    cv_items_dict = {"AZ": NonSpare_658, "RSAZ": NonSpare_1606, "SDASZ": NonSpare_1664, "AZR": NonSpare_662, "SDAZR": NonSpare_1666, "AZEX": NonSpare_660}

    @overload
    @classmethod
    def spec(cls, key : Literal["AZ"]) -> NonSpare_658:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSAZ"]) -> NonSpare_1606:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDASZ"]) -> NonSpare_1664:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AZR"]) -> NonSpare_662:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDAZR"]) -> NonSpare_1666:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AZEX"]) -> NonSpare_660:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AZ"], Literal["RSAZ"], Literal["SDASZ"], Literal["AZR"], Literal["SDAZR"], Literal["AZEX"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AZ"]) -> Optional[NonSpare_658]:
        ...
    @overload
    def get_item(self, key : Literal["RSAZ"]) -> Optional[NonSpare_1606]:
        ...
    @overload
    def get_item(self, key : Literal["SDASZ"]) -> Optional[NonSpare_1664]:
        ...
    @overload
    def get_item(self, key : Literal["AZR"]) -> Optional[NonSpare_662]:
        ...
    @overload
    def get_item(self, key : Literal["SDAZR"]) -> Optional[NonSpare_1666]:
        ...
    @overload
    def get_item(self, key : Literal["AZEX"]) -> Optional[NonSpare_660]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["AZ"], val : NonSpare_658_Arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["RSAZ"], val : NonSpare_1606_Arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["SDASZ"], val : NonSpare_1664_Arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["AZR"], val : NonSpare_662_Arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["SDAZR"], val : NonSpare_1666_Arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["AZEX"], val : NonSpare_660_Arg) -> "Variation_1468":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["AZ"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["RSAZ"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["SDASZ"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["AZR"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["SDAZR"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["AZEX"]) -> "Variation_1468":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1468_Arg) -> 'Variation_1468':
        return cls._create(arg) # type: ignore

RuleVariation_1391_Arg: TypeAlias = Variation_1468_Arg
class RuleVariation_1391(RuleVariationContextFree):
    cv_variation = Variation_1468

    @classmethod
    def create(cls, arg : RuleVariation_1391_Arg) -> "RuleVariation_1391":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1468:
        return self.arg # type: ignore

NonSpare_539_Arg: TypeAlias = RuleVariation_1391_Arg
class NonSpare_539(NonSpare):
    cv_name = "627"
    cv_title = "Azimuth Information"
    cv_rule = RuleVariation_1391

    @classmethod
    def create(cls, arg : NonSpare_539_Arg) -> "NonSpare_539":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1391:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1468:
        return self.rule.variation

class UapItem_538(UapItem):
    cv_non_spare = NonSpare_539

NonSpare_913_Arg: TypeAlias = RuleVariation_286_Arg
class NonSpare_913(NonSpare):
    cv_name = "EL"
    cv_title = "Elevation"
    cv_rule = RuleVariation_286

    @classmethod
    def create(cls, arg : NonSpare_913_Arg) -> "NonSpare_913":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_286:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_293:
        return self.rule.variation

NonSpare_1607_Arg: TypeAlias = RuleVariation_331_Arg
class NonSpare_1607(NonSpare):
    cv_name = "RSEL"
    cv_title = "Elevation Resolution"
    cv_rule = RuleVariation_331

    @classmethod
    def create(cls, arg : NonSpare_1607_Arg) -> "NonSpare_1607":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_331:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_338:
        return self.rule.variation

NonSpare_1670_Arg: TypeAlias = RuleVariation_331_Arg
class NonSpare_1670(NonSpare):
    cv_name = "SDEL"
    cv_title = "Standard Deviation of Elevation"
    cv_rule = RuleVariation_331

    @classmethod
    def create(cls, arg : NonSpare_1670_Arg) -> "NonSpare_1670":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_331:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_338:
        return self.rule.variation

Content_689_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°/s"]]]
class Content_689(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 2.74658203125e-3
    cv_unit = "°/s"

    def as_quantity(self, cv_unit : Optional[Literal["°/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_689_Arg: TypeAlias = Content_689_Arg
class RuleContent_689(RuleContentContextFree):
    cv_content = Content_689

    @property
    def content(self) -> Content_689:
        return self._get_content() # type: ignore

Variation_295_Arg: TypeAlias = RuleContent_689_Arg
class Variation_295(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_689

    @classmethod
    def create(cls, arg : Variation_295_Arg) -> "Variation_295":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_689:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_689:
        return self.rule.content

RuleVariation_288_Arg: TypeAlias = Variation_295_Arg
class RuleVariation_288(RuleVariationContextFree):
    cv_variation = Variation_295

    @classmethod
    def create(cls, arg : RuleVariation_288_Arg) -> "RuleVariation_288":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_295:
        return self.arg # type: ignore

NonSpare_949_Arg: TypeAlias = RuleVariation_288_Arg
class NonSpare_949(NonSpare):
    cv_name = "ER"
    cv_title = "Elevation Rate"
    cv_rule = RuleVariation_288

    @classmethod
    def create(cls, arg : NonSpare_949_Arg) -> "NonSpare_949":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_288:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_295:
        return self.rule.variation

Content_784_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°/s"]]]
class Content_784(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 6.866455078125e-4
    cv_unit = "°/s"

    def as_quantity(self, cv_unit : Optional[Literal["°/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_783_Arg: TypeAlias = Content_784_Arg
class RuleContent_783(RuleContentContextFree):
    cv_content = Content_784

    @property
    def content(self) -> Content_784:
        return self._get_content() # type: ignore

Variation_339_Arg: TypeAlias = RuleContent_783_Arg
class Variation_339(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_783

    @classmethod
    def create(cls, arg : Variation_339_Arg) -> "Variation_339":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_783:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_784:
        return self.rule.content

RuleVariation_332_Arg: TypeAlias = Variation_339_Arg
class RuleVariation_332(RuleVariationContextFree):
    cv_variation = Variation_339

    @classmethod
    def create(cls, arg : RuleVariation_332_Arg) -> "RuleVariation_332":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_339:
        return self.arg # type: ignore

NonSpare_1671_Arg: TypeAlias = RuleVariation_332_Arg
class NonSpare_1671(NonSpare):
    cv_name = "SDELR"
    cv_title = ""
    cv_rule = RuleVariation_332

    @classmethod
    def create(cls, arg : NonSpare_1671_Arg) -> "NonSpare_1671":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_332:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_339:
        return self.rule.variation

Item_866_Arg: TypeAlias = NonSpare_1671_Arg
class Item_866(Item):
    cv_non_spare = NonSpare_1671

    @classmethod
    def create(cls, arg : Item_866_Arg) -> "Item_866":
        return cls._create(arg) # type: ignore

NonSpare_754_Arg: TypeAlias = RuleVariation_205_Arg
class NonSpare_754(NonSpare):
    cv_name = "COELREL"
    cv_title = ""
    cv_rule = RuleVariation_205

    @classmethod
    def create(cls, arg : NonSpare_754_Arg) -> "NonSpare_754":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

Item_172_Arg: TypeAlias = NonSpare_754_Arg
class Item_172(Item):
    cv_non_spare = NonSpare_754

    @classmethod
    def create(cls, arg : Item_172_Arg) -> "Item_172":
        return cls._create(arg) # type: ignore

Variation_1198_Arg_Group = Tuple[Union[RuleVariation_332_Arg, Tuple[Literal["SDELR"], RuleVariation_332_Arg]], Union[RuleVariation_205_Arg, Tuple[Literal["COELREL"], RuleVariation_205_Arg]]]
Variation_1198_Arg: TypeAlias = Union[int, Variation_1198_Arg_Group]
class Variation_1198(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_866, 16), (Item_172, 8)]
    cv_items_dict = {"SDELR": RuleVariation_332, "COELREL": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["SDELR"]) -> RuleVariation_332:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COELREL"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SDELR"], Literal["COELREL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SDELR"]) -> RuleVariation_332:
        ...
    @overload
    def get_item(self, key : Literal["COELREL"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1198_Arg) -> 'Variation_1198':
        return cls._create(arg) # type: ignore

RuleVariation_1143_Arg: TypeAlias = Variation_1198_Arg
class RuleVariation_1143(RuleVariationContextFree):
    cv_variation = Variation_1198

    @classmethod
    def create(cls, arg : RuleVariation_1143_Arg) -> "RuleVariation_1143":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1198:
        return self.arg # type: ignore

NonSpare_1672_Arg: TypeAlias = RuleVariation_1143_Arg
class NonSpare_1672(NonSpare):
    cv_name = "SDER"
    cv_title = "Standard Deviation of Elevation Rate"
    cv_rule = RuleVariation_1143

    @classmethod
    def create(cls, arg : NonSpare_1672_Arg) -> "NonSpare_1672":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1143:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1198:
        return self.rule.variation

NonSpare_1635_Arg: TypeAlias = RuleVariation_286_Arg
class NonSpare_1635(NonSpare):
    cv_name = "S"
    cv_title = ""
    cv_rule = RuleVariation_286

    @classmethod
    def create(cls, arg : NonSpare_1635_Arg) -> "NonSpare_1635":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_286:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_293:
        return self.rule.variation

Item_844_Arg: TypeAlias = NonSpare_1635_Arg
class Item_844(Item):
    cv_non_spare = NonSpare_1635

    @classmethod
    def create(cls, arg : Item_844_Arg) -> "Item_844":
        return cls._create(arg) # type: ignore

NonSpare_908_Arg: TypeAlias = RuleVariation_286_Arg
class NonSpare_908(NonSpare):
    cv_name = "E"
    cv_title = ""
    cv_rule = RuleVariation_286

    @classmethod
    def create(cls, arg : NonSpare_908_Arg) -> "NonSpare_908":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_286:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_293:
        return self.rule.variation

Item_283_Arg: TypeAlias = NonSpare_908_Arg
class Item_283(Item):
    cv_non_spare = NonSpare_908

    @classmethod
    def create(cls, arg : Item_283_Arg) -> "Item_283":
        return cls._create(arg) # type: ignore

Variation_1183_Arg_Group = Tuple[Union[RuleVariation_286_Arg, Tuple[Literal["S"], RuleVariation_286_Arg]], Union[RuleVariation_286_Arg, Tuple[Literal["E"], RuleVariation_286_Arg]]]
Variation_1183_Arg: TypeAlias = Union[int, Variation_1183_Arg_Group]
class Variation_1183(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_844, 16), (Item_283, 16)]
    cv_items_dict = {"S": RuleVariation_286, "E": RuleVariation_286}

    @overload
    @classmethod
    def spec(cls, key : Literal["S"]) -> RuleVariation_286:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["E"]) -> RuleVariation_286:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["S"], Literal["E"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["S"]) -> RuleVariation_286:
        ...
    @overload
    def get_item(self, key : Literal["E"]) -> RuleVariation_286:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1183_Arg) -> 'Variation_1183':
        return cls._create(arg) # type: ignore

RuleVariation_1133_Arg: TypeAlias = Variation_1183_Arg
class RuleVariation_1133(RuleVariationContextFree):
    cv_variation = Variation_1183

    @classmethod
    def create(cls, arg : RuleVariation_1133_Arg) -> "RuleVariation_1133":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1183:
        return self.arg # type: ignore

NonSpare_915_Arg: TypeAlias = RuleVariation_1133_Arg
class NonSpare_915(NonSpare):
    cv_name = "ELEX"
    cv_title = "Elevation Extent"
    cv_rule = RuleVariation_1133

    @classmethod
    def create(cls, arg : NonSpare_915_Arg) -> "NonSpare_915":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1133:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1183:
        return self.rule.variation

Variation_1476_Arg = TypedDict('Variation_1476_Arg', {
    "EL": NonSpare_913_Arg,
    "RSEL": NonSpare_1607_Arg,
    "SDEL": NonSpare_1670_Arg,
    "ER": NonSpare_949_Arg,
    "SDER": NonSpare_1672_Arg,
    "ELEX": NonSpare_915_Arg,
}, total=False)
class Variation_1476(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_913, NonSpare_1607, NonSpare_1670, NonSpare_949, NonSpare_1672, NonSpare_915]
    cv_items_dict = {"EL": NonSpare_913, "RSEL": NonSpare_1607, "SDEL": NonSpare_1670, "ER": NonSpare_949, "SDER": NonSpare_1672, "ELEX": NonSpare_915}

    @overload
    @classmethod
    def spec(cls, key : Literal["EL"]) -> NonSpare_913:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSEL"]) -> NonSpare_1607:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDEL"]) -> NonSpare_1670:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ER"]) -> NonSpare_949:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDER"]) -> NonSpare_1672:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ELEX"]) -> NonSpare_915:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EL"], Literal["RSEL"], Literal["SDEL"], Literal["ER"], Literal["SDER"], Literal["ELEX"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EL"]) -> Optional[NonSpare_913]:
        ...
    @overload
    def get_item(self, key : Literal["RSEL"]) -> Optional[NonSpare_1607]:
        ...
    @overload
    def get_item(self, key : Literal["SDEL"]) -> Optional[NonSpare_1670]:
        ...
    @overload
    def get_item(self, key : Literal["ER"]) -> Optional[NonSpare_949]:
        ...
    @overload
    def get_item(self, key : Literal["SDER"]) -> Optional[NonSpare_1672]:
        ...
    @overload
    def get_item(self, key : Literal["ELEX"]) -> Optional[NonSpare_915]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["EL"], val : NonSpare_913_Arg) -> "Variation_1476":
        ...
    @overload
    def set_item(self, key : Literal["RSEL"], val : NonSpare_1607_Arg) -> "Variation_1476":
        ...
    @overload
    def set_item(self, key : Literal["SDEL"], val : NonSpare_1670_Arg) -> "Variation_1476":
        ...
    @overload
    def set_item(self, key : Literal["ER"], val : NonSpare_949_Arg) -> "Variation_1476":
        ...
    @overload
    def set_item(self, key : Literal["SDER"], val : NonSpare_1672_Arg) -> "Variation_1476":
        ...
    @overload
    def set_item(self, key : Literal["ELEX"], val : NonSpare_915_Arg) -> "Variation_1476":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["EL"]) -> "Variation_1476":
        ...
    @overload
    def del_item(self, key : Literal["RSEL"]) -> "Variation_1476":
        ...
    @overload
    def del_item(self, key : Literal["SDEL"]) -> "Variation_1476":
        ...
    @overload
    def del_item(self, key : Literal["ER"]) -> "Variation_1476":
        ...
    @overload
    def del_item(self, key : Literal["SDER"]) -> "Variation_1476":
        ...
    @overload
    def del_item(self, key : Literal["ELEX"]) -> "Variation_1476":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1476_Arg) -> 'Variation_1476':
        return cls._create(arg) # type: ignore

RuleVariation_1399_Arg: TypeAlias = Variation_1476_Arg
class RuleVariation_1399(RuleVariationContextFree):
    cv_variation = Variation_1476

    @classmethod
    def create(cls, arg : RuleVariation_1399_Arg) -> "RuleVariation_1399":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1476:
        return self.arg # type: ignore

NonSpare_540_Arg: TypeAlias = RuleVariation_1399_Arg
class NonSpare_540(NonSpare):
    cv_name = "628"
    cv_title = "Elevation Information"
    cv_rule = RuleVariation_1399

    @classmethod
    def create(cls, arg : NonSpare_540_Arg) -> "NonSpare_540":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1399:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1476:
        return self.rule.variation

class UapItem_539(UapItem):
    cv_non_spare = NonSpare_540

Content_621_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["dB"]]]
class Content_621(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.0
    cv_unit = "dB"

    def as_quantity(self, cv_unit : Optional[Literal["dB"]] = None) -> float:
        return self._as_quantity()

RuleContent_621_Arg: TypeAlias = Content_621_Arg
class RuleContent_621(RuleContentContextFree):
    cv_content = Content_621

    @property
    def content(self) -> Content_621:
        return self._get_content() # type: ignore

Variation_205_Arg: TypeAlias = RuleContent_621_Arg
class Variation_205(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_621

    @classmethod
    def create(cls, arg : Variation_205_Arg) -> "Variation_205":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_621:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_621:
        return self.rule.content

RuleVariation_198_Arg: TypeAlias = Variation_205_Arg
class RuleVariation_198(RuleVariationContextFree):
    cv_variation = Variation_205

    @classmethod
    def create(cls, arg : RuleVariation_198_Arg) -> "RuleVariation_198":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_205:
        return self.arg # type: ignore

NonSpare_888_Arg: TypeAlias = RuleVariation_198_Arg
class NonSpare_888(NonSpare):
    cv_name = "DPP"
    cv_title = "Direct Path - Power"
    cv_rule = RuleVariation_198

    @classmethod
    def create(cls, arg : NonSpare_888_Arg) -> "NonSpare_888":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_198:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_205:
        return self.rule.variation

NonSpare_889_Arg: TypeAlias = RuleVariation_198_Arg
class NonSpare_889(NonSpare):
    cv_name = "DPS"
    cv_title = "Direct Path - Signal to Noise Ratio (SNR)"
    cv_rule = RuleVariation_198

    @classmethod
    def create(cls, arg : NonSpare_889_Arg) -> "NonSpare_889":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_198:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_205:
        return self.rule.variation

Item_6_Arg: TypeAlias = int
class Item_6(Spare):
    cv_bit_offset8 = 0
    cv_bit_size = 7

Content_620_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["dB"]]]
class Content_620(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.0
    cv_unit = "dB"

    def as_quantity(self, cv_unit : Optional[Literal["dB"]] = None) -> float:
        return self._as_quantity()

RuleContent_620_Arg: TypeAlias = Content_620_Arg
class RuleContent_620(RuleContentContextFree):
    cv_content = Content_620

    @property
    def content(self) -> Content_620:
        return self._get_content() # type: ignore

Variation_991_Arg: TypeAlias = RuleContent_620_Arg
class Variation_991(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 9
    cv_rule = RuleContent_620

    @classmethod
    def create(cls, arg : Variation_991_Arg) -> "Variation_991":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_620:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_620:
        return self.rule.content

RuleVariation_961_Arg: TypeAlias = Variation_991_Arg
class RuleVariation_961(RuleVariationContextFree):
    cv_variation = Variation_991

    @classmethod
    def create(cls, arg : RuleVariation_961_Arg) -> "RuleVariation_961":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_991:
        return self.arg # type: ignore

NonSpare_1597_Arg: TypeAlias = RuleVariation_961_Arg
class NonSpare_1597(NonSpare):
    cv_name = "RPP"
    cv_title = ""
    cv_rule = RuleVariation_961

    @classmethod
    def create(cls, arg : NonSpare_1597_Arg) -> "NonSpare_1597":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_961:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_991:
        return self.rule.variation

Item_824_Arg: TypeAlias = NonSpare_1597_Arg
class Item_824(Item):
    cv_non_spare = NonSpare_1597

    @classmethod
    def create(cls, arg : Item_824_Arg) -> "Item_824":
        return cls._create(arg) # type: ignore

Variation_1039_Arg_Group = Tuple[int, Union[RuleVariation_961_Arg, Tuple[Literal["RPP"], RuleVariation_961_Arg]]]
Variation_1039_Arg: TypeAlias = Union[int, Variation_1039_Arg_Group]
class Variation_1039(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_6, 7), (Item_824, 9)]
    cv_items_dict = {"RPP": RuleVariation_961}

    @classmethod
    def spec(cls, key : Literal["RPP"]) -> RuleVariation_961:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["RPP"]) -> RuleVariation_961:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1039_Arg) -> 'Variation_1039':
        return cls._create(arg) # type: ignore

RuleVariation_1007_Arg: TypeAlias = Variation_1039_Arg
class RuleVariation_1007(RuleVariationContextFree):
    cv_variation = Variation_1039

    @classmethod
    def create(cls, arg : RuleVariation_1007_Arg) -> "RuleVariation_1007":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1039:
        return self.arg # type: ignore

NonSpare_1598_Arg: TypeAlias = RuleVariation_1007_Arg
class NonSpare_1598(NonSpare):
    cv_name = "RPP"
    cv_title = "Reflected Path - Power"
    cv_rule = RuleVariation_1007

    @classmethod
    def create(cls, arg : NonSpare_1598_Arg) -> "NonSpare_1598":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1007:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1039:
        return self.rule.variation

NonSpare_1599_Arg: TypeAlias = RuleVariation_198_Arg
class NonSpare_1599(NonSpare):
    cv_name = "RPS"
    cv_title = "Reflected Path - Signal to Noise Ratio (SNR)"
    cv_rule = RuleVariation_198

    @classmethod
    def create(cls, arg : NonSpare_1599_Arg) -> "NonSpare_1599":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_198:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_205:
        return self.rule.variation

Variation_1474_Arg = TypedDict('Variation_1474_Arg', {
    "DPP": NonSpare_888_Arg,
    "DPS": NonSpare_889_Arg,
    "RPP": NonSpare_1598_Arg,
    "RPS": NonSpare_1599_Arg,
}, total=False)
class Variation_1474(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_888, NonSpare_889, NonSpare_1598, NonSpare_1599]
    cv_items_dict = {"DPP": NonSpare_888, "DPS": NonSpare_889, "RPP": NonSpare_1598, "RPS": NonSpare_1599}

    @overload
    @classmethod
    def spec(cls, key : Literal["DPP"]) -> NonSpare_888:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DPS"]) -> NonSpare_889:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RPP"]) -> NonSpare_1598:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RPS"]) -> NonSpare_1599:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["DPP"], Literal["DPS"], Literal["RPP"], Literal["RPS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["DPP"]) -> Optional[NonSpare_888]:
        ...
    @overload
    def get_item(self, key : Literal["DPS"]) -> Optional[NonSpare_889]:
        ...
    @overload
    def get_item(self, key : Literal["RPP"]) -> Optional[NonSpare_1598]:
        ...
    @overload
    def get_item(self, key : Literal["RPS"]) -> Optional[NonSpare_1599]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["DPP"], val : NonSpare_888_Arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["DPS"], val : NonSpare_889_Arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["RPP"], val : NonSpare_1598_Arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["RPS"], val : NonSpare_1599_Arg) -> "Variation_1474":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["DPP"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["DPS"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["RPP"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["RPS"]) -> "Variation_1474":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1474_Arg) -> 'Variation_1474':
        return cls._create(arg) # type: ignore

RuleVariation_1397_Arg: TypeAlias = Variation_1474_Arg
class RuleVariation_1397(RuleVariationContextFree):
    cv_variation = Variation_1474

    @classmethod
    def create(cls, arg : RuleVariation_1397_Arg) -> "RuleVariation_1397":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1474:
        return self.arg # type: ignore

NonSpare_541_Arg: TypeAlias = RuleVariation_1397_Arg
class NonSpare_541(NonSpare):
    cv_name = "630"
    cv_title = "Path Quality"
    cv_rule = RuleVariation_1397

    @classmethod
    def create(cls, arg : NonSpare_541_Arg) -> "NonSpare_541":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1397:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1474:
        return self.rule.variation

class UapItem_540(UapItem):
    cv_non_spare = NonSpare_541

NonSpare_659_Arg: TypeAlias = RuleVariation_336_Arg
class NonSpare_659(NonSpare):
    cv_name = "AZCON"
    cv_title = ""
    cv_rule = RuleVariation_336

    @classmethod
    def create(cls, arg : NonSpare_659_Arg) -> "NonSpare_659":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

Item_106_Arg: TypeAlias = NonSpare_659_Arg
class Item_106(Item):
    cv_non_spare = NonSpare_659

    @classmethod
    def create(cls, arg : Item_106_Arg) -> "Item_106":
        return cls._create(arg) # type: ignore

Content_688_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_688(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 2.74658203125e-3
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_688_Arg: TypeAlias = Content_688_Arg
class RuleContent_688(RuleContentContextFree):
    cv_content = Content_688

    @property
    def content(self) -> Content_688:
        return self._get_content() # type: ignore

Variation_294_Arg: TypeAlias = RuleContent_688_Arg
class Variation_294(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_688

    @classmethod
    def create(cls, arg : Variation_294_Arg) -> "Variation_294":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_688:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_688:
        return self.rule.content

RuleVariation_287_Arg: TypeAlias = Variation_294_Arg
class RuleVariation_287(RuleVariationContextFree):
    cv_variation = Variation_294

    @classmethod
    def create(cls, arg : RuleVariation_287_Arg) -> "RuleVariation_287":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_294:
        return self.arg # type: ignore

NonSpare_914_Arg: TypeAlias = RuleVariation_287_Arg
class NonSpare_914(NonSpare):
    cv_name = "ELCON"
    cv_title = ""
    cv_rule = RuleVariation_287

    @classmethod
    def create(cls, arg : NonSpare_914_Arg) -> "NonSpare_914":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_287:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_294:
        return self.rule.variation

Item_287_Arg: TypeAlias = NonSpare_914_Arg
class Item_287(Item):
    cv_non_spare = NonSpare_914

    @classmethod
    def create(cls, arg : Item_287_Arg) -> "Item_287":
        return cls._create(arg) # type: ignore

Content_794_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_794(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.152587890625
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_793_Arg: TypeAlias = Content_794_Arg
class RuleContent_793(RuleContentContextFree):
    cv_content = Content_794

    @property
    def content(self) -> Content_794:
        return self._get_content() # type: ignore

Variation_345_Arg: TypeAlias = RuleContent_793_Arg
class Variation_345(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_793

    @classmethod
    def create(cls, arg : Variation_345_Arg) -> "Variation_345":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_793:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_794:
        return self.rule.content

RuleVariation_338_Arg: TypeAlias = Variation_345_Arg
class RuleVariation_338(RuleVariationContextFree):
    cv_variation = Variation_345

    @classmethod
    def create(cls, arg : RuleVariation_338_Arg) -> "RuleVariation_338":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_345:
        return self.arg # type: ignore

NonSpare_1578_Arg: TypeAlias = RuleVariation_338_Arg
class NonSpare_1578(NonSpare):
    cv_name = "RGCONSTOP"
    cv_title = ""
    cv_rule = RuleVariation_338

    @classmethod
    def create(cls, arg : NonSpare_1578_Arg) -> "NonSpare_1578":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_338:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_345:
        return self.rule.variation

Item_809_Arg: TypeAlias = NonSpare_1578_Arg
class Item_809(Item):
    cv_non_spare = NonSpare_1578

    @classmethod
    def create(cls, arg : Item_809_Arg) -> "Item_809":
        return cls._create(arg) # type: ignore

NonSpare_1577_Arg: TypeAlias = RuleVariation_338_Arg
class NonSpare_1577(NonSpare):
    cv_name = "RGCONSTART"
    cv_title = ""
    cv_rule = RuleVariation_338

    @classmethod
    def create(cls, arg : NonSpare_1577_Arg) -> "NonSpare_1577":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_338:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_345:
        return self.rule.variation

Item_808_Arg: TypeAlias = NonSpare_1577_Arg
class Item_808(Item):
    cv_non_spare = NonSpare_1577

    @classmethod
    def create(cls, arg : Item_808_Arg) -> "Item_808":
        return cls._create(arg) # type: ignore

Variation_1055_Arg_Group = Tuple[Union[RuleVariation_336_Arg, Tuple[Literal["AZCON"], RuleVariation_336_Arg]], Union[RuleVariation_287_Arg, Tuple[Literal["ELCON"], RuleVariation_287_Arg]], Union[RuleVariation_338_Arg, Tuple[Literal["RGCONSTOP"], RuleVariation_338_Arg]], Union[RuleVariation_338_Arg, Tuple[Literal["RGCONSTART"], RuleVariation_338_Arg]]]
Variation_1055_Arg: TypeAlias = Union[int, Variation_1055_Arg_Group]
class Variation_1055(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_106, 16), (Item_287, 16), (Item_809, 16), (Item_808, 16)]
    cv_items_dict = {"AZCON": RuleVariation_336, "ELCON": RuleVariation_287, "RGCONSTOP": RuleVariation_338, "RGCONSTART": RuleVariation_338}

    @overload
    @classmethod
    def spec(cls, key : Literal["AZCON"]) -> RuleVariation_336:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ELCON"]) -> RuleVariation_287:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RGCONSTOP"]) -> RuleVariation_338:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RGCONSTART"]) -> RuleVariation_338:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AZCON"], Literal["ELCON"], Literal["RGCONSTOP"], Literal["RGCONSTART"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AZCON"]) -> RuleVariation_336:
        ...
    @overload
    def get_item(self, key : Literal["ELCON"]) -> RuleVariation_287:
        ...
    @overload
    def get_item(self, key : Literal["RGCONSTOP"]) -> RuleVariation_338:
        ...
    @overload
    def get_item(self, key : Literal["RGCONSTART"]) -> RuleVariation_338:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1055_Arg) -> 'Variation_1055':
        return cls._create(arg) # type: ignore

Variation_1402_Arg: TypeAlias = List[Variation_1055_Arg]
class Variation_1402(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1055

    @classmethod
    def create(cls, arg : Variation_1402_Arg) -> 'Variation_1402':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1055]:
        return self._get_list() # type: ignore

RuleVariation_1325_Arg: TypeAlias = Variation_1402_Arg
class RuleVariation_1325(RuleVariationContextFree):
    cv_variation = Variation_1402

    @classmethod
    def create(cls, arg : RuleVariation_1325_Arg) -> "RuleVariation_1325":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1402:
        return self.arg # type: ignore

NonSpare_542_Arg: TypeAlias = RuleVariation_1325_Arg
class NonSpare_542(NonSpare):
    cv_name = "631"
    cv_title = "Contour (Azimuth, Elevation Angle, Range Extent)"
    cv_rule = RuleVariation_1325

    @classmethod
    def create(cls, arg : NonSpare_542_Arg) -> "NonSpare_542":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1325:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1402:
        return self.rule.variation

class UapItem_541(UapItem):
    cv_non_spare = NonSpare_542

Record_33_Arg = TypedDict('Record_33_Arg', {
    "010": NonSpare_39_Arg,
    "000": NonSpare_16_Arg,
    "015": NonSpare_59_Arg,
    "020": NonSpare_84_Arg,
    "030": NonSpare_114_Arg,
    "145": NonSpare_334_Arg,
    "161": NonSpare_362_Arg,
    "170": NonSpare_376_Arg,
    "050": NonSpare_179_Arg,
    "270": NonSpare_455_Arg,
    "300": NonSpare_469_Arg,
    "400": NonSpare_493_Arg,
    "600": NonSpare_524_Arg,
    "601": NonSpare_527_Arg,
    "602": NonSpare_528_Arg,
    "603": NonSpare_529_Arg,
    "604": NonSpare_530_Arg,
    "605": NonSpare_532_Arg,
    "480": NonSpare_507_Arg,
    "625": NonSpare_537_Arg,
    "626": NonSpare_538_Arg,
    "627": NonSpare_539_Arg,
    "628": NonSpare_540_Arg,
    "630": NonSpare_541_Arg,
    "631": NonSpare_542_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_33(Record):
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_39, UapItem_16, UapItem_59, UapItem_84, UapItem_114, UapItem_334, UapItem_362, UapItem_376, UapItem_179, UapItem_455, UapItem_469, UapItem_492, UapItem_523, UapItem_526, UapItem_527, UapItem_528, UapItem_529, UapItem_531, UapItem_506, UapItem_536, UapItem_537, UapItem_538, UapItem_539, UapItem_540, UapItem_541, UapItem_543]
    cv_items_dict = {"010": NonSpare_39, "000": NonSpare_16, "015": NonSpare_59, "020": NonSpare_84, "030": NonSpare_114, "145": NonSpare_334, "161": NonSpare_362, "170": NonSpare_376, "050": NonSpare_179, "270": NonSpare_455, "300": NonSpare_469, "400": NonSpare_493, "600": NonSpare_524, "601": NonSpare_527, "602": NonSpare_528, "603": NonSpare_529, "604": NonSpare_530, "605": NonSpare_532, "480": NonSpare_507, "625": NonSpare_537, "626": NonSpare_538, "627": NonSpare_539, "628": NonSpare_540, "630": NonSpare_541, "631": NonSpare_542, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_39:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_16:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_59:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_84:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_114:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_334:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_362:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_376:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_179:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["270"]) -> NonSpare_455:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_469:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_493:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["600"]) -> NonSpare_524:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["601"]) -> NonSpare_527:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["602"]) -> NonSpare_528:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["603"]) -> NonSpare_529:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["604"]) -> NonSpare_530:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["605"]) -> NonSpare_532:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["480"]) -> NonSpare_507:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["625"]) -> NonSpare_537:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["626"]) -> NonSpare_538:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["627"]) -> NonSpare_539:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["628"]) -> NonSpare_540:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["630"]) -> NonSpare_541:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["631"]) -> NonSpare_542:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["015"], Literal["020"], Literal["030"], Literal["145"], Literal["161"], Literal["170"], Literal["050"], Literal["270"], Literal["300"], Literal["400"], Literal["600"], Literal["601"], Literal["602"], Literal["603"], Literal["604"], Literal["605"], Literal["480"], Literal["625"], Literal["626"], Literal["627"], Literal["628"], Literal["630"], Literal["631"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_39]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_16]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_59]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_84]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_114]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_334]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_362]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_376]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_179]:
        ...
    @overload
    def get_item(self, key : Literal["270"]) -> Optional[NonSpare_455]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_469]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_493]:
        ...
    @overload
    def get_item(self, key : Literal["600"]) -> Optional[NonSpare_524]:
        ...
    @overload
    def get_item(self, key : Literal["601"]) -> Optional[NonSpare_527]:
        ...
    @overload
    def get_item(self, key : Literal["602"]) -> Optional[NonSpare_528]:
        ...
    @overload
    def get_item(self, key : Literal["603"]) -> Optional[NonSpare_529]:
        ...
    @overload
    def get_item(self, key : Literal["604"]) -> Optional[NonSpare_530]:
        ...
    @overload
    def get_item(self, key : Literal["605"]) -> Optional[NonSpare_532]:
        ...
    @overload
    def get_item(self, key : Literal["480"]) -> Optional[NonSpare_507]:
        ...
    @overload
    def get_item(self, key : Literal["625"]) -> Optional[NonSpare_537]:
        ...
    @overload
    def get_item(self, key : Literal["626"]) -> Optional[NonSpare_538]:
        ...
    @overload
    def get_item(self, key : Literal["627"]) -> Optional[NonSpare_539]:
        ...
    @overload
    def get_item(self, key : Literal["628"]) -> Optional[NonSpare_540]:
        ...
    @overload
    def get_item(self, key : Literal["630"]) -> Optional[NonSpare_541]:
        ...
    @overload
    def get_item(self, key : Literal["631"]) -> Optional[NonSpare_542]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_39_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_16_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_59_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_84_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_114_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_334_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_362_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_376_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_179_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["270"], val : NonSpare_455_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_469_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_493_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["600"], val : NonSpare_524_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["601"], val : NonSpare_527_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["602"], val : NonSpare_528_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["603"], val : NonSpare_529_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["604"], val : NonSpare_530_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["605"], val : NonSpare_532_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["480"], val : NonSpare_507_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["625"], val : NonSpare_537_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["626"], val : NonSpare_538_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["627"], val : NonSpare_539_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["628"], val : NonSpare_540_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["630"], val : NonSpare_541_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["631"], val : NonSpare_542_Arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_33':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["270"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["600"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["601"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["602"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["603"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["604"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["605"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["480"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["625"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["626"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["627"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["628"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["630"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["631"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_33':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_33_Arg) -> 'Record_33':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_33", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_29_Arg: TypeAlias = Record_33
class Uap_29(UapSingle):
    cv_record = Record_33

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_33]]:
        return cls._parse(bs)

class Asterix_12(AstCat):
    cv_category = 15
    cv_edition = (1, 0)
    cv_uap = Uap_29

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_29_Arg]) -> "Asterix_12":
        return cls._create(records) # type: ignore

class Asterix_13(AstCat):
    cv_category = 15
    cv_edition = (1, 1)
    cv_uap = Uap_29

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_29_Arg]) -> "Asterix_13":
        return cls._create(records) # type: ignore

class Asterix_14(AstCat):
    cv_category = 15
    cv_edition = (1, 2)
    cv_uap = Uap_29

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_29_Arg]) -> "Asterix_14":
        return cls._create(records) # type: ignore

NonSpare_30_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_30(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_30_Arg) -> "NonSpare_30":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_30(UapItem):
    cv_non_spare = NonSpare_30

NonSpare_66_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_66(NonSpare):
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_66_Arg) -> "NonSpare_66":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_66(UapItem):
    cv_non_spare = NonSpare_66

Content_594_Arg: TypeAlias = int
class Content_594(ContentTable):
    cv_values = {1: "System Configuration", 2: "Transmitter / Receiver Configuration"}

RuleContent_594_Arg: TypeAlias = Content_594_Arg
class RuleContent_594(RuleContentContextFree):
    cv_content = Content_594

    @property
    def content(self) -> Content_594:
        return self._get_content() # type: ignore

Variation_194_Arg: TypeAlias = RuleContent_594_Arg
class Variation_194(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_594

    @classmethod
    def create(cls, arg : Variation_194_Arg) -> "Variation_194":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_594:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_594:
        return self.rule.content

RuleVariation_187_Arg: TypeAlias = Variation_194_Arg
class RuleVariation_187(RuleVariationContextFree):
    cv_variation = Variation_194

    @classmethod
    def create(cls, arg : RuleVariation_187_Arg) -> "RuleVariation_187":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_194:
        return self.arg # type: ignore

NonSpare_10_Arg: TypeAlias = RuleVariation_187_Arg
class NonSpare_10(NonSpare):
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule = RuleVariation_187

    @classmethod
    def create(cls, arg : NonSpare_10_Arg) -> "NonSpare_10":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_187:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_194:
        return self.rule.variation

class UapItem_10(UapItem):
    cv_non_spare = NonSpare_10

NonSpare_322_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_322(NonSpare):
    cv_name = "140"
    cv_title = "Time of Day"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_322_Arg) -> "NonSpare_322":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_322(UapItem):
    cv_non_spare = NonSpare_322

Content_722_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
class Content_722(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

RuleContent_722_Arg: TypeAlias = Content_722_Arg
class RuleContent_722(RuleContentContextFree):
    cv_content = Content_722

    @property
    def content(self) -> Content_722:
        return self._get_content() # type: ignore

Variation_222_Arg: TypeAlias = RuleContent_722_Arg
class Variation_222(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_722

    @classmethod
    def create(cls, arg : Variation_222_Arg) -> "Variation_222":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_722:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_722:
        return self.rule.content

RuleVariation_215_Arg: TypeAlias = Variation_222_Arg
class RuleVariation_215(RuleVariationContextFree):
    cv_variation = Variation_222

    @classmethod
    def create(cls, arg : RuleVariation_215_Arg) -> "RuleVariation_215":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_222:
        return self.arg # type: ignore

NonSpare_392_Arg: TypeAlias = RuleVariation_215_Arg
class NonSpare_392(NonSpare):
    cv_name = "200"
    cv_title = "System Configuration Reporting Period"
    cv_rule = RuleVariation_215

    @classmethod
    def create(cls, arg : NonSpare_392_Arg) -> "NonSpare_392":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_215:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_222:
        return self.rule.variation

class UapItem_392(UapItem):
    cv_non_spare = NonSpare_392

NonSpare_1419_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_1419(NonSpare):
    cv_name = "PID"
    cv_title = "Pair Identification"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_1419_Arg) -> "NonSpare_1419":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

Item_679_Arg: TypeAlias = NonSpare_1419_Arg
class Item_679(Item):
    cv_non_spare = NonSpare_1419

    @classmethod
    def create(cls, arg : Item_679_Arg) -> "Item_679":
        return cls._create(arg) # type: ignore

NonSpare_1861_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_1861(NonSpare):
    cv_name = "TID"
    cv_title = "Transmitter Identification"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_1861_Arg) -> "NonSpare_1861":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

Item_1000_Arg: TypeAlias = NonSpare_1861_Arg
class Item_1000(Item):
    cv_non_spare = NonSpare_1861

    @classmethod
    def create(cls, arg : Item_1000_Arg) -> "Item_1000":
        return cls._create(arg) # type: ignore

NonSpare_1586_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_1586(NonSpare):
    cv_name = "RID"
    cv_title = "Receiver Identification"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_1586_Arg) -> "NonSpare_1586":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

Item_817_Arg: TypeAlias = NonSpare_1586_Arg
class Item_817(Item):
    cv_non_spare = NonSpare_1586

    @classmethod
    def create(cls, arg : Item_817_Arg) -> "Item_817":
        return cls._create(arg) # type: ignore

Variation_1151_Arg_Group = Tuple[Union[RuleVariation_244_Arg, Tuple[Literal["PID"], RuleVariation_244_Arg]], Union[RuleVariation_244_Arg, Tuple[Literal["TID"], RuleVariation_244_Arg]], Union[RuleVariation_244_Arg, Tuple[Literal["RID"], RuleVariation_244_Arg]]]
Variation_1151_Arg: TypeAlias = Union[int, Variation_1151_Arg_Group]
class Variation_1151(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_679, 16), (Item_1000, 16), (Item_817, 16)]
    cv_items_dict = {"PID": RuleVariation_244, "TID": RuleVariation_244, "RID": RuleVariation_244}

    @overload
    @classmethod
    def spec(cls, key : Literal["PID"]) -> RuleVariation_244:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> RuleVariation_244:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RID"]) -> RuleVariation_244:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PID"], Literal["TID"], Literal["RID"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PID"]) -> RuleVariation_244:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> RuleVariation_244:
        ...
    @overload
    def get_item(self, key : Literal["RID"]) -> RuleVariation_244:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1151_Arg) -> 'Variation_1151':
        return cls._create(arg) # type: ignore

Variation_1416_Arg: TypeAlias = List[Variation_1151_Arg]
class Variation_1416(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1151

    @classmethod
    def create(cls, arg : Variation_1416_Arg) -> 'Variation_1416':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1151]:
        return self._get_list() # type: ignore

RuleVariation_1339_Arg: TypeAlias = Variation_1416_Arg
class RuleVariation_1339(RuleVariationContextFree):
    cv_variation = Variation_1416

    @classmethod
    def create(cls, arg : RuleVariation_1339_Arg) -> "RuleVariation_1339":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1416:
        return self.arg # type: ignore

NonSpare_470_Arg: TypeAlias = RuleVariation_1339_Arg
class NonSpare_470(NonSpare):
    cv_name = "300"
    cv_title = "Pair Identification"
    cv_rule = RuleVariation_1339

    @classmethod
    def create(cls, arg : NonSpare_470_Arg) -> "NonSpare_470":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1339:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1416:
        return self.rule.variation

class UapItem_470(UapItem):
    cv_non_spare = NonSpare_470

NonSpare_494_Arg: TypeAlias = RuleVariation_1082_Arg
class NonSpare_494(NonSpare):
    cv_name = "400"
    cv_title = "Position of the System Reference Point"
    cv_rule = RuleVariation_1082

    @classmethod
    def create(cls, arg : NonSpare_494_Arg) -> "NonSpare_494":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1082:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1125:
        return self.rule.variation

class UapItem_493(UapItem):
    cv_non_spare = NonSpare_494

Content_656_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_656(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.25
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_656_Arg: TypeAlias = Content_656_Arg
class RuleContent_656(RuleContentContextFree):
    cv_content = Content_656

    @property
    def content(self) -> Content_656:
        return self._get_content() # type: ignore

Variation_274_Arg: TypeAlias = RuleContent_656_Arg
class Variation_274(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_656

    @classmethod
    def create(cls, arg : Variation_274_Arg) -> "Variation_274":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_656:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_656:
        return self.rule.content

RuleVariation_267_Arg: TypeAlias = Variation_274_Arg
class RuleVariation_267(RuleVariationContextFree):
    cv_variation = Variation_274

    @classmethod
    def create(cls, arg : RuleVariation_267_Arg) -> "RuleVariation_267":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_274:
        return self.arg # type: ignore

NonSpare_496_Arg: TypeAlias = RuleVariation_267_Arg
class NonSpare_496(NonSpare):
    cv_name = "405"
    cv_title = "Height of System Reference Point"
    cv_rule = RuleVariation_267

    @classmethod
    def create(cls, arg : NonSpare_496_Arg) -> "NonSpare_496":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_267:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_274:
        return self.rule.variation

class UapItem_495(UapItem):
    cv_non_spare = NonSpare_496

NonSpare_1860_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_1860(NonSpare):
    cv_name = "TID"
    cv_title = "Transmitter ID"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_1860_Arg) -> "NonSpare_1860":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

Item_999_Arg: TypeAlias = NonSpare_1860_Arg
class Item_999(Item):
    cv_non_spare = NonSpare_1860

    @classmethod
    def create(cls, arg : Item_999_Arg) -> "Item_999":
        return cls._create(arg) # type: ignore

NonSpare_586_Arg: TypeAlias = RuleVariation_267_Arg
class NonSpare_586(NonSpare):
    cv_name = "ALT"
    cv_title = "Altitude"
    cv_rule = RuleVariation_267

    @classmethod
    def create(cls, arg : NonSpare_586_Arg) -> "NonSpare_586":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_267:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_274:
        return self.rule.variation

Item_58_Arg: TypeAlias = NonSpare_586_Arg
class Item_58(Item):
    cv_non_spare = NonSpare_586

    @classmethod
    def create(cls, arg : Item_58_Arg) -> "Item_58":
        return cls._create(arg) # type: ignore

Content_628_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ns"]]]
class Content_628(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 2.0
    cv_unit = "ns"

    def as_quantity(self, cv_unit : Optional[Literal["ns"]] = None) -> float:
        return self._as_quantity()

RuleContent_628_Arg: TypeAlias = Content_628_Arg
class RuleContent_628(RuleContentContextFree):
    cv_content = Content_628

    @property
    def content(self) -> Content_628:
        return self._get_content() # type: ignore

Variation_374_Arg: TypeAlias = RuleContent_628_Arg
class Variation_374(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_628

    @classmethod
    def create(cls, arg : Variation_374_Arg) -> "Variation_374":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_628:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_628:
        return self.rule.content

RuleVariation_367_Arg: TypeAlias = Variation_374_Arg
class RuleVariation_367(RuleVariationContextFree):
    cv_variation = Variation_374

    @classmethod
    def create(cls, arg : RuleVariation_367_Arg) -> "RuleVariation_367":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_374:
        return self.arg # type: ignore

NonSpare_1942_Arg: TypeAlias = RuleVariation_367_Arg
class NonSpare_1942(NonSpare):
    cv_name = "TTO"
    cv_title = "Transmission Time Offset"
    cv_rule = RuleVariation_367

    @classmethod
    def create(cls, arg : NonSpare_1942_Arg) -> "NonSpare_1942":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_367:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_374:
        return self.rule.variation

Item_1063_Arg: TypeAlias = NonSpare_1942_Arg
class Item_1063(Item):
    cv_non_spare = NonSpare_1942

    @classmethod
    def create(cls, arg : Item_1063_Arg) -> "Item_1063":
        return cls._create(arg) # type: ignore

Content_720_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ns"]]]
class Content_720(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = "ns"

    def as_quantity(self, cv_unit : Optional[Literal["ns"]] = None) -> float:
        return self._as_quantity()

RuleContent_720_Arg: TypeAlias = Content_720_Arg
class RuleContent_720(RuleContentContextFree):
    cv_content = Content_720

    @property
    def content(self) -> Content_720:
        return self._get_content() # type: ignore

Variation_813_Arg: TypeAlias = RuleContent_720_Arg
class Variation_813(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 20
    cv_rule = RuleContent_720

    @classmethod
    def create(cls, arg : Variation_813_Arg) -> "Variation_813":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_720:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_720:
        return self.rule.content

RuleVariation_783_Arg: TypeAlias = Variation_813_Arg
class RuleVariation_783(RuleVariationContextFree):
    cv_variation = Variation_813

    @classmethod
    def create(cls, arg : RuleVariation_783_Arg) -> "RuleVariation_783":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_813:
        return self.arg # type: ignore

NonSpare_637_Arg: TypeAlias = RuleVariation_783_Arg
class NonSpare_637(NonSpare):
    cv_name = "ATO"
    cv_title = "Accuracy of Transmission Time Offset"
    cv_rule = RuleVariation_783

    @classmethod
    def create(cls, arg : NonSpare_637_Arg) -> "NonSpare_637":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_783:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_813:
        return self.rule.variation

Item_88_Arg: TypeAlias = NonSpare_637_Arg
class Item_88(Item):
    cv_non_spare = NonSpare_637

    @classmethod
    def create(cls, arg : Item_88_Arg) -> "Item_88":
        return cls._create(arg) # type: ignore

NonSpare_1414_Arg: TypeAlias = RuleVariation_247_Arg
class NonSpare_1414(NonSpare):
    cv_name = "PCI"
    cv_title = "Parallel Transmitter Index"
    cv_rule = RuleVariation_247

    @classmethod
    def create(cls, arg : NonSpare_1414_Arg) -> "NonSpare_1414":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_247:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_254:
        return self.rule.variation

Item_676_Arg: TypeAlias = NonSpare_1414_Arg
class Item_676(Item):
    cv_non_spare = NonSpare_1414

    @classmethod
    def create(cls, arg : Item_676_Arg) -> "Item_676":
        return cls._create(arg) # type: ignore

Variation_1219_Arg_Group = Tuple[Union[RuleVariation_244_Arg, Tuple[Literal["TID"], RuleVariation_244_Arg]], Union[RuleVariation_374_Arg, Tuple[Literal["LAT"], RuleVariation_374_Arg]], Union[RuleVariation_372_Arg, Tuple[Literal["LON"], RuleVariation_372_Arg]], Union[RuleVariation_267_Arg, Tuple[Literal["ALT"], RuleVariation_267_Arg]], Union[RuleVariation_367_Arg, Tuple[Literal["TTO"], RuleVariation_367_Arg]], int, Union[RuleVariation_783_Arg, Tuple[Literal["ATO"], RuleVariation_783_Arg]], Union[RuleVariation_247_Arg, Tuple[Literal["PCI"], RuleVariation_247_Arg]]]
Variation_1219_Arg: TypeAlias = Union[int, Variation_1219_Arg_Group]
class Variation_1219(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 168
    cv_items_list = [(Item_999, 16), (Item_464, 32), (Item_491, 32), (Item_58, 16), (Item_1063, 32), (Item_3, 4), (Item_88, 20), (Item_676, 16)]
    cv_items_dict = {"TID": RuleVariation_244, "LAT": RuleVariation_374, "LON": RuleVariation_372, "ALT": RuleVariation_267, "TTO": RuleVariation_367, "ATO": RuleVariation_783, "PCI": RuleVariation_247}

    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> RuleVariation_244:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_374:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_372:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_267:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TTO"]) -> RuleVariation_367:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ATO"]) -> RuleVariation_783:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PCI"]) -> RuleVariation_247:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TID"], Literal["LAT"], Literal["LON"], Literal["ALT"], Literal["TTO"], Literal["ATO"], Literal["PCI"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TID"]) -> RuleVariation_244:
        ...
    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_374:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_372:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_267:
        ...
    @overload
    def get_item(self, key : Literal["TTO"]) -> RuleVariation_367:
        ...
    @overload
    def get_item(self, key : Literal["ATO"]) -> RuleVariation_783:
        ...
    @overload
    def get_item(self, key : Literal["PCI"]) -> RuleVariation_247:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1219_Arg) -> 'Variation_1219':
        return cls._create(arg) # type: ignore

Variation_1430_Arg: TypeAlias = List[Variation_1219_Arg]
class Variation_1430(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1219

    @classmethod
    def create(cls, arg : Variation_1430_Arg) -> 'Variation_1430':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1219]:
        return self._get_list() # type: ignore

RuleVariation_1353_Arg: TypeAlias = Variation_1430_Arg
class RuleVariation_1353(RuleVariationContextFree):
    cv_variation = Variation_1430

    @classmethod
    def create(cls, arg : RuleVariation_1353_Arg) -> "RuleVariation_1353":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1430:
        return self.arg # type: ignore

NonSpare_498_Arg: TypeAlias = RuleVariation_1353_Arg
class NonSpare_498(NonSpare):
    cv_name = "410"
    cv_title = "Transmitter Properties"
    cv_rule = RuleVariation_1353

    @classmethod
    def create(cls, arg : NonSpare_498_Arg) -> "NonSpare_498":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1353:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1430:
        return self.rule.variation

class UapItem_497(UapItem):
    cv_non_spare = NonSpare_498

NonSpare_1585_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_1585(NonSpare):
    cv_name = "RID"
    cv_title = "Receiver Component ID"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_1585_Arg) -> "NonSpare_1585":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

Item_816_Arg: TypeAlias = NonSpare_1585_Arg
class Item_816(Item):
    cv_non_spare = NonSpare_1585

    @classmethod
    def create(cls, arg : Item_816_Arg) -> "Item_816":
        return cls._create(arg) # type: ignore

Variation_1177_Arg_Group = Tuple[Union[RuleVariation_244_Arg, Tuple[Literal["RID"], RuleVariation_244_Arg]], Union[RuleVariation_374_Arg, Tuple[Literal["LAT"], RuleVariation_374_Arg]], Union[RuleVariation_372_Arg, Tuple[Literal["LON"], RuleVariation_372_Arg]], Union[RuleVariation_267_Arg, Tuple[Literal["ALT"], RuleVariation_267_Arg]]]
Variation_1177_Arg: TypeAlias = Union[int, Variation_1177_Arg_Group]
class Variation_1177(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 96
    cv_items_list = [(Item_816, 16), (Item_464, 32), (Item_491, 32), (Item_58, 16)]
    cv_items_dict = {"RID": RuleVariation_244, "LAT": RuleVariation_374, "LON": RuleVariation_372, "ALT": RuleVariation_267}

    @overload
    @classmethod
    def spec(cls, key : Literal["RID"]) -> RuleVariation_244:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_374:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_372:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_267:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RID"], Literal["LAT"], Literal["LON"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RID"]) -> RuleVariation_244:
        ...
    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_374:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_372:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_267:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1177_Arg) -> 'Variation_1177':
        return cls._create(arg) # type: ignore

Variation_1418_Arg: TypeAlias = List[Variation_1177_Arg]
class Variation_1418(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1177

    @classmethod
    def create(cls, arg : Variation_1418_Arg) -> 'Variation_1418':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1177]:
        return self._get_list() # type: ignore

RuleVariation_1341_Arg: TypeAlias = Variation_1418_Arg
class RuleVariation_1341(RuleVariationContextFree):
    cv_variation = Variation_1418

    @classmethod
    def create(cls, arg : RuleVariation_1341_Arg) -> "RuleVariation_1341":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1418:
        return self.arg # type: ignore

NonSpare_500_Arg: TypeAlias = RuleVariation_1341_Arg
class NonSpare_500(NonSpare):
    cv_name = "420"
    cv_title = "Receiver Properties"
    cv_rule = RuleVariation_1341

    @classmethod
    def create(cls, arg : NonSpare_500_Arg) -> "NonSpare_500":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1341:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1418:
        return self.rule.variation

class UapItem_499(UapItem):
    cv_non_spare = NonSpare_500

Record_10_Arg = TypedDict('Record_10_Arg', {
    "010": NonSpare_30_Arg,
    "015": NonSpare_66_Arg,
    "000": NonSpare_10_Arg,
    "140": NonSpare_322_Arg,
    "200": NonSpare_392_Arg,
    "300": NonSpare_470_Arg,
    "400": NonSpare_494_Arg,
    "405": NonSpare_496_Arg,
    "410": NonSpare_498_Arg,
    "420": NonSpare_500_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_10(Record):
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_30, UapItem_66, UapItem_10, UapItem_322, UapItem_392, UapItem_470, UapItem_493, UapItem_495, UapItem_497, UapItem_499, UapItem_543]
    cv_items_dict = {"010": NonSpare_30, "015": NonSpare_66, "000": NonSpare_10, "140": NonSpare_322, "200": NonSpare_392, "300": NonSpare_470, "400": NonSpare_494, "405": NonSpare_496, "410": NonSpare_498, "420": NonSpare_500, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_30:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_66:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_10:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_322:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_392:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_470:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_494:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["405"]) -> NonSpare_496:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["410"]) -> NonSpare_498:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["420"]) -> NonSpare_500:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["000"], Literal["140"], Literal["200"], Literal["300"], Literal["400"], Literal["405"], Literal["410"], Literal["420"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_30]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_66]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_10]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_322]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_392]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_470]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_494]:
        ...
    @overload
    def get_item(self, key : Literal["405"]) -> Optional[NonSpare_496]:
        ...
    @overload
    def get_item(self, key : Literal["410"]) -> Optional[NonSpare_498]:
        ...
    @overload
    def get_item(self, key : Literal["420"]) -> Optional[NonSpare_500]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_30_Arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_66_Arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_10_Arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_322_Arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_392_Arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_470_Arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_494_Arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["405"], val : NonSpare_496_Arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["410"], val : NonSpare_498_Arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["420"], val : NonSpare_500_Arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_10':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["405"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["410"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["420"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_10':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_10_Arg) -> 'Record_10':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_10", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_10_Arg: TypeAlias = Record_10
class Uap_10(UapSingle):
    cv_record = Record_10

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_10]]:
        return cls._parse(bs)

class Asterix_15(AstCat):
    cv_category = 16
    cv_edition = (1, 0)
    cv_uap = Uap_10

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_10_Arg]) -> "Asterix_15":
        return cls._create(records) # type: ignore

NonSpare_40_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_40(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_40_Arg) -> "NonSpare_40":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_40(UapItem):
    cv_non_spare = NonSpare_40

NonSpare_53_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_53(NonSpare):
    cv_name = "012"
    cv_title = "Data Destination Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_53_Arg) -> "NonSpare_53":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_53(UapItem):
    cv_non_spare = NonSpare_53

Content_301_Arg: TypeAlias = int
class Content_301(ContentTable):
    cv_values = {0: "Network information", 10: "Track data", 20: "Track data request", 21: "Track data stop", 22: "Cancel track data request", 23: "Track data stop acknowledgement", 30: "New Node / Change-over Initial or intermediate message segment", 31: "New Node / Change-over Final or only message segment", 32: "New Node / Change-over Initial or intermediate message segment reply", 33: "New Node / Change-over Final or only message segment reply", 110: "Move node to new cluster state;", 111: "Move node to new cluster state acknowledgement"}

RuleContent_301_Arg: TypeAlias = Content_301_Arg
class RuleContent_301(RuleContentContextFree):
    cv_content = Content_301

    @property
    def content(self) -> Content_301:
        return self._get_content() # type: ignore

Variation_168_Arg: TypeAlias = RuleContent_301_Arg
class Variation_168(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_301

    @classmethod
    def create(cls, arg : Variation_168_Arg) -> "Variation_168":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_301:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_301:
        return self.rule.content

RuleVariation_162_Arg: TypeAlias = Variation_168_Arg
class RuleVariation_162(RuleVariationContextFree):
    cv_variation = Variation_168

    @classmethod
    def create(cls, arg : RuleVariation_162_Arg) -> "RuleVariation_162":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_168:
        return self.arg # type: ignore

NonSpare_1_Arg: TypeAlias = RuleVariation_162_Arg
class NonSpare_1(NonSpare):
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule = RuleVariation_162

    @classmethod
    def create(cls, arg : NonSpare_1_Arg) -> "NonSpare_1":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_162:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_168:
        return self.rule.variation

class UapItem_1(UapItem):
    cv_non_spare = NonSpare_1

NonSpare_478_Arg: TypeAlias = RuleVariation_1344_Arg
class NonSpare_478(NonSpare):
    cv_name = "350"
    cv_title = "Cluster Station/Node List"
    cv_rule = RuleVariation_1344

    @classmethod
    def create(cls, arg : NonSpare_478_Arg) -> "NonSpare_478":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1344:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1421:
        return self.rule.variation

class UapItem_478(UapItem):
    cv_non_spare = NonSpare_478

NonSpare_414_Arg: TypeAlias = RuleVariation_340_Arg
class NonSpare_414(NonSpare):
    cv_name = "220"
    cv_title = "Aircraft Address"
    cv_rule = RuleVariation_340

    @classmethod
    def create(cls, arg : NonSpare_414_Arg) -> "NonSpare_414":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_340:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_347:
        return self.rule.variation

class UapItem_414(UapItem):
    cv_non_spare = NonSpare_414

NonSpare_423_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_423(NonSpare):
    cv_name = "221"
    cv_title = "Duplicate Address Reference Number (DRN)"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_423_Arg) -> "NonSpare_423":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

class UapItem_423(UapItem):
    cv_non_spare = NonSpare_423

NonSpare_329_Arg: TypeAlias = RuleVariation_362_Arg
class NonSpare_329(NonSpare):
    cv_name = "140"
    cv_title = "Time of Day"
    cv_rule = RuleVariation_362

    @classmethod
    def create(cls, arg : NonSpare_329_Arg) -> "NonSpare_329":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_362:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_369:
        return self.rule.variation

class UapItem_329(UapItem):
    cv_non_spare = NonSpare_329

Variation_362_Arg: TypeAlias = RuleContent_696_Arg
class Variation_362(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_696

    @classmethod
    def create(cls, arg : Variation_362_Arg) -> "Variation_362":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_696:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_696:
        return self.rule.content

RuleVariation_355_Arg: TypeAlias = Variation_362_Arg
class RuleVariation_355(RuleVariationContextFree):
    cv_variation = Variation_362

    @classmethod
    def create(cls, arg : RuleVariation_355_Arg) -> "RuleVariation_355":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_362:
        return self.arg # type: ignore

NonSpare_1143_Arg: TypeAlias = RuleVariation_355_Arg
class NonSpare_1143(NonSpare):
    cv_name = "LAT"
    cv_title = "Latitude"
    cv_rule = RuleVariation_355

    @classmethod
    def create(cls, arg : NonSpare_1143_Arg) -> "NonSpare_1143":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_355:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_362:
        return self.rule.variation

Item_461_Arg: TypeAlias = NonSpare_1143_Arg
class Item_461(Item):
    cv_non_spare = NonSpare_1143

    @classmethod
    def create(cls, arg : Item_461_Arg) -> "Item_461":
        return cls._create(arg) # type: ignore

Variation_361_Arg: TypeAlias = RuleContent_695_Arg
class Variation_361(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_695

    @classmethod
    def create(cls, arg : Variation_361_Arg) -> "Variation_361":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_695:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_695:
        return self.rule.content

RuleVariation_354_Arg: TypeAlias = Variation_361_Arg
class RuleVariation_354(RuleVariationContextFree):
    cv_variation = Variation_361

    @classmethod
    def create(cls, arg : RuleVariation_354_Arg) -> "RuleVariation_354":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_361:
        return self.arg # type: ignore

NonSpare_1172_Arg: TypeAlias = RuleVariation_354_Arg
class NonSpare_1172(NonSpare):
    cv_name = "LON"
    cv_title = "Longitude"
    cv_rule = RuleVariation_354

    @classmethod
    def create(cls, arg : NonSpare_1172_Arg) -> "NonSpare_1172":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_354:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_361:
        return self.rule.variation

Item_488_Arg: TypeAlias = NonSpare_1172_Arg
class Item_488(Item):
    cv_non_spare = NonSpare_1172

    @classmethod
    def create(cls, arg : Item_488_Arg) -> "Item_488":
        return cls._create(arg) # type: ignore

Variation_1122_Arg_Group = Tuple[Union[RuleVariation_355_Arg, Tuple[Literal["LAT"], RuleVariation_355_Arg]], Union[RuleVariation_354_Arg, Tuple[Literal["LON"], RuleVariation_354_Arg]]]
Variation_1122_Arg: TypeAlias = Union[int, Variation_1122_Arg_Group]
class Variation_1122(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_461, 24), (Item_488, 24)]
    cv_items_dict = {"LAT": RuleVariation_355, "LON": RuleVariation_354}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_355:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_354:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_355:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_354:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1122_Arg) -> 'Variation_1122':
        return cls._create(arg) # type: ignore

RuleVariation_1079_Arg: TypeAlias = Variation_1122_Arg
class RuleVariation_1079(RuleVariationContextFree):
    cv_variation = Variation_1122

    @classmethod
    def create(cls, arg : RuleVariation_1079_Arg) -> "RuleVariation_1079":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1122:
        return self.arg # type: ignore

NonSpare_162_Arg: TypeAlias = RuleVariation_1079_Arg
class NonSpare_162(NonSpare):
    cv_name = "045"
    cv_title = "Calculated Position in WGS-84 Coordinates"
    cv_rule = RuleVariation_1079

    @classmethod
    def create(cls, arg : NonSpare_162_Arg) -> "NonSpare_162":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1079:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1122:
        return self.rule.variation

class UapItem_162(UapItem):
    cv_non_spare = NonSpare_162

Content_291_Arg: TypeAlias = int
class Content_291(ContentTable):
    cv_values = {0: "Mode-3/A code derived from the reply of the transponder", 1: "Smoothed Mode-3/A code not extracted during the last scan"}

RuleContent_291_Arg: TypeAlias = Content_291_Arg
class RuleContent_291(RuleContentContextFree):
    cv_content = Content_291

    @property
    def content(self) -> Content_291:
        return self._get_content() # type: ignore

Variation_553_Arg: TypeAlias = RuleContent_291_Arg
class Variation_553(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_291

    @classmethod
    def create(cls, arg : Variation_553_Arg) -> "Variation_553":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_291:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_291:
        return self.rule.content

RuleVariation_542_Arg: TypeAlias = Variation_553_Arg
class RuleVariation_542(RuleVariationContextFree):
    cv_variation = Variation_553

    @classmethod
    def create(cls, arg : RuleVariation_542_Arg) -> "RuleVariation_542":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_553:
        return self.arg # type: ignore

NonSpare_1135_Arg: TypeAlias = RuleVariation_542_Arg
class NonSpare_1135(NonSpare):
    cv_name = "L"
    cv_title = ""
    cv_rule = RuleVariation_542

    @classmethod
    def create(cls, arg : NonSpare_1135_Arg) -> "NonSpare_1135":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_542:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_553:
        return self.rule.variation

Item_453_Arg: TypeAlias = NonSpare_1135_Arg
class Item_453(Item):
    cv_non_spare = NonSpare_1135

    @classmethod
    def create(cls, arg : Item_453_Arg) -> "Item_453":
        return cls._create(arg) # type: ignore

NonSpare_1297_Arg: TypeAlias = RuleVariation_776_Arg
class NonSpare_1297(NonSpare):
    cv_name = "MODE3A"
    cv_title = "Mode 3/A Reply in Octal Representation"
    cv_rule = RuleVariation_776

    @classmethod
    def create(cls, arg : NonSpare_1297_Arg) -> "NonSpare_1297":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_776:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_806:
        return self.rule.variation

Item_569_Arg: TypeAlias = NonSpare_1297_Arg
class Item_569(Item):
    cv_non_spare = NonSpare_1297

    @classmethod
    def create(cls, arg : Item_569_Arg) -> "Item_569":
        return cls._create(arg) # type: ignore

Variation_1260_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_542_Arg, Tuple[Literal["L"], RuleVariation_542_Arg]], int, Union[RuleVariation_776_Arg, Tuple[Literal["MODE3A"], RuleVariation_776_Arg]]]
Variation_1260_Arg: TypeAlias = Union[int, Variation_1260_Arg_Group]
class Variation_1260(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1099, 1), (Item_353, 1), (Item_453, 1), (Item_16, 1), (Item_569, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "L": RuleVariation_542, "MODE3A": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_542:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_542:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1260_Arg) -> 'Variation_1260':
        return cls._create(arg) # type: ignore

RuleVariation_1190_Arg: TypeAlias = Variation_1260_Arg
class RuleVariation_1190(RuleVariationContextFree):
    cv_variation = Variation_1260

    @classmethod
    def create(cls, arg : RuleVariation_1190_Arg) -> "RuleVariation_1190":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1260:
        return self.arg # type: ignore

NonSpare_206_Arg: TypeAlias = RuleVariation_1190_Arg
class NonSpare_206(NonSpare):
    cv_name = "070"
    cv_title = "Mode 3/A Code in Octal Representation"
    cv_rule = RuleVariation_1190

    @classmethod
    def create(cls, arg : NonSpare_206_Arg) -> "NonSpare_206":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1190:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1260:
        return self.rule.variation

class UapItem_206(UapItem):
    cv_non_spare = NonSpare_206

Content_98_Arg: TypeAlias = int
class Content_98(ContentTable):
    cv_values = {0: "Default", 1: "Garbled code / Error correction applied"}

RuleContent_98_Arg: TypeAlias = Content_98_Arg
class RuleContent_98(RuleContentContextFree):
    cv_content = Content_98

    @property
    def content(self) -> Content_98:
        return self._get_content() # type: ignore

Variation_406_Arg: TypeAlias = RuleContent_98_Arg
class Variation_406(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_98

    @classmethod
    def create(cls, arg : Variation_406_Arg) -> "Variation_406":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_98:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_98:
        return self.rule.content

RuleVariation_395_Arg: TypeAlias = Variation_406_Arg
class RuleVariation_395(RuleVariationContextFree):
    cv_variation = Variation_406

    @classmethod
    def create(cls, arg : RuleVariation_395_Arg) -> "RuleVariation_395":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_406:
        return self.arg # type: ignore

NonSpare_1002_Arg: TypeAlias = RuleVariation_395_Arg
class NonSpare_1002(NonSpare):
    cv_name = "G"
    cv_title = ""
    cv_rule = RuleVariation_395

    @classmethod
    def create(cls, arg : NonSpare_1002_Arg) -> "NonSpare_1002":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_395:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_406:
        return self.rule.variation

Item_354_Arg: TypeAlias = NonSpare_1002_Arg
class Item_354(Item):
    cv_non_spare = NonSpare_1002

    @classmethod
    def create(cls, arg : Item_354_Arg) -> "Item_354":
        return cls._create(arg) # type: ignore

Variation_608_Arg: TypeAlias = RuleContent_748_Arg
class Variation_608(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_748

    @classmethod
    def create(cls, arg : Variation_608_Arg) -> "Variation_608":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_748:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_749:
        return self.rule.content

RuleVariation_597_Arg: TypeAlias = Variation_608_Arg
class RuleVariation_597(RuleVariationContextFree):
    cv_variation = Variation_608

    @classmethod
    def create(cls, arg : RuleVariation_597_Arg) -> "RuleVariation_597":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_608:
        return self.arg # type: ignore

NonSpare_587_Arg: TypeAlias = RuleVariation_597_Arg
class NonSpare_587(NonSpare):
    cv_name = "ALT"
    cv_title = "Altitude"
    cv_rule = RuleVariation_597

    @classmethod
    def create(cls, arg : NonSpare_587_Arg) -> "NonSpare_587":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_597:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_608:
        return self.rule.variation

Item_59_Arg: TypeAlias = NonSpare_587_Arg
class Item_59(Item):
    cv_non_spare = NonSpare_587

    @classmethod
    def create(cls, arg : Item_59_Arg) -> "Item_59":
        return cls._create(arg) # type: ignore

Variation_1261_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_395_Arg, Tuple[Literal["G"], RuleVariation_395_Arg]], Union[RuleVariation_597_Arg, Tuple[Literal["ALT"], RuleVariation_597_Arg]]]
Variation_1261_Arg: TypeAlias = Union[int, Variation_1261_Arg_Group]
class Variation_1261(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1099, 1), (Item_354, 1), (Item_59, 14)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_395, "ALT": RuleVariation_597}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_395:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_597:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_395:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_597:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1261_Arg) -> 'Variation_1261':
        return cls._create(arg) # type: ignore

RuleVariation_1191_Arg: TypeAlias = Variation_1261_Arg
class RuleVariation_1191(RuleVariationContextFree):
    cv_variation = Variation_1261

    @classmethod
    def create(cls, arg : RuleVariation_1191_Arg) -> "RuleVariation_1191":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1261:
        return self.arg # type: ignore

NonSpare_167_Arg: TypeAlias = RuleVariation_1191_Arg
class NonSpare_167(NonSpare):
    cv_name = "050"
    cv_title = "Flight Level in Binary Representation"
    cv_rule = RuleVariation_1191

    @classmethod
    def create(cls, arg : NonSpare_167_Arg) -> "NonSpare_167":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1191:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1261:
        return self.rule.variation

class UapItem_167(UapItem):
    cv_non_spare = NonSpare_167

NonSpare_398_Arg: TypeAlias = RuleVariation_1067_Arg
class NonSpare_398(NonSpare):
    cv_name = "200"
    cv_title = "Track Velocity in Polar Co-ordinates"
    cv_rule = RuleVariation_1067

    @classmethod
    def create(cls, arg : NonSpare_398_Arg) -> "NonSpare_398":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1067:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1109:
        return self.rule.variation

class UapItem_398(UapItem):
    cv_non_spare = NonSpare_398

Content_338_Arg: TypeAlias = int
class Content_338(ContentTable):
    cv_values = {0: "No communications capability (surveillance only), no ability to set CA code 7 either airborne or on the ground", 1: "Reserved", 2: "Reserved", 3: "Reserved", 4: "At Least Comm. A and Comm. B capability and the ability to set CA code 7 and on the ground", 5: "At Least Comm. A and Comm. B capability and the ability to set CA code 7 and airborne", 6: "At Least Comm. A and Comm. B capability and the ability to set CA code 7 and either airborne or on the ground", 7: "Signifies the DR field is not equal to 0 or the FS field equals 2, 3, 4 or 5 and either airborne or on the ground SI/II-capabilities of the Transponder"}

RuleContent_338_Arg: TypeAlias = Content_338_Arg
class RuleContent_338(RuleContentContextFree):
    cv_content = Content_338

    @property
    def content(self) -> Content_338:
        return self._get_content() # type: ignore

Variation_124_Arg: TypeAlias = RuleContent_338_Arg
class Variation_124(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_338

    @classmethod
    def create(cls, arg : Variation_124_Arg) -> "Variation_124":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_338:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_338:
        return self.rule.content

RuleVariation_124_Arg: TypeAlias = Variation_124_Arg
class RuleVariation_124(RuleVariationContextFree):
    cv_variation = Variation_124

    @classmethod
    def create(cls, arg : RuleVariation_124_Arg) -> "RuleVariation_124":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_124:
        return self.arg # type: ignore

NonSpare_695_Arg: TypeAlias = RuleVariation_124_Arg
class NonSpare_695(NonSpare):
    cv_name = "CA"
    cv_title = "Communications Capability of the Transponder"
    cv_rule = RuleVariation_124

    @classmethod
    def create(cls, arg : NonSpare_695_Arg) -> "NonSpare_695":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_124:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_124:
        return self.rule.variation

Item_132_Arg: TypeAlias = NonSpare_695_Arg
class Item_132(Item):
    cv_non_spare = NonSpare_695

    @classmethod
    def create(cls, arg : Item_132_Arg) -> "Item_132":
        return cls._create(arg) # type: ignore

Content_521_Arg: TypeAlias = int
class Content_521(ContentTable):
    cv_values = {0: "Transponder SI capable", 1: "Transponder not SI capable"}

RuleContent_521_Arg: TypeAlias = Content_521_Arg
class RuleContent_521(RuleContentContextFree):
    cv_content = Content_521

    @property
    def content(self) -> Content_521:
        return self._get_content() # type: ignore

Variation_666_Arg: TypeAlias = RuleContent_521_Arg
class Variation_666(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_521

    @classmethod
    def create(cls, arg : Variation_666_Arg) -> "Variation_666":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_521:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_521:
        return self.rule.content

RuleVariation_655_Arg: TypeAlias = Variation_666_Arg
class RuleVariation_655(RuleVariationContextFree):
    cv_variation = Variation_666

    @classmethod
    def create(cls, arg : RuleVariation_655_Arg) -> "RuleVariation_655":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_666:
        return self.arg # type: ignore

NonSpare_1698_Arg: TypeAlias = RuleVariation_655_Arg
class NonSpare_1698(NonSpare):
    cv_name = "SI"
    cv_title = "SI/II-capabilities of the Transponder"
    cv_rule = RuleVariation_655

    @classmethod
    def create(cls, arg : NonSpare_1698_Arg) -> "NonSpare_1698":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_655:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_666:
        return self.rule.variation

Item_881_Arg: TypeAlias = NonSpare_1698_Arg
class Item_881(Item):
    cv_non_spare = NonSpare_1698

    @classmethod
    def create(cls, arg : Item_881_Arg) -> "Item_881":
        return cls._create(arg) # type: ignore

Variation_1059_Arg_Group = Tuple[Union[RuleVariation_124_Arg, Tuple[Literal["CA"], RuleVariation_124_Arg]], Union[RuleVariation_655_Arg, Tuple[Literal["SI"], RuleVariation_655_Arg]], int]
Variation_1059_Arg: TypeAlias = Union[int, Variation_1059_Arg_Group]
class Variation_1059(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_132, 3), (Item_881, 1), (Item_22, 4)]
    cv_items_dict = {"CA": RuleVariation_124, "SI": RuleVariation_655}

    @overload
    @classmethod
    def spec(cls, key : Literal["CA"]) -> RuleVariation_124:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SI"]) -> RuleVariation_655:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CA"], Literal["SI"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CA"]) -> RuleVariation_124:
        ...
    @overload
    def get_item(self, key : Literal["SI"]) -> RuleVariation_655:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1059_Arg) -> 'Variation_1059':
        return cls._create(arg) # type: ignore

RuleVariation_1023_Arg: TypeAlias = Variation_1059_Arg
class RuleVariation_1023(RuleVariationContextFree):
    cv_variation = Variation_1059

    @classmethod
    def create(cls, arg : RuleVariation_1023_Arg) -> "RuleVariation_1023":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1059:
        return self.arg # type: ignore

NonSpare_430_Arg: TypeAlias = RuleVariation_1023_Arg
class NonSpare_430(NonSpare):
    cv_name = "230"
    cv_title = "Transponder Capability"
    cv_rule = RuleVariation_1023

    @classmethod
    def create(cls, arg : NonSpare_430_Arg) -> "NonSpare_430":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1023:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1059:
        return self.rule.variation

class UapItem_430(UapItem):
    cv_non_spare = NonSpare_430

Content_265_Arg: TypeAlias = int
class Content_265(ContentTable):
    cv_values = {0: "Measured position", 1: "No measured position (coasted)"}

RuleContent_265_Arg: TypeAlias = Content_265_Arg
class RuleContent_265(RuleContentContextFree):
    cv_content = Content_265

    @property
    def content(self) -> Content_265:
        return self._get_content() # type: ignore

Variation_52_Arg: TypeAlias = RuleContent_265_Arg
class Variation_52(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_265

    @classmethod
    def create(cls, arg : Variation_52_Arg) -> "Variation_52":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_265:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_265:
        return self.rule.content

RuleVariation_52_Arg: TypeAlias = Variation_52_Arg
class RuleVariation_52(RuleVariationContextFree):
    cv_variation = Variation_52

    @classmethod
    def create(cls, arg : RuleVariation_52_Arg) -> "RuleVariation_52":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_52:
        return self.arg # type: ignore

NonSpare_836_Arg: TypeAlias = RuleVariation_52_Arg
class NonSpare_836(NonSpare):
    cv_name = "CST"
    cv_title = "Track Coasted"
    cv_rule = RuleVariation_52

    @classmethod
    def create(cls, arg : NonSpare_836_Arg) -> "NonSpare_836":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_52:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_52:
        return self.rule.variation

Item_224_Arg: TypeAlias = NonSpare_836_Arg
class Item_224(Item):
    cv_non_spare = NonSpare_836

    @classmethod
    def create(cls, arg : Item_224_Arg) -> "Item_224":
        return cls._create(arg) # type: ignore

Content_253_Arg: TypeAlias = int
class Content_253(ContentTable):
    cv_values = {0: "Last Measured Flight Level", 1: "Predicted Flight Level"}

RuleContent_253_Arg: TypeAlias = Content_253_Arg
class RuleContent_253(RuleContentContextFree):
    cv_content = Content_253

    @property
    def content(self) -> Content_253:
        return self._get_content() # type: ignore

Variation_434_Arg: TypeAlias = RuleContent_253_Arg
class Variation_434(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_253

    @classmethod
    def create(cls, arg : Variation_434_Arg) -> "Variation_434":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_253:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_253:
        return self.rule.content

RuleVariation_423_Arg: TypeAlias = Variation_434_Arg
class RuleVariation_423(RuleVariationContextFree):
    cv_variation = Variation_434

    @classmethod
    def create(cls, arg : RuleVariation_423_Arg) -> "RuleVariation_423":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_434:
        return self.arg # type: ignore

NonSpare_971_Arg: TypeAlias = RuleVariation_423_Arg
class NonSpare_971(NonSpare):
    cv_name = "FLT"
    cv_title = "Flight Level Tracking"
    cv_rule = RuleVariation_423

    @classmethod
    def create(cls, arg : NonSpare_971_Arg) -> "NonSpare_971":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_423:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_434:
        return self.rule.variation

Item_331_Arg: TypeAlias = NonSpare_971_Arg
class Item_331(Item):
    cv_non_spare = NonSpare_971

    @classmethod
    def create(cls, arg : Item_331_Arg) -> "Item_331":
        return cls._create(arg) # type: ignore

Variation_1077_Arg_Group = Tuple[Union[RuleVariation_52_Arg, Tuple[Literal["CST"], RuleVariation_52_Arg]], Union[RuleVariation_423_Arg, Tuple[Literal["FLT"], RuleVariation_423_Arg]], int]
Variation_1077_Arg: TypeAlias = Union[int, Variation_1077_Arg_Group]
class Variation_1077(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_224, 1), (Item_331, 1), (Item_15, 6)]
    cv_items_dict = {"CST": RuleVariation_52, "FLT": RuleVariation_423}

    @overload
    @classmethod
    def spec(cls, key : Literal["CST"]) -> RuleVariation_52:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FLT"]) -> RuleVariation_423:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CST"], Literal["FLT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CST"]) -> RuleVariation_52:
        ...
    @overload
    def get_item(self, key : Literal["FLT"]) -> RuleVariation_423:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1077_Arg) -> 'Variation_1077':
        return cls._create(arg) # type: ignore

RuleVariation_1037_Arg: TypeAlias = Variation_1077_Arg
class RuleVariation_1037(RuleVariationContextFree):
    cv_variation = Variation_1077

    @classmethod
    def create(cls, arg : RuleVariation_1037_Arg) -> "RuleVariation_1037":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1077:
        return self.arg # type: ignore

NonSpare_434_Arg: TypeAlias = RuleVariation_1037_Arg
class NonSpare_434(NonSpare):
    cv_name = "240"
    cv_title = "Track Status"
    cv_rule = RuleVariation_1037

    @classmethod
    def create(cls, arg : NonSpare_434_Arg) -> "NonSpare_434":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1037:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1077:
        return self.rule.variation

class UapItem_434(UapItem):
    cv_non_spare = NonSpare_434

Variation_1390_Arg: TypeAlias = List[Variation_347_Arg]
class Variation_1390(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_347

    @classmethod
    def create(cls, arg : Variation_1390_Arg) -> 'Variation_1390':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_347]:
        return self._get_list() # type: ignore

RuleVariation_1313_Arg: TypeAlias = Variation_1390_Arg
class RuleVariation_1313(RuleVariationContextFree):
    cv_variation = Variation_1390

    @classmethod
    def create(cls, arg : RuleVariation_1313_Arg) -> "RuleVariation_1313":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1390:
        return self.arg # type: ignore

NonSpare_410_Arg: TypeAlias = RuleVariation_1313_Arg
class NonSpare_410(NonSpare):
    cv_name = "210"
    cv_title = "Mode S Address List"
    cv_rule = RuleVariation_1313

    @classmethod
    def create(cls, arg : NonSpare_410_Arg) -> "NonSpare_410":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1313:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1390:
        return self.rule.variation

class UapItem_410(UapItem):
    cv_non_spare = NonSpare_410

NonSpare_479_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_479(NonSpare):
    cv_name = "360"
    cv_title = "Cluster Controller Command State"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_479_Arg) -> "NonSpare_479":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_479(UapItem):
    cv_non_spare = NonSpare_479

Record_34_Arg = TypedDict('Record_34_Arg', {
    "010": NonSpare_40_Arg,
    "012": NonSpare_53_Arg,
    "000": NonSpare_1_Arg,
    "350": NonSpare_478_Arg,
    "220": NonSpare_414_Arg,
    "221": NonSpare_423_Arg,
    "140": NonSpare_329_Arg,
    "045": NonSpare_162_Arg,
    "070": NonSpare_206_Arg,
    "050": NonSpare_167_Arg,
    "200": NonSpare_398_Arg,
    "230": NonSpare_430_Arg,
    "240": NonSpare_434_Arg,
    "210": NonSpare_410_Arg,
    "360": NonSpare_479_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_34(Record):
    cv_fspec_max_bytes = 3
    cv_items_list = [UapItem_40, UapItem_53, UapItem_1, UapItem_478, UapItem_414, UapItem_423, UapItem_329, UapItem_162, UapItem_206, UapItem_167, UapItem_398, UapItem_430, UapItem_434, UapItem_410, UapItem_479, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_543]
    cv_items_dict = {"010": NonSpare_40, "012": NonSpare_53, "000": NonSpare_1, "350": NonSpare_478, "220": NonSpare_414, "221": NonSpare_423, "140": NonSpare_329, "045": NonSpare_162, "070": NonSpare_206, "050": NonSpare_167, "200": NonSpare_398, "230": NonSpare_430, "240": NonSpare_434, "210": NonSpare_410, "360": NonSpare_479, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_40:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["012"]) -> NonSpare_53:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_1:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["350"]) -> NonSpare_478:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_414:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["221"]) -> NonSpare_423:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_329:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["045"]) -> NonSpare_162:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_206:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_167:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_398:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_430:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["240"]) -> NonSpare_434:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_410:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["360"]) -> NonSpare_479:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["012"], Literal["000"], Literal["350"], Literal["220"], Literal["221"], Literal["140"], Literal["045"], Literal["070"], Literal["050"], Literal["200"], Literal["230"], Literal["240"], Literal["210"], Literal["360"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_40]:
        ...
    @overload
    def get_item(self, key : Literal["012"]) -> Optional[NonSpare_53]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_1]:
        ...
    @overload
    def get_item(self, key : Literal["350"]) -> Optional[NonSpare_478]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_414]:
        ...
    @overload
    def get_item(self, key : Literal["221"]) -> Optional[NonSpare_423]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_329]:
        ...
    @overload
    def get_item(self, key : Literal["045"]) -> Optional[NonSpare_162]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_206]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_167]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_398]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_430]:
        ...
    @overload
    def get_item(self, key : Literal["240"]) -> Optional[NonSpare_434]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_410]:
        ...
    @overload
    def get_item(self, key : Literal["360"]) -> Optional[NonSpare_479]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_40_Arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["012"], val : NonSpare_53_Arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_1_Arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["350"], val : NonSpare_478_Arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_414_Arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["221"], val : NonSpare_423_Arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_329_Arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["045"], val : NonSpare_162_Arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_206_Arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_167_Arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_398_Arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_430_Arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["240"], val : NonSpare_434_Arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_410_Arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["360"], val : NonSpare_479_Arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_34':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["012"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["350"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["221"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["045"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["240"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["360"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_34':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_34_Arg) -> 'Record_34':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_34", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_30_Arg: TypeAlias = Record_34
class Uap_30(UapSingle):
    cv_record = Record_34

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_34]]:
        return cls._parse(bs)

class Asterix_16(AstCat):
    cv_category = 17
    cv_edition = (1, 3)
    cv_uap = Uap_30

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_30_Arg]) -> "Asterix_16":
        return cls._create(records) # type: ignore

NonSpare_130_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_130(NonSpare):
    cv_name = "036"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_130_Arg) -> "NonSpare_130":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_130(UapItem):
    cv_non_spare = NonSpare_130

NonSpare_132_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_132(NonSpare):
    cv_name = "037"
    cv_title = "Data Destination Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_132_Arg) -> "NonSpare_132":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_132(UapItem):
    cv_non_spare = NonSpare_132

Content_36_Arg: TypeAlias = int
class Content_36(ContentTable):
    cv_values = {0: "Associate_req", 1: "Associate_resp", 2: "Release_req", 3: "Release_resp", 4: "Abort_req", 5: "Keep_alive", 16: "Aircraft_report", 17: "Aircraft_command", 18: "II_code_change", 32: "Uplink_packet", 33: "Cancel_uplink_packet", 34: "Uplink_packet_ack", 35: "Downlink_packet", 38: "Data_XON", 39: "Data_XOFF", 48: "Uplink_broadcast", 49: "Cancel_uplink_broadcast", 50: "Uplink_broadcast_ack", 52: "Downlink_broadcast", 64: "GICB_extraction", 65: "Cancel_GICB_extraction", 66: "GICB_extraction_ack", 67: "GICB_response"}

RuleContent_36_Arg: TypeAlias = Content_36_Arg
class RuleContent_36(RuleContentContextFree):
    cv_content = Content_36

    @property
    def content(self) -> Content_36:
        return self._get_content() # type: ignore

Variation_165_Arg: TypeAlias = RuleContent_36_Arg
class Variation_165(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_36

    @classmethod
    def create(cls, arg : Variation_165_Arg) -> "Variation_165":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_36:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_36:
        return self.rule.content

RuleVariation_159_Arg: TypeAlias = Variation_165_Arg
class RuleVariation_159(RuleVariationContextFree):
    cv_variation = Variation_165

    @classmethod
    def create(cls, arg : RuleVariation_159_Arg) -> "RuleVariation_159":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_165:
        return self.arg # type: ignore

NonSpare_0_Arg: TypeAlias = RuleVariation_159_Arg
class NonSpare_0(NonSpare):
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule = RuleVariation_159

    @classmethod
    def create(cls, arg : NonSpare_0_Arg) -> "NonSpare_0":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_0(UapItem):
    cv_non_spare = NonSpare_0

Content_14_Arg: TypeAlias = int
class Content_14(ContentTable):
    cv_values = {0: "Accepted, the request is accepted and is under processing", 1: "Rejected, the request has not been accepted", 2: "Cancelled, the request has been cancelled", 3: "Finished, the request has been accepted and successfully processed", 4: "Delayed, the request processing is temporarily delayed but the request is still valid", 5: "In Progress, the request is being successfully processed", 6: "In Progress, the request is being successfully processed"}

RuleContent_14_Arg: TypeAlias = Content_14_Arg
class RuleContent_14(RuleContentContextFree):
    cv_content = Content_14

    @property
    def content(self) -> Content_14:
        return self._get_content() # type: ignore

Variation_132_Arg: TypeAlias = RuleContent_14_Arg
class Variation_132(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_14

    @classmethod
    def create(cls, arg : Variation_132_Arg) -> "Variation_132":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_14:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_14:
        return self.rule.content

RuleVariation_132_Arg: TypeAlias = Variation_132_Arg
class RuleVariation_132(RuleVariationContextFree):
    cv_variation = Variation_132

    @classmethod
    def create(cls, arg : RuleVariation_132_Arg) -> "RuleVariation_132":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_132:
        return self.arg # type: ignore

NonSpare_703_Arg: TypeAlias = RuleVariation_132_Arg
class NonSpare_703(NonSpare):
    cv_name = "CAUSE"
    cv_title = "Cause"
    cv_rule = RuleVariation_132

    @classmethod
    def create(cls, arg : NonSpare_703_Arg) -> "NonSpare_703":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_132:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_132:
        return self.rule.variation

Item_138_Arg: TypeAlias = NonSpare_703_Arg
class Item_138(Item):
    cv_non_spare = NonSpare_703

    @classmethod
    def create(cls, arg : Item_138_Arg) -> "Item_138":
        return cls._create(arg) # type: ignore

Content_349_Arg: TypeAlias = int
class Content_349(ContentTable):
    cv_values = {0: "No diagnostic available", 1: "Aircraft Exit", 2: "Incorrect aircraft address", 3: "Impossibility to process the message", 4: "Insufficient or change in data link capability", 5: "Invalid LV field", 6: "Duplicate request number", 7: "Unknown request number", 8: "Timer T3 expiry", 9: "Expiry of I/R delivery timer", 10: "Uplink flow disabled by UC"}

RuleContent_349_Arg: TypeAlias = Content_349_Arg
class RuleContent_349(RuleContentContextFree):
    cv_content = Content_349

    @property
    def content(self) -> Content_349:
        return self._get_content() # type: ignore

Variation_798_Arg: TypeAlias = RuleContent_349_Arg
class Variation_798(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 4
    cv_rule = RuleContent_349

    @classmethod
    def create(cls, arg : Variation_798_Arg) -> "Variation_798":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_349:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_349:
        return self.rule.content

RuleVariation_768_Arg: TypeAlias = Variation_798_Arg
class RuleVariation_768(RuleVariationContextFree):
    cv_variation = Variation_798

    @classmethod
    def create(cls, arg : RuleVariation_768_Arg) -> "RuleVariation_768":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_798:
        return self.arg # type: ignore

NonSpare_876_Arg: TypeAlias = RuleVariation_768_Arg
class NonSpare_876(NonSpare):
    cv_name = "DIAG"
    cv_title = "Diagnostic"
    cv_rule = RuleVariation_768

    @classmethod
    def create(cls, arg : NonSpare_876_Arg) -> "NonSpare_876":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_768:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_798:
        return self.rule.variation

Item_259_Arg: TypeAlias = NonSpare_876_Arg
class Item_259(Item):
    cv_non_spare = NonSpare_876

    @classmethod
    def create(cls, arg : Item_259_Arg) -> "Item_259":
        return cls._create(arg) # type: ignore

Variation_1061_Arg_Group = Tuple[Union[RuleVariation_132_Arg, Tuple[Literal["CAUSE"], RuleVariation_132_Arg]], Union[RuleVariation_768_Arg, Tuple[Literal["DIAG"], RuleVariation_768_Arg]]]
Variation_1061_Arg: TypeAlias = Union[int, Variation_1061_Arg_Group]
class Variation_1061(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_138, 4), (Item_259, 4)]
    cv_items_dict = {"CAUSE": RuleVariation_132, "DIAG": RuleVariation_768}

    @overload
    @classmethod
    def spec(cls, key : Literal["CAUSE"]) -> RuleVariation_132:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DIAG"]) -> RuleVariation_768:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CAUSE"], Literal["DIAG"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CAUSE"]) -> RuleVariation_132:
        ...
    @overload
    def get_item(self, key : Literal["DIAG"]) -> RuleVariation_768:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1061_Arg) -> 'Variation_1061':
        return cls._create(arg) # type: ignore

RuleVariation_1024_Arg: TypeAlias = Variation_1061_Arg
class RuleVariation_1024(RuleVariationContextFree):
    cv_variation = Variation_1061

    @classmethod
    def create(cls, arg : RuleVariation_1024_Arg) -> "RuleVariation_1024":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1061:
        return self.arg # type: ignore

NonSpare_19_Arg: TypeAlias = RuleVariation_1024_Arg
class NonSpare_19(NonSpare):
    cv_name = "001"
    cv_title = "Result"
    cv_rule = RuleVariation_1024

    @classmethod
    def create(cls, arg : NonSpare_19_Arg) -> "NonSpare_19":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1024:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1061:
        return self.rule.variation

class UapItem_19(UapItem):
    cv_non_spare = NonSpare_19

NonSpare_22_Arg: TypeAlias = RuleVariation_340_Arg
class NonSpare_22(NonSpare):
    cv_name = "005"
    cv_title = "Mode S Address"
    cv_rule = RuleVariation_340

    @classmethod
    def create(cls, arg : NonSpare_22_Arg) -> "NonSpare_22":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_340:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_347:
        return self.rule.variation

class UapItem_22(UapItem):
    cv_non_spare = NonSpare_22

Variation_373_Arg: TypeAlias = RuleContent_610_Arg
class Variation_373(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_373_Arg) -> "Variation_373":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_366_Arg: TypeAlias = Variation_373_Arg
class RuleVariation_366(RuleVariationContextFree):
    cv_variation = Variation_373

    @classmethod
    def create(cls, arg : RuleVariation_366_Arg) -> "RuleVariation_366":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_373:
        return self.arg # type: ignore

NonSpare_70_Arg: TypeAlias = RuleVariation_366_Arg
class NonSpare_70(NonSpare):
    cv_name = "016"
    cv_title = "Packet Number"
    cv_rule = RuleVariation_366

    @classmethod
    def create(cls, arg : NonSpare_70_Arg) -> "NonSpare_70":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_366:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_373:
        return self.rule.variation

class UapItem_70(UapItem):
    cv_non_spare = NonSpare_70

Variation_1394_Arg: TypeAlias = List[Variation_373_Arg]
class Variation_1394(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_373

    @classmethod
    def create(cls, arg : Variation_1394_Arg) -> 'Variation_1394':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_373]:
        return self._get_list() # type: ignore

RuleVariation_1317_Arg: TypeAlias = Variation_1394_Arg
class RuleVariation_1317(RuleVariationContextFree):
    cv_variation = Variation_1394

    @classmethod
    def create(cls, arg : RuleVariation_1317_Arg) -> "RuleVariation_1317":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1394:
        return self.arg # type: ignore

NonSpare_72_Arg: TypeAlias = RuleVariation_1317_Arg
class NonSpare_72(NonSpare):
    cv_name = "017"
    cv_title = "Packet Number List"
    cv_rule = RuleVariation_1317

    @classmethod
    def create(cls, arg : NonSpare_72_Arg) -> "NonSpare_72":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1317:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1394:
        return self.rule.variation

class UapItem_72(UapItem):
    cv_non_spare = NonSpare_72

Variation_489_Arg: TypeAlias = RuleContent_610_Arg
class Variation_489(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 5
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_489_Arg) -> "Variation_489":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_478_Arg: TypeAlias = Variation_489_Arg
class RuleVariation_478(RuleVariationContextFree):
    cv_variation = Variation_489

    @classmethod
    def create(cls, arg : RuleVariation_478_Arg) -> "RuleVariation_478":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_489:
        return self.arg # type: ignore

NonSpare_1446_Arg: TypeAlias = RuleVariation_478_Arg
class NonSpare_1446(NonSpare):
    cv_name = "PR"
    cv_title = "Mode S Packet Internal Priority"
    cv_rule = RuleVariation_478

    @classmethod
    def create(cls, arg : NonSpare_1446_Arg) -> "NonSpare_1446":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_478:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_489:
        return self.rule.variation

Item_695_Arg: TypeAlias = NonSpare_1446_Arg
class Item_695(Item):
    cv_non_spare = NonSpare_1446

    @classmethod
    def create(cls, arg : Item_695_Arg) -> "Item_695":
        return cls._create(arg) # type: ignore

Content_451_Arg: TypeAlias = int
class Content_451(ContentTable):
    cv_values = {0: "SVC packets", 1: "MSP packets", 2: "Route packets"}

RuleContent_451_Arg: TypeAlias = Content_451_Arg
class RuleContent_451(RuleContentContextFree):
    cv_content = Content_451

    @property
    def content(self) -> Content_451:
        return self._get_content() # type: ignore

Variation_961_Arg: TypeAlias = RuleContent_451_Arg
class Variation_961(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 2
    cv_rule = RuleContent_451

    @classmethod
    def create(cls, arg : Variation_961_Arg) -> "Variation_961":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_451:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_451:
        return self.rule.content

RuleVariation_931_Arg: TypeAlias = Variation_961_Arg
class RuleVariation_931(RuleVariationContextFree):
    cv_variation = Variation_961

    @classmethod
    def create(cls, arg : RuleVariation_931_Arg) -> "RuleVariation_931":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_961:
        return self.arg # type: ignore

NonSpare_1471_Arg: TypeAlias = RuleVariation_931_Arg
class NonSpare_1471(NonSpare):
    cv_name = "PT"
    cv_title = "Packet Type"
    cv_rule = RuleVariation_931

    @classmethod
    def create(cls, arg : NonSpare_1471_Arg) -> "NonSpare_1471":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_931:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_961:
        return self.rule.variation

Item_713_Arg: TypeAlias = NonSpare_1471_Arg
class Item_713(Item):
    cv_non_spare = NonSpare_1471

    @classmethod
    def create(cls, arg : Item_713_Arg) -> "Item_713":
        return cls._create(arg) # type: ignore

Variation_994_Arg_Group = Tuple[int, Union[RuleVariation_478_Arg, Tuple[Literal["PR"], RuleVariation_478_Arg]], Union[RuleVariation_931_Arg, Tuple[Literal["PT"], RuleVariation_931_Arg]]]
Variation_994_Arg: TypeAlias = Union[int, Variation_994_Arg_Group]
class Variation_994(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_0, 1), (Item_695, 5), (Item_713, 2)]
    cv_items_dict = {"PR": RuleVariation_478, "PT": RuleVariation_931}

    @overload
    @classmethod
    def spec(cls, key : Literal["PR"]) -> RuleVariation_478:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PT"]) -> RuleVariation_931:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PR"], Literal["PT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PR"]) -> RuleVariation_478:
        ...
    @overload
    def get_item(self, key : Literal["PT"]) -> RuleVariation_931:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_994_Arg) -> 'Variation_994':
        return cls._create(arg) # type: ignore

RuleVariation_964_Arg: TypeAlias = Variation_994_Arg
class RuleVariation_964(RuleVariationContextFree):
    cv_variation = Variation_994

    @classmethod
    def create(cls, arg : RuleVariation_964_Arg) -> "RuleVariation_964":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_994:
        return self.arg # type: ignore

NonSpare_74_Arg: TypeAlias = RuleVariation_964_Arg
class NonSpare_74(NonSpare):
    cv_name = "018"
    cv_title = "Mode S Packet Properties"
    cv_rule = RuleVariation_964

    @classmethod
    def create(cls, arg : NonSpare_74_Arg) -> "NonSpare_74":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_964:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_994:
        return self.rule.variation

class UapItem_74(UapItem):
    cv_non_spare = NonSpare_74

Variation_1453_Arg: TypeAlias = bytes
class Variation_1453(Explicit):
    cv_explicit_type = None

    @classmethod
    def create(cls, arg : Variation_1453_Arg) -> 'Variation_1453':
        return cls._create(arg) # type: ignore

RuleVariation_1376_Arg: TypeAlias = Variation_1453_Arg
class RuleVariation_1376(RuleVariationContextFree):
    cv_variation = Variation_1453

    @classmethod
    def create(cls, arg : RuleVariation_1376_Arg) -> "RuleVariation_1376":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1453:
        return self.arg # type: ignore

NonSpare_75_Arg: TypeAlias = RuleVariation_1376_Arg
class NonSpare_75(NonSpare):
    cv_name = "019"
    cv_title = "Mode S Packet"
    cv_rule = RuleVariation_1376

    @classmethod
    def create(cls, arg : NonSpare_75_Arg) -> "NonSpare_75":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1376:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1453:
        return self.rule.variation

class UapItem_75(UapItem):
    cv_non_spare = NonSpare_75

Content_721_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
class Content_721(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

RuleContent_721_Arg: TypeAlias = Content_721_Arg
class RuleContent_721(RuleContentContextFree):
    cv_content = Content_721

    @property
    def content(self) -> Content_721:
        return self._get_content() # type: ignore

Variation_306_Arg: TypeAlias = RuleContent_721_Arg
class Variation_306(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_721

    @classmethod
    def create(cls, arg : Variation_306_Arg) -> "Variation_306":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_721:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_721:
        return self.rule.content

RuleVariation_299_Arg: TypeAlias = Variation_306_Arg
class RuleVariation_299(RuleVariationContextFree):
    cv_variation = Variation_306

    @classmethod
    def create(cls, arg : RuleVariation_299_Arg) -> "RuleVariation_299":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_306:
        return self.arg # type: ignore

NonSpare_101_Arg: TypeAlias = RuleVariation_299_Arg
class NonSpare_101(NonSpare):
    cv_name = "028"
    cv_title = "GICB Extraction Periodicity"
    cv_rule = RuleVariation_299

    @classmethod
    def create(cls, arg : NonSpare_101_Arg) -> "NonSpare_101":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_299:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_306:
        return self.rule.variation

class UapItem_101(UapItem):
    cv_non_spare = NonSpare_101

Variation_146_Arg: TypeAlias = RuleContent_610_Arg
class Variation_146(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 5
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_146_Arg) -> "Variation_146":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_146_Arg: TypeAlias = Variation_146_Arg
class RuleVariation_146(RuleVariationContextFree):
    cv_variation = Variation_146

    @classmethod
    def create(cls, arg : RuleVariation_146_Arg) -> "RuleVariation_146":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_146:
        return self.arg # type: ignore

NonSpare_1456_Arg: TypeAlias = RuleVariation_146_Arg
class NonSpare_1456(NonSpare):
    cv_name = "PRIORITY"
    cv_title = "GICB Priority"
    cv_rule = RuleVariation_146

    @classmethod
    def create(cls, arg : NonSpare_1456_Arg) -> "NonSpare_1456":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_146:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_146:
        return self.rule.variation

Item_705_Arg: TypeAlias = NonSpare_1456_Arg
class Item_705(Item):
    cv_non_spare = NonSpare_1456

    @classmethod
    def create(cls, arg : Item_705_Arg) -> "Item_705":
        return cls._create(arg) # type: ignore

Item_25_Arg: TypeAlias = int
class Item_25(Spare):
    cv_bit_offset8 = 5
    cv_bit_size = 3

Content_506_Arg: TypeAlias = int
class Content_506(ContentTable):
    cv_values = {0: "The periodicity may not be strictly respected", 1: "The periodicity shall be strictly respected"}

RuleContent_506_Arg: TypeAlias = Content_506_Arg
class RuleContent_506(RuleContentContextFree):
    cv_content = Content_506

    @property
    def content(self) -> Content_506:
        return self._get_content() # type: ignore

Variation_88_Arg: TypeAlias = RuleContent_506_Arg
class Variation_88(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_506

    @classmethod
    def create(cls, arg : Variation_88_Arg) -> "Variation_88":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_506:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_506:
        return self.rule.content

RuleVariation_88_Arg: TypeAlias = Variation_88_Arg
class RuleVariation_88(RuleVariationContextFree):
    cv_variation = Variation_88

    @classmethod
    def create(cls, arg : RuleVariation_88_Arg) -> "RuleVariation_88":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_88:
        return self.arg # type: ignore

NonSpare_1413_Arg: TypeAlias = RuleVariation_88_Arg
class NonSpare_1413(NonSpare):
    cv_name = "PC"
    cv_title = "Periodicity Constraint"
    cv_rule = RuleVariation_88

    @classmethod
    def create(cls, arg : NonSpare_1413_Arg) -> "NonSpare_1413":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_88:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_88:
        return self.rule.variation

Item_675_Arg: TypeAlias = NonSpare_1413_Arg
class Item_675(Item):
    cv_non_spare = NonSpare_1413

    @classmethod
    def create(cls, arg : Item_675_Arg) -> "Item_675":
        return cls._create(arg) # type: ignore

Content_219_Arg: TypeAlias = int
class Content_219(ContentTable):
    cv_values = {0: "GICB extractions should be sent only when required by the periodicity", 1: "If a GICB extraction is done due to external conditions, an update will also be sent, even if it does not match the expected periodicity"}

RuleContent_219_Arg: TypeAlias = Content_219_Arg
class RuleContent_219(RuleContentContextFree):
    cv_content = Content_219

    @property
    def content(self) -> Content_219:
        return self._get_content() # type: ignore

Variation_426_Arg: TypeAlias = RuleContent_219_Arg
class Variation_426(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_219

    @classmethod
    def create(cls, arg : Variation_426_Arg) -> "Variation_426":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_219:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_219:
        return self.rule.content

RuleVariation_415_Arg: TypeAlias = Variation_426_Arg
class RuleVariation_415(RuleVariationContextFree):
    cv_variation = Variation_426

    @classmethod
    def create(cls, arg : RuleVariation_415_Arg) -> "RuleVariation_415":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_426:
        return self.arg # type: ignore

NonSpare_641_Arg: TypeAlias = RuleVariation_415_Arg
class NonSpare_641(NonSpare):
    cv_name = "AU"
    cv_title = "Asynchronous Update"
    cv_rule = RuleVariation_415

    @classmethod
    def create(cls, arg : NonSpare_641_Arg) -> "NonSpare_641":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_415:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_426:
        return self.rule.variation

Item_91_Arg: TypeAlias = NonSpare_641_Arg
class Item_91(Item):
    cv_non_spare = NonSpare_641

    @classmethod
    def create(cls, arg : Item_91_Arg) -> "Item_91":
        return cls._create(arg) # type: ignore

Content_487_Arg: TypeAlias = int
class Content_487(ContentTable):
    cv_values = {0: "The GICB extraction is attempted according to the periodicity", 1: "There will no GICB attempts"}

RuleContent_487_Arg: TypeAlias = Content_487_Arg
class RuleContent_487(RuleContentContextFree):
    cv_content = Content_487

    @property
    def content(self) -> Content_487:
        return self._get_content() # type: ignore

Variation_575_Arg: TypeAlias = RuleContent_487_Arg
class Variation_575(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_487

    @classmethod
    def create(cls, arg : Variation_575_Arg) -> "Variation_575":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_487:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_487:
        return self.rule.content

RuleVariation_564_Arg: TypeAlias = Variation_575_Arg
class RuleVariation_564(RuleVariationContextFree):
    cv_variation = Variation_575

    @classmethod
    def create(cls, arg : RuleVariation_564_Arg) -> "RuleVariation_564":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_575:
        return self.arg # type: ignore

NonSpare_1349_Arg: TypeAlias = RuleVariation_564_Arg
class NonSpare_1349(NonSpare):
    cv_name = "NE"
    cv_title = "Non Extraction"
    cv_rule = RuleVariation_564

    @classmethod
    def create(cls, arg : NonSpare_1349_Arg) -> "NonSpare_1349":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_564:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_575:
        return self.rule.variation

Item_615_Arg: TypeAlias = NonSpare_1349_Arg
class Item_615(Item):
    cv_non_spare = NonSpare_1349

    @classmethod
    def create(cls, arg : Item_615_Arg) -> "Item_615":
        return cls._create(arg) # type: ignore

Content_490_Arg: TypeAlias = int
class Content_490(ContentTable):
    cv_values = {0: "The extracted GICB must be sent only on the Data Link line", 1: "The extracted GICB must be sent only on the Surveillance line", 2: "The extracted GICB must be sent both on the Data Link and on the Surveillance lines"}

RuleContent_490_Arg: TypeAlias = Content_490_Arg
class RuleContent_490(RuleContentContextFree):
    cv_content = Content_490

    @property
    def content(self) -> Content_490:
        return self._get_content() # type: ignore

Variation_678_Arg: TypeAlias = RuleContent_490_Arg
class Variation_678(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_rule = RuleContent_490

    @classmethod
    def create(cls, arg : Variation_678_Arg) -> "Variation_678":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_490:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_490:
        return self.rule.content

RuleVariation_667_Arg: TypeAlias = Variation_678_Arg
class RuleVariation_667(RuleVariationContextFree):
    cv_variation = Variation_678

    @classmethod
    def create(cls, arg : RuleVariation_667_Arg) -> "RuleVariation_667":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_678:
        return self.arg # type: ignore

NonSpare_1548_Arg: TypeAlias = RuleVariation_667_Arg
class NonSpare_1548(NonSpare):
    cv_name = "RD"
    cv_title = "Reply Destination"
    cv_rule = RuleVariation_667

    @classmethod
    def create(cls, arg : NonSpare_1548_Arg) -> "NonSpare_1548":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_667:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_678:
        return self.rule.variation

Item_782_Arg: TypeAlias = NonSpare_1548_Arg
class Item_782(Item):
    cv_non_spare = NonSpare_1548

    @classmethod
    def create(cls, arg : Item_782_Arg) -> "Item_782":
        return cls._create(arg) # type: ignore

Variation_1158_Arg_Group = Tuple[Union[RuleVariation_146_Arg, Tuple[Literal["PRIORITY"], RuleVariation_146_Arg]], int, Union[RuleVariation_88_Arg, Tuple[Literal["PC"], RuleVariation_88_Arg]], Union[RuleVariation_415_Arg, Tuple[Literal["AU"], RuleVariation_415_Arg]], Union[RuleVariation_564_Arg, Tuple[Literal["NE"], RuleVariation_564_Arg]], Union[RuleVariation_667_Arg, Tuple[Literal["RD"], RuleVariation_667_Arg]], int]
Variation_1158_Arg: TypeAlias = Union[int, Variation_1158_Arg_Group]
class Variation_1158(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_705, 5), (Item_25, 3), (Item_675, 1), (Item_91, 1), (Item_615, 1), (Item_782, 2), (Item_25, 3)]
    cv_items_dict = {"PRIORITY": RuleVariation_146, "PC": RuleVariation_88, "AU": RuleVariation_415, "NE": RuleVariation_564, "RD": RuleVariation_667}

    @overload
    @classmethod
    def spec(cls, key : Literal["PRIORITY"]) -> RuleVariation_146:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PC"]) -> RuleVariation_88:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AU"]) -> RuleVariation_415:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NE"]) -> RuleVariation_564:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RD"]) -> RuleVariation_667:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PRIORITY"], Literal["PC"], Literal["AU"], Literal["NE"], Literal["RD"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PRIORITY"]) -> RuleVariation_146:
        ...
    @overload
    def get_item(self, key : Literal["PC"]) -> RuleVariation_88:
        ...
    @overload
    def get_item(self, key : Literal["AU"]) -> RuleVariation_415:
        ...
    @overload
    def get_item(self, key : Literal["NE"]) -> RuleVariation_564:
        ...
    @overload
    def get_item(self, key : Literal["RD"]) -> RuleVariation_667:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1158_Arg) -> 'Variation_1158':
        return cls._create(arg) # type: ignore

RuleVariation_1110_Arg: TypeAlias = Variation_1158_Arg
class RuleVariation_1110(RuleVariationContextFree):
    cv_variation = Variation_1158

    @classmethod
    def create(cls, arg : RuleVariation_1110_Arg) -> "RuleVariation_1110":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1158:
        return self.arg # type: ignore

NonSpare_103_Arg: TypeAlias = RuleVariation_1110_Arg
class NonSpare_103(NonSpare):
    cv_name = "030"
    cv_title = "GICB Properties"
    cv_rule = RuleVariation_1110

    @classmethod
    def create(cls, arg : NonSpare_103_Arg) -> "NonSpare_103":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1110:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1158:
        return self.rule.variation

class UapItem_103(UapItem):
    cv_non_spare = NonSpare_103

NonSpare_99_Arg: TypeAlias = RuleVariation_366_Arg
class NonSpare_99(NonSpare):
    cv_name = "025"
    cv_title = "GICB Number"
    cv_rule = RuleVariation_366

    @classmethod
    def create(cls, arg : NonSpare_99_Arg) -> "NonSpare_99":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_366:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_373:
        return self.rule.variation

class UapItem_99(UapItem):
    cv_non_spare = NonSpare_99

NonSpare_100_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_100(NonSpare):
    cv_name = "027"
    cv_title = "BDS Code"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_100_Arg) -> "NonSpare_100":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_100(UapItem):
    cv_non_spare = NonSpare_100

Content_796_Arg: TypeAlias = int
class Content_796(ContentBds):
    cv_bds_type = (BdsAt, None)

RuleContent_795_Arg: TypeAlias = Content_796_Arg
class RuleContent_795(RuleContentContextFree):
    cv_content = Content_796

    @property
    def content(self) -> Content_796:
        return self._get_content() # type: ignore

Variation_392_Arg: TypeAlias = RuleContent_795_Arg
class Variation_392(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_rule = RuleContent_795

    @classmethod
    def create(cls, arg : Variation_392_Arg) -> "Variation_392":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_795:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_796:
        return self.rule.content

RuleVariation_384_Arg: TypeAlias = Variation_392_Arg
class RuleVariation_384(RuleVariationContextFree):
    cv_variation = Variation_392

    @classmethod
    def create(cls, arg : RuleVariation_384_Arg) -> "RuleVariation_384":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_392:
        return self.arg # type: ignore

NonSpare_102_Arg: TypeAlias = RuleVariation_384_Arg
class NonSpare_102(NonSpare):
    cv_name = "029"
    cv_title = "GICB Extracted"
    cv_rule = RuleVariation_384

    @classmethod
    def create(cls, arg : NonSpare_102_Arg) -> "NonSpare_102":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_384:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_392:
        return self.rule.variation

class UapItem_102(UapItem):
    cv_non_spare = NonSpare_102

NonSpare_20_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_20(NonSpare):
    cv_name = "002"
    cv_title = "Time of Day"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_20_Arg) -> "NonSpare_20":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_20(UapItem):
    cv_non_spare = NonSpare_20

NonSpare_23_Arg: TypeAlias = RuleVariation_1313_Arg
class NonSpare_23(NonSpare):
    cv_name = "006"
    cv_title = "Mode S Address List"
    cv_rule = RuleVariation_1313

    @classmethod
    def create(cls, arg : NonSpare_23_Arg) -> "NonSpare_23":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1313:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1390:
        return self.rule.variation

class UapItem_23(UapItem):
    cv_non_spare = NonSpare_23

Content_528_Arg: TypeAlias = int
class Content_528(ContentTable):
    cv_values = {0: "UC shall be ignored", 1: "UC shall be taken into account"}

RuleContent_528_Arg: TypeAlias = Content_528_Arg
class RuleContent_528(RuleContentContextFree):
    cv_content = Content_528

    @property
    def content(self) -> Content_528:
        return self._get_content() # type: ignore

Variation_93_Arg: TypeAlias = RuleContent_528_Arg
class Variation_93(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_528

    @classmethod
    def create(cls, arg : Variation_93_Arg) -> "Variation_93":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_528:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_528:
        return self.rule.content

RuleVariation_93_Arg: TypeAlias = Variation_93_Arg
class RuleVariation_93(RuleVariationContextFree):
    cv_variation = Variation_93

    @classmethod
    def create(cls, arg : RuleVariation_93_Arg) -> "RuleVariation_93":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_93:
        return self.arg # type: ignore

NonSpare_1978_Arg: TypeAlias = RuleVariation_93_Arg
class NonSpare_1978(NonSpare):
    cv_name = "UM"
    cv_title = "Uplink Mask"
    cv_rule = RuleVariation_93

    @classmethod
    def create(cls, arg : NonSpare_1978_Arg) -> "NonSpare_1978":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_93:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_93:
        return self.rule.variation

Item_1096_Arg: TypeAlias = NonSpare_1978_Arg
class Item_1096(Item):
    cv_non_spare = NonSpare_1978

    @classmethod
    def create(cls, arg : Item_1096_Arg) -> "Item_1096":
        return cls._create(arg) # type: ignore

Content_71_Arg: TypeAlias = int
class Content_71(ContentTable):
    cv_values = {0: "DC shall be ignored", 1: "DC shall be taken into account"}

RuleContent_71_Arg: TypeAlias = Content_71_Arg
class RuleContent_71(RuleContentContextFree):
    cv_content = Content_71

    @property
    def content(self) -> Content_71:
        return self._get_content() # type: ignore

Variation_403_Arg: TypeAlias = RuleContent_71_Arg
class Variation_403(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_71

    @classmethod
    def create(cls, arg : Variation_403_Arg) -> "Variation_403":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_71:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_71:
        return self.rule.content

RuleVariation_392_Arg: TypeAlias = Variation_403_Arg
class RuleVariation_392(RuleVariationContextFree):
    cv_variation = Variation_403

    @classmethod
    def create(cls, arg : RuleVariation_392_Arg) -> "RuleVariation_392":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_403:
        return self.arg # type: ignore

NonSpare_881_Arg: TypeAlias = RuleVariation_392_Arg
class NonSpare_881(NonSpare):
    cv_name = "DM"
    cv_title = "Downlink Mask"
    cv_rule = RuleVariation_392

    @classmethod
    def create(cls, arg : NonSpare_881_Arg) -> "NonSpare_881":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_392:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_403:
        return self.rule.variation

Item_263_Arg: TypeAlias = NonSpare_881_Arg
class Item_263(Item):
    cv_non_spare = NonSpare_881

    @classmethod
    def create(cls, arg : Item_263_Arg) -> "Item_263":
        return cls._create(arg) # type: ignore

Content_571_Arg: TypeAlias = int
class Content_571(ContentTable):
    cv_values = {0: "the uplink flow shall be enabled", 1: "the uplink flow shall be stopped"}

RuleContent_571_Arg: TypeAlias = Content_571_Arg
class RuleContent_571(RuleContentContextFree):
    cv_content = Content_571

    @property
    def content(self) -> Content_571:
        return self._get_content() # type: ignore

Variation_583_Arg: TypeAlias = RuleContent_571_Arg
class Variation_583(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_571

    @classmethod
    def create(cls, arg : Variation_583_Arg) -> "Variation_583":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_571:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_571:
        return self.rule.content

RuleVariation_572_Arg: TypeAlias = Variation_583_Arg
class RuleVariation_572(RuleVariationContextFree):
    cv_variation = Variation_583

    @classmethod
    def create(cls, arg : RuleVariation_572_Arg) -> "RuleVariation_572":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_583:
        return self.arg # type: ignore

NonSpare_1973_Arg: TypeAlias = RuleVariation_572_Arg
class NonSpare_1973(NonSpare):
    cv_name = "UC"
    cv_title = "Uplink Command"
    cv_rule = RuleVariation_572

    @classmethod
    def create(cls, arg : NonSpare_1973_Arg) -> "NonSpare_1973":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_572:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_583:
        return self.rule.variation

Item_1091_Arg: TypeAlias = NonSpare_1973_Arg
class Item_1091(Item):
    cv_non_spare = NonSpare_1973

    @classmethod
    def create(cls, arg : Item_1091_Arg) -> "Item_1091":
        return cls._create(arg) # type: ignore

Content_570_Arg: TypeAlias = int
class Content_570(ContentTable):
    cv_values = {0: "the downlink flow shall be enabled", 1: "the downlink flow shall be stopped"}

RuleContent_570_Arg: TypeAlias = Content_570_Arg
class RuleContent_570(RuleContentContextFree):
    cv_content = Content_570

    @property
    def content(self) -> Content_570:
        return self._get_content() # type: ignore

Variation_672_Arg: TypeAlias = RuleContent_570_Arg
class Variation_672(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_570

    @classmethod
    def create(cls, arg : Variation_672_Arg) -> "Variation_672":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_570:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_570:
        return self.rule.content

RuleVariation_661_Arg: TypeAlias = Variation_672_Arg
class RuleVariation_661(RuleVariationContextFree):
    cv_variation = Variation_672

    @classmethod
    def create(cls, arg : RuleVariation_661_Arg) -> "RuleVariation_661":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_672:
        return self.arg # type: ignore

NonSpare_866_Arg: TypeAlias = RuleVariation_661_Arg
class NonSpare_866(NonSpare):
    cv_name = "DC"
    cv_title = "Downlink Command"
    cv_rule = RuleVariation_661

    @classmethod
    def create(cls, arg : NonSpare_866_Arg) -> "NonSpare_866":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_661:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_672:
        return self.rule.variation

Item_250_Arg: TypeAlias = NonSpare_866_Arg
class Item_250(Item):
    cv_non_spare = NonSpare_866

    @classmethod
    def create(cls, arg : Item_250_Arg) -> "Item_250":
        return cls._create(arg) # type: ignore

Variation_1242_Arg_Group = Tuple[Union[RuleVariation_93_Arg, Tuple[Literal["UM"], RuleVariation_93_Arg]], Union[RuleVariation_392_Arg, Tuple[Literal["DM"], RuleVariation_392_Arg]], Union[RuleVariation_572_Arg, Tuple[Literal["UC"], RuleVariation_572_Arg]], Union[RuleVariation_661_Arg, Tuple[Literal["DC"], RuleVariation_661_Arg]], int]
Variation_1242_Arg: TypeAlias = Union[int, Variation_1242_Arg_Group]
class Variation_1242(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1096, 1), (Item_263, 1), (Item_1091, 1), (Item_250, 1), (Item_22, 4)]
    cv_items_dict = {"UM": RuleVariation_93, "DM": RuleVariation_392, "UC": RuleVariation_572, "DC": RuleVariation_661}

    @overload
    @classmethod
    def spec(cls, key : Literal["UM"]) -> RuleVariation_93:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DM"]) -> RuleVariation_392:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["UC"]) -> RuleVariation_572:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DC"]) -> RuleVariation_661:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["UM"], Literal["DM"], Literal["UC"], Literal["DC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["UM"]) -> RuleVariation_93:
        ...
    @overload
    def get_item(self, key : Literal["DM"]) -> RuleVariation_392:
        ...
    @overload
    def get_item(self, key : Literal["UC"]) -> RuleVariation_572:
        ...
    @overload
    def get_item(self, key : Literal["DC"]) -> RuleVariation_661:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1242_Arg) -> 'Variation_1242':
        return cls._create(arg) # type: ignore

RuleVariation_1172_Arg: TypeAlias = Variation_1242_Arg
class RuleVariation_1172(RuleVariationContextFree):
    cv_variation = Variation_1242

    @classmethod
    def create(cls, arg : RuleVariation_1172_Arg) -> "RuleVariation_1172":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1242:
        return self.arg # type: ignore

NonSpare_24_Arg: TypeAlias = RuleVariation_1172_Arg
class NonSpare_24(NonSpare):
    cv_name = "007"
    cv_title = "Aircraft Data Link Command"
    cv_rule = RuleVariation_1172

    @classmethod
    def create(cls, arg : NonSpare_24_Arg) -> "NonSpare_24":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1172:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1242:
        return self.rule.variation

class UapItem_24(UapItem):
    cv_non_spare = NonSpare_24

Content_492_Arg: TypeAlias = int
class Content_492(ContentTable):
    cv_values = {0: "The interrogator is enabled to uplink frames", 1: "The interrogator is disabled to uplink frames"}

RuleContent_492_Arg: TypeAlias = Content_492_Arg
class RuleContent_492(RuleContentContextFree):
    cv_content = Content_492

    @property
    def content(self) -> Content_492:
        return self._get_content() # type: ignore

Variation_84_Arg: TypeAlias = RuleContent_492_Arg
class Variation_84(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_492

    @classmethod
    def create(cls, arg : Variation_84_Arg) -> "Variation_84":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_492:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_492:
        return self.rule.content

RuleVariation_84_Arg: TypeAlias = Variation_84_Arg
class RuleVariation_84(RuleVariationContextFree):
    cv_variation = Variation_84

    @classmethod
    def create(cls, arg : RuleVariation_84_Arg) -> "RuleVariation_84":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_84:
        return self.arg # type: ignore

Content_491_Arg: TypeAlias = int
class Content_491(ContentTable):
    cv_values = {0: "The interrogator is enabled to extract frames", 1: "The interrogator is disabled to extract frames"}

RuleContent_491_Arg: TypeAlias = Content_491_Arg
class RuleContent_491(RuleContentContextFree):
    cv_content = Content_491

    @property
    def content(self) -> Content_491:
        return self._get_content() # type: ignore

Variation_454_Arg: TypeAlias = RuleContent_491_Arg
class Variation_454(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_491

    @classmethod
    def create(cls, arg : Variation_454_Arg) -> "Variation_454":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_491:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_491:
        return self.rule.content

RuleVariation_443_Arg: TypeAlias = Variation_454_Arg
class RuleVariation_443(RuleVariationContextFree):
    cv_variation = Variation_454

    @classmethod
    def create(cls, arg : RuleVariation_443_Arg) -> "RuleVariation_443":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_454:
        return self.arg # type: ignore

Variation_576_Arg: TypeAlias = RuleContent_492_Arg
class Variation_576(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_492

    @classmethod
    def create(cls, arg : Variation_576_Arg) -> "Variation_576":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_492:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_492:
        return self.rule.content

RuleVariation_565_Arg: TypeAlias = Variation_576_Arg
class RuleVariation_565(RuleVariationContextFree):
    cv_variation = Variation_576

    @classmethod
    def create(cls, arg : RuleVariation_565_Arg) -> "RuleVariation_565":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_576:
        return self.arg # type: ignore

Variation_660_Arg: TypeAlias = RuleContent_491_Arg
class Variation_660(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_491

    @classmethod
    def create(cls, arg : Variation_660_Arg) -> "Variation_660":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_491:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_491:
        return self.rule.content

RuleVariation_649_Arg: TypeAlias = Variation_660_Arg
class RuleVariation_649(RuleVariationContextFree):
    cv_variation = Variation_660

    @classmethod
    def create(cls, arg : RuleVariation_649_Arg) -> "RuleVariation_649":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_660:
        return self.arg # type: ignore

Content_489_Arg: TypeAlias = int
class Content_489(ContentTable):
    cv_values = {0: "The aircraft is in the Datalink coverage map of the interrogator", 1: "The aircraft is not in the Datalink coverage map of the interrogator"}

RuleContent_489_Arg: TypeAlias = Content_489_Arg
class RuleContent_489(RuleContentContextFree):
    cv_content = Content_489

    @property
    def content(self) -> Content_489:
        return self._get_content() # type: ignore

Variation_952_Arg: TypeAlias = RuleContent_489_Arg
class Variation_952(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_489

    @classmethod
    def create(cls, arg : Variation_952_Arg) -> "Variation_952":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_489:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_489:
        return self.rule.content

RuleVariation_922_Arg: TypeAlias = Variation_952_Arg
class RuleVariation_922(RuleVariationContextFree):
    cv_variation = Variation_952

    @classmethod
    def create(cls, arg : RuleVariation_922_Arg) -> "RuleVariation_922":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_952:
        return self.arg # type: ignore

Content_493_Arg: TypeAlias = int
class Content_493(ContentTable):
    cv_values = {0: "The interrogators current ability to uplink/downlink frames (UCS/DCS) and the content of the Aircraft_report could be changed using D_Data_link_command", 1: "The interrogators current ability to uplink/downlink frames (UCS/DCS) and the content of the Aircraft_report cannot be changed using D_Data_link_command"}

RuleContent_493_Arg: TypeAlias = Content_493_Arg
class RuleContent_493(RuleContentContextFree):
    cv_content = Content_493

    @property
    def content(self) -> Content_493:
        return self._get_content() # type: ignore

Variation_85_Arg: TypeAlias = RuleContent_493_Arg
class Variation_85(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_493

    @classmethod
    def create(cls, arg : Variation_85_Arg) -> "Variation_85":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_493:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_493:
        return self.rule.content

RuleVariation_85_Arg: TypeAlias = Variation_85_Arg
class RuleVariation_85(RuleVariationContextFree):
    cv_variation = Variation_85

    @classmethod
    def create(cls, arg : RuleVariation_85_Arg) -> "RuleVariation_85":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_85:
        return self.arg # type: ignore

NonSpare_1977_Arg: TypeAlias = RuleVariation_84_Arg
class NonSpare_1977(NonSpare):
    cv_name = "UDS"
    cv_title = "Uplink Default Status"
    cv_rule = RuleVariation_84

    @classmethod
    def create(cls, arg : NonSpare_1977_Arg) -> "NonSpare_1977":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_84:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_84:
        return self.rule.variation

Item_1095_Arg: TypeAlias = NonSpare_1977_Arg
class Item_1095(Item):
    cv_non_spare = NonSpare_1977

    @classmethod
    def create(cls, arg : Item_1095_Arg) -> "Item_1095":
        return cls._create(arg) # type: ignore

NonSpare_870_Arg: TypeAlias = RuleVariation_443_Arg
class NonSpare_870(NonSpare):
    cv_name = "DDS"
    cv_title = "Downlink Default Status"
    cv_rule = RuleVariation_443

    @classmethod
    def create(cls, arg : NonSpare_870_Arg) -> "NonSpare_870":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_443:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_454:
        return self.rule.variation

Item_254_Arg: TypeAlias = NonSpare_870_Arg
class Item_254(Item):
    cv_non_spare = NonSpare_870

    @classmethod
    def create(cls, arg : Item_254_Arg) -> "Item_254":
        return cls._create(arg) # type: ignore

NonSpare_1976_Arg: TypeAlias = RuleVariation_565_Arg
class NonSpare_1976(NonSpare):
    cv_name = "UCS"
    cv_title = "Uplink Current Status"
    cv_rule = RuleVariation_565

    @classmethod
    def create(cls, arg : NonSpare_1976_Arg) -> "NonSpare_1976":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_565:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_576:
        return self.rule.variation

Item_1094_Arg: TypeAlias = NonSpare_1976_Arg
class Item_1094(Item):
    cv_non_spare = NonSpare_1976

    @classmethod
    def create(cls, arg : Item_1094_Arg) -> "Item_1094":
        return cls._create(arg) # type: ignore

NonSpare_869_Arg: TypeAlias = RuleVariation_649_Arg
class NonSpare_869(NonSpare):
    cv_name = "DCS"
    cv_title = "Downlink Current Status"
    cv_rule = RuleVariation_649

    @classmethod
    def create(cls, arg : NonSpare_869_Arg) -> "NonSpare_869":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_649:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_660:
        return self.rule.variation

Item_253_Arg: TypeAlias = NonSpare_869_Arg
class Item_253(Item):
    cv_non_spare = NonSpare_869

    @classmethod
    def create(cls, arg : Item_253_Arg) -> "Item_253":
        return cls._create(arg) # type: ignore

NonSpare_912_Arg: TypeAlias = RuleVariation_922_Arg
class NonSpare_912(NonSpare):
    cv_name = "EI"
    cv_title = "Exit Indication"
    cv_rule = RuleVariation_922

    @classmethod
    def create(cls, arg : NonSpare_912_Arg) -> "NonSpare_912":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_922:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_952:
        return self.rule.variation

Item_286_Arg: TypeAlias = NonSpare_912_Arg
class Item_286(Item):
    cv_non_spare = NonSpare_912

    @classmethod
    def create(cls, arg : Item_286_Arg) -> "Item_286":
        return cls._create(arg) # type: ignore

NonSpare_1098_Arg: TypeAlias = RuleVariation_85_Arg
class NonSpare_1098(NonSpare):
    cv_name = "IC"
    cv_title = "Interrogator Control"
    cv_rule = RuleVariation_85

    @classmethod
    def create(cls, arg : NonSpare_1098_Arg) -> "NonSpare_1098":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_85:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_85:
        return self.rule.variation

Item_422_Arg: TypeAlias = NonSpare_1098_Arg
class Item_422(Item):
    cv_non_spare = NonSpare_1098

    @classmethod
    def create(cls, arg : Item_422_Arg) -> "Item_422":
        return cls._create(arg) # type: ignore

Variation_1385_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_84_Arg, Tuple[Literal["UDS"], RuleVariation_84_Arg]], Union[RuleVariation_443_Arg, Tuple[Literal["DDS"], RuleVariation_443_Arg]], Union[RuleVariation_565_Arg, Tuple[Literal["UCS"], RuleVariation_565_Arg]], Union[RuleVariation_649_Arg, Tuple[Literal["DCS"], RuleVariation_649_Arg]], int, Union[RuleVariation_922_Arg, Tuple[Literal["EI"], RuleVariation_922_Arg]], None]]
Variation_1385_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_85_Arg, Tuple[Literal["IC"], RuleVariation_85_Arg]], int, None]]
Variation_1385_Arg: TypeAlias = Union[
    Tuple[Variation_1385_Arg_Group_1],
    Tuple[Variation_1385_Arg_Group_1, Variation_1385_Arg_Group_2],
]
class Variation_1385(Extended):
    cv_items_list = [[(Item_1095, 1), (Item_254, 1), (Item_1094, 1), (Item_253, 1), (Item_20, 2), (Item_286, 1), None], [(Item_422, 1), (Item_9, 6), None]]

    @classmethod
    def create(cls, arg : Variation_1385_Arg) -> 'Variation_1385':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["UDS"]) -> RuleVariation_84:
        ...
    @overload
    def get_item(self, key : Literal["DDS"]) -> RuleVariation_443:
        ...
    @overload
    def get_item(self, key : Literal["UCS"]) -> RuleVariation_565:
        ...
    @overload
    def get_item(self, key : Literal["DCS"]) -> RuleVariation_649:
        ...
    @overload
    def get_item(self, key : Literal["EI"]) -> RuleVariation_922:
        ...
    @overload
    def get_item(self, key : Literal["IC"]) -> Optional[RuleVariation_85]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1308_Arg: TypeAlias = Variation_1385_Arg
class RuleVariation_1308(RuleVariationContextFree):
    cv_variation = Variation_1385

    @classmethod
    def create(cls, arg : RuleVariation_1308_Arg) -> "RuleVariation_1308":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1385:
        return self.arg # type: ignore

NonSpare_25_Arg: TypeAlias = RuleVariation_1308_Arg
class NonSpare_25(NonSpare):
    cv_name = "008"
    cv_title = "Aircraft Data Link Status"
    cv_rule = RuleVariation_1308

    @classmethod
    def create(cls, arg : NonSpare_25_Arg) -> "NonSpare_25":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1308:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1385:
        return self.rule.variation

class UapItem_25(UapItem):
    cv_non_spare = NonSpare_25

Content_499_Arg: TypeAlias = int
class Content_499(ContentTable):
    cv_values = {0: "The next Aircraft_report may not include D_Data_link_status", 1: "The next Aircraft_report shall include D_Data_link_status"}

RuleContent_499_Arg: TypeAlias = Content_499_Arg
class RuleContent_499(RuleContentContextFree):
    cv_content = Content_499

    @property
    def content(self) -> Content_499:
        return self._get_content() # type: ignore

Variation_87_Arg: TypeAlias = RuleContent_499_Arg
class Variation_87(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_499

    @classmethod
    def create(cls, arg : Variation_87_Arg) -> "Variation_87":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_499:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_499:
        return self.rule.content

RuleVariation_87_Arg: TypeAlias = Variation_87_Arg
class RuleVariation_87(RuleVariationContextFree):
    cv_variation = Variation_87

    @classmethod
    def create(cls, arg : RuleVariation_87_Arg) -> "RuleVariation_87":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_87:
        return self.arg # type: ignore

Content_495_Arg: TypeAlias = int
class Content_495(ContentTable):
    cv_values = {0: "The next Aircraft_report may not include D_COM", 1: "The next Aircraft_report shall include D_COM"}

RuleContent_495_Arg: TypeAlias = Content_495_Arg
class RuleContent_495(RuleContentContextFree):
    cv_content = Content_495

    @property
    def content(self) -> Content_495:
        return self._get_content() # type: ignore

Variation_455_Arg: TypeAlias = RuleContent_495_Arg
class Variation_455(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_495

    @classmethod
    def create(cls, arg : Variation_455_Arg) -> "Variation_455":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_495:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_495:
        return self.rule.content

RuleVariation_444_Arg: TypeAlias = Variation_455_Arg
class RuleVariation_444(RuleVariationContextFree):
    cv_variation = Variation_455

    @classmethod
    def create(cls, arg : RuleVariation_444_Arg) -> "RuleVariation_444":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_455:
        return self.arg # type: ignore

Content_500_Arg: TypeAlias = int
class Content_500(ContentTable):
    cv_values = {0: "The next Aircraft_report may not include D_ECA", 1: "The next Aircraft_report shall include D_ECA"}

RuleContent_500_Arg: TypeAlias = Content_500_Arg
class RuleContent_500(RuleContentContextFree):
    cv_content = Content_500

    @property
    def content(self) -> Content_500:
        return self._get_content() # type: ignore

Variation_577_Arg: TypeAlias = RuleContent_500_Arg
class Variation_577(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_500

    @classmethod
    def create(cls, arg : Variation_577_Arg) -> "Variation_577":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_500:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_500:
        return self.rule.content

RuleVariation_566_Arg: TypeAlias = Variation_577_Arg
class RuleVariation_566(RuleVariationContextFree):
    cv_variation = Variation_577

    @classmethod
    def create(cls, arg : RuleVariation_566_Arg) -> "RuleVariation_566":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_577:
        return self.arg # type: ignore

Content_496_Arg: TypeAlias = int
class Content_496(ContentTable):
    cv_values = {0: "The next Aircraft_report may not include D_CQF", 1: "The next Aircraft_report shall include D_CQF"}

RuleContent_496_Arg: TypeAlias = Content_496_Arg
class RuleContent_496(RuleContentContextFree):
    cv_content = Content_496

    @property
    def content(self) -> Content_496:
        return self._get_content() # type: ignore

Variation_661_Arg: TypeAlias = RuleContent_496_Arg
class Variation_661(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_496

    @classmethod
    def create(cls, arg : Variation_661_Arg) -> "Variation_661":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_496:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_496:
        return self.rule.content

RuleVariation_650_Arg: TypeAlias = Variation_661_Arg
class RuleVariation_650(RuleVariationContextFree):
    cv_variation = Variation_661

    @classmethod
    def create(cls, arg : RuleVariation_650_Arg) -> "RuleVariation_650":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_661:
        return self.arg # type: ignore

Content_497_Arg: TypeAlias = int
class Content_497(ContentTable):
    cv_values = {0: "The next Aircraft_report may not include D_CQF_method", 1: "The next Aircraft_report shall include D_CQF_method"}

RuleContent_497_Arg: TypeAlias = Content_497_Arg
class RuleContent_497(RuleContentContextFree):
    cv_content = Content_497

    @property
    def content(self) -> Content_497:
        return self._get_content() # type: ignore

Variation_753_Arg: TypeAlias = RuleContent_497_Arg
class Variation_753(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_497

    @classmethod
    def create(cls, arg : Variation_753_Arg) -> "Variation_753":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_497:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_497:
        return self.rule.content

RuleVariation_742_Arg: TypeAlias = Variation_753_Arg
class RuleVariation_742(RuleVariationContextFree):
    cv_variation = Variation_753

    @classmethod
    def create(cls, arg : RuleVariation_742_Arg) -> "RuleVariation_742":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_753:
        return self.arg # type: ignore

Content_501_Arg: TypeAlias = int
class Content_501(ContentTable):
    cv_values = {0: "The next Aircraft_report may not include D_Polar_position", 1: "The next Aircraft_report shall include D_Polar_position"}

RuleContent_501_Arg: TypeAlias = Content_501_Arg
class RuleContent_501(RuleContentContextFree):
    cv_content = Content_501

    @property
    def content(self) -> Content_501:
        return self._get_content() # type: ignore

Variation_870_Arg: TypeAlias = RuleContent_501_Arg
class Variation_870(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_501

    @classmethod
    def create(cls, arg : Variation_870_Arg) -> "Variation_870":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_501:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_501:
        return self.rule.content

RuleVariation_840_Arg: TypeAlias = Variation_870_Arg
class RuleVariation_840(RuleVariationContextFree):
    cv_variation = Variation_870

    @classmethod
    def create(cls, arg : RuleVariation_840_Arg) -> "RuleVariation_840":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_870:
        return self.arg # type: ignore

Content_498_Arg: TypeAlias = int
class Content_498(ContentTable):
    cv_values = {0: "The next Aircraft_report may not include D_Cartesian_position", 1: "The next Aircraft_report shall include D_Cartesian_position"}

RuleContent_498_Arg: TypeAlias = Content_498_Arg
class RuleContent_498(RuleContentContextFree):
    cv_content = Content_498

    @property
    def content(self) -> Content_498:
        return self._get_content() # type: ignore

Variation_953_Arg: TypeAlias = RuleContent_498_Arg
class Variation_953(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_498

    @classmethod
    def create(cls, arg : Variation_953_Arg) -> "Variation_953":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_498:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_498:
        return self.rule.content

RuleVariation_923_Arg: TypeAlias = Variation_953_Arg
class RuleVariation_923(RuleVariationContextFree):
    cv_variation = Variation_953

    @classmethod
    def create(cls, arg : RuleVariation_923_Arg) -> "RuleVariation_923":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_953:
        return self.arg # type: ignore

Content_494_Arg: TypeAlias = int
class Content_494(ContentTable):
    cv_values = {0: "The next Aircraft_report may not include Aircraft_ID", 1: "The next Aircraft_report shall include Aircraft_ID"}

RuleContent_494_Arg: TypeAlias = Content_494_Arg
class RuleContent_494(RuleContentContextFree):
    cv_content = Content_494

    @property
    def content(self) -> Content_494:
        return self._get_content() # type: ignore

Variation_86_Arg: TypeAlias = RuleContent_494_Arg
class Variation_86(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_494

    @classmethod
    def create(cls, arg : Variation_86_Arg) -> "Variation_86":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_494:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_494:
        return self.rule.content

RuleVariation_86_Arg: TypeAlias = Variation_86_Arg
class RuleVariation_86(RuleVariationContextFree):
    cv_variation = Variation_86

    @classmethod
    def create(cls, arg : RuleVariation_86_Arg) -> "RuleVariation_86":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_86:
        return self.arg # type: ignore

Content_504_Arg: TypeAlias = int
class Content_504(ContentTable):
    cv_values = {0: "The next Aircraft_report may not include Mode_A", 1: "The next Aircraft_report shall include Mode_A"}

RuleContent_504_Arg: TypeAlias = Content_504_Arg
class RuleContent_504(RuleContentContextFree):
    cv_content = Content_504

    @property
    def content(self) -> Content_504:
        return self._get_content() # type: ignore

Variation_456_Arg: TypeAlias = RuleContent_504_Arg
class Variation_456(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_504

    @classmethod
    def create(cls, arg : Variation_456_Arg) -> "Variation_456":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_504:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_504:
        return self.rule.content

RuleVariation_445_Arg: TypeAlias = Variation_456_Arg
class RuleVariation_445(RuleVariationContextFree):
    cv_variation = Variation_456

    @classmethod
    def create(cls, arg : RuleVariation_445_Arg) -> "RuleVariation_445":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_456:
        return self.arg # type: ignore

Content_505_Arg: TypeAlias = int
class Content_505(ContentTable):
    cv_values = {0: "The next Aircraft_report may not include Speed", 1: "The next Aircraft_report shall include Speed"}

RuleContent_505_Arg: TypeAlias = Content_505_Arg
class RuleContent_505(RuleContentContextFree):
    cv_content = Content_505

    @property
    def content(self) -> Content_505:
        return self._get_content() # type: ignore

Variation_578_Arg: TypeAlias = RuleContent_505_Arg
class Variation_578(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_505

    @classmethod
    def create(cls, arg : Variation_578_Arg) -> "Variation_578":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_505:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_505:
        return self.rule.content

RuleVariation_567_Arg: TypeAlias = Variation_578_Arg
class RuleVariation_567(RuleVariationContextFree):
    cv_variation = Variation_578

    @classmethod
    def create(cls, arg : RuleVariation_567_Arg) -> "RuleVariation_567":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_578:
        return self.arg # type: ignore

Content_503_Arg: TypeAlias = int
class Content_503(ContentTable):
    cv_values = {0: "The next Aircraft_report may not include Height", 1: "The next Aircraft_report shall include Height"}

RuleContent_503_Arg: TypeAlias = Content_503_Arg
class RuleContent_503(RuleContentContextFree):
    cv_content = Content_503

    @property
    def content(self) -> Content_503:
        return self._get_content() # type: ignore

Variation_662_Arg: TypeAlias = RuleContent_503_Arg
class Variation_662(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_503

    @classmethod
    def create(cls, arg : Variation_662_Arg) -> "Variation_662":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_503:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_503:
        return self.rule.content

RuleVariation_651_Arg: TypeAlias = Variation_662_Arg
class RuleVariation_651(RuleVariationContextFree):
    cv_variation = Variation_662

    @classmethod
    def create(cls, arg : RuleVariation_651_Arg) -> "RuleVariation_651":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_662:
        return self.arg # type: ignore

Content_502_Arg: TypeAlias = int
class Content_502(ContentTable):
    cv_values = {0: "The next Aircraft_report may not include Heading", 1: "The next Aircraft_report shall include Heading"}

RuleContent_502_Arg: TypeAlias = Content_502_Arg
class RuleContent_502(RuleContentContextFree):
    cv_content = Content_502

    @property
    def content(self) -> Content_502:
        return self._get_content() # type: ignore

Variation_754_Arg: TypeAlias = RuleContent_502_Arg
class Variation_754(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_502

    @classmethod
    def create(cls, arg : Variation_754_Arg) -> "Variation_754":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_502:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_502:
        return self.rule.content

RuleVariation_743_Arg: TypeAlias = Variation_754_Arg
class RuleVariation_743(RuleVariationContextFree):
    cv_variation = Variation_754

    @classmethod
    def create(cls, arg : RuleVariation_743_Arg) -> "RuleVariation_743":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_754:
        return self.arg # type: ignore

NonSpare_1736_Arg: TypeAlias = RuleVariation_87_Arg
class NonSpare_1736(NonSpare):
    cv_name = "SR"
    cv_title = ""
    cv_rule = RuleVariation_87

    @classmethod
    def create(cls, arg : NonSpare_1736_Arg) -> "NonSpare_1736":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_87:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_87:
        return self.rule.variation

Item_915_Arg: TypeAlias = NonSpare_1736_Arg
class Item_915(Item):
    cv_non_spare = NonSpare_1736

    @classmethod
    def create(cls, arg : Item_915_Arg) -> "Item_915":
        return cls._create(arg) # type: ignore

NonSpare_617_Arg: TypeAlias = RuleVariation_444_Arg
class NonSpare_617(NonSpare):
    cv_name = "AR"
    cv_title = ""
    cv_rule = RuleVariation_444

    @classmethod
    def create(cls, arg : NonSpare_617_Arg) -> "NonSpare_617":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_444:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_455:
        return self.rule.variation

Item_79_Arg: TypeAlias = NonSpare_617_Arg
class Item_79(Item):
    cv_non_spare = NonSpare_617

    @classmethod
    def create(cls, arg : Item_79_Arg) -> "Item_79":
        return cls._create(arg) # type: ignore

NonSpare_947_Arg: TypeAlias = RuleVariation_566_Arg
class NonSpare_947(NonSpare):
    cv_name = "ER"
    cv_title = ""
    cv_rule = RuleVariation_566

    @classmethod
    def create(cls, arg : NonSpare_947_Arg) -> "NonSpare_947":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_566:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_577:
        return self.rule.variation

Item_314_Arg: TypeAlias = NonSpare_947_Arg
class Item_314(Item):
    cv_non_spare = NonSpare_947

    @classmethod
    def create(cls, arg : Item_314_Arg) -> "Item_314":
        return cls._create(arg) # type: ignore

NonSpare_983_Arg: TypeAlias = RuleVariation_650_Arg
class NonSpare_983(NonSpare):
    cv_name = "FR"
    cv_title = ""
    cv_rule = RuleVariation_650

    @classmethod
    def create(cls, arg : NonSpare_983_Arg) -> "NonSpare_983":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_650:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_661:
        return self.rule.variation

Item_338_Arg: TypeAlias = NonSpare_983_Arg
class Item_338(Item):
    cv_non_spare = NonSpare_983

    @classmethod
    def create(cls, arg : Item_338_Arg) -> "Item_338":
        return cls._create(arg) # type: ignore

NonSpare_1305_Arg: TypeAlias = RuleVariation_742_Arg
class NonSpare_1305(NonSpare):
    cv_name = "MR"
    cv_title = ""
    cv_rule = RuleVariation_742

    @classmethod
    def create(cls, arg : NonSpare_1305_Arg) -> "NonSpare_1305":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_742:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_753:
        return self.rule.variation

Item_577_Arg: TypeAlias = NonSpare_1305_Arg
class Item_577(Item):
    cv_non_spare = NonSpare_1305

    @classmethod
    def create(cls, arg : Item_577_Arg) -> "Item_577":
        return cls._create(arg) # type: ignore

NonSpare_1445_Arg: TypeAlias = RuleVariation_840_Arg
class NonSpare_1445(NonSpare):
    cv_name = "PR"
    cv_title = ""
    cv_rule = RuleVariation_840

    @classmethod
    def create(cls, arg : NonSpare_1445_Arg) -> "NonSpare_1445":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_840:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_870:
        return self.rule.variation

Item_694_Arg: TypeAlias = NonSpare_1445_Arg
class Item_694(Item):
    cv_non_spare = NonSpare_1445

    @classmethod
    def create(cls, arg : Item_694_Arg) -> "Item_694":
        return cls._create(arg) # type: ignore

NonSpare_819_Arg: TypeAlias = RuleVariation_923_Arg
class NonSpare_819(NonSpare):
    cv_name = "CR"
    cv_title = ""
    cv_rule = RuleVariation_923

    @classmethod
    def create(cls, arg : NonSpare_819_Arg) -> "NonSpare_819":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_923:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_953:
        return self.rule.variation

Item_211_Arg: TypeAlias = NonSpare_819_Arg
class Item_211(Item):
    cv_non_spare = NonSpare_819

    @classmethod
    def create(cls, arg : Item_211_Arg) -> "Item_211":
        return cls._create(arg) # type: ignore

NonSpare_1100_Arg: TypeAlias = RuleVariation_86_Arg
class NonSpare_1100(NonSpare):
    cv_name = "ID"
    cv_title = ""
    cv_rule = RuleVariation_86

    @classmethod
    def create(cls, arg : NonSpare_1100_Arg) -> "NonSpare_1100":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_86:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_86:
        return self.rule.variation

Item_424_Arg: TypeAlias = NonSpare_1100_Arg
class Item_424(Item):
    cv_non_spare = NonSpare_1100

    @classmethod
    def create(cls, arg : Item_424_Arg) -> "Item_424":
        return cls._create(arg) # type: ignore

NonSpare_1211_Arg: TypeAlias = RuleVariation_445_Arg
class NonSpare_1211(NonSpare):
    cv_name = "MA"
    cv_title = ""
    cv_rule = RuleVariation_445

    @classmethod
    def create(cls, arg : NonSpare_1211_Arg) -> "NonSpare_1211":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_445:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_456:
        return self.rule.variation

Item_519_Arg: TypeAlias = NonSpare_1211_Arg
class Item_519(Item):
    cv_non_spare = NonSpare_1211

    @classmethod
    def create(cls, arg : Item_519_Arg) -> "Item_519":
        return cls._create(arg) # type: ignore

NonSpare_1722_Arg: TypeAlias = RuleVariation_567_Arg
class NonSpare_1722(NonSpare):
    cv_name = "SP"
    cv_title = ""
    cv_rule = RuleVariation_567

    @classmethod
    def create(cls, arg : NonSpare_1722_Arg) -> "NonSpare_1722":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_567:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_578:
        return self.rule.variation

Item_902_Arg: TypeAlias = NonSpare_1722_Arg
class Item_902(Item):
    cv_non_spare = NonSpare_1722

    @classmethod
    def create(cls, arg : Item_902_Arg) -> "Item_902":
        return cls._create(arg) # type: ignore

NonSpare_1058_Arg: TypeAlias = RuleVariation_651_Arg
class NonSpare_1058(NonSpare):
    cv_name = "HG"
    cv_title = ""
    cv_rule = RuleVariation_651

    @classmethod
    def create(cls, arg : NonSpare_1058_Arg) -> "NonSpare_1058":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_651:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_662:
        return self.rule.variation

Item_390_Arg: TypeAlias = NonSpare_1058_Arg
class Item_390(Item):
    cv_non_spare = NonSpare_1058

    @classmethod
    def create(cls, arg : Item_390_Arg) -> "Item_390":
        return cls._create(arg) # type: ignore

NonSpare_1052_Arg: TypeAlias = RuleVariation_743_Arg
class NonSpare_1052(NonSpare):
    cv_name = "HD"
    cv_title = ""
    cv_rule = RuleVariation_743

    @classmethod
    def create(cls, arg : NonSpare_1052_Arg) -> "NonSpare_1052":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_743:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_754:
        return self.rule.variation

Item_386_Arg: TypeAlias = NonSpare_1052_Arg
class Item_386(Item):
    cv_non_spare = NonSpare_1052

    @classmethod
    def create(cls, arg : Item_386_Arg) -> "Item_386":
        return cls._create(arg) # type: ignore

Variation_1375_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_87_Arg, Tuple[Literal["SR"], RuleVariation_87_Arg]], Union[RuleVariation_444_Arg, Tuple[Literal["AR"], RuleVariation_444_Arg]], Union[RuleVariation_566_Arg, Tuple[Literal["ER"], RuleVariation_566_Arg]], Union[RuleVariation_650_Arg, Tuple[Literal["FR"], RuleVariation_650_Arg]], Union[RuleVariation_742_Arg, Tuple[Literal["MR"], RuleVariation_742_Arg]], Union[RuleVariation_840_Arg, Tuple[Literal["PR"], RuleVariation_840_Arg]], Union[RuleVariation_923_Arg, Tuple[Literal["CR"], RuleVariation_923_Arg]], None]]
Variation_1375_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_86_Arg, Tuple[Literal["ID"], RuleVariation_86_Arg]], Union[RuleVariation_445_Arg, Tuple[Literal["MA"], RuleVariation_445_Arg]], Union[RuleVariation_567_Arg, Tuple[Literal["SP"], RuleVariation_567_Arg]], Union[RuleVariation_651_Arg, Tuple[Literal["HG"], RuleVariation_651_Arg]], Union[RuleVariation_743_Arg, Tuple[Literal["HD"], RuleVariation_743_Arg]], int, None]]
Variation_1375_Arg: TypeAlias = Union[
    Tuple[Variation_1375_Arg_Group_1],
    Tuple[Variation_1375_Arg_Group_1, Variation_1375_Arg_Group_2],
]
class Variation_1375(Extended):
    cv_items_list = [[(Item_915, 1), (Item_79, 1), (Item_314, 1), (Item_338, 1), (Item_577, 1), (Item_694, 1), (Item_211, 1), None], [(Item_424, 1), (Item_519, 1), (Item_902, 1), (Item_390, 1), (Item_386, 1), (Item_24, 2), None]]

    @classmethod
    def create(cls, arg : Variation_1375_Arg) -> 'Variation_1375':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["SR"]) -> RuleVariation_87:
        ...
    @overload
    def get_item(self, key : Literal["AR"]) -> RuleVariation_444:
        ...
    @overload
    def get_item(self, key : Literal["ER"]) -> RuleVariation_566:
        ...
    @overload
    def get_item(self, key : Literal["FR"]) -> RuleVariation_650:
        ...
    @overload
    def get_item(self, key : Literal["MR"]) -> RuleVariation_742:
        ...
    @overload
    def get_item(self, key : Literal["PR"]) -> RuleVariation_840:
        ...
    @overload
    def get_item(self, key : Literal["CR"]) -> RuleVariation_923:
        ...
    @overload
    def get_item(self, key : Literal["ID"]) -> Optional[RuleVariation_86]:
        ...
    @overload
    def get_item(self, key : Literal["MA"]) -> Optional[RuleVariation_445]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[RuleVariation_567]:
        ...
    @overload
    def get_item(self, key : Literal["HG"]) -> Optional[RuleVariation_651]:
        ...
    @overload
    def get_item(self, key : Literal["HD"]) -> Optional[RuleVariation_743]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1298_Arg: TypeAlias = Variation_1375_Arg
class RuleVariation_1298(RuleVariationContextFree):
    cv_variation = Variation_1375

    @classmethod
    def create(cls, arg : RuleVariation_1298_Arg) -> "RuleVariation_1298":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1375:
        return self.arg # type: ignore

NonSpare_27_Arg: TypeAlias = RuleVariation_1298_Arg
class NonSpare_27(NonSpare):
    cv_name = "009"
    cv_title = "Aircraft Data Link Report Request"
    cv_rule = RuleVariation_1298

    @classmethod
    def create(cls, arg : NonSpare_27_Arg) -> "NonSpare_27":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1298:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1375:
        return self.rule.variation

class UapItem_27(UapItem):
    cv_non_spare = NonSpare_27

Content_335_Arg: TypeAlias = int
class Content_335(ContentTable):
    cv_values = {0: "No communications capability (surveillance only)", 1: "Comm. A and Comm. B capability", 2: "Comm. A, Comm. B and Uplink ELM", 3: "Comm. A, Comm. B and Uplink ELM and Downlink ELM", 4: "Level 5 Transponder capability"}

RuleContent_335_Arg: TypeAlias = Content_335_Arg
class RuleContent_335(RuleContentContextFree):
    cv_content = Content_335

    @property
    def content(self) -> Content_335:
        return self._get_content() # type: ignore

Variation_887_Arg: TypeAlias = RuleContent_335_Arg
class Variation_887(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 3
    cv_rule = RuleContent_335

    @classmethod
    def create(cls, arg : Variation_887_Arg) -> "Variation_887":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_335:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_335:
        return self.rule.content

RuleVariation_857_Arg: TypeAlias = Variation_887_Arg
class RuleVariation_857(RuleVariationContextFree):
    cv_variation = Variation_887

    @classmethod
    def create(cls, arg : RuleVariation_857_Arg) -> "RuleVariation_857":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_887:
        return self.arg # type: ignore

NonSpare_779_Arg: TypeAlias = RuleVariation_857_Arg
class NonSpare_779(NonSpare):
    cv_name = "COM"
    cv_title = "Communications Capability of the Transponder"
    cv_rule = RuleVariation_857

    @classmethod
    def create(cls, arg : NonSpare_779_Arg) -> "NonSpare_779":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_857:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_887:
        return self.rule.variation

Item_188_Arg: TypeAlias = NonSpare_779_Arg
class Item_188(Item):
    cv_non_spare = NonSpare_779

    @classmethod
    def create(cls, arg : Item_188_Arg) -> "Item_188":
        return cls._create(arg) # type: ignore

Variation_1034_Arg_Group = Tuple[int, Union[RuleVariation_857_Arg, Tuple[Literal["COM"], RuleVariation_857_Arg]]]
Variation_1034_Arg: TypeAlias = Union[int, Variation_1034_Arg_Group]
class Variation_1034(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_4, 5), (Item_188, 3)]
    cv_items_dict = {"COM": RuleVariation_857}

    @classmethod
    def spec(cls, key : Literal["COM"]) -> RuleVariation_857:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["COM"]) -> RuleVariation_857:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1034_Arg) -> 'Variation_1034':
        return cls._create(arg) # type: ignore

RuleVariation_1002_Arg: TypeAlias = Variation_1034_Arg
class RuleVariation_1002(RuleVariationContextFree):
    cv_variation = Variation_1034

    @classmethod
    def create(cls, arg : RuleVariation_1002_Arg) -> "RuleVariation_1002":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1034:
        return self.arg # type: ignore

NonSpare_50_Arg: TypeAlias = RuleVariation_1002_Arg
class NonSpare_50(NonSpare):
    cv_name = "010"
    cv_title = "Transponder Communications Capability"
    cv_rule = RuleVariation_1002

    @classmethod
    def create(cls, arg : NonSpare_50_Arg) -> "NonSpare_50":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1002:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1034:
        return self.rule.variation

class UapItem_50(UapItem):
    cv_non_spare = NonSpare_50

NonSpare_51_Arg: TypeAlias = RuleVariation_382_Arg
class NonSpare_51(NonSpare):
    cv_name = "011"
    cv_title = "Capability Report"
    cv_rule = RuleVariation_382

    @classmethod
    def create(cls, arg : NonSpare_51_Arg) -> "NonSpare_51":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_382:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_390:
        return self.rule.variation

class UapItem_51(UapItem):
    cv_non_spare = NonSpare_51

Content_770_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
class Content_770(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 3.90625e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

RuleContent_769_Arg: TypeAlias = Content_770_Arg
class RuleContent_769(RuleContentContextFree):
    cv_content = Content_770

    @property
    def content(self) -> Content_770:
        return self._get_content() # type: ignore

Variation_333_Arg: TypeAlias = RuleContent_769_Arg
class Variation_333(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_769

    @classmethod
    def create(cls, arg : Variation_333_Arg) -> "Variation_333":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_769:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_770:
        return self.rule.content

RuleVariation_326_Arg: TypeAlias = Variation_333_Arg
class RuleVariation_326(RuleVariationContextFree):
    cv_variation = Variation_333

    @classmethod
    def create(cls, arg : RuleVariation_326_Arg) -> "RuleVariation_326":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_333:
        return self.arg # type: ignore

NonSpare_1580_Arg: TypeAlias = RuleVariation_326_Arg
class NonSpare_1580(NonSpare):
    cv_name = "RHO"
    cv_title = ""
    cv_rule = RuleVariation_326

    @classmethod
    def create(cls, arg : NonSpare_1580_Arg) -> "NonSpare_1580":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_326:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_333:
        return self.rule.variation

Item_811_Arg: TypeAlias = NonSpare_1580_Arg
class Item_811(Item):
    cv_non_spare = NonSpare_1580

    @classmethod
    def create(cls, arg : Item_811_Arg) -> "Item_811":
        return cls._create(arg) # type: ignore

Variation_1173_Arg_Group = Tuple[Union[RuleVariation_326_Arg, Tuple[Literal["RHO"], RuleVariation_326_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["THETA"], RuleVariation_334_Arg]]]
Variation_1173_Arg: TypeAlias = Union[int, Variation_1173_Arg_Group]
class Variation_1173(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_811, 16), (Item_991, 16)]
    cv_items_dict = {"RHO": RuleVariation_326, "THETA": RuleVariation_334}

    @overload
    @classmethod
    def spec(cls, key : Literal["RHO"]) -> RuleVariation_326:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["THETA"]) -> RuleVariation_334:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RHO"], Literal["THETA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RHO"]) -> RuleVariation_326:
        ...
    @overload
    def get_item(self, key : Literal["THETA"]) -> RuleVariation_334:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1173_Arg) -> 'Variation_1173':
        return cls._create(arg) # type: ignore

RuleVariation_1125_Arg: TypeAlias = Variation_1173_Arg
class RuleVariation_1125(RuleVariationContextFree):
    cv_variation = Variation_1173

    @classmethod
    def create(cls, arg : RuleVariation_1125_Arg) -> "RuleVariation_1125":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1173:
        return self.arg # type: ignore

NonSpare_55_Arg: TypeAlias = RuleVariation_1125_Arg
class NonSpare_55(NonSpare):
    cv_name = "014"
    cv_title = "Aircraft Position in Polar Co-ordinates"
    cv_rule = RuleVariation_1125

    @classmethod
    def create(cls, arg : NonSpare_55_Arg) -> "NonSpare_55":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1125:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1173:
        return self.rule.variation

class UapItem_55(UapItem):
    cv_non_spare = NonSpare_55

Content_675_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
class Content_675(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 7.8125e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

RuleContent_675_Arg: TypeAlias = Content_675_Arg
class RuleContent_675(RuleContentContextFree):
    cv_content = Content_675

    @property
    def content(self) -> Content_675:
        return self._get_content() # type: ignore

Variation_285_Arg: TypeAlias = RuleContent_675_Arg
class Variation_285(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_675

    @classmethod
    def create(cls, arg : Variation_285_Arg) -> "Variation_285":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_675:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_675:
        return self.rule.content

RuleVariation_278_Arg: TypeAlias = Variation_285_Arg
class RuleVariation_278(RuleVariationContextFree):
    cv_variation = Variation_285

    @classmethod
    def create(cls, arg : RuleVariation_278_Arg) -> "RuleVariation_278":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_285:
        return self.arg # type: ignore

NonSpare_2090_Arg: TypeAlias = RuleVariation_278_Arg
class NonSpare_2090(NonSpare):
    cv_name = "X"
    cv_title = "X-Component"
    cv_rule = RuleVariation_278

    @classmethod
    def create(cls, arg : NonSpare_2090_Arg) -> "NonSpare_2090":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_278:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_285:
        return self.rule.variation

Item_1197_Arg: TypeAlias = NonSpare_2090_Arg
class Item_1197(Item):
    cv_non_spare = NonSpare_2090

    @classmethod
    def create(cls, arg : Item_1197_Arg) -> "Item_1197":
        return cls._create(arg) # type: ignore

NonSpare_2144_Arg: TypeAlias = RuleVariation_278_Arg
class NonSpare_2144(NonSpare):
    cv_name = "Y"
    cv_title = "Y-Component"
    cv_rule = RuleVariation_278

    @classmethod
    def create(cls, arg : NonSpare_2144_Arg) -> "NonSpare_2144":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_278:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_285:
        return self.rule.variation

Item_1248_Arg: TypeAlias = NonSpare_2144_Arg
class Item_1248(Item):
    cv_non_spare = NonSpare_2144

    @classmethod
    def create(cls, arg : Item_1248_Arg) -> "Item_1248":
        return cls._create(arg) # type: ignore

Variation_1308_Arg_Group = Tuple[Union[RuleVariation_278_Arg, Tuple[Literal["X"], RuleVariation_278_Arg]], Union[RuleVariation_278_Arg, Tuple[Literal["Y"], RuleVariation_278_Arg]]]
Variation_1308_Arg: TypeAlias = Union[int, Variation_1308_Arg_Group]
class Variation_1308(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1197, 16), (Item_1248, 16)]
    cv_items_dict = {"X": RuleVariation_278, "Y": RuleVariation_278}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_278:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_278:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_278:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_278:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1308_Arg) -> 'Variation_1308':
        return cls._create(arg) # type: ignore

RuleVariation_1236_Arg: TypeAlias = Variation_1308_Arg
class RuleVariation_1236(RuleVariationContextFree):
    cv_variation = Variation_1308

    @classmethod
    def create(cls, arg : RuleVariation_1236_Arg) -> "RuleVariation_1236":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1308:
        return self.arg # type: ignore

NonSpare_56_Arg: TypeAlias = RuleVariation_1236_Arg
class NonSpare_56(NonSpare):
    cv_name = "015"
    cv_title = "Aircraft Position in Cartesian Co-ordinates"
    cv_rule = RuleVariation_1236

    @classmethod
    def create(cls, arg : NonSpare_56_Arg) -> "NonSpare_56":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1236:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1308:
        return self.rule.variation

class UapItem_56(UapItem):
    cv_non_spare = NonSpare_56

NonSpare_77_Arg: TypeAlias = RuleVariation_366_Arg
class NonSpare_77(NonSpare):
    cv_name = "020"
    cv_title = "Broadcast Number"
    cv_rule = RuleVariation_366

    @classmethod
    def create(cls, arg : NonSpare_77_Arg) -> "NonSpare_77":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_366:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_373:
        return self.rule.variation

class UapItem_77(UapItem):
    cv_non_spare = NonSpare_77

Variation_136_Arg: TypeAlias = RuleContent_610_Arg
class Variation_136(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_136_Arg) -> "Variation_136":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_136_Arg: TypeAlias = Variation_136_Arg
class RuleVariation_136(RuleVariationContextFree):
    cv_variation = Variation_136

    @classmethod
    def create(cls, arg : RuleVariation_136_Arg) -> "RuleVariation_136":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_136:
        return self.arg # type: ignore

NonSpare_1457_Arg: TypeAlias = RuleVariation_136_Arg
class NonSpare_1457(NonSpare):
    cv_name = "PRIORITY"
    cv_title = "Priority"
    cv_rule = RuleVariation_136

    @classmethod
    def create(cls, arg : NonSpare_1457_Arg) -> "NonSpare_1457":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_136:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_136:
        return self.rule.variation

Item_706_Arg: TypeAlias = NonSpare_1457_Arg
class Item_706(Item):
    cv_non_spare = NonSpare_1457

    @classmethod
    def create(cls, arg : Item_706_Arg) -> "Item_706":
        return cls._create(arg) # type: ignore

Variation_801_Arg: TypeAlias = RuleContent_610_Arg
class Variation_801(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 4
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_801_Arg) -> "Variation_801":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_771_Arg: TypeAlias = Variation_801_Arg
class RuleVariation_771(RuleVariationContextFree):
    cv_variation = Variation_801

    @classmethod
    def create(cls, arg : RuleVariation_771_Arg) -> "RuleVariation_771":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_801:
        return self.arg # type: ignore

NonSpare_1443_Arg: TypeAlias = RuleVariation_771_Arg
class NonSpare_1443(NonSpare):
    cv_name = "POWER"
    cv_title = "Power"
    cv_rule = RuleVariation_771

    @classmethod
    def create(cls, arg : NonSpare_1443_Arg) -> "NonSpare_1443":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_771:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_801:
        return self.rule.variation

Item_692_Arg: TypeAlias = NonSpare_1443_Arg
class Item_692(Item):
    cv_non_spare = NonSpare_1443

    @classmethod
    def create(cls, arg : Item_692_Arg) -> "Item_692":
        return cls._create(arg) # type: ignore

Variation_221_Arg: TypeAlias = RuleContent_721_Arg
class Variation_221(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_721

    @classmethod
    def create(cls, arg : Variation_221_Arg) -> "Variation_221":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_721:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_721:
        return self.rule.content

RuleVariation_214_Arg: TypeAlias = Variation_221_Arg
class RuleVariation_214(RuleVariationContextFree):
    cv_variation = Variation_221

    @classmethod
    def create(cls, arg : RuleVariation_214_Arg) -> "RuleVariation_214":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_221:
        return self.arg # type: ignore

NonSpare_906_Arg: TypeAlias = RuleVariation_214_Arg
class NonSpare_906(NonSpare):
    cv_name = "DURATION"
    cv_title = "Duration"
    cv_rule = RuleVariation_214

    @classmethod
    def create(cls, arg : NonSpare_906_Arg) -> "NonSpare_906":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_214:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_221:
        return self.rule.variation

Item_282_Arg: TypeAlias = NonSpare_906_Arg
class Item_282(Item):
    cv_non_spare = NonSpare_906

    @classmethod
    def create(cls, arg : Item_282_Arg) -> "Item_282":
        return cls._create(arg) # type: ignore

Variation_371_Arg: TypeAlias = RuleContent_0_Arg
class Variation_371(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_371_Arg) -> "Variation_371":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_364_Arg: TypeAlias = Variation_371_Arg
class RuleVariation_364(RuleVariationContextFree):
    cv_variation = Variation_371

    @classmethod
    def create(cls, arg : RuleVariation_364_Arg) -> "RuleVariation_364":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_371:
        return self.arg # type: ignore

NonSpare_801_Arg: TypeAlias = RuleVariation_364_Arg
class NonSpare_801(NonSpare):
    cv_name = "COVERAGE"
    cv_title = "Coverage"
    cv_rule = RuleVariation_364

    @classmethod
    def create(cls, arg : NonSpare_801_Arg) -> "NonSpare_801":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_364:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_371:
        return self.rule.variation

Item_202_Arg: TypeAlias = NonSpare_801_Arg
class Item_202(Item):
    cv_non_spare = NonSpare_801

    @classmethod
    def create(cls, arg : Item_202_Arg) -> "Item_202":
        return cls._create(arg) # type: ignore

Variation_1159_Arg_Group = Tuple[Union[RuleVariation_136_Arg, Tuple[Literal["PRIORITY"], RuleVariation_136_Arg]], Union[RuleVariation_771_Arg, Tuple[Literal["POWER"], RuleVariation_771_Arg]], Union[RuleVariation_214_Arg, Tuple[Literal["DURATION"], RuleVariation_214_Arg]], Union[RuleVariation_364_Arg, Tuple[Literal["COVERAGE"], RuleVariation_364_Arg]]]
Variation_1159_Arg: TypeAlias = Union[int, Variation_1159_Arg_Group]
class Variation_1159(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_706, 4), (Item_692, 4), (Item_282, 8), (Item_202, 32)]
    cv_items_dict = {"PRIORITY": RuleVariation_136, "POWER": RuleVariation_771, "DURATION": RuleVariation_214, "COVERAGE": RuleVariation_364}

    @overload
    @classmethod
    def spec(cls, key : Literal["PRIORITY"]) -> RuleVariation_136:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POWER"]) -> RuleVariation_771:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DURATION"]) -> RuleVariation_214:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVERAGE"]) -> RuleVariation_364:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PRIORITY"], Literal["POWER"], Literal["DURATION"], Literal["COVERAGE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PRIORITY"]) -> RuleVariation_136:
        ...
    @overload
    def get_item(self, key : Literal["POWER"]) -> RuleVariation_771:
        ...
    @overload
    def get_item(self, key : Literal["DURATION"]) -> RuleVariation_214:
        ...
    @overload
    def get_item(self, key : Literal["COVERAGE"]) -> RuleVariation_364:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1159_Arg) -> 'Variation_1159':
        return cls._create(arg) # type: ignore

RuleVariation_1111_Arg: TypeAlias = Variation_1159_Arg
class RuleVariation_1111(RuleVariationContextFree):
    cv_variation = Variation_1159

    @classmethod
    def create(cls, arg : RuleVariation_1111_Arg) -> "RuleVariation_1111":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1159:
        return self.arg # type: ignore

NonSpare_96_Arg: TypeAlias = RuleVariation_1111_Arg
class NonSpare_96(NonSpare):
    cv_name = "021"
    cv_title = "Broadcast Properties"
    cv_rule = RuleVariation_1111

    @classmethod
    def create(cls, arg : NonSpare_96_Arg) -> "NonSpare_96":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1111:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1159:
        return self.rule.variation

class UapItem_96(UapItem):
    cv_non_spare = NonSpare_96

NonSpare_1452_Arg: TypeAlias = RuleVariation_863_Arg
class NonSpare_1452(NonSpare):
    cv_name = "PREFIX"
    cv_title = "Prefix Field"
    cv_rule = RuleVariation_863

    @classmethod
    def create(cls, arg : NonSpare_1452_Arg) -> "NonSpare_1452":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_863:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_893:
        return self.rule.variation

Item_701_Arg: TypeAlias = NonSpare_1452_Arg
class Item_701(Item):
    cv_non_spare = NonSpare_1452

    @classmethod
    def create(cls, arg : Item_701_Arg) -> "Item_701":
        return cls._create(arg) # type: ignore

Variation_1036_Arg_Group = Tuple[int, Union[RuleVariation_863_Arg, Tuple[Literal["PREFIX"], RuleVariation_863_Arg]]]
Variation_1036_Arg: TypeAlias = Union[int, Variation_1036_Arg_Group]
class Variation_1036(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_4, 5), (Item_701, 27)]
    cv_items_dict = {"PREFIX": RuleVariation_863}

    @classmethod
    def spec(cls, key : Literal["PREFIX"]) -> RuleVariation_863:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["PREFIX"]) -> RuleVariation_863:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1036_Arg) -> 'Variation_1036':
        return cls._create(arg) # type: ignore

RuleVariation_1004_Arg: TypeAlias = Variation_1036_Arg
class RuleVariation_1004(RuleVariationContextFree):
    cv_variation = Variation_1036

    @classmethod
    def create(cls, arg : RuleVariation_1004_Arg) -> "RuleVariation_1004":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1036:
        return self.arg # type: ignore

NonSpare_97_Arg: TypeAlias = RuleVariation_1004_Arg
class NonSpare_97(NonSpare):
    cv_name = "022"
    cv_title = "Broadcast Prefix"
    cv_rule = RuleVariation_1004

    @classmethod
    def create(cls, arg : NonSpare_97_Arg) -> "NonSpare_97":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1004:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1036:
        return self.rule.variation

class UapItem_97(UapItem):
    cv_non_spare = NonSpare_97

NonSpare_98_Arg: TypeAlias = RuleVariation_382_Arg
class NonSpare_98(NonSpare):
    cv_name = "023"
    cv_title = "Uplink or Downlink Broadcast"
    cv_rule = RuleVariation_382

    @classmethod
    def create(cls, arg : NonSpare_98_Arg) -> "NonSpare_98":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_382:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_390:
        return self.rule.variation

class UapItem_98(UapItem):
    cv_non_spare = NonSpare_98

NonSpare_1453_Arg: TypeAlias = RuleVariation_131_Arg
class NonSpare_1453(NonSpare):
    cv_name = "PREVIOUSII"
    cv_title = "Former II Code"
    cv_rule = RuleVariation_131

    @classmethod
    def create(cls, arg : NonSpare_1453_Arg) -> "NonSpare_1453":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_131:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_131:
        return self.rule.variation

Item_702_Arg: TypeAlias = NonSpare_1453_Arg
class Item_702(Item):
    cv_non_spare = NonSpare_1453

    @classmethod
    def create(cls, arg : Item_702_Arg) -> "Item_702":
        return cls._create(arg) # type: ignore

NonSpare_842_Arg: TypeAlias = RuleVariation_766_Arg
class NonSpare_842(NonSpare):
    cv_name = "CURRENTII"
    cv_title = "Current II Code"
    cv_rule = RuleVariation_766

    @classmethod
    def create(cls, arg : NonSpare_842_Arg) -> "NonSpare_842":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_766:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_796:
        return self.rule.variation

Item_229_Arg: TypeAlias = NonSpare_842_Arg
class Item_229(Item):
    cv_non_spare = NonSpare_842

    @classmethod
    def create(cls, arg : Item_229_Arg) -> "Item_229":
        return cls._create(arg) # type: ignore

Variation_1156_Arg_Group = Tuple[Union[RuleVariation_131_Arg, Tuple[Literal["PREVIOUSII"], RuleVariation_131_Arg]], Union[RuleVariation_766_Arg, Tuple[Literal["CURRENTII"], RuleVariation_766_Arg]]]
Variation_1156_Arg: TypeAlias = Union[int, Variation_1156_Arg_Group]
class Variation_1156(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_702, 4), (Item_229, 4)]
    cv_items_dict = {"PREVIOUSII": RuleVariation_131, "CURRENTII": RuleVariation_766}

    @overload
    @classmethod
    def spec(cls, key : Literal["PREVIOUSII"]) -> RuleVariation_131:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CURRENTII"]) -> RuleVariation_766:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PREVIOUSII"], Literal["CURRENTII"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PREVIOUSII"]) -> RuleVariation_131:
        ...
    @overload
    def get_item(self, key : Literal["CURRENTII"]) -> RuleVariation_766:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1156_Arg) -> 'Variation_1156':
        return cls._create(arg) # type: ignore

RuleVariation_1108_Arg: TypeAlias = Variation_1156_Arg
class RuleVariation_1108(RuleVariationContextFree):
    cv_variation = Variation_1156

    @classmethod
    def create(cls, arg : RuleVariation_1108_Arg) -> "RuleVariation_1108":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1156:
        return self.arg # type: ignore

NonSpare_21_Arg: TypeAlias = RuleVariation_1108_Arg
class NonSpare_21(NonSpare):
    cv_name = "004"
    cv_title = "II Code"
    cv_rule = RuleVariation_1108

    @classmethod
    def create(cls, arg : NonSpare_21_Arg) -> "NonSpare_21":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1108:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1156:
        return self.rule.variation

class UapItem_21(UapItem):
    cv_non_spare = NonSpare_21

Variation_387_Arg: TypeAlias = RuleContent_0_Arg
class Variation_387(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_387_Arg) -> "Variation_387":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_379_Arg: TypeAlias = Variation_387_Arg
class RuleVariation_379(RuleVariationContextFree):
    cv_variation = Variation_387

    @classmethod
    def create(cls, arg : RuleVariation_379_Arg) -> "RuleVariation_379":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_387:
        return self.arg # type: ignore

NonSpare_121_Arg: TypeAlias = RuleVariation_379_Arg
class NonSpare_121(NonSpare):
    cv_name = "031"
    cv_title = "Aircraft Identity"
    cv_rule = RuleVariation_379

    @classmethod
    def create(cls, arg : NonSpare_121_Arg) -> "NonSpare_121":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_379:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_387:
        return self.rule.variation

class UapItem_121(UapItem):
    cv_non_spare = NonSpare_121

NonSpare_1289_Arg: TypeAlias = RuleVariation_776_Arg
class NonSpare_1289(NonSpare):
    cv_name = "MOD3A"
    cv_title = ""
    cv_rule = RuleVariation_776

    @classmethod
    def create(cls, arg : NonSpare_1289_Arg) -> "NonSpare_1289":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_776:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_806:
        return self.rule.variation

Item_561_Arg: TypeAlias = NonSpare_1289_Arg
class Item_561(Item):
    cv_non_spare = NonSpare_1289

    @classmethod
    def create(cls, arg : Item_561_Arg) -> "Item_561":
        return cls._create(arg) # type: ignore

Variation_1257_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_539_Arg, Tuple[Literal["L"], RuleVariation_539_Arg]], int, Union[RuleVariation_776_Arg, Tuple[Literal["MOD3A"], RuleVariation_776_Arg]]]
Variation_1257_Arg: TypeAlias = Union[int, Variation_1257_Arg_Group]
class Variation_1257(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1099, 1), (Item_353, 1), (Item_450, 1), (Item_16, 1), (Item_561, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "L": RuleVariation_539, "MOD3A": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_539:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MOD3A"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MOD3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_539:
        ...
    @overload
    def get_item(self, key : Literal["MOD3A"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1257_Arg) -> 'Variation_1257':
        return cls._create(arg) # type: ignore

RuleVariation_1187_Arg: TypeAlias = Variation_1257_Arg
class RuleVariation_1187(RuleVariationContextFree):
    cv_variation = Variation_1257

    @classmethod
    def create(cls, arg : RuleVariation_1187_Arg) -> "RuleVariation_1187":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1257:
        return self.arg # type: ignore

NonSpare_122_Arg: TypeAlias = RuleVariation_1187_Arg
class NonSpare_122(NonSpare):
    cv_name = "032"
    cv_title = "Aircraft Mode A"
    cv_rule = RuleVariation_1187

    @classmethod
    def create(cls, arg : NonSpare_122_Arg) -> "NonSpare_122":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1187:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1257:
        return self.rule.variation

class UapItem_122(UapItem):
    cv_non_spare = NonSpare_122

Variation_1250_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_595_Arg, Tuple[Literal["FL"], RuleVariation_595_Arg]]]
Variation_1250_Arg: TypeAlias = Union[int, Variation_1250_Arg_Group]
class Variation_1250(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1099, 1), (Item_353, 1), (Item_329, 14)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "FL": RuleVariation_595}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FL"]) -> RuleVariation_595:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["FL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["FL"]) -> RuleVariation_595:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1250_Arg) -> 'Variation_1250':
        return cls._create(arg) # type: ignore

RuleVariation_1180_Arg: TypeAlias = Variation_1250_Arg
class RuleVariation_1180(RuleVariationContextFree):
    cv_variation = Variation_1250

    @classmethod
    def create(cls, arg : RuleVariation_1180_Arg) -> "RuleVariation_1180":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1250:
        return self.arg # type: ignore

NonSpare_124_Arg: TypeAlias = RuleVariation_1180_Arg
class NonSpare_124(NonSpare):
    cv_name = "033"
    cv_title = "Aircraft Height"
    cv_rule = RuleVariation_1180

    @classmethod
    def create(cls, arg : NonSpare_124_Arg) -> "NonSpare_124":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1180:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1250:
        return self.rule.variation

class UapItem_124(UapItem):
    cv_non_spare = NonSpare_124

NonSpare_125_Arg: TypeAlias = RuleVariation_329_Arg
class NonSpare_125(NonSpare):
    cv_name = "034"
    cv_title = "Aircraft Speed"
    cv_rule = RuleVariation_329

    @classmethod
    def create(cls, arg : NonSpare_125_Arg) -> "NonSpare_125":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_329:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_336:
        return self.rule.variation

class UapItem_125(UapItem):
    cv_non_spare = NonSpare_125

NonSpare_127_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_127(NonSpare):
    cv_name = "035"
    cv_title = "Aircraft Heading"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_127_Arg) -> "NonSpare_127":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

class UapItem_127(UapItem):
    cv_non_spare = NonSpare_127

Content_29_Arg: TypeAlias = int
class Content_29(ContentTable):
    cv_values = {0: "Aircraft is airborne", 1: "Aircraft is on the ground"}

RuleContent_29_Arg: TypeAlias = Content_29_Arg
class RuleContent_29(RuleContentContextFree):
    cv_content = Content_29

    @property
    def content(self) -> Content_29:
        return self._get_content() # type: ignore

Variation_10_Arg: TypeAlias = RuleContent_29_Arg
class Variation_10(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_29

    @classmethod
    def create(cls, arg : Variation_10_Arg) -> "Variation_10":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_29:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_29:
        return self.rule.content

RuleVariation_10_Arg: TypeAlias = Variation_10_Arg
class RuleVariation_10(RuleVariationContextFree):
    cv_variation = Variation_10

    @classmethod
    def create(cls, arg : RuleVariation_10_Arg) -> "RuleVariation_10":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_10:
        return self.arg # type: ignore

NonSpare_990_Arg: TypeAlias = RuleVariation_10_Arg
class NonSpare_990(NonSpare):
    cv_name = "FS"
    cv_title = "Flight Status"
    cv_rule = RuleVariation_10

    @classmethod
    def create(cls, arg : NonSpare_990_Arg) -> "NonSpare_990":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_10:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_10:
        return self.rule.variation

Item_345_Arg: TypeAlias = NonSpare_990_Arg
class Item_345(Item):
    cv_non_spare = NonSpare_990

    @classmethod
    def create(cls, arg : Item_345_Arg) -> "Item_345":
        return cls._create(arg) # type: ignore

Content_486_Arg: TypeAlias = int
class Content_486(ContentTable):
    cv_values = {0: "The CQF calculation method is not supported", 1: "The CQF is minimum", 126: "The CQF is maximum", 127: "The CQF is undefined according to the calculation method"}

RuleContent_486_Arg: TypeAlias = Content_486_Arg
class RuleContent_486(RuleContentContextFree):
    cv_content = Content_486

    @property
    def content(self) -> Content_486:
        return self._get_content() # type: ignore

Variation_491_Arg: TypeAlias = RuleContent_486_Arg
class Variation_491(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 7
    cv_rule = RuleContent_486

    @classmethod
    def create(cls, arg : Variation_491_Arg) -> "Variation_491":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_486:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_486:
        return self.rule.content

RuleVariation_480_Arg: TypeAlias = Variation_491_Arg
class RuleVariation_480(RuleVariationContextFree):
    cv_variation = Variation_491

    @classmethod
    def create(cls, arg : RuleVariation_480_Arg) -> "RuleVariation_480":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_491:
        return self.arg # type: ignore

NonSpare_818_Arg: TypeAlias = RuleVariation_480_Arg
class NonSpare_818(NonSpare):
    cv_name = "CQF"
    cv_title = "Aircraft CQF"
    cv_rule = RuleVariation_480

    @classmethod
    def create(cls, arg : NonSpare_818_Arg) -> "NonSpare_818":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_480:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_491:
        return self.rule.variation

Item_210_Arg: TypeAlias = NonSpare_818_Arg
class Item_210(Item):
    cv_non_spare = NonSpare_818

    @classmethod
    def create(cls, arg : Item_210_Arg) -> "Item_210":
        return cls._create(arg) # type: ignore

Variation_1100_Arg_Group = Tuple[Union[RuleVariation_10_Arg, Tuple[Literal["FS"], RuleVariation_10_Arg]], Union[RuleVariation_480_Arg, Tuple[Literal["CQF"], RuleVariation_480_Arg]]]
Variation_1100_Arg: TypeAlias = Union[int, Variation_1100_Arg_Group]
class Variation_1100(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_345, 1), (Item_210, 7)]
    cv_items_dict = {"FS": RuleVariation_10, "CQF": RuleVariation_480}

    @overload
    @classmethod
    def spec(cls, key : Literal["FS"]) -> RuleVariation_10:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CQF"]) -> RuleVariation_480:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["FS"], Literal["CQF"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["FS"]) -> RuleVariation_10:
        ...
    @overload
    def get_item(self, key : Literal["CQF"]) -> RuleVariation_480:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1100_Arg) -> 'Variation_1100':
        return cls._create(arg) # type: ignore

RuleVariation_1058_Arg: TypeAlias = Variation_1100_Arg
class RuleVariation_1058(RuleVariationContextFree):
    cv_variation = Variation_1100

    @classmethod
    def create(cls, arg : RuleVariation_1058_Arg) -> "RuleVariation_1058":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1100:
        return self.arg # type: ignore

NonSpare_52_Arg: TypeAlias = RuleVariation_1058_Arg
class NonSpare_52(NonSpare):
    cv_name = "012"
    cv_title = "Aircraft Coverage Quality Factor"
    cv_rule = RuleVariation_1058

    @classmethod
    def create(cls, arg : NonSpare_52_Arg) -> "NonSpare_52":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1058:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1100:
        return self.rule.variation

class UapItem_52(UapItem):
    cv_non_spare = NonSpare_52

NonSpare_54_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_54(NonSpare):
    cv_name = "013"
    cv_title = "Aircraft CQF Calculation Method"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_54_Arg) -> "NonSpare_54":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_54(UapItem):
    cv_non_spare = NonSpare_54

Record_50_Arg = TypedDict('Record_50_Arg', {
    "036": NonSpare_130_Arg,
    "037": NonSpare_132_Arg,
    "000": NonSpare_0_Arg,
    "001": NonSpare_19_Arg,
    "005": NonSpare_22_Arg,
    "016": NonSpare_70_Arg,
    "017": NonSpare_72_Arg,
    "018": NonSpare_74_Arg,
    "019": NonSpare_75_Arg,
    "028": NonSpare_101_Arg,
    "030": NonSpare_103_Arg,
    "025": NonSpare_99_Arg,
    "027": NonSpare_100_Arg,
    "029": NonSpare_102_Arg,
    "002": NonSpare_20_Arg,
    "006": NonSpare_23_Arg,
    "007": NonSpare_24_Arg,
    "008": NonSpare_25_Arg,
    "009": NonSpare_27_Arg,
    "010": NonSpare_50_Arg,
    "011": NonSpare_51_Arg,
    "014": NonSpare_55_Arg,
    "015": NonSpare_56_Arg,
    "020": NonSpare_77_Arg,
    "021": NonSpare_96_Arg,
    "022": NonSpare_97_Arg,
    "023": NonSpare_98_Arg,
    "004": NonSpare_21_Arg,
    "031": NonSpare_121_Arg,
    "032": NonSpare_122_Arg,
    "033": NonSpare_124_Arg,
    "034": NonSpare_125_Arg,
    "035": NonSpare_127_Arg,
    "012": NonSpare_52_Arg,
    "013": NonSpare_54_Arg,
}, total=False)
class Record_50(Record):
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_130, UapItem_132, UapItem_0, UapItem_19, UapItem_22, UapItem_70, UapItem_72, UapItem_74, UapItem_75, UapItem_101, UapItem_103, UapItem_99, UapItem_100, UapItem_102, UapItem_20, UapItem_23, UapItem_24, UapItem_25, UapItem_27, UapItem_50, UapItem_51, UapItem_55, UapItem_56, UapItem_77, UapItem_96, UapItem_97, UapItem_98, UapItem_21, UapItem_121, UapItem_122, UapItem_124, UapItem_125, UapItem_127, UapItem_52, UapItem_54]
    cv_items_dict = {"036": NonSpare_130, "037": NonSpare_132, "000": NonSpare_0, "001": NonSpare_19, "005": NonSpare_22, "016": NonSpare_70, "017": NonSpare_72, "018": NonSpare_74, "019": NonSpare_75, "028": NonSpare_101, "030": NonSpare_103, "025": NonSpare_99, "027": NonSpare_100, "029": NonSpare_102, "002": NonSpare_20, "006": NonSpare_23, "007": NonSpare_24, "008": NonSpare_25, "009": NonSpare_27, "010": NonSpare_50, "011": NonSpare_51, "014": NonSpare_55, "015": NonSpare_56, "020": NonSpare_77, "021": NonSpare_96, "022": NonSpare_97, "023": NonSpare_98, "004": NonSpare_21, "031": NonSpare_121, "032": NonSpare_122, "033": NonSpare_124, "034": NonSpare_125, "035": NonSpare_127, "012": NonSpare_52, "013": NonSpare_54}

    @overload
    @classmethod
    def spec(cls, key : Literal["036"]) -> NonSpare_130:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["037"]) -> NonSpare_132:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_0:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["001"]) -> NonSpare_19:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["005"]) -> NonSpare_22:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["016"]) -> NonSpare_70:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["017"]) -> NonSpare_72:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["018"]) -> NonSpare_74:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["019"]) -> NonSpare_75:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["028"]) -> NonSpare_101:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_103:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["025"]) -> NonSpare_99:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["027"]) -> NonSpare_100:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["029"]) -> NonSpare_102:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["002"]) -> NonSpare_20:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["006"]) -> NonSpare_23:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["007"]) -> NonSpare_24:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["008"]) -> NonSpare_25:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["009"]) -> NonSpare_27:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_50:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["011"]) -> NonSpare_51:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["014"]) -> NonSpare_55:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_56:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_77:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["021"]) -> NonSpare_96:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["022"]) -> NonSpare_97:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["023"]) -> NonSpare_98:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["004"]) -> NonSpare_21:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["031"]) -> NonSpare_121:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["032"]) -> NonSpare_122:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["033"]) -> NonSpare_124:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["034"]) -> NonSpare_125:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["035"]) -> NonSpare_127:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["012"]) -> NonSpare_52:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["013"]) -> NonSpare_54:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["036"], Literal["037"], Literal["000"], Literal["001"], Literal["005"], Literal["016"], Literal["017"], Literal["018"], Literal["019"], Literal["028"], Literal["030"], Literal["025"], Literal["027"], Literal["029"], Literal["002"], Literal["006"], Literal["007"], Literal["008"], Literal["009"], Literal["010"], Literal["011"], Literal["014"], Literal["015"], Literal["020"], Literal["021"], Literal["022"], Literal["023"], Literal["004"], Literal["031"], Literal["032"], Literal["033"], Literal["034"], Literal["035"], Literal["012"], Literal["013"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["036"]) -> Optional[NonSpare_130]:
        ...
    @overload
    def get_item(self, key : Literal["037"]) -> Optional[NonSpare_132]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_0]:
        ...
    @overload
    def get_item(self, key : Literal["001"]) -> Optional[NonSpare_19]:
        ...
    @overload
    def get_item(self, key : Literal["005"]) -> Optional[NonSpare_22]:
        ...
    @overload
    def get_item(self, key : Literal["016"]) -> Optional[NonSpare_70]:
        ...
    @overload
    def get_item(self, key : Literal["017"]) -> Optional[NonSpare_72]:
        ...
    @overload
    def get_item(self, key : Literal["018"]) -> Optional[NonSpare_74]:
        ...
    @overload
    def get_item(self, key : Literal["019"]) -> Optional[NonSpare_75]:
        ...
    @overload
    def get_item(self, key : Literal["028"]) -> Optional[NonSpare_101]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_103]:
        ...
    @overload
    def get_item(self, key : Literal["025"]) -> Optional[NonSpare_99]:
        ...
    @overload
    def get_item(self, key : Literal["027"]) -> Optional[NonSpare_100]:
        ...
    @overload
    def get_item(self, key : Literal["029"]) -> Optional[NonSpare_102]:
        ...
    @overload
    def get_item(self, key : Literal["002"]) -> Optional[NonSpare_20]:
        ...
    @overload
    def get_item(self, key : Literal["006"]) -> Optional[NonSpare_23]:
        ...
    @overload
    def get_item(self, key : Literal["007"]) -> Optional[NonSpare_24]:
        ...
    @overload
    def get_item(self, key : Literal["008"]) -> Optional[NonSpare_25]:
        ...
    @overload
    def get_item(self, key : Literal["009"]) -> Optional[NonSpare_27]:
        ...
    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_50]:
        ...
    @overload
    def get_item(self, key : Literal["011"]) -> Optional[NonSpare_51]:
        ...
    @overload
    def get_item(self, key : Literal["014"]) -> Optional[NonSpare_55]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_56]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_77]:
        ...
    @overload
    def get_item(self, key : Literal["021"]) -> Optional[NonSpare_96]:
        ...
    @overload
    def get_item(self, key : Literal["022"]) -> Optional[NonSpare_97]:
        ...
    @overload
    def get_item(self, key : Literal["023"]) -> Optional[NonSpare_98]:
        ...
    @overload
    def get_item(self, key : Literal["004"]) -> Optional[NonSpare_21]:
        ...
    @overload
    def get_item(self, key : Literal["031"]) -> Optional[NonSpare_121]:
        ...
    @overload
    def get_item(self, key : Literal["032"]) -> Optional[NonSpare_122]:
        ...
    @overload
    def get_item(self, key : Literal["033"]) -> Optional[NonSpare_124]:
        ...
    @overload
    def get_item(self, key : Literal["034"]) -> Optional[NonSpare_125]:
        ...
    @overload
    def get_item(self, key : Literal["035"]) -> Optional[NonSpare_127]:
        ...
    @overload
    def get_item(self, key : Literal["012"]) -> Optional[NonSpare_52]:
        ...
    @overload
    def get_item(self, key : Literal["013"]) -> Optional[NonSpare_54]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["036"], val : NonSpare_130_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["037"], val : NonSpare_132_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_0_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["001"], val : NonSpare_19_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["005"], val : NonSpare_22_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["016"], val : NonSpare_70_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["017"], val : NonSpare_72_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["018"], val : NonSpare_74_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["019"], val : NonSpare_75_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["028"], val : NonSpare_101_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_103_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["025"], val : NonSpare_99_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["027"], val : NonSpare_100_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["029"], val : NonSpare_102_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["002"], val : NonSpare_20_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["006"], val : NonSpare_23_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["007"], val : NonSpare_24_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["008"], val : NonSpare_25_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["009"], val : NonSpare_27_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_50_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["011"], val : NonSpare_51_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["014"], val : NonSpare_55_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_56_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_77_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["021"], val : NonSpare_96_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["022"], val : NonSpare_97_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["023"], val : NonSpare_98_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["004"], val : NonSpare_21_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["031"], val : NonSpare_121_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["032"], val : NonSpare_122_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["033"], val : NonSpare_124_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["034"], val : NonSpare_125_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["035"], val : NonSpare_127_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["012"], val : NonSpare_52_Arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["013"], val : NonSpare_54_Arg) -> 'Record_50':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["036"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["037"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["001"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["005"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["016"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["017"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["018"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["019"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["028"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["025"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["027"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["029"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["002"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["006"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["007"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["008"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["009"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["011"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["014"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["021"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["022"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["023"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["004"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["031"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["032"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["033"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["034"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["035"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["012"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["013"]) -> 'Record_50':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_50_Arg) -> 'Record_50':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_50", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_46_Arg: TypeAlias = Record_50
class Uap_46(UapSingle):
    cv_record = Record_50

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_50]]:
        return cls._parse(bs)

class Asterix_17(AstCat):
    cv_category = 18
    cv_edition = (1, 7)
    cv_uap = Uap_46

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_46_Arg]) -> "Asterix_17":
        return cls._create(records) # type: ignore

class Asterix_18(AstCat):
    cv_category = 18
    cv_edition = (1, 8)
    cv_uap = Uap_46

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_46_Arg]) -> "Asterix_18":
        return cls._create(records) # type: ignore

NonSpare_44_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_44(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_44_Arg) -> "NonSpare_44":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_44(UapItem):
    cv_non_spare = NonSpare_44

Content_593_Arg: TypeAlias = int
class Content_593(ContentTable):
    cv_values = {1: "Start of Update Cycle", 2: "Periodic Status Message", 3: "Event-triggered Status Message"}

RuleContent_593_Arg: TypeAlias = Content_593_Arg
class RuleContent_593(RuleContentContextFree):
    cv_content = Content_593

    @property
    def content(self) -> Content_593:
        return self._get_content() # type: ignore

Variation_193_Arg: TypeAlias = RuleContent_593_Arg
class Variation_193(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_593

    @classmethod
    def create(cls, arg : Variation_193_Arg) -> "Variation_193":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_593:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_593:
        return self.rule.content

RuleVariation_186_Arg: TypeAlias = Variation_193_Arg
class RuleVariation_186(RuleVariationContextFree):
    cv_variation = Variation_193

    @classmethod
    def create(cls, arg : RuleVariation_186_Arg) -> "RuleVariation_186":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_193:
        return self.arg # type: ignore

NonSpare_9_Arg: TypeAlias = RuleVariation_186_Arg
class NonSpare_9(NonSpare):
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule = RuleVariation_186

    @classmethod
    def create(cls, arg : NonSpare_9_Arg) -> "NonSpare_9":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_186:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_193:
        return self.rule.variation

class UapItem_9(UapItem):
    cv_non_spare = NonSpare_9

NonSpare_324_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_324(NonSpare):
    cv_name = "140"
    cv_title = "Time of Day"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_324_Arg) -> "NonSpare_324":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_324(UapItem):
    cv_non_spare = NonSpare_324

Content_410_Arg: TypeAlias = int
class Content_410(ContentTable):
    cv_values = {0: "Operational", 1: "Degraded", 2: "NOGO", 3: "Undefined"}

RuleContent_410_Arg: TypeAlias = Content_410_Arg
class RuleContent_410(RuleContentContextFree):
    cv_content = Content_410

    @property
    def content(self) -> Content_410:
        return self._get_content() # type: ignore

Variation_108_Arg: TypeAlias = RuleContent_410_Arg
class Variation_108(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_410

    @classmethod
    def create(cls, arg : Variation_108_Arg) -> "Variation_108":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_410:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_410:
        return self.rule.content

RuleVariation_108_Arg: TypeAlias = Variation_108_Arg
class RuleVariation_108(RuleVariationContextFree):
    cv_variation = Variation_108

    @classmethod
    def create(cls, arg : RuleVariation_108_Arg) -> "RuleVariation_108":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_108:
        return self.arg # type: ignore

NonSpare_1361_Arg: TypeAlias = RuleVariation_108_Arg
class NonSpare_1361(NonSpare):
    cv_name = "NOGO"
    cv_title = "Operational Release Status of the System"
    cv_rule = RuleVariation_108

    @classmethod
    def create(cls, arg : NonSpare_1361_Arg) -> "NonSpare_1361":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_108:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_108:
        return self.rule.variation

Item_627_Arg: TypeAlias = NonSpare_1361_Arg
class Item_627(Item):
    cv_non_spare = NonSpare_1361

    @classmethod
    def create(cls, arg : Item_627_Arg) -> "Item_627":
        return cls._create(arg) # type: ignore

Variation_752_Arg: TypeAlias = RuleContent_485_Arg
class Variation_752(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_485

    @classmethod
    def create(cls, arg : Variation_752_Arg) -> "Variation_752":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_485:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_485:
        return self.rule.content

RuleVariation_741_Arg: TypeAlias = Variation_752_Arg
class RuleVariation_741(RuleVariationContextFree):
    cv_variation = Variation_752

    @classmethod
    def create(cls, arg : RuleVariation_741_Arg) -> "RuleVariation_741":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_752:
        return self.arg # type: ignore

NonSpare_1940_Arg: TypeAlias = RuleVariation_741_Arg
class NonSpare_1940(NonSpare):
    cv_name = "TTF"
    cv_title = "Test Target"
    cv_rule = RuleVariation_741

    @classmethod
    def create(cls, arg : NonSpare_1940_Arg) -> "NonSpare_1940":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_741:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_752:
        return self.rule.variation

Item_1061_Arg: TypeAlias = NonSpare_1940_Arg
class Item_1061(Item):
    cv_non_spare = NonSpare_1940

    @classmethod
    def create(cls, arg : Item_1061_Arg) -> "Item_1061":
        return cls._create(arg) # type: ignore

Variation_1148_Arg_Group = Tuple[Union[RuleVariation_108_Arg, Tuple[Literal["NOGO"], RuleVariation_108_Arg]], Union[RuleVariation_550_Arg, Tuple[Literal["OVL"], RuleVariation_550_Arg]], Union[RuleVariation_659_Arg, Tuple[Literal["TSV"], RuleVariation_659_Arg]], Union[RuleVariation_741_Arg, Tuple[Literal["TTF"], RuleVariation_741_Arg]], int]
Variation_1148_Arg: TypeAlias = Union[int, Variation_1148_Arg_Group]
class Variation_1148(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_627, 2), (Item_664, 1), (Item_1055, 1), (Item_1061, 1), (Item_25, 3)]
    cv_items_dict = {"NOGO": RuleVariation_108, "OVL": RuleVariation_550, "TSV": RuleVariation_659, "TTF": RuleVariation_741}

    @overload
    @classmethod
    def spec(cls, key : Literal["NOGO"]) -> RuleVariation_108:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVL"]) -> RuleVariation_550:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TSV"]) -> RuleVariation_659:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TTF"]) -> RuleVariation_741:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["NOGO"], Literal["OVL"], Literal["TSV"], Literal["TTF"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["NOGO"]) -> RuleVariation_108:
        ...
    @overload
    def get_item(self, key : Literal["OVL"]) -> RuleVariation_550:
        ...
    @overload
    def get_item(self, key : Literal["TSV"]) -> RuleVariation_659:
        ...
    @overload
    def get_item(self, key : Literal["TTF"]) -> RuleVariation_741:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1148_Arg) -> 'Variation_1148':
        return cls._create(arg) # type: ignore

RuleVariation_1102_Arg: TypeAlias = Variation_1148_Arg
class RuleVariation_1102(RuleVariationContextFree):
    cv_variation = Variation_1148

    @classmethod
    def create(cls, arg : RuleVariation_1102_Arg) -> "RuleVariation_1102":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1148:
        return self.arg # type: ignore

NonSpare_519_Arg: TypeAlias = RuleVariation_1102_Arg
class NonSpare_519(NonSpare):
    cv_name = "550"
    cv_title = "System Status"
    cv_rule = RuleVariation_1102

    @classmethod
    def create(cls, arg : NonSpare_519_Arg) -> "NonSpare_519":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1102:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1148:
        return self.rule.variation

class UapItem_518(UapItem):
    cv_non_spare = NonSpare_519

Content_457_Arg: TypeAlias = int
class Content_457(ContentTable):
    cv_values = {0: "Standby", 1: "Exec"}

RuleContent_457_Arg: TypeAlias = Content_457_Arg
class RuleContent_457(RuleContentContextFree):
    cv_content = Content_457

    @property
    def content(self) -> Content_457:
        return self._get_content() # type: ignore

Variation_75_Arg: TypeAlias = RuleContent_457_Arg
class Variation_75(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_457

    @classmethod
    def create(cls, arg : Variation_75_Arg) -> "Variation_75":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_457:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_457:
        return self.rule.content

RuleVariation_75_Arg: TypeAlias = Variation_75_Arg
class RuleVariation_75(RuleVariationContextFree):
    cv_variation = Variation_75

    @classmethod
    def create(cls, arg : RuleVariation_75_Arg) -> "RuleVariation_75":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_75:
        return self.arg # type: ignore

NonSpare_1882_Arg: TypeAlias = RuleVariation_75_Arg
class NonSpare_1882(NonSpare):
    cv_name = "TP1A"
    cv_title = ""
    cv_rule = RuleVariation_75

    @classmethod
    def create(cls, arg : NonSpare_1882_Arg) -> "NonSpare_1882":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_75:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_75:
        return self.rule.variation

Item_1011_Arg: TypeAlias = NonSpare_1882_Arg
class Item_1011(Item):
    cv_non_spare = NonSpare_1882

    @classmethod
    def create(cls, arg : Item_1011_Arg) -> "Item_1011":
        return cls._create(arg) # type: ignore

Content_210_Arg: TypeAlias = int
class Content_210(ContentTable):
    cv_values = {0: "Faulted", 1: "Good"}

RuleContent_210_Arg: TypeAlias = Content_210_Arg
class RuleContent_210(RuleContentContextFree):
    cv_content = Content_210

    @property
    def content(self) -> Content_210:
        return self._get_content() # type: ignore

Variation_424_Arg: TypeAlias = RuleContent_210_Arg
class Variation_424(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_210

    @classmethod
    def create(cls, arg : Variation_424_Arg) -> "Variation_424":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_210:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_210:
        return self.rule.content

RuleVariation_413_Arg: TypeAlias = Variation_424_Arg
class RuleVariation_413(RuleVariationContextFree):
    cv_variation = Variation_424

    @classmethod
    def create(cls, arg : RuleVariation_413_Arg) -> "RuleVariation_413":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_424:
        return self.arg # type: ignore

NonSpare_1883_Arg: TypeAlias = RuleVariation_413_Arg
class NonSpare_1883(NonSpare):
    cv_name = "TP1B"
    cv_title = ""
    cv_rule = RuleVariation_413

    @classmethod
    def create(cls, arg : NonSpare_1883_Arg) -> "NonSpare_1883":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_413:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_424:
        return self.rule.variation

Item_1012_Arg: TypeAlias = NonSpare_1883_Arg
class Item_1012(Item):
    cv_non_spare = NonSpare_1883

    @classmethod
    def create(cls, arg : Item_1012_Arg) -> "Item_1012":
        return cls._create(arg) # type: ignore

Variation_573_Arg: TypeAlias = RuleContent_457_Arg
class Variation_573(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_457

    @classmethod
    def create(cls, arg : Variation_573_Arg) -> "Variation_573":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_457:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_457:
        return self.rule.content

RuleVariation_562_Arg: TypeAlias = Variation_573_Arg
class RuleVariation_562(RuleVariationContextFree):
    cv_variation = Variation_573

    @classmethod
    def create(cls, arg : RuleVariation_562_Arg) -> "RuleVariation_562":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_573:
        return self.arg # type: ignore

NonSpare_1884_Arg: TypeAlias = RuleVariation_562_Arg
class NonSpare_1884(NonSpare):
    cv_name = "TP2A"
    cv_title = ""
    cv_rule = RuleVariation_562

    @classmethod
    def create(cls, arg : NonSpare_1884_Arg) -> "NonSpare_1884":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_562:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_573:
        return self.rule.variation

Item_1013_Arg: TypeAlias = NonSpare_1884_Arg
class Item_1013(Item):
    cv_non_spare = NonSpare_1884

    @classmethod
    def create(cls, arg : Item_1013_Arg) -> "Item_1013":
        return cls._create(arg) # type: ignore

Variation_637_Arg: TypeAlias = RuleContent_210_Arg
class Variation_637(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_210

    @classmethod
    def create(cls, arg : Variation_637_Arg) -> "Variation_637":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_210:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_210:
        return self.rule.content

RuleVariation_626_Arg: TypeAlias = Variation_637_Arg
class RuleVariation_626(RuleVariationContextFree):
    cv_variation = Variation_637

    @classmethod
    def create(cls, arg : RuleVariation_626_Arg) -> "RuleVariation_626":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_637:
        return self.arg # type: ignore

NonSpare_1885_Arg: TypeAlias = RuleVariation_626_Arg
class NonSpare_1885(NonSpare):
    cv_name = "TP2B"
    cv_title = ""
    cv_rule = RuleVariation_626

    @classmethod
    def create(cls, arg : NonSpare_1885_Arg) -> "NonSpare_1885":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_626:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_637:
        return self.rule.variation

Item_1014_Arg: TypeAlias = NonSpare_1885_Arg
class Item_1014(Item):
    cv_non_spare = NonSpare_1885

    @classmethod
    def create(cls, arg : Item_1014_Arg) -> "Item_1014":
        return cls._create(arg) # type: ignore

Variation_749_Arg: TypeAlias = RuleContent_457_Arg
class Variation_749(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_457

    @classmethod
    def create(cls, arg : Variation_749_Arg) -> "Variation_749":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_457:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_457:
        return self.rule.content

RuleVariation_738_Arg: TypeAlias = Variation_749_Arg
class RuleVariation_738(RuleVariationContextFree):
    cv_variation = Variation_749

    @classmethod
    def create(cls, arg : RuleVariation_738_Arg) -> "RuleVariation_738":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_749:
        return self.arg # type: ignore

NonSpare_1886_Arg: TypeAlias = RuleVariation_738_Arg
class NonSpare_1886(NonSpare):
    cv_name = "TP3A"
    cv_title = ""
    cv_rule = RuleVariation_738

    @classmethod
    def create(cls, arg : NonSpare_1886_Arg) -> "NonSpare_1886":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_738:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_749:
        return self.rule.variation

Item_1015_Arg: TypeAlias = NonSpare_1886_Arg
class Item_1015(Item):
    cv_non_spare = NonSpare_1886

    @classmethod
    def create(cls, arg : Item_1015_Arg) -> "Item_1015":
        return cls._create(arg) # type: ignore

Variation_847_Arg: TypeAlias = RuleContent_210_Arg
class Variation_847(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_210

    @classmethod
    def create(cls, arg : Variation_847_Arg) -> "Variation_847":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_210:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_210:
        return self.rule.content

RuleVariation_817_Arg: TypeAlias = Variation_847_Arg
class RuleVariation_817(RuleVariationContextFree):
    cv_variation = Variation_847

    @classmethod
    def create(cls, arg : RuleVariation_817_Arg) -> "RuleVariation_817":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_847:
        return self.arg # type: ignore

NonSpare_1887_Arg: TypeAlias = RuleVariation_817_Arg
class NonSpare_1887(NonSpare):
    cv_name = "TP3B"
    cv_title = ""
    cv_rule = RuleVariation_817

    @classmethod
    def create(cls, arg : NonSpare_1887_Arg) -> "NonSpare_1887":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_817:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_847:
        return self.rule.variation

Item_1016_Arg: TypeAlias = NonSpare_1887_Arg
class Item_1016(Item):
    cv_non_spare = NonSpare_1887

    @classmethod
    def create(cls, arg : Item_1016_Arg) -> "Item_1016":
        return cls._create(arg) # type: ignore

Variation_948_Arg: TypeAlias = RuleContent_457_Arg
class Variation_948(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_457

    @classmethod
    def create(cls, arg : Variation_948_Arg) -> "Variation_948":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_457:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_457:
        return self.rule.content

RuleVariation_918_Arg: TypeAlias = Variation_948_Arg
class RuleVariation_918(RuleVariationContextFree):
    cv_variation = Variation_948

    @classmethod
    def create(cls, arg : RuleVariation_918_Arg) -> "RuleVariation_918":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_948:
        return self.arg # type: ignore

NonSpare_1888_Arg: TypeAlias = RuleVariation_918_Arg
class NonSpare_1888(NonSpare):
    cv_name = "TP4A"
    cv_title = ""
    cv_rule = RuleVariation_918

    @classmethod
    def create(cls, arg : NonSpare_1888_Arg) -> "NonSpare_1888":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_918:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_948:
        return self.rule.variation

Item_1017_Arg: TypeAlias = NonSpare_1888_Arg
class Item_1017(Item):
    cv_non_spare = NonSpare_1888

    @classmethod
    def create(cls, arg : Item_1017_Arg) -> "Item_1017":
        return cls._create(arg) # type: ignore

Variation_972_Arg: TypeAlias = RuleContent_210_Arg
class Variation_972(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_210

    @classmethod
    def create(cls, arg : Variation_972_Arg) -> "Variation_972":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_210:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_210:
        return self.rule.content

RuleVariation_942_Arg: TypeAlias = Variation_972_Arg
class RuleVariation_942(RuleVariationContextFree):
    cv_variation = Variation_972

    @classmethod
    def create(cls, arg : RuleVariation_942_Arg) -> "RuleVariation_942":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_972:
        return self.arg # type: ignore

NonSpare_1889_Arg: TypeAlias = RuleVariation_942_Arg
class NonSpare_1889(NonSpare):
    cv_name = "TP4B"
    cv_title = ""
    cv_rule = RuleVariation_942

    @classmethod
    def create(cls, arg : NonSpare_1889_Arg) -> "NonSpare_1889":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_942:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_972:
        return self.rule.variation

Item_1018_Arg: TypeAlias = NonSpare_1889_Arg
class Item_1018(Item):
    cv_non_spare = NonSpare_1889

    @classmethod
    def create(cls, arg : Item_1018_Arg) -> "Item_1018":
        return cls._create(arg) # type: ignore

Variation_1220_Arg_Group = Tuple[Union[RuleVariation_75_Arg, Tuple[Literal["TP1A"], RuleVariation_75_Arg]], Union[RuleVariation_413_Arg, Tuple[Literal["TP1B"], RuleVariation_413_Arg]], Union[RuleVariation_562_Arg, Tuple[Literal["TP2A"], RuleVariation_562_Arg]], Union[RuleVariation_626_Arg, Tuple[Literal["TP2B"], RuleVariation_626_Arg]], Union[RuleVariation_738_Arg, Tuple[Literal["TP3A"], RuleVariation_738_Arg]], Union[RuleVariation_817_Arg, Tuple[Literal["TP3B"], RuleVariation_817_Arg]], Union[RuleVariation_918_Arg, Tuple[Literal["TP4A"], RuleVariation_918_Arg]], Union[RuleVariation_942_Arg, Tuple[Literal["TP4B"], RuleVariation_942_Arg]]]
Variation_1220_Arg: TypeAlias = Union[int, Variation_1220_Arg_Group]
class Variation_1220(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1011, 1), (Item_1012, 1), (Item_1013, 1), (Item_1014, 1), (Item_1015, 1), (Item_1016, 1), (Item_1017, 1), (Item_1018, 1)]
    cv_items_dict = {"TP1A": RuleVariation_75, "TP1B": RuleVariation_413, "TP2A": RuleVariation_562, "TP2B": RuleVariation_626, "TP3A": RuleVariation_738, "TP3B": RuleVariation_817, "TP4A": RuleVariation_918, "TP4B": RuleVariation_942}

    @overload
    @classmethod
    def spec(cls, key : Literal["TP1A"]) -> RuleVariation_75:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TP1B"]) -> RuleVariation_413:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TP2A"]) -> RuleVariation_562:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TP2B"]) -> RuleVariation_626:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TP3A"]) -> RuleVariation_738:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TP3B"]) -> RuleVariation_817:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TP4A"]) -> RuleVariation_918:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TP4B"]) -> RuleVariation_942:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TP1A"], Literal["TP1B"], Literal["TP2A"], Literal["TP2B"], Literal["TP3A"], Literal["TP3B"], Literal["TP4A"], Literal["TP4B"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TP1A"]) -> RuleVariation_75:
        ...
    @overload
    def get_item(self, key : Literal["TP1B"]) -> RuleVariation_413:
        ...
    @overload
    def get_item(self, key : Literal["TP2A"]) -> RuleVariation_562:
        ...
    @overload
    def get_item(self, key : Literal["TP2B"]) -> RuleVariation_626:
        ...
    @overload
    def get_item(self, key : Literal["TP3A"]) -> RuleVariation_738:
        ...
    @overload
    def get_item(self, key : Literal["TP3B"]) -> RuleVariation_817:
        ...
    @overload
    def get_item(self, key : Literal["TP4A"]) -> RuleVariation_918:
        ...
    @overload
    def get_item(self, key : Literal["TP4B"]) -> RuleVariation_942:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1220_Arg) -> 'Variation_1220':
        return cls._create(arg) # type: ignore

RuleVariation_1160_Arg: TypeAlias = Variation_1220_Arg
class RuleVariation_1160(RuleVariationContextFree):
    cv_variation = Variation_1220

    @classmethod
    def create(cls, arg : RuleVariation_1160_Arg) -> "RuleVariation_1160":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1220:
        return self.arg # type: ignore

NonSpare_520_Arg: TypeAlias = RuleVariation_1160_Arg
class NonSpare_520(NonSpare):
    cv_name = "551"
    cv_title = "Tracking Processor Detailed Status"
    cv_rule = RuleVariation_1160

    @classmethod
    def create(cls, arg : NonSpare_520_Arg) -> "NonSpare_520":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1160:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1220:
        return self.rule.variation

class UapItem_519(UapItem):
    cv_non_spare = NonSpare_520

NonSpare_1612_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_1612(NonSpare):
    cv_name = "RSI"
    cv_title = "8-bit Identification Number of RS"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_1612_Arg) -> "NonSpare_1612":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_832_Arg: TypeAlias = NonSpare_1612_Arg
class Item_832(Item):
    cv_non_spare = NonSpare_1612

    @classmethod
    def create(cls, arg : Item_832_Arg) -> "Item_832":
        return cls._create(arg) # type: ignore

Content_398_Arg: TypeAlias = int
class Content_398(ContentTable):
    cv_values = {0: "Not present", 1: "Present"}

RuleContent_398_Arg: TypeAlias = Content_398_Arg
class RuleContent_398(RuleContentContextFree):
    cv_content = Content_398

    @property
    def content(self) -> Content_398:
        return self._get_content() # type: ignore

Variation_444_Arg: TypeAlias = RuleContent_398_Arg
class Variation_444(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_398

    @classmethod
    def create(cls, arg : Variation_444_Arg) -> "Variation_444":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_398:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_398:
        return self.rule.content

RuleVariation_433_Arg: TypeAlias = Variation_444_Arg
class RuleVariation_433(RuleVariationContextFree):
    cv_variation = Variation_444

    @classmethod
    def create(cls, arg : RuleVariation_433_Arg) -> "RuleVariation_433":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_444:
        return self.arg # type: ignore

NonSpare_1605_Arg: TypeAlias = RuleVariation_433_Arg
class NonSpare_1605(NonSpare):
    cv_name = "RS1090"
    cv_title = "Receiver 1090 MHz"
    cv_rule = RuleVariation_433

    @classmethod
    def create(cls, arg : NonSpare_1605_Arg) -> "NonSpare_1605":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_433:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_444:
        return self.rule.variation

Item_829_Arg: TypeAlias = NonSpare_1605_Arg
class Item_829(Item):
    cv_non_spare = NonSpare_1605

    @classmethod
    def create(cls, arg : Item_829_Arg) -> "Item_829":
        return cls._create(arg) # type: ignore

Variation_567_Arg: TypeAlias = RuleContent_398_Arg
class Variation_567(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_398

    @classmethod
    def create(cls, arg : Variation_567_Arg) -> "Variation_567":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_398:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_398:
        return self.rule.content

RuleVariation_556_Arg: TypeAlias = Variation_567_Arg
class RuleVariation_556(RuleVariationContextFree):
    cv_variation = Variation_567

    @classmethod
    def create(cls, arg : RuleVariation_556_Arg) -> "RuleVariation_556":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_567:
        return self.arg # type: ignore

NonSpare_1946_Arg: TypeAlias = RuleVariation_556_Arg
class NonSpare_1946(NonSpare):
    cv_name = "TX1030"
    cv_title = "Transmitter 1030 MHz"
    cv_rule = RuleVariation_556

    @classmethod
    def create(cls, arg : NonSpare_1946_Arg) -> "NonSpare_1946":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_556:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_567:
        return self.rule.variation

Item_1066_Arg: TypeAlias = NonSpare_1946_Arg
class Item_1066(Item):
    cv_non_spare = NonSpare_1946

    @classmethod
    def create(cls, arg : Item_1066_Arg) -> "Item_1066":
        return cls._create(arg) # type: ignore

Variation_656_Arg: TypeAlias = RuleContent_398_Arg
class Variation_656(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_398

    @classmethod
    def create(cls, arg : Variation_656_Arg) -> "Variation_656":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_398:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_398:
        return self.rule.content

RuleVariation_645_Arg: TypeAlias = Variation_656_Arg
class RuleVariation_645(RuleVariationContextFree):
    cv_variation = Variation_656

    @classmethod
    def create(cls, arg : RuleVariation_645_Arg) -> "RuleVariation_645":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_656:
        return self.arg # type: ignore

NonSpare_1947_Arg: TypeAlias = RuleVariation_645_Arg
class NonSpare_1947(NonSpare):
    cv_name = "TX1090"
    cv_title = "Transmitter 1090 MHz"
    cv_rule = RuleVariation_645

    @classmethod
    def create(cls, arg : NonSpare_1947_Arg) -> "NonSpare_1947":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_645:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_656:
        return self.rule.variation

Item_1067_Arg: TypeAlias = NonSpare_1947_Arg
class Item_1067(Item):
    cv_non_spare = NonSpare_1947

    @classmethod
    def create(cls, arg : Item_1067_Arg) -> "Item_1067":
        return cls._create(arg) # type: ignore

Variation_720_Arg: TypeAlias = RuleContent_210_Arg
class Variation_720(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_210

    @classmethod
    def create(cls, arg : Variation_720_Arg) -> "Variation_720":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_210:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_210:
        return self.rule.content

RuleVariation_709_Arg: TypeAlias = Variation_720_Arg
class RuleVariation_709(RuleVariationContextFree):
    cv_variation = Variation_720

    @classmethod
    def create(cls, arg : RuleVariation_709_Arg) -> "RuleVariation_709":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_720:
        return self.arg # type: ignore

NonSpare_1616_Arg: TypeAlias = RuleVariation_709_Arg
class NonSpare_1616(NonSpare):
    cv_name = "RSS"
    cv_title = "RS Status"
    cv_rule = RuleVariation_709

    @classmethod
    def create(cls, arg : NonSpare_1616_Arg) -> "NonSpare_1616":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_709:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_720:
        return self.rule.variation

Item_834_Arg: TypeAlias = NonSpare_1616_Arg
class Item_834(Item):
    cv_non_spare = NonSpare_1616

    @classmethod
    def create(cls, arg : Item_834_Arg) -> "Item_834":
        return cls._create(arg) # type: ignore

Content_407_Arg: TypeAlias = int
class Content_407(ContentTable):
    cv_values = {0: "Offline", 1: "Online"}

RuleContent_407_Arg: TypeAlias = Content_407_Arg
class RuleContent_407(RuleContentContextFree):
    cv_content = Content_407

    @property
    def content(self) -> Content_407:
        return self._get_content() # type: ignore

Variation_865_Arg: TypeAlias = RuleContent_407_Arg
class Variation_865(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_407

    @classmethod
    def create(cls, arg : Variation_865_Arg) -> "Variation_865":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_407:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_407:
        return self.rule.content

RuleVariation_835_Arg: TypeAlias = Variation_865_Arg
class RuleVariation_835(RuleVariationContextFree):
    cv_variation = Variation_865

    @classmethod
    def create(cls, arg : RuleVariation_835_Arg) -> "RuleVariation_835":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_865:
        return self.arg # type: ignore

NonSpare_1613_Arg: TypeAlias = RuleVariation_835_Arg
class NonSpare_1613(NonSpare):
    cv_name = "RSO"
    cv_title = "RS Operational"
    cv_rule = RuleVariation_835

    @classmethod
    def create(cls, arg : NonSpare_1613_Arg) -> "NonSpare_1613":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_835:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_865:
        return self.rule.variation

Item_833_Arg: TypeAlias = NonSpare_1613_Arg
class Item_833(Item):
    cv_non_spare = NonSpare_1613

    @classmethod
    def create(cls, arg : Item_833_Arg) -> "Item_833":
        return cls._create(arg) # type: ignore

Variation_1181_Arg_Group = Tuple[Union[RuleVariation_158_Arg, Tuple[Literal["RSI"], RuleVariation_158_Arg]], int, Union[RuleVariation_433_Arg, Tuple[Literal["RS1090"], RuleVariation_433_Arg]], Union[RuleVariation_556_Arg, Tuple[Literal["TX1030"], RuleVariation_556_Arg]], Union[RuleVariation_645_Arg, Tuple[Literal["TX1090"], RuleVariation_645_Arg]], Union[RuleVariation_709_Arg, Tuple[Literal["RSS"], RuleVariation_709_Arg]], Union[RuleVariation_835_Arg, Tuple[Literal["RSO"], RuleVariation_835_Arg]], int]
Variation_1181_Arg: TypeAlias = Union[int, Variation_1181_Arg_Group]
class Variation_1181(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_832, 8), (Item_0, 1), (Item_829, 1), (Item_1066, 1), (Item_1067, 1), (Item_834, 1), (Item_833, 1), (Item_27, 2)]
    cv_items_dict = {"RSI": RuleVariation_158, "RS1090": RuleVariation_433, "TX1030": RuleVariation_556, "TX1090": RuleVariation_645, "RSS": RuleVariation_709, "RSO": RuleVariation_835}

    @overload
    @classmethod
    def spec(cls, key : Literal["RSI"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RS1090"]) -> RuleVariation_433:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TX1030"]) -> RuleVariation_556:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TX1090"]) -> RuleVariation_645:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSS"]) -> RuleVariation_709:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSO"]) -> RuleVariation_835:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RSI"], Literal["RS1090"], Literal["TX1030"], Literal["TX1090"], Literal["RSS"], Literal["RSO"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RSI"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["RS1090"]) -> RuleVariation_433:
        ...
    @overload
    def get_item(self, key : Literal["TX1030"]) -> RuleVariation_556:
        ...
    @overload
    def get_item(self, key : Literal["TX1090"]) -> RuleVariation_645:
        ...
    @overload
    def get_item(self, key : Literal["RSS"]) -> RuleVariation_709:
        ...
    @overload
    def get_item(self, key : Literal["RSO"]) -> RuleVariation_835:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1181_Arg) -> 'Variation_1181':
        return cls._create(arg) # type: ignore

Variation_1419_Arg: TypeAlias = List[Variation_1181_Arg]
class Variation_1419(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1181

    @classmethod
    def create(cls, arg : Variation_1419_Arg) -> 'Variation_1419':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1181]:
        return self._get_list() # type: ignore

RuleVariation_1342_Arg: TypeAlias = Variation_1419_Arg
class RuleVariation_1342(RuleVariationContextFree):
    cv_variation = Variation_1419

    @classmethod
    def create(cls, arg : RuleVariation_1342_Arg) -> "RuleVariation_1342":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1419:
        return self.arg # type: ignore

NonSpare_521_Arg: TypeAlias = RuleVariation_1342_Arg
class NonSpare_521(NonSpare):
    cv_name = "552"
    cv_title = "Remote Sensor Detailed Status"
    cv_rule = RuleVariation_1342

    @classmethod
    def create(cls, arg : NonSpare_521_Arg) -> "NonSpare_521":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1342:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1419:
        return self.rule.variation

class UapItem_520(UapItem):
    cv_non_spare = NonSpare_521

Content_601_Arg: TypeAlias = int
class Content_601(ContentTable):
    cv_values = {1: "Warning", 2: "Faulted", 3: "Good"}

RuleContent_601_Arg: TypeAlias = Content_601_Arg
class RuleContent_601(RuleContentContextFree):
    cv_content = Content_601

    @property
    def content(self) -> Content_601:
        return self._get_content() # type: ignore

Variation_117_Arg: TypeAlias = RuleContent_601_Arg
class Variation_117(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_601

    @classmethod
    def create(cls, arg : Variation_117_Arg) -> "Variation_117":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_601:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_601:
        return self.rule.content

RuleVariation_117_Arg: TypeAlias = Variation_117_Arg
class RuleVariation_117(RuleVariationContextFree):
    cv_variation = Variation_117

    @classmethod
    def create(cls, arg : RuleVariation_117_Arg) -> "RuleVariation_117":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_117:
        return self.arg # type: ignore

Variation_770_Arg: TypeAlias = RuleContent_601_Arg
class Variation_770(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_601

    @classmethod
    def create(cls, arg : Variation_770_Arg) -> "Variation_770":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_601:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_601:
        return self.rule.content

RuleVariation_759_Arg: TypeAlias = Variation_770_Arg
class RuleVariation_759(RuleVariationContextFree):
    cv_variation = Variation_770

    @classmethod
    def create(cls, arg : RuleVariation_759_Arg) -> "RuleVariation_759":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_770:
        return self.arg # type: ignore

NonSpare_1567_Arg: TypeAlias = RuleVariation_117_Arg
class NonSpare_1567(NonSpare):
    cv_name = "REFTR1"
    cv_title = "Ref Trans 1 Status"
    cv_rule = RuleVariation_117

    @classmethod
    def create(cls, arg : NonSpare_1567_Arg) -> "NonSpare_1567":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_117:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_117:
        return self.rule.variation

Item_798_Arg: TypeAlias = NonSpare_1567_Arg
class Item_798(Item):
    cv_non_spare = NonSpare_1567

    @classmethod
    def create(cls, arg : Item_798_Arg) -> "Item_798":
        return cls._create(arg) # type: ignore

NonSpare_1568_Arg: TypeAlias = RuleVariation_759_Arg
class NonSpare_1568(NonSpare):
    cv_name = "REFTR2"
    cv_title = "Ref Trans 2 Status"
    cv_rule = RuleVariation_759

    @classmethod
    def create(cls, arg : NonSpare_1568_Arg) -> "NonSpare_1568":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_759:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_770:
        return self.rule.variation

Item_799_Arg: TypeAlias = NonSpare_1568_Arg
class Item_799(Item):
    cv_non_spare = NonSpare_1568

    @classmethod
    def create(cls, arg : Item_799_Arg) -> "Item_799":
        return cls._create(arg) # type: ignore

NonSpare_1569_Arg: TypeAlias = RuleVariation_117_Arg
class NonSpare_1569(NonSpare):
    cv_name = "REFTR3"
    cv_title = "Ref Trans 3 Status"
    cv_rule = RuleVariation_117

    @classmethod
    def create(cls, arg : NonSpare_1569_Arg) -> "NonSpare_1569":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_117:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_117:
        return self.rule.variation

Item_800_Arg: TypeAlias = NonSpare_1569_Arg
class Item_800(Item):
    cv_non_spare = NonSpare_1569

    @classmethod
    def create(cls, arg : Item_800_Arg) -> "Item_800":
        return cls._create(arg) # type: ignore

NonSpare_1570_Arg: TypeAlias = RuleVariation_759_Arg
class NonSpare_1570(NonSpare):
    cv_name = "REFTR4"
    cv_title = "Ref Trans 4 Status"
    cv_rule = RuleVariation_759

    @classmethod
    def create(cls, arg : NonSpare_1570_Arg) -> "NonSpare_1570":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_759:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_770:
        return self.rule.variation

Item_801_Arg: TypeAlias = NonSpare_1570_Arg
class Item_801(Item):
    cv_non_spare = NonSpare_1570

    @classmethod
    def create(cls, arg : Item_801_Arg) -> "Item_801":
        return cls._create(arg) # type: ignore

Variation_1372_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_117_Arg, Tuple[Literal["REFTR1"], RuleVariation_117_Arg]], int, Union[RuleVariation_759_Arg, Tuple[Literal["REFTR2"], RuleVariation_759_Arg]], int, None]]
Variation_1372_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_117_Arg, Tuple[Literal["REFTR3"], RuleVariation_117_Arg]], int, Union[RuleVariation_759_Arg, Tuple[Literal["REFTR4"], RuleVariation_759_Arg]], int, None]]
Variation_1372_Arg: TypeAlias = Union[
    Tuple[Variation_1372_Arg_Group_1],
    Tuple[Variation_1372_Arg_Group_1, Variation_1372_Arg_Group_2],
]
class Variation_1372(Extended):
    cv_items_list = [[(Item_798, 2), (Item_12, 2), (Item_799, 2), (Item_26, 1), None], [(Item_800, 2), (Item_12, 2), (Item_801, 2), (Item_26, 1), None]]

    @classmethod
    def create(cls, arg : Variation_1372_Arg) -> 'Variation_1372':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["REFTR1"]) -> RuleVariation_117:
        ...
    @overload
    def get_item(self, key : Literal["REFTR2"]) -> RuleVariation_759:
        ...
    @overload
    def get_item(self, key : Literal["REFTR3"]) -> Optional[RuleVariation_117]:
        ...
    @overload
    def get_item(self, key : Literal["REFTR4"]) -> Optional[RuleVariation_759]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1295_Arg: TypeAlias = Variation_1372_Arg
class RuleVariation_1295(RuleVariationContextFree):
    cv_variation = Variation_1372

    @classmethod
    def create(cls, arg : RuleVariation_1295_Arg) -> "RuleVariation_1295":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1372:
        return self.arg # type: ignore

NonSpare_522_Arg: TypeAlias = RuleVariation_1295_Arg
class NonSpare_522(NonSpare):
    cv_name = "553"
    cv_title = "Reference Transponder Detailed Status"
    cv_rule = RuleVariation_1295

    @classmethod
    def create(cls, arg : NonSpare_522_Arg) -> "NonSpare_522":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1295:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1372:
        return self.rule.variation

class UapItem_521(UapItem):
    cv_non_spare = NonSpare_522

Content_698_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_698(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.6763806343078613e-7
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_698_Arg: TypeAlias = Content_698_Arg
class RuleContent_698(RuleContentContextFree):
    cv_content = Content_698

    @property
    def content(self) -> Content_698:
        return self._get_content() # type: ignore

Variation_378_Arg: TypeAlias = RuleContent_698_Arg
class Variation_378(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_698

    @classmethod
    def create(cls, arg : Variation_378_Arg) -> "Variation_378":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_698:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_698:
        return self.rule.content

RuleVariation_371_Arg: TypeAlias = Variation_378_Arg
class RuleVariation_371(RuleVariationContextFree):
    cv_variation = Variation_378

    @classmethod
    def create(cls, arg : RuleVariation_371_Arg) -> "RuleVariation_371":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_378:
        return self.arg # type: ignore

NonSpare_1145_Arg: TypeAlias = RuleVariation_371_Arg
class NonSpare_1145(NonSpare):
    cv_name = "LAT"
    cv_title = "Latitude"
    cv_rule = RuleVariation_371

    @classmethod
    def create(cls, arg : NonSpare_1145_Arg) -> "NonSpare_1145":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_371:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_378:
        return self.rule.variation

Item_463_Arg: TypeAlias = NonSpare_1145_Arg
class Item_463(Item):
    cv_non_spare = NonSpare_1145

    @classmethod
    def create(cls, arg : Item_463_Arg) -> "Item_463":
        return cls._create(arg) # type: ignore

Content_697_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_697(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.6763806343078613e-7
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_697_Arg: TypeAlias = Content_697_Arg
class RuleContent_697(RuleContentContextFree):
    cv_content = Content_697

    @property
    def content(self) -> Content_697:
        return self._get_content() # type: ignore

Variation_377_Arg: TypeAlias = RuleContent_697_Arg
class Variation_377(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_697

    @classmethod
    def create(cls, arg : Variation_377_Arg) -> "Variation_377":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_697:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_697:
        return self.rule.content

RuleVariation_370_Arg: TypeAlias = Variation_377_Arg
class RuleVariation_370(RuleVariationContextFree):
    cv_variation = Variation_377

    @classmethod
    def create(cls, arg : RuleVariation_370_Arg) -> "RuleVariation_370":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_377:
        return self.arg # type: ignore

NonSpare_1174_Arg: TypeAlias = RuleVariation_370_Arg
class NonSpare_1174(NonSpare):
    cv_name = "LON"
    cv_title = "Longitude"
    cv_rule = RuleVariation_370

    @classmethod
    def create(cls, arg : NonSpare_1174_Arg) -> "NonSpare_1174":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_370:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_377:
        return self.rule.variation

Item_490_Arg: TypeAlias = NonSpare_1174_Arg
class Item_490(Item):
    cv_non_spare = NonSpare_1174

    @classmethod
    def create(cls, arg : Item_490_Arg) -> "Item_490":
        return cls._create(arg) # type: ignore

Variation_1124_Arg_Group = Tuple[Union[RuleVariation_371_Arg, Tuple[Literal["LAT"], RuleVariation_371_Arg]], Union[RuleVariation_370_Arg, Tuple[Literal["LON"], RuleVariation_370_Arg]]]
Variation_1124_Arg: TypeAlias = Union[int, Variation_1124_Arg_Group]
class Variation_1124(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_463, 32), (Item_490, 32)]
    cv_items_dict = {"LAT": RuleVariation_371, "LON": RuleVariation_370}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_371:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_370:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_371:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_370:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1124_Arg) -> 'Variation_1124':
        return cls._create(arg) # type: ignore

RuleVariation_1081_Arg: TypeAlias = Variation_1124_Arg
class RuleVariation_1081(RuleVariationContextFree):
    cv_variation = Variation_1124

    @classmethod
    def create(cls, arg : RuleVariation_1081_Arg) -> "RuleVariation_1081":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1124:
        return self.arg # type: ignore

NonSpare_525_Arg: TypeAlias = RuleVariation_1081_Arg
class NonSpare_525(NonSpare):
    cv_name = "600"
    cv_title = "Position of the MLT System Reference Point"
    cv_rule = RuleVariation_1081

    @classmethod
    def create(cls, arg : NonSpare_525_Arg) -> "NonSpare_525":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1081:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1124:
        return self.rule.variation

class UapItem_524(UapItem):
    cv_non_spare = NonSpare_525

Content_657_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_657(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.25
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_657_Arg: TypeAlias = Content_657_Arg
class RuleContent_657(RuleContentContextFree):
    cv_content = Content_657

    @property
    def content(self) -> Content_657:
        return self._get_content() # type: ignore

Variation_275_Arg: TypeAlias = RuleContent_657_Arg
class Variation_275(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_657

    @classmethod
    def create(cls, arg : Variation_275_Arg) -> "Variation_275":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_657:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_657:
        return self.rule.content

RuleVariation_268_Arg: TypeAlias = Variation_275_Arg
class RuleVariation_268(RuleVariationContextFree):
    cv_variation = Variation_275

    @classmethod
    def create(cls, arg : RuleVariation_268_Arg) -> "RuleVariation_268":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_275:
        return self.arg # type: ignore

NonSpare_533_Arg: TypeAlias = RuleVariation_268_Arg
class NonSpare_533(NonSpare):
    cv_name = "610"
    cv_title = "Height of the MLT System Reference Point"
    cv_rule = RuleVariation_268

    @classmethod
    def create(cls, arg : NonSpare_533_Arg) -> "NonSpare_533":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_268:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_275:
        return self.rule.variation

class UapItem_532(UapItem):
    cv_non_spare = NonSpare_533

Content_623_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_623(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.0
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_623_Arg: TypeAlias = Content_623_Arg
class RuleContent_623(RuleContentContextFree):
    cv_content = Content_623

    @property
    def content(self) -> Content_623:
        return self._get_content() # type: ignore

Variation_207_Arg: TypeAlias = RuleContent_623_Arg
class Variation_207(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_623

    @classmethod
    def create(cls, arg : Variation_207_Arg) -> "Variation_207":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_623:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_623:
        return self.rule.content

RuleVariation_200_Arg: TypeAlias = Variation_207_Arg
class RuleVariation_200(RuleVariationContextFree):
    cv_variation = Variation_207

    @classmethod
    def create(cls, arg : RuleVariation_200_Arg) -> "RuleVariation_200":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_207:
        return self.arg # type: ignore

NonSpare_536_Arg: TypeAlias = RuleVariation_200_Arg
class NonSpare_536(NonSpare):
    cv_name = "620"
    cv_title = "WGS-84 Undulation"
    cv_rule = RuleVariation_200

    @classmethod
    def create(cls, arg : NonSpare_536_Arg) -> "NonSpare_536":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_200:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_207:
        return self.rule.variation

class UapItem_535(UapItem):
    cv_non_spare = NonSpare_536

Record_39_Arg = TypedDict('Record_39_Arg', {
    "010": NonSpare_44_Arg,
    "000": NonSpare_9_Arg,
    "140": NonSpare_324_Arg,
    "550": NonSpare_519_Arg,
    "551": NonSpare_520_Arg,
    "552": NonSpare_521_Arg,
    "553": NonSpare_522_Arg,
    "600": NonSpare_525_Arg,
    "610": NonSpare_533_Arg,
    "620": NonSpare_536_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_39(Record):
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_44, UapItem_9, UapItem_324, UapItem_518, UapItem_519, UapItem_520, UapItem_521, UapItem_524, UapItem_532, UapItem_535, UapItem_544, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_44, "000": NonSpare_9, "140": NonSpare_324, "550": NonSpare_519, "551": NonSpare_520, "552": NonSpare_521, "553": NonSpare_522, "600": NonSpare_525, "610": NonSpare_533, "620": NonSpare_536, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_44:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_9:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_324:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["550"]) -> NonSpare_519:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["551"]) -> NonSpare_520:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["552"]) -> NonSpare_521:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["553"]) -> NonSpare_522:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["600"]) -> NonSpare_525:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["610"]) -> NonSpare_533:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["620"]) -> NonSpare_536:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["140"], Literal["550"], Literal["551"], Literal["552"], Literal["553"], Literal["600"], Literal["610"], Literal["620"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_44]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_9]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_324]:
        ...
    @overload
    def get_item(self, key : Literal["550"]) -> Optional[NonSpare_519]:
        ...
    @overload
    def get_item(self, key : Literal["551"]) -> Optional[NonSpare_520]:
        ...
    @overload
    def get_item(self, key : Literal["552"]) -> Optional[NonSpare_521]:
        ...
    @overload
    def get_item(self, key : Literal["553"]) -> Optional[NonSpare_522]:
        ...
    @overload
    def get_item(self, key : Literal["600"]) -> Optional[NonSpare_525]:
        ...
    @overload
    def get_item(self, key : Literal["610"]) -> Optional[NonSpare_533]:
        ...
    @overload
    def get_item(self, key : Literal["620"]) -> Optional[NonSpare_536]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_44_Arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_9_Arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_324_Arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["550"], val : NonSpare_519_Arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["551"], val : NonSpare_520_Arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["552"], val : NonSpare_521_Arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["553"], val : NonSpare_522_Arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["600"], val : NonSpare_525_Arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["610"], val : NonSpare_533_Arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["620"], val : NonSpare_536_Arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_39':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["550"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["551"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["552"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["553"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["600"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["610"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["620"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_39':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_39_Arg) -> 'Record_39':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_39", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_35_Arg: TypeAlias = Record_39
class Uap_35(UapSingle):
    cv_record = Record_39

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_39]]:
        return cls._parse(bs)

class Asterix_19(AstCat):
    cv_category = 19
    cv_edition = (1, 3)
    cv_uap = Uap_35

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_35_Arg]) -> "Asterix_19":
        return cls._create(records) # type: ignore

NonSpare_41_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_41(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_41_Arg) -> "NonSpare_41":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_41(UapItem):
    cv_non_spare = NonSpare_41

Content_379_Arg: TypeAlias = int
class Content_379(ContentTable):
    cv_values = {0: "Non-Mode S 1090MHz multilateration", 1: "No Non-Mode S 1090MHz multilat"}

RuleContent_379_Arg: TypeAlias = Content_379_Arg
class RuleContent_379(RuleContentContextFree):
    cv_content = Content_379

    @property
    def content(self) -> Content_379:
        return self._get_content() # type: ignore

Variation_65_Arg: TypeAlias = RuleContent_379_Arg
class Variation_65(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_379

    @classmethod
    def create(cls, arg : Variation_65_Arg) -> "Variation_65":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_379:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_379:
        return self.rule.content

RuleVariation_65_Arg: TypeAlias = Variation_65_Arg
class RuleVariation_65(RuleVariationContextFree):
    cv_variation = Variation_65

    @classmethod
    def create(cls, arg : RuleVariation_65_Arg) -> "RuleVariation_65":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_65:
        return self.arg # type: ignore

Content_292_Arg: TypeAlias = int
class Content_292(ContentTable):
    cv_values = {0: "Mode-S 1090 MHz multilateration", 1: "No Mode-S 1090 MHz multilateration"}

RuleContent_292_Arg: TypeAlias = Content_292_Arg
class RuleContent_292(RuleContentContextFree):
    cv_content = Content_292

    @property
    def content(self) -> Content_292:
        return self._get_content() # type: ignore

Variation_436_Arg: TypeAlias = RuleContent_292_Arg
class Variation_436(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_292

    @classmethod
    def create(cls, arg : Variation_436_Arg) -> "Variation_436":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_292:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_292:
        return self.rule.content

RuleVariation_425_Arg: TypeAlias = Variation_436_Arg
class RuleVariation_425(RuleVariationContextFree):
    cv_variation = Variation_436

    @classmethod
    def create(cls, arg : RuleVariation_425_Arg) -> "RuleVariation_425":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_436:
        return self.arg # type: ignore

Content_221_Arg: TypeAlias = int
class Content_221(ContentTable):
    cv_values = {0: "HF multilateration", 1: "No HF multilateration"}

RuleContent_221_Arg: TypeAlias = Content_221_Arg
class RuleContent_221(RuleContentContextFree):
    cv_content = Content_221

    @property
    def content(self) -> Content_221:
        return self._get_content() # type: ignore

Variation_532_Arg: TypeAlias = RuleContent_221_Arg
class Variation_532(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_221

    @classmethod
    def create(cls, arg : Variation_532_Arg) -> "Variation_532":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_221:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_221:
        return self.rule.content

RuleVariation_521_Arg: TypeAlias = Variation_532_Arg
class RuleVariation_521(RuleVariationContextFree):
    cv_variation = Variation_532

    @classmethod
    def create(cls, arg : RuleVariation_521_Arg) -> "RuleVariation_521":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_532:
        return self.arg # type: ignore

Content_554_Arg: TypeAlias = int
class Content_554(ContentTable):
    cv_values = {0: "VDL Mode 4 multilateration", 1: "No VDL Mode 4 multilateration"}

RuleContent_554_Arg: TypeAlias = Content_554_Arg
class RuleContent_554(RuleContentContextFree):
    cv_content = Content_554

    @property
    def content(self) -> Content_554:
        return self._get_content() # type: ignore

Variation_669_Arg: TypeAlias = RuleContent_554_Arg
class Variation_669(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_554

    @classmethod
    def create(cls, arg : Variation_669_Arg) -> "Variation_669":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_554:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_554:
        return self.rule.content

RuleVariation_658_Arg: TypeAlias = Variation_669_Arg
class RuleVariation_658(RuleVariationContextFree):
    cv_variation = Variation_669

    @classmethod
    def create(cls, arg : RuleVariation_658_Arg) -> "RuleVariation_658":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_669:
        return self.arg # type: ignore

Content_527_Arg: TypeAlias = int
class Content_527(ContentTable):
    cv_values = {0: "UAT multilateration", 1: "No UAT multilateration"}

RuleContent_527_Arg: TypeAlias = Content_527_Arg
class RuleContent_527(RuleContentContextFree):
    cv_content = Content_527

    @property
    def content(self) -> Content_527:
        return self._get_content() # type: ignore

Variation_756_Arg: TypeAlias = RuleContent_527_Arg
class Variation_756(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_527

    @classmethod
    def create(cls, arg : Variation_756_Arg) -> "Variation_756":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_527:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_527:
        return self.rule.content

RuleVariation_745_Arg: TypeAlias = Variation_756_Arg
class RuleVariation_745(RuleVariationContextFree):
    cv_variation = Variation_756

    @classmethod
    def create(cls, arg : RuleVariation_745_Arg) -> "RuleVariation_745":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_756:
        return self.arg # type: ignore

Content_72_Arg: TypeAlias = int
class Content_72(ContentTable):
    cv_values = {0: "DME/TACAN multilateration", 1: "No DME/TACAN multilateration"}

RuleContent_72_Arg: TypeAlias = Content_72_Arg
class RuleContent_72(RuleContentContextFree):
    cv_content = Content_72

    @property
    def content(self) -> Content_72:
        return self._get_content() # type: ignore

Variation_824_Arg: TypeAlias = RuleContent_72_Arg
class Variation_824(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_72

    @classmethod
    def create(cls, arg : Variation_824_Arg) -> "Variation_824":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_72:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_72:
        return self.rule.content

RuleVariation_794_Arg: TypeAlias = Variation_824_Arg
class RuleVariation_794(RuleVariationContextFree):
    cv_variation = Variation_824

    @classmethod
    def create(cls, arg : RuleVariation_794_Arg) -> "RuleVariation_794":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_824:
        return self.arg # type: ignore

Content_414_Arg: TypeAlias = int
class Content_414(ContentTable):
    cv_values = {0: "Other Technology Multilateration", 1: "No Other Technology Multilateration"}

RuleContent_414_Arg: TypeAlias = Content_414_Arg
class RuleContent_414(RuleContentContextFree):
    cv_content = Content_414

    @property
    def content(self) -> Content_414:
        return self._get_content() # type: ignore

Variation_941_Arg: TypeAlias = RuleContent_414_Arg
class Variation_941(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_414

    @classmethod
    def create(cls, arg : Variation_941_Arg) -> "Variation_941":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_414:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_414:
        return self.rule.content

RuleVariation_911_Arg: TypeAlias = Variation_941_Arg
class RuleVariation_911(RuleVariationContextFree):
    cv_variation = Variation_941

    @classmethod
    def create(cls, arg : RuleVariation_911_Arg) -> "RuleVariation_911":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_941:
        return self.arg # type: ignore

Content_439_Arg: TypeAlias = int
class Content_439(ContentTable):
    cv_values = {0: "Report from target transponder", 1: "Report from field monitor (element transponder)"}

RuleContent_439_Arg: TypeAlias = Content_439_Arg
class RuleContent_439(RuleContentContextFree):
    cv_content = Content_439

    @property
    def content(self) -> Content_439:
        return self._get_content() # type: ignore

Variation_73_Arg: TypeAlias = RuleContent_439_Arg
class Variation_73(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_439

    @classmethod
    def create(cls, arg : Variation_73_Arg) -> "Variation_73":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_439:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_439:
        return self.rule.content

RuleVariation_73_Arg: TypeAlias = Variation_73_Arg
class RuleVariation_73(RuleVariationContextFree):
    cv_variation = Variation_73

    @classmethod
    def create(cls, arg : RuleVariation_73_Arg) -> "RuleVariation_73":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_73:
        return self.arg # type: ignore

Variation_400_Arg: TypeAlias = RuleContent_13_Arg
class Variation_400(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_13

    @classmethod
    def create(cls, arg : Variation_400_Arg) -> "Variation_400":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_13:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_13:
        return self.rule.content

RuleVariation_389_Arg: TypeAlias = Variation_400_Arg
class RuleVariation_389(RuleVariationContextFree):
    cv_variation = Variation_400

    @classmethod
    def create(cls, arg : RuleVariation_389_Arg) -> "RuleVariation_389":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_400:
        return self.arg # type: ignore

Variation_509_Arg: TypeAlias = RuleContent_53_Arg
class Variation_509(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_53

    @classmethod
    def create(cls, arg : Variation_509_Arg) -> "Variation_509":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_53:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_53:
        return self.rule.content

RuleVariation_498_Arg: TypeAlias = Variation_509_Arg
class RuleVariation_498(RuleVariationContextFree):
    cv_variation = Variation_509

    @classmethod
    def create(cls, arg : RuleVariation_498_Arg) -> "RuleVariation_498":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_509:
        return self.arg # type: ignore

Variation_665_Arg: TypeAlias = RuleContent_519_Arg
class Variation_665(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_519

    @classmethod
    def create(cls, arg : Variation_665_Arg) -> "Variation_665":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_519:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_519:
        return self.rule.content

RuleVariation_654_Arg: TypeAlias = Variation_665_Arg
class RuleVariation_654(RuleVariationContextFree):
    cv_variation = Variation_665

    @classmethod
    def create(cls, arg : RuleVariation_654_Arg) -> "RuleVariation_654":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_665:
        return self.arg # type: ignore

Variation_734_Arg: TypeAlias = RuleContent_304_Arg
class Variation_734(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_304

    @classmethod
    def create(cls, arg : Variation_734_Arg) -> "Variation_734":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_304:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_304:
        return self.rule.content

RuleVariation_723_Arg: TypeAlias = Variation_734_Arg
class RuleVariation_723(RuleVariationContextFree):
    cv_variation = Variation_734

    @classmethod
    def create(cls, arg : RuleVariation_723_Arg) -> "RuleVariation_723":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_734:
        return self.arg # type: ignore

Variation_817_Arg: TypeAlias = RuleContent_19_Arg
class Variation_817(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_19

    @classmethod
    def create(cls, arg : Variation_817_Arg) -> "Variation_817":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_19:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_19:
        return self.rule.content

RuleVariation_787_Arg: TypeAlias = Variation_817_Arg
class RuleVariation_787(RuleVariationContextFree):
    cv_variation = Variation_817

    @classmethod
    def create(cls, arg : RuleVariation_787_Arg) -> "RuleVariation_787":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_817:
        return self.arg # type: ignore

Variation_917_Arg: TypeAlias = RuleContent_154_Arg
class Variation_917(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_154

    @classmethod
    def create(cls, arg : Variation_917_Arg) -> "Variation_917":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_154:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_154:
        return self.rule.content

RuleVariation_887_Arg: TypeAlias = Variation_917_Arg
class RuleVariation_887(RuleVariationContextFree):
    cv_variation = Variation_917

    @classmethod
    def create(cls, arg : RuleVariation_887_Arg) -> "RuleVariation_887":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_917:
        return self.arg # type: ignore

NonSpare_1748_Arg: TypeAlias = RuleVariation_65_Arg
class NonSpare_1748(NonSpare):
    cv_name = "SSR"
    cv_title = ""
    cv_rule = RuleVariation_65

    @classmethod
    def create(cls, arg : NonSpare_1748_Arg) -> "NonSpare_1748":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_65:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_65:
        return self.rule.variation

Item_924_Arg: TypeAlias = NonSpare_1748_Arg
class Item_924(Item):
    cv_non_spare = NonSpare_1748

    @classmethod
    def create(cls, arg : Item_924_Arg) -> "Item_924":
        return cls._create(arg) # type: ignore

NonSpare_1311_Arg: TypeAlias = RuleVariation_425_Arg
class NonSpare_1311(NonSpare):
    cv_name = "MS"
    cv_title = ""
    cv_rule = RuleVariation_425

    @classmethod
    def create(cls, arg : NonSpare_1311_Arg) -> "NonSpare_1311":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_425:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_436:
        return self.rule.variation

Item_583_Arg: TypeAlias = NonSpare_1311_Arg
class Item_583(Item):
    cv_non_spare = NonSpare_1311

    @classmethod
    def create(cls, arg : Item_583_Arg) -> "Item_583":
        return cls._create(arg) # type: ignore

NonSpare_1057_Arg: TypeAlias = RuleVariation_521_Arg
class NonSpare_1057(NonSpare):
    cv_name = "HF"
    cv_title = ""
    cv_rule = RuleVariation_521

    @classmethod
    def create(cls, arg : NonSpare_1057_Arg) -> "NonSpare_1057":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_521:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_532:
        return self.rule.variation

Item_389_Arg: TypeAlias = NonSpare_1057_Arg
class Item_389(Item):
    cv_non_spare = NonSpare_1057

    @classmethod
    def create(cls, arg : Item_389_Arg) -> "Item_389":
        return cls._create(arg) # type: ignore

NonSpare_2022_Arg: TypeAlias = RuleVariation_658_Arg
class NonSpare_2022(NonSpare):
    cv_name = "VDL4"
    cv_title = ""
    cv_rule = RuleVariation_658

    @classmethod
    def create(cls, arg : NonSpare_2022_Arg) -> "NonSpare_2022":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_658:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_669:
        return self.rule.variation

Item_1137_Arg: TypeAlias = NonSpare_2022_Arg
class Item_1137(Item):
    cv_non_spare = NonSpare_2022

    @classmethod
    def create(cls, arg : Item_1137_Arg) -> "Item_1137":
        return cls._create(arg) # type: ignore

NonSpare_1968_Arg: TypeAlias = RuleVariation_745_Arg
class NonSpare_1968(NonSpare):
    cv_name = "UAT"
    cv_title = ""
    cv_rule = RuleVariation_745

    @classmethod
    def create(cls, arg : NonSpare_1968_Arg) -> "NonSpare_1968":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_745:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_756:
        return self.rule.variation

Item_1087_Arg: TypeAlias = NonSpare_1968_Arg
class Item_1087(Item):
    cv_non_spare = NonSpare_1968

    @classmethod
    def create(cls, arg : Item_1087_Arg) -> "Item_1087":
        return cls._create(arg) # type: ignore

NonSpare_882_Arg: TypeAlias = RuleVariation_794_Arg
class NonSpare_882(NonSpare):
    cv_name = "DME"
    cv_title = ""
    cv_rule = RuleVariation_794

    @classmethod
    def create(cls, arg : NonSpare_882_Arg) -> "NonSpare_882":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_794:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_824:
        return self.rule.variation

Item_264_Arg: TypeAlias = NonSpare_882_Arg
class Item_264(Item):
    cv_non_spare = NonSpare_882

    @classmethod
    def create(cls, arg : Item_264_Arg) -> "Item_264":
        return cls._create(arg) # type: ignore

NonSpare_1396_Arg: TypeAlias = RuleVariation_911_Arg
class NonSpare_1396(NonSpare):
    cv_name = "OT"
    cv_title = ""
    cv_rule = RuleVariation_911

    @classmethod
    def create(cls, arg : NonSpare_1396_Arg) -> "NonSpare_1396":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_911:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_941:
        return self.rule.variation

Item_660_Arg: TypeAlias = NonSpare_1396_Arg
class Item_660(Item):
    cv_non_spare = NonSpare_1396

    @classmethod
    def create(cls, arg : Item_660_Arg) -> "Item_660":
        return cls._create(arg) # type: ignore

NonSpare_1526_Arg: TypeAlias = RuleVariation_73_Arg
class NonSpare_1526(NonSpare):
    cv_name = "RAB"
    cv_title = ""
    cv_rule = RuleVariation_73

    @classmethod
    def create(cls, arg : NonSpare_1526_Arg) -> "NonSpare_1526":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_73:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_73:
        return self.rule.variation

Item_762_Arg: TypeAlias = NonSpare_1526_Arg
class Item_762(Item):
    cv_non_spare = NonSpare_1526

    @classmethod
    def create(cls, arg : Item_762_Arg) -> "Item_762":
        return cls._create(arg) # type: ignore

NonSpare_1728_Arg: TypeAlias = RuleVariation_389_Arg
class NonSpare_1728(NonSpare):
    cv_name = "SPI"
    cv_title = ""
    cv_rule = RuleVariation_389

    @classmethod
    def create(cls, arg : NonSpare_1728_Arg) -> "NonSpare_1728":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_389:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_400:
        return self.rule.variation

Item_907_Arg: TypeAlias = NonSpare_1728_Arg
class Item_907(Item):
    cv_non_spare = NonSpare_1728

    @classmethod
    def create(cls, arg : Item_907_Arg) -> "Item_907":
        return cls._create(arg) # type: ignore

NonSpare_727_Arg: TypeAlias = RuleVariation_498_Arg
class NonSpare_727(NonSpare):
    cv_name = "CHN"
    cv_title = ""
    cv_rule = RuleVariation_498

    @classmethod
    def create(cls, arg : NonSpare_727_Arg) -> "NonSpare_727":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_498:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_509:
        return self.rule.variation

Item_155_Arg: TypeAlias = NonSpare_727_Arg
class Item_155(Item):
    cv_non_spare = NonSpare_727

    @classmethod
    def create(cls, arg : Item_155_Arg) -> "Item_155":
        return cls._create(arg) # type: ignore

NonSpare_1020_Arg: TypeAlias = RuleVariation_654_Arg
class NonSpare_1020(NonSpare):
    cv_name = "GBS"
    cv_title = ""
    cv_rule = RuleVariation_654

    @classmethod
    def create(cls, arg : NonSpare_1020_Arg) -> "NonSpare_1020":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_654:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_665:
        return self.rule.variation

Item_364_Arg: TypeAlias = NonSpare_1020_Arg
class Item_364(Item):
    cv_non_spare = NonSpare_1020

    @classmethod
    def create(cls, arg : Item_364_Arg) -> "Item_364":
        return cls._create(arg) # type: ignore

NonSpare_822_Arg: TypeAlias = RuleVariation_723_Arg
class NonSpare_822(NonSpare):
    cv_name = "CRT"
    cv_title = ""
    cv_rule = RuleVariation_723

    @classmethod
    def create(cls, arg : NonSpare_822_Arg) -> "NonSpare_822":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_723:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_734:
        return self.rule.variation

Item_214_Arg: TypeAlias = NonSpare_822_Arg
class Item_214(Item):
    cv_non_spare = NonSpare_822

    @classmethod
    def create(cls, arg : Item_214_Arg) -> "Item_214":
        return cls._create(arg) # type: ignore

NonSpare_1718_Arg: TypeAlias = RuleVariation_787_Arg
class NonSpare_1718(NonSpare):
    cv_name = "SIM"
    cv_title = ""
    cv_rule = RuleVariation_787

    @classmethod
    def create(cls, arg : NonSpare_1718_Arg) -> "NonSpare_1718":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_787:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_817:
        return self.rule.variation

Item_899_Arg: TypeAlias = NonSpare_1718_Arg
class Item_899(Item):
    cv_non_spare = NonSpare_1718

    @classmethod
    def create(cls, arg : Item_899_Arg) -> "Item_899":
        return cls._create(arg) # type: ignore

NonSpare_1929_Arg: TypeAlias = RuleVariation_887_Arg
class NonSpare_1929(NonSpare):
    cv_name = "TST"
    cv_title = ""
    cv_rule = RuleVariation_887

    @classmethod
    def create(cls, arg : NonSpare_1929_Arg) -> "NonSpare_1929":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_887:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_917:
        return self.rule.variation

Item_1052_Arg: TypeAlias = NonSpare_1929_Arg
class Item_1052(Item):
    cv_non_spare = NonSpare_1929

    @classmethod
    def create(cls, arg : Item_1052_Arg) -> "Item_1052":
        return cls._create(arg) # type: ignore

Variation_1376_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_65_Arg, Tuple[Literal["SSR"], RuleVariation_65_Arg]], Union[RuleVariation_425_Arg, Tuple[Literal["MS"], RuleVariation_425_Arg]], Union[RuleVariation_521_Arg, Tuple[Literal["HF"], RuleVariation_521_Arg]], Union[RuleVariation_658_Arg, Tuple[Literal["VDL4"], RuleVariation_658_Arg]], Union[RuleVariation_745_Arg, Tuple[Literal["UAT"], RuleVariation_745_Arg]], Union[RuleVariation_794_Arg, Tuple[Literal["DME"], RuleVariation_794_Arg]], Union[RuleVariation_911_Arg, Tuple[Literal["OT"], RuleVariation_911_Arg]], None]]
Variation_1376_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_73_Arg, Tuple[Literal["RAB"], RuleVariation_73_Arg]], Union[RuleVariation_389_Arg, Tuple[Literal["SPI"], RuleVariation_389_Arg]], Union[RuleVariation_498_Arg, Tuple[Literal["CHN"], RuleVariation_498_Arg]], Union[RuleVariation_654_Arg, Tuple[Literal["GBS"], RuleVariation_654_Arg]], Union[RuleVariation_723_Arg, Tuple[Literal["CRT"], RuleVariation_723_Arg]], Union[RuleVariation_787_Arg, Tuple[Literal["SIM"], RuleVariation_787_Arg]], Union[RuleVariation_887_Arg, Tuple[Literal["TST"], RuleVariation_887_Arg]], None]]
Variation_1376_Arg: TypeAlias = Union[
    Tuple[Variation_1376_Arg_Group_1],
    Tuple[Variation_1376_Arg_Group_1, Variation_1376_Arg_Group_2],
]
class Variation_1376(Extended):
    cv_items_list = [[(Item_924, 1), (Item_583, 1), (Item_389, 1), (Item_1137, 1), (Item_1087, 1), (Item_264, 1), (Item_660, 1), None], [(Item_762, 1), (Item_907, 1), (Item_155, 1), (Item_364, 1), (Item_214, 1), (Item_899, 1), (Item_1052, 1), None]]

    @classmethod
    def create(cls, arg : Variation_1376_Arg) -> 'Variation_1376':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["SSR"]) -> RuleVariation_65:
        ...
    @overload
    def get_item(self, key : Literal["MS"]) -> RuleVariation_425:
        ...
    @overload
    def get_item(self, key : Literal["HF"]) -> RuleVariation_521:
        ...
    @overload
    def get_item(self, key : Literal["VDL4"]) -> RuleVariation_658:
        ...
    @overload
    def get_item(self, key : Literal["UAT"]) -> RuleVariation_745:
        ...
    @overload
    def get_item(self, key : Literal["DME"]) -> RuleVariation_794:
        ...
    @overload
    def get_item(self, key : Literal["OT"]) -> RuleVariation_911:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> Optional[RuleVariation_73]:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> Optional[RuleVariation_389]:
        ...
    @overload
    def get_item(self, key : Literal["CHN"]) -> Optional[RuleVariation_498]:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> Optional[RuleVariation_654]:
        ...
    @overload
    def get_item(self, key : Literal["CRT"]) -> Optional[RuleVariation_723]:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_787]:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_887]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1299_Arg: TypeAlias = Variation_1376_Arg
class RuleVariation_1299(RuleVariationContextFree):
    cv_variation = Variation_1376

    @classmethod
    def create(cls, arg : RuleVariation_1299_Arg) -> "RuleVariation_1299":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1376:
        return self.arg # type: ignore

NonSpare_85_Arg: TypeAlias = RuleVariation_1299_Arg
class NonSpare_85(NonSpare):
    cv_name = "020"
    cv_title = "Target Report Descriptor"
    cv_rule = RuleVariation_1299

    @classmethod
    def create(cls, arg : NonSpare_85_Arg) -> "NonSpare_85":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1299:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1376:
        return self.rule.variation

class UapItem_85(UapItem):
    cv_non_spare = NonSpare_85

NonSpare_323_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_323(NonSpare):
    cv_name = "140"
    cv_title = "Time of Day"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_323_Arg) -> "NonSpare_323":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_323(UapItem):
    cv_non_spare = NonSpare_323

NonSpare_1144_Arg: TypeAlias = RuleVariation_369_Arg
class NonSpare_1144(NonSpare):
    cv_name = "LAT"
    cv_title = "Latitude"
    cv_rule = RuleVariation_369

    @classmethod
    def create(cls, arg : NonSpare_1144_Arg) -> "NonSpare_1144":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_369:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_376:
        return self.rule.variation

Item_462_Arg: TypeAlias = NonSpare_1144_Arg
class Item_462(Item):
    cv_non_spare = NonSpare_1144

    @classmethod
    def create(cls, arg : Item_462_Arg) -> "Item_462":
        return cls._create(arg) # type: ignore

NonSpare_1173_Arg: TypeAlias = RuleVariation_368_Arg
class NonSpare_1173(NonSpare):
    cv_name = "LON"
    cv_title = "Longitude"
    cv_rule = RuleVariation_368

    @classmethod
    def create(cls, arg : NonSpare_1173_Arg) -> "NonSpare_1173":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_368:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_375:
        return self.rule.variation

Item_489_Arg: TypeAlias = NonSpare_1173_Arg
class Item_489(Item):
    cv_non_spare = NonSpare_1173

    @classmethod
    def create(cls, arg : Item_489_Arg) -> "Item_489":
        return cls._create(arg) # type: ignore

Variation_1123_Arg_Group = Tuple[Union[RuleVariation_369_Arg, Tuple[Literal["LAT"], RuleVariation_369_Arg]], Union[RuleVariation_368_Arg, Tuple[Literal["LON"], RuleVariation_368_Arg]]]
Variation_1123_Arg: TypeAlias = Union[int, Variation_1123_Arg_Group]
class Variation_1123(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_462, 32), (Item_489, 32)]
    cv_items_dict = {"LAT": RuleVariation_369, "LON": RuleVariation_368}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_369:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_368:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_369:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_368:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1123_Arg) -> 'Variation_1123':
        return cls._create(arg) # type: ignore

RuleVariation_1080_Arg: TypeAlias = Variation_1123_Arg
class RuleVariation_1080(RuleVariationContextFree):
    cv_variation = Variation_1123

    @classmethod
    def create(cls, arg : RuleVariation_1080_Arg) -> "RuleVariation_1080":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1123:
        return self.arg # type: ignore

NonSpare_152_Arg: TypeAlias = RuleVariation_1080_Arg
class NonSpare_152(NonSpare):
    cv_name = "041"
    cv_title = "Position In WGS-84 Coordinates"
    cv_rule = RuleVariation_1080

    @classmethod
    def create(cls, arg : NonSpare_152_Arg) -> "NonSpare_152":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1080:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1123:
        return self.rule.variation

class UapItem_152(UapItem):
    cv_non_spare = NonSpare_152

Content_637_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_637(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.5
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_637_Arg: TypeAlias = Content_637_Arg
class RuleContent_637(RuleContentContextFree):
    cv_content = Content_637

    @property
    def content(self) -> Content_637:
        return self._get_content() # type: ignore

Variation_351_Arg: TypeAlias = RuleContent_637_Arg
class Variation_351(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_637

    @classmethod
    def create(cls, arg : Variation_351_Arg) -> "Variation_351":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_637:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_637:
        return self.rule.content

RuleVariation_344_Arg: TypeAlias = Variation_351_Arg
class RuleVariation_344(RuleVariationContextFree):
    cv_variation = Variation_351

    @classmethod
    def create(cls, arg : RuleVariation_344_Arg) -> "RuleVariation_344":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_351:
        return self.arg # type: ignore

NonSpare_2092_Arg: TypeAlias = RuleVariation_344_Arg
class NonSpare_2092(NonSpare):
    cv_name = "X"
    cv_title = "X-coordinate"
    cv_rule = RuleVariation_344

    @classmethod
    def create(cls, arg : NonSpare_2092_Arg) -> "NonSpare_2092":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_344:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_351:
        return self.rule.variation

Item_1199_Arg: TypeAlias = NonSpare_2092_Arg
class Item_1199(Item):
    cv_non_spare = NonSpare_2092

    @classmethod
    def create(cls, arg : Item_1199_Arg) -> "Item_1199":
        return cls._create(arg) # type: ignore

NonSpare_2146_Arg: TypeAlias = RuleVariation_344_Arg
class NonSpare_2146(NonSpare):
    cv_name = "Y"
    cv_title = "Y-coordinate"
    cv_rule = RuleVariation_344

    @classmethod
    def create(cls, arg : NonSpare_2146_Arg) -> "NonSpare_2146":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_344:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_351:
        return self.rule.variation

Item_1250_Arg: TypeAlias = NonSpare_2146_Arg
class Item_1250(Item):
    cv_non_spare = NonSpare_2146

    @classmethod
    def create(cls, arg : Item_1250_Arg) -> "Item_1250":
        return cls._create(arg) # type: ignore

Variation_1310_Arg_Group = Tuple[Union[RuleVariation_344_Arg, Tuple[Literal["X"], RuleVariation_344_Arg]], Union[RuleVariation_344_Arg, Tuple[Literal["Y"], RuleVariation_344_Arg]]]
Variation_1310_Arg: TypeAlias = Union[int, Variation_1310_Arg_Group]
class Variation_1310(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_1199, 24), (Item_1250, 24)]
    cv_items_dict = {"X": RuleVariation_344, "Y": RuleVariation_344}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_344:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_344:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_344:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_344:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1310_Arg) -> 'Variation_1310':
        return cls._create(arg) # type: ignore

RuleVariation_1237_Arg: TypeAlias = Variation_1310_Arg
class RuleVariation_1237(RuleVariationContextFree):
    cv_variation = Variation_1310

    @classmethod
    def create(cls, arg : RuleVariation_1237_Arg) -> "RuleVariation_1237":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1310:
        return self.arg # type: ignore

NonSpare_160_Arg: TypeAlias = RuleVariation_1237_Arg
class NonSpare_160(NonSpare):
    cv_name = "042"
    cv_title = "Position in Cartesian Coordinates"
    cv_rule = RuleVariation_1237

    @classmethod
    def create(cls, arg : NonSpare_160_Arg) -> "NonSpare_160":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1237:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1310:
        return self.rule.variation

class UapItem_160(UapItem):
    cv_non_spare = NonSpare_160

NonSpare_1912_Arg: TypeAlias = RuleVariation_775_Arg
class NonSpare_1912(NonSpare):
    cv_name = "TRN"
    cv_title = "Track Number"
    cv_rule = RuleVariation_775

    @classmethod
    def create(cls, arg : NonSpare_1912_Arg) -> "NonSpare_1912":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_775:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_805:
        return self.rule.variation

Item_1037_Arg: TypeAlias = NonSpare_1912_Arg
class Item_1037(Item):
    cv_non_spare = NonSpare_1912

    @classmethod
    def create(cls, arg : Item_1037_Arg) -> "Item_1037":
        return cls._create(arg) # type: ignore

Variation_1032_Arg_Group = Tuple[int, Union[RuleVariation_775_Arg, Tuple[Literal["TRN"], RuleVariation_775_Arg]]]
Variation_1032_Arg: TypeAlias = Union[int, Variation_1032_Arg_Group]
class Variation_1032(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_1037, 12)]
    cv_items_dict = {"TRN": RuleVariation_775}

    @classmethod
    def spec(cls, key : Literal["TRN"]) -> RuleVariation_775:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["TRN"]) -> RuleVariation_775:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1032_Arg) -> 'Variation_1032':
        return cls._create(arg) # type: ignore

RuleVariation_1000_Arg: TypeAlias = Variation_1032_Arg
class RuleVariation_1000(RuleVariationContextFree):
    cv_variation = Variation_1032

    @classmethod
    def create(cls, arg : RuleVariation_1000_Arg) -> "RuleVariation_1000":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1032:
        return self.arg # type: ignore

NonSpare_358_Arg: TypeAlias = RuleVariation_1000_Arg
class NonSpare_358(NonSpare):
    cv_name = "161"
    cv_title = "Track Number"
    cv_rule = RuleVariation_1000

    @classmethod
    def create(cls, arg : NonSpare_358_Arg) -> "NonSpare_358":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1000:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1032:
        return self.rule.variation

class UapItem_358(UapItem):
    cv_non_spare = NonSpare_358

Content_64_Arg: TypeAlias = int
class Content_64(ContentTable):
    cv_values = {0: "Confirmed track", 1: "Track in initiation phase"}

RuleContent_64_Arg: TypeAlias = Content_64_Arg
class RuleContent_64(RuleContentContextFree):
    cv_content = Content_64

    @property
    def content(self) -> Content_64:
        return self._get_content() # type: ignore

Variation_19_Arg: TypeAlias = RuleContent_64_Arg
class Variation_19(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_64

    @classmethod
    def create(cls, arg : Variation_19_Arg) -> "Variation_19":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_64:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_64:
        return self.rule.content

RuleVariation_19_Arg: TypeAlias = Variation_19_Arg
class RuleVariation_19(RuleVariationContextFree):
    cv_variation = Variation_19

    @classmethod
    def create(cls, arg : RuleVariation_19_Arg) -> "RuleVariation_19":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_19:
        return self.arg # type: ignore

Variation_566_Arg: TypeAlias = RuleContent_396_Arg
class Variation_566(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_396

    @classmethod
    def create(cls, arg : Variation_566_Arg) -> "Variation_566":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_396:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_396:
        return self.rule.content

RuleVariation_555_Arg: TypeAlias = Variation_566_Arg
class RuleVariation_555(RuleVariationContextFree):
    cv_variation = Variation_566

    @classmethod
    def create(cls, arg : RuleVariation_555_Arg) -> "RuleVariation_555":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_566:
        return self.arg # type: ignore

Variation_675_Arg: TypeAlias = RuleContent_261_Arg
class Variation_675(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_rule = RuleContent_261

    @classmethod
    def create(cls, arg : Variation_675_Arg) -> "Variation_675":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_261:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_261:
        return self.rule.content

RuleVariation_664_Arg: TypeAlias = Variation_675_Arg
class RuleVariation_664(RuleVariationContextFree):
    cv_variation = Variation_675

    @classmethod
    def create(cls, arg : RuleVariation_664_Arg) -> "RuleVariation_664":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_675:
        return self.arg # type: ignore

Variation_828_Arg: TypeAlias = RuleContent_105_Arg
class Variation_828(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_105

    @classmethod
    def create(cls, arg : Variation_828_Arg) -> "Variation_828":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_105:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_105:
        return self.rule.content

RuleVariation_798_Arg: TypeAlias = Variation_828_Arg
class RuleVariation_798(RuleVariationContextFree):
    cv_variation = Variation_828

    @classmethod
    def create(cls, arg : RuleVariation_798_Arg) -> "RuleVariation_798":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_828:
        return self.arg # type: ignore

NonSpare_741_Arg: TypeAlias = RuleVariation_19_Arg
class NonSpare_741(NonSpare):
    cv_name = "CNF"
    cv_title = ""
    cv_rule = RuleVariation_19

    @classmethod
    def create(cls, arg : NonSpare_741_Arg) -> "NonSpare_741":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_19:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_19:
        return self.rule.variation

Item_165_Arg: TypeAlias = NonSpare_741_Arg
class Item_165(Item):
    cv_non_spare = NonSpare_741

    @classmethod
    def create(cls, arg : Item_165_Arg) -> "Item_165":
        return cls._create(arg) # type: ignore

NonSpare_833_Arg: TypeAlias = RuleVariation_555_Arg
class NonSpare_833(NonSpare):
    cv_name = "CST"
    cv_title = ""
    cv_rule = RuleVariation_555

    @classmethod
    def create(cls, arg : NonSpare_833_Arg) -> "NonSpare_833":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_555:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_566:
        return self.rule.variation

Item_222_Arg: TypeAlias = NonSpare_833_Arg
class Item_222(Item):
    cv_non_spare = NonSpare_833

    @classmethod
    def create(cls, arg : Item_222_Arg) -> "Item_222":
        return cls._create(arg) # type: ignore

NonSpare_707_Arg: TypeAlias = RuleVariation_664_Arg
class NonSpare_707(NonSpare):
    cv_name = "CDM"
    cv_title = ""
    cv_rule = RuleVariation_664

    @classmethod
    def create(cls, arg : NonSpare_707_Arg) -> "NonSpare_707":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_664:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_675:
        return self.rule.variation

Item_139_Arg: TypeAlias = NonSpare_707_Arg
class Item_139(Item):
    cv_non_spare = NonSpare_707

    @classmethod
    def create(cls, arg : Item_139_Arg) -> "Item_139":
        return cls._create(arg) # type: ignore

NonSpare_1215_Arg: TypeAlias = RuleVariation_798_Arg
class NonSpare_1215(NonSpare):
    cv_name = "MAH"
    cv_title = ""
    cv_rule = RuleVariation_798

    @classmethod
    def create(cls, arg : NonSpare_1215_Arg) -> "NonSpare_1215":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_798:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_828:
        return self.rule.variation

Item_521_Arg: TypeAlias = NonSpare_1215_Arg
class Item_521(Item):
    cv_non_spare = NonSpare_1215

    @classmethod
    def create(cls, arg : Item_521_Arg) -> "Item_521":
        return cls._create(arg) # type: ignore

Variation_1345_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_19_Arg, Tuple[Literal["CNF"], RuleVariation_19_Arg]], Union[RuleVariation_398_Arg, Tuple[Literal["TRE"], RuleVariation_398_Arg]], Union[RuleVariation_555_Arg, Tuple[Literal["CST"], RuleVariation_555_Arg]], Union[RuleVariation_664_Arg, Tuple[Literal["CDM"], RuleVariation_664_Arg]], Union[RuleVariation_798_Arg, Tuple[Literal["MAH"], RuleVariation_798_Arg]], Union[RuleVariation_904_Arg, Tuple[Literal["STH"], RuleVariation_904_Arg]], None]]
Variation_1345_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_28_Arg, Tuple[Literal["GHO"], RuleVariation_28_Arg]], int, None]]
Variation_1345_Arg: TypeAlias = Union[
    Tuple[Variation_1345_Arg_Group_1],
    Tuple[Variation_1345_Arg_Group_1, Variation_1345_Arg_Group_2],
]
class Variation_1345(Extended):
    cv_items_list = [[(Item_165, 1), (Item_1033, 1), (Item_222, 1), (Item_139, 2), (Item_521, 1), (Item_946, 1), None], [(Item_368, 1), (Item_9, 6), None]]

    @classmethod
    def create(cls, arg : Variation_1345_Arg) -> 'Variation_1345':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_19:
        ...
    @overload
    def get_item(self, key : Literal["TRE"]) -> RuleVariation_398:
        ...
    @overload
    def get_item(self, key : Literal["CST"]) -> RuleVariation_555:
        ...
    @overload
    def get_item(self, key : Literal["CDM"]) -> RuleVariation_664:
        ...
    @overload
    def get_item(self, key : Literal["MAH"]) -> RuleVariation_798:
        ...
    @overload
    def get_item(self, key : Literal["STH"]) -> RuleVariation_904:
        ...
    @overload
    def get_item(self, key : Literal["GHO"]) -> Optional[RuleVariation_28]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1268_Arg: TypeAlias = Variation_1345_Arg
class RuleVariation_1268(RuleVariationContextFree):
    cv_variation = Variation_1345

    @classmethod
    def create(cls, arg : RuleVariation_1268_Arg) -> "RuleVariation_1268":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1345:
        return self.arg # type: ignore

NonSpare_371_Arg: TypeAlias = RuleVariation_1268_Arg
class NonSpare_371(NonSpare):
    cv_name = "170"
    cv_title = "Track Status"
    cv_rule = RuleVariation_1268

    @classmethod
    def create(cls, arg : NonSpare_371_Arg) -> "NonSpare_371":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1268:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1345:
        return self.rule.variation

class UapItem_371(UapItem):
    cv_non_spare = NonSpare_371

Content_289_Arg: TypeAlias = int
class Content_289(ContentTable):
    cv_values = {0: "Mode-3/A code derived from the reply of the transponder", 1: "Mode-3/A code not extracted during the last update period"}

RuleContent_289_Arg: TypeAlias = Content_289_Arg
class RuleContent_289(RuleContentContextFree):
    cv_content = Content_289

    @property
    def content(self) -> Content_289:
        return self._get_content() # type: ignore

Variation_551_Arg: TypeAlias = RuleContent_289_Arg
class Variation_551(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_289

    @classmethod
    def create(cls, arg : Variation_551_Arg) -> "Variation_551":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_289:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_289:
        return self.rule.content

RuleVariation_540_Arg: TypeAlias = Variation_551_Arg
class RuleVariation_540(RuleVariationContextFree):
    cv_variation = Variation_551

    @classmethod
    def create(cls, arg : RuleVariation_540_Arg) -> "RuleVariation_540":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_551:
        return self.arg # type: ignore

NonSpare_1133_Arg: TypeAlias = RuleVariation_540_Arg
class NonSpare_1133(NonSpare):
    cv_name = "L"
    cv_title = ""
    cv_rule = RuleVariation_540

    @classmethod
    def create(cls, arg : NonSpare_1133_Arg) -> "NonSpare_1133":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_540:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_551:
        return self.rule.variation

Item_451_Arg: TypeAlias = NonSpare_1133_Arg
class Item_451(Item):
    cv_non_spare = NonSpare_1133

    @classmethod
    def create(cls, arg : Item_451_Arg) -> "Item_451":
        return cls._create(arg) # type: ignore

Variation_1269_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_540_Arg, Tuple[Literal["L"], RuleVariation_540_Arg]], int, Union[RuleVariation_776_Arg, Tuple[Literal["MODE3A"], RuleVariation_776_Arg]]]
Variation_1269_Arg: TypeAlias = Union[int, Variation_1269_Arg_Group]
class Variation_1269(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1100, 1), (Item_355, 1), (Item_451, 1), (Item_16, 1), (Item_572, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "L": RuleVariation_540, "MODE3A": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_540:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_540:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1269_Arg) -> 'Variation_1269':
        return cls._create(arg) # type: ignore

RuleVariation_1199_Arg: TypeAlias = Variation_1269_Arg
class RuleVariation_1199(RuleVariationContextFree):
    cv_variation = Variation_1269

    @classmethod
    def create(cls, arg : RuleVariation_1199_Arg) -> "RuleVariation_1199":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1269:
        return self.arg # type: ignore

NonSpare_210_Arg: TypeAlias = RuleVariation_1199_Arg
class NonSpare_210(NonSpare):
    cv_name = "070"
    cv_title = "Mode-3/A Code in Octal Representation"
    cv_rule = RuleVariation_1199

    @classmethod
    def create(cls, arg : NonSpare_210_Arg) -> "NonSpare_210":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1199:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1269:
        return self.rule.variation

class UapItem_210(UapItem):
    cv_non_spare = NonSpare_210

NonSpare_2038_Arg: TypeAlias = RuleVariation_270_Arg
class NonSpare_2038(NonSpare):
    cv_name = "VX"
    cv_title = ""
    cv_rule = RuleVariation_270

    @classmethod
    def create(cls, arg : NonSpare_2038_Arg) -> "NonSpare_2038":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_270:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_277:
        return self.rule.variation

Item_1150_Arg: TypeAlias = NonSpare_2038_Arg
class Item_1150(Item):
    cv_non_spare = NonSpare_2038

    @classmethod
    def create(cls, arg : Item_1150_Arg) -> "Item_1150":
        return cls._create(arg) # type: ignore

NonSpare_2043_Arg: TypeAlias = RuleVariation_270_Arg
class NonSpare_2043(NonSpare):
    cv_name = "VY"
    cv_title = ""
    cv_rule = RuleVariation_270

    @classmethod
    def create(cls, arg : NonSpare_2043_Arg) -> "NonSpare_2043":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_270:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_277:
        return self.rule.variation

Item_1155_Arg: TypeAlias = NonSpare_2043_Arg
class Item_1155(Item):
    cv_non_spare = NonSpare_2043

    @classmethod
    def create(cls, arg : Item_1155_Arg) -> "Item_1155":
        return cls._create(arg) # type: ignore

Variation_1272_Arg_Group = Tuple[Union[RuleVariation_270_Arg, Tuple[Literal["VX"], RuleVariation_270_Arg]], Union[RuleVariation_270_Arg, Tuple[Literal["VY"], RuleVariation_270_Arg]]]
Variation_1272_Arg: TypeAlias = Union[int, Variation_1272_Arg_Group]
class Variation_1272(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1150, 16), (Item_1155, 16)]
    cv_items_dict = {"VX": RuleVariation_270, "VY": RuleVariation_270}

    @overload
    @classmethod
    def spec(cls, key : Literal["VX"]) -> RuleVariation_270:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VY"]) -> RuleVariation_270:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VX"], Literal["VY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VX"]) -> RuleVariation_270:
        ...
    @overload
    def get_item(self, key : Literal["VY"]) -> RuleVariation_270:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1272_Arg) -> 'Variation_1272':
        return cls._create(arg) # type: ignore

RuleVariation_1202_Arg: TypeAlias = Variation_1272_Arg
class RuleVariation_1202(RuleVariationContextFree):
    cv_variation = Variation_1272

    @classmethod
    def create(cls, arg : RuleVariation_1202_Arg) -> "RuleVariation_1202":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1272:
        return self.arg # type: ignore

NonSpare_400_Arg: TypeAlias = RuleVariation_1202_Arg
class NonSpare_400(NonSpare):
    cv_name = "202"
    cv_title = "Calculated Track Velocity in Cartesian Coordinates"
    cv_rule = RuleVariation_1202

    @classmethod
    def create(cls, arg : NonSpare_400_Arg) -> "NonSpare_400":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1202:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1272:
        return self.rule.variation

class UapItem_400(UapItem):
    cv_non_spare = NonSpare_400

NonSpare_247_Arg: TypeAlias = RuleVariation_1194_Arg
class NonSpare_247(NonSpare):
    cv_name = "090"
    cv_title = "Flight Level in Binary Representation"
    cv_rule = RuleVariation_1194

    @classmethod
    def create(cls, arg : NonSpare_247_Arg) -> "NonSpare_247":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1194:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1264:
        return self.rule.variation

class UapItem_247(UapItem):
    cv_non_spare = NonSpare_247

NonSpare_1501_Arg: TypeAlias = RuleVariation_714_Arg
class NonSpare_1501(NonSpare):
    cv_name = "QC1"
    cv_title = "Quality Pulse C1"
    cv_rule = RuleVariation_714

    @classmethod
    def create(cls, arg : NonSpare_1501_Arg) -> "NonSpare_1501":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_714:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_725:
        return self.rule.variation

Item_740_Arg: TypeAlias = NonSpare_1501_Arg
class Item_740(Item):
    cv_non_spare = NonSpare_1501

    @classmethod
    def create(cls, arg : Item_740_Arg) -> "Item_740":
        return cls._create(arg) # type: ignore

NonSpare_1480_Arg: TypeAlias = RuleVariation_819_Arg
class NonSpare_1480(NonSpare):
    cv_name = "QA1"
    cv_title = "Quality Pulse A1"
    cv_rule = RuleVariation_819

    @classmethod
    def create(cls, arg : NonSpare_1480_Arg) -> "NonSpare_1480":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_819:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_849:
        return self.rule.variation

Item_719_Arg: TypeAlias = NonSpare_1480_Arg
class Item_719(Item):
    cv_non_spare = NonSpare_1480

    @classmethod
    def create(cls, arg : Item_719_Arg) -> "Item_719":
        return cls._create(arg) # type: ignore

NonSpare_1504_Arg: TypeAlias = RuleVariation_899_Arg
class NonSpare_1504(NonSpare):
    cv_name = "QC2"
    cv_title = "Quality Pulse C2"
    cv_rule = RuleVariation_899

    @classmethod
    def create(cls, arg : NonSpare_1504_Arg) -> "NonSpare_1504":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_899:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_929:
        return self.rule.variation

Item_743_Arg: TypeAlias = NonSpare_1504_Arg
class Item_743(Item):
    cv_non_spare = NonSpare_1504

    @classmethod
    def create(cls, arg : Item_743_Arg) -> "Item_743":
        return cls._create(arg) # type: ignore

NonSpare_1484_Arg: TypeAlias = RuleVariation_943_Arg
class NonSpare_1484(NonSpare):
    cv_name = "QA2"
    cv_title = "Quality Pulse A2"
    cv_rule = RuleVariation_943

    @classmethod
    def create(cls, arg : NonSpare_1484_Arg) -> "NonSpare_1484":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_943:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_973:
        return self.rule.variation

Item_723_Arg: TypeAlias = NonSpare_1484_Arg
class Item_723(Item):
    cv_non_spare = NonSpare_1484

    @classmethod
    def create(cls, arg : Item_723_Arg) -> "Item_723":
        return cls._create(arg) # type: ignore

NonSpare_1507_Arg: TypeAlias = RuleVariation_46_Arg
class NonSpare_1507(NonSpare):
    cv_name = "QC4"
    cv_title = "Quality Pulse C4"
    cv_rule = RuleVariation_46

    @classmethod
    def create(cls, arg : NonSpare_1507_Arg) -> "NonSpare_1507":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_46:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_46:
        return self.rule.variation

Item_746_Arg: TypeAlias = NonSpare_1507_Arg
class Item_746(Item):
    cv_non_spare = NonSpare_1507

    @classmethod
    def create(cls, arg : Item_746_Arg) -> "Item_746":
        return cls._create(arg) # type: ignore

NonSpare_1488_Arg: TypeAlias = RuleVariation_418_Arg
class NonSpare_1488(NonSpare):
    cv_name = "QA4"
    cv_title = "Quality Pulse A4"
    cv_rule = RuleVariation_418

    @classmethod
    def create(cls, arg : NonSpare_1488_Arg) -> "NonSpare_1488":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_418:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_429:
        return self.rule.variation

Item_727_Arg: TypeAlias = NonSpare_1488_Arg
class Item_727(Item):
    cv_non_spare = NonSpare_1488

    @classmethod
    def create(cls, arg : Item_727_Arg) -> "Item_727":
        return cls._create(arg) # type: ignore

NonSpare_1492_Arg: TypeAlias = RuleVariation_523_Arg
class NonSpare_1492(NonSpare):
    cv_name = "QB1"
    cv_title = "Quality Pulse B1"
    cv_rule = RuleVariation_523

    @classmethod
    def create(cls, arg : NonSpare_1492_Arg) -> "NonSpare_1492":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_523:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_534:
        return self.rule.variation

Item_731_Arg: TypeAlias = NonSpare_1492_Arg
class Item_731(Item):
    cv_non_spare = NonSpare_1492

    @classmethod
    def create(cls, arg : Item_731_Arg) -> "Item_731":
        return cls._create(arg) # type: ignore

NonSpare_1510_Arg: TypeAlias = RuleVariation_629_Arg
class NonSpare_1510(NonSpare):
    cv_name = "QD1"
    cv_title = "Quality Pulse D1"
    cv_rule = RuleVariation_629

    @classmethod
    def create(cls, arg : NonSpare_1510_Arg) -> "NonSpare_1510":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_629:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_640:
        return self.rule.variation

Item_749_Arg: TypeAlias = NonSpare_1510_Arg
class Item_749(Item):
    cv_non_spare = NonSpare_1510

    @classmethod
    def create(cls, arg : Item_749_Arg) -> "Item_749":
        return cls._create(arg) # type: ignore

NonSpare_1496_Arg: TypeAlias = RuleVariation_713_Arg
class NonSpare_1496(NonSpare):
    cv_name = "QB2"
    cv_title = "Quality Pulse B2"
    cv_rule = RuleVariation_713

    @classmethod
    def create(cls, arg : NonSpare_1496_Arg) -> "NonSpare_1496":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_713:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_724:
        return self.rule.variation

Item_735_Arg: TypeAlias = NonSpare_1496_Arg
class Item_735(Item):
    cv_non_spare = NonSpare_1496

    @classmethod
    def create(cls, arg : Item_735_Arg) -> "Item_735":
        return cls._create(arg) # type: ignore

Variation_851_Arg: TypeAlias = RuleContent_228_Arg
class Variation_851(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_228

    @classmethod
    def create(cls, arg : Variation_851_Arg) -> "Variation_851":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_228:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_228:
        return self.rule.content

RuleVariation_821_Arg: TypeAlias = Variation_851_Arg
class RuleVariation_821(RuleVariationContextFree):
    cv_variation = Variation_851

    @classmethod
    def create(cls, arg : RuleVariation_821_Arg) -> "RuleVariation_821":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_851:
        return self.arg # type: ignore

NonSpare_1513_Arg: TypeAlias = RuleVariation_821_Arg
class NonSpare_1513(NonSpare):
    cv_name = "QD2"
    cv_title = "Quality Pulse D2"
    cv_rule = RuleVariation_821

    @classmethod
    def create(cls, arg : NonSpare_1513_Arg) -> "NonSpare_1513":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_821:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_851:
        return self.rule.variation

Item_752_Arg: TypeAlias = NonSpare_1513_Arg
class Item_752(Item):
    cv_non_spare = NonSpare_1513

    @classmethod
    def create(cls, arg : Item_752_Arg) -> "Item_752":
        return cls._create(arg) # type: ignore

NonSpare_1499_Arg: TypeAlias = RuleVariation_898_Arg
class NonSpare_1499(NonSpare):
    cv_name = "QB4"
    cv_title = "Quality Pulse B4"
    cv_rule = RuleVariation_898

    @classmethod
    def create(cls, arg : NonSpare_1499_Arg) -> "NonSpare_1499":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_898:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_928:
        return self.rule.variation

Item_738_Arg: TypeAlias = NonSpare_1499_Arg
class Item_738(Item):
    cv_non_spare = NonSpare_1499

    @classmethod
    def create(cls, arg : Item_738_Arg) -> "Item_738":
        return cls._create(arg) # type: ignore

NonSpare_1516_Arg: TypeAlias = RuleVariation_947_Arg
class NonSpare_1516(NonSpare):
    cv_name = "QD4"
    cv_title = "Quality Pulse D4"
    cv_rule = RuleVariation_947

    @classmethod
    def create(cls, arg : NonSpare_1516_Arg) -> "NonSpare_1516":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_947:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_977:
        return self.rule.variation

Item_755_Arg: TypeAlias = NonSpare_1516_Arg
class Item_755(Item):
    cv_non_spare = NonSpare_1516

    @classmethod
    def create(cls, arg : Item_755_Arg) -> "Item_755":
        return cls._create(arg) # type: ignore

Variation_1262_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], int, Union[RuleVariation_775_Arg, Tuple[Literal["MODEC"], RuleVariation_775_Arg]], int, Union[RuleVariation_714_Arg, Tuple[Literal["QC1"], RuleVariation_714_Arg]], Union[RuleVariation_819_Arg, Tuple[Literal["QA1"], RuleVariation_819_Arg]], Union[RuleVariation_899_Arg, Tuple[Literal["QC2"], RuleVariation_899_Arg]], Union[RuleVariation_943_Arg, Tuple[Literal["QA2"], RuleVariation_943_Arg]], Union[RuleVariation_46_Arg, Tuple[Literal["QC4"], RuleVariation_46_Arg]], Union[RuleVariation_418_Arg, Tuple[Literal["QA4"], RuleVariation_418_Arg]], Union[RuleVariation_523_Arg, Tuple[Literal["QB1"], RuleVariation_523_Arg]], Union[RuleVariation_629_Arg, Tuple[Literal["QD1"], RuleVariation_629_Arg]], Union[RuleVariation_713_Arg, Tuple[Literal["QB2"], RuleVariation_713_Arg]], Union[RuleVariation_821_Arg, Tuple[Literal["QD2"], RuleVariation_821_Arg]], Union[RuleVariation_898_Arg, Tuple[Literal["QB4"], RuleVariation_898_Arg]], Union[RuleVariation_947_Arg, Tuple[Literal["QD4"], RuleVariation_947_Arg]]]
Variation_1262_Arg: TypeAlias = Union[int, Variation_1262_Arg_Group]
class Variation_1262(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1100, 1), (Item_355, 1), (Item_12, 2), (Item_573, 12), (Item_3, 4), (Item_740, 1), (Item_719, 1), (Item_743, 1), (Item_723, 1), (Item_746, 1), (Item_727, 1), (Item_731, 1), (Item_749, 1), (Item_735, 1), (Item_752, 1), (Item_738, 1), (Item_755, 1)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "MODEC": RuleVariation_775, "QC1": RuleVariation_714, "QA1": RuleVariation_819, "QC2": RuleVariation_899, "QA2": RuleVariation_943, "QC4": RuleVariation_46, "QA4": RuleVariation_418, "QB1": RuleVariation_523, "QD1": RuleVariation_629, "QB2": RuleVariation_713, "QD2": RuleVariation_821, "QB4": RuleVariation_898, "QD4": RuleVariation_947}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODEC"]) -> RuleVariation_775:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC1"]) -> RuleVariation_714:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA1"]) -> RuleVariation_819:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC2"]) -> RuleVariation_899:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA2"]) -> RuleVariation_943:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC4"]) -> RuleVariation_46:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA4"]) -> RuleVariation_418:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB1"]) -> RuleVariation_523:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD1"]) -> RuleVariation_629:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB2"]) -> RuleVariation_713:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD2"]) -> RuleVariation_821:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB4"]) -> RuleVariation_898:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD4"]) -> RuleVariation_947:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["MODEC"], Literal["QC1"], Literal["QA1"], Literal["QC2"], Literal["QA2"], Literal["QC4"], Literal["QA4"], Literal["QB1"], Literal["QD1"], Literal["QB2"], Literal["QD2"], Literal["QB4"], Literal["QD4"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["MODEC"]) -> RuleVariation_775:
        ...
    @overload
    def get_item(self, key : Literal["QC1"]) -> RuleVariation_714:
        ...
    @overload
    def get_item(self, key : Literal["QA1"]) -> RuleVariation_819:
        ...
    @overload
    def get_item(self, key : Literal["QC2"]) -> RuleVariation_899:
        ...
    @overload
    def get_item(self, key : Literal["QA2"]) -> RuleVariation_943:
        ...
    @overload
    def get_item(self, key : Literal["QC4"]) -> RuleVariation_46:
        ...
    @overload
    def get_item(self, key : Literal["QA4"]) -> RuleVariation_418:
        ...
    @overload
    def get_item(self, key : Literal["QB1"]) -> RuleVariation_523:
        ...
    @overload
    def get_item(self, key : Literal["QD1"]) -> RuleVariation_629:
        ...
    @overload
    def get_item(self, key : Literal["QB2"]) -> RuleVariation_713:
        ...
    @overload
    def get_item(self, key : Literal["QD2"]) -> RuleVariation_821:
        ...
    @overload
    def get_item(self, key : Literal["QB4"]) -> RuleVariation_898:
        ...
    @overload
    def get_item(self, key : Literal["QD4"]) -> RuleVariation_947:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1262_Arg) -> 'Variation_1262':
        return cls._create(arg) # type: ignore

RuleVariation_1192_Arg: TypeAlias = Variation_1262_Arg
class RuleVariation_1192(RuleVariationContextFree):
    cv_variation = Variation_1262

    @classmethod
    def create(cls, arg : RuleVariation_1192_Arg) -> "RuleVariation_1192":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1262:
        return self.arg # type: ignore

NonSpare_268_Arg: TypeAlias = RuleVariation_1192_Arg
class NonSpare_268(NonSpare):
    cv_name = "100"
    cv_title = "Mode C Code"
    cv_rule = RuleVariation_1192

    @classmethod
    def create(cls, arg : NonSpare_268_Arg) -> "NonSpare_268":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1192:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1262:
        return self.rule.variation

class UapItem_268(UapItem):
    cv_non_spare = NonSpare_268

NonSpare_422_Arg: TypeAlias = RuleVariation_340_Arg
class NonSpare_422(NonSpare):
    cv_name = "220"
    cv_title = "Target Address"
    cv_rule = RuleVariation_340

    @classmethod
    def create(cls, arg : NonSpare_422_Arg) -> "NonSpare_422":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_340:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_347:
        return self.rule.variation

class UapItem_422(UapItem):
    cv_non_spare = NonSpare_422

Content_52_Arg: TypeAlias = int
class Content_52(ContentTable):
    cv_values = {0: "Callsign or registration not downlinked from transponder", 1: "Registration downlinked from transponder", 2: "Callsign downlinked from transponder", 3: "Not defined"}

RuleContent_52_Arg: TypeAlias = Content_52_Arg
class RuleContent_52(RuleContentContextFree):
    cv_content = Content_52

    @property
    def content(self) -> Content_52:
        return self._get_content() # type: ignore

Variation_98_Arg: TypeAlias = RuleContent_52_Arg
class Variation_98(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_52

    @classmethod
    def create(cls, arg : Variation_98_Arg) -> "Variation_98":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_52:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_52:
        return self.rule.content

RuleVariation_98_Arg: TypeAlias = Variation_98_Arg
class RuleVariation_98(RuleVariationContextFree):
    cv_variation = Variation_98

    @classmethod
    def create(cls, arg : RuleVariation_98_Arg) -> "RuleVariation_98":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_98:
        return self.arg # type: ignore

NonSpare_1783_Arg: TypeAlias = RuleVariation_98_Arg
class NonSpare_1783(NonSpare):
    cv_name = "STI"
    cv_title = ""
    cv_rule = RuleVariation_98

    @classmethod
    def create(cls, arg : NonSpare_1783_Arg) -> "NonSpare_1783":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_98:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_98:
        return self.rule.variation

Item_949_Arg: TypeAlias = NonSpare_1783_Arg
class Item_949(Item):
    cv_non_spare = NonSpare_1783

    @classmethod
    def create(cls, arg : Item_949_Arg) -> "Item_949":
        return cls._create(arg) # type: ignore

NonSpare_730_Arg: TypeAlias = RuleVariation_381_Arg
class NonSpare_730(NonSpare):
    cv_name = "CHR"
    cv_title = "Characters 1-8 (coded on 6 Bits Each) Defining Target Identification"
    cv_rule = RuleVariation_381

    @classmethod
    def create(cls, arg : NonSpare_730_Arg) -> "NonSpare_730":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_381:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_389:
        return self.rule.variation

Item_158_Arg: TypeAlias = NonSpare_730_Arg
class Item_158(Item):
    cv_non_spare = NonSpare_730

    @classmethod
    def create(cls, arg : Item_158_Arg) -> "Item_158":
        return cls._create(arg) # type: ignore

Variation_1212_Arg_Group = Tuple[Union[RuleVariation_98_Arg, Tuple[Literal["STI"], RuleVariation_98_Arg]], int, Union[RuleVariation_381_Arg, Tuple[Literal["CHR"], RuleVariation_381_Arg]]]
Variation_1212_Arg: TypeAlias = Union[int, Variation_1212_Arg_Group]
class Variation_1212(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_items_list = [(Item_949, 2), (Item_15, 6), (Item_158, 48)]
    cv_items_dict = {"STI": RuleVariation_98, "CHR": RuleVariation_381}

    @overload
    @classmethod
    def spec(cls, key : Literal["STI"]) -> RuleVariation_98:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CHR"]) -> RuleVariation_381:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["STI"], Literal["CHR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["STI"]) -> RuleVariation_98:
        ...
    @overload
    def get_item(self, key : Literal["CHR"]) -> RuleVariation_381:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1212_Arg) -> 'Variation_1212':
        return cls._create(arg) # type: ignore

RuleVariation_1157_Arg: TypeAlias = Variation_1212_Arg
class RuleVariation_1157(RuleVariationContextFree):
    cv_variation = Variation_1212

    @classmethod
    def create(cls, arg : RuleVariation_1157_Arg) -> "RuleVariation_1157":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1212:
        return self.arg # type: ignore

NonSpare_438_Arg: TypeAlias = RuleVariation_1157_Arg
class NonSpare_438(NonSpare):
    cv_name = "245"
    cv_title = "Target Identification"
    cv_rule = RuleVariation_1157

    @classmethod
    def create(cls, arg : NonSpare_438_Arg) -> "NonSpare_438":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1157:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1212:
        return self.rule.variation

class UapItem_438(UapItem):
    cv_non_spare = NonSpare_438

NonSpare_284_Arg: TypeAlias = RuleVariation_281_Arg
class NonSpare_284(NonSpare):
    cv_name = "110"
    cv_title = "Measured Height (Local Cartesian Coordinates)"
    cv_rule = RuleVariation_281

    @classmethod
    def create(cls, arg : NonSpare_284_Arg) -> "NonSpare_284":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_281:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_288:
        return self.rule.variation

class UapItem_284(UapItem):
    cv_non_spare = NonSpare_284

NonSpare_278_Arg: TypeAlias = RuleVariation_281_Arg
class NonSpare_278(NonSpare):
    cv_name = "105"
    cv_title = "Geometric Height (WGS-84)"
    cv_rule = RuleVariation_281

    @classmethod
    def create(cls, arg : NonSpare_278_Arg) -> "NonSpare_278":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_281:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_288:
        return self.rule.variation

class UapItem_278(UapItem):
    cv_non_spare = NonSpare_278

NonSpare_650_Arg: TypeAlias = RuleVariation_203_Arg
class NonSpare_650(NonSpare):
    cv_name = "AX"
    cv_title = ""
    cv_rule = RuleVariation_203

    @classmethod
    def create(cls, arg : NonSpare_650_Arg) -> "NonSpare_650":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_203:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_210:
        return self.rule.variation

Item_98_Arg: TypeAlias = NonSpare_650_Arg
class Item_98(Item):
    cv_non_spare = NonSpare_650

    @classmethod
    def create(cls, arg : Item_98_Arg) -> "Item_98":
        return cls._create(arg) # type: ignore

NonSpare_654_Arg: TypeAlias = RuleVariation_203_Arg
class NonSpare_654(NonSpare):
    cv_name = "AY"
    cv_title = ""
    cv_rule = RuleVariation_203

    @classmethod
    def create(cls, arg : NonSpare_654_Arg) -> "NonSpare_654":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_203:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_210:
        return self.rule.variation

Item_102_Arg: TypeAlias = NonSpare_654_Arg
class Item_102(Item):
    cv_non_spare = NonSpare_654

    @classmethod
    def create(cls, arg : Item_102_Arg) -> "Item_102":
        return cls._create(arg) # type: ignore

Variation_1052_Arg_Group = Tuple[Union[RuleVariation_203_Arg, Tuple[Literal["AX"], RuleVariation_203_Arg]], Union[RuleVariation_203_Arg, Tuple[Literal["AY"], RuleVariation_203_Arg]]]
Variation_1052_Arg: TypeAlias = Union[int, Variation_1052_Arg_Group]
class Variation_1052(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_98, 8), (Item_102, 8)]
    cv_items_dict = {"AX": RuleVariation_203, "AY": RuleVariation_203}

    @overload
    @classmethod
    def spec(cls, key : Literal["AX"]) -> RuleVariation_203:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AY"]) -> RuleVariation_203:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AX"], Literal["AY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AX"]) -> RuleVariation_203:
        ...
    @overload
    def get_item(self, key : Literal["AY"]) -> RuleVariation_203:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1052_Arg) -> 'Variation_1052':
        return cls._create(arg) # type: ignore

RuleVariation_1019_Arg: TypeAlias = Variation_1052_Arg
class RuleVariation_1019(RuleVariationContextFree):
    cv_variation = Variation_1052

    @classmethod
    def create(cls, arg : RuleVariation_1019_Arg) -> "RuleVariation_1019":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1052:
        return self.arg # type: ignore

NonSpare_402_Arg: TypeAlias = RuleVariation_1019_Arg
class NonSpare_402(NonSpare):
    cv_name = "210"
    cv_title = "Calculated Acceleration"
    cv_rule = RuleVariation_1019

    @classmethod
    def create(cls, arg : NonSpare_402_Arg) -> "NonSpare_402":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1019:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1052:
        return self.rule.variation

class UapItem_402(UapItem):
    cv_non_spare = NonSpare_402

NonSpare_1320_Arg: TypeAlias = RuleVariation_481_Arg
class NonSpare_1320(NonSpare):
    cv_name = "MSG"
    cv_title = ""
    cv_rule = RuleVariation_481

    @classmethod
    def create(cls, arg : NonSpare_1320_Arg) -> "NonSpare_1320":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_481:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_492:
        return self.rule.variation

Item_590_Arg: TypeAlias = NonSpare_1320_Arg
class Item_590(Item):
    cv_non_spare = NonSpare_1320

    @classmethod
    def create(cls, arg : Item_590_Arg) -> "Item_590":
        return cls._create(arg) # type: ignore

Variation_1223_Arg_Group = Tuple[Union[RuleVariation_30_Arg, Tuple[Literal["TRB"], RuleVariation_30_Arg]], Union[RuleVariation_481_Arg, Tuple[Literal["MSG"], RuleVariation_481_Arg]]]
Variation_1223_Arg: TypeAlias = Union[int, Variation_1223_Arg_Group]
class Variation_1223(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1028, 1), (Item_590, 7)]
    cv_items_dict = {"TRB": RuleVariation_30, "MSG": RuleVariation_481}

    @overload
    @classmethod
    def spec(cls, key : Literal["TRB"]) -> RuleVariation_30:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSG"]) -> RuleVariation_481:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TRB"], Literal["MSG"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TRB"]) -> RuleVariation_30:
        ...
    @overload
    def get_item(self, key : Literal["MSG"]) -> RuleVariation_481:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1223_Arg) -> 'Variation_1223':
        return cls._create(arg) # type: ignore

RuleVariation_1162_Arg: TypeAlias = Variation_1223_Arg
class RuleVariation_1162(RuleVariationContextFree):
    cv_variation = Variation_1223

    @classmethod
    def create(cls, arg : RuleVariation_1162_Arg) -> "RuleVariation_1162":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1223:
        return self.arg # type: ignore

NonSpare_473_Arg: TypeAlias = RuleVariation_1162_Arg
class NonSpare_473(NonSpare):
    cv_name = "310"
    cv_title = "Pre-programmed Message"
    cv_rule = RuleVariation_1162

    @classmethod
    def create(cls, arg : NonSpare_473_Arg) -> "NonSpare_473":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1162:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1223:
        return self.rule.variation

class UapItem_473(UapItem):
    cv_non_spare = NonSpare_473

Content_748_Arg: TypeAlias = Union[int, float, Tuple[float, Literal[""]]]
class Content_748(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.25
    cv_unit = ""

    def as_quantity(self, cv_unit : Optional[Literal[""]] = None) -> float:
        return self._as_quantity()

RuleContent_747_Arg: TypeAlias = Content_748_Arg
class RuleContent_747(RuleContentContextFree):
    cv_content = Content_748

    @property
    def content(self) -> Content_748:
        return self._get_content() # type: ignore

Variation_318_Arg: TypeAlias = RuleContent_747_Arg
class Variation_318(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_747

    @classmethod
    def create(cls, arg : Variation_318_Arg) -> "Variation_318":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_747:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_748:
        return self.rule.content

RuleVariation_311_Arg: TypeAlias = Variation_318_Arg
class RuleVariation_311(RuleVariationContextFree):
    cv_variation = Variation_318

    @classmethod
    def create(cls, arg : RuleVariation_311_Arg) -> "RuleVariation_311":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_318:
        return self.arg # type: ignore

NonSpare_2078_Arg: TypeAlias = RuleVariation_311_Arg
class NonSpare_2078(NonSpare):
    cv_name = "X"
    cv_title = "DOP (X-Component)"
    cv_rule = RuleVariation_311

    @classmethod
    def create(cls, arg : NonSpare_2078_Arg) -> "NonSpare_2078":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_311:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_318:
        return self.rule.variation

Item_1185_Arg: TypeAlias = NonSpare_2078_Arg
class Item_1185(Item):
    cv_non_spare = NonSpare_2078

    @classmethod
    def create(cls, arg : Item_1185_Arg) -> "Item_1185":
        return cls._create(arg) # type: ignore

NonSpare_2131_Arg: TypeAlias = RuleVariation_311_Arg
class NonSpare_2131(NonSpare):
    cv_name = "Y"
    cv_title = "DOP (Y-Component)"
    cv_rule = RuleVariation_311

    @classmethod
    def create(cls, arg : NonSpare_2131_Arg) -> "NonSpare_2131":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_311:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_318:
        return self.rule.variation

Item_1235_Arg: TypeAlias = NonSpare_2131_Arg
class Item_1235(Item):
    cv_non_spare = NonSpare_2131

    @classmethod
    def create(cls, arg : Item_1235_Arg) -> "Item_1235":
        return cls._create(arg) # type: ignore

NonSpare_2112_Arg: TypeAlias = RuleVariation_311_Arg
class NonSpare_2112(NonSpare):
    cv_name = "XY"
    cv_title = "DOP (Correlation XY)"
    cv_rule = RuleVariation_311

    @classmethod
    def create(cls, arg : NonSpare_2112_Arg) -> "NonSpare_2112":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_311:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_318:
        return self.rule.variation

Item_1216_Arg: TypeAlias = NonSpare_2112_Arg
class Item_1216(Item):
    cv_non_spare = NonSpare_2112

    @classmethod
    def create(cls, arg : Item_1216_Arg) -> "Item_1216":
        return cls._create(arg) # type: ignore

Variation_1295_Arg_Group = Tuple[Union[RuleVariation_311_Arg, Tuple[Literal["X"], RuleVariation_311_Arg]], Union[RuleVariation_311_Arg, Tuple[Literal["Y"], RuleVariation_311_Arg]], Union[RuleVariation_311_Arg, Tuple[Literal["XY"], RuleVariation_311_Arg]]]
Variation_1295_Arg: TypeAlias = Union[int, Variation_1295_Arg_Group]
class Variation_1295(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_1185, 16), (Item_1235, 16), (Item_1216, 16)]
    cv_items_dict = {"X": RuleVariation_311, "Y": RuleVariation_311, "XY": RuleVariation_311}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_311:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_311:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XY"]) -> RuleVariation_311:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"], Literal["XY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_311:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_311:
        ...
    @overload
    def get_item(self, key : Literal["XY"]) -> RuleVariation_311:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1295_Arg) -> 'Variation_1295':
        return cls._create(arg) # type: ignore

RuleVariation_1225_Arg: TypeAlias = Variation_1295_Arg
class RuleVariation_1225(RuleVariationContextFree):
    cv_variation = Variation_1295

    @classmethod
    def create(cls, arg : RuleVariation_1225_Arg) -> "RuleVariation_1225":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1295:
        return self.arg # type: ignore

NonSpare_883_Arg: TypeAlias = RuleVariation_1225_Arg
class NonSpare_883(NonSpare):
    cv_name = "DOP"
    cv_title = "DOP of Position"
    cv_rule = RuleVariation_1225

    @classmethod
    def create(cls, arg : NonSpare_883_Arg) -> "NonSpare_883":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1225:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1295:
        return self.rule.variation

Variation_322_Arg: TypeAlias = RuleContent_751_Arg
class Variation_322(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_751

    @classmethod
    def create(cls, arg : Variation_322_Arg) -> "Variation_322":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_751:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_752:
        return self.rule.content

RuleVariation_315_Arg: TypeAlias = Variation_322_Arg
class RuleVariation_315(RuleVariationContextFree):
    cv_variation = Variation_322

    @classmethod
    def create(cls, arg : RuleVariation_315_Arg) -> "RuleVariation_315":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_322:
        return self.arg # type: ignore

NonSpare_2082_Arg: TypeAlias = RuleVariation_315_Arg
class NonSpare_2082(NonSpare):
    cv_name = "X"
    cv_title = "SDP (X-Component)"
    cv_rule = RuleVariation_315

    @classmethod
    def create(cls, arg : NonSpare_2082_Arg) -> "NonSpare_2082":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_315:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_322:
        return self.rule.variation

Item_1189_Arg: TypeAlias = NonSpare_2082_Arg
class Item_1189(Item):
    cv_non_spare = NonSpare_2082

    @classmethod
    def create(cls, arg : Item_1189_Arg) -> "Item_1189":
        return cls._create(arg) # type: ignore

NonSpare_2135_Arg: TypeAlias = RuleVariation_315_Arg
class NonSpare_2135(NonSpare):
    cv_name = "Y"
    cv_title = "SDP (Y-Component)"
    cv_rule = RuleVariation_315

    @classmethod
    def create(cls, arg : NonSpare_2135_Arg) -> "NonSpare_2135":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_315:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_322:
        return self.rule.variation

Item_1239_Arg: TypeAlias = NonSpare_2135_Arg
class Item_1239(Item):
    cv_non_spare = NonSpare_2135

    @classmethod
    def create(cls, arg : Item_1239_Arg) -> "Item_1239":
        return cls._create(arg) # type: ignore

NonSpare_2113_Arg: TypeAlias = RuleVariation_311_Arg
class NonSpare_2113(NonSpare):
    cv_name = "XY"
    cv_title = "SDP (Correlation XY)"
    cv_rule = RuleVariation_311

    @classmethod
    def create(cls, arg : NonSpare_2113_Arg) -> "NonSpare_2113":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_311:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_318:
        return self.rule.variation

Item_1217_Arg: TypeAlias = NonSpare_2113_Arg
class Item_1217(Item):
    cv_non_spare = NonSpare_2113

    @classmethod
    def create(cls, arg : Item_1217_Arg) -> "Item_1217":
        return cls._create(arg) # type: ignore

Variation_1299_Arg_Group = Tuple[Union[RuleVariation_315_Arg, Tuple[Literal["X"], RuleVariation_315_Arg]], Union[RuleVariation_315_Arg, Tuple[Literal["Y"], RuleVariation_315_Arg]], Union[RuleVariation_311_Arg, Tuple[Literal["XY"], RuleVariation_311_Arg]]]
Variation_1299_Arg: TypeAlias = Union[int, Variation_1299_Arg_Group]
class Variation_1299(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_1189, 16), (Item_1239, 16), (Item_1217, 16)]
    cv_items_dict = {"X": RuleVariation_315, "Y": RuleVariation_315, "XY": RuleVariation_311}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_315:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_315:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XY"]) -> RuleVariation_311:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"], Literal["XY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_315:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_315:
        ...
    @overload
    def get_item(self, key : Literal["XY"]) -> RuleVariation_311:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1299_Arg) -> 'Variation_1299':
        return cls._create(arg) # type: ignore

RuleVariation_1229_Arg: TypeAlias = Variation_1299_Arg
class RuleVariation_1229(RuleVariationContextFree):
    cv_variation = Variation_1299

    @classmethod
    def create(cls, arg : RuleVariation_1229_Arg) -> "RuleVariation_1229":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1299:
        return self.arg # type: ignore

NonSpare_1679_Arg: TypeAlias = RuleVariation_1229_Arg
class NonSpare_1679(NonSpare):
    cv_name = "SDP"
    cv_title = "Standard Deviation of Position"
    cv_rule = RuleVariation_1229

    @classmethod
    def create(cls, arg : NonSpare_1679_Arg) -> "NonSpare_1679":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1299:
        return self.rule.variation

NonSpare_1674_Arg: TypeAlias = RuleVariation_302_Arg
class NonSpare_1674(NonSpare):
    cv_name = "SDH"
    cv_title = "Standard Deviation of Geometric Height (WGS 84)"
    cv_rule = RuleVariation_302

    @classmethod
    def create(cls, arg : NonSpare_1674_Arg) -> "NonSpare_1674":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_302:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_309:
        return self.rule.variation

Variation_1473_Arg = TypedDict('Variation_1473_Arg', {
    "DOP": NonSpare_883_Arg,
    "SDP": NonSpare_1679_Arg,
    "SDH": NonSpare_1674_Arg,
}, total=False)
class Variation_1473(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_883, NonSpare_1679, NonSpare_1674]
    cv_items_dict = {"DOP": NonSpare_883, "SDP": NonSpare_1679, "SDH": NonSpare_1674}

    @overload
    @classmethod
    def spec(cls, key : Literal["DOP"]) -> NonSpare_883:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDP"]) -> NonSpare_1679:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDH"]) -> NonSpare_1674:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["DOP"], Literal["SDP"], Literal["SDH"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["DOP"]) -> Optional[NonSpare_883]:
        ...
    @overload
    def get_item(self, key : Literal["SDP"]) -> Optional[NonSpare_1679]:
        ...
    @overload
    def get_item(self, key : Literal["SDH"]) -> Optional[NonSpare_1674]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["DOP"], val : NonSpare_883_Arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["SDP"], val : NonSpare_1679_Arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["SDH"], val : NonSpare_1674_Arg) -> "Variation_1473":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["DOP"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["SDP"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["SDH"]) -> "Variation_1473":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1473_Arg) -> 'Variation_1473':
        return cls._create(arg) # type: ignore

RuleVariation_1396_Arg: TypeAlias = Variation_1473_Arg
class RuleVariation_1396(RuleVariationContextFree):
    cv_variation = Variation_1473

    @classmethod
    def create(cls, arg : RuleVariation_1396_Arg) -> "RuleVariation_1396":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1473:
        return self.arg # type: ignore

NonSpare_512_Arg: TypeAlias = RuleVariation_1396_Arg
class NonSpare_512(NonSpare):
    cv_name = "500"
    cv_title = "Position Accuracy"
    cv_rule = RuleVariation_1396

    @classmethod
    def create(cls, arg : NonSpare_512_Arg) -> "NonSpare_512":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1396:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1473:
        return self.rule.variation

class UapItem_511(UapItem):
    cv_non_spare = NonSpare_512

Content_467_Arg: TypeAlias = int
class Content_467(ContentTable):
    cv_values = {0: "TU1/RU1 has NOT contributed to the target detection", 1: "TU1/RU1 has contributed to the target detection"}

RuleContent_467_Arg: TypeAlias = Content_467_Arg
class RuleContent_467(RuleContentContextFree):
    cv_content = Content_467

    @property
    def content(self) -> Content_467:
        return self._get_content() # type: ignore

Variation_80_Arg: TypeAlias = RuleContent_467_Arg
class Variation_80(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_467

    @classmethod
    def create(cls, arg : Variation_80_Arg) -> "Variation_80":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_467:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_467:
        return self.rule.content

RuleVariation_80_Arg: TypeAlias = Variation_80_Arg
class RuleVariation_80(RuleVariationContextFree):
    cv_variation = Variation_80

    @classmethod
    def create(cls, arg : RuleVariation_80_Arg) -> "RuleVariation_80":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_80:
        return self.arg # type: ignore

NonSpare_674_Arg: TypeAlias = RuleVariation_80_Arg
class NonSpare_674(NonSpare):
    cv_name = "BIT1"
    cv_title = "TU1/RU1 Contribution"
    cv_rule = RuleVariation_80

    @classmethod
    def create(cls, arg : NonSpare_674_Arg) -> "NonSpare_674":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_80:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_80:
        return self.rule.variation

Item_118_Arg: TypeAlias = NonSpare_674_Arg
class Item_118(Item):
    cv_non_spare = NonSpare_674

    @classmethod
    def create(cls, arg : Item_118_Arg) -> "Item_118":
        return cls._create(arg) # type: ignore

Content_468_Arg: TypeAlias = int
class Content_468(ContentTable):
    cv_values = {0: "TU2/RU2 has NOT contributed to the target detection", 1: "TU2/RU2 has contributed to the target detection"}

RuleContent_468_Arg: TypeAlias = Content_468_Arg
class RuleContent_468(RuleContentContextFree):
    cv_content = Content_468

    @property
    def content(self) -> Content_468:
        return self._get_content() # type: ignore

Variation_450_Arg: TypeAlias = RuleContent_468_Arg
class Variation_450(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_468

    @classmethod
    def create(cls, arg : Variation_450_Arg) -> "Variation_450":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_468:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_468:
        return self.rule.content

RuleVariation_439_Arg: TypeAlias = Variation_450_Arg
class RuleVariation_439(RuleVariationContextFree):
    cv_variation = Variation_450

    @classmethod
    def create(cls, arg : RuleVariation_439_Arg) -> "RuleVariation_439":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_450:
        return self.arg # type: ignore

NonSpare_675_Arg: TypeAlias = RuleVariation_439_Arg
class NonSpare_675(NonSpare):
    cv_name = "BIT2"
    cv_title = "TU2/RU2 Contribution"
    cv_rule = RuleVariation_439

    @classmethod
    def create(cls, arg : NonSpare_675_Arg) -> "NonSpare_675":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_439:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_450:
        return self.rule.variation

Item_119_Arg: TypeAlias = NonSpare_675_Arg
class Item_119(Item):
    cv_non_spare = NonSpare_675

    @classmethod
    def create(cls, arg : Item_119_Arg) -> "Item_119":
        return cls._create(arg) # type: ignore

Content_469_Arg: TypeAlias = int
class Content_469(ContentTable):
    cv_values = {0: "TU3/RU3 has NOT contributed to the target detection", 1: "TU3/RU3 has contributed to the target detection"}

RuleContent_469_Arg: TypeAlias = Content_469_Arg
class RuleContent_469(RuleContentContextFree):
    cv_content = Content_469

    @property
    def content(self) -> Content_469:
        return self._get_content() # type: ignore

Variation_574_Arg: TypeAlias = RuleContent_469_Arg
class Variation_574(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_469

    @classmethod
    def create(cls, arg : Variation_574_Arg) -> "Variation_574":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_469:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_469:
        return self.rule.content

RuleVariation_563_Arg: TypeAlias = Variation_574_Arg
class RuleVariation_563(RuleVariationContextFree):
    cv_variation = Variation_574

    @classmethod
    def create(cls, arg : RuleVariation_563_Arg) -> "RuleVariation_563":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_574:
        return self.arg # type: ignore

NonSpare_676_Arg: TypeAlias = RuleVariation_563_Arg
class NonSpare_676(NonSpare):
    cv_name = "BIT3"
    cv_title = "TU3/RU3 Contribution"
    cv_rule = RuleVariation_563

    @classmethod
    def create(cls, arg : NonSpare_676_Arg) -> "NonSpare_676":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_563:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_574:
        return self.rule.variation

Item_120_Arg: TypeAlias = NonSpare_676_Arg
class Item_120(Item):
    cv_non_spare = NonSpare_676

    @classmethod
    def create(cls, arg : Item_120_Arg) -> "Item_120":
        return cls._create(arg) # type: ignore

Content_470_Arg: TypeAlias = int
class Content_470(ContentTable):
    cv_values = {0: "TU4/RU4 has NOT contributed to the target detection", 1: "TU4/RU4 has contributed to the target detection"}

RuleContent_470_Arg: TypeAlias = Content_470_Arg
class RuleContent_470(RuleContentContextFree):
    cv_content = Content_470

    @property
    def content(self) -> Content_470:
        return self._get_content() # type: ignore

Variation_659_Arg: TypeAlias = RuleContent_470_Arg
class Variation_659(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_470

    @classmethod
    def create(cls, arg : Variation_659_Arg) -> "Variation_659":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_470:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_470:
        return self.rule.content

RuleVariation_648_Arg: TypeAlias = Variation_659_Arg
class RuleVariation_648(RuleVariationContextFree):
    cv_variation = Variation_659

    @classmethod
    def create(cls, arg : RuleVariation_648_Arg) -> "RuleVariation_648":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_659:
        return self.arg # type: ignore

NonSpare_677_Arg: TypeAlias = RuleVariation_648_Arg
class NonSpare_677(NonSpare):
    cv_name = "BIT4"
    cv_title = "TU4/RU4 Contribution"
    cv_rule = RuleVariation_648

    @classmethod
    def create(cls, arg : NonSpare_677_Arg) -> "NonSpare_677":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_648:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_659:
        return self.rule.variation

Item_121_Arg: TypeAlias = NonSpare_677_Arg
class Item_121(Item):
    cv_non_spare = NonSpare_677

    @classmethod
    def create(cls, arg : Item_121_Arg) -> "Item_121":
        return cls._create(arg) # type: ignore

Content_471_Arg: TypeAlias = int
class Content_471(ContentTable):
    cv_values = {0: "TU5/RU5 has NOT contributed to the target detection", 1: "TU5/RU5 has contributed to the target detection"}

RuleContent_471_Arg: TypeAlias = Content_471_Arg
class RuleContent_471(RuleContentContextFree):
    cv_content = Content_471

    @property
    def content(self) -> Content_471:
        return self._get_content() # type: ignore

Variation_750_Arg: TypeAlias = RuleContent_471_Arg
class Variation_750(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_471

    @classmethod
    def create(cls, arg : Variation_750_Arg) -> "Variation_750":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_471:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_471:
        return self.rule.content

RuleVariation_739_Arg: TypeAlias = Variation_750_Arg
class RuleVariation_739(RuleVariationContextFree):
    cv_variation = Variation_750

    @classmethod
    def create(cls, arg : RuleVariation_739_Arg) -> "RuleVariation_739":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_750:
        return self.arg # type: ignore

NonSpare_678_Arg: TypeAlias = RuleVariation_739_Arg
class NonSpare_678(NonSpare):
    cv_name = "BIT5"
    cv_title = "TU5/RU5 Contribution"
    cv_rule = RuleVariation_739

    @classmethod
    def create(cls, arg : NonSpare_678_Arg) -> "NonSpare_678":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_739:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_750:
        return self.rule.variation

Item_122_Arg: TypeAlias = NonSpare_678_Arg
class Item_122(Item):
    cv_non_spare = NonSpare_678

    @classmethod
    def create(cls, arg : Item_122_Arg) -> "Item_122":
        return cls._create(arg) # type: ignore

Content_472_Arg: TypeAlias = int
class Content_472(ContentTable):
    cv_values = {0: "TU6/RU6 has NOT contributed to the target detection", 1: "TU6/RU6 has contributed to the target detection"}

RuleContent_472_Arg: TypeAlias = Content_472_Arg
class RuleContent_472(RuleContentContextFree):
    cv_content = Content_472

    @property
    def content(self) -> Content_472:
        return self._get_content() # type: ignore

Variation_868_Arg: TypeAlias = RuleContent_472_Arg
class Variation_868(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_472

    @classmethod
    def create(cls, arg : Variation_868_Arg) -> "Variation_868":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_472:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_472:
        return self.rule.content

RuleVariation_838_Arg: TypeAlias = Variation_868_Arg
class RuleVariation_838(RuleVariationContextFree):
    cv_variation = Variation_868

    @classmethod
    def create(cls, arg : RuleVariation_838_Arg) -> "RuleVariation_838":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_868:
        return self.arg # type: ignore

NonSpare_679_Arg: TypeAlias = RuleVariation_838_Arg
class NonSpare_679(NonSpare):
    cv_name = "BIT6"
    cv_title = "TU6/RU6 Contribution"
    cv_rule = RuleVariation_838

    @classmethod
    def create(cls, arg : NonSpare_679_Arg) -> "NonSpare_679":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_838:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_868:
        return self.rule.variation

Item_123_Arg: TypeAlias = NonSpare_679_Arg
class Item_123(Item):
    cv_non_spare = NonSpare_679

    @classmethod
    def create(cls, arg : Item_123_Arg) -> "Item_123":
        return cls._create(arg) # type: ignore

Content_473_Arg: TypeAlias = int
class Content_473(ContentTable):
    cv_values = {0: "TU7/RU7 has NOT contributed to the target detection", 1: "TU7/RU7 has contributed to the target detection"}

RuleContent_473_Arg: TypeAlias = Content_473_Arg
class RuleContent_473(RuleContentContextFree):
    cv_content = Content_473

    @property
    def content(self) -> Content_473:
        return self._get_content() # type: ignore

Variation_951_Arg: TypeAlias = RuleContent_473_Arg
class Variation_951(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_473

    @classmethod
    def create(cls, arg : Variation_951_Arg) -> "Variation_951":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_473:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_473:
        return self.rule.content

RuleVariation_921_Arg: TypeAlias = Variation_951_Arg
class RuleVariation_921(RuleVariationContextFree):
    cv_variation = Variation_951

    @classmethod
    def create(cls, arg : RuleVariation_921_Arg) -> "RuleVariation_921":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_951:
        return self.arg # type: ignore

NonSpare_680_Arg: TypeAlias = RuleVariation_921_Arg
class NonSpare_680(NonSpare):
    cv_name = "BIT7"
    cv_title = "TU7/RU7 Contribution"
    cv_rule = RuleVariation_921

    @classmethod
    def create(cls, arg : NonSpare_680_Arg) -> "NonSpare_680":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_921:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_951:
        return self.rule.variation

Item_124_Arg: TypeAlias = NonSpare_680_Arg
class Item_124(Item):
    cv_non_spare = NonSpare_680

    @classmethod
    def create(cls, arg : Item_124_Arg) -> "Item_124":
        return cls._create(arg) # type: ignore

Content_474_Arg: TypeAlias = int
class Content_474(ContentTable):
    cv_values = {0: "TU8/RU8 has NOT contributed to the target detection", 1: "TU8/RU8 has contributed to the target detection"}

RuleContent_474_Arg: TypeAlias = Content_474_Arg
class RuleContent_474(RuleContentContextFree):
    cv_content = Content_474

    @property
    def content(self) -> Content_474:
        return self._get_content() # type: ignore

Variation_986_Arg: TypeAlias = RuleContent_474_Arg
class Variation_986(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_474

    @classmethod
    def create(cls, arg : Variation_986_Arg) -> "Variation_986":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_474:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_474:
        return self.rule.content

RuleVariation_956_Arg: TypeAlias = Variation_986_Arg
class RuleVariation_956(RuleVariationContextFree):
    cv_variation = Variation_986

    @classmethod
    def create(cls, arg : RuleVariation_956_Arg) -> "RuleVariation_956":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_986:
        return self.arg # type: ignore

NonSpare_681_Arg: TypeAlias = RuleVariation_956_Arg
class NonSpare_681(NonSpare):
    cv_name = "BIT8"
    cv_title = "TU8/RU8 Contribution"
    cv_rule = RuleVariation_956

    @classmethod
    def create(cls, arg : NonSpare_681_Arg) -> "NonSpare_681":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_956:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_986:
        return self.rule.variation

Item_125_Arg: TypeAlias = NonSpare_681_Arg
class Item_125(Item):
    cv_non_spare = NonSpare_681

    @classmethod
    def create(cls, arg : Item_125_Arg) -> "Item_125":
        return cls._create(arg) # type: ignore

Variation_1056_Arg_Group = Tuple[Union[RuleVariation_80_Arg, Tuple[Literal["BIT1"], RuleVariation_80_Arg]], Union[RuleVariation_439_Arg, Tuple[Literal["BIT2"], RuleVariation_439_Arg]], Union[RuleVariation_563_Arg, Tuple[Literal["BIT3"], RuleVariation_563_Arg]], Union[RuleVariation_648_Arg, Tuple[Literal["BIT4"], RuleVariation_648_Arg]], Union[RuleVariation_739_Arg, Tuple[Literal["BIT5"], RuleVariation_739_Arg]], Union[RuleVariation_838_Arg, Tuple[Literal["BIT6"], RuleVariation_838_Arg]], Union[RuleVariation_921_Arg, Tuple[Literal["BIT7"], RuleVariation_921_Arg]], Union[RuleVariation_956_Arg, Tuple[Literal["BIT8"], RuleVariation_956_Arg]]]
Variation_1056_Arg: TypeAlias = Union[int, Variation_1056_Arg_Group]
class Variation_1056(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_118, 1), (Item_119, 1), (Item_120, 1), (Item_121, 1), (Item_122, 1), (Item_123, 1), (Item_124, 1), (Item_125, 1)]
    cv_items_dict = {"BIT1": RuleVariation_80, "BIT2": RuleVariation_439, "BIT3": RuleVariation_563, "BIT4": RuleVariation_648, "BIT5": RuleVariation_739, "BIT6": RuleVariation_838, "BIT7": RuleVariation_921, "BIT8": RuleVariation_956}

    @overload
    @classmethod
    def spec(cls, key : Literal["BIT1"]) -> RuleVariation_80:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BIT2"]) -> RuleVariation_439:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BIT3"]) -> RuleVariation_563:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BIT4"]) -> RuleVariation_648:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BIT5"]) -> RuleVariation_739:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BIT6"]) -> RuleVariation_838:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BIT7"]) -> RuleVariation_921:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BIT8"]) -> RuleVariation_956:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["BIT1"], Literal["BIT2"], Literal["BIT3"], Literal["BIT4"], Literal["BIT5"], Literal["BIT6"], Literal["BIT7"], Literal["BIT8"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["BIT1"]) -> RuleVariation_80:
        ...
    @overload
    def get_item(self, key : Literal["BIT2"]) -> RuleVariation_439:
        ...
    @overload
    def get_item(self, key : Literal["BIT3"]) -> RuleVariation_563:
        ...
    @overload
    def get_item(self, key : Literal["BIT4"]) -> RuleVariation_648:
        ...
    @overload
    def get_item(self, key : Literal["BIT5"]) -> RuleVariation_739:
        ...
    @overload
    def get_item(self, key : Literal["BIT6"]) -> RuleVariation_838:
        ...
    @overload
    def get_item(self, key : Literal["BIT7"]) -> RuleVariation_921:
        ...
    @overload
    def get_item(self, key : Literal["BIT8"]) -> RuleVariation_956:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1056_Arg) -> 'Variation_1056':
        return cls._create(arg) # type: ignore

Variation_1403_Arg: TypeAlias = List[Variation_1056_Arg]
class Variation_1403(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1056

    @classmethod
    def create(cls, arg : Variation_1403_Arg) -> 'Variation_1403':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1056]:
        return self._get_list() # type: ignore

RuleVariation_1326_Arg: TypeAlias = Variation_1403_Arg
class RuleVariation_1326(RuleVariationContextFree):
    cv_variation = Variation_1403

    @classmethod
    def create(cls, arg : RuleVariation_1326_Arg) -> "RuleVariation_1326":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1403:
        return self.arg # type: ignore

NonSpare_492_Arg: TypeAlias = RuleVariation_1326_Arg
class NonSpare_492(NonSpare):
    cv_name = "400"
    cv_title = "Contributing Devices"
    cv_rule = RuleVariation_1326

    @classmethod
    def create(cls, arg : NonSpare_492_Arg) -> "NonSpare_492":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1326:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1403:
        return self.rule.variation

class UapItem_491(UapItem):
    cv_non_spare = NonSpare_492

NonSpare_1226_Arg: TypeAlias = RuleVariation_382_Arg
class NonSpare_1226(NonSpare):
    cv_name = "MBDATA"
    cv_title = "56-bit Message Conveying Mode S Comm B Message Data"
    cv_rule = RuleVariation_382

    @classmethod
    def create(cls, arg : NonSpare_1226_Arg) -> "NonSpare_1226":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_382:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_390:
        return self.rule.variation

Item_528_Arg: TypeAlias = NonSpare_1226_Arg
class Item_528(Item):
    cv_non_spare = NonSpare_1226

    @classmethod
    def create(cls, arg : Item_528_Arg) -> "Item_528":
        return cls._create(arg) # type: ignore

NonSpare_670_Arg: TypeAlias = RuleVariation_131_Arg
class NonSpare_670(NonSpare):
    cv_name = "BDS1"
    cv_title = "Comm B Data Buffer Store 1 Address"
    cv_rule = RuleVariation_131

    @classmethod
    def create(cls, arg : NonSpare_670_Arg) -> "NonSpare_670":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_131:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_131:
        return self.rule.variation

Item_115_Arg: TypeAlias = NonSpare_670_Arg
class Item_115(Item):
    cv_non_spare = NonSpare_670

    @classmethod
    def create(cls, arg : Item_115_Arg) -> "Item_115":
        return cls._create(arg) # type: ignore

NonSpare_672_Arg: TypeAlias = RuleVariation_766_Arg
class NonSpare_672(NonSpare):
    cv_name = "BDS2"
    cv_title = "Comm B Data Buffer Store 2 Address"
    cv_rule = RuleVariation_766

    @classmethod
    def create(cls, arg : NonSpare_672_Arg) -> "NonSpare_672":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_766:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_796:
        return self.rule.variation

Item_117_Arg: TypeAlias = NonSpare_672_Arg
class Item_117(Item):
    cv_non_spare = NonSpare_672

    @classmethod
    def create(cls, arg : Item_117_Arg) -> "Item_117":
        return cls._create(arg) # type: ignore

Variation_1137_Arg_Group = Tuple[Union[RuleVariation_382_Arg, Tuple[Literal["MBDATA"], RuleVariation_382_Arg]], Union[RuleVariation_131_Arg, Tuple[Literal["BDS1"], RuleVariation_131_Arg]], Union[RuleVariation_766_Arg, Tuple[Literal["BDS2"], RuleVariation_766_Arg]]]
Variation_1137_Arg: TypeAlias = Union[int, Variation_1137_Arg_Group]
class Variation_1137(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_528, 56), (Item_115, 4), (Item_117, 4)]
    cv_items_dict = {"MBDATA": RuleVariation_382, "BDS1": RuleVariation_131, "BDS2": RuleVariation_766}

    @overload
    @classmethod
    def spec(cls, key : Literal["MBDATA"]) -> RuleVariation_382:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BDS1"]) -> RuleVariation_131:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BDS2"]) -> RuleVariation_766:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MBDATA"], Literal["BDS1"], Literal["BDS2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MBDATA"]) -> RuleVariation_382:
        ...
    @overload
    def get_item(self, key : Literal["BDS1"]) -> RuleVariation_131:
        ...
    @overload
    def get_item(self, key : Literal["BDS2"]) -> RuleVariation_766:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1137_Arg) -> 'Variation_1137':
        return cls._create(arg) # type: ignore

Variation_1414_Arg: TypeAlias = List[Variation_1137_Arg]
class Variation_1414(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1137

    @classmethod
    def create(cls, arg : Variation_1414_Arg) -> 'Variation_1414':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1137]:
        return self._get_list() # type: ignore

RuleVariation_1337_Arg: TypeAlias = Variation_1414_Arg
class RuleVariation_1337(RuleVariationContextFree):
    cv_variation = Variation_1414

    @classmethod
    def create(cls, arg : RuleVariation_1337_Arg) -> "RuleVariation_1337":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1414:
        return self.arg # type: ignore

NonSpare_444_Arg: TypeAlias = RuleVariation_1337_Arg
class NonSpare_444(NonSpare):
    cv_name = "250"
    cv_title = "Mode S MB Data"
    cv_rule = RuleVariation_1337

    @classmethod
    def create(cls, arg : NonSpare_444_Arg) -> "NonSpare_444":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1337:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1414:
        return self.rule.variation

class UapItem_444(UapItem):
    cv_non_spare = NonSpare_444

Content_320_Arg: TypeAlias = int
class Content_320(ContentTable):
    cv_values = {0: "No alert, no SPI, aircraft airborne", 1: "No alert, no SPI, aircraft on ground", 2: "Alert, no SPI, aircraft airborne", 3: "Alert, no SPI, aircraft on ground", 4: "Alert, SPI, aircraft airborne or on ground", 5: "No alert, SPI, aircraft airborne or on ground", 6: "Not assigned", 7: "Information not yet extracted"}

RuleContent_320_Arg: TypeAlias = Content_320_Arg
class RuleContent_320(RuleContentContextFree):
    cv_content = Content_320

    @property
    def content(self) -> Content_320:
        return self._get_content() # type: ignore

Variation_682_Arg: TypeAlias = RuleContent_320_Arg
class Variation_682(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 3
    cv_rule = RuleContent_320

    @classmethod
    def create(cls, arg : Variation_682_Arg) -> "Variation_682":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_320:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_320:
        return self.rule.content

RuleVariation_671_Arg: TypeAlias = Variation_682_Arg
class RuleVariation_671(RuleVariationContextFree):
    cv_variation = Variation_682

    @classmethod
    def create(cls, arg : RuleVariation_671_Arg) -> "RuleVariation_671":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_682:
        return self.arg # type: ignore

NonSpare_1767_Arg: TypeAlias = RuleVariation_671_Arg
class NonSpare_1767(NonSpare):
    cv_name = "STAT"
    cv_title = "Flight Status"
    cv_rule = RuleVariation_671

    @classmethod
    def create(cls, arg : NonSpare_1767_Arg) -> "NonSpare_1767":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_671:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_682:
        return self.rule.variation

Item_934_Arg: TypeAlias = NonSpare_1767_Arg
class Item_934(Item):
    cv_non_spare = NonSpare_1767

    @classmethod
    def create(cls, arg : Item_934_Arg) -> "Item_934":
        return cls._create(arg) # type: ignore

NonSpare_1323_Arg: TypeAlias = RuleVariation_55_Arg
class NonSpare_1323(NonSpare):
    cv_name = "MSSC"
    cv_title = "Mode-S Specific Service Capability"
    cv_rule = RuleVariation_55

    @classmethod
    def create(cls, arg : NonSpare_1323_Arg) -> "NonSpare_1323":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_55:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_55:
        return self.rule.variation

Item_593_Arg: TypeAlias = NonSpare_1323_Arg
class Item_593(Item):
    cv_non_spare = NonSpare_1323

    @classmethod
    def create(cls, arg : Item_593_Arg) -> "Item_593":
        return cls._create(arg) # type: ignore

NonSpare_665_Arg: TypeAlias = RuleVariation_766_Arg
class NonSpare_665(NonSpare):
    cv_name = "B1B"
    cv_title = "BDS 1,0 Bits 37/40"
    cv_rule = RuleVariation_766

    @classmethod
    def create(cls, arg : NonSpare_665_Arg) -> "NonSpare_665":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_766:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_796:
        return self.rule.variation

Item_110_Arg: TypeAlias = NonSpare_665_Arg
class Item_110(Item):
    cv_non_spare = NonSpare_665

    @classmethod
    def create(cls, arg : Item_110_Arg) -> "Item_110":
        return cls._create(arg) # type: ignore

Variation_1073_Arg_Group = Tuple[Union[RuleVariation_123_Arg, Tuple[Literal["COM"], RuleVariation_123_Arg]], Union[RuleVariation_671_Arg, Tuple[Literal["STAT"], RuleVariation_671_Arg]], int, Union[RuleVariation_55_Arg, Tuple[Literal["MSSC"], RuleVariation_55_Arg]], Union[RuleVariation_388_Arg, Tuple[Literal["ARC"], RuleVariation_388_Arg]], Union[RuleVariation_544_Arg, Tuple[Literal["AIC"], RuleVariation_544_Arg]], Union[RuleVariation_600_Arg, Tuple[Literal["B1A"], RuleVariation_600_Arg]], Union[RuleVariation_766_Arg, Tuple[Literal["B1B"], RuleVariation_766_Arg]]]
Variation_1073_Arg: TypeAlias = Union[int, Variation_1073_Arg_Group]
class Variation_1073(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_187, 3), (Item_934, 3), (Item_27, 2), (Item_593, 1), (Item_81, 1), (Item_55, 1), (Item_108, 1), (Item_110, 4)]
    cv_items_dict = {"COM": RuleVariation_123, "STAT": RuleVariation_671, "MSSC": RuleVariation_55, "ARC": RuleVariation_388, "AIC": RuleVariation_544, "B1A": RuleVariation_600, "B1B": RuleVariation_766}

    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> RuleVariation_123:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_671:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSSC"]) -> RuleVariation_55:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> RuleVariation_388:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AIC"]) -> RuleVariation_544:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1A"]) -> RuleVariation_600:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1B"]) -> RuleVariation_766:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COM"], Literal["STAT"], Literal["MSSC"], Literal["ARC"], Literal["AIC"], Literal["B1A"], Literal["B1B"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COM"]) -> RuleVariation_123:
        ...
    @overload
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_671:
        ...
    @overload
    def get_item(self, key : Literal["MSSC"]) -> RuleVariation_55:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_388:
        ...
    @overload
    def get_item(self, key : Literal["AIC"]) -> RuleVariation_544:
        ...
    @overload
    def get_item(self, key : Literal["B1A"]) -> RuleVariation_600:
        ...
    @overload
    def get_item(self, key : Literal["B1B"]) -> RuleVariation_766:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1073_Arg) -> 'Variation_1073':
        return cls._create(arg) # type: ignore

RuleVariation_1033_Arg: TypeAlias = Variation_1073_Arg
class RuleVariation_1033(RuleVariationContextFree):
    cv_variation = Variation_1073

    @classmethod
    def create(cls, arg : RuleVariation_1033_Arg) -> "RuleVariation_1033":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1073:
        return self.arg # type: ignore

NonSpare_426_Arg: TypeAlias = RuleVariation_1033_Arg
class NonSpare_426(NonSpare):
    cv_name = "230"
    cv_title = "Communications/ACAS Capability and Flight Status"
    cv_rule = RuleVariation_1033

    @classmethod
    def create(cls, arg : NonSpare_426_Arg) -> "NonSpare_426":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1033:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1073:
        return self.rule.variation

class UapItem_426(UapItem):
    cv_non_spare = NonSpare_426

NonSpare_448_Arg: TypeAlias = RuleVariation_382_Arg
class NonSpare_448(NonSpare):
    cv_name = "260"
    cv_title = "ACAS Resolution Advisory Report"
    cv_rule = RuleVariation_382

    @classmethod
    def create(cls, arg : NonSpare_448_Arg) -> "NonSpare_448":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_382:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_390:
        return self.rule.variation

class UapItem_448(UapItem):
    cv_non_spare = NonSpare_448

Content_395_Arg: TypeAlias = int
class Content_395(ContentTable):
    cv_values = {0: "Not defined; never used", 1: "Multipath Reply (Reflection)", 3: "Split plot", 10: "Phantom SSR plot", 11: "Non-Matching Mode-3/A Code", 12: "Mode C code / Mode S altitude code abnormal value compared to the track", 15: "Transponder anomaly detected", 16: "Duplicated or Illegal Mode S Aircraft Address", 17: "Mode S error correction applied", 18: "Undecodable Mode C code / Mode S altitude code"}

RuleContent_395_Arg: TypeAlias = Content_395_Arg
class RuleContent_395(RuleContentContextFree):
    cv_content = Content_395

    @property
    def content(self) -> Content_395:
        return self._get_content() # type: ignore

Variation_156_Arg: TypeAlias = RuleContent_395_Arg
class Variation_156(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_395

    @classmethod
    def create(cls, arg : Variation_156_Arg) -> "Variation_156":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_395:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_395:
        return self.rule.content

Variation_1452_Arg: TypeAlias = List[Variation_156_Arg]
class Variation_1452(Repetitive):
    cv_rep_bytes = None
    cv_variation = Variation_156

    @classmethod
    def create(cls, arg : Variation_1452_Arg) -> 'Variation_1452':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_156]:
        return self._get_list() # type: ignore

RuleVariation_1375_Arg: TypeAlias = Variation_1452_Arg
class RuleVariation_1375(RuleVariationContextFree):
    cv_variation = Variation_1452

    @classmethod
    def create(cls, arg : RuleVariation_1375_Arg) -> "RuleVariation_1375":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1452:
        return self.arg # type: ignore

NonSpare_116_Arg: TypeAlias = RuleVariation_1375_Arg
class NonSpare_116(NonSpare):
    cv_name = "030"
    cv_title = "Warning/Error Conditions"
    cv_rule = RuleVariation_1375

    @classmethod
    def create(cls, arg : NonSpare_116_Arg) -> "NonSpare_116":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1375:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1452:
        return self.rule.variation

class UapItem_116(UapItem):
    cv_non_spare = NonSpare_116

Content_282_Arg: TypeAlias = int
class Content_282(ContentTable):
    cv_values = {0: "Mode-1 code derived from the reply of the transponder", 1: "Smoothed Mode-1 code as provided by a local tracker"}

RuleContent_282_Arg: TypeAlias = Content_282_Arg
class RuleContent_282(RuleContentContextFree):
    cv_content = Content_282

    @property
    def content(self) -> Content_282:
        return self._get_content() # type: ignore

Variation_544_Arg: TypeAlias = RuleContent_282_Arg
class Variation_544(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_282

    @classmethod
    def create(cls, arg : Variation_544_Arg) -> "Variation_544":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_282:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_282:
        return self.rule.content

RuleVariation_533_Arg: TypeAlias = Variation_544_Arg
class RuleVariation_533(RuleVariationContextFree):
    cv_variation = Variation_544

    @classmethod
    def create(cls, arg : RuleVariation_533_Arg) -> "RuleVariation_533":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_544:
        return self.arg # type: ignore

NonSpare_1126_Arg: TypeAlias = RuleVariation_533_Arg
class NonSpare_1126(NonSpare):
    cv_name = "L"
    cv_title = ""
    cv_rule = RuleVariation_533

    @classmethod
    def create(cls, arg : NonSpare_1126_Arg) -> "NonSpare_1126":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_533:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_544:
        return self.rule.variation

Item_444_Arg: TypeAlias = NonSpare_1126_Arg
class Item_444(Item):
    cv_non_spare = NonSpare_1126

    @classmethod
    def create(cls, arg : Item_444_Arg) -> "Item_444":
        return cls._create(arg) # type: ignore

Variation_692_Arg: TypeAlias = RuleContent_0_Arg
class Variation_692(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 5
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_692_Arg) -> "Variation_692":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_681_Arg: TypeAlias = Variation_692_Arg
class RuleVariation_681(RuleVariationContextFree):
    cv_variation = Variation_692

    @classmethod
    def create(cls, arg : RuleVariation_681_Arg) -> "RuleVariation_681":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_692:
        return self.arg # type: ignore

NonSpare_1292_Arg: TypeAlias = RuleVariation_681_Arg
class NonSpare_1292(NonSpare):
    cv_name = "MODE1"
    cv_title = "Mode-1 Code in Octal Representation"
    cv_rule = RuleVariation_681

    @classmethod
    def create(cls, arg : NonSpare_1292_Arg) -> "NonSpare_1292":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_681:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_692:
        return self.rule.variation

Item_564_Arg: TypeAlias = NonSpare_1292_Arg
class Item_564(Item):
    cv_non_spare = NonSpare_1292

    @classmethod
    def create(cls, arg : Item_564_Arg) -> "Item_564":
        return cls._create(arg) # type: ignore

Variation_1266_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_533_Arg, Tuple[Literal["L"], RuleVariation_533_Arg]], Union[RuleVariation_681_Arg, Tuple[Literal["MODE1"], RuleVariation_681_Arg]]]
Variation_1266_Arg: TypeAlias = Union[int, Variation_1266_Arg_Group]
class Variation_1266(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1100, 1), (Item_355, 1), (Item_444, 1), (Item_564, 5)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "L": RuleVariation_533, "MODE1": RuleVariation_681}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_533:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE1"]) -> RuleVariation_681:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_533:
        ...
    @overload
    def get_item(self, key : Literal["MODE1"]) -> RuleVariation_681:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1266_Arg) -> 'Variation_1266':
        return cls._create(arg) # type: ignore

RuleVariation_1196_Arg: TypeAlias = Variation_1266_Arg
class RuleVariation_1196(RuleVariationContextFree):
    cv_variation = Variation_1266

    @classmethod
    def create(cls, arg : RuleVariation_1196_Arg) -> "RuleVariation_1196":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1266:
        return self.arg # type: ignore

NonSpare_184_Arg: TypeAlias = RuleVariation_1196_Arg
class NonSpare_184(NonSpare):
    cv_name = "055"
    cv_title = "Mode-1 Code in Octal Representation"
    cv_rule = RuleVariation_1196

    @classmethod
    def create(cls, arg : NonSpare_184_Arg) -> "NonSpare_184":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1266:
        return self.rule.variation

class UapItem_184(UapItem):
    cv_non_spare = NonSpare_184

Content_285_Arg: TypeAlias = int
class Content_285(ContentTable):
    cv_values = {0: "Mode-2 code derived from the reply of the transponder", 1: "Smoothed Mode-2 code as provided by a local tracker n"}

RuleContent_285_Arg: TypeAlias = Content_285_Arg
class RuleContent_285(RuleContentContextFree):
    cv_content = Content_285

    @property
    def content(self) -> Content_285:
        return self._get_content() # type: ignore

Variation_547_Arg: TypeAlias = RuleContent_285_Arg
class Variation_547(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_285

    @classmethod
    def create(cls, arg : Variation_547_Arg) -> "Variation_547":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_285:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_285:
        return self.rule.content

RuleVariation_536_Arg: TypeAlias = Variation_547_Arg
class RuleVariation_536(RuleVariationContextFree):
    cv_variation = Variation_547

    @classmethod
    def create(cls, arg : RuleVariation_536_Arg) -> "RuleVariation_536":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_547:
        return self.arg # type: ignore

NonSpare_1129_Arg: TypeAlias = RuleVariation_536_Arg
class NonSpare_1129(NonSpare):
    cv_name = "L"
    cv_title = ""
    cv_rule = RuleVariation_536

    @classmethod
    def create(cls, arg : NonSpare_1129_Arg) -> "NonSpare_1129":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_536:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_547:
        return self.rule.variation

Item_447_Arg: TypeAlias = NonSpare_1129_Arg
class Item_447(Item):
    cv_non_spare = NonSpare_1129

    @classmethod
    def create(cls, arg : Item_447_Arg) -> "Item_447":
        return cls._create(arg) # type: ignore

NonSpare_1295_Arg: TypeAlias = RuleVariation_776_Arg
class NonSpare_1295(NonSpare):
    cv_name = "MODE2"
    cv_title = "Mode-2 Reply in Octal Representation"
    cv_rule = RuleVariation_776

    @classmethod
    def create(cls, arg : NonSpare_1295_Arg) -> "NonSpare_1295":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_776:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_806:
        return self.rule.variation

Item_567_Arg: TypeAlias = NonSpare_1295_Arg
class Item_567(Item):
    cv_non_spare = NonSpare_1295

    @classmethod
    def create(cls, arg : Item_567_Arg) -> "Item_567":
        return cls._create(arg) # type: ignore

Variation_1267_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_536_Arg, Tuple[Literal["L"], RuleVariation_536_Arg]], int, Union[RuleVariation_776_Arg, Tuple[Literal["MODE2"], RuleVariation_776_Arg]]]
Variation_1267_Arg: TypeAlias = Union[int, Variation_1267_Arg_Group]
class Variation_1267(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1100, 1), (Item_355, 1), (Item_447, 1), (Item_16, 1), (Item_567, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "L": RuleVariation_536, "MODE2": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_536:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE2"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_536:
        ...
    @overload
    def get_item(self, key : Literal["MODE2"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1267_Arg) -> 'Variation_1267':
        return cls._create(arg) # type: ignore

RuleVariation_1197_Arg: TypeAlias = Variation_1267_Arg
class RuleVariation_1197(RuleVariationContextFree):
    cv_variation = Variation_1267

    @classmethod
    def create(cls, arg : RuleVariation_1197_Arg) -> "RuleVariation_1197":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1267:
        return self.arg # type: ignore

NonSpare_172_Arg: TypeAlias = RuleVariation_1197_Arg
class NonSpare_172(NonSpare):
    cv_name = "050"
    cv_title = "Mode-2 Code in Octal Representation"
    cv_rule = RuleVariation_1197

    @classmethod
    def create(cls, arg : NonSpare_172_Arg) -> "NonSpare_172":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1197:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1267:
        return self.rule.variation

class UapItem_172(UapItem):
    cv_non_spare = NonSpare_172

Record_36_Arg = TypedDict('Record_36_Arg', {
    "010": NonSpare_41_Arg,
    "020": NonSpare_85_Arg,
    "140": NonSpare_323_Arg,
    "041": NonSpare_152_Arg,
    "042": NonSpare_160_Arg,
    "161": NonSpare_358_Arg,
    "170": NonSpare_371_Arg,
    "070": NonSpare_210_Arg,
    "202": NonSpare_400_Arg,
    "090": NonSpare_247_Arg,
    "100": NonSpare_268_Arg,
    "220": NonSpare_422_Arg,
    "245": NonSpare_438_Arg,
    "110": NonSpare_284_Arg,
    "105": NonSpare_278_Arg,
    "210": NonSpare_402_Arg,
    "300": NonSpare_472_Arg,
    "310": NonSpare_473_Arg,
    "500": NonSpare_512_Arg,
    "400": NonSpare_492_Arg,
    "250": NonSpare_444_Arg,
    "230": NonSpare_426_Arg,
    "260": NonSpare_448_Arg,
    "030": NonSpare_116_Arg,
    "055": NonSpare_184_Arg,
    "050": NonSpare_172_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_36(Record):
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_41, UapItem_85, UapItem_323, UapItem_152, UapItem_160, UapItem_358, UapItem_371, UapItem_210, UapItem_400, UapItem_247, UapItem_268, UapItem_422, UapItem_438, UapItem_284, UapItem_278, UapItem_402, UapItem_472, UapItem_473, UapItem_511, UapItem_491, UapItem_444, UapItem_426, UapItem_448, UapItem_116, UapItem_184, UapItem_172, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_41, "020": NonSpare_85, "140": NonSpare_323, "041": NonSpare_152, "042": NonSpare_160, "161": NonSpare_358, "170": NonSpare_371, "070": NonSpare_210, "202": NonSpare_400, "090": NonSpare_247, "100": NonSpare_268, "220": NonSpare_422, "245": NonSpare_438, "110": NonSpare_284, "105": NonSpare_278, "210": NonSpare_402, "300": NonSpare_472, "310": NonSpare_473, "500": NonSpare_512, "400": NonSpare_492, "250": NonSpare_444, "230": NonSpare_426, "260": NonSpare_448, "030": NonSpare_116, "055": NonSpare_184, "050": NonSpare_172, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_41:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_85:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_323:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_152:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_160:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_358:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_371:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_210:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["202"]) -> NonSpare_400:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_247:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_268:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_422:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_438:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_284:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["105"]) -> NonSpare_278:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_402:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_472:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["310"]) -> NonSpare_473:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_512:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_492:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_444:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_426:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_448:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_116:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["055"]) -> NonSpare_184:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_172:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["020"], Literal["140"], Literal["041"], Literal["042"], Literal["161"], Literal["170"], Literal["070"], Literal["202"], Literal["090"], Literal["100"], Literal["220"], Literal["245"], Literal["110"], Literal["105"], Literal["210"], Literal["300"], Literal["310"], Literal["500"], Literal["400"], Literal["250"], Literal["230"], Literal["260"], Literal["030"], Literal["055"], Literal["050"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_41]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_85]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_323]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_152]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_160]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_358]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_371]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_210]:
        ...
    @overload
    def get_item(self, key : Literal["202"]) -> Optional[NonSpare_400]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_247]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_268]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_422]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_438]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_284]:
        ...
    @overload
    def get_item(self, key : Literal["105"]) -> Optional[NonSpare_278]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_402]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_472]:
        ...
    @overload
    def get_item(self, key : Literal["310"]) -> Optional[NonSpare_473]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_512]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_492]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_444]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_426]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_448]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_116]:
        ...
    @overload
    def get_item(self, key : Literal["055"]) -> Optional[NonSpare_184]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_172]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_41_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_85_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_323_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_152_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_160_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_358_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_371_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_210_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["202"], val : NonSpare_400_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_247_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_268_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_422_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_438_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_284_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["105"], val : NonSpare_278_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_402_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_472_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["310"], val : NonSpare_473_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_512_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_492_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_444_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_426_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_448_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_116_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["055"], val : NonSpare_184_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_172_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_36':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["202"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["105"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["310"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["055"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_36':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_36_Arg) -> 'Record_36':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_36", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_32_Arg: TypeAlias = Record_36
class Uap_32(UapSingle):
    cv_record = Record_36

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_36]]:
        return cls._parse(bs)

class Asterix_20(AstCat):
    cv_category = 20
    cv_edition = (1, 9)
    cv_uap = Uap_32

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_32_Arg]) -> "Asterix_20":
        return cls._create(records) # type: ignore

Content_383_Arg: TypeAlias = int
class Content_383(ContentTable):
    cv_values = {0: "Not Coasted", 1: "Coasted"}

RuleContent_383_Arg: TypeAlias = Content_383_Arg
class RuleContent_383(RuleContentContextFree):
    cv_content = Content_383

    @property
    def content(self) -> Content_383:
        return self._get_content() # type: ignore

Variation_563_Arg: TypeAlias = RuleContent_383_Arg
class Variation_563(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_383

    @classmethod
    def create(cls, arg : Variation_563_Arg) -> "Variation_563":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_383:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_383:
        return self.rule.content

RuleVariation_552_Arg: TypeAlias = Variation_563_Arg
class RuleVariation_552(RuleVariationContextFree):
    cv_variation = Variation_563

    @classmethod
    def create(cls, arg : RuleVariation_552_Arg) -> "RuleVariation_552":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_563:
        return self.arg # type: ignore

NonSpare_832_Arg: TypeAlias = RuleVariation_552_Arg
class NonSpare_832(NonSpare):
    cv_name = "CST"
    cv_title = ""
    cv_rule = RuleVariation_552

    @classmethod
    def create(cls, arg : NonSpare_832_Arg) -> "NonSpare_832":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_552:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_563:
        return self.rule.variation

Item_221_Arg: TypeAlias = NonSpare_832_Arg
class Item_221(Item):
    cv_non_spare = NonSpare_832

    @classmethod
    def create(cls, arg : Item_221_Arg) -> "Item_221":
        return cls._create(arg) # type: ignore

Variation_1344_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_19_Arg, Tuple[Literal["CNF"], RuleVariation_19_Arg]], Union[RuleVariation_398_Arg, Tuple[Literal["TRE"], RuleVariation_398_Arg]], Union[RuleVariation_552_Arg, Tuple[Literal["CST"], RuleVariation_552_Arg]], Union[RuleVariation_664_Arg, Tuple[Literal["CDM"], RuleVariation_664_Arg]], Union[RuleVariation_798_Arg, Tuple[Literal["MAH"], RuleVariation_798_Arg]], Union[RuleVariation_904_Arg, Tuple[Literal["STH"], RuleVariation_904_Arg]], None]]
Variation_1344_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_28_Arg, Tuple[Literal["GHO"], RuleVariation_28_Arg]], int, None]]
Variation_1344_Arg: TypeAlias = Union[
    Tuple[Variation_1344_Arg_Group_1],
    Tuple[Variation_1344_Arg_Group_1, Variation_1344_Arg_Group_2],
]
class Variation_1344(Extended):
    cv_items_list = [[(Item_165, 1), (Item_1033, 1), (Item_221, 1), (Item_139, 2), (Item_521, 1), (Item_946, 1), None], [(Item_368, 1), (Item_9, 6), None]]

    @classmethod
    def create(cls, arg : Variation_1344_Arg) -> 'Variation_1344':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_19:
        ...
    @overload
    def get_item(self, key : Literal["TRE"]) -> RuleVariation_398:
        ...
    @overload
    def get_item(self, key : Literal["CST"]) -> RuleVariation_552:
        ...
    @overload
    def get_item(self, key : Literal["CDM"]) -> RuleVariation_664:
        ...
    @overload
    def get_item(self, key : Literal["MAH"]) -> RuleVariation_798:
        ...
    @overload
    def get_item(self, key : Literal["STH"]) -> RuleVariation_904:
        ...
    @overload
    def get_item(self, key : Literal["GHO"]) -> Optional[RuleVariation_28]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1267_Arg: TypeAlias = Variation_1344_Arg
class RuleVariation_1267(RuleVariationContextFree):
    cv_variation = Variation_1344

    @classmethod
    def create(cls, arg : RuleVariation_1267_Arg) -> "RuleVariation_1267":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1344:
        return self.arg # type: ignore

NonSpare_370_Arg: TypeAlias = RuleVariation_1267_Arg
class NonSpare_370(NonSpare):
    cv_name = "170"
    cv_title = "Track Status"
    cv_rule = RuleVariation_1267

    @classmethod
    def create(cls, arg : NonSpare_370_Arg) -> "NonSpare_370":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1267:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1344:
        return self.rule.variation

class UapItem_370(UapItem):
    cv_non_spare = NonSpare_370

NonSpare_420_Arg: TypeAlias = RuleVariation_340_Arg
class NonSpare_420(NonSpare):
    cv_name = "220"
    cv_title = "Target Address"
    cv_rule = RuleVariation_340

    @classmethod
    def create(cls, arg : NonSpare_420_Arg) -> "NonSpare_420":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_340:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_347:
        return self.rule.variation

class UapItem_420(UapItem):
    cv_non_spare = NonSpare_420

NonSpare_439_Arg: TypeAlias = RuleVariation_1337_Arg
class NonSpare_439(NonSpare):
    cv_name = "250"
    cv_title = "BDS Register Data"
    cv_rule = RuleVariation_1337

    @classmethod
    def create(cls, arg : NonSpare_439_Arg) -> "NonSpare_439":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1337:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1414:
        return self.rule.variation

class UapItem_439(UapItem):
    cv_non_spare = NonSpare_439

Record_35_Arg = TypedDict('Record_35_Arg', {
    "010": NonSpare_41_Arg,
    "020": NonSpare_85_Arg,
    "140": NonSpare_323_Arg,
    "041": NonSpare_152_Arg,
    "042": NonSpare_160_Arg,
    "161": NonSpare_358_Arg,
    "170": NonSpare_370_Arg,
    "070": NonSpare_210_Arg,
    "202": NonSpare_400_Arg,
    "090": NonSpare_247_Arg,
    "100": NonSpare_268_Arg,
    "220": NonSpare_420_Arg,
    "245": NonSpare_438_Arg,
    "110": NonSpare_284_Arg,
    "105": NonSpare_278_Arg,
    "210": NonSpare_402_Arg,
    "300": NonSpare_472_Arg,
    "310": NonSpare_473_Arg,
    "500": NonSpare_512_Arg,
    "400": NonSpare_492_Arg,
    "250": NonSpare_439_Arg,
    "230": NonSpare_426_Arg,
    "260": NonSpare_448_Arg,
    "030": NonSpare_116_Arg,
    "055": NonSpare_184_Arg,
    "050": NonSpare_172_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_35(Record):
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_41, UapItem_85, UapItem_323, UapItem_152, UapItem_160, UapItem_358, UapItem_370, UapItem_210, UapItem_400, UapItem_247, UapItem_268, UapItem_420, UapItem_438, UapItem_284, UapItem_278, UapItem_402, UapItem_472, UapItem_473, UapItem_511, UapItem_491, UapItem_439, UapItem_426, UapItem_448, UapItem_116, UapItem_184, UapItem_172, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_41, "020": NonSpare_85, "140": NonSpare_323, "041": NonSpare_152, "042": NonSpare_160, "161": NonSpare_358, "170": NonSpare_370, "070": NonSpare_210, "202": NonSpare_400, "090": NonSpare_247, "100": NonSpare_268, "220": NonSpare_420, "245": NonSpare_438, "110": NonSpare_284, "105": NonSpare_278, "210": NonSpare_402, "300": NonSpare_472, "310": NonSpare_473, "500": NonSpare_512, "400": NonSpare_492, "250": NonSpare_439, "230": NonSpare_426, "260": NonSpare_448, "030": NonSpare_116, "055": NonSpare_184, "050": NonSpare_172, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_41:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_85:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_323:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_152:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_160:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_358:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_370:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_210:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["202"]) -> NonSpare_400:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_247:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_268:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_420:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_438:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_284:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["105"]) -> NonSpare_278:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_402:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_472:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["310"]) -> NonSpare_473:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_512:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_492:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_439:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_426:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_448:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_116:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["055"]) -> NonSpare_184:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_172:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["020"], Literal["140"], Literal["041"], Literal["042"], Literal["161"], Literal["170"], Literal["070"], Literal["202"], Literal["090"], Literal["100"], Literal["220"], Literal["245"], Literal["110"], Literal["105"], Literal["210"], Literal["300"], Literal["310"], Literal["500"], Literal["400"], Literal["250"], Literal["230"], Literal["260"], Literal["030"], Literal["055"], Literal["050"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_41]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_85]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_323]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_152]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_160]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_358]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_370]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_210]:
        ...
    @overload
    def get_item(self, key : Literal["202"]) -> Optional[NonSpare_400]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_247]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_268]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_420]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_438]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_284]:
        ...
    @overload
    def get_item(self, key : Literal["105"]) -> Optional[NonSpare_278]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_402]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_472]:
        ...
    @overload
    def get_item(self, key : Literal["310"]) -> Optional[NonSpare_473]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_512]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_492]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_439]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_426]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_448]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_116]:
        ...
    @overload
    def get_item(self, key : Literal["055"]) -> Optional[NonSpare_184]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_172]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_41_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_85_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_323_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_152_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_160_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_358_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_370_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_210_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["202"], val : NonSpare_400_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_247_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_268_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_420_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_438_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_284_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["105"], val : NonSpare_278_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_402_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_472_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["310"], val : NonSpare_473_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_512_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_492_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_439_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_426_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_448_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_116_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["055"], val : NonSpare_184_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_172_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_35':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["202"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["105"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["310"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["055"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_35':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_35_Arg) -> 'Record_35':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_35", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_31_Arg: TypeAlias = Record_35
class Uap_31(UapSingle):
    cv_record = Record_35

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_35]]:
        return cls._parse(bs)

class Asterix_21(AstCat):
    cv_category = 20
    cv_edition = (1, 10)
    cv_uap = Uap_31

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_31_Arg]) -> "Asterix_21":
        return cls._create(records) # type: ignore

NonSpare_28_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_28(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identification"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_28_Arg) -> "NonSpare_28":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_28(UapItem):
    cv_non_spare = NonSpare_28

Variation_60_Arg: TypeAlias = RuleContent_350_Arg
class Variation_60(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_350

    @classmethod
    def create(cls, arg : Variation_60_Arg) -> "Variation_60":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_350:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_350:
        return self.rule.content

RuleVariation_60_Arg: TypeAlias = Variation_60_Arg
class RuleVariation_60(RuleVariationContextFree):
    cv_variation = Variation_60

    @classmethod
    def create(cls, arg : RuleVariation_60_Arg) -> "RuleVariation_60":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_60:
        return self.arg # type: ignore

NonSpare_868_Arg: TypeAlias = RuleVariation_60_Arg
class NonSpare_868(NonSpare):
    cv_name = "DCR"
    cv_title = "Differential Correction"
    cv_rule = RuleVariation_60

    @classmethod
    def create(cls, arg : NonSpare_868_Arg) -> "NonSpare_868":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_60:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_60:
        return self.rule.variation

Item_252_Arg: TypeAlias = NonSpare_868_Arg
class Item_252(Item):
    cv_non_spare = NonSpare_868

    @classmethod
    def create(cls, arg : Item_252_Arg) -> "Item_252":
        return cls._create(arg) # type: ignore

Content_220_Arg: TypeAlias = int
class Content_220(ContentTable):
    cv_values = {0: "Ground Bit not set", 1: "Ground Bit set"}

RuleContent_220_Arg: TypeAlias = Content_220_Arg
class RuleContent_220(RuleContentContextFree):
    cv_content = Content_220

    @property
    def content(self) -> Content_220:
        return self._get_content() # type: ignore

Variation_427_Arg: TypeAlias = RuleContent_220_Arg
class Variation_427(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_220

    @classmethod
    def create(cls, arg : Variation_427_Arg) -> "Variation_427":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_220:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_220:
        return self.rule.content

RuleVariation_416_Arg: TypeAlias = Variation_427_Arg
class RuleVariation_416(RuleVariationContextFree):
    cv_variation = Variation_427

    @classmethod
    def create(cls, arg : RuleVariation_416_Arg) -> "RuleVariation_416":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_427:
        return self.arg # type: ignore

NonSpare_1023_Arg: TypeAlias = RuleVariation_416_Arg
class NonSpare_1023(NonSpare):
    cv_name = "GBS"
    cv_title = "Ground Bit Setting"
    cv_rule = RuleVariation_416

    @classmethod
    def create(cls, arg : NonSpare_1023_Arg) -> "NonSpare_1023":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_416:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_427:
        return self.rule.variation

Item_367_Arg: TypeAlias = NonSpare_1023_Arg
class Item_367(Item):
    cv_non_spare = NonSpare_1023

    @classmethod
    def create(cls, arg : Item_367_Arg) -> "Item_367":
        return cls._create(arg) # type: ignore

Variation_505_Arg: TypeAlias = RuleContent_19_Arg
class Variation_505(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_19

    @classmethod
    def create(cls, arg : Variation_505_Arg) -> "Variation_505":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_19:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_19:
        return self.rule.content

RuleVariation_494_Arg: TypeAlias = Variation_505_Arg
class RuleVariation_494(RuleVariationContextFree):
    cv_variation = Variation_505

    @classmethod
    def create(cls, arg : RuleVariation_494_Arg) -> "RuleVariation_494":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_505:
        return self.arg # type: ignore

NonSpare_1719_Arg: TypeAlias = RuleVariation_494_Arg
class NonSpare_1719(NonSpare):
    cv_name = "SIM"
    cv_title = "Simulated Target"
    cv_rule = RuleVariation_494

    @classmethod
    def create(cls, arg : NonSpare_1719_Arg) -> "NonSpare_1719":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_494:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_505:
        return self.rule.variation

Item_900_Arg: TypeAlias = NonSpare_1719_Arg
class Item_900(Item):
    cv_non_spare = NonSpare_1719

    @classmethod
    def create(cls, arg : Item_900_Arg) -> "Item_900":
        return cls._create(arg) # type: ignore

Variation_630_Arg: TypeAlias = RuleContent_154_Arg
class Variation_630(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_154

    @classmethod
    def create(cls, arg : Variation_630_Arg) -> "Variation_630":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_154:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_154:
        return self.rule.content

RuleVariation_619_Arg: TypeAlias = Variation_630_Arg
class RuleVariation_619(RuleVariationContextFree):
    cv_variation = Variation_630

    @classmethod
    def create(cls, arg : RuleVariation_619_Arg) -> "RuleVariation_619":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_630:
        return self.arg # type: ignore

NonSpare_1930_Arg: TypeAlias = RuleVariation_619_Arg
class NonSpare_1930(NonSpare):
    cv_name = "TST"
    cv_title = "Test Target"
    cv_rule = RuleVariation_619

    @classmethod
    def create(cls, arg : NonSpare_1930_Arg) -> "NonSpare_1930":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_619:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_630:
        return self.rule.variation

Item_1053_Arg: TypeAlias = NonSpare_1930_Arg
class Item_1053(Item):
    cv_non_spare = NonSpare_1930

    @classmethod
    def create(cls, arg : Item_1053_Arg) -> "Item_1053":
        return cls._create(arg) # type: ignore

Variation_746_Arg: TypeAlias = RuleContent_440_Arg
class Variation_746(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_440

    @classmethod
    def create(cls, arg : Variation_746_Arg) -> "Variation_746":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_440:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_440:
        return self.rule.content

RuleVariation_735_Arg: TypeAlias = Variation_746_Arg
class RuleVariation_735(RuleVariationContextFree):
    cv_variation = Variation_746

    @classmethod
    def create(cls, arg : RuleVariation_735_Arg) -> "RuleVariation_735":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_746:
        return self.arg # type: ignore

NonSpare_1531_Arg: TypeAlias = RuleVariation_735_Arg
class NonSpare_1531(NonSpare):
    cv_name = "RAB"
    cv_title = "Report Type"
    cv_rule = RuleVariation_735

    @classmethod
    def create(cls, arg : NonSpare_1531_Arg) -> "NonSpare_1531":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_735:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_746:
        return self.rule.variation

Item_767_Arg: TypeAlias = NonSpare_1531_Arg
class Item_767(Item):
    cv_non_spare = NonSpare_1531

    @classmethod
    def create(cls, arg : Item_767_Arg) -> "Item_767":
        return cls._create(arg) # type: ignore

Content_209_Arg: TypeAlias = int
class Content_209(ContentTable):
    cv_values = {0: "Equipment capable to provide Selected Altitude", 1: "Equipment not capable to provide Selected Altitude"}

RuleContent_209_Arg: TypeAlias = Content_209_Arg
class RuleContent_209(RuleContentContextFree):
    cv_content = Content_209

    @property
    def content(self) -> Content_209:
        return self._get_content() # type: ignore

Variation_846_Arg: TypeAlias = RuleContent_209_Arg
class Variation_846(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_209

    @classmethod
    def create(cls, arg : Variation_846_Arg) -> "Variation_846":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_209:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_209:
        return self.rule.content

RuleVariation_816_Arg: TypeAlias = Variation_846_Arg
class RuleVariation_816(RuleVariationContextFree):
    cv_variation = Variation_846

    @classmethod
    def create(cls, arg : RuleVariation_816_Arg) -> "RuleVariation_816":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_846:
        return self.arg # type: ignore

NonSpare_1641_Arg: TypeAlias = RuleVariation_816_Arg
class NonSpare_1641(NonSpare):
    cv_name = "SAA"
    cv_title = "Selected Altitude Available"
    cv_rule = RuleVariation_816

    @classmethod
    def create(cls, arg : NonSpare_1641_Arg) -> "NonSpare_1641":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_816:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_846:
        return self.rule.variation

Item_850_Arg: TypeAlias = NonSpare_1641_Arg
class Item_850(Item):
    cv_non_spare = NonSpare_1641

    @classmethod
    def create(cls, arg : Item_850_Arg) -> "Item_850":
        return cls._create(arg) # type: ignore

Variation_898_Arg: TypeAlias = RuleContent_13_Arg
class Variation_898(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_13

    @classmethod
    def create(cls, arg : Variation_898_Arg) -> "Variation_898":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_13:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_13:
        return self.rule.content

RuleVariation_868_Arg: TypeAlias = Variation_898_Arg
class RuleVariation_868(RuleVariationContextFree):
    cv_variation = Variation_898

    @classmethod
    def create(cls, arg : RuleVariation_868_Arg) -> "RuleVariation_868":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_898:
        return self.arg # type: ignore

NonSpare_1732_Arg: TypeAlias = RuleVariation_868_Arg
class NonSpare_1732(NonSpare):
    cv_name = "SPI"
    cv_title = "Special Position Identification"
    cv_rule = RuleVariation_868

    @classmethod
    def create(cls, arg : NonSpare_1732_Arg) -> "NonSpare_1732":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_868:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_898:
        return self.rule.variation

Item_911_Arg: TypeAlias = NonSpare_1732_Arg
class Item_911(Item):
    cv_non_spare = NonSpare_1732

    @classmethod
    def create(cls, arg : Item_911_Arg) -> "Item_911":
        return cls._create(arg) # type: ignore

Content_377_Arg: TypeAlias = int
class Content_377(ContentTable):
    cv_values = {0: "Non unique address", 1: "24-Bit ICAO address", 2: "Surface vehicle address", 3: "Anonymous address", 4: "Reserved for future use", 5: "Reserved for future use", 6: "Reserved for future use", 7: "Reserved for future use"}

RuleContent_377_Arg: TypeAlias = Content_377_Arg
class RuleContent_377(RuleContentContextFree):
    cv_content = Content_377

    @property
    def content(self) -> Content_377:
        return self._get_content() # type: ignore

Variation_129_Arg: TypeAlias = RuleContent_377_Arg
class Variation_129(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_377

    @classmethod
    def create(cls, arg : Variation_129_Arg) -> "Variation_129":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_377:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_377:
        return self.rule.content

RuleVariation_129_Arg: TypeAlias = Variation_129_Arg
class RuleVariation_129(RuleVariationContextFree):
    cv_variation = Variation_129

    @classmethod
    def create(cls, arg : RuleVariation_129_Arg) -> "RuleVariation_129":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_129:
        return self.arg # type: ignore

NonSpare_639_Arg: TypeAlias = RuleVariation_129_Arg
class NonSpare_639(NonSpare):
    cv_name = "ATP"
    cv_title = "Address Type"
    cv_rule = RuleVariation_129

    @classmethod
    def create(cls, arg : NonSpare_639_Arg) -> "NonSpare_639":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_129:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_129:
        return self.rule.variation

Item_90_Arg: TypeAlias = NonSpare_639_Arg
class Item_90(Item):
    cv_non_spare = NonSpare_639

    @classmethod
    def create(cls, arg : Item_90_Arg) -> "Item_90":
        return cls._create(arg) # type: ignore

Content_532_Arg: TypeAlias = int
class Content_532(ContentTable):
    cv_values = {0: "Unknown", 1: "25 ft", 2: "100 ft"}

RuleContent_532_Arg: TypeAlias = Content_532_Arg
class RuleContent_532(RuleContentContextFree):
    cv_content = Content_532

    @property
    def content(self) -> Content_532:
        return self._get_content() # type: ignore

Variation_680_Arg: TypeAlias = RuleContent_532_Arg
class Variation_680(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_rule = RuleContent_532

    @classmethod
    def create(cls, arg : Variation_680_Arg) -> "Variation_680":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_532:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_532:
        return self.rule.content

RuleVariation_669_Arg: TypeAlias = Variation_680_Arg
class RuleVariation_669(RuleVariationContextFree):
    cv_variation = Variation_680

    @classmethod
    def create(cls, arg : RuleVariation_669_Arg) -> "RuleVariation_669":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_680:
        return self.arg # type: ignore

NonSpare_623_Arg: TypeAlias = RuleVariation_669_Arg
class NonSpare_623(NonSpare):
    cv_name = "ARC"
    cv_title = "Altitude Reporting Capability"
    cv_rule = RuleVariation_669

    @classmethod
    def create(cls, arg : NonSpare_623_Arg) -> "NonSpare_623":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_669:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_680:
        return self.rule.variation

Item_83_Arg: TypeAlias = NonSpare_623_Arg
class Item_83(Item):
    cv_non_spare = NonSpare_623

    @classmethod
    def create(cls, arg : Item_83_Arg) -> "Item_83":
        return cls._create(arg) # type: ignore

Variation_1079_Arg_Group = Tuple[Union[RuleVariation_60_Arg, Tuple[Literal["DCR"], RuleVariation_60_Arg]], Union[RuleVariation_416_Arg, Tuple[Literal["GBS"], RuleVariation_416_Arg]], Union[RuleVariation_494_Arg, Tuple[Literal["SIM"], RuleVariation_494_Arg]], Union[RuleVariation_619_Arg, Tuple[Literal["TST"], RuleVariation_619_Arg]], Union[RuleVariation_735_Arg, Tuple[Literal["RAB"], RuleVariation_735_Arg]], Union[RuleVariation_816_Arg, Tuple[Literal["SAA"], RuleVariation_816_Arg]], Union[RuleVariation_868_Arg, Tuple[Literal["SPI"], RuleVariation_868_Arg]], int, Union[RuleVariation_129_Arg, Tuple[Literal["ATP"], RuleVariation_129_Arg]], Union[RuleVariation_669_Arg, Tuple[Literal["ARC"], RuleVariation_669_Arg]], int]
Variation_1079_Arg: TypeAlias = Union[int, Variation_1079_Arg_Group]
class Variation_1079(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_252, 1), (Item_367, 1), (Item_900, 1), (Item_1053, 1), (Item_767, 1), (Item_850, 1), (Item_911, 1), (Item_29, 1), (Item_90, 3), (Item_83, 2), (Item_25, 3)]
    cv_items_dict = {"DCR": RuleVariation_60, "GBS": RuleVariation_416, "SIM": RuleVariation_494, "TST": RuleVariation_619, "RAB": RuleVariation_735, "SAA": RuleVariation_816, "SPI": RuleVariation_868, "ATP": RuleVariation_129, "ARC": RuleVariation_669}

    @overload
    @classmethod
    def spec(cls, key : Literal["DCR"]) -> RuleVariation_60:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GBS"]) -> RuleVariation_416:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIM"]) -> RuleVariation_494:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TST"]) -> RuleVariation_619:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAB"]) -> RuleVariation_735:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAA"]) -> RuleVariation_816:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SPI"]) -> RuleVariation_868:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ATP"]) -> RuleVariation_129:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> RuleVariation_669:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["DCR"], Literal["GBS"], Literal["SIM"], Literal["TST"], Literal["RAB"], Literal["SAA"], Literal["SPI"], Literal["ATP"], Literal["ARC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["DCR"]) -> RuleVariation_60:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> RuleVariation_416:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> RuleVariation_494:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> RuleVariation_619:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_735:
        ...
    @overload
    def get_item(self, key : Literal["SAA"]) -> RuleVariation_816:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> RuleVariation_868:
        ...
    @overload
    def get_item(self, key : Literal["ATP"]) -> RuleVariation_129:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_669:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1079_Arg) -> 'Variation_1079':
        return cls._create(arg) # type: ignore

RuleVariation_1039_Arg: TypeAlias = Variation_1079_Arg
class RuleVariation_1039(RuleVariationContextFree):
    cv_variation = Variation_1079

    @classmethod
    def create(cls, arg : RuleVariation_1039_Arg) -> "RuleVariation_1039":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1079:
        return self.arg # type: ignore

NonSpare_142_Arg: TypeAlias = RuleVariation_1039_Arg
class NonSpare_142(NonSpare):
    cv_name = "040"
    cv_title = "Target Report Descriptor"
    cv_rule = RuleVariation_1039

    @classmethod
    def create(cls, arg : NonSpare_142_Arg) -> "NonSpare_142":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1039:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1079:
        return self.rule.variation

class UapItem_142(UapItem):
    cv_non_spare = NonSpare_142

NonSpare_108_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_108(NonSpare):
    cv_name = "030"
    cv_title = "Time of Day"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_108_Arg) -> "NonSpare_108":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_108(UapItem):
    cv_non_spare = NonSpare_108

Content_692_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_692(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 2.1457672119140625e-5
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_692_Arg: TypeAlias = Content_692_Arg
class RuleContent_692(RuleContentContextFree):
    cv_content = Content_692

    @property
    def content(self) -> Content_692:
        return self._get_content() # type: ignore

Variation_358_Arg: TypeAlias = RuleContent_692_Arg
class Variation_358(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_692

    @classmethod
    def create(cls, arg : Variation_358_Arg) -> "Variation_358":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_692:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_692:
        return self.rule.content

RuleVariation_351_Arg: TypeAlias = Variation_358_Arg
class RuleVariation_351(RuleVariationContextFree):
    cv_variation = Variation_358

    @classmethod
    def create(cls, arg : RuleVariation_351_Arg) -> "RuleVariation_351":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_358:
        return self.arg # type: ignore

NonSpare_1142_Arg: TypeAlias = RuleVariation_351_Arg
class NonSpare_1142(NonSpare):
    cv_name = "LAT"
    cv_title = "Latitude"
    cv_rule = RuleVariation_351

    @classmethod
    def create(cls, arg : NonSpare_1142_Arg) -> "NonSpare_1142":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_351:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_358:
        return self.rule.variation

Item_460_Arg: TypeAlias = NonSpare_1142_Arg
class Item_460(Item):
    cv_non_spare = NonSpare_1142

    @classmethod
    def create(cls, arg : Item_460_Arg) -> "Item_460":
        return cls._create(arg) # type: ignore

Content_690_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_690(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 2.1457672119140625e-5
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_690_Arg: TypeAlias = Content_690_Arg
class RuleContent_690(RuleContentContextFree):
    cv_content = Content_690

    @property
    def content(self) -> Content_690:
        return self._get_content() # type: ignore

Variation_356_Arg: TypeAlias = RuleContent_690_Arg
class Variation_356(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_690

    @classmethod
    def create(cls, arg : Variation_356_Arg) -> "Variation_356":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_690:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_690:
        return self.rule.content

RuleVariation_349_Arg: TypeAlias = Variation_356_Arg
class RuleVariation_349(RuleVariationContextFree):
    cv_variation = Variation_356

    @classmethod
    def create(cls, arg : RuleVariation_349_Arg) -> "RuleVariation_349":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_356:
        return self.arg # type: ignore

NonSpare_1170_Arg: TypeAlias = RuleVariation_349_Arg
class NonSpare_1170(NonSpare):
    cv_name = "LON"
    cv_title = "Longitude"
    cv_rule = RuleVariation_349

    @classmethod
    def create(cls, arg : NonSpare_1170_Arg) -> "NonSpare_1170":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_349:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_356:
        return self.rule.variation

Item_486_Arg: TypeAlias = NonSpare_1170_Arg
class Item_486(Item):
    cv_non_spare = NonSpare_1170

    @classmethod
    def create(cls, arg : Item_486_Arg) -> "Item_486":
        return cls._create(arg) # type: ignore

Variation_1121_Arg_Group = Tuple[Union[RuleVariation_351_Arg, Tuple[Literal["LAT"], RuleVariation_351_Arg]], Union[RuleVariation_349_Arg, Tuple[Literal["LON"], RuleVariation_349_Arg]]]
Variation_1121_Arg: TypeAlias = Union[int, Variation_1121_Arg_Group]
class Variation_1121(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_460, 24), (Item_486, 24)]
    cv_items_dict = {"LAT": RuleVariation_351, "LON": RuleVariation_349}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_351:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_349:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_351:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_349:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1121_Arg) -> 'Variation_1121':
        return cls._create(arg) # type: ignore

RuleVariation_1078_Arg: TypeAlias = Variation_1121_Arg
class RuleVariation_1078(RuleVariationContextFree):
    cv_variation = Variation_1121

    @classmethod
    def create(cls, arg : RuleVariation_1078_Arg) -> "RuleVariation_1078":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1121:
        return self.arg # type: ignore

NonSpare_304_Arg: TypeAlias = RuleVariation_1078_Arg
class NonSpare_304(NonSpare):
    cv_name = "130"
    cv_title = "Position in WGS-84 Co-ordinates"
    cv_rule = RuleVariation_1078

    @classmethod
    def create(cls, arg : NonSpare_304_Arg) -> "NonSpare_304":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1078:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1121:
        return self.rule.variation

class UapItem_304(UapItem):
    cv_non_spare = NonSpare_304

NonSpare_233_Arg: TypeAlias = RuleVariation_340_Arg
class NonSpare_233(NonSpare):
    cv_name = "080"
    cv_title = "Target Address"
    cv_rule = RuleVariation_340

    @classmethod
    def create(cls, arg : NonSpare_233_Arg) -> "NonSpare_233":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_340:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_347:
        return self.rule.variation

class UapItem_233(UapItem):
    cv_non_spare = NonSpare_233

Content_683_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
class Content_683(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 6.25
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

RuleContent_683_Arg: TypeAlias = Content_683_Arg
class RuleContent_683(RuleContentContextFree):
    cv_content = Content_683

    @property
    def content(self) -> Content_683:
        return self._get_content() # type: ignore

Variation_289_Arg: TypeAlias = RuleContent_683_Arg
class Variation_289(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_683

    @classmethod
    def create(cls, arg : Variation_289_Arg) -> "Variation_289":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_683:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_683:
        return self.rule.content

RuleVariation_282_Arg: TypeAlias = Variation_289_Arg
class RuleVariation_282(RuleVariationContextFree):
    cv_variation = Variation_289

    @classmethod
    def create(cls, arg : RuleVariation_282_Arg) -> "RuleVariation_282":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_289:
        return self.arg # type: ignore

NonSpare_317_Arg: TypeAlias = RuleVariation_282_Arg
class NonSpare_317(NonSpare):
    cv_name = "140"
    cv_title = "Geometric Altitude"
    cv_rule = RuleVariation_282

    @classmethod
    def create(cls, arg : NonSpare_317_Arg) -> "NonSpare_317":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_282:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_289:
        return self.rule.variation

class UapItem_317(UapItem):
    cv_non_spare = NonSpare_317

Content_533_Arg: TypeAlias = int
class Content_533(ContentTable):
    cv_values = {0: "Unknown", 1: "ACAS not operational", 2: "ACAS operartional", 3: "Invalid"}

RuleContent_533_Arg: TypeAlias = Content_533_Arg
class RuleContent_533(RuleContentContextFree):
    cv_content = Content_533

    @property
    def content(self) -> Content_533:
        return self._get_content() # type: ignore

Variation_113_Arg: TypeAlias = RuleContent_533_Arg
class Variation_113(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_533

    @classmethod
    def create(cls, arg : Variation_113_Arg) -> "Variation_113":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_533:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_533:
        return self.rule.content

RuleVariation_113_Arg: TypeAlias = Variation_113_Arg
class RuleVariation_113(RuleVariationContextFree):
    cv_variation = Variation_113

    @classmethod
    def create(cls, arg : RuleVariation_113_Arg) -> "RuleVariation_113":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_113:
        return self.arg # type: ignore

NonSpare_549_Arg: TypeAlias = RuleVariation_113_Arg
class NonSpare_549(NonSpare):
    cv_name = "AC"
    cv_title = "ACAS Capabilities"
    cv_rule = RuleVariation_113

    @classmethod
    def create(cls, arg : NonSpare_549_Arg) -> "NonSpare_549":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_113:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_113:
        return self.rule.variation

Item_36_Arg: TypeAlias = NonSpare_549_Arg
class Item_36(Item):
    cv_non_spare = NonSpare_549

    @classmethod
    def create(cls, arg : Item_36_Arg) -> "Item_36":
        return cls._create(arg) # type: ignore

Content_547_Arg: TypeAlias = int
class Content_547(ContentTable):
    cv_values = {0: "Unknown", 1: "Multiple Navigation not operational", 2: "Multiple Navigation operartional", 3: "Invalid"}

RuleContent_547_Arg: TypeAlias = Content_547_Arg
class RuleContent_547(RuleContentContextFree):
    cv_content = Content_547

    @property
    def content(self) -> Content_547:
        return self._get_content() # type: ignore

Variation_592_Arg: TypeAlias = RuleContent_547_Arg
class Variation_592(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_547

    @classmethod
    def create(cls, arg : Variation_592_Arg) -> "Variation_592":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_547:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_547:
        return self.rule.content

RuleVariation_581_Arg: TypeAlias = Variation_592_Arg
class RuleVariation_581(RuleVariationContextFree):
    cv_variation = Variation_592

    @classmethod
    def create(cls, arg : RuleVariation_581_Arg) -> "RuleVariation_581":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_592:
        return self.arg # type: ignore

NonSpare_1286_Arg: TypeAlias = RuleVariation_581_Arg
class NonSpare_1286(NonSpare):
    cv_name = "MN"
    cv_title = "Multiple Navigation Aids"
    cv_rule = RuleVariation_581

    @classmethod
    def create(cls, arg : NonSpare_1286_Arg) -> "NonSpare_1286":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_581:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_592:
        return self.rule.variation

Item_558_Arg: TypeAlias = NonSpare_1286_Arg
class Item_558(Item):
    cv_non_spare = NonSpare_1286

    @classmethod
    def create(cls, arg : Item_558_Arg) -> "Item_558":
        return cls._create(arg) # type: ignore

Content_541_Arg: TypeAlias = int
class Content_541(ContentTable):
    cv_values = {0: "Unknown", 1: "Differencial Correction", 2: "NO Differencial Correction", 3: "Invalid"}

RuleContent_541_Arg: TypeAlias = Content_541_Arg
class RuleContent_541(RuleContentContextFree):
    cv_content = Content_541

    @property
    def content(self) -> Content_541:
        return self._get_content() # type: ignore

Variation_767_Arg: TypeAlias = RuleContent_541_Arg
class Variation_767(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_541

    @classmethod
    def create(cls, arg : Variation_767_Arg) -> "Variation_767":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_541:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_541:
        return self.rule.content

RuleVariation_756_Arg: TypeAlias = Variation_767_Arg
class RuleVariation_756(RuleVariationContextFree):
    cv_variation = Variation_767

    @classmethod
    def create(cls, arg : RuleVariation_756_Arg) -> "RuleVariation_756":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_767:
        return self.arg # type: ignore

NonSpare_863_Arg: TypeAlias = RuleVariation_756_Arg
class NonSpare_863(NonSpare):
    cv_name = "DC"
    cv_title = "Differencial Correction"
    cv_rule = RuleVariation_756

    @classmethod
    def create(cls, arg : NonSpare_863_Arg) -> "NonSpare_863":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_756:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_767:
        return self.rule.variation

Item_247_Arg: TypeAlias = NonSpare_863_Arg
class Item_247(Item):
    cv_non_spare = NonSpare_863

    @classmethod
    def create(cls, arg : Item_247_Arg) -> "Item_247":
        return cls._create(arg) # type: ignore

Item_28_Arg: TypeAlias = int
class Item_28(Spare):
    cv_bit_offset8 = 6
    cv_bit_size = 6

Content_619_Arg: TypeAlias = Union[int, float, Tuple[float, Literal[""]]]
class Content_619(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.0
    cv_unit = ""

    def as_quantity(self, cv_unit : Optional[Literal[""]] = None) -> float:
        return self._as_quantity()

RuleContent_619_Arg: TypeAlias = Content_619_Arg
class RuleContent_619(RuleContentContextFree):
    cv_content = Content_619

    @property
    def content(self) -> Content_619:
        return self._get_content() # type: ignore

Variation_803_Arg: TypeAlias = RuleContent_619_Arg
class Variation_803(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 4
    cv_rule = RuleContent_619

    @classmethod
    def create(cls, arg : Variation_803_Arg) -> "Variation_803":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_619:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_619:
        return self.rule.content

RuleVariation_773_Arg: TypeAlias = Variation_803_Arg
class RuleVariation_773(RuleVariationContextFree):
    cv_variation = Variation_803

    @classmethod
    def create(cls, arg : RuleVariation_773_Arg) -> "RuleVariation_773":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_803:
        return self.arg # type: ignore

NonSpare_1409_Arg: TypeAlias = RuleVariation_773_Arg
class NonSpare_1409(NonSpare):
    cv_name = "PA"
    cv_title = "Position Accuracy"
    cv_rule = RuleVariation_773

    @classmethod
    def create(cls, arg : NonSpare_1409_Arg) -> "NonSpare_1409":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_773:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_803:
        return self.rule.variation

Item_672_Arg: TypeAlias = NonSpare_1409_Arg
class Item_672(Item):
    cv_non_spare = NonSpare_1409

    @classmethod
    def create(cls, arg : Item_672_Arg) -> "Item_672":
        return cls._create(arg) # type: ignore

Variation_1042_Arg_Group = Tuple[Union[RuleVariation_113_Arg, Tuple[Literal["AC"], RuleVariation_113_Arg]], Union[RuleVariation_581_Arg, Tuple[Literal["MN"], RuleVariation_581_Arg]], Union[RuleVariation_756_Arg, Tuple[Literal["DC"], RuleVariation_756_Arg]], int, Union[RuleVariation_773_Arg, Tuple[Literal["PA"], RuleVariation_773_Arg]]]
Variation_1042_Arg: TypeAlias = Union[int, Variation_1042_Arg_Group]
class Variation_1042(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_36, 2), (Item_558, 2), (Item_247, 2), (Item_28, 6), (Item_672, 4)]
    cv_items_dict = {"AC": RuleVariation_113, "MN": RuleVariation_581, "DC": RuleVariation_756, "PA": RuleVariation_773}

    @overload
    @classmethod
    def spec(cls, key : Literal["AC"]) -> RuleVariation_113:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MN"]) -> RuleVariation_581:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DC"]) -> RuleVariation_756:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PA"]) -> RuleVariation_773:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AC"], Literal["MN"], Literal["DC"], Literal["PA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AC"]) -> RuleVariation_113:
        ...
    @overload
    def get_item(self, key : Literal["MN"]) -> RuleVariation_581:
        ...
    @overload
    def get_item(self, key : Literal["DC"]) -> RuleVariation_756:
        ...
    @overload
    def get_item(self, key : Literal["PA"]) -> RuleVariation_773:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1042_Arg) -> 'Variation_1042':
        return cls._create(arg) # type: ignore

RuleVariation_1009_Arg: TypeAlias = Variation_1042_Arg
class RuleVariation_1009(RuleVariationContextFree):
    cv_variation = Variation_1042

    @classmethod
    def create(cls, arg : RuleVariation_1009_Arg) -> "RuleVariation_1009":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1042:
        return self.arg # type: ignore

NonSpare_243_Arg: TypeAlias = RuleVariation_1009_Arg
class NonSpare_243(NonSpare):
    cv_name = "090"
    cv_title = "Figure of Merit"
    cv_rule = RuleVariation_1009

    @classmethod
    def create(cls, arg : NonSpare_243_Arg) -> "NonSpare_243":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1009:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1042:
        return self.rule.variation

class UapItem_243(UapItem):
    cv_non_spare = NonSpare_243

Content_538_Arg: TypeAlias = int
class Content_538(ContentTable):
    cv_values = {0: "Unknown", 1: "Aircraft equiped with CDTI"}

RuleContent_538_Arg: TypeAlias = Content_538_Arg
class RuleContent_538(RuleContentContextFree):
    cv_content = Content_538

    @property
    def content(self) -> Content_538:
        return self._get_content() # type: ignore

Variation_668_Arg: TypeAlias = RuleContent_538_Arg
class Variation_668(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_538

    @classmethod
    def create(cls, arg : Variation_668_Arg) -> "Variation_668":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_538:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_538:
        return self.rule.content

RuleVariation_657_Arg: TypeAlias = Variation_668_Arg
class RuleVariation_657(RuleVariationContextFree):
    cv_variation = Variation_668

    @classmethod
    def create(cls, arg : RuleVariation_657_Arg) -> "RuleVariation_657":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_668:
        return self.arg # type: ignore

NonSpare_902_Arg: TypeAlias = RuleVariation_657_Arg
class NonSpare_902(NonSpare):
    cv_name = "DTI"
    cv_title = "Cockpit Display of Traffic Information"
    cv_rule = RuleVariation_657

    @classmethod
    def create(cls, arg : NonSpare_902_Arg) -> "NonSpare_902":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_657:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_668:
        return self.rule.variation

Item_278_Arg: TypeAlias = NonSpare_902_Arg
class Item_278(Item):
    cv_non_spare = NonSpare_902

    @classmethod
    def create(cls, arg : Item_278_Arg) -> "Item_278":
        return cls._create(arg) # type: ignore

Content_399_Arg: TypeAlias = int
class Content_399(ContentTable):
    cv_values = {0: "Not used", 1: "Used"}

RuleContent_399_Arg: TypeAlias = Content_399_Arg
class RuleContent_399(RuleContentContextFree):
    cv_content = Content_399

    @property
    def content(self) -> Content_399:
        return self._get_content() # type: ignore

Variation_741_Arg: TypeAlias = RuleContent_399_Arg
class Variation_741(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_399

    @classmethod
    def create(cls, arg : Variation_741_Arg) -> "Variation_741":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_399:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_399:
        return self.rule.content

RuleVariation_730_Arg: TypeAlias = Variation_741_Arg
class RuleVariation_730(RuleVariationContextFree):
    cv_variation = Variation_741

    @classmethod
    def create(cls, arg : RuleVariation_730_Arg) -> "RuleVariation_730":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_741:
        return self.arg # type: ignore

NonSpare_1252_Arg: TypeAlias = RuleVariation_730_Arg
class NonSpare_1252(NonSpare):
    cv_name = "MDS"
    cv_title = "Mode-S Extended Squitter"
    cv_rule = RuleVariation_730

    @classmethod
    def create(cls, arg : NonSpare_1252_Arg) -> "NonSpare_1252":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_730:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_741:
        return self.rule.variation

Item_538_Arg: TypeAlias = NonSpare_1252_Arg
class Item_538(Item):
    cv_non_spare = NonSpare_1252

    @classmethod
    def create(cls, arg : Item_538_Arg) -> "Item_538":
        return cls._create(arg) # type: ignore

Variation_864_Arg: TypeAlias = RuleContent_399_Arg
class Variation_864(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_399

    @classmethod
    def create(cls, arg : Variation_864_Arg) -> "Variation_864":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_399:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_399:
        return self.rule.content

RuleVariation_834_Arg: TypeAlias = Variation_864_Arg
class RuleVariation_834(RuleVariationContextFree):
    cv_variation = Variation_864

    @classmethod
    def create(cls, arg : RuleVariation_834_Arg) -> "RuleVariation_834":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_864:
        return self.arg # type: ignore

NonSpare_1971_Arg: TypeAlias = RuleVariation_834_Arg
class NonSpare_1971(NonSpare):
    cv_name = "UAT"
    cv_title = "UAT"
    cv_rule = RuleVariation_834

    @classmethod
    def create(cls, arg : NonSpare_1971_Arg) -> "NonSpare_1971":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_834:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_864:
        return self.rule.variation

Item_1089_Arg: TypeAlias = NonSpare_1971_Arg
class Item_1089(Item):
    cv_non_spare = NonSpare_1971

    @classmethod
    def create(cls, arg : Item_1089_Arg) -> "Item_1089":
        return cls._create(arg) # type: ignore

Variation_940_Arg: TypeAlias = RuleContent_399_Arg
class Variation_940(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_399

    @classmethod
    def create(cls, arg : Variation_940_Arg) -> "Variation_940":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_399:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_399:
        return self.rule.content

RuleVariation_910_Arg: TypeAlias = Variation_940_Arg
class RuleVariation_910(RuleVariationContextFree):
    cv_variation = Variation_940

    @classmethod
    def create(cls, arg : RuleVariation_910_Arg) -> "RuleVariation_910":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_940:
        return self.arg # type: ignore

NonSpare_2021_Arg: TypeAlias = RuleVariation_910_Arg
class NonSpare_2021(NonSpare):
    cv_name = "VDL"
    cv_title = "VDL Mode 4"
    cv_rule = RuleVariation_910

    @classmethod
    def create(cls, arg : NonSpare_2021_Arg) -> "NonSpare_2021":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_910:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_940:
        return self.rule.variation

Item_1136_Arg: TypeAlias = NonSpare_2021_Arg
class Item_1136(Item):
    cv_non_spare = NonSpare_2021

    @classmethod
    def create(cls, arg : Item_1136_Arg) -> "Item_1136":
        return cls._create(arg) # type: ignore

Variation_982_Arg: TypeAlias = RuleContent_399_Arg
class Variation_982(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_399

    @classmethod
    def create(cls, arg : Variation_982_Arg) -> "Variation_982":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_399:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_399:
        return self.rule.content

RuleVariation_952_Arg: TypeAlias = Variation_982_Arg
class RuleVariation_952(RuleVariationContextFree):
    cv_variation = Variation_982

    @classmethod
    def create(cls, arg : RuleVariation_952_Arg) -> "RuleVariation_952":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_982:
        return self.arg # type: ignore

NonSpare_1397_Arg: TypeAlias = RuleVariation_952_Arg
class NonSpare_1397(NonSpare):
    cv_name = "OTR"
    cv_title = "Other Technology"
    cv_rule = RuleVariation_952

    @classmethod
    def create(cls, arg : NonSpare_1397_Arg) -> "NonSpare_1397":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_952:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_982:
        return self.rule.variation

Item_661_Arg: TypeAlias = NonSpare_1397_Arg
class Item_661(Item):
    cv_non_spare = NonSpare_1397

    @classmethod
    def create(cls, arg : Item_661_Arg) -> "Item_661":
        return cls._create(arg) # type: ignore

Variation_1009_Arg_Group = Tuple[int, Union[RuleVariation_657_Arg, Tuple[Literal["DTI"], RuleVariation_657_Arg]], Union[RuleVariation_730_Arg, Tuple[Literal["MDS"], RuleVariation_730_Arg]], Union[RuleVariation_834_Arg, Tuple[Literal["UAT"], RuleVariation_834_Arg]], Union[RuleVariation_910_Arg, Tuple[Literal["VDL"], RuleVariation_910_Arg]], Union[RuleVariation_952_Arg, Tuple[Literal["OTR"], RuleVariation_952_Arg]]]
Variation_1009_Arg: TypeAlias = Union[int, Variation_1009_Arg_Group]
class Variation_1009(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_2, 3), (Item_278, 1), (Item_538, 1), (Item_1089, 1), (Item_1136, 1), (Item_661, 1)]
    cv_items_dict = {"DTI": RuleVariation_657, "MDS": RuleVariation_730, "UAT": RuleVariation_834, "VDL": RuleVariation_910, "OTR": RuleVariation_952}

    @overload
    @classmethod
    def spec(cls, key : Literal["DTI"]) -> RuleVariation_657:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDS"]) -> RuleVariation_730:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["UAT"]) -> RuleVariation_834:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VDL"]) -> RuleVariation_910:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OTR"]) -> RuleVariation_952:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["DTI"], Literal["MDS"], Literal["UAT"], Literal["VDL"], Literal["OTR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["DTI"]) -> RuleVariation_657:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> RuleVariation_730:
        ...
    @overload
    def get_item(self, key : Literal["UAT"]) -> RuleVariation_834:
        ...
    @overload
    def get_item(self, key : Literal["VDL"]) -> RuleVariation_910:
        ...
    @overload
    def get_item(self, key : Literal["OTR"]) -> RuleVariation_952:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1009_Arg) -> 'Variation_1009':
        return cls._create(arg) # type: ignore

RuleVariation_979_Arg: TypeAlias = Variation_1009_Arg
class RuleVariation_979(RuleVariationContextFree):
    cv_variation = Variation_1009

    @classmethod
    def create(cls, arg : RuleVariation_979_Arg) -> "RuleVariation_979":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1009:
        return self.arg # type: ignore

NonSpare_407_Arg: TypeAlias = RuleVariation_979_Arg
class NonSpare_407(NonSpare):
    cv_name = "210"
    cv_title = "Link Technology Indicator"
    cv_rule = RuleVariation_979

    @classmethod
    def create(cls, arg : NonSpare_407_Arg) -> "NonSpare_407":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_979:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1009:
        return self.rule.variation

class UapItem_407(UapItem):
    cv_non_spare = NonSpare_407

Content_646_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_646(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.0e-2
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_646_Arg: TypeAlias = Content_646_Arg
class RuleContent_646(RuleContentContextFree):
    cv_content = Content_646

    @property
    def content(self) -> Content_646:
        return self._get_content() # type: ignore

Variation_267_Arg: TypeAlias = RuleContent_646_Arg
class Variation_267(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_646

    @classmethod
    def create(cls, arg : Variation_267_Arg) -> "Variation_267":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_646:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_646:
        return self.rule.content

RuleVariation_260_Arg: TypeAlias = Variation_267_Arg
class RuleVariation_260(RuleVariationContextFree):
    cv_variation = Variation_267

    @classmethod
    def create(cls, arg : RuleVariation_260_Arg) -> "RuleVariation_260":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_267:
        return self.arg # type: ignore

NonSpare_429_Arg: TypeAlias = RuleVariation_260_Arg
class NonSpare_429(NonSpare):
    cv_name = "230"
    cv_title = "Roll Angle"
    cv_rule = RuleVariation_260

    @classmethod
    def create(cls, arg : NonSpare_429_Arg) -> "NonSpare_429":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_260:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_267:
        return self.rule.variation

class UapItem_429(UapItem):
    cv_non_spare = NonSpare_429

Content_651_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["FL"]]]
class Content_651(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.25
    cv_unit = "FL"

    def as_quantity(self, cv_unit : Optional[Literal["FL"]] = None) -> float:
        return self._as_quantity()

RuleContent_651_Arg: TypeAlias = Content_651_Arg
class RuleContent_651(RuleContentContextFree):
    cv_content = Content_651

    @property
    def content(self) -> Content_651:
        return self._get_content() # type: ignore

Variation_270_Arg: TypeAlias = RuleContent_651_Arg
class Variation_270(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_651

    @classmethod
    def create(cls, arg : Variation_270_Arg) -> "Variation_270":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_651:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_651:
        return self.rule.content

RuleVariation_263_Arg: TypeAlias = Variation_270_Arg
class RuleVariation_263(RuleVariationContextFree):
    cv_variation = Variation_270

    @classmethod
    def create(cls, arg : RuleVariation_263_Arg) -> "RuleVariation_263":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_270:
        return self.arg # type: ignore

NonSpare_333_Arg: TypeAlias = RuleVariation_263_Arg
class NonSpare_333(NonSpare):
    cv_name = "145"
    cv_title = "Flight Level"
    cv_rule = RuleVariation_263

    @classmethod
    def create(cls, arg : NonSpare_333_Arg) -> "NonSpare_333":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_263:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_270:
        return self.rule.variation

class UapItem_333(UapItem):
    cv_non_spare = NonSpare_333

Content_22_Arg: TypeAlias = int
class Content_22(ContentTable):
    cv_values = {0: "Air Speed = IAS, LSB (Bit-1) = 2 -14 NM/s", 1: "Air Speed = Mach, LSB (Bit-1) = 0.001"}

RuleContent_22_Arg: TypeAlias = Content_22_Arg
class RuleContent_22(RuleContentContextFree):
    cv_content = Content_22

    @property
    def content(self) -> Content_22:
        return self._get_content() # type: ignore

Variation_7_Arg: TypeAlias = RuleContent_22_Arg
class Variation_7(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_22

    @classmethod
    def create(cls, arg : Variation_7_Arg) -> "Variation_7":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_22:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_22:
        return self.rule.content

RuleVariation_7_Arg: TypeAlias = Variation_7_Arg
class RuleVariation_7(RuleVariationContextFree):
    cv_variation = Variation_7

    @classmethod
    def create(cls, arg : RuleVariation_7_Arg) -> "RuleVariation_7":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_7:
        return self.arg # type: ignore

NonSpare_1112_Arg: TypeAlias = RuleVariation_7_Arg
class NonSpare_1112(NonSpare):
    cv_name = "IM"
    cv_title = ""
    cv_rule = RuleVariation_7

    @classmethod
    def create(cls, arg : NonSpare_1112_Arg) -> "NonSpare_1112":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_7:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_7:
        return self.rule.variation

Item_432_Arg: TypeAlias = NonSpare_1112_Arg
class Item_432(Item):
    cv_non_spare = NonSpare_1112

    @classmethod
    def create(cls, arg : Item_432_Arg) -> "Item_432":
        return cls._create(arg) # type: ignore

Content_747_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["Mach"]]]
class Content_747(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0e-3
    cv_unit = "Mach"

    def as_quantity(self, cv_unit : Optional[Literal["Mach"]] = None) -> float:
        return self._as_quantity()

RuleContent_797_Arg = Union[
    Tuple[None, Content_0_Arg],
    Tuple[Tuple[Literal[0]], Content_775_Arg],
    Tuple[Tuple[Literal[1]], Content_747_Arg],
]
class RuleContent_797(RuleContentDependent):
    cv_depends_on = [["150", "IM"]]
    cv_default_content = Content_0
    cv_cases = [
        ([0], Content_775),
        ([1], Content_747),
    ]

    @overload
    def content(self, arg : Literal[None]) -> Content_0:
        ...
    @overload
    def content(self, arg : Tuple[Literal[0]]) -> Content_775:
        ...
    @overload
    def content(self, arg : Tuple[Literal[1]]) -> Content_747:
        ...
    def content(self, arg : Any) -> Any:
        return self._get_content(arg)

Variation_502_Arg: TypeAlias = RuleContent_797_Arg
class Variation_502(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 15
    cv_rule = RuleContent_797

    @classmethod
    def create(cls, arg : Variation_502_Arg) -> "Variation_502":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_797:
        return self._get_rule() # type: ignore

RuleVariation_491_Arg: TypeAlias = Variation_502_Arg
class RuleVariation_491(RuleVariationContextFree):
    cv_variation = Variation_502

    @classmethod
    def create(cls, arg : RuleVariation_491_Arg) -> "RuleVariation_491":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_502:
        return self.arg # type: ignore

NonSpare_627_Arg: TypeAlias = RuleVariation_491_Arg
class NonSpare_627(NonSpare):
    cv_name = "AS"
    cv_title = "Air Speed (IAS or Mach)"
    cv_rule = RuleVariation_491

    @classmethod
    def create(cls, arg : NonSpare_627_Arg) -> "NonSpare_627":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_491:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_502:
        return self.rule.variation

Item_85_Arg: TypeAlias = NonSpare_627_Arg
class Item_85(Item):
    cv_non_spare = NonSpare_627

    @classmethod
    def create(cls, arg : Item_85_Arg) -> "Item_85":
        return cls._create(arg) # type: ignore

Variation_1115_Arg_Group = Tuple[Union[RuleVariation_7_Arg, Tuple[Literal["IM"], RuleVariation_7_Arg]], Union[RuleVariation_491_Arg, Tuple[Literal["AS"], RuleVariation_491_Arg]]]
Variation_1115_Arg: TypeAlias = Union[int, Variation_1115_Arg_Group]
class Variation_1115(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_432, 1), (Item_85, 15)]
    cv_items_dict = {"IM": RuleVariation_7, "AS": RuleVariation_491}

    @overload
    @classmethod
    def spec(cls, key : Literal["IM"]) -> RuleVariation_7:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AS"]) -> RuleVariation_491:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["IM"], Literal["AS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["IM"]) -> RuleVariation_7:
        ...
    @overload
    def get_item(self, key : Literal["AS"]) -> RuleVariation_491:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1115_Arg) -> 'Variation_1115':
        return cls._create(arg) # type: ignore

RuleVariation_1072_Arg: TypeAlias = Variation_1115_Arg
class RuleVariation_1072(RuleVariationContextFree):
    cv_variation = Variation_1115

    @classmethod
    def create(cls, arg : RuleVariation_1072_Arg) -> "RuleVariation_1072":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1115:
        return self.arg # type: ignore

NonSpare_339_Arg: TypeAlias = RuleVariation_1072_Arg
class NonSpare_339(NonSpare):
    cv_name = "150"
    cv_title = "Air Speed"
    cv_rule = RuleVariation_1072

    @classmethod
    def create(cls, arg : NonSpare_339_Arg) -> "NonSpare_339":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1072:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1115:
        return self.rule.variation

class UapItem_339(UapItem):
    cv_non_spare = NonSpare_339

Content_712_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["kt"]]]
class Content_712(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = "kt"

    def as_quantity(self, cv_unit : Optional[Literal["kt"]] = None) -> float:
        return self._as_quantity()

RuleContent_712_Arg: TypeAlias = Content_712_Arg
class RuleContent_712(RuleContentContextFree):
    cv_content = Content_712

    @property
    def content(self) -> Content_712:
        return self._get_content() # type: ignore

Variation_299_Arg: TypeAlias = RuleContent_712_Arg
class Variation_299(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_712

    @classmethod
    def create(cls, arg : Variation_299_Arg) -> "Variation_299":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_712:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_712:
        return self.rule.content

RuleVariation_292_Arg: TypeAlias = Variation_299_Arg
class RuleVariation_292(RuleVariationContextFree):
    cv_variation = Variation_299

    @classmethod
    def create(cls, arg : RuleVariation_292_Arg) -> "RuleVariation_292":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_299:
        return self.arg # type: ignore

NonSpare_344_Arg: TypeAlias = RuleVariation_292_Arg
class NonSpare_344(NonSpare):
    cv_name = "151"
    cv_title = "True Airspeed"
    cv_rule = RuleVariation_292

    @classmethod
    def create(cls, arg : NonSpare_344_Arg) -> "NonSpare_344":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_292:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_299:
        return self.rule.variation

class UapItem_344(UapItem):
    cv_non_spare = NonSpare_344

NonSpare_346_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_346(NonSpare):
    cv_name = "152"
    cv_title = "Magnetic Heading"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_346_Arg) -> "NonSpare_346":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

class UapItem_346(UapItem):
    cv_non_spare = NonSpare_346

Content_685_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft/min"]]]
class Content_685(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 6.25
    cv_unit = "ft/min"

    def as_quantity(self, cv_unit : Optional[Literal["ft/min"]] = None) -> float:
        return self._as_quantity()

RuleContent_685_Arg: TypeAlias = Content_685_Arg
class RuleContent_685(RuleContentContextFree):
    cv_content = Content_685

    @property
    def content(self) -> Content_685:
        return self._get_content() # type: ignore

Variation_291_Arg: TypeAlias = RuleContent_685_Arg
class Variation_291(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_685

    @classmethod
    def create(cls, arg : Variation_291_Arg) -> "Variation_291":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_685:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_685:
        return self.rule.content

RuleVariation_284_Arg: TypeAlias = Variation_291_Arg
class RuleVariation_284(RuleVariationContextFree):
    cv_variation = Variation_291

    @classmethod
    def create(cls, arg : RuleVariation_284_Arg) -> "RuleVariation_284":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_291:
        return self.arg # type: ignore

NonSpare_348_Arg: TypeAlias = RuleVariation_284_Arg
class NonSpare_348(NonSpare):
    cv_name = "155"
    cv_title = "Barometric Vertical Rate"
    cv_rule = RuleVariation_284

    @classmethod
    def create(cls, arg : NonSpare_348_Arg) -> "NonSpare_348":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_284:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_291:
        return self.rule.variation

class UapItem_348(UapItem):
    cv_non_spare = NonSpare_348

NonSpare_350_Arg: TypeAlias = RuleVariation_284_Arg
class NonSpare_350(NonSpare):
    cv_name = "157"
    cv_title = "Geometric Vertical Rate"
    cv_rule = RuleVariation_284

    @classmethod
    def create(cls, arg : NonSpare_350_Arg) -> "NonSpare_350":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_284:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_291:
        return self.rule.variation

class UapItem_350(UapItem):
    cv_non_spare = NonSpare_350

Content_680_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM/s"]]]
class Content_680(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 6.103515625e-5
    cv_unit = "NM/s"

    def as_quantity(self, cv_unit : Optional[Literal["NM/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_680_Arg: TypeAlias = Content_680_Arg
class RuleContent_680(RuleContentContextFree):
    cv_content = Content_680

    @property
    def content(self) -> Content_680:
        return self._get_content() # type: ignore

Variation_287_Arg: TypeAlias = RuleContent_680_Arg
class Variation_287(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_680

    @classmethod
    def create(cls, arg : Variation_287_Arg) -> "Variation_287":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_680:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_680:
        return self.rule.content

RuleVariation_280_Arg: TypeAlias = Variation_287_Arg
class RuleVariation_280(RuleVariationContextFree):
    cv_variation = Variation_287

    @classmethod
    def create(cls, arg : RuleVariation_280_Arg) -> "RuleVariation_280":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_287:
        return self.arg # type: ignore

NonSpare_1032_Arg: TypeAlias = RuleVariation_280_Arg
class NonSpare_1032(NonSpare):
    cv_name = "GS"
    cv_title = "Ground Speed in Two's Complement Form Referenced to WGS84"
    cv_rule = RuleVariation_280

    @classmethod
    def create(cls, arg : NonSpare_1032_Arg) -> "NonSpare_1032":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_280:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_287:
        return self.rule.variation

Item_372_Arg: TypeAlias = NonSpare_1032_Arg
class Item_372(Item):
    cv_non_spare = NonSpare_1032

    @classmethod
    def create(cls, arg : Item_372_Arg) -> "Item_372":
        return cls._create(arg) # type: ignore

NonSpare_1809_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_1809(NonSpare):
    cv_name = "TA"
    cv_title = "Track Angle"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_1809_Arg) -> "NonSpare_1809":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Item_967_Arg: TypeAlias = NonSpare_1809_Arg
class Item_967(Item):
    cv_non_spare = NonSpare_1809

    @classmethod
    def create(cls, arg : Item_967_Arg) -> "Item_967":
        return cls._create(arg) # type: ignore

Variation_1108_Arg_Group = Tuple[Union[RuleVariation_280_Arg, Tuple[Literal["GS"], RuleVariation_280_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["TA"], RuleVariation_334_Arg]]]
Variation_1108_Arg: TypeAlias = Union[int, Variation_1108_Arg_Group]
class Variation_1108(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_372, 16), (Item_967, 16)]
    cv_items_dict = {"GS": RuleVariation_280, "TA": RuleVariation_334}

    @overload
    @classmethod
    def spec(cls, key : Literal["GS"]) -> RuleVariation_280:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TA"]) -> RuleVariation_334:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GS"], Literal["TA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GS"]) -> RuleVariation_280:
        ...
    @overload
    def get_item(self, key : Literal["TA"]) -> RuleVariation_334:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1108_Arg) -> 'Variation_1108':
        return cls._create(arg) # type: ignore

RuleVariation_1066_Arg: TypeAlias = Variation_1108_Arg
class RuleVariation_1066(RuleVariationContextFree):
    cv_variation = Variation_1108

    @classmethod
    def create(cls, arg : RuleVariation_1066_Arg) -> "RuleVariation_1066":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1108:
        return self.arg # type: ignore

NonSpare_353_Arg: TypeAlias = RuleVariation_1066_Arg
class NonSpare_353(NonSpare):
    cv_name = "160"
    cv_title = "Ground Vector"
    cv_rule = RuleVariation_1066

    @classmethod
    def create(cls, arg : NonSpare_353_Arg) -> "NonSpare_353":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1066:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1108:
        return self.rule.variation

class UapItem_353(UapItem):
    cv_non_spare = NonSpare_353

Content_390_Arg: TypeAlias = int
class Content_390(ContentTable):
    cv_values = {0: "Not available", 1: "Left", 2: "Right", 3: "Straight"}

RuleContent_390_Arg: TypeAlias = Content_390_Arg
class RuleContent_390(RuleContentContextFree):
    cv_content = Content_390

    @property
    def content(self) -> Content_390:
        return self._get_content() # type: ignore

Variation_105_Arg: TypeAlias = RuleContent_390_Arg
class Variation_105(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_390

    @classmethod
    def create(cls, arg : Variation_105_Arg) -> "Variation_105":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_390:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_390:
        return self.rule.content

RuleVariation_105_Arg: TypeAlias = Variation_105_Arg
class RuleVariation_105(RuleVariationContextFree):
    cv_variation = Variation_105

    @classmethod
    def create(cls, arg : RuleVariation_105_Arg) -> "RuleVariation_105":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_105:
        return self.arg # type: ignore

Content_664_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°/s"]]]
class Content_664(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.25
    cv_unit = "°/s"

    def as_quantity(self, cv_unit : Optional[Literal["°/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_664_Arg: TypeAlias = Content_664_Arg
class RuleContent_664(RuleContentContextFree):
    cv_content = Content_664

    @property
    def content(self) -> Content_664:
        return self._get_content() # type: ignore

Variation_159_Arg: TypeAlias = RuleContent_664_Arg
class Variation_159(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_664

    @classmethod
    def create(cls, arg : Variation_159_Arg) -> "Variation_159":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_664:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_664:
        return self.rule.content

RuleVariation_153_Arg: TypeAlias = Variation_159_Arg
class RuleVariation_153(RuleVariationContextFree):
    cv_variation = Variation_159

    @classmethod
    def create(cls, arg : RuleVariation_153_Arg) -> "RuleVariation_153":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_159:
        return self.arg # type: ignore

NonSpare_1851_Arg: TypeAlias = RuleVariation_105_Arg
class NonSpare_1851(NonSpare):
    cv_name = "TI"
    cv_title = "Turn Indicator"
    cv_rule = RuleVariation_105

    @classmethod
    def create(cls, arg : NonSpare_1851_Arg) -> "NonSpare_1851":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_105:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_105:
        return self.rule.variation

Item_995_Arg: TypeAlias = NonSpare_1851_Arg
class Item_995(Item):
    cv_non_spare = NonSpare_1851

    @classmethod
    def create(cls, arg : Item_995_Arg) -> "Item_995":
        return cls._create(arg) # type: ignore

Item_14_Arg: TypeAlias = int
class Item_14(Spare):
    cv_bit_offset8 = 2
    cv_bit_size = 5

NonSpare_1591_Arg: TypeAlias = RuleVariation_153_Arg
class NonSpare_1591(NonSpare):
    cv_name = "ROT"
    cv_title = "Rate of Turn"
    cv_rule = RuleVariation_153

    @classmethod
    def create(cls, arg : NonSpare_1591_Arg) -> "NonSpare_1591":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_153:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_159:
        return self.rule.variation

Item_821_Arg: TypeAlias = NonSpare_1591_Arg
class Item_821(Item):
    cv_non_spare = NonSpare_1591

    @classmethod
    def create(cls, arg : Item_821_Arg) -> "Item_821":
        return cls._create(arg) # type: ignore

Variation_1379_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_105_Arg, Tuple[Literal["TI"], RuleVariation_105_Arg]], int, None]]
Variation_1379_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_153_Arg, Tuple[Literal["ROT"], RuleVariation_153_Arg]], None]]
Variation_1379_Arg: TypeAlias = Union[
    Tuple[Variation_1379_Arg_Group_1],
    Tuple[Variation_1379_Arg_Group_1, Variation_1379_Arg_Group_2],
]
class Variation_1379(Extended):
    cv_items_list = [[(Item_995, 2), (Item_14, 5), None], [(Item_821, 7), None]]

    @classmethod
    def create(cls, arg : Variation_1379_Arg) -> 'Variation_1379':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["TI"]) -> RuleVariation_105:
        ...
    @overload
    def get_item(self, key : Literal["ROT"]) -> Optional[RuleVariation_153]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1302_Arg: TypeAlias = Variation_1379_Arg
class RuleVariation_1302(RuleVariationContextFree):
    cv_variation = Variation_1379

    @classmethod
    def create(cls, arg : RuleVariation_1302_Arg) -> "RuleVariation_1302":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1379:
        return self.arg # type: ignore

NonSpare_363_Arg: TypeAlias = RuleVariation_1302_Arg
class NonSpare_363(NonSpare):
    cv_name = "165"
    cv_title = "Rate Of Turn"
    cv_rule = RuleVariation_1302

    @classmethod
    def create(cls, arg : NonSpare_363_Arg) -> "NonSpare_363":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1302:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1379:
        return self.rule.variation

class UapItem_363(UapItem):
    cv_non_spare = NonSpare_363

NonSpare_368_Arg: TypeAlias = RuleVariation_381_Arg
class NonSpare_368(NonSpare):
    cv_name = "170"
    cv_title = "Target Identification"
    cv_rule = RuleVariation_381

    @classmethod
    def create(cls, arg : NonSpare_368_Arg) -> "NonSpare_368":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_381:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_389:
        return self.rule.variation

class UapItem_368(UapItem):
    cv_non_spare = NonSpare_368

NonSpare_262_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_262(NonSpare):
    cv_name = "095"
    cv_title = "Velocity Accuracy"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_262_Arg) -> "NonSpare_262":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_262(UapItem):
    cv_non_spare = NonSpare_262

Content_774_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
class Content_774(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 3.90625e-3
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

RuleContent_773_Arg: TypeAlias = Content_774_Arg
class RuleContent_773(RuleContentContextFree):
    cv_content = Content_774

    @property
    def content(self) -> Content_774:
        return self._get_content() # type: ignore

Variation_237_Arg: TypeAlias = RuleContent_773_Arg
class Variation_237(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_773

    @classmethod
    def create(cls, arg : Variation_237_Arg) -> "Variation_237":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_773:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_774:
        return self.rule.content

RuleVariation_230_Arg: TypeAlias = Variation_237_Arg
class RuleVariation_230(RuleVariationContextFree):
    cv_variation = Variation_237

    @classmethod
    def create(cls, arg : RuleVariation_230_Arg) -> "RuleVariation_230":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_237:
        return self.arg # type: ignore

NonSpare_123_Arg: TypeAlias = RuleVariation_230_Arg
class NonSpare_123(NonSpare):
    cv_name = "032"
    cv_title = "Time of Day Accuracy"
    cv_rule = RuleVariation_230

    @classmethod
    def create(cls, arg : NonSpare_123_Arg) -> "NonSpare_123":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_230:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_237:
        return self.rule.variation

class UapItem_123(UapItem):
    cv_non_spare = NonSpare_123

Content_354_Arg: TypeAlias = int
class Content_354(ContentTable):
    cv_values = {0: "No emergency / not reported", 1: "General emergency", 2: "Lifeguard / medical", 3: "Minimum fuel", 4: "No communications", 5: "Unlawful interference"}

RuleContent_354_Arg: TypeAlias = Content_354_Arg
class RuleContent_354(RuleContentContextFree):
    cv_content = Content_354

    @property
    def content(self) -> Content_354:
        return self._get_content() # type: ignore

Variation_170_Arg: TypeAlias = RuleContent_354_Arg
class Variation_170(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_354

    @classmethod
    def create(cls, arg : Variation_170_Arg) -> "Variation_170":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_354:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_354:
        return self.rule.content

RuleVariation_164_Arg: TypeAlias = Variation_170_Arg
class RuleVariation_164(RuleVariationContextFree):
    cv_variation = Variation_170

    @classmethod
    def create(cls, arg : RuleVariation_164_Arg) -> "RuleVariation_164":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_170:
        return self.arg # type: ignore

NonSpare_393_Arg: TypeAlias = RuleVariation_164_Arg
class NonSpare_393(NonSpare):
    cv_name = "200"
    cv_title = "Target Status"
    cv_rule = RuleVariation_164

    @classmethod
    def create(cls, arg : NonSpare_393_Arg) -> "NonSpare_393":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_164:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_170:
        return self.rule.variation

class UapItem_393(UapItem):
    cv_non_spare = NonSpare_393

Content_579_Arg: TypeAlias = int
class Content_579(ContentTable):
    cv_values = {1: "Light aircraft <= 7000 kg", 2: "Reserved", 3: "7000 kg < Medium aircraft < 136000 kg", 4: "Reserved", 5: "136000 kg <= Heavy aircraft", 6: "Highly manoeuvrable (5g acceleration capability) and high speed (>400 knots cruise)", 7: "Reserved", 8: "Reserved", 9: "Reserved", 10: "Rotocraft", 11: "Glider / sailplane", 12: "Lighter-than-air", 13: "Unmanned aerial vehicle", 14: "Space / transatmospheric vehicle", 15: "Ultralight / handglider / paraglider", 16: "Parachutist / skydiver", 17: "Reserved", 18: "Reserved", 19: "Reserved", 20: "Surface emergency vehicle", 21: "Surface service vehicle", 22: "Fixed ground or tethered obstruction", 23: "Reserved", 24: "Reserved"}

RuleContent_579_Arg: TypeAlias = Content_579_Arg
class RuleContent_579(RuleContentContextFree):
    cv_content = Content_579

    @property
    def content(self) -> Content_579:
        return self._get_content() # type: ignore

Variation_182_Arg: TypeAlias = RuleContent_579_Arg
class Variation_182(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_579

    @classmethod
    def create(cls, arg : Variation_182_Arg) -> "Variation_182":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_579:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_579:
        return self.rule.content

RuleVariation_175_Arg: TypeAlias = Variation_182_Arg
class RuleVariation_175(RuleVariationContextFree):
    cv_variation = Variation_182

    @classmethod
    def create(cls, arg : RuleVariation_175_Arg) -> "RuleVariation_175":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_182:
        return self.arg # type: ignore

NonSpare_79_Arg: TypeAlias = RuleVariation_175_Arg
class NonSpare_79(NonSpare):
    cv_name = "020"
    cv_title = "Emitter Category"
    cv_rule = RuleVariation_175

    @classmethod
    def create(cls, arg : NonSpare_79_Arg) -> "NonSpare_79":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_175:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_182:
        return self.rule.variation

class UapItem_79(UapItem):
    cv_non_spare = NonSpare_79

Content_713_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["kt"]]]
class Content_713(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = "kt"

    def as_quantity(self, cv_unit : Optional[Literal["kt"]] = None) -> float:
        return self._as_quantity()

RuleContent_713_Arg: TypeAlias = Content_713_Arg
class RuleContent_713(RuleContentContextFree):
    cv_content = Content_713

    @property
    def content(self) -> Content_713:
        return self._get_content() # type: ignore

Variation_300_Arg: TypeAlias = RuleContent_713_Arg
class Variation_300(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_713

    @classmethod
    def create(cls, arg : Variation_300_Arg) -> "Variation_300":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_713:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_713:
        return self.rule.content

RuleVariation_293_Arg: TypeAlias = Variation_300_Arg
class RuleVariation_293(RuleVariationContextFree):
    cv_variation = Variation_300

    @classmethod
    def create(cls, arg : RuleVariation_293_Arg) -> "RuleVariation_293":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_300:
        return self.arg # type: ignore

NonSpare_2055_Arg: TypeAlias = RuleVariation_293_Arg
class NonSpare_2055(NonSpare):
    cv_name = "WS"
    cv_title = "Wind Speed"
    cv_rule = RuleVariation_293

    @classmethod
    def create(cls, arg : NonSpare_2055_Arg) -> "NonSpare_2055":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_293:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_300:
        return self.rule.variation

Content_724_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_724(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_724_Arg: TypeAlias = Content_724_Arg
class RuleContent_724(RuleContentContextFree):
    cv_content = Content_724

    @property
    def content(self) -> Content_724:
        return self._get_content() # type: ignore

Variation_307_Arg: TypeAlias = RuleContent_724_Arg
class Variation_307(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_724

    @classmethod
    def create(cls, arg : Variation_307_Arg) -> "Variation_307":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_724:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_724:
        return self.rule.content

RuleVariation_300_Arg: TypeAlias = Variation_307_Arg
class RuleVariation_300(RuleVariationContextFree):
    cv_variation = Variation_307

    @classmethod
    def create(cls, arg : RuleVariation_300_Arg) -> "RuleVariation_300":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_307:
        return self.arg # type: ignore

NonSpare_2048_Arg: TypeAlias = RuleVariation_300_Arg
class NonSpare_2048(NonSpare):
    cv_name = "WD"
    cv_title = "Wind Direction"
    cv_rule = RuleVariation_300

    @classmethod
    def create(cls, arg : NonSpare_2048_Arg) -> "NonSpare_2048":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_300:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_307:
        return self.rule.variation

Content_665_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°C"]]]
class Content_665(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.25
    cv_unit = "°C"

    def as_quantity(self, cv_unit : Optional[Literal["°C"]] = None) -> float:
        return self._as_quantity()

RuleContent_665_Arg: TypeAlias = Content_665_Arg
class RuleContent_665(RuleContentContextFree):
    cv_content = Content_665

    @property
    def content(self) -> Content_665:
        return self._get_content() # type: ignore

Variation_279_Arg: TypeAlias = RuleContent_665_Arg
class Variation_279(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_665

    @classmethod
    def create(cls, arg : Variation_279_Arg) -> "Variation_279":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_665:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_665:
        return self.rule.content

RuleVariation_272_Arg: TypeAlias = Variation_279_Arg
class RuleVariation_272(RuleVariationContextFree):
    cv_variation = Variation_279

    @classmethod
    def create(cls, arg : RuleVariation_272_Arg) -> "RuleVariation_272":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_279:
        return self.arg # type: ignore

NonSpare_1866_Arg: TypeAlias = RuleVariation_272_Arg
class NonSpare_1866(NonSpare):
    cv_name = "TMP"
    cv_title = "Temperature"
    cv_rule = RuleVariation_272

    @classmethod
    def create(cls, arg : NonSpare_1866_Arg) -> "NonSpare_1866":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_272:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_279:
        return self.rule.variation

Content_614_Arg: TypeAlias = int
class Content_614(ContentInteger):
    cv_signedness = Unsigned

RuleContent_614_Arg: TypeAlias = Content_614_Arg
class RuleContent_614(RuleContentContextFree):
    cv_content = Content_614

    @property
    def content(self) -> Content_614:
        return self._get_content() # type: ignore

Variation_204_Arg: TypeAlias = RuleContent_614_Arg
class Variation_204(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_614

    @classmethod
    def create(cls, arg : Variation_204_Arg) -> "Variation_204":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_614:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_614:
        return self.rule.content

RuleVariation_197_Arg: TypeAlias = Variation_204_Arg
class RuleVariation_197(RuleVariationContextFree):
    cv_variation = Variation_204

    @classmethod
    def create(cls, arg : RuleVariation_197_Arg) -> "RuleVariation_197":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_204:
        return self.arg # type: ignore

NonSpare_1901_Arg: TypeAlias = RuleVariation_197_Arg
class NonSpare_1901(NonSpare):
    cv_name = "TRB"
    cv_title = "Turbulence"
    cv_rule = RuleVariation_197

    @classmethod
    def create(cls, arg : NonSpare_1901_Arg) -> "NonSpare_1901":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_197:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_204:
        return self.rule.variation

Variation_1510_Arg = TypedDict('Variation_1510_Arg', {
    "WS": NonSpare_2055_Arg,
    "WD": NonSpare_2048_Arg,
    "TMP": NonSpare_1866_Arg,
    "TRB": NonSpare_1901_Arg,
}, total=False)
class Variation_1510(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_2055, NonSpare_2048, NonSpare_1866, NonSpare_1901]
    cv_items_dict = {"WS": NonSpare_2055, "WD": NonSpare_2048, "TMP": NonSpare_1866, "TRB": NonSpare_1901}

    @overload
    @classmethod
    def spec(cls, key : Literal["WS"]) -> NonSpare_2055:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WD"]) -> NonSpare_2048:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TMP"]) -> NonSpare_1866:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRB"]) -> NonSpare_1901:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["WS"], Literal["WD"], Literal["TMP"], Literal["TRB"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["WS"]) -> Optional[NonSpare_2055]:
        ...
    @overload
    def get_item(self, key : Literal["WD"]) -> Optional[NonSpare_2048]:
        ...
    @overload
    def get_item(self, key : Literal["TMP"]) -> Optional[NonSpare_1866]:
        ...
    @overload
    def get_item(self, key : Literal["TRB"]) -> Optional[NonSpare_1901]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["WS"], val : NonSpare_2055_Arg) -> "Variation_1510":
        ...
    @overload
    def set_item(self, key : Literal["WD"], val : NonSpare_2048_Arg) -> "Variation_1510":
        ...
    @overload
    def set_item(self, key : Literal["TMP"], val : NonSpare_1866_Arg) -> "Variation_1510":
        ...
    @overload
    def set_item(self, key : Literal["TRB"], val : NonSpare_1901_Arg) -> "Variation_1510":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["WS"]) -> "Variation_1510":
        ...
    @overload
    def del_item(self, key : Literal["WD"]) -> "Variation_1510":
        ...
    @overload
    def del_item(self, key : Literal["TMP"]) -> "Variation_1510":
        ...
    @overload
    def del_item(self, key : Literal["TRB"]) -> "Variation_1510":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1510_Arg) -> 'Variation_1510':
        return cls._create(arg) # type: ignore

RuleVariation_1433_Arg: TypeAlias = Variation_1510_Arg
class RuleVariation_1433(RuleVariationContextFree):
    cv_variation = Variation_1510

    @classmethod
    def create(cls, arg : RuleVariation_1433_Arg) -> "RuleVariation_1433":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1510:
        return self.arg # type: ignore

NonSpare_419_Arg: TypeAlias = RuleVariation_1433_Arg
class NonSpare_419(NonSpare):
    cv_name = "220"
    cv_title = "Met Information"
    cv_rule = RuleVariation_1433

    @classmethod
    def create(cls, arg : NonSpare_419_Arg) -> "NonSpare_419":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1433:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1510:
        return self.rule.variation

class UapItem_419(UapItem):
    cv_non_spare = NonSpare_419

Content_371_Arg: TypeAlias = int
class Content_371(ContentTable):
    cv_values = {0: "No source information provided", 1: "Source Information provided"}

RuleContent_371_Arg: TypeAlias = Content_371_Arg
class RuleContent_371(RuleContentContextFree):
    cv_content = Content_371

    @property
    def content(self) -> Content_371:
        return self._get_content() # type: ignore

Variation_63_Arg: TypeAlias = RuleContent_371_Arg
class Variation_63(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_371

    @classmethod
    def create(cls, arg : Variation_63_Arg) -> "Variation_63":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_371:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_371:
        return self.rule.content

RuleVariation_63_Arg: TypeAlias = Variation_63_Arg
class RuleVariation_63(RuleVariationContextFree):
    cv_variation = Variation_63

    @classmethod
    def create(cls, arg : RuleVariation_63_Arg) -> "RuleVariation_63":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_63:
        return self.arg # type: ignore

NonSpare_1654_Arg: TypeAlias = RuleVariation_63_Arg
class NonSpare_1654(NonSpare):
    cv_name = "SAS"
    cv_title = "Source Availability"
    cv_rule = RuleVariation_63

    @classmethod
    def create(cls, arg : NonSpare_1654_Arg) -> "NonSpare_1654":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_63:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_63:
        return self.rule.variation

Item_857_Arg: TypeAlias = NonSpare_1654_Arg
class Item_857(Item):
    cv_non_spare = NonSpare_1654

    @classmethod
    def create(cls, arg : Item_857_Arg) -> "Item_857":
        return cls._create(arg) # type: ignore

Content_536_Arg: TypeAlias = int
class Content_536(ContentTable):
    cv_values = {0: "Unknown", 1: "Aircraft Altitude (Holding Altitude)", 2: "MCP/FCU Selected Altitude", 3: "FMS Selected Altitude"}

RuleContent_536_Arg: TypeAlias = Content_536_Arg
class RuleContent_536(RuleContentContextFree):
    cv_content = Content_536

    @property
    def content(self) -> Content_536:
        return self._get_content() # type: ignore

Variation_475_Arg: TypeAlias = RuleContent_536_Arg
class Variation_475(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_536

    @classmethod
    def create(cls, arg : Variation_475_Arg) -> "Variation_475":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_536:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_536:
        return self.rule.content

RuleVariation_464_Arg: TypeAlias = Variation_475_Arg
class RuleVariation_464(RuleVariationContextFree):
    cv_variation = Variation_475

    @classmethod
    def create(cls, arg : RuleVariation_464_Arg) -> "RuleVariation_464":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_475:
        return self.arg # type: ignore

NonSpare_1741_Arg: TypeAlias = RuleVariation_464_Arg
class NonSpare_1741(NonSpare):
    cv_name = "SRC"
    cv_title = "Source"
    cv_rule = RuleVariation_464

    @classmethod
    def create(cls, arg : NonSpare_1741_Arg) -> "NonSpare_1741":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_464:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_475:
        return self.rule.variation

Item_919_Arg: TypeAlias = NonSpare_1741_Arg
class Item_919(Item):
    cv_non_spare = NonSpare_1741

    @classmethod
    def create(cls, arg : Item_919_Arg) -> "Item_919":
        return cls._create(arg) # type: ignore

Content_632_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
class Content_632(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 25.0
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

RuleContent_632_Arg: TypeAlias = Content_632_Arg
class RuleContent_632(RuleContentContextFree):
    cv_content = Content_632

    @property
    def content(self) -> Content_632:
        return self._get_content() # type: ignore

Variation_694_Arg: TypeAlias = RuleContent_632_Arg
class Variation_694(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 13
    cv_rule = RuleContent_632

    @classmethod
    def create(cls, arg : Variation_694_Arg) -> "Variation_694":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_632:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_632:
        return self.rule.content

RuleVariation_683_Arg: TypeAlias = Variation_694_Arg
class RuleVariation_683(RuleVariationContextFree):
    cv_variation = Variation_694

    @classmethod
    def create(cls, arg : RuleVariation_683_Arg) -> "RuleVariation_683":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_694:
        return self.arg # type: ignore

NonSpare_588_Arg: TypeAlias = RuleVariation_683_Arg
class NonSpare_588(NonSpare):
    cv_name = "ALT"
    cv_title = "Altitude"
    cv_rule = RuleVariation_683

    @classmethod
    def create(cls, arg : NonSpare_588_Arg) -> "NonSpare_588":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_683:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_694:
        return self.rule.variation

Item_60_Arg: TypeAlias = NonSpare_588_Arg
class Item_60(Item):
    cv_non_spare = NonSpare_588

    @classmethod
    def create(cls, arg : Item_60_Arg) -> "Item_60":
        return cls._create(arg) # type: ignore

Variation_1195_Arg_Group = Tuple[Union[RuleVariation_63_Arg, Tuple[Literal["SAS"], RuleVariation_63_Arg]], Union[RuleVariation_464_Arg, Tuple[Literal["SRC"], RuleVariation_464_Arg]], Union[RuleVariation_683_Arg, Tuple[Literal["ALT"], RuleVariation_683_Arg]]]
Variation_1195_Arg: TypeAlias = Union[int, Variation_1195_Arg_Group]
class Variation_1195(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_857, 1), (Item_919, 2), (Item_60, 13)]
    cv_items_dict = {"SAS": RuleVariation_63, "SRC": RuleVariation_464, "ALT": RuleVariation_683}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAS"]) -> RuleVariation_63:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SRC"]) -> RuleVariation_464:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_683:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAS"], Literal["SRC"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAS"]) -> RuleVariation_63:
        ...
    @overload
    def get_item(self, key : Literal["SRC"]) -> RuleVariation_464:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_683:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1195_Arg) -> 'Variation_1195':
        return cls._create(arg) # type: ignore

RuleVariation_1140_Arg: TypeAlias = Variation_1195_Arg
class RuleVariation_1140(RuleVariationContextFree):
    cv_variation = Variation_1195

    @classmethod
    def create(cls, arg : RuleVariation_1140_Arg) -> "RuleVariation_1140":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1195:
        return self.arg # type: ignore

NonSpare_335_Arg: TypeAlias = RuleVariation_1140_Arg
class NonSpare_335(NonSpare):
    cv_name = "146"
    cv_title = "Intermediate State Selected Altitude"
    cv_rule = RuleVariation_1140

    @classmethod
    def create(cls, arg : NonSpare_335_Arg) -> "NonSpare_335":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1195:
        return self.rule.variation

class UapItem_335(UapItem):
    cv_non_spare = NonSpare_335

Content_386_Arg: TypeAlias = int
class Content_386(ContentTable):
    cv_values = {0: "Not active", 1: "Active"}

RuleContent_386_Arg: TypeAlias = Content_386_Arg
class RuleContent_386(RuleContentContextFree):
    cv_content = Content_386

    @property
    def content(self) -> Content_386:
        return self._get_content() # type: ignore

Variation_66_Arg: TypeAlias = RuleContent_386_Arg
class Variation_66(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_386

    @classmethod
    def create(cls, arg : Variation_66_Arg) -> "Variation_66":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_386:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_386:
        return self.rule.content

RuleVariation_66_Arg: TypeAlias = Variation_66_Arg
class RuleVariation_66(RuleVariationContextFree):
    cv_variation = Variation_66

    @classmethod
    def create(cls, arg : RuleVariation_66_Arg) -> "RuleVariation_66":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_66:
        return self.arg # type: ignore

NonSpare_1329_Arg: TypeAlias = RuleVariation_66_Arg
class NonSpare_1329(NonSpare):
    cv_name = "MV"
    cv_title = "Manage Vertical Mode"
    cv_rule = RuleVariation_66

    @classmethod
    def create(cls, arg : NonSpare_1329_Arg) -> "NonSpare_1329":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_66:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_66:
        return self.rule.variation

Item_598_Arg: TypeAlias = NonSpare_1329_Arg
class Item_598(Item):
    cv_non_spare = NonSpare_1329

    @classmethod
    def create(cls, arg : Item_598_Arg) -> "Item_598":
        return cls._create(arg) # type: ignore

Variation_441_Arg: TypeAlias = RuleContent_386_Arg
class Variation_441(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_386

    @classmethod
    def create(cls, arg : Variation_441_Arg) -> "Variation_441":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_386:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_386:
        return self.rule.content

RuleVariation_430_Arg: TypeAlias = Variation_441_Arg
class RuleVariation_430(RuleVariationContextFree):
    cv_variation = Variation_441

    @classmethod
    def create(cls, arg : RuleVariation_430_Arg) -> "RuleVariation_430":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_441:
        return self.arg # type: ignore

NonSpare_579_Arg: TypeAlias = RuleVariation_430_Arg
class NonSpare_579(NonSpare):
    cv_name = "AH"
    cv_title = "Altitude Hold Mode"
    cv_rule = RuleVariation_430

    @classmethod
    def create(cls, arg : NonSpare_579_Arg) -> "NonSpare_579":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_430:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_441:
        return self.rule.variation

Item_53_Arg: TypeAlias = NonSpare_579_Arg
class Item_53(Item):
    cv_non_spare = NonSpare_579

    @classmethod
    def create(cls, arg : Item_53_Arg) -> "Item_53":
        return cls._create(arg) # type: ignore

Variation_564_Arg: TypeAlias = RuleContent_386_Arg
class Variation_564(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_386

    @classmethod
    def create(cls, arg : Variation_564_Arg) -> "Variation_564":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_386:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_386:
        return self.rule.content

RuleVariation_553_Arg: TypeAlias = Variation_564_Arg
class RuleVariation_553(RuleVariationContextFree):
    cv_variation = Variation_564

    @classmethod
    def create(cls, arg : RuleVariation_553_Arg) -> "RuleVariation_553":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_564:
        return self.arg # type: ignore

NonSpare_598_Arg: TypeAlias = RuleVariation_553_Arg
class NonSpare_598(NonSpare):
    cv_name = "AM"
    cv_title = "Approach Mode"
    cv_rule = RuleVariation_553

    @classmethod
    def create(cls, arg : NonSpare_598_Arg) -> "NonSpare_598":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_553:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_564:
        return self.rule.variation

Item_67_Arg: TypeAlias = NonSpare_598_Arg
class Item_67(Item):
    cv_non_spare = NonSpare_598

    @classmethod
    def create(cls, arg : Item_67_Arg) -> "Item_67":
        return cls._create(arg) # type: ignore

Variation_1140_Arg_Group = Tuple[Union[RuleVariation_66_Arg, Tuple[Literal["MV"], RuleVariation_66_Arg]], Union[RuleVariation_430_Arg, Tuple[Literal["AH"], RuleVariation_430_Arg]], Union[RuleVariation_553_Arg, Tuple[Literal["AM"], RuleVariation_553_Arg]], Union[RuleVariation_683_Arg, Tuple[Literal["ALT"], RuleVariation_683_Arg]]]
Variation_1140_Arg: TypeAlias = Union[int, Variation_1140_Arg_Group]
class Variation_1140(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_598, 1), (Item_53, 1), (Item_67, 1), (Item_60, 13)]
    cv_items_dict = {"MV": RuleVariation_66, "AH": RuleVariation_430, "AM": RuleVariation_553, "ALT": RuleVariation_683}

    @overload
    @classmethod
    def spec(cls, key : Literal["MV"]) -> RuleVariation_66:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AH"]) -> RuleVariation_430:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AM"]) -> RuleVariation_553:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_683:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MV"], Literal["AH"], Literal["AM"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MV"]) -> RuleVariation_66:
        ...
    @overload
    def get_item(self, key : Literal["AH"]) -> RuleVariation_430:
        ...
    @overload
    def get_item(self, key : Literal["AM"]) -> RuleVariation_553:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_683:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1140_Arg) -> 'Variation_1140':
        return cls._create(arg) # type: ignore

RuleVariation_1094_Arg: TypeAlias = Variation_1140_Arg
class RuleVariation_1094(RuleVariationContextFree):
    cv_variation = Variation_1140

    @classmethod
    def create(cls, arg : RuleVariation_1094_Arg) -> "RuleVariation_1094":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1140:
        return self.arg # type: ignore

NonSpare_337_Arg: TypeAlias = RuleVariation_1094_Arg
class NonSpare_337(NonSpare):
    cv_name = "148"
    cv_title = "Final State Selected Altitude"
    cv_rule = RuleVariation_1094

    @classmethod
    def create(cls, arg : NonSpare_337_Arg) -> "NonSpare_337":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1094:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1140:
        return self.rule.variation

class UapItem_337(UapItem):
    cv_non_spare = NonSpare_337

Content_515_Arg: TypeAlias = int
class Content_515(ContentTable):
    cv_values = {0: "Trajectory Intent Data is available for this aircraft", 1: "Trajectory Intent Data is not available for this aircraft"}

RuleContent_515_Arg: TypeAlias = Content_515_Arg
class RuleContent_515(RuleContentContextFree):
    cv_content = Content_515

    @property
    def content(self) -> Content_515:
        return self._get_content() # type: ignore

Variation_91_Arg: TypeAlias = RuleContent_515_Arg
class Variation_91(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_515

    @classmethod
    def create(cls, arg : Variation_91_Arg) -> "Variation_91":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_515:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_515:
        return self.rule.content

RuleVariation_91_Arg: TypeAlias = Variation_91_Arg
class RuleVariation_91(RuleVariationContextFree):
    cv_variation = Variation_91

    @classmethod
    def create(cls, arg : RuleVariation_91_Arg) -> "RuleVariation_91":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_91:
        return self.arg # type: ignore

Content_516_Arg: TypeAlias = int
class Content_516(ContentTable):
    cv_values = {0: "Trajectory Intent Data is valid", 1: "Trajectory Intent Data is not valid"}

RuleContent_516_Arg: TypeAlias = Content_516_Arg
class RuleContent_516(RuleContentContextFree):
    cv_content = Content_516

    @property
    def content(self) -> Content_516:
        return self._get_content() # type: ignore

Variation_457_Arg: TypeAlias = RuleContent_516_Arg
class Variation_457(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_516

    @classmethod
    def create(cls, arg : Variation_457_Arg) -> "Variation_457":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_516:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_516:
        return self.rule.content

RuleVariation_446_Arg: TypeAlias = Variation_457_Arg
class RuleVariation_446(RuleVariationContextFree):
    cv_variation = Variation_457

    @classmethod
    def create(cls, arg : RuleVariation_446_Arg) -> "RuleVariation_446":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_457:
        return self.arg # type: ignore

NonSpare_1336_Arg: TypeAlias = RuleVariation_91_Arg
class NonSpare_1336(NonSpare):
    cv_name = "NAV"
    cv_title = ""
    cv_rule = RuleVariation_91

    @classmethod
    def create(cls, arg : NonSpare_1336_Arg) -> "NonSpare_1336":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_91:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_91:
        return self.rule.variation

Item_604_Arg: TypeAlias = NonSpare_1336_Arg
class Item_604(Item):
    cv_non_spare = NonSpare_1336

    @classmethod
    def create(cls, arg : Item_604_Arg) -> "Item_604":
        return cls._create(arg) # type: ignore

NonSpare_1377_Arg: TypeAlias = RuleVariation_446_Arg
class NonSpare_1377(NonSpare):
    cv_name = "NVB"
    cv_title = ""
    cv_rule = RuleVariation_446

    @classmethod
    def create(cls, arg : NonSpare_1377_Arg) -> "NonSpare_1377":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_446:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_457:
        return self.rule.variation

Item_642_Arg: TypeAlias = NonSpare_1377_Arg
class Item_642(Item):
    cv_non_spare = NonSpare_1377

    @classmethod
    def create(cls, arg : Item_642_Arg) -> "Item_642":
        return cls._create(arg) # type: ignore

Variation_1365_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_91_Arg, Tuple[Literal["NAV"], RuleVariation_91_Arg]], Union[RuleVariation_446_Arg, Tuple[Literal["NVB"], RuleVariation_446_Arg]], int, None]]
Variation_1365_Arg: TypeAlias = Union[
    Tuple[Variation_1365_Arg_Group_1],
]
class Variation_1365(Extended):
    cv_items_list = [[(Item_604, 1), (Item_642, 1), (Item_14, 5), None]]

    @classmethod
    def create(cls, arg : Variation_1365_Arg) -> 'Variation_1365':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["NAV"]) -> RuleVariation_91:
        ...
    @overload
    def get_item(self, key : Literal["NVB"]) -> RuleVariation_446:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1288_Arg: TypeAlias = Variation_1365_Arg
class RuleVariation_1288(RuleVariationContextFree):
    cv_variation = Variation_1365

    @classmethod
    def create(cls, arg : RuleVariation_1288_Arg) -> "RuleVariation_1288":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1365:
        return self.arg # type: ignore

NonSpare_1863_Arg: TypeAlias = RuleVariation_1288_Arg
class NonSpare_1863(NonSpare):
    cv_name = "TIS"
    cv_title = "Trajectory Intent Status"
    cv_rule = RuleVariation_1288

    @classmethod
    def create(cls, arg : NonSpare_1863_Arg) -> "NonSpare_1863":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1288:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1365:
        return self.rule.variation

Content_464_Arg: TypeAlias = int
class Content_464(ContentTable):
    cv_values = {0: "TCP number available", 1: "TCP number not available"}

RuleContent_464_Arg: TypeAlias = Content_464_Arg
class RuleContent_464(RuleContentContextFree):
    cv_content = Content_464

    @property
    def content(self) -> Content_464:
        return self._get_content() # type: ignore

Variation_79_Arg: TypeAlias = RuleContent_464_Arg
class Variation_79(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_464

    @classmethod
    def create(cls, arg : Variation_79_Arg) -> "Variation_79":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_464:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_464:
        return self.rule.content

RuleVariation_79_Arg: TypeAlias = Variation_79_Arg
class RuleVariation_79(RuleVariationContextFree):
    cv_variation = Variation_79

    @classmethod
    def create(cls, arg : RuleVariation_79_Arg) -> "RuleVariation_79":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_79:
        return self.arg # type: ignore

NonSpare_1829_Arg: TypeAlias = RuleVariation_79_Arg
class NonSpare_1829(NonSpare):
    cv_name = "TCA"
    cv_title = ""
    cv_rule = RuleVariation_79

    @classmethod
    def create(cls, arg : NonSpare_1829_Arg) -> "NonSpare_1829":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_79:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_79:
        return self.rule.variation

Item_975_Arg: TypeAlias = NonSpare_1829_Arg
class Item_975(Item):
    cv_non_spare = NonSpare_1829

    @classmethod
    def create(cls, arg : Item_975_Arg) -> "Item_975":
        return cls._create(arg) # type: ignore

Content_463_Arg: TypeAlias = int
class Content_463(ContentTable):
    cv_values = {0: "TCP compliance", 1: "TCP non-compliance"}

RuleContent_463_Arg: TypeAlias = Content_463_Arg
class RuleContent_463(RuleContentContextFree):
    cv_content = Content_463

    @property
    def content(self) -> Content_463:
        return self._get_content() # type: ignore

Variation_449_Arg: TypeAlias = RuleContent_463_Arg
class Variation_449(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_463

    @classmethod
    def create(cls, arg : Variation_449_Arg) -> "Variation_449":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_463:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_463:
        return self.rule.content

RuleVariation_438_Arg: TypeAlias = Variation_449_Arg
class RuleVariation_438(RuleVariationContextFree):
    cv_variation = Variation_449

    @classmethod
    def create(cls, arg : RuleVariation_438_Arg) -> "RuleVariation_438":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_449:
        return self.arg # type: ignore

NonSpare_1347_Arg: TypeAlias = RuleVariation_438_Arg
class NonSpare_1347(NonSpare):
    cv_name = "NC"
    cv_title = ""
    cv_rule = RuleVariation_438

    @classmethod
    def create(cls, arg : NonSpare_1347_Arg) -> "NonSpare_1347":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_438:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_449:
        return self.rule.variation

Item_613_Arg: TypeAlias = NonSpare_1347_Arg
class Item_613(Item):
    cv_non_spare = NonSpare_1347

    @classmethod
    def create(cls, arg : Item_613_Arg) -> "Item_613":
        return cls._create(arg) # type: ignore

Variation_599_Arg: TypeAlias = RuleContent_0_Arg
class Variation_599(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 6
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_599_Arg) -> "Variation_599":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_588_Arg: TypeAlias = Variation_599_Arg
class RuleVariation_588(RuleVariationContextFree):
    cv_variation = Variation_599

    @classmethod
    def create(cls, arg : RuleVariation_588_Arg) -> "RuleVariation_588":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_599:
        return self.arg # type: ignore

NonSpare_1840_Arg: TypeAlias = RuleVariation_588_Arg
class NonSpare_1840(NonSpare):
    cv_name = "TCPN"
    cv_title = ""
    cv_rule = RuleVariation_588

    @classmethod
    def create(cls, arg : NonSpare_1840_Arg) -> "NonSpare_1840":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_588:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_599:
        return self.rule.variation

Item_985_Arg: TypeAlias = NonSpare_1840_Arg
class Item_985(Item):
    cv_non_spare = NonSpare_1840

    @classmethod
    def create(cls, arg : Item_985_Arg) -> "Item_985":
        return cls._create(arg) # type: ignore

Content_629_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
class Content_629(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 10.0
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

RuleContent_629_Arg: TypeAlias = Content_629_Arg
class RuleContent_629(RuleContentContextFree):
    cv_content = Content_629

    @property
    def content(self) -> Content_629:
        return self._get_content() # type: ignore

Variation_259_Arg: TypeAlias = RuleContent_629_Arg
class Variation_259(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_629

    @classmethod
    def create(cls, arg : Variation_259_Arg) -> "Variation_259":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_629:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_629:
        return self.rule.content

RuleVariation_252_Arg: TypeAlias = Variation_259_Arg
class RuleVariation_252(RuleVariationContextFree):
    cv_variation = Variation_259

    @classmethod
    def create(cls, arg : RuleVariation_252_Arg) -> "RuleVariation_252":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_259:
        return self.arg # type: ignore

NonSpare_589_Arg: TypeAlias = RuleVariation_252_Arg
class NonSpare_589(NonSpare):
    cv_name = "ALT"
    cv_title = "Altitude in Two's Complement Form"
    cv_rule = RuleVariation_252

    @classmethod
    def create(cls, arg : NonSpare_589_Arg) -> "NonSpare_589":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_252:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_259:
        return self.rule.variation

Item_61_Arg: TypeAlias = NonSpare_589_Arg
class Item_61(Item):
    cv_non_spare = NonSpare_589

    @classmethod
    def create(cls, arg : Item_61_Arg) -> "Item_61":
        return cls._create(arg) # type: ignore

NonSpare_1141_Arg: TypeAlias = RuleVariation_351_Arg
class NonSpare_1141(NonSpare):
    cv_name = "LAT"
    cv_title = "In WGS.84 in Two's Complement"
    cv_rule = RuleVariation_351

    @classmethod
    def create(cls, arg : NonSpare_1141_Arg) -> "NonSpare_1141":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_351:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_358:
        return self.rule.variation

Item_459_Arg: TypeAlias = NonSpare_1141_Arg
class Item_459(Item):
    cv_non_spare = NonSpare_1141

    @classmethod
    def create(cls, arg : Item_459_Arg) -> "Item_459":
        return cls._create(arg) # type: ignore

NonSpare_1169_Arg: TypeAlias = RuleVariation_349_Arg
class NonSpare_1169(NonSpare):
    cv_name = "LON"
    cv_title = "In WGS.84 in Two's Complement"
    cv_rule = RuleVariation_349

    @classmethod
    def create(cls, arg : NonSpare_1169_Arg) -> "NonSpare_1169":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_349:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_356:
        return self.rule.variation

Item_485_Arg: TypeAlias = NonSpare_1169_Arg
class Item_485(Item):
    cv_non_spare = NonSpare_1169

    @classmethod
    def create(cls, arg : Item_485_Arg) -> "Item_485":
        return cls._create(arg) # type: ignore

Content_544_Arg: TypeAlias = int
class Content_544(ContentTable):
    cv_values = {0: "Unknown", 1: "Fly by waypoint (LT)", 2: "Fly over waypoint (LT)", 3: "Hold pattern (LT)", 4: "Procedure hold (LT)", 5: "Procedure turn (LT)", 6: "RF leg (LT)", 7: "Top of climb (VT)", 8: "Top of descent (VT)", 9: "Start of level (VT)", 10: "Cross-over altitude (VT)", 11: "Transition altitude (VT)"}

RuleContent_544_Arg: TypeAlias = Content_544_Arg
class RuleContent_544(RuleContentContextFree):
    cv_content = Content_544

    @property
    def content(self) -> Content_544:
        return self._get_content() # type: ignore

Variation_134_Arg: TypeAlias = RuleContent_544_Arg
class Variation_134(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_544

    @classmethod
    def create(cls, arg : Variation_134_Arg) -> "Variation_134":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_544:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_544:
        return self.rule.content

RuleVariation_134_Arg: TypeAlias = Variation_134_Arg
class RuleVariation_134(RuleVariationContextFree):
    cv_variation = Variation_134

    @classmethod
    def create(cls, arg : RuleVariation_134_Arg) -> "RuleVariation_134":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_134:
        return self.arg # type: ignore

NonSpare_1472_Arg: TypeAlias = RuleVariation_134_Arg
class NonSpare_1472(NonSpare):
    cv_name = "PT"
    cv_title = "Point Type"
    cv_rule = RuleVariation_134

    @classmethod
    def create(cls, arg : NonSpare_1472_Arg) -> "NonSpare_1472":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_134:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_134:
        return self.rule.variation

Item_714_Arg: TypeAlias = NonSpare_1472_Arg
class Item_714(Item):
    cv_non_spare = NonSpare_1472

    @classmethod
    def create(cls, arg : Item_714_Arg) -> "Item_714":
        return cls._create(arg) # type: ignore

Content_298_Arg: TypeAlias = int
class Content_298(ContentTable):
    cv_values = {0: "N/A", 1: "Turn right", 2: "Turn left", 3: "No turn"}

RuleContent_298_Arg: TypeAlias = Content_298_Arg
class RuleContent_298(RuleContentContextFree):
    cv_content = Content_298

    @property
    def content(self) -> Content_298:
        return self._get_content() # type: ignore

Variation_763_Arg: TypeAlias = RuleContent_298_Arg
class Variation_763(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_298

    @classmethod
    def create(cls, arg : Variation_763_Arg) -> "Variation_763":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_298:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_298:
        return self.rule.content

RuleVariation_752_Arg: TypeAlias = Variation_763_Arg
class RuleVariation_752(RuleVariationContextFree):
    cv_variation = Variation_763

    @classmethod
    def create(cls, arg : RuleVariation_752_Arg) -> "RuleVariation_752":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_763:
        return self.arg # type: ignore

NonSpare_1842_Arg: TypeAlias = RuleVariation_752_Arg
class NonSpare_1842(NonSpare):
    cv_name = "TD"
    cv_title = ""
    cv_rule = RuleVariation_752

    @classmethod
    def create(cls, arg : NonSpare_1842_Arg) -> "NonSpare_1842":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_752:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_763:
        return self.rule.variation

Item_987_Arg: TypeAlias = NonSpare_1842_Arg
class Item_987(Item):
    cv_non_spare = NonSpare_1842

    @classmethod
    def create(cls, arg : Item_987_Arg) -> "Item_987":
        return cls._create(arg) # type: ignore

Content_466_Arg: TypeAlias = int
class Content_466(ContentTable):
    cv_values = {0: "TTR not available", 1: "TTR available"}

RuleContent_466_Arg: TypeAlias = Content_466_Arg
class RuleContent_466(RuleContentContextFree):
    cv_content = Content_466

    @property
    def content(self) -> Content_466:
        return self._get_content() # type: ignore

Variation_950_Arg: TypeAlias = RuleContent_466_Arg
class Variation_950(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_466

    @classmethod
    def create(cls, arg : Variation_950_Arg) -> "Variation_950":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_466:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_466:
        return self.rule.content

RuleVariation_920_Arg: TypeAlias = Variation_950_Arg
class RuleVariation_920(RuleVariationContextFree):
    cv_variation = Variation_950

    @classmethod
    def create(cls, arg : RuleVariation_920_Arg) -> "RuleVariation_920":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_950:
        return self.arg # type: ignore

NonSpare_1892_Arg: TypeAlias = RuleVariation_920_Arg
class NonSpare_1892(NonSpare):
    cv_name = "TRA"
    cv_title = ""
    cv_rule = RuleVariation_920

    @classmethod
    def create(cls, arg : NonSpare_1892_Arg) -> "NonSpare_1892":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_920:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_950:
        return self.rule.variation

Item_1021_Arg: TypeAlias = NonSpare_1892_Arg
class Item_1021(Item):
    cv_non_spare = NonSpare_1892

    @classmethod
    def create(cls, arg : Item_1021_Arg) -> "Item_1021":
        return cls._create(arg) # type: ignore

Content_465_Arg: TypeAlias = int
class Content_465(ContentTable):
    cv_values = {0: "TOV available", 1: "TOV not available"}

RuleContent_465_Arg: TypeAlias = Content_465_Arg
class RuleContent_465(RuleContentContextFree):
    cv_content = Content_465

    @property
    def content(self) -> Content_465:
        return self._get_content() # type: ignore

Variation_985_Arg: TypeAlias = RuleContent_465_Arg
class Variation_985(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_465

    @classmethod
    def create(cls, arg : Variation_985_Arg) -> "Variation_985":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_465:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_465:
        return self.rule.content

RuleVariation_955_Arg: TypeAlias = Variation_985_Arg
class RuleVariation_955(RuleVariationContextFree):
    cv_variation = Variation_985

    @classmethod
    def create(cls, arg : RuleVariation_955_Arg) -> "RuleVariation_955":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_985:
        return self.arg # type: ignore

NonSpare_1870_Arg: TypeAlias = RuleVariation_955_Arg
class NonSpare_1870(NonSpare):
    cv_name = "TOA"
    cv_title = ""
    cv_rule = RuleVariation_955

    @classmethod
    def create(cls, arg : NonSpare_1870_Arg) -> "NonSpare_1870":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_955:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_985:
        return self.rule.variation

Item_1004_Arg: TypeAlias = NonSpare_1870_Arg
class Item_1004(Item):
    cv_non_spare = NonSpare_1870

    @classmethod
    def create(cls, arg : Item_1004_Arg) -> "Item_1004":
        return cls._create(arg) # type: ignore

Variation_363_Arg: TypeAlias = RuleContent_721_Arg
class Variation_363(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_721

    @classmethod
    def create(cls, arg : Variation_363_Arg) -> "Variation_363":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_721:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_721:
        return self.rule.content

RuleVariation_356_Arg: TypeAlias = Variation_363_Arg
class RuleVariation_356(RuleVariationContextFree):
    cv_variation = Variation_363

    @classmethod
    def create(cls, arg : RuleVariation_356_Arg) -> "RuleVariation_356":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_363:
        return self.arg # type: ignore

NonSpare_1881_Arg: TypeAlias = RuleVariation_356_Arg
class NonSpare_1881(NonSpare):
    cv_name = "TOV"
    cv_title = "Time Over Point"
    cv_rule = RuleVariation_356

    @classmethod
    def create(cls, arg : NonSpare_1881_Arg) -> "NonSpare_1881":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_356:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_363:
        return self.rule.variation

Item_1010_Arg: TypeAlias = NonSpare_1881_Arg
class Item_1010(Item):
    cv_non_spare = NonSpare_1881

    @classmethod
    def create(cls, arg : Item_1010_Arg) -> "Item_1010":
        return cls._create(arg) # type: ignore

Content_739_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
class Content_739(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0e-2
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

RuleContent_739_Arg: TypeAlias = Content_739_Arg
class RuleContent_739(RuleContentContextFree):
    cv_content = Content_739

    @property
    def content(self) -> Content_739:
        return self._get_content() # type: ignore

Variation_312_Arg: TypeAlias = RuleContent_739_Arg
class Variation_312(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_739

    @classmethod
    def create(cls, arg : Variation_312_Arg) -> "Variation_312":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_739:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_739:
        return self.rule.content

RuleVariation_305_Arg: TypeAlias = Variation_312_Arg
class RuleVariation_305(RuleVariationContextFree):
    cv_variation = Variation_312

    @classmethod
    def create(cls, arg : RuleVariation_305_Arg) -> "RuleVariation_305":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_312:
        return self.arg # type: ignore

NonSpare_1943_Arg: TypeAlias = RuleVariation_305_Arg
class NonSpare_1943(NonSpare):
    cv_name = "TTR"
    cv_title = "TCP Turn Radius"
    cv_rule = RuleVariation_305

    @classmethod
    def create(cls, arg : NonSpare_1943_Arg) -> "NonSpare_1943":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_305:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_312:
        return self.rule.variation

Item_1064_Arg: TypeAlias = NonSpare_1943_Arg
class Item_1064(Item):
    cv_non_spare = NonSpare_1943

    @classmethod
    def create(cls, arg : Item_1064_Arg) -> "Item_1064":
        return cls._create(arg) # type: ignore

Variation_1215_Arg_Group = Tuple[Union[RuleVariation_79_Arg, Tuple[Literal["TCA"], RuleVariation_79_Arg]], Union[RuleVariation_438_Arg, Tuple[Literal["NC"], RuleVariation_438_Arg]], Union[RuleVariation_588_Arg, Tuple[Literal["TCPN"], RuleVariation_588_Arg]], Union[RuleVariation_252_Arg, Tuple[Literal["ALT"], RuleVariation_252_Arg]], Union[RuleVariation_351_Arg, Tuple[Literal["LAT"], RuleVariation_351_Arg]], Union[RuleVariation_349_Arg, Tuple[Literal["LON"], RuleVariation_349_Arg]], Union[RuleVariation_134_Arg, Tuple[Literal["PT"], RuleVariation_134_Arg]], Union[RuleVariation_752_Arg, Tuple[Literal["TD"], RuleVariation_752_Arg]], Union[RuleVariation_920_Arg, Tuple[Literal["TRA"], RuleVariation_920_Arg]], Union[RuleVariation_955_Arg, Tuple[Literal["TOA"], RuleVariation_955_Arg]], Union[RuleVariation_356_Arg, Tuple[Literal["TOV"], RuleVariation_356_Arg]], Union[RuleVariation_305_Arg, Tuple[Literal["TTR"], RuleVariation_305_Arg]]]
Variation_1215_Arg: TypeAlias = Union[int, Variation_1215_Arg_Group]
class Variation_1215(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 120
    cv_items_list = [(Item_975, 1), (Item_613, 1), (Item_985, 6), (Item_61, 16), (Item_459, 24), (Item_485, 24), (Item_714, 4), (Item_987, 2), (Item_1021, 1), (Item_1004, 1), (Item_1010, 24), (Item_1064, 16)]
    cv_items_dict = {"TCA": RuleVariation_79, "NC": RuleVariation_438, "TCPN": RuleVariation_588, "ALT": RuleVariation_252, "LAT": RuleVariation_351, "LON": RuleVariation_349, "PT": RuleVariation_134, "TD": RuleVariation_752, "TRA": RuleVariation_920, "TOA": RuleVariation_955, "TOV": RuleVariation_356, "TTR": RuleVariation_305}

    @overload
    @classmethod
    def spec(cls, key : Literal["TCA"]) -> RuleVariation_79:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NC"]) -> RuleVariation_438:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TCPN"]) -> RuleVariation_588:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_252:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_351:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_349:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PT"]) -> RuleVariation_134:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TD"]) -> RuleVariation_752:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRA"]) -> RuleVariation_920:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOA"]) -> RuleVariation_955:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOV"]) -> RuleVariation_356:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TTR"]) -> RuleVariation_305:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TCA"], Literal["NC"], Literal["TCPN"], Literal["ALT"], Literal["LAT"], Literal["LON"], Literal["PT"], Literal["TD"], Literal["TRA"], Literal["TOA"], Literal["TOV"], Literal["TTR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TCA"]) -> RuleVariation_79:
        ...
    @overload
    def get_item(self, key : Literal["NC"]) -> RuleVariation_438:
        ...
    @overload
    def get_item(self, key : Literal["TCPN"]) -> RuleVariation_588:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_252:
        ...
    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_351:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_349:
        ...
    @overload
    def get_item(self, key : Literal["PT"]) -> RuleVariation_134:
        ...
    @overload
    def get_item(self, key : Literal["TD"]) -> RuleVariation_752:
        ...
    @overload
    def get_item(self, key : Literal["TRA"]) -> RuleVariation_920:
        ...
    @overload
    def get_item(self, key : Literal["TOA"]) -> RuleVariation_955:
        ...
    @overload
    def get_item(self, key : Literal["TOV"]) -> RuleVariation_356:
        ...
    @overload
    def get_item(self, key : Literal["TTR"]) -> RuleVariation_305:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1215_Arg) -> 'Variation_1215':
        return cls._create(arg) # type: ignore

Variation_1428_Arg: TypeAlias = List[Variation_1215_Arg]
class Variation_1428(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1215

    @classmethod
    def create(cls, arg : Variation_1428_Arg) -> 'Variation_1428':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1215]:
        return self._get_list() # type: ignore

RuleVariation_1351_Arg: TypeAlias = Variation_1428_Arg
class RuleVariation_1351(RuleVariationContextFree):
    cv_variation = Variation_1428

    @classmethod
    def create(cls, arg : RuleVariation_1351_Arg) -> "RuleVariation_1351":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1428:
        return self.arg # type: ignore

NonSpare_1858_Arg: TypeAlias = RuleVariation_1351_Arg
class NonSpare_1858(NonSpare):
    cv_name = "TID"
    cv_title = "Trajectory Intent Data"
    cv_rule = RuleVariation_1351

    @classmethod
    def create(cls, arg : NonSpare_1858_Arg) -> "NonSpare_1858":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1351:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1428:
        return self.rule.variation

Variation_1506_Arg = TypedDict('Variation_1506_Arg', {
    "TIS": NonSpare_1863_Arg,
    "TID": NonSpare_1858_Arg,
}, total=False)
class Variation_1506(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1863, NonSpare_1858]
    cv_items_dict = {"TIS": NonSpare_1863, "TID": NonSpare_1858}

    @overload
    @classmethod
    def spec(cls, key : Literal["TIS"]) -> NonSpare_1863:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> NonSpare_1858:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TIS"], Literal["TID"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TIS"]) -> Optional[NonSpare_1863]:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> Optional[NonSpare_1858]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["TIS"], val : NonSpare_1863_Arg) -> "Variation_1506":
        ...
    @overload
    def set_item(self, key : Literal["TID"], val : NonSpare_1858_Arg) -> "Variation_1506":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["TIS"]) -> "Variation_1506":
        ...
    @overload
    def del_item(self, key : Literal["TID"]) -> "Variation_1506":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1506_Arg) -> 'Variation_1506':
        return cls._create(arg) # type: ignore

RuleVariation_1429_Arg: TypeAlias = Variation_1506_Arg
class RuleVariation_1429(RuleVariationContextFree):
    cv_variation = Variation_1506

    @classmethod
    def create(cls, arg : RuleVariation_1429_Arg) -> "RuleVariation_1429":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1506:
        return self.arg # type: ignore

NonSpare_289_Arg: TypeAlias = RuleVariation_1429_Arg
class NonSpare_289(NonSpare):
    cv_name = "110"
    cv_title = "Trajectory Intent"
    cv_rule = RuleVariation_1429

    @classmethod
    def create(cls, arg : NonSpare_289_Arg) -> "NonSpare_289":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1429:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1506:
        return self.rule.variation

class UapItem_289(UapItem):
    cv_non_spare = NonSpare_289

Record_0_Arg = TypedDict('Record_0_Arg', {
    "010": NonSpare_28_Arg,
    "040": NonSpare_142_Arg,
    "030": NonSpare_108_Arg,
    "130": NonSpare_304_Arg,
    "080": NonSpare_233_Arg,
    "140": NonSpare_317_Arg,
    "090": NonSpare_243_Arg,
    "210": NonSpare_407_Arg,
    "230": NonSpare_429_Arg,
    "145": NonSpare_333_Arg,
    "150": NonSpare_339_Arg,
    "151": NonSpare_344_Arg,
    "152": NonSpare_346_Arg,
    "155": NonSpare_348_Arg,
    "157": NonSpare_350_Arg,
    "160": NonSpare_353_Arg,
    "165": NonSpare_363_Arg,
    "170": NonSpare_368_Arg,
    "095": NonSpare_262_Arg,
    "032": NonSpare_123_Arg,
    "200": NonSpare_393_Arg,
    "020": NonSpare_79_Arg,
    "220": NonSpare_419_Arg,
    "146": NonSpare_335_Arg,
    "148": NonSpare_337_Arg,
    "110": NonSpare_289_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_0(Record):
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_28, UapItem_142, UapItem_108, UapItem_304, UapItem_233, UapItem_317, UapItem_243, UapItem_407, UapItem_429, UapItem_333, UapItem_339, UapItem_344, UapItem_346, UapItem_348, UapItem_350, UapItem_353, UapItem_363, UapItem_368, UapItem_262, UapItem_123, UapItem_393, UapItem_79, UapItem_419, UapItem_335, UapItem_337, UapItem_289, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_28, "040": NonSpare_142, "030": NonSpare_108, "130": NonSpare_304, "080": NonSpare_233, "140": NonSpare_317, "090": NonSpare_243, "210": NonSpare_407, "230": NonSpare_429, "145": NonSpare_333, "150": NonSpare_339, "151": NonSpare_344, "152": NonSpare_346, "155": NonSpare_348, "157": NonSpare_350, "160": NonSpare_353, "165": NonSpare_363, "170": NonSpare_368, "095": NonSpare_262, "032": NonSpare_123, "200": NonSpare_393, "020": NonSpare_79, "220": NonSpare_419, "146": NonSpare_335, "148": NonSpare_337, "110": NonSpare_289, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_28:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_142:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_108:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_304:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_317:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_243:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_407:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_429:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_333:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_339:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_344:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_346:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_348:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_350:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_353:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_363:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_368:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["095"]) -> NonSpare_262:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["032"]) -> NonSpare_123:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_393:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_79:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_419:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_335:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_337:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_289:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["030"], Literal["130"], Literal["080"], Literal["140"], Literal["090"], Literal["210"], Literal["230"], Literal["145"], Literal["150"], Literal["151"], Literal["152"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["170"], Literal["095"], Literal["032"], Literal["200"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_28]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_142]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_108]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_304]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_233]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_317]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_243]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_407]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_429]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_333]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_339]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_344]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_346]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_348]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_350]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_353]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_363]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_368]:
        ...
    @overload
    def get_item(self, key : Literal["095"]) -> Optional[NonSpare_262]:
        ...
    @overload
    def get_item(self, key : Literal["032"]) -> Optional[NonSpare_123]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_393]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_79]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_419]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_335]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_337]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_289]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_28_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_142_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_108_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_304_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_233_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_317_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_243_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_407_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_429_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_333_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_339_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_344_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_346_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_348_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_350_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_353_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_363_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_368_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["095"], val : NonSpare_262_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["032"], val : NonSpare_123_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_393_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_79_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_419_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_335_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_337_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_289_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_0':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["095"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["032"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_0':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_0_Arg) -> 'Record_0':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_0", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_0_Arg: TypeAlias = Record_0
class Uap_0(UapSingle):
    cv_record = Record_0

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_0]]:
        return cls._parse(bs)

class Asterix_22(AstCat):
    cv_category = 21
    cv_edition = (0, 23)
    cv_uap = Uap_0

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_0_Arg]) -> "Asterix_22":
        return cls._create(records) # type: ignore

NonSpare_306_Arg: TypeAlias = RuleVariation_1080_Arg
class NonSpare_306(NonSpare):
    cv_name = "130"
    cv_title = "Position in WGS-84 Co-ordinates"
    cv_rule = RuleVariation_1080

    @classmethod
    def create(cls, arg : NonSpare_306_Arg) -> "NonSpare_306":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1080:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1123:
        return self.rule.variation

class UapItem_306(UapItem):
    cv_non_spare = NonSpare_306

Record_1_Arg = TypedDict('Record_1_Arg', {
    "010": NonSpare_28_Arg,
    "040": NonSpare_142_Arg,
    "030": NonSpare_108_Arg,
    "130": NonSpare_306_Arg,
    "080": NonSpare_233_Arg,
    "140": NonSpare_317_Arg,
    "090": NonSpare_243_Arg,
    "210": NonSpare_407_Arg,
    "230": NonSpare_429_Arg,
    "145": NonSpare_333_Arg,
    "150": NonSpare_339_Arg,
    "151": NonSpare_344_Arg,
    "152": NonSpare_346_Arg,
    "155": NonSpare_348_Arg,
    "157": NonSpare_350_Arg,
    "160": NonSpare_353_Arg,
    "165": NonSpare_363_Arg,
    "170": NonSpare_368_Arg,
    "095": NonSpare_262_Arg,
    "032": NonSpare_123_Arg,
    "200": NonSpare_393_Arg,
    "020": NonSpare_79_Arg,
    "220": NonSpare_419_Arg,
    "146": NonSpare_335_Arg,
    "148": NonSpare_337_Arg,
    "110": NonSpare_289_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_1(Record):
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_28, UapItem_142, UapItem_108, UapItem_306, UapItem_233, UapItem_317, UapItem_243, UapItem_407, UapItem_429, UapItem_333, UapItem_339, UapItem_344, UapItem_346, UapItem_348, UapItem_350, UapItem_353, UapItem_363, UapItem_368, UapItem_262, UapItem_123, UapItem_393, UapItem_79, UapItem_419, UapItem_335, UapItem_337, UapItem_289, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_28, "040": NonSpare_142, "030": NonSpare_108, "130": NonSpare_306, "080": NonSpare_233, "140": NonSpare_317, "090": NonSpare_243, "210": NonSpare_407, "230": NonSpare_429, "145": NonSpare_333, "150": NonSpare_339, "151": NonSpare_344, "152": NonSpare_346, "155": NonSpare_348, "157": NonSpare_350, "160": NonSpare_353, "165": NonSpare_363, "170": NonSpare_368, "095": NonSpare_262, "032": NonSpare_123, "200": NonSpare_393, "020": NonSpare_79, "220": NonSpare_419, "146": NonSpare_335, "148": NonSpare_337, "110": NonSpare_289, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_28:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_142:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_108:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_306:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_317:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_243:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_407:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_429:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_333:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_339:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_344:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_346:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_348:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_350:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_353:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_363:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_368:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["095"]) -> NonSpare_262:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["032"]) -> NonSpare_123:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_393:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_79:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_419:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_335:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_337:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_289:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["030"], Literal["130"], Literal["080"], Literal["140"], Literal["090"], Literal["210"], Literal["230"], Literal["145"], Literal["150"], Literal["151"], Literal["152"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["170"], Literal["095"], Literal["032"], Literal["200"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_28]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_142]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_108]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_306]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_233]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_317]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_243]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_407]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_429]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_333]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_339]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_344]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_346]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_348]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_350]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_353]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_363]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_368]:
        ...
    @overload
    def get_item(self, key : Literal["095"]) -> Optional[NonSpare_262]:
        ...
    @overload
    def get_item(self, key : Literal["032"]) -> Optional[NonSpare_123]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_393]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_79]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_419]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_335]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_337]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_289]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_28_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_142_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_108_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_306_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_233_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_317_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_243_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_407_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_429_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_333_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_339_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_344_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_346_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_348_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_350_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_353_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_363_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_368_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["095"], val : NonSpare_262_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["032"], val : NonSpare_123_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_393_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_79_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_419_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_335_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_337_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_289_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_1':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["095"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["032"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_1':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_1_Arg) -> 'Record_1':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_1", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_1_Arg: TypeAlias = Record_1
class Uap_1(UapSingle):
    cv_record = Record_1

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_1]]:
        return cls._parse(bs)

class Asterix_23(AstCat):
    cv_category = 21
    cv_edition = (0, 24)
    cv_uap = Uap_1

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_1_Arg]) -> "Asterix_23":
        return cls._create(records) # type: ignore

NonSpare_318_Arg: TypeAlias = RuleVariation_282_Arg
class NonSpare_318(NonSpare):
    cv_name = "140"
    cv_title = "Geometric Altitude"
    cv_rule = RuleVariation_282

    @classmethod
    def create(cls, arg : NonSpare_318_Arg) -> "NonSpare_318":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_282:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_289:
        return self.rule.variation

class UapItem_318(UapItem):
    cv_non_spare = NonSpare_318

Record_3_Arg = TypedDict('Record_3_Arg', {
    "010": NonSpare_28_Arg,
    "040": NonSpare_142_Arg,
    "030": NonSpare_108_Arg,
    "130": NonSpare_306_Arg,
    "080": NonSpare_233_Arg,
    "140": NonSpare_318_Arg,
    "090": NonSpare_243_Arg,
    "210": NonSpare_407_Arg,
    "230": NonSpare_429_Arg,
    "145": NonSpare_333_Arg,
    "150": NonSpare_339_Arg,
    "151": NonSpare_344_Arg,
    "152": NonSpare_346_Arg,
    "155": NonSpare_348_Arg,
    "157": NonSpare_350_Arg,
    "160": NonSpare_353_Arg,
    "165": NonSpare_363_Arg,
    "170": NonSpare_368_Arg,
    "095": NonSpare_262_Arg,
    "032": NonSpare_123_Arg,
    "200": NonSpare_393_Arg,
    "020": NonSpare_79_Arg,
    "220": NonSpare_419_Arg,
    "146": NonSpare_335_Arg,
    "148": NonSpare_337_Arg,
    "110": NonSpare_289_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_3(Record):
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_28, UapItem_142, UapItem_108, UapItem_306, UapItem_233, UapItem_318, UapItem_243, UapItem_407, UapItem_429, UapItem_333, UapItem_339, UapItem_344, UapItem_346, UapItem_348, UapItem_350, UapItem_353, UapItem_363, UapItem_368, UapItem_262, UapItem_123, UapItem_393, UapItem_79, UapItem_419, UapItem_335, UapItem_337, UapItem_289, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_28, "040": NonSpare_142, "030": NonSpare_108, "130": NonSpare_306, "080": NonSpare_233, "140": NonSpare_318, "090": NonSpare_243, "210": NonSpare_407, "230": NonSpare_429, "145": NonSpare_333, "150": NonSpare_339, "151": NonSpare_344, "152": NonSpare_346, "155": NonSpare_348, "157": NonSpare_350, "160": NonSpare_353, "165": NonSpare_363, "170": NonSpare_368, "095": NonSpare_262, "032": NonSpare_123, "200": NonSpare_393, "020": NonSpare_79, "220": NonSpare_419, "146": NonSpare_335, "148": NonSpare_337, "110": NonSpare_289, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_28:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_142:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_108:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_306:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_318:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_243:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_407:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_429:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_333:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_339:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_344:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_346:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_348:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_350:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_353:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_363:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_368:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["095"]) -> NonSpare_262:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["032"]) -> NonSpare_123:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_393:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_79:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_419:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_335:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_337:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_289:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["030"], Literal["130"], Literal["080"], Literal["140"], Literal["090"], Literal["210"], Literal["230"], Literal["145"], Literal["150"], Literal["151"], Literal["152"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["170"], Literal["095"], Literal["032"], Literal["200"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_28]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_142]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_108]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_306]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_233]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_318]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_243]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_407]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_429]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_333]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_339]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_344]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_346]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_348]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_350]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_353]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_363]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_368]:
        ...
    @overload
    def get_item(self, key : Literal["095"]) -> Optional[NonSpare_262]:
        ...
    @overload
    def get_item(self, key : Literal["032"]) -> Optional[NonSpare_123]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_393]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_79]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_419]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_335]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_337]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_289]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_28_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_142_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_108_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_306_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_233_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_318_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_243_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_407_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_429_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_333_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_339_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_344_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_346_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_348_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_350_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_353_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_363_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_368_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["095"], val : NonSpare_262_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["032"], val : NonSpare_123_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_393_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_79_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_419_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_335_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_337_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_289_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_3':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["095"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["032"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_3':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_3_Arg) -> 'Record_3':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_3", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_3_Arg: TypeAlias = Record_3
class Uap_3(UapSingle):
    cv_record = Record_3

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_3]]:
        return cls._parse(bs)

class Asterix_24(AstCat):
    cv_category = 21
    cv_edition = (0, 25)
    cv_uap = Uap_3

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_3_Arg]) -> "Asterix_24":
        return cls._create(records) # type: ignore

Content_287_Arg: TypeAlias = int
class Content_287(ContentTable):
    cv_values = {0: "Mode-3/A code derived during last update", 1: "Mode-3/A code not extracted during the last update"}

RuleContent_287_Arg: TypeAlias = Content_287_Arg
class RuleContent_287(RuleContentContextFree):
    cv_content = Content_287

    @property
    def content(self) -> Content_287:
        return self._get_content() # type: ignore

Variation_549_Arg: TypeAlias = RuleContent_287_Arg
class Variation_549(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_287

    @classmethod
    def create(cls, arg : Variation_549_Arg) -> "Variation_549":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_287:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_287:
        return self.rule.content

RuleVariation_538_Arg: TypeAlias = Variation_549_Arg
class RuleVariation_538(RuleVariationContextFree):
    cv_variation = Variation_549

    @classmethod
    def create(cls, arg : RuleVariation_538_Arg) -> "RuleVariation_538":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_549:
        return self.arg # type: ignore

NonSpare_1131_Arg: TypeAlias = RuleVariation_538_Arg
class NonSpare_1131(NonSpare):
    cv_name = "L"
    cv_title = ""
    cv_rule = RuleVariation_538

    @classmethod
    def create(cls, arg : NonSpare_1131_Arg) -> "NonSpare_1131":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_538:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_549:
        return self.rule.variation

Item_449_Arg: TypeAlias = NonSpare_1131_Arg
class Item_449(Item):
    cv_non_spare = NonSpare_1131

    @classmethod
    def create(cls, arg : Item_449_Arg) -> "Item_449":
        return cls._create(arg) # type: ignore

Variation_1256_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_538_Arg, Tuple[Literal["L"], RuleVariation_538_Arg]], int, Union[RuleVariation_776_Arg, Tuple[Literal["MODE3A"], RuleVariation_776_Arg]]]
Variation_1256_Arg: TypeAlias = Union[int, Variation_1256_Arg_Group]
class Variation_1256(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1099, 1), (Item_353, 1), (Item_449, 1), (Item_16, 1), (Item_572, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "L": RuleVariation_538, "MODE3A": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_538:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_538:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1256_Arg) -> 'Variation_1256':
        return cls._create(arg) # type: ignore

RuleVariation_1186_Arg: TypeAlias = Variation_1256_Arg
class RuleVariation_1186(RuleVariationContextFree):
    cv_variation = Variation_1256

    @classmethod
    def create(cls, arg : RuleVariation_1186_Arg) -> "RuleVariation_1186":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1256:
        return self.arg # type: ignore

NonSpare_205_Arg: TypeAlias = RuleVariation_1186_Arg
class NonSpare_205(NonSpare):
    cv_name = "070"
    cv_title = "Mode 3/A Code in Octal Representation"
    cv_rule = RuleVariation_1186

    @classmethod
    def create(cls, arg : NonSpare_205_Arg) -> "NonSpare_205":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1186:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1256:
        return self.rule.variation

class UapItem_205(UapItem):
    cv_non_spare = NonSpare_205

NonSpare_312_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_312(NonSpare):
    cv_name = "131"
    cv_title = "Signal Amplitude"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_312_Arg) -> "NonSpare_312":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_312(UapItem):
    cv_non_spare = NonSpare_312

Record_2_Arg = TypedDict('Record_2_Arg', {
    "010": NonSpare_28_Arg,
    "040": NonSpare_142_Arg,
    "030": NonSpare_108_Arg,
    "130": NonSpare_306_Arg,
    "080": NonSpare_233_Arg,
    "140": NonSpare_318_Arg,
    "090": NonSpare_243_Arg,
    "210": NonSpare_407_Arg,
    "230": NonSpare_429_Arg,
    "145": NonSpare_333_Arg,
    "150": NonSpare_339_Arg,
    "151": NonSpare_344_Arg,
    "152": NonSpare_346_Arg,
    "155": NonSpare_348_Arg,
    "157": NonSpare_350_Arg,
    "160": NonSpare_353_Arg,
    "165": NonSpare_363_Arg,
    "170": NonSpare_368_Arg,
    "095": NonSpare_262_Arg,
    "032": NonSpare_123_Arg,
    "200": NonSpare_393_Arg,
    "020": NonSpare_79_Arg,
    "220": NonSpare_419_Arg,
    "146": NonSpare_335_Arg,
    "148": NonSpare_337_Arg,
    "110": NonSpare_289_Arg,
    "070": NonSpare_205_Arg,
    "131": NonSpare_312_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_2(Record):
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_28, UapItem_142, UapItem_108, UapItem_306, UapItem_233, UapItem_318, UapItem_243, UapItem_407, UapItem_429, UapItem_333, UapItem_339, UapItem_344, UapItem_346, UapItem_348, UapItem_350, UapItem_353, UapItem_363, UapItem_368, UapItem_262, UapItem_123, UapItem_393, UapItem_79, UapItem_419, UapItem_335, UapItem_337, UapItem_289, UapItem_205, UapItem_312, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_28, "040": NonSpare_142, "030": NonSpare_108, "130": NonSpare_306, "080": NonSpare_233, "140": NonSpare_318, "090": NonSpare_243, "210": NonSpare_407, "230": NonSpare_429, "145": NonSpare_333, "150": NonSpare_339, "151": NonSpare_344, "152": NonSpare_346, "155": NonSpare_348, "157": NonSpare_350, "160": NonSpare_353, "165": NonSpare_363, "170": NonSpare_368, "095": NonSpare_262, "032": NonSpare_123, "200": NonSpare_393, "020": NonSpare_79, "220": NonSpare_419, "146": NonSpare_335, "148": NonSpare_337, "110": NonSpare_289, "070": NonSpare_205, "131": NonSpare_312, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_28:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_142:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_108:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_306:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_318:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_243:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_407:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_429:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_333:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_339:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_344:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_346:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_348:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_350:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_353:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_363:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_368:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["095"]) -> NonSpare_262:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["032"]) -> NonSpare_123:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_393:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_79:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_419:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_335:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_337:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_289:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_312:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["030"], Literal["130"], Literal["080"], Literal["140"], Literal["090"], Literal["210"], Literal["230"], Literal["145"], Literal["150"], Literal["151"], Literal["152"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["170"], Literal["095"], Literal["032"], Literal["200"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["070"], Literal["131"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_28]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_142]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_108]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_306]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_233]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_318]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_243]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_407]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_429]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_333]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_339]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_344]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_346]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_348]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_350]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_353]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_363]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_368]:
        ...
    @overload
    def get_item(self, key : Literal["095"]) -> Optional[NonSpare_262]:
        ...
    @overload
    def get_item(self, key : Literal["032"]) -> Optional[NonSpare_123]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_393]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_79]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_419]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_335]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_337]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_289]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_205]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_312]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_28_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_142_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_108_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_306_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_233_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_318_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_243_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_407_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_429_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_333_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_339_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_344_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_346_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_348_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_350_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_353_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_363_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_368_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["095"], val : NonSpare_262_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["032"], val : NonSpare_123_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_393_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_79_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_419_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_335_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_337_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_289_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_205_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_312_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_2':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["095"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["032"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_2':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_2_Arg) -> 'Record_2':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_2", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_2_Arg: TypeAlias = Record_2
class Uap_2(UapSingle):
    cv_record = Record_2

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_2]]:
        return cls._parse(bs)

class Asterix_25(AstCat):
    cv_category = 21
    cv_edition = (0, 26)
    cv_uap = Uap_2

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_2_Arg]) -> "Asterix_25":
        return cls._create(records) # type: ignore

Content_733_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["hPa"]]]
class Content_733(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.1
    cv_unit = "hPa"

    def as_quantity(self, cv_unit : Optional[Literal["hPa"]] = None) -> float:
        return self._as_quantity()

RuleContent_733_Arg: TypeAlias = Content_733_Arg
class RuleContent_733(RuleContentContextFree):
    cv_content = Content_733

    @property
    def content(self) -> Content_733:
        return self._get_content() # type: ignore

Variation_809_Arg: TypeAlias = RuleContent_733_Arg
class Variation_809(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 12
    cv_rule = RuleContent_733

    @classmethod
    def create(cls, arg : Variation_809_Arg) -> "Variation_809":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_733:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_733:
        return self.rule.content

RuleVariation_779_Arg: TypeAlias = Variation_809_Arg
class RuleVariation_779(RuleVariationContextFree):
    cv_variation = Variation_809

    @classmethod
    def create(cls, arg : RuleVariation_779_Arg) -> "RuleVariation_779":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_809:
        return self.arg # type: ignore

NonSpare_685_Arg: TypeAlias = RuleVariation_779_Arg
class NonSpare_685(NonSpare):
    cv_name = "BPS"
    cv_title = "Barometric Pressure Setting"
    cv_rule = RuleVariation_779

    @classmethod
    def create(cls, arg : NonSpare_685_Arg) -> "NonSpare_685":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_779:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_809:
        return self.rule.variation

Item_129_Arg: TypeAlias = NonSpare_685_Arg
class Item_129(Item):
    cv_non_spare = NonSpare_685

    @classmethod
    def create(cls, arg : Item_129_Arg) -> "Item_129":
        return cls._create(arg) # type: ignore

Variation_1017_Arg_Group = Tuple[int, Union[RuleVariation_779_Arg, Tuple[Literal["BPS"], RuleVariation_779_Arg]]]
Variation_1017_Arg: TypeAlias = Union[int, Variation_1017_Arg_Group]
class Variation_1017(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_129, 12)]
    cv_items_dict = {"BPS": RuleVariation_779}

    @classmethod
    def spec(cls, key : Literal["BPS"]) -> RuleVariation_779:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["BPS"]) -> RuleVariation_779:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1017_Arg) -> 'Variation_1017':
        return cls._create(arg) # type: ignore

RuleVariation_987_Arg: TypeAlias = Variation_1017_Arg
class RuleVariation_987(RuleVariationContextFree):
    cv_variation = Variation_1017

    @classmethod
    def create(cls, arg : RuleVariation_987_Arg) -> "RuleVariation_987":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1017:
        return self.arg # type: ignore

NonSpare_687_Arg: TypeAlias = RuleVariation_987_Arg
class NonSpare_687(NonSpare):
    cv_name = "BPS"
    cv_title = "Barometric Pressure Setting"
    cv_rule = RuleVariation_987

    @classmethod
    def create(cls, arg : NonSpare_687_Arg) -> "NonSpare_687":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_987:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1017:
        return self.rule.variation

Content_524_Arg: TypeAlias = int
class Content_524(ContentTable):
    cv_values = {0: "True North", 1: "Magnetic North"}

RuleContent_524_Arg: TypeAlias = Content_524_Arg
class RuleContent_524(RuleContentContextFree):
    cv_content = Content_524

    @property
    def content(self) -> Content_524:
        return self._get_content() # type: ignore

Variation_755_Arg: TypeAlias = RuleContent_524_Arg
class Variation_755(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_524

    @classmethod
    def create(cls, arg : Variation_755_Arg) -> "Variation_755":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_524:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_524:
        return self.rule.content

RuleVariation_744_Arg: TypeAlias = Variation_755_Arg
class RuleVariation_744(RuleVariationContextFree):
    cv_variation = Variation_755

    @classmethod
    def create(cls, arg : RuleVariation_744_Arg) -> "RuleVariation_744":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_755:
        return self.arg # type: ignore

NonSpare_1054_Arg: TypeAlias = RuleVariation_744_Arg
class NonSpare_1054(NonSpare):
    cv_name = "HDR"
    cv_title = "Horizontal Reference Direction"
    cv_rule = RuleVariation_744

    @classmethod
    def create(cls, arg : NonSpare_1054_Arg) -> "NonSpare_1054":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_744:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_755:
        return self.rule.variation

Item_388_Arg: TypeAlias = NonSpare_1054_Arg
class Item_388(Item):
    cv_non_spare = NonSpare_1054

    @classmethod
    def create(cls, arg : Item_388_Arg) -> "Item_388":
        return cls._create(arg) # type: ignore

Content_76_Arg: TypeAlias = int
class Content_76(ContentTable):
    cv_values = {0: "Data is either unavailable or invalid", 1: "Data is available and valid"}

RuleContent_76_Arg: TypeAlias = Content_76_Arg
class RuleContent_76(RuleContentContextFree):
    cv_content = Content_76

    @property
    def content(self) -> Content_76:
        return self._get_content() # type: ignore

Variation_825_Arg: TypeAlias = RuleContent_76_Arg
class Variation_825(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_76

    @classmethod
    def create(cls, arg : Variation_825_Arg) -> "Variation_825":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_76:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_76:
        return self.rule.content

RuleVariation_795_Arg: TypeAlias = Variation_825_Arg
class RuleVariation_795(RuleVariationContextFree):
    cv_variation = Variation_825

    @classmethod
    def create(cls, arg : RuleVariation_795_Arg) -> "RuleVariation_795":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_825:
        return self.arg # type: ignore

NonSpare_1773_Arg: TypeAlias = RuleVariation_795_Arg
class NonSpare_1773(NonSpare):
    cv_name = "STAT"
    cv_title = "Selected Heading Status"
    cv_rule = RuleVariation_795

    @classmethod
    def create(cls, arg : NonSpare_1773_Arg) -> "NonSpare_1773":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_795:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_825:
        return self.rule.variation

Item_940_Arg: TypeAlias = NonSpare_1773_Arg
class Item_940(Item):
    cv_non_spare = NonSpare_1773

    @classmethod
    def create(cls, arg : Item_940_Arg) -> "Item_940":
        return cls._create(arg) # type: ignore

Content_782_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_782(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.703125
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_781_Arg: TypeAlias = Content_782_Arg
class RuleContent_781(RuleContentContextFree):
    cv_content = Content_782

    @property
    def content(self) -> Content_782:
        return self._get_content() # type: ignore

Variation_967_Arg: TypeAlias = RuleContent_781_Arg
class Variation_967(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 10
    cv_rule = RuleContent_781

    @classmethod
    def create(cls, arg : Variation_967_Arg) -> "Variation_967":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_781:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_782:
        return self.rule.content

RuleVariation_937_Arg: TypeAlias = Variation_967_Arg
class RuleVariation_937(RuleVariationContextFree):
    cv_variation = Variation_967

    @classmethod
    def create(cls, arg : RuleVariation_937_Arg) -> "RuleVariation_937":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_967:
        return self.arg # type: ignore

NonSpare_1695_Arg: TypeAlias = RuleVariation_937_Arg
class NonSpare_1695(NonSpare):
    cv_name = "SH"
    cv_title = "Selected Heading"
    cv_rule = RuleVariation_937

    @classmethod
    def create(cls, arg : NonSpare_1695_Arg) -> "NonSpare_1695":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_937:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_967:
        return self.rule.variation

Item_879_Arg: TypeAlias = NonSpare_1695_Arg
class Item_879(Item):
    cv_non_spare = NonSpare_1695

    @classmethod
    def create(cls, arg : Item_879_Arg) -> "Item_879":
        return cls._create(arg) # type: ignore

Variation_1020_Arg_Group = Tuple[int, Union[RuleVariation_744_Arg, Tuple[Literal["HDR"], RuleVariation_744_Arg]], Union[RuleVariation_795_Arg, Tuple[Literal["STAT"], RuleVariation_795_Arg]], Union[RuleVariation_937_Arg, Tuple[Literal["SH"], RuleVariation_937_Arg]]]
Variation_1020_Arg: TypeAlias = Union[int, Variation_1020_Arg_Group]
class Variation_1020(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_388, 1), (Item_940, 1), (Item_879, 10)]
    cv_items_dict = {"HDR": RuleVariation_744, "STAT": RuleVariation_795, "SH": RuleVariation_937}

    @overload
    @classmethod
    def spec(cls, key : Literal["HDR"]) -> RuleVariation_744:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_795:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SH"]) -> RuleVariation_937:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["HDR"], Literal["STAT"], Literal["SH"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["HDR"]) -> RuleVariation_744:
        ...
    @overload
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_795:
        ...
    @overload
    def get_item(self, key : Literal["SH"]) -> RuleVariation_937:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1020_Arg) -> 'Variation_1020':
        return cls._create(arg) # type: ignore

RuleVariation_989_Arg: TypeAlias = Variation_1020_Arg
class RuleVariation_989(RuleVariationContextFree):
    cv_variation = Variation_1020

    @classmethod
    def create(cls, arg : RuleVariation_989_Arg) -> "RuleVariation_989":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1020:
        return self.arg # type: ignore

NonSpare_1696_Arg: TypeAlias = RuleVariation_989_Arg
class NonSpare_1696(NonSpare):
    cv_name = "SH"
    cv_title = "Selected Heading"
    cv_rule = RuleVariation_989

    @classmethod
    def create(cls, arg : NonSpare_1696_Arg) -> "NonSpare_1696":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_989:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1020:
        return self.rule.variation

Content_42_Arg: TypeAlias = int
class Content_42(ContentTable):
    cv_values = {0: "Autopilot not engaged", 1: "Autopilot engaged"}

RuleContent_42_Arg: TypeAlias = Content_42_Arg
class RuleContent_42(RuleContentContextFree):
    cv_content = Content_42

    @property
    def content(self) -> Content_42:
        return self._get_content() # type: ignore

Variation_13_Arg: TypeAlias = RuleContent_42_Arg
class Variation_13(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_42

    @classmethod
    def create(cls, arg : Variation_13_Arg) -> "Variation_13":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_42:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_42:
        return self.rule.content

RuleVariation_13_Arg: TypeAlias = Variation_13_Arg
class RuleVariation_13(RuleVariationContextFree):
    cv_variation = Variation_13

    @classmethod
    def create(cls, arg : RuleVariation_13_Arg) -> "RuleVariation_13":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_13:
        return self.arg # type: ignore

NonSpare_609_Arg: TypeAlias = RuleVariation_13_Arg
class NonSpare_609(NonSpare):
    cv_name = "AP"
    cv_title = "Autopilot"
    cv_rule = RuleVariation_13

    @classmethod
    def create(cls, arg : NonSpare_609_Arg) -> "NonSpare_609":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_13:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_13:
        return self.rule.variation

Item_76_Arg: TypeAlias = NonSpare_609_Arg
class Item_76(Item):
    cv_non_spare = NonSpare_609

    @classmethod
    def create(cls, arg : Item_76_Arg) -> "Item_76":
        return cls._create(arg) # type: ignore

Content_559_Arg: TypeAlias = int
class Content_559(ContentTable):
    cv_values = {0: "Vertical Navigation not active", 1: "Vertical Navigation active"}

RuleContent_559_Arg: TypeAlias = Content_559_Arg
class RuleContent_559(RuleContentContextFree):
    cv_content = Content_559

    @property
    def content(self) -> Content_559:
        return self._get_content() # type: ignore

Variation_462_Arg: TypeAlias = RuleContent_559_Arg
class Variation_462(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_559

    @classmethod
    def create(cls, arg : Variation_462_Arg) -> "Variation_462":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_559:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_559:
        return self.rule.content

RuleVariation_451_Arg: TypeAlias = Variation_462_Arg
class RuleVariation_451(RuleVariationContextFree):
    cv_variation = Variation_462

    @classmethod
    def create(cls, arg : RuleVariation_451_Arg) -> "RuleVariation_451":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_462:
        return self.arg # type: ignore

NonSpare_2026_Arg: TypeAlias = RuleVariation_451_Arg
class NonSpare_2026(NonSpare):
    cv_name = "VN"
    cv_title = "Vertical Navigation"
    cv_rule = RuleVariation_451

    @classmethod
    def create(cls, arg : NonSpare_2026_Arg) -> "NonSpare_2026":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_451:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_462:
        return self.rule.variation

Item_1141_Arg: TypeAlias = NonSpare_2026_Arg
class Item_1141(Item):
    cv_non_spare = NonSpare_2026

    @classmethod
    def create(cls, arg : Item_1141_Arg) -> "Item_1141":
        return cls._create(arg) # type: ignore

Content_32_Arg: TypeAlias = int
class Content_32(ContentTable):
    cv_values = {0: "Altitude Hold not engaged", 1: "Altitude Hold engaged"}

RuleContent_32_Arg: TypeAlias = Content_32_Arg
class RuleContent_32(RuleContentContextFree):
    cv_content = Content_32

    @property
    def content(self) -> Content_32:
        return self._get_content() # type: ignore

Variation_507_Arg: TypeAlias = RuleContent_32_Arg
class Variation_507(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_32

    @classmethod
    def create(cls, arg : Variation_507_Arg) -> "Variation_507":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_32:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_32:
        return self.rule.content

RuleVariation_496_Arg: TypeAlias = Variation_507_Arg
class RuleVariation_496(RuleVariationContextFree):
    cv_variation = Variation_507

    @classmethod
    def create(cls, arg : RuleVariation_496_Arg) -> "RuleVariation_496":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_507:
        return self.arg # type: ignore

NonSpare_578_Arg: TypeAlias = RuleVariation_496_Arg
class NonSpare_578(NonSpare):
    cv_name = "AH"
    cv_title = "Altitude Hold"
    cv_rule = RuleVariation_496

    @classmethod
    def create(cls, arg : NonSpare_578_Arg) -> "NonSpare_578":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_496:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_507:
        return self.rule.variation

Item_52_Arg: TypeAlias = NonSpare_578_Arg
class Item_52(Item):
    cv_non_spare = NonSpare_578

    @classmethod
    def create(cls, arg : Item_52_Arg) -> "Item_52":
        return cls._create(arg) # type: ignore

Content_35_Arg: TypeAlias = int
class Content_35(ContentTable):
    cv_values = {0: "Approach Mode not active", 1: "Approach Mode active"}

RuleContent_35_Arg: TypeAlias = Content_35_Arg
class RuleContent_35(RuleContentContextFree):
    cv_content = Content_35

    @property
    def content(self) -> Content_35:
        return self._get_content() # type: ignore

Variation_614_Arg: TypeAlias = RuleContent_35_Arg
class Variation_614(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_35

    @classmethod
    def create(cls, arg : Variation_614_Arg) -> "Variation_614":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_35:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_35:
        return self.rule.content

RuleVariation_603_Arg: TypeAlias = Variation_614_Arg
class RuleVariation_603(RuleVariationContextFree):
    cv_variation = Variation_614

    @classmethod
    def create(cls, arg : RuleVariation_603_Arg) -> "RuleVariation_603":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_614:
        return self.arg # type: ignore

NonSpare_601_Arg: TypeAlias = RuleVariation_603_Arg
class NonSpare_601(NonSpare):
    cv_name = "AM"
    cv_title = "Approach Mode"
    cv_rule = RuleVariation_603

    @classmethod
    def create(cls, arg : NonSpare_601_Arg) -> "NonSpare_601":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_603:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_614:
        return self.rule.variation

Item_70_Arg: TypeAlias = NonSpare_601_Arg
class Item_70(Item):
    cv_non_spare = NonSpare_601

    @classmethod
    def create(cls, arg : Item_70_Arg) -> "Item_70":
        return cls._create(arg) # type: ignore

Variation_1049_Arg_Group = Tuple[Union[RuleVariation_13_Arg, Tuple[Literal["AP"], RuleVariation_13_Arg]], Union[RuleVariation_451_Arg, Tuple[Literal["VN"], RuleVariation_451_Arg]], Union[RuleVariation_496_Arg, Tuple[Literal["AH"], RuleVariation_496_Arg]], Union[RuleVariation_603_Arg, Tuple[Literal["AM"], RuleVariation_603_Arg]], int]
Variation_1049_Arg: TypeAlias = Union[int, Variation_1049_Arg_Group]
class Variation_1049(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_76, 1), (Item_1141, 1), (Item_52, 1), (Item_70, 1), (Item_22, 4)]
    cv_items_dict = {"AP": RuleVariation_13, "VN": RuleVariation_451, "AH": RuleVariation_496, "AM": RuleVariation_603}

    @overload
    @classmethod
    def spec(cls, key : Literal["AP"]) -> RuleVariation_13:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VN"]) -> RuleVariation_451:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AH"]) -> RuleVariation_496:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AM"]) -> RuleVariation_603:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AP"], Literal["VN"], Literal["AH"], Literal["AM"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AP"]) -> RuleVariation_13:
        ...
    @overload
    def get_item(self, key : Literal["VN"]) -> RuleVariation_451:
        ...
    @overload
    def get_item(self, key : Literal["AH"]) -> RuleVariation_496:
        ...
    @overload
    def get_item(self, key : Literal["AM"]) -> RuleVariation_603:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1049_Arg) -> 'Variation_1049':
        return cls._create(arg) # type: ignore

RuleVariation_1016_Arg: TypeAlias = Variation_1049_Arg
class RuleVariation_1016(RuleVariationContextFree):
    cv_variation = Variation_1049

    @classmethod
    def create(cls, arg : RuleVariation_1016_Arg) -> "RuleVariation_1016":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1049:
        return self.arg # type: ignore

NonSpare_1337_Arg: TypeAlias = RuleVariation_1016_Arg
class NonSpare_1337(NonSpare):
    cv_name = "NAV"
    cv_title = "Navigation Mode"
    cv_rule = RuleVariation_1016

    @classmethod
    def create(cls, arg : NonSpare_1337_Arg) -> "NonSpare_1337":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1016:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1049:
        return self.rule.variation

NonSpare_1014_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_1014(NonSpare):
    cv_name = "GAO"
    cv_title = "GPS Antenna Offset"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_1014_Arg) -> "NonSpare_1014":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Content_27_Arg: TypeAlias = int
class Content_27(ContentTable):
    cv_values = {0: "Aircraft has not stopped", 1: "Aircraft has stopped"}

RuleContent_27_Arg: TypeAlias = Content_27_Arg
class RuleContent_27(RuleContentContextFree):
    cv_content = Content_27

    @property
    def content(self) -> Content_27:
        return self._get_content() # type: ignore

Variation_9_Arg: TypeAlias = RuleContent_27_Arg
class Variation_9(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_27

    @classmethod
    def create(cls, arg : Variation_9_Arg) -> "Variation_9":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_27:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_27:
        return self.rule.content

RuleVariation_9_Arg: TypeAlias = Variation_9_Arg
class RuleVariation_9(RuleVariationContextFree):
    cv_variation = Variation_9

    @classmethod
    def create(cls, arg : RuleVariation_9_Arg) -> "RuleVariation_9":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_9:
        return self.arg # type: ignore

Content_223_Arg: TypeAlias = int
class Content_223(ContentTable):
    cv_values = {0: "Heading/Ground Track data is not valid", 1: "Heading/Ground Track data is valid"}

RuleContent_223_Arg: TypeAlias = Content_223_Arg
class RuleContent_223(RuleContentContextFree):
    cv_content = Content_223

    @property
    def content(self) -> Content_223:
        return self._get_content() # type: ignore

Variation_428_Arg: TypeAlias = RuleContent_223_Arg
class Variation_428(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_223

    @classmethod
    def create(cls, arg : Variation_428_Arg) -> "Variation_428":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_223:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_223:
        return self.rule.content

RuleVariation_417_Arg: TypeAlias = Variation_428_Arg
class RuleVariation_417(RuleVariationContextFree):
    cv_variation = Variation_428

    @classmethod
    def create(cls, arg : RuleVariation_417_Arg) -> "RuleVariation_417":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_428:
        return self.arg # type: ignore

Content_222_Arg: TypeAlias = int
class Content_222(ContentTable):
    cv_values = {0: "Heading data provided", 1: "Ground Track provided"}

RuleContent_222_Arg: TypeAlias = Content_222_Arg
class RuleContent_222(RuleContentContextFree):
    cv_content = Content_222

    @property
    def content(self) -> Content_222:
        return self._get_content() # type: ignore

Variation_533_Arg: TypeAlias = RuleContent_222_Arg
class Variation_533(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_222

    @classmethod
    def create(cls, arg : Variation_533_Arg) -> "Variation_533":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_222:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_222:
        return self.rule.content

RuleVariation_522_Arg: TypeAlias = Variation_533_Arg
class RuleVariation_522(RuleVariationContextFree):
    cv_variation = Variation_533

    @classmethod
    def create(cls, arg : RuleVariation_522_Arg) -> "RuleVariation_522":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_533:
        return self.arg # type: ignore

Variation_667_Arg: TypeAlias = RuleContent_524_Arg
class Variation_667(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_524

    @classmethod
    def create(cls, arg : Variation_667_Arg) -> "Variation_667":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_524:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_524:
        return self.rule.content

RuleVariation_656_Arg: TypeAlias = Variation_667_Arg
class RuleVariation_656(RuleVariationContextFree):
    cv_variation = Variation_667

    @classmethod
    def create(cls, arg : RuleVariation_656_Arg) -> "RuleVariation_656":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_667:
        return self.arg # type: ignore

Content_759_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["kt"]]]
class Content_759(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.125
    cv_unit = "kt"

    def as_quantity(self, cv_unit : Optional[Literal["kt"]] = None) -> float:
        return self._as_quantity()

RuleContent_758_Arg: TypeAlias = Content_759_Arg
class RuleContent_758(RuleContentContextFree):
    cv_content = Content_759

    @property
    def content(self) -> Content_759:
        return self._get_content() # type: ignore

Variation_804_Arg: TypeAlias = RuleContent_758_Arg
class Variation_804(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 11
    cv_rule = RuleContent_758

    @classmethod
    def create(cls, arg : Variation_804_Arg) -> "Variation_804":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_758:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_759:
        return self.rule.content

RuleVariation_774_Arg: TypeAlias = Variation_804_Arg
class RuleVariation_774(RuleVariationContextFree):
    cv_variation = Variation_804

    @classmethod
    def create(cls, arg : RuleVariation_774_Arg) -> "RuleVariation_774":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_804:
        return self.arg # type: ignore

Content_781_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_781(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 2.8125
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_780_Arg: TypeAlias = Content_781_Arg
class RuleContent_780(RuleContentContextFree):
    cv_content = Content_781

    @property
    def content(self) -> Content_781:
        return self._get_content() # type: ignore

Variation_162_Arg: TypeAlias = RuleContent_780_Arg
class Variation_162(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_780

    @classmethod
    def create(cls, arg : Variation_162_Arg) -> "Variation_162":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_780:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_781:
        return self.rule.content

RuleVariation_156_Arg: TypeAlias = Variation_162_Arg
class RuleVariation_156(RuleVariationContextFree):
    cv_variation = Variation_162

    @classmethod
    def create(cls, arg : RuleVariation_156_Arg) -> "RuleVariation_156":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_162:
        return self.arg # type: ignore

NonSpare_1786_Arg: TypeAlias = RuleVariation_9_Arg
class NonSpare_1786(NonSpare):
    cv_name = "STP"
    cv_title = ""
    cv_rule = RuleVariation_9

    @classmethod
    def create(cls, arg : NonSpare_1786_Arg) -> "NonSpare_1786":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_9:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_9:
        return self.rule.variation

Item_952_Arg: TypeAlias = NonSpare_1786_Arg
class Item_952(Item):
    cv_non_spare = NonSpare_1786

    @classmethod
    def create(cls, arg : Item_952_Arg) -> "Item_952":
        return cls._create(arg) # type: ignore

NonSpare_1074_Arg: TypeAlias = RuleVariation_417_Arg
class NonSpare_1074(NonSpare):
    cv_name = "HTS"
    cv_title = ""
    cv_rule = RuleVariation_417

    @classmethod
    def create(cls, arg : NonSpare_1074_Arg) -> "NonSpare_1074":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_417:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_428:
        return self.rule.variation

Item_403_Arg: TypeAlias = NonSpare_1074_Arg
class Item_403(Item):
    cv_non_spare = NonSpare_1074

    @classmethod
    def create(cls, arg : Item_403_Arg) -> "Item_403":
        return cls._create(arg) # type: ignore

NonSpare_1075_Arg: TypeAlias = RuleVariation_522_Arg
class NonSpare_1075(NonSpare):
    cv_name = "HTT"
    cv_title = ""
    cv_rule = RuleVariation_522

    @classmethod
    def create(cls, arg : NonSpare_1075_Arg) -> "NonSpare_1075":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_522:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_533:
        return self.rule.variation

Item_404_Arg: TypeAlias = NonSpare_1075_Arg
class Item_404(Item):
    cv_non_spare = NonSpare_1075

    @classmethod
    def create(cls, arg : Item_404_Arg) -> "Item_404":
        return cls._create(arg) # type: ignore

NonSpare_1073_Arg: TypeAlias = RuleVariation_656_Arg
class NonSpare_1073(NonSpare):
    cv_name = "HRD"
    cv_title = ""
    cv_rule = RuleVariation_656

    @classmethod
    def create(cls, arg : NonSpare_1073_Arg) -> "NonSpare_1073":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_656:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_667:
        return self.rule.variation

Item_402_Arg: TypeAlias = NonSpare_1073_Arg
class Item_402(Item):
    cv_non_spare = NonSpare_1073

    @classmethod
    def create(cls, arg : Item_402_Arg) -> "Item_402":
        return cls._create(arg) # type: ignore

NonSpare_1036_Arg: TypeAlias = RuleVariation_774_Arg
class NonSpare_1036(NonSpare):
    cv_name = "GSS"
    cv_title = "Ground Speed"
    cv_rule = RuleVariation_774

    @classmethod
    def create(cls, arg : NonSpare_1036_Arg) -> "NonSpare_1036":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_774:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_804:
        return self.rule.variation

Item_375_Arg: TypeAlias = NonSpare_1036_Arg
class Item_375(Item):
    cv_non_spare = NonSpare_1036

    @classmethod
    def create(cls, arg : Item_375_Arg) -> "Item_375":
        return cls._create(arg) # type: ignore

NonSpare_1059_Arg: TypeAlias = RuleVariation_156_Arg
class NonSpare_1059(NonSpare):
    cv_name = "HGT"
    cv_title = "Heading/Ground Track Information"
    cv_rule = RuleVariation_156

    @classmethod
    def create(cls, arg : NonSpare_1059_Arg) -> "NonSpare_1059":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_156:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_162:
        return self.rule.variation

Item_391_Arg: TypeAlias = NonSpare_1059_Arg
class Item_391(Item):
    cv_non_spare = NonSpare_1059

    @classmethod
    def create(cls, arg : Item_391_Arg) -> "Item_391":
        return cls._create(arg) # type: ignore

Variation_1377_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_9_Arg, Tuple[Literal["STP"], RuleVariation_9_Arg]], Union[RuleVariation_417_Arg, Tuple[Literal["HTS"], RuleVariation_417_Arg]], Union[RuleVariation_522_Arg, Tuple[Literal["HTT"], RuleVariation_522_Arg]], Union[RuleVariation_656_Arg, Tuple[Literal["HRD"], RuleVariation_656_Arg]], Union[RuleVariation_774_Arg, Tuple[Literal["GSS"], RuleVariation_774_Arg]], None]]
Variation_1377_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_156_Arg, Tuple[Literal["HGT"], RuleVariation_156_Arg]], None]]
Variation_1377_Arg: TypeAlias = Union[
    Tuple[Variation_1377_Arg_Group_1],
    Tuple[Variation_1377_Arg_Group_1, Variation_1377_Arg_Group_2],
]
class Variation_1377(Extended):
    cv_items_list = [[(Item_952, 1), (Item_403, 1), (Item_404, 1), (Item_402, 1), (Item_375, 11), None], [(Item_391, 7), None]]

    @classmethod
    def create(cls, arg : Variation_1377_Arg) -> 'Variation_1377':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["STP"]) -> RuleVariation_9:
        ...
    @overload
    def get_item(self, key : Literal["HTS"]) -> RuleVariation_417:
        ...
    @overload
    def get_item(self, key : Literal["HTT"]) -> RuleVariation_522:
        ...
    @overload
    def get_item(self, key : Literal["HRD"]) -> RuleVariation_656:
        ...
    @overload
    def get_item(self, key : Literal["GSS"]) -> RuleVariation_774:
        ...
    @overload
    def get_item(self, key : Literal["HGT"]) -> Optional[RuleVariation_156]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1300_Arg: TypeAlias = Variation_1377_Arg
class RuleVariation_1300(RuleVariationContextFree):
    cv_variation = Variation_1377

    @classmethod
    def create(cls, arg : RuleVariation_1300_Arg) -> "RuleVariation_1300":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1377:
        return self.arg # type: ignore

NonSpare_1694_Arg: TypeAlias = RuleVariation_1300_Arg
class NonSpare_1694(NonSpare):
    cv_name = "SGV"
    cv_title = "Surface Ground Vector"
    cv_rule = RuleVariation_1300

    @classmethod
    def create(cls, arg : NonSpare_1694_Arg) -> "NonSpare_1694":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1300:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1377:
        return self.rule.variation

Content_477_Arg: TypeAlias = int
class Content_477(ContentTable):
    cv_values = {0: "Target is not 1090 ES IN capable", 1: "Target is 1090 ES IN capable"}

RuleContent_477_Arg: TypeAlias = Content_477_Arg
class RuleContent_477(RuleContentContextFree):
    cv_content = Content_477

    @property
    def content(self) -> Content_477:
        return self._get_content() # type: ignore

Variation_81_Arg: TypeAlias = RuleContent_477_Arg
class Variation_81(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_477

    @classmethod
    def create(cls, arg : Variation_81_Arg) -> "Variation_81":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_477:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_477:
        return self.rule.content

RuleVariation_81_Arg: TypeAlias = Variation_81_Arg
class RuleVariation_81(RuleVariationContextFree):
    cv_variation = Variation_81

    @classmethod
    def create(cls, arg : RuleVariation_81_Arg) -> "RuleVariation_81":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_81:
        return self.arg # type: ignore

Content_478_Arg: TypeAlias = int
class Content_478(ContentTable):
    cv_values = {0: "Target is not UAT IN capable", 1: "Target is UAT IN capable"}

RuleContent_478_Arg: TypeAlias = Content_478_Arg
class RuleContent_478(RuleContentContextFree):
    cv_content = Content_478

    @property
    def content(self) -> Content_478:
        return self._get_content() # type: ignore

Variation_451_Arg: TypeAlias = RuleContent_478_Arg
class Variation_451(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_478

    @classmethod
    def create(cls, arg : Variation_451_Arg) -> "Variation_451":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_478:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_478:
        return self.rule.content

RuleVariation_440_Arg: TypeAlias = Variation_451_Arg
class RuleVariation_440(RuleVariationContextFree):
    cv_variation = Variation_451

    @classmethod
    def create(cls, arg : RuleVariation_440_Arg) -> "RuleVariation_440":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_451:
        return self.arg # type: ignore

NonSpare_953_Arg: TypeAlias = RuleVariation_81_Arg
class NonSpare_953(NonSpare):
    cv_name = "ES"
    cv_title = ""
    cv_rule = RuleVariation_81

    @classmethod
    def create(cls, arg : NonSpare_953_Arg) -> "NonSpare_953":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_81:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_81:
        return self.rule.variation

Item_318_Arg: TypeAlias = NonSpare_953_Arg
class Item_318(Item):
    cv_non_spare = NonSpare_953

    @classmethod
    def create(cls, arg : Item_318_Arg) -> "Item_318":
        return cls._create(arg) # type: ignore

NonSpare_1967_Arg: TypeAlias = RuleVariation_440_Arg
class NonSpare_1967(NonSpare):
    cv_name = "UAT"
    cv_title = ""
    cv_rule = RuleVariation_440

    @classmethod
    def create(cls, arg : NonSpare_1967_Arg) -> "NonSpare_1967":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_440:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_451:
        return self.rule.variation

Item_1086_Arg: TypeAlias = NonSpare_1967_Arg
class Item_1086(Item):
    cv_non_spare = NonSpare_1967

    @classmethod
    def create(cls, arg : Item_1086_Arg) -> "Item_1086":
        return cls._create(arg) # type: ignore

Variation_1349_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_81_Arg, Tuple[Literal["ES"], RuleVariation_81_Arg]], Union[RuleVariation_440_Arg, Tuple[Literal["UAT"], RuleVariation_440_Arg]], int, None]]
Variation_1349_Arg: TypeAlias = Union[
    Tuple[Variation_1349_Arg_Group_1],
]
class Variation_1349(Extended):
    cv_items_list = [[(Item_318, 1), (Item_1086, 1), (Item_14, 5), None]]

    @classmethod
    def create(cls, arg : Variation_1349_Arg) -> 'Variation_1349':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["ES"]) -> RuleVariation_81:
        ...
    @overload
    def get_item(self, key : Literal["UAT"]) -> RuleVariation_440:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1272_Arg: TypeAlias = Variation_1349_Arg
class RuleVariation_1272(RuleVariationContextFree):
    cv_variation = Variation_1349

    @classmethod
    def create(cls, arg : RuleVariation_1272_Arg) -> "RuleVariation_1272":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1349:
        return self.arg # type: ignore

NonSpare_1760_Arg: TypeAlias = RuleVariation_1272_Arg
class NonSpare_1760(NonSpare):
    cv_name = "STA"
    cv_title = "Aircraft Status"
    cv_rule = RuleVariation_1272

    @classmethod
    def create(cls, arg : NonSpare_1760_Arg) -> "NonSpare_1760":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1272:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1349:
        return self.rule.variation

NonSpare_1869_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_1869(NonSpare):
    cv_name = "TNH"
    cv_title = "True North Heading"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_1869_Arg) -> "NonSpare_1869":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Content_311_Arg: TypeAlias = int
class Content_311(ContentTable):
    cv_values = {0: "No Mode 5 interrogation", 1: "Mode 5 interrogation"}

RuleContent_311_Arg: TypeAlias = Content_311_Arg
class RuleContent_311(RuleContentContextFree):
    cv_content = Content_311

    @property
    def content(self) -> Content_311:
        return self._get_content() # type: ignore

Variation_56_Arg: TypeAlias = RuleContent_311_Arg
class Variation_56(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_311

    @classmethod
    def create(cls, arg : Variation_56_Arg) -> "Variation_56":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_311:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_311:
        return self.rule.content

RuleVariation_56_Arg: TypeAlias = Variation_56_Arg
class RuleVariation_56(RuleVariationContextFree):
    cv_variation = Variation_56

    @classmethod
    def create(cls, arg : RuleVariation_56_Arg) -> "RuleVariation_56":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_56:
        return self.arg # type: ignore

NonSpare_1209_Arg: TypeAlias = RuleVariation_56_Arg
class NonSpare_1209(NonSpare):
    cv_name = "M5"
    cv_title = ""
    cv_rule = RuleVariation_56

    @classmethod
    def create(cls, arg : NonSpare_1209_Arg) -> "NonSpare_1209":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_56:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_56:
        return self.rule.variation

Item_518_Arg: TypeAlias = NonSpare_1209_Arg
class Item_518(Item):
    cv_non_spare = NonSpare_1209

    @classmethod
    def create(cls, arg : Item_518_Arg) -> "Item_518":
        return cls._create(arg) # type: ignore

Content_327_Arg: TypeAlias = int
class Content_327(ContentTable):
    cv_values = {0: "No authenticated Mode 5 ID reply/report", 1: "Authenticated Mode 5 ID reply/report"}

RuleContent_327_Arg: TypeAlias = Content_327_Arg
class RuleContent_327(RuleContentContextFree):
    cv_content = Content_327

    @property
    def content(self) -> Content_327:
        return self._get_content() # type: ignore

Variation_440_Arg: TypeAlias = RuleContent_327_Arg
class Variation_440(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_327

    @classmethod
    def create(cls, arg : Variation_440_Arg) -> "Variation_440":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_327:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_327:
        return self.rule.content

RuleVariation_429_Arg: TypeAlias = Variation_440_Arg
class RuleVariation_429(RuleVariationContextFree):
    cv_variation = Variation_440

    @classmethod
    def create(cls, arg : RuleVariation_429_Arg) -> "RuleVariation_429":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_440:
        return self.arg # type: ignore

NonSpare_1102_Arg: TypeAlias = RuleVariation_429_Arg
class NonSpare_1102(NonSpare):
    cv_name = "ID"
    cv_title = ""
    cv_rule = RuleVariation_429

    @classmethod
    def create(cls, arg : NonSpare_1102_Arg) -> "NonSpare_1102":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_429:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_440:
        return self.rule.variation

Item_426_Arg: TypeAlias = NonSpare_1102_Arg
class Item_426(Item):
    cv_non_spare = NonSpare_1102

    @classmethod
    def create(cls, arg : Item_426_Arg) -> "Item_426":
        return cls._create(arg) # type: ignore

Content_324_Arg: TypeAlias = int
class Content_324(ContentTable):
    cv_values = {0: "No authenticated Mode 5 Data reply or Report", 1: "Authenticated Mode 5 Data reply or Report (i.e any valid Mode 5 reply type other than ID)"}

RuleContent_324_Arg: TypeAlias = Content_324_Arg
class RuleContent_324(RuleContentContextFree):
    cv_content = Content_324

    @property
    def content(self) -> Content_324:
        return self._get_content() # type: ignore

Variation_557_Arg: TypeAlias = RuleContent_324_Arg
class Variation_557(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_324

    @classmethod
    def create(cls, arg : Variation_557_Arg) -> "Variation_557":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_324:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_324:
        return self.rule.content

RuleVariation_546_Arg: TypeAlias = Variation_557_Arg
class RuleVariation_546(RuleVariationContextFree):
    cv_variation = Variation_557

    @classmethod
    def create(cls, arg : RuleVariation_546_Arg) -> "RuleVariation_546":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_557:
        return self.arg # type: ignore

NonSpare_849_Arg: TypeAlias = RuleVariation_546_Arg
class NonSpare_849(NonSpare):
    cv_name = "DA"
    cv_title = ""
    cv_rule = RuleVariation_546

    @classmethod
    def create(cls, arg : NonSpare_849_Arg) -> "NonSpare_849":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_546:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_557:
        return self.rule.variation

Item_235_Arg: TypeAlias = NonSpare_849_Arg
class Item_235(Item):
    cv_non_spare = NonSpare_849

    @classmethod
    def create(cls, arg : Item_235_Arg) -> "Item_235":
        return cls._create(arg) # type: ignore

Content_272_Arg: TypeAlias = int
class Content_272(ContentTable):
    cv_values = {0: "Mode 1 code not present or not from Mode 5 reply/report", 1: "Mode 1 code from Mode 5 reply/report"}

RuleContent_272_Arg: TypeAlias = Content_272_Arg
class RuleContent_272(RuleContentContextFree):
    cv_content = Content_272

    @property
    def content(self) -> Content_272:
        return self._get_content() # type: ignore

Variation_644_Arg: TypeAlias = RuleContent_272_Arg
class Variation_644(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_272

    @classmethod
    def create(cls, arg : Variation_644_Arg) -> "Variation_644":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_272:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_272:
        return self.rule.content

RuleVariation_633_Arg: TypeAlias = Variation_644_Arg
class RuleVariation_633(RuleVariationContextFree):
    cv_variation = Variation_644

    @classmethod
    def create(cls, arg : RuleVariation_633_Arg) -> "RuleVariation_633":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_644:
        return self.arg # type: ignore

NonSpare_1197_Arg: TypeAlias = RuleVariation_633_Arg
class NonSpare_1197(NonSpare):
    cv_name = "M1"
    cv_title = ""
    cv_rule = RuleVariation_633

    @classmethod
    def create(cls, arg : NonSpare_1197_Arg) -> "NonSpare_1197":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_633:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_644:
        return self.rule.variation

Item_511_Arg: TypeAlias = NonSpare_1197_Arg
class Item_511(Item):
    cv_non_spare = NonSpare_1197

    @classmethod
    def create(cls, arg : Item_511_Arg) -> "Item_511":
        return cls._create(arg) # type: ignore

Content_274_Arg: TypeAlias = int
class Content_274(ContentTable):
    cv_values = {0: "Mode 2 code not present or not from Mode 5 reply/report", 1: "Mode 2 code from Mode 5 reply/report"}

RuleContent_274_Arg: TypeAlias = Content_274_Arg
class RuleContent_274(RuleContentContextFree):
    cv_content = Content_274

    @property
    def content(self) -> Content_274:
        return self._get_content() # type: ignore

Variation_731_Arg: TypeAlias = RuleContent_274_Arg
class Variation_731(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_274

    @classmethod
    def create(cls, arg : Variation_731_Arg) -> "Variation_731":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_274:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_274:
        return self.rule.content

RuleVariation_720_Arg: TypeAlias = Variation_731_Arg
class RuleVariation_720(RuleVariationContextFree):
    cv_variation = Variation_731

    @classmethod
    def create(cls, arg : RuleVariation_720_Arg) -> "RuleVariation_720":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_731:
        return self.arg # type: ignore

NonSpare_1199_Arg: TypeAlias = RuleVariation_720_Arg
class NonSpare_1199(NonSpare):
    cv_name = "M2"
    cv_title = ""
    cv_rule = RuleVariation_720

    @classmethod
    def create(cls, arg : NonSpare_1199_Arg) -> "NonSpare_1199":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_720:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_731:
        return self.rule.variation

Item_513_Arg: TypeAlias = NonSpare_1199_Arg
class Item_513(Item):
    cv_non_spare = NonSpare_1199

    @classmethod
    def create(cls, arg : Item_513_Arg) -> "Item_513":
        return cls._create(arg) # type: ignore

Content_276_Arg: TypeAlias = int
class Content_276(ContentTable):
    cv_values = {0: "Mode 3 code not present or not from Mode 5 reply/report", 1: "Mode 3 code from Mode 5 reply/report"}

RuleContent_276_Arg: TypeAlias = Content_276_Arg
class RuleContent_276(RuleContentContextFree):
    cv_content = Content_276

    @property
    def content(self) -> Content_276:
        return self._get_content() # type: ignore

Variation_858_Arg: TypeAlias = RuleContent_276_Arg
class Variation_858(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_276

    @classmethod
    def create(cls, arg : Variation_858_Arg) -> "Variation_858":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_276:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_276:
        return self.rule.content

RuleVariation_828_Arg: TypeAlias = Variation_858_Arg
class RuleVariation_828(RuleVariationContextFree):
    cv_variation = Variation_858

    @classmethod
    def create(cls, arg : RuleVariation_828_Arg) -> "RuleVariation_828":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_858:
        return self.arg # type: ignore

NonSpare_1203_Arg: TypeAlias = RuleVariation_828_Arg
class NonSpare_1203(NonSpare):
    cv_name = "M3"
    cv_title = ""
    cv_rule = RuleVariation_828

    @classmethod
    def create(cls, arg : NonSpare_1203_Arg) -> "NonSpare_1203":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_828:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_858:
        return self.rule.variation

Item_516_Arg: TypeAlias = NonSpare_1203_Arg
class Item_516(Item):
    cv_non_spare = NonSpare_1203

    @classmethod
    def create(cls, arg : Item_516_Arg) -> "Item_516":
        return cls._create(arg) # type: ignore

Content_213_Arg: TypeAlias = int
class Content_213(ContentTable):
    cv_values = {0: "Flightlevel not present or not from Mode 5 reply/report", 1: "Flightlevel from Mode 5 reply/report"}

RuleContent_213_Arg: TypeAlias = Content_213_Arg
class RuleContent_213(RuleContentContextFree):
    cv_content = Content_213

    @property
    def content(self) -> Content_213:
        return self._get_content() # type: ignore

Variation_925_Arg: TypeAlias = RuleContent_213_Arg
class Variation_925(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_213

    @classmethod
    def create(cls, arg : Variation_925_Arg) -> "Variation_925":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_213:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_213:
        return self.rule.content

RuleVariation_895_Arg: TypeAlias = Variation_925_Arg
class RuleVariation_895(RuleVariationContextFree):
    cv_variation = Variation_925

    @classmethod
    def create(cls, arg : RuleVariation_895_Arg) -> "RuleVariation_895":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_925:
        return self.arg # type: ignore

NonSpare_1228_Arg: TypeAlias = RuleVariation_895_Arg
class NonSpare_1228(NonSpare):
    cv_name = "MC"
    cv_title = ""
    cv_rule = RuleVariation_895

    @classmethod
    def create(cls, arg : NonSpare_1228_Arg) -> "NonSpare_1228":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_895:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_925:
        return self.rule.variation

Item_530_Arg: TypeAlias = NonSpare_1228_Arg
class Item_530(Item):
    cv_non_spare = NonSpare_1228

    @classmethod
    def create(cls, arg : Item_530_Arg) -> "Item_530":
        return cls._create(arg) # type: ignore

Content_427_Arg: TypeAlias = int
class Content_427(ContentTable):
    cv_values = {0: "Position not from Mode 5 report (ADS-B report)", 1: "Position from Mode 5 report"}

RuleContent_427_Arg: TypeAlias = Content_427_Arg
class RuleContent_427(RuleContentContextFree):
    cv_content = Content_427

    @property
    def content(self) -> Content_427:
        return self._get_content() # type: ignore

Variation_984_Arg: TypeAlias = RuleContent_427_Arg
class Variation_984(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_427

    @classmethod
    def create(cls, arg : Variation_984_Arg) -> "Variation_984":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_427:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_427:
        return self.rule.content

RuleVariation_954_Arg: TypeAlias = Variation_984_Arg
class RuleVariation_954(RuleVariationContextFree):
    cv_variation = Variation_984

    @classmethod
    def create(cls, arg : RuleVariation_954_Arg) -> "RuleVariation_954":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_984:
        return self.arg # type: ignore

NonSpare_1429_Arg: TypeAlias = RuleVariation_954_Arg
class NonSpare_1429(NonSpare):
    cv_name = "PO"
    cv_title = ""
    cv_rule = RuleVariation_954

    @classmethod
    def create(cls, arg : NonSpare_1429_Arg) -> "NonSpare_1429":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_954:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_984:
        return self.rule.variation

Item_684_Arg: TypeAlias = NonSpare_1429_Arg
class Item_684(Item):
    cv_non_spare = NonSpare_1429

    @classmethod
    def create(cls, arg : Item_684_Arg) -> "Item_684":
        return cls._create(arg) # type: ignore

Variation_1134_Arg_Group = Tuple[Union[RuleVariation_56_Arg, Tuple[Literal["M5"], RuleVariation_56_Arg]], Union[RuleVariation_429_Arg, Tuple[Literal["ID"], RuleVariation_429_Arg]], Union[RuleVariation_546_Arg, Tuple[Literal["DA"], RuleVariation_546_Arg]], Union[RuleVariation_633_Arg, Tuple[Literal["M1"], RuleVariation_633_Arg]], Union[RuleVariation_720_Arg, Tuple[Literal["M2"], RuleVariation_720_Arg]], Union[RuleVariation_828_Arg, Tuple[Literal["M3"], RuleVariation_828_Arg]], Union[RuleVariation_895_Arg, Tuple[Literal["MC"], RuleVariation_895_Arg]], Union[RuleVariation_954_Arg, Tuple[Literal["PO"], RuleVariation_954_Arg]]]
Variation_1134_Arg: TypeAlias = Union[int, Variation_1134_Arg_Group]
class Variation_1134(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_518, 1), (Item_426, 1), (Item_235, 1), (Item_511, 1), (Item_513, 1), (Item_516, 1), (Item_530, 1), (Item_684, 1)]
    cv_items_dict = {"M5": RuleVariation_56, "ID": RuleVariation_429, "DA": RuleVariation_546, "M1": RuleVariation_633, "M2": RuleVariation_720, "M3": RuleVariation_828, "MC": RuleVariation_895, "PO": RuleVariation_954}

    @overload
    @classmethod
    def spec(cls, key : Literal["M5"]) -> RuleVariation_56:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ID"]) -> RuleVariation_429:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DA"]) -> RuleVariation_546:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M1"]) -> RuleVariation_633:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M2"]) -> RuleVariation_720:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M3"]) -> RuleVariation_828:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MC"]) -> RuleVariation_895:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PO"]) -> RuleVariation_954:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["M5"], Literal["ID"], Literal["DA"], Literal["M1"], Literal["M2"], Literal["M3"], Literal["MC"], Literal["PO"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["M5"]) -> RuleVariation_56:
        ...
    @overload
    def get_item(self, key : Literal["ID"]) -> RuleVariation_429:
        ...
    @overload
    def get_item(self, key : Literal["DA"]) -> RuleVariation_546:
        ...
    @overload
    def get_item(self, key : Literal["M1"]) -> RuleVariation_633:
        ...
    @overload
    def get_item(self, key : Literal["M2"]) -> RuleVariation_720:
        ...
    @overload
    def get_item(self, key : Literal["M3"]) -> RuleVariation_828:
        ...
    @overload
    def get_item(self, key : Literal["MC"]) -> RuleVariation_895:
        ...
    @overload
    def get_item(self, key : Literal["PO"]) -> RuleVariation_954:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1134_Arg) -> 'Variation_1134':
        return cls._create(arg) # type: ignore

RuleVariation_1091_Arg: TypeAlias = Variation_1134_Arg
class RuleVariation_1091(RuleVariationContextFree):
    cv_variation = Variation_1134

    @classmethod
    def create(cls, arg : RuleVariation_1091_Arg) -> "RuleVariation_1091":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1134:
        return self.arg # type: ignore

NonSpare_1801_Arg: TypeAlias = RuleVariation_1091_Arg
class NonSpare_1801(NonSpare):
    cv_name = "SUM"
    cv_title = "Mode 5 Summary"
    cv_rule = RuleVariation_1091

    @classmethod
    def create(cls, arg : NonSpare_1801_Arg) -> "NonSpare_1801":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1091:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1134:
        return self.rule.variation

Variation_601_Arg: TypeAlias = RuleContent_0_Arg
class Variation_601(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_601_Arg) -> "Variation_601":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_590_Arg: TypeAlias = Variation_601_Arg
class RuleVariation_590(RuleVariationContextFree):
    cv_variation = Variation_601

    @classmethod
    def create(cls, arg : RuleVariation_590_Arg) -> "RuleVariation_590":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_601:
        return self.arg # type: ignore

NonSpare_1421_Arg: TypeAlias = RuleVariation_590_Arg
class NonSpare_1421(NonSpare):
    cv_name = "PIN"
    cv_title = "PIN Code"
    cv_rule = RuleVariation_590

    @classmethod
    def create(cls, arg : NonSpare_1421_Arg) -> "NonSpare_1421":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_590:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_601:
        return self.rule.variation

Item_681_Arg: TypeAlias = NonSpare_1421_Arg
class Item_681(Item):
    cv_non_spare = NonSpare_1421

    @classmethod
    def create(cls, arg : Item_681_Arg) -> "Item_681":
        return cls._create(arg) # type: ignore

Variation_891_Arg: TypeAlias = RuleContent_0_Arg
class Variation_891(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 11
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_891_Arg) -> "Variation_891":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_861_Arg: TypeAlias = Variation_891_Arg
class RuleVariation_861(RuleVariationContextFree):
    cv_variation = Variation_891

    @classmethod
    def create(cls, arg : RuleVariation_861_Arg) -> "RuleVariation_861":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_891:
        return self.arg # type: ignore

NonSpare_1352_Arg: TypeAlias = RuleVariation_861_Arg
class NonSpare_1352(NonSpare):
    cv_name = "NO"
    cv_title = "National Origin Code"
    cv_rule = RuleVariation_861

    @classmethod
    def create(cls, arg : NonSpare_1352_Arg) -> "NonSpare_1352":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_861:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_891:
        return self.rule.variation

Item_618_Arg: TypeAlias = NonSpare_1352_Arg
class Item_618(Item):
    cv_non_spare = NonSpare_1352

    @classmethod
    def create(cls, arg : Item_618_Arg) -> "Item_618":
        return cls._create(arg) # type: ignore

Variation_1005_Arg_Group = Tuple[int, Union[RuleVariation_590_Arg, Tuple[Literal["PIN"], RuleVariation_590_Arg]], int, Union[RuleVariation_861_Arg, Tuple[Literal["NO"], RuleVariation_861_Arg]]]
Variation_1005_Arg: TypeAlias = Union[int, Variation_1005_Arg_Group]
class Variation_1005(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1, 2), (Item_681, 14), (Item_4, 5), (Item_618, 11)]
    cv_items_dict = {"PIN": RuleVariation_590, "NO": RuleVariation_861}

    @overload
    @classmethod
    def spec(cls, key : Literal["PIN"]) -> RuleVariation_590:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NO"]) -> RuleVariation_861:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PIN"], Literal["NO"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PIN"]) -> RuleVariation_590:
        ...
    @overload
    def get_item(self, key : Literal["NO"]) -> RuleVariation_861:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1005_Arg) -> 'Variation_1005':
        return cls._create(arg) # type: ignore

RuleVariation_975_Arg: TypeAlias = Variation_1005_Arg
class RuleVariation_975(RuleVariationContextFree):
    cv_variation = Variation_1005

    @classmethod
    def create(cls, arg : RuleVariation_975_Arg) -> "RuleVariation_975":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1005:
        return self.arg # type: ignore

NonSpare_1428_Arg: TypeAlias = RuleVariation_975_Arg
class NonSpare_1428(NonSpare):
    cv_name = "PNO"
    cv_title = "Mode 5 PIN / National Origin"
    cv_rule = RuleVariation_975

    @classmethod
    def create(cls, arg : NonSpare_1428_Arg) -> "NonSpare_1428":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_975:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1005:
        return self.rule.variation

Content_270_Arg: TypeAlias = int
class Content_270(ContentTable):
    cv_values = {0: "Mode 1 code as derived from the report of the transponder", 1: "Smoothed Mode 1 code as provided by a local tracker"}

RuleContent_270_Arg: TypeAlias = Content_270_Arg
class RuleContent_270(RuleContentContextFree):
    cv_content = Content_270

    @property
    def content(self) -> Content_270:
        return self._get_content() # type: ignore

Variation_541_Arg: TypeAlias = RuleContent_270_Arg
class Variation_541(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_270

    @classmethod
    def create(cls, arg : Variation_541_Arg) -> "Variation_541":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_270:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_270:
        return self.rule.content

RuleVariation_530_Arg: TypeAlias = Variation_541_Arg
class RuleVariation_530(RuleVariationContextFree):
    cv_variation = Variation_541

    @classmethod
    def create(cls, arg : RuleVariation_530_Arg) -> "RuleVariation_530":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_541:
        return self.arg # type: ignore

NonSpare_1123_Arg: TypeAlias = RuleVariation_530_Arg
class NonSpare_1123(NonSpare):
    cv_name = "L"
    cv_title = ""
    cv_rule = RuleVariation_530

    @classmethod
    def create(cls, arg : NonSpare_1123_Arg) -> "NonSpare_1123":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_530:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_541:
        return self.rule.variation

Item_441_Arg: TypeAlias = NonSpare_1123_Arg
class Item_441(Item):
    cv_non_spare = NonSpare_1123

    @classmethod
    def create(cls, arg : Item_441_Arg) -> "Item_441":
        return cls._create(arg) # type: ignore

NonSpare_916_Arg: TypeAlias = RuleVariation_776_Arg
class NonSpare_916(NonSpare):
    cv_name = "EM1"
    cv_title = "Extended Mode 1 Code in Octal Representation"
    cv_rule = RuleVariation_776

    @classmethod
    def create(cls, arg : NonSpare_916_Arg) -> "NonSpare_916":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_776:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_806:
        return self.rule.variation

Item_288_Arg: TypeAlias = NonSpare_916_Arg
class Item_288(Item):
    cv_non_spare = NonSpare_916

    @classmethod
    def create(cls, arg : Item_288_Arg) -> "Item_288":
        return cls._create(arg) # type: ignore

Variation_1244_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], int, Union[RuleVariation_530_Arg, Tuple[Literal["L"], RuleVariation_530_Arg]], int, Union[RuleVariation_776_Arg, Tuple[Literal["EM1"], RuleVariation_776_Arg]]]
Variation_1244_Arg: TypeAlias = Union[int, Variation_1244_Arg_Group]
class Variation_1244(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1099, 1), (Item_7, 1), (Item_441, 1), (Item_16, 1), (Item_288, 12)]
    cv_items_dict = {"V": RuleVariation_15, "L": RuleVariation_530, "EM1": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_530:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EM1"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["L"], Literal["EM1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_530:
        ...
    @overload
    def get_item(self, key : Literal["EM1"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1244_Arg) -> 'Variation_1244':
        return cls._create(arg) # type: ignore

RuleVariation_1174_Arg: TypeAlias = Variation_1244_Arg
class RuleVariation_1174(RuleVariationContextFree):
    cv_variation = Variation_1244

    @classmethod
    def create(cls, arg : RuleVariation_1174_Arg) -> "RuleVariation_1174":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1244:
        return self.arg # type: ignore

NonSpare_919_Arg: TypeAlias = RuleVariation_1174_Arg
class NonSpare_919(NonSpare):
    cv_name = "EM1"
    cv_title = "Extended Mode 1 Code in Octal Representation"
    cv_rule = RuleVariation_1174

    @classmethod
    def create(cls, arg : NonSpare_919_Arg) -> "NonSpare_919":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1174:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1244:
        return self.rule.variation

Content_562_Arg: TypeAlias = int
class Content_562(ContentTable):
    cv_values = {0: "X-Pulse not present", 1: "X-pulse present"}

RuleContent_562_Arg: TypeAlias = Content_562_Arg
class RuleContent_562(RuleContentContextFree):
    cv_content = Content_562

    @property
    def content(self) -> Content_562:
        return self._get_content() # type: ignore

Variation_581_Arg: TypeAlias = RuleContent_562_Arg
class Variation_581(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_562

    @classmethod
    def create(cls, arg : Variation_581_Arg) -> "Variation_581":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_562:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_562:
        return self.rule.content

RuleVariation_570_Arg: TypeAlias = Variation_581_Arg
class RuleVariation_570(RuleVariationContextFree):
    cv_variation = Variation_581

    @classmethod
    def create(cls, arg : RuleVariation_570_Arg) -> "RuleVariation_570":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_581:
        return self.arg # type: ignore

NonSpare_2110_Arg: TypeAlias = RuleVariation_570_Arg
class NonSpare_2110(NonSpare):
    cv_name = "XP"
    cv_title = "X-pulse from Mode 5 PIN Reply/report"
    cv_rule = RuleVariation_570

    @classmethod
    def create(cls, arg : NonSpare_2110_Arg) -> "NonSpare_2110":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_570:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_581:
        return self.rule.variation

Item_1214_Arg: TypeAlias = NonSpare_2110_Arg
class Item_1214(Item):
    cv_non_spare = NonSpare_2110

    @classmethod
    def create(cls, arg : Item_1214_Arg) -> "Item_1214":
        return cls._create(arg) # type: ignore

Content_568_Arg: TypeAlias = int
class Content_568(ContentTable):
    cv_values = {0: "X-pulse set to zero or no authenticated Data reply or Report received", 1: "X-pulse set to one (present)"}

RuleContent_568_Arg: TypeAlias = Content_568_Arg
class RuleContent_568(RuleContentContextFree):
    cv_content = Content_568

    @property
    def content(self) -> Content_568:
        return self._get_content() # type: ignore

Variation_671_Arg: TypeAlias = RuleContent_568_Arg
class Variation_671(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_568

    @classmethod
    def create(cls, arg : Variation_671_Arg) -> "Variation_671":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_568:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_568:
        return self.rule.content

RuleVariation_660_Arg: TypeAlias = Variation_671_Arg
class RuleVariation_660(RuleVariationContextFree):
    cv_variation = Variation_671

    @classmethod
    def create(cls, arg : RuleVariation_660_Arg) -> "RuleVariation_660":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_671:
        return self.arg # type: ignore

NonSpare_2102_Arg: TypeAlias = RuleVariation_660_Arg
class NonSpare_2102(NonSpare):
    cv_name = "X5"
    cv_title = "X-pulse from Mode 5 Data Reply or Report"
    cv_rule = RuleVariation_660

    @classmethod
    def create(cls, arg : NonSpare_2102_Arg) -> "NonSpare_2102":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_660:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_671:
        return self.rule.variation

Item_1209_Arg: TypeAlias = NonSpare_2102_Arg
class Item_1209(Item):
    cv_non_spare = NonSpare_2102

    @classmethod
    def create(cls, arg : Item_1209_Arg) -> "Item_1209":
        return cls._create(arg) # type: ignore

Content_566_Arg: TypeAlias = int
class Content_566(ContentTable):
    cv_values = {0: "X-pulse set to zero or no Mode C reply", 1: "X-pulse set to one (present)"}

RuleContent_566_Arg: TypeAlias = Content_566_Arg
class RuleContent_566(RuleContentContextFree):
    cv_content = Content_566

    @property
    def content(self) -> Content_566:
        return self._get_content() # type: ignore

Variation_759_Arg: TypeAlias = RuleContent_566_Arg
class Variation_759(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_566

    @classmethod
    def create(cls, arg : Variation_759_Arg) -> "Variation_759":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_566:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_566:
        return self.rule.content

RuleVariation_748_Arg: TypeAlias = Variation_759_Arg
class RuleVariation_748(RuleVariationContextFree):
    cv_variation = Variation_759

    @classmethod
    def create(cls, arg : RuleVariation_748_Arg) -> "RuleVariation_748":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_759:
        return self.arg # type: ignore

NonSpare_2105_Arg: TypeAlias = RuleVariation_748_Arg
class NonSpare_2105(NonSpare):
    cv_name = "XC"
    cv_title = "X-pulse from Mode C Reply"
    cv_rule = RuleVariation_748

    @classmethod
    def create(cls, arg : NonSpare_2105_Arg) -> "NonSpare_2105":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_748:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_759:
        return self.rule.variation

Item_1212_Arg: TypeAlias = NonSpare_2105_Arg
class Item_1212(Item):
    cv_non_spare = NonSpare_2105

    @classmethod
    def create(cls, arg : Item_1212_Arg) -> "Item_1212":
        return cls._create(arg) # type: ignore

Content_565_Arg: TypeAlias = int
class Content_565(ContentTable):
    cv_values = {0: "X-pulse set to zero or no Mode 3/A reply", 1: "X-pulse set to one (present)"}

RuleContent_565_Arg: TypeAlias = Content_565_Arg
class RuleContent_565(RuleContentContextFree):
    cv_content = Content_565

    @property
    def content(self) -> Content_565:
        return self._get_content() # type: ignore

Variation_873_Arg: TypeAlias = RuleContent_565_Arg
class Variation_873(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_565

    @classmethod
    def create(cls, arg : Variation_873_Arg) -> "Variation_873":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_565:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_565:
        return self.rule.content

RuleVariation_843_Arg: TypeAlias = Variation_873_Arg
class RuleVariation_843(RuleVariationContextFree):
    cv_variation = Variation_873

    @classmethod
    def create(cls, arg : RuleVariation_843_Arg) -> "RuleVariation_843":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_873:
        return self.arg # type: ignore

NonSpare_2101_Arg: TypeAlias = RuleVariation_843_Arg
class NonSpare_2101(NonSpare):
    cv_name = "X3"
    cv_title = "X-pulse from Mode 3/A Reply"
    cv_rule = RuleVariation_843

    @classmethod
    def create(cls, arg : NonSpare_2101_Arg) -> "NonSpare_2101":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_843:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_873:
        return self.rule.variation

Item_1208_Arg: TypeAlias = NonSpare_2101_Arg
class Item_1208(Item):
    cv_non_spare = NonSpare_2101

    @classmethod
    def create(cls, arg : Item_1208_Arg) -> "Item_1208":
        return cls._create(arg) # type: ignore

Content_1_Arg: TypeAlias = int
class Content_1(ContentTable):
    cv_values = {0: "0 X-pulse set to zero or no Mode 2 reply", 1: "X-pulse set to one (present)"}

RuleContent_1_Arg: TypeAlias = Content_1_Arg
class RuleContent_1(RuleContentContextFree):
    cv_content = Content_1

    @property
    def content(self) -> Content_1:
        return self._get_content() # type: ignore

Variation_897_Arg: TypeAlias = RuleContent_1_Arg
class Variation_897(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_1

    @classmethod
    def create(cls, arg : Variation_897_Arg) -> "Variation_897":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_1:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_1:
        return self.rule.content

RuleVariation_867_Arg: TypeAlias = Variation_897_Arg
class RuleVariation_867(RuleVariationContextFree):
    cv_variation = Variation_897

    @classmethod
    def create(cls, arg : RuleVariation_867_Arg) -> "RuleVariation_867":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_897:
        return self.arg # type: ignore

NonSpare_2098_Arg: TypeAlias = RuleVariation_867_Arg
class NonSpare_2098(NonSpare):
    cv_name = "X2"
    cv_title = "X-pulse from Mode 2 Reply"
    cv_rule = RuleVariation_867

    @classmethod
    def create(cls, arg : NonSpare_2098_Arg) -> "NonSpare_2098":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_867:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_897:
        return self.rule.variation

Item_1205_Arg: TypeAlias = NonSpare_2098_Arg
class Item_1205(Item):
    cv_non_spare = NonSpare_2098

    @classmethod
    def create(cls, arg : Item_1205_Arg) -> "Item_1205":
        return cls._create(arg) # type: ignore

Content_563_Arg: TypeAlias = int
class Content_563(ContentTable):
    cv_values = {0: "X-pulse set to zero or no Mode 1 reply", 1: "X-pulse set to one (present)"}

RuleContent_563_Arg: TypeAlias = Content_563_Arg
class RuleContent_563(RuleContentContextFree):
    cv_content = Content_563

    @property
    def content(self) -> Content_563:
        return self._get_content() # type: ignore

Variation_987_Arg: TypeAlias = RuleContent_563_Arg
class Variation_987(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_563

    @classmethod
    def create(cls, arg : Variation_987_Arg) -> "Variation_987":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_563:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_563:
        return self.rule.content

RuleVariation_957_Arg: TypeAlias = Variation_987_Arg
class RuleVariation_957(RuleVariationContextFree):
    cv_variation = Variation_987

    @classmethod
    def create(cls, arg : RuleVariation_957_Arg) -> "RuleVariation_957":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_987:
        return self.arg # type: ignore

NonSpare_2095_Arg: TypeAlias = RuleVariation_957_Arg
class NonSpare_2095(NonSpare):
    cv_name = "X1"
    cv_title = "X-pulse from Mode 1 Reply"
    cv_rule = RuleVariation_957

    @classmethod
    def create(cls, arg : NonSpare_2095_Arg) -> "NonSpare_2095":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_957:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_987:
        return self.rule.variation

Item_1202_Arg: TypeAlias = NonSpare_2095_Arg
class Item_1202(Item):
    cv_non_spare = NonSpare_2095

    @classmethod
    def create(cls, arg : Item_1202_Arg) -> "Item_1202":
        return cls._create(arg) # type: ignore

Variation_1008_Arg_Group = Tuple[int, Union[RuleVariation_570_Arg, Tuple[Literal["XP"], RuleVariation_570_Arg]], Union[RuleVariation_660_Arg, Tuple[Literal["X5"], RuleVariation_660_Arg]], Union[RuleVariation_748_Arg, Tuple[Literal["XC"], RuleVariation_748_Arg]], Union[RuleVariation_843_Arg, Tuple[Literal["X3"], RuleVariation_843_Arg]], Union[RuleVariation_867_Arg, Tuple[Literal["X2"], RuleVariation_867_Arg]], Union[RuleVariation_957_Arg, Tuple[Literal["X1"], RuleVariation_957_Arg]]]
Variation_1008_Arg: TypeAlias = Union[int, Variation_1008_Arg_Group]
class Variation_1008(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1, 2), (Item_1214, 1), (Item_1209, 1), (Item_1212, 1), (Item_1208, 1), (Item_1205, 1), (Item_1202, 1)]
    cv_items_dict = {"XP": RuleVariation_570, "X5": RuleVariation_660, "XC": RuleVariation_748, "X3": RuleVariation_843, "X2": RuleVariation_867, "X1": RuleVariation_957}

    @overload
    @classmethod
    def spec(cls, key : Literal["XP"]) -> RuleVariation_570:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X5"]) -> RuleVariation_660:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XC"]) -> RuleVariation_748:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X3"]) -> RuleVariation_843:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X2"]) -> RuleVariation_867:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X1"]) -> RuleVariation_957:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["XP"], Literal["X5"], Literal["XC"], Literal["X3"], Literal["X2"], Literal["X1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["XP"]) -> RuleVariation_570:
        ...
    @overload
    def get_item(self, key : Literal["X5"]) -> RuleVariation_660:
        ...
    @overload
    def get_item(self, key : Literal["XC"]) -> RuleVariation_748:
        ...
    @overload
    def get_item(self, key : Literal["X3"]) -> RuleVariation_843:
        ...
    @overload
    def get_item(self, key : Literal["X2"]) -> RuleVariation_867:
        ...
    @overload
    def get_item(self, key : Literal["X1"]) -> RuleVariation_957:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1008_Arg) -> 'Variation_1008':
        return cls._create(arg) # type: ignore

RuleVariation_978_Arg: TypeAlias = Variation_1008_Arg
class RuleVariation_978(RuleVariationContextFree):
    cv_variation = Variation_1008

    @classmethod
    def create(cls, arg : RuleVariation_978_Arg) -> "RuleVariation_978":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1008:
        return self.arg # type: ignore

NonSpare_2107_Arg: TypeAlias = RuleVariation_978_Arg
class NonSpare_2107(NonSpare):
    cv_name = "XP"
    cv_title = "X Pulse Presence"
    cv_rule = RuleVariation_978

    @classmethod
    def create(cls, arg : NonSpare_2107_Arg) -> "NonSpare_2107":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_978:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1008:
        return self.rule.variation

NonSpare_975_Arg: TypeAlias = RuleVariation_681_Arg
class NonSpare_975(NonSpare):
    cv_name = "FOM"
    cv_title = "Figure of Merit"
    cv_rule = RuleVariation_681

    @classmethod
    def create(cls, arg : NonSpare_975_Arg) -> "NonSpare_975":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_681:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_692:
        return self.rule.variation

Item_335_Arg: TypeAlias = NonSpare_975_Arg
class Item_335(Item):
    cv_non_spare = NonSpare_975

    @classmethod
    def create(cls, arg : Item_335_Arg) -> "Item_335":
        return cls._create(arg) # type: ignore

Variation_1011_Arg_Group = Tuple[int, Union[RuleVariation_681_Arg, Tuple[Literal["FOM"], RuleVariation_681_Arg]]]
Variation_1011_Arg: TypeAlias = Union[int, Variation_1011_Arg_Group]
class Variation_1011(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_2, 3), (Item_335, 5)]
    cv_items_dict = {"FOM": RuleVariation_681}

    @classmethod
    def spec(cls, key : Literal["FOM"]) -> RuleVariation_681:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["FOM"]) -> RuleVariation_681:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1011_Arg) -> 'Variation_1011':
        return cls._create(arg) # type: ignore

RuleVariation_981_Arg: TypeAlias = Variation_1011_Arg
class RuleVariation_981(RuleVariationContextFree):
    cv_variation = Variation_1011

    @classmethod
    def create(cls, arg : RuleVariation_981_Arg) -> "RuleVariation_981":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1011:
        return self.arg # type: ignore

NonSpare_977_Arg: TypeAlias = RuleVariation_981_Arg
class NonSpare_977(NonSpare):
    cv_name = "FOM"
    cv_title = "Figure of Merit"
    cv_rule = RuleVariation_981

    @classmethod
    def create(cls, arg : NonSpare_977_Arg) -> "NonSpare_977":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_981:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1011:
        return self.rule.variation

NonSpare_1293_Arg: TypeAlias = RuleVariation_776_Arg
class NonSpare_1293(NonSpare):
    cv_name = "MODE2"
    cv_title = "Mode 2 Code in Octal Representation"
    cv_rule = RuleVariation_776

    @classmethod
    def create(cls, arg : NonSpare_1293_Arg) -> "NonSpare_1293":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_776:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_806:
        return self.rule.variation

Item_565_Arg: TypeAlias = NonSpare_1293_Arg
class Item_565(Item):
    cv_non_spare = NonSpare_1293

    @classmethod
    def create(cls, arg : Item_565_Arg) -> "Item_565":
        return cls._create(arg) # type: ignore

Variation_1245_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], int, Union[RuleVariation_535_Arg, Tuple[Literal["L"], RuleVariation_535_Arg]], int, Union[RuleVariation_776_Arg, Tuple[Literal["MODE2"], RuleVariation_776_Arg]]]
Variation_1245_Arg: TypeAlias = Union[int, Variation_1245_Arg_Group]
class Variation_1245(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1099, 1), (Item_7, 1), (Item_446, 1), (Item_16, 1), (Item_565, 12)]
    cv_items_dict = {"V": RuleVariation_15, "L": RuleVariation_535, "MODE2": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_535:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE2"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["L"], Literal["MODE2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_535:
        ...
    @overload
    def get_item(self, key : Literal["MODE2"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1245_Arg) -> 'Variation_1245':
        return cls._create(arg) # type: ignore

RuleVariation_1175_Arg: TypeAlias = Variation_1245_Arg
class RuleVariation_1175(RuleVariationContextFree):
    cv_variation = Variation_1245

    @classmethod
    def create(cls, arg : RuleVariation_1175_Arg) -> "RuleVariation_1175":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1245:
        return self.arg # type: ignore

NonSpare_1201_Arg: TypeAlias = RuleVariation_1175_Arg
class NonSpare_1201(NonSpare):
    cv_name = "M2"
    cv_title = "Mode 2 Code in Octal Representation"
    cv_rule = RuleVariation_1175

    @classmethod
    def create(cls, arg : NonSpare_1201_Arg) -> "NonSpare_1201":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1175:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1245:
        return self.rule.variation

Variation_1500_Arg = TypedDict('Variation_1500_Arg', {
    "SUM": NonSpare_1801_Arg,
    "PNO": NonSpare_1428_Arg,
    "EM1": NonSpare_919_Arg,
    "XP": NonSpare_2107_Arg,
    "FOM": NonSpare_977_Arg,
    "M2": NonSpare_1201_Arg,
}, total=False)
class Variation_1500(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1801, NonSpare_1428, NonSpare_919, NonSpare_2107, NonSpare_977, NonSpare_1201]
    cv_items_dict = {"SUM": NonSpare_1801, "PNO": NonSpare_1428, "EM1": NonSpare_919, "XP": NonSpare_2107, "FOM": NonSpare_977, "M2": NonSpare_1201}

    @overload
    @classmethod
    def spec(cls, key : Literal["SUM"]) -> NonSpare_1801:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PNO"]) -> NonSpare_1428:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EM1"]) -> NonSpare_919:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XP"]) -> NonSpare_2107:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FOM"]) -> NonSpare_977:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M2"]) -> NonSpare_1201:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SUM"], Literal["PNO"], Literal["EM1"], Literal["XP"], Literal["FOM"], Literal["M2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SUM"]) -> Optional[NonSpare_1801]:
        ...
    @overload
    def get_item(self, key : Literal["PNO"]) -> Optional[NonSpare_1428]:
        ...
    @overload
    def get_item(self, key : Literal["EM1"]) -> Optional[NonSpare_919]:
        ...
    @overload
    def get_item(self, key : Literal["XP"]) -> Optional[NonSpare_2107]:
        ...
    @overload
    def get_item(self, key : Literal["FOM"]) -> Optional[NonSpare_977]:
        ...
    @overload
    def get_item(self, key : Literal["M2"]) -> Optional[NonSpare_1201]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["SUM"], val : NonSpare_1801_Arg) -> "Variation_1500":
        ...
    @overload
    def set_item(self, key : Literal["PNO"], val : NonSpare_1428_Arg) -> "Variation_1500":
        ...
    @overload
    def set_item(self, key : Literal["EM1"], val : NonSpare_919_Arg) -> "Variation_1500":
        ...
    @overload
    def set_item(self, key : Literal["XP"], val : NonSpare_2107_Arg) -> "Variation_1500":
        ...
    @overload
    def set_item(self, key : Literal["FOM"], val : NonSpare_977_Arg) -> "Variation_1500":
        ...
    @overload
    def set_item(self, key : Literal["M2"], val : NonSpare_1201_Arg) -> "Variation_1500":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["SUM"]) -> "Variation_1500":
        ...
    @overload
    def del_item(self, key : Literal["PNO"]) -> "Variation_1500":
        ...
    @overload
    def del_item(self, key : Literal["EM1"]) -> "Variation_1500":
        ...
    @overload
    def del_item(self, key : Literal["XP"]) -> "Variation_1500":
        ...
    @overload
    def del_item(self, key : Literal["FOM"]) -> "Variation_1500":
        ...
    @overload
    def del_item(self, key : Literal["M2"]) -> "Variation_1500":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1500_Arg) -> 'Variation_1500':
        return cls._create(arg) # type: ignore

RuleVariation_1423_Arg: TypeAlias = Variation_1500_Arg
class RuleVariation_1423(RuleVariationContextFree):
    cv_variation = Variation_1500

    @classmethod
    def create(cls, arg : RuleVariation_1423_Arg) -> "RuleVariation_1423":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1500:
        return self.arg # type: ignore

NonSpare_1260_Arg: TypeAlias = RuleVariation_1423_Arg
class NonSpare_1260(NonSpare):
    cv_name = "MES"
    cv_title = "Military Extended Squitter"
    cv_rule = RuleVariation_1423

    @classmethod
    def create(cls, arg : NonSpare_1260_Arg) -> "NonSpare_1260":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1423:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1500:
        return self.rule.variation

Expansion_0_Arg = TypedDict('Expansion_0_Arg', {
    "BPS": NonSpare_687_Arg,
    "SH": NonSpare_1696_Arg,
    "NAV": NonSpare_1337_Arg,
    "GAO": NonSpare_1014_Arg,
    "SGV": NonSpare_1694_Arg,
    "STA": NonSpare_1760_Arg,
    "TNH": NonSpare_1869_Arg,
    "MES": NonSpare_1260_Arg,
}, total=False)
class Expansion_0(Expansion):
    cv_fspec_bytes = 1
    cv_items_list = [NonSpare_687, NonSpare_1696, NonSpare_1337, NonSpare_1014, NonSpare_1694, NonSpare_1760, NonSpare_1869, NonSpare_1260]
    items_dict = {"BPS": NonSpare_687, "SH": NonSpare_1696, "NAV": NonSpare_1337, "GAO": NonSpare_1014, "SGV": NonSpare_1694, "STA": NonSpare_1760, "TNH": NonSpare_1869, "MES": NonSpare_1260}

    @overload
    @classmethod
    def spec(cls, key : Literal["BPS"]) -> NonSpare_687:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SH"]) -> NonSpare_1696:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NAV"]) -> NonSpare_1337:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GAO"]) -> NonSpare_1014:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SGV"]) -> NonSpare_1694:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STA"]) -> NonSpare_1760:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TNH"]) -> NonSpare_1869:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MES"]) -> NonSpare_1260:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["BPS"], Literal["SH"], Literal["NAV"], Literal["GAO"], Literal["SGV"], Literal["STA"], Literal["TNH"], Literal["MES"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["BPS"]) -> Optional[NonSpare_687]:
        ...
    @overload
    def get_item(self, key : Literal["SH"]) -> Optional[NonSpare_1696]:
        ...
    @overload
    def get_item(self, key : Literal["NAV"]) -> Optional[NonSpare_1337]:
        ...
    @overload
    def get_item(self, key : Literal["GAO"]) -> Optional[NonSpare_1014]:
        ...
    @overload
    def get_item(self, key : Literal["SGV"]) -> Optional[NonSpare_1694]:
        ...
    @overload
    def get_item(self, key : Literal["STA"]) -> Optional[NonSpare_1760]:
        ...
    @overload
    def get_item(self, key : Literal["TNH"]) -> Optional[NonSpare_1869]:
        ...
    @overload
    def get_item(self, key : Literal["MES"]) -> Optional[NonSpare_1260]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["BPS"], val : NonSpare_687_Arg) -> "Expansion_0":
        ...
    @overload
    def set_item(self, key : Literal["SH"], val : NonSpare_1696_Arg) -> "Expansion_0":
        ...
    @overload
    def set_item(self, key : Literal["NAV"], val : NonSpare_1337_Arg) -> "Expansion_0":
        ...
    @overload
    def set_item(self, key : Literal["GAO"], val : NonSpare_1014_Arg) -> "Expansion_0":
        ...
    @overload
    def set_item(self, key : Literal["SGV"], val : NonSpare_1694_Arg) -> "Expansion_0":
        ...
    @overload
    def set_item(self, key : Literal["STA"], val : NonSpare_1760_Arg) -> "Expansion_0":
        ...
    @overload
    def set_item(self, key : Literal["TNH"], val : NonSpare_1869_Arg) -> "Expansion_0":
        ...
    @overload
    def set_item(self, key : Literal["MES"], val : NonSpare_1260_Arg) -> "Expansion_0":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["BPS"]) -> "Expansion_0":
        ...
    @overload
    def del_item(self, key : Literal["SH"]) -> "Expansion_0":
        ...
    @overload
    def del_item(self, key : Literal["NAV"]) -> "Expansion_0":
        ...
    @overload
    def del_item(self, key : Literal["GAO"]) -> "Expansion_0":
        ...
    @overload
    def del_item(self, key : Literal["SGV"]) -> "Expansion_0":
        ...
    @overload
    def del_item(self, key : Literal["STA"]) -> "Expansion_0":
        ...
    @overload
    def del_item(self, key : Literal["TNH"]) -> "Expansion_0":
        ...
    @overload
    def del_item(self, key : Literal["MES"]) -> "Expansion_0":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Expansion_0_Arg) -> 'Expansion_0':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Expansion_0", Bits]]:
        return cls._parse(bs) # type: ignore

class Asterix_26(AstRef):
    cv_category = 21
    cv_edition = (1, 4)
    cv_expansion = Expansion_0

Content_203_Arg: TypeAlias = int
class Content_203(ContentTable):
    cv_values = {0: "Element not populated", 1: "Element populated"}

RuleContent_203_Arg: TypeAlias = Content_203_Arg
class RuleContent_203(RuleContentContextFree):
    cv_content = Content_203

    @property
    def content(self) -> Content_203:
        return self._get_content() # type: ignore

Variation_718_Arg: TypeAlias = RuleContent_203_Arg
class Variation_718(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_203

    @classmethod
    def create(cls, arg : Variation_718_Arg) -> "Variation_718":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_203:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_203:
        return self.rule.content

RuleVariation_707_Arg: TypeAlias = Variation_718_Arg
class RuleVariation_707(RuleVariationContextFree):
    cv_variation = Variation_718

    @classmethod
    def create(cls, arg : RuleVariation_707_Arg) -> "RuleVariation_707":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_718:
        return self.arg # type: ignore

NonSpare_936_Arg: TypeAlias = RuleVariation_707_Arg
class NonSpare_936(NonSpare):
    cv_name = "EP"
    cv_title = "Element Populated Bit"
    cv_rule = RuleVariation_707

    @classmethod
    def create(cls, arg : NonSpare_936_Arg) -> "NonSpare_936":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_707:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_718:
        return self.rule.variation

Item_303_Arg: TypeAlias = NonSpare_936_Arg
class Item_303(Item):
    cv_non_spare = NonSpare_936

    @classmethod
    def create(cls, arg : Item_303_Arg) -> "Item_303":
        return cls._create(arg) # type: ignore

Content_258_Arg: TypeAlias = int
class Content_258(ContentTable):
    cv_values = {0: "MCP/FCU Mode Bits not populated", 1: "MCP/FCU Mode Bits populated"}

RuleContent_258_Arg: TypeAlias = Content_258_Arg
class RuleContent_258(RuleContentContextFree):
    cv_content = Content_258

    @property
    def content(self) -> Content_258:
        return self._get_content() # type: ignore

Variation_856_Arg: TypeAlias = RuleContent_258_Arg
class Variation_856(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_258

    @classmethod
    def create(cls, arg : Variation_856_Arg) -> "Variation_856":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_258:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_258:
        return self.rule.content

RuleVariation_826_Arg: TypeAlias = Variation_856_Arg
class RuleVariation_826(RuleVariationContextFree):
    cv_variation = Variation_856

    @classmethod
    def create(cls, arg : RuleVariation_826_Arg) -> "RuleVariation_826":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_856:
        return self.arg # type: ignore

NonSpare_2012_Arg: TypeAlias = RuleVariation_826_Arg
class NonSpare_2012(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_826

    @classmethod
    def create(cls, arg : NonSpare_2012_Arg) -> "NonSpare_2012":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_826:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_856:
        return self.rule.variation

Item_1128_Arg: TypeAlias = NonSpare_2012_Arg
class Item_1128(Item):
    cv_non_spare = NonSpare_2012

    @classmethod
    def create(cls, arg : Item_1128_Arg) -> "Item_1128":
        return cls._create(arg) # type: ignore

Variation_1326_Arg_Group = Tuple[Union[RuleVariation_707_Arg, Tuple[Literal["EP"], RuleVariation_707_Arg]], Union[RuleVariation_826_Arg, Tuple[Literal["VAL"], RuleVariation_826_Arg]]]
Variation_1326_Arg: TypeAlias = Union[int, Variation_1326_Arg_Group]
class Variation_1326(Group):
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_items_list = [(Item_303, 1), (Item_1128, 1)]
    cv_items_dict = {"EP": RuleVariation_707, "VAL": RuleVariation_826}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_707:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_826:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_707:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_826:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1326_Arg) -> 'Variation_1326':
        return cls._create(arg) # type: ignore

RuleVariation_1251_Arg: TypeAlias = Variation_1326_Arg
class RuleVariation_1251(RuleVariationContextFree):
    cv_variation = Variation_1326

    @classmethod
    def create(cls, arg : RuleVariation_1251_Arg) -> "RuleVariation_1251":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1326:
        return self.arg # type: ignore

NonSpare_1267_Arg: TypeAlias = RuleVariation_1251_Arg
class NonSpare_1267(NonSpare):
    cv_name = "MFM"
    cv_title = "Status of MCP/FCU Mode Bits"
    cv_rule = RuleVariation_1251

    @classmethod
    def create(cls, arg : NonSpare_1267_Arg) -> "NonSpare_1267":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1251:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1326:
        return self.rule.variation

Item_544_Arg: TypeAlias = NonSpare_1267_Arg
class Item_544(Item):
    cv_non_spare = NonSpare_1267

    @classmethod
    def create(cls, arg : Item_544_Arg) -> "Item_544":
        return cls._create(arg) # type: ignore

Variation_1050_Arg_Group = Tuple[Union[RuleVariation_13_Arg, Tuple[Literal["AP"], RuleVariation_13_Arg]], Union[RuleVariation_451_Arg, Tuple[Literal["VN"], RuleVariation_451_Arg]], Union[RuleVariation_496_Arg, Tuple[Literal["AH"], RuleVariation_496_Arg]], Union[RuleVariation_603_Arg, Tuple[Literal["AM"], RuleVariation_603_Arg]], Union[RuleVariation_1251_Arg, Tuple[Literal["MFM"], RuleVariation_1251_Arg]], int]
Variation_1050_Arg: TypeAlias = Union[int, Variation_1050_Arg_Group]
class Variation_1050(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_76, 1), (Item_1141, 1), (Item_52, 1), (Item_70, 1), (Item_544, 2), (Item_27, 2)]
    cv_items_dict = {"AP": RuleVariation_13, "VN": RuleVariation_451, "AH": RuleVariation_496, "AM": RuleVariation_603, "MFM": RuleVariation_1251}

    @overload
    @classmethod
    def spec(cls, key : Literal["AP"]) -> RuleVariation_13:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VN"]) -> RuleVariation_451:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AH"]) -> RuleVariation_496:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AM"]) -> RuleVariation_603:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MFM"]) -> RuleVariation_1251:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AP"], Literal["VN"], Literal["AH"], Literal["AM"], Literal["MFM"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AP"]) -> RuleVariation_13:
        ...
    @overload
    def get_item(self, key : Literal["VN"]) -> RuleVariation_451:
        ...
    @overload
    def get_item(self, key : Literal["AH"]) -> RuleVariation_496:
        ...
    @overload
    def get_item(self, key : Literal["AM"]) -> RuleVariation_603:
        ...
    @overload
    def get_item(self, key : Literal["MFM"]) -> RuleVariation_1251:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1050_Arg) -> 'Variation_1050':
        return cls._create(arg) # type: ignore

RuleVariation_1017_Arg: TypeAlias = Variation_1050_Arg
class RuleVariation_1017(RuleVariationContextFree):
    cv_variation = Variation_1050

    @classmethod
    def create(cls, arg : RuleVariation_1017_Arg) -> "RuleVariation_1017":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1050:
        return self.arg # type: ignore

NonSpare_1338_Arg: TypeAlias = RuleVariation_1017_Arg
class NonSpare_1338(NonSpare):
    cv_name = "NAV"
    cv_title = "Navigation Mode"
    cv_rule = RuleVariation_1017

    @classmethod
    def create(cls, arg : NonSpare_1338_Arg) -> "NonSpare_1338":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1017:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1050:
        return self.rule.variation

NonSpare_1013_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_1013(NonSpare):
    cv_name = "GAO"
    cv_title = "GPS Antenna Offset"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_1013_Arg) -> "NonSpare_1013":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Variation_531_Arg: TypeAlias = RuleContent_203_Arg
class Variation_531(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_203

    @classmethod
    def create(cls, arg : Variation_531_Arg) -> "Variation_531":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_203:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_203:
        return self.rule.content

RuleVariation_520_Arg: TypeAlias = Variation_531_Arg
class RuleVariation_520(RuleVariationContextFree):
    cv_variation = Variation_531

    @classmethod
    def create(cls, arg : RuleVariation_520_Arg) -> "RuleVariation_520":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_531:
        return self.arg # type: ignore

NonSpare_934_Arg: TypeAlias = RuleVariation_520_Arg
class NonSpare_934(NonSpare):
    cv_name = "EP"
    cv_title = "Element Populated Bit"
    cv_rule = RuleVariation_520

    @classmethod
    def create(cls, arg : NonSpare_934_Arg) -> "NonSpare_934":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_520:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_531:
        return self.rule.variation

Item_301_Arg: TypeAlias = NonSpare_934_Arg
class Item_301(Item):
    cv_non_spare = NonSpare_934

    @classmethod
    def create(cls, arg : Item_301_Arg) -> "Item_301":
        return cls._create(arg) # type: ignore

Content_385_Arg: TypeAlias = int
class Content_385(ContentTable):
    cv_values = {0: "Not RCE", 1: "TABS (see Note 2)", 2: "Reserved for future use", 3: "Other RCE"}

RuleContent_385_Arg: TypeAlias = Content_385_Arg
class RuleContent_385(RuleContentContextFree):
    cv_content = Content_385

    @property
    def content(self) -> Content_385:
        return self._get_content() # type: ignore

Variation_677_Arg: TypeAlias = RuleContent_385_Arg
class Variation_677(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_rule = RuleContent_385

    @classmethod
    def create(cls, arg : Variation_677_Arg) -> "Variation_677":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_385:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_385:
        return self.rule.content

RuleVariation_666_Arg: TypeAlias = Variation_677_Arg
class RuleVariation_666(RuleVariationContextFree):
    cv_variation = Variation_677

    @classmethod
    def create(cls, arg : RuleVariation_666_Arg) -> "RuleVariation_666":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_677:
        return self.arg # type: ignore

NonSpare_2007_Arg: TypeAlias = RuleVariation_666_Arg
class NonSpare_2007(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_666

    @classmethod
    def create(cls, arg : NonSpare_2007_Arg) -> "NonSpare_2007":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_666:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_677:
        return self.rule.variation

Item_1123_Arg: TypeAlias = NonSpare_2007_Arg
class Item_1123(Item):
    cv_non_spare = NonSpare_2007

    @classmethod
    def create(cls, arg : Item_1123_Arg) -> "Item_1123":
        return cls._create(arg) # type: ignore

Variation_1317_Arg_Group = Tuple[Union[RuleVariation_520_Arg, Tuple[Literal["EP"], RuleVariation_520_Arg]], Union[RuleVariation_666_Arg, Tuple[Literal["VAL"], RuleVariation_666_Arg]]]
Variation_1317_Arg: TypeAlias = Union[int, Variation_1317_Arg_Group]
class Variation_1317(Group):
    cv_bit_offset8 = 2
    cv_bit_size = 3
    cv_items_list = [(Item_301, 1), (Item_1123, 2)]
    cv_items_dict = {"EP": RuleVariation_520, "VAL": RuleVariation_666}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_520:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_666:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_520:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_666:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1317_Arg) -> 'Variation_1317':
        return cls._create(arg) # type: ignore

RuleVariation_1242_Arg: TypeAlias = Variation_1317_Arg
class RuleVariation_1242(RuleVariationContextFree):
    cv_variation = Variation_1317

    @classmethod
    def create(cls, arg : RuleVariation_1242_Arg) -> "RuleVariation_1242":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1317:
        return self.arg # type: ignore

Variation_845_Arg: TypeAlias = RuleContent_203_Arg
class Variation_845(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_203

    @classmethod
    def create(cls, arg : Variation_845_Arg) -> "Variation_845":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_203:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_203:
        return self.rule.content

RuleVariation_815_Arg: TypeAlias = Variation_845_Arg
class RuleVariation_815(RuleVariationContextFree):
    cv_variation = Variation_845

    @classmethod
    def create(cls, arg : RuleVariation_815_Arg) -> "RuleVariation_815":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_845:
        return self.arg # type: ignore

NonSpare_937_Arg: TypeAlias = RuleVariation_815_Arg
class NonSpare_937(NonSpare):
    cv_name = "EP"
    cv_title = "Element Populated Bit"
    cv_rule = RuleVariation_815

    @classmethod
    def create(cls, arg : NonSpare_937_Arg) -> "NonSpare_937":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_815:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_845:
        return self.rule.variation

Item_304_Arg: TypeAlias = NonSpare_937_Arg
class Item_304(Item):
    cv_non_spare = NonSpare_937

    @classmethod
    def create(cls, arg : Item_304_Arg) -> "Item_304":
        return cls._create(arg) # type: ignore

Content_436_Arg: TypeAlias = int
class Content_436(ContentTable):
    cv_values = {0: "Reply Rate Limiting is not active", 1: "Reply Rate Limiting is active"}

RuleContent_436_Arg: TypeAlias = Content_436_Arg
class RuleContent_436(RuleContentContextFree):
    cv_content = Content_436

    @property
    def content(self) -> Content_436:
        return self._get_content() # type: ignore

Variation_944_Arg: TypeAlias = RuleContent_436_Arg
class Variation_944(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_436

    @classmethod
    def create(cls, arg : Variation_944_Arg) -> "Variation_944":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_436:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_436:
        return self.rule.content

RuleVariation_914_Arg: TypeAlias = Variation_944_Arg
class RuleVariation_914(RuleVariationContextFree):
    cv_variation = Variation_944

    @classmethod
    def create(cls, arg : RuleVariation_914_Arg) -> "RuleVariation_914":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_944:
        return self.arg # type: ignore

NonSpare_2016_Arg: TypeAlias = RuleVariation_914_Arg
class NonSpare_2016(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_914

    @classmethod
    def create(cls, arg : NonSpare_2016_Arg) -> "NonSpare_2016":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_914:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_944:
        return self.rule.variation

Item_1132_Arg: TypeAlias = NonSpare_2016_Arg
class Item_1132(Item):
    cv_non_spare = NonSpare_2016

    @classmethod
    def create(cls, arg : Item_1132_Arg) -> "Item_1132":
        return cls._create(arg) # type: ignore

Variation_1332_Arg_Group = Tuple[Union[RuleVariation_815_Arg, Tuple[Literal["EP"], RuleVariation_815_Arg]], Union[RuleVariation_914_Arg, Tuple[Literal["VAL"], RuleVariation_914_Arg]]]
Variation_1332_Arg: TypeAlias = Union[int, Variation_1332_Arg_Group]
class Variation_1332(Group):
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_items_list = [(Item_304, 1), (Item_1132, 1)]
    cv_items_dict = {"EP": RuleVariation_815, "VAL": RuleVariation_914}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_815:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_914:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_815:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_914:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1332_Arg) -> 'Variation_1332':
        return cls._create(arg) # type: ignore

RuleVariation_1255_Arg: TypeAlias = Variation_1332_Arg
class RuleVariation_1255(RuleVariationContextFree):
    cv_variation = Variation_1332

    @classmethod
    def create(cls, arg : RuleVariation_1255_Arg) -> "RuleVariation_1255":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1332:
        return self.arg # type: ignore

Variation_41_Arg: TypeAlias = RuleContent_203_Arg
class Variation_41(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_203

    @classmethod
    def create(cls, arg : Variation_41_Arg) -> "Variation_41":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_203:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_203:
        return self.rule.content

RuleVariation_41_Arg: TypeAlias = Variation_41_Arg
class RuleVariation_41(RuleVariationContextFree):
    cv_variation = Variation_41

    @classmethod
    def create(cls, arg : RuleVariation_41_Arg) -> "RuleVariation_41":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_41:
        return self.arg # type: ignore

NonSpare_933_Arg: TypeAlias = RuleVariation_41_Arg
class NonSpare_933(NonSpare):
    cv_name = "EP"
    cv_title = "Element Populated Bit"
    cv_rule = RuleVariation_41

    @classmethod
    def create(cls, arg : NonSpare_933_Arg) -> "NonSpare_933":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_41:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_41:
        return self.rule.variation

Item_300_Arg: TypeAlias = NonSpare_933_Arg
class Item_300(Item):
    cv_non_spare = NonSpare_933

    @classmethod
    def create(cls, arg : Item_300_Arg) -> "Item_300":
        return cls._create(arg) # type: ignore

Content_356_Arg: TypeAlias = int
class Content_356(ContentTable):
    cv_values = {0: "No emergency / not reported", 1: "General emergency", 2: "UAS/RPAS - Lost link", 3: "Minimum fuel", 4: "No communications", 5: "Unlawful interference", 6: "Aircraft in Distress", 7: "Aircraft in Distress Manual Activation"}

RuleContent_356_Arg: TypeAlias = Content_356_Arg
class RuleContent_356(RuleContentContextFree):
    cv_content = Content_356

    @property
    def content(self) -> Content_356:
        return self._get_content() # type: ignore

Variation_481_Arg: TypeAlias = RuleContent_356_Arg
class Variation_481(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 3
    cv_rule = RuleContent_356

    @classmethod
    def create(cls, arg : Variation_481_Arg) -> "Variation_481":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_356:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_356:
        return self.rule.content

RuleVariation_470_Arg: TypeAlias = Variation_481_Arg
class RuleVariation_470(RuleVariationContextFree):
    cv_variation = Variation_481

    @classmethod
    def create(cls, arg : RuleVariation_470_Arg) -> "RuleVariation_470":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_481:
        return self.arg # type: ignore

NonSpare_2003_Arg: TypeAlias = RuleVariation_470_Arg
class NonSpare_2003(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_470

    @classmethod
    def create(cls, arg : NonSpare_2003_Arg) -> "NonSpare_2003":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_470:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_481:
        return self.rule.variation

Item_1119_Arg: TypeAlias = NonSpare_2003_Arg
class Item_1119(Item):
    cv_non_spare = NonSpare_2003

    @classmethod
    def create(cls, arg : Item_1119_Arg) -> "Item_1119":
        return cls._create(arg) # type: ignore

Variation_1093_Arg_Group = Tuple[Union[RuleVariation_41_Arg, Tuple[Literal["EP"], RuleVariation_41_Arg]], Union[RuleVariation_470_Arg, Tuple[Literal["VAL"], RuleVariation_470_Arg]]]
Variation_1093_Arg: TypeAlias = Union[int, Variation_1093_Arg_Group]
class Variation_1093(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_items_list = [(Item_300, 1), (Item_1119, 3)]
    cv_items_dict = {"EP": RuleVariation_41, "VAL": RuleVariation_470}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_470:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_470:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1093_Arg) -> 'Variation_1093':
        return cls._create(arg) # type: ignore

RuleVariation_1051_Arg: TypeAlias = Variation_1093_Arg
class RuleVariation_1051(RuleVariationContextFree):
    cv_variation = Variation_1093

    @classmethod
    def create(cls, arg : RuleVariation_1051_Arg) -> "RuleVariation_1051":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1093:
        return self.arg # type: ignore

Content_529_Arg: TypeAlias = int
class Content_529(ContentTable):
    cv_values = {0: "Unavailable, Unknown, or less than 70 W", 1: "70 W", 2: "125 W", 3: "200 W"}

RuleContent_529_Arg: TypeAlias = Content_529_Arg
class RuleContent_529(RuleContentContextFree):
    cv_content = Content_529

    @property
    def content(self) -> Content_529:
        return self._get_content() # type: ignore

Variation_883_Arg: TypeAlias = RuleContent_529_Arg
class Variation_883(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_529

    @classmethod
    def create(cls, arg : Variation_883_Arg) -> "Variation_883":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_529:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_529:
        return self.rule.content

RuleVariation_853_Arg: TypeAlias = Variation_883_Arg
class RuleVariation_853(RuleVariationContextFree):
    cv_variation = Variation_883

    @classmethod
    def create(cls, arg : RuleVariation_853_Arg) -> "RuleVariation_853":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_883:
        return self.arg # type: ignore

NonSpare_2013_Arg: TypeAlias = RuleVariation_853_Arg
class NonSpare_2013(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_853

    @classmethod
    def create(cls, arg : NonSpare_2013_Arg) -> "NonSpare_2013":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_853:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_883:
        return self.rule.variation

Item_1129_Arg: TypeAlias = NonSpare_2013_Arg
class Item_1129(Item):
    cv_non_spare = NonSpare_2013

    @classmethod
    def create(cls, arg : Item_1129_Arg) -> "Item_1129":
        return cls._create(arg) # type: ignore

Variation_1327_Arg_Group = Tuple[Union[RuleVariation_707_Arg, Tuple[Literal["EP"], RuleVariation_707_Arg]], Union[RuleVariation_853_Arg, Tuple[Literal["VAL"], RuleVariation_853_Arg]]]
Variation_1327_Arg: TypeAlias = Union[int, Variation_1327_Arg_Group]
class Variation_1327(Group):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_items_list = [(Item_303, 1), (Item_1129, 2)]
    cv_items_dict = {"EP": RuleVariation_707, "VAL": RuleVariation_853}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_707:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_853:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_707:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_853:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1327_Arg) -> 'Variation_1327':
        return cls._create(arg) # type: ignore

RuleVariation_1252_Arg: TypeAlias = Variation_1327_Arg
class RuleVariation_1252(RuleVariationContextFree):
    cv_variation = Variation_1327

    @classmethod
    def create(cls, arg : RuleVariation_1252_Arg) -> "RuleVariation_1252":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1327:
        return self.arg # type: ignore

Content_551_Arg: TypeAlias = int
class Content_551(ContentTable):
    cv_values = {0: "Unknown", 1: "Transponder #1 (left/pilot side or single)", 2: "Transponder #2 (right/co-pilot side)", 3: "Transponder #3 (auxiliary or Backup)"}

RuleContent_551_Arg: TypeAlias = Content_551_Arg
class RuleContent_551(RuleContentContextFree):
    cv_content = Content_551

    @property
    def content(self) -> Content_551:
        return self._get_content() # type: ignore

Variation_478_Arg: TypeAlias = RuleContent_551_Arg
class Variation_478(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_551

    @classmethod
    def create(cls, arg : Variation_478_Arg) -> "Variation_478":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_551:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_551:
        return self.rule.content

RuleVariation_467_Arg: TypeAlias = Variation_478_Arg
class RuleVariation_467(RuleVariationContextFree):
    cv_variation = Variation_478

    @classmethod
    def create(cls, arg : RuleVariation_467_Arg) -> "RuleVariation_467":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_478:
        return self.arg # type: ignore

NonSpare_2001_Arg: TypeAlias = RuleVariation_467_Arg
class NonSpare_2001(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_467

    @classmethod
    def create(cls, arg : NonSpare_2001_Arg) -> "NonSpare_2001":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_467:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_478:
        return self.rule.variation

Item_1117_Arg: TypeAlias = NonSpare_2001_Arg
class Item_1117(Item):
    cv_non_spare = NonSpare_2001

    @classmethod
    def create(cls, arg : Item_1117_Arg) -> "Item_1117":
        return cls._create(arg) # type: ignore

Variation_1091_Arg_Group = Tuple[Union[RuleVariation_41_Arg, Tuple[Literal["EP"], RuleVariation_41_Arg]], Union[RuleVariation_467_Arg, Tuple[Literal["VAL"], RuleVariation_467_Arg]]]
Variation_1091_Arg: TypeAlias = Union[int, Variation_1091_Arg_Group]
class Variation_1091(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_items_list = [(Item_300, 1), (Item_1117, 2)]
    cv_items_dict = {"EP": RuleVariation_41, "VAL": RuleVariation_467}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_467:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_467:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1091_Arg) -> 'Variation_1091':
        return cls._create(arg) # type: ignore

RuleVariation_1049_Arg: TypeAlias = Variation_1091_Arg
class RuleVariation_1049(RuleVariationContextFree):
    cv_variation = Variation_1091

    @classmethod
    def create(cls, arg : RuleVariation_1049_Arg) -> "RuleVariation_1049":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1091:
        return self.arg # type: ignore

Variation_636_Arg: TypeAlias = RuleContent_203_Arg
class Variation_636(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_203

    @classmethod
    def create(cls, arg : Variation_636_Arg) -> "Variation_636":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_203:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_203:
        return self.rule.content

RuleVariation_625_Arg: TypeAlias = Variation_636_Arg
class RuleVariation_625(RuleVariationContextFree):
    cv_variation = Variation_636

    @classmethod
    def create(cls, arg : RuleVariation_625_Arg) -> "RuleVariation_625":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_636:
        return self.arg # type: ignore

NonSpare_935_Arg: TypeAlias = RuleVariation_625_Arg
class NonSpare_935(NonSpare):
    cv_name = "EP"
    cv_title = "Element Populated Bit"
    cv_rule = RuleVariation_625

    @classmethod
    def create(cls, arg : NonSpare_935_Arg) -> "NonSpare_935":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_625:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_636:
        return self.rule.variation

Item_302_Arg: TypeAlias = NonSpare_935_Arg
class Item_302(Item):
    cv_non_spare = NonSpare_935

    @classmethod
    def create(cls, arg : Item_302_Arg) -> "Item_302":
        return cls._create(arg) # type: ignore

Content_263_Arg: TypeAlias = int
class Content_263(ContentTable):
    cv_values = {0: "Manned Operation", 1: "Unmanned Operation"}

RuleContent_263_Arg: TypeAlias = Content_263_Arg
class RuleContent_263(RuleContentContextFree):
    cv_content = Content_263

    @property
    def content(self) -> Content_263:
        return self._get_content() # type: ignore

Variation_728_Arg: TypeAlias = RuleContent_263_Arg
class Variation_728(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_263

    @classmethod
    def create(cls, arg : Variation_728_Arg) -> "Variation_728":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_263:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_263:
        return self.rule.content

RuleVariation_717_Arg: TypeAlias = Variation_728_Arg
class RuleVariation_717(RuleVariationContextFree):
    cv_variation = Variation_728

    @classmethod
    def create(cls, arg : RuleVariation_717_Arg) -> "RuleVariation_717":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_728:
        return self.arg # type: ignore

NonSpare_2008_Arg: TypeAlias = RuleVariation_717_Arg
class NonSpare_2008(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_717

    @classmethod
    def create(cls, arg : NonSpare_2008_Arg) -> "NonSpare_2008":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_717:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_728:
        return self.rule.variation

Item_1124_Arg: TypeAlias = NonSpare_2008_Arg
class Item_1124(Item):
    cv_non_spare = NonSpare_2008

    @classmethod
    def create(cls, arg : Item_1124_Arg) -> "Item_1124":
        return cls._create(arg) # type: ignore

Variation_1321_Arg_Group = Tuple[Union[RuleVariation_625_Arg, Tuple[Literal["EP"], RuleVariation_625_Arg]], Union[RuleVariation_717_Arg, Tuple[Literal["VAL"], RuleVariation_717_Arg]]]
Variation_1321_Arg: TypeAlias = Union[int, Variation_1321_Arg_Group]
class Variation_1321(Group):
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_items_list = [(Item_302, 1), (Item_1124, 1)]
    cv_items_dict = {"EP": RuleVariation_625, "VAL": RuleVariation_717}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_625:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_717:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_625:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_717:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1321_Arg) -> 'Variation_1321':
        return cls._create(arg) # type: ignore

RuleVariation_1246_Arg: TypeAlias = Variation_1321_Arg
class RuleVariation_1246(RuleVariationContextFree):
    cv_variation = Variation_1321

    @classmethod
    def create(cls, arg : RuleVariation_1246_Arg) -> "RuleVariation_1246":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1321:
        return self.arg # type: ignore

Content_433_Arg: TypeAlias = int
class Content_433(ContentTable):
    cv_values = {0: "RWC Corrective Alert not active", 1: "RWC Corrective Alert active"}

RuleContent_433_Arg: TypeAlias = Content_433_Arg
class RuleContent_433(RuleContentContextFree):
    cv_content = Content_433

    @property
    def content(self) -> Content_433:
        return self._get_content() # type: ignore

Variation_943_Arg: TypeAlias = RuleContent_433_Arg
class Variation_943(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_433

    @classmethod
    def create(cls, arg : Variation_943_Arg) -> "Variation_943":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_433:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_433:
        return self.rule.content

RuleVariation_913_Arg: TypeAlias = Variation_943_Arg
class RuleVariation_913(RuleVariationContextFree):
    cv_variation = Variation_943

    @classmethod
    def create(cls, arg : RuleVariation_913_Arg) -> "RuleVariation_913":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_943:
        return self.arg # type: ignore

NonSpare_2015_Arg: TypeAlias = RuleVariation_913_Arg
class NonSpare_2015(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_913

    @classmethod
    def create(cls, arg : NonSpare_2015_Arg) -> "NonSpare_2015":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_913:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_943:
        return self.rule.variation

Item_1131_Arg: TypeAlias = NonSpare_2015_Arg
class Item_1131(Item):
    cv_non_spare = NonSpare_2015

    @classmethod
    def create(cls, arg : Item_1131_Arg) -> "Item_1131":
        return cls._create(arg) # type: ignore

Variation_1331_Arg_Group = Tuple[Union[RuleVariation_815_Arg, Tuple[Literal["EP"], RuleVariation_815_Arg]], Union[RuleVariation_913_Arg, Tuple[Literal["VAL"], RuleVariation_913_Arg]]]
Variation_1331_Arg: TypeAlias = Union[int, Variation_1331_Arg_Group]
class Variation_1331(Group):
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_items_list = [(Item_304, 1), (Item_1131, 1)]
    cv_items_dict = {"EP": RuleVariation_815, "VAL": RuleVariation_913}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_815:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_913:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_815:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_913:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1331_Arg) -> 'Variation_1331':
        return cls._create(arg) # type: ignore

RuleVariation_1254_Arg: TypeAlias = Variation_1331_Arg
class RuleVariation_1254(RuleVariationContextFree):
    cv_variation = Variation_1331

    @classmethod
    def create(cls, arg : RuleVariation_1254_Arg) -> "RuleVariation_1254":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1331:
        return self.arg # type: ignore

Content_315_Arg: TypeAlias = int
class Content_315(ContentTable):
    cv_values = {0: "No RWC Capability", 1: "RWC/RA/OCM Capability", 2: "RWC/OCM Capability", 3: "Invalid ASTERIX Value"}

RuleContent_315_Arg: TypeAlias = Content_315_Arg
class RuleContent_315(RuleContentContextFree):
    cv_content = Content_315

    @property
    def content(self) -> Content_315:
        return self._get_content() # type: ignore

Variation_468_Arg: TypeAlias = RuleContent_315_Arg
class Variation_468(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_315

    @classmethod
    def create(cls, arg : Variation_468_Arg) -> "Variation_468":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_315:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_315:
        return self.rule.content

RuleVariation_457_Arg: TypeAlias = Variation_468_Arg
class RuleVariation_457(RuleVariationContextFree):
    cv_variation = Variation_468

    @classmethod
    def create(cls, arg : RuleVariation_457_Arg) -> "RuleVariation_457":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_468:
        return self.arg # type: ignore

NonSpare_1998_Arg: TypeAlias = RuleVariation_457_Arg
class NonSpare_1998(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_457

    @classmethod
    def create(cls, arg : NonSpare_1998_Arg) -> "NonSpare_1998":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_457:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_468:
        return self.rule.variation

Item_1114_Arg: TypeAlias = NonSpare_1998_Arg
class Item_1114(Item):
    cv_non_spare = NonSpare_1998

    @classmethod
    def create(cls, arg : Item_1114_Arg) -> "Item_1114":
        return cls._create(arg) # type: ignore

Variation_1088_Arg_Group = Tuple[Union[RuleVariation_41_Arg, Tuple[Literal["EP"], RuleVariation_41_Arg]], Union[RuleVariation_457_Arg, Tuple[Literal["VAL"], RuleVariation_457_Arg]]]
Variation_1088_Arg: TypeAlias = Union[int, Variation_1088_Arg_Group]
class Variation_1088(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_items_list = [(Item_300, 1), (Item_1114, 2)]
    cv_items_dict = {"EP": RuleVariation_41, "VAL": RuleVariation_457}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_457:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_457:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1088_Arg) -> 'Variation_1088':
        return cls._create(arg) # type: ignore

RuleVariation_1046_Arg: TypeAlias = Variation_1088_Arg
class RuleVariation_1046(RuleVariationContextFree):
    cv_variation = Variation_1088

    @classmethod
    def create(cls, arg : RuleVariation_1046_Arg) -> "RuleVariation_1046":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1088:
        return self.arg # type: ignore

NonSpare_2010_Arg: TypeAlias = RuleVariation_760_Arg
class NonSpare_2010(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_760

    @classmethod
    def create(cls, arg : NonSpare_2010_Arg) -> "NonSpare_2010":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_760:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_771:
        return self.rule.variation

Item_1126_Arg: TypeAlias = NonSpare_2010_Arg
class Item_1126(Item):
    cv_non_spare = NonSpare_2010

    @classmethod
    def create(cls, arg : Item_1126_Arg) -> "Item_1126":
        return cls._create(arg) # type: ignore

Variation_1323_Arg_Group = Tuple[Union[RuleVariation_625_Arg, Tuple[Literal["EP"], RuleVariation_625_Arg]], Union[RuleVariation_760_Arg, Tuple[Literal["VAL"], RuleVariation_760_Arg]]]
Variation_1323_Arg: TypeAlias = Union[int, Variation_1323_Arg_Group]
class Variation_1323(Group):
    cv_bit_offset8 = 3
    cv_bit_size = 4
    cv_items_list = [(Item_302, 1), (Item_1126, 3)]
    cv_items_dict = {"EP": RuleVariation_625, "VAL": RuleVariation_760}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_625:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_760:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_625:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_760:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1323_Arg) -> 'Variation_1323':
        return cls._create(arg) # type: ignore

RuleVariation_1248_Arg: TypeAlias = Variation_1323_Arg
class RuleVariation_1248(RuleVariationContextFree):
    cv_variation = Variation_1323

    @classmethod
    def create(cls, arg : RuleVariation_1248_Arg) -> "RuleVariation_1248":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1323:
        return self.arg # type: ignore

Content_560_Arg: TypeAlias = int
class Content_560(ContentTable):
    cv_values = {0: "Vertical Only", 1: "Horizontal Only", 2: "Blended", 3: "Vertical Only or Horizontal Only per intruder"}

RuleContent_560_Arg: TypeAlias = Content_560_Arg
class RuleContent_560(RuleContentContextFree):
    cv_content = Content_560

    @property
    def content(self) -> Content_560:
        return self._get_content() # type: ignore

Variation_479_Arg: TypeAlias = RuleContent_560_Arg
class Variation_479(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_560

    @classmethod
    def create(cls, arg : Variation_479_Arg) -> "Variation_479":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_560:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_560:
        return self.rule.content

RuleVariation_468_Arg: TypeAlias = Variation_479_Arg
class RuleVariation_468(RuleVariationContextFree):
    cv_variation = Variation_479

    @classmethod
    def create(cls, arg : RuleVariation_468_Arg) -> "RuleVariation_468":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_479:
        return self.arg # type: ignore

NonSpare_2002_Arg: TypeAlias = RuleVariation_468_Arg
class NonSpare_2002(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_468

    @classmethod
    def create(cls, arg : NonSpare_2002_Arg) -> "NonSpare_2002":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_468:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_479:
        return self.rule.variation

Item_1118_Arg: TypeAlias = NonSpare_2002_Arg
class Item_1118(Item):
    cv_non_spare = NonSpare_2002

    @classmethod
    def create(cls, arg : Item_1118_Arg) -> "Item_1118":
        return cls._create(arg) # type: ignore

Variation_1092_Arg_Group = Tuple[Union[RuleVariation_41_Arg, Tuple[Literal["EP"], RuleVariation_41_Arg]], Union[RuleVariation_468_Arg, Tuple[Literal["VAL"], RuleVariation_468_Arg]]]
Variation_1092_Arg: TypeAlias = Union[int, Variation_1092_Arg_Group]
class Variation_1092(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_items_list = [(Item_300, 1), (Item_1118, 2)]
    cv_items_dict = {"EP": RuleVariation_41, "VAL": RuleVariation_468}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_468:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_468:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1092_Arg) -> 'Variation_1092':
        return cls._create(arg) # type: ignore

RuleVariation_1050_Arg: TypeAlias = Variation_1092_Arg
class RuleVariation_1050(RuleVariationContextFree):
    cv_variation = Variation_1092

    @classmethod
    def create(cls, arg : RuleVariation_1050_Arg) -> "RuleVariation_1050":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1092:
        return self.arg # type: ignore

NonSpare_938_Arg: TypeAlias = RuleVariation_625_Arg
class NonSpare_938(NonSpare):
    cv_name = "EP"
    cv_title = "Element Population Bit"
    cv_rule = RuleVariation_625

    @classmethod
    def create(cls, arg : NonSpare_938_Arg) -> "NonSpare_938":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_625:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_636:
        return self.rule.variation

Item_305_Arg: TypeAlias = NonSpare_938_Arg
class Item_305(Item):
    cv_non_spare = NonSpare_938

    @classmethod
    def create(cls, arg : Item_305_Arg) -> "Item_305":
        return cls._create(arg) # type: ignore

Content_15_Arg: TypeAlias = int
class Content_15(ContentTable):
    cv_values = {0: "Active CAS (TCAS II) or no CAS", 1: "Active CAS (not TCAS II)", 2: "Active CAS (not TCAS II) with OCM transmit capability", 3: "Active CAS of Junior Status", 4: "Passive CAS with 1030TCAS Resolution Message receive capability", 5: "Passive CAS with only OCM receive capability", 6: "Reserved for future use", 7: "Reserved for future use"}

RuleContent_15_Arg: TypeAlias = Content_15_Arg
class RuleContent_15(RuleContentContextFree):
    cv_content = Content_15

    @property
    def content(self) -> Content_15:
        return self._get_content() # type: ignore

Variation_776_Arg: TypeAlias = RuleContent_15_Arg
class Variation_776(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_15

    @classmethod
    def create(cls, arg : Variation_776_Arg) -> "Variation_776":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_15:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_15:
        return self.rule.content

RuleVariation_762_Arg: TypeAlias = Variation_776_Arg
class RuleVariation_762(RuleVariationContextFree):
    cv_variation = Variation_776

    @classmethod
    def create(cls, arg : RuleVariation_762_Arg) -> "RuleVariation_762":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_776:
        return self.arg # type: ignore

NonSpare_2011_Arg: TypeAlias = RuleVariation_762_Arg
class NonSpare_2011(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_762

    @classmethod
    def create(cls, arg : NonSpare_2011_Arg) -> "NonSpare_2011":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_762:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_776:
        return self.rule.variation

Item_1127_Arg: TypeAlias = NonSpare_2011_Arg
class Item_1127(Item):
    cv_non_spare = NonSpare_2011

    @classmethod
    def create(cls, arg : Item_1127_Arg) -> "Item_1127":
        return cls._create(arg) # type: ignore

Variation_1324_Arg_Group = Tuple[Union[RuleVariation_625_Arg, Tuple[Literal["EP"], RuleVariation_625_Arg]], Union[RuleVariation_762_Arg, Tuple[Literal["VAL"], RuleVariation_762_Arg]]]
Variation_1324_Arg: TypeAlias = Union[int, Variation_1324_Arg_Group]
class Variation_1324(Group):
    cv_bit_offset8 = 3
    cv_bit_size = 4
    cv_items_list = [(Item_305, 1), (Item_1127, 3)]
    cv_items_dict = {"EP": RuleVariation_625, "VAL": RuleVariation_762}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_625:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_762:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_625:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_762:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1324_Arg) -> 'Variation_1324':
        return cls._create(arg) # type: ignore

RuleVariation_1249_Arg: TypeAlias = Variation_1324_Arg
class RuleVariation_1249(RuleVariationContextFree):
    cv_variation = Variation_1324

    @classmethod
    def create(cls, arg : RuleVariation_1249_Arg) -> "RuleVariation_1249":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1324:
        return self.arg # type: ignore

Content_202_Arg: TypeAlias = int
class Content_202(ContentTable):
    cv_values = {0: "Element Not Populated", 1: "Element Populated"}

RuleContent_202_Arg: TypeAlias = Content_202_Arg
class RuleContent_202(RuleContentContextFree):
    cv_content = Content_202

    @property
    def content(self) -> Content_202:
        return self._get_content() # type: ignore

Variation_40_Arg: TypeAlias = RuleContent_202_Arg
class Variation_40(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_202

    @classmethod
    def create(cls, arg : Variation_40_Arg) -> "Variation_40":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_202:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_202:
        return self.rule.content

RuleVariation_40_Arg: TypeAlias = Variation_40_Arg
class RuleVariation_40(RuleVariationContextFree):
    cv_variation = Variation_40

    @classmethod
    def create(cls, arg : RuleVariation_40_Arg) -> "RuleVariation_40":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_40:
        return self.arg # type: ignore

NonSpare_932_Arg: TypeAlias = RuleVariation_40_Arg
class NonSpare_932(NonSpare):
    cv_name = "EP"
    cv_title = "Element Populated Bit"
    cv_rule = RuleVariation_40

    @classmethod
    def create(cls, arg : NonSpare_932_Arg) -> "NonSpare_932":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_40:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_40:
        return self.rule.variation

Item_299_Arg: TypeAlias = NonSpare_932_Arg
class Item_299(Item):
    cv_non_spare = NonSpare_932

    @classmethod
    def create(cls, arg : Item_299_Arg) -> "Item_299":
        return cls._create(arg) # type: ignore

Content_342_Arg: TypeAlias = int
class Content_342(ContentTable):
    cv_values = {0: "No data", 1: "0 ≤ TAO ≤ 1", 2: "1 < TAO ≤ 2", 3: "2 < TAO ≤ 4", 4: "4 < TAO ≤ 6", 5: "6 < TAO ≤ 8", 6: "8 < TAO ≤ 10", 7: "10 < TAO ≤ 12", 8: "12 < TAO ≤ 14", 9: "14 < TAO ≤ 16", 10: "16 < TAO ≤ 18", 11: "18 < TAO ≤ 20", 12: "20 < TAO ≤ 22", 13: "22 < TAO ≤ 24", 14: "24 < TAO ≤ 26", 15: "26 < TAO ≤ 28", 16: "28 < TAO ≤ 30", 17: "30 < TAO ≤ 32", 18: "32 < TAO ≤ 34", 19: "34 < TAO ≤ 36", 20: "36 < TAO ≤ 38", 21: "38 < TAO ≤ 40", 22: "40 < TAO ≤ 42", 23: "42 < TAO ≤ 44", 24: "44 < TAO ≤ 46", 25: "46 < TAO ≤ 48", 26: "48 < TAO ≤ 50", 27: "50 < TAO ≤ 52", 28: "52 < TAO ≤ 54", 29: "54 < TAO ≤ 56", 30: "56 < TAO ≤ 58", 31: "TAO > 58"}

RuleContent_342_Arg: TypeAlias = Content_342_Arg
class RuleContent_342(RuleContentContextFree):
    cv_content = Content_342

    @property
    def content(self) -> Content_342:
        return self._get_content() # type: ignore

Variation_487_Arg: TypeAlias = RuleContent_342_Arg
class Variation_487(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 5
    cv_rule = RuleContent_342

    @classmethod
    def create(cls, arg : Variation_487_Arg) -> "Variation_487":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_342:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_342:
        return self.rule.content

RuleVariation_476_Arg: TypeAlias = Variation_487_Arg
class RuleVariation_476(RuleVariationContextFree):
    cv_variation = Variation_487

    @classmethod
    def create(cls, arg : RuleVariation_476_Arg) -> "RuleVariation_476":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_487:
        return self.arg # type: ignore

NonSpare_2004_Arg: TypeAlias = RuleVariation_476_Arg
class NonSpare_2004(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_476

    @classmethod
    def create(cls, arg : NonSpare_2004_Arg) -> "NonSpare_2004":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_476:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_487:
        return self.rule.variation

Item_1120_Arg: TypeAlias = NonSpare_2004_Arg
class Item_1120(Item):
    cv_non_spare = NonSpare_2004

    @classmethod
    def create(cls, arg : Item_1120_Arg) -> "Item_1120":
        return cls._create(arg) # type: ignore

Variation_1087_Arg_Group = Tuple[Union[RuleVariation_40_Arg, Tuple[Literal["EP"], RuleVariation_40_Arg]], Union[RuleVariation_476_Arg, Tuple[Literal["VAL"], RuleVariation_476_Arg]], int]
Variation_1087_Arg: TypeAlias = Union[int, Variation_1087_Arg_Group]
class Variation_1087(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_items_list = [(Item_299, 1), (Item_1120, 5), (Item_26, 1)]
    cv_items_dict = {"EP": RuleVariation_40, "VAL": RuleVariation_476}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_40:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_476:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_40:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_476:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1087_Arg) -> 'Variation_1087':
        return cls._create(arg) # type: ignore

RuleVariation_1045_Arg: TypeAlias = Variation_1087_Arg
class RuleVariation_1045(RuleVariationContextFree):
    cv_variation = Variation_1087

    @classmethod
    def create(cls, arg : RuleVariation_1045_Arg) -> "RuleVariation_1045":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1087:
        return self.arg # type: ignore

NonSpare_955_Arg: TypeAlias = RuleVariation_81_Arg
class NonSpare_955(NonSpare):
    cv_name = "ES"
    cv_title = "ES IN Capability"
    cv_rule = RuleVariation_81

    @classmethod
    def create(cls, arg : NonSpare_955_Arg) -> "NonSpare_955":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_81:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_81:
        return self.rule.variation

Item_319_Arg: TypeAlias = NonSpare_955_Arg
class Item_319(Item):
    cv_non_spare = NonSpare_955

    @classmethod
    def create(cls, arg : Item_319_Arg) -> "Item_319":
        return cls._create(arg) # type: ignore

NonSpare_1972_Arg: TypeAlias = RuleVariation_440_Arg
class NonSpare_1972(NonSpare):
    cv_name = "UAT"
    cv_title = "UAT IN Capability"
    cv_rule = RuleVariation_440

    @classmethod
    def create(cls, arg : NonSpare_1972_Arg) -> "NonSpare_1972":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_440:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_451:
        return self.rule.variation

Item_1090_Arg: TypeAlias = NonSpare_1972_Arg
class Item_1090(Item):
    cv_non_spare = NonSpare_1972

    @classmethod
    def create(cls, arg : Item_1090_Arg) -> "Item_1090":
        return cls._create(arg) # type: ignore

NonSpare_1546_Arg: TypeAlias = RuleVariation_1242_Arg
class NonSpare_1546(NonSpare):
    cv_name = "RCE"
    cv_title = "Reduced Capability Equipment"
    cv_rule = RuleVariation_1242

    @classmethod
    def create(cls, arg : NonSpare_1546_Arg) -> "NonSpare_1546":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1242:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1317:
        return self.rule.variation

Item_780_Arg: TypeAlias = NonSpare_1546_Arg
class Item_780(Item):
    cv_non_spare = NonSpare_1546

    @classmethod
    def create(cls, arg : Item_780_Arg) -> "Item_780":
        return cls._create(arg) # type: ignore

NonSpare_1603_Arg: TypeAlias = RuleVariation_1255_Arg
class NonSpare_1603(NonSpare):
    cv_name = "RRL"
    cv_title = "Reply Rate Limiting"
    cv_rule = RuleVariation_1255

    @classmethod
    def create(cls, arg : NonSpare_1603_Arg) -> "NonSpare_1603":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1255:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1332:
        return self.rule.variation

Item_827_Arg: TypeAlias = NonSpare_1603_Arg
class Item_827(Item):
    cv_non_spare = NonSpare_1603

    @classmethod
    def create(cls, arg : Item_827_Arg) -> "Item_827":
        return cls._create(arg) # type: ignore

NonSpare_1460_Arg: TypeAlias = RuleVariation_1051_Arg
class NonSpare_1460(NonSpare):
    cv_name = "PS3"
    cv_title = "Priority Status for Version 3 ADS-B Systems"
    cv_rule = RuleVariation_1051

    @classmethod
    def create(cls, arg : NonSpare_1460_Arg) -> "NonSpare_1460":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1051:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1093:
        return self.rule.variation

Item_708_Arg: TypeAlias = NonSpare_1460_Arg
class Item_708(Item):
    cv_non_spare = NonSpare_1460

    @classmethod
    def create(cls, arg : Item_708_Arg) -> "Item_708":
        return cls._create(arg) # type: ignore

NonSpare_1890_Arg: TypeAlias = RuleVariation_1252_Arg
class NonSpare_1890(NonSpare):
    cv_name = "TPW"
    cv_title = "Transmit Power"
    cv_rule = RuleVariation_1252

    @classmethod
    def create(cls, arg : NonSpare_1890_Arg) -> "NonSpare_1890":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1252:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1327:
        return self.rule.variation

Item_1019_Arg: TypeAlias = NonSpare_1890_Arg
class Item_1019(Item):
    cv_non_spare = NonSpare_1890

    @classmethod
    def create(cls, arg : Item_1019_Arg) -> "Item_1019":
        return cls._create(arg) # type: ignore

NonSpare_1923_Arg: TypeAlias = RuleVariation_1049_Arg
class NonSpare_1923(NonSpare):
    cv_name = "TSI"
    cv_title = "Transponder Side Indication"
    cv_rule = RuleVariation_1049

    @classmethod
    def create(cls, arg : NonSpare_1923_Arg) -> "NonSpare_1923":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1049:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1091:
        return self.rule.variation

Item_1046_Arg: TypeAlias = NonSpare_1923_Arg
class Item_1046(Item):
    cv_non_spare = NonSpare_1923

    @classmethod
    def create(cls, arg : Item_1046_Arg) -> "Item_1046":
        return cls._create(arg) # type: ignore

NonSpare_1328_Arg: TypeAlias = RuleVariation_1246_Arg
class NonSpare_1328(NonSpare):
    cv_name = "MUO"
    cv_title = "Manned / Unmanned Operation"
    cv_rule = RuleVariation_1246

    @classmethod
    def create(cls, arg : NonSpare_1328_Arg) -> "NonSpare_1328":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1321:
        return self.rule.variation

Item_597_Arg: TypeAlias = NonSpare_1328_Arg
class Item_597(Item):
    cv_non_spare = NonSpare_1328

    @classmethod
    def create(cls, arg : Item_597_Arg) -> "Item_597":
        return cls._create(arg) # type: ignore

NonSpare_1633_Arg: TypeAlias = RuleVariation_1254_Arg
class NonSpare_1633(NonSpare):
    cv_name = "RWC"
    cv_title = "Remain Well Clear Corrective Alert"
    cv_rule = RuleVariation_1254

    @classmethod
    def create(cls, arg : NonSpare_1633_Arg) -> "NonSpare_1633":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1254:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1331:
        return self.rule.variation

Item_843_Arg: TypeAlias = NonSpare_1633_Arg
class Item_843(Item):
    cv_non_spare = NonSpare_1633

    @classmethod
    def create(cls, arg : Item_843_Arg) -> "Item_843":
        return cls._create(arg) # type: ignore

NonSpare_852_Arg: TypeAlias = RuleVariation_1046_Arg
class NonSpare_852(NonSpare):
    cv_name = "DAA"
    cv_title = "Detectand Avoid Capabilities"
    cv_rule = RuleVariation_1046

    @classmethod
    def create(cls, arg : NonSpare_852_Arg) -> "NonSpare_852":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1046:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1088:
        return self.rule.variation

Item_237_Arg: TypeAlias = NonSpare_852_Arg
class Item_237(Item):
    cv_non_spare = NonSpare_852

    @classmethod
    def create(cls, arg : Item_237_Arg) -> "Item_237":
        return cls._create(arg) # type: ignore

NonSpare_874_Arg: TypeAlias = RuleVariation_1248_Arg
class NonSpare_874(NonSpare):
    cv_name = "DF17CA"
    cv_title = "Transponder Capability"
    cv_rule = RuleVariation_1248

    @classmethod
    def create(cls, arg : NonSpare_874_Arg) -> "NonSpare_874":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1248:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1323:
        return self.rule.variation

Item_257_Arg: TypeAlias = NonSpare_874_Arg
class Item_257(Item):
    cv_non_spare = NonSpare_874

    @classmethod
    def create(cls, arg : Item_257_Arg) -> "Item_257":
        return cls._create(arg) # type: ignore

NonSpare_1805_Arg: TypeAlias = RuleVariation_1050_Arg
class NonSpare_1805(NonSpare):
    cv_name = "SVH"
    cv_title = "Sense Vertical & Horizontal"
    cv_rule = RuleVariation_1050

    @classmethod
    def create(cls, arg : NonSpare_1805_Arg) -> "NonSpare_1805":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1050:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1092:
        return self.rule.variation

Item_963_Arg: TypeAlias = NonSpare_1805_Arg
class Item_963(Item):
    cv_non_spare = NonSpare_1805

    @classmethod
    def create(cls, arg : Item_963_Arg) -> "Item_963":
        return cls._create(arg) # type: ignore

NonSpare_702_Arg: TypeAlias = RuleVariation_1249_Arg
class NonSpare_702(NonSpare):
    cv_name = "CATC"
    cv_title = "CAS Type & Capability"
    cv_rule = RuleVariation_1249

    @classmethod
    def create(cls, arg : NonSpare_702_Arg) -> "NonSpare_702":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1249:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1324:
        return self.rule.variation

Item_137_Arg: TypeAlias = NonSpare_702_Arg
class Item_137(Item):
    cv_non_spare = NonSpare_702

    @classmethod
    def create(cls, arg : Item_137_Arg) -> "Item_137":
        return cls._create(arg) # type: ignore

NonSpare_1815_Arg: TypeAlias = RuleVariation_1045_Arg
class NonSpare_1815(NonSpare):
    cv_name = "TAO"
    cv_title = "Transponder Antenna Offset"
    cv_rule = RuleVariation_1045

    @classmethod
    def create(cls, arg : NonSpare_1815_Arg) -> "NonSpare_1815":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1045:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1087:
        return self.rule.variation

Item_969_Arg: TypeAlias = NonSpare_1815_Arg
class Item_969(Item):
    cv_non_spare = NonSpare_1815

    @classmethod
    def create(cls, arg : Item_969_Arg) -> "Item_969":
        return cls._create(arg) # type: ignore

Variation_1350_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_81_Arg, Tuple[Literal["ES"], RuleVariation_81_Arg]], Union[RuleVariation_440_Arg, Tuple[Literal["UAT"], RuleVariation_440_Arg]], Union[RuleVariation_1242_Arg, Tuple[Literal["RCE"], RuleVariation_1242_Arg]], Union[RuleVariation_1255_Arg, Tuple[Literal["RRL"], RuleVariation_1255_Arg]], None]]
Variation_1350_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_1051_Arg, Tuple[Literal["PS3"], RuleVariation_1051_Arg]], Union[RuleVariation_1252_Arg, Tuple[Literal["TPW"], RuleVariation_1252_Arg]], None]]
Variation_1350_Arg_Group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_1049_Arg, Tuple[Literal["TSI"], RuleVariation_1049_Arg]], Union[RuleVariation_1246_Arg, Tuple[Literal["MUO"], RuleVariation_1246_Arg]], Union[RuleVariation_1254_Arg, Tuple[Literal["RWC"], RuleVariation_1254_Arg]], None]]
Variation_1350_Arg_Group_4: TypeAlias = Union[int, Tuple[Union[RuleVariation_1046_Arg, Tuple[Literal["DAA"], RuleVariation_1046_Arg]], Union[RuleVariation_1248_Arg, Tuple[Literal["DF17CA"], RuleVariation_1248_Arg]], None]]
Variation_1350_Arg_Group_5: TypeAlias = Union[int, Tuple[Union[RuleVariation_1050_Arg, Tuple[Literal["SVH"], RuleVariation_1050_Arg]], Union[RuleVariation_1249_Arg, Tuple[Literal["CATC"], RuleVariation_1249_Arg]], None]]
Variation_1350_Arg_Group_6: TypeAlias = Union[int, Tuple[Union[RuleVariation_1045_Arg, Tuple[Literal["TAO"], RuleVariation_1045_Arg]], None]]
Variation_1350_Arg: TypeAlias = Union[
    Tuple[Variation_1350_Arg_Group_1],
    Tuple[Variation_1350_Arg_Group_1, Variation_1350_Arg_Group_2],
    Tuple[Variation_1350_Arg_Group_1, Variation_1350_Arg_Group_2, Variation_1350_Arg_Group_3],
    Tuple[Variation_1350_Arg_Group_1, Variation_1350_Arg_Group_2, Variation_1350_Arg_Group_3, Variation_1350_Arg_Group_4],
    Tuple[Variation_1350_Arg_Group_1, Variation_1350_Arg_Group_2, Variation_1350_Arg_Group_3, Variation_1350_Arg_Group_4, Variation_1350_Arg_Group_5],
    Tuple[Variation_1350_Arg_Group_1, Variation_1350_Arg_Group_2, Variation_1350_Arg_Group_3, Variation_1350_Arg_Group_4, Variation_1350_Arg_Group_5, Variation_1350_Arg_Group_6],
]
class Variation_1350(Extended):
    cv_items_list = [[(Item_319, 1), (Item_1090, 1), (Item_780, 3), (Item_827, 2), None], [(Item_708, 4), (Item_1019, 3), None], [(Item_1046, 3), (Item_597, 2), (Item_843, 2), None], [(Item_237, 3), (Item_257, 4), None], [(Item_963, 3), (Item_137, 4), None], [(Item_969, 7), None]]

    @classmethod
    def create(cls, arg : Variation_1350_Arg) -> 'Variation_1350':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["ES"]) -> RuleVariation_81:
        ...
    @overload
    def get_item(self, key : Literal["UAT"]) -> RuleVariation_440:
        ...
    @overload
    def get_item(self, key : Literal["RCE"]) -> RuleVariation_1242:
        ...
    @overload
    def get_item(self, key : Literal["RRL"]) -> RuleVariation_1255:
        ...
    @overload
    def get_item(self, key : Literal["PS3"]) -> Optional[RuleVariation_1051]:
        ...
    @overload
    def get_item(self, key : Literal["TPW"]) -> Optional[RuleVariation_1252]:
        ...
    @overload
    def get_item(self, key : Literal["TSI"]) -> Optional[RuleVariation_1049]:
        ...
    @overload
    def get_item(self, key : Literal["MUO"]) -> Optional[RuleVariation_1246]:
        ...
    @overload
    def get_item(self, key : Literal["RWC"]) -> Optional[RuleVariation_1254]:
        ...
    @overload
    def get_item(self, key : Literal["DAA"]) -> Optional[RuleVariation_1046]:
        ...
    @overload
    def get_item(self, key : Literal["DF17CA"]) -> Optional[RuleVariation_1248]:
        ...
    @overload
    def get_item(self, key : Literal["SVH"]) -> Optional[RuleVariation_1050]:
        ...
    @overload
    def get_item(self, key : Literal["CATC"]) -> Optional[RuleVariation_1249]:
        ...
    @overload
    def get_item(self, key : Literal["TAO"]) -> Optional[RuleVariation_1045]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1273_Arg: TypeAlias = Variation_1350_Arg
class RuleVariation_1273(RuleVariationContextFree):
    cv_variation = Variation_1350

    @classmethod
    def create(cls, arg : RuleVariation_1273_Arg) -> "RuleVariation_1273":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1350:
        return self.arg # type: ignore

NonSpare_1761_Arg: TypeAlias = RuleVariation_1273_Arg
class NonSpare_1761(NonSpare):
    cv_name = "STA"
    cv_title = "Aircraft Status"
    cv_rule = RuleVariation_1273

    @classmethod
    def create(cls, arg : NonSpare_1761_Arg) -> "NonSpare_1761":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1273:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1350:
        return self.rule.variation

Expansion_1_Arg = TypedDict('Expansion_1_Arg', {
    "BPS": NonSpare_687_Arg,
    "SH": NonSpare_1696_Arg,
    "NAV": NonSpare_1338_Arg,
    "GAO": NonSpare_1013_Arg,
    "SGV": NonSpare_1694_Arg,
    "STA": NonSpare_1761_Arg,
    "TNH": NonSpare_1869_Arg,
    "MES": NonSpare_1260_Arg,
}, total=False)
class Expansion_1(Expansion):
    cv_fspec_bytes = 1
    cv_items_list = [NonSpare_687, NonSpare_1696, NonSpare_1338, NonSpare_1013, NonSpare_1694, NonSpare_1761, NonSpare_1869, NonSpare_1260]
    items_dict = {"BPS": NonSpare_687, "SH": NonSpare_1696, "NAV": NonSpare_1338, "GAO": NonSpare_1013, "SGV": NonSpare_1694, "STA": NonSpare_1761, "TNH": NonSpare_1869, "MES": NonSpare_1260}

    @overload
    @classmethod
    def spec(cls, key : Literal["BPS"]) -> NonSpare_687:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SH"]) -> NonSpare_1696:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NAV"]) -> NonSpare_1338:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GAO"]) -> NonSpare_1013:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SGV"]) -> NonSpare_1694:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STA"]) -> NonSpare_1761:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TNH"]) -> NonSpare_1869:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MES"]) -> NonSpare_1260:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["BPS"], Literal["SH"], Literal["NAV"], Literal["GAO"], Literal["SGV"], Literal["STA"], Literal["TNH"], Literal["MES"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["BPS"]) -> Optional[NonSpare_687]:
        ...
    @overload
    def get_item(self, key : Literal["SH"]) -> Optional[NonSpare_1696]:
        ...
    @overload
    def get_item(self, key : Literal["NAV"]) -> Optional[NonSpare_1338]:
        ...
    @overload
    def get_item(self, key : Literal["GAO"]) -> Optional[NonSpare_1013]:
        ...
    @overload
    def get_item(self, key : Literal["SGV"]) -> Optional[NonSpare_1694]:
        ...
    @overload
    def get_item(self, key : Literal["STA"]) -> Optional[NonSpare_1761]:
        ...
    @overload
    def get_item(self, key : Literal["TNH"]) -> Optional[NonSpare_1869]:
        ...
    @overload
    def get_item(self, key : Literal["MES"]) -> Optional[NonSpare_1260]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["BPS"], val : NonSpare_687_Arg) -> "Expansion_1":
        ...
    @overload
    def set_item(self, key : Literal["SH"], val : NonSpare_1696_Arg) -> "Expansion_1":
        ...
    @overload
    def set_item(self, key : Literal["NAV"], val : NonSpare_1338_Arg) -> "Expansion_1":
        ...
    @overload
    def set_item(self, key : Literal["GAO"], val : NonSpare_1013_Arg) -> "Expansion_1":
        ...
    @overload
    def set_item(self, key : Literal["SGV"], val : NonSpare_1694_Arg) -> "Expansion_1":
        ...
    @overload
    def set_item(self, key : Literal["STA"], val : NonSpare_1761_Arg) -> "Expansion_1":
        ...
    @overload
    def set_item(self, key : Literal["TNH"], val : NonSpare_1869_Arg) -> "Expansion_1":
        ...
    @overload
    def set_item(self, key : Literal["MES"], val : NonSpare_1260_Arg) -> "Expansion_1":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["BPS"]) -> "Expansion_1":
        ...
    @overload
    def del_item(self, key : Literal["SH"]) -> "Expansion_1":
        ...
    @overload
    def del_item(self, key : Literal["NAV"]) -> "Expansion_1":
        ...
    @overload
    def del_item(self, key : Literal["GAO"]) -> "Expansion_1":
        ...
    @overload
    def del_item(self, key : Literal["SGV"]) -> "Expansion_1":
        ...
    @overload
    def del_item(self, key : Literal["STA"]) -> "Expansion_1":
        ...
    @overload
    def del_item(self, key : Literal["TNH"]) -> "Expansion_1":
        ...
    @overload
    def del_item(self, key : Literal["MES"]) -> "Expansion_1":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Expansion_1_Arg) -> 'Expansion_1':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Expansion_1", Bits]]:
        return cls._parse(bs) # type: ignore

class Asterix_27(AstRef):
    cv_category = 21
    cv_edition = (1, 5)
    cv_expansion = Expansion_1

Content_5_Arg: TypeAlias = int
class Content_5(ContentTable):
    cv_values = {0: "24-Bit ICAO address", 1: "Duplicate address", 2: "Surface vehicle address", 3: "Anonymous address", 4: "Reserved for future use", 5: "Reserved for future use", 6: "Reserved for future use", 7: "Reserved for future use"}

RuleContent_5_Arg: TypeAlias = Content_5_Arg
class RuleContent_5(RuleContentContextFree):
    cv_content = Content_5

    @property
    def content(self) -> Content_5:
        return self._get_content() # type: ignore

Variation_121_Arg: TypeAlias = RuleContent_5_Arg
class Variation_121(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_5

    @classmethod
    def create(cls, arg : Variation_121_Arg) -> "Variation_121":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_5:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_5:
        return self.rule.content

RuleVariation_121_Arg: TypeAlias = Variation_121_Arg
class RuleVariation_121(RuleVariationContextFree):
    cv_variation = Variation_121

    @classmethod
    def create(cls, arg : RuleVariation_121_Arg) -> "RuleVariation_121":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_121:
        return self.arg # type: ignore

Content_6_Arg: TypeAlias = int
class Content_6(ContentTable):
    cv_values = {0: "25 ft", 1: "100 ft", 2: "Unknown", 3: "Invalid"}

RuleContent_6_Arg: TypeAlias = Content_6_Arg
class RuleContent_6(RuleContentContextFree):
    cv_content = Content_6

    @property
    def content(self) -> Content_6:
        return self._get_content() # type: ignore

Variation_674_Arg: TypeAlias = RuleContent_6_Arg
class Variation_674(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_rule = RuleContent_6

    @classmethod
    def create(cls, arg : Variation_674_Arg) -> "Variation_674":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_6:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_6:
        return self.rule.content

RuleVariation_663_Arg: TypeAlias = Variation_674_Arg
class RuleVariation_663(RuleVariationContextFree):
    cv_variation = Variation_674

    @classmethod
    def create(cls, arg : RuleVariation_663_Arg) -> "RuleVariation_663":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_674:
        return self.arg # type: ignore

Content_144_Arg: TypeAlias = int
class Content_144(ContentTable):
    cv_values = {0: "Default", 1: "Range Check passed, CPR Validation pending"}

RuleContent_144_Arg: TypeAlias = Content_144_Arg
class RuleContent_144(RuleContentContextFree):
    cv_content = Content_144

    @property
    def content(self) -> Content_144:
        return self._get_content() # type: ignore

Variation_832_Arg: TypeAlias = RuleContent_144_Arg
class Variation_832(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_144

    @classmethod
    def create(cls, arg : Variation_832_Arg) -> "Variation_832":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_144:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_144:
        return self.rule.content

RuleVariation_802_Arg: TypeAlias = Variation_832_Arg
class RuleVariation_802(RuleVariationContextFree):
    cv_variation = Variation_832

    @classmethod
    def create(cls, arg : RuleVariation_802_Arg) -> "RuleVariation_802":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_832:
        return self.arg # type: ignore

Variation_946_Arg: TypeAlias = RuleContent_440_Arg
class Variation_946(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_440

    @classmethod
    def create(cls, arg : Variation_946_Arg) -> "Variation_946":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_440:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_440:
        return self.rule.content

RuleVariation_916_Arg: TypeAlias = Variation_946_Arg
class RuleVariation_916(RuleVariationContextFree):
    cv_variation = Variation_946

    @classmethod
    def create(cls, arg : RuleVariation_916_Arg) -> "RuleVariation_916":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_946:
        return self.arg # type: ignore

Variation_719_Arg: TypeAlias = RuleContent_209_Arg
class Variation_719(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_209

    @classmethod
    def create(cls, arg : Variation_719_Arg) -> "Variation_719":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_209:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_209:
        return self.rule.content

RuleVariation_708_Arg: TypeAlias = Variation_719_Arg
class RuleVariation_708(RuleVariationContextFree):
    cv_variation = Variation_719

    @classmethod
    def create(cls, arg : RuleVariation_708_Arg) -> "RuleVariation_708":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_719:
        return self.arg # type: ignore

Content_442_Arg: TypeAlias = int
class Content_442(ContentTable):
    cv_values = {0: "Report valid", 1: "Report suspect", 2: "No information", 3: "Reserved for future use"}

RuleContent_442_Arg: TypeAlias = Content_442_Arg
class RuleContent_442(RuleContentContextFree):
    cv_content = Content_442

    @property
    def content(self) -> Content_442:
        return self._get_content() # type: ignore

Variation_880_Arg: TypeAlias = RuleContent_442_Arg
class Variation_880(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_442

    @classmethod
    def create(cls, arg : Variation_880_Arg) -> "Variation_880":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_442:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_442:
        return self.rule.content

RuleVariation_850_Arg: TypeAlias = Variation_880_Arg
class RuleVariation_850(RuleVariationContextFree):
    cv_variation = Variation_880

    @classmethod
    def create(cls, arg : RuleVariation_850_Arg) -> "RuleVariation_850":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_880:
        return self.arg # type: ignore

Content_169_Arg: TypeAlias = int
class Content_169(ContentTable):
    cv_values = {0: "Default (see note)", 1: "Independent Position Check failed"}

RuleContent_169_Arg: TypeAlias = Content_169_Arg
class RuleContent_169(RuleContentContextFree):
    cv_content = Content_169

    @property
    def content(self) -> Content_169:
        return self._get_content() # type: ignore

Variation_523_Arg: TypeAlias = RuleContent_169_Arg
class Variation_523(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_169

    @classmethod
    def create(cls, arg : Variation_523_Arg) -> "Variation_523":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_169:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_169:
        return self.rule.content

RuleVariation_512_Arg: TypeAlias = Variation_523_Arg
class RuleVariation_512(RuleVariationContextFree):
    cv_variation = Variation_523

    @classmethod
    def create(cls, arg : RuleVariation_512_Arg) -> "RuleVariation_512":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_523:
        return self.arg # type: ignore

Content_299_Arg: TypeAlias = int
class Content_299(ContentTable):
    cv_values = {0: "NOGO-bit not set", 1: "NOGO-bit set"}

RuleContent_299_Arg: TypeAlias = Content_299_Arg
class RuleContent_299(RuleContentContextFree):
    cv_content = Content_299

    @property
    def content(self) -> Content_299:
        return self._get_content() # type: ignore

Variation_647_Arg: TypeAlias = RuleContent_299_Arg
class Variation_647(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_299

    @classmethod
    def create(cls, arg : Variation_647_Arg) -> "Variation_647":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_299:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_299:
        return self.rule.content

RuleVariation_636_Arg: TypeAlias = Variation_647_Arg
class RuleVariation_636(RuleVariationContextFree):
    cv_variation = Variation_647

    @classmethod
    def create(cls, arg : RuleVariation_636_Arg) -> "RuleVariation_636":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_647:
        return self.arg # type: ignore

Content_49_Arg: TypeAlias = int
class Content_49(ContentTable):
    cv_values = {0: "CPR Validation correct", 1: "CPR Validation failed"}

RuleContent_49_Arg: TypeAlias = Content_49_Arg
class RuleContent_49(RuleContentContextFree):
    cv_content = Content_49

    @property
    def content(self) -> Content_49:
        return self._get_content() # type: ignore

Variation_699_Arg: TypeAlias = RuleContent_49_Arg
class Variation_699(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_49

    @classmethod
    def create(cls, arg : Variation_699_Arg) -> "Variation_699":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_49:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_49:
        return self.rule.content

RuleVariation_688_Arg: TypeAlias = Variation_699_Arg
class RuleVariation_688(RuleVariationContextFree):
    cv_variation = Variation_699

    @classmethod
    def create(cls, arg : RuleVariation_688_Arg) -> "RuleVariation_688":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_699:
        return self.arg # type: ignore

Content_247_Arg: TypeAlias = int
class Content_247(ContentTable):
    cv_values = {0: "LDPJ not detected", 1: "LDPJ detected"}

RuleContent_247_Arg: TypeAlias = Content_247_Arg
class RuleContent_247(RuleContentContextFree):
    cv_content = Content_247

    @property
    def content(self) -> Content_247:
        return self._get_content() # type: ignore

Variation_855_Arg: TypeAlias = RuleContent_247_Arg
class Variation_855(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_247

    @classmethod
    def create(cls, arg : Variation_855_Arg) -> "Variation_855":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_247:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_247:
        return self.rule.content

RuleVariation_825_Arg: TypeAlias = Variation_855_Arg
class RuleVariation_825(RuleVariationContextFree):
    cv_variation = Variation_855

    @classmethod
    def create(cls, arg : RuleVariation_825_Arg) -> "RuleVariation_825":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_855:
        return self.arg # type: ignore

Content_143_Arg: TypeAlias = int
class Content_143(ContentTable):
    cv_values = {0: "Default", 1: "Range Check failed"}

RuleContent_143_Arg: TypeAlias = Content_143_Arg
class RuleContent_143(RuleContentContextFree):
    cv_content = Content_143

    @property
    def content(self) -> Content_143:
        return self._get_content() # type: ignore

Variation_915_Arg: TypeAlias = RuleContent_143_Arg
class Variation_915(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_143

    @classmethod
    def create(cls, arg : Variation_915_Arg) -> "Variation_915":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_143:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_143:
        return self.rule.content

RuleVariation_885_Arg: TypeAlias = Variation_915_Arg
class RuleVariation_885(RuleVariationContextFree):
    cv_variation = Variation_915

    @classmethod
    def create(cls, arg : RuleVariation_885_Arg) -> "RuleVariation_885":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_915:
        return self.arg # type: ignore

NonSpare_638_Arg: TypeAlias = RuleVariation_121_Arg
class NonSpare_638(NonSpare):
    cv_name = "ATP"
    cv_title = "Address Type"
    cv_rule = RuleVariation_121

    @classmethod
    def create(cls, arg : NonSpare_638_Arg) -> "NonSpare_638":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_121:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_121:
        return self.rule.variation

Item_89_Arg: TypeAlias = NonSpare_638_Arg
class Item_89(Item):
    cv_non_spare = NonSpare_638

    @classmethod
    def create(cls, arg : Item_89_Arg) -> "Item_89":
        return cls._create(arg) # type: ignore

NonSpare_622_Arg: TypeAlias = RuleVariation_663_Arg
class NonSpare_622(NonSpare):
    cv_name = "ARC"
    cv_title = "Altitude Reporting Capability"
    cv_rule = RuleVariation_663

    @classmethod
    def create(cls, arg : NonSpare_622_Arg) -> "NonSpare_622":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_663:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_674:
        return self.rule.variation

Item_82_Arg: TypeAlias = NonSpare_622_Arg
class Item_82(Item):
    cv_non_spare = NonSpare_622

    @classmethod
    def create(cls, arg : Item_82_Arg) -> "Item_82":
        return cls._create(arg) # type: ignore

NonSpare_1543_Arg: TypeAlias = RuleVariation_802_Arg
class NonSpare_1543(NonSpare):
    cv_name = "RC"
    cv_title = "Range Check"
    cv_rule = RuleVariation_802

    @classmethod
    def create(cls, arg : NonSpare_1543_Arg) -> "NonSpare_1543":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_802:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_832:
        return self.rule.variation

Item_777_Arg: TypeAlias = NonSpare_1543_Arg
class Item_777(Item):
    cv_non_spare = NonSpare_1543

    @classmethod
    def create(cls, arg : Item_777_Arg) -> "Item_777":
        return cls._create(arg) # type: ignore

NonSpare_1532_Arg: TypeAlias = RuleVariation_916_Arg
class NonSpare_1532(NonSpare):
    cv_name = "RAB"
    cv_title = "Report Type"
    cv_rule = RuleVariation_916

    @classmethod
    def create(cls, arg : NonSpare_1532_Arg) -> "NonSpare_1532":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_916:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_946:
        return self.rule.variation

Item_768_Arg: TypeAlias = NonSpare_1532_Arg
class Item_768(Item):
    cv_non_spare = NonSpare_1532

    @classmethod
    def create(cls, arg : Item_768_Arg) -> "Item_768":
        return cls._create(arg) # type: ignore

NonSpare_1640_Arg: TypeAlias = RuleVariation_708_Arg
class NonSpare_1640(NonSpare):
    cv_name = "SAA"
    cv_title = "Selected Altitude Available"
    cv_rule = RuleVariation_708

    @classmethod
    def create(cls, arg : NonSpare_1640_Arg) -> "NonSpare_1640":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_708:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_719:
        return self.rule.variation

Item_849_Arg: TypeAlias = NonSpare_1640_Arg
class Item_849(Item):
    cv_non_spare = NonSpare_1640

    @classmethod
    def create(cls, arg : Item_849_Arg) -> "Item_849":
        return cls._create(arg) # type: ignore

NonSpare_735_Arg: TypeAlias = RuleVariation_850_Arg
class NonSpare_735(NonSpare):
    cv_name = "CL"
    cv_title = "Confidence Level"
    cv_rule = RuleVariation_850

    @classmethod
    def create(cls, arg : NonSpare_735_Arg) -> "NonSpare_735":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_850:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_880:
        return self.rule.variation

Item_160_Arg: TypeAlias = NonSpare_735_Arg
class Item_160(Item):
    cv_non_spare = NonSpare_735

    @classmethod
    def create(cls, arg : Item_160_Arg) -> "Item_160":
        return cls._create(arg) # type: ignore

NonSpare_1114_Arg: TypeAlias = RuleVariation_512_Arg
class NonSpare_1114(NonSpare):
    cv_name = "IPC"
    cv_title = "Independent Position Check"
    cv_rule = RuleVariation_512

    @classmethod
    def create(cls, arg : NonSpare_1114_Arg) -> "NonSpare_1114":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_512:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_523:
        return self.rule.variation

Item_434_Arg: TypeAlias = NonSpare_1114_Arg
class Item_434(Item):
    cv_non_spare = NonSpare_1114

    @classmethod
    def create(cls, arg : Item_434_Arg) -> "Item_434":
        return cls._create(arg) # type: ignore

NonSpare_1357_Arg: TypeAlias = RuleVariation_636_Arg
class NonSpare_1357(NonSpare):
    cv_name = "NOGO"
    cv_title = "No-go Bit Status"
    cv_rule = RuleVariation_636

    @classmethod
    def create(cls, arg : NonSpare_1357_Arg) -> "NonSpare_1357":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_636:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_647:
        return self.rule.variation

Item_623_Arg: TypeAlias = NonSpare_1357_Arg
class Item_623(Item):
    cv_non_spare = NonSpare_1357

    @classmethod
    def create(cls, arg : Item_623_Arg) -> "Item_623":
        return cls._create(arg) # type: ignore

NonSpare_815_Arg: TypeAlias = RuleVariation_688_Arg
class NonSpare_815(NonSpare):
    cv_name = "CPR"
    cv_title = "Compact Position Reporting"
    cv_rule = RuleVariation_688

    @classmethod
    def create(cls, arg : NonSpare_815_Arg) -> "NonSpare_815":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_688:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_699:
        return self.rule.variation

Item_209_Arg: TypeAlias = NonSpare_815_Arg
class Item_209(Item):
    cv_non_spare = NonSpare_815

    @classmethod
    def create(cls, arg : Item_209_Arg) -> "Item_209":
        return cls._create(arg) # type: ignore

NonSpare_1157_Arg: TypeAlias = RuleVariation_825_Arg
class NonSpare_1157(NonSpare):
    cv_name = "LDPJ"
    cv_title = "Local Decoding Position Jump"
    cv_rule = RuleVariation_825

    @classmethod
    def create(cls, arg : NonSpare_1157_Arg) -> "NonSpare_1157":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_825:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_855:
        return self.rule.variation

Item_474_Arg: TypeAlias = NonSpare_1157_Arg
class Item_474(Item):
    cv_non_spare = NonSpare_1157

    @classmethod
    def create(cls, arg : Item_474_Arg) -> "Item_474":
        return cls._create(arg) # type: ignore

NonSpare_1547_Arg: TypeAlias = RuleVariation_885_Arg
class NonSpare_1547(NonSpare):
    cv_name = "RCF"
    cv_title = "Range Check"
    cv_rule = RuleVariation_885

    @classmethod
    def create(cls, arg : NonSpare_1547_Arg) -> "NonSpare_1547":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_885:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_915:
        return self.rule.variation

Item_781_Arg: TypeAlias = NonSpare_1547_Arg
class Item_781(Item):
    cv_non_spare = NonSpare_1547

    @classmethod
    def create(cls, arg : Item_781_Arg) -> "Item_781":
        return cls._create(arg) # type: ignore

Variation_1341_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_121_Arg, Tuple[Literal["ATP"], RuleVariation_121_Arg]], Union[RuleVariation_663_Arg, Tuple[Literal["ARC"], RuleVariation_663_Arg]], Union[RuleVariation_802_Arg, Tuple[Literal["RC"], RuleVariation_802_Arg]], Union[RuleVariation_916_Arg, Tuple[Literal["RAB"], RuleVariation_916_Arg]], None]]
Variation_1341_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_60_Arg, Tuple[Literal["DCR"], RuleVariation_60_Arg]], Union[RuleVariation_416_Arg, Tuple[Literal["GBS"], RuleVariation_416_Arg]], Union[RuleVariation_494_Arg, Tuple[Literal["SIM"], RuleVariation_494_Arg]], Union[RuleVariation_619_Arg, Tuple[Literal["TST"], RuleVariation_619_Arg]], Union[RuleVariation_708_Arg, Tuple[Literal["SAA"], RuleVariation_708_Arg]], Union[RuleVariation_850_Arg, Tuple[Literal["CL"], RuleVariation_850_Arg]], None]]
Variation_1341_Arg_Group_3: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_512_Arg, Tuple[Literal["IPC"], RuleVariation_512_Arg]], Union[RuleVariation_636_Arg, Tuple[Literal["NOGO"], RuleVariation_636_Arg]], Union[RuleVariation_688_Arg, Tuple[Literal["CPR"], RuleVariation_688_Arg]], Union[RuleVariation_825_Arg, Tuple[Literal["LDPJ"], RuleVariation_825_Arg]], Union[RuleVariation_885_Arg, Tuple[Literal["RCF"], RuleVariation_885_Arg]], None]]
Variation_1341_Arg: TypeAlias = Union[
    Tuple[Variation_1341_Arg_Group_1],
    Tuple[Variation_1341_Arg_Group_1, Variation_1341_Arg_Group_2],
    Tuple[Variation_1341_Arg_Group_1, Variation_1341_Arg_Group_2, Variation_1341_Arg_Group_3],
]
class Variation_1341(Extended):
    cv_items_list = [[(Item_89, 3), (Item_82, 2), (Item_777, 1), (Item_768, 1), None], [(Item_252, 1), (Item_367, 1), (Item_900, 1), (Item_1053, 1), (Item_849, 1), (Item_160, 2), None], [(Item_1, 2), (Item_434, 1), (Item_623, 1), (Item_209, 1), (Item_474, 1), (Item_781, 1), None]]

    @classmethod
    def create(cls, arg : Variation_1341_Arg) -> 'Variation_1341':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["ATP"]) -> RuleVariation_121:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_663:
        ...
    @overload
    def get_item(self, key : Literal["RC"]) -> RuleVariation_802:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_916:
        ...
    @overload
    def get_item(self, key : Literal["DCR"]) -> Optional[RuleVariation_60]:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> Optional[RuleVariation_416]:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_494]:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_619]:
        ...
    @overload
    def get_item(self, key : Literal["SAA"]) -> Optional[RuleVariation_708]:
        ...
    @overload
    def get_item(self, key : Literal["CL"]) -> Optional[RuleVariation_850]:
        ...
    @overload
    def get_item(self, key : Literal["IPC"]) -> Optional[RuleVariation_512]:
        ...
    @overload
    def get_item(self, key : Literal["NOGO"]) -> Optional[RuleVariation_636]:
        ...
    @overload
    def get_item(self, key : Literal["CPR"]) -> Optional[RuleVariation_688]:
        ...
    @overload
    def get_item(self, key : Literal["LDPJ"]) -> Optional[RuleVariation_825]:
        ...
    @overload
    def get_item(self, key : Literal["RCF"]) -> Optional[RuleVariation_885]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1264_Arg: TypeAlias = Variation_1341_Arg
class RuleVariation_1264(RuleVariationContextFree):
    cv_variation = Variation_1341

    @classmethod
    def create(cls, arg : RuleVariation_1264_Arg) -> "RuleVariation_1264":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1341:
        return self.arg # type: ignore

NonSpare_146_Arg: TypeAlias = RuleVariation_1264_Arg
class NonSpare_146(NonSpare):
    cv_name = "040"
    cv_title = "Target Report Descriptor"
    cv_rule = RuleVariation_1264

    @classmethod
    def create(cls, arg : NonSpare_146_Arg) -> "NonSpare_146":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1264:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1341:
        return self.rule.variation

class UapItem_146(UapItem):
    cv_non_spare = NonSpare_146

NonSpare_1914_Arg: TypeAlias = RuleVariation_775_Arg
class NonSpare_1914(NonSpare):
    cv_name = "TRNUM"
    cv_title = "Track Number"
    cv_rule = RuleVariation_775

    @classmethod
    def create(cls, arg : NonSpare_1914_Arg) -> "NonSpare_1914":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_775:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_805:
        return self.rule.variation

Item_1038_Arg: TypeAlias = NonSpare_1914_Arg
class Item_1038(Item):
    cv_non_spare = NonSpare_1914

    @classmethod
    def create(cls, arg : Item_1038_Arg) -> "Item_1038":
        return cls._create(arg) # type: ignore

Variation_1033_Arg_Group = Tuple[int, Union[RuleVariation_775_Arg, Tuple[Literal["TRNUM"], RuleVariation_775_Arg]]]
Variation_1033_Arg: TypeAlias = Union[int, Variation_1033_Arg_Group]
class Variation_1033(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_1038, 12)]
    cv_items_dict = {"TRNUM": RuleVariation_775}

    @classmethod
    def spec(cls, key : Literal["TRNUM"]) -> RuleVariation_775:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["TRNUM"]) -> RuleVariation_775:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1033_Arg) -> 'Variation_1033':
        return cls._create(arg) # type: ignore

RuleVariation_1001_Arg: TypeAlias = Variation_1033_Arg
class RuleVariation_1001(RuleVariationContextFree):
    cv_variation = Variation_1033

    @classmethod
    def create(cls, arg : RuleVariation_1001_Arg) -> "RuleVariation_1001":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1033:
        return self.arg # type: ignore

NonSpare_360_Arg: TypeAlias = RuleVariation_1001_Arg
class NonSpare_360(NonSpare):
    cv_name = "161"
    cv_title = "Track Number"
    cv_rule = RuleVariation_1001

    @classmethod
    def create(cls, arg : NonSpare_360_Arg) -> "NonSpare_360":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1001:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1033:
        return self.rule.variation

class UapItem_360(UapItem):
    cv_non_spare = NonSpare_360

NonSpare_63_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_63(NonSpare):
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_63_Arg) -> "NonSpare_63":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_63(UapItem):
    cv_non_spare = NonSpare_63

NonSpare_218_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_218(NonSpare):
    cv_name = "071"
    cv_title = "Time of Applicability for Position"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_218_Arg) -> "NonSpare_218":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_218(UapItem):
    cv_non_spare = NonSpare_218

NonSpare_305_Arg: TypeAlias = RuleVariation_1078_Arg
class NonSpare_305(NonSpare):
    cv_name = "130"
    cv_title = "Position in WGS-84 Co-ordinates"
    cv_rule = RuleVariation_1078

    @classmethod
    def create(cls, arg : NonSpare_305_Arg) -> "NonSpare_305":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1078:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1121:
        return self.rule.variation

class UapItem_305(UapItem):
    cv_non_spare = NonSpare_305

NonSpare_310_Arg: TypeAlias = RuleVariation_1081_Arg
class NonSpare_310(NonSpare):
    cv_name = "131"
    cv_title = "High-Resolution Position in WGS-84 Co-ordinates"
    cv_rule = RuleVariation_1081

    @classmethod
    def create(cls, arg : NonSpare_310_Arg) -> "NonSpare_310":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1081:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1124:
        return self.rule.variation

class UapItem_310(UapItem):
    cv_non_spare = NonSpare_310

NonSpare_219_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_219(NonSpare):
    cv_name = "072"
    cv_title = "Time of Applicability for Velocity"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_219_Arg) -> "NonSpare_219":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_219(UapItem):
    cv_non_spare = NonSpare_219

Content_558_Arg: TypeAlias = int
class Content_558(ContentTable):
    cv_values = {0: "Value in defined range", 1: "Value exceeds defined range"}

RuleContent_558_Arg: TypeAlias = Content_558_Arg
class RuleContent_558(RuleContentContextFree):
    cv_content = Content_558

    @property
    def content(self) -> Content_558:
        return self._get_content() # type: ignore

Variation_95_Arg: TypeAlias = RuleContent_558_Arg
class Variation_95(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_558

    @classmethod
    def create(cls, arg : Variation_95_Arg) -> "Variation_95":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_558:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_558:
        return self.rule.content

RuleVariation_95_Arg: TypeAlias = Variation_95_Arg
class RuleVariation_95(RuleVariationContextFree):
    cv_variation = Variation_95

    @classmethod
    def create(cls, arg : RuleVariation_95_Arg) -> "RuleVariation_95":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_95:
        return self.arg # type: ignore

NonSpare_1557_Arg: TypeAlias = RuleVariation_95_Arg
class NonSpare_1557(NonSpare):
    cv_name = "RE"
    cv_title = "Range Exceeded Indicator"
    cv_rule = RuleVariation_95

    @classmethod
    def create(cls, arg : NonSpare_1557_Arg) -> "NonSpare_1557":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_95:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_95:
        return self.rule.variation

Item_789_Arg: TypeAlias = NonSpare_1557_Arg
class Item_789(Item):
    cv_non_spare = NonSpare_1557

    @classmethod
    def create(cls, arg : Item_789_Arg) -> "Item_789":
        return cls._create(arg) # type: ignore

Variation_499_Arg: TypeAlias = RuleContent_712_Arg
class Variation_499(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 15
    cv_rule = RuleContent_712

    @classmethod
    def create(cls, arg : Variation_499_Arg) -> "Variation_499":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_712:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_712:
        return self.rule.content

RuleVariation_488_Arg: TypeAlias = Variation_499_Arg
class RuleVariation_488(RuleVariationContextFree):
    cv_variation = Variation_499

    @classmethod
    def create(cls, arg : RuleVariation_488_Arg) -> "RuleVariation_488":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_499:
        return self.arg # type: ignore

NonSpare_1821_Arg: TypeAlias = RuleVariation_488_Arg
class NonSpare_1821(NonSpare):
    cv_name = "TAS"
    cv_title = "True Air Speed"
    cv_rule = RuleVariation_488

    @classmethod
    def create(cls, arg : NonSpare_1821_Arg) -> "NonSpare_1821":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_488:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_499:
        return self.rule.variation

Item_972_Arg: TypeAlias = NonSpare_1821_Arg
class Item_972(Item):
    cv_non_spare = NonSpare_1821

    @classmethod
    def create(cls, arg : Item_972_Arg) -> "Item_972":
        return cls._create(arg) # type: ignore

Variation_1169_Arg_Group = Tuple[Union[RuleVariation_95_Arg, Tuple[Literal["RE"], RuleVariation_95_Arg]], Union[RuleVariation_488_Arg, Tuple[Literal["TAS"], RuleVariation_488_Arg]]]
Variation_1169_Arg: TypeAlias = Union[int, Variation_1169_Arg_Group]
class Variation_1169(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_789, 1), (Item_972, 15)]
    cv_items_dict = {"RE": RuleVariation_95, "TAS": RuleVariation_488}

    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> RuleVariation_95:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAS"]) -> RuleVariation_488:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RE"], Literal["TAS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RE"]) -> RuleVariation_95:
        ...
    @overload
    def get_item(self, key : Literal["TAS"]) -> RuleVariation_488:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1169_Arg) -> 'Variation_1169':
        return cls._create(arg) # type: ignore

RuleVariation_1121_Arg: TypeAlias = Variation_1169_Arg
class RuleVariation_1121(RuleVariationContextFree):
    cv_variation = Variation_1169

    @classmethod
    def create(cls, arg : RuleVariation_1121_Arg) -> "RuleVariation_1121":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1169:
        return self.arg # type: ignore

NonSpare_345_Arg: TypeAlias = RuleVariation_1121_Arg
class NonSpare_345(NonSpare):
    cv_name = "151"
    cv_title = "True Airspeed"
    cv_rule = RuleVariation_1121

    @classmethod
    def create(cls, arg : NonSpare_345_Arg) -> "NonSpare_345":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1121:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1169:
        return self.rule.variation

class UapItem_345(UapItem):
    cv_non_spare = NonSpare_345

NonSpare_220_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_220(NonSpare):
    cv_name = "073"
    cv_title = "Time of Message Reception for Position"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_220_Arg) -> "NonSpare_220":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_220(UapItem):
    cv_non_spare = NonSpare_220

Content_603_Arg: TypeAlias = int
class Content_603(ContentTable):
    cv_values = {3: "Reserved", 2: "TOMRp whole seconds = (I021/073) Whole seconds - 1", 1: "TOMRp whole seconds = (I021/073) Whole seconds + 1", 0: "TOMRp whole seconds = (I021/073) Whole seconds"}

RuleContent_603_Arg: TypeAlias = Content_603_Arg
class RuleContent_603(RuleContentContextFree):
    cv_content = Content_603

    @property
    def content(self) -> Content_603:
        return self._get_content() # type: ignore

Variation_118_Arg: TypeAlias = RuleContent_603_Arg
class Variation_118(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_603

    @classmethod
    def create(cls, arg : Variation_118_Arg) -> "Variation_118":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_603:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_603:
        return self.rule.content

RuleVariation_118_Arg: TypeAlias = Variation_118_Arg
class RuleVariation_118(RuleVariationContextFree):
    cv_variation = Variation_118

    @classmethod
    def create(cls, arg : RuleVariation_118_Arg) -> "RuleVariation_118":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_118:
        return self.arg # type: ignore

NonSpare_992_Arg: TypeAlias = RuleVariation_118_Arg
class NonSpare_992(NonSpare):
    cv_name = "FSI"
    cv_title = "Full Second Indication"
    cv_rule = RuleVariation_118

    @classmethod
    def create(cls, arg : NonSpare_992_Arg) -> "NonSpare_992":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_118:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_118:
        return self.rule.variation

Item_346_Arg: TypeAlias = NonSpare_992_Arg
class Item_346(Item):
    cv_non_spare = NonSpare_992

    @classmethod
    def create(cls, arg : Item_346_Arg) -> "Item_346":
        return cls._create(arg) # type: ignore

Content_778_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
class Content_778(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 9.313225746154785e-10
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

RuleContent_777_Arg: TypeAlias = Content_778_Arg
class RuleContent_777(RuleContentContextFree):
    cv_content = Content_778

    @property
    def content(self) -> Content_778:
        return self._get_content() # type: ignore

Variation_610_Arg: TypeAlias = RuleContent_777_Arg
class Variation_610(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 30
    cv_rule = RuleContent_777

    @classmethod
    def create(cls, arg : Variation_610_Arg) -> "Variation_610":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_777:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_778:
        return self.rule.content

RuleVariation_599_Arg: TypeAlias = Variation_610_Arg
class RuleVariation_599(RuleVariationContextFree):
    cv_variation = Variation_610

    @classmethod
    def create(cls, arg : RuleVariation_599_Arg) -> "RuleVariation_599":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_610:
        return self.arg # type: ignore

NonSpare_1877_Arg: TypeAlias = RuleVariation_599_Arg
class NonSpare_1877(NonSpare):
    cv_name = "TOMRP"
    cv_title = "Fractional Part of the Time of Message Reception for Position in the Ground Station"
    cv_rule = RuleVariation_599

    @classmethod
    def create(cls, arg : NonSpare_1877_Arg) -> "NonSpare_1877":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_599:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_610:
        return self.rule.variation

Item_1008_Arg: TypeAlias = NonSpare_1877_Arg
class Item_1008(Item):
    cv_non_spare = NonSpare_1877

    @classmethod
    def create(cls, arg : Item_1008_Arg) -> "Item_1008":
        return cls._create(arg) # type: ignore

Variation_1101_Arg_Group = Tuple[Union[RuleVariation_118_Arg, Tuple[Literal["FSI"], RuleVariation_118_Arg]], Union[RuleVariation_599_Arg, Tuple[Literal["TOMRP"], RuleVariation_599_Arg]]]
Variation_1101_Arg: TypeAlias = Union[int, Variation_1101_Arg_Group]
class Variation_1101(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_346, 2), (Item_1008, 30)]
    cv_items_dict = {"FSI": RuleVariation_118, "TOMRP": RuleVariation_599}

    @overload
    @classmethod
    def spec(cls, key : Literal["FSI"]) -> RuleVariation_118:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOMRP"]) -> RuleVariation_599:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["FSI"], Literal["TOMRP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["FSI"]) -> RuleVariation_118:
        ...
    @overload
    def get_item(self, key : Literal["TOMRP"]) -> RuleVariation_599:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1101_Arg) -> 'Variation_1101':
        return cls._create(arg) # type: ignore

RuleVariation_1059_Arg: TypeAlias = Variation_1101_Arg
class RuleVariation_1059(RuleVariationContextFree):
    cv_variation = Variation_1101

    @classmethod
    def create(cls, arg : RuleVariation_1059_Arg) -> "RuleVariation_1059":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1101:
        return self.arg # type: ignore

NonSpare_222_Arg: TypeAlias = RuleVariation_1059_Arg
class NonSpare_222(NonSpare):
    cv_name = "074"
    cv_title = "Time of Message Reception of Position-High Precision"
    cv_rule = RuleVariation_1059

    @classmethod
    def create(cls, arg : NonSpare_222_Arg) -> "NonSpare_222":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1059:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1101:
        return self.rule.variation

class UapItem_222(UapItem):
    cv_non_spare = NonSpare_222

NonSpare_223_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_223(NonSpare):
    cv_name = "075"
    cv_title = "Time of Message Reception for Velocity"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_223_Arg) -> "NonSpare_223":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_223(UapItem):
    cv_non_spare = NonSpare_223

Content_604_Arg: TypeAlias = int
class Content_604(ContentTable):
    cv_values = {3: "Reserved", 2: "TOMRp whole seconds = (I021/075) Whole seconds - 1", 1: "TOMRp whole seconds = (I021/075) Whole seconds + 1", 0: "TOMRp whole seconds = (I021/075) Whole seconds"}

RuleContent_604_Arg: TypeAlias = Content_604_Arg
class RuleContent_604(RuleContentContextFree):
    cv_content = Content_604

    @property
    def content(self) -> Content_604:
        return self._get_content() # type: ignore

Variation_119_Arg: TypeAlias = RuleContent_604_Arg
class Variation_119(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_604

    @classmethod
    def create(cls, arg : Variation_119_Arg) -> "Variation_119":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_604:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_604:
        return self.rule.content

RuleVariation_119_Arg: TypeAlias = Variation_119_Arg
class RuleVariation_119(RuleVariationContextFree):
    cv_variation = Variation_119

    @classmethod
    def create(cls, arg : RuleVariation_119_Arg) -> "RuleVariation_119":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_119:
        return self.arg # type: ignore

NonSpare_993_Arg: TypeAlias = RuleVariation_119_Arg
class NonSpare_993(NonSpare):
    cv_name = "FSI"
    cv_title = "Full Second Indication"
    cv_rule = RuleVariation_119

    @classmethod
    def create(cls, arg : NonSpare_993_Arg) -> "NonSpare_993":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_119:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_119:
        return self.rule.variation

Item_347_Arg: TypeAlias = NonSpare_993_Arg
class Item_347(Item):
    cv_non_spare = NonSpare_993

    @classmethod
    def create(cls, arg : Item_347_Arg) -> "Item_347":
        return cls._create(arg) # type: ignore

Variation_1102_Arg_Group = Tuple[Union[RuleVariation_119_Arg, Tuple[Literal["FSI"], RuleVariation_119_Arg]], Union[RuleVariation_599_Arg, Tuple[Literal["TOMRP"], RuleVariation_599_Arg]]]
Variation_1102_Arg: TypeAlias = Union[int, Variation_1102_Arg_Group]
class Variation_1102(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_347, 2), (Item_1008, 30)]
    cv_items_dict = {"FSI": RuleVariation_119, "TOMRP": RuleVariation_599}

    @overload
    @classmethod
    def spec(cls, key : Literal["FSI"]) -> RuleVariation_119:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOMRP"]) -> RuleVariation_599:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["FSI"], Literal["TOMRP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["FSI"]) -> RuleVariation_119:
        ...
    @overload
    def get_item(self, key : Literal["TOMRP"]) -> RuleVariation_599:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1102_Arg) -> 'Variation_1102':
        return cls._create(arg) # type: ignore

RuleVariation_1060_Arg: TypeAlias = Variation_1102_Arg
class RuleVariation_1060(RuleVariationContextFree):
    cv_variation = Variation_1102

    @classmethod
    def create(cls, arg : RuleVariation_1060_Arg) -> "RuleVariation_1060":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1102:
        return self.arg # type: ignore

NonSpare_225_Arg: TypeAlias = RuleVariation_1060_Arg
class NonSpare_225(NonSpare):
    cv_name = "076"
    cv_title = "Time of Message Reception of Velocity-High Precision"
    cv_rule = RuleVariation_1060

    @classmethod
    def create(cls, arg : NonSpare_225_Arg) -> "NonSpare_225":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1060:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1102:
        return self.rule.variation

class UapItem_225(UapItem):
    cv_non_spare = NonSpare_225

NonSpare_319_Arg: TypeAlias = RuleVariation_282_Arg
class NonSpare_319(NonSpare):
    cv_name = "140"
    cv_title = "Geometric Height"
    cv_rule = RuleVariation_282

    @classmethod
    def create(cls, arg : NonSpare_319_Arg) -> "NonSpare_319":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_282:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_289:
        return self.rule.variation

class UapItem_319(UapItem):
    cv_non_spare = NonSpare_319

Variation_120_Arg: TypeAlias = RuleContent_0_Arg
class Variation_120(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_120_Arg) -> "Variation_120":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_120_Arg: TypeAlias = Variation_120_Arg
class RuleVariation_120(RuleVariationContextFree):
    cv_variation = Variation_120

    @classmethod
    def create(cls, arg : RuleVariation_120_Arg) -> "RuleVariation_120":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_120:
        return self.arg # type: ignore

Variation_688_Arg: TypeAlias = RuleContent_0_Arg
class Variation_688(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 4
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_688_Arg) -> "Variation_688":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_677_Arg: TypeAlias = Variation_688_Arg
class RuleVariation_677(RuleVariationContextFree):
    cv_variation = Variation_688

    @classmethod
    def create(cls, arg : RuleVariation_677_Arg) -> "RuleVariation_677":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_688:
        return self.arg # type: ignore

Variation_0_Arg: TypeAlias = RuleContent_0_Arg
class Variation_0(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_0_Arg) -> "Variation_0":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_0_Arg: TypeAlias = Variation_0_Arg
class RuleVariation_0(RuleVariationContextFree):
    cv_variation = Variation_0

    @classmethod
    def create(cls, arg : RuleVariation_0_Arg) -> "RuleVariation_0":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_0:
        return self.arg # type: ignore

Variation_463_Arg: TypeAlias = RuleContent_0_Arg
class Variation_463(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_463_Arg) -> "Variation_463":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_452_Arg: TypeAlias = Variation_463_Arg
class RuleVariation_452(RuleVariationContextFree):
    cv_variation = Variation_463

    @classmethod
    def create(cls, arg : RuleVariation_452_Arg) -> "RuleVariation_452":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_463:
        return self.arg # type: ignore

Content_264_Arg: TypeAlias = int
class Content_264(ContentTable):
    cv_values = {0: "Measured per flight-hour", 1: "Measured per sample"}

RuleContent_264_Arg: TypeAlias = Content_264_Arg
class RuleContent_264(RuleContentContextFree):
    cv_content = Content_264

    @property
    def content(self) -> Content_264:
        return self._get_content() # type: ignore

Variation_539_Arg: TypeAlias = RuleContent_264_Arg
class Variation_539(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_264

    @classmethod
    def create(cls, arg : Variation_539_Arg) -> "Variation_539":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_264:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_264:
        return self.rule.content

RuleVariation_528_Arg: TypeAlias = Variation_539_Arg
class RuleVariation_528(RuleVariationContextFree):
    cv_variation = Variation_539

    @classmethod
    def create(cls, arg : RuleVariation_528_Arg) -> "RuleVariation_528":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_539:
        return self.arg # type: ignore

Variation_673_Arg: TypeAlias = RuleContent_0_Arg
class Variation_673(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_673_Arg) -> "Variation_673":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_662_Arg: TypeAlias = Variation_673_Arg
class RuleVariation_662(RuleVariationContextFree):
    cv_variation = Variation_673

    @classmethod
    def create(cls, arg : RuleVariation_662_Arg) -> "RuleVariation_662":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_673:
        return self.arg # type: ignore

Variation_874_Arg: TypeAlias = RuleContent_0_Arg
class Variation_874(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_874_Arg) -> "Variation_874":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_844_Arg: TypeAlias = Variation_874_Arg
class RuleVariation_844(RuleVariationContextFree):
    cv_variation = Variation_874

    @classmethod
    def create(cls, arg : RuleVariation_844_Arg) -> "RuleVariation_844":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_874:
        return self.arg # type: ignore

NonSpare_1376_Arg: TypeAlias = RuleVariation_120_Arg
class NonSpare_1376(NonSpare):
    cv_name = "NUCRNACV"
    cv_title = "Navigation Uncertainty Category for Velocity NUCr or the Navigation Accuracy Category for Velocity NACv"
    cv_rule = RuleVariation_120

    @classmethod
    def create(cls, arg : NonSpare_1376_Arg) -> "NonSpare_1376":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_120:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_120:
        return self.rule.variation

Item_641_Arg: TypeAlias = NonSpare_1376_Arg
class Item_641(Item):
    cv_non_spare = NonSpare_1376

    @classmethod
    def create(cls, arg : Item_641_Arg) -> "Item_641":
        return cls._create(arg) # type: ignore

NonSpare_1375_Arg: TypeAlias = RuleVariation_677_Arg
class NonSpare_1375(NonSpare):
    cv_name = "NUCPNIC"
    cv_title = "Navigation Uncertainty Category for Position NUCp or Navigation Integrity Category NIC"
    cv_rule = RuleVariation_677

    @classmethod
    def create(cls, arg : NonSpare_1375_Arg) -> "NonSpare_1375":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_677:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_688:
        return self.rule.variation

Item_640_Arg: TypeAlias = NonSpare_1375_Arg
class Item_640(Item):
    cv_non_spare = NonSpare_1375

    @classmethod
    def create(cls, arg : Item_640_Arg) -> "Item_640":
        return cls._create(arg) # type: ignore

NonSpare_1350_Arg: TypeAlias = RuleVariation_0_Arg
class NonSpare_1350(NonSpare):
    cv_name = "NICBARO"
    cv_title = "Navigation Integrity Category for Barometric Altitude"
    cv_rule = RuleVariation_0

    @classmethod
    def create(cls, arg : NonSpare_1350_Arg) -> "NonSpare_1350":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_0:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_0:
        return self.rule.variation

Item_616_Arg: TypeAlias = NonSpare_1350_Arg
class Item_616(Item):
    cv_non_spare = NonSpare_1350

    @classmethod
    def create(cls, arg : Item_616_Arg) -> "Item_616":
        return cls._create(arg) # type: ignore

NonSpare_1711_Arg: TypeAlias = RuleVariation_452_Arg
class NonSpare_1711(NonSpare):
    cv_name = "SIL"
    cv_title = "Surveillance (version 1) or Source (version 2) Integrity Level"
    cv_rule = RuleVariation_452

    @classmethod
    def create(cls, arg : NonSpare_1711_Arg) -> "NonSpare_1711":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_452:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_463:
        return self.rule.variation

Item_892_Arg: TypeAlias = NonSpare_1711_Arg
class Item_892(Item):
    cv_non_spare = NonSpare_1711

    @classmethod
    def create(cls, arg : Item_892_Arg) -> "Item_892":
        return cls._create(arg) # type: ignore

NonSpare_1333_Arg: TypeAlias = RuleVariation_677_Arg
class NonSpare_1333(NonSpare):
    cv_name = "NACP"
    cv_title = "Navigation Accuracy Category for Position"
    cv_rule = RuleVariation_677

    @classmethod
    def create(cls, arg : NonSpare_1333_Arg) -> "NonSpare_1333":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_677:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_688:
        return self.rule.variation

Item_601_Arg: TypeAlias = NonSpare_1333_Arg
class Item_601(Item):
    cv_non_spare = NonSpare_1333

    @classmethod
    def create(cls, arg : Item_601_Arg) -> "Item_601":
        return cls._create(arg) # type: ignore

NonSpare_1712_Arg: TypeAlias = RuleVariation_528_Arg
class NonSpare_1712(NonSpare):
    cv_name = "SILS"
    cv_title = "SIL-Supplement"
    cv_rule = RuleVariation_528

    @classmethod
    def create(cls, arg : NonSpare_1712_Arg) -> "NonSpare_1712":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_528:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_539:
        return self.rule.variation

Item_893_Arg: TypeAlias = NonSpare_1712_Arg
class Item_893(Item):
    cv_non_spare = NonSpare_1712

    @classmethod
    def create(cls, arg : Item_893_Arg) -> "Item_893":
        return cls._create(arg) # type: ignore

NonSpare_1663_Arg: TypeAlias = RuleVariation_662_Arg
class NonSpare_1663(NonSpare):
    cv_name = "SDA"
    cv_title = "Horizontal Position System Design Assurance Level (as Defined in Version 2)"
    cv_rule = RuleVariation_662

    @classmethod
    def create(cls, arg : NonSpare_1663_Arg) -> "NonSpare_1663":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_662:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_673:
        return self.rule.variation

Item_863_Arg: TypeAlias = NonSpare_1663_Arg
class Item_863(Item):
    cv_non_spare = NonSpare_1663

    @classmethod
    def create(cls, arg : Item_863_Arg) -> "Item_863":
        return cls._create(arg) # type: ignore

NonSpare_1040_Arg: TypeAlias = RuleVariation_844_Arg
class NonSpare_1040(NonSpare):
    cv_name = "GVA"
    cv_title = "Geometric Altitude Accuracy"
    cv_rule = RuleVariation_844

    @classmethod
    def create(cls, arg : NonSpare_1040_Arg) -> "NonSpare_1040":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_844:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_874:
        return self.rule.variation

Item_378_Arg: TypeAlias = NonSpare_1040_Arg
class Item_378(Item):
    cv_non_spare = NonSpare_1040

    @classmethod
    def create(cls, arg : Item_378_Arg) -> "Item_378":
        return cls._create(arg) # type: ignore

NonSpare_1418_Arg: TypeAlias = RuleVariation_131_Arg
class NonSpare_1418(NonSpare):
    cv_name = "PIC"
    cv_title = "Position Integrity Category"
    cv_rule = RuleVariation_131

    @classmethod
    def create(cls, arg : NonSpare_1418_Arg) -> "NonSpare_1418":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_131:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_131:
        return self.rule.variation

Item_678_Arg: TypeAlias = NonSpare_1418_Arg
class Item_678(Item):
    cv_non_spare = NonSpare_1418

    @classmethod
    def create(cls, arg : Item_678_Arg) -> "Item_678":
        return cls._create(arg) # type: ignore

Variation_1369_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_120_Arg, Tuple[Literal["NUCRNACV"], RuleVariation_120_Arg]], Union[RuleVariation_677_Arg, Tuple[Literal["NUCPNIC"], RuleVariation_677_Arg]], None]]
Variation_1369_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_0_Arg, Tuple[Literal["NICBARO"], RuleVariation_0_Arg]], Union[RuleVariation_452_Arg, Tuple[Literal["SIL"], RuleVariation_452_Arg]], Union[RuleVariation_677_Arg, Tuple[Literal["NACP"], RuleVariation_677_Arg]], None]]
Variation_1369_Arg_Group_3: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_528_Arg, Tuple[Literal["SILS"], RuleVariation_528_Arg]], Union[RuleVariation_662_Arg, Tuple[Literal["SDA"], RuleVariation_662_Arg]], Union[RuleVariation_844_Arg, Tuple[Literal["GVA"], RuleVariation_844_Arg]], None]]
Variation_1369_Arg_Group_4: TypeAlias = Union[int, Tuple[Union[RuleVariation_131_Arg, Tuple[Literal["PIC"], RuleVariation_131_Arg]], int, None]]
Variation_1369_Arg: TypeAlias = Union[
    Tuple[Variation_1369_Arg_Group_1],
    Tuple[Variation_1369_Arg_Group_1, Variation_1369_Arg_Group_2],
    Tuple[Variation_1369_Arg_Group_1, Variation_1369_Arg_Group_2, Variation_1369_Arg_Group_3],
    Tuple[Variation_1369_Arg_Group_1, Variation_1369_Arg_Group_2, Variation_1369_Arg_Group_3, Variation_1369_Arg_Group_4],
]
class Variation_1369(Extended):
    cv_items_list = [[(Item_641, 3), (Item_640, 4), None], [(Item_616, 1), (Item_892, 2), (Item_601, 4), None], [(Item_1, 2), (Item_893, 1), (Item_863, 2), (Item_378, 2), None], [(Item_678, 4), (Item_21, 3), None]]

    @classmethod
    def create(cls, arg : Variation_1369_Arg) -> 'Variation_1369':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["NUCRNACV"]) -> RuleVariation_120:
        ...
    @overload
    def get_item(self, key : Literal["NUCPNIC"]) -> RuleVariation_677:
        ...
    @overload
    def get_item(self, key : Literal["NICBARO"]) -> Optional[RuleVariation_0]:
        ...
    @overload
    def get_item(self, key : Literal["SIL"]) -> Optional[RuleVariation_452]:
        ...
    @overload
    def get_item(self, key : Literal["NACP"]) -> Optional[RuleVariation_677]:
        ...
    @overload
    def get_item(self, key : Literal["SILS"]) -> Optional[RuleVariation_528]:
        ...
    @overload
    def get_item(self, key : Literal["SDA"]) -> Optional[RuleVariation_662]:
        ...
    @overload
    def get_item(self, key : Literal["GVA"]) -> Optional[RuleVariation_844]:
        ...
    @overload
    def get_item(self, key : Literal["PIC"]) -> Optional[RuleVariation_131]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1292_Arg: TypeAlias = Variation_1369_Arg
class RuleVariation_1292(RuleVariationContextFree):
    cv_variation = Variation_1369

    @classmethod
    def create(cls, arg : RuleVariation_1292_Arg) -> "RuleVariation_1292":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1369:
        return self.arg # type: ignore

NonSpare_251_Arg: TypeAlias = RuleVariation_1292_Arg
class NonSpare_251(NonSpare):
    cv_name = "090"
    cv_title = "Quality Indicators"
    cv_rule = RuleVariation_1292

    @classmethod
    def create(cls, arg : NonSpare_251_Arg) -> "NonSpare_251":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1292:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1369:
        return self.rule.variation

class UapItem_251(UapItem):
    cv_non_spare = NonSpare_251

Content_488_Arg: TypeAlias = int
class Content_488(ContentTable):
    cv_values = {0: "The MOPS Version is supported by the GS", 1: "The MOPS Version is not supported by the GS"}

RuleContent_488_Arg: TypeAlias = Content_488_Arg
class RuleContent_488(RuleContentContextFree):
    cv_content = Content_488

    @property
    def content(self) -> Content_488:
        return self._get_content() # type: ignore

Variation_453_Arg: TypeAlias = RuleContent_488_Arg
class Variation_453(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_488

    @classmethod
    def create(cls, arg : Variation_453_Arg) -> "Variation_453":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_488:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_488:
        return self.rule.content

RuleVariation_442_Arg: TypeAlias = Variation_453_Arg
class RuleVariation_442(RuleVariationContextFree):
    cv_variation = Variation_453

    @classmethod
    def create(cls, arg : RuleVariation_442_Arg) -> "RuleVariation_442":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_453:
        return self.arg # type: ignore

NonSpare_2027_Arg: TypeAlias = RuleVariation_442_Arg
class NonSpare_2027(NonSpare):
    cv_name = "VNS"
    cv_title = "Version Not Supported"
    cv_rule = RuleVariation_442

    @classmethod
    def create(cls, arg : NonSpare_2027_Arg) -> "NonSpare_2027":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_442:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_453:
        return self.rule.variation

Item_1142_Arg: TypeAlias = NonSpare_2027_Arg
class Item_1142(Item):
    cv_non_spare = NonSpare_2027

    @classmethod
    def create(cls, arg : Item_1142_Arg) -> "Item_1142":
        return cls._create(arg) # type: ignore

Content_201_Arg: TypeAlias = int
class Content_201(ContentTable):
    cv_values = {0: "ED102/DO-260 [Ref. 8]", 1: "DO-260A [Ref. 9]", 2: "ED102A/DO-260B [Ref. 11]"}

RuleContent_201_Arg: TypeAlias = Content_201_Arg
class RuleContent_201(RuleContentContextFree):
    cv_content = Content_201

    @property
    def content(self) -> Content_201:
        return self._get_content() # type: ignore

Variation_596_Arg: TypeAlias = RuleContent_201_Arg
class Variation_596(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 3
    cv_rule = RuleContent_201

    @classmethod
    def create(cls, arg : Variation_596_Arg) -> "Variation_596":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_201:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_201:
        return self.rule.content

RuleVariation_585_Arg: TypeAlias = Variation_596_Arg
class RuleVariation_585(RuleVariationContextFree):
    cv_variation = Variation_596

    @classmethod
    def create(cls, arg : RuleVariation_585_Arg) -> "RuleVariation_585":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_596:
        return self.arg # type: ignore

NonSpare_2025_Arg: TypeAlias = RuleVariation_585_Arg
class NonSpare_2025(NonSpare):
    cv_name = "VN"
    cv_title = "Version Number"
    cv_rule = RuleVariation_585

    @classmethod
    def create(cls, arg : NonSpare_2025_Arg) -> "NonSpare_2025":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_585:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_596:
        return self.rule.variation

Item_1140_Arg: TypeAlias = NonSpare_2025_Arg
class Item_1140(Item):
    cv_non_spare = NonSpare_2025

    @classmethod
    def create(cls, arg : Item_1140_Arg) -> "Item_1140":
        return cls._create(arg) # type: ignore

Content_413_Arg: TypeAlias = int
class Content_413(ContentTable):
    cv_values = {0: "Other", 1: "UAT", 2: "1090 ES", 3: "VDL 4", 4: "Not assigned", 5: "Not assigned", 6: "Not assigned", 7: "Not assigned"}

RuleContent_413_Arg: TypeAlias = Content_413_Arg
class RuleContent_413(RuleContentContextFree):
    cv_content = Content_413

    @property
    def content(self) -> Content_413:
        return self._get_content() # type: ignore

Variation_889_Arg: TypeAlias = RuleContent_413_Arg
class Variation_889(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 3
    cv_rule = RuleContent_413

    @classmethod
    def create(cls, arg : Variation_889_Arg) -> "Variation_889":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_413:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_413:
        return self.rule.content

RuleVariation_859_Arg: TypeAlias = Variation_889_Arg
class RuleVariation_859(RuleVariationContextFree):
    cv_variation = Variation_889

    @classmethod
    def create(cls, arg : RuleVariation_859_Arg) -> "RuleVariation_859":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_889:
        return self.arg # type: ignore

NonSpare_1191_Arg: TypeAlias = RuleVariation_859_Arg
class NonSpare_1191(NonSpare):
    cv_name = "LTT"
    cv_title = "Link Technology Type"
    cv_rule = RuleVariation_859

    @classmethod
    def create(cls, arg : NonSpare_1191_Arg) -> "NonSpare_1191":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_859:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_889:
        return self.rule.variation

Item_505_Arg: TypeAlias = NonSpare_1191_Arg
class Item_505(Item):
    cv_non_spare = NonSpare_1191

    @classmethod
    def create(cls, arg : Item_505_Arg) -> "Item_505":
        return cls._create(arg) # type: ignore

Variation_1000_Arg_Group = Tuple[int, Union[RuleVariation_442_Arg, Tuple[Literal["VNS"], RuleVariation_442_Arg]], Union[RuleVariation_585_Arg, Tuple[Literal["VN"], RuleVariation_585_Arg]], Union[RuleVariation_859_Arg, Tuple[Literal["LTT"], RuleVariation_859_Arg]]]
Variation_1000_Arg: TypeAlias = Union[int, Variation_1000_Arg_Group]
class Variation_1000(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_0, 1), (Item_1142, 1), (Item_1140, 3), (Item_505, 3)]
    cv_items_dict = {"VNS": RuleVariation_442, "VN": RuleVariation_585, "LTT": RuleVariation_859}

    @overload
    @classmethod
    def spec(cls, key : Literal["VNS"]) -> RuleVariation_442:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VN"]) -> RuleVariation_585:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LTT"]) -> RuleVariation_859:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VNS"], Literal["VN"], Literal["LTT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VNS"]) -> RuleVariation_442:
        ...
    @overload
    def get_item(self, key : Literal["VN"]) -> RuleVariation_585:
        ...
    @overload
    def get_item(self, key : Literal["LTT"]) -> RuleVariation_859:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1000_Arg) -> 'Variation_1000':
        return cls._create(arg) # type: ignore

RuleVariation_970_Arg: TypeAlias = Variation_1000_Arg
class RuleVariation_970(RuleVariationContextFree):
    cv_variation = Variation_1000

    @classmethod
    def create(cls, arg : RuleVariation_970_Arg) -> "RuleVariation_970":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1000:
        return self.arg # type: ignore

NonSpare_409_Arg: TypeAlias = RuleVariation_970_Arg
class NonSpare_409(NonSpare):
    cv_name = "210"
    cv_title = "MOPS Version"
    cv_rule = RuleVariation_970

    @classmethod
    def create(cls, arg : NonSpare_409_Arg) -> "NonSpare_409":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_970:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1000:
        return self.rule.variation

class UapItem_409(UapItem):
    cv_non_spare = NonSpare_409

Variation_1026_Arg_Group = Tuple[int, Union[RuleVariation_776_Arg, Tuple[Literal["MODE3A"], RuleVariation_776_Arg]]]
Variation_1026_Arg: TypeAlias = Union[int, Variation_1026_Arg_Group]
class Variation_1026(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_572, 12)]
    cv_items_dict = {"MODE3A": RuleVariation_776}

    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_776:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_776:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1026_Arg) -> 'Variation_1026':
        return cls._create(arg) # type: ignore

RuleVariation_995_Arg: TypeAlias = Variation_1026_Arg
class RuleVariation_995(RuleVariationContextFree):
    cv_variation = Variation_1026

    @classmethod
    def create(cls, arg : RuleVariation_995_Arg) -> "RuleVariation_995":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1026:
        return self.arg # type: ignore

NonSpare_204_Arg: TypeAlias = RuleVariation_995_Arg
class NonSpare_204(NonSpare):
    cv_name = "070"
    cv_title = "Mode 3/A Code in Octal Representation"
    cv_rule = RuleVariation_995

    @classmethod
    def create(cls, arg : NonSpare_204_Arg) -> "NonSpare_204":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_995:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1026:
        return self.rule.variation

class UapItem_204(UapItem):
    cv_non_spare = NonSpare_204

NonSpare_428_Arg: TypeAlias = RuleVariation_260_Arg
class NonSpare_428(NonSpare):
    cv_name = "230"
    cv_title = "Roll Angle"
    cv_rule = RuleVariation_260

    @classmethod
    def create(cls, arg : NonSpare_428_Arg) -> "NonSpare_428":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_260:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_267:
        return self.rule.variation

class UapItem_428(UapItem):
    cv_non_spare = NonSpare_428

NonSpare_347_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_347(NonSpare):
    cv_name = "152"
    cv_title = "Magnetic Heading"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_347_Arg) -> "NonSpare_347":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

class UapItem_347(UapItem):
    cv_non_spare = NonSpare_347

Content_364_Arg: TypeAlias = int
class Content_364(ContentTable):
    cv_values = {0: "No intent change active", 1: "Intent change flag raised"}

RuleContent_364_Arg: TypeAlias = Content_364_Arg
class RuleContent_364(RuleContentContextFree):
    cv_content = Content_364

    @property
    def content(self) -> Content_364:
        return self._get_content() # type: ignore

Variation_61_Arg: TypeAlias = RuleContent_364_Arg
class Variation_61(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_364

    @classmethod
    def create(cls, arg : Variation_61_Arg) -> "Variation_61":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_364:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_364:
        return self.rule.content

RuleVariation_61_Arg: TypeAlias = Variation_61_Arg
class RuleVariation_61(RuleVariationContextFree):
    cv_variation = Variation_61

    @classmethod
    def create(cls, arg : RuleVariation_61_Arg) -> "RuleVariation_61":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_61:
        return self.arg # type: ignore

NonSpare_1099_Arg: TypeAlias = RuleVariation_61_Arg
class NonSpare_1099(NonSpare):
    cv_name = "ICF"
    cv_title = "Intent Change Flag (see Note)"
    cv_rule = RuleVariation_61

    @classmethod
    def create(cls, arg : NonSpare_1099_Arg) -> "NonSpare_1099":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_61:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_61:
        return self.rule.variation

Item_423_Arg: TypeAlias = NonSpare_1099_Arg
class Item_423(Item):
    cv_non_spare = NonSpare_1099

    @classmethod
    def create(cls, arg : Item_423_Arg) -> "Item_423":
        return cls._create(arg) # type: ignore

Content_249_Arg: TypeAlias = int
class Content_249(ContentTable):
    cv_values = {0: "LNAV Mode engaged", 1: "LNAV Mode not engaged"}

RuleContent_249_Arg: TypeAlias = Content_249_Arg
class RuleContent_249(RuleContentContextFree):
    cv_content = Content_249

    @property
    def content(self) -> Content_249:
        return self._get_content() # type: ignore

Variation_432_Arg: TypeAlias = RuleContent_249_Arg
class Variation_432(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_249

    @classmethod
    def create(cls, arg : Variation_432_Arg) -> "Variation_432":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_249:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_249:
        return self.rule.content

RuleVariation_421_Arg: TypeAlias = Variation_432_Arg
class RuleVariation_421(RuleVariationContextFree):
    cv_variation = Variation_432

    @classmethod
    def create(cls, arg : RuleVariation_421_Arg) -> "RuleVariation_421":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_432:
        return self.arg # type: ignore

NonSpare_1163_Arg: TypeAlias = RuleVariation_421_Arg
class NonSpare_1163(NonSpare):
    cv_name = "LNAV"
    cv_title = "LNAV Mode"
    cv_rule = RuleVariation_421

    @classmethod
    def create(cls, arg : NonSpare_1163_Arg) -> "NonSpare_1163":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_421:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_432:
        return self.rule.variation

Item_479_Arg: TypeAlias = NonSpare_1163_Arg
class Item_479(Item):
    cv_non_spare = NonSpare_1163

    @classmethod
    def create(cls, arg : Item_479_Arg) -> "Item_479":
        return cls._create(arg) # type: ignore

Item_11_Arg: TypeAlias = int
class Item_11(Spare):
    cv_bit_offset8 = 2
    cv_bit_size = 1

Content_355_Arg: TypeAlias = int
class Content_355(ContentTable):
    cv_values = {0: "No emergency / not reported", 1: "General emergency", 2: "Lifeguard / medical emergency", 3: "Minimum fuel", 4: "No communications", 5: "Unlawful interference", 6: "DOWNED Aircraft"}

RuleContent_355_Arg: TypeAlias = Content_355_Arg
class RuleContent_355(RuleContentContextFree):
    cv_content = Content_355

    @property
    def content(self) -> Content_355:
        return self._get_content() # type: ignore

Variation_685_Arg: TypeAlias = RuleContent_355_Arg
class Variation_685(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 3
    cv_rule = RuleContent_355

    @classmethod
    def create(cls, arg : Variation_685_Arg) -> "Variation_685":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_355:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_355:
        return self.rule.content

RuleVariation_674_Arg: TypeAlias = Variation_685_Arg
class RuleVariation_674(RuleVariationContextFree):
    cv_variation = Variation_685

    @classmethod
    def create(cls, arg : RuleVariation_674_Arg) -> "RuleVariation_674":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_685:
        return self.arg # type: ignore

NonSpare_1459_Arg: TypeAlias = RuleVariation_674_Arg
class NonSpare_1459(NonSpare):
    cv_name = "PS"
    cv_title = "Priority Status"
    cv_rule = RuleVariation_674

    @classmethod
    def create(cls, arg : NonSpare_1459_Arg) -> "NonSpare_1459":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_674:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_685:
        return self.rule.variation

Item_707_Arg: TypeAlias = NonSpare_1459_Arg
class Item_707(Item):
    cv_non_spare = NonSpare_1459

    @classmethod
    def create(cls, arg : Item_707_Arg) -> "Item_707":
        return cls._create(arg) # type: ignore

Content_340_Arg: TypeAlias = int
class Content_340(ContentTable):
    cv_values = {0: "No condition reported", 1: "Permanent Alert (Emergency condition)", 2: "Temporary Alert (change in Mode 3/A Code other than emergency)", 3: "SPI set"}

RuleContent_340_Arg: TypeAlias = Content_340_Arg
class RuleContent_340(RuleContentContextFree):
    cv_content = Content_340

    @property
    def content(self) -> Content_340:
        return self._get_content() # type: ignore

Variation_959_Arg: TypeAlias = RuleContent_340_Arg
class Variation_959(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 2
    cv_rule = RuleContent_340

    @classmethod
    def create(cls, arg : Variation_959_Arg) -> "Variation_959":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_340:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_340:
        return self.rule.content

RuleVariation_929_Arg: TypeAlias = Variation_959_Arg
class RuleVariation_929(RuleVariationContextFree):
    cv_variation = Variation_959

    @classmethod
    def create(cls, arg : RuleVariation_929_Arg) -> "RuleVariation_929":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_959:
        return self.arg # type: ignore

NonSpare_1746_Arg: TypeAlias = RuleVariation_929_Arg
class NonSpare_1746(NonSpare):
    cv_name = "SS"
    cv_title = "Surveillance Status"
    cv_rule = RuleVariation_929

    @classmethod
    def create(cls, arg : NonSpare_1746_Arg) -> "NonSpare_1746":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_929:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_959:
        return self.rule.variation

Item_922_Arg: TypeAlias = NonSpare_1746_Arg
class Item_922(Item):
    cv_non_spare = NonSpare_1746

    @classmethod
    def create(cls, arg : Item_922_Arg) -> "Item_922":
        return cls._create(arg) # type: ignore

Variation_1113_Arg_Group = Tuple[Union[RuleVariation_61_Arg, Tuple[Literal["ICF"], RuleVariation_61_Arg]], Union[RuleVariation_421_Arg, Tuple[Literal["LNAV"], RuleVariation_421_Arg]], int, Union[RuleVariation_674_Arg, Tuple[Literal["PS"], RuleVariation_674_Arg]], Union[RuleVariation_929_Arg, Tuple[Literal["SS"], RuleVariation_929_Arg]]]
Variation_1113_Arg: TypeAlias = Union[int, Variation_1113_Arg_Group]
class Variation_1113(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_423, 1), (Item_479, 1), (Item_11, 1), (Item_707, 3), (Item_922, 2)]
    cv_items_dict = {"ICF": RuleVariation_61, "LNAV": RuleVariation_421, "PS": RuleVariation_674, "SS": RuleVariation_929}

    @overload
    @classmethod
    def spec(cls, key : Literal["ICF"]) -> RuleVariation_61:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LNAV"]) -> RuleVariation_421:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PS"]) -> RuleVariation_674:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SS"]) -> RuleVariation_929:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ICF"], Literal["LNAV"], Literal["PS"], Literal["SS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ICF"]) -> RuleVariation_61:
        ...
    @overload
    def get_item(self, key : Literal["LNAV"]) -> RuleVariation_421:
        ...
    @overload
    def get_item(self, key : Literal["PS"]) -> RuleVariation_674:
        ...
    @overload
    def get_item(self, key : Literal["SS"]) -> RuleVariation_929:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1113_Arg) -> 'Variation_1113':
        return cls._create(arg) # type: ignore

RuleVariation_1070_Arg: TypeAlias = Variation_1113_Arg
class RuleVariation_1070(RuleVariationContextFree):
    cv_variation = Variation_1113

    @classmethod
    def create(cls, arg : RuleVariation_1070_Arg) -> "RuleVariation_1070":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1113:
        return self.arg # type: ignore

NonSpare_394_Arg: TypeAlias = RuleVariation_1070_Arg
class NonSpare_394(NonSpare):
    cv_name = "200"
    cv_title = "Target Status"
    cv_rule = RuleVariation_1070

    @classmethod
    def create(cls, arg : NonSpare_394_Arg) -> "NonSpare_394":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1070:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1113:
        return self.rule.variation

class UapItem_394(UapItem):
    cv_non_spare = NonSpare_394

Variation_498_Arg: TypeAlias = RuleContent_685_Arg
class Variation_498(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 15
    cv_rule = RuleContent_685

    @classmethod
    def create(cls, arg : Variation_498_Arg) -> "Variation_498":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_685:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_685:
        return self.rule.content

RuleVariation_487_Arg: TypeAlias = Variation_498_Arg
class RuleVariation_487(RuleVariationContextFree):
    cv_variation = Variation_498

    @classmethod
    def create(cls, arg : RuleVariation_487_Arg) -> "RuleVariation_487":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_498:
        return self.arg # type: ignore

NonSpare_691_Arg: TypeAlias = RuleVariation_487_Arg
class NonSpare_691(NonSpare):
    cv_name = "BVR"
    cv_title = "Barometric Vertical Rate"
    cv_rule = RuleVariation_487

    @classmethod
    def create(cls, arg : NonSpare_691_Arg) -> "NonSpare_691":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_487:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_498:
        return self.rule.variation

Item_130_Arg: TypeAlias = NonSpare_691_Arg
class Item_130(Item):
    cv_non_spare = NonSpare_691

    @classmethod
    def create(cls, arg : Item_130_Arg) -> "Item_130":
        return cls._create(arg) # type: ignore

Variation_1166_Arg_Group = Tuple[Union[RuleVariation_95_Arg, Tuple[Literal["RE"], RuleVariation_95_Arg]], Union[RuleVariation_487_Arg, Tuple[Literal["BVR"], RuleVariation_487_Arg]]]
Variation_1166_Arg: TypeAlias = Union[int, Variation_1166_Arg_Group]
class Variation_1166(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_789, 1), (Item_130, 15)]
    cv_items_dict = {"RE": RuleVariation_95, "BVR": RuleVariation_487}

    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> RuleVariation_95:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BVR"]) -> RuleVariation_487:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RE"], Literal["BVR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RE"]) -> RuleVariation_95:
        ...
    @overload
    def get_item(self, key : Literal["BVR"]) -> RuleVariation_487:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1166_Arg) -> 'Variation_1166':
        return cls._create(arg) # type: ignore

RuleVariation_1118_Arg: TypeAlias = Variation_1166_Arg
class RuleVariation_1118(RuleVariationContextFree):
    cv_variation = Variation_1166

    @classmethod
    def create(cls, arg : RuleVariation_1118_Arg) -> "RuleVariation_1118":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1166:
        return self.arg # type: ignore

NonSpare_349_Arg: TypeAlias = RuleVariation_1118_Arg
class NonSpare_349(NonSpare):
    cv_name = "155"
    cv_title = "Barometric Vertical Rate"
    cv_rule = RuleVariation_1118

    @classmethod
    def create(cls, arg : NonSpare_349_Arg) -> "NonSpare_349":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1118:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1166:
        return self.rule.variation

class UapItem_349(UapItem):
    cv_non_spare = NonSpare_349

NonSpare_1042_Arg: TypeAlias = RuleVariation_487_Arg
class NonSpare_1042(NonSpare):
    cv_name = "GVR"
    cv_title = "Geometric Vertical Rate"
    cv_rule = RuleVariation_487

    @classmethod
    def create(cls, arg : NonSpare_1042_Arg) -> "NonSpare_1042":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_487:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_498:
        return self.rule.variation

Item_379_Arg: TypeAlias = NonSpare_1042_Arg
class Item_379(Item):
    cv_non_spare = NonSpare_1042

    @classmethod
    def create(cls, arg : Item_379_Arg) -> "Item_379":
        return cls._create(arg) # type: ignore

Variation_1168_Arg_Group = Tuple[Union[RuleVariation_95_Arg, Tuple[Literal["RE"], RuleVariation_95_Arg]], Union[RuleVariation_487_Arg, Tuple[Literal["GVR"], RuleVariation_487_Arg]]]
Variation_1168_Arg: TypeAlias = Union[int, Variation_1168_Arg_Group]
class Variation_1168(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_789, 1), (Item_379, 15)]
    cv_items_dict = {"RE": RuleVariation_95, "GVR": RuleVariation_487}

    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> RuleVariation_95:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GVR"]) -> RuleVariation_487:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RE"], Literal["GVR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RE"]) -> RuleVariation_95:
        ...
    @overload
    def get_item(self, key : Literal["GVR"]) -> RuleVariation_487:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1168_Arg) -> 'Variation_1168':
        return cls._create(arg) # type: ignore

RuleVariation_1120_Arg: TypeAlias = Variation_1168_Arg
class RuleVariation_1120(RuleVariationContextFree):
    cv_variation = Variation_1168

    @classmethod
    def create(cls, arg : RuleVariation_1120_Arg) -> "RuleVariation_1120":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1168:
        return self.arg # type: ignore

NonSpare_351_Arg: TypeAlias = RuleVariation_1120_Arg
class NonSpare_351(NonSpare):
    cv_name = "157"
    cv_title = "Geometric Vertical Rate"
    cv_rule = RuleVariation_1120

    @classmethod
    def create(cls, arg : NonSpare_351_Arg) -> "NonSpare_351":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1120:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1168:
        return self.rule.variation

class UapItem_351(UapItem):
    cv_non_spare = NonSpare_351

Content_776_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM/s"]]]
class Content_776(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 6.103515625e-5
    cv_unit = "NM/s"

    def as_quantity(self, cv_unit : Optional[Literal["NM/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_775_Arg: TypeAlias = Content_776_Arg
class RuleContent_775(RuleContentContextFree):
    cv_content = Content_776

    @property
    def content(self) -> Content_776:
        return self._get_content() # type: ignore

Variation_501_Arg: TypeAlias = RuleContent_775_Arg
class Variation_501(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 15
    cv_rule = RuleContent_775

    @classmethod
    def create(cls, arg : Variation_501_Arg) -> "Variation_501":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_775:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_776:
        return self.rule.content

RuleVariation_490_Arg: TypeAlias = Variation_501_Arg
class RuleVariation_490(RuleVariationContextFree):
    cv_variation = Variation_501

    @classmethod
    def create(cls, arg : RuleVariation_490_Arg) -> "RuleVariation_490":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_501:
        return self.arg # type: ignore

NonSpare_1031_Arg: TypeAlias = RuleVariation_490_Arg
class NonSpare_1031(NonSpare):
    cv_name = "GS"
    cv_title = "Ground Speed Referenced to WGS-84"
    cv_rule = RuleVariation_490

    @classmethod
    def create(cls, arg : NonSpare_1031_Arg) -> "NonSpare_1031":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_490:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_501:
        return self.rule.variation

Item_371_Arg: TypeAlias = NonSpare_1031_Arg
class Item_371(Item):
    cv_non_spare = NonSpare_1031

    @classmethod
    def create(cls, arg : Item_371_Arg) -> "Item_371":
        return cls._create(arg) # type: ignore

NonSpare_1810_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_1810(NonSpare):
    cv_name = "TA"
    cv_title = "Track Angle Clockwise Reference to True North"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_1810_Arg) -> "NonSpare_1810":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Item_968_Arg: TypeAlias = NonSpare_1810_Arg
class Item_968(Item):
    cv_non_spare = NonSpare_1810

    @classmethod
    def create(cls, arg : Item_968_Arg) -> "Item_968":
        return cls._create(arg) # type: ignore

Variation_1167_Arg_Group = Tuple[Union[RuleVariation_95_Arg, Tuple[Literal["RE"], RuleVariation_95_Arg]], Union[RuleVariation_490_Arg, Tuple[Literal["GS"], RuleVariation_490_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["TA"], RuleVariation_334_Arg]]]
Variation_1167_Arg: TypeAlias = Union[int, Variation_1167_Arg_Group]
class Variation_1167(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_789, 1), (Item_371, 15), (Item_968, 16)]
    cv_items_dict = {"RE": RuleVariation_95, "GS": RuleVariation_490, "TA": RuleVariation_334}

    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> RuleVariation_95:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GS"]) -> RuleVariation_490:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TA"]) -> RuleVariation_334:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RE"], Literal["GS"], Literal["TA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RE"]) -> RuleVariation_95:
        ...
    @overload
    def get_item(self, key : Literal["GS"]) -> RuleVariation_490:
        ...
    @overload
    def get_item(self, key : Literal["TA"]) -> RuleVariation_334:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1167_Arg) -> 'Variation_1167':
        return cls._create(arg) # type: ignore

RuleVariation_1119_Arg: TypeAlias = Variation_1167_Arg
class RuleVariation_1119(RuleVariationContextFree):
    cv_variation = Variation_1167

    @classmethod
    def create(cls, arg : RuleVariation_1119_Arg) -> "RuleVariation_1119":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1167:
        return self.arg # type: ignore

NonSpare_352_Arg: TypeAlias = RuleVariation_1119_Arg
class NonSpare_352(NonSpare):
    cv_name = "160"
    cv_title = "Airborne Ground Vector"
    cv_rule = RuleVariation_1119

    @classmethod
    def create(cls, arg : NonSpare_352_Arg) -> "NonSpare_352":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1119:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1167:
        return self.rule.variation

class UapItem_352(UapItem):
    cv_non_spare = NonSpare_352

Item_5_Arg: TypeAlias = int
class Item_5(Spare):
    cv_bit_offset8 = 0
    cv_bit_size = 6

Content_669_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°/s"]]]
class Content_669(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 3.125e-2
    cv_unit = "°/s"

    def as_quantity(self, cv_unit : Optional[Literal["°/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_669_Arg: TypeAlias = Content_669_Arg
class RuleContent_669(RuleContentContextFree):
    cv_content = Content_669

    @property
    def content(self) -> Content_669:
        return self._get_content() # type: ignore

Variation_966_Arg: TypeAlias = RuleContent_669_Arg
class Variation_966(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 10
    cv_rule = RuleContent_669

    @classmethod
    def create(cls, arg : Variation_966_Arg) -> "Variation_966":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_669:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_669:
        return self.rule.content

RuleVariation_936_Arg: TypeAlias = Variation_966_Arg
class RuleVariation_936(RuleVariationContextFree):
    cv_variation = Variation_966

    @classmethod
    def create(cls, arg : RuleVariation_936_Arg) -> "RuleVariation_936":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_966:
        return self.arg # type: ignore

NonSpare_1817_Arg: TypeAlias = RuleVariation_936_Arg
class NonSpare_1817(NonSpare):
    cv_name = "TAR"
    cv_title = "Track Angle Rate"
    cv_rule = RuleVariation_936

    @classmethod
    def create(cls, arg : NonSpare_1817_Arg) -> "NonSpare_1817":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_936:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_966:
        return self.rule.variation

Item_971_Arg: TypeAlias = NonSpare_1817_Arg
class Item_971(Item):
    cv_non_spare = NonSpare_1817

    @classmethod
    def create(cls, arg : Item_971_Arg) -> "Item_971":
        return cls._create(arg) # type: ignore

Variation_1038_Arg_Group = Tuple[int, Union[RuleVariation_936_Arg, Tuple[Literal["TAR"], RuleVariation_936_Arg]]]
Variation_1038_Arg: TypeAlias = Union[int, Variation_1038_Arg_Group]
class Variation_1038(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_5, 6), (Item_971, 10)]
    cv_items_dict = {"TAR": RuleVariation_936}

    @classmethod
    def spec(cls, key : Literal["TAR"]) -> RuleVariation_936:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["TAR"]) -> RuleVariation_936:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1038_Arg) -> 'Variation_1038':
        return cls._create(arg) # type: ignore

RuleVariation_1006_Arg: TypeAlias = Variation_1038_Arg
class RuleVariation_1006(RuleVariationContextFree):
    cv_variation = Variation_1038

    @classmethod
    def create(cls, arg : RuleVariation_1006_Arg) -> "RuleVariation_1006":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1038:
        return self.arg # type: ignore

NonSpare_364_Arg: TypeAlias = RuleVariation_1006_Arg
class NonSpare_364(NonSpare):
    cv_name = "165"
    cv_title = "Track Angle Rate"
    cv_rule = RuleVariation_1006

    @classmethod
    def create(cls, arg : NonSpare_364_Arg) -> "NonSpare_364":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1006:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1038:
        return self.rule.variation

class UapItem_364(UapItem):
    cv_non_spare = NonSpare_364

NonSpare_227_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_227(NonSpare):
    cv_name = "077"
    cv_title = "Time of ASTERIX Report Transmission"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_227_Arg) -> "NonSpare_227":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_227(UapItem):
    cv_non_spare = NonSpare_227

Content_303_Arg: TypeAlias = int
class Content_303(ContentTable):
    cv_values = {0: "No ADS-B Emitter Category Information", 1: "Light aircraft <= 15500 lbs", 2: "15500 lbs < small aircraft <75000 lbs", 3: "75000 lbs < medium a/c < 300000 lbs", 4: "High Vortex Large", 5: "300000 lbs <= heavy aircraft", 6: "Highly manoeuvrable (5g acceleration capability) and high speed (>400 knots cruise)", 7: "Reserved", 8: "Reserved", 9: "Reserved", 10: "Rotocraft", 11: "Glider / sailplane", 12: "Lighter-than-air", 13: "Unmanned aerial vehicle", 14: "Space / transatmospheric vehicle", 15: "Ultralight / handglider / paraglider", 16: "Parachutist / skydiver", 17: "Reserved", 18: "Reserved", 19: "Reserved", 20: "Surface emergency vehicle", 21: "Surface service vehicle", 22: "Fixed ground or tethered obstruction", 23: "Cluster obstacle", 24: "Line obstacle"}

RuleContent_303_Arg: TypeAlias = Content_303_Arg
class RuleContent_303(RuleContentContextFree):
    cv_content = Content_303

    @property
    def content(self) -> Content_303:
        return self._get_content() # type: ignore

Variation_169_Arg: TypeAlias = RuleContent_303_Arg
class Variation_169(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_303

    @classmethod
    def create(cls, arg : Variation_169_Arg) -> "Variation_169":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_303:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_303:
        return self.rule.content

RuleVariation_163_Arg: TypeAlias = Variation_169_Arg
class RuleVariation_163(RuleVariationContextFree):
    cv_variation = Variation_169

    @classmethod
    def create(cls, arg : RuleVariation_163_Arg) -> "RuleVariation_163":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_169:
        return self.arg # type: ignore

NonSpare_78_Arg: TypeAlias = RuleVariation_163_Arg
class NonSpare_78(NonSpare):
    cv_name = "020"
    cv_title = "Emitter Category"
    cv_rule = RuleVariation_163

    @classmethod
    def create(cls, arg : NonSpare_78_Arg) -> "NonSpare_78":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_163:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_169:
        return self.rule.variation

class UapItem_78(UapItem):
    cv_non_spare = NonSpare_78

NonSpare_1638_Arg: TypeAlias = RuleVariation_464_Arg
class NonSpare_1638(NonSpare):
    cv_name = "S"
    cv_title = "Source"
    cv_rule = RuleVariation_464

    @classmethod
    def create(cls, arg : NonSpare_1638_Arg) -> "NonSpare_1638":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_464:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_475:
        return self.rule.variation

Item_847_Arg: TypeAlias = NonSpare_1638_Arg
class Item_847(Item):
    cv_non_spare = NonSpare_1638

    @classmethod
    def create(cls, arg : Item_847_Arg) -> "Item_847":
        return cls._create(arg) # type: ignore

Variation_1194_Arg_Group = Tuple[Union[RuleVariation_63_Arg, Tuple[Literal["SAS"], RuleVariation_63_Arg]], Union[RuleVariation_464_Arg, Tuple[Literal["S"], RuleVariation_464_Arg]], Union[RuleVariation_683_Arg, Tuple[Literal["ALT"], RuleVariation_683_Arg]]]
Variation_1194_Arg: TypeAlias = Union[int, Variation_1194_Arg_Group]
class Variation_1194(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_857, 1), (Item_847, 2), (Item_60, 13)]
    cv_items_dict = {"SAS": RuleVariation_63, "S": RuleVariation_464, "ALT": RuleVariation_683}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAS"]) -> RuleVariation_63:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["S"]) -> RuleVariation_464:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_683:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAS"], Literal["S"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAS"]) -> RuleVariation_63:
        ...
    @overload
    def get_item(self, key : Literal["S"]) -> RuleVariation_464:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_683:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1194_Arg) -> 'Variation_1194':
        return cls._create(arg) # type: ignore

RuleVariation_1139_Arg: TypeAlias = Variation_1194_Arg
class RuleVariation_1139(RuleVariationContextFree):
    cv_variation = Variation_1194

    @classmethod
    def create(cls, arg : RuleVariation_1139_Arg) -> "RuleVariation_1139":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1194:
        return self.arg # type: ignore

NonSpare_336_Arg: TypeAlias = RuleVariation_1139_Arg
class NonSpare_336(NonSpare):
    cv_name = "146"
    cv_title = "Selected Altitude"
    cv_rule = RuleVariation_1139

    @classmethod
    def create(cls, arg : NonSpare_336_Arg) -> "NonSpare_336":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1139:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1194:
        return self.rule.variation

class UapItem_336(UapItem):
    cv_non_spare = NonSpare_336

Content_387_Arg: TypeAlias = int
class Content_387(ContentTable):
    cv_values = {0: "Not active or unknown", 1: "Active"}

RuleContent_387_Arg: TypeAlias = Content_387_Arg
class RuleContent_387(RuleContentContextFree):
    cv_content = Content_387

    @property
    def content(self) -> Content_387:
        return self._get_content() # type: ignore

Variation_67_Arg: TypeAlias = RuleContent_387_Arg
class Variation_67(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_387

    @classmethod
    def create(cls, arg : Variation_67_Arg) -> "Variation_67":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_387:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_387:
        return self.rule.content

RuleVariation_67_Arg: TypeAlias = Variation_67_Arg
class RuleVariation_67(RuleVariationContextFree):
    cv_variation = Variation_67

    @classmethod
    def create(cls, arg : RuleVariation_67_Arg) -> "RuleVariation_67":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_67:
        return self.arg # type: ignore

NonSpare_1331_Arg: TypeAlias = RuleVariation_67_Arg
class NonSpare_1331(NonSpare):
    cv_name = "MV"
    cv_title = "Manage Vertical Mode"
    cv_rule = RuleVariation_67

    @classmethod
    def create(cls, arg : NonSpare_1331_Arg) -> "NonSpare_1331":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_67:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_67:
        return self.rule.variation

Item_600_Arg: TypeAlias = NonSpare_1331_Arg
class Item_600(Item):
    cv_non_spare = NonSpare_1331

    @classmethod
    def create(cls, arg : Item_600_Arg) -> "Item_600":
        return cls._create(arg) # type: ignore

Variation_442_Arg: TypeAlias = RuleContent_387_Arg
class Variation_442(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_387

    @classmethod
    def create(cls, arg : Variation_442_Arg) -> "Variation_442":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_387:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_387:
        return self.rule.content

RuleVariation_431_Arg: TypeAlias = Variation_442_Arg
class RuleVariation_431(RuleVariationContextFree):
    cv_variation = Variation_442

    @classmethod
    def create(cls, arg : RuleVariation_431_Arg) -> "RuleVariation_431":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_442:
        return self.arg # type: ignore

NonSpare_580_Arg: TypeAlias = RuleVariation_431_Arg
class NonSpare_580(NonSpare):
    cv_name = "AH"
    cv_title = "Altitude Hold Mode"
    cv_rule = RuleVariation_431

    @classmethod
    def create(cls, arg : NonSpare_580_Arg) -> "NonSpare_580":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_431:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_442:
        return self.rule.variation

Item_54_Arg: TypeAlias = NonSpare_580_Arg
class Item_54(Item):
    cv_non_spare = NonSpare_580

    @classmethod
    def create(cls, arg : Item_54_Arg) -> "Item_54":
        return cls._create(arg) # type: ignore

Variation_565_Arg: TypeAlias = RuleContent_387_Arg
class Variation_565(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_387

    @classmethod
    def create(cls, arg : Variation_565_Arg) -> "Variation_565":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_387:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_387:
        return self.rule.content

RuleVariation_554_Arg: TypeAlias = Variation_565_Arg
class RuleVariation_554(RuleVariationContextFree):
    cv_variation = Variation_565

    @classmethod
    def create(cls, arg : RuleVariation_554_Arg) -> "RuleVariation_554":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_565:
        return self.arg # type: ignore

NonSpare_600_Arg: TypeAlias = RuleVariation_554_Arg
class NonSpare_600(NonSpare):
    cv_name = "AM"
    cv_title = "Approach Mode"
    cv_rule = RuleVariation_554

    @classmethod
    def create(cls, arg : NonSpare_600_Arg) -> "NonSpare_600":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_554:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_565:
        return self.rule.variation

Item_69_Arg: TypeAlias = NonSpare_600_Arg
class Item_69(Item):
    cv_non_spare = NonSpare_600

    @classmethod
    def create(cls, arg : Item_69_Arg) -> "Item_69":
        return cls._create(arg) # type: ignore

Variation_1142_Arg_Group = Tuple[Union[RuleVariation_67_Arg, Tuple[Literal["MV"], RuleVariation_67_Arg]], Union[RuleVariation_431_Arg, Tuple[Literal["AH"], RuleVariation_431_Arg]], Union[RuleVariation_554_Arg, Tuple[Literal["AM"], RuleVariation_554_Arg]], Union[RuleVariation_683_Arg, Tuple[Literal["ALT"], RuleVariation_683_Arg]]]
Variation_1142_Arg: TypeAlias = Union[int, Variation_1142_Arg_Group]
class Variation_1142(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_600, 1), (Item_54, 1), (Item_69, 1), (Item_60, 13)]
    cv_items_dict = {"MV": RuleVariation_67, "AH": RuleVariation_431, "AM": RuleVariation_554, "ALT": RuleVariation_683}

    @overload
    @classmethod
    def spec(cls, key : Literal["MV"]) -> RuleVariation_67:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AH"]) -> RuleVariation_431:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AM"]) -> RuleVariation_554:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_683:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MV"], Literal["AH"], Literal["AM"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MV"]) -> RuleVariation_67:
        ...
    @overload
    def get_item(self, key : Literal["AH"]) -> RuleVariation_431:
        ...
    @overload
    def get_item(self, key : Literal["AM"]) -> RuleVariation_554:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_683:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1142_Arg) -> 'Variation_1142':
        return cls._create(arg) # type: ignore

RuleVariation_1096_Arg: TypeAlias = Variation_1142_Arg
class RuleVariation_1096(RuleVariationContextFree):
    cv_variation = Variation_1142

    @classmethod
    def create(cls, arg : RuleVariation_1096_Arg) -> "RuleVariation_1096":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1142:
        return self.arg # type: ignore

NonSpare_338_Arg: TypeAlias = RuleVariation_1096_Arg
class NonSpare_338(NonSpare):
    cv_name = "148"
    cv_title = "Final State Selected Altitude"
    cv_rule = RuleVariation_1096

    @classmethod
    def create(cls, arg : NonSpare_338_Arg) -> "NonSpare_338":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1096:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1142:
        return self.rule.variation

class UapItem_338(UapItem):
    cv_non_spare = NonSpare_338

Content_731_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
class Content_731(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.5
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

RuleContent_731_Arg: TypeAlias = Content_731_Arg
class RuleContent_731(RuleContentContextFree):
    cv_content = Content_731

    @property
    def content(self) -> Content_731:
        return self._get_content() # type: ignore

Variation_225_Arg: TypeAlias = RuleContent_731_Arg
class Variation_225(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_731

    @classmethod
    def create(cls, arg : Variation_225_Arg) -> "Variation_225":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_731:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_731:
        return self.rule.content

RuleVariation_218_Arg: TypeAlias = Variation_225_Arg
class RuleVariation_218(RuleVariationContextFree):
    cv_variation = Variation_225

    @classmethod
    def create(cls, arg : RuleVariation_218_Arg) -> "RuleVariation_218":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_225:
        return self.arg # type: ignore

NonSpare_71_Arg: TypeAlias = RuleVariation_218_Arg
class NonSpare_71(NonSpare):
    cv_name = "016"
    cv_title = "Service Management"
    cv_rule = RuleVariation_218

    @classmethod
    def create(cls, arg : NonSpare_71_Arg) -> "NonSpare_71":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_218:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_225:
        return self.rule.variation

class UapItem_71(UapItem):
    cv_non_spare = NonSpare_71

Content_461_Arg: TypeAlias = int
class Content_461(ContentTable):
    cv_values = {0: "TCAS II or ACAS RA not active", 1: "TCAS RA active"}

RuleContent_461_Arg: TypeAlias = Content_461_Arg
class RuleContent_461(RuleContentContextFree):
    cv_content = Content_461

    @property
    def content(self) -> Content_461:
        return self._get_content() # type: ignore

Variation_78_Arg: TypeAlias = RuleContent_461_Arg
class Variation_78(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_461

    @classmethod
    def create(cls, arg : Variation_78_Arg) -> "Variation_78":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_461:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_461:
        return self.rule.content

RuleVariation_78_Arg: TypeAlias = Variation_78_Arg
class RuleVariation_78(RuleVariationContextFree):
    cv_variation = Variation_78

    @classmethod
    def create(cls, arg : RuleVariation_78_Arg) -> "RuleVariation_78":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_78:
        return self.arg # type: ignore

NonSpare_1525_Arg: TypeAlias = RuleVariation_78_Arg
class NonSpare_1525(NonSpare):
    cv_name = "RA"
    cv_title = "TCAS Resolution Advisory Active"
    cv_rule = RuleVariation_78

    @classmethod
    def create(cls, arg : NonSpare_1525_Arg) -> "NonSpare_1525":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_78:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_78:
        return self.rule.variation

Item_761_Arg: TypeAlias = NonSpare_1525_Arg
class Item_761(Item):
    cv_non_spare = NonSpare_1525

    @classmethod
    def create(cls, arg : Item_761_Arg) -> "Item_761":
        return cls._create(arg) # type: ignore

Content_328_Arg: TypeAlias = int
class Content_328(ContentTable):
    cv_values = {0: "No capability for Trajectory Change Reports", 1: "Support for TC+0 reports only", 2: "Support for multiple TC reports", 3: "Reserved"}

RuleContent_328_Arg: TypeAlias = Content_328_Arg
class RuleContent_328(RuleContentContextFree):
    cv_content = Content_328

    @property
    def content(self) -> Content_328:
        return self._get_content() # type: ignore

Variation_469_Arg: TypeAlias = RuleContent_328_Arg
class Variation_469(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_328

    @classmethod
    def create(cls, arg : Variation_469_Arg) -> "Variation_469":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_328:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_328:
        return self.rule.content

RuleVariation_458_Arg: TypeAlias = Variation_469_Arg
class RuleVariation_458(RuleVariationContextFree):
    cv_variation = Variation_469

    @classmethod
    def create(cls, arg : RuleVariation_458_Arg) -> "RuleVariation_458":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_469:
        return self.arg # type: ignore

NonSpare_1826_Arg: TypeAlias = RuleVariation_458_Arg
class NonSpare_1826(NonSpare):
    cv_name = "TC"
    cv_title = "Target Trajectory Change Report Capability"
    cv_rule = RuleVariation_458

    @classmethod
    def create(cls, arg : NonSpare_1826_Arg) -> "NonSpare_1826":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_458:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_469:
        return self.rule.variation

Item_974_Arg: TypeAlias = NonSpare_1826_Arg
class Item_974(Item):
    cv_non_spare = NonSpare_1826

    @classmethod
    def create(cls, arg : Item_974_Arg) -> "Item_974":
        return cls._create(arg) # type: ignore

Content_330_Arg: TypeAlias = int
class Content_330(ContentTable):
    cv_values = {0: "No capability to support Target State Reports", 1: "Capable of supporting target State Reports"}

RuleContent_330_Arg: TypeAlias = Content_330_Arg
class RuleContent_330(RuleContentContextFree):
    cv_content = Content_330

    @property
    def content(self) -> Content_330:
        return self._get_content() # type: ignore

Variation_648_Arg: TypeAlias = RuleContent_330_Arg
class Variation_648(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_330

    @classmethod
    def create(cls, arg : Variation_648_Arg) -> "Variation_648":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_330:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_330:
        return self.rule.content

RuleVariation_637_Arg: TypeAlias = Variation_648_Arg
class RuleVariation_637(RuleVariationContextFree):
    cv_variation = Variation_648

    @classmethod
    def create(cls, arg : RuleVariation_637_Arg) -> "RuleVariation_637":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_648:
        return self.arg # type: ignore

NonSpare_1915_Arg: TypeAlias = RuleVariation_637_Arg
class NonSpare_1915(NonSpare):
    cv_name = "TS"
    cv_title = "Target State Report Capability"
    cv_rule = RuleVariation_637

    @classmethod
    def create(cls, arg : NonSpare_1915_Arg) -> "NonSpare_1915":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_637:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_648:
        return self.rule.variation

Item_1039_Arg: TypeAlias = NonSpare_1915_Arg
class Item_1039(Item):
    cv_non_spare = NonSpare_1915

    @classmethod
    def create(cls, arg : Item_1039_Arg) -> "Item_1039":
        return cls._create(arg) # type: ignore

Content_329_Arg: TypeAlias = int
class Content_329(ContentTable):
    cv_values = {0: "No capability to generate ARV-reports", 1: "Capable of generate ARV-reports"}

RuleContent_329_Arg: TypeAlias = Content_329_Arg
class RuleContent_329(RuleContentContextFree):
    cv_content = Content_329

    @property
    def content(self) -> Content_329:
        return self._get_content() # type: ignore

Variation_735_Arg: TypeAlias = RuleContent_329_Arg
class Variation_735(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_329

    @classmethod
    def create(cls, arg : Variation_735_Arg) -> "Variation_735":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_329:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_329:
        return self.rule.content

RuleVariation_724_Arg: TypeAlias = Variation_735_Arg
class RuleVariation_724(RuleVariationContextFree):
    cv_variation = Variation_735

    @classmethod
    def create(cls, arg : RuleVariation_724_Arg) -> "RuleVariation_724":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_735:
        return self.arg # type: ignore

NonSpare_626_Arg: TypeAlias = RuleVariation_724_Arg
class NonSpare_626(NonSpare):
    cv_name = "ARV"
    cv_title = "Air-Referenced Velocity Report Capability"
    cv_rule = RuleVariation_724

    @classmethod
    def create(cls, arg : NonSpare_626_Arg) -> "NonSpare_626":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_724:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_735:
        return self.rule.variation

Item_84_Arg: TypeAlias = NonSpare_626_Arg
class Item_84(Item):
    cv_non_spare = NonSpare_626

    @classmethod
    def create(cls, arg : Item_84_Arg) -> "Item_84":
        return cls._create(arg) # type: ignore

Content_48_Arg: TypeAlias = int
class Content_48(ContentTable):
    cv_values = {0: "CDTI not operational", 1: "CDTI operational"}

RuleContent_48_Arg: TypeAlias = Content_48_Arg
class RuleContent_48(RuleContentContextFree):
    cv_content = Content_48

    @property
    def content(self) -> Content_48:
        return self._get_content() # type: ignore

Variation_822_Arg: TypeAlias = RuleContent_48_Arg
class Variation_822(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_48

    @classmethod
    def create(cls, arg : Variation_822_Arg) -> "Variation_822":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_48:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_48:
        return self.rule.content

RuleVariation_792_Arg: TypeAlias = Variation_822_Arg
class RuleVariation_792(RuleVariationContextFree):
    cv_variation = Variation_822

    @classmethod
    def create(cls, arg : RuleVariation_792_Arg) -> "RuleVariation_792":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_822:
        return self.arg # type: ignore

NonSpare_710_Arg: TypeAlias = RuleVariation_792_Arg
class NonSpare_710(NonSpare):
    cv_name = "CDTIA"
    cv_title = "Cockpit Display of Traffic Information Airborne"
    cv_rule = RuleVariation_792

    @classmethod
    def create(cls, arg : NonSpare_710_Arg) -> "NonSpare_710":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_792:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_822:
        return self.rule.variation

Item_142_Arg: TypeAlias = NonSpare_710_Arg
class Item_142(Item):
    cv_non_spare = NonSpare_710

    @classmethod
    def create(cls, arg : Item_142_Arg) -> "Item_142":
        return cls._create(arg) # type: ignore

Content_462_Arg: TypeAlias = int
class Content_462(ContentTable):
    cv_values = {0: "TCAS operational", 1: "TCAS not operational"}

RuleContent_462_Arg: TypeAlias = Content_462_Arg
class RuleContent_462(RuleContentContextFree):
    cv_content = Content_462

    @property
    def content(self) -> Content_462:
        return self._get_content() # type: ignore

Variation_949_Arg: TypeAlias = RuleContent_462_Arg
class Variation_949(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_462

    @classmethod
    def create(cls, arg : Variation_949_Arg) -> "Variation_949":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_462:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_462:
        return self.rule.content

RuleVariation_919_Arg: TypeAlias = Variation_949_Arg
class RuleVariation_919(RuleVariationContextFree):
    cv_variation = Variation_949

    @classmethod
    def create(cls, arg : RuleVariation_919_Arg) -> "RuleVariation_919":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_949:
        return self.arg # type: ignore

NonSpare_1368_Arg: TypeAlias = RuleVariation_919_Arg
class NonSpare_1368(NonSpare):
    cv_name = "NOTTCAS"
    cv_title = "TCAS System Status"
    cv_rule = RuleVariation_919

    @classmethod
    def create(cls, arg : NonSpare_1368_Arg) -> "NonSpare_1368":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_919:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_949:
        return self.rule.variation

Item_634_Arg: TypeAlias = NonSpare_1368_Arg
class Item_634(Item):
    cv_non_spare = NonSpare_1368

    @classmethod
    def create(cls, arg : Item_634_Arg) -> "Item_634":
        return cls._create(arg) # type: ignore

Content_34_Arg: TypeAlias = int
class Content_34(ContentTable):
    cv_values = {0: "Antenna Diversity", 1: "Single Antenna only"}

RuleContent_34_Arg: TypeAlias = Content_34_Arg
class RuleContent_34(RuleContentContextFree):
    cv_content = Content_34

    @property
    def content(self) -> Content_34:
        return self._get_content() # type: ignore

Variation_969_Arg: TypeAlias = RuleContent_34_Arg
class Variation_969(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_34

    @classmethod
    def create(cls, arg : Variation_969_Arg) -> "Variation_969":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_34:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_34:
        return self.rule.content

RuleVariation_939_Arg: TypeAlias = Variation_969_Arg
class RuleVariation_939(RuleVariationContextFree):
    cv_variation = Variation_969

    @classmethod
    def create(cls, arg : RuleVariation_939_Arg) -> "RuleVariation_939":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_969:
        return self.arg # type: ignore

NonSpare_1639_Arg: TypeAlias = RuleVariation_939_Arg
class NonSpare_1639(NonSpare):
    cv_name = "SA"
    cv_title = "Single Antenna"
    cv_rule = RuleVariation_939

    @classmethod
    def create(cls, arg : NonSpare_1639_Arg) -> "NonSpare_1639":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_939:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_969:
        return self.rule.variation

Item_848_Arg: TypeAlias = NonSpare_1639_Arg
class Item_848(Item):
    cv_non_spare = NonSpare_1639

    @classmethod
    def create(cls, arg : Item_848_Arg) -> "Item_848":
        return cls._create(arg) # type: ignore

Variation_1163_Arg_Group = Tuple[Union[RuleVariation_78_Arg, Tuple[Literal["RA"], RuleVariation_78_Arg]], Union[RuleVariation_458_Arg, Tuple[Literal["TC"], RuleVariation_458_Arg]], Union[RuleVariation_637_Arg, Tuple[Literal["TS"], RuleVariation_637_Arg]], Union[RuleVariation_724_Arg, Tuple[Literal["ARV"], RuleVariation_724_Arg]], Union[RuleVariation_792_Arg, Tuple[Literal["CDTIA"], RuleVariation_792_Arg]], Union[RuleVariation_919_Arg, Tuple[Literal["NOTTCAS"], RuleVariation_919_Arg]], Union[RuleVariation_939_Arg, Tuple[Literal["SA"], RuleVariation_939_Arg]]]
Variation_1163_Arg: TypeAlias = Union[int, Variation_1163_Arg_Group]
class Variation_1163(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_761, 1), (Item_974, 2), (Item_1039, 1), (Item_84, 1), (Item_142, 1), (Item_634, 1), (Item_848, 1)]
    cv_items_dict = {"RA": RuleVariation_78, "TC": RuleVariation_458, "TS": RuleVariation_637, "ARV": RuleVariation_724, "CDTIA": RuleVariation_792, "NOTTCAS": RuleVariation_919, "SA": RuleVariation_939}

    @overload
    @classmethod
    def spec(cls, key : Literal["RA"]) -> RuleVariation_78:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TC"]) -> RuleVariation_458:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TS"]) -> RuleVariation_637:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARV"]) -> RuleVariation_724:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CDTIA"]) -> RuleVariation_792:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NOTTCAS"]) -> RuleVariation_919:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SA"]) -> RuleVariation_939:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RA"], Literal["TC"], Literal["TS"], Literal["ARV"], Literal["CDTIA"], Literal["NOTTCAS"], Literal["SA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RA"]) -> RuleVariation_78:
        ...
    @overload
    def get_item(self, key : Literal["TC"]) -> RuleVariation_458:
        ...
    @overload
    def get_item(self, key : Literal["TS"]) -> RuleVariation_637:
        ...
    @overload
    def get_item(self, key : Literal["ARV"]) -> RuleVariation_724:
        ...
    @overload
    def get_item(self, key : Literal["CDTIA"]) -> RuleVariation_792:
        ...
    @overload
    def get_item(self, key : Literal["NOTTCAS"]) -> RuleVariation_919:
        ...
    @overload
    def get_item(self, key : Literal["SA"]) -> RuleVariation_939:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1163_Arg) -> 'Variation_1163':
        return cls._create(arg) # type: ignore

RuleVariation_1115_Arg: TypeAlias = Variation_1163_Arg
class RuleVariation_1115(RuleVariationContextFree):
    cv_variation = Variation_1163

    @classmethod
    def create(cls, arg : RuleVariation_1115_Arg) -> "RuleVariation_1115":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1163:
        return self.arg # type: ignore

NonSpare_26_Arg: TypeAlias = RuleVariation_1115_Arg
class NonSpare_26(NonSpare):
    cv_name = "008"
    cv_title = "Aircraft Operational Status"
    cv_rule = RuleVariation_1115

    @classmethod
    def create(cls, arg : NonSpare_26_Arg) -> "NonSpare_26":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1115:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1163:
        return self.rule.variation

class UapItem_26(UapItem):
    cv_non_spare = NonSpare_26

Content_428_Arg: TypeAlias = int
class Content_428(ContentTable):
    cv_values = {0: "Position transmitted is not ADS-B position reference point", 1: "Position transmitted is the ADS-B position reference point"}

RuleContent_428_Arg: TypeAlias = Content_428_Arg
class RuleContent_428(RuleContentContextFree):
    cv_content = Content_428

    @property
    def content(self) -> Content_428:
        return self._get_content() # type: ignore

Variation_570_Arg: TypeAlias = RuleContent_428_Arg
class Variation_570(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_428

    @classmethod
    def create(cls, arg : Variation_570_Arg) -> "Variation_570":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_428:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_428:
        return self.rule.content

RuleVariation_559_Arg: TypeAlias = Variation_570_Arg
class RuleVariation_559(RuleVariationContextFree):
    cv_variation = Variation_570

    @classmethod
    def create(cls, arg : RuleVariation_559_Arg) -> "RuleVariation_559":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_570:
        return self.arg # type: ignore

Variation_617_Arg: TypeAlias = RuleContent_48_Arg
class Variation_617(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_48

    @classmethod
    def create(cls, arg : Variation_617_Arg) -> "Variation_617":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_48:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_48:
        return self.rule.content

RuleVariation_606_Arg: TypeAlias = Variation_617_Arg
class RuleVariation_606(RuleVariationContextFree):
    cv_variation = Variation_617

    @classmethod
    def create(cls, arg : RuleVariation_606_Arg) -> "RuleVariation_606":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_617:
        return self.arg # type: ignore

Content_7_Arg: TypeAlias = int
class Content_7(ContentTable):
    cv_values = {0: ">= 70 Watts", 1: "< 70 Watts"}

RuleContent_7_Arg: TypeAlias = Content_7_Arg
class RuleContent_7(RuleContentContextFree):
    cv_content = Content_7

    @property
    def content(self) -> Content_7:
        return self._get_content() # type: ignore

Variation_697_Arg: TypeAlias = RuleContent_7_Arg
class Variation_697(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_7

    @classmethod
    def create(cls, arg : Variation_697_Arg) -> "Variation_697":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_7:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_7:
        return self.rule.content

RuleVariation_686_Arg: TypeAlias = Variation_697_Arg
class RuleVariation_686(RuleVariationContextFree):
    cv_variation = Variation_697

    @classmethod
    def create(cls, arg : RuleVariation_686_Arg) -> "RuleVariation_686":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_697:
        return self.arg # type: ignore

Content_30_Arg: TypeAlias = int
class Content_30(ContentTable):
    cv_values = {0: "Aircraft not receiving ATC-services", 1: "Aircraft receiving ATC services"}

RuleContent_30_Arg: TypeAlias = Content_30_Arg
class RuleContent_30(RuleContentContextFree):
    cv_content = Content_30

    @property
    def content(self) -> Content_30:
        return self._get_content() # type: ignore

Variation_819_Arg: TypeAlias = RuleContent_30_Arg
class Variation_819(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_30

    @classmethod
    def create(cls, arg : Variation_819_Arg) -> "Variation_819":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_30:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_30:
        return self.rule.content

RuleVariation_789_Arg: TypeAlias = Variation_819_Arg
class RuleVariation_789(RuleVariationContextFree):
    cv_variation = Variation_819

    @classmethod
    def create(cls, arg : RuleVariation_789_Arg) -> "RuleVariation_789":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_819:
        return self.arg # type: ignore

Content_236_Arg: TypeAlias = int
class Content_236(ContentTable):
    cv_values = {0: "IDENT switch not active", 1: "IDENT switch active"}

RuleContent_236_Arg: TypeAlias = Content_236_Arg
class RuleContent_236(RuleContentContextFree):
    cv_content = Content_236

    @property
    def content(self) -> Content_236:
        return self._get_content() # type: ignore

Variation_931_Arg: TypeAlias = RuleContent_236_Arg
class Variation_931(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_236

    @classmethod
    def create(cls, arg : Variation_931_Arg) -> "Variation_931":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_236:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_236:
        return self.rule.content

RuleVariation_901_Arg: TypeAlias = Variation_931_Arg
class RuleVariation_901(RuleVariationContextFree):
    cv_variation = Variation_931

    @classmethod
    def create(cls, arg : RuleVariation_901_Arg) -> "RuleVariation_901":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_931:
        return self.arg # type: ignore

NonSpare_1430_Arg: TypeAlias = RuleVariation_559_Arg
class NonSpare_1430(NonSpare):
    cv_name = "POA"
    cv_title = "Position Offset Applied"
    cv_rule = RuleVariation_559

    @classmethod
    def create(cls, arg : NonSpare_1430_Arg) -> "NonSpare_1430":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_559:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_570:
        return self.rule.variation

Item_685_Arg: TypeAlias = NonSpare_1430_Arg
class Item_685(Item):
    cv_non_spare = NonSpare_1430

    @classmethod
    def create(cls, arg : Item_685_Arg) -> "Item_685":
        return cls._create(arg) # type: ignore

NonSpare_711_Arg: TypeAlias = RuleVariation_606_Arg
class NonSpare_711(NonSpare):
    cv_name = "CDTIS"
    cv_title = "Cockpit Display of Traffic Information Surface"
    cv_rule = RuleVariation_606

    @classmethod
    def create(cls, arg : NonSpare_711_Arg) -> "NonSpare_711":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_606:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_617:
        return self.rule.variation

Item_143_Arg: TypeAlias = NonSpare_711_Arg
class Item_143(Item):
    cv_non_spare = NonSpare_711

    @classmethod
    def create(cls, arg : Item_143_Arg) -> "Item_143":
        return cls._create(arg) # type: ignore

NonSpare_667_Arg: TypeAlias = RuleVariation_686_Arg
class NonSpare_667(NonSpare):
    cv_name = "B2LOW"
    cv_title = "Class B2 Transmit Power Less Than 70 Watts"
    cv_rule = RuleVariation_686

    @classmethod
    def create(cls, arg : NonSpare_667_Arg) -> "NonSpare_667":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_686:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_697:
        return self.rule.variation

Item_112_Arg: TypeAlias = NonSpare_667_Arg
class Item_112(Item):
    cv_non_spare = NonSpare_667

    @classmethod
    def create(cls, arg : Item_112_Arg) -> "Item_112":
        return cls._create(arg) # type: ignore

NonSpare_1541_Arg: TypeAlias = RuleVariation_789_Arg
class NonSpare_1541(NonSpare):
    cv_name = "RAS"
    cv_title = "Receiving ATC Services"
    cv_rule = RuleVariation_789

    @classmethod
    def create(cls, arg : NonSpare_1541_Arg) -> "NonSpare_1541":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_789:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_819:
        return self.rule.variation

Item_775_Arg: TypeAlias = NonSpare_1541_Arg
class Item_775(Item):
    cv_non_spare = NonSpare_1541

    @classmethod
    def create(cls, arg : Item_775_Arg) -> "Item_775":
        return cls._create(arg) # type: ignore

NonSpare_1106_Arg: TypeAlias = RuleVariation_901_Arg
class NonSpare_1106(NonSpare):
    cv_name = "IDENT"
    cv_title = "Setting of IDENT Switch"
    cv_rule = RuleVariation_901

    @classmethod
    def create(cls, arg : NonSpare_1106_Arg) -> "NonSpare_1106":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_901:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_931:
        return self.rule.variation

Item_429_Arg: TypeAlias = NonSpare_1106_Arg
class Item_429(Item):
    cv_non_spare = NonSpare_1106

    @classmethod
    def create(cls, arg : Item_429_Arg) -> "Item_429":
        return cls._create(arg) # type: ignore

NonSpare_1194_Arg: TypeAlias = RuleVariation_766_Arg
class NonSpare_1194(NonSpare):
    cv_name = "LW"
    cv_title = "Length and Width of the Aircraft"
    cv_rule = RuleVariation_766

    @classmethod
    def create(cls, arg : NonSpare_1194_Arg) -> "NonSpare_1194":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_766:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_796:
        return self.rule.variation

Item_508_Arg: TypeAlias = NonSpare_1194_Arg
class Item_508(Item):
    cv_non_spare = NonSpare_1194

    @classmethod
    def create(cls, arg : Item_508_Arg) -> "Item_508":
        return cls._create(arg) # type: ignore

Variation_1335_Arg_Group_1: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_559_Arg, Tuple[Literal["POA"], RuleVariation_559_Arg]], Union[RuleVariation_606_Arg, Tuple[Literal["CDTIS"], RuleVariation_606_Arg]], Union[RuleVariation_686_Arg, Tuple[Literal["B2LOW"], RuleVariation_686_Arg]], Union[RuleVariation_789_Arg, Tuple[Literal["RAS"], RuleVariation_789_Arg]], Union[RuleVariation_901_Arg, Tuple[Literal["IDENT"], RuleVariation_901_Arg]], None]]
Variation_1335_Arg_Group_2: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_766_Arg, Tuple[Literal["LW"], RuleVariation_766_Arg]]]]
Variation_1335_Arg: TypeAlias = Union[
    Tuple[Variation_1335_Arg_Group_1],
    Tuple[Variation_1335_Arg_Group_1, Variation_1335_Arg_Group_2],
]
class Variation_1335(Extended):
    cv_items_list = [[(Item_1, 2), (Item_685, 1), (Item_143, 1), (Item_112, 1), (Item_775, 1), (Item_429, 1), None], [(Item_3, 4), (Item_508, 4)]]

    @classmethod
    def create(cls, arg : Variation_1335_Arg) -> 'Variation_1335':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["POA"]) -> RuleVariation_559:
        ...
    @overload
    def get_item(self, key : Literal["CDTIS"]) -> RuleVariation_606:
        ...
    @overload
    def get_item(self, key : Literal["B2LOW"]) -> RuleVariation_686:
        ...
    @overload
    def get_item(self, key : Literal["RAS"]) -> RuleVariation_789:
        ...
    @overload
    def get_item(self, key : Literal["IDENT"]) -> RuleVariation_901:
        ...
    @overload
    def get_item(self, key : Literal["LW"]) -> Optional[RuleVariation_766]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1258_Arg: TypeAlias = Variation_1335_Arg
class RuleVariation_1258(RuleVariationContextFree):
    cv_variation = Variation_1335

    @classmethod
    def create(cls, arg : RuleVariation_1258_Arg) -> "RuleVariation_1258":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1335:
        return self.arg # type: ignore

NonSpare_460_Arg: TypeAlias = RuleVariation_1258_Arg
class NonSpare_460(NonSpare):
    cv_name = "271"
    cv_title = "Surface Capabilities and Characteristics"
    cv_rule = RuleVariation_1258

    @classmethod
    def create(cls, arg : NonSpare_460_Arg) -> "NonSpare_460":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1258:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1335:
        return self.rule.variation

class UapItem_460(UapItem):
    cv_non_spare = NonSpare_460

NonSpare_313_Arg: TypeAlias = RuleVariation_199_Arg
class NonSpare_313(NonSpare):
    cv_name = "132"
    cv_title = "Message Amplitude"
    cv_rule = RuleVariation_199

    @classmethod
    def create(cls, arg : NonSpare_313_Arg) -> "NonSpare_313":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_199:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_206:
        return self.rule.variation

class UapItem_313(UapItem):
    cv_non_spare = NonSpare_313

NonSpare_442_Arg: TypeAlias = RuleVariation_1319_Arg
class NonSpare_442(NonSpare):
    cv_name = "250"
    cv_title = "Mode S MB Data"
    cv_rule = RuleVariation_1319

    @classmethod
    def create(cls, arg : NonSpare_442_Arg) -> "NonSpare_442":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1319:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1396:
        return self.rule.variation

class UapItem_442(UapItem):
    cv_non_spare = NonSpare_442

Variation_140_Arg: TypeAlias = RuleContent_0_Arg
class Variation_140(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 5
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_140_Arg) -> "Variation_140":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_140_Arg: TypeAlias = Variation_140_Arg
class RuleVariation_140(RuleVariationContextFree):
    cv_variation = Variation_140

    @classmethod
    def create(cls, arg : RuleVariation_140_Arg) -> "RuleVariation_140":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_140:
        return self.arg # type: ignore

NonSpare_1957_Arg: TypeAlias = RuleVariation_140_Arg
class NonSpare_1957(NonSpare):
    cv_name = "TYP"
    cv_title = "Message Type (= 28 for 1090 ES, Version 2)"
    cv_rule = RuleVariation_140

    @classmethod
    def create(cls, arg : NonSpare_1957_Arg) -> "NonSpare_1957":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_140:
        return self.rule.variation

Item_1076_Arg: TypeAlias = NonSpare_1957_Arg
class Item_1076(Item):
    cv_non_spare = NonSpare_1957

    @classmethod
    def create(cls, arg : Item_1076_Arg) -> "Item_1076":
        return cls._create(arg) # type: ignore

NonSpare_1795_Arg: TypeAlias = RuleVariation_856_Arg
class NonSpare_1795(NonSpare):
    cv_name = "STYP"
    cv_title = "Message Sub-type (= 2 for 1090 ES, Version 2)"
    cv_rule = RuleVariation_856

    @classmethod
    def create(cls, arg : NonSpare_1795_Arg) -> "NonSpare_1795":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_856:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_886:
        return self.rule.variation

Item_957_Arg: TypeAlias = NonSpare_1795_Arg
class Item_957(Item):
    cv_non_spare = NonSpare_1795

    @classmethod
    def create(cls, arg : Item_957_Arg) -> "Item_957":
        return cls._create(arg) # type: ignore

Variation_248_Arg: TypeAlias = RuleContent_0_Arg
class Variation_248(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 14
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_248_Arg) -> "Variation_248":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_241_Arg: TypeAlias = Variation_248_Arg
class RuleVariation_241(RuleVariationContextFree):
    cv_variation = Variation_248

    @classmethod
    def create(cls, arg : RuleVariation_241_Arg) -> "RuleVariation_241":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_248:
        return self.arg # type: ignore

NonSpare_620_Arg: TypeAlias = RuleVariation_241_Arg
class NonSpare_620(NonSpare):
    cv_name = "ARA"
    cv_title = "Active Resolution Advisories"
    cv_rule = RuleVariation_241

    @classmethod
    def create(cls, arg : NonSpare_620_Arg) -> "NonSpare_620":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_241:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_248:
        return self.rule.variation

Item_80_Arg: TypeAlias = NonSpare_620_Arg
class Item_80(Item):
    cv_non_spare = NonSpare_620

    @classmethod
    def create(cls, arg : Item_80_Arg) -> "Item_80":
        return cls._create(arg) # type: ignore

Variation_963_Arg: TypeAlias = RuleContent_0_Arg
class Variation_963(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 4
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_963_Arg) -> "Variation_963":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_933_Arg: TypeAlias = Variation_963_Arg
class RuleVariation_933(RuleVariationContextFree):
    cv_variation = Variation_963

    @classmethod
    def create(cls, arg : RuleVariation_933_Arg) -> "RuleVariation_933":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_963:
        return self.arg # type: ignore

NonSpare_1533_Arg: TypeAlias = RuleVariation_933_Arg
class NonSpare_1533(NonSpare):
    cv_name = "RAC"
    cv_title = "RAC (RA Complement) Record"
    cv_rule = RuleVariation_933

    @classmethod
    def create(cls, arg : NonSpare_1533_Arg) -> "NonSpare_1533":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_933:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_963:
        return self.rule.variation

Item_769_Arg: TypeAlias = NonSpare_1533_Arg
class Item_769(Item):
    cv_non_spare = NonSpare_1533

    @classmethod
    def create(cls, arg : Item_769_Arg) -> "Item_769":
        return cls._create(arg) # type: ignore

Variation_504_Arg: TypeAlias = RuleContent_0_Arg
class Variation_504(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_504_Arg) -> "Variation_504":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_493_Arg: TypeAlias = Variation_504_Arg
class RuleVariation_493(RuleVariationContextFree):
    cv_variation = Variation_504

    @classmethod
    def create(cls, arg : RuleVariation_493_Arg) -> "RuleVariation_493":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_504:
        return self.arg # type: ignore

NonSpare_1542_Arg: TypeAlias = RuleVariation_493_Arg
class NonSpare_1542(NonSpare):
    cv_name = "RAT"
    cv_title = "RA Terminated"
    cv_rule = RuleVariation_493

    @classmethod
    def create(cls, arg : NonSpare_1542_Arg) -> "NonSpare_1542":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_493:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_504:
        return self.rule.variation

Item_776_Arg: TypeAlias = NonSpare_1542_Arg
class Item_776(Item):
    cv_non_spare = NonSpare_1542

    @classmethod
    def create(cls, arg : Item_776_Arg) -> "Item_776":
        return cls._create(arg) # type: ignore

NonSpare_1325_Arg: TypeAlias = RuleVariation_600_Arg
class NonSpare_1325(NonSpare):
    cv_name = "MTE"
    cv_title = "Multiple Threat Encounter"
    cv_rule = RuleVariation_600

    @classmethod
    def create(cls, arg : NonSpare_1325_Arg) -> "NonSpare_1325":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_600:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_611:
        return self.rule.variation

Item_595_Arg: TypeAlias = NonSpare_1325_Arg
class Item_595(Item):
    cv_non_spare = NonSpare_1325

    @classmethod
    def create(cls, arg : Item_595_Arg) -> "Item_595":
        return cls._create(arg) # type: ignore

Variation_760_Arg: TypeAlias = RuleContent_0_Arg
class Variation_760(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_760_Arg) -> "Variation_760":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_749_Arg: TypeAlias = Variation_760_Arg
class RuleVariation_749(RuleVariationContextFree):
    cv_variation = Variation_760

    @classmethod
    def create(cls, arg : RuleVariation_749_Arg) -> "RuleVariation_749":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_760:
        return self.arg # type: ignore

NonSpare_1941_Arg: TypeAlias = RuleVariation_749_Arg
class NonSpare_1941(NonSpare):
    cv_name = "TTI"
    cv_title = "Threat Type Indicator"
    cv_rule = RuleVariation_749

    @classmethod
    def create(cls, arg : NonSpare_1941_Arg) -> "NonSpare_1941":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_749:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_760:
        return self.rule.variation

Item_1062_Arg: TypeAlias = NonSpare_1941_Arg
class Item_1062(Item):
    cv_non_spare = NonSpare_1941

    @classmethod
    def create(cls, arg : Item_1062_Arg) -> "Item_1062":
        return cls._create(arg) # type: ignore

Variation_968_Arg: TypeAlias = RuleContent_0_Arg
class Variation_968(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 26
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_968_Arg) -> "Variation_968":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_938_Arg: TypeAlias = Variation_968_Arg
class RuleVariation_938(RuleVariationContextFree):
    cv_variation = Variation_968

    @classmethod
    def create(cls, arg : RuleVariation_938_Arg) -> "RuleVariation_938":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_968:
        return self.arg # type: ignore

NonSpare_1856_Arg: TypeAlias = RuleVariation_938_Arg
class NonSpare_1856(NonSpare):
    cv_name = "TID"
    cv_title = "Threat Identity Data"
    cv_rule = RuleVariation_938

    @classmethod
    def create(cls, arg : NonSpare_1856_Arg) -> "NonSpare_1856":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_938:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_968:
        return self.rule.variation

Item_998_Arg: TypeAlias = NonSpare_1856_Arg
class Item_998(Item):
    cv_non_spare = NonSpare_1856

    @classmethod
    def create(cls, arg : Item_998_Arg) -> "Item_998":
        return cls._create(arg) # type: ignore

Variation_1231_Arg_Group = Tuple[Union[RuleVariation_140_Arg, Tuple[Literal["TYP"], RuleVariation_140_Arg]], Union[RuleVariation_856_Arg, Tuple[Literal["STYP"], RuleVariation_856_Arg]], Union[RuleVariation_241_Arg, Tuple[Literal["ARA"], RuleVariation_241_Arg]], Union[RuleVariation_933_Arg, Tuple[Literal["RAC"], RuleVariation_933_Arg]], Union[RuleVariation_493_Arg, Tuple[Literal["RAT"], RuleVariation_493_Arg]], Union[RuleVariation_600_Arg, Tuple[Literal["MTE"], RuleVariation_600_Arg]], Union[RuleVariation_749_Arg, Tuple[Literal["TTI"], RuleVariation_749_Arg]], Union[RuleVariation_938_Arg, Tuple[Literal["TID"], RuleVariation_938_Arg]]]
Variation_1231_Arg: TypeAlias = Union[int, Variation_1231_Arg_Group]
class Variation_1231(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_items_list = [(Item_1076, 5), (Item_957, 3), (Item_80, 14), (Item_769, 4), (Item_776, 1), (Item_595, 1), (Item_1062, 2), (Item_998, 26)]
    cv_items_dict = {"TYP": RuleVariation_140, "STYP": RuleVariation_856, "ARA": RuleVariation_241, "RAC": RuleVariation_933, "RAT": RuleVariation_493, "MTE": RuleVariation_600, "TTI": RuleVariation_749, "TID": RuleVariation_938}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_140:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STYP"]) -> RuleVariation_856:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARA"]) -> RuleVariation_241:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAC"]) -> RuleVariation_933:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAT"]) -> RuleVariation_493:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MTE"]) -> RuleVariation_600:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TTI"]) -> RuleVariation_749:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> RuleVariation_938:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["STYP"], Literal["ARA"], Literal["RAC"], Literal["RAT"], Literal["MTE"], Literal["TTI"], Literal["TID"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_140:
        ...
    @overload
    def get_item(self, key : Literal["STYP"]) -> RuleVariation_856:
        ...
    @overload
    def get_item(self, key : Literal["ARA"]) -> RuleVariation_241:
        ...
    @overload
    def get_item(self, key : Literal["RAC"]) -> RuleVariation_933:
        ...
    @overload
    def get_item(self, key : Literal["RAT"]) -> RuleVariation_493:
        ...
    @overload
    def get_item(self, key : Literal["MTE"]) -> RuleVariation_600:
        ...
    @overload
    def get_item(self, key : Literal["TTI"]) -> RuleVariation_749:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> RuleVariation_938:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1231_Arg) -> 'Variation_1231':
        return cls._create(arg) # type: ignore

RuleVariation_1168_Arg: TypeAlias = Variation_1231_Arg
class RuleVariation_1168(RuleVariationContextFree):
    cv_variation = Variation_1231

    @classmethod
    def create(cls, arg : RuleVariation_1168_Arg) -> "RuleVariation_1168":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1231:
        return self.arg # type: ignore

NonSpare_454_Arg: TypeAlias = RuleVariation_1168_Arg
class NonSpare_454(NonSpare):
    cv_name = "260"
    cv_title = "ACAS Resolution Advisory Report"
    cv_rule = RuleVariation_1168

    @classmethod
    def create(cls, arg : NonSpare_454_Arg) -> "NonSpare_454":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1168:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1231:
        return self.rule.variation

class UapItem_454(UapItem):
    cv_non_spare = NonSpare_454

NonSpare_495_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_495(NonSpare):
    cv_name = "400"
    cv_title = "Receiver ID"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_495_Arg) -> "NonSpare_495":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_494(UapItem):
    cv_non_spare = NonSpare_495

Content_738_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
class Content_738(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.1
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

RuleContent_738_Arg: TypeAlias = Content_738_Arg
class RuleContent_738(RuleContentContextFree):
    cv_content = Content_738

    @property
    def content(self) -> Content_738:
        return self._get_content() # type: ignore

Variation_227_Arg: TypeAlias = RuleContent_738_Arg
class Variation_227(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_738

    @classmethod
    def create(cls, arg : Variation_227_Arg) -> "Variation_227":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_738:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_738:
        return self.rule.content

RuleVariation_220_Arg: TypeAlias = Variation_227_Arg
class RuleVariation_220(RuleVariationContextFree):
    cv_variation = Variation_227

    @classmethod
    def create(cls, arg : RuleVariation_220_Arg) -> "RuleVariation_220":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_227:
        return self.arg # type: ignore

NonSpare_608_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_608(NonSpare):
    cv_name = "AOS"
    cv_title = "Aircraft Operational Status Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_608_Arg) -> "NonSpare_608":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_1904_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1904(NonSpare):
    cv_name = "TRD"
    cv_title = "Target Report Descriptor Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1904_Arg) -> "NonSpare_1904":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_1207_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1207(NonSpare):
    cv_name = "M3A"
    cv_title = "Mode 3/A Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1207_Arg) -> "NonSpare_1207":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_1517_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1517(NonSpare):
    cv_name = "QI"
    cv_title = "Quality Indicators Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1517_Arg) -> "NonSpare_1517":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_1852_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1852(NonSpare):
    cv_name = "TI1"
    cv_title = "Trajectory Intent Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1852_Arg) -> "NonSpare_1852":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_1218_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1218(NonSpare):
    cv_name = "MAM"
    cv_title = "Message Amplitude Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1218_Arg) -> "NonSpare_1218":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_1026_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1026(NonSpare):
    cv_name = "GH"
    cv_title = "Geometric Height Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1026_Arg) -> "NonSpare_1026":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_967_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_967(NonSpare):
    cv_name = "FL"
    cv_title = "Flight Level Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_967_Arg) -> "NonSpare_967":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_1119_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1119(NonSpare):
    cv_name = "ISA"
    cv_title = "Intermediate State Selected Altitude Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1119_Arg) -> "NonSpare_1119":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_991_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_991(NonSpare):
    cv_name = "FSA"
    cv_title = "Final State Selected Altitude Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_991_Arg) -> "NonSpare_991":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_628_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_628(NonSpare):
    cv_name = "AS"
    cv_title = "Air Speed Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_628_Arg) -> "NonSpare_628":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_1822_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1822(NonSpare):
    cv_name = "TAS"
    cv_title = "True Air Speed Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1822_Arg) -> "NonSpare_1822":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_1268_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1268(NonSpare):
    cv_name = "MH"
    cv_title = "Magnetic Heading Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1268_Arg) -> "NonSpare_1268":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_692_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_692(NonSpare):
    cv_name = "BVR"
    cv_title = "Barometric Vertical Rate Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_692_Arg) -> "NonSpare_692":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_1043_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1043(NonSpare):
    cv_name = "GVR"
    cv_title = "Geometric Vertical Rate Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1043_Arg) -> "NonSpare_1043":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_1039_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1039(NonSpare):
    cv_name = "GV"
    cv_title = "Ground Vector Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1039_Arg) -> "NonSpare_1039":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_1819_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1819(NonSpare):
    cv_name = "TAR"
    cv_title = "Track Angle Rate Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1819_Arg) -> "NonSpare_1819":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_1853_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1853(NonSpare):
    cv_name = "TI2"
    cv_title = "Target Identification Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1853_Arg) -> "NonSpare_1853":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_1916_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1916(NonSpare):
    cv_name = "TS"
    cv_title = "Target Status Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1916_Arg) -> "NonSpare_1916":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_1261_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1261(NonSpare):
    cv_name = "MET"
    cv_title = "Met Information Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1261_Arg) -> "NonSpare_1261":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_1590_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1590(NonSpare):
    cv_name = "ROA"
    cv_title = "Roll Angle Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1590_Arg) -> "NonSpare_1590":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_619_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_619(NonSpare):
    cv_name = "ARA"
    cv_title = "ACAS Resolution Advisory Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_619_Arg) -> "NonSpare_619":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

NonSpare_1657_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1657(NonSpare):
    cv_name = "SCC"
    cv_title = "Surface Capabilities and Characteristics Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1657_Arg) -> "NonSpare_1657":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

Variation_1464_Arg = TypedDict('Variation_1464_Arg', {
    "AOS": NonSpare_608_Arg,
    "TRD": NonSpare_1904_Arg,
    "M3A": NonSpare_1207_Arg,
    "QI": NonSpare_1517_Arg,
    "TI1": NonSpare_1852_Arg,
    "MAM": NonSpare_1218_Arg,
    "GH": NonSpare_1026_Arg,
    "FL": NonSpare_967_Arg,
    "ISA": NonSpare_1119_Arg,
    "FSA": NonSpare_991_Arg,
    "AS": NonSpare_628_Arg,
    "TAS": NonSpare_1822_Arg,
    "MH": NonSpare_1268_Arg,
    "BVR": NonSpare_692_Arg,
    "GVR": NonSpare_1043_Arg,
    "GV": NonSpare_1039_Arg,
    "TAR": NonSpare_1819_Arg,
    "TI2": NonSpare_1853_Arg,
    "TS": NonSpare_1916_Arg,
    "MET": NonSpare_1261_Arg,
    "ROA": NonSpare_1590_Arg,
    "ARA": NonSpare_619_Arg,
    "SCC": NonSpare_1657_Arg,
}, total=False)
class Variation_1464(Compound):
    cv_fspec_max_bytes = 4
    cv_items_list = [NonSpare_608, NonSpare_1904, NonSpare_1207, NonSpare_1517, NonSpare_1852, NonSpare_1218, NonSpare_1026, NonSpare_967, NonSpare_1119, NonSpare_991, NonSpare_628, NonSpare_1822, NonSpare_1268, NonSpare_692, NonSpare_1043, NonSpare_1039, NonSpare_1819, NonSpare_1853, NonSpare_1916, NonSpare_1261, NonSpare_1590, NonSpare_619, NonSpare_1657]
    cv_items_dict = {"AOS": NonSpare_608, "TRD": NonSpare_1904, "M3A": NonSpare_1207, "QI": NonSpare_1517, "TI1": NonSpare_1852, "MAM": NonSpare_1218, "GH": NonSpare_1026, "FL": NonSpare_967, "ISA": NonSpare_1119, "FSA": NonSpare_991, "AS": NonSpare_628, "TAS": NonSpare_1822, "MH": NonSpare_1268, "BVR": NonSpare_692, "GVR": NonSpare_1043, "GV": NonSpare_1039, "TAR": NonSpare_1819, "TI2": NonSpare_1853, "TS": NonSpare_1916, "MET": NonSpare_1261, "ROA": NonSpare_1590, "ARA": NonSpare_619, "SCC": NonSpare_1657}

    @overload
    @classmethod
    def spec(cls, key : Literal["AOS"]) -> NonSpare_608:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRD"]) -> NonSpare_1904:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M3A"]) -> NonSpare_1207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QI"]) -> NonSpare_1517:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TI1"]) -> NonSpare_1852:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MAM"]) -> NonSpare_1218:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GH"]) -> NonSpare_1026:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FL"]) -> NonSpare_967:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ISA"]) -> NonSpare_1119:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FSA"]) -> NonSpare_991:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AS"]) -> NonSpare_628:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAS"]) -> NonSpare_1822:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MH"]) -> NonSpare_1268:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BVR"]) -> NonSpare_692:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GVR"]) -> NonSpare_1043:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GV"]) -> NonSpare_1039:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAR"]) -> NonSpare_1819:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TI2"]) -> NonSpare_1853:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TS"]) -> NonSpare_1916:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MET"]) -> NonSpare_1261:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ROA"]) -> NonSpare_1590:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARA"]) -> NonSpare_619:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SCC"]) -> NonSpare_1657:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AOS"], Literal["TRD"], Literal["M3A"], Literal["QI"], Literal["TI1"], Literal["MAM"], Literal["GH"], Literal["FL"], Literal["ISA"], Literal["FSA"], Literal["AS"], Literal["TAS"], Literal["MH"], Literal["BVR"], Literal["GVR"], Literal["GV"], Literal["TAR"], Literal["TI2"], Literal["TS"], Literal["MET"], Literal["ROA"], Literal["ARA"], Literal["SCC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AOS"]) -> Optional[NonSpare_608]:
        ...
    @overload
    def get_item(self, key : Literal["TRD"]) -> Optional[NonSpare_1904]:
        ...
    @overload
    def get_item(self, key : Literal["M3A"]) -> Optional[NonSpare_1207]:
        ...
    @overload
    def get_item(self, key : Literal["QI"]) -> Optional[NonSpare_1517]:
        ...
    @overload
    def get_item(self, key : Literal["TI1"]) -> Optional[NonSpare_1852]:
        ...
    @overload
    def get_item(self, key : Literal["MAM"]) -> Optional[NonSpare_1218]:
        ...
    @overload
    def get_item(self, key : Literal["GH"]) -> Optional[NonSpare_1026]:
        ...
    @overload
    def get_item(self, key : Literal["FL"]) -> Optional[NonSpare_967]:
        ...
    @overload
    def get_item(self, key : Literal["ISA"]) -> Optional[NonSpare_1119]:
        ...
    @overload
    def get_item(self, key : Literal["FSA"]) -> Optional[NonSpare_991]:
        ...
    @overload
    def get_item(self, key : Literal["AS"]) -> Optional[NonSpare_628]:
        ...
    @overload
    def get_item(self, key : Literal["TAS"]) -> Optional[NonSpare_1822]:
        ...
    @overload
    def get_item(self, key : Literal["MH"]) -> Optional[NonSpare_1268]:
        ...
    @overload
    def get_item(self, key : Literal["BVR"]) -> Optional[NonSpare_692]:
        ...
    @overload
    def get_item(self, key : Literal["GVR"]) -> Optional[NonSpare_1043]:
        ...
    @overload
    def get_item(self, key : Literal["GV"]) -> Optional[NonSpare_1039]:
        ...
    @overload
    def get_item(self, key : Literal["TAR"]) -> Optional[NonSpare_1819]:
        ...
    @overload
    def get_item(self, key : Literal["TI2"]) -> Optional[NonSpare_1853]:
        ...
    @overload
    def get_item(self, key : Literal["TS"]) -> Optional[NonSpare_1916]:
        ...
    @overload
    def get_item(self, key : Literal["MET"]) -> Optional[NonSpare_1261]:
        ...
    @overload
    def get_item(self, key : Literal["ROA"]) -> Optional[NonSpare_1590]:
        ...
    @overload
    def get_item(self, key : Literal["ARA"]) -> Optional[NonSpare_619]:
        ...
    @overload
    def get_item(self, key : Literal["SCC"]) -> Optional[NonSpare_1657]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["AOS"], val : NonSpare_608_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["TRD"], val : NonSpare_1904_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["M3A"], val : NonSpare_1207_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["QI"], val : NonSpare_1517_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["TI1"], val : NonSpare_1852_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["MAM"], val : NonSpare_1218_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["GH"], val : NonSpare_1026_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["FL"], val : NonSpare_967_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["ISA"], val : NonSpare_1119_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["FSA"], val : NonSpare_991_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["AS"], val : NonSpare_628_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["TAS"], val : NonSpare_1822_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["MH"], val : NonSpare_1268_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["BVR"], val : NonSpare_692_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["GVR"], val : NonSpare_1043_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["GV"], val : NonSpare_1039_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["TAR"], val : NonSpare_1819_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["TI2"], val : NonSpare_1853_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["TS"], val : NonSpare_1916_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["MET"], val : NonSpare_1261_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["ROA"], val : NonSpare_1590_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["ARA"], val : NonSpare_619_Arg) -> "Variation_1464":
        ...
    @overload
    def set_item(self, key : Literal["SCC"], val : NonSpare_1657_Arg) -> "Variation_1464":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["AOS"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["TRD"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["M3A"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["QI"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["TI1"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["MAM"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["GH"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["FL"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["ISA"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["FSA"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["AS"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["TAS"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["MH"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["BVR"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["GVR"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["GV"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["TAR"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["TI2"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["TS"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["MET"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["ROA"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["ARA"]) -> "Variation_1464":
        ...
    @overload
    def del_item(self, key : Literal["SCC"]) -> "Variation_1464":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1464_Arg) -> 'Variation_1464':
        return cls._create(arg) # type: ignore

RuleVariation_1387_Arg: TypeAlias = Variation_1464_Arg
class RuleVariation_1387(RuleVariationContextFree):
    cv_variation = Variation_1464

    @classmethod
    def create(cls, arg : RuleVariation_1387_Arg) -> "RuleVariation_1387":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1464:
        return self.arg # type: ignore

NonSpare_466_Arg: TypeAlias = RuleVariation_1387_Arg
class NonSpare_466(NonSpare):
    cv_name = "295"
    cv_title = "Data Ages"
    cv_rule = RuleVariation_1387

    @classmethod
    def create(cls, arg : NonSpare_466_Arg) -> "NonSpare_466":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1387:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1464:
        return self.rule.variation

class UapItem_466(UapItem):
    cv_non_spare = NonSpare_466

Record_7_Arg = TypedDict('Record_7_Arg', {
    "010": NonSpare_28_Arg,
    "040": NonSpare_146_Arg,
    "161": NonSpare_360_Arg,
    "015": NonSpare_63_Arg,
    "071": NonSpare_218_Arg,
    "130": NonSpare_305_Arg,
    "131": NonSpare_310_Arg,
    "072": NonSpare_219_Arg,
    "150": NonSpare_339_Arg,
    "151": NonSpare_345_Arg,
    "080": NonSpare_233_Arg,
    "073": NonSpare_220_Arg,
    "074": NonSpare_222_Arg,
    "075": NonSpare_223_Arg,
    "076": NonSpare_225_Arg,
    "140": NonSpare_319_Arg,
    "090": NonSpare_251_Arg,
    "210": NonSpare_409_Arg,
    "070": NonSpare_204_Arg,
    "230": NonSpare_428_Arg,
    "145": NonSpare_333_Arg,
    "152": NonSpare_347_Arg,
    "200": NonSpare_394_Arg,
    "155": NonSpare_349_Arg,
    "157": NonSpare_351_Arg,
    "160": NonSpare_352_Arg,
    "165": NonSpare_364_Arg,
    "077": NonSpare_227_Arg,
    "170": NonSpare_368_Arg,
    "020": NonSpare_78_Arg,
    "220": NonSpare_419_Arg,
    "146": NonSpare_336_Arg,
    "148": NonSpare_338_Arg,
    "110": NonSpare_289_Arg,
    "016": NonSpare_71_Arg,
    "008": NonSpare_26_Arg,
    "271": NonSpare_460_Arg,
    "132": NonSpare_313_Arg,
    "250": NonSpare_442_Arg,
    "260": NonSpare_454_Arg,
    "400": NonSpare_495_Arg,
    "295": NonSpare_466_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_7(Record):
    cv_fspec_max_bytes = 7
    cv_items_list = [UapItem_28, UapItem_146, UapItem_360, UapItem_63, UapItem_218, UapItem_305, UapItem_310, UapItem_219, UapItem_339, UapItem_345, UapItem_233, UapItem_220, UapItem_222, UapItem_223, UapItem_225, UapItem_319, UapItem_251, UapItem_409, UapItem_204, UapItem_428, UapItem_333, UapItem_347, UapItem_394, UapItem_349, UapItem_351, UapItem_352, UapItem_364, UapItem_227, UapItem_368, UapItem_78, UapItem_419, UapItem_336, UapItem_338, UapItem_289, UapItem_71, UapItem_26, UapItem_460, UapItem_313, UapItem_442, UapItem_454, UapItem_494, UapItem_466, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_28, "040": NonSpare_146, "161": NonSpare_360, "015": NonSpare_63, "071": NonSpare_218, "130": NonSpare_305, "131": NonSpare_310, "072": NonSpare_219, "150": NonSpare_339, "151": NonSpare_345, "080": NonSpare_233, "073": NonSpare_220, "074": NonSpare_222, "075": NonSpare_223, "076": NonSpare_225, "140": NonSpare_319, "090": NonSpare_251, "210": NonSpare_409, "070": NonSpare_204, "230": NonSpare_428, "145": NonSpare_333, "152": NonSpare_347, "200": NonSpare_394, "155": NonSpare_349, "157": NonSpare_351, "160": NonSpare_352, "165": NonSpare_364, "077": NonSpare_227, "170": NonSpare_368, "020": NonSpare_78, "220": NonSpare_419, "146": NonSpare_336, "148": NonSpare_338, "110": NonSpare_289, "016": NonSpare_71, "008": NonSpare_26, "271": NonSpare_460, "132": NonSpare_313, "250": NonSpare_442, "260": NonSpare_454, "400": NonSpare_495, "295": NonSpare_466, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_28:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_146:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_360:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_63:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["071"]) -> NonSpare_218:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_305:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_310:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["072"]) -> NonSpare_219:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_339:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_345:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["073"]) -> NonSpare_220:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["074"]) -> NonSpare_222:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["075"]) -> NonSpare_223:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["076"]) -> NonSpare_225:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_319:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_251:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_409:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_204:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_428:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_333:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_347:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_349:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_351:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_352:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_364:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["077"]) -> NonSpare_227:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_368:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_78:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_419:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_336:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_338:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_289:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["016"]) -> NonSpare_71:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["008"]) -> NonSpare_26:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["271"]) -> NonSpare_460:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["132"]) -> NonSpare_313:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_442:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_454:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_495:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_466:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["161"], Literal["015"], Literal["071"], Literal["130"], Literal["131"], Literal["072"], Literal["150"], Literal["151"], Literal["080"], Literal["073"], Literal["074"], Literal["075"], Literal["076"], Literal["140"], Literal["090"], Literal["210"], Literal["070"], Literal["230"], Literal["145"], Literal["152"], Literal["200"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["077"], Literal["170"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["016"], Literal["008"], Literal["271"], Literal["132"], Literal["250"], Literal["260"], Literal["400"], Literal["295"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_28]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_146]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_360]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_63]:
        ...
    @overload
    def get_item(self, key : Literal["071"]) -> Optional[NonSpare_218]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_305]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_310]:
        ...
    @overload
    def get_item(self, key : Literal["072"]) -> Optional[NonSpare_219]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_339]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_345]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_233]:
        ...
    @overload
    def get_item(self, key : Literal["073"]) -> Optional[NonSpare_220]:
        ...
    @overload
    def get_item(self, key : Literal["074"]) -> Optional[NonSpare_222]:
        ...
    @overload
    def get_item(self, key : Literal["075"]) -> Optional[NonSpare_223]:
        ...
    @overload
    def get_item(self, key : Literal["076"]) -> Optional[NonSpare_225]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_319]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_251]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_409]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_204]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_428]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_333]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_347]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_394]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_349]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_351]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_352]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_364]:
        ...
    @overload
    def get_item(self, key : Literal["077"]) -> Optional[NonSpare_227]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_368]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_78]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_419]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_336]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_338]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_289]:
        ...
    @overload
    def get_item(self, key : Literal["016"]) -> Optional[NonSpare_71]:
        ...
    @overload
    def get_item(self, key : Literal["008"]) -> Optional[NonSpare_26]:
        ...
    @overload
    def get_item(self, key : Literal["271"]) -> Optional[NonSpare_460]:
        ...
    @overload
    def get_item(self, key : Literal["132"]) -> Optional[NonSpare_313]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_442]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_454]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_495]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_466]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_28_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_146_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_360_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_63_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["071"], val : NonSpare_218_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_305_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_310_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["072"], val : NonSpare_219_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_339_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_345_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_233_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["073"], val : NonSpare_220_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["074"], val : NonSpare_222_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["075"], val : NonSpare_223_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["076"], val : NonSpare_225_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_319_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_251_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_409_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_204_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_428_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_333_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_347_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_394_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_349_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_351_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_352_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_364_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["077"], val : NonSpare_227_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_368_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_78_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_419_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_336_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_338_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_289_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["016"], val : NonSpare_71_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["008"], val : NonSpare_26_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["271"], val : NonSpare_460_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["132"], val : NonSpare_313_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_442_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_454_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_495_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_466_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_7':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["071"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["072"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["073"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["074"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["075"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["076"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["077"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["016"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["008"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["271"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["132"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_7':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_7_Arg) -> 'Record_7':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_7", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_7_Arg: TypeAlias = Record_7
class Uap_7(UapSingle):
    cv_record = Record_7

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_7]]:
        return cls._parse(bs)

class Asterix_28(AstCat):
    cv_category = 21
    cv_edition = (2, 1)
    cv_uap = Uap_7

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_7_Arg]) -> "Asterix_28":
        return cls._create(records) # type: ignore

NonSpare_252_Arg: TypeAlias = RuleVariation_1292_Arg
class NonSpare_252(NonSpare):
    cv_name = "090"
    cv_title = "Quality Indicators"
    cv_rule = RuleVariation_1292

    @classmethod
    def create(cls, arg : NonSpare_252_Arg) -> "NonSpare_252":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1292:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1369:
        return self.rule.variation

class UapItem_252(UapItem):
    cv_non_spare = NonSpare_252

Content_365_Arg: TypeAlias = int
class Content_365(ContentTable):
    cv_values = {0: "No military emergency", 1: "Military emergency"}

RuleContent_365_Arg: TypeAlias = Content_365_Arg
class RuleContent_365(RuleContentContextFree):
    cv_content = Content_365

    @property
    def content(self) -> Content_365:
        return self._get_content() # type: ignore

Variation_560_Arg: TypeAlias = RuleContent_365_Arg
class Variation_560(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_365

    @classmethod
    def create(cls, arg : Variation_560_Arg) -> "Variation_560":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_365:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_365:
        return self.rule.content

RuleVariation_549_Arg: TypeAlias = Variation_560_Arg
class RuleVariation_549(RuleVariationContextFree):
    cv_variation = Variation_560

    @classmethod
    def create(cls, arg : RuleVariation_549_Arg) -> "RuleVariation_549":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_560:
        return self.arg # type: ignore

NonSpare_1259_Arg: TypeAlias = RuleVariation_549_Arg
class NonSpare_1259(NonSpare):
    cv_name = "ME"
    cv_title = "Military Emergency"
    cv_rule = RuleVariation_549

    @classmethod
    def create(cls, arg : NonSpare_1259_Arg) -> "NonSpare_1259":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_549:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_560:
        return self.rule.variation

Item_543_Arg: TypeAlias = NonSpare_1259_Arg
class Item_543(Item):
    cv_non_spare = NonSpare_1259

    @classmethod
    def create(cls, arg : Item_543_Arg) -> "Item_543":
        return cls._create(arg) # type: ignore

Variation_1114_Arg_Group = Tuple[Union[RuleVariation_61_Arg, Tuple[Literal["ICF"], RuleVariation_61_Arg]], Union[RuleVariation_421_Arg, Tuple[Literal["LNAV"], RuleVariation_421_Arg]], Union[RuleVariation_549_Arg, Tuple[Literal["ME"], RuleVariation_549_Arg]], Union[RuleVariation_674_Arg, Tuple[Literal["PS"], RuleVariation_674_Arg]], Union[RuleVariation_929_Arg, Tuple[Literal["SS"], RuleVariation_929_Arg]]]
Variation_1114_Arg: TypeAlias = Union[int, Variation_1114_Arg_Group]
class Variation_1114(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_423, 1), (Item_479, 1), (Item_543, 1), (Item_707, 3), (Item_922, 2)]
    cv_items_dict = {"ICF": RuleVariation_61, "LNAV": RuleVariation_421, "ME": RuleVariation_549, "PS": RuleVariation_674, "SS": RuleVariation_929}

    @overload
    @classmethod
    def spec(cls, key : Literal["ICF"]) -> RuleVariation_61:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LNAV"]) -> RuleVariation_421:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ME"]) -> RuleVariation_549:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PS"]) -> RuleVariation_674:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SS"]) -> RuleVariation_929:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ICF"], Literal["LNAV"], Literal["ME"], Literal["PS"], Literal["SS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ICF"]) -> RuleVariation_61:
        ...
    @overload
    def get_item(self, key : Literal["LNAV"]) -> RuleVariation_421:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> RuleVariation_549:
        ...
    @overload
    def get_item(self, key : Literal["PS"]) -> RuleVariation_674:
        ...
    @overload
    def get_item(self, key : Literal["SS"]) -> RuleVariation_929:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1114_Arg) -> 'Variation_1114':
        return cls._create(arg) # type: ignore

RuleVariation_1071_Arg: TypeAlias = Variation_1114_Arg
class RuleVariation_1071(RuleVariationContextFree):
    cv_variation = Variation_1114

    @classmethod
    def create(cls, arg : RuleVariation_1071_Arg) -> "RuleVariation_1071":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1114:
        return self.arg # type: ignore

NonSpare_395_Arg: TypeAlias = RuleVariation_1071_Arg
class NonSpare_395(NonSpare):
    cv_name = "200"
    cv_title = "Target Status"
    cv_rule = RuleVariation_1071

    @classmethod
    def create(cls, arg : NonSpare_395_Arg) -> "NonSpare_395":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1071:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1114:
        return self.rule.variation

class UapItem_395(UapItem):
    cv_non_spare = NonSpare_395

NonSpare_1193_Arg: TypeAlias = RuleVariation_131_Arg
class NonSpare_1193(NonSpare):
    cv_name = "LW"
    cv_title = "Length and Width of the Aircraft"
    cv_rule = RuleVariation_131

    @classmethod
    def create(cls, arg : NonSpare_1193_Arg) -> "NonSpare_1193":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_131:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_131:
        return self.rule.variation

Item_507_Arg: TypeAlias = NonSpare_1193_Arg
class Item_507(Item):
    cv_non_spare = NonSpare_1193

    @classmethod
    def create(cls, arg : Item_507_Arg) -> "Item_507":
        return cls._create(arg) # type: ignore

Variation_1336_Arg_Group_1: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_559_Arg, Tuple[Literal["POA"], RuleVariation_559_Arg]], Union[RuleVariation_606_Arg, Tuple[Literal["CDTIS"], RuleVariation_606_Arg]], Union[RuleVariation_686_Arg, Tuple[Literal["B2LOW"], RuleVariation_686_Arg]], Union[RuleVariation_789_Arg, Tuple[Literal["RAS"], RuleVariation_789_Arg]], Union[RuleVariation_901_Arg, Tuple[Literal["IDENT"], RuleVariation_901_Arg]], None]]
Variation_1336_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_131_Arg, Tuple[Literal["LW"], RuleVariation_131_Arg]], int, None]]
Variation_1336_Arg: TypeAlias = Union[
    Tuple[Variation_1336_Arg_Group_1],
    Tuple[Variation_1336_Arg_Group_1, Variation_1336_Arg_Group_2],
]
class Variation_1336(Extended):
    cv_items_list = [[(Item_1, 2), (Item_685, 1), (Item_143, 1), (Item_112, 1), (Item_775, 1), (Item_429, 1), None], [(Item_507, 4), (Item_21, 3), None]]

    @classmethod
    def create(cls, arg : Variation_1336_Arg) -> 'Variation_1336':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["POA"]) -> RuleVariation_559:
        ...
    @overload
    def get_item(self, key : Literal["CDTIS"]) -> RuleVariation_606:
        ...
    @overload
    def get_item(self, key : Literal["B2LOW"]) -> RuleVariation_686:
        ...
    @overload
    def get_item(self, key : Literal["RAS"]) -> RuleVariation_789:
        ...
    @overload
    def get_item(self, key : Literal["IDENT"]) -> RuleVariation_901:
        ...
    @overload
    def get_item(self, key : Literal["LW"]) -> Optional[RuleVariation_131]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1259_Arg: TypeAlias = Variation_1336_Arg
class RuleVariation_1259(RuleVariationContextFree):
    cv_variation = Variation_1336

    @classmethod
    def create(cls, arg : RuleVariation_1259_Arg) -> "RuleVariation_1259":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1336:
        return self.arg # type: ignore

NonSpare_461_Arg: TypeAlias = RuleVariation_1259_Arg
class NonSpare_461(NonSpare):
    cv_name = "271"
    cv_title = "Surface Capabilities and Characteristics"
    cv_rule = RuleVariation_1259

    @classmethod
    def create(cls, arg : NonSpare_461_Arg) -> "NonSpare_461":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1259:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1336:
        return self.rule.variation

class UapItem_461(UapItem):
    cv_non_spare = NonSpare_461

NonSpare_451_Arg: TypeAlias = RuleVariation_1168_Arg
class NonSpare_451(NonSpare):
    cv_name = "260"
    cv_title = "ACAS Resolution Advisory Report"
    cv_rule = RuleVariation_1168

    @classmethod
    def create(cls, arg : NonSpare_451_Arg) -> "NonSpare_451":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1168:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1231:
        return self.rule.variation

class UapItem_451(UapItem):
    cv_non_spare = NonSpare_451

Record_8_Arg = TypedDict('Record_8_Arg', {
    "010": NonSpare_28_Arg,
    "040": NonSpare_146_Arg,
    "161": NonSpare_360_Arg,
    "015": NonSpare_63_Arg,
    "071": NonSpare_218_Arg,
    "130": NonSpare_305_Arg,
    "131": NonSpare_310_Arg,
    "072": NonSpare_219_Arg,
    "150": NonSpare_339_Arg,
    "151": NonSpare_345_Arg,
    "080": NonSpare_233_Arg,
    "073": NonSpare_220_Arg,
    "074": NonSpare_222_Arg,
    "075": NonSpare_223_Arg,
    "076": NonSpare_225_Arg,
    "140": NonSpare_319_Arg,
    "090": NonSpare_252_Arg,
    "210": NonSpare_409_Arg,
    "070": NonSpare_204_Arg,
    "230": NonSpare_428_Arg,
    "145": NonSpare_333_Arg,
    "152": NonSpare_347_Arg,
    "200": NonSpare_395_Arg,
    "155": NonSpare_349_Arg,
    "157": NonSpare_351_Arg,
    "160": NonSpare_352_Arg,
    "165": NonSpare_364_Arg,
    "077": NonSpare_227_Arg,
    "170": NonSpare_368_Arg,
    "020": NonSpare_78_Arg,
    "220": NonSpare_419_Arg,
    "146": NonSpare_336_Arg,
    "148": NonSpare_338_Arg,
    "110": NonSpare_289_Arg,
    "016": NonSpare_71_Arg,
    "008": NonSpare_26_Arg,
    "271": NonSpare_461_Arg,
    "132": NonSpare_313_Arg,
    "250": NonSpare_442_Arg,
    "260": NonSpare_451_Arg,
    "400": NonSpare_495_Arg,
    "295": NonSpare_466_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_8(Record):
    cv_fspec_max_bytes = 7
    cv_items_list = [UapItem_28, UapItem_146, UapItem_360, UapItem_63, UapItem_218, UapItem_305, UapItem_310, UapItem_219, UapItem_339, UapItem_345, UapItem_233, UapItem_220, UapItem_222, UapItem_223, UapItem_225, UapItem_319, UapItem_252, UapItem_409, UapItem_204, UapItem_428, UapItem_333, UapItem_347, UapItem_395, UapItem_349, UapItem_351, UapItem_352, UapItem_364, UapItem_227, UapItem_368, UapItem_78, UapItem_419, UapItem_336, UapItem_338, UapItem_289, UapItem_71, UapItem_26, UapItem_461, UapItem_313, UapItem_442, UapItem_451, UapItem_494, UapItem_466, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_28, "040": NonSpare_146, "161": NonSpare_360, "015": NonSpare_63, "071": NonSpare_218, "130": NonSpare_305, "131": NonSpare_310, "072": NonSpare_219, "150": NonSpare_339, "151": NonSpare_345, "080": NonSpare_233, "073": NonSpare_220, "074": NonSpare_222, "075": NonSpare_223, "076": NonSpare_225, "140": NonSpare_319, "090": NonSpare_252, "210": NonSpare_409, "070": NonSpare_204, "230": NonSpare_428, "145": NonSpare_333, "152": NonSpare_347, "200": NonSpare_395, "155": NonSpare_349, "157": NonSpare_351, "160": NonSpare_352, "165": NonSpare_364, "077": NonSpare_227, "170": NonSpare_368, "020": NonSpare_78, "220": NonSpare_419, "146": NonSpare_336, "148": NonSpare_338, "110": NonSpare_289, "016": NonSpare_71, "008": NonSpare_26, "271": NonSpare_461, "132": NonSpare_313, "250": NonSpare_442, "260": NonSpare_451, "400": NonSpare_495, "295": NonSpare_466, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_28:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_146:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_360:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_63:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["071"]) -> NonSpare_218:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_305:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_310:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["072"]) -> NonSpare_219:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_339:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_345:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["073"]) -> NonSpare_220:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["074"]) -> NonSpare_222:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["075"]) -> NonSpare_223:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["076"]) -> NonSpare_225:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_319:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_252:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_409:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_204:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_428:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_333:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_347:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_395:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_349:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_351:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_352:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_364:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["077"]) -> NonSpare_227:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_368:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_78:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_419:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_336:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_338:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_289:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["016"]) -> NonSpare_71:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["008"]) -> NonSpare_26:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["271"]) -> NonSpare_461:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["132"]) -> NonSpare_313:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_442:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_451:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_495:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_466:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["161"], Literal["015"], Literal["071"], Literal["130"], Literal["131"], Literal["072"], Literal["150"], Literal["151"], Literal["080"], Literal["073"], Literal["074"], Literal["075"], Literal["076"], Literal["140"], Literal["090"], Literal["210"], Literal["070"], Literal["230"], Literal["145"], Literal["152"], Literal["200"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["077"], Literal["170"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["016"], Literal["008"], Literal["271"], Literal["132"], Literal["250"], Literal["260"], Literal["400"], Literal["295"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_28]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_146]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_360]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_63]:
        ...
    @overload
    def get_item(self, key : Literal["071"]) -> Optional[NonSpare_218]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_305]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_310]:
        ...
    @overload
    def get_item(self, key : Literal["072"]) -> Optional[NonSpare_219]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_339]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_345]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_233]:
        ...
    @overload
    def get_item(self, key : Literal["073"]) -> Optional[NonSpare_220]:
        ...
    @overload
    def get_item(self, key : Literal["074"]) -> Optional[NonSpare_222]:
        ...
    @overload
    def get_item(self, key : Literal["075"]) -> Optional[NonSpare_223]:
        ...
    @overload
    def get_item(self, key : Literal["076"]) -> Optional[NonSpare_225]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_319]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_252]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_409]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_204]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_428]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_333]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_347]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_395]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_349]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_351]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_352]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_364]:
        ...
    @overload
    def get_item(self, key : Literal["077"]) -> Optional[NonSpare_227]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_368]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_78]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_419]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_336]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_338]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_289]:
        ...
    @overload
    def get_item(self, key : Literal["016"]) -> Optional[NonSpare_71]:
        ...
    @overload
    def get_item(self, key : Literal["008"]) -> Optional[NonSpare_26]:
        ...
    @overload
    def get_item(self, key : Literal["271"]) -> Optional[NonSpare_461]:
        ...
    @overload
    def get_item(self, key : Literal["132"]) -> Optional[NonSpare_313]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_442]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_451]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_495]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_466]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_28_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_146_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_360_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_63_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["071"], val : NonSpare_218_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_305_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_310_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["072"], val : NonSpare_219_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_339_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_345_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_233_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["073"], val : NonSpare_220_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["074"], val : NonSpare_222_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["075"], val : NonSpare_223_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["076"], val : NonSpare_225_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_319_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_252_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_409_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_204_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_428_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_333_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_347_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_395_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_349_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_351_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_352_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_364_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["077"], val : NonSpare_227_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_368_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_78_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_419_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_336_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_338_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_289_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["016"], val : NonSpare_71_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["008"], val : NonSpare_26_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["271"], val : NonSpare_461_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["132"], val : NonSpare_313_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_442_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_451_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_495_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_466_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_8':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["071"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["072"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["073"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["074"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["075"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["076"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["077"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["016"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["008"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["271"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["132"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_8':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_8_Arg) -> 'Record_8':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_8", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_8_Arg: TypeAlias = Record_8
class Uap_8(UapSingle):
    cv_record = Record_8

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_8]]:
        return cls._parse(bs)

class Asterix_29(AstCat):
    cv_category = 21
    cv_edition = (2, 2)
    cv_uap = Uap_8

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_8_Arg]) -> "Asterix_29":
        return cls._create(records) # type: ignore

Content_113_Arg: TypeAlias = int
class Content_113(ContentTable):
    cv_values = {0: "Default", 1: "List Lookup failed (see note)"}

RuleContent_113_Arg: TypeAlias = Content_113_Arg
class RuleContent_113(RuleContentContextFree):
    cv_content = Content_113

    @property
    def content(self) -> Content_113:
        return self._get_content() # type: ignore

Variation_410_Arg: TypeAlias = RuleContent_113_Arg
class Variation_410(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_113

    @classmethod
    def create(cls, arg : Variation_410_Arg) -> "Variation_410":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_113:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_113:
        return self.rule.content

RuleVariation_399_Arg: TypeAlias = Variation_410_Arg
class RuleVariation_399(RuleVariationContextFree):
    cv_variation = Variation_410

    @classmethod
    def create(cls, arg : RuleVariation_399_Arg) -> "RuleVariation_399":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_410:
        return self.arg # type: ignore

NonSpare_1161_Arg: TypeAlias = RuleVariation_399_Arg
class NonSpare_1161(NonSpare):
    cv_name = "LLC"
    cv_title = "List Lookup Check"
    cv_rule = RuleVariation_399

    @classmethod
    def create(cls, arg : NonSpare_1161_Arg) -> "NonSpare_1161":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_399:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_410:
        return self.rule.variation

Item_477_Arg: TypeAlias = NonSpare_1161_Arg
class Item_477(Item):
    cv_non_spare = NonSpare_1161

    @classmethod
    def create(cls, arg : Item_477_Arg) -> "Item_477":
        return cls._create(arg) # type: ignore

Variation_1339_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_121_Arg, Tuple[Literal["ATP"], RuleVariation_121_Arg]], Union[RuleVariation_663_Arg, Tuple[Literal["ARC"], RuleVariation_663_Arg]], Union[RuleVariation_802_Arg, Tuple[Literal["RC"], RuleVariation_802_Arg]], Union[RuleVariation_916_Arg, Tuple[Literal["RAB"], RuleVariation_916_Arg]], None]]
Variation_1339_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_60_Arg, Tuple[Literal["DCR"], RuleVariation_60_Arg]], Union[RuleVariation_416_Arg, Tuple[Literal["GBS"], RuleVariation_416_Arg]], Union[RuleVariation_494_Arg, Tuple[Literal["SIM"], RuleVariation_494_Arg]], Union[RuleVariation_619_Arg, Tuple[Literal["TST"], RuleVariation_619_Arg]], Union[RuleVariation_708_Arg, Tuple[Literal["SAA"], RuleVariation_708_Arg]], Union[RuleVariation_850_Arg, Tuple[Literal["CL"], RuleVariation_850_Arg]], None]]
Variation_1339_Arg_Group_3: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_399_Arg, Tuple[Literal["LLC"], RuleVariation_399_Arg]], Union[RuleVariation_512_Arg, Tuple[Literal["IPC"], RuleVariation_512_Arg]], Union[RuleVariation_636_Arg, Tuple[Literal["NOGO"], RuleVariation_636_Arg]], Union[RuleVariation_688_Arg, Tuple[Literal["CPR"], RuleVariation_688_Arg]], Union[RuleVariation_825_Arg, Tuple[Literal["LDPJ"], RuleVariation_825_Arg]], Union[RuleVariation_885_Arg, Tuple[Literal["RCF"], RuleVariation_885_Arg]], None]]
Variation_1339_Arg: TypeAlias = Union[
    Tuple[Variation_1339_Arg_Group_1],
    Tuple[Variation_1339_Arg_Group_1, Variation_1339_Arg_Group_2],
    Tuple[Variation_1339_Arg_Group_1, Variation_1339_Arg_Group_2, Variation_1339_Arg_Group_3],
]
class Variation_1339(Extended):
    cv_items_list = [[(Item_89, 3), (Item_82, 2), (Item_777, 1), (Item_768, 1), None], [(Item_252, 1), (Item_367, 1), (Item_900, 1), (Item_1053, 1), (Item_849, 1), (Item_160, 2), None], [(Item_0, 1), (Item_477, 1), (Item_434, 1), (Item_623, 1), (Item_209, 1), (Item_474, 1), (Item_781, 1), None]]

    @classmethod
    def create(cls, arg : Variation_1339_Arg) -> 'Variation_1339':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["ATP"]) -> RuleVariation_121:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_663:
        ...
    @overload
    def get_item(self, key : Literal["RC"]) -> RuleVariation_802:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_916:
        ...
    @overload
    def get_item(self, key : Literal["DCR"]) -> Optional[RuleVariation_60]:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> Optional[RuleVariation_416]:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_494]:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_619]:
        ...
    @overload
    def get_item(self, key : Literal["SAA"]) -> Optional[RuleVariation_708]:
        ...
    @overload
    def get_item(self, key : Literal["CL"]) -> Optional[RuleVariation_850]:
        ...
    @overload
    def get_item(self, key : Literal["LLC"]) -> Optional[RuleVariation_399]:
        ...
    @overload
    def get_item(self, key : Literal["IPC"]) -> Optional[RuleVariation_512]:
        ...
    @overload
    def get_item(self, key : Literal["NOGO"]) -> Optional[RuleVariation_636]:
        ...
    @overload
    def get_item(self, key : Literal["CPR"]) -> Optional[RuleVariation_688]:
        ...
    @overload
    def get_item(self, key : Literal["LDPJ"]) -> Optional[RuleVariation_825]:
        ...
    @overload
    def get_item(self, key : Literal["RCF"]) -> Optional[RuleVariation_885]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1262_Arg: TypeAlias = Variation_1339_Arg
class RuleVariation_1262(RuleVariationContextFree):
    cv_variation = Variation_1339

    @classmethod
    def create(cls, arg : RuleVariation_1262_Arg) -> "RuleVariation_1262":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1339:
        return self.arg # type: ignore

NonSpare_144_Arg: TypeAlias = RuleVariation_1262_Arg
class NonSpare_144(NonSpare):
    cv_name = "040"
    cv_title = "Target Report Descriptor"
    cv_rule = RuleVariation_1262

    @classmethod
    def create(cls, arg : NonSpare_144_Arg) -> "NonSpare_144":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1262:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1339:
        return self.rule.variation

class UapItem_144(UapItem):
    cv_non_spare = NonSpare_144

Record_5_Arg = TypedDict('Record_5_Arg', {
    "010": NonSpare_28_Arg,
    "040": NonSpare_144_Arg,
    "161": NonSpare_360_Arg,
    "015": NonSpare_63_Arg,
    "071": NonSpare_218_Arg,
    "130": NonSpare_305_Arg,
    "131": NonSpare_310_Arg,
    "072": NonSpare_219_Arg,
    "150": NonSpare_339_Arg,
    "151": NonSpare_345_Arg,
    "080": NonSpare_233_Arg,
    "073": NonSpare_220_Arg,
    "074": NonSpare_222_Arg,
    "075": NonSpare_223_Arg,
    "076": NonSpare_225_Arg,
    "140": NonSpare_319_Arg,
    "090": NonSpare_252_Arg,
    "210": NonSpare_409_Arg,
    "070": NonSpare_204_Arg,
    "230": NonSpare_428_Arg,
    "145": NonSpare_333_Arg,
    "152": NonSpare_347_Arg,
    "200": NonSpare_395_Arg,
    "155": NonSpare_349_Arg,
    "157": NonSpare_351_Arg,
    "160": NonSpare_352_Arg,
    "165": NonSpare_364_Arg,
    "077": NonSpare_227_Arg,
    "170": NonSpare_368_Arg,
    "020": NonSpare_78_Arg,
    "220": NonSpare_419_Arg,
    "146": NonSpare_336_Arg,
    "148": NonSpare_338_Arg,
    "110": NonSpare_289_Arg,
    "016": NonSpare_71_Arg,
    "008": NonSpare_26_Arg,
    "271": NonSpare_461_Arg,
    "132": NonSpare_313_Arg,
    "250": NonSpare_442_Arg,
    "260": NonSpare_451_Arg,
    "400": NonSpare_495_Arg,
    "295": NonSpare_466_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_5(Record):
    cv_fspec_max_bytes = 7
    cv_items_list = [UapItem_28, UapItem_144, UapItem_360, UapItem_63, UapItem_218, UapItem_305, UapItem_310, UapItem_219, UapItem_339, UapItem_345, UapItem_233, UapItem_220, UapItem_222, UapItem_223, UapItem_225, UapItem_319, UapItem_252, UapItem_409, UapItem_204, UapItem_428, UapItem_333, UapItem_347, UapItem_395, UapItem_349, UapItem_351, UapItem_352, UapItem_364, UapItem_227, UapItem_368, UapItem_78, UapItem_419, UapItem_336, UapItem_338, UapItem_289, UapItem_71, UapItem_26, UapItem_461, UapItem_313, UapItem_442, UapItem_451, UapItem_494, UapItem_466, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_28, "040": NonSpare_144, "161": NonSpare_360, "015": NonSpare_63, "071": NonSpare_218, "130": NonSpare_305, "131": NonSpare_310, "072": NonSpare_219, "150": NonSpare_339, "151": NonSpare_345, "080": NonSpare_233, "073": NonSpare_220, "074": NonSpare_222, "075": NonSpare_223, "076": NonSpare_225, "140": NonSpare_319, "090": NonSpare_252, "210": NonSpare_409, "070": NonSpare_204, "230": NonSpare_428, "145": NonSpare_333, "152": NonSpare_347, "200": NonSpare_395, "155": NonSpare_349, "157": NonSpare_351, "160": NonSpare_352, "165": NonSpare_364, "077": NonSpare_227, "170": NonSpare_368, "020": NonSpare_78, "220": NonSpare_419, "146": NonSpare_336, "148": NonSpare_338, "110": NonSpare_289, "016": NonSpare_71, "008": NonSpare_26, "271": NonSpare_461, "132": NonSpare_313, "250": NonSpare_442, "260": NonSpare_451, "400": NonSpare_495, "295": NonSpare_466, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_28:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_144:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_360:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_63:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["071"]) -> NonSpare_218:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_305:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_310:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["072"]) -> NonSpare_219:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_339:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_345:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["073"]) -> NonSpare_220:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["074"]) -> NonSpare_222:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["075"]) -> NonSpare_223:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["076"]) -> NonSpare_225:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_319:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_252:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_409:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_204:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_428:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_333:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_347:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_395:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_349:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_351:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_352:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_364:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["077"]) -> NonSpare_227:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_368:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_78:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_419:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_336:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_338:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_289:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["016"]) -> NonSpare_71:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["008"]) -> NonSpare_26:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["271"]) -> NonSpare_461:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["132"]) -> NonSpare_313:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_442:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_451:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_495:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_466:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["161"], Literal["015"], Literal["071"], Literal["130"], Literal["131"], Literal["072"], Literal["150"], Literal["151"], Literal["080"], Literal["073"], Literal["074"], Literal["075"], Literal["076"], Literal["140"], Literal["090"], Literal["210"], Literal["070"], Literal["230"], Literal["145"], Literal["152"], Literal["200"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["077"], Literal["170"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["016"], Literal["008"], Literal["271"], Literal["132"], Literal["250"], Literal["260"], Literal["400"], Literal["295"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_28]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_144]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_360]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_63]:
        ...
    @overload
    def get_item(self, key : Literal["071"]) -> Optional[NonSpare_218]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_305]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_310]:
        ...
    @overload
    def get_item(self, key : Literal["072"]) -> Optional[NonSpare_219]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_339]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_345]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_233]:
        ...
    @overload
    def get_item(self, key : Literal["073"]) -> Optional[NonSpare_220]:
        ...
    @overload
    def get_item(self, key : Literal["074"]) -> Optional[NonSpare_222]:
        ...
    @overload
    def get_item(self, key : Literal["075"]) -> Optional[NonSpare_223]:
        ...
    @overload
    def get_item(self, key : Literal["076"]) -> Optional[NonSpare_225]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_319]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_252]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_409]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_204]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_428]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_333]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_347]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_395]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_349]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_351]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_352]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_364]:
        ...
    @overload
    def get_item(self, key : Literal["077"]) -> Optional[NonSpare_227]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_368]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_78]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_419]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_336]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_338]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_289]:
        ...
    @overload
    def get_item(self, key : Literal["016"]) -> Optional[NonSpare_71]:
        ...
    @overload
    def get_item(self, key : Literal["008"]) -> Optional[NonSpare_26]:
        ...
    @overload
    def get_item(self, key : Literal["271"]) -> Optional[NonSpare_461]:
        ...
    @overload
    def get_item(self, key : Literal["132"]) -> Optional[NonSpare_313]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_442]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_451]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_495]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_466]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_28_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_144_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_360_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_63_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["071"], val : NonSpare_218_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_305_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_310_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["072"], val : NonSpare_219_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_339_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_345_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_233_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["073"], val : NonSpare_220_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["074"], val : NonSpare_222_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["075"], val : NonSpare_223_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["076"], val : NonSpare_225_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_319_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_252_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_409_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_204_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_428_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_333_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_347_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_395_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_349_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_351_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_352_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_364_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["077"], val : NonSpare_227_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_368_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_78_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_419_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_336_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_338_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_289_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["016"], val : NonSpare_71_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["008"], val : NonSpare_26_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["271"], val : NonSpare_461_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["132"], val : NonSpare_313_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_442_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_451_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_495_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_466_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_5':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["071"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["072"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["073"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["074"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["075"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["076"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["077"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["016"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["008"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["271"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["132"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_5':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_5_Arg) -> 'Record_5':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_5", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_5_Arg: TypeAlias = Record_5
class Uap_5(UapSingle):
    cv_record = Record_5

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_5]]:
        return cls._parse(bs)

class Asterix_30(AstCat):
    cv_category = 21
    cv_edition = (2, 3)
    cv_uap = Uap_5

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_5_Arg]) -> "Asterix_30":
        return cls._create(records) # type: ignore

class Asterix_31(AstCat):
    cv_category = 21
    cv_edition = (2, 4)
    cv_uap = Uap_5

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_5_Arg]) -> "Asterix_31":
        return cls._create(records) # type: ignore

NonSpare_143_Arg: TypeAlias = RuleVariation_1262_Arg
class NonSpare_143(NonSpare):
    cv_name = "040"
    cv_title = "Target Report Descriptor"
    cv_rule = RuleVariation_1262

    @classmethod
    def create(cls, arg : NonSpare_143_Arg) -> "NonSpare_143":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1262:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1339:
        return self.rule.variation

class UapItem_143(UapItem):
    cv_non_spare = NonSpare_143

NonSpare_234_Arg: TypeAlias = RuleVariation_340_Arg
class NonSpare_234(NonSpare):
    cv_name = "080"
    cv_title = "Target Address"
    cv_rule = RuleVariation_340

    @classmethod
    def create(cls, arg : NonSpare_234_Arg) -> "NonSpare_234":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_340:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_347:
        return self.rule.variation

class UapItem_234(UapItem):
    cv_non_spare = NonSpare_234

Content_200_Arg: TypeAlias = int
class Content_200(ContentTable):
    cv_values = {0: "ED102/DO-260 [Ref. 7]", 1: "DO-260A [Ref. 8]", 2: "ED102A/DO-260B [Ref. 10]", 3: "ED-102B/DO-260C [Ref. 11]"}

RuleContent_200_Arg: TypeAlias = Content_200_Arg
class RuleContent_200(RuleContentContextFree):
    cv_content = Content_200

    @property
    def content(self) -> Content_200:
        return self._get_content() # type: ignore

Variation_595_Arg: TypeAlias = RuleContent_200_Arg
class Variation_595(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 3
    cv_rule = RuleContent_200

    @classmethod
    def create(cls, arg : Variation_595_Arg) -> "Variation_595":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_200:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_200:
        return self.rule.content

RuleVariation_584_Arg: TypeAlias = Variation_595_Arg
class RuleVariation_584(RuleVariationContextFree):
    cv_variation = Variation_595

    @classmethod
    def create(cls, arg : RuleVariation_584_Arg) -> "RuleVariation_584":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_595:
        return self.arg # type: ignore

NonSpare_2024_Arg: TypeAlias = RuleVariation_584_Arg
class NonSpare_2024(NonSpare):
    cv_name = "VN"
    cv_title = "Version Number"
    cv_rule = RuleVariation_584

    @classmethod
    def create(cls, arg : NonSpare_2024_Arg) -> "NonSpare_2024":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_584:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_595:
        return self.rule.variation

Item_1139_Arg: TypeAlias = NonSpare_2024_Arg
class Item_1139(Item):
    cv_non_spare = NonSpare_2024

    @classmethod
    def create(cls, arg : Item_1139_Arg) -> "Item_1139":
        return cls._create(arg) # type: ignore

Variation_999_Arg_Group = Tuple[int, Union[RuleVariation_442_Arg, Tuple[Literal["VNS"], RuleVariation_442_Arg]], Union[RuleVariation_584_Arg, Tuple[Literal["VN"], RuleVariation_584_Arg]], Union[RuleVariation_859_Arg, Tuple[Literal["LTT"], RuleVariation_859_Arg]]]
Variation_999_Arg: TypeAlias = Union[int, Variation_999_Arg_Group]
class Variation_999(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_0, 1), (Item_1142, 1), (Item_1139, 3), (Item_505, 3)]
    cv_items_dict = {"VNS": RuleVariation_442, "VN": RuleVariation_584, "LTT": RuleVariation_859}

    @overload
    @classmethod
    def spec(cls, key : Literal["VNS"]) -> RuleVariation_442:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VN"]) -> RuleVariation_584:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LTT"]) -> RuleVariation_859:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VNS"], Literal["VN"], Literal["LTT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VNS"]) -> RuleVariation_442:
        ...
    @overload
    def get_item(self, key : Literal["VN"]) -> RuleVariation_584:
        ...
    @overload
    def get_item(self, key : Literal["LTT"]) -> RuleVariation_859:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_999_Arg) -> 'Variation_999':
        return cls._create(arg) # type: ignore

RuleVariation_969_Arg: TypeAlias = Variation_999_Arg
class RuleVariation_969(RuleVariationContextFree):
    cv_variation = Variation_999

    @classmethod
    def create(cls, arg : RuleVariation_969_Arg) -> "RuleVariation_969":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_999:
        return self.arg # type: ignore

NonSpare_408_Arg: TypeAlias = RuleVariation_969_Arg
class NonSpare_408(NonSpare):
    cv_name = "210"
    cv_title = "MOPS Version"
    cv_rule = RuleVariation_969

    @classmethod
    def create(cls, arg : NonSpare_408_Arg) -> "NonSpare_408":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_969:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_999:
        return self.rule.variation

class UapItem_408(UapItem):
    cv_non_spare = NonSpare_408

NonSpare_396_Arg: TypeAlias = RuleVariation_1071_Arg
class NonSpare_396(NonSpare):
    cv_name = "200"
    cv_title = "Target Status"
    cv_rule = RuleVariation_1071

    @classmethod
    def create(cls, arg : NonSpare_396_Arg) -> "NonSpare_396":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1071:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1114:
        return self.rule.variation

class UapItem_396(UapItem):
    cv_non_spare = NonSpare_396

NonSpare_452_Arg: TypeAlias = RuleVariation_1168_Arg
class NonSpare_452(NonSpare):
    cv_name = "260"
    cv_title = "ACAS Resolution Advisory Report"
    cv_rule = RuleVariation_1168

    @classmethod
    def create(cls, arg : NonSpare_452_Arg) -> "NonSpare_452":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1168:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1231:
        return self.rule.variation

class UapItem_452(UapItem):
    cv_non_spare = NonSpare_452

Record_4_Arg = TypedDict('Record_4_Arg', {
    "010": NonSpare_28_Arg,
    "040": NonSpare_143_Arg,
    "161": NonSpare_360_Arg,
    "015": NonSpare_63_Arg,
    "071": NonSpare_218_Arg,
    "130": NonSpare_305_Arg,
    "131": NonSpare_310_Arg,
    "072": NonSpare_219_Arg,
    "150": NonSpare_339_Arg,
    "151": NonSpare_345_Arg,
    "080": NonSpare_234_Arg,
    "073": NonSpare_220_Arg,
    "074": NonSpare_222_Arg,
    "075": NonSpare_223_Arg,
    "076": NonSpare_225_Arg,
    "140": NonSpare_319_Arg,
    "090": NonSpare_252_Arg,
    "210": NonSpare_408_Arg,
    "070": NonSpare_204_Arg,
    "230": NonSpare_428_Arg,
    "145": NonSpare_333_Arg,
    "152": NonSpare_347_Arg,
    "200": NonSpare_396_Arg,
    "155": NonSpare_349_Arg,
    "157": NonSpare_351_Arg,
    "160": NonSpare_352_Arg,
    "165": NonSpare_364_Arg,
    "077": NonSpare_227_Arg,
    "170": NonSpare_368_Arg,
    "020": NonSpare_78_Arg,
    "220": NonSpare_419_Arg,
    "146": NonSpare_336_Arg,
    "148": NonSpare_338_Arg,
    "110": NonSpare_289_Arg,
    "016": NonSpare_71_Arg,
    "008": NonSpare_26_Arg,
    "271": NonSpare_461_Arg,
    "132": NonSpare_313_Arg,
    "250": NonSpare_442_Arg,
    "260": NonSpare_452_Arg,
    "400": NonSpare_495_Arg,
    "295": NonSpare_466_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_4(Record):
    cv_fspec_max_bytes = 7
    cv_items_list = [UapItem_28, UapItem_143, UapItem_360, UapItem_63, UapItem_218, UapItem_305, UapItem_310, UapItem_219, UapItem_339, UapItem_345, UapItem_234, UapItem_220, UapItem_222, UapItem_223, UapItem_225, UapItem_319, UapItem_252, UapItem_408, UapItem_204, UapItem_428, UapItem_333, UapItem_347, UapItem_396, UapItem_349, UapItem_351, UapItem_352, UapItem_364, UapItem_227, UapItem_368, UapItem_78, UapItem_419, UapItem_336, UapItem_338, UapItem_289, UapItem_71, UapItem_26, UapItem_461, UapItem_313, UapItem_442, UapItem_452, UapItem_494, UapItem_466, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_28, "040": NonSpare_143, "161": NonSpare_360, "015": NonSpare_63, "071": NonSpare_218, "130": NonSpare_305, "131": NonSpare_310, "072": NonSpare_219, "150": NonSpare_339, "151": NonSpare_345, "080": NonSpare_234, "073": NonSpare_220, "074": NonSpare_222, "075": NonSpare_223, "076": NonSpare_225, "140": NonSpare_319, "090": NonSpare_252, "210": NonSpare_408, "070": NonSpare_204, "230": NonSpare_428, "145": NonSpare_333, "152": NonSpare_347, "200": NonSpare_396, "155": NonSpare_349, "157": NonSpare_351, "160": NonSpare_352, "165": NonSpare_364, "077": NonSpare_227, "170": NonSpare_368, "020": NonSpare_78, "220": NonSpare_419, "146": NonSpare_336, "148": NonSpare_338, "110": NonSpare_289, "016": NonSpare_71, "008": NonSpare_26, "271": NonSpare_461, "132": NonSpare_313, "250": NonSpare_442, "260": NonSpare_452, "400": NonSpare_495, "295": NonSpare_466, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_28:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_143:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_360:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_63:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["071"]) -> NonSpare_218:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_305:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_310:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["072"]) -> NonSpare_219:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_339:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_345:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_234:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["073"]) -> NonSpare_220:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["074"]) -> NonSpare_222:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["075"]) -> NonSpare_223:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["076"]) -> NonSpare_225:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_319:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_252:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_408:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_204:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_428:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_333:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_347:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_349:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_351:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_352:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_364:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["077"]) -> NonSpare_227:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_368:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_78:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_419:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_336:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_338:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_289:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["016"]) -> NonSpare_71:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["008"]) -> NonSpare_26:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["271"]) -> NonSpare_461:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["132"]) -> NonSpare_313:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_442:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_452:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_495:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_466:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["161"], Literal["015"], Literal["071"], Literal["130"], Literal["131"], Literal["072"], Literal["150"], Literal["151"], Literal["080"], Literal["073"], Literal["074"], Literal["075"], Literal["076"], Literal["140"], Literal["090"], Literal["210"], Literal["070"], Literal["230"], Literal["145"], Literal["152"], Literal["200"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["077"], Literal["170"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["016"], Literal["008"], Literal["271"], Literal["132"], Literal["250"], Literal["260"], Literal["400"], Literal["295"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_28]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_143]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_360]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_63]:
        ...
    @overload
    def get_item(self, key : Literal["071"]) -> Optional[NonSpare_218]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_305]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_310]:
        ...
    @overload
    def get_item(self, key : Literal["072"]) -> Optional[NonSpare_219]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_339]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_345]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_234]:
        ...
    @overload
    def get_item(self, key : Literal["073"]) -> Optional[NonSpare_220]:
        ...
    @overload
    def get_item(self, key : Literal["074"]) -> Optional[NonSpare_222]:
        ...
    @overload
    def get_item(self, key : Literal["075"]) -> Optional[NonSpare_223]:
        ...
    @overload
    def get_item(self, key : Literal["076"]) -> Optional[NonSpare_225]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_319]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_252]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_408]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_204]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_428]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_333]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_347]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_396]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_349]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_351]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_352]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_364]:
        ...
    @overload
    def get_item(self, key : Literal["077"]) -> Optional[NonSpare_227]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_368]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_78]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_419]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_336]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_338]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_289]:
        ...
    @overload
    def get_item(self, key : Literal["016"]) -> Optional[NonSpare_71]:
        ...
    @overload
    def get_item(self, key : Literal["008"]) -> Optional[NonSpare_26]:
        ...
    @overload
    def get_item(self, key : Literal["271"]) -> Optional[NonSpare_461]:
        ...
    @overload
    def get_item(self, key : Literal["132"]) -> Optional[NonSpare_313]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_442]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_452]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_495]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_466]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_28_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_143_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_360_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_63_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["071"], val : NonSpare_218_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_305_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_310_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["072"], val : NonSpare_219_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_339_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_345_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_234_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["073"], val : NonSpare_220_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["074"], val : NonSpare_222_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["075"], val : NonSpare_223_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["076"], val : NonSpare_225_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_319_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_252_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_408_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_204_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_428_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_333_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_347_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_396_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_349_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_351_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_352_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_364_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["077"], val : NonSpare_227_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_368_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_78_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_419_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_336_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_338_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_289_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["016"], val : NonSpare_71_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["008"], val : NonSpare_26_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["271"], val : NonSpare_461_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["132"], val : NonSpare_313_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_442_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_452_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_495_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_466_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_4':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["071"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["072"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["073"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["074"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["075"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["076"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["077"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["016"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["008"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["271"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["132"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_4':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_4_Arg) -> 'Record_4':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_4", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_4_Arg: TypeAlias = Record_4
class Uap_4(UapSingle):
    cv_record = Record_4

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_4]]:
        return cls._parse(bs)

class Asterix_32(AstCat):
    cv_category = 21
    cv_edition = (2, 5)
    cv_uap = Uap_4

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_4_Arg]) -> "Asterix_32":
        return cls._create(records) # type: ignore

Variation_490_Arg: TypeAlias = RuleContent_610_Arg
class Variation_490(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 6
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_490_Arg) -> "Variation_490":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_479_Arg: TypeAlias = Variation_490_Arg
class RuleVariation_479(RuleVariationContextFree):
    cv_variation = Variation_490

    @classmethod
    def create(cls, arg : RuleVariation_479_Arg) -> "RuleVariation_479":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_490:
        return self.arg # type: ignore

NonSpare_2006_Arg: TypeAlias = RuleVariation_479_Arg
class NonSpare_2006(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_479

    @classmethod
    def create(cls, arg : NonSpare_2006_Arg) -> "NonSpare_2006":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_479:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_490:
        return self.rule.variation

Item_1122_Arg: TypeAlias = NonSpare_2006_Arg
class Item_1122(Item):
    cv_non_spare = NonSpare_2006

    @classmethod
    def create(cls, arg : Item_1122_Arg) -> "Item_1122":
        return cls._create(arg) # type: ignore

Variation_1095_Arg_Group = Tuple[Union[RuleVariation_41_Arg, Tuple[Literal["EP"], RuleVariation_41_Arg]], Union[RuleVariation_479_Arg, Tuple[Literal["VAL"], RuleVariation_479_Arg]]]
Variation_1095_Arg: TypeAlias = Union[int, Variation_1095_Arg_Group]
class Variation_1095(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_items_list = [(Item_300, 1), (Item_1122, 6)]
    cv_items_dict = {"EP": RuleVariation_41, "VAL": RuleVariation_479}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_479:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_479:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1095_Arg) -> 'Variation_1095':
        return cls._create(arg) # type: ignore

RuleVariation_1053_Arg: TypeAlias = Variation_1095_Arg
class RuleVariation_1053(RuleVariationContextFree):
    cv_variation = Variation_1095

    @classmethod
    def create(cls, arg : RuleVariation_1053_Arg) -> "RuleVariation_1053":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1095:
        return self.arg # type: ignore

NonSpare_2005_Arg: TypeAlias = RuleVariation_479_Arg
class NonSpare_2005(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_479

    @classmethod
    def create(cls, arg : NonSpare_2005_Arg) -> "NonSpare_2005":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_479:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_490:
        return self.rule.variation

Item_1121_Arg: TypeAlias = NonSpare_2005_Arg
class Item_1121(Item):
    cv_non_spare = NonSpare_2005

    @classmethod
    def create(cls, arg : Item_1121_Arg) -> "Item_1121":
        return cls._create(arg) # type: ignore

Variation_1094_Arg_Group = Tuple[Union[RuleVariation_41_Arg, Tuple[Literal["EP"], RuleVariation_41_Arg]], Union[RuleVariation_479_Arg, Tuple[Literal["VAL"], RuleVariation_479_Arg]]]
Variation_1094_Arg: TypeAlias = Union[int, Variation_1094_Arg_Group]
class Variation_1094(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_items_list = [(Item_300, 1), (Item_1121, 6)]
    cv_items_dict = {"EP": RuleVariation_41, "VAL": RuleVariation_479}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_479:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_479:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1094_Arg) -> 'Variation_1094':
        return cls._create(arg) # type: ignore

RuleVariation_1052_Arg: TypeAlias = Variation_1094_Arg
class RuleVariation_1052(RuleVariationContextFree):
    cv_variation = Variation_1094

    @classmethod
    def create(cls, arg : RuleVariation_1052_Arg) -> "RuleVariation_1052":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1094:
        return self.arg # type: ignore

NonSpare_1825_Arg: TypeAlias = RuleVariation_1053_Arg
class NonSpare_1825(NonSpare):
    cv_name = "TBC"
    cv_title = "Total Bits Corrected"
    cv_rule = RuleVariation_1053

    @classmethod
    def create(cls, arg : NonSpare_1825_Arg) -> "NonSpare_1825":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1053:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1095:
        return self.rule.variation

Item_973_Arg: TypeAlias = NonSpare_1825_Arg
class Item_973(Item):
    cv_non_spare = NonSpare_1825

    @classmethod
    def create(cls, arg : Item_973_Arg) -> "Item_973":
        return cls._create(arg) # type: ignore

NonSpare_1224_Arg: TypeAlias = RuleVariation_1052_Arg
class NonSpare_1224(NonSpare):
    cv_name = "MBC"
    cv_title = "Maximum Bits Corrected"
    cv_rule = RuleVariation_1052

    @classmethod
    def create(cls, arg : NonSpare_1224_Arg) -> "NonSpare_1224":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1052:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1094:
        return self.rule.variation

Item_526_Arg: TypeAlias = NonSpare_1224_Arg
class Item_526(Item):
    cv_non_spare = NonSpare_1224

    @classmethod
    def create(cls, arg : Item_526_Arg) -> "Item_526":
        return cls._create(arg) # type: ignore

Variation_1340_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_121_Arg, Tuple[Literal["ATP"], RuleVariation_121_Arg]], Union[RuleVariation_663_Arg, Tuple[Literal["ARC"], RuleVariation_663_Arg]], Union[RuleVariation_802_Arg, Tuple[Literal["RC"], RuleVariation_802_Arg]], Union[RuleVariation_916_Arg, Tuple[Literal["RAB"], RuleVariation_916_Arg]], None]]
Variation_1340_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_60_Arg, Tuple[Literal["DCR"], RuleVariation_60_Arg]], Union[RuleVariation_416_Arg, Tuple[Literal["GBS"], RuleVariation_416_Arg]], Union[RuleVariation_494_Arg, Tuple[Literal["SIM"], RuleVariation_494_Arg]], Union[RuleVariation_619_Arg, Tuple[Literal["TST"], RuleVariation_619_Arg]], Union[RuleVariation_708_Arg, Tuple[Literal["SAA"], RuleVariation_708_Arg]], Union[RuleVariation_850_Arg, Tuple[Literal["CL"], RuleVariation_850_Arg]], None]]
Variation_1340_Arg_Group_3: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_399_Arg, Tuple[Literal["LLC"], RuleVariation_399_Arg]], Union[RuleVariation_512_Arg, Tuple[Literal["IPC"], RuleVariation_512_Arg]], Union[RuleVariation_636_Arg, Tuple[Literal["NOGO"], RuleVariation_636_Arg]], Union[RuleVariation_688_Arg, Tuple[Literal["CPR"], RuleVariation_688_Arg]], Union[RuleVariation_825_Arg, Tuple[Literal["LDPJ"], RuleVariation_825_Arg]], Union[RuleVariation_885_Arg, Tuple[Literal["RCF"], RuleVariation_885_Arg]], None]]
Variation_1340_Arg_Group_4: TypeAlias = Union[int, Tuple[Union[RuleVariation_1053_Arg, Tuple[Literal["TBC"], RuleVariation_1053_Arg]], None]]
Variation_1340_Arg_Group_5: TypeAlias = Union[int, Tuple[Union[RuleVariation_1052_Arg, Tuple[Literal["MBC"], RuleVariation_1052_Arg]], None]]
Variation_1340_Arg: TypeAlias = Union[
    Tuple[Variation_1340_Arg_Group_1],
    Tuple[Variation_1340_Arg_Group_1, Variation_1340_Arg_Group_2],
    Tuple[Variation_1340_Arg_Group_1, Variation_1340_Arg_Group_2, Variation_1340_Arg_Group_3],
    Tuple[Variation_1340_Arg_Group_1, Variation_1340_Arg_Group_2, Variation_1340_Arg_Group_3, Variation_1340_Arg_Group_4],
    Tuple[Variation_1340_Arg_Group_1, Variation_1340_Arg_Group_2, Variation_1340_Arg_Group_3, Variation_1340_Arg_Group_4, Variation_1340_Arg_Group_5],
]
class Variation_1340(Extended):
    cv_items_list = [[(Item_89, 3), (Item_82, 2), (Item_777, 1), (Item_768, 1), None], [(Item_252, 1), (Item_367, 1), (Item_900, 1), (Item_1053, 1), (Item_849, 1), (Item_160, 2), None], [(Item_0, 1), (Item_477, 1), (Item_434, 1), (Item_623, 1), (Item_209, 1), (Item_474, 1), (Item_781, 1), None], [(Item_973, 7), None], [(Item_526, 7), None]]

    @classmethod
    def create(cls, arg : Variation_1340_Arg) -> 'Variation_1340':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["ATP"]) -> RuleVariation_121:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_663:
        ...
    @overload
    def get_item(self, key : Literal["RC"]) -> RuleVariation_802:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_916:
        ...
    @overload
    def get_item(self, key : Literal["DCR"]) -> Optional[RuleVariation_60]:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> Optional[RuleVariation_416]:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_494]:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_619]:
        ...
    @overload
    def get_item(self, key : Literal["SAA"]) -> Optional[RuleVariation_708]:
        ...
    @overload
    def get_item(self, key : Literal["CL"]) -> Optional[RuleVariation_850]:
        ...
    @overload
    def get_item(self, key : Literal["LLC"]) -> Optional[RuleVariation_399]:
        ...
    @overload
    def get_item(self, key : Literal["IPC"]) -> Optional[RuleVariation_512]:
        ...
    @overload
    def get_item(self, key : Literal["NOGO"]) -> Optional[RuleVariation_636]:
        ...
    @overload
    def get_item(self, key : Literal["CPR"]) -> Optional[RuleVariation_688]:
        ...
    @overload
    def get_item(self, key : Literal["LDPJ"]) -> Optional[RuleVariation_825]:
        ...
    @overload
    def get_item(self, key : Literal["RCF"]) -> Optional[RuleVariation_885]:
        ...
    @overload
    def get_item(self, key : Literal["TBC"]) -> Optional[RuleVariation_1053]:
        ...
    @overload
    def get_item(self, key : Literal["MBC"]) -> Optional[RuleVariation_1052]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1263_Arg: TypeAlias = Variation_1340_Arg
class RuleVariation_1263(RuleVariationContextFree):
    cv_variation = Variation_1340

    @classmethod
    def create(cls, arg : RuleVariation_1263_Arg) -> "RuleVariation_1263":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1340:
        return self.arg # type: ignore

NonSpare_145_Arg: TypeAlias = RuleVariation_1263_Arg
class NonSpare_145(NonSpare):
    cv_name = "040"
    cv_title = "Target Report Descriptor"
    cv_rule = RuleVariation_1263

    @classmethod
    def create(cls, arg : NonSpare_145_Arg) -> "NonSpare_145":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1263:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1340:
        return self.rule.variation

class UapItem_145(UapItem):
    cv_non_spare = NonSpare_145

NonSpare_397_Arg: TypeAlias = RuleVariation_1071_Arg
class NonSpare_397(NonSpare):
    cv_name = "200"
    cv_title = "Target Status"
    cv_rule = RuleVariation_1071

    @classmethod
    def create(cls, arg : NonSpare_397_Arg) -> "NonSpare_397":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1071:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1114:
        return self.rule.variation

class UapItem_397(UapItem):
    cv_non_spare = NonSpare_397

NonSpare_453_Arg: TypeAlias = RuleVariation_1168_Arg
class NonSpare_453(NonSpare):
    cv_name = "260"
    cv_title = "ACAS Resolution Advisory Report"
    cv_rule = RuleVariation_1168

    @classmethod
    def create(cls, arg : NonSpare_453_Arg) -> "NonSpare_453":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1168:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1231:
        return self.rule.variation

class UapItem_453(UapItem):
    cv_non_spare = NonSpare_453

NonSpare_1649_Arg: TypeAlias = RuleVariation_220_Arg
class NonSpare_1649(NonSpare):
    cv_name = "SAL"
    cv_title = "Selected Altitude Age"
    cv_rule = RuleVariation_220

    @classmethod
    def create(cls, arg : NonSpare_1649_Arg) -> "NonSpare_1649":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

Variation_1465_Arg = TypedDict('Variation_1465_Arg', {
    "AOS": NonSpare_608_Arg,
    "TRD": NonSpare_1904_Arg,
    "M3A": NonSpare_1207_Arg,
    "QI": NonSpare_1517_Arg,
    "TI1": NonSpare_1852_Arg,
    "MAM": NonSpare_1218_Arg,
    "GH": NonSpare_1026_Arg,
    "FL": NonSpare_967_Arg,
    "SAL": NonSpare_1649_Arg,
    "FSA": NonSpare_991_Arg,
    "AS": NonSpare_628_Arg,
    "TAS": NonSpare_1822_Arg,
    "MH": NonSpare_1268_Arg,
    "BVR": NonSpare_692_Arg,
    "GVR": NonSpare_1043_Arg,
    "GV": NonSpare_1039_Arg,
    "TAR": NonSpare_1819_Arg,
    "TI2": NonSpare_1853_Arg,
    "TS": NonSpare_1916_Arg,
    "MET": NonSpare_1261_Arg,
    "ROA": NonSpare_1590_Arg,
    "ARA": NonSpare_619_Arg,
    "SCC": NonSpare_1657_Arg,
}, total=False)
class Variation_1465(Compound):
    cv_fspec_max_bytes = 4
    cv_items_list = [NonSpare_608, NonSpare_1904, NonSpare_1207, NonSpare_1517, NonSpare_1852, NonSpare_1218, NonSpare_1026, NonSpare_967, NonSpare_1649, NonSpare_991, NonSpare_628, NonSpare_1822, NonSpare_1268, NonSpare_692, NonSpare_1043, NonSpare_1039, NonSpare_1819, NonSpare_1853, NonSpare_1916, NonSpare_1261, NonSpare_1590, NonSpare_619, NonSpare_1657]
    cv_items_dict = {"AOS": NonSpare_608, "TRD": NonSpare_1904, "M3A": NonSpare_1207, "QI": NonSpare_1517, "TI1": NonSpare_1852, "MAM": NonSpare_1218, "GH": NonSpare_1026, "FL": NonSpare_967, "SAL": NonSpare_1649, "FSA": NonSpare_991, "AS": NonSpare_628, "TAS": NonSpare_1822, "MH": NonSpare_1268, "BVR": NonSpare_692, "GVR": NonSpare_1043, "GV": NonSpare_1039, "TAR": NonSpare_1819, "TI2": NonSpare_1853, "TS": NonSpare_1916, "MET": NonSpare_1261, "ROA": NonSpare_1590, "ARA": NonSpare_619, "SCC": NonSpare_1657}

    @overload
    @classmethod
    def spec(cls, key : Literal["AOS"]) -> NonSpare_608:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRD"]) -> NonSpare_1904:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M3A"]) -> NonSpare_1207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QI"]) -> NonSpare_1517:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TI1"]) -> NonSpare_1852:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MAM"]) -> NonSpare_1218:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GH"]) -> NonSpare_1026:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FL"]) -> NonSpare_967:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAL"]) -> NonSpare_1649:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FSA"]) -> NonSpare_991:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AS"]) -> NonSpare_628:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAS"]) -> NonSpare_1822:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MH"]) -> NonSpare_1268:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BVR"]) -> NonSpare_692:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GVR"]) -> NonSpare_1043:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GV"]) -> NonSpare_1039:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAR"]) -> NonSpare_1819:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TI2"]) -> NonSpare_1853:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TS"]) -> NonSpare_1916:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MET"]) -> NonSpare_1261:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ROA"]) -> NonSpare_1590:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARA"]) -> NonSpare_619:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SCC"]) -> NonSpare_1657:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AOS"], Literal["TRD"], Literal["M3A"], Literal["QI"], Literal["TI1"], Literal["MAM"], Literal["GH"], Literal["FL"], Literal["SAL"], Literal["FSA"], Literal["AS"], Literal["TAS"], Literal["MH"], Literal["BVR"], Literal["GVR"], Literal["GV"], Literal["TAR"], Literal["TI2"], Literal["TS"], Literal["MET"], Literal["ROA"], Literal["ARA"], Literal["SCC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AOS"]) -> Optional[NonSpare_608]:
        ...
    @overload
    def get_item(self, key : Literal["TRD"]) -> Optional[NonSpare_1904]:
        ...
    @overload
    def get_item(self, key : Literal["M3A"]) -> Optional[NonSpare_1207]:
        ...
    @overload
    def get_item(self, key : Literal["QI"]) -> Optional[NonSpare_1517]:
        ...
    @overload
    def get_item(self, key : Literal["TI1"]) -> Optional[NonSpare_1852]:
        ...
    @overload
    def get_item(self, key : Literal["MAM"]) -> Optional[NonSpare_1218]:
        ...
    @overload
    def get_item(self, key : Literal["GH"]) -> Optional[NonSpare_1026]:
        ...
    @overload
    def get_item(self, key : Literal["FL"]) -> Optional[NonSpare_967]:
        ...
    @overload
    def get_item(self, key : Literal["SAL"]) -> Optional[NonSpare_1649]:
        ...
    @overload
    def get_item(self, key : Literal["FSA"]) -> Optional[NonSpare_991]:
        ...
    @overload
    def get_item(self, key : Literal["AS"]) -> Optional[NonSpare_628]:
        ...
    @overload
    def get_item(self, key : Literal["TAS"]) -> Optional[NonSpare_1822]:
        ...
    @overload
    def get_item(self, key : Literal["MH"]) -> Optional[NonSpare_1268]:
        ...
    @overload
    def get_item(self, key : Literal["BVR"]) -> Optional[NonSpare_692]:
        ...
    @overload
    def get_item(self, key : Literal["GVR"]) -> Optional[NonSpare_1043]:
        ...
    @overload
    def get_item(self, key : Literal["GV"]) -> Optional[NonSpare_1039]:
        ...
    @overload
    def get_item(self, key : Literal["TAR"]) -> Optional[NonSpare_1819]:
        ...
    @overload
    def get_item(self, key : Literal["TI2"]) -> Optional[NonSpare_1853]:
        ...
    @overload
    def get_item(self, key : Literal["TS"]) -> Optional[NonSpare_1916]:
        ...
    @overload
    def get_item(self, key : Literal["MET"]) -> Optional[NonSpare_1261]:
        ...
    @overload
    def get_item(self, key : Literal["ROA"]) -> Optional[NonSpare_1590]:
        ...
    @overload
    def get_item(self, key : Literal["ARA"]) -> Optional[NonSpare_619]:
        ...
    @overload
    def get_item(self, key : Literal["SCC"]) -> Optional[NonSpare_1657]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["AOS"], val : NonSpare_608_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["TRD"], val : NonSpare_1904_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["M3A"], val : NonSpare_1207_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["QI"], val : NonSpare_1517_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["TI1"], val : NonSpare_1852_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["MAM"], val : NonSpare_1218_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["GH"], val : NonSpare_1026_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["FL"], val : NonSpare_967_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["SAL"], val : NonSpare_1649_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["FSA"], val : NonSpare_991_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["AS"], val : NonSpare_628_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["TAS"], val : NonSpare_1822_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["MH"], val : NonSpare_1268_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["BVR"], val : NonSpare_692_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["GVR"], val : NonSpare_1043_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["GV"], val : NonSpare_1039_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["TAR"], val : NonSpare_1819_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["TI2"], val : NonSpare_1853_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["TS"], val : NonSpare_1916_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["MET"], val : NonSpare_1261_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["ROA"], val : NonSpare_1590_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["ARA"], val : NonSpare_619_Arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["SCC"], val : NonSpare_1657_Arg) -> "Variation_1465":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["AOS"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["TRD"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["M3A"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["QI"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["TI1"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["MAM"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["GH"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["FL"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["SAL"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["FSA"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["AS"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["TAS"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["MH"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["BVR"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["GVR"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["GV"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["TAR"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["TI2"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["TS"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["MET"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["ROA"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["ARA"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["SCC"]) -> "Variation_1465":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1465_Arg) -> 'Variation_1465':
        return cls._create(arg) # type: ignore

RuleVariation_1388_Arg: TypeAlias = Variation_1465_Arg
class RuleVariation_1388(RuleVariationContextFree):
    cv_variation = Variation_1465

    @classmethod
    def create(cls, arg : RuleVariation_1388_Arg) -> "RuleVariation_1388":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1465:
        return self.arg # type: ignore

NonSpare_467_Arg: TypeAlias = RuleVariation_1388_Arg
class NonSpare_467(NonSpare):
    cv_name = "295"
    cv_title = "Data Ages"
    cv_rule = RuleVariation_1388

    @classmethod
    def create(cls, arg : NonSpare_467_Arg) -> "NonSpare_467":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1388:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1465:
        return self.rule.variation

class UapItem_467(UapItem):
    cv_non_spare = NonSpare_467

Record_6_Arg = TypedDict('Record_6_Arg', {
    "010": NonSpare_28_Arg,
    "040": NonSpare_145_Arg,
    "161": NonSpare_360_Arg,
    "015": NonSpare_63_Arg,
    "071": NonSpare_218_Arg,
    "130": NonSpare_305_Arg,
    "131": NonSpare_310_Arg,
    "072": NonSpare_219_Arg,
    "150": NonSpare_339_Arg,
    "151": NonSpare_345_Arg,
    "080": NonSpare_234_Arg,
    "073": NonSpare_220_Arg,
    "074": NonSpare_222_Arg,
    "075": NonSpare_223_Arg,
    "076": NonSpare_225_Arg,
    "140": NonSpare_319_Arg,
    "090": NonSpare_252_Arg,
    "210": NonSpare_408_Arg,
    "070": NonSpare_204_Arg,
    "230": NonSpare_428_Arg,
    "145": NonSpare_333_Arg,
    "152": NonSpare_347_Arg,
    "200": NonSpare_397_Arg,
    "155": NonSpare_349_Arg,
    "157": NonSpare_351_Arg,
    "160": NonSpare_352_Arg,
    "165": NonSpare_364_Arg,
    "077": NonSpare_227_Arg,
    "170": NonSpare_368_Arg,
    "020": NonSpare_78_Arg,
    "220": NonSpare_419_Arg,
    "146": NonSpare_336_Arg,
    "148": NonSpare_338_Arg,
    "110": NonSpare_289_Arg,
    "016": NonSpare_71_Arg,
    "008": NonSpare_26_Arg,
    "271": NonSpare_461_Arg,
    "132": NonSpare_313_Arg,
    "250": NonSpare_442_Arg,
    "260": NonSpare_453_Arg,
    "400": NonSpare_495_Arg,
    "295": NonSpare_467_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_6(Record):
    cv_fspec_max_bytes = 7
    cv_items_list = [UapItem_28, UapItem_145, UapItem_360, UapItem_63, UapItem_218, UapItem_305, UapItem_310, UapItem_219, UapItem_339, UapItem_345, UapItem_234, UapItem_220, UapItem_222, UapItem_223, UapItem_225, UapItem_319, UapItem_252, UapItem_408, UapItem_204, UapItem_428, UapItem_333, UapItem_347, UapItem_397, UapItem_349, UapItem_351, UapItem_352, UapItem_364, UapItem_227, UapItem_368, UapItem_78, UapItem_419, UapItem_336, UapItem_338, UapItem_289, UapItem_71, UapItem_26, UapItem_461, UapItem_313, UapItem_442, UapItem_453, UapItem_494, UapItem_467, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_28, "040": NonSpare_145, "161": NonSpare_360, "015": NonSpare_63, "071": NonSpare_218, "130": NonSpare_305, "131": NonSpare_310, "072": NonSpare_219, "150": NonSpare_339, "151": NonSpare_345, "080": NonSpare_234, "073": NonSpare_220, "074": NonSpare_222, "075": NonSpare_223, "076": NonSpare_225, "140": NonSpare_319, "090": NonSpare_252, "210": NonSpare_408, "070": NonSpare_204, "230": NonSpare_428, "145": NonSpare_333, "152": NonSpare_347, "200": NonSpare_397, "155": NonSpare_349, "157": NonSpare_351, "160": NonSpare_352, "165": NonSpare_364, "077": NonSpare_227, "170": NonSpare_368, "020": NonSpare_78, "220": NonSpare_419, "146": NonSpare_336, "148": NonSpare_338, "110": NonSpare_289, "016": NonSpare_71, "008": NonSpare_26, "271": NonSpare_461, "132": NonSpare_313, "250": NonSpare_442, "260": NonSpare_453, "400": NonSpare_495, "295": NonSpare_467, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_28:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_145:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_360:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_63:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["071"]) -> NonSpare_218:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_305:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_310:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["072"]) -> NonSpare_219:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_339:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_345:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_234:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["073"]) -> NonSpare_220:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["074"]) -> NonSpare_222:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["075"]) -> NonSpare_223:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["076"]) -> NonSpare_225:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_319:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_252:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_408:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_204:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_428:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_333:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_347:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_397:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_349:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_351:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_352:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_364:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["077"]) -> NonSpare_227:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_368:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_78:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_419:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_336:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_338:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_289:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["016"]) -> NonSpare_71:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["008"]) -> NonSpare_26:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["271"]) -> NonSpare_461:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["132"]) -> NonSpare_313:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_442:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_453:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_495:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_467:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["161"], Literal["015"], Literal["071"], Literal["130"], Literal["131"], Literal["072"], Literal["150"], Literal["151"], Literal["080"], Literal["073"], Literal["074"], Literal["075"], Literal["076"], Literal["140"], Literal["090"], Literal["210"], Literal["070"], Literal["230"], Literal["145"], Literal["152"], Literal["200"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["077"], Literal["170"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["016"], Literal["008"], Literal["271"], Literal["132"], Literal["250"], Literal["260"], Literal["400"], Literal["295"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_28]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_145]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_360]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_63]:
        ...
    @overload
    def get_item(self, key : Literal["071"]) -> Optional[NonSpare_218]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_305]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_310]:
        ...
    @overload
    def get_item(self, key : Literal["072"]) -> Optional[NonSpare_219]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_339]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_345]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_234]:
        ...
    @overload
    def get_item(self, key : Literal["073"]) -> Optional[NonSpare_220]:
        ...
    @overload
    def get_item(self, key : Literal["074"]) -> Optional[NonSpare_222]:
        ...
    @overload
    def get_item(self, key : Literal["075"]) -> Optional[NonSpare_223]:
        ...
    @overload
    def get_item(self, key : Literal["076"]) -> Optional[NonSpare_225]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_319]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_252]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_408]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_204]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_428]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_333]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_347]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_397]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_349]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_351]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_352]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_364]:
        ...
    @overload
    def get_item(self, key : Literal["077"]) -> Optional[NonSpare_227]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_368]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_78]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_419]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_336]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_338]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_289]:
        ...
    @overload
    def get_item(self, key : Literal["016"]) -> Optional[NonSpare_71]:
        ...
    @overload
    def get_item(self, key : Literal["008"]) -> Optional[NonSpare_26]:
        ...
    @overload
    def get_item(self, key : Literal["271"]) -> Optional[NonSpare_461]:
        ...
    @overload
    def get_item(self, key : Literal["132"]) -> Optional[NonSpare_313]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_442]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_453]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_495]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_467]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_28_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_145_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_360_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_63_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["071"], val : NonSpare_218_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_305_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_310_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["072"], val : NonSpare_219_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_339_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_345_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_234_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["073"], val : NonSpare_220_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["074"], val : NonSpare_222_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["075"], val : NonSpare_223_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["076"], val : NonSpare_225_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_319_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_252_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_408_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_204_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_428_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_333_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_347_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_397_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_349_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_351_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_352_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_364_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["077"], val : NonSpare_227_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_368_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_78_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_419_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_336_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_338_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_289_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["016"], val : NonSpare_71_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["008"], val : NonSpare_26_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["271"], val : NonSpare_461_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["132"], val : NonSpare_313_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_442_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_453_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_495_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_467_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_6':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["071"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["072"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["073"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["074"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["075"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["076"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["077"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["016"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["008"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["271"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["132"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_6':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_6_Arg) -> 'Record_6':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_6", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_6_Arg: TypeAlias = Record_6
class Uap_6(UapSingle):
    cv_record = Record_6

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_6]]:
        return cls._parse(bs)

class Asterix_33(AstCat):
    cv_category = 21
    cv_edition = (2, 6)
    cv_uap = Uap_6

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_6_Arg]) -> "Asterix_33":
        return cls._create(records) # type: ignore

NonSpare_29_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_29(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_29_Arg) -> "NonSpare_29":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_29(UapItem):
    cv_non_spare = NonSpare_29

Content_576_Arg: TypeAlias = int
class Content_576(ContentTable):
    cv_values = {1: "Ground station status report", 2: "Service status report", 3: "Service statistics report"}

RuleContent_576_Arg: TypeAlias = Content_576_Arg
class RuleContent_576(RuleContentContextFree):
    cv_content = Content_576

    @property
    def content(self) -> Content_576:
        return self._get_content() # type: ignore

Variation_180_Arg: TypeAlias = RuleContent_576_Arg
class Variation_180(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_576

    @classmethod
    def create(cls, arg : Variation_180_Arg) -> "Variation_180":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_576:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_576:
        return self.rule.content

RuleVariation_173_Arg: TypeAlias = Variation_180_Arg
class RuleVariation_173(RuleVariationContextFree):
    cv_variation = Variation_180

    @classmethod
    def create(cls, arg : RuleVariation_173_Arg) -> "RuleVariation_173":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_180:
        return self.arg # type: ignore

NonSpare_17_Arg: TypeAlias = RuleVariation_173_Arg
class NonSpare_17(NonSpare):
    cv_name = "000"
    cv_title = "Report Type"
    cv_rule = RuleVariation_173

    @classmethod
    def create(cls, arg : NonSpare_17_Arg) -> "NonSpare_17":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_173:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_180:
        return self.rule.variation

class UapItem_17(UapItem):
    cv_non_spare = NonSpare_17

NonSpare_1704_Arg: TypeAlias = RuleVariation_131_Arg
class NonSpare_1704(NonSpare):
    cv_name = "SID"
    cv_title = "Service Identification"
    cv_rule = RuleVariation_131

    @classmethod
    def create(cls, arg : NonSpare_1704_Arg) -> "NonSpare_1704":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_131:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_131:
        return self.rule.variation

Item_886_Arg: TypeAlias = NonSpare_1704_Arg
class Item_886(Item):
    cv_non_spare = NonSpare_1704

    @classmethod
    def create(cls, arg : Item_886_Arg) -> "Item_886":
        return cls._create(arg) # type: ignore

Content_572_Arg: TypeAlias = int
class Content_572(ContentTable):
    cv_values = {1: "ADS-B VDL4", 2: "ADS-B Ext Squitter", 3: "ADS-B UAT", 4: "TIS-B VDL4", 5: "TIS-B Ext Squitter", 6: "TIS-B UAT", 7: "FIS-B VDL4", 8: "GRAS VDL4", 9: "MLT"}

RuleContent_572_Arg: TypeAlias = Content_572_Arg
class RuleContent_572(RuleContentContextFree):
    cv_content = Content_572

    @property
    def content(self) -> Content_572:
        return self._get_content() # type: ignore

Variation_799_Arg: TypeAlias = RuleContent_572_Arg
class Variation_799(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 4
    cv_rule = RuleContent_572

    @classmethod
    def create(cls, arg : Variation_799_Arg) -> "Variation_799":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_572:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_572:
        return self.rule.content

RuleVariation_769_Arg: TypeAlias = Variation_799_Arg
class RuleVariation_769(RuleVariationContextFree):
    cv_variation = Variation_799

    @classmethod
    def create(cls, arg : RuleVariation_769_Arg) -> "RuleVariation_769":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_799:
        return self.arg # type: ignore

NonSpare_1796_Arg: TypeAlias = RuleVariation_769_Arg
class NonSpare_1796(NonSpare):
    cv_name = "STYP"
    cv_title = "Type of Service"
    cv_rule = RuleVariation_769

    @classmethod
    def create(cls, arg : NonSpare_1796_Arg) -> "NonSpare_1796":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_769:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_799:
        return self.rule.variation

Item_958_Arg: TypeAlias = NonSpare_1796_Arg
class Item_958(Item):
    cv_non_spare = NonSpare_1796

    @classmethod
    def create(cls, arg : Item_958_Arg) -> "Item_958":
        return cls._create(arg) # type: ignore

Variation_1204_Arg_Group = Tuple[Union[RuleVariation_131_Arg, Tuple[Literal["SID"], RuleVariation_131_Arg]], Union[RuleVariation_769_Arg, Tuple[Literal["STYP"], RuleVariation_769_Arg]]]
Variation_1204_Arg: TypeAlias = Union[int, Variation_1204_Arg_Group]
class Variation_1204(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_886, 4), (Item_958, 4)]
    cv_items_dict = {"SID": RuleVariation_131, "STYP": RuleVariation_769}

    @overload
    @classmethod
    def spec(cls, key : Literal["SID"]) -> RuleVariation_131:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STYP"]) -> RuleVariation_769:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SID"], Literal["STYP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SID"]) -> RuleVariation_131:
        ...
    @overload
    def get_item(self, key : Literal["STYP"]) -> RuleVariation_769:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1204_Arg) -> 'Variation_1204':
        return cls._create(arg) # type: ignore

RuleVariation_1149_Arg: TypeAlias = Variation_1204_Arg
class RuleVariation_1149(RuleVariationContextFree):
    cv_variation = Variation_1204

    @classmethod
    def create(cls, arg : RuleVariation_1149_Arg) -> "RuleVariation_1149":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1204:
        return self.arg # type: ignore

NonSpare_68_Arg: TypeAlias = RuleVariation_1149_Arg
class NonSpare_68(NonSpare):
    cv_name = "015"
    cv_title = "Service Type and Identification"
    cv_rule = RuleVariation_1149

    @classmethod
    def create(cls, arg : NonSpare_68_Arg) -> "NonSpare_68":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1149:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1204:
        return self.rule.variation

class UapItem_68(UapItem):
    cv_non_spare = NonSpare_68

NonSpare_216_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_216(NonSpare):
    cv_name = "070"
    cv_title = "Time of Day"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_216_Arg) -> "NonSpare_216":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_216(UapItem):
    cv_non_spare = NonSpare_216

Content_77_Arg: TypeAlias = int
class Content_77(ContentTable):
    cv_values = {0: "Data is released for operational use", 1: "Data must not be used operationally"}

RuleContent_77_Arg: TypeAlias = Content_77_Arg
class RuleContent_77(RuleContentContextFree):
    cv_content = Content_77

    @property
    def content(self) -> Content_77:
        return self._get_content() # type: ignore

Variation_22_Arg: TypeAlias = RuleContent_77_Arg
class Variation_22(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_77

    @classmethod
    def create(cls, arg : Variation_22_Arg) -> "Variation_22":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_77:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_77:
        return self.rule.content

RuleVariation_22_Arg: TypeAlias = Variation_22_Arg
class RuleVariation_22(RuleVariationContextFree):
    cv_variation = Variation_22

    @classmethod
    def create(cls, arg : RuleVariation_22_Arg) -> "RuleVariation_22":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_22:
        return self.arg # type: ignore

Content_196_Arg: TypeAlias = int
class Content_196(ContentTable):
    cv_values = {0: "Default, no overload", 1: "Overload in DP"}

RuleContent_196_Arg: TypeAlias = Content_196_Arg
class RuleContent_196(RuleContentContextFree):
    cv_content = Content_196

    @property
    def content(self) -> Content_196:
        return self._get_content() # type: ignore

Variation_423_Arg: TypeAlias = RuleContent_196_Arg
class Variation_423(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_196

    @classmethod
    def create(cls, arg : Variation_423_Arg) -> "Variation_423":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_196:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_196:
        return self.rule.content

RuleVariation_412_Arg: TypeAlias = Variation_423_Arg
class RuleVariation_412(RuleVariationContextFree):
    cv_variation = Variation_423

    @classmethod
    def create(cls, arg : RuleVariation_412_Arg) -> "RuleVariation_412":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_423:
        return self.arg # type: ignore

Content_198_Arg: TypeAlias = int
class Content_198(ContentTable):
    cv_values = {0: "Default, no overload", 1: "Overload in transmission subsystem"}

RuleContent_198_Arg: TypeAlias = Content_198_Arg
class RuleContent_198(RuleContentContextFree):
    cv_content = Content_198

    @property
    def content(self) -> Content_198:
        return self._get_content() # type: ignore

Variation_530_Arg: TypeAlias = RuleContent_198_Arg
class Variation_530(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_198

    @classmethod
    def create(cls, arg : Variation_530_Arg) -> "Variation_530":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_198:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_198:
        return self.rule.content

RuleVariation_519_Arg: TypeAlias = Variation_530_Arg
class RuleVariation_519(RuleVariationContextFree):
    cv_variation = Variation_530

    @classmethod
    def create(cls, arg : RuleVariation_519_Arg) -> "RuleVariation_519":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_530:
        return self.arg # type: ignore

Content_294_Arg: TypeAlias = int
class Content_294(ContentTable):
    cv_values = {0: "Monitoring system not connected or unknown", 1: "Monitoring system connected"}

RuleContent_294_Arg: TypeAlias = Content_294_Arg
class RuleContent_294(RuleContentContextFree):
    cv_content = Content_294

    @property
    def content(self) -> Content_294:
        return self._get_content() # type: ignore

Variation_646_Arg: TypeAlias = RuleContent_294_Arg
class Variation_646(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_294

    @classmethod
    def create(cls, arg : Variation_646_Arg) -> "Variation_646":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_294:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_294:
        return self.rule.content

RuleVariation_635_Arg: TypeAlias = Variation_646_Arg
class RuleVariation_635(RuleVariationContextFree):
    cv_variation = Variation_646

    @classmethod
    def create(cls, arg : RuleVariation_635_Arg) -> "RuleVariation_635":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_646:
        return self.arg # type: ignore

Variation_757_Arg: TypeAlias = RuleContent_557_Arg
class Variation_757(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_557

    @classmethod
    def create(cls, arg : Variation_757_Arg) -> "Variation_757":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_557:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_557:
        return self.rule.content

RuleVariation_746_Arg: TypeAlias = Variation_757_Arg
class RuleVariation_746(RuleVariationContextFree):
    cv_variation = Variation_757

    @classmethod
    def create(cls, arg : RuleVariation_746_Arg) -> "RuleVariation_746":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_757:
        return self.arg # type: ignore

Content_373_Arg: TypeAlias = int
class Content_373(ContentTable):
    cv_values = {0: "No spoofing detected", 1: "Potential spoofing attack"}

RuleContent_373_Arg: TypeAlias = Content_373_Arg
class RuleContent_373(RuleContentContextFree):
    cv_content = Content_373

    @property
    def content(self) -> Content_373:
        return self._get_content() # type: ignore

Variation_861_Arg: TypeAlias = RuleContent_373_Arg
class Variation_861(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_373

    @classmethod
    def create(cls, arg : Variation_861_Arg) -> "Variation_861":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_373:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_373:
        return self.rule.content

RuleVariation_831_Arg: TypeAlias = Variation_861_Arg
class RuleVariation_831(RuleVariationContextFree):
    cv_variation = Variation_861

    @classmethod
    def create(cls, arg : RuleVariation_831_Arg) -> "RuleVariation_831":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_861:
        return self.arg # type: ignore

Content_157_Arg: TypeAlias = int
class Content_157(ContentTable):
    cv_values = {0: "Default", 1: "Track numbering has restarted"}

RuleContent_157_Arg: TypeAlias = Content_157_Arg
class RuleContent_157(RuleContentContextFree):
    cv_content = Content_157

    @property
    def content(self) -> Content_157:
        return self._get_content() # type: ignore

Variation_918_Arg: TypeAlias = RuleContent_157_Arg
class Variation_918(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_157

    @classmethod
    def create(cls, arg : Variation_918_Arg) -> "Variation_918":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_157:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_157:
        return self.rule.content

RuleVariation_888_Arg: TypeAlias = Variation_918_Arg
class RuleVariation_888(RuleVariationContextFree):
    cv_variation = Variation_918

    @classmethod
    def create(cls, arg : RuleVariation_888_Arg) -> "RuleVariation_888":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_918:
        return self.arg # type: ignore

Content_723_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
class Content_723(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

RuleContent_723_Arg: TypeAlias = Content_723_Arg
class RuleContent_723(RuleContentContextFree):
    cv_content = Content_723

    @property
    def content(self) -> Content_723:
        return self._get_content() # type: ignore

Variation_161_Arg: TypeAlias = RuleContent_723_Arg
class Variation_161(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_723

    @classmethod
    def create(cls, arg : Variation_161_Arg) -> "Variation_161":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_723:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_723:
        return self.rule.content

RuleVariation_155_Arg: TypeAlias = Variation_161_Arg
class RuleVariation_155(RuleVariationContextFree):
    cv_variation = Variation_161

    @classmethod
    def create(cls, arg : RuleVariation_155_Arg) -> "RuleVariation_155":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_161:
        return self.arg # type: ignore

NonSpare_1358_Arg: TypeAlias = RuleVariation_22_Arg
class NonSpare_1358(NonSpare):
    cv_name = "NOGO"
    cv_title = "Operational Release Status of the Data"
    cv_rule = RuleVariation_22

    @classmethod
    def create(cls, arg : NonSpare_1358_Arg) -> "NonSpare_1358":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_22:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_22:
        return self.rule.variation

Item_624_Arg: TypeAlias = NonSpare_1358_Arg
class Item_624(Item):
    cv_non_spare = NonSpare_1358

    @classmethod
    def create(cls, arg : Item_624_Arg) -> "Item_624":
        return cls._create(arg) # type: ignore

NonSpare_1385_Arg: TypeAlias = RuleVariation_412_Arg
class NonSpare_1385(NonSpare):
    cv_name = "ODP"
    cv_title = "Data Processor Overload Indicator"
    cv_rule = RuleVariation_412

    @classmethod
    def create(cls, arg : NonSpare_1385_Arg) -> "NonSpare_1385":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_412:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_423:
        return self.rule.variation

Item_650_Arg: TypeAlias = NonSpare_1385_Arg
class Item_650(Item):
    cv_non_spare = NonSpare_1385

    @classmethod
    def create(cls, arg : Item_650_Arg) -> "Item_650":
        return cls._create(arg) # type: ignore

NonSpare_1406_Arg: TypeAlias = RuleVariation_519_Arg
class NonSpare_1406(NonSpare):
    cv_name = "OXT"
    cv_title = "Ground Interface Data Communications Overload"
    cv_rule = RuleVariation_519

    @classmethod
    def create(cls, arg : NonSpare_1406_Arg) -> "NonSpare_1406":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_519:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_530:
        return self.rule.variation

Item_670_Arg: TypeAlias = NonSpare_1406_Arg
class Item_670(Item):
    cv_non_spare = NonSpare_1406

    @classmethod
    def create(cls, arg : Item_670_Arg) -> "Item_670":
        return cls._create(arg) # type: ignore

NonSpare_1316_Arg: TypeAlias = RuleVariation_635_Arg
class NonSpare_1316(NonSpare):
    cv_name = "MSC"
    cv_title = "Monitoring System Connected Status"
    cv_rule = RuleVariation_635

    @classmethod
    def create(cls, arg : NonSpare_1316_Arg) -> "NonSpare_1316":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_635:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_646:
        return self.rule.variation

Item_586_Arg: TypeAlias = NonSpare_1316_Arg
class Item_586(Item):
    cv_non_spare = NonSpare_1316

    @classmethod
    def create(cls, arg : Item_586_Arg) -> "Item_586":
        return cls._create(arg) # type: ignore

NonSpare_1933_Arg: TypeAlias = RuleVariation_746_Arg
class NonSpare_1933(NonSpare):
    cv_name = "TSV"
    cv_title = "Time Source Validity"
    cv_rule = RuleVariation_746

    @classmethod
    def create(cls, arg : NonSpare_1933_Arg) -> "NonSpare_1933":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_746:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_757:
        return self.rule.variation

Item_1056_Arg: TypeAlias = NonSpare_1933_Arg
class Item_1056(Item):
    cv_non_spare = NonSpare_1933

    @classmethod
    def create(cls, arg : Item_1056_Arg) -> "Item_1056":
        return cls._create(arg) # type: ignore

NonSpare_1734_Arg: TypeAlias = RuleVariation_831_Arg
class NonSpare_1734(NonSpare):
    cv_name = "SPO"
    cv_title = "Indication of Spoofing Attack"
    cv_rule = RuleVariation_831

    @classmethod
    def create(cls, arg : NonSpare_1734_Arg) -> "NonSpare_1734":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_831:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_861:
        return self.rule.variation

Item_913_Arg: TypeAlias = NonSpare_1734_Arg
class Item_913(Item):
    cv_non_spare = NonSpare_1734

    @classmethod
    def create(cls, arg : Item_913_Arg) -> "Item_913":
        return cls._create(arg) # type: ignore

NonSpare_1588_Arg: TypeAlias = RuleVariation_888_Arg
class NonSpare_1588(NonSpare):
    cv_name = "RN"
    cv_title = "Renumbering Indication for Track ID"
    cv_rule = RuleVariation_888

    @classmethod
    def create(cls, arg : NonSpare_1588_Arg) -> "NonSpare_1588":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_888:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_918:
        return self.rule.variation

Item_819_Arg: TypeAlias = NonSpare_1588_Arg
class Item_819(Item):
    cv_non_spare = NonSpare_1588

    @classmethod
    def create(cls, arg : Item_819_Arg) -> "Item_819":
        return cls._create(arg) # type: ignore

NonSpare_1037_Arg: TypeAlias = RuleVariation_155_Arg
class NonSpare_1037(NonSpare):
    cv_name = "GSSP"
    cv_title = "Ground Station Status Reporting Period"
    cv_rule = RuleVariation_155

    @classmethod
    def create(cls, arg : NonSpare_1037_Arg) -> "NonSpare_1037":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_155:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_161:
        return self.rule.variation

Item_376_Arg: TypeAlias = NonSpare_1037_Arg
class Item_376(Item):
    cv_non_spare = NonSpare_1037

    @classmethod
    def create(cls, arg : Item_376_Arg) -> "Item_376":
        return cls._create(arg) # type: ignore

Variation_1368_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_22_Arg, Tuple[Literal["NOGO"], RuleVariation_22_Arg]], Union[RuleVariation_412_Arg, Tuple[Literal["ODP"], RuleVariation_412_Arg]], Union[RuleVariation_519_Arg, Tuple[Literal["OXT"], RuleVariation_519_Arg]], Union[RuleVariation_635_Arg, Tuple[Literal["MSC"], RuleVariation_635_Arg]], Union[RuleVariation_746_Arg, Tuple[Literal["TSV"], RuleVariation_746_Arg]], Union[RuleVariation_831_Arg, Tuple[Literal["SPO"], RuleVariation_831_Arg]], Union[RuleVariation_888_Arg, Tuple[Literal["RN"], RuleVariation_888_Arg]], None]]
Variation_1368_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_155_Arg, Tuple[Literal["GSSP"], RuleVariation_155_Arg]], None]]
Variation_1368_Arg: TypeAlias = Union[
    Tuple[Variation_1368_Arg_Group_1],
    Tuple[Variation_1368_Arg_Group_1, Variation_1368_Arg_Group_2],
]
class Variation_1368(Extended):
    cv_items_list = [[(Item_624, 1), (Item_650, 1), (Item_670, 1), (Item_586, 1), (Item_1056, 1), (Item_913, 1), (Item_819, 1), None], [(Item_376, 7), None]]

    @classmethod
    def create(cls, arg : Variation_1368_Arg) -> 'Variation_1368':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["NOGO"]) -> RuleVariation_22:
        ...
    @overload
    def get_item(self, key : Literal["ODP"]) -> RuleVariation_412:
        ...
    @overload
    def get_item(self, key : Literal["OXT"]) -> RuleVariation_519:
        ...
    @overload
    def get_item(self, key : Literal["MSC"]) -> RuleVariation_635:
        ...
    @overload
    def get_item(self, key : Literal["TSV"]) -> RuleVariation_746:
        ...
    @overload
    def get_item(self, key : Literal["SPO"]) -> RuleVariation_831:
        ...
    @overload
    def get_item(self, key : Literal["RN"]) -> RuleVariation_888:
        ...
    @overload
    def get_item(self, key : Literal["GSSP"]) -> Optional[RuleVariation_155]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1291_Arg: TypeAlias = Variation_1368_Arg
class RuleVariation_1291(RuleVariationContextFree):
    cv_variation = Variation_1368

    @classmethod
    def create(cls, arg : RuleVariation_1291_Arg) -> "RuleVariation_1291":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1368:
        return self.arg # type: ignore

NonSpare_267_Arg: TypeAlias = RuleVariation_1291_Arg
class NonSpare_267(NonSpare):
    cv_name = "100"
    cv_title = "Ground Station Status"
    cv_rule = RuleVariation_1291

    @classmethod
    def create(cls, arg : NonSpare_267_Arg) -> "NonSpare_267":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1291:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1368:
        return self.rule.variation

class UapItem_267(UapItem):
    cv_non_spare = NonSpare_267

Content_363_Arg: TypeAlias = int
class Content_363(ContentTable):
    cv_values = {0: "No information", 1: "NRA class", 2: "Reserved for future use", 3: "Reserved for future use", 4: "Reserved for future use", 5: "Reserved for future use", 6: "Reserved for future use", 7: "Reserved for future use"}

RuleContent_363_Arg: TypeAlias = Content_363_Arg
class RuleContent_363(RuleContentContextFree):
    cv_content = Content_363

    @property
    def content(self) -> Content_363:
        return self._get_content() # type: ignore

Variation_127_Arg: TypeAlias = RuleContent_363_Arg
class Variation_127(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_363

    @classmethod
    def create(cls, arg : Variation_127_Arg) -> "Variation_127":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_363:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_363:
        return self.rule.content

RuleVariation_127_Arg: TypeAlias = Variation_127_Arg
class RuleVariation_127(RuleVariationContextFree):
    cv_variation = Variation_127

    @classmethod
    def create(cls, arg : RuleVariation_127_Arg) -> "RuleVariation_127":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_127:
        return self.arg # type: ignore

NonSpare_1593_Arg: TypeAlias = RuleVariation_218_Arg
class NonSpare_1593(NonSpare):
    cv_name = "RP"
    cv_title = "Report Period for Category 021 Reports"
    cv_rule = RuleVariation_218

    @classmethod
    def create(cls, arg : NonSpare_1593_Arg) -> "NonSpare_1593":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_218:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_225:
        return self.rule.variation

Item_823_Arg: TypeAlias = NonSpare_1593_Arg
class Item_823(Item):
    cv_non_spare = NonSpare_1593

    @classmethod
    def create(cls, arg : Item_823_Arg) -> "Item_823":
        return cls._create(arg) # type: ignore

NonSpare_1656_Arg: TypeAlias = RuleVariation_127_Arg
class NonSpare_1656(NonSpare):
    cv_name = "SC"
    cv_title = "Service Class"
    cv_rule = RuleVariation_127

    @classmethod
    def create(cls, arg : NonSpare_1656_Arg) -> "NonSpare_1656":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_127:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_127:
        return self.rule.variation

Item_858_Arg: TypeAlias = NonSpare_1656_Arg
class Item_858(Item):
    cv_non_spare = NonSpare_1656

    @classmethod
    def create(cls, arg : Item_858_Arg) -> "Item_858":
        return cls._create(arg) # type: ignore

Item_18_Arg: TypeAlias = int
class Item_18(Spare):
    cv_bit_offset8 = 3
    cv_bit_size = 4

NonSpare_1757_Arg: TypeAlias = RuleVariation_155_Arg
class NonSpare_1757(NonSpare):
    cv_name = "SSRP"
    cv_title = "Service Status Reporting Period"
    cv_rule = RuleVariation_155

    @classmethod
    def create(cls, arg : NonSpare_1757_Arg) -> "NonSpare_1757":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_155:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_161:
        return self.rule.variation

Item_928_Arg: TypeAlias = NonSpare_1757_Arg
class Item_928(Item):
    cv_non_spare = NonSpare_1757

    @classmethod
    def create(cls, arg : Item_928_Arg) -> "Item_928":
        return cls._create(arg) # type: ignore

Variation_1373_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_218_Arg, Tuple[Literal["RP"], RuleVariation_218_Arg]], Union[RuleVariation_127_Arg, Tuple[Literal["SC"], RuleVariation_127_Arg]], int, None]]
Variation_1373_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_155_Arg, Tuple[Literal["SSRP"], RuleVariation_155_Arg]], None]]
Variation_1373_Arg: TypeAlias = Union[
    Tuple[Variation_1373_Arg_Group_1],
    Tuple[Variation_1373_Arg_Group_1, Variation_1373_Arg_Group_2],
]
class Variation_1373(Extended):
    cv_items_list = [[(Item_823, 8), (Item_858, 3), (Item_18, 4), None], [(Item_928, 7), None]]

    @classmethod
    def create(cls, arg : Variation_1373_Arg) -> 'Variation_1373':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["RP"]) -> RuleVariation_218:
        ...
    @overload
    def get_item(self, key : Literal["SC"]) -> RuleVariation_127:
        ...
    @overload
    def get_item(self, key : Literal["SSRP"]) -> Optional[RuleVariation_155]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1296_Arg: TypeAlias = Variation_1373_Arg
class RuleVariation_1296(RuleVariationContextFree):
    cv_variation = Variation_1373

    @classmethod
    def create(cls, arg : RuleVariation_1296_Arg) -> "RuleVariation_1296":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1373:
        return self.arg # type: ignore

NonSpare_276_Arg: TypeAlias = RuleVariation_1296_Arg
class NonSpare_276(NonSpare):
    cv_name = "101"
    cv_title = "Service Configuration"
    cv_rule = RuleVariation_1296

    @classmethod
    def create(cls, arg : NonSpare_276_Arg) -> "NonSpare_276":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1296:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1373:
        return self.rule.variation

class UapItem_276(UapItem):
    cv_non_spare = NonSpare_276

Content_710_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
class Content_710(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

RuleContent_710_Arg: TypeAlias = Content_710_Arg
class RuleContent_710(RuleContentContextFree):
    cv_content = Content_710

    @property
    def content(self) -> Content_710:
        return self._get_content() # type: ignore

Variation_220_Arg: TypeAlias = RuleContent_710_Arg
class Variation_220(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_710

    @classmethod
    def create(cls, arg : Variation_220_Arg) -> "Variation_220":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_710:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_710:
        return self.rule.content

RuleVariation_213_Arg: TypeAlias = Variation_220_Arg
class RuleVariation_213(RuleVariationContextFree):
    cv_variation = Variation_220

    @classmethod
    def create(cls, arg : RuleVariation_213_Arg) -> "RuleVariation_213":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_220:
        return self.arg # type: ignore

NonSpare_390_Arg: TypeAlias = RuleVariation_213_Arg
class NonSpare_390(NonSpare):
    cv_name = "200"
    cv_title = "Operational Range"
    cv_rule = RuleVariation_213

    @classmethod
    def create(cls, arg : NonSpare_390_Arg) -> "NonSpare_390":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_213:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_220:
        return self.rule.variation

class UapItem_390(UapItem):
    cv_non_spare = NonSpare_390

Content_543_Arg: TypeAlias = int
class Content_543(ContentTable):
    cv_values = {0: "Unknown", 1: "Failed", 2: "Disabled", 3: "Degraded", 4: "Normal", 5: "Initialisation"}

RuleContent_543_Arg: TypeAlias = Content_543_Arg
class RuleContent_543(RuleContentContextFree):
    cv_content = Content_543

    @property
    def content(self) -> Content_543:
        return self._get_content() # type: ignore

Variation_791_Arg: TypeAlias = RuleContent_543_Arg
class Variation_791(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_543

    @classmethod
    def create(cls, arg : Variation_791_Arg) -> "Variation_791":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_543:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_543:
        return self.rule.content

RuleVariation_765_Arg: TypeAlias = Variation_791_Arg
class RuleVariation_765(RuleVariationContextFree):
    cv_variation = Variation_791

    @classmethod
    def create(cls, arg : RuleVariation_765_Arg) -> "RuleVariation_765":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_791:
        return self.arg # type: ignore

NonSpare_1775_Arg: TypeAlias = RuleVariation_765_Arg
class NonSpare_1775(NonSpare):
    cv_name = "STAT"
    cv_title = "Status of the Service"
    cv_rule = RuleVariation_765

    @classmethod
    def create(cls, arg : NonSpare_1775_Arg) -> "NonSpare_1775":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_765:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_791:
        return self.rule.variation

Item_942_Arg: TypeAlias = NonSpare_1775_Arg
class Item_942(Item):
    cv_non_spare = NonSpare_1775

    @classmethod
    def create(cls, arg : Item_942_Arg) -> "Item_942":
        return cls._create(arg) # type: ignore

Variation_1337_Arg_Group_1: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_765_Arg, Tuple[Literal["STAT"], RuleVariation_765_Arg]], None]]
Variation_1337_Arg: TypeAlias = Union[
    Tuple[Variation_1337_Arg_Group_1],
]
class Variation_1337(Extended):
    cv_items_list = [[(Item_3, 4), (Item_942, 3), None]]

    @classmethod
    def create(cls, arg : Variation_1337_Arg) -> 'Variation_1337':
        return cls._create(arg) # type: ignore

    @overload # type: ignore
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_765:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1260_Arg: TypeAlias = Variation_1337_Arg
class RuleVariation_1260(RuleVariationContextFree):
    cv_variation = Variation_1337

    @classmethod
    def create(cls, arg : RuleVariation_1260_Arg) -> "RuleVariation_1260":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1337:
        return self.arg # type: ignore

NonSpare_286_Arg: TypeAlias = RuleVariation_1260_Arg
class NonSpare_286(NonSpare):
    cv_name = "110"
    cv_title = "Service Status"
    cv_rule = RuleVariation_1260

    @classmethod
    def create(cls, arg : NonSpare_286_Arg) -> "NonSpare_286":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1260:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1337:
        return self.rule.variation

class UapItem_286(UapItem):
    cv_non_spare = NonSpare_286

Content_404_Arg: TypeAlias = int
class Content_404(ContentTable):
    cv_values = {0: "Number of unknown messages received", 1: "Number of too old messages received", 2: "Number of failed message conversions", 3: "Total Number of messages received", 4: "Total Number of messages transmitted", 20: "Number of TIS-B management messages received", 21: "Number of Basic messages received", 22: "Number of High Dynamic messages received", 23: "Number of Full Position messages received", 24: "Number of Basic Ground  messages received", 25: "Number of TCP messages received", 26: "Number of UTC time  messages received", 27: "Number of Data messages received", 28: "Number of High Resolution messages received", 29: "Number of Aircraft Target Airborne messages received", 30: "Number of Aircraft Target Ground messages received", 31: "Number of Ground Vehicle Target messages received", 32: "Number of 2 slots TCP messages received"}

RuleContent_404_Arg: TypeAlias = Content_404_Arg
class RuleContent_404(RuleContentContextFree):
    cv_content = Content_404

    @property
    def content(self) -> Content_404:
        return self._get_content() # type: ignore

Variation_172_Arg: TypeAlias = RuleContent_404_Arg
class Variation_172(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_404

    @classmethod
    def create(cls, arg : Variation_172_Arg) -> "Variation_172":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_404:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_404:
        return self.rule.content

RuleVariation_165_Arg: TypeAlias = Variation_172_Arg
class RuleVariation_165(RuleVariationContextFree):
    cv_variation = Variation_172

    @classmethod
    def create(cls, arg : RuleVariation_165_Arg) -> "RuleVariation_165":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_172:
        return self.arg # type: ignore

NonSpare_1964_Arg: TypeAlias = RuleVariation_165_Arg
class NonSpare_1964(NonSpare):
    cv_name = "TYPE"
    cv_title = "Type of Report Counter"
    cv_rule = RuleVariation_165

    @classmethod
    def create(cls, arg : NonSpare_1964_Arg) -> "NonSpare_1964":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_165:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_172:
        return self.rule.variation

Item_1083_Arg: TypeAlias = NonSpare_1964_Arg
class Item_1083(Item):
    cv_non_spare = NonSpare_1964

    @classmethod
    def create(cls, arg : Item_1083_Arg) -> "Item_1083":
        return cls._create(arg) # type: ignore

Content_216_Arg: TypeAlias = int
class Content_216(ContentTable):
    cv_values = {0: "From midnight", 1: "From the last report"}

RuleContent_216_Arg: TypeAlias = Content_216_Arg
class RuleContent_216(RuleContentContextFree):
    cv_content = Content_216

    @property
    def content(self) -> Content_216:
        return self._get_content() # type: ignore

Variation_44_Arg: TypeAlias = RuleContent_216_Arg
class Variation_44(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_216

    @classmethod
    def create(cls, arg : Variation_44_Arg) -> "Variation_44":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_216:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_216:
        return self.rule.content

RuleVariation_44_Arg: TypeAlias = Variation_44_Arg
class RuleVariation_44(RuleVariationContextFree):
    cv_variation = Variation_44

    @classmethod
    def create(cls, arg : RuleVariation_44_Arg) -> "RuleVariation_44":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_44:
        return self.arg # type: ignore

NonSpare_1566_Arg: TypeAlias = RuleVariation_44_Arg
class NonSpare_1566(NonSpare):
    cv_name = "REF"
    cv_title = "Reference from which the Messages Are Countered"
    cv_rule = RuleVariation_44

    @classmethod
    def create(cls, arg : NonSpare_1566_Arg) -> "NonSpare_1566":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_44:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_44:
        return self.rule.variation

Item_797_Arg: TypeAlias = NonSpare_1566_Arg
class Item_797(Item):
    cv_non_spare = NonSpare_1566

    @classmethod
    def create(cls, arg : Item_797_Arg) -> "Item_797":
        return cls._create(arg) # type: ignore

Item_10_Arg: TypeAlias = int
class Item_10(Spare):
    cv_bit_offset8 = 1
    cv_bit_size = 7

NonSpare_844_Arg: TypeAlias = RuleVariation_364_Arg
class NonSpare_844(NonSpare):
    cv_name = "CV"
    cv_title = "32-bit Counter Value"
    cv_rule = RuleVariation_364

    @classmethod
    def create(cls, arg : NonSpare_844_Arg) -> "NonSpare_844":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_364:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_371:
        return self.rule.variation

Item_231_Arg: TypeAlias = NonSpare_844_Arg
class Item_231(Item):
    cv_non_spare = NonSpare_844

    @classmethod
    def create(cls, arg : Item_231_Arg) -> "Item_231":
        return cls._create(arg) # type: ignore

Variation_1238_Arg_Group = Tuple[Union[RuleVariation_165_Arg, Tuple[Literal["TYPE"], RuleVariation_165_Arg]], Union[RuleVariation_44_Arg, Tuple[Literal["REF"], RuleVariation_44_Arg]], int, Union[RuleVariation_364_Arg, Tuple[Literal["CV"], RuleVariation_364_Arg]]]
Variation_1238_Arg: TypeAlias = Union[int, Variation_1238_Arg_Group]
class Variation_1238(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_1083, 8), (Item_797, 1), (Item_10, 7), (Item_231, 32)]
    cv_items_dict = {"TYPE": RuleVariation_165, "REF": RuleVariation_44, "CV": RuleVariation_364}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYPE"]) -> RuleVariation_165:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["REF"]) -> RuleVariation_44:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CV"]) -> RuleVariation_364:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYPE"], Literal["REF"], Literal["CV"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYPE"]) -> RuleVariation_165:
        ...
    @overload
    def get_item(self, key : Literal["REF"]) -> RuleVariation_44:
        ...
    @overload
    def get_item(self, key : Literal["CV"]) -> RuleVariation_364:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1238_Arg) -> 'Variation_1238':
        return cls._create(arg) # type: ignore

Variation_1439_Arg: TypeAlias = List[Variation_1238_Arg]
class Variation_1439(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1238

    @classmethod
    def create(cls, arg : Variation_1439_Arg) -> 'Variation_1439':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1238]:
        return self._get_list() # type: ignore

RuleVariation_1362_Arg: TypeAlias = Variation_1439_Arg
class RuleVariation_1362(RuleVariationContextFree):
    cv_variation = Variation_1439

    @classmethod
    def create(cls, arg : RuleVariation_1362_Arg) -> "RuleVariation_1362":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1439:
        return self.arg # type: ignore

NonSpare_298_Arg: TypeAlias = RuleVariation_1362_Arg
class NonSpare_298(NonSpare):
    cv_name = "120"
    cv_title = "Service Statistics"
    cv_rule = RuleVariation_1362

    @classmethod
    def create(cls, arg : NonSpare_298_Arg) -> "NonSpare_298":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1362:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1439:
        return self.rule.variation

class UapItem_298(UapItem):
    cv_non_spare = NonSpare_298

Record_9_Arg = TypedDict('Record_9_Arg', {
    "010": NonSpare_29_Arg,
    "000": NonSpare_17_Arg,
    "015": NonSpare_68_Arg,
    "070": NonSpare_216_Arg,
    "100": NonSpare_267_Arg,
    "101": NonSpare_276_Arg,
    "200": NonSpare_390_Arg,
    "110": NonSpare_286_Arg,
    "120": NonSpare_298_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_9(Record):
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_29, UapItem_17, UapItem_68, UapItem_216, UapItem_267, UapItem_276, UapItem_390, UapItem_286, UapItem_298, UapItem_544, UapItem_544, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_29, "000": NonSpare_17, "015": NonSpare_68, "070": NonSpare_216, "100": NonSpare_267, "101": NonSpare_276, "200": NonSpare_390, "110": NonSpare_286, "120": NonSpare_298, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_29:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_17:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_68:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_216:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_267:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["101"]) -> NonSpare_276:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_390:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_286:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_298:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["015"], Literal["070"], Literal["100"], Literal["101"], Literal["200"], Literal["110"], Literal["120"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_29]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_17]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_68]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_216]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_267]:
        ...
    @overload
    def get_item(self, key : Literal["101"]) -> Optional[NonSpare_276]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_390]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_286]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_298]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_29_Arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_17_Arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_68_Arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_216_Arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_267_Arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["101"], val : NonSpare_276_Arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_390_Arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_286_Arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_298_Arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_9':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["101"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_9':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_9_Arg) -> 'Record_9':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_9", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_9_Arg: TypeAlias = Record_9
class Uap_9(UapSingle):
    cv_record = Record_9

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_9]]:
        return cls._parse(bs)

class Asterix_34(AstCat):
    cv_category = 23
    cv_edition = (1, 2)
    cv_uap = Uap_9

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_9_Arg]) -> "Asterix_34":
        return cls._create(records) # type: ignore

class Asterix_35(AstCat):
    cv_category = 23
    cv_edition = (1, 3)
    cv_uap = Uap_9

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_9_Arg]) -> "Asterix_35":
        return cls._create(records) # type: ignore

NonSpare_31_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_31(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_31_Arg) -> "NonSpare_31":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_31(UapItem):
    cv_non_spare = NonSpare_31

RuleVariation_149_Arg: TypeAlias = Variation_149_Arg
class RuleVariation_149(RuleVariationContextFree):
    cv_variation = Variation_149

    @classmethod
    def create(cls, arg : RuleVariation_149_Arg) -> "RuleVariation_149":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_149:
        return self.arg # type: ignore

NonSpare_1624_Arg: TypeAlias = RuleVariation_149_Arg
class NonSpare_1624(NonSpare):
    cv_name = "RTYP"
    cv_title = "Report Type"
    cv_rule = RuleVariation_149

    @classmethod
    def create(cls, arg : NonSpare_1624_Arg) -> "NonSpare_1624":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_149:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_149:
        return self.rule.variation

Item_836_Arg: TypeAlias = NonSpare_1624_Arg
class Item_836(Item):
    cv_non_spare = NonSpare_1624

    @classmethod
    def create(cls, arg : Item_836_Arg) -> "Item_836":
        return cls._create(arg) # type: ignore

Variation_1182_Arg_Group = Tuple[Union[RuleVariation_149_Arg, Tuple[Literal["RTYP"], RuleVariation_149_Arg]], Union[RuleVariation_953_Arg, Tuple[Literal["RG"], RuleVariation_953_Arg]]]
Variation_1182_Arg: TypeAlias = Union[int, Variation_1182_Arg_Group]
class Variation_1182(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_836, 7), (Item_807, 1)]
    cv_items_dict = {"RTYP": RuleVariation_149, "RG": RuleVariation_953}

    @overload
    @classmethod
    def spec(cls, key : Literal["RTYP"]) -> RuleVariation_149:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RG"]) -> RuleVariation_953:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RTYP"], Literal["RG"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RTYP"]) -> RuleVariation_149:
        ...
    @overload
    def get_item(self, key : Literal["RG"]) -> RuleVariation_953:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1182_Arg) -> 'Variation_1182':
        return cls._create(arg) # type: ignore

RuleVariation_1132_Arg: TypeAlias = Variation_1182_Arg
class RuleVariation_1132(RuleVariationContextFree):
    cv_variation = Variation_1182

    @classmethod
    def create(cls, arg : RuleVariation_1132_Arg) -> "RuleVariation_1132":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1182:
        return self.arg # type: ignore

NonSpare_18_Arg: TypeAlias = RuleVariation_1132_Arg
class NonSpare_18(NonSpare):
    cv_name = "000"
    cv_title = "Report Type"
    cv_rule = RuleVariation_1132

    @classmethod
    def create(cls, arg : NonSpare_18_Arg) -> "NonSpare_18":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1132:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1182:
        return self.rule.variation

class UapItem_18(UapItem):
    cv_non_spare = NonSpare_18

NonSpare_388_Arg: TypeAlias = RuleVariation_342_Arg
class NonSpare_388(NonSpare):
    cv_name = "200"
    cv_title = "Message Identification"
    cv_rule = RuleVariation_342

    @classmethod
    def create(cls, arg : NonSpare_388_Arg) -> "NonSpare_388":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_342:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_349:
        return self.rule.variation

class UapItem_388(UapItem):
    cv_non_spare = NonSpare_388

NonSpare_67_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_67(NonSpare):
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_67_Arg) -> "NonSpare_67":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_67(UapItem):
    cv_non_spare = NonSpare_67

NonSpare_82_Arg: TypeAlias = RuleVariation_381_Arg
class NonSpare_82(NonSpare):
    cv_name = "020"
    cv_title = "Service Designator"
    cv_rule = RuleVariation_381

    @classmethod
    def create(cls, arg : NonSpare_82_Arg) -> "NonSpare_82":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_381:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_389:
        return self.rule.variation

class UapItem_82(UapItem):
    cv_non_spare = NonSpare_82

NonSpare_215_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_215(NonSpare):
    cv_name = "070"
    cv_title = "Time of Day"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_215_Arg) -> "NonSpare_215":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_215(UapItem):
    cv_non_spare = NonSpare_215

Content_412_Arg: TypeAlias = int
class Content_412(ContentTable):
    cv_values = {0: "Operational", 1: "Operational but in Standby", 2: "Maintenance", 3: "Reserved for future use"}

RuleContent_412_Arg: TypeAlias = Content_412_Arg
class RuleContent_412(RuleContentContextFree):
    cv_content = Content_412

    @property
    def content(self) -> Content_412:
        return self._get_content() # type: ignore

Variation_474_Arg: TypeAlias = RuleContent_412_Arg
class Variation_474(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_412

    @classmethod
    def create(cls, arg : Variation_474_Arg) -> "Variation_474":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_412:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_412:
        return self.rule.content

RuleVariation_463_Arg: TypeAlias = Variation_474_Arg
class RuleVariation_463(RuleVariationContextFree):
    cv_variation = Variation_474

    @classmethod
    def create(cls, arg : RuleVariation_463_Arg) -> "RuleVariation_463":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_474:
        return self.arg # type: ignore

Content_443_Arg: TypeAlias = int
class Content_443(ContentTable):
    cv_values = {0: "Running", 1: "Failed", 2: "Degraded", 3: "Undefined", 4: "Reserved for future use", 5: "Reserved for future use", 6: "Reserved for future use", 7: "Reserved for future use", 8: "Reserved for future use", 9: "Reserved for future use", 10: "Reserved for future use", 11: "Reserved for future use", 12: "Reserved for future use", 13: "Reserved for future use", 14: "Reserved for future use", 15: "Reserved for future use"}

RuleContent_443_Arg: TypeAlias = Content_443_Arg
class RuleContent_443(RuleContentContextFree):
    cv_content = Content_443

    @property
    def content(self) -> Content_443:
        return self._get_content() # type: ignore

Variation_691_Arg: TypeAlias = RuleContent_443_Arg
class Variation_691(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 4
    cv_rule = RuleContent_443

    @classmethod
    def create(cls, arg : Variation_691_Arg) -> "Variation_691":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_443:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_443:
        return self.rule.content

RuleVariation_680_Arg: TypeAlias = Variation_691_Arg
class RuleVariation_680(RuleVariationContextFree):
    cv_variation = Variation_691

    @classmethod
    def create(cls, arg : RuleVariation_680_Arg) -> "RuleVariation_680":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_691:
        return self.arg # type: ignore

Content_445_Arg: TypeAlias = int
class Content_445(ContentTable):
    cv_values = {0: "Running / OK", 1: "Failed", 2: "Degraded", 3: "Undefined", 4: "Reserved for future use", 5: "Reserved for future use", 6: "Reserved for future use", 7: "Reserved for future use"}

RuleContent_445_Arg: TypeAlias = Content_445_Arg
class RuleContent_445(RuleContentContextFree):
    cv_content = Content_445

    @property
    def content(self) -> Content_445:
        return self._get_content() # type: ignore

Variation_484_Arg: TypeAlias = RuleContent_445_Arg
class Variation_484(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 3
    cv_rule = RuleContent_445

    @classmethod
    def create(cls, arg : Variation_484_Arg) -> "Variation_484":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_445:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_445:
        return self.rule.content

RuleVariation_473_Arg: TypeAlias = Variation_484_Arg
class RuleVariation_473(RuleVariationContextFree):
    cv_variation = Variation_484

    @classmethod
    def create(cls, arg : RuleVariation_473_Arg) -> "RuleVariation_473":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_484:
        return self.arg # type: ignore

Content_406_Arg: TypeAlias = int
class Content_406(ContentTable):
    cv_values = {0: "OK", 1: "Failed", 2: "Degraded", 3: "Undefined", 4: "Reserved for future use", 5: "Reserved for future use", 6: "Reserved for future use", 7: "Reserved for future use"}

RuleContent_406_Arg: TypeAlias = Content_406_Arg
class RuleContent_406(RuleContentContextFree):
    cv_content = Content_406

    @property
    def content(self) -> Content_406:
        return self._get_content() # type: ignore

Variation_785_Arg: TypeAlias = RuleContent_406_Arg
class Variation_785(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_406

    @classmethod
    def create(cls, arg : Variation_785_Arg) -> "Variation_785":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_406:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_406:
        return self.rule.content

RuleVariation_764_Arg: TypeAlias = Variation_785_Arg
class RuleVariation_764(RuleVariationContextFree):
    cv_variation = Variation_785

    @classmethod
    def create(cls, arg : RuleVariation_764_Arg) -> "RuleVariation_764":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_785:
        return self.arg # type: ignore

NonSpare_1355_Arg: TypeAlias = RuleVariation_22_Arg
class NonSpare_1355(NonSpare):
    cv_name = "NOGO"
    cv_title = ""
    cv_rule = RuleVariation_22

    @classmethod
    def create(cls, arg : NonSpare_1355_Arg) -> "NonSpare_1355":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_22:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_22:
        return self.rule.variation

Item_621_Arg: TypeAlias = NonSpare_1355_Arg
class Item_621(Item):
    cv_non_spare = NonSpare_1355

    @classmethod
    def create(cls, arg : Item_621_Arg) -> "Item_621":
        return cls._create(arg) # type: ignore

NonSpare_1390_Arg: TypeAlias = RuleVariation_463_Arg
class NonSpare_1390(NonSpare):
    cv_name = "OPS"
    cv_title = ""
    cv_rule = RuleVariation_463

    @classmethod
    def create(cls, arg : NonSpare_1390_Arg) -> "NonSpare_1390":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_463:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_474:
        return self.rule.variation

Item_655_Arg: TypeAlias = NonSpare_1390_Arg
class Item_655(Item):
    cv_non_spare = NonSpare_1390

    @classmethod
    def create(cls, arg : Item_655_Arg) -> "Item_655":
        return cls._create(arg) # type: ignore

NonSpare_1759_Arg: TypeAlias = RuleVariation_680_Arg
class NonSpare_1759(NonSpare):
    cv_name = "SSTAT"
    cv_title = ""
    cv_rule = RuleVariation_680

    @classmethod
    def create(cls, arg : NonSpare_1759_Arg) -> "NonSpare_1759":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_680:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_691:
        return self.rule.variation

Item_930_Arg: TypeAlias = NonSpare_1759_Arg
class Item_930(Item):
    cv_non_spare = NonSpare_1759

    @classmethod
    def create(cls, arg : Item_930_Arg) -> "Item_930":
        return cls._create(arg) # type: ignore

NonSpare_1807_Arg: TypeAlias = RuleVariation_473_Arg
class NonSpare_1807(NonSpare):
    cv_name = "SYSTAT"
    cv_title = ""
    cv_rule = RuleVariation_473

    @classmethod
    def create(cls, arg : NonSpare_1807_Arg) -> "NonSpare_1807":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_473:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_484:
        return self.rule.variation

Item_965_Arg: TypeAlias = NonSpare_1807_Arg
class Item_965(Item):
    cv_non_spare = NonSpare_1807

    @classmethod
    def create(cls, arg : Item_965_Arg) -> "Item_965":
        return cls._create(arg) # type: ignore

NonSpare_1692_Arg: TypeAlias = RuleVariation_764_Arg
class NonSpare_1692(NonSpare):
    cv_name = "SESTAT"
    cv_title = ""
    cv_rule = RuleVariation_764

    @classmethod
    def create(cls, arg : NonSpare_1692_Arg) -> "NonSpare_1692":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_764:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_785:
        return self.rule.variation

Item_877_Arg: TypeAlias = NonSpare_1692_Arg
class Item_877(Item):
    cv_non_spare = NonSpare_1692

    @classmethod
    def create(cls, arg : Item_877_Arg) -> "Item_877":
        return cls._create(arg) # type: ignore

Variation_1367_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_22_Arg, Tuple[Literal["NOGO"], RuleVariation_22_Arg]], Union[RuleVariation_463_Arg, Tuple[Literal["OPS"], RuleVariation_463_Arg]], Union[RuleVariation_680_Arg, Tuple[Literal["SSTAT"], RuleVariation_680_Arg]], None]]
Variation_1367_Arg_Group_2: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_473_Arg, Tuple[Literal["SYSTAT"], RuleVariation_473_Arg]], Union[RuleVariation_764_Arg, Tuple[Literal["SESTAT"], RuleVariation_764_Arg]], None]]
Variation_1367_Arg: TypeAlias = Union[
    Tuple[Variation_1367_Arg_Group_1],
    Tuple[Variation_1367_Arg_Group_1, Variation_1367_Arg_Group_2],
]
class Variation_1367(Extended):
    cv_items_list = [[(Item_621, 1), (Item_655, 2), (Item_930, 4), None], [(Item_0, 1), (Item_965, 3), (Item_877, 3), None]]

    @classmethod
    def create(cls, arg : Variation_1367_Arg) -> 'Variation_1367':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["NOGO"]) -> RuleVariation_22:
        ...
    @overload
    def get_item(self, key : Literal["OPS"]) -> RuleVariation_463:
        ...
    @overload
    def get_item(self, key : Literal["SSTAT"]) -> RuleVariation_680:
        ...
    @overload
    def get_item(self, key : Literal["SYSTAT"]) -> Optional[RuleVariation_473]:
        ...
    @overload
    def get_item(self, key : Literal["SESTAT"]) -> Optional[RuleVariation_764]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1290_Arg: TypeAlias = Variation_1367_Arg
class RuleVariation_1290(RuleVariationContextFree):
    cv_variation = Variation_1367

    @classmethod
    def create(cls, arg : RuleVariation_1290_Arg) -> "RuleVariation_1290":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1367:
        return self.arg # type: ignore

NonSpare_273_Arg: TypeAlias = RuleVariation_1290_Arg
class NonSpare_273(NonSpare):
    cv_name = "100"
    cv_title = "System and Service Status"
    cv_rule = RuleVariation_1290

    @classmethod
    def create(cls, arg : NonSpare_273_Arg) -> "NonSpare_273":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1290:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1367:
        return self.rule.variation

class UapItem_273(UapItem):
    cv_non_spare = NonSpare_273

Content_358_Arg: TypeAlias = int
class Content_358(ContentTable):
    cv_values = {0: "No error detected (shall not be sent)", 1: "Error Code Undefined", 2: "Time Source Invalid", 3: "Time Source Coasting", 4: "Track ID numbering has restarted", 5: "Data Processor Overload", 6: "Ground Interface Data Communications Overload", 7: "System stopped by operator", 8: "CBIT failed", 9: "Test Target Failure", 10: "Reserved for allocation by the AMG", 11: "Reserved for allocation by the AMG", 12: "Reserved for allocation by the AMG", 13: "Reserved for allocation by the AMG", 14: "Reserved for allocation by the AMG", 15: "Reserved for allocation by the AMG", 16: "Reserved for allocation by the AMG", 17: "Reserved for allocation by the AMG", 18: "Reserved for allocation by the AMG", 19: "Reserved for allocation by the AMG", 20: "Reserved for allocation by the AMG", 21: "Reserved for allocation by the AMG", 22: "Reserved for allocation by the AMG", 23: "Reserved for allocation by the AMG", 24: "Reserved for allocation by the AMG", 25: "Reserved for allocation by the AMG", 26: "Reserved for allocation by the AMG", 27: "Reserved for allocation by the AMG", 28: "Reserved for allocation by the AMG", 29: "Reserved for allocation by the AMG", 30: "Reserved for allocation by the AMG", 31: "Reserved for allocation by the AMG", 32: "Reserved for allocation by system manufacturers", 33: "Reserved for allocation by system manufacturers", 34: "Reserved for allocation by system manufacturers", 35: "Reserved for allocation by system manufacturers", 36: "Reserved for allocation by system manufacturers", 37: "Reserved for allocation by system manufacturers", 38: "Reserved for allocation by system manufacturers", 39: "Reserved for allocation by system manufacturers", 40: "Reserved for allocation by system manufacturers", 41: "Reserved for allocation by system manufacturers", 42: "Reserved for allocation by system manufacturers", 43: "Reserved for allocation by system manufacturers", 44: "Reserved for allocation by system manufacturers", 45: "Reserved for allocation by system manufacturers", 46: "Reserved for allocation by system manufacturers", 47: "Reserved for allocation by system manufacturers", 48: "Reserved for allocation by system manufacturers", 49: "Reserved for allocation by system manufacturers", 50: "Reserved for allocation by system manufacturers", 51: "Reserved for allocation by system manufacturers", 52: "Reserved for allocation by system manufacturers", 53: "Reserved for allocation by system manufacturers", 54: "Reserved for allocation by system manufacturers", 55: "Reserved for allocation by system manufacturers", 56: "Reserved for allocation by system manufacturers", 57: "Reserved for allocation by system manufacturers", 58: "Reserved for allocation by system manufacturers", 59: "Reserved for allocation by system manufacturers", 60: "Reserved for allocation by system manufacturers", 61: "Reserved for allocation by system manufacturers", 62: "Reserved for allocation by system manufacturers", 63: "Reserved for allocation by system manufacturers", 64: "Reserved for allocation by system manufacturers", 65: "Reserved for allocation by system manufacturers", 66: "Reserved for allocation by system manufacturers", 67: "Reserved for allocation by system manufacturers", 68: "Reserved for allocation by system manufacturers", 69: "Reserved for allocation by system manufacturers", 70: "Reserved for allocation by system manufacturers", 71: "Reserved for allocation by system manufacturers", 72: "Reserved for allocation by system manufacturers", 73: "Reserved for allocation by system manufacturers", 74: "Reserved for allocation by system manufacturers", 75: "Reserved for allocation by system manufacturers", 76: "Reserved for allocation by system manufacturers", 77: "Reserved for allocation by system manufacturers", 78: "Reserved for allocation by system manufacturers", 79: "Reserved for allocation by system manufacturers", 80: "Reserved for allocation by system manufacturers", 81: "Reserved for allocation by system manufacturers", 82: "Reserved for allocation by system manufacturers", 83: "Reserved for allocation by system manufacturers", 84: "Reserved for allocation by system manufacturers", 85: "Reserved for allocation by system manufacturers", 86: "Reserved for allocation by system manufacturers", 87: "Reserved for allocation by system manufacturers", 88: "Reserved for allocation by system manufacturers", 89: "Reserved for allocation by system manufacturers", 90: "Reserved for allocation by system manufacturers", 91: "Reserved for allocation by system manufacturers", 92: "Reserved for allocation by system manufacturers", 93: "Reserved for allocation by system manufacturers", 94: "Reserved for allocation by system manufacturers", 95: "Reserved for allocation by system manufacturers", 96: "Reserved for allocation by system manufacturers", 97: "Reserved for allocation by system manufacturers", 98: "Reserved for allocation by system manufacturers", 99: "Reserved for allocation by system manufacturers", 100: "Reserved for allocation by system manufacturers", 101: "Reserved for allocation by system manufacturers", 102: "Reserved for allocation by system manufacturers", 103: "Reserved for allocation by system manufacturers", 104: "Reserved for allocation by system manufacturers", 105: "Reserved for allocation by system manufacturers", 106: "Reserved for allocation by system manufacturers", 107: "Reserved for allocation by system manufacturers", 108: "Reserved for allocation by system manufacturers", 109: "Reserved for allocation by system manufacturers", 110: "Reserved for allocation by system manufacturers", 111: "Reserved for allocation by system manufacturers", 112: "Reserved for allocation by system manufacturers", 113: "Reserved for allocation by system manufacturers", 114: "Reserved for allocation by system manufacturers", 115: "Reserved for allocation by system manufacturers", 116: "Reserved for allocation by system manufacturers", 117: "Reserved for allocation by system manufacturers", 118: "Reserved for allocation by system manufacturers", 119: "Reserved for allocation by system manufacturers", 120: "Reserved for allocation by system manufacturers", 121: "Reserved for allocation by system manufacturers", 122: "Reserved for allocation by system manufacturers", 123: "Reserved for allocation by system manufacturers", 124: "Reserved for allocation by system manufacturers", 125: "Reserved for allocation by system manufacturers", 126: "Reserved for allocation by system manufacturers", 127: "Reserved for allocation by system manufacturers", 128: "Reserved for allocation by system manufacturers", 129: "Reserved for allocation by system manufacturers", 130: "Reserved for allocation by system manufacturers", 131: "Reserved for allocation by system manufacturers", 132: "Reserved for allocation by system manufacturers", 133: "Reserved for allocation by system manufacturers", 134: "Reserved for allocation by system manufacturers", 135: "Reserved for allocation by system manufacturers", 136: "Reserved for allocation by system manufacturers", 137: "Reserved for allocation by system manufacturers", 138: "Reserved for allocation by system manufacturers", 139: "Reserved for allocation by system manufacturers", 140: "Reserved for allocation by system manufacturers", 141: "Reserved for allocation by system manufacturers", 142: "Reserved for allocation by system manufacturers", 143: "Reserved for allocation by system manufacturers", 144: "Reserved for allocation by system manufacturers", 145: "Reserved for allocation by system manufacturers", 146: "Reserved for allocation by system manufacturers", 147: "Reserved for allocation by system manufacturers", 148: "Reserved for allocation by system manufacturers", 149: "Reserved for allocation by system manufacturers", 150: "Reserved for allocation by system manufacturers", 151: "Reserved for allocation by system manufacturers", 152: "Reserved for allocation by system manufacturers", 153: "Reserved for allocation by system manufacturers", 154: "Reserved for allocation by system manufacturers", 155: "Reserved for allocation by system manufacturers", 156: "Reserved for allocation by system manufacturers", 157: "Reserved for allocation by system manufacturers", 158: "Reserved for allocation by system manufacturers", 159: "Reserved for allocation by system manufacturers", 160: "Reserved for allocation by system manufacturers", 161: "Reserved for allocation by system manufacturers", 162: "Reserved for allocation by system manufacturers", 163: "Reserved for allocation by system manufacturers", 164: "Reserved for allocation by system manufacturers", 165: "Reserved for allocation by system manufacturers", 166: "Reserved for allocation by system manufacturers", 167: "Reserved for allocation by system manufacturers", 168: "Reserved for allocation by system manufacturers", 169: "Reserved for allocation by system manufacturers", 170: "Reserved for allocation by system manufacturers", 171: "Reserved for allocation by system manufacturers", 172: "Reserved for allocation by system manufacturers", 173: "Reserved for allocation by system manufacturers", 174: "Reserved for allocation by system manufacturers", 175: "Reserved for allocation by system manufacturers", 176: "Reserved for allocation by system manufacturers", 177: "Reserved for allocation by system manufacturers", 178: "Reserved for allocation by system manufacturers", 179: "Reserved for allocation by system manufacturers", 180: "Reserved for allocation by system manufacturers", 181: "Reserved for allocation by system manufacturers", 182: "Reserved for allocation by system manufacturers", 183: "Reserved for allocation by system manufacturers", 184: "Reserved for allocation by system manufacturers", 185: "Reserved for allocation by system manufacturers", 186: "Reserved for allocation by system manufacturers", 187: "Reserved for allocation by system manufacturers", 188: "Reserved for allocation by system manufacturers", 189: "Reserved for allocation by system manufacturers", 190: "Reserved for allocation by system manufacturers", 191: "Reserved for allocation by system manufacturers", 192: "Reserved for allocation by system manufacturers", 193: "Reserved for allocation by system manufacturers", 194: "Reserved for allocation by system manufacturers", 195: "Reserved for allocation by system manufacturers", 196: "Reserved for allocation by system manufacturers", 197: "Reserved for allocation by system manufacturers", 198: "Reserved for allocation by system manufacturers", 199: "Reserved for allocation by system manufacturers", 200: "Reserved for allocation by system manufacturers", 201: "Reserved for allocation by system manufacturers", 202: "Reserved for allocation by system manufacturers", 203: "Reserved for allocation by system manufacturers", 204: "Reserved for allocation by system manufacturers", 205: "Reserved for allocation by system manufacturers", 206: "Reserved for allocation by system manufacturers", 207: "Reserved for allocation by system manufacturers", 208: "Reserved for allocation by system manufacturers", 209: "Reserved for allocation by system manufacturers", 210: "Reserved for allocation by system manufacturers", 211: "Reserved for allocation by system manufacturers", 212: "Reserved for allocation by system manufacturers", 213: "Reserved for allocation by system manufacturers", 214: "Reserved for allocation by system manufacturers", 215: "Reserved for allocation by system manufacturers", 216: "Reserved for allocation by system manufacturers", 217: "Reserved for allocation by system manufacturers", 218: "Reserved for allocation by system manufacturers", 219: "Reserved for allocation by system manufacturers", 220: "Reserved for allocation by system manufacturers", 221: "Reserved for allocation by system manufacturers", 222: "Reserved for allocation by system manufacturers", 223: "Reserved for allocation by system manufacturers", 224: "Reserved for allocation by system manufacturers", 225: "Reserved for allocation by system manufacturers", 226: "Reserved for allocation by system manufacturers", 227: "Reserved for allocation by system manufacturers", 228: "Reserved for allocation by system manufacturers", 229: "Reserved for allocation by system manufacturers", 230: "Reserved for allocation by system manufacturers", 231: "Reserved for allocation by system manufacturers", 232: "Reserved for allocation by system manufacturers", 233: "Reserved for allocation by system manufacturers", 234: "Reserved for allocation by system manufacturers", 235: "Reserved for allocation by system manufacturers", 236: "Reserved for allocation by system manufacturers", 237: "Reserved for allocation by system manufacturers", 238: "Reserved for allocation by system manufacturers", 239: "Reserved for allocation by system manufacturers", 240: "Reserved for allocation by system manufacturers", 241: "Reserved for allocation by system manufacturers", 242: "Reserved for allocation by system manufacturers", 243: "Reserved for allocation by system manufacturers", 244: "Reserved for allocation by system manufacturers", 245: "Reserved for allocation by system manufacturers", 246: "Reserved for allocation by system manufacturers", 247: "Reserved for allocation by system manufacturers", 248: "Reserved for allocation by system manufacturers", 249: "Reserved for allocation by system manufacturers", 250: "Reserved for allocation by system manufacturers", 251: "Reserved for allocation by system manufacturers", 252: "Reserved for allocation by system manufacturers", 253: "Reserved for allocation by system manufacturers", 254: "Reserved for allocation by system manufacturers", 255: "Reserved for allocation by system manufacturers"}

RuleContent_358_Arg: TypeAlias = Content_358_Arg
class RuleContent_358(RuleContentContextFree):
    cv_content = Content_358

    @property
    def content(self) -> Content_358:
        return self._get_content() # type: ignore

Variation_171_Arg: TypeAlias = RuleContent_358_Arg
class Variation_171(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_358

    @classmethod
    def create(cls, arg : Variation_171_Arg) -> "Variation_171":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_358:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_358:
        return self.rule.content

Variation_1387_Arg: TypeAlias = List[Variation_171_Arg]
class Variation_1387(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_171

    @classmethod
    def create(cls, arg : Variation_1387_Arg) -> 'Variation_1387':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_171]:
        return self._get_list() # type: ignore

RuleVariation_1310_Arg: TypeAlias = Variation_1387_Arg
class RuleVariation_1310(RuleVariationContextFree):
    cv_variation = Variation_1387

    @classmethod
    def create(cls, arg : RuleVariation_1310_Arg) -> "RuleVariation_1310":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1387:
        return self.arg # type: ignore

NonSpare_279_Arg: TypeAlias = RuleVariation_1310_Arg
class NonSpare_279(NonSpare):
    cv_name = "105"
    cv_title = "System and Service Error Codes"
    cv_rule = RuleVariation_1310

    @classmethod
    def create(cls, arg : NonSpare_279_Arg) -> "NonSpare_279":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1310:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1387:
        return self.rule.variation

class UapItem_279(UapItem):
    cv_non_spare = NonSpare_279

NonSpare_734_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_734(NonSpare):
    cv_name = "CID"
    cv_title = "Component ID"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_734_Arg) -> "NonSpare_734":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

Item_159_Arg: TypeAlias = NonSpare_734_Arg
class Item_159(Item):
    cv_non_spare = NonSpare_734

    @classmethod
    def create(cls, arg : Item_159_Arg) -> "Item_159":
        return cls._create(arg) # type: ignore

Content_305_Arg: TypeAlias = int
class Content_305(ContentTable):
    cv_values = {0: "No Error Detected", 1: "Error Code Undefined", 2: "Reserved for allocation by the AMG", 3: "Reserved for allocation by the AMG", 4: "Reserved for allocation by the AMG", 5: "Reserved for allocation by the AMG", 6: "Reserved for allocation by the AMG", 7: "Reserved for allocation by the AMG", 8: "Reserved for allocation by the AMG", 9: "Reserved for allocation by the AMG", 10: "Reserved for allocation by the AMG", 11: "Reserved for allocation by the AMG", 12: "Reserved for allocation by the AMG", 13: "Reserved for allocation by the AMG", 14: "Reserved for allocation by the AMG", 15: "Reserved for allocation by the AMG", 16: "Reserved for allocation by system manufacturers", 17: "Reserved for allocation by system manufacturers", 18: "Reserved for allocation by system manufacturers", 19: "Reserved for allocation by system manufacturers", 20: "Reserved for allocation by system manufacturers", 21: "Reserved for allocation by system manufacturers", 22: "Reserved for allocation by system manufacturers", 23: "Reserved for allocation by system manufacturers", 24: "Reserved for allocation by system manufacturers", 25: "Reserved for allocation by system manufacturers", 26: "Reserved for allocation by system manufacturers", 27: "Reserved for allocation by system manufacturers", 28: "Reserved for allocation by system manufacturers", 29: "Reserved for allocation by system manufacturers", 30: "Reserved for allocation by system manufacturers", 31: "Reserved for allocation by system manufacturers", 32: "Reserved for allocation by system manufacturers", 33: "Reserved for allocation by system manufacturers", 34: "Reserved for allocation by system manufacturers", 35: "Reserved for allocation by system manufacturers", 36: "Reserved for allocation by system manufacturers", 37: "Reserved for allocation by system manufacturers", 38: "Reserved for allocation by system manufacturers", 39: "Reserved for allocation by system manufacturers", 40: "Reserved for allocation by system manufacturers", 41: "Reserved for allocation by system manufacturers", 42: "Reserved for allocation by system manufacturers", 43: "Reserved for allocation by system manufacturers", 44: "Reserved for allocation by system manufacturers", 45: "Reserved for allocation by system manufacturers", 46: "Reserved for allocation by system manufacturers", 47: "Reserved for allocation by system manufacturers", 48: "Reserved for allocation by system manufacturers", 49: "Reserved for allocation by system manufacturers", 50: "Reserved for allocation by system manufacturers", 51: "Reserved for allocation by system manufacturers", 52: "Reserved for allocation by system manufacturers", 53: "Reserved for allocation by system manufacturers", 54: "Reserved for allocation by system manufacturers", 55: "Reserved for allocation by system manufacturers", 56: "Reserved for allocation by system manufacturers", 57: "Reserved for allocation by system manufacturers", 58: "Reserved for allocation by system manufacturers", 59: "Reserved for allocation by system manufacturers", 60: "Reserved for allocation by system manufacturers", 61: "Reserved for allocation by system manufacturers", 62: "Reserved for allocation by system manufacturers", 63: "Reserved for allocation by system manufacturers"}

RuleContent_305_Arg: TypeAlias = Content_305_Arg
class RuleContent_305(RuleContentContextFree):
    cv_content = Content_305

    @property
    def content(self) -> Content_305:
        return self._get_content() # type: ignore

Variation_147_Arg: TypeAlias = RuleContent_305_Arg
class Variation_147(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 6
    cv_rule = RuleContent_305

    @classmethod
    def create(cls, arg : Variation_147_Arg) -> "Variation_147":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_305:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_305:
        return self.rule.content

RuleVariation_147_Arg: TypeAlias = Variation_147_Arg
class RuleVariation_147(RuleVariationContextFree):
    cv_variation = Variation_147

    @classmethod
    def create(cls, arg : RuleVariation_147_Arg) -> "RuleVariation_147":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_147:
        return self.arg # type: ignore

NonSpare_952_Arg: TypeAlias = RuleVariation_147_Arg
class NonSpare_952(NonSpare):
    cv_name = "ERRC"
    cv_title = "Error Code"
    cv_rule = RuleVariation_147

    @classmethod
    def create(cls, arg : NonSpare_952_Arg) -> "NonSpare_952":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_147:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_147:
        return self.rule.variation

Item_317_Arg: TypeAlias = NonSpare_952_Arg
class Item_317(Item):
    cv_non_spare = NonSpare_952

    @classmethod
    def create(cls, arg : Item_317_Arg) -> "Item_317":
        return cls._create(arg) # type: ignore

Content_444_Arg: TypeAlias = int
class Content_444(ContentTable):
    cv_values = {0: "Running", 1: "Failed", 2: "Maintenance", 3: "Reserved"}

RuleContent_444_Arg: TypeAlias = Content_444_Arg
class RuleContent_444(RuleContentContextFree):
    cv_content = Content_444

    @property
    def content(self) -> Content_444:
        return self._get_content() # type: ignore

Variation_960_Arg: TypeAlias = RuleContent_444_Arg
class Variation_960(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 2
    cv_rule = RuleContent_444

    @classmethod
    def create(cls, arg : Variation_960_Arg) -> "Variation_960":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_444:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_444:
        return self.rule.content

RuleVariation_930_Arg: TypeAlias = Variation_960_Arg
class RuleVariation_930(RuleVariationContextFree):
    cv_variation = Variation_960

    @classmethod
    def create(cls, arg : RuleVariation_930_Arg) -> "RuleVariation_930":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_960:
        return self.arg # type: ignore

NonSpare_825_Arg: TypeAlias = RuleVariation_930_Arg
class NonSpare_825(NonSpare):
    cv_name = "CS"
    cv_title = "Component State/Mode"
    cv_rule = RuleVariation_930

    @classmethod
    def create(cls, arg : NonSpare_825_Arg) -> "NonSpare_825":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_930:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_960:
        return self.rule.variation

Item_216_Arg: TypeAlias = NonSpare_825_Arg
class Item_216(Item):
    cv_non_spare = NonSpare_825

    @classmethod
    def create(cls, arg : Item_216_Arg) -> "Item_216":
        return cls._create(arg) # type: ignore

Variation_1066_Arg_Group = Tuple[Union[RuleVariation_244_Arg, Tuple[Literal["CID"], RuleVariation_244_Arg]], Union[RuleVariation_147_Arg, Tuple[Literal["ERRC"], RuleVariation_147_Arg]], Union[RuleVariation_930_Arg, Tuple[Literal["CS"], RuleVariation_930_Arg]]]
Variation_1066_Arg: TypeAlias = Union[int, Variation_1066_Arg_Group]
class Variation_1066(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_159, 16), (Item_317, 6), (Item_216, 2)]
    cv_items_dict = {"CID": RuleVariation_244, "ERRC": RuleVariation_147, "CS": RuleVariation_930}

    @overload
    @classmethod
    def spec(cls, key : Literal["CID"]) -> RuleVariation_244:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ERRC"]) -> RuleVariation_147:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CS"]) -> RuleVariation_930:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CID"], Literal["ERRC"], Literal["CS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CID"]) -> RuleVariation_244:
        ...
    @overload
    def get_item(self, key : Literal["ERRC"]) -> RuleVariation_147:
        ...
    @overload
    def get_item(self, key : Literal["CS"]) -> RuleVariation_930:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1066_Arg) -> 'Variation_1066':
        return cls._create(arg) # type: ignore

Variation_1407_Arg: TypeAlias = List[Variation_1066_Arg]
class Variation_1407(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1066

    @classmethod
    def create(cls, arg : Variation_1407_Arg) -> 'Variation_1407':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1066]:
        return self._get_list() # type: ignore

RuleVariation_1330_Arg: TypeAlias = Variation_1407_Arg
class RuleVariation_1330(RuleVariationContextFree):
    cv_variation = Variation_1407

    @classmethod
    def create(cls, arg : RuleVariation_1330_Arg) -> "RuleVariation_1330":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1407:
        return self.arg # type: ignore

NonSpare_292_Arg: TypeAlias = RuleVariation_1330_Arg
class NonSpare_292(NonSpare):
    cv_name = "120"
    cv_title = "Component Status"
    cv_rule = RuleVariation_1330

    @classmethod
    def create(cls, arg : NonSpare_292_Arg) -> "NonSpare_292":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1330:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1407:
        return self.rule.variation

class UapItem_292(UapItem):
    cv_non_spare = NonSpare_292

Content_405_Arg: TypeAlias = int
class Content_405(ContentTable):
    cv_values = {0: "Number of unknown messages received", 1: "Number of too old messages received", 2: "Number of failed message conversions", 3: "Total Number of messages received", 4: "Total number of messages transmitted", 5: "Reserved for AMG", 6: "Reserved for AMG", 7: "Reserved for AMG", 8: "Reserved for AMG", 9: "Reserved for AMG", 10: "Reserved for AMG", 11: "Reserved for AMG", 12: "Reserved for AMG", 13: "Reserved for AMG", 14: "Reserved for AMG", 15: "Reserved for AMG", 16: "Reserved for AMG", 17: "Reserved for AMG", 18: "Reserved for AMG", 19: "Reserved for AMG", 20: "Implementation specific", 21: "Implementation specific", 22: "Implementation specific", 23: "Implementation specific", 24: "Implementation specific", 25: "Implementation specific", 26: "Implementation specific", 27: "Implementation specific", 28: "Implementation specific", 29: "Implementation specific", 30: "Implementation specific", 31: "Implementation specific", 32: "Implementation specific", 33: "Implementation specific", 34: "Implementation specific", 35: "Implementation specific", 36: "Implementation specific", 37: "Implementation specific", 38: "Implementation specific", 39: "Implementation specific", 40: "Implementation specific", 41: "Implementation specific", 42: "Implementation specific", 43: "Implementation specific", 44: "Implementation specific", 45: "Implementation specific", 46: "Implementation specific", 47: "Implementation specific", 48: "Implementation specific", 49: "Implementation specific", 50: "Implementation specific", 51: "Implementation specific", 52: "Implementation specific", 53: "Implementation specific", 54: "Implementation specific", 55: "Implementation specific", 56: "Implementation specific", 57: "Implementation specific", 58: "Implementation specific", 59: "Implementation specific", 60: "Implementation specific", 61: "Implementation specific", 62: "Implementation specific", 63: "Implementation specific", 64: "Implementation specific", 65: "Implementation specific", 66: "Implementation specific", 67: "Implementation specific", 68: "Implementation specific", 69: "Implementation specific", 70: "Implementation specific", 71: "Implementation specific", 72: "Implementation specific", 73: "Implementation specific", 74: "Implementation specific", 75: "Implementation specific", 76: "Implementation specific", 77: "Implementation specific", 78: "Implementation specific", 79: "Implementation specific", 80: "Implementation specific", 81: "Implementation specific", 82: "Implementation specific", 83: "Implementation specific", 84: "Implementation specific", 85: "Implementation specific", 86: "Implementation specific", 87: "Implementation specific", 88: "Implementation specific", 89: "Implementation specific", 90: "Implementation specific", 91: "Implementation specific", 92: "Implementation specific", 93: "Implementation specific", 94: "Implementation specific", 95: "Implementation specific", 96: "Implementation specific", 97: "Implementation specific", 98: "Implementation specific", 99: "Implementation specific", 100: "Implementation specific", 101: "Implementation specific", 102: "Implementation specific", 103: "Implementation specific", 104: "Implementation specific", 105: "Implementation specific", 106: "Implementation specific", 107: "Implementation specific", 108: "Implementation specific", 109: "Implementation specific", 110: "Implementation specific", 111: "Implementation specific", 112: "Implementation specific", 113: "Implementation specific", 114: "Implementation specific", 115: "Implementation specific", 116: "Implementation specific", 117: "Implementation specific", 118: "Implementation specific", 119: "Implementation specific", 120: "Implementation specific", 121: "Implementation specific", 122: "Implementation specific", 123: "Implementation specific", 124: "Implementation specific", 125: "Implementation specific", 126: "Implementation specific", 127: "Implementation specific", 128: "Implementation specific", 129: "Implementation specific", 130: "Implementation specific", 131: "Implementation specific", 132: "Implementation specific", 133: "Implementation specific", 134: "Implementation specific", 135: "Implementation specific", 136: "Implementation specific", 137: "Implementation specific", 138: "Implementation specific", 139: "Implementation specific", 140: "Implementation specific", 141: "Implementation specific", 142: "Implementation specific", 143: "Implementation specific", 144: "Implementation specific", 145: "Implementation specific", 146: "Implementation specific", 147: "Implementation specific", 148: "Implementation specific", 149: "Implementation specific", 150: "Implementation specific", 151: "Implementation specific", 152: "Implementation specific", 153: "Implementation specific", 154: "Implementation specific", 155: "Implementation specific", 156: "Implementation specific", 157: "Implementation specific", 158: "Implementation specific", 159: "Implementation specific", 160: "Implementation specific", 161: "Implementation specific", 162: "Implementation specific", 163: "Implementation specific", 164: "Implementation specific", 165: "Implementation specific", 166: "Implementation specific", 167: "Implementation specific", 168: "Implementation specific", 169: "Implementation specific", 170: "Implementation specific", 171: "Implementation specific", 172: "Implementation specific", 173: "Implementation specific", 174: "Implementation specific", 175: "Implementation specific", 176: "Implementation specific", 177: "Implementation specific", 178: "Implementation specific", 179: "Implementation specific", 180: "Implementation specific", 181: "Implementation specific", 182: "Implementation specific", 183: "Implementation specific", 184: "Implementation specific", 185: "Implementation specific", 186: "Implementation specific", 187: "Implementation specific", 188: "Implementation specific", 189: "Implementation specific", 190: "Implementation specific", 191: "Implementation specific", 192: "Implementation specific", 193: "Implementation specific", 194: "Implementation specific", 195: "Implementation specific", 196: "Implementation specific", 197: "Implementation specific", 198: "Implementation specific", 199: "Implementation specific", 200: "Implementation specific", 201: "Implementation specific", 202: "Implementation specific", 203: "Implementation specific", 204: "Implementation specific", 205: "Implementation specific", 206: "Implementation specific", 207: "Implementation specific", 208: "Implementation specific", 209: "Implementation specific", 210: "Implementation specific", 211: "Implementation specific", 212: "Implementation specific", 213: "Implementation specific", 214: "Implementation specific", 215: "Implementation specific", 216: "Implementation specific", 217: "Implementation specific", 218: "Implementation specific", 219: "Implementation specific", 220: "Implementation specific", 221: "Implementation specific", 222: "Implementation specific", 223: "Implementation specific", 224: "Implementation specific", 225: "Implementation specific", 226: "Implementation specific", 227: "Implementation specific", 228: "Implementation specific", 229: "Implementation specific", 230: "Implementation specific", 231: "Implementation specific", 232: "Implementation specific", 233: "Implementation specific", 234: "Implementation specific", 235: "Implementation specific", 236: "Implementation specific", 237: "Implementation specific", 238: "Implementation specific", 239: "Implementation specific", 240: "Implementation specific", 241: "Implementation specific", 242: "Implementation specific", 243: "Implementation specific", 244: "Implementation specific", 245: "Implementation specific", 246: "Implementation specific", 247: "Implementation specific", 248: "Implementation specific", 249: "Implementation specific", 250: "Implementation specific", 251: "Implementation specific", 252: "Implementation specific", 253: "Implementation specific", 254: "Implementation specific", 255: "Implementation specific"}

RuleContent_405_Arg: TypeAlias = Content_405_Arg
class RuleContent_405(RuleContentContextFree):
    cv_content = Content_405

    @property
    def content(self) -> Content_405:
        return self._get_content() # type: ignore

Variation_173_Arg: TypeAlias = RuleContent_405_Arg
class Variation_173(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_405

    @classmethod
    def create(cls, arg : Variation_173_Arg) -> "Variation_173":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_405:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_405:
        return self.rule.content

RuleVariation_166_Arg: TypeAlias = Variation_173_Arg
class RuleVariation_166(RuleVariationContextFree):
    cv_variation = Variation_173

    @classmethod
    def create(cls, arg : RuleVariation_166_Arg) -> "RuleVariation_166":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_173:
        return self.arg # type: ignore

NonSpare_1965_Arg: TypeAlias = RuleVariation_166_Arg
class NonSpare_1965(NonSpare):
    cv_name = "TYPE"
    cv_title = "Type of Report Counter"
    cv_rule = RuleVariation_166

    @classmethod
    def create(cls, arg : NonSpare_1965_Arg) -> "NonSpare_1965":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_166:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_173:
        return self.rule.variation

Item_1084_Arg: TypeAlias = NonSpare_1965_Arg
class Item_1084(Item):
    cv_non_spare = NonSpare_1965

    @classmethod
    def create(cls, arg : Item_1084_Arg) -> "Item_1084":
        return cls._create(arg) # type: ignore

Content_215_Arg: TypeAlias = int
class Content_215(ContentTable):
    cv_values = {0: "From UTC midnight", 1: "From the previous report"}

RuleContent_215_Arg: TypeAlias = Content_215_Arg
class RuleContent_215(RuleContentContextFree):
    cv_content = Content_215

    @property
    def content(self) -> Content_215:
        return self._get_content() # type: ignore

Variation_43_Arg: TypeAlias = RuleContent_215_Arg
class Variation_43(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_215

    @classmethod
    def create(cls, arg : Variation_43_Arg) -> "Variation_43":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_215:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_215:
        return self.rule.content

RuleVariation_43_Arg: TypeAlias = Variation_43_Arg
class RuleVariation_43(RuleVariationContextFree):
    cv_variation = Variation_43

    @classmethod
    def create(cls, arg : RuleVariation_43_Arg) -> "RuleVariation_43":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_43:
        return self.arg # type: ignore

NonSpare_1565_Arg: TypeAlias = RuleVariation_43_Arg
class NonSpare_1565(NonSpare):
    cv_name = "REF"
    cv_title = "Reference from which the Messages Are Counted"
    cv_rule = RuleVariation_43

    @classmethod
    def create(cls, arg : NonSpare_1565_Arg) -> "NonSpare_1565":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_43:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_43:
        return self.rule.variation

Item_796_Arg: TypeAlias = NonSpare_1565_Arg
class Item_796(Item):
    cv_non_spare = NonSpare_1565

    @classmethod
    def create(cls, arg : Item_796_Arg) -> "Item_796":
        return cls._create(arg) # type: ignore

NonSpare_793_Arg: TypeAlias = RuleVariation_366_Arg
class NonSpare_793(NonSpare):
    cv_name = "COUNT"
    cv_title = "Counter Value"
    cv_rule = RuleVariation_366

    @classmethod
    def create(cls, arg : NonSpare_793_Arg) -> "NonSpare_793":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_366:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_373:
        return self.rule.variation

Item_198_Arg: TypeAlias = NonSpare_793_Arg
class Item_198(Item):
    cv_non_spare = NonSpare_793

    @classmethod
    def create(cls, arg : Item_198_Arg) -> "Item_198":
        return cls._create(arg) # type: ignore

Variation_1239_Arg_Group = Tuple[Union[RuleVariation_166_Arg, Tuple[Literal["TYPE"], RuleVariation_166_Arg]], Union[RuleVariation_43_Arg, Tuple[Literal["REF"], RuleVariation_43_Arg]], int, Union[RuleVariation_366_Arg, Tuple[Literal["COUNT"], RuleVariation_366_Arg]]]
Variation_1239_Arg: TypeAlias = Union[int, Variation_1239_Arg_Group]
class Variation_1239(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_1084, 8), (Item_796, 1), (Item_10, 7), (Item_198, 32)]
    cv_items_dict = {"TYPE": RuleVariation_166, "REF": RuleVariation_43, "COUNT": RuleVariation_366}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYPE"]) -> RuleVariation_166:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["REF"]) -> RuleVariation_43:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COUNT"]) -> RuleVariation_366:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYPE"], Literal["REF"], Literal["COUNT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYPE"]) -> RuleVariation_166:
        ...
    @overload
    def get_item(self, key : Literal["REF"]) -> RuleVariation_43:
        ...
    @overload
    def get_item(self, key : Literal["COUNT"]) -> RuleVariation_366:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1239_Arg) -> 'Variation_1239':
        return cls._create(arg) # type: ignore

Variation_1440_Arg: TypeAlias = List[Variation_1239_Arg]
class Variation_1440(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1239

    @classmethod
    def create(cls, arg : Variation_1440_Arg) -> 'Variation_1440':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1239]:
        return self._get_list() # type: ignore

RuleVariation_1363_Arg: TypeAlias = Variation_1440_Arg
class RuleVariation_1363(RuleVariationContextFree):
    cv_variation = Variation_1440

    @classmethod
    def create(cls, arg : RuleVariation_1363_Arg) -> "RuleVariation_1363":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1440:
        return self.arg # type: ignore

NonSpare_321_Arg: TypeAlias = RuleVariation_1363_Arg
class NonSpare_321(NonSpare):
    cv_name = "140"
    cv_title = "Service Statistics"
    cv_rule = RuleVariation_1363

    @classmethod
    def create(cls, arg : NonSpare_321_Arg) -> "NonSpare_321":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1440:
        return self.rule.variation

class UapItem_321(UapItem):
    cv_non_spare = NonSpare_321

Content_704_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_704(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 4.190951585769653e-8
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_704_Arg: TypeAlias = Content_704_Arg
class RuleContent_704(RuleContentContextFree):
    cv_content = Content_704

    @property
    def content(self) -> Content_704:
        return self._get_content() # type: ignore

Variation_383_Arg: TypeAlias = RuleContent_704_Arg
class Variation_383(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_704

    @classmethod
    def create(cls, arg : Variation_383_Arg) -> "Variation_383":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_704:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_704:
        return self.rule.content

RuleVariation_376_Arg: TypeAlias = Variation_383_Arg
class RuleVariation_376(RuleVariationContextFree):
    cv_variation = Variation_383

    @classmethod
    def create(cls, arg : RuleVariation_376_Arg) -> "RuleVariation_376":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_383:
        return self.arg # type: ignore

NonSpare_1147_Arg: TypeAlias = RuleVariation_376_Arg
class NonSpare_1147(NonSpare):
    cv_name = "LAT"
    cv_title = "Latitude"
    cv_rule = RuleVariation_376

    @classmethod
    def create(cls, arg : NonSpare_1147_Arg) -> "NonSpare_1147":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_376:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_383:
        return self.rule.variation

Item_465_Arg: TypeAlias = NonSpare_1147_Arg
class Item_465(Item):
    cv_non_spare = NonSpare_1147

    @classmethod
    def create(cls, arg : Item_465_Arg) -> "Item_465":
        return cls._create(arg) # type: ignore

Content_703_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_703(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 4.190951585769653e-8
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_703_Arg: TypeAlias = Content_703_Arg
class RuleContent_703(RuleContentContextFree):
    cv_content = Content_703

    @property
    def content(self) -> Content_703:
        return self._get_content() # type: ignore

Variation_382_Arg: TypeAlias = RuleContent_703_Arg
class Variation_382(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_703

    @classmethod
    def create(cls, arg : Variation_382_Arg) -> "Variation_382":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_703:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_703:
        return self.rule.content

RuleVariation_375_Arg: TypeAlias = Variation_382_Arg
class RuleVariation_375(RuleVariationContextFree):
    cv_variation = Variation_382

    @classmethod
    def create(cls, arg : RuleVariation_375_Arg) -> "RuleVariation_375":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_382:
        return self.arg # type: ignore

NonSpare_1176_Arg: TypeAlias = RuleVariation_375_Arg
class NonSpare_1176(NonSpare):
    cv_name = "LON"
    cv_title = "Longitude"
    cv_rule = RuleVariation_375

    @classmethod
    def create(cls, arg : NonSpare_1176_Arg) -> "NonSpare_1176":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_375:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_382:
        return self.rule.variation

Item_492_Arg: TypeAlias = NonSpare_1176_Arg
class Item_492(Item):
    cv_non_spare = NonSpare_1176

    @classmethod
    def create(cls, arg : Item_492_Arg) -> "Item_492":
        return cls._create(arg) # type: ignore

Variation_1126_Arg_Group = Tuple[Union[RuleVariation_376_Arg, Tuple[Literal["LAT"], RuleVariation_376_Arg]], Union[RuleVariation_375_Arg, Tuple[Literal["LON"], RuleVariation_375_Arg]]]
Variation_1126_Arg: TypeAlias = Union[int, Variation_1126_Arg_Group]
class Variation_1126(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_465, 32), (Item_492, 32)]
    cv_items_dict = {"LAT": RuleVariation_376, "LON": RuleVariation_375}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_376:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_375:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_376:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_375:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1126_Arg) -> 'Variation_1126':
        return cls._create(arg) # type: ignore

RuleVariation_1083_Arg: TypeAlias = Variation_1126_Arg
class RuleVariation_1083(RuleVariationContextFree):
    cv_variation = Variation_1126

    @classmethod
    def create(cls, arg : RuleVariation_1083_Arg) -> "RuleVariation_1083":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1126:
        return self.arg # type: ignore

NonSpare_526_Arg: TypeAlias = RuleVariation_1083_Arg
class NonSpare_526(NonSpare):
    cv_name = "600"
    cv_title = "Position of the System Reference Point"
    cv_rule = RuleVariation_1083

    @classmethod
    def create(cls, arg : NonSpare_526_Arg) -> "NonSpare_526":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1083:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1126:
        return self.rule.variation

class UapItem_525(UapItem):
    cv_non_spare = NonSpare_526

Content_658_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_658(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.25
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_658_Arg: TypeAlias = Content_658_Arg
class RuleContent_658(RuleContentContextFree):
    cv_content = Content_658

    @property
    def content(self) -> Content_658:
        return self._get_content() # type: ignore

Variation_276_Arg: TypeAlias = RuleContent_658_Arg
class Variation_276(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_658

    @classmethod
    def create(cls, arg : Variation_276_Arg) -> "Variation_276":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_658:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_658:
        return self.rule.content

RuleVariation_269_Arg: TypeAlias = Variation_276_Arg
class RuleVariation_269(RuleVariationContextFree):
    cv_variation = Variation_276

    @classmethod
    def create(cls, arg : RuleVariation_269_Arg) -> "RuleVariation_269":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_276:
        return self.arg # type: ignore

NonSpare_534_Arg: TypeAlias = RuleVariation_269_Arg
class NonSpare_534(NonSpare):
    cv_name = "610"
    cv_title = "Height of the System Reference Point"
    cv_rule = RuleVariation_269

    @classmethod
    def create(cls, arg : NonSpare_534_Arg) -> "NonSpare_534":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_269:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_276:
        return self.rule.variation

class UapItem_533(UapItem):
    cv_non_spare = NonSpare_534

Record_11_Arg = TypedDict('Record_11_Arg', {
    "010": NonSpare_31_Arg,
    "000": NonSpare_18_Arg,
    "200": NonSpare_388_Arg,
    "015": NonSpare_67_Arg,
    "020": NonSpare_82_Arg,
    "070": NonSpare_215_Arg,
    "100": NonSpare_273_Arg,
    "105": NonSpare_279_Arg,
    "120": NonSpare_292_Arg,
    "140": NonSpare_321_Arg,
    "SP": NonSpare_1723_Arg,
    "600": NonSpare_526_Arg,
    "610": NonSpare_534_Arg,
}, total=False)
class Record_11(Record):
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_31, UapItem_18, UapItem_388, UapItem_67, UapItem_82, UapItem_215, UapItem_273, UapItem_279, UapItem_292, UapItem_321, UapItem_543, UapItem_525, UapItem_533]
    cv_items_dict = {"010": NonSpare_31, "000": NonSpare_18, "200": NonSpare_388, "015": NonSpare_67, "020": NonSpare_82, "070": NonSpare_215, "100": NonSpare_273, "105": NonSpare_279, "120": NonSpare_292, "140": NonSpare_321, "SP": NonSpare_1723, "600": NonSpare_526, "610": NonSpare_534}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_31:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_18:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_388:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_67:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_82:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_215:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_273:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["105"]) -> NonSpare_279:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_292:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_321:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["600"]) -> NonSpare_526:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["610"]) -> NonSpare_534:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["200"], Literal["015"], Literal["020"], Literal["070"], Literal["100"], Literal["105"], Literal["120"], Literal["140"], Literal["SP"], Literal["600"], Literal["610"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_31]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_18]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_388]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_67]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_82]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_215]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_273]:
        ...
    @overload
    def get_item(self, key : Literal["105"]) -> Optional[NonSpare_279]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_292]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_321]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    @overload
    def get_item(self, key : Literal["600"]) -> Optional[NonSpare_526]:
        ...
    @overload
    def get_item(self, key : Literal["610"]) -> Optional[NonSpare_534]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_31_Arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_18_Arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_388_Arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_67_Arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_82_Arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_215_Arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_273_Arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["105"], val : NonSpare_279_Arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_292_Arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_321_Arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["600"], val : NonSpare_526_Arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["610"], val : NonSpare_534_Arg) -> 'Record_11':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["105"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["600"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["610"]) -> 'Record_11':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_11_Arg) -> 'Record_11':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_11", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_11_Arg: TypeAlias = Record_11
class Uap_11(UapSingle):
    cv_record = Record_11

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_11]]:
        return cls._parse(bs)

class Asterix_36(AstCat):
    cv_category = 25
    cv_edition = (1, 5)
    cv_uap = Uap_11

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_11_Arg]) -> "Asterix_36":
        return cls._create(records) # type: ignore

NonSpare_49_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_49(NonSpare):
    cv_name = "010"
    cv_title = "Server Identification Tag"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_49_Arg) -> "NonSpare_49":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_49(UapItem):
    cv_non_spare = NonSpare_49

NonSpare_69_Arg: TypeAlias = RuleVariation_247_Arg
class NonSpare_69(NonSpare):
    cv_name = "015"
    cv_title = "User Number"
    cv_rule = RuleVariation_247

    @classmethod
    def create(cls, arg : NonSpare_69_Arg) -> "NonSpare_69":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_247:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_254:
        return self.rule.variation

class UapItem_69(UapItem):
    cv_non_spare = NonSpare_69

NonSpare_73_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_73(NonSpare):
    cv_name = "018"
    cv_title = "Data Source Identification Tag"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_73_Arg) -> "NonSpare_73":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_73(UapItem):
    cv_non_spare = NonSpare_73

Content_577_Arg: TypeAlias = int
class Content_577(ContentTable):
    cv_values = {1: "Information sent by an FPPS"}

RuleContent_577_Arg: TypeAlias = Content_577_Arg
class RuleContent_577(RuleContentContextFree):
    cv_content = Content_577

    @property
    def content(self) -> Content_577:
        return self._get_content() # type: ignore

Variation_135_Arg: TypeAlias = RuleContent_577_Arg
class Variation_135(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_577

    @classmethod
    def create(cls, arg : Variation_135_Arg) -> "Variation_135":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_577:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_577:
        return self.rule.content

RuleVariation_135_Arg: TypeAlias = Variation_135_Arg
class RuleVariation_135(RuleVariationContextFree):
    cv_variation = Variation_135

    @classmethod
    def create(cls, arg : RuleVariation_135_Arg) -> "RuleVariation_135":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_135:
        return self.arg # type: ignore

NonSpare_961_Arg: TypeAlias = RuleVariation_135_Arg
class NonSpare_961(NonSpare):
    cv_name = "FAMILY"
    cv_title = ""
    cv_rule = RuleVariation_135

    @classmethod
    def create(cls, arg : NonSpare_961_Arg) -> "NonSpare_961":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_135:
        return self.rule.variation

Item_325_Arg: TypeAlias = NonSpare_961_Arg
class Item_325(Item):
    cv_non_spare = NonSpare_961

    @classmethod
    def create(cls, arg : Item_325_Arg) -> "Item_325":
        return cls._create(arg) # type: ignore

Content_574_Arg: TypeAlias = int
class Content_574(ContentTable):
    cv_values = {1: "Flight Plan to track initial correlation", 2: "Miniplan update", 3: "End of correlation", 4: "Miniplan Cancellation", 5: "Retained Miniplan"}

RuleContent_574_Arg: TypeAlias = Content_574_Arg
class RuleContent_574(RuleContentContextFree):
    cv_content = Content_574

    @property
    def content(self) -> Content_574:
        return self._get_content() # type: ignore

Variation_800_Arg: TypeAlias = RuleContent_574_Arg
class Variation_800(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 4
    cv_rule = RuleContent_574

    @classmethod
    def create(cls, arg : Variation_800_Arg) -> "Variation_800":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_574:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_574:
        return self.rule.content

RuleVariation_770_Arg: TypeAlias = Variation_800_Arg
class RuleVariation_770(RuleVariationContextFree):
    cv_variation = Variation_800

    @classmethod
    def create(cls, arg : RuleVariation_770_Arg) -> "RuleVariation_770":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_800:
        return self.arg # type: ignore

NonSpare_1335_Arg: TypeAlias = RuleVariation_770_Arg
class NonSpare_1335(NonSpare):
    cv_name = "NATURE"
    cv_title = ""
    cv_rule = RuleVariation_770

    @classmethod
    def create(cls, arg : NonSpare_1335_Arg) -> "NonSpare_1335":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_770:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_800:
        return self.rule.variation

Item_603_Arg: TypeAlias = NonSpare_1335_Arg
class Item_603(Item):
    cv_non_spare = NonSpare_1335

    @classmethod
    def create(cls, arg : Item_603_Arg) -> "Item_603":
        return cls._create(arg) # type: ignore

Variation_1099_Arg_Group = Tuple[Union[RuleVariation_135_Arg, Tuple[Literal["FAMILY"], RuleVariation_135_Arg]], Union[RuleVariation_770_Arg, Tuple[Literal["NATURE"], RuleVariation_770_Arg]]]
Variation_1099_Arg: TypeAlias = Union[int, Variation_1099_Arg_Group]
class Variation_1099(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_325, 4), (Item_603, 4)]
    cv_items_dict = {"FAMILY": RuleVariation_135, "NATURE": RuleVariation_770}

    @overload
    @classmethod
    def spec(cls, key : Literal["FAMILY"]) -> RuleVariation_135:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NATURE"]) -> RuleVariation_770:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["FAMILY"], Literal["NATURE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["FAMILY"]) -> RuleVariation_135:
        ...
    @overload
    def get_item(self, key : Literal["NATURE"]) -> RuleVariation_770:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1099_Arg) -> 'Variation_1099':
        return cls._create(arg) # type: ignore

RuleVariation_1057_Arg: TypeAlias = Variation_1099_Arg
class RuleVariation_1057(RuleVariationContextFree):
    cv_variation = Variation_1099

    @classmethod
    def create(cls, arg : RuleVariation_1057_Arg) -> "RuleVariation_1057":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1099:
        return self.arg # type: ignore

NonSpare_129_Arg: TypeAlias = RuleVariation_1057_Arg
class NonSpare_129(NonSpare):
    cv_name = "035"
    cv_title = "Type of Message"
    cv_rule = RuleVariation_1057

    @classmethod
    def create(cls, arg : NonSpare_129_Arg) -> "NonSpare_129":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1057:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1099:
        return self.rule.variation

class UapItem_129(UapItem):
    cv_non_spare = NonSpare_129

NonSpare_91_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_91(NonSpare):
    cv_name = "020"
    cv_title = "Time of ASTERIX Report Generation"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_91_Arg) -> "NonSpare_91":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_91(UapItem):
    cv_non_spare = NonSpare_91

NonSpare_148_Arg: TypeAlias = RuleVariation_247_Arg
class NonSpare_148(NonSpare):
    cv_name = "040"
    cv_title = "Track Number"
    cv_rule = RuleVariation_247

    @classmethod
    def create(cls, arg : NonSpare_148_Arg) -> "NonSpare_148":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_247:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_254:
        return self.rule.variation

class UapItem_148(UapItem):
    cv_non_spare = NonSpare_148

Variation_250_Arg: TypeAlias = RuleContent_610_Arg
class Variation_250(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 15
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_250_Arg) -> "Variation_250":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_243_Arg: TypeAlias = Variation_250_Arg
class RuleVariation_243(RuleVariationContextFree):
    cv_variation = Variation_250

    @classmethod
    def create(cls, arg : RuleVariation_243_Arg) -> "RuleVariation_243":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_250:
        return self.arg # type: ignore

NonSpare_1799_Arg: TypeAlias = RuleVariation_196_Arg
class NonSpare_1799(NonSpare):
    cv_name = "SUI"
    cv_title = "System Unit Identification"
    cv_rule = RuleVariation_196

    @classmethod
    def create(cls, arg : NonSpare_1799_Arg) -> "NonSpare_1799":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_203:
        return self.rule.variation

Item_961_Arg: TypeAlias = NonSpare_1799_Arg
class Item_961(Item):
    cv_non_spare = NonSpare_1799

    @classmethod
    def create(cls, arg : Item_961_Arg) -> "Item_961":
        return cls._create(arg) # type: ignore

NonSpare_1784_Arg: TypeAlias = RuleVariation_243_Arg
class NonSpare_1784(NonSpare):
    cv_name = "STN"
    cv_title = "System Track Number"
    cv_rule = RuleVariation_243

    @classmethod
    def create(cls, arg : NonSpare_1784_Arg) -> "NonSpare_1784":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_243:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_250:
        return self.rule.variation

Item_950_Arg: TypeAlias = NonSpare_1784_Arg
class Item_950(Item):
    cv_non_spare = NonSpare_1784

    @classmethod
    def create(cls, arg : Item_950_Arg) -> "Item_950":
        return cls._create(arg) # type: ignore

Variation_1378_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_196_Arg, Tuple[Literal["SUI"], RuleVariation_196_Arg]], Union[RuleVariation_243_Arg, Tuple[Literal["STN"], RuleVariation_243_Arg]], None]]
Variation_1378_Arg: TypeAlias = Union[
    Tuple[Variation_1378_Arg_Group_1],
]
class Variation_1378(Extended):
    cv_items_list = [[(Item_961, 8), (Item_950, 15), None]]

    @classmethod
    def create(cls, arg : Variation_1378_Arg) -> 'Variation_1378':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["SUI"]) -> RuleVariation_196:
        ...
    @overload
    def get_item(self, key : Literal["STN"]) -> RuleVariation_243:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1301_Arg: TypeAlias = Variation_1378_Arg
class RuleVariation_1301(RuleVariationContextFree):
    cv_variation = Variation_1378

    @classmethod
    def create(cls, arg : RuleVariation_1301_Arg) -> "RuleVariation_1301":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1378:
        return self.arg # type: ignore

NonSpare_166_Arg: TypeAlias = RuleVariation_1301_Arg
class NonSpare_166(NonSpare):
    cv_name = "050"
    cv_title = "Composed Track Number"
    cv_rule = RuleVariation_1301

    @classmethod
    def create(cls, arg : NonSpare_166_Arg) -> "NonSpare_166":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1301:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1378:
        return self.rule.variation

class UapItem_166(UapItem):
    cv_non_spare = NonSpare_166

NonSpare_1296_Arg: TypeAlias = RuleVariation_776_Arg
class NonSpare_1296(NonSpare):
    cv_name = "MODE3A"
    cv_title = "(Mode 3/A Code) 4 Digits, Octal Representation"
    cv_rule = RuleVariation_776

    @classmethod
    def create(cls, arg : NonSpare_1296_Arg) -> "NonSpare_1296":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_776:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_806:
        return self.rule.variation

Item_568_Arg: TypeAlias = NonSpare_1296_Arg
class Item_568(Item):
    cv_non_spare = NonSpare_1296

    @classmethod
    def create(cls, arg : Item_568_Arg) -> "Item_568":
        return cls._create(arg) # type: ignore

Variation_1023_Arg_Group = Tuple[int, Union[RuleVariation_776_Arg, Tuple[Literal["MODE3A"], RuleVariation_776_Arg]]]
Variation_1023_Arg: TypeAlias = Union[int, Variation_1023_Arg_Group]
class Variation_1023(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_568, 12)]
    cv_items_dict = {"MODE3A": RuleVariation_776}

    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_776:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_776:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1023_Arg) -> 'Variation_1023':
        return cls._create(arg) # type: ignore

RuleVariation_992_Arg: TypeAlias = Variation_1023_Arg
class RuleVariation_992(RuleVariationContextFree):
    cv_variation = Variation_1023

    @classmethod
    def create(cls, arg : RuleVariation_992_Arg) -> "RuleVariation_992":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1023:
        return self.arg # type: ignore

NonSpare_197_Arg: TypeAlias = RuleVariation_992_Arg
class NonSpare_197(NonSpare):
    cv_name = "060"
    cv_title = "Track Mode 3/A"
    cv_rule = RuleVariation_992

    @classmethod
    def create(cls, arg : NonSpare_197_Arg) -> "NonSpare_197":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_992:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1023:
        return self.rule.variation

class UapItem_197(UapItem):
    cv_non_spare = NonSpare_197

NonSpare_491_Arg: TypeAlias = RuleVariation_383_Arg
class NonSpare_491(NonSpare):
    cv_name = "400"
    cv_title = "Callsign"
    cv_rule = RuleVariation_383

    @classmethod
    def create(cls, arg : NonSpare_491_Arg) -> "NonSpare_491":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

class UapItem_490(UapItem):
    cv_non_spare = NonSpare_491

NonSpare_497_Arg: TypeAlias = RuleVariation_247_Arg
class NonSpare_497(NonSpare):
    cv_name = "410"
    cv_title = "Plan Number"
    cv_rule = RuleVariation_247

    @classmethod
    def create(cls, arg : NonSpare_497_Arg) -> "NonSpare_497":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_247:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_254:
        return self.rule.variation

class UapItem_496(UapItem):
    cv_non_spare = NonSpare_497

NonSpare_1016_Arg: TypeAlias = RuleVariation_115_Arg
class NonSpare_1016(NonSpare):
    cv_name = "GATOAT"
    cv_title = ""
    cv_rule = RuleVariation_115

    @classmethod
    def create(cls, arg : NonSpare_1016_Arg) -> "NonSpare_1016":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_115:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_115:
        return self.rule.variation

Item_360_Arg: TypeAlias = NonSpare_1016_Arg
class Item_360(Item):
    cv_non_spare = NonSpare_1016

    @classmethod
    def create(cls, arg : Item_360_Arg) -> "Item_360":
        return cls._create(arg) # type: ignore

NonSpare_985_Arg: TypeAlias = RuleVariation_578_Arg
class NonSpare_985(NonSpare):
    cv_name = "FR1FR2"
    cv_title = ""
    cv_rule = RuleVariation_578

    @classmethod
    def create(cls, arg : NonSpare_985_Arg) -> "NonSpare_985":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_578:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_589:
        return self.rule.variation

Item_340_Arg: TypeAlias = NonSpare_985_Arg
class Item_340(Item):
    cv_non_spare = NonSpare_985

    @classmethod
    def create(cls, arg : Item_340_Arg) -> "Item_340":
        return cls._create(arg) # type: ignore

NonSpare_1726_Arg: TypeAlias = RuleVariation_685_Arg
class NonSpare_1726(NonSpare):
    cv_name = "SP3"
    cv_title = ""
    cv_rule = RuleVariation_685

    @classmethod
    def create(cls, arg : NonSpare_1726_Arg) -> "NonSpare_1726":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_685:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_696:
        return self.rule.variation

Item_905_Arg: TypeAlias = NonSpare_1726_Arg
class Item_905(Item):
    cv_non_spare = NonSpare_1726

    @classmethod
    def create(cls, arg : Item_905_Arg) -> "Item_905":
        return cls._create(arg) # type: ignore

Variation_814_Arg: TypeAlias = RuleContent_0_Arg
class Variation_814(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_814_Arg) -> "Variation_814":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_784_Arg: TypeAlias = Variation_814_Arg
class RuleVariation_784(RuleVariationContextFree):
    cv_variation = Variation_814

    @classmethod
    def create(cls, arg : RuleVariation_784_Arg) -> "RuleVariation_784":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_814:
        return self.arg # type: ignore

NonSpare_1725_Arg: TypeAlias = RuleVariation_784_Arg
class NonSpare_1725(NonSpare):
    cv_name = "SP2"
    cv_title = ""
    cv_rule = RuleVariation_784

    @classmethod
    def create(cls, arg : NonSpare_1725_Arg) -> "NonSpare_1725":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_784:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_814:
        return self.rule.variation

Item_904_Arg: TypeAlias = NonSpare_1725_Arg
class Item_904(Item):
    cv_non_spare = NonSpare_1725

    @classmethod
    def create(cls, arg : Item_904_Arg) -> "Item_904":
        return cls._create(arg) # type: ignore

Variation_896_Arg: TypeAlias = RuleContent_0_Arg
class Variation_896(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_896_Arg) -> "Variation_896":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_866_Arg: TypeAlias = Variation_896_Arg
class RuleVariation_866(RuleVariationContextFree):
    cv_variation = Variation_896

    @classmethod
    def create(cls, arg : RuleVariation_866_Arg) -> "RuleVariation_866":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_896:
        return self.arg # type: ignore

NonSpare_1724_Arg: TypeAlias = RuleVariation_866_Arg
class NonSpare_1724(NonSpare):
    cv_name = "SP1"
    cv_title = ""
    cv_rule = RuleVariation_866

    @classmethod
    def create(cls, arg : NonSpare_1724_Arg) -> "NonSpare_1724":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_866:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_896:
        return self.rule.variation

Item_903_Arg: TypeAlias = NonSpare_1724_Arg
class Item_903(Item):
    cv_non_spare = NonSpare_1724

    @classmethod
    def create(cls, arg : Item_903_Arg) -> "Item_903":
        return cls._create(arg) # type: ignore

Variation_1105_Arg_Group = Tuple[Union[RuleVariation_115_Arg, Tuple[Literal["GATOAT"], RuleVariation_115_Arg]], Union[RuleVariation_578_Arg, Tuple[Literal["FR1FR2"], RuleVariation_578_Arg]], Union[RuleVariation_685_Arg, Tuple[Literal["SP3"], RuleVariation_685_Arg]], Union[RuleVariation_784_Arg, Tuple[Literal["SP2"], RuleVariation_784_Arg]], Union[RuleVariation_866_Arg, Tuple[Literal["SP1"], RuleVariation_866_Arg]], int]
Variation_1105_Arg: TypeAlias = Union[int, Variation_1105_Arg_Group]
class Variation_1105(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_360, 2), (Item_340, 2), (Item_905, 1), (Item_904, 1), (Item_903, 1), (Item_29, 1)]
    cv_items_dict = {"GATOAT": RuleVariation_115, "FR1FR2": RuleVariation_578, "SP3": RuleVariation_685, "SP2": RuleVariation_784, "SP1": RuleVariation_866}

    @overload
    @classmethod
    def spec(cls, key : Literal["GATOAT"]) -> RuleVariation_115:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FR1FR2"]) -> RuleVariation_578:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP3"]) -> RuleVariation_685:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP2"]) -> RuleVariation_784:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP1"]) -> RuleVariation_866:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GATOAT"], Literal["FR1FR2"], Literal["SP3"], Literal["SP2"], Literal["SP1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GATOAT"]) -> RuleVariation_115:
        ...
    @overload
    def get_item(self, key : Literal["FR1FR2"]) -> RuleVariation_578:
        ...
    @overload
    def get_item(self, key : Literal["SP3"]) -> RuleVariation_685:
        ...
    @overload
    def get_item(self, key : Literal["SP2"]) -> RuleVariation_784:
        ...
    @overload
    def get_item(self, key : Literal["SP1"]) -> RuleVariation_866:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1105_Arg) -> 'Variation_1105':
        return cls._create(arg) # type: ignore

RuleVariation_1063_Arg: TypeAlias = Variation_1105_Arg
class RuleVariation_1063(RuleVariationContextFree):
    cv_variation = Variation_1105

    @classmethod
    def create(cls, arg : RuleVariation_1063_Arg) -> "RuleVariation_1063":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1105:
        return self.arg # type: ignore

NonSpare_499_Arg: TypeAlias = RuleVariation_1063_Arg
class NonSpare_499(NonSpare):
    cv_name = "420"
    cv_title = "Flight Category"
    cv_rule = RuleVariation_1063

    @classmethod
    def create(cls, arg : NonSpare_499_Arg) -> "NonSpare_499":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1063:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1105:
        return self.rule.variation

class UapItem_498(UapItem):
    cv_non_spare = NonSpare_499

NonSpare_504_Arg: TypeAlias = RuleVariation_365_Arg
class NonSpare_504(NonSpare):
    cv_name = "440"
    cv_title = "Departure Aerodrome"
    cv_rule = RuleVariation_365

    @classmethod
    def create(cls, arg : NonSpare_504_Arg) -> "NonSpare_504":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_365:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_372:
        return self.rule.variation

class UapItem_503(UapItem):
    cv_non_spare = NonSpare_504

NonSpare_505_Arg: TypeAlias = RuleVariation_365_Arg
class NonSpare_505(NonSpare):
    cv_name = "450"
    cv_title = "Destination Aerodrome"
    cv_rule = RuleVariation_365

    @classmethod
    def create(cls, arg : NonSpare_505_Arg) -> "NonSpare_505":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_365:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_372:
        return self.rule.variation

class UapItem_504(UapItem):
    cv_non_spare = NonSpare_505

Content_750_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["FL"]]]
class Content_750(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.25
    cv_unit = "FL"

    def as_quantity(self, cv_unit : Optional[Literal["FL"]] = None) -> float:
        return self._as_quantity()

RuleContent_749_Arg: TypeAlias = Content_750_Arg
class RuleContent_749(RuleContentContextFree):
    cv_content = Content_750

    @property
    def content(self) -> Content_750:
        return self._get_content() # type: ignore

Variation_320_Arg: TypeAlias = RuleContent_749_Arg
class Variation_320(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_749

    @classmethod
    def create(cls, arg : Variation_320_Arg) -> "Variation_320":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_749:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_750:
        return self.rule.content

RuleVariation_313_Arg: TypeAlias = Variation_320_Arg
class RuleVariation_313(RuleVariationContextFree):
    cv_variation = Variation_320

    @classmethod
    def create(cls, arg : RuleVariation_313_Arg) -> "RuleVariation_313":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_320:
        return self.arg # type: ignore

NonSpare_508_Arg: TypeAlias = RuleVariation_313_Arg
class NonSpare_508(NonSpare):
    cv_name = "480"
    cv_title = "Current Cleared Flight Level"
    cv_rule = RuleVariation_313

    @classmethod
    def create(cls, arg : NonSpare_508_Arg) -> "NonSpare_508":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_313:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_320:
        return self.rule.variation

class UapItem_507(UapItem):
    cv_non_spare = NonSpare_508

NonSpare_715_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_715(NonSpare):
    cv_name = "CEN"
    cv_title = "Centre"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_715_Arg) -> "NonSpare_715":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_147_Arg: TypeAlias = NonSpare_715_Arg
class Item_147(Item):
    cv_non_spare = NonSpare_715

    @classmethod
    def create(cls, arg : Item_147_Arg) -> "Item_147":
        return cls._create(arg) # type: ignore

NonSpare_1438_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_1438(NonSpare):
    cv_name = "POS"
    cv_title = "Position"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_1438_Arg) -> "NonSpare_1438":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_689_Arg: TypeAlias = NonSpare_1438_Arg
class Item_689(Item):
    cv_non_spare = NonSpare_1438

    @classmethod
    def create(cls, arg : Item_689_Arg) -> "Item_689":
        return cls._create(arg) # type: ignore

Variation_1063_Arg_Group = Tuple[Union[RuleVariation_158_Arg, Tuple[Literal["CEN"], RuleVariation_158_Arg]], Union[RuleVariation_158_Arg, Tuple[Literal["POS"], RuleVariation_158_Arg]]]
Variation_1063_Arg: TypeAlias = Union[int, Variation_1063_Arg_Group]
class Variation_1063(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_147, 8), (Item_689, 8)]
    cv_items_dict = {"CEN": RuleVariation_158, "POS": RuleVariation_158}

    @overload
    @classmethod
    def spec(cls, key : Literal["CEN"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> RuleVariation_158:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CEN"], Literal["POS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CEN"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> RuleVariation_158:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1063_Arg) -> 'Variation_1063':
        return cls._create(arg) # type: ignore

RuleVariation_1025_Arg: TypeAlias = Variation_1063_Arg
class RuleVariation_1025(RuleVariationContextFree):
    cv_variation = Variation_1063

    @classmethod
    def create(cls, arg : RuleVariation_1025_Arg) -> "RuleVariation_1025":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1063:
        return self.arg # type: ignore

NonSpare_509_Arg: TypeAlias = RuleVariation_1025_Arg
class NonSpare_509(NonSpare):
    cv_name = "490"
    cv_title = "Current Control Position"
    cv_rule = RuleVariation_1025

    @classmethod
    def create(cls, arg : NonSpare_509_Arg) -> "NonSpare_509":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1025:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1063:
        return self.rule.variation

class UapItem_508(UapItem):
    cv_non_spare = NonSpare_509

NonSpare_502_Arg: TypeAlias = RuleVariation_365_Arg
class NonSpare_502(NonSpare):
    cv_name = "430"
    cv_title = "Type of Aircraft"
    cv_rule = RuleVariation_365

    @classmethod
    def create(cls, arg : NonSpare_502_Arg) -> "NonSpare_502":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_365:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_372:
        return self.rule.variation

class UapItem_501(UapItem):
    cv_non_spare = NonSpare_502

NonSpare_503_Arg: TypeAlias = RuleVariation_193_Arg
class NonSpare_503(NonSpare):
    cv_name = "435"
    cv_title = "Wake Turbulence Category"
    cv_rule = RuleVariation_193

    @classmethod
    def create(cls, arg : NonSpare_503_Arg) -> "NonSpare_503":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_193:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_200:
        return self.rule.variation

class UapItem_502(UapItem):
    cv_non_spare = NonSpare_503

NonSpare_1381_Arg: TypeAlias = RuleVariation_760_Arg
class NonSpare_1381(NonSpare):
    cv_name = "OCT1"
    cv_title = "1st Octal Digit"
    cv_rule = RuleVariation_760

    @classmethod
    def create(cls, arg : NonSpare_1381_Arg) -> "NonSpare_1381":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_760:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_771:
        return self.rule.variation

Item_646_Arg: TypeAlias = NonSpare_1381_Arg
class Item_646(Item):
    cv_non_spare = NonSpare_1381

    @classmethod
    def create(cls, arg : Item_646_Arg) -> "Item_646":
        return cls._create(arg) # type: ignore

Variation_989_Arg: TypeAlias = RuleContent_0_Arg
class Variation_989(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 3
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_989_Arg) -> "Variation_989":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_959_Arg: TypeAlias = Variation_989_Arg
class RuleVariation_959(RuleVariationContextFree):
    cv_variation = Variation_989

    @classmethod
    def create(cls, arg : RuleVariation_959_Arg) -> "RuleVariation_959":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_989:
        return self.arg # type: ignore

NonSpare_1382_Arg: TypeAlias = RuleVariation_959_Arg
class NonSpare_1382(NonSpare):
    cv_name = "OCT2"
    cv_title = "2nd Octal Digit"
    cv_rule = RuleVariation_959

    @classmethod
    def create(cls, arg : NonSpare_1382_Arg) -> "NonSpare_1382":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_959:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_989:
        return self.rule.variation

Item_647_Arg: TypeAlias = NonSpare_1382_Arg
class Item_647(Item):
    cv_non_spare = NonSpare_1382

    @classmethod
    def create(cls, arg : Item_647_Arg) -> "Item_647":
        return cls._create(arg) # type: ignore

Variation_594_Arg: TypeAlias = RuleContent_0_Arg
class Variation_594(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 3
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_594_Arg) -> "Variation_594":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_583_Arg: TypeAlias = Variation_594_Arg
class RuleVariation_583(RuleVariationContextFree):
    cv_variation = Variation_594

    @classmethod
    def create(cls, arg : RuleVariation_583_Arg) -> "RuleVariation_583":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_594:
        return self.arg # type: ignore

NonSpare_1383_Arg: TypeAlias = RuleVariation_583_Arg
class NonSpare_1383(NonSpare):
    cv_name = "OCT3"
    cv_title = "3rd Octal Digit"
    cv_rule = RuleVariation_583

    @classmethod
    def create(cls, arg : NonSpare_1383_Arg) -> "NonSpare_1383":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_583:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_594:
        return self.rule.variation

Item_648_Arg: TypeAlias = NonSpare_1383_Arg
class Item_648(Item):
    cv_non_spare = NonSpare_1383

    @classmethod
    def create(cls, arg : Item_648_Arg) -> "Item_648":
        return cls._create(arg) # type: ignore

NonSpare_1384_Arg: TypeAlias = RuleVariation_856_Arg
class NonSpare_1384(NonSpare):
    cv_name = "OCT4"
    cv_title = "4th Octal Digit"
    cv_rule = RuleVariation_856

    @classmethod
    def create(cls, arg : NonSpare_1384_Arg) -> "NonSpare_1384":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_856:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_886:
        return self.rule.variation

Item_649_Arg: TypeAlias = NonSpare_1384_Arg
class Item_649(Item):
    cv_non_spare = NonSpare_1384

    @classmethod
    def create(cls, arg : Item_649_Arg) -> "Item_649":
        return cls._create(arg) # type: ignore

Variation_1027_Arg_Group = Tuple[int, Union[RuleVariation_760_Arg, Tuple[Literal["OCT1"], RuleVariation_760_Arg]], Union[RuleVariation_959_Arg, Tuple[Literal["OCT2"], RuleVariation_959_Arg]], Union[RuleVariation_583_Arg, Tuple[Literal["OCT3"], RuleVariation_583_Arg]], Union[RuleVariation_856_Arg, Tuple[Literal["OCT4"], RuleVariation_856_Arg]]]
Variation_1027_Arg: TypeAlias = Union[int, Variation_1027_Arg_Group]
class Variation_1027(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_646, 3), (Item_647, 3), (Item_648, 3), (Item_649, 3)]
    cv_items_dict = {"OCT1": RuleVariation_760, "OCT2": RuleVariation_959, "OCT3": RuleVariation_583, "OCT4": RuleVariation_856}

    @overload
    @classmethod
    def spec(cls, key : Literal["OCT1"]) -> RuleVariation_760:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OCT2"]) -> RuleVariation_959:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OCT3"]) -> RuleVariation_583:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OCT4"]) -> RuleVariation_856:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["OCT1"], Literal["OCT2"], Literal["OCT3"], Literal["OCT4"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["OCT1"]) -> RuleVariation_760:
        ...
    @overload
    def get_item(self, key : Literal["OCT2"]) -> RuleVariation_959:
        ...
    @overload
    def get_item(self, key : Literal["OCT3"]) -> RuleVariation_583:
        ...
    @overload
    def get_item(self, key : Literal["OCT4"]) -> RuleVariation_856:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1027_Arg) -> 'Variation_1027':
        return cls._create(arg) # type: ignore

Variation_1400_Arg: TypeAlias = List[Variation_1027_Arg]
class Variation_1400(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1027

    @classmethod
    def create(cls, arg : Variation_1400_Arg) -> 'Variation_1400':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1027]:
        return self._get_list() # type: ignore

RuleVariation_1323_Arg: TypeAlias = Variation_1400_Arg
class RuleVariation_1323(RuleVariationContextFree):
    cv_variation = Variation_1400

    @classmethod
    def create(cls, arg : RuleVariation_1323_Arg) -> "RuleVariation_1323":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1400:
        return self.arg # type: ignore

NonSpare_506_Arg: TypeAlias = RuleVariation_1323_Arg
class NonSpare_506(NonSpare):
    cv_name = "460"
    cv_title = "Allocated SSR Codes"
    cv_rule = RuleVariation_1323

    @classmethod
    def create(cls, arg : NonSpare_506_Arg) -> "NonSpare_506":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1323:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1400:
        return self.rule.variation

class UapItem_505(UapItem):
    cv_non_spare = NonSpare_506

Content_424_Arg: TypeAlias = int
class Content_424(ContentTable):
    cv_values = {0: "Plan Number", 1: "Unit 1 internal flight number", 2: "Unit 2 internal flight number", 3: "Unit 3 internal flight number"}

RuleContent_424_Arg: TypeAlias = Content_424_Arg
class RuleContent_424(RuleContentContextFree):
    cv_content = Content_424

    @property
    def content(self) -> Content_424:
        return self._get_content() # type: ignore

Variation_110_Arg: TypeAlias = RuleContent_424_Arg
class Variation_110(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_424

    @classmethod
    def create(cls, arg : Variation_110_Arg) -> "Variation_110":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_424:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_424:
        return self.rule.content

RuleVariation_110_Arg: TypeAlias = Variation_110_Arg
class RuleVariation_110(RuleVariationContextFree):
    cv_variation = Variation_110

    @classmethod
    def create(cls, arg : RuleVariation_110_Arg) -> "RuleVariation_110":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_110:
        return self.arg # type: ignore

NonSpare_1949_Arg: TypeAlias = RuleVariation_110_Arg
class NonSpare_1949(NonSpare):
    cv_name = "TYP"
    cv_title = ""
    cv_rule = RuleVariation_110

    @classmethod
    def create(cls, arg : NonSpare_1949_Arg) -> "NonSpare_1949":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_110:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_110:
        return self.rule.variation

Item_1069_Arg: TypeAlias = NonSpare_1949_Arg
class Item_1069(Item):
    cv_non_spare = NonSpare_1949

    @classmethod
    def create(cls, arg : Item_1069_Arg) -> "Item_1069":
        return cls._create(arg) # type: ignore

Content_617_Arg: TypeAlias = int
class Content_617(ContentInteger):
    cv_signedness = Unsigned

RuleContent_617_Arg: TypeAlias = Content_617_Arg
class RuleContent_617(RuleContentContextFree):
    cv_content = Content_617

    @property
    def content(self) -> Content_617:
        return self._get_content() # type: ignore

Variation_894_Arg: TypeAlias = RuleContent_617_Arg
class Variation_894(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 27
    cv_rule = RuleContent_617

    @classmethod
    def create(cls, arg : Variation_894_Arg) -> "Variation_894":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_617:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_617:
        return self.rule.content

RuleVariation_864_Arg: TypeAlias = Variation_894_Arg
class RuleVariation_864(RuleVariationContextFree):
    cv_variation = Variation_894

    @classmethod
    def create(cls, arg : RuleVariation_864_Arg) -> "RuleVariation_864":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_894:
        return self.arg # type: ignore

NonSpare_1342_Arg: TypeAlias = RuleVariation_864_Arg
class NonSpare_1342(NonSpare):
    cv_name = "NBR"
    cv_title = ""
    cv_rule = RuleVariation_864

    @classmethod
    def create(cls, arg : NonSpare_1342_Arg) -> "NonSpare_1342":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_864:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_894:
        return self.rule.variation

Item_608_Arg: TypeAlias = NonSpare_1342_Arg
class Item_608(Item):
    cv_non_spare = NonSpare_1342

    @classmethod
    def create(cls, arg : Item_608_Arg) -> "Item_608":
        return cls._create(arg) # type: ignore

Variation_1226_Arg_Group = Tuple[Union[RuleVariation_110_Arg, Tuple[Literal["TYP"], RuleVariation_110_Arg]], int, Union[RuleVariation_864_Arg, Tuple[Literal["NBR"], RuleVariation_864_Arg]]]
Variation_1226_Arg: TypeAlias = Union[int, Variation_1226_Arg_Group]
class Variation_1226(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1069, 2), (Item_13, 3), (Item_608, 27)]
    cv_items_dict = {"TYP": RuleVariation_110, "NBR": RuleVariation_864}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_110:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NBR"]) -> RuleVariation_864:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["NBR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_110:
        ...
    @overload
    def get_item(self, key : Literal["NBR"]) -> RuleVariation_864:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1226_Arg) -> 'Variation_1226':
        return cls._create(arg) # type: ignore

RuleVariation_1165_Arg: TypeAlias = Variation_1226_Arg
class RuleVariation_1165(RuleVariationContextFree):
    cv_variation = Variation_1226

    @classmethod
    def create(cls, arg : RuleVariation_1165_Arg) -> "RuleVariation_1165":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1226:
        return self.arg # type: ignore

NonSpare_1108_Arg: TypeAlias = RuleVariation_1165_Arg
class NonSpare_1108(NonSpare):
    cv_name = "IFI"
    cv_title = "IFPS FLIGHT ID"
    cv_rule = RuleVariation_1165

    @classmethod
    def create(cls, arg : NonSpare_1108_Arg) -> "NonSpare_1108":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1165:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1226:
        return self.rule.variation

Content_540_Arg: TypeAlias = int
class Content_540(ContentTable):
    cv_values = {0: "Unknown", 1: "Approved", 2: "Exempt", 3: "Not approved"}

RuleContent_540_Arg: TypeAlias = Content_540_Arg
class RuleContent_540(RuleContentContextFree):
    cv_content = Content_540

    @property
    def content(self) -> Content_540:
        return self._get_content() # type: ignore

Variation_885_Arg: TypeAlias = RuleContent_540_Arg
class Variation_885(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_540

    @classmethod
    def create(cls, arg : Variation_885_Arg) -> "Variation_885":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_540:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_540:
        return self.rule.content

RuleVariation_855_Arg: TypeAlias = Variation_885_Arg
class RuleVariation_855(RuleVariationContextFree):
    cv_variation = Variation_885

    @classmethod
    def create(cls, arg : RuleVariation_855_Arg) -> "RuleVariation_855":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_885:
        return self.arg # type: ignore

NonSpare_1629_Arg: TypeAlias = RuleVariation_855_Arg
class NonSpare_1629(NonSpare):
    cv_name = "RVSM"
    cv_title = ""
    cv_rule = RuleVariation_855

    @classmethod
    def create(cls, arg : NonSpare_1629_Arg) -> "NonSpare_1629":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_855:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_885:
        return self.rule.variation

Item_840_Arg: TypeAlias = NonSpare_1629_Arg
class Item_840(Item):
    cv_non_spare = NonSpare_1629

    @classmethod
    def create(cls, arg : Item_840_Arg) -> "Item_840":
        return cls._create(arg) # type: ignore

Variation_981_Arg: TypeAlias = RuleContent_381_Arg
class Variation_981(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_381

    @classmethod
    def create(cls, arg : Variation_981_Arg) -> "Variation_981":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_381:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_381:
        return self.rule.content

RuleVariation_951_Arg: TypeAlias = Variation_981_Arg
class RuleVariation_951(RuleVariationContextFree):
    cv_variation = Variation_981

    @classmethod
    def create(cls, arg : RuleVariation_951_Arg) -> "RuleVariation_951":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_981:
        return self.arg # type: ignore

NonSpare_1070_Arg: TypeAlias = RuleVariation_951_Arg
class NonSpare_1070(NonSpare):
    cv_name = "HPR"
    cv_title = ""
    cv_rule = RuleVariation_951

    @classmethod
    def create(cls, arg : NonSpare_1070_Arg) -> "NonSpare_1070":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_951:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_981:
        return self.rule.variation

Item_400_Arg: TypeAlias = NonSpare_1070_Arg
class Item_400(Item):
    cv_non_spare = NonSpare_1070

    @classmethod
    def create(cls, arg : Item_400_Arg) -> "Item_400":
        return cls._create(arg) # type: ignore

Variation_1037_Arg_Group = Tuple[int, Union[RuleVariation_855_Arg, Tuple[Literal["RVSM"], RuleVariation_855_Arg]], Union[RuleVariation_951_Arg, Tuple[Literal["HPR"], RuleVariation_951_Arg]]]
Variation_1037_Arg: TypeAlias = Union[int, Variation_1037_Arg_Group]
class Variation_1037(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_4, 5), (Item_840, 2), (Item_400, 1)]
    cv_items_dict = {"RVSM": RuleVariation_855, "HPR": RuleVariation_951}

    @overload
    @classmethod
    def spec(cls, key : Literal["RVSM"]) -> RuleVariation_855:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HPR"]) -> RuleVariation_951:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RVSM"], Literal["HPR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RVSM"]) -> RuleVariation_855:
        ...
    @overload
    def get_item(self, key : Literal["HPR"]) -> RuleVariation_951:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1037_Arg) -> 'Variation_1037':
        return cls._create(arg) # type: ignore

RuleVariation_1005_Arg: TypeAlias = Variation_1037_Arg
class RuleVariation_1005(RuleVariationContextFree):
    cv_variation = Variation_1037

    @classmethod
    def create(cls, arg : RuleVariation_1005_Arg) -> "RuleVariation_1005":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1037:
        return self.arg # type: ignore

NonSpare_1626_Arg: TypeAlias = RuleVariation_1005_Arg
class NonSpare_1626(NonSpare):
    cv_name = "RVP"
    cv_title = "RVSM & Flight Priority"
    cv_rule = RuleVariation_1005

    @classmethod
    def create(cls, arg : NonSpare_1626_Arg) -> "NonSpare_1626":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1005:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1037:
        return self.rule.variation

Variation_201_Arg: TypeAlias = RuleContent_606_Arg
class Variation_201(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_606

    @classmethod
    def create(cls, arg : Variation_201_Arg) -> "Variation_201":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_606:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_606:
        return self.rule.content

RuleVariation_194_Arg: TypeAlias = Variation_201_Arg
class RuleVariation_194(RuleVariationContextFree):
    cv_variation = Variation_201

    @classmethod
    def create(cls, arg : RuleVariation_194_Arg) -> "RuleVariation_194":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_201:
        return self.arg # type: ignore

NonSpare_1373_Arg: TypeAlias = RuleVariation_194_Arg
class NonSpare_1373(NonSpare):
    cv_name = "NU1"
    cv_title = "First Number"
    cv_rule = RuleVariation_194

    @classmethod
    def create(cls, arg : NonSpare_1373_Arg) -> "NonSpare_1373":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_194:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_201:
        return self.rule.variation

Item_638_Arg: TypeAlias = NonSpare_1373_Arg
class Item_638(Item):
    cv_non_spare = NonSpare_1373

    @classmethod
    def create(cls, arg : Item_638_Arg) -> "Item_638":
        return cls._create(arg) # type: ignore

NonSpare_1374_Arg: TypeAlias = RuleVariation_194_Arg
class NonSpare_1374(NonSpare):
    cv_name = "NU2"
    cv_title = "Second Number"
    cv_rule = RuleVariation_194

    @classmethod
    def create(cls, arg : NonSpare_1374_Arg) -> "NonSpare_1374":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_194:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_201:
        return self.rule.variation

Item_639_Arg: TypeAlias = NonSpare_1374_Arg
class Item_639(Item):
    cv_non_spare = NonSpare_1374

    @classmethod
    def create(cls, arg : Item_639_Arg) -> "Item_639":
        return cls._create(arg) # type: ignore

NonSpare_1190_Arg: TypeAlias = RuleVariation_194_Arg
class NonSpare_1190(NonSpare):
    cv_name = "LTR"
    cv_title = "Letter"
    cv_rule = RuleVariation_194

    @classmethod
    def create(cls, arg : NonSpare_1190_Arg) -> "NonSpare_1190":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_194:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_201:
        return self.rule.variation

Item_504_Arg: TypeAlias = NonSpare_1190_Arg
class Item_504(Item):
    cv_non_spare = NonSpare_1190

    @classmethod
    def create(cls, arg : Item_504_Arg) -> "Item_504":
        return cls._create(arg) # type: ignore

Variation_1149_Arg_Group = Tuple[Union[RuleVariation_194_Arg, Tuple[Literal["NU1"], RuleVariation_194_Arg]], Union[RuleVariation_194_Arg, Tuple[Literal["NU2"], RuleVariation_194_Arg]], Union[RuleVariation_194_Arg, Tuple[Literal["LTR"], RuleVariation_194_Arg]]]
Variation_1149_Arg: TypeAlias = Union[int, Variation_1149_Arg_Group]
class Variation_1149(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_638, 8), (Item_639, 8), (Item_504, 8)]
    cv_items_dict = {"NU1": RuleVariation_194, "NU2": RuleVariation_194, "LTR": RuleVariation_194}

    @overload
    @classmethod
    def spec(cls, key : Literal["NU1"]) -> RuleVariation_194:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NU2"]) -> RuleVariation_194:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LTR"]) -> RuleVariation_194:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["NU1"], Literal["NU2"], Literal["LTR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["NU1"]) -> RuleVariation_194:
        ...
    @overload
    def get_item(self, key : Literal["NU2"]) -> RuleVariation_194:
        ...
    @overload
    def get_item(self, key : Literal["LTR"]) -> RuleVariation_194:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1149_Arg) -> 'Variation_1149':
        return cls._create(arg) # type: ignore

RuleVariation_1103_Arg: TypeAlias = Variation_1149_Arg
class RuleVariation_1103(RuleVariationContextFree):
    cv_variation = Variation_1149

    @classmethod
    def create(cls, arg : RuleVariation_1103_Arg) -> "RuleVariation_1103":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1149:
        return self.arg # type: ignore

NonSpare_1554_Arg: TypeAlias = RuleVariation_1103_Arg
class NonSpare_1554(NonSpare):
    cv_name = "RDS"
    cv_title = "Runway Designation"
    cv_rule = RuleVariation_1103

    @classmethod
    def create(cls, arg : NonSpare_1554_Arg) -> "NonSpare_1554":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1103:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1149:
        return self.rule.variation

Content_452_Arg: TypeAlias = int
class Content_452(ContentTable):
    cv_values = {0: "Scheduled Off-Block Time", 1: "Estimated Off-Block Time", 2: "Estimated Take-Off Time", 3: "Actual Off-Block Time", 4: "Predicted Time at Runway Hold", 5: "Actual Time at Runway Hold", 6: "Actual Line-Up Time", 7: "Actual Take-Off Time", 8: "Estimated Time of Arrival", 9: "Predicted Landing Time", 10: "Actual Landing Time", 11: "Actual Time off Runway", 12: "Predicted Time to Gate", 13: "Actual On-Block Time"}

RuleContent_452_Arg: TypeAlias = Content_452_Arg
class RuleContent_452(RuleContentContextFree):
    cv_content = Content_452

    @property
    def content(self) -> Content_452:
        return self._get_content() # type: ignore

Variation_143_Arg: TypeAlias = RuleContent_452_Arg
class Variation_143(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 5
    cv_rule = RuleContent_452

    @classmethod
    def create(cls, arg : Variation_143_Arg) -> "Variation_143":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_452:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_452:
        return self.rule.content

RuleVariation_143_Arg: TypeAlias = Variation_143_Arg
class RuleVariation_143(RuleVariationContextFree):
    cv_variation = Variation_143

    @classmethod
    def create(cls, arg : RuleVariation_143_Arg) -> "RuleVariation_143":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_143:
        return self.arg # type: ignore

NonSpare_1952_Arg: TypeAlias = RuleVariation_143_Arg
class NonSpare_1952(NonSpare):
    cv_name = "TYP"
    cv_title = ""
    cv_rule = RuleVariation_143

    @classmethod
    def create(cls, arg : NonSpare_1952_Arg) -> "NonSpare_1952":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_143:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_143:
        return self.rule.variation

Item_1072_Arg: TypeAlias = NonSpare_1952_Arg
class Item_1072(Item):
    cv_non_spare = NonSpare_1952

    @classmethod
    def create(cls, arg : Item_1072_Arg) -> "Item_1072":
        return cls._create(arg) # type: ignore

Content_508_Arg: TypeAlias = int
class Content_508(ContentTable):
    cv_values = {0: "Today", 1: "Yesterday", 2: "Tomorrow", 3: "Invalid"}

RuleContent_508_Arg: TypeAlias = Content_508_Arg
class RuleContent_508(RuleContentContextFree):
    cv_content = Content_508

    @property
    def content(self) -> Content_508:
        return self._get_content() # type: ignore

Variation_882_Arg: TypeAlias = RuleContent_508_Arg
class Variation_882(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_508

    @classmethod
    def create(cls, arg : Variation_882_Arg) -> "Variation_882":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_508:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_508:
        return self.rule.content

RuleVariation_852_Arg: TypeAlias = Variation_882_Arg
class RuleVariation_852(RuleVariationContextFree):
    cv_variation = Variation_882

    @classmethod
    def create(cls, arg : RuleVariation_852_Arg) -> "RuleVariation_852":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_882:
        return self.arg # type: ignore

NonSpare_855_Arg: TypeAlias = RuleVariation_852_Arg
class NonSpare_855(NonSpare):
    cv_name = "DAY"
    cv_title = ""
    cv_rule = RuleVariation_852

    @classmethod
    def create(cls, arg : NonSpare_855_Arg) -> "NonSpare_855":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_852:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_882:
        return self.rule.variation

Item_239_Arg: TypeAlias = NonSpare_855_Arg
class Item_239(Item):
    cv_non_spare = NonSpare_855

    @classmethod
    def create(cls, arg : Item_239_Arg) -> "Item_239":
        return cls._create(arg) # type: ignore

NonSpare_1065_Arg: TypeAlias = RuleVariation_682_Arg
class NonSpare_1065(NonSpare):
    cv_name = "HOR"
    cv_title = ""
    cv_rule = RuleVariation_682

    @classmethod
    def create(cls, arg : NonSpare_1065_Arg) -> "NonSpare_1065":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_682:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_693:
        return self.rule.variation

Item_396_Arg: TypeAlias = NonSpare_1065_Arg
class Item_396(Item):
    cv_non_spare = NonSpare_1065

    @classmethod
    def create(cls, arg : Item_396_Arg) -> "Item_396":
        return cls._create(arg) # type: ignore

NonSpare_1278_Arg: TypeAlias = RuleVariation_589_Arg
class NonSpare_1278(NonSpare):
    cv_name = "MIN"
    cv_title = ""
    cv_rule = RuleVariation_589

    @classmethod
    def create(cls, arg : NonSpare_1278_Arg) -> "NonSpare_1278":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_589:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_600:
        return self.rule.variation

Item_551_Arg: TypeAlias = NonSpare_1278_Arg
class Item_551(Item):
    cv_non_spare = NonSpare_1278

    @classmethod
    def create(cls, arg : Item_551_Arg) -> "Item_551":
        return cls._create(arg) # type: ignore

NonSpare_645_Arg: TypeAlias = RuleVariation_74_Arg
class NonSpare_645(NonSpare):
    cv_name = "AVS"
    cv_title = ""
    cv_rule = RuleVariation_74

    @classmethod
    def create(cls, arg : NonSpare_645_Arg) -> "NonSpare_645":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_74:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_74:
        return self.rule.variation

Item_94_Arg: TypeAlias = NonSpare_645_Arg
class Item_94(Item):
    cv_non_spare = NonSpare_645

    @classmethod
    def create(cls, arg : Item_94_Arg) -> "Item_94":
        return cls._create(arg) # type: ignore

NonSpare_1689_Arg: TypeAlias = RuleVariation_589_Arg
class NonSpare_1689(NonSpare):
    cv_name = "SEC"
    cv_title = ""
    cv_rule = RuleVariation_589

    @classmethod
    def create(cls, arg : NonSpare_1689_Arg) -> "NonSpare_1689":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_589:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_600:
        return self.rule.variation

Item_874_Arg: TypeAlias = NonSpare_1689_Arg
class Item_874(Item):
    cv_non_spare = NonSpare_1689

    @classmethod
    def create(cls, arg : Item_874_Arg) -> "Item_874":
        return cls._create(arg) # type: ignore

Variation_1228_Arg_Group = Tuple[Union[RuleVariation_143_Arg, Tuple[Literal["TYP"], RuleVariation_143_Arg]], Union[RuleVariation_852_Arg, Tuple[Literal["DAY"], RuleVariation_852_Arg]], int, Union[RuleVariation_682_Arg, Tuple[Literal["HOR"], RuleVariation_682_Arg]], int, Union[RuleVariation_589_Arg, Tuple[Literal["MIN"], RuleVariation_589_Arg]], Union[RuleVariation_74_Arg, Tuple[Literal["AVS"], RuleVariation_74_Arg]], int, Union[RuleVariation_589_Arg, Tuple[Literal["SEC"], RuleVariation_589_Arg]]]
Variation_1228_Arg: TypeAlias = Union[int, Variation_1228_Arg_Group]
class Variation_1228(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1072, 5), (Item_239, 2), (Item_30, 4), (Item_396, 5), (Item_1, 2), (Item_551, 6), (Item_94, 1), (Item_7, 1), (Item_874, 6)]
    cv_items_dict = {"TYP": RuleVariation_143, "DAY": RuleVariation_852, "HOR": RuleVariation_682, "MIN": RuleVariation_589, "AVS": RuleVariation_74, "SEC": RuleVariation_589}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_143:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DAY"]) -> RuleVariation_852:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HOR"]) -> RuleVariation_682:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MIN"]) -> RuleVariation_589:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AVS"]) -> RuleVariation_74:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SEC"]) -> RuleVariation_589:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["DAY"], Literal["HOR"], Literal["MIN"], Literal["AVS"], Literal["SEC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_143:
        ...
    @overload
    def get_item(self, key : Literal["DAY"]) -> RuleVariation_852:
        ...
    @overload
    def get_item(self, key : Literal["HOR"]) -> RuleVariation_682:
        ...
    @overload
    def get_item(self, key : Literal["MIN"]) -> RuleVariation_589:
        ...
    @overload
    def get_item(self, key : Literal["AVS"]) -> RuleVariation_74:
        ...
    @overload
    def get_item(self, key : Literal["SEC"]) -> RuleVariation_589:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1228_Arg) -> 'Variation_1228':
        return cls._create(arg) # type: ignore

Variation_1432_Arg: TypeAlias = List[Variation_1228_Arg]
class Variation_1432(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1228

    @classmethod
    def create(cls, arg : Variation_1432_Arg) -> 'Variation_1432':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1228]:
        return self._get_list() # type: ignore

RuleVariation_1355_Arg: TypeAlias = Variation_1432_Arg
class RuleVariation_1355(RuleVariationContextFree):
    cv_variation = Variation_1432

    @classmethod
    def create(cls, arg : RuleVariation_1355_Arg) -> "RuleVariation_1355":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1432:
        return self.arg # type: ignore

NonSpare_1874_Arg: TypeAlias = RuleVariation_1355_Arg
class NonSpare_1874(NonSpare):
    cv_name = "TOD"
    cv_title = "Time of Departure / Arrival"
    cv_rule = RuleVariation_1355

    @classmethod
    def create(cls, arg : NonSpare_1874_Arg) -> "NonSpare_1874":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1355:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1432:
        return self.rule.variation

Content_205_Arg: TypeAlias = int
class Content_205(ContentTable):
    cv_values = {0: "Empty", 1: "Occupied", 2: "Unknown", 3: "Invalid"}

RuleContent_205_Arg: TypeAlias = Content_205_Arg
class RuleContent_205(RuleContentContextFree):
    cv_content = Content_205

    @property
    def content(self) -> Content_205:
        return self._get_content() # type: ignore

Variation_102_Arg: TypeAlias = RuleContent_205_Arg
class Variation_102(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_205

    @classmethod
    def create(cls, arg : Variation_102_Arg) -> "Variation_102":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_205:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_205:
        return self.rule.content

RuleVariation_102_Arg: TypeAlias = Variation_102_Arg
class RuleVariation_102(RuleVariationContextFree):
    cv_variation = Variation_102

    @classmethod
    def create(cls, arg : RuleVariation_102_Arg) -> "RuleVariation_102":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_102:
        return self.arg # type: ignore

NonSpare_923_Arg: TypeAlias = RuleVariation_102_Arg
class NonSpare_923(NonSpare):
    cv_name = "EMP"
    cv_title = ""
    cv_rule = RuleVariation_102

    @classmethod
    def create(cls, arg : NonSpare_923_Arg) -> "NonSpare_923":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_102:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_102:
        return self.rule.variation

Item_290_Arg: TypeAlias = NonSpare_923_Arg
class Item_290(Item):
    cv_non_spare = NonSpare_923

    @classmethod
    def create(cls, arg : Item_290_Arg) -> "Item_290":
        return cls._create(arg) # type: ignore

Content_44_Arg: TypeAlias = int
class Content_44(ContentTable):
    cv_values = {0: "Available", 1: "Not available", 2: "Unknown", 3: "Invalid"}

RuleContent_44_Arg: TypeAlias = Content_44_Arg
class RuleContent_44(RuleContentContextFree):
    cv_content = Content_44

    @property
    def content(self) -> Content_44:
        return self._get_content() # type: ignore

Variation_586_Arg: TypeAlias = RuleContent_44_Arg
class Variation_586(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_44

    @classmethod
    def create(cls, arg : Variation_586_Arg) -> "Variation_586":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_44:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_44:
        return self.rule.content

RuleVariation_575_Arg: TypeAlias = Variation_586_Arg
class RuleVariation_575(RuleVariationContextFree):
    cv_variation = Variation_586

    @classmethod
    def create(cls, arg : RuleVariation_575_Arg) -> "RuleVariation_575":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_586:
        return self.arg # type: ignore

NonSpare_643_Arg: TypeAlias = RuleVariation_575_Arg
class NonSpare_643(NonSpare):
    cv_name = "AVL"
    cv_title = ""
    cv_rule = RuleVariation_575

    @classmethod
    def create(cls, arg : NonSpare_643_Arg) -> "NonSpare_643":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_575:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_586:
        return self.rule.variation

Item_92_Arg: TypeAlias = NonSpare_643_Arg
class Item_92(Item):
    cv_non_spare = NonSpare_643

    @classmethod
    def create(cls, arg : Item_92_Arg) -> "Item_92":
        return cls._create(arg) # type: ignore

Variation_1083_Arg_Group = Tuple[Union[RuleVariation_102_Arg, Tuple[Literal["EMP"], RuleVariation_102_Arg]], Union[RuleVariation_575_Arg, Tuple[Literal["AVL"], RuleVariation_575_Arg]], int]
Variation_1083_Arg: TypeAlias = Union[int, Variation_1083_Arg_Group]
class Variation_1083(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_290, 2), (Item_92, 2), (Item_22, 4)]
    cv_items_dict = {"EMP": RuleVariation_102, "AVL": RuleVariation_575}

    @overload
    @classmethod
    def spec(cls, key : Literal["EMP"]) -> RuleVariation_102:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AVL"]) -> RuleVariation_575:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EMP"], Literal["AVL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EMP"]) -> RuleVariation_102:
        ...
    @overload
    def get_item(self, key : Literal["AVL"]) -> RuleVariation_575:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1083_Arg) -> 'Variation_1083':
        return cls._create(arg) # type: ignore

RuleVariation_1041_Arg: TypeAlias = Variation_1083_Arg
class RuleVariation_1041(RuleVariationContextFree):
    cv_variation = Variation_1083

    @classmethod
    def create(cls, arg : RuleVariation_1041_Arg) -> "RuleVariation_1041":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1083:
        return self.arg # type: ignore

NonSpare_1790_Arg: TypeAlias = RuleVariation_1041_Arg
class NonSpare_1790(NonSpare):
    cv_name = "STS"
    cv_title = "Stand Status"
    cv_rule = RuleVariation_1041

    @classmethod
    def create(cls, arg : NonSpare_1790_Arg) -> "NonSpare_1790":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1041:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1083:
        return self.rule.variation

NonSpare_1705_Arg: TypeAlias = RuleVariation_383_Arg
class NonSpare_1705(NonSpare):
    cv_name = "SID"
    cv_title = "Standard Instrument Departure"
    cv_rule = RuleVariation_383

    @classmethod
    def create(cls, arg : NonSpare_1705_Arg) -> "NonSpare_1705":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

NonSpare_1763_Arg: TypeAlias = RuleVariation_383_Arg
class NonSpare_1763(NonSpare):
    cv_name = "STAR"
    cv_title = "Standard Instrument Arrival"
    cv_rule = RuleVariation_383

    @classmethod
    def create(cls, arg : NonSpare_1763_Arg) -> "NonSpare_1763":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

Variation_1482_Arg = TypedDict('Variation_1482_Arg', {
    "IFI": NonSpare_1108_Arg,
    "RVP": NonSpare_1626_Arg,
    "RDS": NonSpare_1554_Arg,
    "TOD": NonSpare_1874_Arg,
    "AST": NonSpare_633_Arg,
    "STS": NonSpare_1790_Arg,
    "SID": NonSpare_1705_Arg,
    "STAR": NonSpare_1763_Arg,
}, total=False)
class Variation_1482(Compound):
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1108, NonSpare_1626, NonSpare_1554, NonSpare_1874, NonSpare_633, NonSpare_1790, NonSpare_1705, NonSpare_1763]
    cv_items_dict = {"IFI": NonSpare_1108, "RVP": NonSpare_1626, "RDS": NonSpare_1554, "TOD": NonSpare_1874, "AST": NonSpare_633, "STS": NonSpare_1790, "SID": NonSpare_1705, "STAR": NonSpare_1763}

    @overload
    @classmethod
    def spec(cls, key : Literal["IFI"]) -> NonSpare_1108:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RVP"]) -> NonSpare_1626:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RDS"]) -> NonSpare_1554:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOD"]) -> NonSpare_1874:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AST"]) -> NonSpare_633:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STS"]) -> NonSpare_1790:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SID"]) -> NonSpare_1705:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAR"]) -> NonSpare_1763:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["IFI"], Literal["RVP"], Literal["RDS"], Literal["TOD"], Literal["AST"], Literal["STS"], Literal["SID"], Literal["STAR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["IFI"]) -> Optional[NonSpare_1108]:
        ...
    @overload
    def get_item(self, key : Literal["RVP"]) -> Optional[NonSpare_1626]:
        ...
    @overload
    def get_item(self, key : Literal["RDS"]) -> Optional[NonSpare_1554]:
        ...
    @overload
    def get_item(self, key : Literal["TOD"]) -> Optional[NonSpare_1874]:
        ...
    @overload
    def get_item(self, key : Literal["AST"]) -> Optional[NonSpare_633]:
        ...
    @overload
    def get_item(self, key : Literal["STS"]) -> Optional[NonSpare_1790]:
        ...
    @overload
    def get_item(self, key : Literal["SID"]) -> Optional[NonSpare_1705]:
        ...
    @overload
    def get_item(self, key : Literal["STAR"]) -> Optional[NonSpare_1763]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["IFI"], val : NonSpare_1108_Arg) -> "Variation_1482":
        ...
    @overload
    def set_item(self, key : Literal["RVP"], val : NonSpare_1626_Arg) -> "Variation_1482":
        ...
    @overload
    def set_item(self, key : Literal["RDS"], val : NonSpare_1554_Arg) -> "Variation_1482":
        ...
    @overload
    def set_item(self, key : Literal["TOD"], val : NonSpare_1874_Arg) -> "Variation_1482":
        ...
    @overload
    def set_item(self, key : Literal["AST"], val : NonSpare_633_Arg) -> "Variation_1482":
        ...
    @overload
    def set_item(self, key : Literal["STS"], val : NonSpare_1790_Arg) -> "Variation_1482":
        ...
    @overload
    def set_item(self, key : Literal["SID"], val : NonSpare_1705_Arg) -> "Variation_1482":
        ...
    @overload
    def set_item(self, key : Literal["STAR"], val : NonSpare_1763_Arg) -> "Variation_1482":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["IFI"]) -> "Variation_1482":
        ...
    @overload
    def del_item(self, key : Literal["RVP"]) -> "Variation_1482":
        ...
    @overload
    def del_item(self, key : Literal["RDS"]) -> "Variation_1482":
        ...
    @overload
    def del_item(self, key : Literal["TOD"]) -> "Variation_1482":
        ...
    @overload
    def del_item(self, key : Literal["AST"]) -> "Variation_1482":
        ...
    @overload
    def del_item(self, key : Literal["STS"]) -> "Variation_1482":
        ...
    @overload
    def del_item(self, key : Literal["SID"]) -> "Variation_1482":
        ...
    @overload
    def del_item(self, key : Literal["STAR"]) -> "Variation_1482":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1482_Arg) -> 'Variation_1482':
        return cls._create(arg) # type: ignore

RuleVariation_1405_Arg: TypeAlias = Variation_1482_Arg
class RuleVariation_1405(RuleVariationContextFree):
    cv_variation = Variation_1482

    @classmethod
    def create(cls, arg : RuleVariation_1405_Arg) -> "RuleVariation_1405":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1482:
        return self.arg # type: ignore

NonSpare_514_Arg: TypeAlias = RuleVariation_1405_Arg
class NonSpare_514(NonSpare):
    cv_name = "500"
    cv_title = "Supplementary Flight Data"
    cv_rule = RuleVariation_1405

    @classmethod
    def create(cls, arg : NonSpare_514_Arg) -> "NonSpare_514":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1405:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1482:
        return self.rule.variation

class UapItem_513(UapItem):
    cv_non_spare = NonSpare_514

Record_49_Arg = TypedDict('Record_49_Arg', {
    "010": NonSpare_49_Arg,
    "015": NonSpare_69_Arg,
    "018": NonSpare_73_Arg,
    "035": NonSpare_129_Arg,
    "020": NonSpare_91_Arg,
    "040": NonSpare_148_Arg,
    "050": NonSpare_166_Arg,
    "060": NonSpare_197_Arg,
    "400": NonSpare_491_Arg,
    "410": NonSpare_497_Arg,
    "420": NonSpare_499_Arg,
    "440": NonSpare_504_Arg,
    "450": NonSpare_505_Arg,
    "480": NonSpare_508_Arg,
    "490": NonSpare_509_Arg,
    "430": NonSpare_502_Arg,
    "435": NonSpare_503_Arg,
    "460": NonSpare_506_Arg,
    "500": NonSpare_514_Arg,
    "RE": NonSpare_1558_Arg,
}, total=False)
class Record_49(Record):
    cv_fspec_max_bytes = 3
    cv_items_list = [UapItem_49, UapItem_69, UapItem_73, UapItem_129, UapItem_91, UapItem_148, UapItem_166, UapItem_197, UapItem_490, UapItem_496, UapItem_498, UapItem_503, UapItem_504, UapItem_507, UapItem_508, UapItem_501, UapItem_502, UapItem_505, UapItem_513, UapItem_544, UapItem_542]
    cv_items_dict = {"010": NonSpare_49, "015": NonSpare_69, "018": NonSpare_73, "035": NonSpare_129, "020": NonSpare_91, "040": NonSpare_148, "050": NonSpare_166, "060": NonSpare_197, "400": NonSpare_491, "410": NonSpare_497, "420": NonSpare_499, "440": NonSpare_504, "450": NonSpare_505, "480": NonSpare_508, "490": NonSpare_509, "430": NonSpare_502, "435": NonSpare_503, "460": NonSpare_506, "500": NonSpare_514, "RE": NonSpare_1558}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_49:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_69:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["018"]) -> NonSpare_73:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["035"]) -> NonSpare_129:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_91:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_148:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_166:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_197:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_491:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["410"]) -> NonSpare_497:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["420"]) -> NonSpare_499:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["440"]) -> NonSpare_504:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["450"]) -> NonSpare_505:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["480"]) -> NonSpare_508:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["490"]) -> NonSpare_509:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["430"]) -> NonSpare_502:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["435"]) -> NonSpare_503:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["460"]) -> NonSpare_506:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_514:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["018"], Literal["035"], Literal["020"], Literal["040"], Literal["050"], Literal["060"], Literal["400"], Literal["410"], Literal["420"], Literal["440"], Literal["450"], Literal["480"], Literal["490"], Literal["430"], Literal["435"], Literal["460"], Literal["500"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_49]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_69]:
        ...
    @overload
    def get_item(self, key : Literal["018"]) -> Optional[NonSpare_73]:
        ...
    @overload
    def get_item(self, key : Literal["035"]) -> Optional[NonSpare_129]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_91]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_148]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_166]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_197]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_491]:
        ...
    @overload
    def get_item(self, key : Literal["410"]) -> Optional[NonSpare_497]:
        ...
    @overload
    def get_item(self, key : Literal["420"]) -> Optional[NonSpare_499]:
        ...
    @overload
    def get_item(self, key : Literal["440"]) -> Optional[NonSpare_504]:
        ...
    @overload
    def get_item(self, key : Literal["450"]) -> Optional[NonSpare_505]:
        ...
    @overload
    def get_item(self, key : Literal["480"]) -> Optional[NonSpare_508]:
        ...
    @overload
    def get_item(self, key : Literal["490"]) -> Optional[NonSpare_509]:
        ...
    @overload
    def get_item(self, key : Literal["430"]) -> Optional[NonSpare_502]:
        ...
    @overload
    def get_item(self, key : Literal["435"]) -> Optional[NonSpare_503]:
        ...
    @overload
    def get_item(self, key : Literal["460"]) -> Optional[NonSpare_506]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_514]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_49_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_69_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["018"], val : NonSpare_73_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["035"], val : NonSpare_129_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_91_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_148_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_166_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_197_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_491_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["410"], val : NonSpare_497_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["420"], val : NonSpare_499_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["440"], val : NonSpare_504_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["450"], val : NonSpare_505_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["480"], val : NonSpare_508_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["490"], val : NonSpare_509_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["430"], val : NonSpare_502_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["435"], val : NonSpare_503_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["460"], val : NonSpare_506_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_514_Arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_49':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["018"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["035"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["410"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["420"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["440"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["450"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["480"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["490"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["430"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["435"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["460"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_49':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_49_Arg) -> 'Record_49':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_49", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_45_Arg: TypeAlias = Record_49
class Uap_45(UapSingle):
    cv_record = Record_49

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_49]]:
        return cls._parse(bs)

class Asterix_37(AstCat):
    cv_category = 32
    cv_edition = (1, 1)
    cv_uap = Uap_45

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_45_Arg]) -> "Asterix_37":
        return cls._create(records) # type: ignore

NonSpare_34_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_34(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_34_Arg) -> "NonSpare_34":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_34(UapItem):
    cv_non_spare = NonSpare_34

Content_584_Arg: TypeAlias = int
class Content_584(ContentTable):
    cv_values = {1: "North marker message", 2: "Sector crossing message", 3: "Geographical filtering message", 4: "Jamming strobe message"}

RuleContent_584_Arg: TypeAlias = Content_584_Arg
class RuleContent_584(RuleContentContextFree):
    cv_content = Content_584

    @property
    def content(self) -> Content_584:
        return self._get_content() # type: ignore

Variation_185_Arg: TypeAlias = RuleContent_584_Arg
class Variation_185(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_584

    @classmethod
    def create(cls, arg : Variation_185_Arg) -> "Variation_185":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_584:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_584:
        return self.rule.content

RuleVariation_178_Arg: TypeAlias = Variation_185_Arg
class RuleVariation_178(RuleVariationContextFree):
    cv_variation = Variation_185

    @classmethod
    def create(cls, arg : RuleVariation_178_Arg) -> "RuleVariation_178":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_185:
        return self.arg # type: ignore

NonSpare_3_Arg: TypeAlias = RuleVariation_178_Arg
class NonSpare_3(NonSpare):
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule = RuleVariation_178

    @classmethod
    def create(cls, arg : NonSpare_3_Arg) -> "NonSpare_3":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_178:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_185:
        return self.rule.variation

class UapItem_3(UapItem):
    cv_non_spare = NonSpare_3

NonSpare_106_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_106(NonSpare):
    cv_name = "030"
    cv_title = "Time of Day"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_106_Arg) -> "NonSpare_106":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_106(UapItem):
    cv_non_spare = NonSpare_106

NonSpare_81_Arg: TypeAlias = RuleVariation_234_Arg
class NonSpare_81(NonSpare):
    cv_name = "020"
    cv_title = "Sector Number"
    cv_rule = RuleVariation_234

    @classmethod
    def create(cls, arg : NonSpare_81_Arg) -> "NonSpare_81":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_234:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_241:
        return self.rule.variation

class UapItem_81(UapItem):
    cv_non_spare = NonSpare_81

NonSpare_151_Arg: TypeAlias = RuleVariation_325_Arg
class NonSpare_151(NonSpare):
    cv_name = "041"
    cv_title = "Antenna Rotation Speed"
    cv_rule = RuleVariation_325

    @classmethod
    def create(cls, arg : NonSpare_151_Arg) -> "NonSpare_151":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_325:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_332:
        return self.rule.variation

class UapItem_151(UapItem):
    cv_non_spare = NonSpare_151

Content_460_Arg: TypeAlias = int
class Content_460(ContentTable):
    cv_values = {0: "System is released for operational use", 1: "Operational use of System is inhibited, i.e. the data shall be discarded by an operational SDPS"}

RuleContent_460_Arg: TypeAlias = Content_460_Arg
class RuleContent_460(RuleContentContextFree):
    cv_content = Content_460

    @property
    def content(self) -> Content_460:
        return self._get_content() # type: ignore

Variation_77_Arg: TypeAlias = RuleContent_460_Arg
class Variation_77(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_460

    @classmethod
    def create(cls, arg : Variation_77_Arg) -> "Variation_77":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_460:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_460:
        return self.rule.content

RuleVariation_77_Arg: TypeAlias = Variation_77_Arg
class RuleVariation_77(RuleVariationContextFree):
    cv_variation = Variation_77

    @classmethod
    def create(cls, arg : RuleVariation_77_Arg) -> "RuleVariation_77":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_77:
        return self.arg # type: ignore

NonSpare_1359_Arg: TypeAlias = RuleVariation_77_Arg
class NonSpare_1359(NonSpare):
    cv_name = "NOGO"
    cv_title = "Operational Release Status of the System"
    cv_rule = RuleVariation_77

    @classmethod
    def create(cls, arg : NonSpare_1359_Arg) -> "NonSpare_1359":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_77:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_77:
        return self.rule.variation

Item_625_Arg: TypeAlias = NonSpare_1359_Arg
class Item_625(Item):
    cv_non_spare = NonSpare_1359

    @classmethod
    def create(cls, arg : Item_625_Arg) -> "Item_625":
        return cls._create(arg) # type: ignore

Content_432_Arg: TypeAlias = int
class Content_432(ContentTable):
    cv_values = {0: "RDPC-1 selected", 1: "RDPC-2 selected"}

RuleContent_432_Arg: TypeAlias = Content_432_Arg
class RuleContent_432(RuleContentContextFree):
    cv_content = Content_432

    @property
    def content(self) -> Content_432:
        return self._get_content() # type: ignore

Variation_448_Arg: TypeAlias = RuleContent_432_Arg
class Variation_448(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_432

    @classmethod
    def create(cls, arg : Variation_448_Arg) -> "Variation_448":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_432:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_432:
        return self.rule.content

RuleVariation_437_Arg: TypeAlias = Variation_448_Arg
class RuleVariation_437(RuleVariationContextFree):
    cv_variation = Variation_448

    @classmethod
    def create(cls, arg : RuleVariation_437_Arg) -> "RuleVariation_437":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_448:
        return self.arg # type: ignore

NonSpare_1551_Arg: TypeAlias = RuleVariation_437_Arg
class NonSpare_1551(NonSpare):
    cv_name = "RDPC"
    cv_title = "Radar Data Processor Chain Selection Status"
    cv_rule = RuleVariation_437

    @classmethod
    def create(cls, arg : NonSpare_1551_Arg) -> "NonSpare_1551":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_437:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_448:
        return self.rule.variation

Item_785_Arg: TypeAlias = NonSpare_1551_Arg
class Item_785(Item):
    cv_non_spare = NonSpare_1551

    @classmethod
    def create(cls, arg : Item_785_Arg) -> "Item_785":
        return cls._create(arg) # type: ignore

Content_170_Arg: TypeAlias = int
class Content_170(ContentTable):
    cv_values = {0: "Default situation", 1: "Reset of RDPC"}

RuleContent_170_Arg: TypeAlias = Content_170_Arg
class RuleContent_170(RuleContentContextFree):
    cv_content = Content_170

    @property
    def content(self) -> Content_170:
        return self._get_content() # type: ignore

Variation_524_Arg: TypeAlias = RuleContent_170_Arg
class Variation_524(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_170

    @classmethod
    def create(cls, arg : Variation_524_Arg) -> "Variation_524":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_170:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_170:
        return self.rule.content

RuleVariation_513_Arg: TypeAlias = Variation_524_Arg
class RuleVariation_513(RuleVariationContextFree):
    cv_variation = Variation_524

    @classmethod
    def create(cls, arg : RuleVariation_513_Arg) -> "RuleVariation_513":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_524:
        return self.arg # type: ignore

NonSpare_1552_Arg: TypeAlias = RuleVariation_513_Arg
class NonSpare_1552(NonSpare):
    cv_name = "RDPR"
    cv_title = "Event to Signal a Reset/restart of the Selected Radar Data Processor Chain, I.e. Expect a New Assignment of Track Numbers"
    cv_rule = RuleVariation_513

    @classmethod
    def create(cls, arg : NonSpare_1552_Arg) -> "NonSpare_1552":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_513:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_524:
        return self.rule.variation

Item_786_Arg: TypeAlias = NonSpare_1552_Arg
class Item_786(Item):
    cv_non_spare = NonSpare_1552

    @classmethod
    def create(cls, arg : Item_786_Arg) -> "Item_786":
        return cls._create(arg) # type: ignore

Content_197_Arg: TypeAlias = int
class Content_197(ContentTable):
    cv_values = {0: "Default, no overload", 1: "Overload in RDP"}

RuleContent_197_Arg: TypeAlias = Content_197_Arg
class RuleContent_197(RuleContentContextFree):
    cv_content = Content_197

    @property
    def content(self) -> Content_197:
        return self._get_content() # type: ignore

Variation_635_Arg: TypeAlias = RuleContent_197_Arg
class Variation_635(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_197

    @classmethod
    def create(cls, arg : Variation_635_Arg) -> "Variation_635":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_197:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_197:
        return self.rule.content

RuleVariation_624_Arg: TypeAlias = Variation_635_Arg
class RuleVariation_624(RuleVariationContextFree):
    cv_variation = Variation_635

    @classmethod
    def create(cls, arg : RuleVariation_624_Arg) -> "RuleVariation_624":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_635:
        return self.arg # type: ignore

NonSpare_1402_Arg: TypeAlias = RuleVariation_624_Arg
class NonSpare_1402(NonSpare):
    cv_name = "OVLRDP"
    cv_title = "Radar Data Processor Overload Indicator"
    cv_rule = RuleVariation_624

    @classmethod
    def create(cls, arg : NonSpare_1402_Arg) -> "NonSpare_1402":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_624:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_635:
        return self.rule.variation

Item_666_Arg: TypeAlias = NonSpare_1402_Arg
class Item_666(Item):
    cv_non_spare = NonSpare_1402

    @classmethod
    def create(cls, arg : Item_666_Arg) -> "Item_666":
        return cls._create(arg) # type: ignore

Variation_717_Arg: TypeAlias = RuleContent_198_Arg
class Variation_717(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_198

    @classmethod
    def create(cls, arg : Variation_717_Arg) -> "Variation_717":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_198:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_198:
        return self.rule.content

RuleVariation_706_Arg: TypeAlias = Variation_717_Arg
class RuleVariation_706(RuleVariationContextFree):
    cv_variation = Variation_717

    @classmethod
    def create(cls, arg : RuleVariation_706_Arg) -> "RuleVariation_706":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_717:
        return self.arg # type: ignore

NonSpare_1405_Arg: TypeAlias = RuleVariation_706_Arg
class NonSpare_1405(NonSpare):
    cv_name = "OVLXMT"
    cv_title = "Transmission Subsystem Overload Status"
    cv_rule = RuleVariation_706

    @classmethod
    def create(cls, arg : NonSpare_1405_Arg) -> "NonSpare_1405":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_706:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_717:
        return self.rule.variation

Item_669_Arg: TypeAlias = NonSpare_1405_Arg
class Item_669(Item):
    cv_non_spare = NonSpare_1405

    @classmethod
    def create(cls, arg : Item_669_Arg) -> "Item_669":
        return cls._create(arg) # type: ignore

Content_293_Arg: TypeAlias = int
class Content_293(ContentTable):
    cv_values = {0: "Monitoring system connected", 1: "Monitoring system disconnected"}

RuleContent_293_Arg: TypeAlias = Content_293_Arg
class RuleContent_293(RuleContentContextFree):
    cv_content = Content_293

    @property
    def content(self) -> Content_293:
        return self._get_content() # type: ignore

Variation_859_Arg: TypeAlias = RuleContent_293_Arg
class Variation_859(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_293

    @classmethod
    def create(cls, arg : Variation_859_Arg) -> "Variation_859":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_293:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_293:
        return self.rule.content

RuleVariation_829_Arg: TypeAlias = Variation_859_Arg
class RuleVariation_829(RuleVariationContextFree):
    cv_variation = Variation_859

    @classmethod
    def create(cls, arg : RuleVariation_829_Arg) -> "RuleVariation_829":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_859:
        return self.arg # type: ignore

NonSpare_1318_Arg: TypeAlias = RuleVariation_829_Arg
class NonSpare_1318(NonSpare):
    cv_name = "MSC"
    cv_title = "Monitoring System Connected Status"
    cv_rule = RuleVariation_829

    @classmethod
    def create(cls, arg : NonSpare_1318_Arg) -> "NonSpare_1318":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_829:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_859:
        return self.rule.variation

Item_588_Arg: TypeAlias = NonSpare_1318_Arg
class Item_588(Item):
    cv_non_spare = NonSpare_1318

    @classmethod
    def create(cls, arg : Item_588_Arg) -> "Item_588":
        return cls._create(arg) # type: ignore

Variation_955_Arg: TypeAlias = RuleContent_557_Arg
class Variation_955(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_557

    @classmethod
    def create(cls, arg : Variation_955_Arg) -> "Variation_955":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_557:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_557:
        return self.rule.content

RuleVariation_925_Arg: TypeAlias = Variation_955_Arg
class RuleVariation_925(RuleVariationContextFree):
    cv_variation = Variation_955

    @classmethod
    def create(cls, arg : RuleVariation_925_Arg) -> "RuleVariation_925":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_955:
        return self.arg # type: ignore

NonSpare_1934_Arg: TypeAlias = RuleVariation_925_Arg
class NonSpare_1934(NonSpare):
    cv_name = "TSV"
    cv_title = "Time Source Validity"
    cv_rule = RuleVariation_925

    @classmethod
    def create(cls, arg : NonSpare_1934_Arg) -> "NonSpare_1934":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_925:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_955:
        return self.rule.variation

Item_1057_Arg: TypeAlias = NonSpare_1934_Arg
class Item_1057(Item):
    cv_non_spare = NonSpare_1934

    @classmethod
    def create(cls, arg : Item_1057_Arg) -> "Item_1057":
        return cls._create(arg) # type: ignore

Variation_1146_Arg_Group = Tuple[Union[RuleVariation_77_Arg, Tuple[Literal["NOGO"], RuleVariation_77_Arg]], Union[RuleVariation_437_Arg, Tuple[Literal["RDPC"], RuleVariation_437_Arg]], Union[RuleVariation_513_Arg, Tuple[Literal["RDPR"], RuleVariation_513_Arg]], Union[RuleVariation_624_Arg, Tuple[Literal["OVLRDP"], RuleVariation_624_Arg]], Union[RuleVariation_706_Arg, Tuple[Literal["OVLXMT"], RuleVariation_706_Arg]], Union[RuleVariation_829_Arg, Tuple[Literal["MSC"], RuleVariation_829_Arg]], Union[RuleVariation_925_Arg, Tuple[Literal["TSV"], RuleVariation_925_Arg]], int]
Variation_1146_Arg: TypeAlias = Union[int, Variation_1146_Arg_Group]
class Variation_1146(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_625, 1), (Item_785, 1), (Item_786, 1), (Item_666, 1), (Item_669, 1), (Item_588, 1), (Item_1057, 1), (Item_29, 1)]
    cv_items_dict = {"NOGO": RuleVariation_77, "RDPC": RuleVariation_437, "RDPR": RuleVariation_513, "OVLRDP": RuleVariation_624, "OVLXMT": RuleVariation_706, "MSC": RuleVariation_829, "TSV": RuleVariation_925}

    @overload
    @classmethod
    def spec(cls, key : Literal["NOGO"]) -> RuleVariation_77:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RDPC"]) -> RuleVariation_437:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RDPR"]) -> RuleVariation_513:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVLRDP"]) -> RuleVariation_624:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVLXMT"]) -> RuleVariation_706:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSC"]) -> RuleVariation_829:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TSV"]) -> RuleVariation_925:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["NOGO"], Literal["RDPC"], Literal["RDPR"], Literal["OVLRDP"], Literal["OVLXMT"], Literal["MSC"], Literal["TSV"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["NOGO"]) -> RuleVariation_77:
        ...
    @overload
    def get_item(self, key : Literal["RDPC"]) -> RuleVariation_437:
        ...
    @overload
    def get_item(self, key : Literal["RDPR"]) -> RuleVariation_513:
        ...
    @overload
    def get_item(self, key : Literal["OVLRDP"]) -> RuleVariation_624:
        ...
    @overload
    def get_item(self, key : Literal["OVLXMT"]) -> RuleVariation_706:
        ...
    @overload
    def get_item(self, key : Literal["MSC"]) -> RuleVariation_829:
        ...
    @overload
    def get_item(self, key : Literal["TSV"]) -> RuleVariation_925:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1146_Arg) -> 'Variation_1146':
        return cls._create(arg) # type: ignore

RuleVariation_1100_Arg: TypeAlias = Variation_1146_Arg
class RuleVariation_1100(RuleVariationContextFree):
    cv_variation = Variation_1146

    @classmethod
    def create(cls, arg : RuleVariation_1100_Arg) -> "RuleVariation_1100":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1146:
        return self.arg # type: ignore

NonSpare_775_Arg: TypeAlias = RuleVariation_1100_Arg
class NonSpare_775(NonSpare):
    cv_name = "COM"
    cv_title = "Common Part"
    cv_rule = RuleVariation_1100

    @classmethod
    def create(cls, arg : NonSpare_775_Arg) -> "NonSpare_775":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1100:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1146:
        return self.rule.variation

Content_33_Arg: TypeAlias = int
class Content_33(ContentTable):
    cv_values = {0: "Antenna 1", 1: "Antenna 2"}

RuleContent_33_Arg: TypeAlias = Content_33_Arg
class RuleContent_33(RuleContentContextFree):
    cv_content = Content_33

    @property
    def content(self) -> Content_33:
        return self._get_content() # type: ignore

Variation_12_Arg: TypeAlias = RuleContent_33_Arg
class Variation_12(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_33

    @classmethod
    def create(cls, arg : Variation_12_Arg) -> "Variation_12":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_33:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_33:
        return self.rule.content

RuleVariation_12_Arg: TypeAlias = Variation_12_Arg
class RuleVariation_12(RuleVariationContextFree):
    cv_variation = Variation_12

    @classmethod
    def create(cls, arg : RuleVariation_12_Arg) -> "RuleVariation_12":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_12:
        return self.arg # type: ignore

NonSpare_607_Arg: TypeAlias = RuleVariation_12_Arg
class NonSpare_607(NonSpare):
    cv_name = "ANT"
    cv_title = "Selected Antenna"
    cv_rule = RuleVariation_12

    @classmethod
    def create(cls, arg : NonSpare_607_Arg) -> "NonSpare_607":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_12:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_12:
        return self.rule.variation

Item_75_Arg: TypeAlias = NonSpare_607_Arg
class Item_75(Item):
    cv_non_spare = NonSpare_607

    @classmethod
    def create(cls, arg : Item_75_Arg) -> "Item_75":
        return cls._create(arg) # type: ignore

Content_332_Arg: TypeAlias = int
class Content_332(ContentTable):
    cv_values = {0: "No channel selected", 1: "Channel A only selected", 2: "Channel B only selected", 3: "Diversity mode ; Channel A and B selected"}

RuleContent_332_Arg: TypeAlias = Content_332_Arg
class RuleContent_332(RuleContentContextFree):
    cv_content = Content_332

    @property
    def content(self) -> Content_332:
        return self._get_content() # type: ignore

Variation_470_Arg: TypeAlias = RuleContent_332_Arg
class Variation_470(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_332

    @classmethod
    def create(cls, arg : Variation_470_Arg) -> "Variation_470":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_332:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_332:
        return self.rule.content

RuleVariation_459_Arg: TypeAlias = Variation_470_Arg
class RuleVariation_459(RuleVariationContextFree):
    cv_variation = Variation_470

    @classmethod
    def create(cls, arg : RuleVariation_459_Arg) -> "RuleVariation_459":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_470:
        return self.arg # type: ignore

NonSpare_723_Arg: TypeAlias = RuleVariation_459_Arg
class NonSpare_723(NonSpare):
    cv_name = "CHAB"
    cv_title = "Channel A/B Selection Status"
    cv_rule = RuleVariation_459

    @classmethod
    def create(cls, arg : NonSpare_723_Arg) -> "NonSpare_723":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_459:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_470:
        return self.rule.variation

Item_151_Arg: TypeAlias = NonSpare_723_Arg
class Item_151(Item):
    cv_non_spare = NonSpare_723

    @classmethod
    def create(cls, arg : Item_151_Arg) -> "Item_151":
        return cls._create(arg) # type: ignore

Variation_651_Arg: TypeAlias = RuleContent_367_Arg
class Variation_651(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_367

    @classmethod
    def create(cls, arg : Variation_651_Arg) -> "Variation_651":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_367:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_367:
        return self.rule.content

RuleVariation_640_Arg: TypeAlias = Variation_651_Arg
class RuleVariation_640(RuleVariationContextFree):
    cv_variation = Variation_651

    @classmethod
    def create(cls, arg : RuleVariation_640_Arg) -> "RuleVariation_640":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_651:
        return self.arg # type: ignore

NonSpare_1399_Arg: TypeAlias = RuleVariation_640_Arg
class NonSpare_1399(NonSpare):
    cv_name = "OVL"
    cv_title = "Overload Condition"
    cv_rule = RuleVariation_640

    @classmethod
    def create(cls, arg : NonSpare_1399_Arg) -> "NonSpare_1399":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_640:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_651:
        return self.rule.variation

Item_663_Arg: TypeAlias = NonSpare_1399_Arg
class Item_663(Item):
    cv_non_spare = NonSpare_1399

    @classmethod
    def create(cls, arg : Item_663_Arg) -> "Item_663":
        return cls._create(arg) # type: ignore

Variation_732_Arg: TypeAlias = RuleContent_293_Arg
class Variation_732(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_293

    @classmethod
    def create(cls, arg : Variation_732_Arg) -> "Variation_732":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_293:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_293:
        return self.rule.content

RuleVariation_721_Arg: TypeAlias = Variation_732_Arg
class RuleVariation_721(RuleVariationContextFree):
    cv_variation = Variation_732

    @classmethod
    def create(cls, arg : RuleVariation_721_Arg) -> "RuleVariation_721":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_732:
        return self.arg # type: ignore

NonSpare_1317_Arg: TypeAlias = RuleVariation_721_Arg
class NonSpare_1317(NonSpare):
    cv_name = "MSC"
    cv_title = "Monitoring System Connected Status"
    cv_rule = RuleVariation_721

    @classmethod
    def create(cls, arg : NonSpare_1317_Arg) -> "NonSpare_1317":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_721:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_732:
        return self.rule.variation

Item_587_Arg: TypeAlias = NonSpare_1317_Arg
class Item_587(Item):
    cv_non_spare = NonSpare_1317

    @classmethod
    def create(cls, arg : Item_587_Arg) -> "Item_587":
        return cls._create(arg) # type: ignore

Variation_1046_Arg_Group = Tuple[Union[RuleVariation_12_Arg, Tuple[Literal["ANT"], RuleVariation_12_Arg]], Union[RuleVariation_459_Arg, Tuple[Literal["CHAB"], RuleVariation_459_Arg]], Union[RuleVariation_640_Arg, Tuple[Literal["OVL"], RuleVariation_640_Arg]], Union[RuleVariation_721_Arg, Tuple[Literal["MSC"], RuleVariation_721_Arg]], int]
Variation_1046_Arg: TypeAlias = Union[int, Variation_1046_Arg_Group]
class Variation_1046(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_75, 1), (Item_151, 2), (Item_663, 1), (Item_587, 1), (Item_25, 3)]
    cv_items_dict = {"ANT": RuleVariation_12, "CHAB": RuleVariation_459, "OVL": RuleVariation_640, "MSC": RuleVariation_721}

    @overload
    @classmethod
    def spec(cls, key : Literal["ANT"]) -> RuleVariation_12:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CHAB"]) -> RuleVariation_459:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVL"]) -> RuleVariation_640:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSC"]) -> RuleVariation_721:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ANT"], Literal["CHAB"], Literal["OVL"], Literal["MSC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ANT"]) -> RuleVariation_12:
        ...
    @overload
    def get_item(self, key : Literal["CHAB"]) -> RuleVariation_459:
        ...
    @overload
    def get_item(self, key : Literal["OVL"]) -> RuleVariation_640:
        ...
    @overload
    def get_item(self, key : Literal["MSC"]) -> RuleVariation_721:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1046_Arg) -> 'Variation_1046':
        return cls._create(arg) # type: ignore

RuleVariation_1013_Arg: TypeAlias = Variation_1046_Arg
class RuleVariation_1013(RuleVariationContextFree):
    cv_variation = Variation_1046

    @classmethod
    def create(cls, arg : RuleVariation_1013_Arg) -> "RuleVariation_1013":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1046:
        return self.arg # type: ignore

NonSpare_1469_Arg: TypeAlias = RuleVariation_1013_Arg
class NonSpare_1469(NonSpare):
    cv_name = "PSR"
    cv_title = "Specific Status Information for a PSR Sensor"
    cv_rule = RuleVariation_1013

    @classmethod
    def create(cls, arg : NonSpare_1469_Arg) -> "NonSpare_1469":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1013:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1046:
        return self.rule.variation

Content_334_Arg: TypeAlias = int
class Content_334(ContentTable):
    cv_values = {0: "No channel selected", 1: "Channel A only selected", 2: "Channel B only selected", 3: "Invalid combination"}

RuleContent_334_Arg: TypeAlias = Content_334_Arg
class RuleContent_334(RuleContentContextFree):
    cv_content = Content_334

    @property
    def content(self) -> Content_334:
        return self._get_content() # type: ignore

Variation_472_Arg: TypeAlias = RuleContent_334_Arg
class Variation_472(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_334

    @classmethod
    def create(cls, arg : Variation_472_Arg) -> "Variation_472":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_334:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_334:
        return self.rule.content

RuleVariation_461_Arg: TypeAlias = Variation_472_Arg
class RuleVariation_461(RuleVariationContextFree):
    cv_variation = Variation_472

    @classmethod
    def create(cls, arg : RuleVariation_461_Arg) -> "RuleVariation_461":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_472:
        return self.arg # type: ignore

NonSpare_725_Arg: TypeAlias = RuleVariation_461_Arg
class NonSpare_725(NonSpare):
    cv_name = "CHAB"
    cv_title = "Channel A/B Selection Status"
    cv_rule = RuleVariation_461

    @classmethod
    def create(cls, arg : NonSpare_725_Arg) -> "NonSpare_725":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_461:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_472:
        return self.rule.variation

Item_153_Arg: TypeAlias = NonSpare_725_Arg
class Item_153(Item):
    cv_non_spare = NonSpare_725

    @classmethod
    def create(cls, arg : Item_153_Arg) -> "Item_153":
        return cls._create(arg) # type: ignore

NonSpare_1319_Arg: TypeAlias = RuleVariation_721_Arg
class NonSpare_1319(NonSpare):
    cv_name = "MSC"
    cv_title = "Monitoring System Connected Status:"
    cv_rule = RuleVariation_721

    @classmethod
    def create(cls, arg : NonSpare_1319_Arg) -> "NonSpare_1319":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_721:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_732:
        return self.rule.variation

Item_589_Arg: TypeAlias = NonSpare_1319_Arg
class Item_589(Item):
    cv_non_spare = NonSpare_1319

    @classmethod
    def create(cls, arg : Item_589_Arg) -> "Item_589":
        return cls._create(arg) # type: ignore

Variation_1048_Arg_Group = Tuple[Union[RuleVariation_12_Arg, Tuple[Literal["ANT"], RuleVariation_12_Arg]], Union[RuleVariation_461_Arg, Tuple[Literal["CHAB"], RuleVariation_461_Arg]], Union[RuleVariation_640_Arg, Tuple[Literal["OVL"], RuleVariation_640_Arg]], Union[RuleVariation_721_Arg, Tuple[Literal["MSC"], RuleVariation_721_Arg]], int]
Variation_1048_Arg: TypeAlias = Union[int, Variation_1048_Arg_Group]
class Variation_1048(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_75, 1), (Item_153, 2), (Item_663, 1), (Item_589, 1), (Item_25, 3)]
    cv_items_dict = {"ANT": RuleVariation_12, "CHAB": RuleVariation_461, "OVL": RuleVariation_640, "MSC": RuleVariation_721}

    @overload
    @classmethod
    def spec(cls, key : Literal["ANT"]) -> RuleVariation_12:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CHAB"]) -> RuleVariation_461:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVL"]) -> RuleVariation_640:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSC"]) -> RuleVariation_721:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ANT"], Literal["CHAB"], Literal["OVL"], Literal["MSC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ANT"]) -> RuleVariation_12:
        ...
    @overload
    def get_item(self, key : Literal["CHAB"]) -> RuleVariation_461:
        ...
    @overload
    def get_item(self, key : Literal["OVL"]) -> RuleVariation_640:
        ...
    @overload
    def get_item(self, key : Literal["MSC"]) -> RuleVariation_721:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1048_Arg) -> 'Variation_1048':
        return cls._create(arg) # type: ignore

RuleVariation_1015_Arg: TypeAlias = Variation_1048_Arg
class RuleVariation_1015(RuleVariationContextFree):
    cv_variation = Variation_1048

    @classmethod
    def create(cls, arg : RuleVariation_1015_Arg) -> "RuleVariation_1015":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1048:
        return self.arg # type: ignore

NonSpare_1756_Arg: TypeAlias = RuleVariation_1015_Arg
class NonSpare_1756(NonSpare):
    cv_name = "SSR"
    cv_title = "Specific Status Information for a SSR Sensor"
    cv_rule = RuleVariation_1015

    @classmethod
    def create(cls, arg : NonSpare_1756_Arg) -> "NonSpare_1756":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1015:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1048:
        return self.rule.variation

Content_333_Arg: TypeAlias = int
class Content_333(ContentTable):
    cv_values = {0: "No channel selected", 1: "Channel A only selected", 2: "Channel B only selected", 3: "Illegal combination"}

RuleContent_333_Arg: TypeAlias = Content_333_Arg
class RuleContent_333(RuleContentContextFree):
    cv_content = Content_333

    @property
    def content(self) -> Content_333:
        return self._get_content() # type: ignore

Variation_471_Arg: TypeAlias = RuleContent_333_Arg
class Variation_471(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_333

    @classmethod
    def create(cls, arg : Variation_471_Arg) -> "Variation_471":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_333:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_333:
        return self.rule.content

RuleVariation_460_Arg: TypeAlias = Variation_471_Arg
class RuleVariation_460(RuleVariationContextFree):
    cv_variation = Variation_471

    @classmethod
    def create(cls, arg : RuleVariation_460_Arg) -> "RuleVariation_460":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_471:
        return self.arg # type: ignore

NonSpare_724_Arg: TypeAlias = RuleVariation_460_Arg
class NonSpare_724(NonSpare):
    cv_name = "CHAB"
    cv_title = "Channel A/B Selection Status"
    cv_rule = RuleVariation_460

    @classmethod
    def create(cls, arg : NonSpare_724_Arg) -> "NonSpare_724":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_460:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_471:
        return self.rule.variation

Item_152_Arg: TypeAlias = NonSpare_724_Arg
class Item_152(Item):
    cv_non_spare = NonSpare_724

    @classmethod
    def create(cls, arg : Item_152_Arg) -> "Item_152":
        return cls._create(arg) # type: ignore

NonSpare_1404_Arg: TypeAlias = RuleVariation_640_Arg
class NonSpare_1404(NonSpare):
    cv_name = "OVLSUR"
    cv_title = "Overload Condition"
    cv_rule = RuleVariation_640

    @classmethod
    def create(cls, arg : NonSpare_1404_Arg) -> "NonSpare_1404":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_640:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_651:
        return self.rule.variation

Item_668_Arg: TypeAlias = NonSpare_1404_Arg
class Item_668(Item):
    cv_non_spare = NonSpare_1404

    @classmethod
    def create(cls, arg : Item_668_Arg) -> "Item_668":
        return cls._create(arg) # type: ignore

Content_54_Arg: TypeAlias = int
class Content_54(ContentTable):
    cv_values = {0: "Channel A in use", 1: "Channel B in use"}

RuleContent_54_Arg: TypeAlias = Content_54_Arg
class RuleContent_54(RuleContentContextFree):
    cv_content = Content_54

    @property
    def content(self) -> Content_54:
        return self._get_content() # type: ignore

Variation_823_Arg: TypeAlias = RuleContent_54_Arg
class Variation_823(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_54

    @classmethod
    def create(cls, arg : Variation_823_Arg) -> "Variation_823":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_54:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_54:
        return self.rule.content

RuleVariation_793_Arg: TypeAlias = Variation_823_Arg
class RuleVariation_793(RuleVariationContextFree):
    cv_variation = Variation_823

    @classmethod
    def create(cls, arg : RuleVariation_793_Arg) -> "RuleVariation_793":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_823:
        return self.arg # type: ignore

NonSpare_1659_Arg: TypeAlias = RuleVariation_793_Arg
class NonSpare_1659(NonSpare):
    cv_name = "SCF"
    cv_title = "Channel A/B Selection Status for Surveillance Co-ordination Function"
    cv_rule = RuleVariation_793

    @classmethod
    def create(cls, arg : NonSpare_1659_Arg) -> "NonSpare_1659":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_793:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_823:
        return self.rule.variation

Item_860_Arg: TypeAlias = NonSpare_1659_Arg
class Item_860(Item):
    cv_non_spare = NonSpare_1659

    @classmethod
    def create(cls, arg : Item_860_Arg) -> "Item_860":
        return cls._create(arg) # type: ignore

Variation_901_Arg: TypeAlias = RuleContent_54_Arg
class Variation_901(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_54

    @classmethod
    def create(cls, arg : Variation_901_Arg) -> "Variation_901":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_54:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_54:
        return self.rule.content

RuleVariation_871_Arg: TypeAlias = Variation_901_Arg
class RuleVariation_871(RuleVariationContextFree):
    cv_variation = Variation_901

    @classmethod
    def create(cls, arg : RuleVariation_871_Arg) -> "RuleVariation_871":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_901:
        return self.arg # type: ignore

NonSpare_879_Arg: TypeAlias = RuleVariation_871_Arg
class NonSpare_879(NonSpare):
    cv_name = "DLF"
    cv_title = "Channel A/B Selection Status for Data Link Function"
    cv_rule = RuleVariation_871

    @classmethod
    def create(cls, arg : NonSpare_879_Arg) -> "NonSpare_879":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_871:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_901:
        return self.rule.variation

Item_262_Arg: TypeAlias = NonSpare_879_Arg
class Item_262(Item):
    cv_non_spare = NonSpare_879

    @classmethod
    def create(cls, arg : Item_262_Arg) -> "Item_262":
        return cls._create(arg) # type: ignore

Variation_980_Arg: TypeAlias = RuleContent_367_Arg
class Variation_980(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_367

    @classmethod
    def create(cls, arg : Variation_980_Arg) -> "Variation_980":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_367:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_367:
        return self.rule.content

RuleVariation_950_Arg: TypeAlias = Variation_980_Arg
class RuleVariation_950(RuleVariationContextFree):
    cv_variation = Variation_980

    @classmethod
    def create(cls, arg : RuleVariation_950_Arg) -> "RuleVariation_950":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_980:
        return self.arg # type: ignore

NonSpare_1403_Arg: TypeAlias = RuleVariation_950_Arg
class NonSpare_1403(NonSpare):
    cv_name = "OVLSCF"
    cv_title = "Overload in Surveillance Co-ordination Function"
    cv_rule = RuleVariation_950

    @classmethod
    def create(cls, arg : NonSpare_1403_Arg) -> "NonSpare_1403":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_950:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_980:
        return self.rule.variation

Item_667_Arg: TypeAlias = NonSpare_1403_Arg
class Item_667(Item):
    cv_non_spare = NonSpare_1403

    @classmethod
    def create(cls, arg : Item_667_Arg) -> "Item_667":
        return cls._create(arg) # type: ignore

Variation_62_Arg: TypeAlias = RuleContent_367_Arg
class Variation_62(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_367

    @classmethod
    def create(cls, arg : Variation_62_Arg) -> "Variation_62":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_367:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_367:
        return self.rule.content

RuleVariation_62_Arg: TypeAlias = Variation_62_Arg
class RuleVariation_62(RuleVariationContextFree):
    cv_variation = Variation_62

    @classmethod
    def create(cls, arg : RuleVariation_62_Arg) -> "RuleVariation_62":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_62:
        return self.arg # type: ignore

NonSpare_1401_Arg: TypeAlias = RuleVariation_62_Arg
class NonSpare_1401(NonSpare):
    cv_name = "OVLDLF"
    cv_title = "Overload in Data Link Function"
    cv_rule = RuleVariation_62

    @classmethod
    def create(cls, arg : NonSpare_1401_Arg) -> "NonSpare_1401":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_62:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_62:
        return self.rule.variation

Item_665_Arg: TypeAlias = NonSpare_1401_Arg
class Item_665(Item):
    cv_non_spare = NonSpare_1401

    @classmethod
    def create(cls, arg : Item_665_Arg) -> "Item_665":
        return cls._create(arg) # type: ignore

Variation_1047_Arg_Group = Tuple[Union[RuleVariation_12_Arg, Tuple[Literal["ANT"], RuleVariation_12_Arg]], Union[RuleVariation_460_Arg, Tuple[Literal["CHAB"], RuleVariation_460_Arg]], Union[RuleVariation_640_Arg, Tuple[Literal["OVLSUR"], RuleVariation_640_Arg]], Union[RuleVariation_721_Arg, Tuple[Literal["MSC"], RuleVariation_721_Arg]], Union[RuleVariation_793_Arg, Tuple[Literal["SCF"], RuleVariation_793_Arg]], Union[RuleVariation_871_Arg, Tuple[Literal["DLF"], RuleVariation_871_Arg]], Union[RuleVariation_950_Arg, Tuple[Literal["OVLSCF"], RuleVariation_950_Arg]], Union[RuleVariation_62_Arg, Tuple[Literal["OVLDLF"], RuleVariation_62_Arg]], int]
Variation_1047_Arg: TypeAlias = Union[int, Variation_1047_Arg_Group]
class Variation_1047(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_75, 1), (Item_152, 2), (Item_668, 1), (Item_589, 1), (Item_860, 1), (Item_262, 1), (Item_667, 1), (Item_665, 1), (Item_10, 7)]
    cv_items_dict = {"ANT": RuleVariation_12, "CHAB": RuleVariation_460, "OVLSUR": RuleVariation_640, "MSC": RuleVariation_721, "SCF": RuleVariation_793, "DLF": RuleVariation_871, "OVLSCF": RuleVariation_950, "OVLDLF": RuleVariation_62}

    @overload
    @classmethod
    def spec(cls, key : Literal["ANT"]) -> RuleVariation_12:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CHAB"]) -> RuleVariation_460:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVLSUR"]) -> RuleVariation_640:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSC"]) -> RuleVariation_721:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SCF"]) -> RuleVariation_793:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DLF"]) -> RuleVariation_871:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVLSCF"]) -> RuleVariation_950:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVLDLF"]) -> RuleVariation_62:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ANT"], Literal["CHAB"], Literal["OVLSUR"], Literal["MSC"], Literal["SCF"], Literal["DLF"], Literal["OVLSCF"], Literal["OVLDLF"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ANT"]) -> RuleVariation_12:
        ...
    @overload
    def get_item(self, key : Literal["CHAB"]) -> RuleVariation_460:
        ...
    @overload
    def get_item(self, key : Literal["OVLSUR"]) -> RuleVariation_640:
        ...
    @overload
    def get_item(self, key : Literal["MSC"]) -> RuleVariation_721:
        ...
    @overload
    def get_item(self, key : Literal["SCF"]) -> RuleVariation_793:
        ...
    @overload
    def get_item(self, key : Literal["DLF"]) -> RuleVariation_871:
        ...
    @overload
    def get_item(self, key : Literal["OVLSCF"]) -> RuleVariation_950:
        ...
    @overload
    def get_item(self, key : Literal["OVLDLF"]) -> RuleVariation_62:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1047_Arg) -> 'Variation_1047':
        return cls._create(arg) # type: ignore

RuleVariation_1014_Arg: TypeAlias = Variation_1047_Arg
class RuleVariation_1014(RuleVariationContextFree):
    cv_variation = Variation_1047

    @classmethod
    def create(cls, arg : RuleVariation_1014_Arg) -> "RuleVariation_1014":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1047:
        return self.arg # type: ignore

NonSpare_1254_Arg: TypeAlias = RuleVariation_1014_Arg
class NonSpare_1254(NonSpare):
    cv_name = "MDS"
    cv_title = "Specific Status Information for a Mode S Sensor"
    cv_rule = RuleVariation_1014

    @classmethod
    def create(cls, arg : NonSpare_1254_Arg) -> "NonSpare_1254":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1014:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1047:
        return self.rule.variation

Variation_1472_Arg = TypedDict('Variation_1472_Arg', {
    "COM": NonSpare_775_Arg,
    "PSR": NonSpare_1469_Arg,
    "SSR": NonSpare_1756_Arg,
    "MDS": NonSpare_1254_Arg,
}, total=False)
class Variation_1472(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_775, None, None, NonSpare_1469, NonSpare_1756, NonSpare_1254]
    cv_items_dict = {"COM": NonSpare_775, "PSR": NonSpare_1469, "SSR": NonSpare_1756, "MDS": NonSpare_1254}

    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> NonSpare_775:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PSR"]) -> NonSpare_1469:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSR"]) -> NonSpare_1756:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDS"]) -> NonSpare_1254:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COM"], Literal["PSR"], Literal["SSR"], Literal["MDS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COM"]) -> Optional[NonSpare_775]:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[NonSpare_1469]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[NonSpare_1756]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[NonSpare_1254]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["COM"], val : NonSpare_775_Arg) -> "Variation_1472":
        ...
    @overload
    def set_item(self, key : Literal["PSR"], val : NonSpare_1469_Arg) -> "Variation_1472":
        ...
    @overload
    def set_item(self, key : Literal["SSR"], val : NonSpare_1756_Arg) -> "Variation_1472":
        ...
    @overload
    def set_item(self, key : Literal["MDS"], val : NonSpare_1254_Arg) -> "Variation_1472":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["COM"]) -> "Variation_1472":
        ...
    @overload
    def del_item(self, key : Literal["PSR"]) -> "Variation_1472":
        ...
    @overload
    def del_item(self, key : Literal["SSR"]) -> "Variation_1472":
        ...
    @overload
    def del_item(self, key : Literal["MDS"]) -> "Variation_1472":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1472_Arg) -> 'Variation_1472':
        return cls._create(arg) # type: ignore

RuleVariation_1395_Arg: TypeAlias = Variation_1472_Arg
class RuleVariation_1395(RuleVariationContextFree):
    cv_variation = Variation_1472

    @classmethod
    def create(cls, arg : RuleVariation_1395_Arg) -> "RuleVariation_1395":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1472:
        return self.arg # type: ignore

NonSpare_178_Arg: TypeAlias = RuleVariation_1395_Arg
class NonSpare_178(NonSpare):
    cv_name = "050"
    cv_title = "System Configuration and Status"
    cv_rule = RuleVariation_1395

    @classmethod
    def create(cls, arg : NonSpare_178_Arg) -> "NonSpare_178":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1395:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1472:
        return self.rule.variation

class UapItem_178(UapItem):
    cv_non_spare = NonSpare_178

Content_368_Arg: TypeAlias = int
class Content_368(ContentTable):
    cv_values = {0: "No reduction active", 1: "Reduction step 1 active", 2: "Reduction step 2 active", 3: "Reduction step 3 active", 4: "Reduction step 4 active", 5: "Reduction step 5 active", 6: "Reduction step 6 active", 7: "Reduction step 7 active"}

RuleContent_368_Arg: TypeAlias = Content_368_Arg
class RuleContent_368(RuleContentContextFree):
    cv_content = Content_368

    @property
    def content(self) -> Content_368:
        return self._get_content() # type: ignore

Variation_483_Arg: TypeAlias = RuleContent_368_Arg
class Variation_483(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 3
    cv_rule = RuleContent_368

    @classmethod
    def create(cls, arg : Variation_483_Arg) -> "Variation_483":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_368:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_368:
        return self.rule.content

RuleVariation_472_Arg: TypeAlias = Variation_483_Arg
class RuleVariation_472(RuleVariationContextFree):
    cv_variation = Variation_483

    @classmethod
    def create(cls, arg : RuleVariation_472_Arg) -> "RuleVariation_472":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_483:
        return self.arg # type: ignore

NonSpare_1563_Arg: TypeAlias = RuleVariation_472_Arg
class NonSpare_1563(NonSpare):
    cv_name = "REDRDP"
    cv_title = "Reduction Steps in Use for An Overload of the RDP"
    cv_rule = RuleVariation_472

    @classmethod
    def create(cls, arg : NonSpare_1563_Arg) -> "NonSpare_1563":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_472:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_483:
        return self.rule.variation

Item_794_Arg: TypeAlias = NonSpare_1563_Arg
class Item_794(Item):
    cv_non_spare = NonSpare_1563

    @classmethod
    def create(cls, arg : Item_794_Arg) -> "Item_794":
        return cls._create(arg) # type: ignore

Variation_784_Arg: TypeAlias = RuleContent_368_Arg
class Variation_784(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_368

    @classmethod
    def create(cls, arg : Variation_784_Arg) -> "Variation_784":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_368:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_368:
        return self.rule.content

RuleVariation_763_Arg: TypeAlias = Variation_784_Arg
class RuleVariation_763(RuleVariationContextFree):
    cv_variation = Variation_784

    @classmethod
    def create(cls, arg : RuleVariation_763_Arg) -> "RuleVariation_763":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_784:
        return self.arg # type: ignore

NonSpare_1564_Arg: TypeAlias = RuleVariation_763_Arg
class NonSpare_1564(NonSpare):
    cv_name = "REDXMT"
    cv_title = "Reduction Steps in Use for An Overload of the Transmission Subsystem"
    cv_rule = RuleVariation_763

    @classmethod
    def create(cls, arg : NonSpare_1564_Arg) -> "NonSpare_1564":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_763:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_784:
        return self.rule.variation

Item_795_Arg: TypeAlias = NonSpare_1564_Arg
class Item_795(Item):
    cv_non_spare = NonSpare_1564

    @classmethod
    def create(cls, arg : Item_795_Arg) -> "Item_795":
        return cls._create(arg) # type: ignore

Variation_995_Arg_Group = Tuple[int, Union[RuleVariation_472_Arg, Tuple[Literal["REDRDP"], RuleVariation_472_Arg]], Union[RuleVariation_763_Arg, Tuple[Literal["REDXMT"], RuleVariation_763_Arg]], int]
Variation_995_Arg: TypeAlias = Union[int, Variation_995_Arg_Group]
class Variation_995(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_0, 1), (Item_794, 3), (Item_795, 3), (Item_29, 1)]
    cv_items_dict = {"REDRDP": RuleVariation_472, "REDXMT": RuleVariation_763}

    @overload
    @classmethod
    def spec(cls, key : Literal["REDRDP"]) -> RuleVariation_472:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["REDXMT"]) -> RuleVariation_763:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["REDRDP"], Literal["REDXMT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["REDRDP"]) -> RuleVariation_472:
        ...
    @overload
    def get_item(self, key : Literal["REDXMT"]) -> RuleVariation_763:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_995_Arg) -> 'Variation_995':
        return cls._create(arg) # type: ignore

RuleVariation_965_Arg: TypeAlias = Variation_995_Arg
class RuleVariation_965(RuleVariationContextFree):
    cv_variation = Variation_995

    @classmethod
    def create(cls, arg : RuleVariation_965_Arg) -> "RuleVariation_965":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_995:
        return self.arg # type: ignore

NonSpare_774_Arg: TypeAlias = RuleVariation_965_Arg
class NonSpare_774(NonSpare):
    cv_name = "COM"
    cv_title = "Common Part"
    cv_rule = RuleVariation_965

    @classmethod
    def create(cls, arg : NonSpare_774_Arg) -> "NonSpare_774":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_965:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_995:
        return self.rule.variation

Content_256_Arg: TypeAlias = int
class Content_256(ContentTable):
    cv_values = {0: "Linear polarization", 1: "Circular polarization"}

RuleContent_256_Arg: TypeAlias = Content_256_Arg
class RuleContent_256(RuleContentContextFree):
    cv_content = Content_256

    @property
    def content(self) -> Content_256:
        return self._get_content() # type: ignore

Variation_50_Arg: TypeAlias = RuleContent_256_Arg
class Variation_50(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_256

    @classmethod
    def create(cls, arg : Variation_50_Arg) -> "Variation_50":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_256:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_256:
        return self.rule.content

RuleVariation_50_Arg: TypeAlias = Variation_50_Arg
class RuleVariation_50(RuleVariationContextFree):
    cv_variation = Variation_50

    @classmethod
    def create(cls, arg : RuleVariation_50_Arg) -> "RuleVariation_50":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_50:
        return self.arg # type: ignore

NonSpare_1432_Arg: TypeAlias = RuleVariation_50_Arg
class NonSpare_1432(NonSpare):
    cv_name = "POL"
    cv_title = "Polarization in Use by PSR"
    cv_rule = RuleVariation_50

    @classmethod
    def create(cls, arg : NonSpare_1432_Arg) -> "NonSpare_1432":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_50:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_50:
        return self.rule.variation

Item_687_Arg: TypeAlias = NonSpare_1432_Arg
class Item_687(Item):
    cv_non_spare = NonSpare_1432

    @classmethod
    def create(cls, arg : Item_687_Arg) -> "Item_687":
        return cls._create(arg) # type: ignore

NonSpare_1561_Arg: TypeAlias = RuleVariation_472_Arg
class NonSpare_1561(NonSpare):
    cv_name = "REDRAD"
    cv_title = "Reduction Steps in Use as Result of An Overload Within the PSR Subsystem"
    cv_rule = RuleVariation_472

    @classmethod
    def create(cls, arg : NonSpare_1561_Arg) -> "NonSpare_1561":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_472:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_483:
        return self.rule.variation

Item_792_Arg: TypeAlias = NonSpare_1561_Arg
class Item_792(Item):
    cv_non_spare = NonSpare_1561

    @classmethod
    def create(cls, arg : Item_792_Arg) -> "Item_792":
        return cls._create(arg) # type: ignore

Content_450_Arg: TypeAlias = int
class Content_450(ContentTable):
    cv_values = {0: "STC Map-1", 1: "STC Map-2", 2: "STC Map-3", 3: "STC Map-4"}

RuleContent_450_Arg: TypeAlias = Content_450_Arg
class RuleContent_450(RuleContentContextFree):
    cv_content = Content_450

    @property
    def content(self) -> Content_450:
        return self._get_content() # type: ignore

Variation_765_Arg: TypeAlias = RuleContent_450_Arg
class Variation_765(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_450

    @classmethod
    def create(cls, arg : Variation_765_Arg) -> "Variation_765":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_450:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_450:
        return self.rule.content

RuleVariation_754_Arg: TypeAlias = Variation_765_Arg
class RuleVariation_754(RuleVariationContextFree):
    cv_variation = Variation_765

    @classmethod
    def create(cls, arg : RuleVariation_754_Arg) -> "RuleVariation_754":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_765:
        return self.arg # type: ignore

NonSpare_1777_Arg: TypeAlias = RuleVariation_754_Arg
class NonSpare_1777(NonSpare):
    cv_name = "STC"
    cv_title = "Sensitivity Time Control Map in Use"
    cv_rule = RuleVariation_754

    @classmethod
    def create(cls, arg : NonSpare_1777_Arg) -> "NonSpare_1777":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_754:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_765:
        return self.rule.variation

Item_944_Arg: TypeAlias = NonSpare_1777_Arg
class Item_944(Item):
    cv_non_spare = NonSpare_1777

    @classmethod
    def create(cls, arg : Item_944_Arg) -> "Item_944":
        return cls._create(arg) # type: ignore

Variation_1154_Arg_Group = Tuple[Union[RuleVariation_50_Arg, Tuple[Literal["POL"], RuleVariation_50_Arg]], Union[RuleVariation_472_Arg, Tuple[Literal["REDRAD"], RuleVariation_472_Arg]], Union[RuleVariation_754_Arg, Tuple[Literal["STC"], RuleVariation_754_Arg]], int]
Variation_1154_Arg: TypeAlias = Union[int, Variation_1154_Arg_Group]
class Variation_1154(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_687, 1), (Item_792, 3), (Item_944, 2), (Item_27, 2)]
    cv_items_dict = {"POL": RuleVariation_50, "REDRAD": RuleVariation_472, "STC": RuleVariation_754}

    @overload
    @classmethod
    def spec(cls, key : Literal["POL"]) -> RuleVariation_50:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["REDRAD"]) -> RuleVariation_472:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STC"]) -> RuleVariation_754:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["POL"], Literal["REDRAD"], Literal["STC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["POL"]) -> RuleVariation_50:
        ...
    @overload
    def get_item(self, key : Literal["REDRAD"]) -> RuleVariation_472:
        ...
    @overload
    def get_item(self, key : Literal["STC"]) -> RuleVariation_754:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1154_Arg) -> 'Variation_1154':
        return cls._create(arg) # type: ignore

RuleVariation_1106_Arg: TypeAlias = Variation_1154_Arg
class RuleVariation_1106(RuleVariationContextFree):
    cv_variation = Variation_1154

    @classmethod
    def create(cls, arg : RuleVariation_1106_Arg) -> "RuleVariation_1106":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1154:
        return self.arg # type: ignore

NonSpare_1468_Arg: TypeAlias = RuleVariation_1106_Arg
class NonSpare_1468(NonSpare):
    cv_name = "PSR"
    cv_title = "Specific Processing Mode Information for a PSR Sensor"
    cv_rule = RuleVariation_1106

    @classmethod
    def create(cls, arg : NonSpare_1468_Arg) -> "NonSpare_1468":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1106:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1154:
        return self.rule.variation

Variation_128_Arg: TypeAlias = RuleContent_368_Arg
class Variation_128(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_368

    @classmethod
    def create(cls, arg : Variation_128_Arg) -> "Variation_128":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_368:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_368:
        return self.rule.content

RuleVariation_128_Arg: TypeAlias = Variation_128_Arg
class RuleVariation_128(RuleVariationContextFree):
    cv_variation = Variation_128

    @classmethod
    def create(cls, arg : RuleVariation_128_Arg) -> "RuleVariation_128":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_128:
        return self.arg # type: ignore

NonSpare_1562_Arg: TypeAlias = RuleVariation_128_Arg
class NonSpare_1562(NonSpare):
    cv_name = "REDRAD"
    cv_title = "Reduction Steps in Use as Result of An Overload Within the SSR Subsystem"
    cv_rule = RuleVariation_128

    @classmethod
    def create(cls, arg : NonSpare_1562_Arg) -> "NonSpare_1562":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_128:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_128:
        return self.rule.variation

Item_793_Arg: TypeAlias = NonSpare_1562_Arg
class Item_793(Item):
    cv_non_spare = NonSpare_1562

    @classmethod
    def create(cls, arg : Item_793_Arg) -> "Item_793":
        return cls._create(arg) # type: ignore

Variation_1171_Arg_Group = Tuple[Union[RuleVariation_128_Arg, Tuple[Literal["REDRAD"], RuleVariation_128_Arg]], int]
Variation_1171_Arg: TypeAlias = Union[int, Variation_1171_Arg_Group]
class Variation_1171(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_793, 3), (Item_19, 5)]
    cv_items_dict = {"REDRAD": RuleVariation_128}

    @classmethod
    def spec(cls, key : Literal["REDRAD"]) -> RuleVariation_128:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["REDRAD"]) -> RuleVariation_128:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1171_Arg) -> 'Variation_1171':
        return cls._create(arg) # type: ignore

RuleVariation_1123_Arg: TypeAlias = Variation_1171_Arg
class RuleVariation_1123(RuleVariationContextFree):
    cv_variation = Variation_1171

    @classmethod
    def create(cls, arg : RuleVariation_1123_Arg) -> "RuleVariation_1123":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1171:
        return self.arg # type: ignore

NonSpare_1755_Arg: TypeAlias = RuleVariation_1123_Arg
class NonSpare_1755(NonSpare):
    cv_name = "SSR"
    cv_title = "Specific Processing Mode Information for a SSR Sensor"
    cv_rule = RuleVariation_1123

    @classmethod
    def create(cls, arg : NonSpare_1755_Arg) -> "NonSpare_1755":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1123:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1171:
        return self.rule.variation

NonSpare_1560_Arg: TypeAlias = RuleVariation_128_Arg
class NonSpare_1560(NonSpare):
    cv_name = "REDRAD"
    cv_title = "Reduction Steps in Use as Result of An Overload Within the Mode S Subsystem"
    cv_rule = RuleVariation_128

    @classmethod
    def create(cls, arg : NonSpare_1560_Arg) -> "NonSpare_1560":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_128:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_128:
        return self.rule.variation

Item_791_Arg: TypeAlias = NonSpare_1560_Arg
class Item_791(Item):
    cv_non_spare = NonSpare_1560

    @classmethod
    def create(cls, arg : Item_791_Arg) -> "Item_791":
        return cls._create(arg) # type: ignore

Content_41_Arg: TypeAlias = int
class Content_41(ContentTable):
    cv_values = {0: "Autonomous", 1: "Not autonomous"}

RuleContent_41_Arg: TypeAlias = Content_41_Arg
class RuleContent_41(RuleContentContextFree):
    cv_content = Content_41

    @property
    def content(self) -> Content_41:
        return self._get_content() # type: ignore

Variation_615_Arg: TypeAlias = RuleContent_41_Arg
class Variation_615(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_41

    @classmethod
    def create(cls, arg : Variation_615_Arg) -> "Variation_615":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_41:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_41:
        return self.rule.content

RuleVariation_604_Arg: TypeAlias = Variation_615_Arg
class RuleVariation_604(RuleVariationContextFree):
    cv_variation = Variation_615

    @classmethod
    def create(cls, arg : RuleVariation_604_Arg) -> "RuleVariation_604":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_615:
        return self.arg # type: ignore

NonSpare_738_Arg: TypeAlias = RuleVariation_604_Arg
class NonSpare_738(NonSpare):
    cv_name = "CLU"
    cv_title = "Cluster State"
    cv_rule = RuleVariation_604

    @classmethod
    def create(cls, arg : NonSpare_738_Arg) -> "NonSpare_738":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_604:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_615:
        return self.rule.variation

Item_163_Arg: TypeAlias = NonSpare_738_Arg
class Item_163(Item):
    cv_non_spare = NonSpare_738

    @classmethod
    def create(cls, arg : Item_163_Arg) -> "Item_163":
        return cls._create(arg) # type: ignore

Variation_1170_Arg_Group = Tuple[Union[RuleVariation_128_Arg, Tuple[Literal["REDRAD"], RuleVariation_128_Arg]], Union[RuleVariation_604_Arg, Tuple[Literal["CLU"], RuleVariation_604_Arg]], int]
Variation_1170_Arg: TypeAlias = Union[int, Variation_1170_Arg_Group]
class Variation_1170(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_791, 3), (Item_163, 1), (Item_22, 4)]
    cv_items_dict = {"REDRAD": RuleVariation_128, "CLU": RuleVariation_604}

    @overload
    @classmethod
    def spec(cls, key : Literal["REDRAD"]) -> RuleVariation_128:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CLU"]) -> RuleVariation_604:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["REDRAD"], Literal["CLU"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["REDRAD"]) -> RuleVariation_128:
        ...
    @overload
    def get_item(self, key : Literal["CLU"]) -> RuleVariation_604:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1170_Arg) -> 'Variation_1170':
        return cls._create(arg) # type: ignore

RuleVariation_1122_Arg: TypeAlias = Variation_1170_Arg
class RuleVariation_1122(RuleVariationContextFree):
    cv_variation = Variation_1170

    @classmethod
    def create(cls, arg : RuleVariation_1122_Arg) -> "RuleVariation_1122":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1170:
        return self.arg # type: ignore

NonSpare_1253_Arg: TypeAlias = RuleVariation_1122_Arg
class NonSpare_1253(NonSpare):
    cv_name = "MDS"
    cv_title = "Specific Processing Mode Information for a Mode S Sensor"
    cv_rule = RuleVariation_1122

    @classmethod
    def create(cls, arg : NonSpare_1253_Arg) -> "NonSpare_1253":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1122:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1170:
        return self.rule.variation

Variation_1471_Arg = TypedDict('Variation_1471_Arg', {
    "COM": NonSpare_774_Arg,
    "PSR": NonSpare_1468_Arg,
    "SSR": NonSpare_1755_Arg,
    "MDS": NonSpare_1253_Arg,
}, total=False)
class Variation_1471(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_774, None, None, NonSpare_1468, NonSpare_1755, NonSpare_1253]
    cv_items_dict = {"COM": NonSpare_774, "PSR": NonSpare_1468, "SSR": NonSpare_1755, "MDS": NonSpare_1253}

    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> NonSpare_774:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PSR"]) -> NonSpare_1468:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSR"]) -> NonSpare_1755:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDS"]) -> NonSpare_1253:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COM"], Literal["PSR"], Literal["SSR"], Literal["MDS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COM"]) -> Optional[NonSpare_774]:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[NonSpare_1468]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[NonSpare_1755]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[NonSpare_1253]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["COM"], val : NonSpare_774_Arg) -> "Variation_1471":
        ...
    @overload
    def set_item(self, key : Literal["PSR"], val : NonSpare_1468_Arg) -> "Variation_1471":
        ...
    @overload
    def set_item(self, key : Literal["SSR"], val : NonSpare_1755_Arg) -> "Variation_1471":
        ...
    @overload
    def set_item(self, key : Literal["MDS"], val : NonSpare_1253_Arg) -> "Variation_1471":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["COM"]) -> "Variation_1471":
        ...
    @overload
    def del_item(self, key : Literal["PSR"]) -> "Variation_1471":
        ...
    @overload
    def del_item(self, key : Literal["SSR"]) -> "Variation_1471":
        ...
    @overload
    def del_item(self, key : Literal["MDS"]) -> "Variation_1471":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1471_Arg) -> 'Variation_1471':
        return cls._create(arg) # type: ignore

RuleVariation_1394_Arg: TypeAlias = Variation_1471_Arg
class RuleVariation_1394(RuleVariationContextFree):
    cv_variation = Variation_1471

    @classmethod
    def create(cls, arg : RuleVariation_1394_Arg) -> "RuleVariation_1394":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1471:
        return self.arg # type: ignore

NonSpare_196_Arg: TypeAlias = RuleVariation_1394_Arg
class NonSpare_196(NonSpare):
    cv_name = "060"
    cv_title = "System Processing Mode"
    cv_rule = RuleVariation_1394

    @classmethod
    def create(cls, arg : NonSpare_196_Arg) -> "NonSpare_196":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1394:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1471:
        return self.rule.variation

class UapItem_196(UapItem):
    cv_non_spare = NonSpare_196

Content_347_Arg: TypeAlias = int
class Content_347(ContentTable):
    cv_values = {0: "No detection (number of misses)", 1: "Single PSR target reports", 2: "Single SSR target reports (Non-Mode S)", 3: "SSR+PSR target reports (Non-Mode S)", 4: "Single All-Call target reports (Mode S)", 5: "Single Roll-Call target reports (Mode S)", 6: "All-Call + PSR (Mode S) target reports", 7: "Roll-Call + PSR (Mode S) target reports", 8: "Filter for Weather data", 9: "Filter for Jamming Strobe", 10: "Filter for PSR data", 11: "Filter for SSR/Mode S data", 12: "Filter for SSR/Mode S+PSR data", 13: "Filter for Enhanced Surveillance data", 14: "Filter for PSR+Enhanced Surveillance", 15: "Filter for PSR+Enhanced Surveillance + SSR/Mode S data not in Area of Prime Interest", 16: "Filter for PSR+Enhanced Surveillance + all SSR/Mode S data"}

RuleContent_347_Arg: TypeAlias = Content_347_Arg
class RuleContent_347(RuleContentContextFree):
    cv_content = Content_347

    @property
    def content(self) -> Content_347:
        return self._get_content() # type: ignore

Variation_141_Arg: TypeAlias = RuleContent_347_Arg
class Variation_141(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 5
    cv_rule = RuleContent_347

    @classmethod
    def create(cls, arg : Variation_141_Arg) -> "Variation_141":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_347:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_347:
        return self.rule.content

RuleVariation_141_Arg: TypeAlias = Variation_141_Arg
class RuleVariation_141(RuleVariationContextFree):
    cv_variation = Variation_141

    @classmethod
    def create(cls, arg : RuleVariation_141_Arg) -> "RuleVariation_141":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_141:
        return self.arg # type: ignore

NonSpare_1960_Arg: TypeAlias = RuleVariation_141_Arg
class NonSpare_1960(NonSpare):
    cv_name = "TYP"
    cv_title = "Type of Message Counter"
    cv_rule = RuleVariation_141

    @classmethod
    def create(cls, arg : NonSpare_1960_Arg) -> "NonSpare_1960":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_141:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_141:
        return self.rule.variation

Item_1079_Arg: TypeAlias = NonSpare_1960_Arg
class Item_1079(Item):
    cv_non_spare = NonSpare_1960

    @classmethod
    def create(cls, arg : Item_1079_Arg) -> "Item_1079":
        return cls._create(arg) # type: ignore

Variation_892_Arg: TypeAlias = RuleContent_610_Arg
class Variation_892(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 11
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_892_Arg) -> "Variation_892":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_862_Arg: TypeAlias = Variation_892_Arg
class RuleVariation_862(RuleVariationContextFree):
    cv_variation = Variation_892

    @classmethod
    def create(cls, arg : RuleVariation_862_Arg) -> "RuleVariation_862":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_892:
        return self.arg # type: ignore

NonSpare_792_Arg: TypeAlias = RuleVariation_862_Arg
class NonSpare_792(NonSpare):
    cv_name = "COUNT"
    cv_title = "COUNTER"
    cv_rule = RuleVariation_862

    @classmethod
    def create(cls, arg : NonSpare_792_Arg) -> "NonSpare_792":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_862:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_892:
        return self.rule.variation

Item_197_Arg: TypeAlias = NonSpare_792_Arg
class Item_197(Item):
    cv_non_spare = NonSpare_792

    @classmethod
    def create(cls, arg : Item_197_Arg) -> "Item_197":
        return cls._create(arg) # type: ignore

Variation_1234_Arg_Group = Tuple[Union[RuleVariation_141_Arg, Tuple[Literal["TYP"], RuleVariation_141_Arg]], Union[RuleVariation_862_Arg, Tuple[Literal["COUNT"], RuleVariation_862_Arg]]]
Variation_1234_Arg: TypeAlias = Union[int, Variation_1234_Arg_Group]
class Variation_1234(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1079, 5), (Item_197, 11)]
    cv_items_dict = {"TYP": RuleVariation_141, "COUNT": RuleVariation_862}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_141:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COUNT"]) -> RuleVariation_862:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["COUNT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_141:
        ...
    @overload
    def get_item(self, key : Literal["COUNT"]) -> RuleVariation_862:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1234_Arg) -> 'Variation_1234':
        return cls._create(arg) # type: ignore

Variation_1435_Arg: TypeAlias = List[Variation_1234_Arg]
class Variation_1435(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1234

    @classmethod
    def create(cls, arg : Variation_1435_Arg) -> 'Variation_1435':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1234]:
        return self._get_list() # type: ignore

RuleVariation_1358_Arg: TypeAlias = Variation_1435_Arg
class RuleVariation_1358(RuleVariationContextFree):
    cv_variation = Variation_1435

    @classmethod
    def create(cls, arg : RuleVariation_1358_Arg) -> "RuleVariation_1358":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1435:
        return self.arg # type: ignore

NonSpare_202_Arg: TypeAlias = RuleVariation_1358_Arg
class NonSpare_202(NonSpare):
    cv_name = "070"
    cv_title = "Message Count Values"
    cv_rule = RuleVariation_1358

    @classmethod
    def create(cls, arg : NonSpare_202_Arg) -> "NonSpare_202":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1358:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1435:
        return self.rule.variation

class UapItem_202(UapItem):
    cv_non_spare = NonSpare_202

Content_771_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
class Content_771(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 3.90625e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

RuleContent_770_Arg: TypeAlias = Content_771_Arg
class RuleContent_770(RuleContentContextFree):
    cv_content = Content_771

    @property
    def content(self) -> Content_771:
        return self._get_content() # type: ignore

Variation_334_Arg: TypeAlias = RuleContent_770_Arg
class Variation_334(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_770

    @classmethod
    def create(cls, arg : Variation_334_Arg) -> "Variation_334":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_770:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_771:
        return self.rule.content

RuleVariation_327_Arg: TypeAlias = Variation_334_Arg
class RuleVariation_327(RuleVariationContextFree):
    cv_variation = Variation_334

    @classmethod
    def create(cls, arg : RuleVariation_327_Arg) -> "RuleVariation_327":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_334:
        return self.arg # type: ignore

NonSpare_1584_Arg: TypeAlias = RuleVariation_327_Arg
class NonSpare_1584(NonSpare):
    cv_name = "RHOST"
    cv_title = "Rho Start"
    cv_rule = RuleVariation_327

    @classmethod
    def create(cls, arg : NonSpare_1584_Arg) -> "NonSpare_1584":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_327:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_334:
        return self.rule.variation

Item_815_Arg: TypeAlias = NonSpare_1584_Arg
class Item_815(Item):
    cv_non_spare = NonSpare_1584

    @classmethod
    def create(cls, arg : Item_815_Arg) -> "Item_815":
        return cls._create(arg) # type: ignore

NonSpare_1583_Arg: TypeAlias = RuleVariation_327_Arg
class NonSpare_1583(NonSpare):
    cv_name = "RHOEND"
    cv_title = "Rho End"
    cv_rule = RuleVariation_327

    @classmethod
    def create(cls, arg : NonSpare_1583_Arg) -> "NonSpare_1583":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_327:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_334:
        return self.rule.variation

Item_814_Arg: TypeAlias = NonSpare_1583_Arg
class Item_814(Item):
    cv_non_spare = NonSpare_1583

    @classmethod
    def create(cls, arg : Item_814_Arg) -> "Item_814":
        return cls._create(arg) # type: ignore

NonSpare_1850_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_1850(NonSpare):
    cv_name = "THETAST"
    cv_title = "Theta Start"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_1850_Arg) -> "NonSpare_1850":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Item_994_Arg: TypeAlias = NonSpare_1850_Arg
class Item_994(Item):
    cv_non_spare = NonSpare_1850

    @classmethod
    def create(cls, arg : Item_994_Arg) -> "Item_994":
        return cls._create(arg) # type: ignore

NonSpare_1849_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_1849(NonSpare):
    cv_name = "THETAEND"
    cv_title = "Theta End"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_1849_Arg) -> "NonSpare_1849":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Item_993_Arg: TypeAlias = NonSpare_1849_Arg
class Item_993(Item):
    cv_non_spare = NonSpare_1849

    @classmethod
    def create(cls, arg : Item_993_Arg) -> "Item_993":
        return cls._create(arg) # type: ignore

Variation_1176_Arg_Group = Tuple[Union[RuleVariation_327_Arg, Tuple[Literal["RHOST"], RuleVariation_327_Arg]], Union[RuleVariation_327_Arg, Tuple[Literal["RHOEND"], RuleVariation_327_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["THETAST"], RuleVariation_334_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["THETAEND"], RuleVariation_334_Arg]]]
Variation_1176_Arg: TypeAlias = Union[int, Variation_1176_Arg_Group]
class Variation_1176(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_815, 16), (Item_814, 16), (Item_994, 16), (Item_993, 16)]
    cv_items_dict = {"RHOST": RuleVariation_327, "RHOEND": RuleVariation_327, "THETAST": RuleVariation_334, "THETAEND": RuleVariation_334}

    @overload
    @classmethod
    def spec(cls, key : Literal["RHOST"]) -> RuleVariation_327:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RHOEND"]) -> RuleVariation_327:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["THETAST"]) -> RuleVariation_334:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["THETAEND"]) -> RuleVariation_334:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RHOST"], Literal["RHOEND"], Literal["THETAST"], Literal["THETAEND"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RHOST"]) -> RuleVariation_327:
        ...
    @overload
    def get_item(self, key : Literal["RHOEND"]) -> RuleVariation_327:
        ...
    @overload
    def get_item(self, key : Literal["THETAST"]) -> RuleVariation_334:
        ...
    @overload
    def get_item(self, key : Literal["THETAEND"]) -> RuleVariation_334:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1176_Arg) -> 'Variation_1176':
        return cls._create(arg) # type: ignore

RuleVariation_1128_Arg: TypeAlias = Variation_1176_Arg
class RuleVariation_1128(RuleVariationContextFree):
    cv_variation = Variation_1176

    @classmethod
    def create(cls, arg : RuleVariation_1128_Arg) -> "RuleVariation_1128":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1176:
        return self.arg # type: ignore

NonSpare_266_Arg: TypeAlias = RuleVariation_1128_Arg
class NonSpare_266(NonSpare):
    cv_name = "100"
    cv_title = "Generic Polar Window"
    cv_rule = RuleVariation_1128

    @classmethod
    def create(cls, arg : NonSpare_266_Arg) -> "NonSpare_266":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1128:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1176:
        return self.rule.variation

class UapItem_266(UapItem):
    cv_non_spare = NonSpare_266

Content_246_Arg: TypeAlias = int
class Content_246(ContentTable):
    cv_values = {0: "Invalid value", 1: "Filter for Weather data", 2: "Filter for Jamming Strobe", 3: "Filter for PSR data", 4: "Filter for SSR/Mode S data", 5: "Filter for SSR/Mode S + PSR data", 6: "Enhanced Surveillance data", 7: "Filter for PSR+Enhanced Surveillance data", 8: "Filter for PSR+Enhanced Surveillance + SSR/Mode S data not in Area of Prime Interest", 9: "Filter for PSR+Enhanced Surveillance + all SSR/Mode S data"}

RuleContent_246_Arg: TypeAlias = Content_246_Arg
class RuleContent_246(RuleContentContextFree):
    cv_content = Content_246

    @property
    def content(self) -> Content_246:
        return self._get_content() # type: ignore

Variation_167_Arg: TypeAlias = RuleContent_246_Arg
class Variation_167(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_246

    @classmethod
    def create(cls, arg : Variation_167_Arg) -> "Variation_167":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_246:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_246:
        return self.rule.content

RuleVariation_161_Arg: TypeAlias = Variation_167_Arg
class RuleVariation_161(RuleVariationContextFree):
    cv_variation = Variation_167

    @classmethod
    def create(cls, arg : RuleVariation_161_Arg) -> "RuleVariation_161":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_167:
        return self.arg # type: ignore

NonSpare_280_Arg: TypeAlias = RuleVariation_161_Arg
class NonSpare_280(NonSpare):
    cv_name = "110"
    cv_title = "Data Filter"
    cv_rule = RuleVariation_161

    @classmethod
    def create(cls, arg : NonSpare_280_Arg) -> "NonSpare_280":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_161:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_167:
        return self.rule.variation

class UapItem_280(UapItem):
    cv_non_spare = NonSpare_280

Variation_256_Arg: TypeAlias = RuleContent_623_Arg
class Variation_256(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_623

    @classmethod
    def create(cls, arg : Variation_256_Arg) -> "Variation_256":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_623:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_623:
        return self.rule.content

RuleVariation_249_Arg: TypeAlias = Variation_256_Arg
class RuleVariation_249(RuleVariationContextFree):
    cv_variation = Variation_256

    @classmethod
    def create(cls, arg : RuleVariation_249_Arg) -> "RuleVariation_249":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_256:
        return self.arg # type: ignore

NonSpare_1060_Arg: TypeAlias = RuleVariation_249_Arg
class NonSpare_1060(NonSpare):
    cv_name = "HGT"
    cv_title = "Height of Data Source"
    cv_rule = RuleVariation_249

    @classmethod
    def create(cls, arg : NonSpare_1060_Arg) -> "NonSpare_1060":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_249:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_256:
        return self.rule.variation

Item_392_Arg: TypeAlias = NonSpare_1060_Arg
class Item_392(Item):
    cv_non_spare = NonSpare_1060

    @classmethod
    def create(cls, arg : Item_392_Arg) -> "Item_392":
        return cls._create(arg) # type: ignore

Content_691_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_691(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 2.1457672119140625e-5
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_691_Arg: TypeAlias = Content_691_Arg
class RuleContent_691(RuleContentContextFree):
    cv_content = Content_691

    @property
    def content(self) -> Content_691:
        return self._get_content() # type: ignore

Variation_357_Arg: TypeAlias = RuleContent_691_Arg
class Variation_357(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_691

    @classmethod
    def create(cls, arg : Variation_357_Arg) -> "Variation_357":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_691:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_691:
        return self.rule.content

RuleVariation_350_Arg: TypeAlias = Variation_357_Arg
class RuleVariation_350(RuleVariationContextFree):
    cv_variation = Variation_357

    @classmethod
    def create(cls, arg : RuleVariation_350_Arg) -> "RuleVariation_350":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_357:
        return self.arg # type: ignore

NonSpare_1171_Arg: TypeAlias = RuleVariation_350_Arg
class NonSpare_1171(NonSpare):
    cv_name = "LON"
    cv_title = "Longitude"
    cv_rule = RuleVariation_350

    @classmethod
    def create(cls, arg : NonSpare_1171_Arg) -> "NonSpare_1171":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_350:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_357:
        return self.rule.variation

Item_487_Arg: TypeAlias = NonSpare_1171_Arg
class Item_487(Item):
    cv_non_spare = NonSpare_1171

    @classmethod
    def create(cls, arg : Item_487_Arg) -> "Item_487":
        return cls._create(arg) # type: ignore

Variation_1111_Arg_Group = Tuple[Union[RuleVariation_249_Arg, Tuple[Literal["HGT"], RuleVariation_249_Arg]], Union[RuleVariation_351_Arg, Tuple[Literal["LAT"], RuleVariation_351_Arg]], Union[RuleVariation_350_Arg, Tuple[Literal["LON"], RuleVariation_350_Arg]]]
Variation_1111_Arg: TypeAlias = Union[int, Variation_1111_Arg_Group]
class Variation_1111(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_392, 16), (Item_460, 24), (Item_487, 24)]
    cv_items_dict = {"HGT": RuleVariation_249, "LAT": RuleVariation_351, "LON": RuleVariation_350}

    @overload
    @classmethod
    def spec(cls, key : Literal["HGT"]) -> RuleVariation_249:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_351:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_350:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["HGT"], Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["HGT"]) -> RuleVariation_249:
        ...
    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_351:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_350:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1111_Arg) -> 'Variation_1111':
        return cls._create(arg) # type: ignore

RuleVariation_1069_Arg: TypeAlias = Variation_1111_Arg
class RuleVariation_1069(RuleVariationContextFree):
    cv_variation = Variation_1111

    @classmethod
    def create(cls, arg : RuleVariation_1069_Arg) -> "RuleVariation_1069":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1111:
        return self.arg # type: ignore

NonSpare_290_Arg: TypeAlias = RuleVariation_1069_Arg
class NonSpare_290(NonSpare):
    cv_name = "120"
    cv_title = "3D-Position Of Data Source"
    cv_rule = RuleVariation_1069

    @classmethod
    def create(cls, arg : NonSpare_290_Arg) -> "NonSpare_290":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1069:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1111:
        return self.rule.variation

class UapItem_290(UapItem):
    cv_non_spare = NonSpare_290

NonSpare_1589_Arg: TypeAlias = RuleVariation_206_Arg
class NonSpare_1589(NonSpare):
    cv_name = "RNG"
    cv_title = "Range Error"
    cv_rule = RuleVariation_206

    @classmethod
    def create(cls, arg : NonSpare_1589_Arg) -> "NonSpare_1589":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_206:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_213:
        return self.rule.variation

Item_820_Arg: TypeAlias = NonSpare_1589_Arg
class Item_820(Item):
    cv_non_spare = NonSpare_1589

    @classmethod
    def create(cls, arg : Item_820_Arg) -> "Item_820":
        return cls._create(arg) # type: ignore

NonSpare_661_Arg: TypeAlias = RuleVariation_211_Arg
class NonSpare_661(NonSpare):
    cv_name = "AZM"
    cv_title = "Azimuth Error"
    cv_rule = RuleVariation_211

    @classmethod
    def create(cls, arg : NonSpare_661_Arg) -> "NonSpare_661":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_211:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_218:
        return self.rule.variation

Item_107_Arg: TypeAlias = NonSpare_661_Arg
class Item_107(Item):
    cv_non_spare = NonSpare_661

    @classmethod
    def create(cls, arg : Item_107_Arg) -> "Item_107":
        return cls._create(arg) # type: ignore

Variation_1178_Arg_Group = Tuple[Union[RuleVariation_206_Arg, Tuple[Literal["RNG"], RuleVariation_206_Arg]], Union[RuleVariation_211_Arg, Tuple[Literal["AZM"], RuleVariation_211_Arg]]]
Variation_1178_Arg: TypeAlias = Union[int, Variation_1178_Arg_Group]
class Variation_1178(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_820, 8), (Item_107, 8)]
    cv_items_dict = {"RNG": RuleVariation_206, "AZM": RuleVariation_211}

    @overload
    @classmethod
    def spec(cls, key : Literal["RNG"]) -> RuleVariation_206:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AZM"]) -> RuleVariation_211:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RNG"], Literal["AZM"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RNG"]) -> RuleVariation_206:
        ...
    @overload
    def get_item(self, key : Literal["AZM"]) -> RuleVariation_211:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1178_Arg) -> 'Variation_1178':
        return cls._create(arg) # type: ignore

RuleVariation_1129_Arg: TypeAlias = Variation_1178_Arg
class RuleVariation_1129(RuleVariationContextFree):
    cv_variation = Variation_1178

    @classmethod
    def create(cls, arg : RuleVariation_1129_Arg) -> "RuleVariation_1129":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1178:
        return self.arg # type: ignore

NonSpare_241_Arg: TypeAlias = RuleVariation_1129_Arg
class NonSpare_241(NonSpare):
    cv_name = "090"
    cv_title = "Collimation Error"
    cv_rule = RuleVariation_1129

    @classmethod
    def create(cls, arg : NonSpare_241_Arg) -> "NonSpare_241":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1129:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1178:
        return self.rule.variation

class UapItem_241(UapItem):
    cv_non_spare = NonSpare_241

Record_14_Arg = TypedDict('Record_14_Arg', {
    "010": NonSpare_34_Arg,
    "000": NonSpare_3_Arg,
    "030": NonSpare_106_Arg,
    "020": NonSpare_81_Arg,
    "041": NonSpare_151_Arg,
    "050": NonSpare_178_Arg,
    "060": NonSpare_196_Arg,
    "070": NonSpare_202_Arg,
    "100": NonSpare_266_Arg,
    "110": NonSpare_280_Arg,
    "120": NonSpare_290_Arg,
    "090": NonSpare_241_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_14(Record):
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_34, UapItem_3, UapItem_106, UapItem_81, UapItem_151, UapItem_178, UapItem_196, UapItem_202, UapItem_266, UapItem_280, UapItem_290, UapItem_241, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_34, "000": NonSpare_3, "030": NonSpare_106, "020": NonSpare_81, "041": NonSpare_151, "050": NonSpare_178, "060": NonSpare_196, "070": NonSpare_202, "100": NonSpare_266, "110": NonSpare_280, "120": NonSpare_290, "090": NonSpare_241, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_34:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_3:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_106:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_81:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_151:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_178:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_196:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_202:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_266:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_280:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_290:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_241:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["030"], Literal["020"], Literal["041"], Literal["050"], Literal["060"], Literal["070"], Literal["100"], Literal["110"], Literal["120"], Literal["090"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_34]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_3]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_106]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_81]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_151]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_178]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_196]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_202]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_266]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_280]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_290]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_241]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_34_Arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_3_Arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_106_Arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_81_Arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_151_Arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_178_Arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_196_Arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_202_Arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_266_Arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_280_Arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_290_Arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_241_Arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_14':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_14':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_14_Arg) -> 'Record_14':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_14", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_14_Arg: TypeAlias = Record_14
class Uap_14(UapSingle):
    cv_record = Record_14

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_14]]:
        return cls._parse(bs)

class Asterix_38(AstCat):
    cv_category = 34
    cv_edition = (1, 27)
    cv_uap = Uap_14

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_14_Arg]) -> "Asterix_38":
        return cls._create(records) # type: ignore

Content_585_Arg: TypeAlias = int
class Content_585(ContentTable):
    cv_values = {1: "North marker message", 2: "Sector crossing message", 3: "Geographical filtering message", 4: "Jamming strobe message", 5: "Solar Storm Message"}

RuleContent_585_Arg: TypeAlias = Content_585_Arg
class RuleContent_585(RuleContentContextFree):
    cv_content = Content_585

    @property
    def content(self) -> Content_585:
        return self._get_content() # type: ignore

Variation_186_Arg: TypeAlias = RuleContent_585_Arg
class Variation_186(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_585

    @classmethod
    def create(cls, arg : Variation_186_Arg) -> "Variation_186":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_585:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_585:
        return self.rule.content

RuleVariation_179_Arg: TypeAlias = Variation_186_Arg
class RuleVariation_179(RuleVariationContextFree):
    cv_variation = Variation_186

    @classmethod
    def create(cls, arg : RuleVariation_179_Arg) -> "RuleVariation_179":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_186:
        return self.arg # type: ignore

NonSpare_4_Arg: TypeAlias = RuleVariation_179_Arg
class NonSpare_4(NonSpare):
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule = RuleVariation_179

    @classmethod
    def create(cls, arg : NonSpare_4_Arg) -> "NonSpare_4":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_179:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_186:
        return self.rule.variation

class UapItem_4(UapItem):
    cv_non_spare = NonSpare_4

Content_348_Arg: TypeAlias = int
class Content_348(ContentTable):
    cv_values = {0: "No detection (number of misses)", 1: "Single PSR target reports", 2: "Single SSR target reports (Non-Mode S)", 3: "SSR+PSR target reports (Non-Mode S)", 4: "Single All-Call target reports (Mode S)", 5: "Single Roll-Call target reports (Mode S)", 6: "All-Call + PSR (Mode S) target reports", 7: "Roll-Call + PSR (Mode S) target reports", 8: "Filter for Weather data", 9: "Filter for Jamming Strobe", 10: "Filter for PSR data", 11: "Filter for SSR/Mode S data", 12: "Filter for SSR/Mode S+PSR data", 13: "Filter for Enhanced Surveillance data", 14: "Filter for PSR+Enhanced Surveillance", 15: "Filter for PSR+Enhanced Surveillance + SSR/Mode S data not in Area of Prime Interest", 16: "Filter for PSR+Enhanced Surveillance + all SSR/Mode S data", 17: "Re-Interrogations (per sector)", 18: "BDS Swap and wrong DF replies(per sector)", 19: "Mode A/C FRUIT (per sector)", 20: "Mode S FRUIT (per sector)"}

RuleContent_348_Arg: TypeAlias = Content_348_Arg
class RuleContent_348(RuleContentContextFree):
    cv_content = Content_348

    @property
    def content(self) -> Content_348:
        return self._get_content() # type: ignore

Variation_142_Arg: TypeAlias = RuleContent_348_Arg
class Variation_142(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 5
    cv_rule = RuleContent_348

    @classmethod
    def create(cls, arg : Variation_142_Arg) -> "Variation_142":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_348:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_348:
        return self.rule.content

RuleVariation_142_Arg: TypeAlias = Variation_142_Arg
class RuleVariation_142(RuleVariationContextFree):
    cv_variation = Variation_142

    @classmethod
    def create(cls, arg : RuleVariation_142_Arg) -> "RuleVariation_142":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_142:
        return self.arg # type: ignore

NonSpare_1961_Arg: TypeAlias = RuleVariation_142_Arg
class NonSpare_1961(NonSpare):
    cv_name = "TYP"
    cv_title = "Type of Message Counter"
    cv_rule = RuleVariation_142

    @classmethod
    def create(cls, arg : NonSpare_1961_Arg) -> "NonSpare_1961":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_142:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_142:
        return self.rule.variation

Item_1080_Arg: TypeAlias = NonSpare_1961_Arg
class Item_1080(Item):
    cv_non_spare = NonSpare_1961

    @classmethod
    def create(cls, arg : Item_1080_Arg) -> "Item_1080":
        return cls._create(arg) # type: ignore

Variation_1235_Arg_Group = Tuple[Union[RuleVariation_142_Arg, Tuple[Literal["TYP"], RuleVariation_142_Arg]], Union[RuleVariation_862_Arg, Tuple[Literal["COUNT"], RuleVariation_862_Arg]]]
Variation_1235_Arg: TypeAlias = Union[int, Variation_1235_Arg_Group]
class Variation_1235(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1080, 5), (Item_197, 11)]
    cv_items_dict = {"TYP": RuleVariation_142, "COUNT": RuleVariation_862}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_142:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COUNT"]) -> RuleVariation_862:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["COUNT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_142:
        ...
    @overload
    def get_item(self, key : Literal["COUNT"]) -> RuleVariation_862:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1235_Arg) -> 'Variation_1235':
        return cls._create(arg) # type: ignore

Variation_1436_Arg: TypeAlias = List[Variation_1235_Arg]
class Variation_1436(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1235

    @classmethod
    def create(cls, arg : Variation_1436_Arg) -> 'Variation_1436':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1235]:
        return self._get_list() # type: ignore

RuleVariation_1359_Arg: TypeAlias = Variation_1436_Arg
class RuleVariation_1359(RuleVariationContextFree):
    cv_variation = Variation_1436

    @classmethod
    def create(cls, arg : RuleVariation_1359_Arg) -> "RuleVariation_1359":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1436:
        return self.arg # type: ignore

NonSpare_203_Arg: TypeAlias = RuleVariation_1359_Arg
class NonSpare_203(NonSpare):
    cv_name = "070"
    cv_title = "Message Count Values"
    cv_rule = RuleVariation_1359

    @classmethod
    def create(cls, arg : NonSpare_203_Arg) -> "NonSpare_203":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1359:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1436:
        return self.rule.variation

class UapItem_203(UapItem):
    cv_non_spare = NonSpare_203

Record_15_Arg = TypedDict('Record_15_Arg', {
    "010": NonSpare_34_Arg,
    "000": NonSpare_4_Arg,
    "030": NonSpare_106_Arg,
    "020": NonSpare_81_Arg,
    "041": NonSpare_151_Arg,
    "050": NonSpare_178_Arg,
    "060": NonSpare_196_Arg,
    "070": NonSpare_203_Arg,
    "100": NonSpare_266_Arg,
    "110": NonSpare_280_Arg,
    "120": NonSpare_290_Arg,
    "090": NonSpare_241_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_15(Record):
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_34, UapItem_4, UapItem_106, UapItem_81, UapItem_151, UapItem_178, UapItem_196, UapItem_203, UapItem_266, UapItem_280, UapItem_290, UapItem_241, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_34, "000": NonSpare_4, "030": NonSpare_106, "020": NonSpare_81, "041": NonSpare_151, "050": NonSpare_178, "060": NonSpare_196, "070": NonSpare_203, "100": NonSpare_266, "110": NonSpare_280, "120": NonSpare_290, "090": NonSpare_241, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_34:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_4:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_106:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_81:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_151:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_178:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_196:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_203:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_266:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_280:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_290:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_241:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["030"], Literal["020"], Literal["041"], Literal["050"], Literal["060"], Literal["070"], Literal["100"], Literal["110"], Literal["120"], Literal["090"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_34]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_4]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_106]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_81]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_151]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_178]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_196]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_203]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_266]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_280]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_290]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_241]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_34_Arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_4_Arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_106_Arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_81_Arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_151_Arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_178_Arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_196_Arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_203_Arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_266_Arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_280_Arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_290_Arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_241_Arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_15':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_15':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_15_Arg) -> 'Record_15':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_15", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_15_Arg: TypeAlias = Record_15
class Uap_15(UapSingle):
    cv_record = Record_15

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_15]]:
        return cls._parse(bs)

class Asterix_39(AstCat):
    cv_category = 34
    cv_edition = (1, 28)
    cv_uap = Uap_15

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_15_Arg]) -> "Asterix_39":
        return cls._create(records) # type: ignore

Content_586_Arg: TypeAlias = int
class Content_586(ContentTable):
    cv_values = {1: "North marker message", 2: "Sector crossing message", 3: "Geographical filtering message", 4: "Jamming strobe message", 5: "Solar Storm Message", 6: "SSR Jamming Strobe Message", 7: "Mode S Jamming Strobe Message"}

RuleContent_586_Arg: TypeAlias = Content_586_Arg
class RuleContent_586(RuleContentContextFree):
    cv_content = Content_586

    @property
    def content(self) -> Content_586:
        return self._get_content() # type: ignore

Variation_187_Arg: TypeAlias = RuleContent_586_Arg
class Variation_187(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_586

    @classmethod
    def create(cls, arg : Variation_187_Arg) -> "Variation_187":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_586:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_586:
        return self.rule.content

RuleVariation_180_Arg: TypeAlias = Variation_187_Arg
class RuleVariation_180(RuleVariationContextFree):
    cv_variation = Variation_187

    @classmethod
    def create(cls, arg : RuleVariation_180_Arg) -> "RuleVariation_180":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_187:
        return self.arg # type: ignore

NonSpare_5_Arg: TypeAlias = RuleVariation_180_Arg
class NonSpare_5(NonSpare):
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule = RuleVariation_180

    @classmethod
    def create(cls, arg : NonSpare_5_Arg) -> "NonSpare_5":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_180:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_187:
        return self.rule.variation

class UapItem_5(UapItem):
    cv_non_spare = NonSpare_5

Record_16_Arg = TypedDict('Record_16_Arg', {
    "010": NonSpare_34_Arg,
    "000": NonSpare_5_Arg,
    "030": NonSpare_106_Arg,
    "020": NonSpare_81_Arg,
    "041": NonSpare_151_Arg,
    "050": NonSpare_178_Arg,
    "060": NonSpare_196_Arg,
    "070": NonSpare_203_Arg,
    "100": NonSpare_266_Arg,
    "110": NonSpare_280_Arg,
    "120": NonSpare_290_Arg,
    "090": NonSpare_241_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_16(Record):
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_34, UapItem_5, UapItem_106, UapItem_81, UapItem_151, UapItem_178, UapItem_196, UapItem_203, UapItem_266, UapItem_280, UapItem_290, UapItem_241, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_34, "000": NonSpare_5, "030": NonSpare_106, "020": NonSpare_81, "041": NonSpare_151, "050": NonSpare_178, "060": NonSpare_196, "070": NonSpare_203, "100": NonSpare_266, "110": NonSpare_280, "120": NonSpare_290, "090": NonSpare_241, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_34:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_5:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_106:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_81:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_151:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_178:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_196:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_203:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_266:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_280:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_290:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_241:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["030"], Literal["020"], Literal["041"], Literal["050"], Literal["060"], Literal["070"], Literal["100"], Literal["110"], Literal["120"], Literal["090"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_34]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_5]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_106]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_81]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_151]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_178]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_196]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_203]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_266]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_280]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_290]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_241]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_34_Arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_5_Arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_106_Arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_81_Arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_151_Arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_178_Arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_196_Arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_203_Arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_266_Arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_280_Arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_290_Arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_241_Arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_16':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_16':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_16_Arg) -> 'Record_16':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_16", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_16_Arg: TypeAlias = Record_16
class Uap_16(UapSingle):
    cv_record = Record_16

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_16]]:
        return cls._parse(bs)

class Asterix_40(AstCat):
    cv_category = 34
    cv_edition = (1, 29)
    cv_uap = Uap_16

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_16_Arg]) -> "Asterix_40":
        return cls._create(records) # type: ignore

Content_325_Arg: TypeAlias = int
class Content_325(ContentTable):
    cv_values = {0: "No authenticated Mode 5 Data reply/report", 1: "Authenticated Mode 5 Data reply/report (i.e any valid Mode 5 reply type other than ID)"}

RuleContent_325_Arg: TypeAlias = Content_325_Arg
class RuleContent_325(RuleContentContextFree):
    cv_content = Content_325

    @property
    def content(self) -> Content_325:
        return self._get_content() # type: ignore

Variation_558_Arg: TypeAlias = RuleContent_325_Arg
class Variation_558(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_325

    @classmethod
    def create(cls, arg : Variation_558_Arg) -> "Variation_558":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_325:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_325:
        return self.rule.content

RuleVariation_547_Arg: TypeAlias = Variation_558_Arg
class RuleVariation_547(RuleVariationContextFree):
    cv_variation = Variation_558

    @classmethod
    def create(cls, arg : RuleVariation_547_Arg) -> "RuleVariation_547":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_558:
        return self.arg # type: ignore

NonSpare_850_Arg: TypeAlias = RuleVariation_547_Arg
class NonSpare_850(NonSpare):
    cv_name = "DA"
    cv_title = ""
    cv_rule = RuleVariation_547

    @classmethod
    def create(cls, arg : NonSpare_850_Arg) -> "NonSpare_850":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_547:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_558:
        return self.rule.variation

Item_236_Arg: TypeAlias = NonSpare_850_Arg
class Item_236(Item):
    cv_non_spare = NonSpare_850

    @classmethod
    def create(cls, arg : Item_236_Arg) -> "Item_236":
        return cls._create(arg) # type: ignore

Content_279_Arg: TypeAlias = int
class Content_279(ContentTable):
    cv_values = {0: "Mode C altitude not present or not from Mode 5 reply/report", 1: "Mode C altitude from Mode 5 reply/report"}

RuleContent_279_Arg: TypeAlias = Content_279_Arg
class RuleContent_279(RuleContentContextFree):
    cv_content = Content_279

    @property
    def content(self) -> Content_279:
        return self._get_content() # type: ignore

Variation_936_Arg: TypeAlias = RuleContent_279_Arg
class Variation_936(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_279

    @classmethod
    def create(cls, arg : Variation_936_Arg) -> "Variation_936":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_279:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_279:
        return self.rule.content

RuleVariation_906_Arg: TypeAlias = Variation_936_Arg
class RuleVariation_906(RuleVariationContextFree):
    cv_variation = Variation_936

    @classmethod
    def create(cls, arg : RuleVariation_906_Arg) -> "RuleVariation_906":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_936:
        return self.arg # type: ignore

NonSpare_1230_Arg: TypeAlias = RuleVariation_906_Arg
class NonSpare_1230(NonSpare):
    cv_name = "MC"
    cv_title = ""
    cv_rule = RuleVariation_906

    @classmethod
    def create(cls, arg : NonSpare_1230_Arg) -> "NonSpare_1230":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_906:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_936:
        return self.rule.variation

Item_532_Arg: TypeAlias = NonSpare_1230_Arg
class Item_532(Item):
    cv_non_spare = NonSpare_1230

    @classmethod
    def create(cls, arg : Item_532_Arg) -> "Item_532":
        return cls._create(arg) # type: ignore

Variation_1135_Arg_Group = Tuple[Union[RuleVariation_56_Arg, Tuple[Literal["M5"], RuleVariation_56_Arg]], Union[RuleVariation_429_Arg, Tuple[Literal["ID"], RuleVariation_429_Arg]], Union[RuleVariation_547_Arg, Tuple[Literal["DA"], RuleVariation_547_Arg]], Union[RuleVariation_633_Arg, Tuple[Literal["M1"], RuleVariation_633_Arg]], Union[RuleVariation_720_Arg, Tuple[Literal["M2"], RuleVariation_720_Arg]], Union[RuleVariation_828_Arg, Tuple[Literal["M3"], RuleVariation_828_Arg]], Union[RuleVariation_906_Arg, Tuple[Literal["MC"], RuleVariation_906_Arg]], int]
Variation_1135_Arg: TypeAlias = Union[int, Variation_1135_Arg_Group]
class Variation_1135(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_518, 1), (Item_426, 1), (Item_236, 1), (Item_511, 1), (Item_513, 1), (Item_516, 1), (Item_532, 1), (Item_29, 1)]
    cv_items_dict = {"M5": RuleVariation_56, "ID": RuleVariation_429, "DA": RuleVariation_547, "M1": RuleVariation_633, "M2": RuleVariation_720, "M3": RuleVariation_828, "MC": RuleVariation_906}

    @overload
    @classmethod
    def spec(cls, key : Literal["M5"]) -> RuleVariation_56:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ID"]) -> RuleVariation_429:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DA"]) -> RuleVariation_547:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M1"]) -> RuleVariation_633:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M2"]) -> RuleVariation_720:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M3"]) -> RuleVariation_828:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MC"]) -> RuleVariation_906:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["M5"], Literal["ID"], Literal["DA"], Literal["M1"], Literal["M2"], Literal["M3"], Literal["MC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["M5"]) -> RuleVariation_56:
        ...
    @overload
    def get_item(self, key : Literal["ID"]) -> RuleVariation_429:
        ...
    @overload
    def get_item(self, key : Literal["DA"]) -> RuleVariation_547:
        ...
    @overload
    def get_item(self, key : Literal["M1"]) -> RuleVariation_633:
        ...
    @overload
    def get_item(self, key : Literal["M2"]) -> RuleVariation_720:
        ...
    @overload
    def get_item(self, key : Literal["M3"]) -> RuleVariation_828:
        ...
    @overload
    def get_item(self, key : Literal["MC"]) -> RuleVariation_906:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1135_Arg) -> 'Variation_1135':
        return cls._create(arg) # type: ignore

RuleVariation_1092_Arg: TypeAlias = Variation_1135_Arg
class RuleVariation_1092(RuleVariationContextFree):
    cv_variation = Variation_1135

    @classmethod
    def create(cls, arg : RuleVariation_1092_Arg) -> "RuleVariation_1092":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1135:
        return self.arg # type: ignore

NonSpare_1802_Arg: TypeAlias = RuleVariation_1092_Arg
class NonSpare_1802(NonSpare):
    cv_name = "SUM"
    cv_title = "Mode 5 Summary"
    cv_rule = RuleVariation_1092

    @classmethod
    def create(cls, arg : NonSpare_1802_Arg) -> "NonSpare_1802":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1092:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1135:
        return self.rule.variation

Content_300_Arg: TypeAlias = int
class Content_300(ContentTable):
    cv_values = {0: "National Origin is valid", 1: "National Origin is invalid"}

RuleContent_300_Arg: TypeAlias = Content_300_Arg
class RuleContent_300(RuleContentContextFree):
    cv_content = Content_300

    @property
    def content(self) -> Content_300:
        return self._get_content() # type: ignore

Variation_554_Arg: TypeAlias = RuleContent_300_Arg
class Variation_554(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_300

    @classmethod
    def create(cls, arg : Variation_554_Arg) -> "Variation_554":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_300:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_300:
        return self.rule.content

RuleVariation_543_Arg: TypeAlias = Variation_554_Arg
class RuleVariation_543(RuleVariationContextFree):
    cv_variation = Variation_554

    @classmethod
    def create(cls, arg : RuleVariation_543_Arg) -> "RuleVariation_543":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_554:
        return self.arg # type: ignore

NonSpare_1340_Arg: TypeAlias = RuleVariation_543_Arg
class NonSpare_1340(NonSpare):
    cv_name = "NAV"
    cv_title = "Validity of NAT"
    cv_rule = RuleVariation_543

    @classmethod
    def create(cls, arg : NonSpare_1340_Arg) -> "NonSpare_1340":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_543:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_554:
        return self.rule.variation

Item_606_Arg: TypeAlias = NonSpare_1340_Arg
class Item_606(Item):
    cv_non_spare = NonSpare_1340

    @classmethod
    def create(cls, arg : Item_606_Arg) -> "Item_606":
        return cls._create(arg) # type: ignore

NonSpare_1334_Arg: TypeAlias = RuleVariation_681_Arg
class NonSpare_1334(NonSpare):
    cv_name = "NAT"
    cv_title = "National Origin"
    cv_rule = RuleVariation_681

    @classmethod
    def create(cls, arg : NonSpare_1334_Arg) -> "NonSpare_1334":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_681:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_692:
        return self.rule.variation

Item_602_Arg: TypeAlias = NonSpare_1334_Arg
class Item_602(Item):
    cv_non_spare = NonSpare_1334

    @classmethod
    def create(cls, arg : Item_602_Arg) -> "Item_602":
        return cls._create(arg) # type: ignore

NonSpare_1281_Arg: TypeAlias = RuleVariation_588_Arg
class NonSpare_1281(NonSpare):
    cv_name = "MIS"
    cv_title = "Mission Code"
    cv_rule = RuleVariation_588

    @classmethod
    def create(cls, arg : NonSpare_1281_Arg) -> "NonSpare_1281":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_588:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_599:
        return self.rule.variation

Item_554_Arg: TypeAlias = NonSpare_1281_Arg
class Item_554(Item):
    cv_non_spare = NonSpare_1281

    @classmethod
    def create(cls, arg : Item_554_Arg) -> "Item_554":
        return cls._create(arg) # type: ignore

Variation_1002_Arg_Group = Tuple[int, Union[RuleVariation_590_Arg, Tuple[Literal["PIN"], RuleVariation_590_Arg]], int, Union[RuleVariation_543_Arg, Tuple[Literal["NAV"], RuleVariation_543_Arg]], Union[RuleVariation_681_Arg, Tuple[Literal["NAT"], RuleVariation_681_Arg]], int, Union[RuleVariation_588_Arg, Tuple[Literal["MIS"], RuleVariation_588_Arg]]]
Variation_1002_Arg: TypeAlias = Union[int, Variation_1002_Arg_Group]
class Variation_1002(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1, 2), (Item_681, 14), (Item_1, 2), (Item_606, 1), (Item_602, 5), (Item_1, 2), (Item_554, 6)]
    cv_items_dict = {"PIN": RuleVariation_590, "NAV": RuleVariation_543, "NAT": RuleVariation_681, "MIS": RuleVariation_588}

    @overload
    @classmethod
    def spec(cls, key : Literal["PIN"]) -> RuleVariation_590:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NAV"]) -> RuleVariation_543:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NAT"]) -> RuleVariation_681:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MIS"]) -> RuleVariation_588:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PIN"], Literal["NAV"], Literal["NAT"], Literal["MIS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PIN"]) -> RuleVariation_590:
        ...
    @overload
    def get_item(self, key : Literal["NAV"]) -> RuleVariation_543:
        ...
    @overload
    def get_item(self, key : Literal["NAT"]) -> RuleVariation_681:
        ...
    @overload
    def get_item(self, key : Literal["MIS"]) -> RuleVariation_588:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1002_Arg) -> 'Variation_1002':
        return cls._create(arg) # type: ignore

RuleVariation_972_Arg: TypeAlias = Variation_1002_Arg
class RuleVariation_972(RuleVariationContextFree):
    cv_variation = Variation_1002

    @classmethod
    def create(cls, arg : RuleVariation_972_Arg) -> "RuleVariation_972":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1002:
        return self.arg # type: ignore

NonSpare_1425_Arg: TypeAlias = RuleVariation_972_Arg
class NonSpare_1425(NonSpare):
    cv_name = "PMN"
    cv_title = "PIN/ National Origin/Mission Code"
    cv_rule = RuleVariation_972

    @classmethod
    def create(cls, arg : NonSpare_1425_Arg) -> "NonSpare_1425":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_972:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1002:
        return self.rule.variation

Content_694_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_694(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 2.1457672119140625e-5
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_694_Arg: TypeAlias = Content_694_Arg
class RuleContent_694(RuleContentContextFree):
    cv_content = Content_694

    @property
    def content(self) -> Content_694:
        return self._get_content() # type: ignore

Variation_360_Arg: TypeAlias = RuleContent_694_Arg
class Variation_360(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_694

    @classmethod
    def create(cls, arg : Variation_360_Arg) -> "Variation_360":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_694:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_694:
        return self.rule.content

RuleVariation_353_Arg: TypeAlias = Variation_360_Arg
class RuleVariation_353(RuleVariationContextFree):
    cv_variation = Variation_360

    @classmethod
    def create(cls, arg : RuleVariation_353_Arg) -> "RuleVariation_353":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_360:
        return self.arg # type: ignore

NonSpare_1148_Arg: TypeAlias = RuleVariation_353_Arg
class NonSpare_1148(NonSpare):
    cv_name = "LAT"
    cv_title = "Latitude in WGS 84"
    cv_rule = RuleVariation_353

    @classmethod
    def create(cls, arg : NonSpare_1148_Arg) -> "NonSpare_1148":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_353:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_360:
        return self.rule.variation

Item_466_Arg: TypeAlias = NonSpare_1148_Arg
class Item_466(Item):
    cv_non_spare = NonSpare_1148

    @classmethod
    def create(cls, arg : Item_466_Arg) -> "Item_466":
        return cls._create(arg) # type: ignore

Content_693_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_693(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 2.1457672119140625e-5
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_693_Arg: TypeAlias = Content_693_Arg
class RuleContent_693(RuleContentContextFree):
    cv_content = Content_693

    @property
    def content(self) -> Content_693:
        return self._get_content() # type: ignore

Variation_359_Arg: TypeAlias = RuleContent_693_Arg
class Variation_359(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_693

    @classmethod
    def create(cls, arg : Variation_359_Arg) -> "Variation_359":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_693:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_693:
        return self.rule.content

RuleVariation_352_Arg: TypeAlias = Variation_359_Arg
class RuleVariation_352(RuleVariationContextFree):
    cv_variation = Variation_359

    @classmethod
    def create(cls, arg : RuleVariation_352_Arg) -> "RuleVariation_352":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_359:
        return self.arg # type: ignore

NonSpare_1177_Arg: TypeAlias = RuleVariation_352_Arg
class NonSpare_1177(NonSpare):
    cv_name = "LON"
    cv_title = "Longitude in WGS 84"
    cv_rule = RuleVariation_352

    @classmethod
    def create(cls, arg : NonSpare_1177_Arg) -> "NonSpare_1177":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_352:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_359:
        return self.rule.variation

Item_493_Arg: TypeAlias = NonSpare_1177_Arg
class Item_493(Item):
    cv_non_spare = NonSpare_1177

    @classmethod
    def create(cls, arg : Item_493_Arg) -> "Item_493":
        return cls._create(arg) # type: ignore

Variation_1127_Arg_Group = Tuple[Union[RuleVariation_353_Arg, Tuple[Literal["LAT"], RuleVariation_353_Arg]], Union[RuleVariation_352_Arg, Tuple[Literal["LON"], RuleVariation_352_Arg]]]
Variation_1127_Arg: TypeAlias = Union[int, Variation_1127_Arg_Group]
class Variation_1127(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_466, 24), (Item_493, 24)]
    cv_items_dict = {"LAT": RuleVariation_353, "LON": RuleVariation_352}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_353:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_352:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_353:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_352:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1127_Arg) -> 'Variation_1127':
        return cls._create(arg) # type: ignore

RuleVariation_1084_Arg: TypeAlias = Variation_1127_Arg
class RuleVariation_1084(RuleVariationContextFree):
    cv_variation = Variation_1127

    @classmethod
    def create(cls, arg : RuleVariation_1084_Arg) -> "RuleVariation_1084":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1127:
        return self.arg # type: ignore

NonSpare_1437_Arg: TypeAlias = RuleVariation_1084_Arg
class NonSpare_1437(NonSpare):
    cv_name = "POS"
    cv_title = "Mode 5 Reported Position"
    cv_rule = RuleVariation_1084

    @classmethod
    def create(cls, arg : NonSpare_1437_Arg) -> "NonSpare_1437":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1084:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1127:
        return self.rule.variation

Content_218_Arg: TypeAlias = int
class Content_218(ContentTable):
    cv_values = {0: "GA reported in 100 ft increments", 1: "GA reported in 25 ft increments"}

RuleContent_218_Arg: TypeAlias = Content_218_Arg
class RuleContent_218(RuleContentContextFree):
    cv_content = Content_218

    @property
    def content(self) -> Content_218:
        return self._get_content() # type: ignore

Variation_425_Arg: TypeAlias = RuleContent_218_Arg
class Variation_425(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_218

    @classmethod
    def create(cls, arg : Variation_425_Arg) -> "Variation_425":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_218:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_218:
        return self.rule.content

RuleVariation_414_Arg: TypeAlias = Variation_425_Arg
class RuleVariation_414(RuleVariationContextFree):
    cv_variation = Variation_425

    @classmethod
    def create(cls, arg : RuleVariation_414_Arg) -> "RuleVariation_414":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_425:
        return self.arg # type: ignore

NonSpare_1572_Arg: TypeAlias = RuleVariation_414_Arg
class NonSpare_1572(NonSpare):
    cv_name = "RES"
    cv_title = ""
    cv_rule = RuleVariation_414

    @classmethod
    def create(cls, arg : NonSpare_1572_Arg) -> "NonSpare_1572":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_414:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_425:
        return self.rule.variation

Item_803_Arg: TypeAlias = NonSpare_1572_Arg
class Item_803(Item):
    cv_non_spare = NonSpare_1572

    @classmethod
    def create(cls, arg : Item_803_Arg) -> "Item_803":
        return cls._create(arg) # type: ignore

Content_634_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
class Content_634(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 25.0
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

RuleContent_634_Arg: TypeAlias = Content_634_Arg
class RuleContent_634(RuleContentContextFree):
    cv_content = Content_634

    @property
    def content(self) -> Content_634:
        return self._get_content() # type: ignore

Variation_604_Arg: TypeAlias = RuleContent_634_Arg
class Variation_604(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_634

    @classmethod
    def create(cls, arg : Variation_604_Arg) -> "Variation_604":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_634:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_634:
        return self.rule.content

RuleVariation_593_Arg: TypeAlias = Variation_604_Arg
class RuleVariation_593(RuleVariationContextFree):
    cv_variation = Variation_604

    @classmethod
    def create(cls, arg : RuleVariation_593_Arg) -> "RuleVariation_593":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_604:
        return self.arg # type: ignore

NonSpare_1005_Arg: TypeAlias = RuleVariation_593_Arg
class NonSpare_1005(NonSpare):
    cv_name = "GA"
    cv_title = ""
    cv_rule = RuleVariation_593

    @classmethod
    def create(cls, arg : NonSpare_1005_Arg) -> "NonSpare_1005":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_593:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_604:
        return self.rule.variation

Item_356_Arg: TypeAlias = NonSpare_1005_Arg
class Item_356(Item):
    cv_non_spare = NonSpare_1005

    @classmethod
    def create(cls, arg : Item_356_Arg) -> "Item_356":
        return cls._create(arg) # type: ignore

Variation_996_Arg_Group = Tuple[int, Union[RuleVariation_414_Arg, Tuple[Literal["RES"], RuleVariation_414_Arg]], Union[RuleVariation_593_Arg, Tuple[Literal["GA"], RuleVariation_593_Arg]]]
Variation_996_Arg: TypeAlias = Union[int, Variation_996_Arg_Group]
class Variation_996(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_0, 1), (Item_803, 1), (Item_356, 14)]
    cv_items_dict = {"RES": RuleVariation_414, "GA": RuleVariation_593}

    @overload
    @classmethod
    def spec(cls, key : Literal["RES"]) -> RuleVariation_414:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GA"]) -> RuleVariation_593:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RES"], Literal["GA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RES"]) -> RuleVariation_414:
        ...
    @overload
    def get_item(self, key : Literal["GA"]) -> RuleVariation_593:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_996_Arg) -> 'Variation_996':
        return cls._create(arg) # type: ignore

RuleVariation_966_Arg: TypeAlias = Variation_996_Arg
class RuleVariation_966(RuleVariationContextFree):
    cv_variation = Variation_996

    @classmethod
    def create(cls, arg : RuleVariation_966_Arg) -> "RuleVariation_966":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_996:
        return self.arg # type: ignore

NonSpare_1008_Arg: TypeAlias = RuleVariation_966_Arg
class NonSpare_1008(NonSpare):
    cv_name = "GA"
    cv_title = "Mode 5 GNSS-derived Altitude"
    cv_rule = RuleVariation_966

    @classmethod
    def create(cls, arg : NonSpare_1008_Arg) -> "NonSpare_1008":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_966:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_996:
        return self.rule.variation

Content_55_Arg: TypeAlias = int
class Content_55(ContentTable):
    cv_values = {0: "Code not validated", 1: "Code validated"}

RuleContent_55_Arg: TypeAlias = Content_55_Arg
class RuleContent_55(RuleContentContextFree):
    cv_content = Content_55

    @property
    def content(self) -> Content_55:
        return self._get_content() # type: ignore

Variation_14_Arg: TypeAlias = RuleContent_55_Arg
class Variation_14(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_55

    @classmethod
    def create(cls, arg : Variation_14_Arg) -> "Variation_14":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_55:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_55:
        return self.rule.content

RuleVariation_14_Arg: TypeAlias = Variation_14_Arg
class RuleVariation_14(RuleVariationContextFree):
    cv_variation = Variation_14

    @classmethod
    def create(cls, arg : RuleVariation_14_Arg) -> "RuleVariation_14":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_14:
        return self.arg # type: ignore

NonSpare_1980_Arg: TypeAlias = RuleVariation_14_Arg
class NonSpare_1980(NonSpare):
    cv_name = "V"
    cv_title = ""
    cv_rule = RuleVariation_14

    @classmethod
    def create(cls, arg : NonSpare_1980_Arg) -> "NonSpare_1980":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_14:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_14:
        return self.rule.variation

Item_1098_Arg: TypeAlias = NonSpare_1980_Arg
class Item_1098(Item):
    cv_non_spare = NonSpare_1980

    @classmethod
    def create(cls, arg : Item_1098_Arg) -> "Item_1098":
        return cls._create(arg) # type: ignore

Content_269_Arg: TypeAlias = int
class Content_269(ContentTable):
    cv_values = {0: "Mode 1 Code derived from the reply of the transponder", 1: "Mode 1 Code not extracted during the last scan"}

RuleContent_269_Arg: TypeAlias = Content_269_Arg
class RuleContent_269(RuleContentContextFree):
    cv_content = Content_269

    @property
    def content(self) -> Content_269:
        return self._get_content() # type: ignore

Variation_540_Arg: TypeAlias = RuleContent_269_Arg
class Variation_540(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_269

    @classmethod
    def create(cls, arg : Variation_540_Arg) -> "Variation_540":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_269:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_269:
        return self.rule.content

RuleVariation_529_Arg: TypeAlias = Variation_540_Arg
class RuleVariation_529(RuleVariationContextFree):
    cv_variation = Variation_540

    @classmethod
    def create(cls, arg : RuleVariation_529_Arg) -> "RuleVariation_529":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_540:
        return self.arg # type: ignore

NonSpare_1122_Arg: TypeAlias = RuleVariation_529_Arg
class NonSpare_1122(NonSpare):
    cv_name = "L"
    cv_title = ""
    cv_rule = RuleVariation_529

    @classmethod
    def create(cls, arg : NonSpare_1122_Arg) -> "NonSpare_1122":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_529:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_540:
        return self.rule.variation

Item_440_Arg: TypeAlias = NonSpare_1122_Arg
class Item_440(Item):
    cv_non_spare = NonSpare_1122

    @classmethod
    def create(cls, arg : Item_440_Arg) -> "Item_440":
        return cls._create(arg) # type: ignore

Variation_1243_Arg_Group = Tuple[Union[RuleVariation_14_Arg, Tuple[Literal["V"], RuleVariation_14_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_529_Arg, Tuple[Literal["L"], RuleVariation_529_Arg]], int, Union[RuleVariation_776_Arg, Tuple[Literal["EM1"], RuleVariation_776_Arg]]]
Variation_1243_Arg: TypeAlias = Union[int, Variation_1243_Arg_Group]
class Variation_1243(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1098, 1), (Item_353, 1), (Item_440, 1), (Item_16, 1), (Item_288, 12)]
    cv_items_dict = {"V": RuleVariation_14, "G": RuleVariation_394, "L": RuleVariation_529, "EM1": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_14:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_529:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EM1"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["EM1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_14:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_529:
        ...
    @overload
    def get_item(self, key : Literal["EM1"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1243_Arg) -> 'Variation_1243':
        return cls._create(arg) # type: ignore

RuleVariation_1173_Arg: TypeAlias = Variation_1243_Arg
class RuleVariation_1173(RuleVariationContextFree):
    cv_variation = Variation_1243

    @classmethod
    def create(cls, arg : RuleVariation_1173_Arg) -> "RuleVariation_1173":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1243:
        return self.arg # type: ignore

NonSpare_918_Arg: TypeAlias = RuleVariation_1173_Arg
class NonSpare_918(NonSpare):
    cv_name = "EM1"
    cv_title = "Extended Mode 1 Code in Octal Representation"
    cv_rule = RuleVariation_1173

    @classmethod
    def create(cls, arg : NonSpare_918_Arg) -> "NonSpare_918":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1173:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1243:
        return self.rule.variation

Variation_236_Arg: TypeAlias = RuleContent_766_Arg
class Variation_236(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_766

    @classmethod
    def create(cls, arg : Variation_236_Arg) -> "Variation_236":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_766:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_767:
        return self.rule.content

RuleVariation_229_Arg: TypeAlias = Variation_236_Arg
class RuleVariation_229(RuleVariationContextFree):
    cv_variation = Variation_236

    @classmethod
    def create(cls, arg : RuleVariation_229_Arg) -> "RuleVariation_229":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_236:
        return self.arg # type: ignore

NonSpare_1879_Arg: TypeAlias = RuleVariation_229_Arg
class NonSpare_1879(NonSpare):
    cv_name = "TOS"
    cv_title = "Time Offset for POS and GA"
    cv_rule = RuleVariation_229

    @classmethod
    def create(cls, arg : NonSpare_1879_Arg) -> "NonSpare_1879":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

NonSpare_2109_Arg: TypeAlias = RuleVariation_570_Arg
class NonSpare_2109(NonSpare):
    cv_name = "XP"
    cv_title = "X-pulse from Mode 5 PIN Reply/Report"
    cv_rule = RuleVariation_570

    @classmethod
    def create(cls, arg : NonSpare_2109_Arg) -> "NonSpare_2109":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_570:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_581:
        return self.rule.variation

Item_1213_Arg: TypeAlias = NonSpare_2109_Arg
class Item_1213(Item):
    cv_non_spare = NonSpare_2109

    @classmethod
    def create(cls, arg : Item_1213_Arg) -> "Item_1213":
        return cls._create(arg) # type: ignore

Content_564_Arg: TypeAlias = int
class Content_564(ContentTable):
    cv_values = {0: "X-pulse set to zero or no Mode 2 reply", 1: "X-pulse set to one (present)"}

RuleContent_564_Arg: TypeAlias = Content_564_Arg
class RuleContent_564(RuleContentContextFree):
    cv_content = Content_564

    @property
    def content(self) -> Content_564:
        return self._get_content() # type: ignore

Variation_956_Arg: TypeAlias = RuleContent_564_Arg
class Variation_956(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_564

    @classmethod
    def create(cls, arg : Variation_956_Arg) -> "Variation_956":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_564:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_564:
        return self.rule.content

RuleVariation_926_Arg: TypeAlias = Variation_956_Arg
class RuleVariation_926(RuleVariationContextFree):
    cv_variation = Variation_956

    @classmethod
    def create(cls, arg : RuleVariation_926_Arg) -> "RuleVariation_926":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_956:
        return self.arg # type: ignore

NonSpare_2099_Arg: TypeAlias = RuleVariation_926_Arg
class NonSpare_2099(NonSpare):
    cv_name = "X2"
    cv_title = "X-pulse from Mode 2 Reply"
    cv_rule = RuleVariation_926

    @classmethod
    def create(cls, arg : NonSpare_2099_Arg) -> "NonSpare_2099":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_926:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_956:
        return self.rule.variation

Item_1206_Arg: TypeAlias = NonSpare_2099_Arg
class Item_1206(Item):
    cv_non_spare = NonSpare_2099

    @classmethod
    def create(cls, arg : Item_1206_Arg) -> "Item_1206":
        return cls._create(arg) # type: ignore

Variation_1007_Arg_Group = Tuple[int, Union[RuleVariation_570_Arg, Tuple[Literal["XP"], RuleVariation_570_Arg]], Union[RuleVariation_660_Arg, Tuple[Literal["X5"], RuleVariation_660_Arg]], Union[RuleVariation_748_Arg, Tuple[Literal["XC"], RuleVariation_748_Arg]], Union[RuleVariation_843_Arg, Tuple[Literal["X3"], RuleVariation_843_Arg]], Union[RuleVariation_926_Arg, Tuple[Literal["X2"], RuleVariation_926_Arg]], Union[RuleVariation_957_Arg, Tuple[Literal["X1"], RuleVariation_957_Arg]]]
Variation_1007_Arg: TypeAlias = Union[int, Variation_1007_Arg_Group]
class Variation_1007(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1, 2), (Item_1213, 1), (Item_1209, 1), (Item_1212, 1), (Item_1208, 1), (Item_1206, 1), (Item_1202, 1)]
    cv_items_dict = {"XP": RuleVariation_570, "X5": RuleVariation_660, "XC": RuleVariation_748, "X3": RuleVariation_843, "X2": RuleVariation_926, "X1": RuleVariation_957}

    @overload
    @classmethod
    def spec(cls, key : Literal["XP"]) -> RuleVariation_570:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X5"]) -> RuleVariation_660:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XC"]) -> RuleVariation_748:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X3"]) -> RuleVariation_843:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X2"]) -> RuleVariation_926:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X1"]) -> RuleVariation_957:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["XP"], Literal["X5"], Literal["XC"], Literal["X3"], Literal["X2"], Literal["X1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["XP"]) -> RuleVariation_570:
        ...
    @overload
    def get_item(self, key : Literal["X5"]) -> RuleVariation_660:
        ...
    @overload
    def get_item(self, key : Literal["XC"]) -> RuleVariation_748:
        ...
    @overload
    def get_item(self, key : Literal["X3"]) -> RuleVariation_843:
        ...
    @overload
    def get_item(self, key : Literal["X2"]) -> RuleVariation_926:
        ...
    @overload
    def get_item(self, key : Literal["X1"]) -> RuleVariation_957:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1007_Arg) -> 'Variation_1007':
        return cls._create(arg) # type: ignore

RuleVariation_977_Arg: TypeAlias = Variation_1007_Arg
class RuleVariation_977(RuleVariationContextFree):
    cv_variation = Variation_1007

    @classmethod
    def create(cls, arg : RuleVariation_977_Arg) -> "RuleVariation_977":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1007:
        return self.arg # type: ignore

NonSpare_2106_Arg: TypeAlias = RuleVariation_977_Arg
class NonSpare_2106(NonSpare):
    cv_name = "XP"
    cv_title = "X Pulse Presence"
    cv_rule = RuleVariation_977

    @classmethod
    def create(cls, arg : NonSpare_2106_Arg) -> "NonSpare_2106":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_977:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1007:
        return self.rule.variation

Variation_1501_Arg = TypedDict('Variation_1501_Arg', {
    "SUM": NonSpare_1802_Arg,
    "PMN": NonSpare_1425_Arg,
    "POS": NonSpare_1437_Arg,
    "GA": NonSpare_1008_Arg,
    "EM1": NonSpare_918_Arg,
    "TOS": NonSpare_1879_Arg,
    "XP": NonSpare_2106_Arg,
}, total=False)
class Variation_1501(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1802, NonSpare_1425, NonSpare_1437, NonSpare_1008, NonSpare_918, NonSpare_1879, NonSpare_2106]
    cv_items_dict = {"SUM": NonSpare_1802, "PMN": NonSpare_1425, "POS": NonSpare_1437, "GA": NonSpare_1008, "EM1": NonSpare_918, "TOS": NonSpare_1879, "XP": NonSpare_2106}

    @overload
    @classmethod
    def spec(cls, key : Literal["SUM"]) -> NonSpare_1802:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PMN"]) -> NonSpare_1425:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1437:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GA"]) -> NonSpare_1008:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EM1"]) -> NonSpare_918:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOS"]) -> NonSpare_1879:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XP"]) -> NonSpare_2106:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SUM"], Literal["PMN"], Literal["POS"], Literal["GA"], Literal["EM1"], Literal["TOS"], Literal["XP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SUM"]) -> Optional[NonSpare_1802]:
        ...
    @overload
    def get_item(self, key : Literal["PMN"]) -> Optional[NonSpare_1425]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1437]:
        ...
    @overload
    def get_item(self, key : Literal["GA"]) -> Optional[NonSpare_1008]:
        ...
    @overload
    def get_item(self, key : Literal["EM1"]) -> Optional[NonSpare_918]:
        ...
    @overload
    def get_item(self, key : Literal["TOS"]) -> Optional[NonSpare_1879]:
        ...
    @overload
    def get_item(self, key : Literal["XP"]) -> Optional[NonSpare_2106]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["SUM"], val : NonSpare_1802_Arg) -> "Variation_1501":
        ...
    @overload
    def set_item(self, key : Literal["PMN"], val : NonSpare_1425_Arg) -> "Variation_1501":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1437_Arg) -> "Variation_1501":
        ...
    @overload
    def set_item(self, key : Literal["GA"], val : NonSpare_1008_Arg) -> "Variation_1501":
        ...
    @overload
    def set_item(self, key : Literal["EM1"], val : NonSpare_918_Arg) -> "Variation_1501":
        ...
    @overload
    def set_item(self, key : Literal["TOS"], val : NonSpare_1879_Arg) -> "Variation_1501":
        ...
    @overload
    def set_item(self, key : Literal["XP"], val : NonSpare_2106_Arg) -> "Variation_1501":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["SUM"]) -> "Variation_1501":
        ...
    @overload
    def del_item(self, key : Literal["PMN"]) -> "Variation_1501":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1501":
        ...
    @overload
    def del_item(self, key : Literal["GA"]) -> "Variation_1501":
        ...
    @overload
    def del_item(self, key : Literal["EM1"]) -> "Variation_1501":
        ...
    @overload
    def del_item(self, key : Literal["TOS"]) -> "Variation_1501":
        ...
    @overload
    def del_item(self, key : Literal["XP"]) -> "Variation_1501":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1501_Arg) -> 'Variation_1501':
        return cls._create(arg) # type: ignore

RuleVariation_1424_Arg: TypeAlias = Variation_1501_Arg
class RuleVariation_1424(RuleVariationContextFree):
    cv_variation = Variation_1501

    @classmethod
    def create(cls, arg : RuleVariation_1424_Arg) -> "RuleVariation_1424":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1501:
        return self.arg # type: ignore

NonSpare_1240_Arg: TypeAlias = RuleVariation_1424_Arg
class NonSpare_1240(NonSpare):
    cv_name = "MD5"
    cv_title = "Mode 5 Reports"
    cv_rule = RuleVariation_1424

    @classmethod
    def create(cls, arg : NonSpare_1240_Arg) -> "NonSpare_1240":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1424:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1501:
        return self.rule.variation

NonSpare_1803_Arg: TypeAlias = RuleVariation_1092_Arg
class NonSpare_1803(NonSpare):
    cv_name = "SUM"
    cv_title = "Mode 5 Summary"
    cv_rule = RuleVariation_1092

    @classmethod
    def create(cls, arg : NonSpare_1803_Arg) -> "NonSpare_1803":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1092:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1135:
        return self.rule.variation

Variation_733_Arg: TypeAlias = RuleContent_300_Arg
class Variation_733(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_300

    @classmethod
    def create(cls, arg : Variation_733_Arg) -> "Variation_733":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_300:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_300:
        return self.rule.content

RuleVariation_722_Arg: TypeAlias = Variation_733_Arg
class RuleVariation_722(RuleVariationContextFree):
    cv_variation = Variation_733

    @classmethod
    def create(cls, arg : RuleVariation_722_Arg) -> "RuleVariation_722":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_733:
        return self.arg # type: ignore

NonSpare_1369_Arg: TypeAlias = RuleVariation_722_Arg
class NonSpare_1369(NonSpare):
    cv_name = "NOV"
    cv_title = "Validity of NO"
    cv_rule = RuleVariation_722

    @classmethod
    def create(cls, arg : NonSpare_1369_Arg) -> "NonSpare_1369":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_722:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_733:
        return self.rule.variation

Item_635_Arg: TypeAlias = NonSpare_1369_Arg
class Item_635(Item):
    cv_non_spare = NonSpare_1369

    @classmethod
    def create(cls, arg : Item_635_Arg) -> "Item_635":
        return cls._create(arg) # type: ignore

NonSpare_1351_Arg: TypeAlias = RuleVariation_861_Arg
class NonSpare_1351(NonSpare):
    cv_name = "NO"
    cv_title = "National Origin"
    cv_rule = RuleVariation_861

    @classmethod
    def create(cls, arg : NonSpare_1351_Arg) -> "NonSpare_1351":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_861:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_891:
        return self.rule.variation

Item_617_Arg: TypeAlias = NonSpare_1351_Arg
class Item_617(Item):
    cv_non_spare = NonSpare_1351

    @classmethod
    def create(cls, arg : Item_617_Arg) -> "Item_617":
        return cls._create(arg) # type: ignore

Variation_1004_Arg_Group = Tuple[int, Union[RuleVariation_590_Arg, Tuple[Literal["PIN"], RuleVariation_590_Arg]], int, Union[RuleVariation_722_Arg, Tuple[Literal["NOV"], RuleVariation_722_Arg]], Union[RuleVariation_861_Arg, Tuple[Literal["NO"], RuleVariation_861_Arg]]]
Variation_1004_Arg: TypeAlias = Union[int, Variation_1004_Arg_Group]
class Variation_1004(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1, 2), (Item_681, 14), (Item_3, 4), (Item_635, 1), (Item_617, 11)]
    cv_items_dict = {"PIN": RuleVariation_590, "NOV": RuleVariation_722, "NO": RuleVariation_861}

    @overload
    @classmethod
    def spec(cls, key : Literal["PIN"]) -> RuleVariation_590:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NOV"]) -> RuleVariation_722:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NO"]) -> RuleVariation_861:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PIN"], Literal["NOV"], Literal["NO"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PIN"]) -> RuleVariation_590:
        ...
    @overload
    def get_item(self, key : Literal["NOV"]) -> RuleVariation_722:
        ...
    @overload
    def get_item(self, key : Literal["NO"]) -> RuleVariation_861:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1004_Arg) -> 'Variation_1004':
        return cls._create(arg) # type: ignore

RuleVariation_974_Arg: TypeAlias = Variation_1004_Arg
class RuleVariation_974(RuleVariationContextFree):
    cv_variation = Variation_1004

    @classmethod
    def create(cls, arg : RuleVariation_974_Arg) -> "RuleVariation_974":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1004:
        return self.arg # type: ignore

NonSpare_1426_Arg: TypeAlias = RuleVariation_974_Arg
class NonSpare_1426(NonSpare):
    cv_name = "PMN"
    cv_title = "PIN/ National Origin/Mission Code"
    cv_rule = RuleVariation_974

    @classmethod
    def create(cls, arg : NonSpare_1426_Arg) -> "NonSpare_1426":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_974:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1004:
        return self.rule.variation

NonSpare_1436_Arg: TypeAlias = RuleVariation_1084_Arg
class NonSpare_1436(NonSpare):
    cv_name = "POS"
    cv_title = "Mode 5 Reported Position"
    cv_rule = RuleVariation_1084

    @classmethod
    def create(cls, arg : NonSpare_1436_Arg) -> "NonSpare_1436":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1084:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1127:
        return self.rule.variation

NonSpare_1573_Arg: TypeAlias = RuleVariation_414_Arg
class NonSpare_1573(NonSpare):
    cv_name = "RES"
    cv_title = ""
    cv_rule = RuleVariation_414

    @classmethod
    def create(cls, arg : NonSpare_1573_Arg) -> "NonSpare_1573":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_414:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_425:
        return self.rule.variation

Item_804_Arg: TypeAlias = NonSpare_1573_Arg
class Item_804(Item):
    cv_non_spare = NonSpare_1573

    @classmethod
    def create(cls, arg : Item_804_Arg) -> "Item_804":
        return cls._create(arg) # type: ignore

NonSpare_1006_Arg: TypeAlias = RuleVariation_593_Arg
class NonSpare_1006(NonSpare):
    cv_name = "GA"
    cv_title = ""
    cv_rule = RuleVariation_593

    @classmethod
    def create(cls, arg : NonSpare_1006_Arg) -> "NonSpare_1006":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_593:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_604:
        return self.rule.variation

Item_357_Arg: TypeAlias = NonSpare_1006_Arg
class Item_357(Item):
    cv_non_spare = NonSpare_1006

    @classmethod
    def create(cls, arg : Item_357_Arg) -> "Item_357":
        return cls._create(arg) # type: ignore

Variation_997_Arg_Group = Tuple[int, Union[RuleVariation_414_Arg, Tuple[Literal["RES"], RuleVariation_414_Arg]], Union[RuleVariation_593_Arg, Tuple[Literal["GA"], RuleVariation_593_Arg]]]
Variation_997_Arg: TypeAlias = Union[int, Variation_997_Arg_Group]
class Variation_997(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_0, 1), (Item_804, 1), (Item_357, 14)]
    cv_items_dict = {"RES": RuleVariation_414, "GA": RuleVariation_593}

    @overload
    @classmethod
    def spec(cls, key : Literal["RES"]) -> RuleVariation_414:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GA"]) -> RuleVariation_593:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RES"], Literal["GA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RES"]) -> RuleVariation_414:
        ...
    @overload
    def get_item(self, key : Literal["GA"]) -> RuleVariation_593:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_997_Arg) -> 'Variation_997':
        return cls._create(arg) # type: ignore

RuleVariation_967_Arg: TypeAlias = Variation_997_Arg
class RuleVariation_967(RuleVariationContextFree):
    cv_variation = Variation_997

    @classmethod
    def create(cls, arg : RuleVariation_967_Arg) -> "RuleVariation_967":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_997:
        return self.arg # type: ignore

NonSpare_1009_Arg: TypeAlias = RuleVariation_967_Arg
class NonSpare_1009(NonSpare):
    cv_name = "GA"
    cv_title = "Mode 5 GNSS-derived Altitude"
    cv_rule = RuleVariation_967

    @classmethod
    def create(cls, arg : NonSpare_1009_Arg) -> "NonSpare_1009":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_967:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_997:
        return self.rule.variation

NonSpare_974_Arg: TypeAlias = RuleVariation_681_Arg
class NonSpare_974(NonSpare):
    cv_name = "FOM"
    cv_title = ""
    cv_rule = RuleVariation_681

    @classmethod
    def create(cls, arg : NonSpare_974_Arg) -> "NonSpare_974":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_681:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_692:
        return self.rule.variation

Item_334_Arg: TypeAlias = NonSpare_974_Arg
class Item_334(Item):
    cv_non_spare = NonSpare_974

    @classmethod
    def create(cls, arg : Item_334_Arg) -> "Item_334":
        return cls._create(arg) # type: ignore

Variation_1010_Arg_Group = Tuple[int, Union[RuleVariation_681_Arg, Tuple[Literal["FOM"], RuleVariation_681_Arg]]]
Variation_1010_Arg: TypeAlias = Union[int, Variation_1010_Arg_Group]
class Variation_1010(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_2, 3), (Item_334, 5)]
    cv_items_dict = {"FOM": RuleVariation_681}

    @classmethod
    def spec(cls, key : Literal["FOM"]) -> RuleVariation_681:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["FOM"]) -> RuleVariation_681:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1010_Arg) -> 'Variation_1010':
        return cls._create(arg) # type: ignore

RuleVariation_980_Arg: TypeAlias = Variation_1010_Arg
class RuleVariation_980(RuleVariationContextFree):
    cv_variation = Variation_1010

    @classmethod
    def create(cls, arg : RuleVariation_980_Arg) -> "RuleVariation_980":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1010:
        return self.arg # type: ignore

NonSpare_976_Arg: TypeAlias = RuleVariation_980_Arg
class NonSpare_976(NonSpare):
    cv_name = "FOM"
    cv_title = "Figure of Merit"
    cv_rule = RuleVariation_980

    @classmethod
    def create(cls, arg : NonSpare_976_Arg) -> "NonSpare_976":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_980:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1010:
        return self.rule.variation

Variation_1502_Arg = TypedDict('Variation_1502_Arg', {
    "SUM": NonSpare_1803_Arg,
    "PMN": NonSpare_1426_Arg,
    "POS": NonSpare_1436_Arg,
    "GA": NonSpare_1009_Arg,
    "EM1": NonSpare_918_Arg,
    "TOS": NonSpare_1879_Arg,
    "XP": NonSpare_2106_Arg,
    "FOM": NonSpare_976_Arg,
}, total=False)
class Variation_1502(Compound):
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1803, NonSpare_1426, NonSpare_1436, NonSpare_1009, NonSpare_918, NonSpare_1879, NonSpare_2106, NonSpare_976]
    cv_items_dict = {"SUM": NonSpare_1803, "PMN": NonSpare_1426, "POS": NonSpare_1436, "GA": NonSpare_1009, "EM1": NonSpare_918, "TOS": NonSpare_1879, "XP": NonSpare_2106, "FOM": NonSpare_976}

    @overload
    @classmethod
    def spec(cls, key : Literal["SUM"]) -> NonSpare_1803:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PMN"]) -> NonSpare_1426:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1436:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GA"]) -> NonSpare_1009:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EM1"]) -> NonSpare_918:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOS"]) -> NonSpare_1879:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XP"]) -> NonSpare_2106:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FOM"]) -> NonSpare_976:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SUM"], Literal["PMN"], Literal["POS"], Literal["GA"], Literal["EM1"], Literal["TOS"], Literal["XP"], Literal["FOM"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SUM"]) -> Optional[NonSpare_1803]:
        ...
    @overload
    def get_item(self, key : Literal["PMN"]) -> Optional[NonSpare_1426]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1436]:
        ...
    @overload
    def get_item(self, key : Literal["GA"]) -> Optional[NonSpare_1009]:
        ...
    @overload
    def get_item(self, key : Literal["EM1"]) -> Optional[NonSpare_918]:
        ...
    @overload
    def get_item(self, key : Literal["TOS"]) -> Optional[NonSpare_1879]:
        ...
    @overload
    def get_item(self, key : Literal["XP"]) -> Optional[NonSpare_2106]:
        ...
    @overload
    def get_item(self, key : Literal["FOM"]) -> Optional[NonSpare_976]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["SUM"], val : NonSpare_1803_Arg) -> "Variation_1502":
        ...
    @overload
    def set_item(self, key : Literal["PMN"], val : NonSpare_1426_Arg) -> "Variation_1502":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1436_Arg) -> "Variation_1502":
        ...
    @overload
    def set_item(self, key : Literal["GA"], val : NonSpare_1009_Arg) -> "Variation_1502":
        ...
    @overload
    def set_item(self, key : Literal["EM1"], val : NonSpare_918_Arg) -> "Variation_1502":
        ...
    @overload
    def set_item(self, key : Literal["TOS"], val : NonSpare_1879_Arg) -> "Variation_1502":
        ...
    @overload
    def set_item(self, key : Literal["XP"], val : NonSpare_2106_Arg) -> "Variation_1502":
        ...
    @overload
    def set_item(self, key : Literal["FOM"], val : NonSpare_976_Arg) -> "Variation_1502":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["SUM"]) -> "Variation_1502":
        ...
    @overload
    def del_item(self, key : Literal["PMN"]) -> "Variation_1502":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1502":
        ...
    @overload
    def del_item(self, key : Literal["GA"]) -> "Variation_1502":
        ...
    @overload
    def del_item(self, key : Literal["EM1"]) -> "Variation_1502":
        ...
    @overload
    def del_item(self, key : Literal["TOS"]) -> "Variation_1502":
        ...
    @overload
    def del_item(self, key : Literal["XP"]) -> "Variation_1502":
        ...
    @overload
    def del_item(self, key : Literal["FOM"]) -> "Variation_1502":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1502_Arg) -> 'Variation_1502':
        return cls._create(arg) # type: ignore

RuleVariation_1425_Arg: TypeAlias = Variation_1502_Arg
class RuleVariation_1425(RuleVariationContextFree):
    cv_variation = Variation_1502

    @classmethod
    def create(cls, arg : RuleVariation_1425_Arg) -> "RuleVariation_1425":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1502:
        return self.arg # type: ignore

NonSpare_1210_Arg: TypeAlias = RuleVariation_1425_Arg
class NonSpare_1210(NonSpare):
    cv_name = "M5N"
    cv_title = "Mode 5 Reports, New Format"
    cv_rule = RuleVariation_1425

    @classmethod
    def create(cls, arg : NonSpare_1210_Arg) -> "NonSpare_1210":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1425:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1502:
        return self.rule.variation

Content_308_Arg: TypeAlias = int
class Content_308(ContentTable):
    cv_values = {0: "No Mode 4 interrogation", 1: "Possibly friendly target", 2: "Probably friendly target", 3: "Friendly target"}

RuleContent_308_Arg: TypeAlias = Content_308_Arg
class RuleContent_308(RuleContentContextFree):
    cv_content = Content_308

    @property
    def content(self) -> Content_308:
        return self._get_content() # type: ignore

Variation_878_Arg: TypeAlias = RuleContent_308_Arg
class Variation_878(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_308

    @classmethod
    def create(cls, arg : Variation_878_Arg) -> "Variation_878":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_308:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_308:
        return self.rule.content

RuleVariation_848_Arg: TypeAlias = Variation_878_Arg
class RuleVariation_848(RuleVariationContextFree):
    cv_variation = Variation_878

    @classmethod
    def create(cls, arg : RuleVariation_848_Arg) -> "RuleVariation_848":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_878:
        return self.arg # type: ignore

NonSpare_973_Arg: TypeAlias = RuleVariation_848_Arg
class NonSpare_973(NonSpare):
    cv_name = "FOEFRI"
    cv_title = "Indication Foe/Friend (Mode4)"
    cv_rule = RuleVariation_848

    @classmethod
    def create(cls, arg : NonSpare_973_Arg) -> "NonSpare_973":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_848:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_878:
        return self.rule.variation

Item_333_Arg: TypeAlias = NonSpare_973_Arg
class Item_333(Item):
    cv_non_spare = NonSpare_973

    @classmethod
    def create(cls, arg : Item_333_Arg) -> "Item_333":
        return cls._create(arg) # type: ignore

Variation_1338_Arg_Group_1: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_848_Arg, Tuple[Literal["FOEFRI"], RuleVariation_848_Arg]], None]]
Variation_1338_Arg: TypeAlias = Union[
    Tuple[Variation_1338_Arg_Group_1],
]
class Variation_1338(Extended):
    cv_items_list = [[(Item_4, 5), (Item_333, 2), None]]

    @classmethod
    def create(cls, arg : Variation_1338_Arg) -> 'Variation_1338':
        return cls._create(arg) # type: ignore

    @overload # type: ignore
    def get_item(self, key : Literal["FOEFRI"]) -> RuleVariation_848:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1261_Arg: TypeAlias = Variation_1338_Arg
class RuleVariation_1261(RuleVariationContextFree):
    cv_variation = Variation_1338

    @classmethod
    def create(cls, arg : RuleVariation_1261_Arg) -> "RuleVariation_1261":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1338:
        return self.arg # type: ignore

NonSpare_1208_Arg: TypeAlias = RuleVariation_1261_Arg
class NonSpare_1208(NonSpare):
    cv_name = "M4E"
    cv_title = "Extended Mode 4 Report"
    cv_rule = RuleVariation_1261

    @classmethod
    def create(cls, arg : NonSpare_1208_Arg) -> "NonSpare_1208":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1261:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1338:
        return self.rule.variation

NonSpare_1662_Arg: TypeAlias = RuleVariation_196_Arg
class NonSpare_1662(NonSpare):
    cv_name = "SCO"
    cv_title = "Score"
    cv_rule = RuleVariation_196

    @classmethod
    def create(cls, arg : NonSpare_1662_Arg) -> "NonSpare_1662":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_203:
        return self.rule.variation

Content_732_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["dB"]]]
class Content_732(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.1
    cv_unit = "dB"

    def as_quantity(self, cv_unit : Optional[Literal["dB"]] = None) -> float:
        return self._as_quantity()

RuleContent_732_Arg: TypeAlias = Content_732_Arg
class RuleContent_732(RuleContentContextFree):
    cv_content = Content_732

    @property
    def content(self) -> Content_732:
        return self._get_content() # type: ignore

Variation_311_Arg: TypeAlias = RuleContent_732_Arg
class Variation_311(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_732

    @classmethod
    def create(cls, arg : Variation_311_Arg) -> "Variation_311":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_732:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_732:
        return self.rule.content

RuleVariation_304_Arg: TypeAlias = Variation_311_Arg
class RuleVariation_304(RuleVariationContextFree):
    cv_variation = Variation_311

    @classmethod
    def create(cls, arg : RuleVariation_304_Arg) -> "RuleVariation_304":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_311:
        return self.arg # type: ignore

NonSpare_1740_Arg: TypeAlias = RuleVariation_304_Arg
class NonSpare_1740(NonSpare):
    cv_name = "SRC"
    cv_title = "Signal/Clutter Ratio"
    cv_rule = RuleVariation_304

    @classmethod
    def create(cls, arg : NonSpare_1740_Arg) -> "NonSpare_1740":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_304:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_311:
        return self.rule.variation

Content_773_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
class Content_773(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 3.90625e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

RuleContent_772_Arg: TypeAlias = Content_773_Arg
class RuleContent_772(RuleContentContextFree):
    cv_content = Content_773

    @property
    def content(self) -> Content_773:
        return self._get_content() # type: ignore

Variation_335_Arg: TypeAlias = RuleContent_772_Arg
class Variation_335(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_772

    @classmethod
    def create(cls, arg : Variation_335_Arg) -> "Variation_335":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_772:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_773:
        return self.rule.content

RuleVariation_328_Arg: TypeAlias = Variation_335_Arg
class RuleVariation_328(RuleVariationContextFree):
    cv_variation = Variation_335

    @classmethod
    def create(cls, arg : RuleVariation_328_Arg) -> "RuleVariation_328":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_335:
        return self.arg # type: ignore

NonSpare_1632_Arg: TypeAlias = RuleVariation_328_Arg
class NonSpare_1632(NonSpare):
    cv_name = "RW"
    cv_title = "Range Width"
    cv_rule = RuleVariation_328

    @classmethod
    def create(cls, arg : NonSpare_1632_Arg) -> "NonSpare_1632":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_328:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_335:
        return self.rule.variation

NonSpare_618_Arg: TypeAlias = RuleVariation_328_Arg
class NonSpare_618(NonSpare):
    cv_name = "AR"
    cv_title = "Ambiguous Range"
    cv_rule = RuleVariation_328

    @classmethod
    def create(cls, arg : NonSpare_618_Arg) -> "NonSpare_618":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_328:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_335:
        return self.rule.variation

Variation_1495_Arg = TypedDict('Variation_1495_Arg', {
    "SCO": NonSpare_1662_Arg,
    "SRC": NonSpare_1740_Arg,
    "RW": NonSpare_1632_Arg,
    "AR": NonSpare_618_Arg,
}, total=False)
class Variation_1495(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1662, NonSpare_1740, NonSpare_1632, NonSpare_618]
    cv_items_dict = {"SCO": NonSpare_1662, "SRC": NonSpare_1740, "RW": NonSpare_1632, "AR": NonSpare_618}

    @overload
    @classmethod
    def spec(cls, key : Literal["SCO"]) -> NonSpare_1662:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SRC"]) -> NonSpare_1740:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RW"]) -> NonSpare_1632:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AR"]) -> NonSpare_618:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SCO"], Literal["SRC"], Literal["RW"], Literal["AR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SCO"]) -> Optional[NonSpare_1662]:
        ...
    @overload
    def get_item(self, key : Literal["SRC"]) -> Optional[NonSpare_1740]:
        ...
    @overload
    def get_item(self, key : Literal["RW"]) -> Optional[NonSpare_1632]:
        ...
    @overload
    def get_item(self, key : Literal["AR"]) -> Optional[NonSpare_618]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["SCO"], val : NonSpare_1662_Arg) -> "Variation_1495":
        ...
    @overload
    def set_item(self, key : Literal["SRC"], val : NonSpare_1740_Arg) -> "Variation_1495":
        ...
    @overload
    def set_item(self, key : Literal["RW"], val : NonSpare_1632_Arg) -> "Variation_1495":
        ...
    @overload
    def set_item(self, key : Literal["AR"], val : NonSpare_618_Arg) -> "Variation_1495":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["SCO"]) -> "Variation_1495":
        ...
    @overload
    def del_item(self, key : Literal["SRC"]) -> "Variation_1495":
        ...
    @overload
    def del_item(self, key : Literal["RW"]) -> "Variation_1495":
        ...
    @overload
    def del_item(self, key : Literal["AR"]) -> "Variation_1495":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1495_Arg) -> 'Variation_1495':
        return cls._create(arg) # type: ignore

RuleVariation_1418_Arg: TypeAlias = Variation_1495_Arg
class RuleVariation_1418(RuleVariationContextFree):
    cv_variation = Variation_1495

    @classmethod
    def create(cls, arg : RuleVariation_1418_Arg) -> "RuleVariation_1418":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1495:
        return self.arg # type: ignore

NonSpare_1594_Arg: TypeAlias = RuleVariation_1418_Arg
class NonSpare_1594(NonSpare):
    cv_name = "RPC"
    cv_title = "Radar Plot Characteristics"
    cv_rule = RuleVariation_1418

    @classmethod
    def create(cls, arg : NonSpare_1594_Arg) -> "NonSpare_1594":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1418:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1495:
        return self.rule.variation

Content_772_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
class Content_772(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 3.90625e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

RuleContent_771_Arg: TypeAlias = Content_772_Arg
class RuleContent_771(RuleContentContextFree):
    cv_content = Content_772

    @property
    def content(self) -> Content_772:
        return self._get_content() # type: ignore

Variation_370_Arg: TypeAlias = RuleContent_771_Arg
class Variation_370(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_771

    @classmethod
    def create(cls, arg : Variation_370_Arg) -> "Variation_370":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_771:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_772:
        return self.rule.content

RuleVariation_363_Arg: TypeAlias = Variation_370_Arg
class RuleVariation_363(RuleVariationContextFree):
    cv_variation = Variation_370

    @classmethod
    def create(cls, arg : RuleVariation_363_Arg) -> "RuleVariation_363":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_370:
        return self.arg # type: ignore

NonSpare_951_Arg: TypeAlias = RuleVariation_363_Arg
class NonSpare_951(NonSpare):
    cv_name = "ERR"
    cv_title = "Extended Range Report"
    cv_rule = RuleVariation_363

    @classmethod
    def create(cls, arg : NonSpare_951_Arg) -> "NonSpare_951":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

Content_510_Arg: TypeAlias = int
class Content_510(ContentTable):
    cv_values = {0: "Track is not associated with an SCN Plot", 1: "Track is associated with an SCN Plot"}

RuleContent_510_Arg: TypeAlias = Content_510_Arg
class RuleContent_510(RuleContentContextFree):
    cv_content = Content_510

    @property
    def content(self) -> Content_510:
        return self._get_content() # type: ignore

Variation_663_Arg: TypeAlias = RuleContent_510_Arg
class Variation_663(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_510

    @classmethod
    def create(cls, arg : Variation_663_Arg) -> "Variation_663":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_510:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_510:
        return self.rule.content

RuleVariation_652_Arg: TypeAlias = Variation_663_Arg
class RuleVariation_652(RuleVariationContextFree):
    cv_variation = Variation_663

    @classmethod
    def create(cls, arg : RuleVariation_652_Arg) -> "RuleVariation_652":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_663:
        return self.arg # type: ignore

NonSpare_1661_Arg: TypeAlias = RuleVariation_652_Arg
class NonSpare_1661(NonSpare):
    cv_name = "SCN"
    cv_title = "Track / SCN Association"
    cv_rule = RuleVariation_652

    @classmethod
    def create(cls, arg : NonSpare_1661_Arg) -> "NonSpare_1661":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_652:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_663:
        return self.rule.variation

Item_862_Arg: TypeAlias = NonSpare_1661_Arg
class Item_862(Item):
    cv_non_spare = NonSpare_1661

    @classmethod
    def create(cls, arg : Item_862_Arg) -> "Item_862":
        return cls._create(arg) # type: ignore

Content_38_Arg: TypeAlias = int
class Content_38(ContentTable):
    cv_values = {0: "Associated Plot does not contain a Roll Call component", 1: "Associated Plot contains at least a Roll Call component"}

RuleContent_38_Arg: TypeAlias = Content_38_Arg
class RuleContent_38(RuleContentContextFree):
    cv_content = Content_38

    @property
    def content(self) -> Content_38:
        return self._get_content() # type: ignore

Variation_698_Arg: TypeAlias = RuleContent_38_Arg
class Variation_698(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_38

    @classmethod
    def create(cls, arg : Variation_698_Arg) -> "Variation_698":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_38:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_38:
        return self.rule.content

RuleVariation_687_Arg: TypeAlias = Variation_698_Arg
class RuleVariation_687(RuleVariationContextFree):
    cv_variation = Variation_698

    @classmethod
    def create(cls, arg : RuleVariation_687_Arg) -> "RuleVariation_687":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_698:
        return self.arg # type: ignore

NonSpare_1544_Arg: TypeAlias = RuleVariation_687_Arg
class NonSpare_1544(NonSpare):
    cv_name = "RC"
    cv_title = "Roll Call Component"
    cv_rule = RuleVariation_687

    @classmethod
    def create(cls, arg : NonSpare_1544_Arg) -> "NonSpare_1544":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_687:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_698:
        return self.rule.variation

Item_778_Arg: TypeAlias = NonSpare_1544_Arg
class Item_778(Item):
    cv_non_spare = NonSpare_1544

    @classmethod
    def create(cls, arg : Item_778_Arg) -> "Item_778":
        return cls._create(arg) # type: ignore

Content_39_Arg: TypeAlias = int
class Content_39(ContentTable):
    cv_values = {0: "Associated Plot does not contain an All Call component", 1: "Associated Plot contains at least an All Call component"}

RuleContent_39_Arg: TypeAlias = Content_39_Arg
class RuleContent_39(RuleContentContextFree):
    cv_content = Content_39

    @property
    def content(self) -> Content_39:
        return self._get_content() # type: ignore

Variation_820_Arg: TypeAlias = RuleContent_39_Arg
class Variation_820(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_39

    @classmethod
    def create(cls, arg : Variation_820_Arg) -> "Variation_820":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_39:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_39:
        return self.rule.content

RuleVariation_790_Arg: TypeAlias = Variation_820_Arg
class RuleVariation_790(RuleVariationContextFree):
    cv_variation = Variation_820

    @classmethod
    def create(cls, arg : RuleVariation_790_Arg) -> "RuleVariation_790":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_820:
        return self.arg # type: ignore

NonSpare_552_Arg: TypeAlias = RuleVariation_790_Arg
class NonSpare_552(NonSpare):
    cv_name = "AC"
    cv_title = "All Call Component"
    cv_rule = RuleVariation_790

    @classmethod
    def create(cls, arg : NonSpare_552_Arg) -> "NonSpare_552":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_790:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_820:
        return self.rule.variation

Item_39_Arg: TypeAlias = NonSpare_552_Arg
class Item_39(Item):
    cv_non_spare = NonSpare_552

    @classmethod
    def create(cls, arg : Item_39_Arg) -> "Item_39":
        return cls._create(arg) # type: ignore

Content_40_Arg: TypeAlias = int
class Content_40(ContentTable):
    cv_values = {0: "Associated Plot does not contain an SSR component", 1: "Associated Plot contains at least an SSR component"}

RuleContent_40_Arg: TypeAlias = Content_40_Arg
class RuleContent_40(RuleContentContextFree):
    cv_content = Content_40

    @property
    def content(self) -> Content_40:
        return self._get_content() # type: ignore

Variation_900_Arg: TypeAlias = RuleContent_40_Arg
class Variation_900(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_40

    @classmethod
    def create(cls, arg : Variation_900_Arg) -> "Variation_900":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_40:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_40:
        return self.rule.content

RuleVariation_870_Arg: TypeAlias = Variation_900_Arg
class RuleVariation_870(RuleVariationContextFree):
    cv_variation = Variation_900

    @classmethod
    def create(cls, arg : RuleVariation_870_Arg) -> "RuleVariation_870":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_900:
        return self.arg # type: ignore

NonSpare_1754_Arg: TypeAlias = RuleVariation_870_Arg
class NonSpare_1754(NonSpare):
    cv_name = "SSR"
    cv_title = "SSR Component"
    cv_rule = RuleVariation_870

    @classmethod
    def create(cls, arg : NonSpare_1754_Arg) -> "NonSpare_1754":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_870:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_900:
        return self.rule.variation

Item_927_Arg: TypeAlias = NonSpare_1754_Arg
class Item_927(Item):
    cv_non_spare = NonSpare_1754

    @classmethod
    def create(cls, arg : Item_927_Arg) -> "Item_927":
        return cls._create(arg) # type: ignore

Content_37_Arg: TypeAlias = int
class Content_37(ContentTable):
    cv_values = {0: "Associated Plot does not contain a PSR component", 1: "Associated Plot contains at least a PSR component"}

RuleContent_37_Arg: TypeAlias = Content_37_Arg
class RuleContent_37(RuleContentContextFree):
    cv_content = Content_37

    @property
    def content(self) -> Content_37:
        return self._get_content() # type: ignore

Variation_970_Arg: TypeAlias = RuleContent_37_Arg
class Variation_970(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_37

    @classmethod
    def create(cls, arg : Variation_970_Arg) -> "Variation_970":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_37:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_37:
        return self.rule.content

RuleVariation_940_Arg: TypeAlias = Variation_970_Arg
class RuleVariation_940(RuleVariationContextFree):
    cv_variation = Variation_970

    @classmethod
    def create(cls, arg : RuleVariation_940_Arg) -> "RuleVariation_940":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_970:
        return self.arg # type: ignore

NonSpare_1467_Arg: TypeAlias = RuleVariation_940_Arg
class NonSpare_1467(NonSpare):
    cv_name = "PSR"
    cv_title = "PSR Component"
    cv_rule = RuleVariation_940

    @classmethod
    def create(cls, arg : NonSpare_1467_Arg) -> "NonSpare_1467":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_940:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_970:
        return self.rule.variation

Item_711_Arg: TypeAlias = NonSpare_1467_Arg
class Item_711(Item):
    cv_non_spare = NonSpare_1467

    @classmethod
    def create(cls, arg : Item_711_Arg) -> "Item_711":
        return cls._create(arg) # type: ignore

NonSpare_1423_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_1423(NonSpare):
    cv_name = "PLOTNR"
    cv_title = ""
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_1423_Arg) -> "NonSpare_1423":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

Item_683_Arg: TypeAlias = NonSpare_1423_Arg
class Item_683(Item):
    cv_non_spare = NonSpare_1423

    @classmethod
    def create(cls, arg : Item_683_Arg) -> "Item_683":
        return cls._create(arg) # type: ignore

Variation_1013_Arg_Group = Tuple[int, Union[RuleVariation_652_Arg, Tuple[Literal["SCN"], RuleVariation_652_Arg]], Union[RuleVariation_687_Arg, Tuple[Literal["RC"], RuleVariation_687_Arg]], Union[RuleVariation_790_Arg, Tuple[Literal["AC"], RuleVariation_790_Arg]], Union[RuleVariation_870_Arg, Tuple[Literal["SSR"], RuleVariation_870_Arg]], Union[RuleVariation_940_Arg, Tuple[Literal["PSR"], RuleVariation_940_Arg]], Union[RuleVariation_244_Arg, Tuple[Literal["PLOTNR"], RuleVariation_244_Arg]]]
Variation_1013_Arg: TypeAlias = Union[int, Variation_1013_Arg_Group]
class Variation_1013(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_2, 3), (Item_862, 1), (Item_778, 1), (Item_39, 1), (Item_927, 1), (Item_711, 1), (Item_683, 16)]
    cv_items_dict = {"SCN": RuleVariation_652, "RC": RuleVariation_687, "AC": RuleVariation_790, "SSR": RuleVariation_870, "PSR": RuleVariation_940, "PLOTNR": RuleVariation_244}

    @overload
    @classmethod
    def spec(cls, key : Literal["SCN"]) -> RuleVariation_652:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RC"]) -> RuleVariation_687:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AC"]) -> RuleVariation_790:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSR"]) -> RuleVariation_870:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PSR"]) -> RuleVariation_940:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PLOTNR"]) -> RuleVariation_244:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SCN"], Literal["RC"], Literal["AC"], Literal["SSR"], Literal["PSR"], Literal["PLOTNR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SCN"]) -> RuleVariation_652:
        ...
    @overload
    def get_item(self, key : Literal["RC"]) -> RuleVariation_687:
        ...
    @overload
    def get_item(self, key : Literal["AC"]) -> RuleVariation_790:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> RuleVariation_870:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> RuleVariation_940:
        ...
    @overload
    def get_item(self, key : Literal["PLOTNR"]) -> RuleVariation_244:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1013_Arg) -> 'Variation_1013':
        return cls._create(arg) # type: ignore

RuleVariation_983_Arg: TypeAlias = Variation_1013_Arg
class RuleVariation_983(RuleVariationContextFree):
    cv_variation = Variation_1013

    @classmethod
    def create(cls, arg : RuleVariation_983_Arg) -> "RuleVariation_983":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1013:
        return self.arg # type: ignore

NonSpare_1473_Arg: TypeAlias = RuleVariation_983_Arg
class NonSpare_1473(NonSpare):
    cv_name = "PTL"
    cv_title = "Plot/Track Link"
    cv_rule = RuleVariation_983

    @classmethod
    def create(cls, arg : NonSpare_1473_Arg) -> "NonSpare_1473":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_983:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1013:
        return self.rule.variation

Variation_1389_Arg: TypeAlias = List[Variation_251_Arg]
class Variation_1389(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_251

    @classmethod
    def create(cls, arg : Variation_1389_Arg) -> 'Variation_1389':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_251]:
        return self._get_list() # type: ignore

RuleVariation_1312_Arg: TypeAlias = Variation_1389_Arg
class RuleVariation_1312(RuleVariationContextFree):
    cv_variation = Variation_1389

    @classmethod
    def create(cls, arg : RuleVariation_1312_Arg) -> "RuleVariation_1312":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1389:
        return self.arg # type: ignore

NonSpare_636_Arg: TypeAlias = RuleVariation_1312_Arg
class NonSpare_636(NonSpare):
    cv_name = "ATL"
    cv_title = "ADS-B/Track Link"
    cv_rule = RuleVariation_1312

    @classmethod
    def create(cls, arg : NonSpare_636_Arg) -> "NonSpare_636":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1312:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1389:
        return self.rule.variation

Content_708_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["%"]]]
class Content_708(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = "%"

    def as_quantity(self, cv_unit : Optional[Literal["%"]] = None) -> float:
        return self._as_quantity()

RuleContent_708_Arg: TypeAlias = Content_708_Arg
class RuleContent_708(RuleContentContextFree):
    cv_content = Content_708

    @property
    def content(self) -> Content_708:
        return self._get_content() # type: ignore

Variation_219_Arg: TypeAlias = RuleContent_708_Arg
class Variation_219(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_708

    @classmethod
    def create(cls, arg : Variation_219_Arg) -> "Variation_219":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_708:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_708:
        return self.rule.content

RuleVariation_212_Arg: TypeAlias = Variation_219_Arg
class RuleVariation_212(RuleVariationContextFree):
    cv_variation = Variation_219

    @classmethod
    def create(cls, arg : RuleVariation_212_Arg) -> "RuleVariation_212":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_219:
        return self.arg # type: ignore

NonSpare_1913_Arg: TypeAlias = RuleVariation_212_Arg
class NonSpare_1913(NonSpare):
    cv_name = "TRN"
    cv_title = "Turn State"
    cv_rule = RuleVariation_212

    @classmethod
    def create(cls, arg : NonSpare_1913_Arg) -> "NonSpare_1913":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_212:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_219:
        return self.rule.variation

Content_763_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
class Content_763(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 7.8125e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

RuleContent_762_Arg: TypeAlias = Content_763_Arg
class RuleContent_762(RuleContentContextFree):
    cv_content = Content_763

    @property
    def content(self) -> Content_763:
        return self._get_content() # type: ignore

Variation_328_Arg: TypeAlias = RuleContent_762_Arg
class Variation_328(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_762

    @classmethod
    def create(cls, arg : Variation_328_Arg) -> "Variation_328":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_762:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_763:
        return self.rule.content

RuleVariation_321_Arg: TypeAlias = Variation_328_Arg
class RuleVariation_321(RuleVariationContextFree):
    cv_variation = Variation_328

    @classmethod
    def create(cls, arg : RuleVariation_321_Arg) -> "RuleVariation_321":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_328:
        return self.arg # type: ignore

NonSpare_1449_Arg: TypeAlias = RuleVariation_321_Arg
class NonSpare_1449(NonSpare):
    cv_name = "PREDRHO"
    cv_title = "Predicted Range"
    cv_rule = RuleVariation_321

    @classmethod
    def create(cls, arg : NonSpare_1449_Arg) -> "NonSpare_1449":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_321:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_328:
        return self.rule.variation

Item_698_Arg: TypeAlias = NonSpare_1449_Arg
class Item_698(Item):
    cv_non_spare = NonSpare_1449

    @classmethod
    def create(cls, arg : Item_698_Arg) -> "Item_698":
        return cls._create(arg) # type: ignore

NonSpare_1450_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_1450(NonSpare):
    cv_name = "PREDTHETA"
    cv_title = "Predicted Azimuth"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_1450_Arg) -> "NonSpare_1450":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Item_699_Arg: TypeAlias = NonSpare_1450_Arg
class Item_699(Item):
    cv_non_spare = NonSpare_1450

    @classmethod
    def create(cls, arg : Item_699_Arg) -> "Item_699":
        return cls._create(arg) # type: ignore

NonSpare_957_Arg: TypeAlias = RuleVariation_321_Arg
class NonSpare_957(NonSpare):
    cv_name = "EVOLRHOSTART"
    cv_title = "Predicted Closest Range"
    cv_rule = RuleVariation_321

    @classmethod
    def create(cls, arg : NonSpare_957_Arg) -> "NonSpare_957":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_321:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_328:
        return self.rule.variation

Item_321_Arg: TypeAlias = NonSpare_957_Arg
class Item_321(Item):
    cv_non_spare = NonSpare_957

    @classmethod
    def create(cls, arg : Item_321_Arg) -> "Item_321":
        return cls._create(arg) # type: ignore

NonSpare_956_Arg: TypeAlias = RuleVariation_321_Arg
class NonSpare_956(NonSpare):
    cv_name = "EVOLRHOEND"
    cv_title = "Predicted Largest Range"
    cv_rule = RuleVariation_321

    @classmethod
    def create(cls, arg : NonSpare_956_Arg) -> "NonSpare_956":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_321:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_328:
        return self.rule.variation

Item_320_Arg: TypeAlias = NonSpare_956_Arg
class Item_320(Item):
    cv_non_spare = NonSpare_956

    @classmethod
    def create(cls, arg : Item_320_Arg) -> "Item_320":
        return cls._create(arg) # type: ignore

NonSpare_959_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_959(NonSpare):
    cv_name = "EVOLTHETASTART"
    cv_title = "Predicted Smallest Azimuth"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_959_Arg) -> "NonSpare_959":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Item_323_Arg: TypeAlias = NonSpare_959_Arg
class Item_323(Item):
    cv_non_spare = NonSpare_959

    @classmethod
    def create(cls, arg : Item_323_Arg) -> "Item_323":
        return cls._create(arg) # type: ignore

NonSpare_958_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_958(NonSpare):
    cv_name = "EVOLTHETAEND"
    cv_title = "Predicted Largest Azimuth"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_958_Arg) -> "NonSpare_958":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Item_322_Arg: TypeAlias = NonSpare_958_Arg
class Item_322(Item):
    cv_non_spare = NonSpare_958

    @classmethod
    def create(cls, arg : Item_322_Arg) -> "Item_322":
        return cls._create(arg) # type: ignore

NonSpare_1364_Arg: TypeAlias = RuleVariation_321_Arg
class NonSpare_1364(NonSpare):
    cv_name = "NOISERHOSTART"
    cv_title = "Predicted Closest Range"
    cv_rule = RuleVariation_321

    @classmethod
    def create(cls, arg : NonSpare_1364_Arg) -> "NonSpare_1364":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_321:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_328:
        return self.rule.variation

Item_630_Arg: TypeAlias = NonSpare_1364_Arg
class Item_630(Item):
    cv_non_spare = NonSpare_1364

    @classmethod
    def create(cls, arg : Item_630_Arg) -> "Item_630":
        return cls._create(arg) # type: ignore

NonSpare_1363_Arg: TypeAlias = RuleVariation_321_Arg
class NonSpare_1363(NonSpare):
    cv_name = "NOISERHOEND"
    cv_title = "Predicted Largest Range"
    cv_rule = RuleVariation_321

    @classmethod
    def create(cls, arg : NonSpare_1363_Arg) -> "NonSpare_1363":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_321:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_328:
        return self.rule.variation

Item_629_Arg: TypeAlias = NonSpare_1363_Arg
class Item_629(Item):
    cv_non_spare = NonSpare_1363

    @classmethod
    def create(cls, arg : Item_629_Arg) -> "Item_629":
        return cls._create(arg) # type: ignore

NonSpare_1366_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_1366(NonSpare):
    cv_name = "NOISETHETASTART"
    cv_title = "Predicted Smallest Azimuth"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_1366_Arg) -> "NonSpare_1366":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Item_632_Arg: TypeAlias = NonSpare_1366_Arg
class Item_632(Item):
    cv_non_spare = NonSpare_1366

    @classmethod
    def create(cls, arg : Item_632_Arg) -> "Item_632":
        return cls._create(arg) # type: ignore

NonSpare_1365_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_1365(NonSpare):
    cv_name = "NOISETHETAEND"
    cv_title = "Predicted Largest Azimuth"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_1365_Arg) -> "NonSpare_1365":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Item_631_Arg: TypeAlias = NonSpare_1365_Arg
class Item_631(Item):
    cv_non_spare = NonSpare_1365

    @classmethod
    def create(cls, arg : Item_631_Arg) -> "Item_631":
        return cls._create(arg) # type: ignore

NonSpare_1451_Arg: TypeAlias = RuleVariation_325_Arg
class NonSpare_1451(NonSpare):
    cv_name = "PREDTIME"
    cv_title = "Predicted Detection Time"
    cv_rule = RuleVariation_325

    @classmethod
    def create(cls, arg : NonSpare_1451_Arg) -> "NonSpare_1451":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_325:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_332:
        return self.rule.variation

Item_700_Arg: TypeAlias = NonSpare_1451_Arg
class Item_700(Item):
    cv_non_spare = NonSpare_1451

    @classmethod
    def create(cls, arg : Item_700_Arg) -> "Item_700":
        return cls._create(arg) # type: ignore

Variation_1155_Arg_Group = Tuple[Union[RuleVariation_321_Arg, Tuple[Literal["PREDRHO"], RuleVariation_321_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["PREDTHETA"], RuleVariation_334_Arg]], Union[RuleVariation_321_Arg, Tuple[Literal["EVOLRHOSTART"], RuleVariation_321_Arg]], Union[RuleVariation_321_Arg, Tuple[Literal["EVOLRHOEND"], RuleVariation_321_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["EVOLTHETASTART"], RuleVariation_334_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["EVOLTHETAEND"], RuleVariation_334_Arg]], Union[RuleVariation_321_Arg, Tuple[Literal["NOISERHOSTART"], RuleVariation_321_Arg]], Union[RuleVariation_321_Arg, Tuple[Literal["NOISERHOEND"], RuleVariation_321_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["NOISETHETASTART"], RuleVariation_334_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["NOISETHETAEND"], RuleVariation_334_Arg]], Union[RuleVariation_325_Arg, Tuple[Literal["PREDTIME"], RuleVariation_325_Arg]]]
Variation_1155_Arg: TypeAlias = Union[int, Variation_1155_Arg_Group]
class Variation_1155(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 176
    cv_items_list = [(Item_698, 16), (Item_699, 16), (Item_321, 16), (Item_320, 16), (Item_323, 16), (Item_322, 16), (Item_630, 16), (Item_629, 16), (Item_632, 16), (Item_631, 16), (Item_700, 16)]
    cv_items_dict = {"PREDRHO": RuleVariation_321, "PREDTHETA": RuleVariation_334, "EVOLRHOSTART": RuleVariation_321, "EVOLRHOEND": RuleVariation_321, "EVOLTHETASTART": RuleVariation_334, "EVOLTHETAEND": RuleVariation_334, "NOISERHOSTART": RuleVariation_321, "NOISERHOEND": RuleVariation_321, "NOISETHETASTART": RuleVariation_334, "NOISETHETAEND": RuleVariation_334, "PREDTIME": RuleVariation_325}

    @overload
    @classmethod
    def spec(cls, key : Literal["PREDRHO"]) -> RuleVariation_321:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PREDTHETA"]) -> RuleVariation_334:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EVOLRHOSTART"]) -> RuleVariation_321:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EVOLRHOEND"]) -> RuleVariation_321:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EVOLTHETASTART"]) -> RuleVariation_334:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EVOLTHETAEND"]) -> RuleVariation_334:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NOISERHOSTART"]) -> RuleVariation_321:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NOISERHOEND"]) -> RuleVariation_321:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NOISETHETASTART"]) -> RuleVariation_334:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NOISETHETAEND"]) -> RuleVariation_334:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PREDTIME"]) -> RuleVariation_325:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PREDRHO"], Literal["PREDTHETA"], Literal["EVOLRHOSTART"], Literal["EVOLRHOEND"], Literal["EVOLTHETASTART"], Literal["EVOLTHETAEND"], Literal["NOISERHOSTART"], Literal["NOISERHOEND"], Literal["NOISETHETASTART"], Literal["NOISETHETAEND"], Literal["PREDTIME"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PREDRHO"]) -> RuleVariation_321:
        ...
    @overload
    def get_item(self, key : Literal["PREDTHETA"]) -> RuleVariation_334:
        ...
    @overload
    def get_item(self, key : Literal["EVOLRHOSTART"]) -> RuleVariation_321:
        ...
    @overload
    def get_item(self, key : Literal["EVOLRHOEND"]) -> RuleVariation_321:
        ...
    @overload
    def get_item(self, key : Literal["EVOLTHETASTART"]) -> RuleVariation_334:
        ...
    @overload
    def get_item(self, key : Literal["EVOLTHETAEND"]) -> RuleVariation_334:
        ...
    @overload
    def get_item(self, key : Literal["NOISERHOSTART"]) -> RuleVariation_321:
        ...
    @overload
    def get_item(self, key : Literal["NOISERHOEND"]) -> RuleVariation_321:
        ...
    @overload
    def get_item(self, key : Literal["NOISETHETASTART"]) -> RuleVariation_334:
        ...
    @overload
    def get_item(self, key : Literal["NOISETHETAEND"]) -> RuleVariation_334:
        ...
    @overload
    def get_item(self, key : Literal["PREDTIME"]) -> RuleVariation_325:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1155_Arg) -> 'Variation_1155':
        return cls._create(arg) # type: ignore

RuleVariation_1107_Arg: TypeAlias = Variation_1155_Arg
class RuleVariation_1107(RuleVariationContextFree):
    cv_variation = Variation_1155

    @classmethod
    def create(cls, arg : RuleVariation_1107_Arg) -> "RuleVariation_1107":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1155:
        return self.arg # type: ignore

NonSpare_1370_Arg: TypeAlias = RuleVariation_1107_Arg
class NonSpare_1370(NonSpare):
    cv_name = "NPP"
    cv_title = "Next Predicted Position"
    cv_rule = RuleVariation_1107

    @classmethod
    def create(cls, arg : NonSpare_1370_Arg) -> "NonSpare_1370":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1107:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1155:
        return self.rule.variation

Content_458_Arg: TypeAlias = int
class Content_458(ContentTable):
    cv_values = {0: "Surveillance Mode A (alert bit or periodic)", 1: "Comm-A", 2: "Ground Initiated Comm-B", 3: "Air Initiated Comm-B", 4: "Broadcast Comm-B", 5: "Comm-C", 6: "Comm-D", 7: "Reserved for future use", 8: "Reserved for future use", 9: "Reserved for future use", 10: "Reserved for future use", 11: "Reserved for future use", 12: "Reserved for future use", 13: "Reserved for future use", 14: "Reserved for future use", 15: "Reserved for future use"}

RuleContent_458_Arg: TypeAlias = Content_458_Arg
class RuleContent_458(RuleContentContextFree):
    cv_content = Content_458

    @property
    def content(self) -> Content_458:
        return self._get_content() # type: ignore

Variation_133_Arg: TypeAlias = RuleContent_458_Arg
class Variation_133(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_458

    @classmethod
    def create(cls, arg : Variation_133_Arg) -> "Variation_133":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_458:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_458:
        return self.rule.content

RuleVariation_133_Arg: TypeAlias = Variation_133_Arg
class RuleVariation_133(RuleVariationContextFree):
    cv_variation = Variation_133

    @classmethod
    def create(cls, arg : RuleVariation_133_Arg) -> "RuleVariation_133":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_133:
        return self.arg # type: ignore

NonSpare_1962_Arg: TypeAlias = RuleVariation_133_Arg
class NonSpare_1962(NonSpare):
    cv_name = "TYPE"
    cv_title = ""
    cv_rule = RuleVariation_133

    @classmethod
    def create(cls, arg : NonSpare_1962_Arg) -> "NonSpare_1962":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_133:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_133:
        return self.rule.variation

Item_1081_Arg: TypeAlias = NonSpare_1962_Arg
class Item_1081(Item):
    cv_non_spare = NonSpare_1962

    @classmethod
    def create(cls, arg : Item_1081_Arg) -> "Item_1081":
        return cls._create(arg) # type: ignore

Content_217_Arg: TypeAlias = int
class Content_217(ContentTable):
    cv_values = {0: "From previous scan", 1: "New in current scan", 2: "Requested in the beam by transponder", 3: "Invalid ASTERIX value"}

RuleContent_217_Arg: TypeAlias = Content_217_Arg
class RuleContent_217(RuleContentContextFree):
    cv_content = Content_217

    @property
    def content(self) -> Content_217:
        return self._get_content() # type: ignore

Variation_761_Arg: TypeAlias = RuleContent_217_Arg
class Variation_761(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_217

    @classmethod
    def create(cls, arg : Variation_761_Arg) -> "Variation_761":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_217:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_217:
        return self.rule.content

RuleVariation_750_Arg: TypeAlias = Variation_761_Arg
class RuleVariation_750(RuleVariationContextFree):
    cv_variation = Variation_761

    @classmethod
    def create(cls, arg : RuleVariation_750_Arg) -> "RuleVariation_750":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_761:
        return self.arg # type: ignore

NonSpare_1394_Arg: TypeAlias = RuleVariation_750_Arg
class NonSpare_1394(NonSpare):
    cv_name = "ORIGIN"
    cv_title = ""
    cv_rule = RuleVariation_750

    @classmethod
    def create(cls, arg : NonSpare_1394_Arg) -> "NonSpare_1394":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_750:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_761:
        return self.rule.variation

Item_659_Arg: TypeAlias = NonSpare_1394_Arg
class Item_659(Item):
    cv_non_spare = NonSpare_1394

    @classmethod
    def create(cls, arg : Item_659_Arg) -> "Item_659":
        return cls._create(arg) # type: ignore

Content_241_Arg: TypeAlias = int
class Content_241(ContentTable):
    cv_values = {0: "In progress", 1: "Completed", 2: "Cancelled", 3: "Invalid ASTERIX value"}

RuleContent_241_Arg: TypeAlias = Content_241_Arg
class RuleContent_241(RuleContentContextFree):
    cv_content = Content_241

    @property
    def content(self) -> Content_241:
        return self._get_content() # type: ignore

Variation_957_Arg: TypeAlias = RuleContent_241_Arg
class Variation_957(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 2
    cv_rule = RuleContent_241

    @classmethod
    def create(cls, arg : Variation_957_Arg) -> "Variation_957":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_241:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_241:
        return self.rule.content

RuleVariation_927_Arg: TypeAlias = Variation_957_Arg
class RuleVariation_927(RuleVariationContextFree):
    cv_variation = Variation_957

    @classmethod
    def create(cls, arg : RuleVariation_927_Arg) -> "RuleVariation_927":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_957:
        return self.arg # type: ignore

NonSpare_1776_Arg: TypeAlias = RuleVariation_927_Arg
class NonSpare_1776(NonSpare):
    cv_name = "STATE"
    cv_title = ""
    cv_rule = RuleVariation_927

    @classmethod
    def create(cls, arg : NonSpare_1776_Arg) -> "NonSpare_1776":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_927:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_957:
        return self.rule.variation

Item_943_Arg: TypeAlias = NonSpare_1776_Arg
class Item_943(Item):
    cv_non_spare = NonSpare_1776

    @classmethod
    def create(cls, arg : Item_943_Arg) -> "Item_943":
        return cls._create(arg) # type: ignore

Variation_1236_Arg_Group = Tuple[Union[RuleVariation_133_Arg, Tuple[Literal["TYPE"], RuleVariation_133_Arg]], Union[RuleVariation_750_Arg, Tuple[Literal["ORIGIN"], RuleVariation_750_Arg]], Union[RuleVariation_927_Arg, Tuple[Literal["STATE"], RuleVariation_927_Arg]]]
Variation_1236_Arg: TypeAlias = Union[int, Variation_1236_Arg_Group]
class Variation_1236(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1081, 4), (Item_659, 2), (Item_943, 2)]
    cv_items_dict = {"TYPE": RuleVariation_133, "ORIGIN": RuleVariation_750, "STATE": RuleVariation_927}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYPE"]) -> RuleVariation_133:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ORIGIN"]) -> RuleVariation_750:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STATE"]) -> RuleVariation_927:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYPE"], Literal["ORIGIN"], Literal["STATE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYPE"]) -> RuleVariation_133:
        ...
    @overload
    def get_item(self, key : Literal["ORIGIN"]) -> RuleVariation_750:
        ...
    @overload
    def get_item(self, key : Literal["STATE"]) -> RuleVariation_927:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1236_Arg) -> 'Variation_1236':
        return cls._create(arg) # type: ignore

Variation_1437_Arg: TypeAlias = List[Variation_1236_Arg]
class Variation_1437(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1236

    @classmethod
    def create(cls, arg : Variation_1437_Arg) -> 'Variation_1437':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1236]:
        return self._get_list() # type: ignore

RuleVariation_1360_Arg: TypeAlias = Variation_1437_Arg
class RuleVariation_1360(RuleVariationContextFree):
    cv_variation = Variation_1437

    @classmethod
    def create(cls, arg : RuleVariation_1360_Arg) -> "RuleVariation_1360":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1437:
        return self.arg # type: ignore

NonSpare_880_Arg: TypeAlias = RuleVariation_1360_Arg
class NonSpare_880(NonSpare):
    cv_name = "DLK"
    cv_title = "Data Link Characteristics"
    cv_rule = RuleVariation_1360

    @classmethod
    def create(cls, arg : NonSpare_880_Arg) -> "NonSpare_880":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1360:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1437:
        return self.rule.variation

Content_481_Arg: TypeAlias = int
class Content_481(ContentTable):
    cv_values = {0: "Target not locked out by this radar", 1: "Target locked out by this radar"}

RuleContent_481_Arg: TypeAlias = Content_481_Arg
class RuleContent_481(RuleContentContextFree):
    cv_content = Content_481

    @property
    def content(self) -> Content_481:
        return self._get_content() # type: ignore

Variation_83_Arg: TypeAlias = RuleContent_481_Arg
class Variation_83(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_481

    @classmethod
    def create(cls, arg : Variation_83_Arg) -> "Variation_83":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_481:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_481:
        return self.rule.content

RuleVariation_83_Arg: TypeAlias = Variation_83_Arg
class RuleVariation_83(RuleVariationContextFree):
    cv_variation = Variation_83

    @classmethod
    def create(cls, arg : RuleVariation_83_Arg) -> "RuleVariation_83":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_83:
        return self.arg # type: ignore

NonSpare_1188_Arg: TypeAlias = RuleVariation_83_Arg
class NonSpare_1188(NonSpare):
    cv_name = "LS"
    cv_title = "Lockout State"
    cv_rule = RuleVariation_83

    @classmethod
    def create(cls, arg : NonSpare_1188_Arg) -> "NonSpare_1188":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_83:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_83:
        return self.rule.variation

Item_502_Arg: TypeAlias = NonSpare_1188_Arg
class Item_502(Item):
    cv_non_spare = NonSpare_1188

    @classmethod
    def create(cls, arg : Item_502_Arg) -> "Item_502":
        return cls._create(arg) # type: ignore

Content_719_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ms"]]]
class Content_719(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = "ms"

    def as_quantity(self, cv_unit : Optional[Literal["ms"]] = None) -> float:
        return self._as_quantity()

RuleContent_719_Arg: TypeAlias = Content_719_Arg
class RuleContent_719(RuleContentContextFree):
    cv_content = Content_719

    @property
    def content(self) -> Content_719:
        return self._get_content() # type: ignore

Variation_500_Arg: TypeAlias = RuleContent_719_Arg
class Variation_500(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 15
    cv_rule = RuleContent_719

    @classmethod
    def create(cls, arg : Variation_500_Arg) -> "Variation_500":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_719:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_719:
        return self.rule.content

RuleVariation_489_Arg: TypeAlias = Variation_500_Arg
class RuleVariation_489(RuleVariationContextFree):
    cv_variation = Variation_500

    @classmethod
    def create(cls, arg : RuleVariation_489_Arg) -> "RuleVariation_489":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_500:
        return self.arg # type: ignore

NonSpare_1165_Arg: TypeAlias = RuleVariation_489_Arg
class NonSpare_1165(NonSpare):
    cv_name = "LOCTIM"
    cv_title = "Lockout Time"
    cv_rule = RuleVariation_489

    @classmethod
    def create(cls, arg : NonSpare_1165_Arg) -> "NonSpare_1165":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_489:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_500:
        return self.rule.variation

Item_481_Arg: TypeAlias = NonSpare_1165_Arg
class Item_481(Item):
    cv_non_spare = NonSpare_1165

    @classmethod
    def create(cls, arg : Item_481_Arg) -> "Item_481":
        return cls._create(arg) # type: ignore

Variation_1132_Arg_Group = Tuple[Union[RuleVariation_83_Arg, Tuple[Literal["LS"], RuleVariation_83_Arg]], Union[RuleVariation_489_Arg, Tuple[Literal["LOCTIM"], RuleVariation_489_Arg]]]
Variation_1132_Arg: TypeAlias = Union[int, Variation_1132_Arg_Group]
class Variation_1132(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_502, 1), (Item_481, 15)]
    cv_items_dict = {"LS": RuleVariation_83, "LOCTIM": RuleVariation_489}

    @overload
    @classmethod
    def spec(cls, key : Literal["LS"]) -> RuleVariation_83:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LOCTIM"]) -> RuleVariation_489:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LS"], Literal["LOCTIM"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LS"]) -> RuleVariation_83:
        ...
    @overload
    def get_item(self, key : Literal["LOCTIM"]) -> RuleVariation_489:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1132_Arg) -> 'Variation_1132':
        return cls._create(arg) # type: ignore

RuleVariation_1089_Arg: TypeAlias = Variation_1132_Arg
class RuleVariation_1089(RuleVariationContextFree):
    cv_variation = Variation_1132

    @classmethod
    def create(cls, arg : RuleVariation_1089_Arg) -> "RuleVariation_1089":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1132:
        return self.arg # type: ignore

NonSpare_1156_Arg: TypeAlias = RuleVariation_1089_Arg
class NonSpare_1156(NonSpare):
    cv_name = "LCK"
    cv_title = "Lockout Characteristics"
    cv_rule = RuleVariation_1089

    @classmethod
    def create(cls, arg : NonSpare_1156_Arg) -> "NonSpare_1156":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1089:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1132:
        return self.rule.variation

Variation_990_Arg: TypeAlias = RuleContent_610_Arg
class Variation_990(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 4
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_990_Arg) -> "Variation_990":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_960_Arg: TypeAlias = Variation_990_Arg
class RuleVariation_960(RuleVariationContextFree):
    cv_variation = Variation_990

    @classmethod
    def create(cls, arg : RuleVariation_960_Arg) -> "RuleVariation_960":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_990:
        return self.arg # type: ignore

NonSpare_1837_Arg: TypeAlias = RuleVariation_960_Arg
class NonSpare_1837(NonSpare):
    cv_name = "TCOUNT1"
    cv_title = ""
    cv_rule = RuleVariation_960

    @classmethod
    def create(cls, arg : NonSpare_1837_Arg) -> "NonSpare_1837":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_960:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_990:
        return self.rule.variation

Item_982_Arg: TypeAlias = NonSpare_1837_Arg
class Item_982(Item):
    cv_non_spare = NonSpare_1837

    @classmethod
    def create(cls, arg : Item_982_Arg) -> "Item_982":
        return cls._create(arg) # type: ignore

NonSpare_1834_Arg: TypeAlias = RuleVariation_681_Arg
class NonSpare_1834(NonSpare):
    cv_name = "TCODE1"
    cv_title = ""
    cv_rule = RuleVariation_681

    @classmethod
    def create(cls, arg : NonSpare_1834_Arg) -> "NonSpare_1834":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_681:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_692:
        return self.rule.variation

Item_979_Arg: TypeAlias = NonSpare_1834_Arg
class Item_979(Item):
    cv_non_spare = NonSpare_1834

    @classmethod
    def create(cls, arg : Item_979_Arg) -> "Item_979":
        return cls._create(arg) # type: ignore

NonSpare_1838_Arg: TypeAlias = RuleVariation_136_Arg
class NonSpare_1838(NonSpare):
    cv_name = "TCOUNT2"
    cv_title = ""
    cv_rule = RuleVariation_136

    @classmethod
    def create(cls, arg : NonSpare_1838_Arg) -> "NonSpare_1838":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_136:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_136:
        return self.rule.variation

Item_983_Arg: TypeAlias = NonSpare_1838_Arg
class Item_983(Item):
    cv_non_spare = NonSpare_1838

    @classmethod
    def create(cls, arg : Item_983_Arg) -> "Item_983":
        return cls._create(arg) # type: ignore

NonSpare_1835_Arg: TypeAlias = RuleVariation_776_Arg
class NonSpare_1835(NonSpare):
    cv_name = "TCODE2"
    cv_title = ""
    cv_rule = RuleVariation_776

    @classmethod
    def create(cls, arg : NonSpare_1835_Arg) -> "NonSpare_1835":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_776:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_806:
        return self.rule.variation

Item_980_Arg: TypeAlias = NonSpare_1835_Arg
class Item_980(Item):
    cv_non_spare = NonSpare_1835

    @classmethod
    def create(cls, arg : Item_980_Arg) -> "Item_980":
        return cls._create(arg) # type: ignore

NonSpare_1839_Arg: TypeAlias = RuleVariation_136_Arg
class NonSpare_1839(NonSpare):
    cv_name = "TCOUNT3"
    cv_title = ""
    cv_rule = RuleVariation_136

    @classmethod
    def create(cls, arg : NonSpare_1839_Arg) -> "NonSpare_1839":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_136:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_136:
        return self.rule.variation

Item_984_Arg: TypeAlias = NonSpare_1839_Arg
class Item_984(Item):
    cv_non_spare = NonSpare_1839

    @classmethod
    def create(cls, arg : Item_984_Arg) -> "Item_984":
        return cls._create(arg) # type: ignore

NonSpare_1836_Arg: TypeAlias = RuleVariation_776_Arg
class NonSpare_1836(NonSpare):
    cv_name = "TCODE3"
    cv_title = ""
    cv_rule = RuleVariation_776

    @classmethod
    def create(cls, arg : NonSpare_1836_Arg) -> "NonSpare_1836":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_776:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_806:
        return self.rule.variation

Item_981_Arg: TypeAlias = NonSpare_1836_Arg
class Item_981(Item):
    cv_non_spare = NonSpare_1836

    @classmethod
    def create(cls, arg : Item_981_Arg) -> "Item_981":
        return cls._create(arg) # type: ignore

Variation_1040_Arg_Group = Tuple[int, Union[RuleVariation_960_Arg, Tuple[Literal["TCOUNT1"], RuleVariation_960_Arg]], Union[RuleVariation_681_Arg, Tuple[Literal["TCODE1"], RuleVariation_681_Arg]], Union[RuleVariation_136_Arg, Tuple[Literal["TCOUNT2"], RuleVariation_136_Arg]], Union[RuleVariation_776_Arg, Tuple[Literal["TCODE2"], RuleVariation_776_Arg]], Union[RuleVariation_136_Arg, Tuple[Literal["TCOUNT3"], RuleVariation_136_Arg]], Union[RuleVariation_776_Arg, Tuple[Literal["TCODE3"], RuleVariation_776_Arg]]]
Variation_1040_Arg: TypeAlias = Union[int, Variation_1040_Arg_Group]
class Variation_1040(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_6, 7), (Item_982, 4), (Item_979, 5), (Item_983, 4), (Item_980, 12), (Item_984, 4), (Item_981, 12)]
    cv_items_dict = {"TCOUNT1": RuleVariation_960, "TCODE1": RuleVariation_681, "TCOUNT2": RuleVariation_136, "TCODE2": RuleVariation_776, "TCOUNT3": RuleVariation_136, "TCODE3": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["TCOUNT1"]) -> RuleVariation_960:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TCODE1"]) -> RuleVariation_681:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TCOUNT2"]) -> RuleVariation_136:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TCODE2"]) -> RuleVariation_776:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TCOUNT3"]) -> RuleVariation_136:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TCODE3"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TCOUNT1"], Literal["TCODE1"], Literal["TCOUNT2"], Literal["TCODE2"], Literal["TCOUNT3"], Literal["TCODE3"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TCOUNT1"]) -> RuleVariation_960:
        ...
    @overload
    def get_item(self, key : Literal["TCODE1"]) -> RuleVariation_681:
        ...
    @overload
    def get_item(self, key : Literal["TCOUNT2"]) -> RuleVariation_136:
        ...
    @overload
    def get_item(self, key : Literal["TCODE2"]) -> RuleVariation_776:
        ...
    @overload
    def get_item(self, key : Literal["TCOUNT3"]) -> RuleVariation_136:
        ...
    @overload
    def get_item(self, key : Literal["TCODE3"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1040_Arg) -> 'Variation_1040':
        return cls._create(arg) # type: ignore

RuleVariation_1008_Arg: TypeAlias = Variation_1040_Arg
class RuleVariation_1008(RuleVariationContextFree):
    cv_variation = Variation_1040

    @classmethod
    def create(cls, arg : RuleVariation_1008_Arg) -> "RuleVariation_1008":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1040:
        return self.arg # type: ignore

NonSpare_1828_Arg: TypeAlias = RuleVariation_1008_Arg
class NonSpare_1828(NonSpare):
    cv_name = "TC"
    cv_title = "Transition Code"
    cv_rule = RuleVariation_1008

    @classmethod
    def create(cls, arg : NonSpare_1828_Arg) -> "NonSpare_1828":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1008:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1040:
        return self.rule.variation

Content_484_Arg: TypeAlias = int
class Content_484(ContentTable):
    cv_values = {0: "Tentative Track with One Plot", 1: "Tentative Track with at least Two Plots", 2: "Pre-Confirmed Track", 3: "Confirmed Track"}

RuleContent_484_Arg: TypeAlias = Content_484_Arg
class RuleContent_484(RuleContentContextFree):
    cv_content = Content_484

    @property
    def content(self) -> Content_484:
        return self._get_content() # type: ignore

Variation_112_Arg: TypeAlias = RuleContent_484_Arg
class Variation_112(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_484

    @classmethod
    def create(cls, arg : Variation_112_Arg) -> "Variation_112":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_484:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_484:
        return self.rule.content

RuleVariation_112_Arg: TypeAlias = Variation_112_Arg
class RuleVariation_112(RuleVariationContextFree):
    cv_variation = Variation_112

    @classmethod
    def create(cls, arg : RuleVariation_112_Arg) -> "RuleVariation_112":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_112:
        return self.arg # type: ignore

NonSpare_558_Arg: TypeAlias = RuleVariation_112_Arg
class NonSpare_558(NonSpare):
    cv_name = "ACQI"
    cv_title = ""
    cv_rule = RuleVariation_112

    @classmethod
    def create(cls, arg : NonSpare_558_Arg) -> "NonSpare_558":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_112:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_112:
        return self.rule.variation

Item_43_Arg: TypeAlias = NonSpare_558_Arg
class Item_43(Item):
    cv_non_spare = NonSpare_558

    @classmethod
    def create(cls, arg : Item_43_Arg) -> "Item_43":
        return cls._create(arg) # type: ignore

Variation_602_Arg: TypeAlias = RuleContent_610_Arg
class Variation_602(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg : Variation_602_Arg) -> "Variation_602":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_610:
        return self.rule.content

RuleVariation_591_Arg: TypeAlias = Variation_602_Arg
class RuleVariation_591(RuleVariationContextFree):
    cv_variation = Variation_602

    @classmethod
    def create(cls, arg : RuleVariation_591_Arg) -> "RuleVariation_591":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_602:
        return self.arg # type: ignore

NonSpare_1911_Arg: TypeAlias = RuleVariation_591_Arg
class NonSpare_1911(NonSpare):
    cv_name = "TRKUPDCTR"
    cv_title = ""
    cv_rule = RuleVariation_591

    @classmethod
    def create(cls, arg : NonSpare_1911_Arg) -> "NonSpare_1911":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_591:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_602:
        return self.rule.variation

Item_1036_Arg: TypeAlias = NonSpare_1911_Arg
class Item_1036(Item):
    cv_non_spare = NonSpare_1911

    @classmethod
    def create(cls, arg : Item_1036_Arg) -> "Item_1036":
        return cls._create(arg) # type: ignore

Variation_305_Arg: TypeAlias = RuleContent_719_Arg
class Variation_305(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_719

    @classmethod
    def create(cls, arg : Variation_305_Arg) -> "Variation_305":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_719:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_719:
        return self.rule.content

RuleVariation_298_Arg: TypeAlias = Variation_305_Arg
class RuleVariation_298(RuleVariationContextFree):
    cv_variation = Variation_305

    @classmethod
    def create(cls, arg : RuleVariation_298_Arg) -> "RuleVariation_298":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_305:
        return self.arg # type: ignore

NonSpare_1137_Arg: TypeAlias = RuleVariation_298_Arg
class NonSpare_1137(NonSpare):
    cv_name = "LASTTRKUPD"
    cv_title = ""
    cv_rule = RuleVariation_298

    @classmethod
    def create(cls, arg : NonSpare_1137_Arg) -> "NonSpare_1137":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_298:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_305:
        return self.rule.variation

Item_455_Arg: TypeAlias = NonSpare_1137_Arg
class Item_455(Item):
    cv_non_spare = NonSpare_1137

    @classmethod
    def create(cls, arg : Item_455_Arg) -> "Item_455":
        return cls._create(arg) # type: ignore

Variation_1045_Arg_Group = Tuple[Union[RuleVariation_112_Arg, Tuple[Literal["ACQI"], RuleVariation_112_Arg]], Union[RuleVariation_591_Arg, Tuple[Literal["TRKUPDCTR"], RuleVariation_591_Arg]], Union[RuleVariation_298_Arg, Tuple[Literal["LASTTRKUPD"], RuleVariation_298_Arg]]]
Variation_1045_Arg: TypeAlias = Union[int, Variation_1045_Arg_Group]
class Variation_1045(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_43, 2), (Item_1036, 14), (Item_455, 16)]
    cv_items_dict = {"ACQI": RuleVariation_112, "TRKUPDCTR": RuleVariation_591, "LASTTRKUPD": RuleVariation_298}

    @overload
    @classmethod
    def spec(cls, key : Literal["ACQI"]) -> RuleVariation_112:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRKUPDCTR"]) -> RuleVariation_591:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LASTTRKUPD"]) -> RuleVariation_298:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ACQI"], Literal["TRKUPDCTR"], Literal["LASTTRKUPD"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ACQI"]) -> RuleVariation_112:
        ...
    @overload
    def get_item(self, key : Literal["TRKUPDCTR"]) -> RuleVariation_591:
        ...
    @overload
    def get_item(self, key : Literal["LASTTRKUPD"]) -> RuleVariation_298:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1045_Arg) -> 'Variation_1045':
        return cls._create(arg) # type: ignore

RuleVariation_1012_Arg: TypeAlias = Variation_1045_Arg
class RuleVariation_1012(RuleVariationContextFree):
    cv_variation = Variation_1045

    @classmethod
    def create(cls, arg : RuleVariation_1012_Arg) -> "RuleVariation_1012":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1045:
        return self.arg # type: ignore

NonSpare_1865_Arg: TypeAlias = RuleVariation_1012_Arg
class NonSpare_1865(NonSpare):
    cv_name = "TLC"
    cv_title = "Track Life Cycle"
    cv_rule = RuleVariation_1012

    @classmethod
    def create(cls, arg : NonSpare_1865_Arg) -> "NonSpare_1865":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1012:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1045:
        return self.rule.variation

NonSpare_1647_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_1647(NonSpare):
    cv_name = "SACADJS"
    cv_title = "SAC of the Adjacent Sensor"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_1647_Arg) -> "NonSpare_1647":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_854_Arg: TypeAlias = NonSpare_1647_Arg
class Item_854(Item):
    cv_non_spare = NonSpare_1647

    @classmethod
    def create(cls, arg : Item_854_Arg) -> "Item_854":
        return cls._create(arg) # type: ignore

NonSpare_1702_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_1702(NonSpare):
    cv_name = "SICADJS"
    cv_title = "SIC of the Adjacent Sensor"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_1702_Arg) -> "NonSpare_1702":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_885_Arg: TypeAlias = NonSpare_1702_Arg
class Item_885(Item):
    cv_non_spare = NonSpare_1702

    @classmethod
    def create(cls, arg : Item_885_Arg) -> "Item_885":
        return cls._create(arg) # type: ignore

NonSpare_1862_Arg: TypeAlias = RuleVariation_325_Arg
class NonSpare_1862(NonSpare):
    cv_name = "TIMEOFDAYSCN"
    cv_title = "Absolute Timestamp in UTC Provided by the SCN"
    cv_rule = RuleVariation_325

    @classmethod
    def create(cls, arg : NonSpare_1862_Arg) -> "NonSpare_1862":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_325:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_332:
        return self.rule.variation

Item_1001_Arg: TypeAlias = NonSpare_1862_Arg
class Item_1001(Item):
    cv_non_spare = NonSpare_1862

    @classmethod
    def create(cls, arg : Item_1001_Arg) -> "Item_1001":
        return cls._create(arg) # type: ignore

Content_78_Arg: TypeAlias = int
class Content_78(ContentTable):
    cv_values = {0: "Data used by Tracker", 1: "Data not used by Tracker", 2: "2-127: Reserved for future use"}

RuleContent_78_Arg: TypeAlias = Content_78_Arg
class RuleContent_78(RuleContentContextFree):
    cv_content = Content_78

    @property
    def content(self) -> Content_78:
        return self._get_content() # type: ignore

Variation_150_Arg: TypeAlias = RuleContent_78_Arg
class Variation_150(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_78

    @classmethod
    def create(cls, arg : Variation_150_Arg) -> "Variation_150":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_78:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_78:
        return self.rule.content

RuleVariation_150_Arg: TypeAlias = Variation_150_Arg
class RuleVariation_150(RuleVariationContextFree):
    cv_variation = Variation_150

    @classmethod
    def create(cls, arg : RuleVariation_150_Arg) -> "RuleVariation_150":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_150:
        return self.arg # type: ignore

NonSpare_853_Arg: TypeAlias = RuleVariation_150_Arg
class NonSpare_853(NonSpare):
    cv_name = "DATAUSE"
    cv_title = "Use of Adjacent Sensor Data"
    cv_rule = RuleVariation_150

    @classmethod
    def create(cls, arg : NonSpare_853_Arg) -> "NonSpare_853":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_150:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_150:
        return self.rule.variation

Item_238_Arg: TypeAlias = NonSpare_853_Arg
class Item_238(Item):
    cv_non_spare = NonSpare_853

    @classmethod
    def create(cls, arg : Item_238_Arg) -> "Item_238":
        return cls._create(arg) # type: ignore

Content_73_Arg: TypeAlias = int
class Content_73(ContentTable):
    cv_values = {0: "DRN not available", 1: "DRN available"}

RuleContent_73_Arg: TypeAlias = Content_73_Arg
class RuleContent_73(RuleContentContextFree):
    cv_content = Content_73

    @property
    def content(self) -> Content_73:
        return self._get_content() # type: ignore

Variation_971_Arg: TypeAlias = RuleContent_73_Arg
class Variation_971(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_73

    @classmethod
    def create(cls, arg : Variation_971_Arg) -> "Variation_971":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_73:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_73:
        return self.rule.content

RuleVariation_941_Arg: TypeAlias = Variation_971_Arg
class RuleVariation_941(RuleVariationContextFree):
    cv_variation = Variation_971

    @classmethod
    def create(cls, arg : RuleVariation_941_Arg) -> "RuleVariation_941":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_971:
        return self.arg # type: ignore

NonSpare_893_Arg: TypeAlias = RuleVariation_941_Arg
class NonSpare_893(NonSpare):
    cv_name = "DRNA"
    cv_title = "DRN Availability"
    cv_rule = RuleVariation_941

    @classmethod
    def create(cls, arg : NonSpare_893_Arg) -> "NonSpare_893":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_941:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_971:
        return self.rule.variation

Item_272_Arg: TypeAlias = NonSpare_893_Arg
class Item_272(Item):
    cv_non_spare = NonSpare_893

    @classmethod
    def create(cls, arg : Item_272_Arg) -> "Item_272":
        return cls._create(arg) # type: ignore

NonSpare_892_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_892(NonSpare):
    cv_name = "DRN"
    cv_title = ""
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_892_Arg) -> "NonSpare_892":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

Item_271_Arg: TypeAlias = NonSpare_892_Arg
class Item_271(Item):
    cv_non_spare = NonSpare_892

    @classmethod
    def create(cls, arg : Item_271_Arg) -> "Item_271":
        return cls._create(arg) # type: ignore

Variation_1192_Arg_Group = Tuple[Union[RuleVariation_158_Arg, Tuple[Literal["SACADJS"], RuleVariation_158_Arg]], Union[RuleVariation_158_Arg, Tuple[Literal["SICADJS"], RuleVariation_158_Arg]], Union[RuleVariation_325_Arg, Tuple[Literal["TIMEOFDAYSCN"], RuleVariation_325_Arg]], Union[RuleVariation_150_Arg, Tuple[Literal["DATAUSE"], RuleVariation_150_Arg]], Union[RuleVariation_941_Arg, Tuple[Literal["DRNA"], RuleVariation_941_Arg]], Union[RuleVariation_244_Arg, Tuple[Literal["DRN"], RuleVariation_244_Arg]]]
Variation_1192_Arg: TypeAlias = Union[int, Variation_1192_Arg_Group]
class Variation_1192(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_items_list = [(Item_854, 8), (Item_885, 8), (Item_1001, 16), (Item_238, 7), (Item_272, 1), (Item_271, 16)]
    cv_items_dict = {"SACADJS": RuleVariation_158, "SICADJS": RuleVariation_158, "TIMEOFDAYSCN": RuleVariation_325, "DATAUSE": RuleVariation_150, "DRNA": RuleVariation_941, "DRN": RuleVariation_244}

    @overload
    @classmethod
    def spec(cls, key : Literal["SACADJS"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SICADJS"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TIMEOFDAYSCN"]) -> RuleVariation_325:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DATAUSE"]) -> RuleVariation_150:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DRNA"]) -> RuleVariation_941:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DRN"]) -> RuleVariation_244:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SACADJS"], Literal["SICADJS"], Literal["TIMEOFDAYSCN"], Literal["DATAUSE"], Literal["DRNA"], Literal["DRN"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SACADJS"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["SICADJS"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["TIMEOFDAYSCN"]) -> RuleVariation_325:
        ...
    @overload
    def get_item(self, key : Literal["DATAUSE"]) -> RuleVariation_150:
        ...
    @overload
    def get_item(self, key : Literal["DRNA"]) -> RuleVariation_941:
        ...
    @overload
    def get_item(self, key : Literal["DRN"]) -> RuleVariation_244:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1192_Arg) -> 'Variation_1192':
        return cls._create(arg) # type: ignore

Variation_1425_Arg: TypeAlias = List[Variation_1192_Arg]
class Variation_1425(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1192

    @classmethod
    def create(cls, arg : Variation_1425_Arg) -> 'Variation_1425':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1192]:
        return self._get_list() # type: ignore

RuleVariation_1348_Arg: TypeAlias = Variation_1425_Arg
class RuleVariation_1348(RuleVariationContextFree):
    cv_variation = Variation_1425

    @classmethod
    def create(cls, arg : RuleVariation_1348_Arg) -> "RuleVariation_1348":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1425:
        return self.arg # type: ignore

NonSpare_631_Arg: TypeAlias = RuleVariation_1348_Arg
class NonSpare_631(NonSpare):
    cv_name = "ASI"
    cv_title = "Adjacent Sensor Information"
    cv_rule = RuleVariation_1348

    @classmethod
    def create(cls, arg : NonSpare_631_Arg) -> "NonSpare_631":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1348:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1425:
        return self.rule.variation

Content_434_Arg: TypeAlias = int
class Content_434(ContentTable):
    cv_values = {0: "Radar tracker calculation", 1: "Integrated ADS-B", 2: "External ADS-B", 3: "SCN"}

RuleContent_434_Arg: TypeAlias = Content_434_Arg
class RuleContent_434(RuleContentContextFree):
    cv_content = Content_434

    @property
    def content(self) -> Content_434:
        return self._get_content() # type: ignore

Variation_175_Arg: TypeAlias = RuleContent_434_Arg
class Variation_175(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_434

    @classmethod
    def create(cls, arg : Variation_175_Arg) -> "Variation_175":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_434:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_434:
        return self.rule.content

RuleVariation_168_Arg: TypeAlias = Variation_175_Arg
class RuleVariation_168(RuleVariationContextFree):
    cv_variation = Variation_175

    @classmethod
    def create(cls, arg : RuleVariation_168_Arg) -> "RuleVariation_168":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_175:
        return self.arg # type: ignore

NonSpare_1845_Arg: TypeAlias = RuleVariation_168_Arg
class NonSpare_1845(NonSpare):
    cv_name = "TES"
    cv_title = "Track Extrapolation Source"
    cv_rule = RuleVariation_168

    @classmethod
    def create(cls, arg : NonSpare_1845_Arg) -> "NonSpare_1845":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_168:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_175:
        return self.rule.variation

Content_240_Arg: TypeAlias = int
class Content_240(ContentTable):
    cv_values = {0: "Identity not requested", 1: "Identity requested"}

RuleContent_240_Arg: TypeAlias = Content_240_Arg
class RuleContent_240(RuleContentContextFree):
    cv_content = Content_240

    @property
    def content(self) -> Content_240:
        return self._get_content() # type: ignore

Variation_48_Arg: TypeAlias = RuleContent_240_Arg
class Variation_48(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_240

    @classmethod
    def create(cls, arg : Variation_48_Arg) -> "Variation_48":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_240:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_240:
        return self.rule.content

RuleVariation_48_Arg: TypeAlias = Variation_48_Arg
class RuleVariation_48(RuleVariationContextFree):
    cv_variation = Variation_48

    @classmethod
    def create(cls, arg : RuleVariation_48_Arg) -> "RuleVariation_48":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_48:
        return self.arg # type: ignore

NonSpare_1115_Arg: TypeAlias = RuleVariation_48_Arg
class NonSpare_1115(NonSpare):
    cv_name = "IR"
    cv_title = ""
    cv_rule = RuleVariation_48

    @classmethod
    def create(cls, arg : NonSpare_1115_Arg) -> "NonSpare_1115":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_48:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_48:
        return self.rule.variation

Item_435_Arg: TypeAlias = NonSpare_1115_Arg
class Item_435(Item):
    cv_non_spare = NonSpare_1115

    @classmethod
    def create(cls, arg : Item_435_Arg) -> "Item_435":
        return cls._create(arg) # type: ignore

Variation_495_Arg: TypeAlias = RuleContent_721_Arg
class Variation_495(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 7
    cv_rule = RuleContent_721

    @classmethod
    def create(cls, arg : Variation_495_Arg) -> "Variation_495":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_721:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_721:
        return self.rule.content

RuleVariation_484_Arg: TypeAlias = Variation_495_Arg
class RuleVariation_484(RuleVariationContextFree):
    cv_variation = Variation_495

    @classmethod
    def create(cls, arg : RuleVariation_484_Arg) -> "RuleVariation_484":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_495:
        return self.arg # type: ignore

NonSpare_1206_Arg: TypeAlias = RuleVariation_484_Arg
class NonSpare_1206(NonSpare):
    cv_name = "M3A"
    cv_title = "Age of Mode 3/A Code (I048/070)"
    cv_rule = RuleVariation_484

    @classmethod
    def create(cls, arg : NonSpare_1206_Arg) -> "NonSpare_1206":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_484:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_495:
        return self.rule.variation

Item_517_Arg: TypeAlias = NonSpare_1206_Arg
class Item_517(Item):
    cv_non_spare = NonSpare_1206

    @classmethod
    def create(cls, arg : Item_517_Arg) -> "Item_517":
        return cls._create(arg) # type: ignore

Variation_1117_Arg_Group = Tuple[Union[RuleVariation_48_Arg, Tuple[Literal["IR"], RuleVariation_48_Arg]], Union[RuleVariation_484_Arg, Tuple[Literal["M3A"], RuleVariation_484_Arg]]]
Variation_1117_Arg: TypeAlias = Union[int, Variation_1117_Arg_Group]
class Variation_1117(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_435, 1), (Item_517, 7)]
    cv_items_dict = {"IR": RuleVariation_48, "M3A": RuleVariation_484}

    @overload
    @classmethod
    def spec(cls, key : Literal["IR"]) -> RuleVariation_48:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M3A"]) -> RuleVariation_484:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["IR"], Literal["M3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["IR"]) -> RuleVariation_48:
        ...
    @overload
    def get_item(self, key : Literal["M3A"]) -> RuleVariation_484:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1117_Arg) -> 'Variation_1117':
        return cls._create(arg) # type: ignore

RuleVariation_1074_Arg: TypeAlias = Variation_1117_Arg
class RuleVariation_1074(RuleVariationContextFree):
    cv_variation = Variation_1117

    @classmethod
    def create(cls, arg : RuleVariation_1074_Arg) -> "RuleVariation_1074":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1117:
        return self.arg # type: ignore

NonSpare_1116_Arg: TypeAlias = RuleVariation_1074_Arg
class NonSpare_1116(NonSpare):
    cv_name = "IR"
    cv_title = "Identity Requested"
    cv_rule = RuleVariation_1074

    @classmethod
    def create(cls, arg : NonSpare_1116_Arg) -> "NonSpare_1116":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1074:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1117:
        return self.rule.variation

Variation_1493_Arg = TypedDict('Variation_1493_Arg', {
    "PTL": NonSpare_1473_Arg,
    "ATL": NonSpare_636_Arg,
    "TRN": NonSpare_1913_Arg,
    "NPP": NonSpare_1370_Arg,
    "DLK": NonSpare_880_Arg,
    "LCK": NonSpare_1156_Arg,
    "TC": NonSpare_1828_Arg,
    "TLC": NonSpare_1865_Arg,
    "ASI": NonSpare_631_Arg,
    "TES": NonSpare_1845_Arg,
    "IR": NonSpare_1116_Arg,
}, total=False)
class Variation_1493(Compound):
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1473, NonSpare_636, NonSpare_1913, NonSpare_1370, NonSpare_880, NonSpare_1156, NonSpare_1828, NonSpare_1865, NonSpare_631, NonSpare_1845, NonSpare_1116]
    cv_items_dict = {"PTL": NonSpare_1473, "ATL": NonSpare_636, "TRN": NonSpare_1913, "NPP": NonSpare_1370, "DLK": NonSpare_880, "LCK": NonSpare_1156, "TC": NonSpare_1828, "TLC": NonSpare_1865, "ASI": NonSpare_631, "TES": NonSpare_1845, "IR": NonSpare_1116}

    @overload
    @classmethod
    def spec(cls, key : Literal["PTL"]) -> NonSpare_1473:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ATL"]) -> NonSpare_636:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRN"]) -> NonSpare_1913:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NPP"]) -> NonSpare_1370:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DLK"]) -> NonSpare_880:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LCK"]) -> NonSpare_1156:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TC"]) -> NonSpare_1828:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TLC"]) -> NonSpare_1865:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ASI"]) -> NonSpare_631:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TES"]) -> NonSpare_1845:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IR"]) -> NonSpare_1116:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PTL"], Literal["ATL"], Literal["TRN"], Literal["NPP"], Literal["DLK"], Literal["LCK"], Literal["TC"], Literal["TLC"], Literal["ASI"], Literal["TES"], Literal["IR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PTL"]) -> Optional[NonSpare_1473]:
        ...
    @overload
    def get_item(self, key : Literal["ATL"]) -> Optional[NonSpare_636]:
        ...
    @overload
    def get_item(self, key : Literal["TRN"]) -> Optional[NonSpare_1913]:
        ...
    @overload
    def get_item(self, key : Literal["NPP"]) -> Optional[NonSpare_1370]:
        ...
    @overload
    def get_item(self, key : Literal["DLK"]) -> Optional[NonSpare_880]:
        ...
    @overload
    def get_item(self, key : Literal["LCK"]) -> Optional[NonSpare_1156]:
        ...
    @overload
    def get_item(self, key : Literal["TC"]) -> Optional[NonSpare_1828]:
        ...
    @overload
    def get_item(self, key : Literal["TLC"]) -> Optional[NonSpare_1865]:
        ...
    @overload
    def get_item(self, key : Literal["ASI"]) -> Optional[NonSpare_631]:
        ...
    @overload
    def get_item(self, key : Literal["TES"]) -> Optional[NonSpare_1845]:
        ...
    @overload
    def get_item(self, key : Literal["IR"]) -> Optional[NonSpare_1116]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["PTL"], val : NonSpare_1473_Arg) -> "Variation_1493":
        ...
    @overload
    def set_item(self, key : Literal["ATL"], val : NonSpare_636_Arg) -> "Variation_1493":
        ...
    @overload
    def set_item(self, key : Literal["TRN"], val : NonSpare_1913_Arg) -> "Variation_1493":
        ...
    @overload
    def set_item(self, key : Literal["NPP"], val : NonSpare_1370_Arg) -> "Variation_1493":
        ...
    @overload
    def set_item(self, key : Literal["DLK"], val : NonSpare_880_Arg) -> "Variation_1493":
        ...
    @overload
    def set_item(self, key : Literal["LCK"], val : NonSpare_1156_Arg) -> "Variation_1493":
        ...
    @overload
    def set_item(self, key : Literal["TC"], val : NonSpare_1828_Arg) -> "Variation_1493":
        ...
    @overload
    def set_item(self, key : Literal["TLC"], val : NonSpare_1865_Arg) -> "Variation_1493":
        ...
    @overload
    def set_item(self, key : Literal["ASI"], val : NonSpare_631_Arg) -> "Variation_1493":
        ...
    @overload
    def set_item(self, key : Literal["TES"], val : NonSpare_1845_Arg) -> "Variation_1493":
        ...
    @overload
    def set_item(self, key : Literal["IR"], val : NonSpare_1116_Arg) -> "Variation_1493":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["PTL"]) -> "Variation_1493":
        ...
    @overload
    def del_item(self, key : Literal["ATL"]) -> "Variation_1493":
        ...
    @overload
    def del_item(self, key : Literal["TRN"]) -> "Variation_1493":
        ...
    @overload
    def del_item(self, key : Literal["NPP"]) -> "Variation_1493":
        ...
    @overload
    def del_item(self, key : Literal["DLK"]) -> "Variation_1493":
        ...
    @overload
    def del_item(self, key : Literal["LCK"]) -> "Variation_1493":
        ...
    @overload
    def del_item(self, key : Literal["TC"]) -> "Variation_1493":
        ...
    @overload
    def del_item(self, key : Literal["TLC"]) -> "Variation_1493":
        ...
    @overload
    def del_item(self, key : Literal["ASI"]) -> "Variation_1493":
        ...
    @overload
    def del_item(self, key : Literal["TES"]) -> "Variation_1493":
        ...
    @overload
    def del_item(self, key : Literal["IR"]) -> "Variation_1493":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1493_Arg) -> 'Variation_1493':
        return cls._create(arg) # type: ignore

RuleVariation_1416_Arg: TypeAlias = Variation_1493_Arg
class RuleVariation_1416(RuleVariationContextFree):
    cv_variation = Variation_1493

    @classmethod
    def create(cls, arg : RuleVariation_1416_Arg) -> "RuleVariation_1416":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1493:
        return self.arg # type: ignore

NonSpare_1622_Arg: TypeAlias = RuleVariation_1416_Arg
class NonSpare_1622(NonSpare):
    cv_name = "RTC"
    cv_title = "Radar Track Characteristics"
    cv_rule = RuleVariation_1416

    @classmethod
    def create(cls, arg : NonSpare_1622_Arg) -> "NonSpare_1622":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1416:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1493:
        return self.rule.variation

NonSpare_1427_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_1427(NonSpare):
    cv_name = "PNB"
    cv_title = "Plot Number"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_1427_Arg) -> "NonSpare_1427":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

Content_421_Arg: TypeAlias = int
class Content_421(ContentTable):
    cv_values = {0: "PSR Echo", 1: "SSR Reply", 2: "All Call Reply", 3: "Roll Call Reply"}

RuleContent_421_Arg: TypeAlias = Content_421_Arg
class RuleContent_421(RuleContentContextFree):
    cv_content = Content_421

    @property
    def content(self) -> Content_421:
        return self._get_content() # type: ignore

Variation_174_Arg: TypeAlias = RuleContent_421_Arg
class Variation_174(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_421

    @classmethod
    def create(cls, arg : Variation_174_Arg) -> "Variation_174":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_421:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_421:
        return self.rule.content

RuleVariation_167_Arg: TypeAlias = Variation_174_Arg
class RuleVariation_167(RuleVariationContextFree):
    cv_variation = Variation_174

    @classmethod
    def create(cls, arg : RuleVariation_167_Arg) -> "RuleVariation_167":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_174:
        return self.arg # type: ignore

NonSpare_1963_Arg: TypeAlias = RuleVariation_167_Arg
class NonSpare_1963(NonSpare):
    cv_name = "TYPE"
    cv_title = "Reply Type"
    cv_rule = RuleVariation_167

    @classmethod
    def create(cls, arg : NonSpare_1963_Arg) -> "NonSpare_1963":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_167:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_174:
        return self.rule.variation

Item_1082_Arg: TypeAlias = NonSpare_1963_Arg
class Item_1082(Item):
    cv_non_spare = NonSpare_1963

    @classmethod
    def create(cls, arg : Item_1082_Arg) -> "Item_1082":
        return cls._create(arg) # type: ignore

NonSpare_1571_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_1571(NonSpare):
    cv_name = "REPLYNBR"
    cv_title = ""
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_1571_Arg) -> "NonSpare_1571":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

Item_802_Arg: TypeAlias = NonSpare_1571_Arg
class Item_802(Item):
    cv_non_spare = NonSpare_1571

    @classmethod
    def create(cls, arg : Item_802_Arg) -> "Item_802":
        return cls._create(arg) # type: ignore

Variation_1237_Arg_Group = Tuple[Union[RuleVariation_167_Arg, Tuple[Literal["TYPE"], RuleVariation_167_Arg]], Union[RuleVariation_244_Arg, Tuple[Literal["REPLYNBR"], RuleVariation_244_Arg]]]
Variation_1237_Arg: TypeAlias = Union[int, Variation_1237_Arg_Group]
class Variation_1237(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_1082, 8), (Item_802, 16)]
    cv_items_dict = {"TYPE": RuleVariation_167, "REPLYNBR": RuleVariation_244}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYPE"]) -> RuleVariation_167:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["REPLYNBR"]) -> RuleVariation_244:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYPE"], Literal["REPLYNBR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYPE"]) -> RuleVariation_167:
        ...
    @overload
    def get_item(self, key : Literal["REPLYNBR"]) -> RuleVariation_244:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1237_Arg) -> 'Variation_1237':
        return cls._create(arg) # type: ignore

Variation_1438_Arg: TypeAlias = List[Variation_1237_Arg]
class Variation_1438(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1237

    @classmethod
    def create(cls, arg : Variation_1438_Arg) -> 'Variation_1438':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1237]:
        return self._get_list() # type: ignore

RuleVariation_1361_Arg: TypeAlias = Variation_1438_Arg
class RuleVariation_1361(RuleVariationContextFree):
    cv_variation = Variation_1438

    @classmethod
    def create(cls, arg : RuleVariation_1361_Arg) -> "RuleVariation_1361":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1438:
        return self.arg # type: ignore

NonSpare_1596_Arg: TypeAlias = RuleVariation_1361_Arg
class NonSpare_1596(NonSpare):
    cv_name = "RPL"
    cv_title = "Replies/Plot Link"
    cv_rule = RuleVariation_1361

    @classmethod
    def create(cls, arg : NonSpare_1596_Arg) -> "NonSpare_1596":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1438:
        return self.rule.variation

NonSpare_1721_Arg: TypeAlias = RuleVariation_196_Arg
class NonSpare_1721(NonSpare):
    cv_name = "SNB"
    cv_title = "Scan Number"
    cv_rule = RuleVariation_196

    @classmethod
    def create(cls, arg : NonSpare_1721_Arg) -> "NonSpare_1721":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_203:
        return self.rule.variation

Content_613_Arg: TypeAlias = int
class Content_613(ContentInteger):
    cv_signedness = Unsigned

RuleContent_613_Arg: TypeAlias = Content_613_Arg
class RuleContent_613(RuleContentContextFree):
    cv_content = Content_613

    @property
    def content(self) -> Content_613:
        return self._get_content() # type: ignore

Variation_139_Arg: TypeAlias = RuleContent_613_Arg
class Variation_139(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg : Variation_139_Arg) -> "Variation_139":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_613:
        return self.rule.content

RuleVariation_139_Arg: TypeAlias = Variation_139_Arg
class RuleVariation_139(RuleVariationContextFree):
    cv_variation = Variation_139

    @classmethod
    def create(cls, arg : RuleVariation_139_Arg) -> "RuleVariation_139":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_139:
        return self.arg # type: ignore

NonSpare_2147_Arg: TypeAlias = RuleVariation_139_Arg
class NonSpare_2147(NonSpare):
    cv_name = "Y1"
    cv_title = ""
    cv_rule = RuleVariation_139

    @classmethod
    def create(cls, arg : NonSpare_2147_Arg) -> "NonSpare_2147":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_139:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_139:
        return self.rule.variation

Item_1251_Arg: TypeAlias = NonSpare_2147_Arg
class Item_1251(Item):
    cv_non_spare = NonSpare_2147

    @classmethod
    def create(cls, arg : Item_1251_Arg) -> "Item_1251":
        return cls._create(arg) # type: ignore

Variation_802_Arg: TypeAlias = RuleContent_613_Arg
class Variation_802(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 4
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg : Variation_802_Arg) -> "Variation_802":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_613:
        return self.rule.content

RuleVariation_772_Arg: TypeAlias = Variation_802_Arg
class RuleVariation_772(RuleVariationContextFree):
    cv_variation = Variation_802

    @classmethod
    def create(cls, arg : RuleVariation_772_Arg) -> "RuleVariation_772":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_802:
        return self.arg # type: ignore

NonSpare_2150_Arg: TypeAlias = RuleVariation_772_Arg
class NonSpare_2150(NonSpare):
    cv_name = "Y2"
    cv_title = ""
    cv_rule = RuleVariation_772

    @classmethod
    def create(cls, arg : NonSpare_2150_Arg) -> "NonSpare_2150":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_772:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_802:
        return self.rule.variation

Item_1254_Arg: TypeAlias = NonSpare_2150_Arg
class Item_1254(Item):
    cv_non_spare = NonSpare_2150

    @classmethod
    def create(cls, arg : Item_1254_Arg) -> "Item_1254":
        return cls._create(arg) # type: ignore

NonSpare_2152_Arg: TypeAlias = RuleVariation_139_Arg
class NonSpare_2152(NonSpare):
    cv_name = "Y3"
    cv_title = ""
    cv_rule = RuleVariation_139

    @classmethod
    def create(cls, arg : NonSpare_2152_Arg) -> "NonSpare_2152":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_139:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_139:
        return self.rule.variation

Item_1256_Arg: TypeAlias = NonSpare_2152_Arg
class Item_1256(Item):
    cv_non_spare = NonSpare_2152

    @classmethod
    def create(cls, arg : Item_1256_Arg) -> "Item_1256":
        return cls._create(arg) # type: ignore

NonSpare_2153_Arg: TypeAlias = RuleVariation_772_Arg
class NonSpare_2153(NonSpare):
    cv_name = "Y4"
    cv_title = ""
    cv_rule = RuleVariation_772

    @classmethod
    def create(cls, arg : NonSpare_2153_Arg) -> "NonSpare_2153":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_772:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_802:
        return self.rule.variation

Item_1257_Arg: TypeAlias = NonSpare_2153_Arg
class Item_1257(Item):
    cv_non_spare = NonSpare_2153

    @classmethod
    def create(cls, arg : Item_1257_Arg) -> "Item_1257":
        return cls._create(arg) # type: ignore

Content_611_Arg: TypeAlias = int
class Content_611(ContentInteger):
    cv_signedness = Unsigned

RuleContent_611_Arg: TypeAlias = Content_611_Arg
class RuleContent_611(RuleContentContextFree):
    cv_content = Content_611

    @property
    def content(self) -> Content_611:
        return self._get_content() # type: ignore

Variation_137_Arg: TypeAlias = RuleContent_611_Arg
class Variation_137(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_611

    @classmethod
    def create(cls, arg : Variation_137_Arg) -> "Variation_137":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_611:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_611:
        return self.rule.content

RuleVariation_137_Arg: TypeAlias = Variation_137_Arg
class RuleVariation_137(RuleVariationContextFree):
    cv_variation = Variation_137

    @classmethod
    def create(cls, arg : RuleVariation_137_Arg) -> "RuleVariation_137":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_137:
        return self.arg # type: ignore

NonSpare_1195_Arg: TypeAlias = RuleVariation_137_Arg
class NonSpare_1195(NonSpare):
    cv_name = "M1"
    cv_title = ""
    cv_rule = RuleVariation_137

    @classmethod
    def create(cls, arg : NonSpare_1195_Arg) -> "NonSpare_1195":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_137:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_137:
        return self.rule.variation

Item_509_Arg: TypeAlias = NonSpare_1195_Arg
class Item_509(Item):
    cv_non_spare = NonSpare_1195

    @classmethod
    def create(cls, arg : Item_509_Arg) -> "Item_509":
        return cls._create(arg) # type: ignore

NonSpare_1200_Arg: TypeAlias = RuleVariation_772_Arg
class NonSpare_1200(NonSpare):
    cv_name = "M2"
    cv_title = ""
    cv_rule = RuleVariation_772

    @classmethod
    def create(cls, arg : NonSpare_1200_Arg) -> "NonSpare_1200":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_772:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_802:
        return self.rule.variation

Item_514_Arg: TypeAlias = NonSpare_1200_Arg
class Item_514(Item):
    cv_non_spare = NonSpare_1200

    @classmethod
    def create(cls, arg : Item_514_Arg) -> "Item_514":
        return cls._create(arg) # type: ignore

Content_612_Arg: TypeAlias = int
class Content_612(ContentInteger):
    cv_signedness = Unsigned

RuleContent_612_Arg: TypeAlias = Content_612_Arg
class RuleContent_612(RuleContentContextFree):
    cv_content = Content_612

    @property
    def content(self) -> Content_612:
        return self._get_content() # type: ignore

Variation_138_Arg: TypeAlias = RuleContent_612_Arg
class Variation_138(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_612

    @classmethod
    def create(cls, arg : Variation_138_Arg) -> "Variation_138":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_612:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_612:
        return self.rule.content

RuleVariation_138_Arg: TypeAlias = Variation_138_Arg
class RuleVariation_138(RuleVariationContextFree):
    cv_variation = Variation_138

    @classmethod
    def create(cls, arg : RuleVariation_138_Arg) -> "RuleVariation_138":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_138:
        return self.arg # type: ignore

NonSpare_847_Arg: TypeAlias = RuleVariation_138_Arg
class NonSpare_847(NonSpare):
    cv_name = "D1"
    cv_title = ""
    cv_rule = RuleVariation_138

    @classmethod
    def create(cls, arg : NonSpare_847_Arg) -> "NonSpare_847":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_138:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_138:
        return self.rule.variation

Item_233_Arg: TypeAlias = NonSpare_847_Arg
class Item_233(Item):
    cv_non_spare = NonSpare_847

    @classmethod
    def create(cls, arg : Item_233_Arg) -> "Item_233":
        return cls._create(arg) # type: ignore

NonSpare_848_Arg: TypeAlias = RuleVariation_772_Arg
class NonSpare_848(NonSpare):
    cv_name = "D2"
    cv_title = ""
    cv_rule = RuleVariation_772

    @classmethod
    def create(cls, arg : NonSpare_848_Arg) -> "NonSpare_848":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_772:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_802:
        return self.rule.variation

Item_234_Arg: TypeAlias = NonSpare_848_Arg
class Item_234(Item):
    cv_non_spare = NonSpare_848

    @classmethod
    def create(cls, arg : Item_234_Arg) -> "Item_234":
        return cls._create(arg) # type: ignore

Variation_1314_Arg_Group = Tuple[Union[RuleVariation_139_Arg, Tuple[Literal["Y1"], RuleVariation_139_Arg]], Union[RuleVariation_772_Arg, Tuple[Literal["Y2"], RuleVariation_772_Arg]], Union[RuleVariation_139_Arg, Tuple[Literal["Y3"], RuleVariation_139_Arg]], Union[RuleVariation_772_Arg, Tuple[Literal["Y4"], RuleVariation_772_Arg]], Union[RuleVariation_137_Arg, Tuple[Literal["M1"], RuleVariation_137_Arg]], Union[RuleVariation_772_Arg, Tuple[Literal["M2"], RuleVariation_772_Arg]], Union[RuleVariation_138_Arg, Tuple[Literal["D1"], RuleVariation_138_Arg]], Union[RuleVariation_772_Arg, Tuple[Literal["D2"], RuleVariation_772_Arg]]]
Variation_1314_Arg: TypeAlias = Union[int, Variation_1314_Arg_Group]
class Variation_1314(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1251, 4), (Item_1254, 4), (Item_1256, 4), (Item_1257, 4), (Item_509, 4), (Item_514, 4), (Item_233, 4), (Item_234, 4)]
    cv_items_dict = {"Y1": RuleVariation_139, "Y2": RuleVariation_772, "Y3": RuleVariation_139, "Y4": RuleVariation_772, "M1": RuleVariation_137, "M2": RuleVariation_772, "D1": RuleVariation_138, "D2": RuleVariation_772}

    @overload
    @classmethod
    def spec(cls, key : Literal["Y1"]) -> RuleVariation_139:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y2"]) -> RuleVariation_772:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y3"]) -> RuleVariation_139:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y4"]) -> RuleVariation_772:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M1"]) -> RuleVariation_137:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M2"]) -> RuleVariation_772:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["D1"]) -> RuleVariation_138:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["D2"]) -> RuleVariation_772:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["Y1"], Literal["Y2"], Literal["Y3"], Literal["Y4"], Literal["M1"], Literal["M2"], Literal["D1"], Literal["D2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["Y1"]) -> RuleVariation_139:
        ...
    @overload
    def get_item(self, key : Literal["Y2"]) -> RuleVariation_772:
        ...
    @overload
    def get_item(self, key : Literal["Y3"]) -> RuleVariation_139:
        ...
    @overload
    def get_item(self, key : Literal["Y4"]) -> RuleVariation_772:
        ...
    @overload
    def get_item(self, key : Literal["M1"]) -> RuleVariation_137:
        ...
    @overload
    def get_item(self, key : Literal["M2"]) -> RuleVariation_772:
        ...
    @overload
    def get_item(self, key : Literal["D1"]) -> RuleVariation_138:
        ...
    @overload
    def get_item(self, key : Literal["D2"]) -> RuleVariation_772:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1314_Arg) -> 'Variation_1314':
        return cls._create(arg) # type: ignore

RuleVariation_1239_Arg: TypeAlias = Variation_1314_Arg
class RuleVariation_1239(RuleVariationContextFree):
    cv_variation = Variation_1314

    @classmethod
    def create(cls, arg : RuleVariation_1239_Arg) -> "RuleVariation_1239":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1314:
        return self.arg # type: ignore

NonSpare_854_Arg: TypeAlias = RuleVariation_1239_Arg
class NonSpare_854(NonSpare):
    cv_name = "DATE"
    cv_title = "Common and Plot Characteristics Date"
    cv_rule = RuleVariation_1239

    @classmethod
    def create(cls, arg : NonSpare_854_Arg) -> "NonSpare_854":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1239:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1314:
        return self.rule.variation

Variation_1488_Arg = TypedDict('Variation_1488_Arg', {
    "PNB": NonSpare_1427_Arg,
    "RPL": NonSpare_1596_Arg,
    "SNB": NonSpare_1721_Arg,
    "DATE": NonSpare_854_Arg,
}, total=False)
class Variation_1488(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1427, NonSpare_1596, NonSpare_1721, NonSpare_854]
    cv_items_dict = {"PNB": NonSpare_1427, "RPL": NonSpare_1596, "SNB": NonSpare_1721, "DATE": NonSpare_854}

    @overload
    @classmethod
    def spec(cls, key : Literal["PNB"]) -> NonSpare_1427:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RPL"]) -> NonSpare_1596:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SNB"]) -> NonSpare_1721:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DATE"]) -> NonSpare_854:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PNB"], Literal["RPL"], Literal["SNB"], Literal["DATE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PNB"]) -> Optional[NonSpare_1427]:
        ...
    @overload
    def get_item(self, key : Literal["RPL"]) -> Optional[NonSpare_1596]:
        ...
    @overload
    def get_item(self, key : Literal["SNB"]) -> Optional[NonSpare_1721]:
        ...
    @overload
    def get_item(self, key : Literal["DATE"]) -> Optional[NonSpare_854]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["PNB"], val : NonSpare_1427_Arg) -> "Variation_1488":
        ...
    @overload
    def set_item(self, key : Literal["RPL"], val : NonSpare_1596_Arg) -> "Variation_1488":
        ...
    @overload
    def set_item(self, key : Literal["SNB"], val : NonSpare_1721_Arg) -> "Variation_1488":
        ...
    @overload
    def set_item(self, key : Literal["DATE"], val : NonSpare_854_Arg) -> "Variation_1488":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["PNB"]) -> "Variation_1488":
        ...
    @overload
    def del_item(self, key : Literal["RPL"]) -> "Variation_1488":
        ...
    @overload
    def del_item(self, key : Literal["SNB"]) -> "Variation_1488":
        ...
    @overload
    def del_item(self, key : Literal["DATE"]) -> "Variation_1488":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1488_Arg) -> 'Variation_1488':
        return cls._create(arg) # type: ignore

RuleVariation_1411_Arg: TypeAlias = Variation_1488_Arg
class RuleVariation_1411(RuleVariationContextFree):
    cv_variation = Variation_1488

    @classmethod
    def create(cls, arg : RuleVariation_1411_Arg) -> "RuleVariation_1411":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1488:
        return self.arg # type: ignore

NonSpare_809_Arg: TypeAlias = RuleVariation_1411_Arg
class NonSpare_809(NonSpare):
    cv_name = "CPC"
    cv_title = "Common and Plot Characteristics"
    cv_rule = RuleVariation_1411

    @classmethod
    def create(cls, arg : NonSpare_809_Arg) -> "NonSpare_809":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1411:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1488:
        return self.rule.variation

Expansion_5_Arg = TypedDict('Expansion_5_Arg', {
    "MD5": NonSpare_1240_Arg,
    "M5N": NonSpare_1210_Arg,
    "M4E": NonSpare_1208_Arg,
    "RPC": NonSpare_1594_Arg,
    "ERR": NonSpare_951_Arg,
    "RTC": NonSpare_1622_Arg,
    "CPC": NonSpare_809_Arg,
}, total=False)
class Expansion_5(Expansion):
    cv_fspec_bytes = 1
    cv_items_list = [NonSpare_1240, NonSpare_1210, NonSpare_1208, NonSpare_1594, NonSpare_951, NonSpare_1622, NonSpare_809]
    items_dict = {"MD5": NonSpare_1240, "M5N": NonSpare_1210, "M4E": NonSpare_1208, "RPC": NonSpare_1594, "ERR": NonSpare_951, "RTC": NonSpare_1622, "CPC": NonSpare_809}

    @overload
    @classmethod
    def spec(cls, key : Literal["MD5"]) -> NonSpare_1240:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M5N"]) -> NonSpare_1210:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M4E"]) -> NonSpare_1208:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RPC"]) -> NonSpare_1594:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ERR"]) -> NonSpare_951:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RTC"]) -> NonSpare_1622:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPC"]) -> NonSpare_809:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MD5"], Literal["M5N"], Literal["M4E"], Literal["RPC"], Literal["ERR"], Literal["RTC"], Literal["CPC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MD5"]) -> Optional[NonSpare_1240]:
        ...
    @overload
    def get_item(self, key : Literal["M5N"]) -> Optional[NonSpare_1210]:
        ...
    @overload
    def get_item(self, key : Literal["M4E"]) -> Optional[NonSpare_1208]:
        ...
    @overload
    def get_item(self, key : Literal["RPC"]) -> Optional[NonSpare_1594]:
        ...
    @overload
    def get_item(self, key : Literal["ERR"]) -> Optional[NonSpare_951]:
        ...
    @overload
    def get_item(self, key : Literal["RTC"]) -> Optional[NonSpare_1622]:
        ...
    @overload
    def get_item(self, key : Literal["CPC"]) -> Optional[NonSpare_809]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["MD5"], val : NonSpare_1240_Arg) -> "Expansion_5":
        ...
    @overload
    def set_item(self, key : Literal["M5N"], val : NonSpare_1210_Arg) -> "Expansion_5":
        ...
    @overload
    def set_item(self, key : Literal["M4E"], val : NonSpare_1208_Arg) -> "Expansion_5":
        ...
    @overload
    def set_item(self, key : Literal["RPC"], val : NonSpare_1594_Arg) -> "Expansion_5":
        ...
    @overload
    def set_item(self, key : Literal["ERR"], val : NonSpare_951_Arg) -> "Expansion_5":
        ...
    @overload
    def set_item(self, key : Literal["RTC"], val : NonSpare_1622_Arg) -> "Expansion_5":
        ...
    @overload
    def set_item(self, key : Literal["CPC"], val : NonSpare_809_Arg) -> "Expansion_5":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["MD5"]) -> "Expansion_5":
        ...
    @overload
    def del_item(self, key : Literal["M5N"]) -> "Expansion_5":
        ...
    @overload
    def del_item(self, key : Literal["M4E"]) -> "Expansion_5":
        ...
    @overload
    def del_item(self, key : Literal["RPC"]) -> "Expansion_5":
        ...
    @overload
    def del_item(self, key : Literal["ERR"]) -> "Expansion_5":
        ...
    @overload
    def del_item(self, key : Literal["RTC"]) -> "Expansion_5":
        ...
    @overload
    def del_item(self, key : Literal["CPC"]) -> "Expansion_5":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Expansion_5_Arg) -> 'Expansion_5':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Expansion_5", Bits]]:
        return cls._parse(bs) # type: ignore

class Asterix_41(AstRef):
    cv_category = 48
    cv_edition = (1, 11)
    cv_expansion = Expansion_5

NonSpare_891_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_891(NonSpare):
    cv_name = "DRN"
    cv_title = ""
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_891_Arg) -> "NonSpare_891":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

Item_270_Arg: TypeAlias = NonSpare_891_Arg
class Item_270(Item):
    cv_non_spare = NonSpare_891

    @classmethod
    def create(cls, arg : Item_270_Arg) -> "Item_270":
        return cls._create(arg) # type: ignore

Variation_1191_Arg_Group = Tuple[Union[RuleVariation_158_Arg, Tuple[Literal["SACADJS"], RuleVariation_158_Arg]], Union[RuleVariation_158_Arg, Tuple[Literal["SICADJS"], RuleVariation_158_Arg]], Union[RuleVariation_325_Arg, Tuple[Literal["TIMEOFDAYSCN"], RuleVariation_325_Arg]], Union[RuleVariation_150_Arg, Tuple[Literal["DATAUSE"], RuleVariation_150_Arg]], Union[RuleVariation_941_Arg, Tuple[Literal["DRNA"], RuleVariation_941_Arg]], Union[RuleVariation_244_Arg, Tuple[Literal["DRN"], RuleVariation_244_Arg]]]
Variation_1191_Arg: TypeAlias = Union[int, Variation_1191_Arg_Group]
class Variation_1191(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_items_list = [(Item_854, 8), (Item_885, 8), (Item_1001, 16), (Item_238, 7), (Item_272, 1), (Item_270, 16)]
    cv_items_dict = {"SACADJS": RuleVariation_158, "SICADJS": RuleVariation_158, "TIMEOFDAYSCN": RuleVariation_325, "DATAUSE": RuleVariation_150, "DRNA": RuleVariation_941, "DRN": RuleVariation_244}

    @overload
    @classmethod
    def spec(cls, key : Literal["SACADJS"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SICADJS"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TIMEOFDAYSCN"]) -> RuleVariation_325:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DATAUSE"]) -> RuleVariation_150:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DRNA"]) -> RuleVariation_941:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DRN"]) -> RuleVariation_244:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SACADJS"], Literal["SICADJS"], Literal["TIMEOFDAYSCN"], Literal["DATAUSE"], Literal["DRNA"], Literal["DRN"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SACADJS"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["SICADJS"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["TIMEOFDAYSCN"]) -> RuleVariation_325:
        ...
    @overload
    def get_item(self, key : Literal["DATAUSE"]) -> RuleVariation_150:
        ...
    @overload
    def get_item(self, key : Literal["DRNA"]) -> RuleVariation_941:
        ...
    @overload
    def get_item(self, key : Literal["DRN"]) -> RuleVariation_244:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1191_Arg) -> 'Variation_1191':
        return cls._create(arg) # type: ignore

Variation_1424_Arg: TypeAlias = List[Variation_1191_Arg]
class Variation_1424(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1191

    @classmethod
    def create(cls, arg : Variation_1424_Arg) -> 'Variation_1424':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1191]:
        return self._get_list() # type: ignore

RuleVariation_1347_Arg: TypeAlias = Variation_1424_Arg
class RuleVariation_1347(RuleVariationContextFree):
    cv_variation = Variation_1424

    @classmethod
    def create(cls, arg : RuleVariation_1347_Arg) -> "RuleVariation_1347":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1424:
        return self.arg # type: ignore

NonSpare_630_Arg: TypeAlias = RuleVariation_1347_Arg
class NonSpare_630(NonSpare):
    cv_name = "ASI"
    cv_title = "Adjacent Sensor Information"
    cv_rule = RuleVariation_1347

    @classmethod
    def create(cls, arg : NonSpare_630_Arg) -> "NonSpare_630":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1347:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1424:
        return self.rule.variation

Variation_1492_Arg = TypedDict('Variation_1492_Arg', {
    "PTL": NonSpare_1473_Arg,
    "ATL": NonSpare_636_Arg,
    "TRN": NonSpare_1913_Arg,
    "NPP": NonSpare_1370_Arg,
    "DLK": NonSpare_880_Arg,
    "LCK": NonSpare_1156_Arg,
    "TC": NonSpare_1828_Arg,
    "TLC": NonSpare_1865_Arg,
    "ASI": NonSpare_630_Arg,
    "TES": NonSpare_1845_Arg,
    "IR": NonSpare_1116_Arg,
}, total=False)
class Variation_1492(Compound):
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1473, NonSpare_636, NonSpare_1913, NonSpare_1370, NonSpare_880, NonSpare_1156, NonSpare_1828, NonSpare_1865, NonSpare_630, NonSpare_1845, NonSpare_1116]
    cv_items_dict = {"PTL": NonSpare_1473, "ATL": NonSpare_636, "TRN": NonSpare_1913, "NPP": NonSpare_1370, "DLK": NonSpare_880, "LCK": NonSpare_1156, "TC": NonSpare_1828, "TLC": NonSpare_1865, "ASI": NonSpare_630, "TES": NonSpare_1845, "IR": NonSpare_1116}

    @overload
    @classmethod
    def spec(cls, key : Literal["PTL"]) -> NonSpare_1473:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ATL"]) -> NonSpare_636:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRN"]) -> NonSpare_1913:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NPP"]) -> NonSpare_1370:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DLK"]) -> NonSpare_880:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LCK"]) -> NonSpare_1156:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TC"]) -> NonSpare_1828:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TLC"]) -> NonSpare_1865:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ASI"]) -> NonSpare_630:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TES"]) -> NonSpare_1845:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IR"]) -> NonSpare_1116:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PTL"], Literal["ATL"], Literal["TRN"], Literal["NPP"], Literal["DLK"], Literal["LCK"], Literal["TC"], Literal["TLC"], Literal["ASI"], Literal["TES"], Literal["IR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PTL"]) -> Optional[NonSpare_1473]:
        ...
    @overload
    def get_item(self, key : Literal["ATL"]) -> Optional[NonSpare_636]:
        ...
    @overload
    def get_item(self, key : Literal["TRN"]) -> Optional[NonSpare_1913]:
        ...
    @overload
    def get_item(self, key : Literal["NPP"]) -> Optional[NonSpare_1370]:
        ...
    @overload
    def get_item(self, key : Literal["DLK"]) -> Optional[NonSpare_880]:
        ...
    @overload
    def get_item(self, key : Literal["LCK"]) -> Optional[NonSpare_1156]:
        ...
    @overload
    def get_item(self, key : Literal["TC"]) -> Optional[NonSpare_1828]:
        ...
    @overload
    def get_item(self, key : Literal["TLC"]) -> Optional[NonSpare_1865]:
        ...
    @overload
    def get_item(self, key : Literal["ASI"]) -> Optional[NonSpare_630]:
        ...
    @overload
    def get_item(self, key : Literal["TES"]) -> Optional[NonSpare_1845]:
        ...
    @overload
    def get_item(self, key : Literal["IR"]) -> Optional[NonSpare_1116]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["PTL"], val : NonSpare_1473_Arg) -> "Variation_1492":
        ...
    @overload
    def set_item(self, key : Literal["ATL"], val : NonSpare_636_Arg) -> "Variation_1492":
        ...
    @overload
    def set_item(self, key : Literal["TRN"], val : NonSpare_1913_Arg) -> "Variation_1492":
        ...
    @overload
    def set_item(self, key : Literal["NPP"], val : NonSpare_1370_Arg) -> "Variation_1492":
        ...
    @overload
    def set_item(self, key : Literal["DLK"], val : NonSpare_880_Arg) -> "Variation_1492":
        ...
    @overload
    def set_item(self, key : Literal["LCK"], val : NonSpare_1156_Arg) -> "Variation_1492":
        ...
    @overload
    def set_item(self, key : Literal["TC"], val : NonSpare_1828_Arg) -> "Variation_1492":
        ...
    @overload
    def set_item(self, key : Literal["TLC"], val : NonSpare_1865_Arg) -> "Variation_1492":
        ...
    @overload
    def set_item(self, key : Literal["ASI"], val : NonSpare_630_Arg) -> "Variation_1492":
        ...
    @overload
    def set_item(self, key : Literal["TES"], val : NonSpare_1845_Arg) -> "Variation_1492":
        ...
    @overload
    def set_item(self, key : Literal["IR"], val : NonSpare_1116_Arg) -> "Variation_1492":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["PTL"]) -> "Variation_1492":
        ...
    @overload
    def del_item(self, key : Literal["ATL"]) -> "Variation_1492":
        ...
    @overload
    def del_item(self, key : Literal["TRN"]) -> "Variation_1492":
        ...
    @overload
    def del_item(self, key : Literal["NPP"]) -> "Variation_1492":
        ...
    @overload
    def del_item(self, key : Literal["DLK"]) -> "Variation_1492":
        ...
    @overload
    def del_item(self, key : Literal["LCK"]) -> "Variation_1492":
        ...
    @overload
    def del_item(self, key : Literal["TC"]) -> "Variation_1492":
        ...
    @overload
    def del_item(self, key : Literal["TLC"]) -> "Variation_1492":
        ...
    @overload
    def del_item(self, key : Literal["ASI"]) -> "Variation_1492":
        ...
    @overload
    def del_item(self, key : Literal["TES"]) -> "Variation_1492":
        ...
    @overload
    def del_item(self, key : Literal["IR"]) -> "Variation_1492":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1492_Arg) -> 'Variation_1492':
        return cls._create(arg) # type: ignore

RuleVariation_1415_Arg: TypeAlias = Variation_1492_Arg
class RuleVariation_1415(RuleVariationContextFree):
    cv_variation = Variation_1492

    @classmethod
    def create(cls, arg : RuleVariation_1415_Arg) -> "RuleVariation_1415":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1492:
        return self.arg # type: ignore

NonSpare_1621_Arg: TypeAlias = RuleVariation_1415_Arg
class NonSpare_1621(NonSpare):
    cv_name = "RTC"
    cv_title = "Radar Track Characteristics"
    cv_rule = RuleVariation_1415

    @classmethod
    def create(cls, arg : NonSpare_1621_Arg) -> "NonSpare_1621":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1415:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1492:
        return self.rule.variation

Content_283_Arg: TypeAlias = int
class Content_283(ContentTable):
    cv_values = {0: "Mode-2 code as derived from reply of the transponder", 1: "Smoothed Mode-2 as provided by a local tracker"}

RuleContent_283_Arg: TypeAlias = Content_283_Arg
class RuleContent_283(RuleContentContextFree):
    cv_content = Content_283

    @property
    def content(self) -> Content_283:
        return self._get_content() # type: ignore

Variation_545_Arg: TypeAlias = RuleContent_283_Arg
class Variation_545(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_283

    @classmethod
    def create(cls, arg : Variation_545_Arg) -> "Variation_545":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_283:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_283:
        return self.rule.content

RuleVariation_534_Arg: TypeAlias = Variation_545_Arg
class RuleVariation_534(RuleVariationContextFree):
    cv_variation = Variation_545

    @classmethod
    def create(cls, arg : RuleVariation_534_Arg) -> "RuleVariation_534":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_545:
        return self.arg # type: ignore

NonSpare_1127_Arg: TypeAlias = RuleVariation_534_Arg
class NonSpare_1127(NonSpare):
    cv_name = "L"
    cv_title = ""
    cv_rule = RuleVariation_534

    @classmethod
    def create(cls, arg : NonSpare_1127_Arg) -> "NonSpare_1127":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_534:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_545:
        return self.rule.variation

Item_445_Arg: TypeAlias = NonSpare_1127_Arg
class Item_445(Item):
    cv_non_spare = NonSpare_1127

    @classmethod
    def create(cls, arg : Item_445_Arg) -> "Item_445":
        return cls._create(arg) # type: ignore

NonSpare_595_Arg: TypeAlias = RuleVariation_776_Arg
class NonSpare_595(NonSpare):
    cv_name = "ALTM2"
    cv_title = "Mode-2 Code in Octal Representation"
    cv_rule = RuleVariation_776

    @classmethod
    def create(cls, arg : NonSpare_595_Arg) -> "NonSpare_595":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_776:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_806:
        return self.rule.variation

Item_65_Arg: TypeAlias = NonSpare_595_Arg
class Item_65(Item):
    cv_non_spare = NonSpare_595

    @classmethod
    def create(cls, arg : Item_65_Arg) -> "Item_65":
        return cls._create(arg) # type: ignore

Variation_1253_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_534_Arg, Tuple[Literal["L"], RuleVariation_534_Arg]], int, Union[RuleVariation_776_Arg, Tuple[Literal["ALTM2"], RuleVariation_776_Arg]]]
Variation_1253_Arg: TypeAlias = Union[int, Variation_1253_Arg_Group]
class Variation_1253(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1099, 1), (Item_353, 1), (Item_445, 1), (Item_16, 1), (Item_65, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "L": RuleVariation_534, "ALTM2": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_534:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALTM2"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["ALTM2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_534:
        ...
    @overload
    def get_item(self, key : Literal["ALTM2"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1253_Arg) -> 'Variation_1253':
        return cls._create(arg) # type: ignore

RuleVariation_1183_Arg: TypeAlias = Variation_1253_Arg
class RuleVariation_1183(RuleVariationContextFree):
    cv_variation = Variation_1253

    @classmethod
    def create(cls, arg : RuleVariation_1183_Arg) -> "RuleVariation_1183":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1253:
        return self.arg # type: ignore

NonSpare_594_Arg: TypeAlias = RuleVariation_1183_Arg
class NonSpare_594(NonSpare):
    cv_name = "ALTM2"
    cv_title = "Alternative Mode 2 Code"
    cv_rule = RuleVariation_1183

    @classmethod
    def create(cls, arg : NonSpare_594_Arg) -> "NonSpare_594":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1183:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1253:
        return self.rule.variation

Content_286_Arg: TypeAlias = int
class Content_286(ContentTable):
    cv_values = {0: "Mode-3/A code as derived from the reply of the transponder", 1: "Smoothed Mode-3/A code as provided by a local tracker"}

RuleContent_286_Arg: TypeAlias = Content_286_Arg
class RuleContent_286(RuleContentContextFree):
    cv_content = Content_286

    @property
    def content(self) -> Content_286:
        return self._get_content() # type: ignore

Variation_548_Arg: TypeAlias = RuleContent_286_Arg
class Variation_548(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_286

    @classmethod
    def create(cls, arg : Variation_548_Arg) -> "Variation_548":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_286:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_286:
        return self.rule.content

RuleVariation_537_Arg: TypeAlias = Variation_548_Arg
class RuleVariation_537(RuleVariationContextFree):
    cv_variation = Variation_548

    @classmethod
    def create(cls, arg : RuleVariation_537_Arg) -> "RuleVariation_537":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_548:
        return self.arg # type: ignore

NonSpare_1130_Arg: TypeAlias = RuleVariation_537_Arg
class NonSpare_1130(NonSpare):
    cv_name = "L"
    cv_title = ""
    cv_rule = RuleVariation_537

    @classmethod
    def create(cls, arg : NonSpare_1130_Arg) -> "NonSpare_1130":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_537:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_548:
        return self.rule.variation

Item_448_Arg: TypeAlias = NonSpare_1130_Arg
class Item_448(Item):
    cv_non_spare = NonSpare_1130

    @classmethod
    def create(cls, arg : Item_448_Arg) -> "Item_448":
        return cls._create(arg) # type: ignore

NonSpare_597_Arg: TypeAlias = RuleVariation_776_Arg
class NonSpare_597(NonSpare):
    cv_name = "ALTM3"
    cv_title = "Mode-3/A Code in Octal Representation"
    cv_rule = RuleVariation_776

    @classmethod
    def create(cls, arg : NonSpare_597_Arg) -> "NonSpare_597":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_776:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_806:
        return self.rule.variation

Item_66_Arg: TypeAlias = NonSpare_597_Arg
class Item_66(Item):
    cv_non_spare = NonSpare_597

    @classmethod
    def create(cls, arg : Item_66_Arg) -> "Item_66":
        return cls._create(arg) # type: ignore

Variation_1255_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_537_Arg, Tuple[Literal["L"], RuleVariation_537_Arg]], int, Union[RuleVariation_776_Arg, Tuple[Literal["ALTM3"], RuleVariation_776_Arg]]]
Variation_1255_Arg: TypeAlias = Union[int, Variation_1255_Arg_Group]
class Variation_1255(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1099, 1), (Item_353, 1), (Item_448, 1), (Item_16, 1), (Item_66, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "L": RuleVariation_537, "ALTM3": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_537:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALTM3"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["ALTM3"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_537:
        ...
    @overload
    def get_item(self, key : Literal["ALTM3"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1255_Arg) -> 'Variation_1255':
        return cls._create(arg) # type: ignore

RuleVariation_1185_Arg: TypeAlias = Variation_1255_Arg
class RuleVariation_1185(RuleVariationContextFree):
    cv_variation = Variation_1255

    @classmethod
    def create(cls, arg : RuleVariation_1185_Arg) -> "RuleVariation_1185":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1255:
        return self.arg # type: ignore

NonSpare_596_Arg: TypeAlias = RuleVariation_1185_Arg
class NonSpare_596(NonSpare):
    cv_name = "ALTM3"
    cv_title = "Alternative Mode 3/A"
    cv_rule = RuleVariation_1185

    @classmethod
    def create(cls, arg : NonSpare_596_Arg) -> "NonSpare_596":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1185:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1255:
        return self.rule.variation

Content_649_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ALTFL"]]]
class Content_649(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.25
    cv_unit = "ALTFL"

    def as_quantity(self, cv_unit : Optional[Literal["ALTFL"]] = None) -> float:
        return self._as_quantity()

RuleContent_649_Arg: TypeAlias = Content_649_Arg
class RuleContent_649(RuleContentContextFree):
    cv_content = Content_649

    @property
    def content(self) -> Content_649:
        return self._get_content() # type: ignore

Variation_605_Arg: TypeAlias = RuleContent_649_Arg
class Variation_605(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_649

    @classmethod
    def create(cls, arg : Variation_605_Arg) -> "Variation_605":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_649:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_649:
        return self.rule.content

RuleVariation_594_Arg: TypeAlias = Variation_605_Arg
class RuleVariation_594(RuleVariationContextFree):
    cv_variation = Variation_605

    @classmethod
    def create(cls, arg : RuleVariation_594_Arg) -> "RuleVariation_594":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_605:
        return self.arg # type: ignore

NonSpare_593_Arg: TypeAlias = RuleVariation_594_Arg
class NonSpare_593(NonSpare):
    cv_name = "ALTFL"
    cv_title = "Flight Level in Two's Complement Form"
    cv_rule = RuleVariation_594

    @classmethod
    def create(cls, arg : NonSpare_593_Arg) -> "NonSpare_593":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_594:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_605:
        return self.rule.variation

Item_64_Arg: TypeAlias = NonSpare_593_Arg
class Item_64(Item):
    cv_non_spare = NonSpare_593

    @classmethod
    def create(cls, arg : Item_64_Arg) -> "Item_64":
        return cls._create(arg) # type: ignore

Variation_1247_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_594_Arg, Tuple[Literal["ALTFL"], RuleVariation_594_Arg]]]
Variation_1247_Arg: TypeAlias = Union[int, Variation_1247_Arg_Group]
class Variation_1247(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1099, 1), (Item_353, 1), (Item_64, 14)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "ALTFL": RuleVariation_594}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALTFL"]) -> RuleVariation_594:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["ALTFL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["ALTFL"]) -> RuleVariation_594:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1247_Arg) -> 'Variation_1247':
        return cls._create(arg) # type: ignore

RuleVariation_1177_Arg: TypeAlias = Variation_1247_Arg
class RuleVariation_1177(RuleVariationContextFree):
    cv_variation = Variation_1247

    @classmethod
    def create(cls, arg : RuleVariation_1177_Arg) -> "RuleVariation_1177":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1247:
        return self.arg # type: ignore

NonSpare_592_Arg: TypeAlias = RuleVariation_1177_Arg
class NonSpare_592(NonSpare):
    cv_name = "ALTFL"
    cv_title = "Alternative Flight Level"
    cv_rule = RuleVariation_1177

    @classmethod
    def create(cls, arg : NonSpare_592_Arg) -> "NonSpare_592":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1177:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1247:
        return self.rule.variation

Variation_1462_Arg = TypedDict('Variation_1462_Arg', {
    "ALTM2": NonSpare_594_Arg,
    "ALTM3": NonSpare_596_Arg,
    "ALTFL": NonSpare_592_Arg,
}, total=False)
class Variation_1462(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_594, NonSpare_596, NonSpare_592]
    cv_items_dict = {"ALTM2": NonSpare_594, "ALTM3": NonSpare_596, "ALTFL": NonSpare_592}

    @overload
    @classmethod
    def spec(cls, key : Literal["ALTM2"]) -> NonSpare_594:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALTM3"]) -> NonSpare_596:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALTFL"]) -> NonSpare_592:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ALTM2"], Literal["ALTM3"], Literal["ALTFL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ALTM2"]) -> Optional[NonSpare_594]:
        ...
    @overload
    def get_item(self, key : Literal["ALTM3"]) -> Optional[NonSpare_596]:
        ...
    @overload
    def get_item(self, key : Literal["ALTFL"]) -> Optional[NonSpare_592]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["ALTM2"], val : NonSpare_594_Arg) -> "Variation_1462":
        ...
    @overload
    def set_item(self, key : Literal["ALTM3"], val : NonSpare_596_Arg) -> "Variation_1462":
        ...
    @overload
    def set_item(self, key : Literal["ALTFL"], val : NonSpare_592_Arg) -> "Variation_1462":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["ALTM2"]) -> "Variation_1462":
        ...
    @overload
    def del_item(self, key : Literal["ALTM3"]) -> "Variation_1462":
        ...
    @overload
    def del_item(self, key : Literal["ALTFL"]) -> "Variation_1462":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1462_Arg) -> 'Variation_1462':
        return cls._create(arg) # type: ignore

RuleVariation_1385_Arg: TypeAlias = Variation_1462_Arg
class RuleVariation_1385(RuleVariationContextFree):
    cv_variation = Variation_1462

    @classmethod
    def create(cls, arg : RuleVariation_1385_Arg) -> "RuleVariation_1385":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1462:
        return self.arg # type: ignore

NonSpare_1024_Arg: TypeAlias = RuleVariation_1385_Arg
class NonSpare_1024(NonSpare):
    cv_name = "GEN48"
    cv_title = "Generic Category 048 Data"
    cv_rule = RuleVariation_1385

    @classmethod
    def create(cls, arg : NonSpare_1024_Arg) -> "NonSpare_1024":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1462:
        return self.rule.variation

Expansion_4_Arg = TypedDict('Expansion_4_Arg', {
    "MD5": NonSpare_1240_Arg,
    "M5N": NonSpare_1210_Arg,
    "M4E": NonSpare_1208_Arg,
    "RPC": NonSpare_1594_Arg,
    "ERR": NonSpare_951_Arg,
    "RTC": NonSpare_1621_Arg,
    "CPC": NonSpare_809_Arg,
    "GEN48": NonSpare_1024_Arg,
}, total=False)
class Expansion_4(Expansion):
    cv_fspec_bytes = 1
    cv_items_list = [NonSpare_1240, NonSpare_1210, NonSpare_1208, NonSpare_1594, NonSpare_951, NonSpare_1621, NonSpare_809, NonSpare_1024]
    items_dict = {"MD5": NonSpare_1240, "M5N": NonSpare_1210, "M4E": NonSpare_1208, "RPC": NonSpare_1594, "ERR": NonSpare_951, "RTC": NonSpare_1621, "CPC": NonSpare_809, "GEN48": NonSpare_1024}

    @overload
    @classmethod
    def spec(cls, key : Literal["MD5"]) -> NonSpare_1240:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M5N"]) -> NonSpare_1210:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M4E"]) -> NonSpare_1208:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RPC"]) -> NonSpare_1594:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ERR"]) -> NonSpare_951:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RTC"]) -> NonSpare_1621:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPC"]) -> NonSpare_809:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GEN48"]) -> NonSpare_1024:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MD5"], Literal["M5N"], Literal["M4E"], Literal["RPC"], Literal["ERR"], Literal["RTC"], Literal["CPC"], Literal["GEN48"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MD5"]) -> Optional[NonSpare_1240]:
        ...
    @overload
    def get_item(self, key : Literal["M5N"]) -> Optional[NonSpare_1210]:
        ...
    @overload
    def get_item(self, key : Literal["M4E"]) -> Optional[NonSpare_1208]:
        ...
    @overload
    def get_item(self, key : Literal["RPC"]) -> Optional[NonSpare_1594]:
        ...
    @overload
    def get_item(self, key : Literal["ERR"]) -> Optional[NonSpare_951]:
        ...
    @overload
    def get_item(self, key : Literal["RTC"]) -> Optional[NonSpare_1621]:
        ...
    @overload
    def get_item(self, key : Literal["CPC"]) -> Optional[NonSpare_809]:
        ...
    @overload
    def get_item(self, key : Literal["GEN48"]) -> Optional[NonSpare_1024]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["MD5"], val : NonSpare_1240_Arg) -> "Expansion_4":
        ...
    @overload
    def set_item(self, key : Literal["M5N"], val : NonSpare_1210_Arg) -> "Expansion_4":
        ...
    @overload
    def set_item(self, key : Literal["M4E"], val : NonSpare_1208_Arg) -> "Expansion_4":
        ...
    @overload
    def set_item(self, key : Literal["RPC"], val : NonSpare_1594_Arg) -> "Expansion_4":
        ...
    @overload
    def set_item(self, key : Literal["ERR"], val : NonSpare_951_Arg) -> "Expansion_4":
        ...
    @overload
    def set_item(self, key : Literal["RTC"], val : NonSpare_1621_Arg) -> "Expansion_4":
        ...
    @overload
    def set_item(self, key : Literal["CPC"], val : NonSpare_809_Arg) -> "Expansion_4":
        ...
    @overload
    def set_item(self, key : Literal["GEN48"], val : NonSpare_1024_Arg) -> "Expansion_4":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["MD5"]) -> "Expansion_4":
        ...
    @overload
    def del_item(self, key : Literal["M5N"]) -> "Expansion_4":
        ...
    @overload
    def del_item(self, key : Literal["M4E"]) -> "Expansion_4":
        ...
    @overload
    def del_item(self, key : Literal["RPC"]) -> "Expansion_4":
        ...
    @overload
    def del_item(self, key : Literal["ERR"]) -> "Expansion_4":
        ...
    @overload
    def del_item(self, key : Literal["RTC"]) -> "Expansion_4":
        ...
    @overload
    def del_item(self, key : Literal["CPC"]) -> "Expansion_4":
        ...
    @overload
    def del_item(self, key : Literal["GEN48"]) -> "Expansion_4":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Expansion_4_Arg) -> 'Expansion_4':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Expansion_4", Bits]]:
        return cls._parse(bs) # type: ignore

class Asterix_42(AstRef):
    cv_category = 48
    cv_edition = (1, 12)
    cv_expansion = Expansion_4

NonSpare_38_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_38(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_38_Arg) -> "NonSpare_38":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_38(UapItem):
    cv_non_spare = NonSpare_38

NonSpare_328_Arg: TypeAlias = RuleVariation_362_Arg
class NonSpare_328(NonSpare):
    cv_name = "140"
    cv_title = "Time of Day"
    cv_rule = RuleVariation_362

    @classmethod
    def create(cls, arg : NonSpare_328_Arg) -> "NonSpare_328":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_362:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_369:
        return self.rule.variation

class UapItem_328(UapItem):
    cv_non_spare = NonSpare_328

Content_344_Arg: TypeAlias = int
class Content_344(ContentTable):
    cv_values = {0: "No detection", 1: "Single PSR detection", 2: "Single SSR detection", 3: "SSR + PSR detection", 4: "Single ModeS All-Call", 5: "Single ModeS Roll-Call", 6: "ModeS All-Call + PSR", 7: "ModeS Roll-Call +PSR"}

RuleContent_344_Arg: TypeAlias = Content_344_Arg
class RuleContent_344(RuleContentContextFree):
    cv_content = Content_344

    @property
    def content(self) -> Content_344:
        return self._get_content() # type: ignore

Variation_126_Arg: TypeAlias = RuleContent_344_Arg
class Variation_126(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_344

    @classmethod
    def create(cls, arg : Variation_126_Arg) -> "Variation_126":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_344:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_344:
        return self.rule.content

RuleVariation_126_Arg: TypeAlias = Variation_126_Arg
class RuleVariation_126(RuleVariationContextFree):
    cv_variation = Variation_126

    @classmethod
    def create(cls, arg : RuleVariation_126_Arg) -> "RuleVariation_126":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_126:
        return self.arg # type: ignore

Variation_612_Arg: TypeAlias = RuleContent_19_Arg
class Variation_612(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_19

    @classmethod
    def create(cls, arg : Variation_612_Arg) -> "Variation_612":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_19:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_19:
        return self.rule.content

RuleVariation_601_Arg: TypeAlias = Variation_612_Arg
class RuleVariation_601(RuleVariationContextFree):
    cv_variation = Variation_612

    @classmethod
    def create(cls, arg : RuleVariation_601_Arg) -> "RuleVariation_601":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_612:
        return self.arg # type: ignore

Content_437_Arg: TypeAlias = int
class Content_437(ContentTable):
    cv_values = {0: "Report from RDP Chain 1", 1: "Report from RDP Chain 2"}

RuleContent_437_Arg: TypeAlias = Content_437_Arg
class RuleContent_437(RuleContentContextFree):
    cv_content = Content_437

    @property
    def content(self) -> Content_437:
        return self._get_content() # type: ignore

Variation_745_Arg: TypeAlias = RuleContent_437_Arg
class Variation_745(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_437

    @classmethod
    def create(cls, arg : Variation_745_Arg) -> "Variation_745":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_437:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_437:
        return self.rule.content

RuleVariation_734_Arg: TypeAlias = Variation_745_Arg
class RuleVariation_734(RuleVariationContextFree):
    cv_variation = Variation_745

    @classmethod
    def create(cls, arg : RuleVariation_734_Arg) -> "RuleVariation_734":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_745:
        return self.arg # type: ignore

Variation_816_Arg: TypeAlias = RuleContent_13_Arg
class Variation_816(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_13

    @classmethod
    def create(cls, arg : Variation_816_Arg) -> "Variation_816":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_13:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_13:
        return self.rule.content

RuleVariation_786_Arg: TypeAlias = Variation_816_Arg
class RuleVariation_786(RuleVariationContextFree):
    cv_variation = Variation_816

    @classmethod
    def create(cls, arg : RuleVariation_786_Arg) -> "RuleVariation_786":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_816:
        return self.arg # type: ignore

Content_438_Arg: TypeAlias = int
class Content_438(ContentTable):
    cv_values = {0: "Report from aircraft transponder", 1: "Report from field monitor (fixed transponder)"}

RuleContent_438_Arg: TypeAlias = Content_438_Arg
class RuleContent_438(RuleContentContextFree):
    cv_content = Content_438

    @property
    def content(self) -> Content_438:
        return self._get_content() # type: ignore

Variation_945_Arg: TypeAlias = RuleContent_438_Arg
class Variation_945(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_438

    @classmethod
    def create(cls, arg : Variation_945_Arg) -> "Variation_945":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_438:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_438:
        return self.rule.content

RuleVariation_915_Arg: TypeAlias = Variation_945_Arg
class RuleVariation_915(RuleVariationContextFree):
    cv_variation = Variation_945

    @classmethod
    def create(cls, arg : RuleVariation_915_Arg) -> "RuleVariation_915":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_945:
        return self.arg # type: ignore

Content_435_Arg: TypeAlias = int
class Content_435(ContentTable):
    cv_values = {0: "Real target report", 1: "Test target report"}

RuleContent_435_Arg: TypeAlias = Content_435_Arg
class RuleContent_435(RuleContentContextFree):
    cv_content = Content_435

    @property
    def content(self) -> Content_435:
        return self._get_content() # type: ignore

Variation_72_Arg: TypeAlias = RuleContent_435_Arg
class Variation_72(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_435

    @classmethod
    def create(cls, arg : Variation_72_Arg) -> "Variation_72":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_435:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_435:
        return self.rule.content

RuleVariation_72_Arg: TypeAlias = Variation_72_Arg
class RuleVariation_72(RuleVariationContextFree):
    cv_variation = Variation_72

    @classmethod
    def create(cls, arg : RuleVariation_72_Arg) -> "RuleVariation_72":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_72:
        return self.arg # type: ignore

Content_306_Arg: TypeAlias = int
class Content_306(ContentTable):
    cv_values = {0: "No Extended Range", 1: "Extended Range present"}

RuleContent_306_Arg: TypeAlias = Content_306_Arg
class RuleContent_306(RuleContentContextFree):
    cv_content = Content_306

    @property
    def content(self) -> Content_306:
        return self._get_content() # type: ignore

Variation_438_Arg: TypeAlias = RuleContent_306_Arg
class Variation_438(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_306

    @classmethod
    def create(cls, arg : Variation_438_Arg) -> "Variation_438":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_306:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_306:
        return self.rule.content

RuleVariation_427_Arg: TypeAlias = Variation_438_Arg
class RuleVariation_427(RuleVariationContextFree):
    cv_variation = Variation_438

    @classmethod
    def create(cls, arg : RuleVariation_427_Arg) -> "RuleVariation_427":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_438:
        return self.arg # type: ignore

Content_316_Arg: TypeAlias = int
class Content_316(ContentTable):
    cv_values = {0: "No X-Pulse present", 1: "X-Pulse present"}

RuleContent_316_Arg: TypeAlias = Content_316_Arg
class RuleContent_316(RuleContentContextFree):
    cv_content = Content_316

    @property
    def content(self) -> Content_316:
        return self._get_content() # type: ignore

Variation_556_Arg: TypeAlias = RuleContent_316_Arg
class Variation_556(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_316

    @classmethod
    def create(cls, arg : Variation_556_Arg) -> "Variation_556":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_316:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_316:
        return self.rule.content

RuleVariation_545_Arg: TypeAlias = Variation_556_Arg
class RuleVariation_545(RuleVariationContextFree):
    cv_variation = Variation_556

    @classmethod
    def create(cls, arg : RuleVariation_545_Arg) -> "RuleVariation_545":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_556:
        return self.arg # type: ignore

Variation_650_Arg: TypeAlias = RuleContent_365_Arg
class Variation_650(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_365

    @classmethod
    def create(cls, arg : Variation_650_Arg) -> "Variation_650":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_365:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_365:
        return self.rule.content

RuleVariation_639_Arg: TypeAlias = Variation_650_Arg
class RuleVariation_639(RuleVariationContextFree):
    cv_variation = Variation_650

    @classmethod
    def create(cls, arg : RuleVariation_639_Arg) -> "RuleVariation_639":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_650:
        return self.arg # type: ignore

Content_366_Arg: TypeAlias = int
class Content_366(ContentTable):
    cv_values = {0: "No military identification", 1: "Military identification"}

RuleContent_366_Arg: TypeAlias = Content_366_Arg
class RuleContent_366(RuleContentContextFree):
    cv_content = Content_366

    @property
    def content(self) -> Content_366:
        return self._get_content() # type: ignore

Variation_738_Arg: TypeAlias = RuleContent_366_Arg
class Variation_738(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_366

    @classmethod
    def create(cls, arg : Variation_738_Arg) -> "Variation_738":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_366:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_366:
        return self.rule.content

RuleVariation_727_Arg: TypeAlias = Variation_738_Arg
class RuleVariation_727(RuleVariationContextFree):
    cv_variation = Variation_738

    @classmethod
    def create(cls, arg : RuleVariation_727_Arg) -> "RuleVariation_727":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_738:
        return self.arg # type: ignore

Content_307_Arg: TypeAlias = int
class Content_307(ContentTable):
    cv_values = {0: "No Mode 4 interrogation", 1: "Friendly target", 2: "Unknown target", 3: "No reply"}

RuleContent_307_Arg: TypeAlias = Content_307_Arg
class RuleContent_307(RuleContentContextFree):
    cv_content = Content_307

    @property
    def content(self) -> Content_307:
        return self._get_content() # type: ignore

Variation_877_Arg: TypeAlias = RuleContent_307_Arg
class Variation_877(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_307

    @classmethod
    def create(cls, arg : Variation_877_Arg) -> "Variation_877":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_307:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_307:
        return self.rule.content

RuleVariation_847_Arg: TypeAlias = Variation_877_Arg
class RuleVariation_847(RuleVariationContextFree):
    cv_variation = Variation_877

    @classmethod
    def create(cls, arg : RuleVariation_847_Arg) -> "RuleVariation_847":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_877:
        return self.arg # type: ignore

NonSpare_1950_Arg: TypeAlias = RuleVariation_126_Arg
class NonSpare_1950(NonSpare):
    cv_name = "TYP"
    cv_title = ""
    cv_rule = RuleVariation_126

    @classmethod
    def create(cls, arg : NonSpare_1950_Arg) -> "NonSpare_1950":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_126:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_126:
        return self.rule.variation

Item_1070_Arg: TypeAlias = NonSpare_1950_Arg
class Item_1070(Item):
    cv_non_spare = NonSpare_1950

    @classmethod
    def create(cls, arg : Item_1070_Arg) -> "Item_1070":
        return cls._create(arg) # type: ignore

NonSpare_1717_Arg: TypeAlias = RuleVariation_601_Arg
class NonSpare_1717(NonSpare):
    cv_name = "SIM"
    cv_title = ""
    cv_rule = RuleVariation_601

    @classmethod
    def create(cls, arg : NonSpare_1717_Arg) -> "NonSpare_1717":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_601:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_612:
        return self.rule.variation

Item_898_Arg: TypeAlias = NonSpare_1717_Arg
class Item_898(Item):
    cv_non_spare = NonSpare_1717

    @classmethod
    def create(cls, arg : Item_898_Arg) -> "Item_898":
        return cls._create(arg) # type: ignore

NonSpare_1549_Arg: TypeAlias = RuleVariation_734_Arg
class NonSpare_1549(NonSpare):
    cv_name = "RDP"
    cv_title = ""
    cv_rule = RuleVariation_734

    @classmethod
    def create(cls, arg : NonSpare_1549_Arg) -> "NonSpare_1549":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_734:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_745:
        return self.rule.variation

Item_783_Arg: TypeAlias = NonSpare_1549_Arg
class Item_783(Item):
    cv_non_spare = NonSpare_1549

    @classmethod
    def create(cls, arg : Item_783_Arg) -> "Item_783":
        return cls._create(arg) # type: ignore

NonSpare_1730_Arg: TypeAlias = RuleVariation_786_Arg
class NonSpare_1730(NonSpare):
    cv_name = "SPI"
    cv_title = ""
    cv_rule = RuleVariation_786

    @classmethod
    def create(cls, arg : NonSpare_1730_Arg) -> "NonSpare_1730":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_786:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_816:
        return self.rule.variation

Item_909_Arg: TypeAlias = NonSpare_1730_Arg
class Item_909(Item):
    cv_non_spare = NonSpare_1730

    @classmethod
    def create(cls, arg : Item_909_Arg) -> "Item_909":
        return cls._create(arg) # type: ignore

NonSpare_1530_Arg: TypeAlias = RuleVariation_915_Arg
class NonSpare_1530(NonSpare):
    cv_name = "RAB"
    cv_title = ""
    cv_rule = RuleVariation_915

    @classmethod
    def create(cls, arg : NonSpare_1530_Arg) -> "NonSpare_1530":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_915:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_945:
        return self.rule.variation

Item_766_Arg: TypeAlias = NonSpare_1530_Arg
class Item_766(Item):
    cv_non_spare = NonSpare_1530

    @classmethod
    def create(cls, arg : Item_766_Arg) -> "Item_766":
        return cls._create(arg) # type: ignore

NonSpare_1925_Arg: TypeAlias = RuleVariation_72_Arg
class NonSpare_1925(NonSpare):
    cv_name = "TST"
    cv_title = ""
    cv_rule = RuleVariation_72

    @classmethod
    def create(cls, arg : NonSpare_1925_Arg) -> "NonSpare_1925":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_72:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_72:
        return self.rule.variation

Item_1048_Arg: TypeAlias = NonSpare_1925_Arg
class Item_1048(Item):
    cv_non_spare = NonSpare_1925

    @classmethod
    def create(cls, arg : Item_1048_Arg) -> "Item_1048":
        return cls._create(arg) # type: ignore

NonSpare_950_Arg: TypeAlias = RuleVariation_427_Arg
class NonSpare_950(NonSpare):
    cv_name = "ERR"
    cv_title = ""
    cv_rule = RuleVariation_427

    @classmethod
    def create(cls, arg : NonSpare_950_Arg) -> "NonSpare_950":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_427:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_438:
        return self.rule.variation

Item_316_Arg: TypeAlias = NonSpare_950_Arg
class Item_316(Item):
    cv_non_spare = NonSpare_950

    @classmethod
    def create(cls, arg : Item_316_Arg) -> "Item_316":
        return cls._create(arg) # type: ignore

NonSpare_2111_Arg: TypeAlias = RuleVariation_545_Arg
class NonSpare_2111(NonSpare):
    cv_name = "XPP"
    cv_title = ""
    cv_rule = RuleVariation_545

    @classmethod
    def create(cls, arg : NonSpare_2111_Arg) -> "NonSpare_2111":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_545:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_556:
        return self.rule.variation

Item_1215_Arg: TypeAlias = NonSpare_2111_Arg
class Item_1215(Item):
    cv_non_spare = NonSpare_2111

    @classmethod
    def create(cls, arg : Item_1215_Arg) -> "Item_1215":
        return cls._create(arg) # type: ignore

NonSpare_1257_Arg: TypeAlias = RuleVariation_639_Arg
class NonSpare_1257(NonSpare):
    cv_name = "ME"
    cv_title = ""
    cv_rule = RuleVariation_639

    @classmethod
    def create(cls, arg : NonSpare_1257_Arg) -> "NonSpare_1257":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_639:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_650:
        return self.rule.variation

Item_541_Arg: TypeAlias = NonSpare_1257_Arg
class Item_541(Item):
    cv_non_spare = NonSpare_1257

    @classmethod
    def create(cls, arg : Item_541_Arg) -> "Item_541":
        return cls._create(arg) # type: ignore

NonSpare_1275_Arg: TypeAlias = RuleVariation_727_Arg
class NonSpare_1275(NonSpare):
    cv_name = "MI"
    cv_title = ""
    cv_rule = RuleVariation_727

    @classmethod
    def create(cls, arg : NonSpare_1275_Arg) -> "NonSpare_1275":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_727:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_738:
        return self.rule.variation

Item_548_Arg: TypeAlias = NonSpare_1275_Arg
class Item_548(Item):
    cv_non_spare = NonSpare_1275

    @classmethod
    def create(cls, arg : Item_548_Arg) -> "Item_548":
        return cls._create(arg) # type: ignore

NonSpare_972_Arg: TypeAlias = RuleVariation_847_Arg
class NonSpare_972(NonSpare):
    cv_name = "FOEFRI"
    cv_title = ""
    cv_rule = RuleVariation_847

    @classmethod
    def create(cls, arg : NonSpare_972_Arg) -> "NonSpare_972":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_847:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_877:
        return self.rule.variation

Item_332_Arg: TypeAlias = NonSpare_972_Arg
class Item_332(Item):
    cv_non_spare = NonSpare_972

    @classmethod
    def create(cls, arg : Item_332_Arg) -> "Item_332":
        return cls._create(arg) # type: ignore

Variation_1381_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_126_Arg, Tuple[Literal["TYP"], RuleVariation_126_Arg]], Union[RuleVariation_601_Arg, Tuple[Literal["SIM"], RuleVariation_601_Arg]], Union[RuleVariation_734_Arg, Tuple[Literal["RDP"], RuleVariation_734_Arg]], Union[RuleVariation_786_Arg, Tuple[Literal["SPI"], RuleVariation_786_Arg]], Union[RuleVariation_915_Arg, Tuple[Literal["RAB"], RuleVariation_915_Arg]], None]]
Variation_1381_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_72_Arg, Tuple[Literal["TST"], RuleVariation_72_Arg]], Union[RuleVariation_427_Arg, Tuple[Literal["ERR"], RuleVariation_427_Arg]], Union[RuleVariation_545_Arg, Tuple[Literal["XPP"], RuleVariation_545_Arg]], Union[RuleVariation_639_Arg, Tuple[Literal["ME"], RuleVariation_639_Arg]], Union[RuleVariation_727_Arg, Tuple[Literal["MI"], RuleVariation_727_Arg]], Union[RuleVariation_847_Arg, Tuple[Literal["FOEFRI"], RuleVariation_847_Arg]], None]]
Variation_1381_Arg: TypeAlias = Union[
    Tuple[Variation_1381_Arg_Group_1],
    Tuple[Variation_1381_Arg_Group_1, Variation_1381_Arg_Group_2],
]
class Variation_1381(Extended):
    cv_items_list = [[(Item_1070, 3), (Item_898, 1), (Item_783, 1), (Item_909, 1), (Item_766, 1), None], [(Item_1048, 1), (Item_316, 1), (Item_1215, 1), (Item_541, 1), (Item_548, 1), (Item_332, 2), None]]

    @classmethod
    def create(cls, arg : Variation_1381_Arg) -> 'Variation_1381':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_126:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> RuleVariation_601:
        ...
    @overload
    def get_item(self, key : Literal["RDP"]) -> RuleVariation_734:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> RuleVariation_786:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_915:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_72]:
        ...
    @overload
    def get_item(self, key : Literal["ERR"]) -> Optional[RuleVariation_427]:
        ...
    @overload
    def get_item(self, key : Literal["XPP"]) -> Optional[RuleVariation_545]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_639]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_727]:
        ...
    @overload
    def get_item(self, key : Literal["FOEFRI"]) -> Optional[RuleVariation_847]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1304_Arg: TypeAlias = Variation_1381_Arg
class RuleVariation_1304(RuleVariationContextFree):
    cv_variation = Variation_1381

    @classmethod
    def create(cls, arg : RuleVariation_1304_Arg) -> "RuleVariation_1304":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1381:
        return self.arg # type: ignore

NonSpare_87_Arg: TypeAlias = RuleVariation_1304_Arg
class NonSpare_87(NonSpare):
    cv_name = "020"
    cv_title = "Target Report Descriptor"
    cv_rule = RuleVariation_1304

    @classmethod
    def create(cls, arg : NonSpare_87_Arg) -> "NonSpare_87":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1304:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1381:
        return self.rule.variation

class UapItem_87(UapItem):
    cv_non_spare = NonSpare_87

NonSpare_137_Arg: TypeAlias = RuleVariation_1125_Arg
class NonSpare_137(NonSpare):
    cv_name = "040"
    cv_title = "Measured Position in Polar Co-ordinates"
    cv_rule = RuleVariation_1125

    @classmethod
    def create(cls, arg : NonSpare_137_Arg) -> "NonSpare_137":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1125:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1173:
        return self.rule.variation

class UapItem_137(UapItem):
    cv_non_spare = NonSpare_137

Variation_1258_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_539_Arg, Tuple[Literal["L"], RuleVariation_539_Arg]], int, Union[RuleVariation_776_Arg, Tuple[Literal["MODE3A"], RuleVariation_776_Arg]]]
Variation_1258_Arg: TypeAlias = Union[int, Variation_1258_Arg_Group]
class Variation_1258(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1099, 1), (Item_353, 1), (Item_450, 1), (Item_16, 1), (Item_572, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "L": RuleVariation_539, "MODE3A": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_539:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_539:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1258_Arg) -> 'Variation_1258':
        return cls._create(arg) # type: ignore

RuleVariation_1188_Arg: TypeAlias = Variation_1258_Arg
class RuleVariation_1188(RuleVariationContextFree):
    cv_variation = Variation_1258

    @classmethod
    def create(cls, arg : RuleVariation_1188_Arg) -> "RuleVariation_1188":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1258:
        return self.arg # type: ignore

NonSpare_207_Arg: TypeAlias = RuleVariation_1188_Arg
class NonSpare_207(NonSpare):
    cv_name = "070"
    cv_title = "Mode-3/A Code in Octal Representation"
    cv_rule = RuleVariation_1188

    @classmethod
    def create(cls, arg : NonSpare_207_Arg) -> "NonSpare_207":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1188:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1258:
        return self.rule.variation

class UapItem_207(UapItem):
    cv_non_spare = NonSpare_207

NonSpare_965_Arg: TypeAlias = RuleVariation_597_Arg
class NonSpare_965(NonSpare):
    cv_name = "FL"
    cv_title = ""
    cv_rule = RuleVariation_597

    @classmethod
    def create(cls, arg : NonSpare_965_Arg) -> "NonSpare_965":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_597:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_608:
        return self.rule.variation

Item_328_Arg: TypeAlias = NonSpare_965_Arg
class Item_328(Item):
    cv_non_spare = NonSpare_965

    @classmethod
    def create(cls, arg : Item_328_Arg) -> "Item_328":
        return cls._create(arg) # type: ignore

Variation_1249_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_597_Arg, Tuple[Literal["FL"], RuleVariation_597_Arg]]]
Variation_1249_Arg: TypeAlias = Union[int, Variation_1249_Arg_Group]
class Variation_1249(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1099, 1), (Item_353, 1), (Item_328, 14)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "FL": RuleVariation_597}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FL"]) -> RuleVariation_597:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["FL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["FL"]) -> RuleVariation_597:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1249_Arg) -> 'Variation_1249':
        return cls._create(arg) # type: ignore

RuleVariation_1179_Arg: TypeAlias = Variation_1249_Arg
class RuleVariation_1179(RuleVariationContextFree):
    cv_variation = Variation_1249

    @classmethod
    def create(cls, arg : RuleVariation_1179_Arg) -> "RuleVariation_1179":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1249:
        return self.arg # type: ignore

NonSpare_245_Arg: TypeAlias = RuleVariation_1179_Arg
class NonSpare_245(NonSpare):
    cv_name = "090"
    cv_title = "Flight Level in Binary Representation"
    cv_rule = RuleVariation_1179

    @classmethod
    def create(cls, arg : NonSpare_245_Arg) -> "NonSpare_245":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1179:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1249:
        return self.rule.variation

class UapItem_245(UapItem):
    cv_non_spare = NonSpare_245

Content_789_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_789(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 4.39453125e-2
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_788_Arg: TypeAlias = Content_789_Arg
class RuleContent_788(RuleContentContextFree):
    cv_content = Content_789

    @property
    def content(self) -> Content_789:
        return self._get_content() # type: ignore

Variation_243_Arg: TypeAlias = RuleContent_788_Arg
class Variation_243(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_788

    @classmethod
    def create(cls, arg : Variation_243_Arg) -> "Variation_243":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_788:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_789:
        return self.rule.content

RuleVariation_236_Arg: TypeAlias = Variation_243_Arg
class RuleVariation_236(RuleVariationContextFree):
    cv_variation = Variation_243

    @classmethod
    def create(cls, arg : RuleVariation_236_Arg) -> "RuleVariation_236":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_243:
        return self.arg # type: ignore

NonSpare_1744_Arg: TypeAlias = RuleVariation_236_Arg
class NonSpare_1744(NonSpare):
    cv_name = "SRL"
    cv_title = "SSR Plot Runlength"
    cv_rule = RuleVariation_236

    @classmethod
    def create(cls, arg : NonSpare_1744_Arg) -> "NonSpare_1744":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_236:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_243:
        return self.rule.variation

NonSpare_1745_Arg: TypeAlias = RuleVariation_196_Arg
class NonSpare_1745(NonSpare):
    cv_name = "SRR"
    cv_title = "Number of Received Replies for (M)SSR"
    cv_rule = RuleVariation_196

    @classmethod
    def create(cls, arg : NonSpare_1745_Arg) -> "NonSpare_1745":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_203:
        return self.rule.variation

NonSpare_1652_Arg: TypeAlias = RuleVariation_199_Arg
class NonSpare_1652(NonSpare):
    cv_name = "SAM"
    cv_title = "Amplitude of (M)SSR Reply"
    cv_rule = RuleVariation_199

    @classmethod
    def create(cls, arg : NonSpare_1652_Arg) -> "NonSpare_1652":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_199:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_206:
        return self.rule.variation

NonSpare_1458_Arg: TypeAlias = RuleVariation_236_Arg
class NonSpare_1458(NonSpare):
    cv_name = "PRL"
    cv_title = "Primary Plot Runlength"
    cv_rule = RuleVariation_236

    @classmethod
    def create(cls, arg : NonSpare_1458_Arg) -> "NonSpare_1458":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_236:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_243:
        return self.rule.variation

NonSpare_1412_Arg: TypeAlias = RuleVariation_199_Arg
class NonSpare_1412(NonSpare):
    cv_name = "PAM"
    cv_title = "Amplitude of Primary Plot"
    cv_rule = RuleVariation_199

    @classmethod
    def create(cls, arg : NonSpare_1412_Arg) -> "NonSpare_1412":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_199:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_206:
        return self.rule.variation

Content_677_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
class Content_677(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 3.90625e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

RuleContent_677_Arg: TypeAlias = Content_677_Arg
class RuleContent_677(RuleContentContextFree):
    cv_content = Content_677

    @property
    def content(self) -> Content_677:
        return self._get_content() # type: ignore

Variation_215_Arg: TypeAlias = RuleContent_677_Arg
class Variation_215(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_677

    @classmethod
    def create(cls, arg : Variation_215_Arg) -> "Variation_215":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_677:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_677:
        return self.rule.content

RuleVariation_208_Arg: TypeAlias = Variation_215_Arg
class RuleVariation_208(RuleVariationContextFree):
    cv_variation = Variation_215

    @classmethod
    def create(cls, arg : RuleVariation_208_Arg) -> "RuleVariation_208":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_215:
        return self.arg # type: ignore

NonSpare_1595_Arg: TypeAlias = RuleVariation_208_Arg
class NonSpare_1595(NonSpare):
    cv_name = "RPD"
    cv_title = "Difference in Range Between PSR and SSR Plot"
    cv_rule = RuleVariation_208

    @classmethod
    def create(cls, arg : NonSpare_1595_Arg) -> "NonSpare_1595":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_208:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_215:
        return self.rule.variation

NonSpare_612_Arg: TypeAlias = RuleVariation_211_Arg
class NonSpare_612(NonSpare):
    cv_name = "APD"
    cv_title = "Difference in Azimuth Between PSR and SSR Plot"
    cv_rule = RuleVariation_211

    @classmethod
    def create(cls, arg : NonSpare_612_Arg) -> "NonSpare_612":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_211:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_218:
        return self.rule.variation

Variation_1498_Arg = TypedDict('Variation_1498_Arg', {
    "SRL": NonSpare_1744_Arg,
    "SRR": NonSpare_1745_Arg,
    "SAM": NonSpare_1652_Arg,
    "PRL": NonSpare_1458_Arg,
    "PAM": NonSpare_1412_Arg,
    "RPD": NonSpare_1595_Arg,
    "APD": NonSpare_612_Arg,
}, total=False)
class Variation_1498(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1744, NonSpare_1745, NonSpare_1652, NonSpare_1458, NonSpare_1412, NonSpare_1595, NonSpare_612]
    cv_items_dict = {"SRL": NonSpare_1744, "SRR": NonSpare_1745, "SAM": NonSpare_1652, "PRL": NonSpare_1458, "PAM": NonSpare_1412, "RPD": NonSpare_1595, "APD": NonSpare_612}

    @overload
    @classmethod
    def spec(cls, key : Literal["SRL"]) -> NonSpare_1744:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SRR"]) -> NonSpare_1745:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAM"]) -> NonSpare_1652:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PRL"]) -> NonSpare_1458:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PAM"]) -> NonSpare_1412:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RPD"]) -> NonSpare_1595:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["APD"]) -> NonSpare_612:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SRL"], Literal["SRR"], Literal["SAM"], Literal["PRL"], Literal["PAM"], Literal["RPD"], Literal["APD"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SRL"]) -> Optional[NonSpare_1744]:
        ...
    @overload
    def get_item(self, key : Literal["SRR"]) -> Optional[NonSpare_1745]:
        ...
    @overload
    def get_item(self, key : Literal["SAM"]) -> Optional[NonSpare_1652]:
        ...
    @overload
    def get_item(self, key : Literal["PRL"]) -> Optional[NonSpare_1458]:
        ...
    @overload
    def get_item(self, key : Literal["PAM"]) -> Optional[NonSpare_1412]:
        ...
    @overload
    def get_item(self, key : Literal["RPD"]) -> Optional[NonSpare_1595]:
        ...
    @overload
    def get_item(self, key : Literal["APD"]) -> Optional[NonSpare_612]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["SRL"], val : NonSpare_1744_Arg) -> "Variation_1498":
        ...
    @overload
    def set_item(self, key : Literal["SRR"], val : NonSpare_1745_Arg) -> "Variation_1498":
        ...
    @overload
    def set_item(self, key : Literal["SAM"], val : NonSpare_1652_Arg) -> "Variation_1498":
        ...
    @overload
    def set_item(self, key : Literal["PRL"], val : NonSpare_1458_Arg) -> "Variation_1498":
        ...
    @overload
    def set_item(self, key : Literal["PAM"], val : NonSpare_1412_Arg) -> "Variation_1498":
        ...
    @overload
    def set_item(self, key : Literal["RPD"], val : NonSpare_1595_Arg) -> "Variation_1498":
        ...
    @overload
    def set_item(self, key : Literal["APD"], val : NonSpare_612_Arg) -> "Variation_1498":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["SRL"]) -> "Variation_1498":
        ...
    @overload
    def del_item(self, key : Literal["SRR"]) -> "Variation_1498":
        ...
    @overload
    def del_item(self, key : Literal["SAM"]) -> "Variation_1498":
        ...
    @overload
    def del_item(self, key : Literal["PRL"]) -> "Variation_1498":
        ...
    @overload
    def del_item(self, key : Literal["PAM"]) -> "Variation_1498":
        ...
    @overload
    def del_item(self, key : Literal["RPD"]) -> "Variation_1498":
        ...
    @overload
    def del_item(self, key : Literal["APD"]) -> "Variation_1498":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1498_Arg) -> 'Variation_1498':
        return cls._create(arg) # type: ignore

RuleVariation_1421_Arg: TypeAlias = Variation_1498_Arg
class RuleVariation_1421(RuleVariationContextFree):
    cv_variation = Variation_1498

    @classmethod
    def create(cls, arg : RuleVariation_1421_Arg) -> "RuleVariation_1421":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1498:
        return self.arg # type: ignore

NonSpare_308_Arg: TypeAlias = RuleVariation_1421_Arg
class NonSpare_308(NonSpare):
    cv_name = "130"
    cv_title = "Radar Plot Characteristics"
    cv_rule = RuleVariation_1421

    @classmethod
    def create(cls, arg : NonSpare_308_Arg) -> "NonSpare_308":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1421:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1498:
        return self.rule.variation

class UapItem_308(UapItem):
    cv_non_spare = NonSpare_308

NonSpare_415_Arg: TypeAlias = RuleVariation_340_Arg
class NonSpare_415(NonSpare):
    cv_name = "220"
    cv_title = "Aircraft Address"
    cv_rule = RuleVariation_340

    @classmethod
    def create(cls, arg : NonSpare_415_Arg) -> "NonSpare_415":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_340:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_347:
        return self.rule.variation

class UapItem_415(UapItem):
    cv_non_spare = NonSpare_415

NonSpare_431_Arg: TypeAlias = RuleVariation_381_Arg
class NonSpare_431(NonSpare):
    cv_name = "240"
    cv_title = "Aircraft Identification"
    cv_rule = RuleVariation_381

    @classmethod
    def create(cls, arg : NonSpare_431_Arg) -> "NonSpare_431":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_381:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_389:
        return self.rule.variation

class UapItem_431(UapItem):
    cv_non_spare = NonSpare_431

NonSpare_1227_Arg: TypeAlias = RuleVariation_382_Arg
class NonSpare_1227(NonSpare):
    cv_name = "MBDATA"
    cv_title = "Mode S Comm B Message Data"
    cv_rule = RuleVariation_382

    @classmethod
    def create(cls, arg : NonSpare_1227_Arg) -> "NonSpare_1227":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_382:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_390:
        return self.rule.variation

Item_529_Arg: TypeAlias = NonSpare_1227_Arg
class Item_529(Item):
    cv_non_spare = NonSpare_1227

    @classmethod
    def create(cls, arg : Item_529_Arg) -> "Item_529":
        return cls._create(arg) # type: ignore

Variation_1138_Arg_Group = Tuple[Union[RuleVariation_382_Arg, Tuple[Literal["MBDATA"], RuleVariation_382_Arg]], Union[RuleVariation_131_Arg, Tuple[Literal["BDS1"], RuleVariation_131_Arg]], Union[RuleVariation_766_Arg, Tuple[Literal["BDS2"], RuleVariation_766_Arg]]]
Variation_1138_Arg: TypeAlias = Union[int, Variation_1138_Arg_Group]
class Variation_1138(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_529, 56), (Item_115, 4), (Item_117, 4)]
    cv_items_dict = {"MBDATA": RuleVariation_382, "BDS1": RuleVariation_131, "BDS2": RuleVariation_766}

    @overload
    @classmethod
    def spec(cls, key : Literal["MBDATA"]) -> RuleVariation_382:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BDS1"]) -> RuleVariation_131:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BDS2"]) -> RuleVariation_766:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MBDATA"], Literal["BDS1"], Literal["BDS2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MBDATA"]) -> RuleVariation_382:
        ...
    @overload
    def get_item(self, key : Literal["BDS1"]) -> RuleVariation_131:
        ...
    @overload
    def get_item(self, key : Literal["BDS2"]) -> RuleVariation_766:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1138_Arg) -> 'Variation_1138':
        return cls._create(arg) # type: ignore

Variation_1415_Arg: TypeAlias = List[Variation_1138_Arg]
class Variation_1415(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1138

    @classmethod
    def create(cls, arg : Variation_1415_Arg) -> 'Variation_1415':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1138]:
        return self._get_list() # type: ignore

RuleVariation_1338_Arg: TypeAlias = Variation_1415_Arg
class RuleVariation_1338(RuleVariationContextFree):
    cv_variation = Variation_1415

    @classmethod
    def create(cls, arg : RuleVariation_1338_Arg) -> "RuleVariation_1338":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1415:
        return self.arg # type: ignore

NonSpare_445_Arg: TypeAlias = RuleVariation_1338_Arg
class NonSpare_445(NonSpare):
    cv_name = "250"
    cv_title = "Mode S MB Data"
    cv_rule = RuleVariation_1338

    @classmethod
    def create(cls, arg : NonSpare_445_Arg) -> "NonSpare_445":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1338:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1415:
        return self.rule.variation

class UapItem_445(UapItem):
    cv_non_spare = NonSpare_445

NonSpare_359_Arg: TypeAlias = RuleVariation_1000_Arg
class NonSpare_359(NonSpare):
    cv_name = "161"
    cv_title = "Track Number"
    cv_rule = RuleVariation_1000

    @classmethod
    def create(cls, arg : NonSpare_359_Arg) -> "NonSpare_359":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1000:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1032:
        return self.rule.variation

class UapItem_359(UapItem):
    cv_non_spare = NonSpare_359

NonSpare_2137_Arg: TypeAlias = RuleVariation_278_Arg
class NonSpare_2137(NonSpare):
    cv_name = "Y"
    cv_title = "X-Component"
    cv_rule = RuleVariation_278

    @classmethod
    def create(cls, arg : NonSpare_2137_Arg) -> "NonSpare_2137":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_278:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_285:
        return self.rule.variation

Item_1241_Arg: TypeAlias = NonSpare_2137_Arg
class Item_1241(Item):
    cv_non_spare = NonSpare_2137

    @classmethod
    def create(cls, arg : Item_1241_Arg) -> "Item_1241":
        return cls._create(arg) # type: ignore

Variation_1307_Arg_Group = Tuple[Union[RuleVariation_278_Arg, Tuple[Literal["X"], RuleVariation_278_Arg]], Union[RuleVariation_278_Arg, Tuple[Literal["Y"], RuleVariation_278_Arg]]]
Variation_1307_Arg: TypeAlias = Union[int, Variation_1307_Arg_Group]
class Variation_1307(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1197, 16), (Item_1241, 16)]
    cv_items_dict = {"X": RuleVariation_278, "Y": RuleVariation_278}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_278:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_278:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_278:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_278:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1307_Arg) -> 'Variation_1307':
        return cls._create(arg) # type: ignore

RuleVariation_1235_Arg: TypeAlias = Variation_1307_Arg
class RuleVariation_1235(RuleVariationContextFree):
    cv_variation = Variation_1307

    @classmethod
    def create(cls, arg : RuleVariation_1235_Arg) -> "RuleVariation_1235":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1307:
        return self.arg # type: ignore

NonSpare_158_Arg: TypeAlias = RuleVariation_1235_Arg
class NonSpare_158(NonSpare):
    cv_name = "042"
    cv_title = "Calculated Position in Cartesian Co-ordinates"
    cv_rule = RuleVariation_1235

    @classmethod
    def create(cls, arg : NonSpare_158_Arg) -> "NonSpare_158":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1235:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1307:
        return self.rule.variation

class UapItem_158(UapItem):
    cv_non_spare = NonSpare_158

NonSpare_385_Arg: TypeAlias = RuleVariation_1067_Arg
class NonSpare_385(NonSpare):
    cv_name = "200"
    cv_title = "Calculated Track Velocity in Polar Co-ordinates"
    cv_rule = RuleVariation_1067

    @classmethod
    def create(cls, arg : NonSpare_385_Arg) -> "NonSpare_385":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1067:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1109:
        return self.rule.variation

class UapItem_385(UapItem):
    cv_non_spare = NonSpare_385

Variation_16_Arg: TypeAlias = RuleContent_60_Arg
class Variation_16(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_60

    @classmethod
    def create(cls, arg : Variation_16_Arg) -> "Variation_16":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_60:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_60:
        return self.rule.content

RuleVariation_16_Arg: TypeAlias = Variation_16_Arg
class RuleVariation_16(RuleVariationContextFree):
    cv_variation = Variation_16

    @classmethod
    def create(cls, arg : RuleVariation_16_Arg) -> "RuleVariation_16":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_16:
        return self.arg # type: ignore

Content_58_Arg: TypeAlias = int
class Content_58(ContentTable):
    cv_values = {0: "Combined Track", 1: "PSR Track", 2: "SSR/Mode S Track", 3: "Invalid"}

RuleContent_58_Arg: TypeAlias = Content_58_Arg
class RuleContent_58(RuleContentContextFree):
    cv_content = Content_58

    @property
    def content(self) -> Content_58:
        return self._get_content() # type: ignore

Variation_464_Arg: TypeAlias = RuleContent_58_Arg
class Variation_464(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_58

    @classmethod
    def create(cls, arg : Variation_464_Arg) -> "Variation_464":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_58:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_58:
        return self.rule.content

RuleVariation_453_Arg: TypeAlias = Variation_464_Arg
class RuleVariation_453(RuleVariationContextFree):
    cv_variation = Variation_464

    @classmethod
    def create(cls, arg : RuleVariation_453_Arg) -> "RuleVariation_453":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_464:
        return self.arg # type: ignore

Content_382_Arg: TypeAlias = int
class Content_382(ContentTable):
    cv_values = {0: "Normal confidence", 1: "Low confidence in plot to track association"}

RuleContent_382_Arg: TypeAlias = Content_382_Arg
class RuleContent_382(RuleContentContextFree):
    cv_content = Content_382

    @property
    def content(self) -> Content_382:
        return self._get_content() # type: ignore

Variation_653_Arg: TypeAlias = RuleContent_382_Arg
class Variation_653(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_382

    @classmethod
    def create(cls, arg : Variation_653_Arg) -> "Variation_653":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_382:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_382:
        return self.rule.content

RuleVariation_642_Arg: TypeAlias = Variation_653_Arg
class RuleVariation_642(RuleVariationContextFree):
    cv_variation = Variation_653

    @classmethod
    def create(cls, arg : RuleVariation_642_Arg) -> "RuleVariation_642":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_653:
        return self.arg # type: ignore

Content_360_Arg: TypeAlias = int
class Content_360(ContentTable):
    cv_values = {0: "No horizontal man.sensed", 1: "Horizontal man. sensed"}

RuleContent_360_Arg: TypeAlias = Content_360_Arg
class RuleContent_360(RuleContentContextFree):
    cv_content = Content_360

    @property
    def content(self) -> Content_360:
        return self._get_content() # type: ignore

Variation_736_Arg: TypeAlias = RuleContent_360_Arg
class Variation_736(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_360

    @classmethod
    def create(cls, arg : Variation_736_Arg) -> "Variation_736":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_360:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_360:
        return self.rule.content

RuleVariation_725_Arg: TypeAlias = Variation_736_Arg
class RuleVariation_725(RuleVariationContextFree):
    cv_variation = Variation_736

    @classmethod
    def create(cls, arg : RuleVariation_725_Arg) -> "RuleVariation_725":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_736:
        return self.arg # type: ignore

Content_262_Arg: TypeAlias = int
class Content_262(ContentTable):
    cv_values = {0: "Maintaining", 1: "Climbing", 2: "Descending", 3: "Unknown"}

RuleContent_262_Arg: TypeAlias = Content_262_Arg
class RuleContent_262(RuleContentContextFree):
    cv_content = Content_262

    @property
    def content(self) -> Content_262:
        return self._get_content() # type: ignore

Variation_875_Arg: TypeAlias = RuleContent_262_Arg
class Variation_875(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_262

    @classmethod
    def create(cls, arg : Variation_875_Arg) -> "Variation_875":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_262:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_262:
        return self.rule.content

RuleVariation_845_Arg: TypeAlias = Variation_875_Arg
class RuleVariation_845(RuleVariationContextFree):
    cv_variation = Variation_875

    @classmethod
    def create(cls, arg : RuleVariation_845_Arg) -> "RuleVariation_845":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_875:
        return self.arg # type: ignore

Content_512_Arg: TypeAlias = int
class Content_512(ContentTable):
    cv_values = {0: "Track still alive", 1: "End of track lifetime(last report for this track)"}

RuleContent_512_Arg: TypeAlias = Content_512_Arg
class RuleContent_512(RuleContentContextFree):
    cv_content = Content_512

    @property
    def content(self) -> Content_512:
        return self._get_content() # type: ignore

Variation_90_Arg: TypeAlias = RuleContent_512_Arg
class Variation_90(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_512

    @classmethod
    def create(cls, arg : Variation_90_Arg) -> "Variation_90":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_512:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_512:
        return self.rule.content

RuleVariation_90_Arg: TypeAlias = Variation_90_Arg
class RuleVariation_90(RuleVariationContextFree):
    cv_variation = Variation_90

    @classmethod
    def create(cls, arg : RuleVariation_90_Arg) -> "RuleVariation_90":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_90:
        return self.arg # type: ignore

Content_525_Arg: TypeAlias = int
class Content_525(ContentTable):
    cv_values = {0: "True target track", 1: "Ghost target track"}

RuleContent_525_Arg: TypeAlias = Content_525_Arg
class RuleContent_525(RuleContentContextFree):
    cv_content = Content_525

    @property
    def content(self) -> Content_525:
        return self._get_content() # type: ignore

Variation_461_Arg: TypeAlias = RuleContent_525_Arg
class Variation_461(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_525

    @classmethod
    def create(cls, arg : Variation_461_Arg) -> "Variation_461":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_525:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_525:
        return self.rule.content

RuleVariation_450_Arg: TypeAlias = Variation_461_Arg
class RuleVariation_450(RuleVariationContextFree):
    cv_variation = Variation_461

    @classmethod
    def create(cls, arg : RuleVariation_450_Arg) -> "RuleVariation_450":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_461:
        return self.arg # type: ignore

Content_514_Arg: TypeAlias = int
class Content_514(ContentTable):
    cv_values = {0: "Tracking performed in so-called 'Radar Plane', i.e. neither slant range correction nor stereographical projection was applied", 1: "Slant range correction and a suitable projection technique are used to track in a 2D.reference plane, tangential to the earth model at the Radar Site co-ordinates"}

RuleContent_514_Arg: TypeAlias = Content_514_Arg
class RuleContent_514(RuleContentContextFree):
    cv_content = Content_514

    @property
    def content(self) -> Content_514:
        return self._get_content() # type: ignore

Variation_664_Arg: TypeAlias = RuleContent_514_Arg
class Variation_664(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_514

    @classmethod
    def create(cls, arg : Variation_664_Arg) -> "Variation_664":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_514:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_514:
        return self.rule.content

RuleVariation_653_Arg: TypeAlias = Variation_664_Arg
class RuleVariation_653(RuleVariationContextFree):
    cv_variation = Variation_664

    @classmethod
    def create(cls, arg : RuleVariation_653_Arg) -> "RuleVariation_653":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_664:
        return self.arg # type: ignore

NonSpare_743_Arg: TypeAlias = RuleVariation_16_Arg
class NonSpare_743(NonSpare):
    cv_name = "CNF"
    cv_title = "Confirmed Vs. Tentative Track"
    cv_rule = RuleVariation_16

    @classmethod
    def create(cls, arg : NonSpare_743_Arg) -> "NonSpare_743":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_16:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_16:
        return self.rule.variation

Item_167_Arg: TypeAlias = NonSpare_743_Arg
class Item_167(Item):
    cv_non_spare = NonSpare_743

    @classmethod
    def create(cls, arg : Item_167_Arg) -> "Item_167":
        return cls._create(arg) # type: ignore

NonSpare_1535_Arg: TypeAlias = RuleVariation_453_Arg
class NonSpare_1535(NonSpare):
    cv_name = "RAD"
    cv_title = "Type of Sensor(s) Maintaining Track"
    cv_rule = RuleVariation_453

    @classmethod
    def create(cls, arg : NonSpare_1535_Arg) -> "NonSpare_1535":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_453:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_464:
        return self.rule.variation

Item_771_Arg: TypeAlias = NonSpare_1535_Arg
class Item_771(Item):
    cv_non_spare = NonSpare_1535

    @classmethod
    def create(cls, arg : Item_771_Arg) -> "Item_771":
        return cls._create(arg) # type: ignore

NonSpare_887_Arg: TypeAlias = RuleVariation_642_Arg
class NonSpare_887(NonSpare):
    cv_name = "DOU"
    cv_title = "Signals Level of Confidence in Plot to Track Association Process"
    cv_rule = RuleVariation_642

    @classmethod
    def create(cls, arg : NonSpare_887_Arg) -> "NonSpare_887":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_642:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_653:
        return self.rule.variation

Item_268_Arg: TypeAlias = NonSpare_887_Arg
class Item_268(Item):
    cv_non_spare = NonSpare_887

    @classmethod
    def create(cls, arg : Item_268_Arg) -> "Item_268":
        return cls._create(arg) # type: ignore

NonSpare_1216_Arg: TypeAlias = RuleVariation_725_Arg
class NonSpare_1216(NonSpare):
    cv_name = "MAH"
    cv_title = "Manoeuvre Detection in Horizontal Sense"
    cv_rule = RuleVariation_725

    @classmethod
    def create(cls, arg : NonSpare_1216_Arg) -> "NonSpare_1216":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_725:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_736:
        return self.rule.variation

Item_522_Arg: TypeAlias = NonSpare_1216_Arg
class Item_522(Item):
    cv_non_spare = NonSpare_1216

    @classmethod
    def create(cls, arg : Item_522_Arg) -> "Item_522":
        return cls._create(arg) # type: ignore

NonSpare_708_Arg: TypeAlias = RuleVariation_845_Arg
class NonSpare_708(NonSpare):
    cv_name = "CDM"
    cv_title = "Climbing / Descending Mode"
    cv_rule = RuleVariation_845

    @classmethod
    def create(cls, arg : NonSpare_708_Arg) -> "NonSpare_708":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_845:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_875:
        return self.rule.variation

Item_140_Arg: TypeAlias = NonSpare_708_Arg
class Item_140(Item):
    cv_non_spare = NonSpare_708

    @classmethod
    def create(cls, arg : Item_140_Arg) -> "Item_140":
        return cls._create(arg) # type: ignore

NonSpare_1907_Arg: TypeAlias = RuleVariation_90_Arg
class NonSpare_1907(NonSpare):
    cv_name = "TRE"
    cv_title = "Signal for End_of_Track"
    cv_rule = RuleVariation_90

    @classmethod
    def create(cls, arg : NonSpare_1907_Arg) -> "NonSpare_1907":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_90:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_90:
        return self.rule.variation

Item_1034_Arg: TypeAlias = NonSpare_1907_Arg
class Item_1034(Item):
    cv_non_spare = NonSpare_1907

    @classmethod
    def create(cls, arg : Item_1034_Arg) -> "Item_1034":
        return cls._create(arg) # type: ignore

NonSpare_1029_Arg: TypeAlias = RuleVariation_450_Arg
class NonSpare_1029(NonSpare):
    cv_name = "GHO"
    cv_title = "Ghost Vs. True Target"
    cv_rule = RuleVariation_450

    @classmethod
    def create(cls, arg : NonSpare_1029_Arg) -> "NonSpare_1029":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_450:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_461:
        return self.rule.variation

Item_370_Arg: TypeAlias = NonSpare_1029_Arg
class Item_370(Item):
    cv_non_spare = NonSpare_1029

    @classmethod
    def create(cls, arg : Item_370_Arg) -> "Item_370":
        return cls._create(arg) # type: ignore

NonSpare_1804_Arg: TypeAlias = RuleVariation_544_Arg
class NonSpare_1804(NonSpare):
    cv_name = "SUP"
    cv_title = "Track Maintained with Track Information from Neighbouring Node B on the Cluster, or Network"
    cv_rule = RuleVariation_544

    @classmethod
    def create(cls, arg : NonSpare_1804_Arg) -> "NonSpare_1804":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_544:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_555:
        return self.rule.variation

Item_962_Arg: TypeAlias = NonSpare_1804_Arg
class Item_962(Item):
    cv_non_spare = NonSpare_1804

    @classmethod
    def create(cls, arg : Item_962_Arg) -> "Item_962":
        return cls._create(arg) # type: ignore

NonSpare_1833_Arg: TypeAlias = RuleVariation_653_Arg
class NonSpare_1833(NonSpare):
    cv_name = "TCC"
    cv_title = "Type of Plot Coordinate Transformation Mechanism:"
    cv_rule = RuleVariation_653

    @classmethod
    def create(cls, arg : NonSpare_1833_Arg) -> "NonSpare_1833":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_653:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_664:
        return self.rule.variation

Item_978_Arg: TypeAlias = NonSpare_1833_Arg
class Item_978(Item):
    cv_non_spare = NonSpare_1833

    @classmethod
    def create(cls, arg : Item_978_Arg) -> "Item_978":
        return cls._create(arg) # type: ignore

Variation_1346_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_16_Arg, Tuple[Literal["CNF"], RuleVariation_16_Arg]], Union[RuleVariation_453_Arg, Tuple[Literal["RAD"], RuleVariation_453_Arg]], Union[RuleVariation_642_Arg, Tuple[Literal["DOU"], RuleVariation_642_Arg]], Union[RuleVariation_725_Arg, Tuple[Literal["MAH"], RuleVariation_725_Arg]], Union[RuleVariation_845_Arg, Tuple[Literal["CDM"], RuleVariation_845_Arg]], None]]
Variation_1346_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_90_Arg, Tuple[Literal["TRE"], RuleVariation_90_Arg]], Union[RuleVariation_450_Arg, Tuple[Literal["GHO"], RuleVariation_450_Arg]], Union[RuleVariation_544_Arg, Tuple[Literal["SUP"], RuleVariation_544_Arg]], Union[RuleVariation_653_Arg, Tuple[Literal["TCC"], RuleVariation_653_Arg]], int, None]]
Variation_1346_Arg: TypeAlias = Union[
    Tuple[Variation_1346_Arg_Group_1],
    Tuple[Variation_1346_Arg_Group_1, Variation_1346_Arg_Group_2],
]
class Variation_1346(Extended):
    cv_items_list = [[(Item_167, 1), (Item_771, 2), (Item_268, 1), (Item_522, 1), (Item_140, 2), None], [(Item_1034, 1), (Item_370, 1), (Item_962, 1), (Item_978, 1), (Item_21, 3), None]]

    @classmethod
    def create(cls, arg : Variation_1346_Arg) -> 'Variation_1346':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_16:
        ...
    @overload
    def get_item(self, key : Literal["RAD"]) -> RuleVariation_453:
        ...
    @overload
    def get_item(self, key : Literal["DOU"]) -> RuleVariation_642:
        ...
    @overload
    def get_item(self, key : Literal["MAH"]) -> RuleVariation_725:
        ...
    @overload
    def get_item(self, key : Literal["CDM"]) -> RuleVariation_845:
        ...
    @overload
    def get_item(self, key : Literal["TRE"]) -> Optional[RuleVariation_90]:
        ...
    @overload
    def get_item(self, key : Literal["GHO"]) -> Optional[RuleVariation_450]:
        ...
    @overload
    def get_item(self, key : Literal["SUP"]) -> Optional[RuleVariation_544]:
        ...
    @overload
    def get_item(self, key : Literal["TCC"]) -> Optional[RuleVariation_653]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1269_Arg: TypeAlias = Variation_1346_Arg
class RuleVariation_1269(RuleVariationContextFree):
    cv_variation = Variation_1346

    @classmethod
    def create(cls, arg : RuleVariation_1269_Arg) -> "RuleVariation_1269":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1346:
        return self.arg # type: ignore

NonSpare_372_Arg: TypeAlias = RuleVariation_1269_Arg
class NonSpare_372(NonSpare):
    cv_name = "170"
    cv_title = "Track Status"
    cv_rule = RuleVariation_1269

    @classmethod
    def create(cls, arg : NonSpare_372_Arg) -> "NonSpare_372":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1269:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1346:
        return self.rule.variation

class UapItem_372(UapItem):
    cv_non_spare = NonSpare_372

Variation_235_Arg: TypeAlias = RuleContent_762_Arg
class Variation_235(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_762

    @classmethod
    def create(cls, arg : Variation_235_Arg) -> "Variation_235":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_762:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_763:
        return self.rule.content

RuleVariation_228_Arg: TypeAlias = Variation_235_Arg
class RuleVariation_228(RuleVariationContextFree):
    cv_variation = Variation_235

    @classmethod
    def create(cls, arg : RuleVariation_228_Arg) -> "RuleVariation_228":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_235:
        return self.arg # type: ignore

NonSpare_1709_Arg: TypeAlias = RuleVariation_228_Arg
class NonSpare_1709(NonSpare):
    cv_name = "SIGX"
    cv_title = "Sigma (X)) Standard Deviation on the Horizontal Axis of the Local Grid System"
    cv_rule = RuleVariation_228

    @classmethod
    def create(cls, arg : NonSpare_1709_Arg) -> "NonSpare_1709":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

Item_890_Arg: TypeAlias = NonSpare_1709_Arg
class Item_890(Item):
    cv_non_spare = NonSpare_1709

    @classmethod
    def create(cls, arg : Item_890_Arg) -> "Item_890":
        return cls._create(arg) # type: ignore

NonSpare_1710_Arg: TypeAlias = RuleVariation_228_Arg
class NonSpare_1710(NonSpare):
    cv_name = "SIGY"
    cv_title = "Sigma (Y)) Standard Deviation on the Vertical Axis of the Local Grid System"
    cv_rule = RuleVariation_228

    @classmethod
    def create(cls, arg : NonSpare_1710_Arg) -> "NonSpare_1710":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

Item_891_Arg: TypeAlias = NonSpare_1710_Arg
class Item_891(Item):
    cv_non_spare = NonSpare_1710

    @classmethod
    def create(cls, arg : Item_891_Arg) -> "Item_891":
        return cls._create(arg) # type: ignore

Variation_238_Arg: TypeAlias = RuleContent_774_Arg
class Variation_238(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_774

    @classmethod
    def create(cls, arg : Variation_238_Arg) -> "Variation_238":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_774:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_775:
        return self.rule.content

RuleVariation_231_Arg: TypeAlias = Variation_238_Arg
class RuleVariation_231(RuleVariationContextFree):
    cv_variation = Variation_238

    @classmethod
    def create(cls, arg : RuleVariation_231_Arg) -> "RuleVariation_231":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_238:
        return self.arg # type: ignore

NonSpare_1708_Arg: TypeAlias = RuleVariation_231_Arg
class NonSpare_1708(NonSpare):
    cv_name = "SIGV"
    cv_title = "Sigma (V)) Standard Deviation on the Groundspeed Within the Local Grid System"
    cv_rule = RuleVariation_231

    @classmethod
    def create(cls, arg : NonSpare_1708_Arg) -> "NonSpare_1708":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_231:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_238:
        return self.rule.variation

Item_889_Arg: TypeAlias = NonSpare_1708_Arg
class Item_889(Item):
    cv_non_spare = NonSpare_1708

    @classmethod
    def create(cls, arg : Item_889_Arg) -> "Item_889":
        return cls._create(arg) # type: ignore

Content_788_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_788(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 8.7890625e-2
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_787_Arg: TypeAlias = Content_788_Arg
class RuleContent_787(RuleContentContextFree):
    cv_content = Content_788

    @property
    def content(self) -> Content_788:
        return self._get_content() # type: ignore

Variation_242_Arg: TypeAlias = RuleContent_787_Arg
class Variation_242(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_787

    @classmethod
    def create(cls, arg : Variation_242_Arg) -> "Variation_242":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_787:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_788:
        return self.rule.content

RuleVariation_235_Arg: TypeAlias = Variation_242_Arg
class RuleVariation_235(RuleVariationContextFree):
    cv_variation = Variation_242

    @classmethod
    def create(cls, arg : RuleVariation_235_Arg) -> "RuleVariation_235":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_242:
        return self.arg # type: ignore

NonSpare_1707_Arg: TypeAlias = RuleVariation_235_Arg
class NonSpare_1707(NonSpare):
    cv_name = "SIGH"
    cv_title = "Sigma (H)) Standard Deviation on the Heading Within the Local Grid System"
    cv_rule = RuleVariation_235

    @classmethod
    def create(cls, arg : NonSpare_1707_Arg) -> "NonSpare_1707":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_235:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_242:
        return self.rule.variation

Item_888_Arg: TypeAlias = NonSpare_1707_Arg
class Item_888(Item):
    cv_non_spare = NonSpare_1707

    @classmethod
    def create(cls, arg : Item_888_Arg) -> "Item_888":
        return cls._create(arg) # type: ignore

Variation_1205_Arg_Group = Tuple[Union[RuleVariation_228_Arg, Tuple[Literal["SIGX"], RuleVariation_228_Arg]], Union[RuleVariation_228_Arg, Tuple[Literal["SIGY"], RuleVariation_228_Arg]], Union[RuleVariation_231_Arg, Tuple[Literal["SIGV"], RuleVariation_231_Arg]], Union[RuleVariation_235_Arg, Tuple[Literal["SIGH"], RuleVariation_235_Arg]]]
Variation_1205_Arg: TypeAlias = Union[int, Variation_1205_Arg_Group]
class Variation_1205(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_890, 8), (Item_891, 8), (Item_889, 8), (Item_888, 8)]
    cv_items_dict = {"SIGX": RuleVariation_228, "SIGY": RuleVariation_228, "SIGV": RuleVariation_231, "SIGH": RuleVariation_235}

    @overload
    @classmethod
    def spec(cls, key : Literal["SIGX"]) -> RuleVariation_228:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIGY"]) -> RuleVariation_228:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIGV"]) -> RuleVariation_231:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIGH"]) -> RuleVariation_235:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SIGX"], Literal["SIGY"], Literal["SIGV"], Literal["SIGH"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SIGX"]) -> RuleVariation_228:
        ...
    @overload
    def get_item(self, key : Literal["SIGY"]) -> RuleVariation_228:
        ...
    @overload
    def get_item(self, key : Literal["SIGV"]) -> RuleVariation_231:
        ...
    @overload
    def get_item(self, key : Literal["SIGH"]) -> RuleVariation_235:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1205_Arg) -> 'Variation_1205':
        return cls._create(arg) # type: ignore

RuleVariation_1150_Arg: TypeAlias = Variation_1205_Arg
class RuleVariation_1150(RuleVariationContextFree):
    cv_variation = Variation_1205

    @classmethod
    def create(cls, arg : RuleVariation_1150_Arg) -> "RuleVariation_1150":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1205:
        return self.arg # type: ignore

NonSpare_411_Arg: TypeAlias = RuleVariation_1150_Arg
class NonSpare_411(NonSpare):
    cv_name = "210"
    cv_title = "Track Quality"
    cv_rule = RuleVariation_1150

    @classmethod
    def create(cls, arg : NonSpare_411_Arg) -> "NonSpare_411":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1150:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1205:
        return self.rule.variation

class UapItem_411(UapItem):
    cv_non_spare = NonSpare_411

Content_391_Arg: TypeAlias = int
class Content_391(ContentTable):
    cv_values = {0: "Not defined; never used", 1: "Multipath Reply (Reflection)", 2: "Reply due to sidelobe interrogation/reception", 3: "Split plot", 4: "Second time around reply", 5: "Angel", 6: "Slow moving target correlated with road infrastructure (terrestrial vehicle)", 7: "Fixed PSR plot", 8: "Slow PSR target", 9: "Low quality PSR plot", 10: "Phantom SSR plot", 11: "Non-Matching Mode-3/A Code", 12: "Mode C code / Mode S altitude code abnormal value compared to the track", 13: "Target in Clutter Area", 14: "Maximum Doppler Response in Zero Filter", 15: "Transponder anomaly detected", 16: "Duplicated or Illegal Mode S Aircraft Address", 17: "Mode S error correction applied", 18: "Undecodable Mode C code / Mode S altitude code", 19: "Birds", 20: "Flock of Birds", 21: "Mode-1 was present in original reply", 22: "Mode-2 was present in original reply", 23: "Plot potentially caused by Wind Turbine", 24: "Helicopter", 25: "Maximum number of re-interrogations reached (surveillance information)", 26: "Maximum number of re-interrogations reached (BDS Extractions)", 27: "BDS Overlay Incoherence", 28: "Potential BDS Swap Detected", 29: "Track Update in the Zenithal Gap", 30: "Mode S Track re-acquired", 31: "Duplicated Mode 5 Pair NO/PIN detected"}

RuleContent_391_Arg: TypeAlias = Content_391_Arg
class RuleContent_391(RuleContentContextFree):
    cv_content = Content_391

    @property
    def content(self) -> Content_391:
        return self._get_content() # type: ignore

Variation_152_Arg: TypeAlias = RuleContent_391_Arg
class Variation_152(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_391

    @classmethod
    def create(cls, arg : Variation_152_Arg) -> "Variation_152":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_391:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_391:
        return self.rule.content

Variation_1448_Arg: TypeAlias = List[Variation_152_Arg]
class Variation_1448(Repetitive):
    cv_rep_bytes = None
    cv_variation = Variation_152

    @classmethod
    def create(cls, arg : Variation_1448_Arg) -> 'Variation_1448':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_152]:
        return self._get_list() # type: ignore

RuleVariation_1371_Arg: TypeAlias = Variation_1448_Arg
class RuleVariation_1371(RuleVariationContextFree):
    cv_variation = Variation_1448

    @classmethod
    def create(cls, arg : RuleVariation_1371_Arg) -> "RuleVariation_1371":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1448:
        return self.arg # type: ignore

NonSpare_117_Arg: TypeAlias = RuleVariation_1371_Arg
class NonSpare_117(NonSpare):
    cv_name = "030"
    cv_title = "Warning/Error Conditions and Target Classification"
    cv_rule = RuleVariation_1371

    @classmethod
    def create(cls, arg : NonSpare_117_Arg) -> "NonSpare_117":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1371:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1448:
        return self.rule.variation

class UapItem_117(UapItem):
    cv_non_spare = NonSpare_117

NonSpare_269_Arg: TypeAlias = RuleVariation_1176_Arg
class NonSpare_269(NonSpare):
    cv_name = "100"
    cv_title = "Mode-C Code and Code Confidence Indicator"
    cv_rule = RuleVariation_1176

    @classmethod
    def create(cls, arg : NonSpare_269_Arg) -> "NonSpare_269":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1176:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1246:
        return self.rule.variation

class UapItem_269(UapItem):
    cv_non_spare = NonSpare_269

Variation_603_Arg: TypeAlias = RuleContent_630_Arg
class Variation_603(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_630

    @classmethod
    def create(cls, arg : Variation_603_Arg) -> "Variation_603":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_630:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_630:
        return self.rule.content

RuleVariation_592_Arg: TypeAlias = Variation_603_Arg
class RuleVariation_592(RuleVariationContextFree):
    cv_variation = Variation_603

    @classmethod
    def create(cls, arg : RuleVariation_592_Arg) -> "RuleVariation_592":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_603:
        return self.arg # type: ignore

NonSpare_490_Arg: TypeAlias = RuleVariation_592_Arg
class NonSpare_490(NonSpare):
    cv_name = "3DH"
    cv_title = "3D Height, in Binary Notation. Negative Values Are Expressed in Two's Complement"
    cv_rule = RuleVariation_592

    @classmethod
    def create(cls, arg : NonSpare_490_Arg) -> "NonSpare_490":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_592:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_603:
        return self.rule.variation

Item_32_Arg: TypeAlias = NonSpare_490_Arg
class Item_32(Item):
    cv_non_spare = NonSpare_490

    @classmethod
    def create(cls, arg : Item_32_Arg) -> "Item_32":
        return cls._create(arg) # type: ignore

Variation_1001_Arg_Group = Tuple[int, Union[RuleVariation_592_Arg, Tuple[Literal["3DH"], RuleVariation_592_Arg]]]
Variation_1001_Arg: TypeAlias = Union[int, Variation_1001_Arg_Group]
class Variation_1001(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1, 2), (Item_32, 14)]
    cv_items_dict = {"3DH": RuleVariation_592}

    @classmethod
    def spec(cls, key : Literal["3DH"]) -> RuleVariation_592:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["3DH"]) -> RuleVariation_592:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1001_Arg) -> 'Variation_1001':
        return cls._create(arg) # type: ignore

RuleVariation_971_Arg: TypeAlias = Variation_1001_Arg
class RuleVariation_971(RuleVariationContextFree):
    cv_variation = Variation_1001

    @classmethod
    def create(cls, arg : RuleVariation_971_Arg) -> "RuleVariation_971":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1001:
        return self.arg # type: ignore

NonSpare_283_Arg: TypeAlias = RuleVariation_971_Arg
class NonSpare_283(NonSpare):
    cv_name = "110"
    cv_title = "Height Measured by a 3D Radar"
    cv_rule = RuleVariation_971

    @classmethod
    def create(cls, arg : NonSpare_283_Arg) -> "NonSpare_283":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_971:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1001:
        return self.rule.variation

class UapItem_283(UapItem):
    cv_non_spare = NonSpare_283

Content_199_Arg: TypeAlias = int
class Content_199(ContentTable):
    cv_values = {0: "Doppler speed is valid", 1: "Doppler speed is doubtful"}

RuleContent_199_Arg: TypeAlias = Content_199_Arg
class RuleContent_199(RuleContentContextFree):
    cv_content = Content_199

    @property
    def content(self) -> Content_199:
        return self._get_content() # type: ignore

Variation_39_Arg: TypeAlias = RuleContent_199_Arg
class Variation_39(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_199

    @classmethod
    def create(cls, arg : Variation_39_Arg) -> "Variation_39":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_199:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_199:
        return self.rule.content

RuleVariation_39_Arg: TypeAlias = Variation_39_Arg
class RuleVariation_39(RuleVariationContextFree):
    cv_variation = Variation_39

    @classmethod
    def create(cls, arg : RuleVariation_39_Arg) -> "RuleVariation_39":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_39:
        return self.arg # type: ignore

NonSpare_846_Arg: TypeAlias = RuleVariation_39_Arg
class NonSpare_846(NonSpare):
    cv_name = "D"
    cv_title = ""
    cv_rule = RuleVariation_39

    @classmethod
    def create(cls, arg : NonSpare_846_Arg) -> "NonSpare_846":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_39:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_39:
        return self.rule.variation

Item_232_Arg: TypeAlias = NonSpare_846_Arg
class Item_232(Item):
    cv_non_spare = NonSpare_846

    @classmethod
    def create(cls, arg : Item_232_Arg) -> "Item_232":
        return cls._create(arg) # type: ignore

Item_8_Arg: TypeAlias = int
class Item_8(Spare):
    cv_bit_offset8 = 1
    cv_bit_size = 5

Content_626_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
class Content_626(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.0
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_626_Arg: TypeAlias = Content_626_Arg
class RuleContent_626(RuleContentContextFree):
    cv_content = Content_626

    @property
    def content(self) -> Content_626:
        return self._get_content() # type: ignore

Variation_965_Arg: TypeAlias = RuleContent_626_Arg
class Variation_965(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 10
    cv_rule = RuleContent_626

    @classmethod
    def create(cls, arg : Variation_965_Arg) -> "Variation_965":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_626:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_626:
        return self.rule.content

RuleVariation_935_Arg: TypeAlias = Variation_965_Arg
class RuleVariation_935(RuleVariationContextFree):
    cv_variation = Variation_965

    @classmethod
    def create(cls, arg : RuleVariation_935_Arg) -> "RuleVariation_935":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_965:
        return self.arg # type: ignore

NonSpare_697_Arg: TypeAlias = RuleVariation_935_Arg
class NonSpare_697(NonSpare):
    cv_name = "CAL"
    cv_title = "Calculated Doppler Speed, Coded in Two's Complement"
    cv_rule = RuleVariation_935

    @classmethod
    def create(cls, arg : NonSpare_697_Arg) -> "NonSpare_697":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_935:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_965:
        return self.rule.variation

Item_133_Arg: TypeAlias = NonSpare_697_Arg
class Item_133(Item):
    cv_non_spare = NonSpare_697

    @classmethod
    def create(cls, arg : Item_133_Arg) -> "Item_133":
        return cls._create(arg) # type: ignore

Variation_1078_Arg_Group = Tuple[Union[RuleVariation_39_Arg, Tuple[Literal["D"], RuleVariation_39_Arg]], int, Union[RuleVariation_935_Arg, Tuple[Literal["CAL"], RuleVariation_935_Arg]]]
Variation_1078_Arg: TypeAlias = Union[int, Variation_1078_Arg_Group]
class Variation_1078(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_232, 1), (Item_8, 5), (Item_133, 10)]
    cv_items_dict = {"D": RuleVariation_39, "CAL": RuleVariation_935}

    @overload
    @classmethod
    def spec(cls, key : Literal["D"]) -> RuleVariation_39:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CAL"]) -> RuleVariation_935:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["D"], Literal["CAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["D"]) -> RuleVariation_39:
        ...
    @overload
    def get_item(self, key : Literal["CAL"]) -> RuleVariation_935:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1078_Arg) -> 'Variation_1078':
        return cls._create(arg) # type: ignore

RuleVariation_1038_Arg: TypeAlias = Variation_1078_Arg
class RuleVariation_1038(RuleVariationContextFree):
    cv_variation = Variation_1078

    @classmethod
    def create(cls, arg : RuleVariation_1038_Arg) -> "RuleVariation_1038":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1078:
        return self.arg # type: ignore

NonSpare_696_Arg: TypeAlias = RuleVariation_1038_Arg
class NonSpare_696(NonSpare):
    cv_name = "CAL"
    cv_title = "Calculated Doppler Speed"
    cv_rule = RuleVariation_1038

    @classmethod
    def create(cls, arg : NonSpare_696_Arg) -> "NonSpare_696":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1038:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1078:
        return self.rule.variation

Content_718_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
class Content_718(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_718_Arg: TypeAlias = Content_718_Arg
class RuleContent_718(RuleContentContextFree):
    cv_content = Content_718

    @property
    def content(self) -> Content_718:
        return self._get_content() # type: ignore

Variation_304_Arg: TypeAlias = RuleContent_718_Arg
class Variation_304(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_718

    @classmethod
    def create(cls, arg : Variation_304_Arg) -> "Variation_304":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_718:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_718:
        return self.rule.content

RuleVariation_297_Arg: TypeAlias = Variation_304_Arg
class RuleVariation_297(RuleVariationContextFree):
    cv_variation = Variation_304

    @classmethod
    def create(cls, arg : RuleVariation_297_Arg) -> "RuleVariation_297":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_304:
        return self.arg # type: ignore

NonSpare_884_Arg: TypeAlias = RuleVariation_297_Arg
class NonSpare_884(NonSpare):
    cv_name = "DOP"
    cv_title = "Doppler Speed"
    cv_rule = RuleVariation_297

    @classmethod
    def create(cls, arg : NonSpare_884_Arg) -> "NonSpare_884":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_297:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_304:
        return self.rule.variation

Item_265_Arg: TypeAlias = NonSpare_884_Arg
class Item_265(Item):
    cv_non_spare = NonSpare_884

    @classmethod
    def create(cls, arg : Item_265_Arg) -> "Item_265":
        return cls._create(arg) # type: ignore

NonSpare_603_Arg: TypeAlias = RuleVariation_297_Arg
class NonSpare_603(NonSpare):
    cv_name = "AMB"
    cv_title = "Ambiguity Range"
    cv_rule = RuleVariation_297

    @classmethod
    def create(cls, arg : NonSpare_603_Arg) -> "NonSpare_603":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_297:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_304:
        return self.rule.variation

Item_72_Arg: TypeAlias = NonSpare_603_Arg
class Item_72(Item):
    cv_non_spare = NonSpare_603

    @classmethod
    def create(cls, arg : Item_72_Arg) -> "Item_72":
        return cls._create(arg) # type: ignore

Content_709_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["MHz"]]]
class Content_709(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = "MHz"

    def as_quantity(self, cv_unit : Optional[Literal["MHz"]] = None) -> float:
        return self._as_quantity()

RuleContent_709_Arg: TypeAlias = Content_709_Arg
class RuleContent_709(RuleContentContextFree):
    cv_content = Content_709

    @property
    def content(self) -> Content_709:
        return self._get_content() # type: ignore

Variation_298_Arg: TypeAlias = RuleContent_709_Arg
class Variation_298(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_709

    @classmethod
    def create(cls, arg : Variation_298_Arg) -> "Variation_298":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_709:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_709:
        return self.rule.content

RuleVariation_291_Arg: TypeAlias = Variation_298_Arg
class RuleVariation_291(RuleVariationContextFree):
    cv_variation = Variation_298

    @classmethod
    def create(cls, arg : RuleVariation_291_Arg) -> "RuleVariation_291":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_298:
        return self.arg # type: ignore

NonSpare_989_Arg: TypeAlias = RuleVariation_291_Arg
class NonSpare_989(NonSpare):
    cv_name = "FRQ"
    cv_title = "Transmitter Frequency"
    cv_rule = RuleVariation_291

    @classmethod
    def create(cls, arg : NonSpare_989_Arg) -> "NonSpare_989":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_291:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_298:
        return self.rule.variation

Item_344_Arg: TypeAlias = NonSpare_989_Arg
class Item_344(Item):
    cv_non_spare = NonSpare_989

    @classmethod
    def create(cls, arg : Item_344_Arg) -> "Item_344":
        return cls._create(arg) # type: ignore

Variation_1081_Arg_Group = Tuple[Union[RuleVariation_297_Arg, Tuple[Literal["DOP"], RuleVariation_297_Arg]], Union[RuleVariation_297_Arg, Tuple[Literal["AMB"], RuleVariation_297_Arg]], Union[RuleVariation_291_Arg, Tuple[Literal["FRQ"], RuleVariation_291_Arg]]]
Variation_1081_Arg: TypeAlias = Union[int, Variation_1081_Arg_Group]
class Variation_1081(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_265, 16), (Item_72, 16), (Item_344, 16)]
    cv_items_dict = {"DOP": RuleVariation_297, "AMB": RuleVariation_297, "FRQ": RuleVariation_291}

    @overload
    @classmethod
    def spec(cls, key : Literal["DOP"]) -> RuleVariation_297:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AMB"]) -> RuleVariation_297:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FRQ"]) -> RuleVariation_291:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["DOP"], Literal["AMB"], Literal["FRQ"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["DOP"]) -> RuleVariation_297:
        ...
    @overload
    def get_item(self, key : Literal["AMB"]) -> RuleVariation_297:
        ...
    @overload
    def get_item(self, key : Literal["FRQ"]) -> RuleVariation_291:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1081_Arg) -> 'Variation_1081':
        return cls._create(arg) # type: ignore

Variation_1409_Arg: TypeAlias = List[Variation_1081_Arg]
class Variation_1409(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1081

    @classmethod
    def create(cls, arg : Variation_1409_Arg) -> 'Variation_1409':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1081]:
        return self._get_list() # type: ignore

RuleVariation_1332_Arg: TypeAlias = Variation_1409_Arg
class RuleVariation_1332(RuleVariationContextFree):
    cv_variation = Variation_1409

    @classmethod
    def create(cls, arg : RuleVariation_1332_Arg) -> "RuleVariation_1332":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1409:
        return self.arg # type: ignore

NonSpare_1553_Arg: TypeAlias = RuleVariation_1332_Arg
class NonSpare_1553(NonSpare):
    cv_name = "RDS"
    cv_title = "Raw Doppler Speed"
    cv_rule = RuleVariation_1332

    @classmethod
    def create(cls, arg : NonSpare_1553_Arg) -> "NonSpare_1553":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1332:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1409:
        return self.rule.variation

Variation_1469_Arg = TypedDict('Variation_1469_Arg', {
    "CAL": NonSpare_696_Arg,
    "RDS": NonSpare_1553_Arg,
}, total=False)
class Variation_1469(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_696, NonSpare_1553]
    cv_items_dict = {"CAL": NonSpare_696, "RDS": NonSpare_1553}

    @overload
    @classmethod
    def spec(cls, key : Literal["CAL"]) -> NonSpare_696:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RDS"]) -> NonSpare_1553:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CAL"], Literal["RDS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CAL"]) -> Optional[NonSpare_696]:
        ...
    @overload
    def get_item(self, key : Literal["RDS"]) -> Optional[NonSpare_1553]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["CAL"], val : NonSpare_696_Arg) -> "Variation_1469":
        ...
    @overload
    def set_item(self, key : Literal["RDS"], val : NonSpare_1553_Arg) -> "Variation_1469":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["CAL"]) -> "Variation_1469":
        ...
    @overload
    def del_item(self, key : Literal["RDS"]) -> "Variation_1469":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1469_Arg) -> 'Variation_1469':
        return cls._create(arg) # type: ignore

RuleVariation_1392_Arg: TypeAlias = Variation_1469_Arg
class RuleVariation_1392(RuleVariationContextFree):
    cv_variation = Variation_1469

    @classmethod
    def create(cls, arg : RuleVariation_1392_Arg) -> "RuleVariation_1392":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1469:
        return self.arg # type: ignore

NonSpare_296_Arg: TypeAlias = RuleVariation_1392_Arg
class NonSpare_296(NonSpare):
    cv_name = "120"
    cv_title = "Radial Doppler Speed"
    cv_rule = RuleVariation_1392

    @classmethod
    def create(cls, arg : NonSpare_296_Arg) -> "NonSpare_296":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1392:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1469:
        return self.rule.variation

class UapItem_296(UapItem):
    cv_non_spare = NonSpare_296

Content_336_Arg: TypeAlias = int
class Content_336(ContentTable):
    cv_values = {0: "No communications capability (surveillance only)", 1: "Comm. A and Comm. B capability", 2: "Comm. A, Comm. B and Uplink ELM", 3: "Comm. A, Comm. B, Uplink ELM and Downlink ELM", 4: "Level 5 Transponder capability"}

RuleContent_336_Arg: TypeAlias = Content_336_Arg
class RuleContent_336(RuleContentContextFree):
    cv_content = Content_336

    @property
    def content(self) -> Content_336:
        return self._get_content() # type: ignore

Variation_122_Arg: TypeAlias = RuleContent_336_Arg
class Variation_122(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_336

    @classmethod
    def create(cls, arg : Variation_122_Arg) -> "Variation_122":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_336:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_336:
        return self.rule.content

RuleVariation_122_Arg: TypeAlias = Variation_122_Arg
class RuleVariation_122(RuleVariationContextFree):
    cv_variation = Variation_122

    @classmethod
    def create(cls, arg : RuleVariation_122_Arg) -> "RuleVariation_122":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_122:
        return self.arg # type: ignore

NonSpare_777_Arg: TypeAlias = RuleVariation_122_Arg
class NonSpare_777(NonSpare):
    cv_name = "COM"
    cv_title = "Communications Capability of the Transponder"
    cv_rule = RuleVariation_122

    @classmethod
    def create(cls, arg : NonSpare_777_Arg) -> "NonSpare_777":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_122:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_122:
        return self.rule.variation

Item_186_Arg: TypeAlias = NonSpare_777_Arg
class Item_186(Item):
    cv_non_spare = NonSpare_777

    @classmethod
    def create(cls, arg : Item_186_Arg) -> "Item_186":
        return cls._create(arg) # type: ignore

Content_322_Arg: TypeAlias = int
class Content_322(ContentTable):
    cv_values = {0: "No alert, no SPI, aircraft airborne", 1: "No alert, no SPI, aircraft on ground", 2: "Alert, no SPI, aircraft airborne", 3: "Alert, no SPI, aircraft on ground", 4: "Alert, SPI, aircraft airborne or on ground", 5: "No alert, SPI, aircraft airborne or on ground", 7: "Unknown"}

RuleContent_322_Arg: TypeAlias = Content_322_Arg
class RuleContent_322(RuleContentContextFree):
    cv_content = Content_322

    @property
    def content(self) -> Content_322:
        return self._get_content() # type: ignore

Variation_684_Arg: TypeAlias = RuleContent_322_Arg
class Variation_684(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 3
    cv_rule = RuleContent_322

    @classmethod
    def create(cls, arg : Variation_684_Arg) -> "Variation_684":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_322:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_322:
        return self.rule.content

RuleVariation_673_Arg: TypeAlias = Variation_684_Arg
class RuleVariation_673(RuleVariationContextFree):
    cv_variation = Variation_684

    @classmethod
    def create(cls, arg : RuleVariation_673_Arg) -> "RuleVariation_673":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_684:
        return self.arg # type: ignore

NonSpare_1769_Arg: TypeAlias = RuleVariation_673_Arg
class NonSpare_1769(NonSpare):
    cv_name = "STAT"
    cv_title = "Flight Status"
    cv_rule = RuleVariation_673

    @classmethod
    def create(cls, arg : NonSpare_1769_Arg) -> "NonSpare_1769":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_673:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_684:
        return self.rule.variation

Item_936_Arg: TypeAlias = NonSpare_1769_Arg
class Item_936(Item):
    cv_non_spare = NonSpare_1769

    @classmethod
    def create(cls, arg : Item_936_Arg) -> "Item_936":
        return cls._create(arg) # type: ignore

Content_447_Arg: TypeAlias = int
class Content_447(ContentTable):
    cv_values = {0: "SI-Code Capable", 1: "II-Code Capable"}

RuleContent_447_Arg: TypeAlias = Content_447_Arg
class RuleContent_447(RuleContentContextFree):
    cv_content = Content_447

    @property
    def content(self) -> Content_447:
        return self._get_content() # type: ignore

Variation_947_Arg: TypeAlias = RuleContent_447_Arg
class Variation_947(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_447

    @classmethod
    def create(cls, arg : Variation_947_Arg) -> "Variation_947":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_447:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_447:
        return self.rule.content

RuleVariation_917_Arg: TypeAlias = Variation_947_Arg
class RuleVariation_917(RuleVariationContextFree):
    cv_variation = Variation_947

    @classmethod
    def create(cls, arg : RuleVariation_917_Arg) -> "RuleVariation_917":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_947:
        return self.arg # type: ignore

NonSpare_1697_Arg: TypeAlias = RuleVariation_917_Arg
class NonSpare_1697(NonSpare):
    cv_name = "SI"
    cv_title = "SI/II Transponder Capability"
    cv_rule = RuleVariation_917

    @classmethod
    def create(cls, arg : NonSpare_1697_Arg) -> "NonSpare_1697":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_917:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_947:
        return self.rule.variation

Item_880_Arg: TypeAlias = NonSpare_1697_Arg
class Item_880(Item):
    cv_non_spare = NonSpare_1697

    @classmethod
    def create(cls, arg : Item_880_Arg) -> "Item_880":
        return cls._create(arg) # type: ignore

Variation_1071_Arg_Group = Tuple[Union[RuleVariation_122_Arg, Tuple[Literal["COM"], RuleVariation_122_Arg]], Union[RuleVariation_673_Arg, Tuple[Literal["STAT"], RuleVariation_673_Arg]], Union[RuleVariation_917_Arg, Tuple[Literal["SI"], RuleVariation_917_Arg]], int, Union[RuleVariation_55_Arg, Tuple[Literal["MSSC"], RuleVariation_55_Arg]], Union[RuleVariation_388_Arg, Tuple[Literal["ARC"], RuleVariation_388_Arg]], Union[RuleVariation_544_Arg, Tuple[Literal["AIC"], RuleVariation_544_Arg]], Union[RuleVariation_600_Arg, Tuple[Literal["B1A"], RuleVariation_600_Arg]], Union[RuleVariation_766_Arg, Tuple[Literal["B1B"], RuleVariation_766_Arg]]]
Variation_1071_Arg: TypeAlias = Union[int, Variation_1071_Arg_Group]
class Variation_1071(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_186, 3), (Item_936, 3), (Item_880, 1), (Item_29, 1), (Item_593, 1), (Item_81, 1), (Item_55, 1), (Item_108, 1), (Item_110, 4)]
    cv_items_dict = {"COM": RuleVariation_122, "STAT": RuleVariation_673, "SI": RuleVariation_917, "MSSC": RuleVariation_55, "ARC": RuleVariation_388, "AIC": RuleVariation_544, "B1A": RuleVariation_600, "B1B": RuleVariation_766}

    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> RuleVariation_122:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_673:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SI"]) -> RuleVariation_917:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSSC"]) -> RuleVariation_55:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> RuleVariation_388:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AIC"]) -> RuleVariation_544:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1A"]) -> RuleVariation_600:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1B"]) -> RuleVariation_766:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COM"], Literal["STAT"], Literal["SI"], Literal["MSSC"], Literal["ARC"], Literal["AIC"], Literal["B1A"], Literal["B1B"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COM"]) -> RuleVariation_122:
        ...
    @overload
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_673:
        ...
    @overload
    def get_item(self, key : Literal["SI"]) -> RuleVariation_917:
        ...
    @overload
    def get_item(self, key : Literal["MSSC"]) -> RuleVariation_55:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_388:
        ...
    @overload
    def get_item(self, key : Literal["AIC"]) -> RuleVariation_544:
        ...
    @overload
    def get_item(self, key : Literal["B1A"]) -> RuleVariation_600:
        ...
    @overload
    def get_item(self, key : Literal["B1B"]) -> RuleVariation_766:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1071_Arg) -> 'Variation_1071':
        return cls._create(arg) # type: ignore

RuleVariation_1031_Arg: TypeAlias = Variation_1071_Arg
class RuleVariation_1031(RuleVariationContextFree):
    cv_variation = Variation_1071

    @classmethod
    def create(cls, arg : RuleVariation_1031_Arg) -> "RuleVariation_1031":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1071:
        return self.arg # type: ignore

NonSpare_424_Arg: TypeAlias = RuleVariation_1031_Arg
class NonSpare_424(NonSpare):
    cv_name = "230"
    cv_title = "Communications/ACAS Capability and Flight Status"
    cv_rule = RuleVariation_1031

    @classmethod
    def create(cls, arg : NonSpare_424_Arg) -> "NonSpare_424":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1031:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1071:
        return self.rule.variation

class UapItem_424(UapItem):
    cv_non_spare = NonSpare_424

NonSpare_449_Arg: TypeAlias = RuleVariation_382_Arg
class NonSpare_449(NonSpare):
    cv_name = "260"
    cv_title = "ACAS Resolution Advisory Report"
    cv_rule = RuleVariation_382

    @classmethod
    def create(cls, arg : NonSpare_449_Arg) -> "NonSpare_449":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_382:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_390:
        return self.rule.variation

class UapItem_449(UapItem):
    cv_non_spare = NonSpare_449

Content_281_Arg: TypeAlias = int
class Content_281(ContentTable):
    cv_values = {0: "Mode-1 code as derived from the reply of the transponder", 1: "Smoothed Mode-1 code as provided by a local tracker"}

RuleContent_281_Arg: TypeAlias = Content_281_Arg
class RuleContent_281(RuleContentContextFree):
    cv_content = Content_281

    @property
    def content(self) -> Content_281:
        return self._get_content() # type: ignore

Variation_543_Arg: TypeAlias = RuleContent_281_Arg
class Variation_543(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_281

    @classmethod
    def create(cls, arg : Variation_543_Arg) -> "Variation_543":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_281:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_281:
        return self.rule.content

RuleVariation_532_Arg: TypeAlias = Variation_543_Arg
class RuleVariation_532(RuleVariationContextFree):
    cv_variation = Variation_543

    @classmethod
    def create(cls, arg : RuleVariation_532_Arg) -> "RuleVariation_532":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_543:
        return self.arg # type: ignore

NonSpare_1125_Arg: TypeAlias = RuleVariation_532_Arg
class NonSpare_1125(NonSpare):
    cv_name = "L"
    cv_title = ""
    cv_rule = RuleVariation_532

    @classmethod
    def create(cls, arg : NonSpare_1125_Arg) -> "NonSpare_1125":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_532:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_543:
        return self.rule.variation

Item_443_Arg: TypeAlias = NonSpare_1125_Arg
class Item_443(Item):
    cv_non_spare = NonSpare_1125

    @classmethod
    def create(cls, arg : Item_443_Arg) -> "Item_443":
        return cls._create(arg) # type: ignore

NonSpare_1291_Arg: TypeAlias = RuleVariation_681_Arg
class NonSpare_1291(NonSpare):
    cv_name = "MODE1"
    cv_title = "Mode-1 Code"
    cv_rule = RuleVariation_681

    @classmethod
    def create(cls, arg : NonSpare_1291_Arg) -> "NonSpare_1291":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_681:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_692:
        return self.rule.variation

Item_563_Arg: TypeAlias = NonSpare_1291_Arg
class Item_563(Item):
    cv_non_spare = NonSpare_1291

    @classmethod
    def create(cls, arg : Item_563_Arg) -> "Item_563":
        return cls._create(arg) # type: ignore

Variation_1252_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_532_Arg, Tuple[Literal["L"], RuleVariation_532_Arg]], Union[RuleVariation_681_Arg, Tuple[Literal["MODE1"], RuleVariation_681_Arg]]]
Variation_1252_Arg: TypeAlias = Union[int, Variation_1252_Arg_Group]
class Variation_1252(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1099, 1), (Item_353, 1), (Item_443, 1), (Item_563, 5)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "L": RuleVariation_532, "MODE1": RuleVariation_681}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_532:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE1"]) -> RuleVariation_681:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_532:
        ...
    @overload
    def get_item(self, key : Literal["MODE1"]) -> RuleVariation_681:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1252_Arg) -> 'Variation_1252':
        return cls._create(arg) # type: ignore

RuleVariation_1182_Arg: TypeAlias = Variation_1252_Arg
class RuleVariation_1182(RuleVariationContextFree):
    cv_variation = Variation_1252

    @classmethod
    def create(cls, arg : RuleVariation_1182_Arg) -> "RuleVariation_1182":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1252:
        return self.arg # type: ignore

NonSpare_183_Arg: TypeAlias = RuleVariation_1182_Arg
class NonSpare_183(NonSpare):
    cv_name = "055"
    cv_title = "Mode-1 Code in Octal Representation"
    cv_rule = RuleVariation_1182

    @classmethod
    def create(cls, arg : NonSpare_183_Arg) -> "NonSpare_183":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1182:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1252:
        return self.rule.variation

class UapItem_183(UapItem):
    cv_non_spare = NonSpare_183

NonSpare_170_Arg: TypeAlias = RuleVariation_1184_Arg
class NonSpare_170(NonSpare):
    cv_name = "050"
    cv_title = "Mode-2 Code in Octal Representation"
    cv_rule = RuleVariation_1184

    @classmethod
    def create(cls, arg : NonSpare_170_Arg) -> "NonSpare_170":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1184:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1254:
        return self.rule.variation

class UapItem_170(UapItem):
    cv_non_spare = NonSpare_170

Variation_638_Arg: TypeAlias = RuleContent_226_Arg
class Variation_638(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_226

    @classmethod
    def create(cls, arg : Variation_638_Arg) -> "Variation_638":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_226:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_226:
        return self.rule.content

RuleVariation_627_Arg: TypeAlias = Variation_638_Arg
class RuleVariation_627(RuleVariationContextFree):
    cv_variation = Variation_638

    @classmethod
    def create(cls, arg : RuleVariation_627_Arg) -> "RuleVariation_627":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_638:
        return self.arg # type: ignore

NonSpare_1486_Arg: TypeAlias = RuleVariation_627_Arg
class NonSpare_1486(NonSpare):
    cv_name = "QA4"
    cv_title = ""
    cv_rule = RuleVariation_627

    @classmethod
    def create(cls, arg : NonSpare_1486_Arg) -> "NonSpare_1486":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_627:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_638:
        return self.rule.variation

Item_725_Arg: TypeAlias = NonSpare_1486_Arg
class Item_725(Item):
    cv_non_spare = NonSpare_1486

    @classmethod
    def create(cls, arg : Item_725_Arg) -> "Item_725":
        return cls._create(arg) # type: ignore

Variation_722_Arg: TypeAlias = RuleContent_225_Arg
class Variation_722(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_225

    @classmethod
    def create(cls, arg : Variation_722_Arg) -> "Variation_722":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_225:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_225:
        return self.rule.content

RuleVariation_711_Arg: TypeAlias = Variation_722_Arg
class RuleVariation_711(RuleVariationContextFree):
    cv_variation = Variation_722

    @classmethod
    def create(cls, arg : RuleVariation_711_Arg) -> "RuleVariation_711":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_722:
        return self.arg # type: ignore

NonSpare_1481_Arg: TypeAlias = RuleVariation_711_Arg
class NonSpare_1481(NonSpare):
    cv_name = "QA2"
    cv_title = ""
    cv_rule = RuleVariation_711

    @classmethod
    def create(cls, arg : NonSpare_1481_Arg) -> "NonSpare_1481":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_711:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_722:
        return self.rule.variation

Item_720_Arg: TypeAlias = NonSpare_1481_Arg
class Item_720(Item):
    cv_non_spare = NonSpare_1481

    @classmethod
    def create(cls, arg : Item_720_Arg) -> "Item_720":
        return cls._create(arg) # type: ignore

Variation_927_Arg: TypeAlias = RuleContent_228_Arg
class Variation_927(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_228

    @classmethod
    def create(cls, arg : Variation_927_Arg) -> "Variation_927":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_228:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_228:
        return self.rule.content

RuleVariation_897_Arg: TypeAlias = Variation_927_Arg
class RuleVariation_897(RuleVariationContextFree):
    cv_variation = Variation_927

    @classmethod
    def create(cls, arg : RuleVariation_897_Arg) -> "RuleVariation_897":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_927:
        return self.arg # type: ignore

NonSpare_1495_Arg: TypeAlias = RuleVariation_897_Arg
class NonSpare_1495(NonSpare):
    cv_name = "QB2"
    cv_title = ""
    cv_rule = RuleVariation_897

    @classmethod
    def create(cls, arg : NonSpare_1495_Arg) -> "NonSpare_1495":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_897:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_927:
        return self.rule.variation

Item_734_Arg: TypeAlias = NonSpare_1495_Arg
class Item_734(Item):
    cv_non_spare = NonSpare_1495

    @classmethod
    def create(cls, arg : Item_734_Arg) -> "Item_734":
        return cls._create(arg) # type: ignore

Variation_974_Arg: TypeAlias = RuleContent_227_Arg
class Variation_974(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_227

    @classmethod
    def create(cls, arg : Variation_974_Arg) -> "Variation_974":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_227:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_227:
        return self.rule.content

RuleVariation_944_Arg: TypeAlias = Variation_974_Arg
class RuleVariation_944(RuleVariationContextFree):
    cv_variation = Variation_974

    @classmethod
    def create(cls, arg : RuleVariation_944_Arg) -> "RuleVariation_944":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_974:
        return self.arg # type: ignore

NonSpare_1491_Arg: TypeAlias = RuleVariation_944_Arg
class NonSpare_1491(NonSpare):
    cv_name = "QB1"
    cv_title = ""
    cv_rule = RuleVariation_944

    @classmethod
    def create(cls, arg : NonSpare_1491_Arg) -> "NonSpare_1491":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_944:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_974:
        return self.rule.variation

Item_730_Arg: TypeAlias = NonSpare_1491_Arg
class Item_730(Item):
    cv_non_spare = NonSpare_1491

    @classmethod
    def create(cls, arg : Item_730_Arg) -> "Item_730":
        return cls._create(arg) # type: ignore

Variation_1012_Arg_Group = Tuple[int, Union[RuleVariation_627_Arg, Tuple[Literal["QA4"], RuleVariation_627_Arg]], Union[RuleVariation_711_Arg, Tuple[Literal["QA2"], RuleVariation_711_Arg]], Union[RuleVariation_819_Arg, Tuple[Literal["QA1"], RuleVariation_819_Arg]], Union[RuleVariation_897_Arg, Tuple[Literal["QB2"], RuleVariation_897_Arg]], Union[RuleVariation_944_Arg, Tuple[Literal["QB1"], RuleVariation_944_Arg]]]
Variation_1012_Arg: TypeAlias = Union[int, Variation_1012_Arg_Group]
class Variation_1012(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_2, 3), (Item_725, 1), (Item_720, 1), (Item_717, 1), (Item_734, 1), (Item_730, 1)]
    cv_items_dict = {"QA4": RuleVariation_627, "QA2": RuleVariation_711, "QA1": RuleVariation_819, "QB2": RuleVariation_897, "QB1": RuleVariation_944}

    @overload
    @classmethod
    def spec(cls, key : Literal["QA4"]) -> RuleVariation_627:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA2"]) -> RuleVariation_711:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA1"]) -> RuleVariation_819:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB2"]) -> RuleVariation_897:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB1"]) -> RuleVariation_944:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["QA4"], Literal["QA2"], Literal["QA1"], Literal["QB2"], Literal["QB1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["QA4"]) -> RuleVariation_627:
        ...
    @overload
    def get_item(self, key : Literal["QA2"]) -> RuleVariation_711:
        ...
    @overload
    def get_item(self, key : Literal["QA1"]) -> RuleVariation_819:
        ...
    @overload
    def get_item(self, key : Literal["QB2"]) -> RuleVariation_897:
        ...
    @overload
    def get_item(self, key : Literal["QB1"]) -> RuleVariation_944:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1012_Arg) -> 'Variation_1012':
        return cls._create(arg) # type: ignore

RuleVariation_982_Arg: TypeAlias = Variation_1012_Arg
class RuleVariation_982(RuleVariationContextFree):
    cv_variation = Variation_1012

    @classmethod
    def create(cls, arg : RuleVariation_982_Arg) -> "RuleVariation_982":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1012:
        return self.arg # type: ignore

NonSpare_199_Arg: TypeAlias = RuleVariation_982_Arg
class NonSpare_199(NonSpare):
    cv_name = "065"
    cv_title = "Mode-1 Code Confidence Indicator"
    cv_rule = RuleVariation_982

    @classmethod
    def create(cls, arg : NonSpare_199_Arg) -> "NonSpare_199":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_982:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1012:
        return self.rule.variation

class UapItem_199(UapItem):
    cv_non_spare = NonSpare_199

NonSpare_185_Arg: TypeAlias = RuleVariation_997_Arg
class NonSpare_185(NonSpare):
    cv_name = "060"
    cv_title = "Mode-2 Code Confidence Indicator"
    cv_rule = RuleVariation_997

    @classmethod
    def create(cls, arg : NonSpare_185_Arg) -> "NonSpare_185":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_997:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1029:
        return self.rule.variation

class UapItem_185(UapItem):
    cv_non_spare = NonSpare_185

Record_28_Arg = TypedDict('Record_28_Arg', {
    "010": NonSpare_38_Arg,
    "140": NonSpare_328_Arg,
    "020": NonSpare_87_Arg,
    "040": NonSpare_137_Arg,
    "070": NonSpare_207_Arg,
    "090": NonSpare_245_Arg,
    "130": NonSpare_308_Arg,
    "220": NonSpare_415_Arg,
    "240": NonSpare_431_Arg,
    "250": NonSpare_445_Arg,
    "161": NonSpare_359_Arg,
    "042": NonSpare_158_Arg,
    "200": NonSpare_385_Arg,
    "170": NonSpare_372_Arg,
    "210": NonSpare_411_Arg,
    "030": NonSpare_117_Arg,
    "080": NonSpare_229_Arg,
    "100": NonSpare_269_Arg,
    "110": NonSpare_283_Arg,
    "120": NonSpare_296_Arg,
    "230": NonSpare_424_Arg,
    "260": NonSpare_449_Arg,
    "055": NonSpare_183_Arg,
    "050": NonSpare_170_Arg,
    "065": NonSpare_199_Arg,
    "060": NonSpare_185_Arg,
    "SP": NonSpare_1723_Arg,
    "RE": NonSpare_1558_Arg,
}, total=False)
class Record_28(Record):
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_38, UapItem_328, UapItem_87, UapItem_137, UapItem_207, UapItem_245, UapItem_308, UapItem_415, UapItem_431, UapItem_445, UapItem_359, UapItem_158, UapItem_385, UapItem_372, UapItem_411, UapItem_117, UapItem_229, UapItem_269, UapItem_283, UapItem_296, UapItem_424, UapItem_449, UapItem_183, UapItem_170, UapItem_199, UapItem_185, UapItem_543, UapItem_542]
    cv_items_dict = {"010": NonSpare_38, "140": NonSpare_328, "020": NonSpare_87, "040": NonSpare_137, "070": NonSpare_207, "090": NonSpare_245, "130": NonSpare_308, "220": NonSpare_415, "240": NonSpare_431, "250": NonSpare_445, "161": NonSpare_359, "042": NonSpare_158, "200": NonSpare_385, "170": NonSpare_372, "210": NonSpare_411, "030": NonSpare_117, "080": NonSpare_229, "100": NonSpare_269, "110": NonSpare_283, "120": NonSpare_296, "230": NonSpare_424, "260": NonSpare_449, "055": NonSpare_183, "050": NonSpare_170, "065": NonSpare_199, "060": NonSpare_185, "SP": NonSpare_1723, "RE": NonSpare_1558}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_38:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_328:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_87:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_137:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_245:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_308:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_415:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["240"]) -> NonSpare_431:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_445:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_359:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_385:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_372:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_411:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_117:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_229:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_269:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_283:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_296:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_424:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_449:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["055"]) -> NonSpare_183:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_170:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["065"]) -> NonSpare_199:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_185:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["140"], Literal["020"], Literal["040"], Literal["070"], Literal["090"], Literal["130"], Literal["220"], Literal["240"], Literal["250"], Literal["161"], Literal["042"], Literal["200"], Literal["170"], Literal["210"], Literal["030"], Literal["080"], Literal["100"], Literal["110"], Literal["120"], Literal["230"], Literal["260"], Literal["055"], Literal["050"], Literal["065"], Literal["060"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_38]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_328]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_87]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_137]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_207]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_245]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_308]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_415]:
        ...
    @overload
    def get_item(self, key : Literal["240"]) -> Optional[NonSpare_431]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_445]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_359]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_158]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_385]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_372]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_411]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_117]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_229]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_269]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_283]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_296]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_424]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_449]:
        ...
    @overload
    def get_item(self, key : Literal["055"]) -> Optional[NonSpare_183]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_170]:
        ...
    @overload
    def get_item(self, key : Literal["065"]) -> Optional[NonSpare_199]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_185]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_38_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_328_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_87_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_137_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_207_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_245_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_308_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_415_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["240"], val : NonSpare_431_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_445_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_359_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_158_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_385_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_372_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_411_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_117_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_229_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_269_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_283_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_296_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_424_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_449_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["055"], val : NonSpare_183_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_170_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["065"], val : NonSpare_199_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_185_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_28':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["240"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["055"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["065"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_28':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_28_Arg) -> 'Record_28':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_28", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_24_Arg: TypeAlias = Record_28
class Uap_24(UapSingle):
    cv_record = Record_28

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_28]]:
        return cls._parse(bs)

class Asterix_43(AstCat):
    cv_category = 48
    cv_edition = (1, 27)
    cv_uap = Uap_24

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_24_Arg]) -> "Asterix_43":
        return cls._create(records) # type: ignore

Content_392_Arg: TypeAlias = int
class Content_392(ContentTable):
    cv_values = {0: "Not defined; never used", 1: "Multipath Reply (Reflection)", 2: "Reply due to sidelobe interrogation/reception", 3: "Split plot", 4: "Second time around reply", 5: "Angel", 6: "Slow moving target correlated with road infrastructure (terrestrial vehicle)", 7: "Fixed PSR plot", 8: "Slow PSR target", 9: "Low quality PSR plot", 10: "Phantom SSR plot", 11: "Non-Matching Mode-3/A Code", 12: "Mode C code / Mode S altitude code abnormal value compared to the track", 13: "Target in Clutter Area", 14: "Maximum Doppler Response in Zero Filter", 15: "Transponder anomaly detected", 16: "Duplicated or Illegal Mode S Aircraft Address", 17: "Mode S error correction applied", 18: "Undecodable Mode C code / Mode S altitude code", 19: "Birds", 20: "Flock of Birds", 21: "Mode-1 was present in original reply", 22: "Mode-2 was present in original reply", 23: "Plot potentially caused by Wind Turbine", 24: "Helicopter", 25: "Maximum number of re-interrogations reached (surveillance information)", 26: "Maximum number of re-interrogations reached (BDS Extractions)", 27: "BDS Overlay Incoherence", 28: "Potential BDS Swap Detected", 29: "Track Update in the Zenithal Gap", 30: "Mode S Track re-acquired", 31: "Duplicated Mode 5 Pair NO/PIN detected", 32: "Wrong DF reply format detected", 33: "Transponder anomaly (MS XPD replies with Mode A/C to Mode A/C-only all-call)", 34: "Transponder anomaly (SI capability report wrong)"}

RuleContent_392_Arg: TypeAlias = Content_392_Arg
class RuleContent_392(RuleContentContextFree):
    cv_content = Content_392

    @property
    def content(self) -> Content_392:
        return self._get_content() # type: ignore

Variation_153_Arg: TypeAlias = RuleContent_392_Arg
class Variation_153(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_392

    @classmethod
    def create(cls, arg : Variation_153_Arg) -> "Variation_153":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_392:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_392:
        return self.rule.content

Variation_1449_Arg: TypeAlias = List[Variation_153_Arg]
class Variation_1449(Repetitive):
    cv_rep_bytes = None
    cv_variation = Variation_153

    @classmethod
    def create(cls, arg : Variation_1449_Arg) -> 'Variation_1449':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_153]:
        return self._get_list() # type: ignore

RuleVariation_1372_Arg: TypeAlias = Variation_1449_Arg
class RuleVariation_1372(RuleVariationContextFree):
    cv_variation = Variation_1449

    @classmethod
    def create(cls, arg : RuleVariation_1372_Arg) -> "RuleVariation_1372":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1449:
        return self.arg # type: ignore

NonSpare_118_Arg: TypeAlias = RuleVariation_1372_Arg
class NonSpare_118(NonSpare):
    cv_name = "030"
    cv_title = "Warning/Error Conditions and Target Classification"
    cv_rule = RuleVariation_1372

    @classmethod
    def create(cls, arg : NonSpare_118_Arg) -> "NonSpare_118":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1372:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1449:
        return self.rule.variation

class UapItem_118(UapItem):
    cv_non_spare = NonSpare_118

Record_29_Arg = TypedDict('Record_29_Arg', {
    "010": NonSpare_38_Arg,
    "140": NonSpare_328_Arg,
    "020": NonSpare_87_Arg,
    "040": NonSpare_137_Arg,
    "070": NonSpare_207_Arg,
    "090": NonSpare_245_Arg,
    "130": NonSpare_308_Arg,
    "220": NonSpare_415_Arg,
    "240": NonSpare_431_Arg,
    "250": NonSpare_445_Arg,
    "161": NonSpare_359_Arg,
    "042": NonSpare_158_Arg,
    "200": NonSpare_385_Arg,
    "170": NonSpare_372_Arg,
    "210": NonSpare_411_Arg,
    "030": NonSpare_118_Arg,
    "080": NonSpare_229_Arg,
    "100": NonSpare_269_Arg,
    "110": NonSpare_283_Arg,
    "120": NonSpare_296_Arg,
    "230": NonSpare_424_Arg,
    "260": NonSpare_449_Arg,
    "055": NonSpare_183_Arg,
    "050": NonSpare_170_Arg,
    "065": NonSpare_199_Arg,
    "060": NonSpare_185_Arg,
    "SP": NonSpare_1723_Arg,
    "RE": NonSpare_1558_Arg,
}, total=False)
class Record_29(Record):
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_38, UapItem_328, UapItem_87, UapItem_137, UapItem_207, UapItem_245, UapItem_308, UapItem_415, UapItem_431, UapItem_445, UapItem_359, UapItem_158, UapItem_385, UapItem_372, UapItem_411, UapItem_118, UapItem_229, UapItem_269, UapItem_283, UapItem_296, UapItem_424, UapItem_449, UapItem_183, UapItem_170, UapItem_199, UapItem_185, UapItem_543, UapItem_542]
    cv_items_dict = {"010": NonSpare_38, "140": NonSpare_328, "020": NonSpare_87, "040": NonSpare_137, "070": NonSpare_207, "090": NonSpare_245, "130": NonSpare_308, "220": NonSpare_415, "240": NonSpare_431, "250": NonSpare_445, "161": NonSpare_359, "042": NonSpare_158, "200": NonSpare_385, "170": NonSpare_372, "210": NonSpare_411, "030": NonSpare_118, "080": NonSpare_229, "100": NonSpare_269, "110": NonSpare_283, "120": NonSpare_296, "230": NonSpare_424, "260": NonSpare_449, "055": NonSpare_183, "050": NonSpare_170, "065": NonSpare_199, "060": NonSpare_185, "SP": NonSpare_1723, "RE": NonSpare_1558}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_38:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_328:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_87:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_137:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_245:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_308:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_415:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["240"]) -> NonSpare_431:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_445:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_359:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_385:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_372:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_411:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_118:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_229:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_269:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_283:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_296:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_424:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_449:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["055"]) -> NonSpare_183:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_170:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["065"]) -> NonSpare_199:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_185:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["140"], Literal["020"], Literal["040"], Literal["070"], Literal["090"], Literal["130"], Literal["220"], Literal["240"], Literal["250"], Literal["161"], Literal["042"], Literal["200"], Literal["170"], Literal["210"], Literal["030"], Literal["080"], Literal["100"], Literal["110"], Literal["120"], Literal["230"], Literal["260"], Literal["055"], Literal["050"], Literal["065"], Literal["060"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_38]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_328]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_87]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_137]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_207]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_245]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_308]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_415]:
        ...
    @overload
    def get_item(self, key : Literal["240"]) -> Optional[NonSpare_431]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_445]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_359]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_158]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_385]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_372]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_411]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_118]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_229]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_269]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_283]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_296]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_424]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_449]:
        ...
    @overload
    def get_item(self, key : Literal["055"]) -> Optional[NonSpare_183]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_170]:
        ...
    @overload
    def get_item(self, key : Literal["065"]) -> Optional[NonSpare_199]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_185]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_38_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_328_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_87_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_137_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_207_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_245_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_308_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_415_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["240"], val : NonSpare_431_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_445_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_359_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_158_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_385_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_372_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_411_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_118_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_229_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_269_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_283_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_296_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_424_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_449_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["055"], val : NonSpare_183_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_170_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["065"], val : NonSpare_199_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_185_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_29':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["240"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["055"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["065"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_29':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_29_Arg) -> 'Record_29':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_29", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_25_Arg: TypeAlias = Record_29
class Uap_25(UapSingle):
    cv_record = Record_29

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_29]]:
        return cls._parse(bs)

class Asterix_44(AstCat):
    cv_category = 48
    cv_edition = (1, 28)
    cv_uap = Uap_25

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_25_Arg]) -> "Asterix_44":
        return cls._create(records) # type: ignore

NonSpare_441_Arg: TypeAlias = RuleVariation_1338_Arg
class NonSpare_441(NonSpare):
    cv_name = "250"
    cv_title = "BDS Register Data"
    cv_rule = RuleVariation_1338

    @classmethod
    def create(cls, arg : NonSpare_441_Arg) -> "NonSpare_441":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1338:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1415:
        return self.rule.variation

class UapItem_441(UapItem):
    cv_non_spare = NonSpare_441

NonSpare_450_Arg: TypeAlias = RuleVariation_382_Arg
class NonSpare_450(NonSpare):
    cv_name = "260"
    cv_title = "ACAS Resolution Advisory Report"
    cv_rule = RuleVariation_382

    @classmethod
    def create(cls, arg : NonSpare_450_Arg) -> "NonSpare_450":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_382:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_390:
        return self.rule.variation

class UapItem_450(UapItem):
    cv_non_spare = NonSpare_450

Record_27_Arg = TypedDict('Record_27_Arg', {
    "010": NonSpare_38_Arg,
    "140": NonSpare_328_Arg,
    "020": NonSpare_87_Arg,
    "040": NonSpare_137_Arg,
    "070": NonSpare_207_Arg,
    "090": NonSpare_245_Arg,
    "130": NonSpare_308_Arg,
    "220": NonSpare_415_Arg,
    "240": NonSpare_431_Arg,
    "250": NonSpare_441_Arg,
    "161": NonSpare_359_Arg,
    "042": NonSpare_158_Arg,
    "200": NonSpare_385_Arg,
    "170": NonSpare_372_Arg,
    "210": NonSpare_411_Arg,
    "030": NonSpare_118_Arg,
    "080": NonSpare_229_Arg,
    "100": NonSpare_269_Arg,
    "110": NonSpare_283_Arg,
    "120": NonSpare_296_Arg,
    "230": NonSpare_424_Arg,
    "260": NonSpare_450_Arg,
    "055": NonSpare_183_Arg,
    "050": NonSpare_170_Arg,
    "065": NonSpare_199_Arg,
    "060": NonSpare_185_Arg,
    "SP": NonSpare_1723_Arg,
    "RE": NonSpare_1558_Arg,
}, total=False)
class Record_27(Record):
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_38, UapItem_328, UapItem_87, UapItem_137, UapItem_207, UapItem_245, UapItem_308, UapItem_415, UapItem_431, UapItem_441, UapItem_359, UapItem_158, UapItem_385, UapItem_372, UapItem_411, UapItem_118, UapItem_229, UapItem_269, UapItem_283, UapItem_296, UapItem_424, UapItem_450, UapItem_183, UapItem_170, UapItem_199, UapItem_185, UapItem_543, UapItem_542]
    cv_items_dict = {"010": NonSpare_38, "140": NonSpare_328, "020": NonSpare_87, "040": NonSpare_137, "070": NonSpare_207, "090": NonSpare_245, "130": NonSpare_308, "220": NonSpare_415, "240": NonSpare_431, "250": NonSpare_441, "161": NonSpare_359, "042": NonSpare_158, "200": NonSpare_385, "170": NonSpare_372, "210": NonSpare_411, "030": NonSpare_118, "080": NonSpare_229, "100": NonSpare_269, "110": NonSpare_283, "120": NonSpare_296, "230": NonSpare_424, "260": NonSpare_450, "055": NonSpare_183, "050": NonSpare_170, "065": NonSpare_199, "060": NonSpare_185, "SP": NonSpare_1723, "RE": NonSpare_1558}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_38:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_328:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_87:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_137:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_245:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_308:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_415:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["240"]) -> NonSpare_431:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_441:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_359:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_385:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_372:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_411:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_118:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_229:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_269:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_283:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_296:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_424:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_450:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["055"]) -> NonSpare_183:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_170:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["065"]) -> NonSpare_199:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_185:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["140"], Literal["020"], Literal["040"], Literal["070"], Literal["090"], Literal["130"], Literal["220"], Literal["240"], Literal["250"], Literal["161"], Literal["042"], Literal["200"], Literal["170"], Literal["210"], Literal["030"], Literal["080"], Literal["100"], Literal["110"], Literal["120"], Literal["230"], Literal["260"], Literal["055"], Literal["050"], Literal["065"], Literal["060"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_38]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_328]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_87]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_137]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_207]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_245]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_308]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_415]:
        ...
    @overload
    def get_item(self, key : Literal["240"]) -> Optional[NonSpare_431]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_441]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_359]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_158]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_385]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_372]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_411]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_118]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_229]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_269]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_283]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_296]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_424]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_450]:
        ...
    @overload
    def get_item(self, key : Literal["055"]) -> Optional[NonSpare_183]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_170]:
        ...
    @overload
    def get_item(self, key : Literal["065"]) -> Optional[NonSpare_199]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_185]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_38_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_328_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_87_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_137_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_207_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_245_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_308_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_415_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["240"], val : NonSpare_431_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_441_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_359_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_158_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_385_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_372_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_411_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_118_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_229_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_269_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_283_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_296_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_424_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_450_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["055"], val : NonSpare_183_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_170_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["065"], val : NonSpare_199_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_185_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_27':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["240"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["055"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["065"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_27':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_27_Arg) -> 'Record_27':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_27", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_23_Arg: TypeAlias = Record_27
class Uap_23(UapSingle):
    cv_record = Record_27

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_27]]:
        return cls._parse(bs)

class Asterix_45(AstCat):
    cv_category = 48
    cv_edition = (1, 29)
    cv_uap = Uap_23

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_23_Arg]) -> "Asterix_45":
        return cls._create(records) # type: ignore

NonSpare_416_Arg: TypeAlias = RuleVariation_340_Arg
class NonSpare_416(NonSpare):
    cv_name = "220"
    cv_title = "Aircraft Address"
    cv_rule = RuleVariation_340

    @classmethod
    def create(cls, arg : NonSpare_416_Arg) -> "NonSpare_416":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_340:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_347:
        return self.rule.variation

class UapItem_416(UapItem):
    cv_non_spare = NonSpare_416

NonSpare_432_Arg: TypeAlias = RuleVariation_381_Arg
class NonSpare_432(NonSpare):
    cv_name = "240"
    cv_title = "Aircraft Identification"
    cv_rule = RuleVariation_381

    @classmethod
    def create(cls, arg : NonSpare_432_Arg) -> "NonSpare_432":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_381:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_389:
        return self.rule.variation

class UapItem_432(UapItem):
    cv_non_spare = NonSpare_432

NonSpare_440_Arg: TypeAlias = RuleVariation_1338_Arg
class NonSpare_440(NonSpare):
    cv_name = "250"
    cv_title = "BDS Register Data"
    cv_rule = RuleVariation_1338

    @classmethod
    def create(cls, arg : NonSpare_440_Arg) -> "NonSpare_440":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1338:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1415:
        return self.rule.variation

class UapItem_440(UapItem):
    cv_non_spare = NonSpare_440

NonSpare_425_Arg: TypeAlias = RuleVariation_1031_Arg
class NonSpare_425(NonSpare):
    cv_name = "230"
    cv_title = "Communications/ACAS Capability and Flight Status"
    cv_rule = RuleVariation_1031

    @classmethod
    def create(cls, arg : NonSpare_425_Arg) -> "NonSpare_425":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1031:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1071:
        return self.rule.variation

class UapItem_425(UapItem):
    cv_non_spare = NonSpare_425

NonSpare_168_Arg: TypeAlias = RuleVariation_1184_Arg
class NonSpare_168(NonSpare):
    cv_name = "050"
    cv_title = "Mode-2 Code in Octal Representation"
    cv_rule = RuleVariation_1184

    @classmethod
    def create(cls, arg : NonSpare_168_Arg) -> "NonSpare_168":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1184:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1254:
        return self.rule.variation

class UapItem_168(UapItem):
    cv_non_spare = NonSpare_168

Record_30_Arg = TypedDict('Record_30_Arg', {
    "010": NonSpare_38_Arg,
    "140": NonSpare_328_Arg,
    "020": NonSpare_87_Arg,
    "040": NonSpare_137_Arg,
    "070": NonSpare_207_Arg,
    "090": NonSpare_245_Arg,
    "130": NonSpare_308_Arg,
    "220": NonSpare_416_Arg,
    "240": NonSpare_432_Arg,
    "250": NonSpare_440_Arg,
    "161": NonSpare_359_Arg,
    "042": NonSpare_158_Arg,
    "200": NonSpare_385_Arg,
    "170": NonSpare_372_Arg,
    "210": NonSpare_411_Arg,
    "030": NonSpare_118_Arg,
    "080": NonSpare_229_Arg,
    "100": NonSpare_269_Arg,
    "110": NonSpare_283_Arg,
    "120": NonSpare_296_Arg,
    "230": NonSpare_425_Arg,
    "260": NonSpare_450_Arg,
    "055": NonSpare_183_Arg,
    "050": NonSpare_168_Arg,
    "065": NonSpare_199_Arg,
    "060": NonSpare_185_Arg,
    "SP": NonSpare_1723_Arg,
    "RE": NonSpare_1558_Arg,
}, total=False)
class Record_30(Record):
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_38, UapItem_328, UapItem_87, UapItem_137, UapItem_207, UapItem_245, UapItem_308, UapItem_416, UapItem_432, UapItem_440, UapItem_359, UapItem_158, UapItem_385, UapItem_372, UapItem_411, UapItem_118, UapItem_229, UapItem_269, UapItem_283, UapItem_296, UapItem_425, UapItem_450, UapItem_183, UapItem_168, UapItem_199, UapItem_185, UapItem_543, UapItem_542]
    cv_items_dict = {"010": NonSpare_38, "140": NonSpare_328, "020": NonSpare_87, "040": NonSpare_137, "070": NonSpare_207, "090": NonSpare_245, "130": NonSpare_308, "220": NonSpare_416, "240": NonSpare_432, "250": NonSpare_440, "161": NonSpare_359, "042": NonSpare_158, "200": NonSpare_385, "170": NonSpare_372, "210": NonSpare_411, "030": NonSpare_118, "080": NonSpare_229, "100": NonSpare_269, "110": NonSpare_283, "120": NonSpare_296, "230": NonSpare_425, "260": NonSpare_450, "055": NonSpare_183, "050": NonSpare_168, "065": NonSpare_199, "060": NonSpare_185, "SP": NonSpare_1723, "RE": NonSpare_1558}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_38:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_328:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_87:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_137:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_245:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_308:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_416:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["240"]) -> NonSpare_432:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_440:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_359:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_385:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_372:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_411:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_118:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_229:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_269:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_283:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_296:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_425:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_450:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["055"]) -> NonSpare_183:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_168:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["065"]) -> NonSpare_199:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_185:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["140"], Literal["020"], Literal["040"], Literal["070"], Literal["090"], Literal["130"], Literal["220"], Literal["240"], Literal["250"], Literal["161"], Literal["042"], Literal["200"], Literal["170"], Literal["210"], Literal["030"], Literal["080"], Literal["100"], Literal["110"], Literal["120"], Literal["230"], Literal["260"], Literal["055"], Literal["050"], Literal["065"], Literal["060"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_38]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_328]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_87]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_137]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_207]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_245]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_308]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_416]:
        ...
    @overload
    def get_item(self, key : Literal["240"]) -> Optional[NonSpare_432]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_440]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_359]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_158]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_385]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_372]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_411]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_118]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_229]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_269]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_283]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_296]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_425]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_450]:
        ...
    @overload
    def get_item(self, key : Literal["055"]) -> Optional[NonSpare_183]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_168]:
        ...
    @overload
    def get_item(self, key : Literal["065"]) -> Optional[NonSpare_199]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_185]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_38_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_328_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_87_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_137_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_207_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_245_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_308_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_416_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["240"], val : NonSpare_432_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_440_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_359_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_158_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_385_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_372_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_411_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_118_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_229_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_269_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_283_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_296_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_425_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_450_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["055"], val : NonSpare_183_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_168_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["065"], val : NonSpare_199_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_185_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_30':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["240"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["055"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["065"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_30':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_30_Arg) -> 'Record_30':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_30", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_26_Arg: TypeAlias = Record_30
class Uap_26(UapSingle):
    cv_record = Record_30

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_30]]:
        return cls._parse(bs)

class Asterix_46(AstCat):
    cv_category = 48
    cv_edition = (1, 30)
    cv_uap = Uap_26

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_26_Arg]) -> "Asterix_46":
        return cls._create(records) # type: ignore

Content_10_Arg: TypeAlias = int
class Content_10(ContentTable):
    cv_values = {0: "ADSB not populated", 1: "ADSB populated"}

RuleContent_10_Arg: TypeAlias = Content_10_Arg
class RuleContent_10(RuleContentContextFree):
    cv_content = Content_10

    @property
    def content(self) -> Content_10:
        return self._get_content() # type: ignore

Variation_2_Arg: TypeAlias = RuleContent_10_Arg
class Variation_2(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_10

    @classmethod
    def create(cls, arg : Variation_2_Arg) -> "Variation_2":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_10:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_10:
        return self.rule.content

RuleVariation_2_Arg: TypeAlias = Variation_2_Arg
class RuleVariation_2(RuleVariationContextFree):
    cv_variation = Variation_2

    @classmethod
    def create(cls, arg : RuleVariation_2_Arg) -> "RuleVariation_2":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_2:
        return self.arg # type: ignore

NonSpare_929_Arg: TypeAlias = RuleVariation_2_Arg
class NonSpare_929(NonSpare):
    cv_name = "EP"
    cv_title = "ADSB Element Populated Bit"
    cv_rule = RuleVariation_2

    @classmethod
    def create(cls, arg : NonSpare_929_Arg) -> "NonSpare_929":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_2:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_2:
        return self.rule.variation

Item_296_Arg: TypeAlias = NonSpare_929_Arg
class Item_296(Item):
    cv_non_spare = NonSpare_929

    @classmethod
    def create(cls, arg : Item_296_Arg) -> "Item_296":
        return cls._create(arg) # type: ignore

Content_389_Arg: TypeAlias = int
class Content_389(ContentTable):
    cv_values = {0: "Not available", 1: "Available"}

RuleContent_389_Arg: TypeAlias = Content_389_Arg
class RuleContent_389(RuleContentContextFree):
    cv_content = Content_389

    @property
    def content(self) -> Content_389:
        return self._get_content() # type: ignore

Variation_443_Arg: TypeAlias = RuleContent_389_Arg
class Variation_443(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_389

    @classmethod
    def create(cls, arg : Variation_443_Arg) -> "Variation_443":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_389:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_389:
        return self.rule.content

RuleVariation_432_Arg: TypeAlias = Variation_443_Arg
class RuleVariation_432(RuleVariationContextFree):
    cv_variation = Variation_443

    @classmethod
    def create(cls, arg : RuleVariation_432_Arg) -> "RuleVariation_432":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_443:
        return self.arg # type: ignore

NonSpare_1991_Arg: TypeAlias = RuleVariation_432_Arg
class NonSpare_1991(NonSpare):
    cv_name = "VAL"
    cv_title = "On-Site ADS-B Information"
    cv_rule = RuleVariation_432

    @classmethod
    def create(cls, arg : NonSpare_1991_Arg) -> "NonSpare_1991":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_432:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_443:
        return self.rule.variation

Item_1107_Arg: TypeAlias = NonSpare_1991_Arg
class Item_1107(Item):
    cv_non_spare = NonSpare_1991

    @classmethod
    def create(cls, arg : Item_1107_Arg) -> "Item_1107":
        return cls._create(arg) # type: ignore

Variation_1086_Arg_Group = Tuple[Union[RuleVariation_2_Arg, Tuple[Literal["EP"], RuleVariation_2_Arg]], Union[RuleVariation_432_Arg, Tuple[Literal["VAL"], RuleVariation_432_Arg]]]
Variation_1086_Arg: TypeAlias = Union[int, Variation_1086_Arg_Group]
class Variation_1086(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_items_list = [(Item_296, 1), (Item_1107, 1)]
    cv_items_dict = {"EP": RuleVariation_2, "VAL": RuleVariation_432}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_2:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_432:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_2:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_432:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1086_Arg) -> 'Variation_1086':
        return cls._create(arg) # type: ignore

RuleVariation_1044_Arg: TypeAlias = Variation_1086_Arg
class RuleVariation_1044(RuleVariationContextFree):
    cv_variation = Variation_1086

    @classmethod
    def create(cls, arg : RuleVariation_1044_Arg) -> "RuleVariation_1044":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1086:
        return self.arg # type: ignore

Content_446_Arg: TypeAlias = int
class Content_446(ContentTable):
    cv_values = {0: "SCN not populated", 1: "SCN populated"}

RuleContent_446_Arg: TypeAlias = Content_446_Arg
class RuleContent_446(RuleContentContextFree):
    cv_content = Content_446

    @property
    def content(self) -> Content_446:
        return self._get_content() # type: ignore

Variation_572_Arg: TypeAlias = RuleContent_446_Arg
class Variation_572(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_446

    @classmethod
    def create(cls, arg : Variation_572_Arg) -> "Variation_572":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_446:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_446:
        return self.rule.content

RuleVariation_561_Arg: TypeAlias = Variation_572_Arg
class RuleVariation_561(RuleVariationContextFree):
    cv_variation = Variation_572

    @classmethod
    def create(cls, arg : RuleVariation_561_Arg) -> "RuleVariation_561":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_572:
        return self.arg # type: ignore

NonSpare_946_Arg: TypeAlias = RuleVariation_561_Arg
class NonSpare_946(NonSpare):
    cv_name = "EP"
    cv_title = "SCN Element Populated Bit"
    cv_rule = RuleVariation_561

    @classmethod
    def create(cls, arg : NonSpare_946_Arg) -> "NonSpare_946":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_561:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_572:
        return self.rule.variation

Item_313_Arg: TypeAlias = NonSpare_946_Arg
class Item_313(Item):
    cv_non_spare = NonSpare_946

    @classmethod
    def create(cls, arg : Item_313_Arg) -> "Item_313":
        return cls._create(arg) # type: ignore

Variation_654_Arg: TypeAlias = RuleContent_389_Arg
class Variation_654(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_389

    @classmethod
    def create(cls, arg : Variation_654_Arg) -> "Variation_654":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_389:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_389:
        return self.rule.content

RuleVariation_643_Arg: TypeAlias = Variation_654_Arg
class RuleVariation_643(RuleVariationContextFree):
    cv_variation = Variation_654

    @classmethod
    def create(cls, arg : RuleVariation_643_Arg) -> "RuleVariation_643":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_654:
        return self.arg # type: ignore

NonSpare_1996_Arg: TypeAlias = RuleVariation_643_Arg
class NonSpare_1996(NonSpare):
    cv_name = "VAL"
    cv_title = "Surveillance Cluster Network Information"
    cv_rule = RuleVariation_643

    @classmethod
    def create(cls, arg : NonSpare_1996_Arg) -> "NonSpare_1996":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_643:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_654:
        return self.rule.variation

Item_1112_Arg: TypeAlias = NonSpare_1996_Arg
class Item_1112(Item):
    cv_non_spare = NonSpare_1996

    @classmethod
    def create(cls, arg : Item_1112_Arg) -> "Item_1112":
        return cls._create(arg) # type: ignore

Variation_1319_Arg_Group = Tuple[Union[RuleVariation_561_Arg, Tuple[Literal["EP"], RuleVariation_561_Arg]], Union[RuleVariation_643_Arg, Tuple[Literal["VAL"], RuleVariation_643_Arg]]]
Variation_1319_Arg: TypeAlias = Union[int, Variation_1319_Arg_Group]
class Variation_1319(Group):
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_items_list = [(Item_313, 1), (Item_1112, 1)]
    cv_items_dict = {"EP": RuleVariation_561, "VAL": RuleVariation_643}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_561:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_643:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_561:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_643:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1319_Arg) -> 'Variation_1319':
        return cls._create(arg) # type: ignore

RuleVariation_1244_Arg: TypeAlias = Variation_1319_Arg
class RuleVariation_1244(RuleVariationContextFree):
    cv_variation = Variation_1319

    @classmethod
    def create(cls, arg : RuleVariation_1244_Arg) -> "RuleVariation_1244":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1319:
        return self.arg # type: ignore

Content_415_Arg: TypeAlias = int
class Content_415(ContentTable):
    cv_values = {0: "PAI not populated", 1: "PAI populated"}

RuleContent_415_Arg: TypeAlias = Content_415_Arg
class RuleContent_415(RuleContentContextFree):
    cv_content = Content_415

    @property
    def content(self) -> Content_415:
        return self._get_content() # type: ignore

Variation_742_Arg: TypeAlias = RuleContent_415_Arg
class Variation_742(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_415

    @classmethod
    def create(cls, arg : Variation_742_Arg) -> "Variation_742":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_415:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_415:
        return self.rule.content

RuleVariation_731_Arg: TypeAlias = Variation_742_Arg
class RuleVariation_731(RuleVariationContextFree):
    cv_variation = Variation_742

    @classmethod
    def create(cls, arg : RuleVariation_731_Arg) -> "RuleVariation_731":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_742:
        return self.arg # type: ignore

NonSpare_942_Arg: TypeAlias = RuleVariation_731_Arg
class NonSpare_942(NonSpare):
    cv_name = "EP"
    cv_title = "PAI Element Populated Bit"
    cv_rule = RuleVariation_731

    @classmethod
    def create(cls, arg : NonSpare_942_Arg) -> "NonSpare_942":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_731:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_742:
        return self.rule.variation

Item_309_Arg: TypeAlias = NonSpare_942_Arg
class Item_309(Item):
    cv_non_spare = NonSpare_942

    @classmethod
    def create(cls, arg : Item_309_Arg) -> "Item_309":
        return cls._create(arg) # type: ignore

Variation_862_Arg: TypeAlias = RuleContent_389_Arg
class Variation_862(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_389

    @classmethod
    def create(cls, arg : Variation_862_Arg) -> "Variation_862":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_389:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_389:
        return self.rule.content

RuleVariation_832_Arg: TypeAlias = Variation_862_Arg
class RuleVariation_832(RuleVariationContextFree):
    cv_variation = Variation_862

    @classmethod
    def create(cls, arg : RuleVariation_832_Arg) -> "RuleVariation_832":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_862:
        return self.arg # type: ignore

NonSpare_1994_Arg: TypeAlias = RuleVariation_832_Arg
class NonSpare_1994(NonSpare):
    cv_name = "VAL"
    cv_title = "Passive Acquisition Interface Information"
    cv_rule = RuleVariation_832

    @classmethod
    def create(cls, arg : NonSpare_1994_Arg) -> "NonSpare_1994":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_832:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_862:
        return self.rule.variation

Item_1110_Arg: TypeAlias = NonSpare_1994_Arg
class Item_1110(Item):
    cv_non_spare = NonSpare_1994

    @classmethod
    def create(cls, arg : Item_1110_Arg) -> "Item_1110":
        return cls._create(arg) # type: ignore

Variation_1328_Arg_Group = Tuple[Union[RuleVariation_731_Arg, Tuple[Literal["EP"], RuleVariation_731_Arg]], Union[RuleVariation_832_Arg, Tuple[Literal["VAL"], RuleVariation_832_Arg]]]
Variation_1328_Arg: TypeAlias = Union[int, Variation_1328_Arg_Group]
class Variation_1328(Group):
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_items_list = [(Item_309, 1), (Item_1110, 1)]
    cv_items_dict = {"EP": RuleVariation_731, "VAL": RuleVariation_832}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_731:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_832:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_731:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_832:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1328_Arg) -> 'Variation_1328':
        return cls._create(arg) # type: ignore

RuleVariation_1253_Arg: TypeAlias = Variation_1328_Arg
class RuleVariation_1253(RuleVariationContextFree):
    cv_variation = Variation_1328

    @classmethod
    def create(cls, arg : RuleVariation_1253_Arg) -> "RuleVariation_1253":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1328:
        return self.arg # type: ignore

NonSpare_573_Arg: TypeAlias = RuleVariation_1044_Arg
class NonSpare_573(NonSpare):
    cv_name = "ADSB"
    cv_title = "On-Site ADS-B Information"
    cv_rule = RuleVariation_1044

    @classmethod
    def create(cls, arg : NonSpare_573_Arg) -> "NonSpare_573":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1044:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1086:
        return self.rule.variation

Item_48_Arg: TypeAlias = NonSpare_573_Arg
class Item_48(Item):
    cv_non_spare = NonSpare_573

    @classmethod
    def create(cls, arg : Item_48_Arg) -> "Item_48":
        return cls._create(arg) # type: ignore

NonSpare_1660_Arg: TypeAlias = RuleVariation_1244_Arg
class NonSpare_1660(NonSpare):
    cv_name = "SCN"
    cv_title = "Surveillance Cluster Network Information"
    cv_rule = RuleVariation_1244

    @classmethod
    def create(cls, arg : NonSpare_1660_Arg) -> "NonSpare_1660":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1319:
        return self.rule.variation

Item_861_Arg: TypeAlias = NonSpare_1660_Arg
class Item_861(Item):
    cv_non_spare = NonSpare_1660

    @classmethod
    def create(cls, arg : Item_861_Arg) -> "Item_861":
        return cls._create(arg) # type: ignore

NonSpare_1410_Arg: TypeAlias = RuleVariation_1253_Arg
class NonSpare_1410(NonSpare):
    cv_name = "PAI"
    cv_title = "Passive Acquisition Interface Information"
    cv_rule = RuleVariation_1253

    @classmethod
    def create(cls, arg : NonSpare_1410_Arg) -> "NonSpare_1410":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1253:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1328:
        return self.rule.variation

Item_673_Arg: TypeAlias = NonSpare_1410_Arg
class Item_673(Item):
    cv_non_spare = NonSpare_1410

    @classmethod
    def create(cls, arg : Item_673_Arg) -> "Item_673":
        return cls._create(arg) # type: ignore

Variation_1382_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_126_Arg, Tuple[Literal["TYP"], RuleVariation_126_Arg]], Union[RuleVariation_601_Arg, Tuple[Literal["SIM"], RuleVariation_601_Arg]], Union[RuleVariation_734_Arg, Tuple[Literal["RDP"], RuleVariation_734_Arg]], Union[RuleVariation_786_Arg, Tuple[Literal["SPI"], RuleVariation_786_Arg]], Union[RuleVariation_915_Arg, Tuple[Literal["RAB"], RuleVariation_915_Arg]], None]]
Variation_1382_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_72_Arg, Tuple[Literal["TST"], RuleVariation_72_Arg]], Union[RuleVariation_427_Arg, Tuple[Literal["ERR"], RuleVariation_427_Arg]], Union[RuleVariation_545_Arg, Tuple[Literal["XPP"], RuleVariation_545_Arg]], Union[RuleVariation_639_Arg, Tuple[Literal["ME"], RuleVariation_639_Arg]], Union[RuleVariation_727_Arg, Tuple[Literal["MI"], RuleVariation_727_Arg]], Union[RuleVariation_847_Arg, Tuple[Literal["FOEFRI"], RuleVariation_847_Arg]], None]]
Variation_1382_Arg_Group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_1044_Arg, Tuple[Literal["ADSB"], RuleVariation_1044_Arg]], Union[RuleVariation_1244_Arg, Tuple[Literal["SCN"], RuleVariation_1244_Arg]], Union[RuleVariation_1253_Arg, Tuple[Literal["PAI"], RuleVariation_1253_Arg]], int, None]]
Variation_1382_Arg: TypeAlias = Union[
    Tuple[Variation_1382_Arg_Group_1],
    Tuple[Variation_1382_Arg_Group_1, Variation_1382_Arg_Group_2],
    Tuple[Variation_1382_Arg_Group_1, Variation_1382_Arg_Group_2, Variation_1382_Arg_Group_3],
]
class Variation_1382(Extended):
    cv_items_list = [[(Item_1070, 3), (Item_898, 1), (Item_783, 1), (Item_909, 1), (Item_766, 1), None], [(Item_1048, 1), (Item_316, 1), (Item_1215, 1), (Item_541, 1), (Item_548, 1), (Item_332, 2), None], [(Item_48, 2), (Item_861, 2), (Item_673, 2), (Item_26, 1), None]]

    @classmethod
    def create(cls, arg : Variation_1382_Arg) -> 'Variation_1382':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_126:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> RuleVariation_601:
        ...
    @overload
    def get_item(self, key : Literal["RDP"]) -> RuleVariation_734:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> RuleVariation_786:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_915:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_72]:
        ...
    @overload
    def get_item(self, key : Literal["ERR"]) -> Optional[RuleVariation_427]:
        ...
    @overload
    def get_item(self, key : Literal["XPP"]) -> Optional[RuleVariation_545]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_639]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_727]:
        ...
    @overload
    def get_item(self, key : Literal["FOEFRI"]) -> Optional[RuleVariation_847]:
        ...
    @overload
    def get_item(self, key : Literal["ADSB"]) -> Optional[RuleVariation_1044]:
        ...
    @overload
    def get_item(self, key : Literal["SCN"]) -> Optional[RuleVariation_1244]:
        ...
    @overload
    def get_item(self, key : Literal["PAI"]) -> Optional[RuleVariation_1253]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1305_Arg: TypeAlias = Variation_1382_Arg
class RuleVariation_1305(RuleVariationContextFree):
    cv_variation = Variation_1382

    @classmethod
    def create(cls, arg : RuleVariation_1305_Arg) -> "RuleVariation_1305":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1382:
        return self.arg # type: ignore

NonSpare_88_Arg: TypeAlias = RuleVariation_1305_Arg
class NonSpare_88(NonSpare):
    cv_name = "020"
    cv_title = "Target Report Descriptor"
    cv_rule = RuleVariation_1305

    @classmethod
    def create(cls, arg : NonSpare_88_Arg) -> "NonSpare_88":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1305:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1382:
        return self.rule.variation

class UapItem_88(UapItem):
    cv_non_spare = NonSpare_88

Content_393_Arg: TypeAlias = int
class Content_393(ContentTable):
    cv_values = {0: "Not defined; never used", 1: "Multipath Reply (Reflection)", 2: "Reply due to sidelobe interrogation/reception", 3: "Split plot", 4: "Second time around reply", 5: "Angel", 6: "Slow moving target correlated with road infrastructure (terrestrial vehicle)", 7: "Fixed PSR plot", 8: "Slow PSR target", 9: "Low quality PSR plot", 10: "Phantom SSR plot", 11: "Non-Matching Mode-3/A Code", 12: "Mode C code / Mode S altitude code abnormal value compared to the track", 13: "Target in Clutter Area", 14: "Maximum Doppler Response in Zero Filter", 15: "Transponder anomaly detected", 16: "Duplicated or Illegal Mode S Aircraft Address", 17: "Mode S error correction applied", 18: "Undecodable Mode C code / Mode S altitude code", 19: "Birds", 20: "Flock of Birds", 21: "Mode-1 was present in original reply", 22: "Mode-2 was present in original reply", 23: "Plot potentially caused by Wind Turbine", 24: "Helicopter", 25: "Maximum number of re-interrogations reached (surveillance information)", 26: "Maximum number of re-interrogations reached (BDS Extractions)", 27: "BDS Overlay Incoherence", 28: "Potential BDS Swap Detected", 29: "Track Update in the Zenithal Gap", 30: "Mode S Track re-acquired", 31: "Duplicated Mode 5 Pair NO/PIN detected", 32: "Wrong DF reply format detected", 33: "Transponder anomaly (MS XPD replies with Mode A/C to Mode A/C-only all-call)", 34: "Transponder anomaly (SI capability report wrong)", 35: "Potential IC Conflict", 36: "IC Conflict detection possible-no conflict currently detected"}

RuleContent_393_Arg: TypeAlias = Content_393_Arg
class RuleContent_393(RuleContentContextFree):
    cv_content = Content_393

    @property
    def content(self) -> Content_393:
        return self._get_content() # type: ignore

Variation_154_Arg: TypeAlias = RuleContent_393_Arg
class Variation_154(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_393

    @classmethod
    def create(cls, arg : Variation_154_Arg) -> "Variation_154":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_393:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_393:
        return self.rule.content

Variation_1450_Arg: TypeAlias = List[Variation_154_Arg]
class Variation_1450(Repetitive):
    cv_rep_bytes = None
    cv_variation = Variation_154

    @classmethod
    def create(cls, arg : Variation_1450_Arg) -> 'Variation_1450':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_154]:
        return self._get_list() # type: ignore

RuleVariation_1373_Arg: TypeAlias = Variation_1450_Arg
class RuleVariation_1373(RuleVariationContextFree):
    cv_variation = Variation_1450

    @classmethod
    def create(cls, arg : RuleVariation_1373_Arg) -> "RuleVariation_1373":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1450:
        return self.arg # type: ignore

NonSpare_119_Arg: TypeAlias = RuleVariation_1373_Arg
class NonSpare_119(NonSpare):
    cv_name = "030"
    cv_title = "Warning/Error Conditions and Target Classification"
    cv_rule = RuleVariation_1373

    @classmethod
    def create(cls, arg : NonSpare_119_Arg) -> "NonSpare_119":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1373:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1450:
        return self.rule.variation

class UapItem_119(UapItem):
    cv_non_spare = NonSpare_119

NonSpare_297_Arg: TypeAlias = RuleVariation_1392_Arg
class NonSpare_297(NonSpare):
    cv_name = "120"
    cv_title = "Radial Doppler Speed"
    cv_rule = RuleVariation_1392

    @classmethod
    def create(cls, arg : NonSpare_297_Arg) -> "NonSpare_297":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1392:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1469:
        return self.rule.variation

class UapItem_297(UapItem):
    cv_non_spare = NonSpare_297

Record_31_Arg = TypedDict('Record_31_Arg', {
    "010": NonSpare_38_Arg,
    "140": NonSpare_328_Arg,
    "020": NonSpare_88_Arg,
    "040": NonSpare_137_Arg,
    "070": NonSpare_207_Arg,
    "090": NonSpare_245_Arg,
    "130": NonSpare_308_Arg,
    "220": NonSpare_416_Arg,
    "240": NonSpare_432_Arg,
    "250": NonSpare_440_Arg,
    "161": NonSpare_359_Arg,
    "042": NonSpare_158_Arg,
    "200": NonSpare_385_Arg,
    "170": NonSpare_372_Arg,
    "210": NonSpare_411_Arg,
    "030": NonSpare_119_Arg,
    "080": NonSpare_229_Arg,
    "100": NonSpare_269_Arg,
    "110": NonSpare_283_Arg,
    "120": NonSpare_297_Arg,
    "230": NonSpare_425_Arg,
    "260": NonSpare_450_Arg,
    "055": NonSpare_183_Arg,
    "050": NonSpare_168_Arg,
    "065": NonSpare_199_Arg,
    "060": NonSpare_185_Arg,
    "SP": NonSpare_1723_Arg,
    "RE": NonSpare_1558_Arg,
}, total=False)
class Record_31(Record):
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_38, UapItem_328, UapItem_88, UapItem_137, UapItem_207, UapItem_245, UapItem_308, UapItem_416, UapItem_432, UapItem_440, UapItem_359, UapItem_158, UapItem_385, UapItem_372, UapItem_411, UapItem_119, UapItem_229, UapItem_269, UapItem_283, UapItem_297, UapItem_425, UapItem_450, UapItem_183, UapItem_168, UapItem_199, UapItem_185, UapItem_543, UapItem_542]
    cv_items_dict = {"010": NonSpare_38, "140": NonSpare_328, "020": NonSpare_88, "040": NonSpare_137, "070": NonSpare_207, "090": NonSpare_245, "130": NonSpare_308, "220": NonSpare_416, "240": NonSpare_432, "250": NonSpare_440, "161": NonSpare_359, "042": NonSpare_158, "200": NonSpare_385, "170": NonSpare_372, "210": NonSpare_411, "030": NonSpare_119, "080": NonSpare_229, "100": NonSpare_269, "110": NonSpare_283, "120": NonSpare_297, "230": NonSpare_425, "260": NonSpare_450, "055": NonSpare_183, "050": NonSpare_168, "065": NonSpare_199, "060": NonSpare_185, "SP": NonSpare_1723, "RE": NonSpare_1558}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_38:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_328:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_88:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_137:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_245:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_308:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_416:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["240"]) -> NonSpare_432:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_440:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_359:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_385:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_372:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_411:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_119:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_229:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_269:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_283:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_297:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_425:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_450:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["055"]) -> NonSpare_183:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_168:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["065"]) -> NonSpare_199:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_185:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["140"], Literal["020"], Literal["040"], Literal["070"], Literal["090"], Literal["130"], Literal["220"], Literal["240"], Literal["250"], Literal["161"], Literal["042"], Literal["200"], Literal["170"], Literal["210"], Literal["030"], Literal["080"], Literal["100"], Literal["110"], Literal["120"], Literal["230"], Literal["260"], Literal["055"], Literal["050"], Literal["065"], Literal["060"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_38]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_328]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_88]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_137]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_207]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_245]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_308]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_416]:
        ...
    @overload
    def get_item(self, key : Literal["240"]) -> Optional[NonSpare_432]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_440]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_359]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_158]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_385]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_372]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_411]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_119]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_229]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_269]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_283]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_297]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_425]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_450]:
        ...
    @overload
    def get_item(self, key : Literal["055"]) -> Optional[NonSpare_183]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_168]:
        ...
    @overload
    def get_item(self, key : Literal["065"]) -> Optional[NonSpare_199]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_185]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_38_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_328_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_88_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_137_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_207_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_245_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_308_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_416_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["240"], val : NonSpare_432_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_440_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_359_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_158_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_385_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_372_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_411_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_119_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_229_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_269_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_283_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_297_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_425_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_450_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["055"], val : NonSpare_183_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_168_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["065"], val : NonSpare_199_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_185_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_31':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["240"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["055"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["065"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_31':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_31_Arg) -> 'Record_31':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_31", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_27_Arg: TypeAlias = Record_31
class Uap_27(UapSingle):
    cv_record = Record_31

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_31]]:
        return cls._parse(bs)

class Asterix_47(AstCat):
    cv_category = 48
    cv_edition = (1, 31)
    cv_uap = Uap_27

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_27_Arg]) -> "Asterix_47":
        return cls._create(records) # type: ignore

Content_8_Arg: TypeAlias = int
class Content_8(ContentTable):
    cv_values = {0: "ACASXV not populated", 1: "ACASXV populated"}

RuleContent_8_Arg: TypeAlias = Content_8_Arg
class RuleContent_8(RuleContentContextFree):
    cv_content = Content_8

    @property
    def content(self) -> Content_8:
        return self._get_content() # type: ignore

Variation_1_Arg: TypeAlias = RuleContent_8_Arg
class Variation_1(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_8

    @classmethod
    def create(cls, arg : Variation_1_Arg) -> "Variation_1":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_8:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_8:
        return self.rule.content

RuleVariation_1_Arg: TypeAlias = Variation_1_Arg
class RuleVariation_1(RuleVariationContextFree):
    cv_variation = Variation_1

    @classmethod
    def create(cls, arg : RuleVariation_1_Arg) -> "RuleVariation_1":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1:
        return self.arg # type: ignore

NonSpare_928_Arg: TypeAlias = RuleVariation_1_Arg
class NonSpare_928(NonSpare):
    cv_name = "EP"
    cv_title = "ACASXV Element Populated Bit"
    cv_rule = RuleVariation_1

    @classmethod
    def create(cls, arg : NonSpare_928_Arg) -> "NonSpare_928":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1:
        return self.rule.variation

Item_295_Arg: TypeAlias = NonSpare_928_Arg
class Item_295(Item):
    cv_non_spare = NonSpare_928

    @classmethod
    def create(cls, arg : Item_295_Arg) -> "Item_295":
        return cls._create(arg) # type: ignore

Content_378_Arg: TypeAlias = int
class Content_378(ContentTable):
    cv_values = {0: "Non-Extended Version", 1: "ACAS Xa Version 1", 2: "ACAS Xu Version 1"}

RuleContent_378_Arg: TypeAlias = Content_378_Arg
class RuleContent_378(RuleContentContextFree):
    cv_content = Content_378

    @property
    def content(self) -> Content_378:
        return self._get_content() # type: ignore

Variation_486_Arg: TypeAlias = RuleContent_378_Arg
class Variation_486(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 4
    cv_rule = RuleContent_378

    @classmethod
    def create(cls, arg : Variation_486_Arg) -> "Variation_486":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_378:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_378:
        return self.rule.content

RuleVariation_475_Arg: TypeAlias = Variation_486_Arg
class RuleVariation_475(RuleVariationContextFree):
    cv_variation = Variation_486

    @classmethod
    def create(cls, arg : RuleVariation_475_Arg) -> "RuleVariation_475":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_486:
        return self.arg # type: ignore

NonSpare_1986_Arg: TypeAlias = RuleVariation_475_Arg
class NonSpare_1986(NonSpare):
    cv_name = "VAL"
    cv_title = "ACAS Extended Version Value"
    cv_rule = RuleVariation_475

    @classmethod
    def create(cls, arg : NonSpare_1986_Arg) -> "NonSpare_1986":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_475:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_486:
        return self.rule.variation

Item_1102_Arg: TypeAlias = NonSpare_1986_Arg
class Item_1102(Item):
    cv_non_spare = NonSpare_1986

    @classmethod
    def create(cls, arg : Item_1102_Arg) -> "Item_1102":
        return cls._create(arg) # type: ignore

Variation_1085_Arg_Group = Tuple[Union[RuleVariation_1_Arg, Tuple[Literal["EP"], RuleVariation_1_Arg]], Union[RuleVariation_475_Arg, Tuple[Literal["VAL"], RuleVariation_475_Arg]]]
Variation_1085_Arg: TypeAlias = Union[int, Variation_1085_Arg_Group]
class Variation_1085(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 5
    cv_items_list = [(Item_295, 1), (Item_1102, 4)]
    cv_items_dict = {"EP": RuleVariation_1, "VAL": RuleVariation_475}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_1:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_475:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_1:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_475:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1085_Arg) -> 'Variation_1085':
        return cls._create(arg) # type: ignore

RuleVariation_1043_Arg: TypeAlias = Variation_1085_Arg
class RuleVariation_1043(RuleVariationContextFree):
    cv_variation = Variation_1085

    @classmethod
    def create(cls, arg : RuleVariation_1043_Arg) -> "RuleVariation_1043":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1085:
        return self.arg # type: ignore

Content_419_Arg: TypeAlias = int
class Content_419(ContentTable):
    cv_values = {0: "POXPR not populated", 1: "POXPR populated"}

RuleContent_419_Arg: TypeAlias = Content_419_Arg
class RuleContent_419(RuleContentContextFree):
    cv_content = Content_419

    @property
    def content(self) -> Content_419:
        return self._get_content() # type: ignore

Variation_866_Arg: TypeAlias = RuleContent_419_Arg
class Variation_866(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_419

    @classmethod
    def create(cls, arg : Variation_866_Arg) -> "Variation_866":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_419:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_419:
        return self.rule.content

RuleVariation_836_Arg: TypeAlias = Variation_866_Arg
class RuleVariation_836(RuleVariationContextFree):
    cv_variation = Variation_866

    @classmethod
    def create(cls, arg : RuleVariation_836_Arg) -> "RuleVariation_836":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_866:
        return self.arg # type: ignore

NonSpare_944_Arg: TypeAlias = RuleVariation_836_Arg
class NonSpare_944(NonSpare):
    cv_name = "EP"
    cv_title = "POXPR Element Populated Bit"
    cv_rule = RuleVariation_836

    @classmethod
    def create(cls, arg : NonSpare_944_Arg) -> "NonSpare_944":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_836:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_866:
        return self.rule.variation

Item_311_Arg: TypeAlias = NonSpare_944_Arg
class Item_311(Item):
    cv_non_spare = NonSpare_944

    @classmethod
    def create(cls, arg : Item_311_Arg) -> "Item_311":
        return cls._create(arg) # type: ignore

Content_417_Arg: TypeAlias = int
class Content_417(ContentTable):
    cv_values = {0: "PO not supported (PPM only)", 1: "PO supported"}

RuleContent_417_Arg: TypeAlias = Content_417_Arg
class RuleContent_417(RuleContentContextFree):
    cv_content = Content_417

    @property
    def content(self) -> Content_417:
        return self._get_content() # type: ignore

Variation_942_Arg: TypeAlias = RuleContent_417_Arg
class Variation_942(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_417

    @classmethod
    def create(cls, arg : Variation_942_Arg) -> "Variation_942":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_417:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_417:
        return self.rule.content

RuleVariation_912_Arg: TypeAlias = Variation_942_Arg
class RuleVariation_912(RuleVariationContextFree):
    cv_variation = Variation_942

    @classmethod
    def create(cls, arg : RuleVariation_912_Arg) -> "RuleVariation_912":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_942:
        return self.arg # type: ignore

NonSpare_1992_Arg: TypeAlias = RuleVariation_912_Arg
class NonSpare_1992(NonSpare):
    cv_name = "VAL"
    cv_title = "PO Transpomder Capability"
    cv_rule = RuleVariation_912

    @classmethod
    def create(cls, arg : NonSpare_1992_Arg) -> "NonSpare_1992":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_912:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_942:
        return self.rule.variation

Item_1108_Arg: TypeAlias = NonSpare_1992_Arg
class Item_1108(Item):
    cv_non_spare = NonSpare_1992

    @classmethod
    def create(cls, arg : Item_1108_Arg) -> "Item_1108":
        return cls._create(arg) # type: ignore

Variation_1334_Arg_Group = Tuple[Union[RuleVariation_836_Arg, Tuple[Literal["EP"], RuleVariation_836_Arg]], Union[RuleVariation_912_Arg, Tuple[Literal["VAL"], RuleVariation_912_Arg]]]
Variation_1334_Arg: TypeAlias = Union[int, Variation_1334_Arg_Group]
class Variation_1334(Group):
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_items_list = [(Item_311, 1), (Item_1108, 1)]
    cv_items_dict = {"EP": RuleVariation_836, "VAL": RuleVariation_912}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_836:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_912:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_836:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_912:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1334_Arg) -> 'Variation_1334':
        return cls._create(arg) # type: ignore

RuleVariation_1257_Arg: TypeAlias = Variation_1334_Arg
class RuleVariation_1257(RuleVariationContextFree):
    cv_variation = Variation_1334

    @classmethod
    def create(cls, arg : RuleVariation_1257_Arg) -> "RuleVariation_1257":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1334:
        return self.arg # type: ignore

Content_418_Arg: TypeAlias = int
class Content_418(ContentTable):
    cv_values = {0: "POACT not populated", 1: "POACT populated"}

RuleContent_418_Arg: TypeAlias = Content_418_Arg
class RuleContent_418(RuleContentContextFree):
    cv_content = Content_418

    @property
    def content(self) -> Content_418:
        return self._get_content() # type: ignore

Variation_69_Arg: TypeAlias = RuleContent_418_Arg
class Variation_69(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_418

    @classmethod
    def create(cls, arg : Variation_69_Arg) -> "Variation_69":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_418:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_418:
        return self.rule.content

RuleVariation_69_Arg: TypeAlias = Variation_69_Arg
class RuleVariation_69(RuleVariationContextFree):
    cv_variation = Variation_69

    @classmethod
    def create(cls, arg : RuleVariation_69_Arg) -> "RuleVariation_69":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_69:
        return self.arg # type: ignore

NonSpare_943_Arg: TypeAlias = RuleVariation_69_Arg
class NonSpare_943(NonSpare):
    cv_name = "EP"
    cv_title = "POACT Element Populated Bit"
    cv_rule = RuleVariation_69

    @classmethod
    def create(cls, arg : NonSpare_943_Arg) -> "NonSpare_943":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_69:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_69:
        return self.rule.variation

Item_310_Arg: TypeAlias = NonSpare_943_Arg
class Item_310(Item):
    cv_non_spare = NonSpare_943

    @classmethod
    def create(cls, arg : Item_310_Arg) -> "Item_310":
        return cls._create(arg) # type: ignore

Content_416_Arg: TypeAlias = int
class Content_416(ContentTable):
    cv_values = {0: "PO not active", 1: "PO active"}

RuleContent_416_Arg: TypeAlias = Content_416_Arg
class RuleContent_416(RuleContentContextFree):
    cv_content = Content_416

    @property
    def content(self) -> Content_416:
        return self._get_content() # type: ignore

Variation_446_Arg: TypeAlias = RuleContent_416_Arg
class Variation_446(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_416

    @classmethod
    def create(cls, arg : Variation_446_Arg) -> "Variation_446":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_416:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_416:
        return self.rule.content

RuleVariation_435_Arg: TypeAlias = Variation_446_Arg
class RuleVariation_435(RuleVariationContextFree):
    cv_variation = Variation_446

    @classmethod
    def create(cls, arg : RuleVariation_435_Arg) -> "RuleVariation_435":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_446:
        return self.arg # type: ignore

NonSpare_1993_Arg: TypeAlias = RuleVariation_435_Arg
class NonSpare_1993(NonSpare):
    cv_name = "VAL"
    cv_title = "POACT Active for Current Plot"
    cv_rule = RuleVariation_435

    @classmethod
    def create(cls, arg : NonSpare_1993_Arg) -> "NonSpare_1993":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_435:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_446:
        return self.rule.variation

Item_1109_Arg: TypeAlias = NonSpare_1993_Arg
class Item_1109(Item):
    cv_non_spare = NonSpare_1993

    @classmethod
    def create(cls, arg : Item_1109_Arg) -> "Item_1109":
        return cls._create(arg) # type: ignore

Variation_1097_Arg_Group = Tuple[Union[RuleVariation_69_Arg, Tuple[Literal["EP"], RuleVariation_69_Arg]], Union[RuleVariation_435_Arg, Tuple[Literal["VAL"], RuleVariation_435_Arg]]]
Variation_1097_Arg: TypeAlias = Union[int, Variation_1097_Arg_Group]
class Variation_1097(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_items_list = [(Item_310, 1), (Item_1109, 1)]
    cv_items_dict = {"EP": RuleVariation_69, "VAL": RuleVariation_435}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_69:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_435:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_69:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_435:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1097_Arg) -> 'Variation_1097':
        return cls._create(arg) # type: ignore

RuleVariation_1055_Arg: TypeAlias = Variation_1097_Arg
class RuleVariation_1055(RuleVariationContextFree):
    cv_variation = Variation_1097

    @classmethod
    def create(cls, arg : RuleVariation_1055_Arg) -> "RuleVariation_1055":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1097:
        return self.arg # type: ignore

Content_75_Arg: TypeAlias = int
class Content_75(ContentTable):
    cv_values = {0: "DTFXPR not populated", 1: "DTFXPR populated"}

RuleContent_75_Arg: TypeAlias = Content_75_Arg
class RuleContent_75(RuleContentContextFree):
    cv_content = Content_75

    @property
    def content(self) -> Content_75:
        return self._get_content() # type: ignore

Variation_510_Arg: TypeAlias = RuleContent_75_Arg
class Variation_510(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_75

    @classmethod
    def create(cls, arg : Variation_510_Arg) -> "Variation_510":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_75:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_75:
        return self.rule.content

RuleVariation_499_Arg: TypeAlias = Variation_510_Arg
class RuleVariation_499(RuleVariationContextFree):
    cv_variation = Variation_510

    @classmethod
    def create(cls, arg : RuleVariation_499_Arg) -> "RuleVariation_499":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_510:
        return self.arg # type: ignore

NonSpare_931_Arg: TypeAlias = RuleVariation_499_Arg
class NonSpare_931(NonSpare):
    cv_name = "EP"
    cv_title = "DTFXPR Element Populated Bit"
    cv_rule = RuleVariation_499

    @classmethod
    def create(cls, arg : NonSpare_931_Arg) -> "NonSpare_931":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_499:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_510:
        return self.rule.variation

Item_298_Arg: TypeAlias = NonSpare_931_Arg
class Item_298(Item):
    cv_non_spare = NonSpare_931

    @classmethod
    def create(cls, arg : Item_298_Arg) -> "Item_298":
        return cls._create(arg) # type: ignore

Content_47_Arg: TypeAlias = int
class Content_47(ContentTable):
    cv_values = {0: "Basic Dataflash not supported", 1: "Basic Dataflash supported"}

RuleContent_47_Arg: TypeAlias = Content_47_Arg
class RuleContent_47(RuleContentContextFree):
    cv_content = Content_47

    @property
    def content(self) -> Content_47:
        return self._get_content() # type: ignore

Variation_616_Arg: TypeAlias = RuleContent_47_Arg
class Variation_616(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_47

    @classmethod
    def create(cls, arg : Variation_616_Arg) -> "Variation_616":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_47:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_47:
        return self.rule.content

RuleVariation_605_Arg: TypeAlias = Variation_616_Arg
class RuleVariation_605(RuleVariationContextFree):
    cv_variation = Variation_616

    @classmethod
    def create(cls, arg : RuleVariation_605_Arg) -> "RuleVariation_605":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_616:
        return self.arg # type: ignore

NonSpare_1987_Arg: TypeAlias = RuleVariation_605_Arg
class NonSpare_1987(NonSpare):
    cv_name = "VAL"
    cv_title = "Basic Dataflash Transponder Capability"
    cv_rule = RuleVariation_605

    @classmethod
    def create(cls, arg : NonSpare_1987_Arg) -> "NonSpare_1987":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_605:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_616:
        return self.rule.variation

Item_1103_Arg: TypeAlias = NonSpare_1987_Arg
class Item_1103(Item):
    cv_non_spare = NonSpare_1987

    @classmethod
    def create(cls, arg : Item_1103_Arg) -> "Item_1103":
        return cls._create(arg) # type: ignore

Variation_1316_Arg_Group = Tuple[Union[RuleVariation_499_Arg, Tuple[Literal["EP"], RuleVariation_499_Arg]], Union[RuleVariation_605_Arg, Tuple[Literal["VAL"], RuleVariation_605_Arg]]]
Variation_1316_Arg: TypeAlias = Union[int, Variation_1316_Arg_Group]
class Variation_1316(Group):
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_items_list = [(Item_298, 1), (Item_1103, 1)]
    cv_items_dict = {"EP": RuleVariation_499, "VAL": RuleVariation_605}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_499:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_605:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_499:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_605:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1316_Arg) -> 'Variation_1316':
        return cls._create(arg) # type: ignore

RuleVariation_1241_Arg: TypeAlias = Variation_1316_Arg
class RuleVariation_1241(RuleVariationContextFree):
    cv_variation = Variation_1316

    @classmethod
    def create(cls, arg : RuleVariation_1241_Arg) -> "RuleVariation_1241":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1316:
        return self.arg # type: ignore

Content_74_Arg: TypeAlias = int
class Content_74(ContentTable):
    cv_values = {0: "DTFACT not populated", 1: "DTFACT populated"}

RuleContent_74_Arg: TypeAlias = Content_74_Arg
class RuleContent_74(RuleContentContextFree):
    cv_content = Content_74

    @property
    def content(self) -> Content_74:
        return self._get_content() # type: ignore

Variation_701_Arg: TypeAlias = RuleContent_74_Arg
class Variation_701(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_74

    @classmethod
    def create(cls, arg : Variation_701_Arg) -> "Variation_701":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_74:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_74:
        return self.rule.content

RuleVariation_690_Arg: TypeAlias = Variation_701_Arg
class RuleVariation_690(RuleVariationContextFree):
    cv_variation = Variation_701

    @classmethod
    def create(cls, arg : RuleVariation_690_Arg) -> "RuleVariation_690":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_701:
        return self.arg # type: ignore

NonSpare_930_Arg: TypeAlias = RuleVariation_690_Arg
class NonSpare_930(NonSpare):
    cv_name = "EP"
    cv_title = "DTFACT Element Populated Bit"
    cv_rule = RuleVariation_690

    @classmethod
    def create(cls, arg : NonSpare_930_Arg) -> "NonSpare_930":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_690:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_701:
        return self.rule.variation

Item_297_Arg: TypeAlias = NonSpare_930_Arg
class Item_297(Item):
    cv_non_spare = NonSpare_930

    @classmethod
    def create(cls, arg : Item_297_Arg) -> "Item_297":
        return cls._create(arg) # type: ignore

Content_46_Arg: TypeAlias = int
class Content_46(ContentTable):
    cv_values = {0: "Basic Dataflash not active", 1: "Basic Dataflash active"}

RuleContent_46_Arg: TypeAlias = Content_46_Arg
class RuleContent_46(RuleContentContextFree):
    cv_content = Content_46

    @property
    def content(self) -> Content_46:
        return self._get_content() # type: ignore

Variation_821_Arg: TypeAlias = RuleContent_46_Arg
class Variation_821(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_46

    @classmethod
    def create(cls, arg : Variation_821_Arg) -> "Variation_821":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_46:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_46:
        return self.rule.content

RuleVariation_791_Arg: TypeAlias = Variation_821_Arg
class RuleVariation_791(RuleVariationContextFree):
    cv_variation = Variation_821

    @classmethod
    def create(cls, arg : RuleVariation_791_Arg) -> "RuleVariation_791":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_821:
        return self.arg # type: ignore

NonSpare_1988_Arg: TypeAlias = RuleVariation_791_Arg
class NonSpare_1988(NonSpare):
    cv_name = "VAL"
    cv_title = "Basic Dataflash in Current Plot"
    cv_rule = RuleVariation_791

    @classmethod
    def create(cls, arg : NonSpare_1988_Arg) -> "NonSpare_1988":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_791:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_821:
        return self.rule.variation

Item_1104_Arg: TypeAlias = NonSpare_1988_Arg
class Item_1104(Item):
    cv_non_spare = NonSpare_1988

    @classmethod
    def create(cls, arg : Item_1104_Arg) -> "Item_1104":
        return cls._create(arg) # type: ignore

Variation_1325_Arg_Group = Tuple[Union[RuleVariation_690_Arg, Tuple[Literal["EP"], RuleVariation_690_Arg]], Union[RuleVariation_791_Arg, Tuple[Literal["VAL"], RuleVariation_791_Arg]]]
Variation_1325_Arg: TypeAlias = Union[int, Variation_1325_Arg_Group]
class Variation_1325(Group):
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_items_list = [(Item_297, 1), (Item_1104, 1)]
    cv_items_dict = {"EP": RuleVariation_690, "VAL": RuleVariation_791}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_690:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_791:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_690:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_791:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1325_Arg) -> 'Variation_1325':
        return cls._create(arg) # type: ignore

RuleVariation_1250_Arg: TypeAlias = Variation_1325_Arg
class RuleVariation_1250(RuleVariationContextFree):
    cv_variation = Variation_1325

    @classmethod
    def create(cls, arg : RuleVariation_1250_Arg) -> "RuleVariation_1250":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1325:
        return self.arg # type: ignore

Content_239_Arg: TypeAlias = int
class Content_239(ContentTable):
    cv_values = {0: "IRMXPR not populated", 1: "IRMXPR populated"}

RuleContent_239_Arg: TypeAlias = Content_239_Arg
class RuleContent_239(RuleContentContextFree):
    cv_content = Content_239

    @property
    def content(self) -> Content_239:
        return self._get_content() # type: ignore

Variation_47_Arg: TypeAlias = RuleContent_239_Arg
class Variation_47(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_239

    @classmethod
    def create(cls, arg : Variation_47_Arg) -> "Variation_47":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_239:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_239:
        return self.rule.content

RuleVariation_47_Arg: TypeAlias = Variation_47_Arg
class RuleVariation_47(RuleVariationContextFree):
    cv_variation = Variation_47

    @classmethod
    def create(cls, arg : RuleVariation_47_Arg) -> "RuleVariation_47":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_47:
        return self.arg # type: ignore

NonSpare_940_Arg: TypeAlias = RuleVariation_47_Arg
class NonSpare_940(NonSpare):
    cv_name = "EP"
    cv_title = "IRMXPR Element Populated Bit"
    cv_rule = RuleVariation_47

    @classmethod
    def create(cls, arg : NonSpare_940_Arg) -> "NonSpare_940":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_47:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_47:
        return self.rule.variation

Item_307_Arg: TypeAlias = NonSpare_940_Arg
class Item_307(Item):
    cv_non_spare = NonSpare_940

    @classmethod
    def create(cls, arg : Item_307_Arg) -> "Item_307":
        return cls._create(arg) # type: ignore

Content_523_Arg: TypeAlias = int
class Content_523(ContentTable):
    cv_values = {0: "Transponder not IRM capable", 1: "Transponder IRM capable"}

RuleContent_523_Arg: TypeAlias = Content_523_Arg
class RuleContent_523(RuleContentContextFree):
    cv_content = Content_523

    @property
    def content(self) -> Content_523:
        return self._get_content() # type: ignore

Variation_460_Arg: TypeAlias = RuleContent_523_Arg
class Variation_460(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_523

    @classmethod
    def create(cls, arg : Variation_460_Arg) -> "Variation_460":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_523:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_523:
        return self.rule.content

RuleVariation_449_Arg: TypeAlias = Variation_460_Arg
class RuleVariation_449(RuleVariationContextFree):
    cv_variation = Variation_460

    @classmethod
    def create(cls, arg : RuleVariation_449_Arg) -> "RuleVariation_449":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_460:
        return self.arg # type: ignore

NonSpare_1997_Arg: TypeAlias = RuleVariation_449_Arg
class NonSpare_1997(NonSpare):
    cv_name = "VAL"
    cv_title = "Transponder IRM Capability"
    cv_rule = RuleVariation_449

    @classmethod
    def create(cls, arg : NonSpare_1997_Arg) -> "NonSpare_1997":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_449:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_460:
        return self.rule.variation

Item_1113_Arg: TypeAlias = NonSpare_1997_Arg
class Item_1113(Item):
    cv_non_spare = NonSpare_1997

    @classmethod
    def create(cls, arg : Item_1113_Arg) -> "Item_1113":
        return cls._create(arg) # type: ignore

Variation_1096_Arg_Group = Tuple[Union[RuleVariation_47_Arg, Tuple[Literal["EP"], RuleVariation_47_Arg]], Union[RuleVariation_449_Arg, Tuple[Literal["VAL"], RuleVariation_449_Arg]]]
Variation_1096_Arg: TypeAlias = Union[int, Variation_1096_Arg_Group]
class Variation_1096(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_items_list = [(Item_307, 1), (Item_1113, 1)]
    cv_items_dict = {"EP": RuleVariation_47, "VAL": RuleVariation_449}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_47:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_449:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_47:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_449:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1096_Arg) -> 'Variation_1096':
        return cls._create(arg) # type: ignore

RuleVariation_1054_Arg: TypeAlias = Variation_1096_Arg
class RuleVariation_1054(RuleVariationContextFree):
    cv_variation = Variation_1096

    @classmethod
    def create(cls, arg : RuleVariation_1054_Arg) -> "RuleVariation_1054":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1096:
        return self.arg # type: ignore

Content_238_Arg: TypeAlias = int
class Content_238(ContentTable):
    cv_values = {0: "IRMACT not populated", 1: "IRMACT populated"}

RuleContent_238_Arg: TypeAlias = Content_238_Arg
class RuleContent_238(RuleContentContextFree):
    cv_content = Content_238

    @property
    def content(self) -> Content_238:
        return self._get_content() # type: ignore

Variation_536_Arg: TypeAlias = RuleContent_238_Arg
class Variation_536(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_238

    @classmethod
    def create(cls, arg : Variation_536_Arg) -> "Variation_536":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_238:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_238:
        return self.rule.content

RuleVariation_525_Arg: TypeAlias = Variation_536_Arg
class RuleVariation_525(RuleVariationContextFree):
    cv_variation = Variation_536

    @classmethod
    def create(cls, arg : RuleVariation_525_Arg) -> "RuleVariation_525":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_536:
        return self.arg # type: ignore

NonSpare_939_Arg: TypeAlias = RuleVariation_525_Arg
class NonSpare_939(NonSpare):
    cv_name = "EP"
    cv_title = "IRM Element Populated Bit"
    cv_rule = RuleVariation_525

    @classmethod
    def create(cls, arg : NonSpare_939_Arg) -> "NonSpare_939":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_525:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_536:
        return self.rule.variation

Item_306_Arg: TypeAlias = NonSpare_939_Arg
class Item_306(Item):
    cv_non_spare = NonSpare_939

    @classmethod
    def create(cls, arg : Item_306_Arg) -> "Item_306":
        return cls._create(arg) # type: ignore

Content_237_Arg: TypeAlias = int
class Content_237(ContentTable):
    cv_values = {0: "IRM not active", 1: "IRM active"}

RuleContent_237_Arg: TypeAlias = Content_237_Arg
class RuleContent_237(RuleContentContextFree):
    cv_content = Content_237

    @property
    def content(self) -> Content_237:
        return self._get_content() # type: ignore

Variation_641_Arg: TypeAlias = RuleContent_237_Arg
class Variation_641(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_237

    @classmethod
    def create(cls, arg : Variation_641_Arg) -> "Variation_641":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_237:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_237:
        return self.rule.content

RuleVariation_630_Arg: TypeAlias = Variation_641_Arg
class RuleVariation_630(RuleVariationContextFree):
    cv_variation = Variation_641

    @classmethod
    def create(cls, arg : RuleVariation_630_Arg) -> "RuleVariation_630":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_641:
        return self.arg # type: ignore

NonSpare_1989_Arg: TypeAlias = RuleVariation_630_Arg
class NonSpare_1989(NonSpare):
    cv_name = "VAL"
    cv_title = "IRM Active for Current Plot"
    cv_rule = RuleVariation_630

    @classmethod
    def create(cls, arg : NonSpare_1989_Arg) -> "NonSpare_1989":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_630:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_641:
        return self.rule.variation

Item_1105_Arg: TypeAlias = NonSpare_1989_Arg
class Item_1105(Item):
    cv_non_spare = NonSpare_1989

    @classmethod
    def create(cls, arg : Item_1105_Arg) -> "Item_1105":
        return cls._create(arg) # type: ignore

Variation_1318_Arg_Group = Tuple[Union[RuleVariation_525_Arg, Tuple[Literal["EP"], RuleVariation_525_Arg]], Union[RuleVariation_630_Arg, Tuple[Literal["VAL"], RuleVariation_630_Arg]]]
Variation_1318_Arg: TypeAlias = Union[int, Variation_1318_Arg_Group]
class Variation_1318(Group):
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_items_list = [(Item_306, 1), (Item_1105, 1)]
    cv_items_dict = {"EP": RuleVariation_525, "VAL": RuleVariation_630}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_525:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_630:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_525:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_630:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1318_Arg) -> 'Variation_1318':
        return cls._create(arg) # type: ignore

RuleVariation_1243_Arg: TypeAlias = Variation_1318_Arg
class RuleVariation_1243(RuleVariationContextFree):
    cv_variation = Variation_1318

    @classmethod
    def create(cls, arg : RuleVariation_1243_Arg) -> "RuleVariation_1243":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1318:
        return self.arg # type: ignore

NonSpare_556_Arg: TypeAlias = RuleVariation_1043_Arg
class NonSpare_556(NonSpare):
    cv_name = "ACASXV"
    cv_title = "Extended Version"
    cv_rule = RuleVariation_1043

    @classmethod
    def create(cls, arg : NonSpare_556_Arg) -> "NonSpare_556":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1043:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1085:
        return self.rule.variation

Item_41_Arg: TypeAlias = NonSpare_556_Arg
class Item_41(Item):
    cv_non_spare = NonSpare_556

    @classmethod
    def create(cls, arg : Item_41_Arg) -> "Item_41":
        return cls._create(arg) # type: ignore

NonSpare_1444_Arg: TypeAlias = RuleVariation_1257_Arg
class NonSpare_1444(NonSpare):
    cv_name = "POXPR"
    cv_title = "PO Transponder Capability"
    cv_rule = RuleVariation_1257

    @classmethod
    def create(cls, arg : NonSpare_1444_Arg) -> "NonSpare_1444":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1257:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1334:
        return self.rule.variation

Item_693_Arg: TypeAlias = NonSpare_1444_Arg
class Item_693(Item):
    cv_non_spare = NonSpare_1444

    @classmethod
    def create(cls, arg : Item_693_Arg) -> "Item_693":
        return cls._create(arg) # type: ignore

NonSpare_1431_Arg: TypeAlias = RuleVariation_1055_Arg
class NonSpare_1431(NonSpare):
    cv_name = "POACT"
    cv_title = "PO Active for Current Plot"
    cv_rule = RuleVariation_1055

    @classmethod
    def create(cls, arg : NonSpare_1431_Arg) -> "NonSpare_1431":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1055:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1097:
        return self.rule.variation

Item_686_Arg: TypeAlias = NonSpare_1431_Arg
class Item_686(Item):
    cv_non_spare = NonSpare_1431

    @classmethod
    def create(cls, arg : Item_686_Arg) -> "Item_686":
        return cls._create(arg) # type: ignore

NonSpare_900_Arg: TypeAlias = RuleVariation_1241_Arg
class NonSpare_900(NonSpare):
    cv_name = "DTFXPR"
    cv_title = "Basic Dataflash Transponder Capability"
    cv_rule = RuleVariation_1241

    @classmethod
    def create(cls, arg : NonSpare_900_Arg) -> "NonSpare_900":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1241:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1316:
        return self.rule.variation

Item_276_Arg: TypeAlias = NonSpare_900_Arg
class Item_276(Item):
    cv_non_spare = NonSpare_900

    @classmethod
    def create(cls, arg : Item_276_Arg) -> "Item_276":
        return cls._create(arg) # type: ignore

NonSpare_899_Arg: TypeAlias = RuleVariation_1250_Arg
class NonSpare_899(NonSpare):
    cv_name = "DTFACT"
    cv_title = "Basic Dataflash Active for Current Plot"
    cv_rule = RuleVariation_1250

    @classmethod
    def create(cls, arg : NonSpare_899_Arg) -> "NonSpare_899":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1250:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1325:
        return self.rule.variation

Item_275_Arg: TypeAlias = NonSpare_899_Arg
class Item_275(Item):
    cv_non_spare = NonSpare_899

    @classmethod
    def create(cls, arg : Item_275_Arg) -> "Item_275":
        return cls._create(arg) # type: ignore

NonSpare_1118_Arg: TypeAlias = RuleVariation_1054_Arg
class NonSpare_1118(NonSpare):
    cv_name = "IRMXPR"
    cv_title = "IRM Transponder Capability"
    cv_rule = RuleVariation_1054

    @classmethod
    def create(cls, arg : NonSpare_1118_Arg) -> "NonSpare_1118":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1054:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1096:
        return self.rule.variation

Item_437_Arg: TypeAlias = NonSpare_1118_Arg
class Item_437(Item):
    cv_non_spare = NonSpare_1118

    @classmethod
    def create(cls, arg : Item_437_Arg) -> "Item_437":
        return cls._create(arg) # type: ignore

NonSpare_1117_Arg: TypeAlias = RuleVariation_1243_Arg
class NonSpare_1117(NonSpare):
    cv_name = "IRMACT"
    cv_title = "IRM Active for Current Plot"
    cv_rule = RuleVariation_1243

    @classmethod
    def create(cls, arg : NonSpare_1117_Arg) -> "NonSpare_1117":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1243:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1318:
        return self.rule.variation

Item_436_Arg: TypeAlias = NonSpare_1117_Arg
class Item_436(Item):
    cv_non_spare = NonSpare_1117

    @classmethod
    def create(cls, arg : Item_436_Arg) -> "Item_436":
        return cls._create(arg) # type: ignore

Variation_1383_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_126_Arg, Tuple[Literal["TYP"], RuleVariation_126_Arg]], Union[RuleVariation_601_Arg, Tuple[Literal["SIM"], RuleVariation_601_Arg]], Union[RuleVariation_734_Arg, Tuple[Literal["RDP"], RuleVariation_734_Arg]], Union[RuleVariation_786_Arg, Tuple[Literal["SPI"], RuleVariation_786_Arg]], Union[RuleVariation_915_Arg, Tuple[Literal["RAB"], RuleVariation_915_Arg]], None]]
Variation_1383_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_72_Arg, Tuple[Literal["TST"], RuleVariation_72_Arg]], Union[RuleVariation_427_Arg, Tuple[Literal["ERR"], RuleVariation_427_Arg]], Union[RuleVariation_545_Arg, Tuple[Literal["XPP"], RuleVariation_545_Arg]], Union[RuleVariation_639_Arg, Tuple[Literal["ME"], RuleVariation_639_Arg]], Union[RuleVariation_727_Arg, Tuple[Literal["MI"], RuleVariation_727_Arg]], Union[RuleVariation_847_Arg, Tuple[Literal["FOEFRI"], RuleVariation_847_Arg]], None]]
Variation_1383_Arg_Group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_1044_Arg, Tuple[Literal["ADSB"], RuleVariation_1044_Arg]], Union[RuleVariation_1244_Arg, Tuple[Literal["SCN"], RuleVariation_1244_Arg]], Union[RuleVariation_1253_Arg, Tuple[Literal["PAI"], RuleVariation_1253_Arg]], int, None]]
Variation_1383_Arg_Group_4: TypeAlias = Union[int, Tuple[Union[RuleVariation_1043_Arg, Tuple[Literal["ACASXV"], RuleVariation_1043_Arg]], Union[RuleVariation_1257_Arg, Tuple[Literal["POXPR"], RuleVariation_1257_Arg]], None]]
Variation_1383_Arg_Group_5: TypeAlias = Union[int, Tuple[Union[RuleVariation_1055_Arg, Tuple[Literal["POACT"], RuleVariation_1055_Arg]], Union[RuleVariation_1241_Arg, Tuple[Literal["DTFXPR"], RuleVariation_1241_Arg]], Union[RuleVariation_1250_Arg, Tuple[Literal["DTFACT"], RuleVariation_1250_Arg]], int, None]]
Variation_1383_Arg_Group_6: TypeAlias = Union[int, Tuple[Union[RuleVariation_1054_Arg, Tuple[Literal["IRMXPR"], RuleVariation_1054_Arg]], Union[RuleVariation_1243_Arg, Tuple[Literal["IRMACT"], RuleVariation_1243_Arg]], int, None]]
Variation_1383_Arg: TypeAlias = Union[
    Tuple[Variation_1383_Arg_Group_1],
    Tuple[Variation_1383_Arg_Group_1, Variation_1383_Arg_Group_2],
    Tuple[Variation_1383_Arg_Group_1, Variation_1383_Arg_Group_2, Variation_1383_Arg_Group_3],
    Tuple[Variation_1383_Arg_Group_1, Variation_1383_Arg_Group_2, Variation_1383_Arg_Group_3, Variation_1383_Arg_Group_4],
    Tuple[Variation_1383_Arg_Group_1, Variation_1383_Arg_Group_2, Variation_1383_Arg_Group_3, Variation_1383_Arg_Group_4, Variation_1383_Arg_Group_5],
    Tuple[Variation_1383_Arg_Group_1, Variation_1383_Arg_Group_2, Variation_1383_Arg_Group_3, Variation_1383_Arg_Group_4, Variation_1383_Arg_Group_5, Variation_1383_Arg_Group_6],
]
class Variation_1383(Extended):
    cv_items_list = [[(Item_1070, 3), (Item_898, 1), (Item_783, 1), (Item_909, 1), (Item_766, 1), None], [(Item_1048, 1), (Item_316, 1), (Item_1215, 1), (Item_541, 1), (Item_548, 1), (Item_332, 2), None], [(Item_48, 2), (Item_861, 2), (Item_673, 2), (Item_26, 1), None], [(Item_41, 5), (Item_693, 2), None], [(Item_686, 2), (Item_276, 2), (Item_275, 2), (Item_26, 1), None], [(Item_437, 2), (Item_436, 2), (Item_21, 3), None]]

    @classmethod
    def create(cls, arg : Variation_1383_Arg) -> 'Variation_1383':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_126:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> RuleVariation_601:
        ...
    @overload
    def get_item(self, key : Literal["RDP"]) -> RuleVariation_734:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> RuleVariation_786:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_915:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_72]:
        ...
    @overload
    def get_item(self, key : Literal["ERR"]) -> Optional[RuleVariation_427]:
        ...
    @overload
    def get_item(self, key : Literal["XPP"]) -> Optional[RuleVariation_545]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_639]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_727]:
        ...
    @overload
    def get_item(self, key : Literal["FOEFRI"]) -> Optional[RuleVariation_847]:
        ...
    @overload
    def get_item(self, key : Literal["ADSB"]) -> Optional[RuleVariation_1044]:
        ...
    @overload
    def get_item(self, key : Literal["SCN"]) -> Optional[RuleVariation_1244]:
        ...
    @overload
    def get_item(self, key : Literal["PAI"]) -> Optional[RuleVariation_1253]:
        ...
    @overload
    def get_item(self, key : Literal["ACASXV"]) -> Optional[RuleVariation_1043]:
        ...
    @overload
    def get_item(self, key : Literal["POXPR"]) -> Optional[RuleVariation_1257]:
        ...
    @overload
    def get_item(self, key : Literal["POACT"]) -> Optional[RuleVariation_1055]:
        ...
    @overload
    def get_item(self, key : Literal["DTFXPR"]) -> Optional[RuleVariation_1241]:
        ...
    @overload
    def get_item(self, key : Literal["DTFACT"]) -> Optional[RuleVariation_1250]:
        ...
    @overload
    def get_item(self, key : Literal["IRMXPR"]) -> Optional[RuleVariation_1054]:
        ...
    @overload
    def get_item(self, key : Literal["IRMACT"]) -> Optional[RuleVariation_1243]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1306_Arg: TypeAlias = Variation_1383_Arg
class RuleVariation_1306(RuleVariationContextFree):
    cv_variation = Variation_1383

    @classmethod
    def create(cls, arg : RuleVariation_1306_Arg) -> "RuleVariation_1306":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1383:
        return self.arg # type: ignore

NonSpare_89_Arg: TypeAlias = RuleVariation_1306_Arg
class NonSpare_89(NonSpare):
    cv_name = "020"
    cv_title = "Target Report Descriptor"
    cv_rule = RuleVariation_1306

    @classmethod
    def create(cls, arg : NonSpare_89_Arg) -> "NonSpare_89":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1306:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1383:
        return self.rule.variation

class UapItem_89(UapItem):
    cv_non_spare = NonSpare_89

NonSpare_208_Arg: TypeAlias = RuleVariation_1188_Arg
class NonSpare_208(NonSpare):
    cv_name = "070"
    cv_title = "Mode-3/A Code in Octal Representation"
    cv_rule = RuleVariation_1188

    @classmethod
    def create(cls, arg : NonSpare_208_Arg) -> "NonSpare_208":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1188:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1258:
        return self.rule.variation

class UapItem_208(UapItem):
    cv_non_spare = NonSpare_208

NonSpare_964_Arg: TypeAlias = RuleVariation_595_Arg
class NonSpare_964(NonSpare):
    cv_name = "FL"
    cv_title = ""
    cv_rule = RuleVariation_595

    @classmethod
    def create(cls, arg : NonSpare_964_Arg) -> "NonSpare_964":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_595:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_606:
        return self.rule.variation

Item_327_Arg: TypeAlias = NonSpare_964_Arg
class Item_327(Item):
    cv_non_spare = NonSpare_964

    @classmethod
    def create(cls, arg : Item_327_Arg) -> "Item_327":
        return cls._create(arg) # type: ignore

Variation_1248_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_595_Arg, Tuple[Literal["FL"], RuleVariation_595_Arg]]]
Variation_1248_Arg: TypeAlias = Union[int, Variation_1248_Arg_Group]
class Variation_1248(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1099, 1), (Item_353, 1), (Item_327, 14)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "FL": RuleVariation_595}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FL"]) -> RuleVariation_595:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["FL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["FL"]) -> RuleVariation_595:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1248_Arg) -> 'Variation_1248':
        return cls._create(arg) # type: ignore

RuleVariation_1178_Arg: TypeAlias = Variation_1248_Arg
class RuleVariation_1178(RuleVariationContextFree):
    cv_variation = Variation_1248

    @classmethod
    def create(cls, arg : RuleVariation_1178_Arg) -> "RuleVariation_1178":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1248:
        return self.arg # type: ignore

NonSpare_244_Arg: TypeAlias = RuleVariation_1178_Arg
class NonSpare_244(NonSpare):
    cv_name = "090"
    cv_title = "Flight Level in Binary Representation"
    cv_rule = RuleVariation_1178

    @classmethod
    def create(cls, arg : NonSpare_244_Arg) -> "NonSpare_244":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1178:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1248:
        return self.rule.variation

class UapItem_244(UapItem):
    cv_non_spare = NonSpare_244

Content_394_Arg: TypeAlias = int
class Content_394(ContentTable):
    cv_values = {0: "Not defined; never used", 1: "Multipath Reply (Reflection)", 2: "Reply due to sidelobe interrogation/reception", 3: "Split plot", 4: "Second time around reply", 5: "Angel", 6: "Slow moving target correlated with road infrastructure (terrestrial vehicle)", 7: "Fixed PSR plot", 8: "Slow PSR target", 9: "Low quality PSR plot", 10: "Phantom SSR plot", 11: "Non-Matching Mode-3/A Code", 12: "Mode C code / Mode S altitude code abnormal value compared to the track", 13: "Target in Clutter Area", 14: "Maximum Doppler Response in Zero Filter", 15: "Transponder anomaly detected", 16: "Duplicated or Illegal Mode S Aircraft Address", 17: "Mode S error correction applied", 18: "Undecodable Mode C code / Mode S altitude code", 19: "Birds", 20: "Flock of Birds", 21: "Mode-1 was present in original reply", 22: "Mode-2 was present in original reply", 23: "Plot potentially caused by Wind Turbine", 24: "Helicopter", 25: "Maximum number of re-interrogations reached (surveillance information)", 26: "Maximum number of re-interrogations reached (BDS Extractions)", 27: "BDS Overlay Incoherence", 28: "Potential BDS Swap Detected", 29: "Track Update in the Zenithal Gap", 30: "Mode S Track re-acquired", 31: "Duplicated Mode 5 Pair NO/PIN detected", 32: "Wrong DF reply format detected", 33: "Transponder anomaly (MS XPD replies with Mode A/C to Mode A/C-only all-call)", 34: "Transponder anomaly (SI capability report wrong)", 35: "Potential IC Conflict", 36: "IC Conflict detection possible-no conflict currently detected", 37: "Duplicate Mode 5 PIN (refer to the Mode 5 items in the REF)"}

RuleContent_394_Arg: TypeAlias = Content_394_Arg
class RuleContent_394(RuleContentContextFree):
    cv_content = Content_394

    @property
    def content(self) -> Content_394:
        return self._get_content() # type: ignore

Variation_155_Arg: TypeAlias = RuleContent_394_Arg
class Variation_155(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_394

    @classmethod
    def create(cls, arg : Variation_155_Arg) -> "Variation_155":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_394:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_394:
        return self.rule.content

Variation_1451_Arg: TypeAlias = List[Variation_155_Arg]
class Variation_1451(Repetitive):
    cv_rep_bytes = None
    cv_variation = Variation_155

    @classmethod
    def create(cls, arg : Variation_1451_Arg) -> 'Variation_1451':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_155]:
        return self._get_list() # type: ignore

RuleVariation_1374_Arg: TypeAlias = Variation_1451_Arg
class RuleVariation_1374(RuleVariationContextFree):
    cv_variation = Variation_1451

    @classmethod
    def create(cls, arg : RuleVariation_1374_Arg) -> "RuleVariation_1374":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1451:
        return self.arg # type: ignore

NonSpare_120_Arg: TypeAlias = RuleVariation_1374_Arg
class NonSpare_120(NonSpare):
    cv_name = "030"
    cv_title = "Warning/Error Conditions and Target Classification"
    cv_rule = RuleVariation_1374

    @classmethod
    def create(cls, arg : NonSpare_120_Arg) -> "NonSpare_120":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1374:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1451:
        return self.rule.variation

class UapItem_120(UapItem):
    cv_non_spare = NonSpare_120

NonSpare_169_Arg: TypeAlias = RuleVariation_1184_Arg
class NonSpare_169(NonSpare):
    cv_name = "050"
    cv_title = "Mode-2 Code in Octal Representation"
    cv_rule = RuleVariation_1184

    @classmethod
    def create(cls, arg : NonSpare_169_Arg) -> "NonSpare_169":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1184:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1254:
        return self.rule.variation

class UapItem_169(UapItem):
    cv_non_spare = NonSpare_169

Record_32_Arg = TypedDict('Record_32_Arg', {
    "010": NonSpare_38_Arg,
    "140": NonSpare_328_Arg,
    "020": NonSpare_89_Arg,
    "040": NonSpare_137_Arg,
    "070": NonSpare_208_Arg,
    "090": NonSpare_244_Arg,
    "130": NonSpare_308_Arg,
    "220": NonSpare_416_Arg,
    "240": NonSpare_432_Arg,
    "250": NonSpare_440_Arg,
    "161": NonSpare_359_Arg,
    "042": NonSpare_158_Arg,
    "200": NonSpare_385_Arg,
    "170": NonSpare_372_Arg,
    "210": NonSpare_411_Arg,
    "030": NonSpare_120_Arg,
    "080": NonSpare_229_Arg,
    "100": NonSpare_269_Arg,
    "110": NonSpare_283_Arg,
    "120": NonSpare_297_Arg,
    "230": NonSpare_425_Arg,
    "260": NonSpare_450_Arg,
    "055": NonSpare_183_Arg,
    "050": NonSpare_169_Arg,
    "065": NonSpare_199_Arg,
    "060": NonSpare_185_Arg,
    "SP": NonSpare_1723_Arg,
    "RE": NonSpare_1558_Arg,
}, total=False)
class Record_32(Record):
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_38, UapItem_328, UapItem_89, UapItem_137, UapItem_208, UapItem_244, UapItem_308, UapItem_416, UapItem_432, UapItem_440, UapItem_359, UapItem_158, UapItem_385, UapItem_372, UapItem_411, UapItem_120, UapItem_229, UapItem_269, UapItem_283, UapItem_297, UapItem_425, UapItem_450, UapItem_183, UapItem_169, UapItem_199, UapItem_185, UapItem_543, UapItem_542]
    cv_items_dict = {"010": NonSpare_38, "140": NonSpare_328, "020": NonSpare_89, "040": NonSpare_137, "070": NonSpare_208, "090": NonSpare_244, "130": NonSpare_308, "220": NonSpare_416, "240": NonSpare_432, "250": NonSpare_440, "161": NonSpare_359, "042": NonSpare_158, "200": NonSpare_385, "170": NonSpare_372, "210": NonSpare_411, "030": NonSpare_120, "080": NonSpare_229, "100": NonSpare_269, "110": NonSpare_283, "120": NonSpare_297, "230": NonSpare_425, "260": NonSpare_450, "055": NonSpare_183, "050": NonSpare_169, "065": NonSpare_199, "060": NonSpare_185, "SP": NonSpare_1723, "RE": NonSpare_1558}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_38:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_328:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_89:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_137:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_208:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_244:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_308:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_416:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["240"]) -> NonSpare_432:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_440:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_359:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_385:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_372:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_411:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_120:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_229:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_269:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_283:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_297:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_425:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_450:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["055"]) -> NonSpare_183:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_169:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["065"]) -> NonSpare_199:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_185:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["140"], Literal["020"], Literal["040"], Literal["070"], Literal["090"], Literal["130"], Literal["220"], Literal["240"], Literal["250"], Literal["161"], Literal["042"], Literal["200"], Literal["170"], Literal["210"], Literal["030"], Literal["080"], Literal["100"], Literal["110"], Literal["120"], Literal["230"], Literal["260"], Literal["055"], Literal["050"], Literal["065"], Literal["060"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_38]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_328]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_89]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_137]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_208]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_244]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_308]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_416]:
        ...
    @overload
    def get_item(self, key : Literal["240"]) -> Optional[NonSpare_432]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_440]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_359]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_158]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_385]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_372]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_411]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_120]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_229]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_269]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_283]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_297]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_425]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_450]:
        ...
    @overload
    def get_item(self, key : Literal["055"]) -> Optional[NonSpare_183]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_169]:
        ...
    @overload
    def get_item(self, key : Literal["065"]) -> Optional[NonSpare_199]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_185]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_38_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_328_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_89_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_137_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_208_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_244_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_308_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_416_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["240"], val : NonSpare_432_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_440_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_359_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_158_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_385_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_372_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_411_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_120_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_229_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_269_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_283_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_297_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_425_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_450_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["055"], val : NonSpare_183_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_169_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["065"], val : NonSpare_199_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_185_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_32':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["240"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["055"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["065"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_32':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_32_Arg) -> 'Record_32':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_32", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_28_Arg: TypeAlias = Record_32
class Uap_28(UapSingle):
    cv_record = Record_32

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_32]]:
        return cls._parse(bs)

class Asterix_48(AstCat):
    cv_category = 48
    cv_edition = (1, 32)
    cv_uap = Uap_28

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_28_Arg]) -> "Asterix_48":
        return cls._create(records) # type: ignore

Content_345_Arg: TypeAlias = int
class Content_345(ContentTable):
    cv_values = {0: "No detection", 1: "Single PSR detection", 2: "Single SSR detection", 3: "SSR+PSR detection", 4: "Single Mode S All-Call", 5: "Single Mode S Roll-Call", 6: "Mode S All-Call + PSR", 7: "Mode S Roll-Call + PSR", 8: "ADS-B", 9: "WAM"}

RuleContent_345_Arg: TypeAlias = Content_345_Arg
class RuleContent_345(RuleContentContextFree):
    cv_content = Content_345

    @property
    def content(self) -> Content_345:
        return self._get_content() # type: ignore

Variation_797_Arg: TypeAlias = RuleContent_345_Arg
class Variation_797(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 4
    cv_rule = RuleContent_345

    @classmethod
    def create(cls, arg : Variation_797_Arg) -> "Variation_797":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_345:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_345:
        return self.rule.content

RuleVariation_767_Arg: TypeAlias = Variation_797_Arg
class RuleVariation_767(RuleVariationContextFree):
    cv_variation = Variation_797

    @classmethod
    def create(cls, arg : RuleVariation_767_Arg) -> "RuleVariation_767":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_797:
        return self.arg # type: ignore

NonSpare_1954_Arg: TypeAlias = RuleVariation_767_Arg
class NonSpare_1954(NonSpare):
    cv_name = "TYP"
    cv_title = ""
    cv_rule = RuleVariation_767

    @classmethod
    def create(cls, arg : NonSpare_1954_Arg) -> "NonSpare_1954":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_767:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_797:
        return self.rule.variation

Item_1074_Arg: TypeAlias = NonSpare_1954_Arg
class Item_1074(Item):
    cv_non_spare = NonSpare_1954

    @classmethod
    def create(cls, arg : Item_1074_Arg) -> "Item_1074":
        return cls._create(arg) # type: ignore

NonSpare_1189_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_1189(NonSpare):
    cv_name = "LTN"
    cv_title = "Local Track Number"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_1189_Arg) -> "NonSpare_1189":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

Item_503_Arg: TypeAlias = NonSpare_1189_Arg
class Item_503(Item):
    cv_non_spare = NonSpare_1189

    @classmethod
    def create(cls, arg : Item_503_Arg) -> "Item_503":
        return cls._create(arg) # type: ignore

Variation_1188_Arg_Group = Tuple[Union[RuleVariation_158_Arg, Tuple[Literal["SAC"], RuleVariation_158_Arg]], Union[RuleVariation_158_Arg, Tuple[Literal["SIC"], RuleVariation_158_Arg]], int, Union[RuleVariation_767_Arg, Tuple[Literal["TYP"], RuleVariation_767_Arg]], Union[RuleVariation_244_Arg, Tuple[Literal["LTN"], RuleVariation_244_Arg]]]
Variation_1188_Arg: TypeAlias = Union[int, Variation_1188_Arg_Group]
class Variation_1188(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_items_list = [(Item_852, 8), (Item_883, 8), (Item_3, 4), (Item_1074, 4), (Item_503, 16)]
    cv_items_dict = {"SAC": RuleVariation_158, "SIC": RuleVariation_158, "TYP": RuleVariation_767, "LTN": RuleVariation_244}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAC"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIC"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_767:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LTN"]) -> RuleVariation_244:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAC"], Literal["SIC"], Literal["TYP"], Literal["LTN"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAC"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["SIC"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_767:
        ...
    @overload
    def get_item(self, key : Literal["LTN"]) -> RuleVariation_244:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1188_Arg) -> 'Variation_1188':
        return cls._create(arg) # type: ignore

Variation_1423_Arg: TypeAlias = List[Variation_1188_Arg]
class Variation_1423(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1188

    @classmethod
    def create(cls, arg : Variation_1423_Arg) -> 'Variation_1423':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1188]:
        return self._get_list() # type: ignore

RuleVariation_1346_Arg: TypeAlias = Variation_1423_Arg
class RuleVariation_1346(RuleVariationContextFree):
    cv_variation = Variation_1423

    @classmethod
    def create(cls, arg : RuleVariation_1346_Arg) -> "RuleVariation_1346":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1423:
        return self.arg # type: ignore

NonSpare_835_Arg: TypeAlias = RuleVariation_1346_Arg
class NonSpare_835(NonSpare):
    cv_name = "CST"
    cv_title = "Contributing Sensors With Local Tracknumbers"
    cv_rule = RuleVariation_1346

    @classmethod
    def create(cls, arg : NonSpare_835_Arg) -> "NonSpare_835":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1346:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1423:
        return self.rule.variation

Variation_1187_Arg_Group = Tuple[Union[RuleVariation_158_Arg, Tuple[Literal["SAC"], RuleVariation_158_Arg]], Union[RuleVariation_158_Arg, Tuple[Literal["SIC"], RuleVariation_158_Arg]], int, Union[RuleVariation_767_Arg, Tuple[Literal["TYP"], RuleVariation_767_Arg]]]
Variation_1187_Arg: TypeAlias = Union[int, Variation_1187_Arg_Group]
class Variation_1187(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_852, 8), (Item_883, 8), (Item_3, 4), (Item_1074, 4)]
    cv_items_dict = {"SAC": RuleVariation_158, "SIC": RuleVariation_158, "TYP": RuleVariation_767}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAC"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIC"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_767:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAC"], Literal["SIC"], Literal["TYP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAC"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["SIC"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_767:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1187_Arg) -> 'Variation_1187':
        return cls._create(arg) # type: ignore

Variation_1422_Arg: TypeAlias = List[Variation_1187_Arg]
class Variation_1422(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1187

    @classmethod
    def create(cls, arg : Variation_1422_Arg) -> 'Variation_1422':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1187]:
        return self._get_list() # type: ignore

RuleVariation_1345_Arg: TypeAlias = Variation_1422_Arg
class RuleVariation_1345(RuleVariationContextFree):
    cv_variation = Variation_1422

    @classmethod
    def create(cls, arg : RuleVariation_1345_Arg) -> "RuleVariation_1345":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1422:
        return self.arg # type: ignore

NonSpare_829_Arg: TypeAlias = RuleVariation_1345_Arg
class NonSpare_829(NonSpare):
    cv_name = "CSN"
    cv_title = "Contributing Sensors No Local Tracknumbers"
    cv_rule = RuleVariation_1345

    @classmethod
    def create(cls, arg : NonSpare_829_Arg) -> "NonSpare_829":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1345:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1422:
        return self.rule.variation

Content_660_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
class Content_660(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.25
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_660_Arg: TypeAlias = Content_660_Arg
class RuleContent_660(RuleContentContextFree):
    cv_content = Content_660

    @property
    def content(self) -> Content_660:
        return self._get_content() # type: ignore

Variation_278_Arg: TypeAlias = RuleContent_660_Arg
class Variation_278(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_660

    @classmethod
    def create(cls, arg : Variation_278_Arg) -> "Variation_278":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_660:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_660:
        return self.rule.content

RuleVariation_271_Arg: TypeAlias = Variation_278_Arg
class RuleVariation_271(RuleVariationContextFree):
    cv_variation = Variation_278

    @classmethod
    def create(cls, arg : RuleVariation_271_Arg) -> "RuleVariation_271":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_278:
        return self.arg # type: ignore

NonSpare_2039_Arg: TypeAlias = RuleVariation_271_Arg
class NonSpare_2039(NonSpare):
    cv_name = "VX"
    cv_title = ""
    cv_rule = RuleVariation_271

    @classmethod
    def create(cls, arg : NonSpare_2039_Arg) -> "NonSpare_2039":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_271:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_278:
        return self.rule.variation

Item_1151_Arg: TypeAlias = NonSpare_2039_Arg
class Item_1151(Item):
    cv_non_spare = NonSpare_2039

    @classmethod
    def create(cls, arg : Item_1151_Arg) -> "Item_1151":
        return cls._create(arg) # type: ignore

NonSpare_2044_Arg: TypeAlias = RuleVariation_271_Arg
class NonSpare_2044(NonSpare):
    cv_name = "VY"
    cv_title = ""
    cv_rule = RuleVariation_271

    @classmethod
    def create(cls, arg : NonSpare_2044_Arg) -> "NonSpare_2044":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_271:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_278:
        return self.rule.variation

Item_1156_Arg: TypeAlias = NonSpare_2044_Arg
class Item_1156(Item):
    cv_non_spare = NonSpare_2044

    @classmethod
    def create(cls, arg : Item_1156_Arg) -> "Item_1156":
        return cls._create(arg) # type: ignore

Variation_1273_Arg_Group = Tuple[Union[RuleVariation_271_Arg, Tuple[Literal["VX"], RuleVariation_271_Arg]], Union[RuleVariation_271_Arg, Tuple[Literal["VY"], RuleVariation_271_Arg]]]
Variation_1273_Arg: TypeAlias = Union[int, Variation_1273_Arg_Group]
class Variation_1273(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1151, 16), (Item_1156, 16)]
    cv_items_dict = {"VX": RuleVariation_271, "VY": RuleVariation_271}

    @overload
    @classmethod
    def spec(cls, key : Literal["VX"]) -> RuleVariation_271:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VY"]) -> RuleVariation_271:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VX"], Literal["VY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VX"]) -> RuleVariation_271:
        ...
    @overload
    def get_item(self, key : Literal["VY"]) -> RuleVariation_271:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1273_Arg) -> 'Variation_1273':
        return cls._create(arg) # type: ignore

RuleVariation_1203_Arg: TypeAlias = Variation_1273_Arg
class RuleVariation_1203(RuleVariationContextFree):
    cv_variation = Variation_1273

    @classmethod
    def create(cls, arg : RuleVariation_1203_Arg) -> "RuleVariation_1203":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1273:
        return self.arg # type: ignore

NonSpare_1945_Arg: TypeAlias = RuleVariation_1203_Arg
class NonSpare_1945(NonSpare):
    cv_name = "TVS"
    cv_title = "Calculated Track Velocity Relative to System Reference Point"
    cv_rule = RuleVariation_1203

    @classmethod
    def create(cls, arg : NonSpare_1945_Arg) -> "NonSpare_1945":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1203:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1273:
        return self.rule.variation

Content_212_Arg: TypeAlias = int
class Content_212(ContentTable):
    cv_values = {0: "Flight plan data from active FDPS", 1: "Flight plan data retained from no longer active FDPS"}

RuleContent_212_Arg: TypeAlias = Content_212_Arg
class RuleContent_212(RuleContentContextFree):
    cv_content = Content_212

    @property
    def content(self) -> Content_212:
        return self._get_content() # type: ignore

Variation_42_Arg: TypeAlias = RuleContent_212_Arg
class Variation_42(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_212

    @classmethod
    def create(cls, arg : Variation_42_Arg) -> "Variation_42":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_212:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_212:
        return self.rule.content

RuleVariation_42_Arg: TypeAlias = Variation_42_Arg
class RuleVariation_42(RuleVariationContextFree):
    cv_variation = Variation_42

    @classmethod
    def create(cls, arg : RuleVariation_42_Arg) -> "RuleVariation_42":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_42:
        return self.arg # type: ignore

NonSpare_963_Arg: TypeAlias = RuleVariation_42_Arg
class NonSpare_963(NonSpare):
    cv_name = "FDR"
    cv_title = "Flight Data Retained"
    cv_rule = RuleVariation_42

    @classmethod
    def create(cls, arg : NonSpare_963_Arg) -> "NonSpare_963":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_42:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_42:
        return self.rule.variation

Item_326_Arg: TypeAlias = NonSpare_963_Arg
class Item_326(Item):
    cv_non_spare = NonSpare_963

    @classmethod
    def create(cls, arg : Item_326_Arg) -> "Item_326":
        return cls._create(arg) # type: ignore

Variation_1352_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_42_Arg, Tuple[Literal["FDR"], RuleVariation_42_Arg]], int, None]]
Variation_1352_Arg: TypeAlias = Union[
    Tuple[Variation_1352_Arg_Group_1],
]
class Variation_1352(Extended):
    cv_items_list = [[(Item_326, 1), (Item_9, 6), None]]

    @classmethod
    def create(cls, arg : Variation_1352_Arg) -> 'Variation_1352':
        return cls._create(arg) # type: ignore

    @overload # type: ignore
    def get_item(self, key : Literal["FDR"]) -> RuleVariation_42:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1275_Arg: TypeAlias = Variation_1352_Arg
class RuleVariation_1275(RuleVariationContextFree):
    cv_variation = Variation_1352

    @classmethod
    def create(cls, arg : RuleVariation_1275_Arg) -> "RuleVariation_1275":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1352:
        return self.arg # type: ignore

NonSpare_1792_Arg: TypeAlias = RuleVariation_1275_Arg
class NonSpare_1792(NonSpare):
    cv_name = "STS"
    cv_title = "Supplementary Track Status"
    cv_rule = RuleVariation_1275

    @classmethod
    def create(cls, arg : NonSpare_1792_Arg) -> "NonSpare_1792":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1275:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1352:
        return self.rule.variation

Expansion_2_Arg = TypedDict('Expansion_2_Arg', {
    "CST": NonSpare_835_Arg,
    "CSN": NonSpare_829_Arg,
    "TVS": NonSpare_1945_Arg,
    "STS": NonSpare_1792_Arg,
}, total=False)
class Expansion_2(Expansion):
    cv_fspec_bytes = 1
    cv_items_list = [NonSpare_835, NonSpare_829, NonSpare_1945, NonSpare_1792]
    items_dict = {"CST": NonSpare_835, "CSN": NonSpare_829, "TVS": NonSpare_1945, "STS": NonSpare_1792}

    @overload
    @classmethod
    def spec(cls, key : Literal["CST"]) -> NonSpare_835:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CSN"]) -> NonSpare_829:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TVS"]) -> NonSpare_1945:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STS"]) -> NonSpare_1792:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CST"], Literal["CSN"], Literal["TVS"], Literal["STS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CST"]) -> Optional[NonSpare_835]:
        ...
    @overload
    def get_item(self, key : Literal["CSN"]) -> Optional[NonSpare_829]:
        ...
    @overload
    def get_item(self, key : Literal["TVS"]) -> Optional[NonSpare_1945]:
        ...
    @overload
    def get_item(self, key : Literal["STS"]) -> Optional[NonSpare_1792]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["CST"], val : NonSpare_835_Arg) -> "Expansion_2":
        ...
    @overload
    def set_item(self, key : Literal["CSN"], val : NonSpare_829_Arg) -> "Expansion_2":
        ...
    @overload
    def set_item(self, key : Literal["TVS"], val : NonSpare_1945_Arg) -> "Expansion_2":
        ...
    @overload
    def set_item(self, key : Literal["STS"], val : NonSpare_1792_Arg) -> "Expansion_2":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["CST"]) -> "Expansion_2":
        ...
    @overload
    def del_item(self, key : Literal["CSN"]) -> "Expansion_2":
        ...
    @overload
    def del_item(self, key : Literal["TVS"]) -> "Expansion_2":
        ...
    @overload
    def del_item(self, key : Literal["STS"]) -> "Expansion_2":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Expansion_2_Arg) -> 'Expansion_2':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Expansion_2", Bits]]:
        return cls._parse(bs) # type: ignore

class Asterix_49(AstRef):
    cv_category = 62
    cv_edition = (1, 2)
    cv_expansion = Expansion_2

Content_250_Arg: TypeAlias = int
class Content_250(ContentTable):
    cv_values = {0: "LNAV not populated", 1: "LNAV populated"}

RuleContent_250_Arg: TypeAlias = Content_250_Arg
class RuleContent_250(RuleContentContextFree):
    cv_content = Content_250

    @property
    def content(self) -> Content_250:
        return self._get_content() # type: ignore

Variation_433_Arg: TypeAlias = RuleContent_250_Arg
class Variation_433(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_250

    @classmethod
    def create(cls, arg : Variation_433_Arg) -> "Variation_433":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_250:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_250:
        return self.rule.content

RuleVariation_422_Arg: TypeAlias = Variation_433_Arg
class RuleVariation_422(RuleVariationContextFree):
    cv_variation = Variation_433

    @classmethod
    def create(cls, arg : RuleVariation_422_Arg) -> "RuleVariation_422":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_433:
        return self.arg # type: ignore

NonSpare_941_Arg: TypeAlias = RuleVariation_422_Arg
class NonSpare_941(NonSpare):
    cv_name = "EP"
    cv_title = "LNAV Element Populated"
    cv_rule = RuleVariation_422

    @classmethod
    def create(cls, arg : NonSpare_941_Arg) -> "NonSpare_941":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_422:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_433:
        return self.rule.variation

Item_308_Arg: TypeAlias = NonSpare_941_Arg
class Item_308(Item):
    cv_non_spare = NonSpare_941

    @classmethod
    def create(cls, arg : Item_308_Arg) -> "Item_308":
        return cls._create(arg) # type: ignore

Content_248_Arg: TypeAlias = int
class Content_248(ContentTable):
    cv_values = {0: "LNAV Mode Engaged", 1: "LNAV Mode not Engaged"}

RuleContent_248_Arg: TypeAlias = Content_248_Arg
class RuleContent_248(RuleContentContextFree):
    cv_content = Content_248

    @property
    def content(self) -> Content_248:
        return self._get_content() # type: ignore

Variation_538_Arg: TypeAlias = RuleContent_248_Arg
class Variation_538(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_248

    @classmethod
    def create(cls, arg : Variation_538_Arg) -> "Variation_538":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_248:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_248:
        return self.rule.content

RuleVariation_527_Arg: TypeAlias = Variation_538_Arg
class RuleVariation_527(RuleVariationContextFree):
    cv_variation = Variation_538

    @classmethod
    def create(cls, arg : RuleVariation_527_Arg) -> "RuleVariation_527":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_538:
        return self.arg # type: ignore

NonSpare_1990_Arg: TypeAlias = RuleVariation_527_Arg
class NonSpare_1990(NonSpare):
    cv_name = "VAL"
    cv_title = "LNAV Mode"
    cv_rule = RuleVariation_527

    @classmethod
    def create(cls, arg : NonSpare_1990_Arg) -> "NonSpare_1990":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_527:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_538:
        return self.rule.variation

Item_1106_Arg: TypeAlias = NonSpare_1990_Arg
class Item_1106(Item):
    cv_non_spare = NonSpare_1990

    @classmethod
    def create(cls, arg : Item_1106_Arg) -> "Item_1106":
        return cls._create(arg) # type: ignore

Variation_1315_Arg_Group = Tuple[Union[RuleVariation_422_Arg, Tuple[Literal["EP"], RuleVariation_422_Arg]], Union[RuleVariation_527_Arg, Tuple[Literal["VAL"], RuleVariation_527_Arg]]]
Variation_1315_Arg: TypeAlias = Union[int, Variation_1315_Arg_Group]
class Variation_1315(Group):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_items_list = [(Item_308, 1), (Item_1106, 1)]
    cv_items_dict = {"EP": RuleVariation_422, "VAL": RuleVariation_527}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_422:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_527:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_422:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_527:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1315_Arg) -> 'Variation_1315':
        return cls._create(arg) # type: ignore

RuleVariation_1240_Arg: TypeAlias = Variation_1315_Arg
class RuleVariation_1240(RuleVariationContextFree):
    cv_variation = Variation_1315

    @classmethod
    def create(cls, arg : RuleVariation_1240_Arg) -> "RuleVariation_1240":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1315:
        return self.arg # type: ignore

NonSpare_1164_Arg: TypeAlias = RuleVariation_1240_Arg
class NonSpare_1164(NonSpare):
    cv_name = "LNAV"
    cv_title = "Lateral Navigation Mode"
    cv_rule = RuleVariation_1240

    @classmethod
    def create(cls, arg : NonSpare_1164_Arg) -> "NonSpare_1164":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1240:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1315:
        return self.rule.variation

Item_480_Arg: TypeAlias = NonSpare_1164_Arg
class Item_480(Item):
    cv_non_spare = NonSpare_1164

    @classmethod
    def create(cls, arg : Item_480_Arg) -> "Item_480":
        return cls._create(arg) # type: ignore

Variation_1353_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_42_Arg, Tuple[Literal["FDR"], RuleVariation_42_Arg]], Union[RuleVariation_1240_Arg, Tuple[Literal["LNAV"], RuleVariation_1240_Arg]], int, None]]
Variation_1353_Arg: TypeAlias = Union[
    Tuple[Variation_1353_Arg_Group_1],
]
class Variation_1353(Extended):
    cv_items_list = [[(Item_326, 1), (Item_480, 2), (Item_18, 4), None]]

    @classmethod
    def create(cls, arg : Variation_1353_Arg) -> 'Variation_1353':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["FDR"]) -> RuleVariation_42:
        ...
    @overload
    def get_item(self, key : Literal["LNAV"]) -> RuleVariation_1240:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1276_Arg: TypeAlias = Variation_1353_Arg
class RuleVariation_1276(RuleVariationContextFree):
    cv_variation = Variation_1353

    @classmethod
    def create(cls, arg : RuleVariation_1276_Arg) -> "RuleVariation_1276":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1353:
        return self.arg # type: ignore

NonSpare_1793_Arg: TypeAlias = RuleVariation_1276_Arg
class NonSpare_1793(NonSpare):
    cv_name = "STS"
    cv_title = "Supplementary Track Status"
    cv_rule = RuleVariation_1276

    @classmethod
    def create(cls, arg : NonSpare_1793_Arg) -> "NonSpare_1793":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1276:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1353:
        return self.rule.variation

Content_420_Arg: TypeAlias = int
class Content_420(ContentTable):
    cv_values = {0: "PS3 Element not populated", 1: "PS3 Element populated"}

RuleContent_420_Arg: TypeAlias = Content_420_Arg
class RuleContent_420(RuleContentContextFree):
    cv_content = Content_420

    @property
    def content(self) -> Content_420:
        return self._get_content() # type: ignore

Variation_70_Arg: TypeAlias = RuleContent_420_Arg
class Variation_70(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_420

    @classmethod
    def create(cls, arg : Variation_70_Arg) -> "Variation_70":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_420:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_420:
        return self.rule.content

RuleVariation_70_Arg: TypeAlias = Variation_70_Arg
class RuleVariation_70(RuleVariationContextFree):
    cv_variation = Variation_70

    @classmethod
    def create(cls, arg : RuleVariation_70_Arg) -> "RuleVariation_70":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_70:
        return self.arg # type: ignore

NonSpare_945_Arg: TypeAlias = RuleVariation_70_Arg
class NonSpare_945(NonSpare):
    cv_name = "EP"
    cv_title = "Priority Status for Version 3 ADS-B Systems Populated"
    cv_rule = RuleVariation_70

    @classmethod
    def create(cls, arg : NonSpare_945_Arg) -> "NonSpare_945":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_70:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_70:
        return self.rule.variation

Item_312_Arg: TypeAlias = NonSpare_945_Arg
class Item_312(Item):
    cv_non_spare = NonSpare_945

    @classmethod
    def create(cls, arg : Item_312_Arg) -> "Item_312":
        return cls._create(arg) # type: ignore

Content_357_Arg: TypeAlias = int
class Content_357(ContentTable):
    cv_values = {0: "No emergency / not reported", 1: "General emergency", 2: "UAS/RPAS - Lost link", 3: "Minimum fuel", 4: "No communications", 5: "Unlawful interference", 6: "Aircraft in Distress Automatic Activation", 7: "Aircraft in Distress Manual Activation"}

RuleContent_357_Arg: TypeAlias = Content_357_Arg
class RuleContent_357(RuleContentContextFree):
    cv_content = Content_357

    @property
    def content(self) -> Content_357:
        return self._get_content() # type: ignore

Variation_482_Arg: TypeAlias = RuleContent_357_Arg
class Variation_482(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 3
    cv_rule = RuleContent_357

    @classmethod
    def create(cls, arg : Variation_482_Arg) -> "Variation_482":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_357:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_357:
        return self.rule.content

RuleVariation_471_Arg: TypeAlias = Variation_482_Arg
class RuleVariation_471(RuleVariationContextFree):
    cv_variation = Variation_482

    @classmethod
    def create(cls, arg : RuleVariation_471_Arg) -> "RuleVariation_471":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_482:
        return self.arg # type: ignore

NonSpare_1995_Arg: TypeAlias = RuleVariation_471_Arg
class NonSpare_1995(NonSpare):
    cv_name = "VAL"
    cv_title = "Priority Status for Version 3 ADS-B Systems"
    cv_rule = RuleVariation_471

    @classmethod
    def create(cls, arg : NonSpare_1995_Arg) -> "NonSpare_1995":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_471:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_482:
        return self.rule.variation

Item_1111_Arg: TypeAlias = NonSpare_1995_Arg
class Item_1111(Item):
    cv_non_spare = NonSpare_1995

    @classmethod
    def create(cls, arg : Item_1111_Arg) -> "Item_1111":
        return cls._create(arg) # type: ignore

Variation_1098_Arg_Group = Tuple[Union[RuleVariation_70_Arg, Tuple[Literal["EP"], RuleVariation_70_Arg]], Union[RuleVariation_471_Arg, Tuple[Literal["VAL"], RuleVariation_471_Arg]], int]
Variation_1098_Arg: TypeAlias = Union[int, Variation_1098_Arg_Group]
class Variation_1098(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_312, 1), (Item_1111, 3), (Item_22, 4)]
    cv_items_dict = {"EP": RuleVariation_70, "VAL": RuleVariation_471}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_70:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_471:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_70:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_471:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1098_Arg) -> 'Variation_1098':
        return cls._create(arg) # type: ignore

RuleVariation_1056_Arg: TypeAlias = Variation_1098_Arg
class RuleVariation_1056(RuleVariationContextFree):
    cv_variation = Variation_1098

    @classmethod
    def create(cls, arg : RuleVariation_1056_Arg) -> "RuleVariation_1056":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1098:
        return self.arg # type: ignore

NonSpare_1461_Arg: TypeAlias = RuleVariation_1056_Arg
class NonSpare_1461(NonSpare):
    cv_name = "PS3"
    cv_title = "Priority Status for Version 3 ADS-B Systems"
    cv_rule = RuleVariation_1056

    @classmethod
    def create(cls, arg : NonSpare_1461_Arg) -> "NonSpare_1461":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1056:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1098:
        return self.rule.variation

Content_384_Arg: TypeAlias = int
class Content_384(ContentTable):
    cv_values = {0: "Not RCE", 1: "TABS", 2: "Reserved for future use", 3: "Other RCE"}

RuleContent_384_Arg: TypeAlias = Content_384_Arg
class RuleContent_384(RuleContentContextFree):
    cv_content = Content_384

    @property
    def content(self) -> Content_384:
        return self._get_content() # type: ignore

Variation_473_Arg: TypeAlias = RuleContent_384_Arg
class Variation_473(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_384

    @classmethod
    def create(cls, arg : Variation_473_Arg) -> "Variation_473":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_384:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_384:
        return self.rule.content

RuleVariation_462_Arg: TypeAlias = Variation_473_Arg
class RuleVariation_462(RuleVariationContextFree):
    cv_variation = Variation_473

    @classmethod
    def create(cls, arg : RuleVariation_462_Arg) -> "RuleVariation_462":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_473:
        return self.arg # type: ignore

NonSpare_1999_Arg: TypeAlias = RuleVariation_462_Arg
class NonSpare_1999(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_462

    @classmethod
    def create(cls, arg : NonSpare_1999_Arg) -> "NonSpare_1999":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_462:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_473:
        return self.rule.variation

Item_1115_Arg: TypeAlias = NonSpare_1999_Arg
class Item_1115(Item):
    cv_non_spare = NonSpare_1999

    @classmethod
    def create(cls, arg : Item_1115_Arg) -> "Item_1115":
        return cls._create(arg) # type: ignore

Variation_1089_Arg_Group = Tuple[Union[RuleVariation_41_Arg, Tuple[Literal["EP"], RuleVariation_41_Arg]], Union[RuleVariation_462_Arg, Tuple[Literal["VAL"], RuleVariation_462_Arg]]]
Variation_1089_Arg: TypeAlias = Union[int, Variation_1089_Arg_Group]
class Variation_1089(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_items_list = [(Item_300, 1), (Item_1115, 2)]
    cv_items_dict = {"EP": RuleVariation_41, "VAL": RuleVariation_462}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_462:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_462:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1089_Arg) -> 'Variation_1089':
        return cls._create(arg) # type: ignore

RuleVariation_1047_Arg: TypeAlias = Variation_1089_Arg
class RuleVariation_1047(RuleVariationContextFree):
    cv_variation = Variation_1089

    @classmethod
    def create(cls, arg : RuleVariation_1047_Arg) -> "RuleVariation_1047":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1089:
        return self.arg # type: ignore

NonSpare_1545_Arg: TypeAlias = RuleVariation_1047_Arg
class NonSpare_1545(NonSpare):
    cv_name = "RCE"
    cv_title = "Reduced Capability Equipment"
    cv_rule = RuleVariation_1047

    @classmethod
    def create(cls, arg : NonSpare_1545_Arg) -> "NonSpare_1545":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1047:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1089:
        return self.rule.variation

Item_779_Arg: TypeAlias = NonSpare_1545_Arg
class Item_779(Item):
    cv_non_spare = NonSpare_1545

    @classmethod
    def create(cls, arg : Item_779_Arg) -> "Item_779":
        return cls._create(arg) # type: ignore

Variation_744_Arg: TypeAlias = RuleContent_436_Arg
class Variation_744(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_436

    @classmethod
    def create(cls, arg : Variation_744_Arg) -> "Variation_744":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_436:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_436:
        return self.rule.content

RuleVariation_733_Arg: TypeAlias = Variation_744_Arg
class RuleVariation_733(RuleVariationContextFree):
    cv_variation = Variation_744

    @classmethod
    def create(cls, arg : RuleVariation_733_Arg) -> "RuleVariation_733":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_744:
        return self.arg # type: ignore

NonSpare_2009_Arg: TypeAlias = RuleVariation_733_Arg
class NonSpare_2009(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_733

    @classmethod
    def create(cls, arg : NonSpare_2009_Arg) -> "NonSpare_2009":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_733:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_744:
        return self.rule.variation

Item_1125_Arg: TypeAlias = NonSpare_2009_Arg
class Item_1125(Item):
    cv_non_spare = NonSpare_2009

    @classmethod
    def create(cls, arg : Item_1125_Arg) -> "Item_1125":
        return cls._create(arg) # type: ignore

Variation_1322_Arg_Group = Tuple[Union[RuleVariation_625_Arg, Tuple[Literal["EP"], RuleVariation_625_Arg]], Union[RuleVariation_733_Arg, Tuple[Literal["VAL"], RuleVariation_733_Arg]]]
Variation_1322_Arg: TypeAlias = Union[int, Variation_1322_Arg_Group]
class Variation_1322(Group):
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_items_list = [(Item_302, 1), (Item_1125, 1)]
    cv_items_dict = {"EP": RuleVariation_625, "VAL": RuleVariation_733}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_625:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_733:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_625:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_733:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1322_Arg) -> 'Variation_1322':
        return cls._create(arg) # type: ignore

RuleVariation_1247_Arg: TypeAlias = Variation_1322_Arg
class RuleVariation_1247(RuleVariationContextFree):
    cv_variation = Variation_1322

    @classmethod
    def create(cls, arg : RuleVariation_1247_Arg) -> "RuleVariation_1247":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1322:
        return self.arg # type: ignore

NonSpare_1602_Arg: TypeAlias = RuleVariation_1247_Arg
class NonSpare_1602(NonSpare):
    cv_name = "RRL"
    cv_title = "Reply Rate Limiting"
    cv_rule = RuleVariation_1247

    @classmethod
    def create(cls, arg : NonSpare_1602_Arg) -> "NonSpare_1602":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1247:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1322:
        return self.rule.variation

Item_826_Arg: TypeAlias = NonSpare_1602_Arg
class Item_826(Item):
    cv_non_spare = NonSpare_1602

    @classmethod
    def create(cls, arg : Item_826_Arg) -> "Item_826":
        return cls._create(arg) # type: ignore

Variation_962_Arg: TypeAlias = RuleContent_529_Arg
class Variation_962(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 2
    cv_rule = RuleContent_529

    @classmethod
    def create(cls, arg : Variation_962_Arg) -> "Variation_962":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_529:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_529:
        return self.rule.content

RuleVariation_932_Arg: TypeAlias = Variation_962_Arg
class RuleVariation_932(RuleVariationContextFree):
    cv_variation = Variation_962

    @classmethod
    def create(cls, arg : RuleVariation_932_Arg) -> "RuleVariation_932":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_962:
        return self.arg # type: ignore

NonSpare_2017_Arg: TypeAlias = RuleVariation_932_Arg
class NonSpare_2017(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_932

    @classmethod
    def create(cls, arg : NonSpare_2017_Arg) -> "NonSpare_2017":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_932:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_962:
        return self.rule.variation

Item_1133_Arg: TypeAlias = NonSpare_2017_Arg
class Item_1133(Item):
    cv_non_spare = NonSpare_2017

    @classmethod
    def create(cls, arg : Item_1133_Arg) -> "Item_1133":
        return cls._create(arg) # type: ignore

Variation_1333_Arg_Group = Tuple[Union[RuleVariation_815_Arg, Tuple[Literal["EP"], RuleVariation_815_Arg]], Union[RuleVariation_932_Arg, Tuple[Literal["VAL"], RuleVariation_932_Arg]]]
Variation_1333_Arg: TypeAlias = Union[int, Variation_1333_Arg_Group]
class Variation_1333(Group):
    cv_bit_offset8 = 5
    cv_bit_size = 3
    cv_items_list = [(Item_304, 1), (Item_1133, 2)]
    cv_items_dict = {"EP": RuleVariation_815, "VAL": RuleVariation_932}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_815:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_932:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_815:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_932:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1333_Arg) -> 'Variation_1333':
        return cls._create(arg) # type: ignore

RuleVariation_1256_Arg: TypeAlias = Variation_1333_Arg
class RuleVariation_1256(RuleVariationContextFree):
    cv_variation = Variation_1333

    @classmethod
    def create(cls, arg : RuleVariation_1256_Arg) -> "RuleVariation_1256":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1333:
        return self.arg # type: ignore

NonSpare_1891_Arg: TypeAlias = RuleVariation_1256_Arg
class NonSpare_1891(NonSpare):
    cv_name = "TPW"
    cv_title = "Transmit Power"
    cv_rule = RuleVariation_1256

    @classmethod
    def create(cls, arg : NonSpare_1891_Arg) -> "NonSpare_1891":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1256:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1333:
        return self.rule.variation

Item_1020_Arg: TypeAlias = NonSpare_1891_Arg
class Item_1020(Item):
    cv_non_spare = NonSpare_1891

    @classmethod
    def create(cls, arg : Item_1020_Arg) -> "Item_1020":
        return cls._create(arg) # type: ignore

Content_550_Arg: TypeAlias = int
class Content_550(ContentTable):
    cv_values = {0: "Unknown", 1: "Transponder #1 (left/pilot side or single)", 2: "Transponder #2 (right/co-pilot side)", 3: "Transponder #3 (auxiliary or Back-up)"}

RuleContent_550_Arg: TypeAlias = Content_550_Arg
class RuleContent_550(RuleContentContextFree):
    cv_content = Content_550

    @property
    def content(self) -> Content_550:
        return self._get_content() # type: ignore

Variation_477_Arg: TypeAlias = RuleContent_550_Arg
class Variation_477(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_550

    @classmethod
    def create(cls, arg : Variation_477_Arg) -> "Variation_477":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_550:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_550:
        return self.rule.content

RuleVariation_466_Arg: TypeAlias = Variation_477_Arg
class RuleVariation_466(RuleVariationContextFree):
    cv_variation = Variation_477

    @classmethod
    def create(cls, arg : RuleVariation_466_Arg) -> "RuleVariation_466":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_477:
        return self.arg # type: ignore

NonSpare_2000_Arg: TypeAlias = RuleVariation_466_Arg
class NonSpare_2000(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_466

    @classmethod
    def create(cls, arg : NonSpare_2000_Arg) -> "NonSpare_2000":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_466:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_477:
        return self.rule.variation

Item_1116_Arg: TypeAlias = NonSpare_2000_Arg
class Item_1116(Item):
    cv_non_spare = NonSpare_2000

    @classmethod
    def create(cls, arg : Item_1116_Arg) -> "Item_1116":
        return cls._create(arg) # type: ignore

Variation_1090_Arg_Group = Tuple[Union[RuleVariation_41_Arg, Tuple[Literal["EP"], RuleVariation_41_Arg]], Union[RuleVariation_466_Arg, Tuple[Literal["VAL"], RuleVariation_466_Arg]]]
Variation_1090_Arg: TypeAlias = Union[int, Variation_1090_Arg_Group]
class Variation_1090(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_items_list = [(Item_300, 1), (Item_1116, 2)]
    cv_items_dict = {"EP": RuleVariation_41, "VAL": RuleVariation_466}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_466:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_466:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1090_Arg) -> 'Variation_1090':
        return cls._create(arg) # type: ignore

RuleVariation_1048_Arg: TypeAlias = Variation_1090_Arg
class RuleVariation_1048(RuleVariationContextFree):
    cv_variation = Variation_1090

    @classmethod
    def create(cls, arg : RuleVariation_1048_Arg) -> "RuleVariation_1048":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1090:
        return self.arg # type: ignore

NonSpare_1922_Arg: TypeAlias = RuleVariation_1048_Arg
class NonSpare_1922(NonSpare):
    cv_name = "TSI"
    cv_title = "Transponder Side Indication"
    cv_rule = RuleVariation_1048

    @classmethod
    def create(cls, arg : NonSpare_1922_Arg) -> "NonSpare_1922":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1048:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1090:
        return self.rule.variation

Item_1045_Arg: TypeAlias = NonSpare_1922_Arg
class Item_1045(Item):
    cv_non_spare = NonSpare_1922

    @classmethod
    def create(cls, arg : Item_1045_Arg) -> "Item_1045":
        return cls._create(arg) # type: ignore

Variation_758_Arg: TypeAlias = RuleContent_558_Arg
class Variation_758(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_558

    @classmethod
    def create(cls, arg : Variation_758_Arg) -> "Variation_758":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_558:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_558:
        return self.rule.content

RuleVariation_747_Arg: TypeAlias = Variation_758_Arg
class RuleVariation_747(RuleVariationContextFree):
    cv_variation = Variation_758

    @classmethod
    def create(cls, arg : RuleVariation_747_Arg) -> "RuleVariation_747":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_758:
        return self.arg # type: ignore

NonSpare_1556_Arg: TypeAlias = RuleVariation_747_Arg
class NonSpare_1556(NonSpare):
    cv_name = "RE"
    cv_title = "Range Exceeded"
    cv_rule = RuleVariation_747

    @classmethod
    def create(cls, arg : NonSpare_1556_Arg) -> "NonSpare_1556":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_747:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_758:
        return self.rule.variation

Item_788_Arg: TypeAlias = NonSpare_1556_Arg
class Item_788(Item):
    cv_non_spare = NonSpare_1556

    @classmethod
    def create(cls, arg : Item_788_Arg) -> "Item_788":
        return cls._create(arg) # type: ignore

Variation_890_Arg: TypeAlias = RuleContent_0_Arg
class Variation_890(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 6
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_890_Arg) -> "Variation_890":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_860_Arg: TypeAlias = Variation_890_Arg
class RuleVariation_860(RuleVariationContextFree):
    cv_variation = Variation_890

    @classmethod
    def create(cls, arg : RuleVariation_860_Arg) -> "RuleVariation_860":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_890:
        return self.arg # type: ignore

NonSpare_2014_Arg: TypeAlias = RuleVariation_860_Arg
class NonSpare_2014(NonSpare):
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule = RuleVariation_860

    @classmethod
    def create(cls, arg : NonSpare_2014_Arg) -> "NonSpare_2014":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_860:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_890:
        return self.rule.variation

Item_1130_Arg: TypeAlias = NonSpare_2014_Arg
class Item_1130(Item):
    cv_non_spare = NonSpare_2014

    @classmethod
    def create(cls, arg : Item_1130_Arg) -> "Item_1130":
        return cls._create(arg) # type: ignore

Variation_1320_Arg_Group = Tuple[Union[RuleVariation_625_Arg, Tuple[Literal["EP"], RuleVariation_625_Arg]], Union[RuleVariation_747_Arg, Tuple[Literal["RE"], RuleVariation_747_Arg]], Union[RuleVariation_860_Arg, Tuple[Literal["VAL"], RuleVariation_860_Arg]]]
Variation_1320_Arg: TypeAlias = Union[int, Variation_1320_Arg_Group]
class Variation_1320(Group):
    cv_bit_offset8 = 3
    cv_bit_size = 8
    cv_items_list = [(Item_302, 1), (Item_788, 1), (Item_1130, 6)]
    cv_items_dict = {"EP": RuleVariation_625, "RE": RuleVariation_747, "VAL": RuleVariation_860}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_625:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> RuleVariation_747:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_860:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["RE"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_625:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> RuleVariation_747:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_860:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1320_Arg) -> 'Variation_1320':
        return cls._create(arg) # type: ignore

RuleVariation_1245_Arg: TypeAlias = Variation_1320_Arg
class RuleVariation_1245(RuleVariationContextFree):
    cv_variation = Variation_1320

    @classmethod
    def create(cls, arg : RuleVariation_1245_Arg) -> "RuleVariation_1245":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1320:
        return self.arg # type: ignore

NonSpare_1816_Arg: TypeAlias = RuleVariation_1245_Arg
class NonSpare_1816(NonSpare):
    cv_name = "TAO"
    cv_title = "Transponder Antenna Offset"
    cv_rule = RuleVariation_1245

    @classmethod
    def create(cls, arg : NonSpare_1816_Arg) -> "NonSpare_1816":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1245:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1320:
        return self.rule.variation

Item_970_Arg: TypeAlias = NonSpare_1816_Arg
class Item_970(Item):
    cv_non_spare = NonSpare_1816

    @classmethod
    def create(cls, arg : Item_970_Arg) -> "Item_970":
        return cls._create(arg) # type: ignore

Variation_1164_Arg_Group = Tuple[Union[RuleVariation_1047_Arg, Tuple[Literal["RCE"], RuleVariation_1047_Arg]], Union[RuleVariation_1247_Arg, Tuple[Literal["RRL"], RuleVariation_1247_Arg]], Union[RuleVariation_1256_Arg, Tuple[Literal["TPW"], RuleVariation_1256_Arg]], Union[RuleVariation_1048_Arg, Tuple[Literal["TSI"], RuleVariation_1048_Arg]], Union[RuleVariation_1245_Arg, Tuple[Literal["TAO"], RuleVariation_1245_Arg]], int]
Variation_1164_Arg: TypeAlias = Union[int, Variation_1164_Arg_Group]
class Variation_1164(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_779, 3), (Item_826, 2), (Item_1020, 3), (Item_1045, 3), (Item_970, 8), (Item_19, 5)]
    cv_items_dict = {"RCE": RuleVariation_1047, "RRL": RuleVariation_1247, "TPW": RuleVariation_1256, "TSI": RuleVariation_1048, "TAO": RuleVariation_1245}

    @overload
    @classmethod
    def spec(cls, key : Literal["RCE"]) -> RuleVariation_1047:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RRL"]) -> RuleVariation_1247:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TPW"]) -> RuleVariation_1256:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TSI"]) -> RuleVariation_1048:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAO"]) -> RuleVariation_1245:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RCE"], Literal["RRL"], Literal["TPW"], Literal["TSI"], Literal["TAO"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RCE"]) -> RuleVariation_1047:
        ...
    @overload
    def get_item(self, key : Literal["RRL"]) -> RuleVariation_1247:
        ...
    @overload
    def get_item(self, key : Literal["TPW"]) -> RuleVariation_1256:
        ...
    @overload
    def get_item(self, key : Literal["TSI"]) -> RuleVariation_1048:
        ...
    @overload
    def get_item(self, key : Literal["TAO"]) -> RuleVariation_1245:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1164_Arg) -> 'Variation_1164':
        return cls._create(arg) # type: ignore

RuleVariation_1116_Arg: TypeAlias = Variation_1164_Arg
class RuleVariation_1116(RuleVariationContextFree):
    cv_variation = Variation_1164

    @classmethod
    def create(cls, arg : RuleVariation_1116_Arg) -> "RuleVariation_1116":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1164:
        return self.arg # type: ignore

NonSpare_629_Arg: TypeAlias = RuleVariation_1116_Arg
class NonSpare_629(NonSpare):
    cv_name = "AS"
    cv_title = "Aircraft Status"
    cv_rule = RuleVariation_1116

    @classmethod
    def create(cls, arg : NonSpare_629_Arg) -> "NonSpare_629":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1116:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1164:
        return self.rule.variation

Variation_1489_Arg = TypedDict('Variation_1489_Arg', {
    "PS3": NonSpare_1461_Arg,
    "AS": NonSpare_629_Arg,
}, total=False)
class Variation_1489(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1461, NonSpare_629]
    cv_items_dict = {"PS3": NonSpare_1461, "AS": NonSpare_629}

    @overload
    @classmethod
    def spec(cls, key : Literal["PS3"]) -> NonSpare_1461:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AS"]) -> NonSpare_629:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PS3"], Literal["AS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PS3"]) -> Optional[NonSpare_1461]:
        ...
    @overload
    def get_item(self, key : Literal["AS"]) -> Optional[NonSpare_629]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["PS3"], val : NonSpare_1461_Arg) -> "Variation_1489":
        ...
    @overload
    def set_item(self, key : Literal["AS"], val : NonSpare_629_Arg) -> "Variation_1489":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["PS3"]) -> "Variation_1489":
        ...
    @overload
    def del_item(self, key : Literal["AS"]) -> "Variation_1489":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1489_Arg) -> 'Variation_1489':
        return cls._create(arg) # type: ignore

RuleVariation_1412_Arg: TypeAlias = Variation_1489_Arg
class RuleVariation_1412(RuleVariationContextFree):
    cv_variation = Variation_1489

    @classmethod
    def create(cls, arg : RuleVariation_1412_Arg) -> "RuleVariation_1412":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1489:
        return self.arg # type: ignore

NonSpare_1983_Arg: TypeAlias = RuleVariation_1412_Arg
class NonSpare_1983(NonSpare):
    cv_name = "V3"
    cv_title = "ADS-B Version 3 Data"
    cv_rule = RuleVariation_1412

    @classmethod
    def create(cls, arg : NonSpare_1983_Arg) -> "NonSpare_1983":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1412:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1489:
        return self.rule.variation

Expansion_3_Arg = TypedDict('Expansion_3_Arg', {
    "CST": NonSpare_835_Arg,
    "CSN": NonSpare_829_Arg,
    "TVS": NonSpare_1945_Arg,
    "STS": NonSpare_1793_Arg,
    "V3": NonSpare_1983_Arg,
}, total=False)
class Expansion_3(Expansion):
    cv_fspec_bytes = 1
    cv_items_list = [NonSpare_835, NonSpare_829, NonSpare_1945, NonSpare_1793, NonSpare_1983]
    items_dict = {"CST": NonSpare_835, "CSN": NonSpare_829, "TVS": NonSpare_1945, "STS": NonSpare_1793, "V3": NonSpare_1983}

    @overload
    @classmethod
    def spec(cls, key : Literal["CST"]) -> NonSpare_835:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CSN"]) -> NonSpare_829:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TVS"]) -> NonSpare_1945:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STS"]) -> NonSpare_1793:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["V3"]) -> NonSpare_1983:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CST"], Literal["CSN"], Literal["TVS"], Literal["STS"], Literal["V3"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CST"]) -> Optional[NonSpare_835]:
        ...
    @overload
    def get_item(self, key : Literal["CSN"]) -> Optional[NonSpare_829]:
        ...
    @overload
    def get_item(self, key : Literal["TVS"]) -> Optional[NonSpare_1945]:
        ...
    @overload
    def get_item(self, key : Literal["STS"]) -> Optional[NonSpare_1793]:
        ...
    @overload
    def get_item(self, key : Literal["V3"]) -> Optional[NonSpare_1983]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["CST"], val : NonSpare_835_Arg) -> "Expansion_3":
        ...
    @overload
    def set_item(self, key : Literal["CSN"], val : NonSpare_829_Arg) -> "Expansion_3":
        ...
    @overload
    def set_item(self, key : Literal["TVS"], val : NonSpare_1945_Arg) -> "Expansion_3":
        ...
    @overload
    def set_item(self, key : Literal["STS"], val : NonSpare_1793_Arg) -> "Expansion_3":
        ...
    @overload
    def set_item(self, key : Literal["V3"], val : NonSpare_1983_Arg) -> "Expansion_3":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["CST"]) -> "Expansion_3":
        ...
    @overload
    def del_item(self, key : Literal["CSN"]) -> "Expansion_3":
        ...
    @overload
    def del_item(self, key : Literal["TVS"]) -> "Expansion_3":
        ...
    @overload
    def del_item(self, key : Literal["STS"]) -> "Expansion_3":
        ...
    @overload
    def del_item(self, key : Literal["V3"]) -> "Expansion_3":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Expansion_3_Arg) -> 'Expansion_3':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Expansion_3", Bits]]:
        return cls._parse(bs) # type: ignore

class Asterix_50(AstRef):
    cv_category = 62
    cv_edition = (1, 3)
    cv_expansion = Expansion_3

NonSpare_45_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_45(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_45_Arg) -> "NonSpare_45":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_45(UapItem):
    cv_non_spare = NonSpare_45

NonSpare_58_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_58(NonSpare):
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_58_Arg) -> "NonSpare_58":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_58(UapItem):
    cv_non_spare = NonSpare_58

NonSpare_213_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_213(NonSpare):
    cv_name = "070"
    cv_title = "Time Of Track Information"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_213_Arg) -> "NonSpare_213":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_213(UapItem):
    cv_non_spare = NonSpare_213

NonSpare_277_Arg: TypeAlias = RuleVariation_1080_Arg
class NonSpare_277(NonSpare):
    cv_name = "105"
    cv_title = "Calculated Position In WGS-84 Co-ordinates"
    cv_rule = RuleVariation_1080

    @classmethod
    def create(cls, arg : NonSpare_277_Arg) -> "NonSpare_277":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1080:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1123:
        return self.rule.variation

class UapItem_277(UapItem):
    cv_non_spare = NonSpare_277

NonSpare_2086_Arg: TypeAlias = RuleVariation_343_Arg
class NonSpare_2086(NonSpare):
    cv_name = "X"
    cv_title = "X Coordinate"
    cv_rule = RuleVariation_343

    @classmethod
    def create(cls, arg : NonSpare_2086_Arg) -> "NonSpare_2086":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_343:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_350:
        return self.rule.variation

Item_1193_Arg: TypeAlias = NonSpare_2086_Arg
class Item_1193(Item):
    cv_non_spare = NonSpare_2086

    @classmethod
    def create(cls, arg : Item_1193_Arg) -> "Item_1193":
        return cls._create(arg) # type: ignore

NonSpare_2140_Arg: TypeAlias = RuleVariation_343_Arg
class NonSpare_2140(NonSpare):
    cv_name = "Y"
    cv_title = "Y Coordinate"
    cv_rule = RuleVariation_343

    @classmethod
    def create(cls, arg : NonSpare_2140_Arg) -> "NonSpare_2140":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_343:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_350:
        return self.rule.variation

Item_1244_Arg: TypeAlias = NonSpare_2140_Arg
class Item_1244(Item):
    cv_non_spare = NonSpare_2140

    @classmethod
    def create(cls, arg : Item_1244_Arg) -> "Item_1244":
        return cls._create(arg) # type: ignore

Variation_1303_Arg_Group = Tuple[Union[RuleVariation_343_Arg, Tuple[Literal["X"], RuleVariation_343_Arg]], Union[RuleVariation_343_Arg, Tuple[Literal["Y"], RuleVariation_343_Arg]]]
Variation_1303_Arg: TypeAlias = Union[int, Variation_1303_Arg_Group]
class Variation_1303(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_1193, 24), (Item_1244, 24)]
    cv_items_dict = {"X": RuleVariation_343, "Y": RuleVariation_343}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_343:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_343:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_343:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_343:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1303_Arg) -> 'Variation_1303':
        return cls._create(arg) # type: ignore

RuleVariation_1232_Arg: TypeAlias = Variation_1303_Arg
class RuleVariation_1232(RuleVariationContextFree):
    cv_variation = Variation_1303

    @classmethod
    def create(cls, arg : RuleVariation_1232_Arg) -> "RuleVariation_1232":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1303:
        return self.arg # type: ignore

NonSpare_264_Arg: TypeAlias = RuleVariation_1232_Arg
class NonSpare_264(NonSpare):
    cv_name = "100"
    cv_title = "Calculated Track Position (Cartesian)"
    cv_rule = RuleVariation_1232

    @classmethod
    def create(cls, arg : NonSpare_264_Arg) -> "NonSpare_264":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1232:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1303:
        return self.rule.variation

class UapItem_264(UapItem):
    cv_non_spare = NonSpare_264

NonSpare_2040_Arg: TypeAlias = RuleVariation_271_Arg
class NonSpare_2040(NonSpare):
    cv_name = "VX"
    cv_title = "Velocity (X-component)"
    cv_rule = RuleVariation_271

    @classmethod
    def create(cls, arg : NonSpare_2040_Arg) -> "NonSpare_2040":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_271:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_278:
        return self.rule.variation

Item_1152_Arg: TypeAlias = NonSpare_2040_Arg
class Item_1152(Item):
    cv_non_spare = NonSpare_2040

    @classmethod
    def create(cls, arg : Item_1152_Arg) -> "Item_1152":
        return cls._create(arg) # type: ignore

NonSpare_2045_Arg: TypeAlias = RuleVariation_271_Arg
class NonSpare_2045(NonSpare):
    cv_name = "VY"
    cv_title = "Velocity (Y-component)"
    cv_rule = RuleVariation_271

    @classmethod
    def create(cls, arg : NonSpare_2045_Arg) -> "NonSpare_2045":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_271:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_278:
        return self.rule.variation

Item_1157_Arg: TypeAlias = NonSpare_2045_Arg
class Item_1157(Item):
    cv_non_spare = NonSpare_2045

    @classmethod
    def create(cls, arg : Item_1157_Arg) -> "Item_1157":
        return cls._create(arg) # type: ignore

Variation_1274_Arg_Group = Tuple[Union[RuleVariation_271_Arg, Tuple[Literal["VX"], RuleVariation_271_Arg]], Union[RuleVariation_271_Arg, Tuple[Literal["VY"], RuleVariation_271_Arg]]]
Variation_1274_Arg: TypeAlias = Union[int, Variation_1274_Arg_Group]
class Variation_1274(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1152, 16), (Item_1157, 16)]
    cv_items_dict = {"VX": RuleVariation_271, "VY": RuleVariation_271}

    @overload
    @classmethod
    def spec(cls, key : Literal["VX"]) -> RuleVariation_271:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VY"]) -> RuleVariation_271:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VX"], Literal["VY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VX"]) -> RuleVariation_271:
        ...
    @overload
    def get_item(self, key : Literal["VY"]) -> RuleVariation_271:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1274_Arg) -> 'Variation_1274':
        return cls._create(arg) # type: ignore

RuleVariation_1204_Arg: TypeAlias = Variation_1274_Arg
class RuleVariation_1204(RuleVariationContextFree):
    cv_variation = Variation_1274

    @classmethod
    def create(cls, arg : RuleVariation_1204_Arg) -> "RuleVariation_1204":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1274:
        return self.arg # type: ignore

NonSpare_381_Arg: TypeAlias = RuleVariation_1204_Arg
class NonSpare_381(NonSpare):
    cv_name = "185"
    cv_title = "Calculated Track Velocity (Cartesian)"
    cv_rule = RuleVariation_1204

    @classmethod
    def create(cls, arg : NonSpare_381_Arg) -> "NonSpare_381":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1204:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1274:
        return self.rule.variation

class UapItem_381(UapItem):
    cv_non_spare = NonSpare_381

Content_661_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
class Content_661(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.25
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

RuleContent_661_Arg: TypeAlias = Content_661_Arg
class RuleContent_661(RuleContentContextFree):
    cv_content = Content_661

    @property
    def content(self) -> Content_661:
        return self._get_content() # type: ignore

Variation_209_Arg: TypeAlias = RuleContent_661_Arg
class Variation_209(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_661

    @classmethod
    def create(cls, arg : Variation_209_Arg) -> "Variation_209":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_661:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_661:
        return self.rule.content

RuleVariation_202_Arg: TypeAlias = Variation_209_Arg
class RuleVariation_202(RuleVariationContextFree):
    cv_variation = Variation_209

    @classmethod
    def create(cls, arg : RuleVariation_202_Arg) -> "RuleVariation_202":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_209:
        return self.arg # type: ignore

NonSpare_649_Arg: TypeAlias = RuleVariation_202_Arg
class NonSpare_649(NonSpare):
    cv_name = "AX"
    cv_title = ""
    cv_rule = RuleVariation_202

    @classmethod
    def create(cls, arg : NonSpare_649_Arg) -> "NonSpare_649":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_202:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_209:
        return self.rule.variation

Item_97_Arg: TypeAlias = NonSpare_649_Arg
class Item_97(Item):
    cv_non_spare = NonSpare_649

    @classmethod
    def create(cls, arg : Item_97_Arg) -> "Item_97":
        return cls._create(arg) # type: ignore

NonSpare_653_Arg: TypeAlias = RuleVariation_202_Arg
class NonSpare_653(NonSpare):
    cv_name = "AY"
    cv_title = ""
    cv_rule = RuleVariation_202

    @classmethod
    def create(cls, arg : NonSpare_653_Arg) -> "NonSpare_653":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_202:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_209:
        return self.rule.variation

Item_101_Arg: TypeAlias = NonSpare_653_Arg
class Item_101(Item):
    cv_non_spare = NonSpare_653

    @classmethod
    def create(cls, arg : Item_101_Arg) -> "Item_101":
        return cls._create(arg) # type: ignore

Variation_1051_Arg_Group = Tuple[Union[RuleVariation_202_Arg, Tuple[Literal["AX"], RuleVariation_202_Arg]], Union[RuleVariation_202_Arg, Tuple[Literal["AY"], RuleVariation_202_Arg]]]
Variation_1051_Arg: TypeAlias = Union[int, Variation_1051_Arg_Group]
class Variation_1051(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_97, 8), (Item_101, 8)]
    cv_items_dict = {"AX": RuleVariation_202, "AY": RuleVariation_202}

    @overload
    @classmethod
    def spec(cls, key : Literal["AX"]) -> RuleVariation_202:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AY"]) -> RuleVariation_202:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AX"], Literal["AY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AX"]) -> RuleVariation_202:
        ...
    @overload
    def get_item(self, key : Literal["AY"]) -> RuleVariation_202:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1051_Arg) -> 'Variation_1051':
        return cls._create(arg) # type: ignore

RuleVariation_1018_Arg: TypeAlias = Variation_1051_Arg
class RuleVariation_1018(RuleVariationContextFree):
    cv_variation = Variation_1051

    @classmethod
    def create(cls, arg : RuleVariation_1018_Arg) -> "RuleVariation_1018":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1051:
        return self.arg # type: ignore

NonSpare_405_Arg: TypeAlias = RuleVariation_1018_Arg
class NonSpare_405(NonSpare):
    cv_name = "210"
    cv_title = "Calculated Acceleration (Cartesian)"
    cv_rule = RuleVariation_1018

    @classmethod
    def create(cls, arg : NonSpare_405_Arg) -> "NonSpare_405":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1018:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1051:
        return self.rule.variation

class UapItem_405(UapItem):
    cv_non_spare = NonSpare_405

Content_331_Arg: TypeAlias = int
class Content_331(ContentTable):
    cv_values = {0: "No change", 1: "Mode 3/A has changed"}

RuleContent_331_Arg: TypeAlias = Content_331_Arg
class RuleContent_331(RuleContentContextFree):
    cv_content = Content_331

    @property
    def content(self) -> Content_331:
        return self._get_content() # type: ignore

Variation_559_Arg: TypeAlias = RuleContent_331_Arg
class Variation_559(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_331

    @classmethod
    def create(cls, arg : Variation_559_Arg) -> "Variation_559":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_331:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_331:
        return self.rule.content

RuleVariation_548_Arg: TypeAlias = Variation_559_Arg
class RuleVariation_548(RuleVariationContextFree):
    cv_variation = Variation_559

    @classmethod
    def create(cls, arg : RuleVariation_548_Arg) -> "RuleVariation_548":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_559:
        return self.arg # type: ignore

NonSpare_722_Arg: TypeAlias = RuleVariation_548_Arg
class NonSpare_722(NonSpare):
    cv_name = "CH"
    cv_title = "Change in Mode 3/A"
    cv_rule = RuleVariation_548

    @classmethod
    def create(cls, arg : NonSpare_722_Arg) -> "NonSpare_722":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_548:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_559:
        return self.rule.variation

Item_150_Arg: TypeAlias = NonSpare_722_Arg
class Item_150(Item):
    cv_non_spare = NonSpare_722

    @classmethod
    def create(cls, arg : Item_150_Arg) -> "Item_150":
        return cls._create(arg) # type: ignore

Variation_1263_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_548_Arg, Tuple[Literal["CH"], RuleVariation_548_Arg]], int, Union[RuleVariation_776_Arg, Tuple[Literal["MODE3A"], RuleVariation_776_Arg]]]
Variation_1263_Arg: TypeAlias = Union[int, Variation_1263_Arg_Group]
class Variation_1263(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1100, 1), (Item_355, 1), (Item_150, 1), (Item_16, 1), (Item_572, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "CH": RuleVariation_548, "MODE3A": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CH"]) -> RuleVariation_548:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["CH"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["CH"]) -> RuleVariation_548:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1263_Arg) -> 'Variation_1263':
        return cls._create(arg) # type: ignore

RuleVariation_1193_Arg: TypeAlias = Variation_1263_Arg
class RuleVariation_1193(RuleVariationContextFree):
    cv_variation = Variation_1263

    @classmethod
    def create(cls, arg : RuleVariation_1193_Arg) -> "RuleVariation_1193":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1263:
        return self.arg # type: ignore

NonSpare_198_Arg: TypeAlias = RuleVariation_1193_Arg
class NonSpare_198(NonSpare):
    cv_name = "060"
    cv_title = "Track Mode 3/A Code"
    cv_rule = RuleVariation_1193

    @classmethod
    def create(cls, arg : NonSpare_198_Arg) -> "NonSpare_198":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1193:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1263:
        return self.rule.variation

class UapItem_198(UapItem):
    cv_non_spare = NonSpare_198

Content_50_Arg: TypeAlias = int
class Content_50(ContentTable):
    cv_values = {0: "Callsign or registration downlinked from target", 1: "Callsign not downlinked from target", 2: "Registration not downlinked from target", 3: "Invalid"}

RuleContent_50_Arg: TypeAlias = Content_50_Arg
class RuleContent_50(RuleContentContextFree):
    cv_content = Content_50

    @property
    def content(self) -> Content_50:
        return self._get_content() # type: ignore

Variation_96_Arg: TypeAlias = RuleContent_50_Arg
class Variation_96(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_50

    @classmethod
    def create(cls, arg : Variation_96_Arg) -> "Variation_96":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_50:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_50:
        return self.rule.content

RuleVariation_96_Arg: TypeAlias = Variation_96_Arg
class RuleVariation_96(RuleVariationContextFree):
    cv_variation = Variation_96

    @classmethod
    def create(cls, arg : RuleVariation_96_Arg) -> "RuleVariation_96":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_96:
        return self.arg # type: ignore

NonSpare_1781_Arg: TypeAlias = RuleVariation_96_Arg
class NonSpare_1781(NonSpare):
    cv_name = "STI"
    cv_title = ""
    cv_rule = RuleVariation_96

    @classmethod
    def create(cls, arg : NonSpare_1781_Arg) -> "NonSpare_1781":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_96:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_96:
        return self.rule.variation

Item_947_Arg: TypeAlias = NonSpare_1781_Arg
class Item_947(Item):
    cv_non_spare = NonSpare_1781

    @classmethod
    def create(cls, arg : Item_947_Arg) -> "Item_947":
        return cls._create(arg) # type: ignore

Variation_1209_Arg_Group = Tuple[Union[RuleVariation_96_Arg, Tuple[Literal["STI"], RuleVariation_96_Arg]], int, Union[RuleVariation_381_Arg, Tuple[Literal["CHR"], RuleVariation_381_Arg]]]
Variation_1209_Arg: TypeAlias = Union[int, Variation_1209_Arg_Group]
class Variation_1209(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_items_list = [(Item_947, 2), (Item_15, 6), (Item_157, 48)]
    cv_items_dict = {"STI": RuleVariation_96, "CHR": RuleVariation_381}

    @overload
    @classmethod
    def spec(cls, key : Literal["STI"]) -> RuleVariation_96:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CHR"]) -> RuleVariation_381:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["STI"], Literal["CHR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["STI"]) -> RuleVariation_96:
        ...
    @overload
    def get_item(self, key : Literal["CHR"]) -> RuleVariation_381:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1209_Arg) -> 'Variation_1209':
        return cls._create(arg) # type: ignore

RuleVariation_1154_Arg: TypeAlias = Variation_1209_Arg
class RuleVariation_1154(RuleVariationContextFree):
    cv_variation = Variation_1209

    @classmethod
    def create(cls, arg : RuleVariation_1154_Arg) -> "RuleVariation_1154":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1209:
        return self.arg # type: ignore

NonSpare_435_Arg: TypeAlias = RuleVariation_1154_Arg
class NonSpare_435(NonSpare):
    cv_name = "245"
    cv_title = "Target Identification"
    cv_rule = RuleVariation_1154

    @classmethod
    def create(cls, arg : NonSpare_435_Arg) -> "NonSpare_435":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1154:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1209:
        return self.rule.variation

class UapItem_435(UapItem):
    cv_non_spare = NonSpare_435

NonSpare_567_Arg: TypeAlias = RuleVariation_340_Arg
class NonSpare_567(NonSpare):
    cv_name = "ADR"
    cv_title = "Target Address"
    cv_rule = RuleVariation_340

    @classmethod
    def create(cls, arg : NonSpare_567_Arg) -> "NonSpare_567":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_340:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_347:
        return self.rule.variation

NonSpare_1103_Arg: TypeAlias = RuleVariation_381_Arg
class NonSpare_1103(NonSpare):
    cv_name = "ID"
    cv_title = "Target Identification"
    cv_rule = RuleVariation_381

    @classmethod
    def create(cls, arg : NonSpare_1103_Arg) -> "NonSpare_1103":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_381:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_389:
        return self.rule.variation

NonSpare_1270_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_1270(NonSpare):
    cv_name = "MHG"
    cv_title = "Magnetic Heading"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_1270_Arg) -> "NonSpare_1270":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Content_23_Arg: TypeAlias = int
class Content_23(ContentTable):
    cv_values = {0: "Air Speed = IAS, LSB (Bit-1) = 2^-14 NM/s", 1: "Air Speed = Mach, LSB (Bit-1) = 0.001"}

RuleContent_23_Arg: TypeAlias = Content_23_Arg
class RuleContent_23(RuleContentContextFree):
    cv_content = Content_23

    @property
    def content(self) -> Content_23:
        return self._get_content() # type: ignore

Variation_8_Arg: TypeAlias = RuleContent_23_Arg
class Variation_8(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_23

    @classmethod
    def create(cls, arg : Variation_8_Arg) -> "Variation_8":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_23:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_23:
        return self.rule.content

RuleVariation_8_Arg: TypeAlias = Variation_8_Arg
class RuleVariation_8(RuleVariationContextFree):
    cv_variation = Variation_8

    @classmethod
    def create(cls, arg : RuleVariation_8_Arg) -> "RuleVariation_8":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_8:
        return self.arg # type: ignore

NonSpare_1113_Arg: TypeAlias = RuleVariation_8_Arg
class NonSpare_1113(NonSpare):
    cv_name = "IM"
    cv_title = ""
    cv_rule = RuleVariation_8

    @classmethod
    def create(cls, arg : NonSpare_1113_Arg) -> "NonSpare_1113":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_8:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_8:
        return self.rule.variation

Item_433_Arg: TypeAlias = NonSpare_1113_Arg
class Item_433(Item):
    cv_non_spare = NonSpare_1113

    @classmethod
    def create(cls, arg : Item_433_Arg) -> "Item_433":
        return cls._create(arg) # type: ignore

RuleContent_798_Arg = Union[
    Tuple[None, Content_0_Arg],
    Tuple[Tuple[Literal[0]], Content_775_Arg],
    Tuple[Tuple[Literal[1]], Content_747_Arg],
]
class RuleContent_798(RuleContentDependent):
    cv_depends_on = [["380", "IAS", "IM"]]
    cv_default_content = Content_0
    cv_cases = [
        ([0], Content_775),
        ([1], Content_747),
    ]

    @overload
    def content(self, arg : Literal[None]) -> Content_0:
        ...
    @overload
    def content(self, arg : Tuple[Literal[0]]) -> Content_775:
        ...
    @overload
    def content(self, arg : Tuple[Literal[1]]) -> Content_747:
        ...
    def content(self, arg : Any) -> Any:
        return self._get_content(arg)

Variation_503_Arg: TypeAlias = RuleContent_798_Arg
class Variation_503(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 15
    cv_rule = RuleContent_798

    @classmethod
    def create(cls, arg : Variation_503_Arg) -> "Variation_503":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_798:
        return self._get_rule() # type: ignore

RuleVariation_492_Arg: TypeAlias = Variation_503_Arg
class RuleVariation_492(RuleVariationContextFree):
    cv_variation = Variation_503

    @classmethod
    def create(cls, arg : RuleVariation_492_Arg) -> "RuleVariation_492":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_503:
        return self.arg # type: ignore

NonSpare_1094_Arg: TypeAlias = RuleVariation_492_Arg
class NonSpare_1094(NonSpare):
    cv_name = "IAS"
    cv_title = ""
    cv_rule = RuleVariation_492

    @classmethod
    def create(cls, arg : NonSpare_1094_Arg) -> "NonSpare_1094":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_492:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_503:
        return self.rule.variation

Item_420_Arg: TypeAlias = NonSpare_1094_Arg
class Item_420(Item):
    cv_non_spare = NonSpare_1094

    @classmethod
    def create(cls, arg : Item_420_Arg) -> "Item_420":
        return cls._create(arg) # type: ignore

Variation_1116_Arg_Group = Tuple[Union[RuleVariation_8_Arg, Tuple[Literal["IM"], RuleVariation_8_Arg]], Union[RuleVariation_492_Arg, Tuple[Literal["IAS"], RuleVariation_492_Arg]]]
Variation_1116_Arg: TypeAlias = Union[int, Variation_1116_Arg_Group]
class Variation_1116(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_433, 1), (Item_420, 15)]
    cv_items_dict = {"IM": RuleVariation_8, "IAS": RuleVariation_492}

    @overload
    @classmethod
    def spec(cls, key : Literal["IM"]) -> RuleVariation_8:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAS"]) -> RuleVariation_492:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["IM"], Literal["IAS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["IM"]) -> RuleVariation_8:
        ...
    @overload
    def get_item(self, key : Literal["IAS"]) -> RuleVariation_492:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1116_Arg) -> 'Variation_1116':
        return cls._create(arg) # type: ignore

RuleVariation_1073_Arg: TypeAlias = Variation_1116_Arg
class RuleVariation_1073(RuleVariationContextFree):
    cv_variation = Variation_1116

    @classmethod
    def create(cls, arg : RuleVariation_1073_Arg) -> "RuleVariation_1073":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1116:
        return self.arg # type: ignore

NonSpare_1096_Arg: TypeAlias = RuleVariation_1073_Arg
class NonSpare_1096(NonSpare):
    cv_name = "IAS"
    cv_title = "Indicated Airspeed/Mach No"
    cv_rule = RuleVariation_1073

    @classmethod
    def create(cls, arg : NonSpare_1096_Arg) -> "NonSpare_1096":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1073:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1116:
        return self.rule.variation

Content_715_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["kt"]]]
class Content_715(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = "kt"

    def as_quantity(self, cv_unit : Optional[Literal["kt"]] = None) -> float:
        return self._as_quantity()

RuleContent_715_Arg: TypeAlias = Content_715_Arg
class RuleContent_715(RuleContentContextFree):
    cv_content = Content_715

    @property
    def content(self) -> Content_715:
        return self._get_content() # type: ignore

Variation_302_Arg: TypeAlias = RuleContent_715_Arg
class Variation_302(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_715

    @classmethod
    def create(cls, arg : Variation_302_Arg) -> "Variation_302":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_715:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_715:
        return self.rule.content

RuleVariation_295_Arg: TypeAlias = Variation_302_Arg
class RuleVariation_295(RuleVariationContextFree):
    cv_variation = Variation_302

    @classmethod
    def create(cls, arg : RuleVariation_295_Arg) -> "RuleVariation_295":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_302:
        return self.arg # type: ignore

NonSpare_1823_Arg: TypeAlias = RuleVariation_295_Arg
class NonSpare_1823(NonSpare):
    cv_name = "TAS"
    cv_title = "True Airspeed"
    cv_rule = RuleVariation_295

    @classmethod
    def create(cls, arg : NonSpare_1823_Arg) -> "NonSpare_1823":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_295:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_302:
        return self.rule.variation

Content_372_Arg: TypeAlias = int
class Content_372(ContentTable):
    cv_values = {0: "No source information provided", 1: "Source information provided"}

RuleContent_372_Arg: TypeAlias = Content_372_Arg
class RuleContent_372(RuleContentContextFree):
    cv_content = Content_372

    @property
    def content(self) -> Content_372:
        return self._get_content() # type: ignore

Variation_64_Arg: TypeAlias = RuleContent_372_Arg
class Variation_64(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_372

    @classmethod
    def create(cls, arg : Variation_64_Arg) -> "Variation_64":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_372:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_372:
        return self.rule.content

RuleVariation_64_Arg: TypeAlias = Variation_64_Arg
class RuleVariation_64(RuleVariationContextFree):
    cv_variation = Variation_64

    @classmethod
    def create(cls, arg : RuleVariation_64_Arg) -> "RuleVariation_64":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_64:
        return self.arg # type: ignore

NonSpare_1653_Arg: TypeAlias = RuleVariation_64_Arg
class NonSpare_1653(NonSpare):
    cv_name = "SAS"
    cv_title = ""
    cv_rule = RuleVariation_64

    @classmethod
    def create(cls, arg : NonSpare_1653_Arg) -> "NonSpare_1653":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_64:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_64:
        return self.rule.variation

Item_856_Arg: TypeAlias = NonSpare_1653_Arg
class Item_856(Item):
    cv_non_spare = NonSpare_1653

    @classmethod
    def create(cls, arg : Item_856_Arg) -> "Item_856":
        return cls._create(arg) # type: ignore

Content_537_Arg: TypeAlias = int
class Content_537(ContentTable):
    cv_values = {0: "Unknown", 1: "Aircraft altitude", 2: "FCU/MCP selected altitude", 3: "FMS selected altitude"}

RuleContent_537_Arg: TypeAlias = Content_537_Arg
class RuleContent_537(RuleContentContextFree):
    cv_content = Content_537

    @property
    def content(self) -> Content_537:
        return self._get_content() # type: ignore

Variation_476_Arg: TypeAlias = RuleContent_537_Arg
class Variation_476(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_537

    @classmethod
    def create(cls, arg : Variation_476_Arg) -> "Variation_476":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_537:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_537:
        return self.rule.content

RuleVariation_465_Arg: TypeAlias = Variation_476_Arg
class RuleVariation_465(RuleVariationContextFree):
    cv_variation = Variation_476

    @classmethod
    def create(cls, arg : RuleVariation_465_Arg) -> "RuleVariation_465":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_476:
        return self.arg # type: ignore

NonSpare_1738_Arg: TypeAlias = RuleVariation_465_Arg
class NonSpare_1738(NonSpare):
    cv_name = "SRC"
    cv_title = ""
    cv_rule = RuleVariation_465

    @classmethod
    def create(cls, arg : NonSpare_1738_Arg) -> "NonSpare_1738":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_465:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_476:
        return self.rule.variation

Item_917_Arg: TypeAlias = NonSpare_1738_Arg
class Item_917(Item):
    cv_non_spare = NonSpare_1738

    @classmethod
    def create(cls, arg : Item_917_Arg) -> "Item_917":
        return cls._create(arg) # type: ignore

Content_633_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
class Content_633(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 25.0
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

RuleContent_633_Arg: TypeAlias = Content_633_Arg
class RuleContent_633(RuleContentContextFree):
    cv_content = Content_633

    @property
    def content(self) -> Content_633:
        return self._get_content() # type: ignore

Variation_695_Arg: TypeAlias = RuleContent_633_Arg
class Variation_695(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 13
    cv_rule = RuleContent_633

    @classmethod
    def create(cls, arg : Variation_695_Arg) -> "Variation_695":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_633:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_633:
        return self.rule.content

RuleVariation_684_Arg: TypeAlias = Variation_695_Arg
class RuleVariation_684(RuleVariationContextFree):
    cv_variation = Variation_695

    @classmethod
    def create(cls, arg : RuleVariation_684_Arg) -> "RuleVariation_684":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_695:
        return self.arg # type: ignore

NonSpare_590_Arg: TypeAlias = RuleVariation_684_Arg
class NonSpare_590(NonSpare):
    cv_name = "ALT"
    cv_title = "Altitude in Two's Complement Form"
    cv_rule = RuleVariation_684

    @classmethod
    def create(cls, arg : NonSpare_590_Arg) -> "NonSpare_590":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_684:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_695:
        return self.rule.variation

Item_62_Arg: TypeAlias = NonSpare_590_Arg
class Item_62(Item):
    cv_non_spare = NonSpare_590

    @classmethod
    def create(cls, arg : Item_62_Arg) -> "Item_62":
        return cls._create(arg) # type: ignore

Variation_1193_Arg_Group = Tuple[Union[RuleVariation_64_Arg, Tuple[Literal["SAS"], RuleVariation_64_Arg]], Union[RuleVariation_465_Arg, Tuple[Literal["SRC"], RuleVariation_465_Arg]], Union[RuleVariation_684_Arg, Tuple[Literal["ALT"], RuleVariation_684_Arg]]]
Variation_1193_Arg: TypeAlias = Union[int, Variation_1193_Arg_Group]
class Variation_1193(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_856, 1), (Item_917, 2), (Item_62, 13)]
    cv_items_dict = {"SAS": RuleVariation_64, "SRC": RuleVariation_465, "ALT": RuleVariation_684}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAS"]) -> RuleVariation_64:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SRC"]) -> RuleVariation_465:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_684:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAS"], Literal["SRC"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAS"]) -> RuleVariation_64:
        ...
    @overload
    def get_item(self, key : Literal["SRC"]) -> RuleVariation_465:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_684:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1193_Arg) -> 'Variation_1193':
        return cls._create(arg) # type: ignore

RuleVariation_1138_Arg: TypeAlias = Variation_1193_Arg
class RuleVariation_1138(RuleVariationContextFree):
    cv_variation = Variation_1193

    @classmethod
    def create(cls, arg : RuleVariation_1138_Arg) -> "RuleVariation_1138":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1193:
        return self.arg # type: ignore

NonSpare_1648_Arg: TypeAlias = RuleVariation_1138_Arg
class NonSpare_1648(NonSpare):
    cv_name = "SAL"
    cv_title = "Selected Altitude"
    cv_rule = RuleVariation_1138

    @classmethod
    def create(cls, arg : NonSpare_1648_Arg) -> "NonSpare_1648":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1138:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1193:
        return self.rule.variation

NonSpare_1330_Arg: TypeAlias = RuleVariation_66_Arg
class NonSpare_1330(NonSpare):
    cv_name = "MV"
    cv_title = "Manage Vertical Mode"
    cv_rule = RuleVariation_66

    @classmethod
    def create(cls, arg : NonSpare_1330_Arg) -> "NonSpare_1330":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_66:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_66:
        return self.rule.variation

Item_599_Arg: TypeAlias = NonSpare_1330_Arg
class Item_599(Item):
    cv_non_spare = NonSpare_1330

    @classmethod
    def create(cls, arg : Item_599_Arg) -> "Item_599":
        return cls._create(arg) # type: ignore

NonSpare_577_Arg: TypeAlias = RuleVariation_430_Arg
class NonSpare_577(NonSpare):
    cv_name = "AH"
    cv_title = "Altitude Hold"
    cv_rule = RuleVariation_430

    @classmethod
    def create(cls, arg : NonSpare_577_Arg) -> "NonSpare_577":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_430:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_441:
        return self.rule.variation

Item_51_Arg: TypeAlias = NonSpare_577_Arg
class Item_51(Item):
    cv_non_spare = NonSpare_577

    @classmethod
    def create(cls, arg : Item_51_Arg) -> "Item_51":
        return cls._create(arg) # type: ignore

NonSpare_599_Arg: TypeAlias = RuleVariation_553_Arg
class NonSpare_599(NonSpare):
    cv_name = "AM"
    cv_title = "Approach Mode"
    cv_rule = RuleVariation_553

    @classmethod
    def create(cls, arg : NonSpare_599_Arg) -> "NonSpare_599":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_553:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_564:
        return self.rule.variation

Item_68_Arg: TypeAlias = NonSpare_599_Arg
class Item_68(Item):
    cv_non_spare = NonSpare_599

    @classmethod
    def create(cls, arg : Item_68_Arg) -> "Item_68":
        return cls._create(arg) # type: ignore

Variation_1141_Arg_Group = Tuple[Union[RuleVariation_66_Arg, Tuple[Literal["MV"], RuleVariation_66_Arg]], Union[RuleVariation_430_Arg, Tuple[Literal["AH"], RuleVariation_430_Arg]], Union[RuleVariation_553_Arg, Tuple[Literal["AM"], RuleVariation_553_Arg]], Union[RuleVariation_684_Arg, Tuple[Literal["ALT"], RuleVariation_684_Arg]]]
Variation_1141_Arg: TypeAlias = Union[int, Variation_1141_Arg_Group]
class Variation_1141(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_599, 1), (Item_51, 1), (Item_68, 1), (Item_62, 13)]
    cv_items_dict = {"MV": RuleVariation_66, "AH": RuleVariation_430, "AM": RuleVariation_553, "ALT": RuleVariation_684}

    @overload
    @classmethod
    def spec(cls, key : Literal["MV"]) -> RuleVariation_66:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AH"]) -> RuleVariation_430:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AM"]) -> RuleVariation_553:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_684:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MV"], Literal["AH"], Literal["AM"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MV"]) -> RuleVariation_66:
        ...
    @overload
    def get_item(self, key : Literal["AH"]) -> RuleVariation_430:
        ...
    @overload
    def get_item(self, key : Literal["AM"]) -> RuleVariation_553:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_684:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1141_Arg) -> 'Variation_1141':
        return cls._create(arg) # type: ignore

RuleVariation_1095_Arg: TypeAlias = Variation_1141_Arg
class RuleVariation_1095(RuleVariationContextFree):
    cv_variation = Variation_1141

    @classmethod
    def create(cls, arg : RuleVariation_1095_Arg) -> "RuleVariation_1095":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1141:
        return self.arg # type: ignore

NonSpare_994_Arg: TypeAlias = RuleVariation_1095_Arg
class NonSpare_994(NonSpare):
    cv_name = "FSS"
    cv_title = "Final State Selected Altitude"
    cv_rule = RuleVariation_1095

    @classmethod
    def create(cls, arg : NonSpare_994_Arg) -> "NonSpare_994":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1095:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1141:
        return self.rule.variation

Content_517_Arg: TypeAlias = int
class Content_517(ContentTable):
    cv_values = {0: "Trajectory intent data is available for this aircraft", 1: "Trajectory intent data is not available for this aircraft"}

RuleContent_517_Arg: TypeAlias = Content_517_Arg
class RuleContent_517(RuleContentContextFree):
    cv_content = Content_517

    @property
    def content(self) -> Content_517:
        return self._get_content() # type: ignore

Variation_92_Arg: TypeAlias = RuleContent_517_Arg
class Variation_92(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_517

    @classmethod
    def create(cls, arg : Variation_92_Arg) -> "Variation_92":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_517:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_517:
        return self.rule.content

RuleVariation_92_Arg: TypeAlias = Variation_92_Arg
class RuleVariation_92(RuleVariationContextFree):
    cv_variation = Variation_92

    @classmethod
    def create(cls, arg : RuleVariation_92_Arg) -> "RuleVariation_92":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_92:
        return self.arg # type: ignore

Content_518_Arg: TypeAlias = int
class Content_518(ContentTable):
    cv_values = {0: "Trajectory intent data is valid", 1: "Trajectory intent data is not valid"}

RuleContent_518_Arg: TypeAlias = Content_518_Arg
class RuleContent_518(RuleContentContextFree):
    cv_content = Content_518

    @property
    def content(self) -> Content_518:
        return self._get_content() # type: ignore

Variation_458_Arg: TypeAlias = RuleContent_518_Arg
class Variation_458(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_518

    @classmethod
    def create(cls, arg : Variation_458_Arg) -> "Variation_458":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_518:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_518:
        return self.rule.content

RuleVariation_447_Arg: TypeAlias = Variation_458_Arg
class RuleVariation_447(RuleVariationContextFree):
    cv_variation = Variation_458

    @classmethod
    def create(cls, arg : RuleVariation_447_Arg) -> "RuleVariation_447":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_458:
        return self.arg # type: ignore

NonSpare_1339_Arg: TypeAlias = RuleVariation_92_Arg
class NonSpare_1339(NonSpare):
    cv_name = "NAV"
    cv_title = "TID Available"
    cv_rule = RuleVariation_92

    @classmethod
    def create(cls, arg : NonSpare_1339_Arg) -> "NonSpare_1339":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_92:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_92:
        return self.rule.variation

Item_605_Arg: TypeAlias = NonSpare_1339_Arg
class Item_605(Item):
    cv_non_spare = NonSpare_1339

    @classmethod
    def create(cls, arg : Item_605_Arg) -> "Item_605":
        return cls._create(arg) # type: ignore

NonSpare_1378_Arg: TypeAlias = RuleVariation_447_Arg
class NonSpare_1378(NonSpare):
    cv_name = "NVB"
    cv_title = "TID Valid"
    cv_rule = RuleVariation_447

    @classmethod
    def create(cls, arg : NonSpare_1378_Arg) -> "NonSpare_1378":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_447:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_458:
        return self.rule.variation

Item_643_Arg: TypeAlias = NonSpare_1378_Arg
class Item_643(Item):
    cv_non_spare = NonSpare_1378

    @classmethod
    def create(cls, arg : Item_643_Arg) -> "Item_643":
        return cls._create(arg) # type: ignore

Variation_1366_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_92_Arg, Tuple[Literal["NAV"], RuleVariation_92_Arg]], Union[RuleVariation_447_Arg, Tuple[Literal["NVB"], RuleVariation_447_Arg]], int, None]]
Variation_1366_Arg: TypeAlias = Union[
    Tuple[Variation_1366_Arg_Group_1],
]
class Variation_1366(Extended):
    cv_items_list = [[(Item_605, 1), (Item_643, 1), (Item_14, 5), None]]

    @classmethod
    def create(cls, arg : Variation_1366_Arg) -> 'Variation_1366':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["NAV"]) -> RuleVariation_92:
        ...
    @overload
    def get_item(self, key : Literal["NVB"]) -> RuleVariation_447:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1289_Arg: TypeAlias = Variation_1366_Arg
class RuleVariation_1289(RuleVariationContextFree):
    cv_variation = Variation_1366

    @classmethod
    def create(cls, arg : RuleVariation_1289_Arg) -> "RuleVariation_1289":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1366:
        return self.arg # type: ignore

NonSpare_1864_Arg: TypeAlias = RuleVariation_1289_Arg
class NonSpare_1864(NonSpare):
    cv_name = "TIS"
    cv_title = "Trajectory Intent Status"
    cv_rule = RuleVariation_1289

    @classmethod
    def create(cls, arg : NonSpare_1864_Arg) -> "NonSpare_1864":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1289:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1366:
        return self.rule.variation

NonSpare_1830_Arg: TypeAlias = RuleVariation_79_Arg
class NonSpare_1830(NonSpare):
    cv_name = "TCA"
    cv_title = "TCP Number Availability"
    cv_rule = RuleVariation_79

    @classmethod
    def create(cls, arg : NonSpare_1830_Arg) -> "NonSpare_1830":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_79:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_79:
        return self.rule.variation

Item_976_Arg: TypeAlias = NonSpare_1830_Arg
class Item_976(Item):
    cv_non_spare = NonSpare_1830

    @classmethod
    def create(cls, arg : Item_976_Arg) -> "Item_976":
        return cls._create(arg) # type: ignore

NonSpare_1348_Arg: TypeAlias = RuleVariation_438_Arg
class NonSpare_1348(NonSpare):
    cv_name = "NC"
    cv_title = "TCP Compliance"
    cv_rule = RuleVariation_438

    @classmethod
    def create(cls, arg : NonSpare_1348_Arg) -> "NonSpare_1348":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_438:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_449:
        return self.rule.variation

Item_614_Arg: TypeAlias = NonSpare_1348_Arg
class Item_614(Item):
    cv_non_spare = NonSpare_1348

    @classmethod
    def create(cls, arg : Item_614_Arg) -> "Item_614":
        return cls._create(arg) # type: ignore

NonSpare_1841_Arg: TypeAlias = RuleVariation_588_Arg
class NonSpare_1841(NonSpare):
    cv_name = "TCPN"
    cv_title = "Trajectory Change Point Number"
    cv_rule = RuleVariation_588

    @classmethod
    def create(cls, arg : NonSpare_1841_Arg) -> "NonSpare_1841":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_588:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_599:
        return self.rule.variation

Item_986_Arg: TypeAlias = NonSpare_1841_Arg
class Item_986(Item):
    cv_non_spare = NonSpare_1841

    @classmethod
    def create(cls, arg : Item_986_Arg) -> "Item_986":
        return cls._create(arg) # type: ignore

NonSpare_1151_Arg: TypeAlias = RuleVariation_351_Arg
class NonSpare_1151(NonSpare):
    cv_name = "LAT"
    cv_title = "Latitude in WGS.84 in Two's Complement"
    cv_rule = RuleVariation_351

    @classmethod
    def create(cls, arg : NonSpare_1151_Arg) -> "NonSpare_1151":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_351:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_358:
        return self.rule.variation

Item_469_Arg: TypeAlias = NonSpare_1151_Arg
class Item_469(Item):
    cv_non_spare = NonSpare_1151

    @classmethod
    def create(cls, arg : Item_469_Arg) -> "Item_469":
        return cls._create(arg) # type: ignore

NonSpare_1180_Arg: TypeAlias = RuleVariation_349_Arg
class NonSpare_1180(NonSpare):
    cv_name = "LON"
    cv_title = "Longitude in WGS.84 in Two's Complement"
    cv_rule = RuleVariation_349

    @classmethod
    def create(cls, arg : NonSpare_1180_Arg) -> "NonSpare_1180":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_349:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_356:
        return self.rule.variation

Item_496_Arg: TypeAlias = NonSpare_1180_Arg
class Item_496(Item):
    cv_non_spare = NonSpare_1180

    @classmethod
    def create(cls, arg : Item_496_Arg) -> "Item_496":
        return cls._create(arg) # type: ignore

NonSpare_1843_Arg: TypeAlias = RuleVariation_752_Arg
class NonSpare_1843(NonSpare):
    cv_name = "TD"
    cv_title = "Turn Direction"
    cv_rule = RuleVariation_752

    @classmethod
    def create(cls, arg : NonSpare_1843_Arg) -> "NonSpare_1843":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_752:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_763:
        return self.rule.variation

Item_988_Arg: TypeAlias = NonSpare_1843_Arg
class Item_988(Item):
    cv_non_spare = NonSpare_1843

    @classmethod
    def create(cls, arg : Item_988_Arg) -> "Item_988":
        return cls._create(arg) # type: ignore

NonSpare_1894_Arg: TypeAlias = RuleVariation_920_Arg
class NonSpare_1894(NonSpare):
    cv_name = "TRA"
    cv_title = "Turn Radius Availability"
    cv_rule = RuleVariation_920

    @classmethod
    def create(cls, arg : NonSpare_1894_Arg) -> "NonSpare_1894":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_920:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_950:
        return self.rule.variation

Item_1023_Arg: TypeAlias = NonSpare_1894_Arg
class Item_1023(Item):
    cv_non_spare = NonSpare_1894

    @classmethod
    def create(cls, arg : Item_1023_Arg) -> "Item_1023":
        return cls._create(arg) # type: ignore

NonSpare_1871_Arg: TypeAlias = RuleVariation_955_Arg
class NonSpare_1871(NonSpare):
    cv_name = "TOA"
    cv_title = "TOV Available"
    cv_rule = RuleVariation_955

    @classmethod
    def create(cls, arg : NonSpare_1871_Arg) -> "NonSpare_1871":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_955:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_985:
        return self.rule.variation

Item_1005_Arg: TypeAlias = NonSpare_1871_Arg
class Item_1005(Item):
    cv_non_spare = NonSpare_1871

    @classmethod
    def create(cls, arg : Item_1005_Arg) -> "Item_1005":
        return cls._create(arg) # type: ignore

Variation_1216_Arg_Group = Tuple[Union[RuleVariation_79_Arg, Tuple[Literal["TCA"], RuleVariation_79_Arg]], Union[RuleVariation_438_Arg, Tuple[Literal["NC"], RuleVariation_438_Arg]], Union[RuleVariation_588_Arg, Tuple[Literal["TCPN"], RuleVariation_588_Arg]], Union[RuleVariation_252_Arg, Tuple[Literal["ALT"], RuleVariation_252_Arg]], Union[RuleVariation_351_Arg, Tuple[Literal["LAT"], RuleVariation_351_Arg]], Union[RuleVariation_349_Arg, Tuple[Literal["LON"], RuleVariation_349_Arg]], Union[RuleVariation_134_Arg, Tuple[Literal["PT"], RuleVariation_134_Arg]], Union[RuleVariation_752_Arg, Tuple[Literal["TD"], RuleVariation_752_Arg]], Union[RuleVariation_920_Arg, Tuple[Literal["TRA"], RuleVariation_920_Arg]], Union[RuleVariation_955_Arg, Tuple[Literal["TOA"], RuleVariation_955_Arg]], Union[RuleVariation_356_Arg, Tuple[Literal["TOV"], RuleVariation_356_Arg]], Union[RuleVariation_305_Arg, Tuple[Literal["TTR"], RuleVariation_305_Arg]]]
Variation_1216_Arg: TypeAlias = Union[int, Variation_1216_Arg_Group]
class Variation_1216(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 120
    cv_items_list = [(Item_976, 1), (Item_614, 1), (Item_986, 6), (Item_61, 16), (Item_469, 24), (Item_496, 24), (Item_714, 4), (Item_988, 2), (Item_1023, 1), (Item_1005, 1), (Item_1010, 24), (Item_1064, 16)]
    cv_items_dict = {"TCA": RuleVariation_79, "NC": RuleVariation_438, "TCPN": RuleVariation_588, "ALT": RuleVariation_252, "LAT": RuleVariation_351, "LON": RuleVariation_349, "PT": RuleVariation_134, "TD": RuleVariation_752, "TRA": RuleVariation_920, "TOA": RuleVariation_955, "TOV": RuleVariation_356, "TTR": RuleVariation_305}

    @overload
    @classmethod
    def spec(cls, key : Literal["TCA"]) -> RuleVariation_79:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NC"]) -> RuleVariation_438:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TCPN"]) -> RuleVariation_588:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_252:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_351:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_349:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PT"]) -> RuleVariation_134:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TD"]) -> RuleVariation_752:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRA"]) -> RuleVariation_920:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOA"]) -> RuleVariation_955:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOV"]) -> RuleVariation_356:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TTR"]) -> RuleVariation_305:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TCA"], Literal["NC"], Literal["TCPN"], Literal["ALT"], Literal["LAT"], Literal["LON"], Literal["PT"], Literal["TD"], Literal["TRA"], Literal["TOA"], Literal["TOV"], Literal["TTR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TCA"]) -> RuleVariation_79:
        ...
    @overload
    def get_item(self, key : Literal["NC"]) -> RuleVariation_438:
        ...
    @overload
    def get_item(self, key : Literal["TCPN"]) -> RuleVariation_588:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_252:
        ...
    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_351:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_349:
        ...
    @overload
    def get_item(self, key : Literal["PT"]) -> RuleVariation_134:
        ...
    @overload
    def get_item(self, key : Literal["TD"]) -> RuleVariation_752:
        ...
    @overload
    def get_item(self, key : Literal["TRA"]) -> RuleVariation_920:
        ...
    @overload
    def get_item(self, key : Literal["TOA"]) -> RuleVariation_955:
        ...
    @overload
    def get_item(self, key : Literal["TOV"]) -> RuleVariation_356:
        ...
    @overload
    def get_item(self, key : Literal["TTR"]) -> RuleVariation_305:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1216_Arg) -> 'Variation_1216':
        return cls._create(arg) # type: ignore

Variation_1429_Arg: TypeAlias = List[Variation_1216_Arg]
class Variation_1429(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1216

    @classmethod
    def create(cls, arg : Variation_1429_Arg) -> 'Variation_1429':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1216]:
        return self._get_list() # type: ignore

RuleVariation_1352_Arg: TypeAlias = Variation_1429_Arg
class RuleVariation_1352(RuleVariationContextFree):
    cv_variation = Variation_1429

    @classmethod
    def create(cls, arg : RuleVariation_1352_Arg) -> "RuleVariation_1352":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1429:
        return self.arg # type: ignore

NonSpare_1859_Arg: TypeAlias = RuleVariation_1352_Arg
class NonSpare_1859(NonSpare):
    cv_name = "TID"
    cv_title = "Trajectory Intent Data"
    cv_rule = RuleVariation_1352

    @classmethod
    def create(cls, arg : NonSpare_1859_Arg) -> "NonSpare_1859":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1352:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1429:
        return self.rule.variation

Content_317_Arg: TypeAlias = int
class Content_317(ContentTable):
    cv_values = {0: "No alert, no SPI, aircraft airborne", 1: "No alert, no SPI, aircraft on ground", 2: "Alert, no SPI, aircraft airborne", 3: "Alert, no SPI, aircraft on ground", 4: "Alert, SPI, aircraft airborne or on ground", 5: "No alert, SPI, aircraft airborne or on ground"}

RuleContent_317_Arg: TypeAlias = Content_317_Arg
class RuleContent_317(RuleContentContextFree):
    cv_content = Content_317

    @property
    def content(self) -> Content_317:
        return self._get_content() # type: ignore

Variation_681_Arg: TypeAlias = RuleContent_317_Arg
class Variation_681(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 3
    cv_rule = RuleContent_317

    @classmethod
    def create(cls, arg : Variation_681_Arg) -> "Variation_681":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_317:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_317:
        return self.rule.content

RuleVariation_670_Arg: TypeAlias = Variation_681_Arg
class RuleVariation_670(RuleVariationContextFree):
    cv_variation = Variation_681

    @classmethod
    def create(cls, arg : RuleVariation_670_Arg) -> "RuleVariation_670":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_681:
        return self.arg # type: ignore

NonSpare_1766_Arg: TypeAlias = RuleVariation_670_Arg
class NonSpare_1766(NonSpare):
    cv_name = "STAT"
    cv_title = "Flight Status"
    cv_rule = RuleVariation_670

    @classmethod
    def create(cls, arg : NonSpare_1766_Arg) -> "NonSpare_1766":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_670:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_681:
        return self.rule.variation

Item_933_Arg: TypeAlias = NonSpare_1766_Arg
class Item_933(Item):
    cv_non_spare = NonSpare_1766

    @classmethod
    def create(cls, arg : Item_933_Arg) -> "Item_933":
        return cls._create(arg) # type: ignore

NonSpare_666_Arg: TypeAlias = RuleVariation_766_Arg
class NonSpare_666(NonSpare):
    cv_name = "B1B"
    cv_title = "BDS BDS 1,0 Bits 37/40"
    cv_rule = RuleVariation_766

    @classmethod
    def create(cls, arg : NonSpare_666_Arg) -> "NonSpare_666":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_766:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_796:
        return self.rule.variation

Item_111_Arg: TypeAlias = NonSpare_666_Arg
class Item_111(Item):
    cv_non_spare = NonSpare_666

    @classmethod
    def create(cls, arg : Item_111_Arg) -> "Item_111":
        return cls._create(arg) # type: ignore

Variation_1072_Arg_Group = Tuple[Union[RuleVariation_123_Arg, Tuple[Literal["COM"], RuleVariation_123_Arg]], Union[RuleVariation_670_Arg, Tuple[Literal["STAT"], RuleVariation_670_Arg]], int, Union[RuleVariation_55_Arg, Tuple[Literal["SSC"], RuleVariation_55_Arg]], Union[RuleVariation_388_Arg, Tuple[Literal["ARC"], RuleVariation_388_Arg]], Union[RuleVariation_544_Arg, Tuple[Literal["AIC"], RuleVariation_544_Arg]], Union[RuleVariation_600_Arg, Tuple[Literal["B1A"], RuleVariation_600_Arg]], Union[RuleVariation_766_Arg, Tuple[Literal["B1B"], RuleVariation_766_Arg]]]
Variation_1072_Arg: TypeAlias = Union[int, Variation_1072_Arg_Group]
class Variation_1072(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_187, 3), (Item_933, 3), (Item_27, 2), (Item_923, 1), (Item_81, 1), (Item_55, 1), (Item_108, 1), (Item_111, 4)]
    cv_items_dict = {"COM": RuleVariation_123, "STAT": RuleVariation_670, "SSC": RuleVariation_55, "ARC": RuleVariation_388, "AIC": RuleVariation_544, "B1A": RuleVariation_600, "B1B": RuleVariation_766}

    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> RuleVariation_123:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_670:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSC"]) -> RuleVariation_55:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> RuleVariation_388:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AIC"]) -> RuleVariation_544:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1A"]) -> RuleVariation_600:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1B"]) -> RuleVariation_766:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COM"], Literal["STAT"], Literal["SSC"], Literal["ARC"], Literal["AIC"], Literal["B1A"], Literal["B1B"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COM"]) -> RuleVariation_123:
        ...
    @overload
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_670:
        ...
    @overload
    def get_item(self, key : Literal["SSC"]) -> RuleVariation_55:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_388:
        ...
    @overload
    def get_item(self, key : Literal["AIC"]) -> RuleVariation_544:
        ...
    @overload
    def get_item(self, key : Literal["B1A"]) -> RuleVariation_600:
        ...
    @overload
    def get_item(self, key : Literal["B1B"]) -> RuleVariation_766:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1072_Arg) -> 'Variation_1072':
        return cls._create(arg) # type: ignore

RuleVariation_1032_Arg: TypeAlias = Variation_1072_Arg
class RuleVariation_1032(RuleVariationContextFree):
    cv_variation = Variation_1072

    @classmethod
    def create(cls, arg : RuleVariation_1032_Arg) -> "RuleVariation_1032":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1072:
        return self.arg # type: ignore

NonSpare_780_Arg: TypeAlias = RuleVariation_1032_Arg
class NonSpare_780(NonSpare):
    cv_name = "COM"
    cv_title = "Communications/ACAS Capability and Flight Status"
    cv_rule = RuleVariation_1032

    @classmethod
    def create(cls, arg : NonSpare_780_Arg) -> "NonSpare_780":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1032:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1072:
        return self.rule.variation

Content_534_Arg: TypeAlias = int
class Content_534(ContentTable):
    cv_values = {0: "Unknown", 1: "ACAS not operational", 2: "ACAS operational", 3: "Invalid"}

RuleContent_534_Arg: TypeAlias = Content_534_Arg
class RuleContent_534(RuleContentContextFree):
    cv_content = Content_534

    @property
    def content(self) -> Content_534:
        return self._get_content() # type: ignore

Variation_114_Arg: TypeAlias = RuleContent_534_Arg
class Variation_114(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_534

    @classmethod
    def create(cls, arg : Variation_114_Arg) -> "Variation_114":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_534:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_534:
        return self.rule.content

RuleVariation_114_Arg: TypeAlias = Variation_114_Arg
class RuleVariation_114(RuleVariationContextFree):
    cv_variation = Variation_114

    @classmethod
    def create(cls, arg : RuleVariation_114_Arg) -> "RuleVariation_114":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_114:
        return self.arg # type: ignore

NonSpare_551_Arg: TypeAlias = RuleVariation_114_Arg
class NonSpare_551(NonSpare):
    cv_name = "AC"
    cv_title = "ACAS Status"
    cv_rule = RuleVariation_114

    @classmethod
    def create(cls, arg : NonSpare_551_Arg) -> "NonSpare_551":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_114:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_114:
        return self.rule.variation

Item_38_Arg: TypeAlias = NonSpare_551_Arg
class Item_38(Item):
    cv_non_spare = NonSpare_551

    @classmethod
    def create(cls, arg : Item_38_Arg) -> "Item_38":
        return cls._create(arg) # type: ignore

Content_548_Arg: TypeAlias = int
class Content_548(ContentTable):
    cv_values = {0: "Unknown", 1: "Multiple navigational aids not operating", 2: "Multiple navigational aids operating", 3: "Invalid"}

RuleContent_548_Arg: TypeAlias = Content_548_Arg
class RuleContent_548(RuleContentContextFree):
    cv_content = Content_548

    @property
    def content(self) -> Content_548:
        return self._get_content() # type: ignore

Variation_593_Arg: TypeAlias = RuleContent_548_Arg
class Variation_593(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_548

    @classmethod
    def create(cls, arg : Variation_593_Arg) -> "Variation_593":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_548:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_548:
        return self.rule.content

RuleVariation_582_Arg: TypeAlias = Variation_593_Arg
class RuleVariation_582(RuleVariationContextFree):
    cv_variation = Variation_593

    @classmethod
    def create(cls, arg : RuleVariation_582_Arg) -> "RuleVariation_582":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_593:
        return self.arg # type: ignore

NonSpare_1288_Arg: TypeAlias = RuleVariation_582_Arg
class NonSpare_1288(NonSpare):
    cv_name = "MN"
    cv_title = "Multiple Navigational Aids Status"
    cv_rule = RuleVariation_582

    @classmethod
    def create(cls, arg : NonSpare_1288_Arg) -> "NonSpare_1288":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_582:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_593:
        return self.rule.variation

Item_560_Arg: TypeAlias = NonSpare_1288_Arg
class Item_560(Item):
    cv_non_spare = NonSpare_1288

    @classmethod
    def create(cls, arg : Item_560_Arg) -> "Item_560":
        return cls._create(arg) # type: ignore

Content_542_Arg: TypeAlias = int
class Content_542(ContentTable):
    cv_values = {0: "Unknown", 1: "Differential correction", 2: "No differential correction", 3: "Invalid"}

RuleContent_542_Arg: TypeAlias = Content_542_Arg
class RuleContent_542(RuleContentContextFree):
    cv_content = Content_542

    @property
    def content(self) -> Content_542:
        return self._get_content() # type: ignore

Variation_768_Arg: TypeAlias = RuleContent_542_Arg
class Variation_768(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_542

    @classmethod
    def create(cls, arg : Variation_768_Arg) -> "Variation_768":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_542:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_542:
        return self.rule.content

RuleVariation_757_Arg: TypeAlias = Variation_768_Arg
class RuleVariation_757(RuleVariationContextFree):
    cv_variation = Variation_768

    @classmethod
    def create(cls, arg : RuleVariation_757_Arg) -> "RuleVariation_757":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_768:
        return self.arg # type: ignore

NonSpare_865_Arg: TypeAlias = RuleVariation_757_Arg
class NonSpare_865(NonSpare):
    cv_name = "DC"
    cv_title = "Differential Correction Status"
    cv_rule = RuleVariation_757

    @classmethod
    def create(cls, arg : NonSpare_865_Arg) -> "NonSpare_865":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_757:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_768:
        return self.rule.variation

Item_249_Arg: TypeAlias = NonSpare_865_Arg
class Item_249(Item):
    cv_non_spare = NonSpare_865

    @classmethod
    def create(cls, arg : Item_249_Arg) -> "Item_249":
        return cls._create(arg) # type: ignore

Content_522_Arg: TypeAlias = int
class Content_522(ContentTable):
    cv_values = {0: "Transponder ground bit not set or unknown", 1: "Transponder Ground Bit set"}

RuleContent_522_Arg: TypeAlias = Content_522_Arg
class RuleContent_522(RuleContentContextFree):
    cv_content = Content_522

    @property
    def content(self) -> Content_522:
        return self._get_content() # type: ignore

Variation_954_Arg: TypeAlias = RuleContent_522_Arg
class Variation_954(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_522

    @classmethod
    def create(cls, arg : Variation_954_Arg) -> "Variation_954":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_522:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_522:
        return self.rule.content

RuleVariation_924_Arg: TypeAlias = Variation_954_Arg
class RuleVariation_924(RuleVariationContextFree):
    cv_variation = Variation_954

    @classmethod
    def create(cls, arg : RuleVariation_924_Arg) -> "RuleVariation_924":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_954:
        return self.arg # type: ignore

NonSpare_1022_Arg: TypeAlias = RuleVariation_924_Arg
class NonSpare_1022(NonSpare):
    cv_name = "GBS"
    cv_title = "Ground Bit Set"
    cv_rule = RuleVariation_924

    @classmethod
    def create(cls, arg : NonSpare_1022_Arg) -> "NonSpare_1022":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_924:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_954:
        return self.rule.variation

Item_366_Arg: TypeAlias = NonSpare_1022_Arg
class Item_366(Item):
    cv_non_spare = NonSpare_1022

    @classmethod
    def create(cls, arg : Item_366_Arg) -> "Item_366":
        return cls._create(arg) # type: ignore

Item_31_Arg: TypeAlias = int
class Item_31(Spare):
    cv_bit_offset8 = 7
    cv_bit_size = 6

Content_353_Arg: TypeAlias = int
class Content_353(ContentTable):
    cv_values = {0: "No emergency", 1: "General emergency", 2: "Lifeguard / medical", 3: "Minimum fuel", 4: "No communications", 5: "Unlawful interference", 6: "Downed Aircraft", 7: "Unknown"}

RuleContent_353_Arg: TypeAlias = Content_353_Arg
class RuleContent_353(RuleContentContextFree):
    cv_content = Content_353

    @property
    def content(self) -> Content_353:
        return self._get_content() # type: ignore

Variation_888_Arg: TypeAlias = RuleContent_353_Arg
class Variation_888(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 3
    cv_rule = RuleContent_353

    @classmethod
    def create(cls, arg : Variation_888_Arg) -> "Variation_888":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_353:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_353:
        return self.rule.content

RuleVariation_858_Arg: TypeAlias = Variation_888_Arg
class RuleVariation_858(RuleVariationContextFree):
    cv_variation = Variation_888

    @classmethod
    def create(cls, arg : RuleVariation_858_Arg) -> "RuleVariation_858":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_888:
        return self.arg # type: ignore

NonSpare_1772_Arg: TypeAlias = RuleVariation_858_Arg
class NonSpare_1772(NonSpare):
    cv_name = "STAT"
    cv_title = "Flight Status"
    cv_rule = RuleVariation_858

    @classmethod
    def create(cls, arg : NonSpare_1772_Arg) -> "NonSpare_1772":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_858:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_888:
        return self.rule.variation

Item_939_Arg: TypeAlias = NonSpare_1772_Arg
class Item_939(Item):
    cv_non_spare = NonSpare_1772

    @classmethod
    def create(cls, arg : Item_939_Arg) -> "Item_939":
        return cls._create(arg) # type: ignore

Variation_1043_Arg_Group = Tuple[Union[RuleVariation_114_Arg, Tuple[Literal["AC"], RuleVariation_114_Arg]], Union[RuleVariation_582_Arg, Tuple[Literal["MN"], RuleVariation_582_Arg]], Union[RuleVariation_757_Arg, Tuple[Literal["DC"], RuleVariation_757_Arg]], Union[RuleVariation_924_Arg, Tuple[Literal["GBS"], RuleVariation_924_Arg]], int, Union[RuleVariation_858_Arg, Tuple[Literal["STAT"], RuleVariation_858_Arg]]]
Variation_1043_Arg: TypeAlias = Union[int, Variation_1043_Arg_Group]
class Variation_1043(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_38, 2), (Item_560, 2), (Item_249, 2), (Item_366, 1), (Item_31, 6), (Item_939, 3)]
    cv_items_dict = {"AC": RuleVariation_114, "MN": RuleVariation_582, "DC": RuleVariation_757, "GBS": RuleVariation_924, "STAT": RuleVariation_858}

    @overload
    @classmethod
    def spec(cls, key : Literal["AC"]) -> RuleVariation_114:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MN"]) -> RuleVariation_582:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DC"]) -> RuleVariation_757:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GBS"]) -> RuleVariation_924:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_858:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AC"], Literal["MN"], Literal["DC"], Literal["GBS"], Literal["STAT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AC"]) -> RuleVariation_114:
        ...
    @overload
    def get_item(self, key : Literal["MN"]) -> RuleVariation_582:
        ...
    @overload
    def get_item(self, key : Literal["DC"]) -> RuleVariation_757:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> RuleVariation_924:
        ...
    @overload
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_858:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1043_Arg) -> 'Variation_1043':
        return cls._create(arg) # type: ignore

RuleVariation_1010_Arg: TypeAlias = Variation_1043_Arg
class RuleVariation_1010(RuleVariationContextFree):
    cv_variation = Variation_1043

    @classmethod
    def create(cls, arg : RuleVariation_1010_Arg) -> "RuleVariation_1010":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1043:
        return self.arg # type: ignore

NonSpare_1642_Arg: TypeAlias = RuleVariation_1010_Arg
class NonSpare_1642(NonSpare):
    cv_name = "SAB"
    cv_title = "Status Reported by ADS-B"
    cv_rule = RuleVariation_1010

    @classmethod
    def create(cls, arg : NonSpare_1642_Arg) -> "NonSpare_1642":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1010:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1043:
        return self.rule.variation

Content_797_Arg: TypeAlias = int
class Content_797(ContentBds):
    cv_bds_type = (BdsAt, 48)

RuleContent_796_Arg: TypeAlias = Content_797_Arg
class RuleContent_796(RuleContentContextFree):
    cv_content = Content_797

    @property
    def content(self) -> Content_797:
        return self._get_content() # type: ignore

Variation_393_Arg: TypeAlias = RuleContent_796_Arg
class Variation_393(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_rule = RuleContent_796

    @classmethod
    def create(cls, arg : Variation_393_Arg) -> "Variation_393":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_796:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_797:
        return self.rule.content

RuleVariation_385_Arg: TypeAlias = Variation_393_Arg
class RuleVariation_385(RuleVariationContextFree):
    cv_variation = Variation_393

    @classmethod
    def create(cls, arg : RuleVariation_385_Arg) -> "RuleVariation_385":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_393:
        return self.arg # type: ignore

NonSpare_559_Arg: TypeAlias = RuleVariation_385_Arg
class NonSpare_559(NonSpare):
    cv_name = "ACS"
    cv_title = "ACAS Resolution Advisory Report"
    cv_rule = RuleVariation_385

    @classmethod
    def create(cls, arg : NonSpare_559_Arg) -> "NonSpare_559":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

NonSpare_690_Arg: TypeAlias = RuleVariation_284_Arg
class NonSpare_690(NonSpare):
    cv_name = "BVR"
    cv_title = "Barometric Vertical Rate"
    cv_rule = RuleVariation_284

    @classmethod
    def create(cls, arg : NonSpare_690_Arg) -> "NonSpare_690":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_284:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_291:
        return self.rule.variation

NonSpare_1041_Arg: TypeAlias = RuleVariation_284_Arg
class NonSpare_1041(NonSpare):
    cv_name = "GVR"
    cv_title = "Geometric Vertical Rate"
    cv_rule = RuleVariation_284

    @classmethod
    def create(cls, arg : NonSpare_1041_Arg) -> "NonSpare_1041":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_284:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_291:
        return self.rule.variation

NonSpare_1538_Arg: TypeAlias = RuleVariation_260_Arg
class NonSpare_1538(NonSpare):
    cv_name = "RAN"
    cv_title = "Roll Angle"
    cv_rule = RuleVariation_260

    @classmethod
    def create(cls, arg : NonSpare_1538_Arg) -> "NonSpare_1538":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_260:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_267:
        return self.rule.variation

Content_663_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°/s"]]]
class Content_663(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.25
    cv_unit = "°/s"

    def as_quantity(self, cv_unit : Optional[Literal["°/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_663_Arg: TypeAlias = Content_663_Arg
class RuleContent_663(RuleContentContextFree):
    cv_content = Content_663

    @property
    def content(self) -> Content_663:
        return self._get_content() # type: ignore

Variation_158_Arg: TypeAlias = RuleContent_663_Arg
class Variation_158(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_663

    @classmethod
    def create(cls, arg : Variation_158_Arg) -> "Variation_158":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_663:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_663:
        return self.rule.content

RuleVariation_152_Arg: TypeAlias = Variation_158_Arg
class RuleVariation_152(RuleVariationContextFree):
    cv_variation = Variation_158

    @classmethod
    def create(cls, arg : RuleVariation_152_Arg) -> "RuleVariation_152":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_158:
        return self.arg # type: ignore

NonSpare_1592_Arg: TypeAlias = RuleVariation_152_Arg
class NonSpare_1592(NonSpare):
    cv_name = "ROT"
    cv_title = "Rate of Turn in Two's Complement Form"
    cv_rule = RuleVariation_152

    @classmethod
    def create(cls, arg : NonSpare_1592_Arg) -> "NonSpare_1592":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_152:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_158:
        return self.rule.variation

Item_822_Arg: TypeAlias = NonSpare_1592_Arg
class Item_822(Item):
    cv_non_spare = NonSpare_1592

    @classmethod
    def create(cls, arg : Item_822_Arg) -> "Item_822":
        return cls._create(arg) # type: ignore

Variation_1217_Arg_Group = Tuple[Union[RuleVariation_105_Arg, Tuple[Literal["TI"], RuleVariation_105_Arg]], int, Union[RuleVariation_152_Arg, Tuple[Literal["ROT"], RuleVariation_152_Arg]], int]
Variation_1217_Arg: TypeAlias = Union[int, Variation_1217_Arg_Group]
class Variation_1217(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_995, 2), (Item_15, 6), (Item_822, 7), (Item_29, 1)]
    cv_items_dict = {"TI": RuleVariation_105, "ROT": RuleVariation_152}

    @overload
    @classmethod
    def spec(cls, key : Literal["TI"]) -> RuleVariation_105:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ROT"]) -> RuleVariation_152:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TI"], Literal["ROT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TI"]) -> RuleVariation_105:
        ...
    @overload
    def get_item(self, key : Literal["ROT"]) -> RuleVariation_152:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1217_Arg) -> 'Variation_1217':
        return cls._create(arg) # type: ignore

RuleVariation_1158_Arg: TypeAlias = Variation_1217_Arg
class RuleVariation_1158(RuleVariationContextFree):
    cv_variation = Variation_1217

    @classmethod
    def create(cls, arg : RuleVariation_1158_Arg) -> "RuleVariation_1158":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1217:
        return self.arg # type: ignore

NonSpare_1818_Arg: TypeAlias = RuleVariation_1158_Arg
class NonSpare_1818(NonSpare):
    cv_name = "TAR"
    cv_title = "Track Angle Rate"
    cv_rule = RuleVariation_1158

    @classmethod
    def create(cls, arg : NonSpare_1818_Arg) -> "NonSpare_1818":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1217:
        return self.rule.variation

NonSpare_1813_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_1813(NonSpare):
    cv_name = "TAN"
    cv_title = "Track Angle"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_1813_Arg) -> "NonSpare_1813":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Content_679_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM/s"]]]
class Content_679(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 6.103515625e-5
    cv_unit = "NM/s"

    def as_quantity(self, cv_unit : Optional[Literal["NM/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_679_Arg: TypeAlias = Content_679_Arg
class RuleContent_679(RuleContentContextFree):
    cv_content = Content_679

    @property
    def content(self) -> Content_679:
        return self._get_content() # type: ignore

Variation_286_Arg: TypeAlias = RuleContent_679_Arg
class Variation_286(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_679

    @classmethod
    def create(cls, arg : Variation_286_Arg) -> "Variation_286":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_679:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_679:
        return self.rule.content

RuleVariation_279_Arg: TypeAlias = Variation_286_Arg
class RuleVariation_279(RuleVariationContextFree):
    cv_variation = Variation_286

    @classmethod
    def create(cls, arg : RuleVariation_279_Arg) -> "RuleVariation_279":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_286:
        return self.arg # type: ignore

NonSpare_1030_Arg: TypeAlias = RuleVariation_279_Arg
class NonSpare_1030(NonSpare):
    cv_name = "GS"
    cv_title = "Ground Speed"
    cv_rule = RuleVariation_279

    @classmethod
    def create(cls, arg : NonSpare_1030_Arg) -> "NonSpare_1030":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_279:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_286:
        return self.rule.variation

NonSpare_2035_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_2035(NonSpare):
    cv_name = "VUN"
    cv_title = "Velocity Uncertainty"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_2035_Arg) -> "NonSpare_2035":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Content_403_Arg: TypeAlias = int
class Content_403(ContentTable):
    cv_values = {0: "Not valid Wind Speed", 1: "Valid Wind Speed"}

RuleContent_403_Arg: TypeAlias = Content_403_Arg
class RuleContent_403(RuleContentContextFree):
    cv_content = Content_403

    @property
    def content(self) -> Content_403:
        return self._get_content() # type: ignore

Variation_68_Arg: TypeAlias = RuleContent_403_Arg
class Variation_68(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_403

    @classmethod
    def create(cls, arg : Variation_68_Arg) -> "Variation_68":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_403:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_403:
        return self.rule.content

RuleVariation_68_Arg: TypeAlias = Variation_68_Arg
class RuleVariation_68(RuleVariationContextFree):
    cv_variation = Variation_68

    @classmethod
    def create(cls, arg : RuleVariation_68_Arg) -> "RuleVariation_68":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_68:
        return self.arg # type: ignore

NonSpare_2056_Arg: TypeAlias = RuleVariation_68_Arg
class NonSpare_2056(NonSpare):
    cv_name = "WS"
    cv_title = "Wind Speed Valid Flag"
    cv_rule = RuleVariation_68

    @classmethod
    def create(cls, arg : NonSpare_2056_Arg) -> "NonSpare_2056":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_68:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_68:
        return self.rule.variation

Item_1165_Arg: TypeAlias = NonSpare_2056_Arg
class Item_1165(Item):
    cv_non_spare = NonSpare_2056

    @classmethod
    def create(cls, arg : Item_1165_Arg) -> "Item_1165":
        return cls._create(arg) # type: ignore

Content_402_Arg: TypeAlias = int
class Content_402(ContentTable):
    cv_values = {0: "Not valid Wind Direction", 1: "Valid Wind Direction"}

RuleContent_402_Arg: TypeAlias = Content_402_Arg
class RuleContent_402(RuleContentContextFree):
    cv_content = Content_402

    @property
    def content(self) -> Content_402:
        return self._get_content() # type: ignore

Variation_445_Arg: TypeAlias = RuleContent_402_Arg
class Variation_445(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_402

    @classmethod
    def create(cls, arg : Variation_445_Arg) -> "Variation_445":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_402:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_402:
        return self.rule.content

RuleVariation_434_Arg: TypeAlias = Variation_445_Arg
class RuleVariation_434(RuleVariationContextFree):
    cv_variation = Variation_445

    @classmethod
    def create(cls, arg : RuleVariation_434_Arg) -> "RuleVariation_434":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_445:
        return self.arg # type: ignore

NonSpare_2049_Arg: TypeAlias = RuleVariation_434_Arg
class NonSpare_2049(NonSpare):
    cv_name = "WD"
    cv_title = "Wind Direction Valid Flag"
    cv_rule = RuleVariation_434

    @classmethod
    def create(cls, arg : NonSpare_2049_Arg) -> "NonSpare_2049":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_434:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_445:
        return self.rule.variation

Item_1160_Arg: TypeAlias = NonSpare_2049_Arg
class Item_1160(Item):
    cv_non_spare = NonSpare_2049

    @classmethod
    def create(cls, arg : Item_1160_Arg) -> "Item_1160":
        return cls._create(arg) # type: ignore

Content_400_Arg: TypeAlias = int
class Content_400(ContentTable):
    cv_values = {0: "Not valid Temperature", 1: "Valid Temperature"}

RuleContent_400_Arg: TypeAlias = Content_400_Arg
class RuleContent_400(RuleContentContextFree):
    cv_content = Content_400

    @property
    def content(self) -> Content_400:
        return self._get_content() # type: ignore

Variation_568_Arg: TypeAlias = RuleContent_400_Arg
class Variation_568(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_400

    @classmethod
    def create(cls, arg : Variation_568_Arg) -> "Variation_568":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_400:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_400:
        return self.rule.content

RuleVariation_557_Arg: TypeAlias = Variation_568_Arg
class RuleVariation_557(RuleVariationContextFree):
    cv_variation = Variation_568

    @classmethod
    def create(cls, arg : RuleVariation_557_Arg) -> "RuleVariation_557":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_568:
        return self.arg # type: ignore

NonSpare_1867_Arg: TypeAlias = RuleVariation_557_Arg
class NonSpare_1867(NonSpare):
    cv_name = "TMP"
    cv_title = "Temperature Valid Flag"
    cv_rule = RuleVariation_557

    @classmethod
    def create(cls, arg : NonSpare_1867_Arg) -> "NonSpare_1867":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_557:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_568:
        return self.rule.variation

Item_1002_Arg: TypeAlias = NonSpare_1867_Arg
class Item_1002(Item):
    cv_non_spare = NonSpare_1867

    @classmethod
    def create(cls, arg : Item_1002_Arg) -> "Item_1002":
        return cls._create(arg) # type: ignore

Content_401_Arg: TypeAlias = int
class Content_401(ContentTable):
    cv_values = {0: "Not valid Turbulence", 1: "Valid Turbulence"}

RuleContent_401_Arg: TypeAlias = Content_401_Arg
class RuleContent_401(RuleContentContextFree):
    cv_content = Content_401

    @property
    def content(self) -> Content_401:
        return self._get_content() # type: ignore

Variation_657_Arg: TypeAlias = RuleContent_401_Arg
class Variation_657(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_401

    @classmethod
    def create(cls, arg : Variation_657_Arg) -> "Variation_657":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_401:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_401:
        return self.rule.content

RuleVariation_646_Arg: TypeAlias = Variation_657_Arg
class RuleVariation_646(RuleVariationContextFree):
    cv_variation = Variation_657

    @classmethod
    def create(cls, arg : RuleVariation_646_Arg) -> "RuleVariation_646":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_657:
        return self.arg # type: ignore

NonSpare_1902_Arg: TypeAlias = RuleVariation_646_Arg
class NonSpare_1902(NonSpare):
    cv_name = "TRB"
    cv_title = "Turbulence Valid Flag"
    cv_rule = RuleVariation_646

    @classmethod
    def create(cls, arg : NonSpare_1902_Arg) -> "NonSpare_1902":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_646:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_657:
        return self.rule.variation

Item_1030_Arg: TypeAlias = NonSpare_1902_Arg
class Item_1030(Item):
    cv_non_spare = NonSpare_1902

    @classmethod
    def create(cls, arg : Item_1030_Arg) -> "Item_1030":
        return cls._create(arg) # type: ignore

NonSpare_2057_Arg: TypeAlias = RuleVariation_293_Arg
class NonSpare_2057(NonSpare):
    cv_name = "WSD"
    cv_title = "Wind Speed"
    cv_rule = RuleVariation_293

    @classmethod
    def create(cls, arg : NonSpare_2057_Arg) -> "NonSpare_2057":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_293:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_300:
        return self.rule.variation

Item_1166_Arg: TypeAlias = NonSpare_2057_Arg
class Item_1166(Item):
    cv_non_spare = NonSpare_2057

    @classmethod
    def create(cls, arg : Item_1166_Arg) -> "Item_1166":
        return cls._create(arg) # type: ignore

NonSpare_2050_Arg: TypeAlias = RuleVariation_300_Arg
class NonSpare_2050(NonSpare):
    cv_name = "WDD"
    cv_title = "Wind Direction"
    cv_rule = RuleVariation_300

    @classmethod
    def create(cls, arg : NonSpare_2050_Arg) -> "NonSpare_2050":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_300:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_307:
        return self.rule.variation

Item_1161_Arg: TypeAlias = NonSpare_2050_Arg
class Item_1161(Item):
    cv_non_spare = NonSpare_2050

    @classmethod
    def create(cls, arg : Item_1161_Arg) -> "Item_1161":
        return cls._create(arg) # type: ignore

NonSpare_1868_Arg: TypeAlias = RuleVariation_272_Arg
class NonSpare_1868(NonSpare):
    cv_name = "TMPD"
    cv_title = "Temperature in Degrees Celsius"
    cv_rule = RuleVariation_272

    @classmethod
    def create(cls, arg : NonSpare_1868_Arg) -> "NonSpare_1868":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_272:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_279:
        return self.rule.variation

Item_1003_Arg: TypeAlias = NonSpare_1868_Arg
class Item_1003(Item):
    cv_non_spare = NonSpare_1868

    @classmethod
    def create(cls, arg : Item_1003_Arg) -> "Item_1003":
        return cls._create(arg) # type: ignore

NonSpare_1903_Arg: TypeAlias = RuleVariation_197_Arg
class NonSpare_1903(NonSpare):
    cv_name = "TRBD"
    cv_title = "Turbulence"
    cv_rule = RuleVariation_197

    @classmethod
    def create(cls, arg : NonSpare_1903_Arg) -> "NonSpare_1903":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_197:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_204:
        return self.rule.variation

Item_1031_Arg: TypeAlias = NonSpare_1903_Arg
class Item_1031(Item):
    cv_non_spare = NonSpare_1903

    @classmethod
    def create(cls, arg : Item_1031_Arg) -> "Item_1031":
        return cls._create(arg) # type: ignore

Variation_1277_Arg_Group = Tuple[Union[RuleVariation_68_Arg, Tuple[Literal["WS"], RuleVariation_68_Arg]], Union[RuleVariation_434_Arg, Tuple[Literal["WD"], RuleVariation_434_Arg]], Union[RuleVariation_557_Arg, Tuple[Literal["TMP"], RuleVariation_557_Arg]], Union[RuleVariation_646_Arg, Tuple[Literal["TRB"], RuleVariation_646_Arg]], int, Union[RuleVariation_293_Arg, Tuple[Literal["WSD"], RuleVariation_293_Arg]], Union[RuleVariation_300_Arg, Tuple[Literal["WDD"], RuleVariation_300_Arg]], Union[RuleVariation_272_Arg, Tuple[Literal["TMPD"], RuleVariation_272_Arg]], Union[RuleVariation_197_Arg, Tuple[Literal["TRBD"], RuleVariation_197_Arg]]]
Variation_1277_Arg: TypeAlias = Union[int, Variation_1277_Arg_Group]
class Variation_1277(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_1165, 1), (Item_1160, 1), (Item_1002, 1), (Item_1030, 1), (Item_22, 4), (Item_1166, 16), (Item_1161, 16), (Item_1003, 16), (Item_1031, 8)]
    cv_items_dict = {"WS": RuleVariation_68, "WD": RuleVariation_434, "TMP": RuleVariation_557, "TRB": RuleVariation_646, "WSD": RuleVariation_293, "WDD": RuleVariation_300, "TMPD": RuleVariation_272, "TRBD": RuleVariation_197}

    @overload
    @classmethod
    def spec(cls, key : Literal["WS"]) -> RuleVariation_68:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WD"]) -> RuleVariation_434:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TMP"]) -> RuleVariation_557:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRB"]) -> RuleVariation_646:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WSD"]) -> RuleVariation_293:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WDD"]) -> RuleVariation_300:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TMPD"]) -> RuleVariation_272:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRBD"]) -> RuleVariation_197:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["WS"], Literal["WD"], Literal["TMP"], Literal["TRB"], Literal["WSD"], Literal["WDD"], Literal["TMPD"], Literal["TRBD"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["WS"]) -> RuleVariation_68:
        ...
    @overload
    def get_item(self, key : Literal["WD"]) -> RuleVariation_434:
        ...
    @overload
    def get_item(self, key : Literal["TMP"]) -> RuleVariation_557:
        ...
    @overload
    def get_item(self, key : Literal["TRB"]) -> RuleVariation_646:
        ...
    @overload
    def get_item(self, key : Literal["WSD"]) -> RuleVariation_293:
        ...
    @overload
    def get_item(self, key : Literal["WDD"]) -> RuleVariation_300:
        ...
    @overload
    def get_item(self, key : Literal["TMPD"]) -> RuleVariation_272:
        ...
    @overload
    def get_item(self, key : Literal["TRBD"]) -> RuleVariation_197:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1277_Arg) -> 'Variation_1277':
        return cls._create(arg) # type: ignore

RuleVariation_1207_Arg: TypeAlias = Variation_1277_Arg
class RuleVariation_1207(RuleVariationContextFree):
    cv_variation = Variation_1277

    @classmethod
    def create(cls, arg : RuleVariation_1207_Arg) -> "RuleVariation_1207":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1277:
        return self.arg # type: ignore

NonSpare_1262_Arg: TypeAlias = RuleVariation_1207_Arg
class NonSpare_1262(NonSpare):
    cv_name = "MET"
    cv_title = "Meteorological Data"
    cv_rule = RuleVariation_1207

    @classmethod
    def create(cls, arg : NonSpare_1262_Arg) -> "NonSpare_1262":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1277:
        return self.rule.variation

Content_580_Arg: TypeAlias = int
class Content_580(ContentTable):
    cv_values = {1: "Light aircraft =< 7000 kg", 2: "Reserved", 3: "7000 kg < medium aircraft < 136000 kg", 4: "Reserved", 5: "136000 kg <= heavy aircraft", 6: "Highly manoeuvrable (5g acceleration capability) and high speed (>400 knots cruise)", 7: "Reserved", 8: "Reserved", 9: "Reserved", 10: "Rotocraft", 11: "Glider / sailplane", 12: "Lighter-than-air", 13: "Unmanned aerial vehicle", 14: "Space / transatmospheric vehicle", 15: "Ultralight / handglider / paraglider", 16: "Parachutist / skydiver", 17: "Reserved", 18: "Reserved", 19: "Reserved", 20: "Surface emergency vehicle", 21: "Surface service vehicle", 22: "Fixed ground or tethered obstruction", 23: "Reserved", 24: "Reserved"}

RuleContent_580_Arg: TypeAlias = Content_580_Arg
class RuleContent_580(RuleContentContextFree):
    cv_content = Content_580

    @property
    def content(self) -> Content_580:
        return self._get_content() # type: ignore

Variation_183_Arg: TypeAlias = RuleContent_580_Arg
class Variation_183(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_580

    @classmethod
    def create(cls, arg : Variation_183_Arg) -> "Variation_183":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_580:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_580:
        return self.rule.content

RuleVariation_176_Arg: TypeAlias = Variation_183_Arg
class RuleVariation_176(RuleVariationContextFree):
    cv_variation = Variation_183

    @classmethod
    def create(cls, arg : RuleVariation_176_Arg) -> "RuleVariation_176":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_183:
        return self.arg # type: ignore

NonSpare_921_Arg: TypeAlias = RuleVariation_176_Arg
class NonSpare_921(NonSpare):
    cv_name = "EMC"
    cv_title = "Emitter Category"
    cv_rule = RuleVariation_176

    @classmethod
    def create(cls, arg : NonSpare_921_Arg) -> "NonSpare_921":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_176:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_183:
        return self.rule.variation

NonSpare_1152_Arg: TypeAlias = RuleVariation_351_Arg
class NonSpare_1152(NonSpare):
    cv_name = "LAT"
    cv_title = "Latitude in WGS.84 in Two's Complement Form"
    cv_rule = RuleVariation_351

    @classmethod
    def create(cls, arg : NonSpare_1152_Arg) -> "NonSpare_1152":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_351:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_358:
        return self.rule.variation

Item_470_Arg: TypeAlias = NonSpare_1152_Arg
class Item_470(Item):
    cv_non_spare = NonSpare_1152

    @classmethod
    def create(cls, arg : Item_470_Arg) -> "Item_470":
        return cls._create(arg) # type: ignore

NonSpare_1181_Arg: TypeAlias = RuleVariation_349_Arg
class NonSpare_1181(NonSpare):
    cv_name = "LON"
    cv_title = "Longitude in WGS.84 in Two's Complement Form"
    cv_rule = RuleVariation_349

    @classmethod
    def create(cls, arg : NonSpare_1181_Arg) -> "NonSpare_1181":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_349:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_356:
        return self.rule.variation

Item_497_Arg: TypeAlias = NonSpare_1181_Arg
class Item_497(Item):
    cv_non_spare = NonSpare_1181

    @classmethod
    def create(cls, arg : Item_497_Arg) -> "Item_497":
        return cls._create(arg) # type: ignore

Variation_1130_Arg_Group = Tuple[Union[RuleVariation_351_Arg, Tuple[Literal["LAT"], RuleVariation_351_Arg]], Union[RuleVariation_349_Arg, Tuple[Literal["LON"], RuleVariation_349_Arg]]]
Variation_1130_Arg: TypeAlias = Union[int, Variation_1130_Arg_Group]
class Variation_1130(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_470, 24), (Item_497, 24)]
    cv_items_dict = {"LAT": RuleVariation_351, "LON": RuleVariation_349}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_351:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_349:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_351:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_349:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1130_Arg) -> 'Variation_1130':
        return cls._create(arg) # type: ignore

RuleVariation_1087_Arg: TypeAlias = Variation_1130_Arg
class RuleVariation_1087(RuleVariationContextFree):
    cv_variation = Variation_1130

    @classmethod
    def create(cls, arg : RuleVariation_1087_Arg) -> "RuleVariation_1087":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1130:
        return self.arg # type: ignore

NonSpare_1439_Arg: TypeAlias = RuleVariation_1087_Arg
class NonSpare_1439(NonSpare):
    cv_name = "POS"
    cv_title = "Position"
    cv_rule = RuleVariation_1087

    @classmethod
    def create(cls, arg : NonSpare_1439_Arg) -> "NonSpare_1439":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1087:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1130:
        return self.rule.variation

NonSpare_1011_Arg: TypeAlias = RuleVariation_283_Arg
class NonSpare_1011(NonSpare):
    cv_name = "GAL"
    cv_title = "Geometric Altitude"
    cv_rule = RuleVariation_283

    @classmethod
    def create(cls, arg : NonSpare_1011_Arg) -> "NonSpare_1011":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_283:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_290:
        return self.rule.variation

NonSpare_1474_Arg: TypeAlias = RuleVariation_766_Arg
class NonSpare_1474(NonSpare):
    cv_name = "PUN"
    cv_title = "Position Uncertainty"
    cv_rule = RuleVariation_766

    @classmethod
    def create(cls, arg : NonSpare_1474_Arg) -> "NonSpare_1474":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_766:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_796:
        return self.rule.variation

Item_715_Arg: TypeAlias = NonSpare_1474_Arg
class Item_715(Item):
    cv_non_spare = NonSpare_1474

    @classmethod
    def create(cls, arg : Item_715_Arg) -> "Item_715":
        return cls._create(arg) # type: ignore

Variation_1028_Arg_Group = Tuple[int, Union[RuleVariation_766_Arg, Tuple[Literal["PUN"], RuleVariation_766_Arg]]]
Variation_1028_Arg: TypeAlias = Union[int, Variation_1028_Arg_Group]
class Variation_1028(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_3, 4), (Item_715, 4)]
    cv_items_dict = {"PUN": RuleVariation_766}

    @classmethod
    def spec(cls, key : Literal["PUN"]) -> RuleVariation_766:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["PUN"]) -> RuleVariation_766:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1028_Arg) -> 'Variation_1028':
        return cls._create(arg) # type: ignore

RuleVariation_996_Arg: TypeAlias = Variation_1028_Arg
class RuleVariation_996(RuleVariationContextFree):
    cv_variation = Variation_1028

    @classmethod
    def create(cls, arg : RuleVariation_996_Arg) -> "RuleVariation_996":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1028:
        return self.arg # type: ignore

NonSpare_1475_Arg: TypeAlias = RuleVariation_996_Arg
class NonSpare_1475(NonSpare):
    cv_name = "PUN"
    cv_title = "Position Uncertainty"
    cv_rule = RuleVariation_996

    @classmethod
    def create(cls, arg : NonSpare_1475_Arg) -> "NonSpare_1475":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_996:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1028:
        return self.rule.variation

NonSpare_1222_Arg: TypeAlias = RuleVariation_1319_Arg
class NonSpare_1222(NonSpare):
    cv_name = "MB"
    cv_title = "MODE S MB DATA"
    cv_rule = RuleVariation_1319

    @classmethod
    def create(cls, arg : NonSpare_1222_Arg) -> "NonSpare_1222":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1319:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1396:
        return self.rule.variation

Content_714_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["kt"]]]
class Content_714(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = "kt"

    def as_quantity(self, cv_unit : Optional[Literal["kt"]] = None) -> float:
        return self._as_quantity()

RuleContent_714_Arg: TypeAlias = Content_714_Arg
class RuleContent_714(RuleContentContextFree):
    cv_content = Content_714

    @property
    def content(self) -> Content_714:
        return self._get_content() # type: ignore

Variation_301_Arg: TypeAlias = RuleContent_714_Arg
class Variation_301(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_714

    @classmethod
    def create(cls, arg : Variation_301_Arg) -> "Variation_301":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_714:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_714:
        return self.rule.content

RuleVariation_294_Arg: TypeAlias = Variation_301_Arg
class RuleVariation_294(RuleVariationContextFree):
    cv_variation = Variation_301

    @classmethod
    def create(cls, arg : RuleVariation_294_Arg) -> "RuleVariation_294":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_301:
        return self.arg # type: ignore

NonSpare_1092_Arg: TypeAlias = RuleVariation_294_Arg
class NonSpare_1092(NonSpare):
    cv_name = "IAR"
    cv_title = "Indicated Airspeed"
    cv_rule = RuleVariation_294

    @classmethod
    def create(cls, arg : NonSpare_1092_Arg) -> "NonSpare_1092":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_294:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_301:
        return self.rule.variation

Content_746_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["Mach"]]]
class Content_746(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 8.0e-3
    cv_unit = "Mach"

    def as_quantity(self, cv_unit : Optional[Literal["Mach"]] = None) -> float:
        return self._as_quantity()

RuleContent_746_Arg: TypeAlias = Content_746_Arg
class RuleContent_746(RuleContentContextFree):
    cv_content = Content_746

    @property
    def content(self) -> Content_746:
        return self._get_content() # type: ignore

Variation_317_Arg: TypeAlias = RuleContent_746_Arg
class Variation_317(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_746

    @classmethod
    def create(cls, arg : Variation_317_Arg) -> "Variation_317":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_746:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_746:
        return self.rule.content

RuleVariation_310_Arg: TypeAlias = Variation_317_Arg
class RuleVariation_310(RuleVariationContextFree):
    cv_variation = Variation_317

    @classmethod
    def create(cls, arg : RuleVariation_310_Arg) -> "RuleVariation_310":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_317:
        return self.arg # type: ignore

NonSpare_1212_Arg: TypeAlias = RuleVariation_310_Arg
class NonSpare_1212(NonSpare):
    cv_name = "MAC"
    cv_title = "Mach Number"
    cv_rule = RuleVariation_310

    @classmethod
    def create(cls, arg : NonSpare_1212_Arg) -> "NonSpare_1212":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_310:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_317:
        return self.rule.variation

Content_737_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["mb"]]]
class Content_737(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.1
    cv_unit = "mb"

    def as_quantity(self, cv_unit : Optional[Literal["mb"]] = None) -> float:
        return self._as_quantity()

RuleContent_737_Arg: TypeAlias = Content_737_Arg
class RuleContent_737(RuleContentContextFree):
    cv_content = Content_737

    @property
    def content(self) -> Content_737:
        return self._get_content() # type: ignore

Variation_810_Arg: TypeAlias = RuleContent_737_Arg
class Variation_810(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 12
    cv_rule = RuleContent_737

    @classmethod
    def create(cls, arg : Variation_810_Arg) -> "Variation_810":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_737:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_737:
        return self.rule.content

RuleVariation_780_Arg: TypeAlias = Variation_810_Arg
class RuleVariation_780(RuleVariationContextFree):
    cv_variation = Variation_810

    @classmethod
    def create(cls, arg : RuleVariation_780_Arg) -> "RuleVariation_780":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_810:
        return self.arg # type: ignore

NonSpare_684_Arg: TypeAlias = RuleVariation_780_Arg
class NonSpare_684(NonSpare):
    cv_name = "BPS"
    cv_title = ""
    cv_rule = RuleVariation_780

    @classmethod
    def create(cls, arg : NonSpare_684_Arg) -> "NonSpare_684":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_780:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_810:
        return self.rule.variation

Item_128_Arg: TypeAlias = NonSpare_684_Arg
class Item_128(Item):
    cv_non_spare = NonSpare_684

    @classmethod
    def create(cls, arg : Item_128_Arg) -> "Item_128":
        return cls._create(arg) # type: ignore

Variation_1016_Arg_Group = Tuple[int, Union[RuleVariation_780_Arg, Tuple[Literal["BPS"], RuleVariation_780_Arg]]]
Variation_1016_Arg: TypeAlias = Union[int, Variation_1016_Arg_Group]
class Variation_1016(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_128, 12)]
    cv_items_dict = {"BPS": RuleVariation_780}

    @classmethod
    def spec(cls, key : Literal["BPS"]) -> RuleVariation_780:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["BPS"]) -> RuleVariation_780:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1016_Arg) -> 'Variation_1016':
        return cls._create(arg) # type: ignore

RuleVariation_986_Arg: TypeAlias = Variation_1016_Arg
class RuleVariation_986(RuleVariationContextFree):
    cv_variation = Variation_1016

    @classmethod
    def create(cls, arg : RuleVariation_986_Arg) -> "RuleVariation_986":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1016:
        return self.arg # type: ignore

NonSpare_688_Arg: TypeAlias = RuleVariation_986_Arg
class NonSpare_688(NonSpare):
    cv_name = "BPS"
    cv_title = "Barometric Pressure Setting (derived from Mode S BDS 4,0)"
    cv_rule = RuleVariation_986

    @classmethod
    def create(cls, arg : NonSpare_688_Arg) -> "NonSpare_688":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_986:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1016:
        return self.rule.variation

Variation_1456_Arg = TypedDict('Variation_1456_Arg', {
    "ADR": NonSpare_567_Arg,
    "ID": NonSpare_1103_Arg,
    "MHG": NonSpare_1270_Arg,
    "IAS": NonSpare_1096_Arg,
    "TAS": NonSpare_1823_Arg,
    "SAL": NonSpare_1648_Arg,
    "FSS": NonSpare_994_Arg,
    "TIS": NonSpare_1864_Arg,
    "TID": NonSpare_1859_Arg,
    "COM": NonSpare_780_Arg,
    "SAB": NonSpare_1642_Arg,
    "ACS": NonSpare_559_Arg,
    "BVR": NonSpare_690_Arg,
    "GVR": NonSpare_1041_Arg,
    "RAN": NonSpare_1538_Arg,
    "TAR": NonSpare_1818_Arg,
    "TAN": NonSpare_1813_Arg,
    "GS": NonSpare_1030_Arg,
    "VUN": NonSpare_2035_Arg,
    "MET": NonSpare_1262_Arg,
    "EMC": NonSpare_921_Arg,
    "POS": NonSpare_1439_Arg,
    "GAL": NonSpare_1011_Arg,
    "PUN": NonSpare_1475_Arg,
    "MB": NonSpare_1222_Arg,
    "IAR": NonSpare_1092_Arg,
    "MAC": NonSpare_1212_Arg,
    "BPS": NonSpare_688_Arg,
}, total=False)
class Variation_1456(Compound):
    cv_fspec_max_bytes = 4
    cv_items_list = [NonSpare_567, NonSpare_1103, NonSpare_1270, NonSpare_1096, NonSpare_1823, NonSpare_1648, NonSpare_994, NonSpare_1864, NonSpare_1859, NonSpare_780, NonSpare_1642, NonSpare_559, NonSpare_690, NonSpare_1041, NonSpare_1538, NonSpare_1818, NonSpare_1813, NonSpare_1030, NonSpare_2035, NonSpare_1262, NonSpare_921, NonSpare_1439, NonSpare_1011, NonSpare_1475, NonSpare_1222, NonSpare_1092, NonSpare_1212, NonSpare_688]
    cv_items_dict = {"ADR": NonSpare_567, "ID": NonSpare_1103, "MHG": NonSpare_1270, "IAS": NonSpare_1096, "TAS": NonSpare_1823, "SAL": NonSpare_1648, "FSS": NonSpare_994, "TIS": NonSpare_1864, "TID": NonSpare_1859, "COM": NonSpare_780, "SAB": NonSpare_1642, "ACS": NonSpare_559, "BVR": NonSpare_690, "GVR": NonSpare_1041, "RAN": NonSpare_1538, "TAR": NonSpare_1818, "TAN": NonSpare_1813, "GS": NonSpare_1030, "VUN": NonSpare_2035, "MET": NonSpare_1262, "EMC": NonSpare_921, "POS": NonSpare_1439, "GAL": NonSpare_1011, "PUN": NonSpare_1475, "MB": NonSpare_1222, "IAR": NonSpare_1092, "MAC": NonSpare_1212, "BPS": NonSpare_688}

    @overload
    @classmethod
    def spec(cls, key : Literal["ADR"]) -> NonSpare_567:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ID"]) -> NonSpare_1103:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MHG"]) -> NonSpare_1270:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAS"]) -> NonSpare_1096:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAS"]) -> NonSpare_1823:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAL"]) -> NonSpare_1648:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FSS"]) -> NonSpare_994:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TIS"]) -> NonSpare_1864:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> NonSpare_1859:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> NonSpare_780:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAB"]) -> NonSpare_1642:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ACS"]) -> NonSpare_559:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BVR"]) -> NonSpare_690:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GVR"]) -> NonSpare_1041:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAN"]) -> NonSpare_1538:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAR"]) -> NonSpare_1818:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAN"]) -> NonSpare_1813:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GS"]) -> NonSpare_1030:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VUN"]) -> NonSpare_2035:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MET"]) -> NonSpare_1262:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EMC"]) -> NonSpare_921:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1439:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GAL"]) -> NonSpare_1011:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PUN"]) -> NonSpare_1475:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MB"]) -> NonSpare_1222:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAR"]) -> NonSpare_1092:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MAC"]) -> NonSpare_1212:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BPS"]) -> NonSpare_688:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ADR"], Literal["ID"], Literal["MHG"], Literal["IAS"], Literal["TAS"], Literal["SAL"], Literal["FSS"], Literal["TIS"], Literal["TID"], Literal["COM"], Literal["SAB"], Literal["ACS"], Literal["BVR"], Literal["GVR"], Literal["RAN"], Literal["TAR"], Literal["TAN"], Literal["GS"], Literal["VUN"], Literal["MET"], Literal["EMC"], Literal["POS"], Literal["GAL"], Literal["PUN"], Literal["MB"], Literal["IAR"], Literal["MAC"], Literal["BPS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ADR"]) -> Optional[NonSpare_567]:
        ...
    @overload
    def get_item(self, key : Literal["ID"]) -> Optional[NonSpare_1103]:
        ...
    @overload
    def get_item(self, key : Literal["MHG"]) -> Optional[NonSpare_1270]:
        ...
    @overload
    def get_item(self, key : Literal["IAS"]) -> Optional[NonSpare_1096]:
        ...
    @overload
    def get_item(self, key : Literal["TAS"]) -> Optional[NonSpare_1823]:
        ...
    @overload
    def get_item(self, key : Literal["SAL"]) -> Optional[NonSpare_1648]:
        ...
    @overload
    def get_item(self, key : Literal["FSS"]) -> Optional[NonSpare_994]:
        ...
    @overload
    def get_item(self, key : Literal["TIS"]) -> Optional[NonSpare_1864]:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> Optional[NonSpare_1859]:
        ...
    @overload
    def get_item(self, key : Literal["COM"]) -> Optional[NonSpare_780]:
        ...
    @overload
    def get_item(self, key : Literal["SAB"]) -> Optional[NonSpare_1642]:
        ...
    @overload
    def get_item(self, key : Literal["ACS"]) -> Optional[NonSpare_559]:
        ...
    @overload
    def get_item(self, key : Literal["BVR"]) -> Optional[NonSpare_690]:
        ...
    @overload
    def get_item(self, key : Literal["GVR"]) -> Optional[NonSpare_1041]:
        ...
    @overload
    def get_item(self, key : Literal["RAN"]) -> Optional[NonSpare_1538]:
        ...
    @overload
    def get_item(self, key : Literal["TAR"]) -> Optional[NonSpare_1818]:
        ...
    @overload
    def get_item(self, key : Literal["TAN"]) -> Optional[NonSpare_1813]:
        ...
    @overload
    def get_item(self, key : Literal["GS"]) -> Optional[NonSpare_1030]:
        ...
    @overload
    def get_item(self, key : Literal["VUN"]) -> Optional[NonSpare_2035]:
        ...
    @overload
    def get_item(self, key : Literal["MET"]) -> Optional[NonSpare_1262]:
        ...
    @overload
    def get_item(self, key : Literal["EMC"]) -> Optional[NonSpare_921]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1439]:
        ...
    @overload
    def get_item(self, key : Literal["GAL"]) -> Optional[NonSpare_1011]:
        ...
    @overload
    def get_item(self, key : Literal["PUN"]) -> Optional[NonSpare_1475]:
        ...
    @overload
    def get_item(self, key : Literal["MB"]) -> Optional[NonSpare_1222]:
        ...
    @overload
    def get_item(self, key : Literal["IAR"]) -> Optional[NonSpare_1092]:
        ...
    @overload
    def get_item(self, key : Literal["MAC"]) -> Optional[NonSpare_1212]:
        ...
    @overload
    def get_item(self, key : Literal["BPS"]) -> Optional[NonSpare_688]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["ADR"], val : NonSpare_567_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["ID"], val : NonSpare_1103_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["MHG"], val : NonSpare_1270_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["IAS"], val : NonSpare_1096_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["TAS"], val : NonSpare_1823_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["SAL"], val : NonSpare_1648_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["FSS"], val : NonSpare_994_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["TIS"], val : NonSpare_1864_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["TID"], val : NonSpare_1859_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["COM"], val : NonSpare_780_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["SAB"], val : NonSpare_1642_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["ACS"], val : NonSpare_559_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["BVR"], val : NonSpare_690_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["GVR"], val : NonSpare_1041_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["RAN"], val : NonSpare_1538_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["TAR"], val : NonSpare_1818_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["TAN"], val : NonSpare_1813_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["GS"], val : NonSpare_1030_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["VUN"], val : NonSpare_2035_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["MET"], val : NonSpare_1262_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["EMC"], val : NonSpare_921_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1439_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["GAL"], val : NonSpare_1011_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["PUN"], val : NonSpare_1475_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["MB"], val : NonSpare_1222_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["IAR"], val : NonSpare_1092_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["MAC"], val : NonSpare_1212_Arg) -> "Variation_1456":
        ...
    @overload
    def set_item(self, key : Literal["BPS"], val : NonSpare_688_Arg) -> "Variation_1456":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["ADR"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["ID"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["MHG"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["IAS"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["TAS"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["SAL"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["FSS"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["TIS"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["TID"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["COM"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["SAB"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["ACS"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["BVR"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["GVR"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["RAN"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["TAR"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["TAN"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["GS"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["VUN"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["MET"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["EMC"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["GAL"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["PUN"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["MB"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["IAR"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["MAC"]) -> "Variation_1456":
        ...
    @overload
    def del_item(self, key : Literal["BPS"]) -> "Variation_1456":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1456_Arg) -> 'Variation_1456':
        return cls._create(arg) # type: ignore

RuleVariation_1379_Arg: TypeAlias = Variation_1456_Arg
class RuleVariation_1379(RuleVariationContextFree):
    cv_variation = Variation_1456

    @classmethod
    def create(cls, arg : RuleVariation_1379_Arg) -> "RuleVariation_1379":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1456:
        return self.arg # type: ignore

NonSpare_480_Arg: TypeAlias = RuleVariation_1379_Arg
class NonSpare_480(NonSpare):
    cv_name = "380"
    cv_title = "Aircraft Derived Data"
    cv_rule = RuleVariation_1379

    @classmethod
    def create(cls, arg : NonSpare_480_Arg) -> "NonSpare_480":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1379:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1456:
        return self.rule.variation

class UapItem_480(UapItem):
    cv_non_spare = NonSpare_480

NonSpare_147_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_147(NonSpare):
    cv_name = "040"
    cv_title = "Track Number"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_147_Arg) -> "NonSpare_147":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

class UapItem_147(UapItem):
    cv_non_spare = NonSpare_147

Content_297_Arg: TypeAlias = int
class Content_297(ContentTable):
    cv_values = {0: "Multisensor track", 1: "Monosensor track"}

RuleContent_297_Arg: TypeAlias = Content_297_Arg
class RuleContent_297(RuleContentContextFree):
    cv_content = Content_297

    @property
    def content(self) -> Content_297:
        return self._get_content() # type: ignore

Variation_54_Arg: TypeAlias = RuleContent_297_Arg
class Variation_54(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_297

    @classmethod
    def create(cls, arg : Variation_54_Arg) -> "Variation_54":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_297:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_297:
        return self.rule.content

RuleVariation_54_Arg: TypeAlias = Variation_54_Arg
class RuleVariation_54(RuleVariationContextFree):
    cv_variation = Variation_54

    @classmethod
    def create(cls, arg : RuleVariation_54_Arg) -> "RuleVariation_54":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_54:
        return self.arg # type: ignore

Content_369_Arg: TypeAlias = int
class Content_369(ContentTable):
    cv_values = {0: "No source", 1: "GNSS", 2: "3D radar", 3: "Triangulation", 4: "Height from coverage", 5: "Speed look-up table", 6: "Default height", 7: "Multilateration"}

RuleContent_369_Arg: TypeAlias = Content_369_Arg
class RuleContent_369(RuleContentContextFree):
    cv_content = Content_369

    @property
    def content(self) -> Content_369:
        return self._get_content() # type: ignore

Variation_686_Arg: TypeAlias = RuleContent_369_Arg
class Variation_686(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 3
    cv_rule = RuleContent_369

    @classmethod
    def create(cls, arg : Variation_686_Arg) -> "Variation_686":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_369:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_369:
        return self.rule.content

RuleVariation_675_Arg: TypeAlias = Variation_686_Arg
class RuleVariation_675(RuleVariationContextFree):
    cv_variation = Variation_686

    @classmethod
    def create(cls, arg : RuleVariation_675_Arg) -> "RuleVariation_675":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_686:
        return self.arg # type: ignore

Content_20_Arg: TypeAlias = int
class Content_20(ContentTable):
    cv_values = {0: "Actual track", 1: "Simulated track"}

RuleContent_20_Arg: TypeAlias = Content_20_Arg
class RuleContent_20(RuleContentContextFree):
    cv_content = Content_20

    @property
    def content(self) -> Content_20:
        return self._get_content() # type: ignore

Variation_6_Arg: TypeAlias = RuleContent_20_Arg
class Variation_6(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_20

    @classmethod
    def create(cls, arg : Variation_6_Arg) -> "Variation_6":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_20:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_20:
        return self.rule.content

RuleVariation_6_Arg: TypeAlias = Variation_6_Arg
class RuleVariation_6(RuleVariationContextFree):
    cv_variation = Variation_6

    @classmethod
    def create(cls, arg : RuleVariation_6_Arg) -> "RuleVariation_6":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_6:
        return self.arg # type: ignore

Content_186_Arg: TypeAlias = int
class Content_186(ContentTable):
    cv_values = {0: "Default value", 1: "Last message transmitted to the user for the track"}

RuleContent_186_Arg: TypeAlias = Content_186_Arg
class RuleContent_186(RuleContentContextFree):
    cv_content = Content_186

    @property
    def content(self) -> Content_186:
        return self._get_content() # type: ignore

Variation_420_Arg: TypeAlias = RuleContent_186_Arg
class Variation_420(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_186

    @classmethod
    def create(cls, arg : Variation_420_Arg) -> "Variation_420":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_186:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_186:
        return self.rule.content

RuleVariation_409_Arg: TypeAlias = Variation_420_Arg
class RuleVariation_409(RuleVariationContextFree):
    cv_variation = Variation_420

    @classmethod
    def create(cls, arg : RuleVariation_409_Arg) -> "RuleVariation_409":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_420:
        return self.arg # type: ignore

Content_184_Arg: TypeAlias = int
class Content_184(ContentTable):
    cv_values = {0: "Default value", 1: "First message transmitted to the user for the track"}

RuleContent_184_Arg: TypeAlias = Content_184_Arg
class RuleContent_184(RuleContentContextFree):
    cv_content = Content_184

    @property
    def content(self) -> Content_184:
        return self._get_content() # type: ignore

Variation_528_Arg: TypeAlias = RuleContent_184_Arg
class Variation_528(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_184

    @classmethod
    def create(cls, arg : Variation_528_Arg) -> "Variation_528":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_184:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_184:
        return self.rule.content

RuleVariation_517_Arg: TypeAlias = Variation_528_Arg
class RuleVariation_517(RuleVariationContextFree):
    cv_variation = Variation_528

    @classmethod
    def create(cls, arg : RuleVariation_517_Arg) -> "RuleVariation_517":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_528:
        return self.arg # type: ignore

Content_190_Arg: TypeAlias = int
class Content_190(ContentTable):
    cv_values = {0: "Default value", 1: "Slave Track Promotion"}

RuleContent_190_Arg: TypeAlias = Content_190_Arg
class RuleContent_190(RuleContentContextFree):
    cv_content = Content_190

    @property
    def content(self) -> Content_190:
        return self._get_content() # type: ignore

Variation_843_Arg: TypeAlias = RuleContent_190_Arg
class Variation_843(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_190

    @classmethod
    def create(cls, arg : Variation_843_Arg) -> "Variation_843":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_190:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_190:
        return self.rule.content

RuleVariation_813_Arg: TypeAlias = Variation_843_Arg
class RuleVariation_813(RuleVariationContextFree):
    cv_variation = Variation_843

    @classmethod
    def create(cls, arg : RuleVariation_813_Arg) -> "RuleVariation_813":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_843:
        return self.arg # type: ignore

Content_59_Arg: TypeAlias = int
class Content_59(ContentTable):
    cv_values = {0: "Complementary service used", 1: "Background service used"}

RuleContent_59_Arg: TypeAlias = Content_59_Arg
class RuleContent_59(RuleContentContextFree):
    cv_content = Content_59

    @property
    def content(self) -> Content_59:
        return self._get_content() # type: ignore

Variation_902_Arg: TypeAlias = RuleContent_59_Arg
class Variation_902(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_59

    @classmethod
    def create(cls, arg : Variation_902_Arg) -> "Variation_902":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_59:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_59:
        return self.rule.content

RuleVariation_872_Arg: TypeAlias = Variation_902_Arg
class RuleVariation_872(RuleVariationContextFree):
    cv_variation = Variation_902

    @classmethod
    def create(cls, arg : RuleVariation_872_Arg) -> "RuleVariation_872":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_902:
        return self.arg # type: ignore

Variation_467_Arg: TypeAlias = RuleContent_307_Arg
class Variation_467(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_307

    @classmethod
    def create(cls, arg : Variation_467_Arg) -> "Variation_467":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_307:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_307:
        return self.rule.content

RuleVariation_456_Arg: TypeAlias = Variation_467_Arg
class RuleVariation_456(RuleVariationContextFree):
    cv_variation = Variation_467

    @classmethod
    def create(cls, arg : RuleVariation_456_Arg) -> "RuleVariation_456":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_467:
        return self.arg # type: ignore

Variation_633_Arg: TypeAlias = RuleContent_187_Arg
class Variation_633(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_187

    @classmethod
    def create(cls, arg : Variation_633_Arg) -> "Variation_633":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_187:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_187:
        return self.rule.content

RuleVariation_622_Arg: TypeAlias = Variation_633_Arg
class RuleVariation_622(RuleVariationContextFree):
    cv_variation = Variation_633

    @classmethod
    def create(cls, arg : RuleVariation_622_Arg) -> "RuleVariation_622":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_633:
        return self.arg # type: ignore

Content_188_Arg: TypeAlias = int
class Content_188(ContentTable):
    cv_values = {0: "Default value", 1: "Military Identification present in the last report received from a sensor capable of decoding this data"}

RuleContent_188_Arg: TypeAlias = Content_188_Arg
class RuleContent_188(RuleContentContextFree):
    cv_content = Content_188

    @property
    def content(self) -> Content_188:
        return self._get_content() # type: ignore

Variation_716_Arg: TypeAlias = RuleContent_188_Arg
class Variation_716(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_188

    @classmethod
    def create(cls, arg : Variation_716_Arg) -> "Variation_716":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_188:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_188:
        return self.rule.content

RuleVariation_705_Arg: TypeAlias = Variation_716_Arg
class RuleVariation_705(RuleVariationContextFree):
    cv_variation = Variation_716

    @classmethod
    def create(cls, arg : RuleVariation_705_Arg) -> "RuleVariation_705":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_716:
        return self.arg # type: ignore

Content_310_Arg: TypeAlias = int
class Content_310(ContentTable):
    cv_values = {0: "No Mode 5 interrogation", 1: "Friendly target", 2: "Unknown target", 3: "No reply"}

RuleContent_310_Arg: TypeAlias = Content_310_Arg
class RuleContent_310(RuleContentContextFree):
    cv_content = Content_310

    @property
    def content(self) -> Content_310:
        return self._get_content() # type: ignore

Variation_879_Arg: TypeAlias = RuleContent_310_Arg
class Variation_879(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_310

    @classmethod
    def create(cls, arg : Variation_879_Arg) -> "Variation_879":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_310:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_310:
        return self.rule.content

RuleVariation_849_Arg: TypeAlias = Variation_879_Arg
class RuleVariation_849(RuleVariationContextFree):
    cv_variation = Variation_879

    @classmethod
    def create(cls, arg : RuleVariation_849_Arg) -> "RuleVariation_849":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_879:
        return self.arg # type: ignore

Variation_37_Arg: TypeAlias = RuleContent_178_Arg
class Variation_37(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_178

    @classmethod
    def create(cls, arg : Variation_37_Arg) -> "Variation_37":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_178:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_178:
        return self.rule.content

RuleVariation_37_Arg: TypeAlias = Variation_37_Arg
class RuleVariation_37(RuleVariationContextFree):
    cv_variation = Variation_37

    @classmethod
    def create(cls, arg : RuleVariation_37_Arg) -> "RuleVariation_37":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_37:
        return self.arg # type: ignore

Content_173_Arg: TypeAlias = int
class Content_173(ContentTable):
    cv_values = {0: "Default value", 1: "Age of the last received ADS-B track update is higher than system dependent threshold"}

RuleContent_173_Arg: TypeAlias = Content_173_Arg
class RuleContent_173(RuleContentContextFree):
    cv_content = Content_173

    @property
    def content(self) -> Content_173:
        return self._get_content() # type: ignore

Variation_715_Arg: TypeAlias = RuleContent_173_Arg
class Variation_715(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_173

    @classmethod
    def create(cls, arg : Variation_715_Arg) -> "Variation_715":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_173:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_173:
        return self.rule.content

RuleVariation_704_Arg: TypeAlias = Variation_715_Arg
class RuleVariation_704(RuleVariationContextFree):
    cv_variation = Variation_715

    @classmethod
    def create(cls, arg : RuleVariation_704_Arg) -> "RuleVariation_704":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_715:
        return self.arg # type: ignore

Content_179_Arg: TypeAlias = int
class Content_179(ContentTable):
    cv_values = {0: "Default value", 1: "Assigned Mode A Code Conflict (same discrete Mode A Code assigned to another track)"}

RuleContent_179_Arg: TypeAlias = Content_179_Arg
class RuleContent_179(RuleContentContextFree):
    cv_content = Content_179

    @property
    def content(self) -> Content_179:
        return self._get_content() # type: ignore

Variation_920_Arg: TypeAlias = RuleContent_179_Arg
class Variation_920(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_179

    @classmethod
    def create(cls, arg : Variation_920_Arg) -> "Variation_920":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_179:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_179:
        return self.rule.content

RuleVariation_890_Arg: TypeAlias = Variation_920_Arg
class RuleVariation_890(RuleVariationContextFree):
    cv_variation = Variation_920

    @classmethod
    def create(cls, arg : RuleVariation_890_Arg) -> "RuleVariation_890":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_920:
        return self.arg # type: ignore

Content_57_Arg: TypeAlias = int
class Content_57(ContentTable):
    cv_values = {0: "Combined", 1: "Co-operative only", 2: "Non-Cooperative only", 3: "Not defined"}

RuleContent_57_Arg: TypeAlias = Content_57_Arg
class RuleContent_57(RuleContentContextFree):
    cv_content = Content_57

    @property
    def content(self) -> Content_57:
        return self._get_content() # type: ignore

Variation_99_Arg: TypeAlias = RuleContent_57_Arg
class Variation_99(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_57

    @classmethod
    def create(cls, arg : Variation_99_Arg) -> "Variation_99":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_57:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_57:
        return self.rule.content

RuleVariation_99_Arg: TypeAlias = Variation_99_Arg
class RuleVariation_99(RuleVariationContextFree):
    cv_variation = Variation_99

    @classmethod
    def create(cls, arg : RuleVariation_99_Arg) -> "RuleVariation_99":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_99:
        return self.arg # type: ignore

Content_352_Arg: TypeAlias = int
class Content_352(ContentTable):
    cv_values = {0: "No emergency", 1: "General emergency", 2: "Lifeguard / medical", 3: "Minimum fuel", 4: "No communications", 5: "Unlawful interference", 6: "Downed Aircraft", 7: "Undefined"}

RuleContent_352_Arg: TypeAlias = Content_352_Arg
class RuleContent_352(RuleContentContextFree):
    cv_content = Content_352

    @property
    def content(self) -> Content_352:
        return self._get_content() # type: ignore

Variation_598_Arg: TypeAlias = RuleContent_352_Arg
class Variation_598(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 3
    cv_rule = RuleContent_352

    @classmethod
    def create(cls, arg : Variation_598_Arg) -> "Variation_598":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_352:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_352:
        return self.rule.content

RuleVariation_587_Arg: TypeAlias = Variation_598_Arg
class RuleVariation_587(RuleVariationContextFree):
    cv_variation = Variation_598

    @classmethod
    def create(cls, arg : RuleVariation_587_Arg) -> "RuleVariation_587":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_598:
        return self.arg # type: ignore

Content_362_Arg: TypeAlias = int
class Content_362(ContentTable):
    cv_values = {0: "No indication", 1: "Potential False Track Indication"}

RuleContent_362_Arg: TypeAlias = Content_362_Arg
class RuleContent_362(RuleContentContextFree):
    cv_content = Content_362

    @property
    def content(self) -> Content_362:
        return self._get_content() # type: ignore

Variation_860_Arg: TypeAlias = RuleContent_362_Arg
class Variation_860(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_362

    @classmethod
    def create(cls, arg : Variation_860_Arg) -> "Variation_860":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_362:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_362:
        return self.rule.content

RuleVariation_830_Arg: TypeAlias = Variation_860_Arg
class RuleVariation_830(RuleVariationContextFree):
    cv_variation = Variation_860

    @classmethod
    def create(cls, arg : RuleVariation_830_Arg) -> "RuleVariation_830":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_860:
        return self.arg # type: ignore

Content_193_Arg: TypeAlias = int
class Content_193(ContentTable):
    cv_values = {0: "Default value", 1: "Track created / updated with FPL data"}

RuleContent_193_Arg: TypeAlias = Content_193_Arg
class RuleContent_193(RuleContentContextFree):
    cv_content = Content_193

    @property
    def content(self) -> Content_193:
        return self._get_content() # type: ignore

Variation_922_Arg: TypeAlias = RuleContent_193_Arg
class Variation_922(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_193

    @classmethod
    def create(cls, arg : Variation_922_Arg) -> "Variation_922":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_193:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_193:
        return self.rule.content

RuleVariation_892_Arg: TypeAlias = Variation_922_Arg
class RuleVariation_892(RuleVariationContextFree):
    cv_variation = Variation_922

    @classmethod
    def create(cls, arg : RuleVariation_892_Arg) -> "RuleVariation_892":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_922:
        return self.arg # type: ignore

Content_183_Arg: TypeAlias = int
class Content_183(ContentTable):
    cv_values = {0: "Default value", 1: "Duplicate Mode 3/A Code"}

RuleContent_183_Arg: TypeAlias = Content_183_Arg
class RuleContent_183(RuleContentContextFree):
    cv_content = Content_183

    @property
    def content(self) -> Content_183:
        return self._get_content() # type: ignore

Variation_38_Arg: TypeAlias = RuleContent_183_Arg
class Variation_38(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_183

    @classmethod
    def create(cls, arg : Variation_38_Arg) -> "Variation_38":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_183:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_183:
        return self.rule.content

RuleVariation_38_Arg: TypeAlias = Variation_38_Arg
class RuleVariation_38(RuleVariationContextFree):
    cv_variation = Variation_38

    @classmethod
    def create(cls, arg : RuleVariation_38_Arg) -> "RuleVariation_38":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_38:
        return self.arg # type: ignore

Content_181_Arg: TypeAlias = int
class Content_181(ContentTable):
    cv_values = {0: "Default value", 1: "Duplicate Flight Plan"}

RuleContent_181_Arg: TypeAlias = Content_181_Arg
class RuleContent_181(RuleContentContextFree):
    cv_content = Content_181

    @property
    def content(self) -> Content_181:
        return self._get_content() # type: ignore

Variation_419_Arg: TypeAlias = RuleContent_181_Arg
class Variation_419(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_181

    @classmethod
    def create(cls, arg : Variation_419_Arg) -> "Variation_419":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_181:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_181:
        return self.rule.content

RuleVariation_408_Arg: TypeAlias = Variation_419_Arg
class RuleVariation_408(RuleVariationContextFree):
    cv_variation = Variation_419

    @classmethod
    def create(cls, arg : RuleVariation_408_Arg) -> "RuleVariation_408":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_419:
        return self.arg # type: ignore

Content_182_Arg: TypeAlias = int
class Content_182(ContentTable):
    cv_values = {0: "Default value", 1: "Duplicate Flight Plan due to manual correlation"}

RuleContent_182_Arg: TypeAlias = Content_182_Arg
class RuleContent_182(RuleContentContextFree):
    cv_content = Content_182

    @property
    def content(self) -> Content_182:
        return self._get_content() # type: ignore

Variation_527_Arg: TypeAlias = RuleContent_182_Arg
class Variation_527(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_182

    @classmethod
    def create(cls, arg : Variation_527_Arg) -> "Variation_527":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_182:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_182:
        return self.rule.content

RuleVariation_516_Arg: TypeAlias = Variation_527_Arg
class RuleVariation_516(RuleVariationContextFree):
    cv_variation = Variation_527

    @classmethod
    def create(cls, arg : RuleVariation_516_Arg) -> "RuleVariation_516":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_527:
        return self.arg # type: ignore

NonSpare_1304_Arg: TypeAlias = RuleVariation_54_Arg
class NonSpare_1304(NonSpare):
    cv_name = "MON"
    cv_title = ""
    cv_rule = RuleVariation_54

    @classmethod
    def create(cls, arg : NonSpare_1304_Arg) -> "NonSpare_1304":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_54:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_54:
        return self.rule.variation

Item_576_Arg: TypeAlias = NonSpare_1304_Arg
class Item_576(Item):
    cv_non_spare = NonSpare_1304

    @classmethod
    def create(cls, arg : Item_576_Arg) -> "Item_576":
        return cls._create(arg) # type: ignore

NonSpare_1307_Arg: TypeAlias = RuleVariation_497_Arg
class NonSpare_1307(NonSpare):
    cv_name = "MRH"
    cv_title = "Most Reliable Height"
    cv_rule = RuleVariation_497

    @classmethod
    def create(cls, arg : NonSpare_1307_Arg) -> "NonSpare_1307":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_497:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_508:
        return self.rule.variation

Item_579_Arg: TypeAlias = NonSpare_1307_Arg
class Item_579(Item):
    cv_non_spare = NonSpare_1307

    @classmethod
    def create(cls, arg : Item_579_Arg) -> "Item_579":
        return cls._create(arg) # type: ignore

NonSpare_1742_Arg: TypeAlias = RuleVariation_675_Arg
class NonSpare_1742(NonSpare):
    cv_name = "SRC"
    cv_title = "Source of Calculated Track Altitude for I062/130"
    cv_rule = RuleVariation_675

    @classmethod
    def create(cls, arg : NonSpare_1742_Arg) -> "NonSpare_1742":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_675:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_686:
        return self.rule.variation

Item_920_Arg: TypeAlias = NonSpare_1742_Arg
class Item_920(Item):
    cv_non_spare = NonSpare_1742

    @classmethod
    def create(cls, arg : Item_920_Arg) -> "Item_920":
        return cls._create(arg) # type: ignore

NonSpare_1715_Arg: TypeAlias = RuleVariation_6_Arg
class NonSpare_1715(NonSpare):
    cv_name = "SIM"
    cv_title = ""
    cv_rule = RuleVariation_6

    @classmethod
    def create(cls, arg : NonSpare_1715_Arg) -> "NonSpare_1715":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_6:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_6:
        return self.rule.variation

Item_896_Arg: TypeAlias = NonSpare_1715_Arg
class Item_896(Item):
    cv_non_spare = NonSpare_1715

    @classmethod
    def create(cls, arg : Item_896_Arg) -> "Item_896":
        return cls._create(arg) # type: ignore

NonSpare_1920_Arg: TypeAlias = RuleVariation_409_Arg
class NonSpare_1920(NonSpare):
    cv_name = "TSE"
    cv_title = ""
    cv_rule = RuleVariation_409

    @classmethod
    def create(cls, arg : NonSpare_1920_Arg) -> "NonSpare_1920":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_409:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_420:
        return self.rule.variation

Item_1043_Arg: TypeAlias = NonSpare_1920_Arg
class Item_1043(Item):
    cv_non_spare = NonSpare_1920

    @classmethod
    def create(cls, arg : Item_1043_Arg) -> "Item_1043":
        return cls._create(arg) # type: ignore

NonSpare_1918_Arg: TypeAlias = RuleVariation_517_Arg
class NonSpare_1918(NonSpare):
    cv_name = "TSB"
    cv_title = ""
    cv_rule = RuleVariation_517

    @classmethod
    def create(cls, arg : NonSpare_1918_Arg) -> "NonSpare_1918":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_517:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_528:
        return self.rule.variation

Item_1041_Arg: TypeAlias = NonSpare_1918_Arg
class Item_1041(Item):
    cv_non_spare = NonSpare_1918

    @classmethod
    def create(cls, arg : Item_1041_Arg) -> "Item_1041":
        return cls._create(arg) # type: ignore

NonSpare_1787_Arg: TypeAlias = RuleVariation_813_Arg
class NonSpare_1787(NonSpare):
    cv_name = "STP"
    cv_title = ""
    cv_rule = RuleVariation_813

    @classmethod
    def create(cls, arg : NonSpare_1787_Arg) -> "NonSpare_1787":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_813:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_843:
        return self.rule.variation

Item_953_Arg: TypeAlias = NonSpare_1787_Arg
class Item_953(Item):
    cv_non_spare = NonSpare_1787

    @classmethod
    def create(cls, arg : Item_953_Arg) -> "Item_953":
        return cls._create(arg) # type: ignore

NonSpare_1121_Arg: TypeAlias = RuleVariation_872_Arg
class NonSpare_1121(NonSpare):
    cv_name = "KOS"
    cv_title = ""
    cv_rule = RuleVariation_872

    @classmethod
    def create(cls, arg : NonSpare_1121_Arg) -> "NonSpare_1121":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_872:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_902:
        return self.rule.variation

Item_439_Arg: TypeAlias = NonSpare_1121_Arg
class Item_439(Item):
    cv_non_spare = NonSpare_1121

    @classmethod
    def create(cls, arg : Item_439_Arg) -> "Item_439":
        return cls._create(arg) # type: ignore

NonSpare_1236_Arg: TypeAlias = RuleVariation_456_Arg
class NonSpare_1236(NonSpare):
    cv_name = "MD4"
    cv_title = ""
    cv_rule = RuleVariation_456

    @classmethod
    def create(cls, arg : NonSpare_1236_Arg) -> "NonSpare_1236":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_456:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_467:
        return self.rule.variation

Item_533_Arg: TypeAlias = NonSpare_1236_Arg
class Item_533(Item):
    cv_non_spare = NonSpare_1236

    @classmethod
    def create(cls, arg : Item_533_Arg) -> "Item_533":
        return cls._create(arg) # type: ignore

NonSpare_1256_Arg: TypeAlias = RuleVariation_622_Arg
class NonSpare_1256(NonSpare):
    cv_name = "ME"
    cv_title = ""
    cv_rule = RuleVariation_622

    @classmethod
    def create(cls, arg : NonSpare_1256_Arg) -> "NonSpare_1256":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_622:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_633:
        return self.rule.variation

Item_540_Arg: TypeAlias = NonSpare_1256_Arg
class Item_540(Item):
    cv_non_spare = NonSpare_1256

    @classmethod
    def create(cls, arg : Item_540_Arg) -> "Item_540":
        return cls._create(arg) # type: ignore

NonSpare_1274_Arg: TypeAlias = RuleVariation_705_Arg
class NonSpare_1274(NonSpare):
    cv_name = "MI"
    cv_title = ""
    cv_rule = RuleVariation_705

    @classmethod
    def create(cls, arg : NonSpare_1274_Arg) -> "NonSpare_1274":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_705:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_716:
        return self.rule.variation

Item_547_Arg: TypeAlias = NonSpare_1274_Arg
class Item_547(Item):
    cv_non_spare = NonSpare_1274

    @classmethod
    def create(cls, arg : Item_547_Arg) -> "Item_547":
        return cls._create(arg) # type: ignore

NonSpare_1238_Arg: TypeAlias = RuleVariation_849_Arg
class NonSpare_1238(NonSpare):
    cv_name = "MD5"
    cv_title = ""
    cv_rule = RuleVariation_849

    @classmethod
    def create(cls, arg : NonSpare_1238_Arg) -> "NonSpare_1238":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_849:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_879:
        return self.rule.variation

Item_534_Arg: TypeAlias = NonSpare_1238_Arg
class Item_534(Item):
    cv_non_spare = NonSpare_1238

    @classmethod
    def create(cls, arg : Item_534_Arg) -> "Item_534":
        return cls._create(arg) # type: ignore

NonSpare_830_Arg: TypeAlias = RuleVariation_37_Arg
class NonSpare_830(NonSpare):
    cv_name = "CST"
    cv_title = ""
    cv_rule = RuleVariation_37

    @classmethod
    def create(cls, arg : NonSpare_830_Arg) -> "NonSpare_830":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_37:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_37:
        return self.rule.variation

Item_219_Arg: TypeAlias = NonSpare_830_Arg
class Item_219(Item):
    cv_non_spare = NonSpare_830

    @classmethod
    def create(cls, arg : Item_219_Arg) -> "Item_219":
        return cls._create(arg) # type: ignore

NonSpare_569_Arg: TypeAlias = RuleVariation_704_Arg
class NonSpare_569(NonSpare):
    cv_name = "ADS"
    cv_title = ""
    cv_rule = RuleVariation_704

    @classmethod
    def create(cls, arg : NonSpare_569_Arg) -> "NonSpare_569":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_704:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_715:
        return self.rule.variation

Item_46_Arg: TypeAlias = NonSpare_569_Arg
class Item_46(Item):
    cv_non_spare = NonSpare_569

    @classmethod
    def create(cls, arg : Item_46_Arg) -> "Item_46":
        return cls._create(arg) # type: ignore

NonSpare_545_Arg: TypeAlias = RuleVariation_890_Arg
class NonSpare_545(NonSpare):
    cv_name = "AAC"
    cv_title = ""
    cv_rule = RuleVariation_890

    @classmethod
    def create(cls, arg : NonSpare_545_Arg) -> "NonSpare_545":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_890:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_920:
        return self.rule.variation

Item_34_Arg: TypeAlias = NonSpare_545_Arg
class Item_34(Item):
    cv_non_spare = NonSpare_545

    @classmethod
    def create(cls, arg : Item_34_Arg) -> "Item_34":
        return cls._create(arg) # type: ignore

NonSpare_1685_Arg: TypeAlias = RuleVariation_99_Arg
class NonSpare_1685(NonSpare):
    cv_name = "SDS"
    cv_title = ""
    cv_rule = RuleVariation_99

    @classmethod
    def create(cls, arg : NonSpare_1685_Arg) -> "NonSpare_1685":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_99:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_99:
        return self.rule.variation

Item_871_Arg: TypeAlias = NonSpare_1685_Arg
class Item_871(Item):
    cv_non_spare = NonSpare_1685

    @classmethod
    def create(cls, arg : Item_871_Arg) -> "Item_871":
        return cls._create(arg) # type: ignore

NonSpare_925_Arg: TypeAlias = RuleVariation_587_Arg
class NonSpare_925(NonSpare):
    cv_name = "EMS"
    cv_title = ""
    cv_rule = RuleVariation_587

    @classmethod
    def create(cls, arg : NonSpare_925_Arg) -> "NonSpare_925":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_587:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_598:
        return self.rule.variation

Item_292_Arg: TypeAlias = NonSpare_925_Arg
class Item_292(Item):
    cv_non_spare = NonSpare_925

    @classmethod
    def create(cls, arg : Item_292_Arg) -> "Item_292":
        return cls._create(arg) # type: ignore

NonSpare_1417_Arg: TypeAlias = RuleVariation_830_Arg
class NonSpare_1417(NonSpare):
    cv_name = "PFT"
    cv_title = ""
    cv_rule = RuleVariation_830

    @classmethod
    def create(cls, arg : NonSpare_1417_Arg) -> "NonSpare_1417":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_830:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_860:
        return self.rule.variation

Item_677_Arg: TypeAlias = NonSpare_1417_Arg
class Item_677(Item):
    cv_non_spare = NonSpare_1417

    @classmethod
    def create(cls, arg : Item_677_Arg) -> "Item_677":
        return cls._create(arg) # type: ignore

NonSpare_981_Arg: TypeAlias = RuleVariation_892_Arg
class NonSpare_981(NonSpare):
    cv_name = "FPLT"
    cv_title = ""
    cv_rule = RuleVariation_892

    @classmethod
    def create(cls, arg : NonSpare_981_Arg) -> "NonSpare_981":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_892:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_922:
        return self.rule.variation

Item_337_Arg: TypeAlias = NonSpare_981_Arg
class Item_337(Item):
    cv_non_spare = NonSpare_981

    @classmethod
    def create(cls, arg : Item_337_Arg) -> "Item_337":
        return cls._create(arg) # type: ignore

NonSpare_905_Arg: TypeAlias = RuleVariation_38_Arg
class NonSpare_905(NonSpare):
    cv_name = "DUPT"
    cv_title = ""
    cv_rule = RuleVariation_38

    @classmethod
    def create(cls, arg : NonSpare_905_Arg) -> "NonSpare_905":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_38:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_38:
        return self.rule.variation

Item_281_Arg: TypeAlias = NonSpare_905_Arg
class Item_281(Item):
    cv_non_spare = NonSpare_905

    @classmethod
    def create(cls, arg : Item_281_Arg) -> "Item_281":
        return cls._create(arg) # type: ignore

NonSpare_903_Arg: TypeAlias = RuleVariation_408_Arg
class NonSpare_903(NonSpare):
    cv_name = "DUPF"
    cv_title = ""
    cv_rule = RuleVariation_408

    @classmethod
    def create(cls, arg : NonSpare_903_Arg) -> "NonSpare_903":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_408:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_419:
        return self.rule.variation

Item_279_Arg: TypeAlias = NonSpare_903_Arg
class Item_279(Item):
    cv_non_spare = NonSpare_903

    @classmethod
    def create(cls, arg : Item_279_Arg) -> "Item_279":
        return cls._create(arg) # type: ignore

NonSpare_904_Arg: TypeAlias = RuleVariation_516_Arg
class NonSpare_904(NonSpare):
    cv_name = "DUPM"
    cv_title = ""
    cv_rule = RuleVariation_516

    @classmethod
    def create(cls, arg : NonSpare_904_Arg) -> "NonSpare_904":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_516:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_527:
        return self.rule.variation

Item_280_Arg: TypeAlias = NonSpare_904_Arg
class Item_280(Item):
    cv_non_spare = NonSpare_904

    @classmethod
    def create(cls, arg : Item_280_Arg) -> "Item_280":
        return cls._create(arg) # type: ignore

Variation_1361_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_54_Arg, Tuple[Literal["MON"], RuleVariation_54_Arg]], Union[RuleVariation_410_Arg, Tuple[Literal["SPI"], RuleVariation_410_Arg]], Union[RuleVariation_497_Arg, Tuple[Literal["MRH"], RuleVariation_497_Arg]], Union[RuleVariation_675_Arg, Tuple[Literal["SRC"], RuleVariation_675_Arg]], Union[RuleVariation_874_Arg, Tuple[Literal["CNF"], RuleVariation_874_Arg]], None]]
Variation_1361_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_6_Arg, Tuple[Literal["SIM"], RuleVariation_6_Arg]], Union[RuleVariation_409_Arg, Tuple[Literal["TSE"], RuleVariation_409_Arg]], Union[RuleVariation_517_Arg, Tuple[Literal["TSB"], RuleVariation_517_Arg]], Union[RuleVariation_644_Arg, Tuple[Literal["FPC"], RuleVariation_644_Arg]], Union[RuleVariation_702_Arg, Tuple[Literal["AFF"], RuleVariation_702_Arg]], Union[RuleVariation_813_Arg, Tuple[Literal["STP"], RuleVariation_813_Arg]], Union[RuleVariation_872_Arg, Tuple[Literal["KOS"], RuleVariation_872_Arg]], None]]
Variation_1361_Arg_Group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_89_Arg, Tuple[Literal["AMA"], RuleVariation_89_Arg]], Union[RuleVariation_456_Arg, Tuple[Literal["MD4"], RuleVariation_456_Arg]], Union[RuleVariation_622_Arg, Tuple[Literal["ME"], RuleVariation_622_Arg]], Union[RuleVariation_705_Arg, Tuple[Literal["MI"], RuleVariation_705_Arg]], Union[RuleVariation_849_Arg, Tuple[Literal["MD5"], RuleVariation_849_Arg]], None]]
Variation_1361_Arg_Group_4: TypeAlias = Union[int, Tuple[Union[RuleVariation_37_Arg, Tuple[Literal["CST"], RuleVariation_37_Arg]], Union[RuleVariation_407_Arg, Tuple[Literal["PSR"], RuleVariation_407_Arg]], Union[RuleVariation_514_Arg, Tuple[Literal["SSR"], RuleVariation_514_Arg]], Union[RuleVariation_621_Arg, Tuple[Literal["MDS"], RuleVariation_621_Arg]], Union[RuleVariation_704_Arg, Tuple[Literal["ADS"], RuleVariation_704_Arg]], Union[RuleVariation_814_Arg, Tuple[Literal["SUC"], RuleVariation_814_Arg]], Union[RuleVariation_890_Arg, Tuple[Literal["AAC"], RuleVariation_890_Arg]], None]]
Variation_1361_Arg_Group_5: TypeAlias = Union[int, Tuple[Union[RuleVariation_99_Arg, Tuple[Literal["SDS"], RuleVariation_99_Arg]], Union[RuleVariation_587_Arg, Tuple[Literal["EMS"], RuleVariation_587_Arg]], Union[RuleVariation_830_Arg, Tuple[Literal["PFT"], RuleVariation_830_Arg]], Union[RuleVariation_892_Arg, Tuple[Literal["FPLT"], RuleVariation_892_Arg]], None]]
Variation_1361_Arg_Group_6: TypeAlias = Union[int, Tuple[Union[RuleVariation_38_Arg, Tuple[Literal["DUPT"], RuleVariation_38_Arg]], Union[RuleVariation_408_Arg, Tuple[Literal["DUPF"], RuleVariation_408_Arg]], Union[RuleVariation_516_Arg, Tuple[Literal["DUPM"], RuleVariation_516_Arg]], int, None]]
Variation_1361_Arg: TypeAlias = Union[
    Tuple[Variation_1361_Arg_Group_1],
    Tuple[Variation_1361_Arg_Group_1, Variation_1361_Arg_Group_2],
    Tuple[Variation_1361_Arg_Group_1, Variation_1361_Arg_Group_2, Variation_1361_Arg_Group_3],
    Tuple[Variation_1361_Arg_Group_1, Variation_1361_Arg_Group_2, Variation_1361_Arg_Group_3, Variation_1361_Arg_Group_4],
    Tuple[Variation_1361_Arg_Group_1, Variation_1361_Arg_Group_2, Variation_1361_Arg_Group_3, Variation_1361_Arg_Group_4, Variation_1361_Arg_Group_5],
    Tuple[Variation_1361_Arg_Group_1, Variation_1361_Arg_Group_2, Variation_1361_Arg_Group_3, Variation_1361_Arg_Group_4, Variation_1361_Arg_Group_5, Variation_1361_Arg_Group_6],
]
class Variation_1361(Extended):
    cv_items_list = [[(Item_576, 1), (Item_908, 1), (Item_579, 1), (Item_920, 3), (Item_166, 1), None], [(Item_896, 1), (Item_1043, 1), (Item_1041, 1), (Item_336, 1), (Item_50, 1), (Item_953, 1), (Item_439, 1), None], [(Item_71, 1), (Item_533, 2), (Item_540, 1), (Item_547, 1), (Item_534, 2), None], [(Item_219, 1), (Item_709, 1), (Item_925, 1), (Item_535, 1), (Item_46, 1), (Item_960, 1), (Item_34, 1), None], [(Item_871, 2), (Item_292, 3), (Item_677, 1), (Item_337, 1), None], [(Item_281, 1), (Item_279, 1), (Item_280, 1), (Item_18, 4), None]]

    @classmethod
    def create(cls, arg : Variation_1361_Arg) -> 'Variation_1361':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MON"]) -> RuleVariation_54:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> RuleVariation_410:
        ...
    @overload
    def get_item(self, key : Literal["MRH"]) -> RuleVariation_497:
        ...
    @overload
    def get_item(self, key : Literal["SRC"]) -> RuleVariation_675:
        ...
    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_874:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_6]:
        ...
    @overload
    def get_item(self, key : Literal["TSE"]) -> Optional[RuleVariation_409]:
        ...
    @overload
    def get_item(self, key : Literal["TSB"]) -> Optional[RuleVariation_517]:
        ...
    @overload
    def get_item(self, key : Literal["FPC"]) -> Optional[RuleVariation_644]:
        ...
    @overload
    def get_item(self, key : Literal["AFF"]) -> Optional[RuleVariation_702]:
        ...
    @overload
    def get_item(self, key : Literal["STP"]) -> Optional[RuleVariation_813]:
        ...
    @overload
    def get_item(self, key : Literal["KOS"]) -> Optional[RuleVariation_872]:
        ...
    @overload
    def get_item(self, key : Literal["AMA"]) -> Optional[RuleVariation_89]:
        ...
    @overload
    def get_item(self, key : Literal["MD4"]) -> Optional[RuleVariation_456]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_622]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_705]:
        ...
    @overload
    def get_item(self, key : Literal["MD5"]) -> Optional[RuleVariation_849]:
        ...
    @overload
    def get_item(self, key : Literal["CST"]) -> Optional[RuleVariation_37]:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[RuleVariation_407]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[RuleVariation_514]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[RuleVariation_621]:
        ...
    @overload
    def get_item(self, key : Literal["ADS"]) -> Optional[RuleVariation_704]:
        ...
    @overload
    def get_item(self, key : Literal["SUC"]) -> Optional[RuleVariation_814]:
        ...
    @overload
    def get_item(self, key : Literal["AAC"]) -> Optional[RuleVariation_890]:
        ...
    @overload
    def get_item(self, key : Literal["SDS"]) -> Optional[RuleVariation_99]:
        ...
    @overload
    def get_item(self, key : Literal["EMS"]) -> Optional[RuleVariation_587]:
        ...
    @overload
    def get_item(self, key : Literal["PFT"]) -> Optional[RuleVariation_830]:
        ...
    @overload
    def get_item(self, key : Literal["FPLT"]) -> Optional[RuleVariation_892]:
        ...
    @overload
    def get_item(self, key : Literal["DUPT"]) -> Optional[RuleVariation_38]:
        ...
    @overload
    def get_item(self, key : Literal["DUPF"]) -> Optional[RuleVariation_408]:
        ...
    @overload
    def get_item(self, key : Literal["DUPM"]) -> Optional[RuleVariation_516]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1284_Arg: TypeAlias = Variation_1361_Arg
class RuleVariation_1284(RuleVariationContextFree):
    cv_variation = Variation_1361

    @classmethod
    def create(cls, arg : RuleVariation_1284_Arg) -> "RuleVariation_1284":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1361:
        return self.arg # type: ignore

NonSpare_235_Arg: TypeAlias = RuleVariation_1284_Arg
class NonSpare_235(NonSpare):
    cv_name = "080"
    cv_title = "Track Status"
    cv_rule = RuleVariation_1284

    @classmethod
    def create(cls, arg : NonSpare_235_Arg) -> "NonSpare_235":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1284:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1361:
        return self.rule.variation

class UapItem_235(UapItem):
    cv_non_spare = NonSpare_235

Content_757_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
class Content_757(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.25
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

RuleContent_756_Arg: TypeAlias = Content_757_Arg
class RuleContent_756(RuleContentContextFree):
    cv_content = Content_757

    @property
    def content(self) -> Content_757:
        return self._get_content() # type: ignore

Variation_234_Arg: TypeAlias = RuleContent_756_Arg
class Variation_234(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_756

    @classmethod
    def create(cls, arg : Variation_234_Arg) -> "Variation_234":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_756:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_757:
        return self.rule.content

RuleVariation_227_Arg: TypeAlias = Variation_234_Arg
class RuleVariation_227(RuleVariationContextFree):
    cv_variation = Variation_234

    @classmethod
    def create(cls, arg : RuleVariation_227_Arg) -> "RuleVariation_227":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_234:
        return self.arg # type: ignore

NonSpare_1909_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1909(NonSpare):
    cv_name = "TRK"
    cv_title = "Track Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1909_Arg) -> "NonSpare_1909":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1466_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1466(NonSpare):
    cv_name = "PSR"
    cv_title = "PSR Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1466_Arg) -> "NonSpare_1466":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1753_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1753(NonSpare):
    cv_name = "SSR"
    cv_title = "SSR Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1753_Arg) -> "NonSpare_1753":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1251_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1251(NonSpare):
    cv_name = "MDS"
    cv_title = "Mode S Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1251_Arg) -> "NonSpare_1251":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

Content_758_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
class Content_758(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.25
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

RuleContent_757_Arg: TypeAlias = Content_758_Arg
class RuleContent_757(RuleContentContextFree):
    cv_content = Content_758

    @property
    def content(self) -> Content_758:
        return self._get_content() # type: ignore

Variation_325_Arg: TypeAlias = RuleContent_757_Arg
class Variation_325(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_757

    @classmethod
    def create(cls, arg : Variation_325_Arg) -> "Variation_325":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_757:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_758:
        return self.rule.content

RuleVariation_318_Arg: TypeAlias = Variation_325_Arg
class RuleVariation_318(RuleVariationContextFree):
    cv_variation = Variation_325

    @classmethod
    def create(cls, arg : RuleVariation_318_Arg) -> "RuleVariation_318":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_325:
        return self.arg # type: ignore

NonSpare_571_Arg: TypeAlias = RuleVariation_318_Arg
class NonSpare_571(NonSpare):
    cv_name = "ADS"
    cv_title = "ADS-C Age"
    cv_rule = RuleVariation_318

    @classmethod
    def create(cls, arg : NonSpare_571_Arg) -> "NonSpare_571":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_318:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_325:
        return self.rule.variation

NonSpare_954_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_954(NonSpare):
    cv_name = "ES"
    cv_title = "ADS-B Extended Squitter Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_954_Arg) -> "NonSpare_954":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_2019_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_2019(NonSpare):
    cv_name = "VDL"
    cv_title = "ADS-B VDL Mode 4 Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_2019_Arg) -> "NonSpare_2019":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1969_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1969(NonSpare):
    cv_name = "UAT"
    cv_title = "ADS-B UAT Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1969_Arg) -> "NonSpare_1969":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1186_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1186(NonSpare):
    cv_name = "LOP"
    cv_title = "Loop Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1186_Arg) -> "NonSpare_1186":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1284_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1284(NonSpare):
    cv_name = "MLT"
    cv_title = "Multilateration Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1284_Arg) -> "NonSpare_1284":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

Variation_1507_Arg = TypedDict('Variation_1507_Arg', {
    "TRK": NonSpare_1909_Arg,
    "PSR": NonSpare_1466_Arg,
    "SSR": NonSpare_1753_Arg,
    "MDS": NonSpare_1251_Arg,
    "ADS": NonSpare_571_Arg,
    "ES": NonSpare_954_Arg,
    "VDL": NonSpare_2019_Arg,
    "UAT": NonSpare_1969_Arg,
    "LOP": NonSpare_1186_Arg,
    "MLT": NonSpare_1284_Arg,
}, total=False)
class Variation_1507(Compound):
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1909, NonSpare_1466, NonSpare_1753, NonSpare_1251, NonSpare_571, NonSpare_954, NonSpare_2019, NonSpare_1969, NonSpare_1186, NonSpare_1284]
    cv_items_dict = {"TRK": NonSpare_1909, "PSR": NonSpare_1466, "SSR": NonSpare_1753, "MDS": NonSpare_1251, "ADS": NonSpare_571, "ES": NonSpare_954, "VDL": NonSpare_2019, "UAT": NonSpare_1969, "LOP": NonSpare_1186, "MLT": NonSpare_1284}

    @overload
    @classmethod
    def spec(cls, key : Literal["TRK"]) -> NonSpare_1909:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PSR"]) -> NonSpare_1466:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSR"]) -> NonSpare_1753:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDS"]) -> NonSpare_1251:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADS"]) -> NonSpare_571:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ES"]) -> NonSpare_954:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VDL"]) -> NonSpare_2019:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["UAT"]) -> NonSpare_1969:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LOP"]) -> NonSpare_1186:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MLT"]) -> NonSpare_1284:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TRK"], Literal["PSR"], Literal["SSR"], Literal["MDS"], Literal["ADS"], Literal["ES"], Literal["VDL"], Literal["UAT"], Literal["LOP"], Literal["MLT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TRK"]) -> Optional[NonSpare_1909]:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[NonSpare_1466]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[NonSpare_1753]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[NonSpare_1251]:
        ...
    @overload
    def get_item(self, key : Literal["ADS"]) -> Optional[NonSpare_571]:
        ...
    @overload
    def get_item(self, key : Literal["ES"]) -> Optional[NonSpare_954]:
        ...
    @overload
    def get_item(self, key : Literal["VDL"]) -> Optional[NonSpare_2019]:
        ...
    @overload
    def get_item(self, key : Literal["UAT"]) -> Optional[NonSpare_1969]:
        ...
    @overload
    def get_item(self, key : Literal["LOP"]) -> Optional[NonSpare_1186]:
        ...
    @overload
    def get_item(self, key : Literal["MLT"]) -> Optional[NonSpare_1284]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["TRK"], val : NonSpare_1909_Arg) -> "Variation_1507":
        ...
    @overload
    def set_item(self, key : Literal["PSR"], val : NonSpare_1466_Arg) -> "Variation_1507":
        ...
    @overload
    def set_item(self, key : Literal["SSR"], val : NonSpare_1753_Arg) -> "Variation_1507":
        ...
    @overload
    def set_item(self, key : Literal["MDS"], val : NonSpare_1251_Arg) -> "Variation_1507":
        ...
    @overload
    def set_item(self, key : Literal["ADS"], val : NonSpare_571_Arg) -> "Variation_1507":
        ...
    @overload
    def set_item(self, key : Literal["ES"], val : NonSpare_954_Arg) -> "Variation_1507":
        ...
    @overload
    def set_item(self, key : Literal["VDL"], val : NonSpare_2019_Arg) -> "Variation_1507":
        ...
    @overload
    def set_item(self, key : Literal["UAT"], val : NonSpare_1969_Arg) -> "Variation_1507":
        ...
    @overload
    def set_item(self, key : Literal["LOP"], val : NonSpare_1186_Arg) -> "Variation_1507":
        ...
    @overload
    def set_item(self, key : Literal["MLT"], val : NonSpare_1284_Arg) -> "Variation_1507":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["TRK"]) -> "Variation_1507":
        ...
    @overload
    def del_item(self, key : Literal["PSR"]) -> "Variation_1507":
        ...
    @overload
    def del_item(self, key : Literal["SSR"]) -> "Variation_1507":
        ...
    @overload
    def del_item(self, key : Literal["MDS"]) -> "Variation_1507":
        ...
    @overload
    def del_item(self, key : Literal["ADS"]) -> "Variation_1507":
        ...
    @overload
    def del_item(self, key : Literal["ES"]) -> "Variation_1507":
        ...
    @overload
    def del_item(self, key : Literal["VDL"]) -> "Variation_1507":
        ...
    @overload
    def del_item(self, key : Literal["UAT"]) -> "Variation_1507":
        ...
    @overload
    def del_item(self, key : Literal["LOP"]) -> "Variation_1507":
        ...
    @overload
    def del_item(self, key : Literal["MLT"]) -> "Variation_1507":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1507_Arg) -> 'Variation_1507':
        return cls._create(arg) # type: ignore

RuleVariation_1430_Arg: TypeAlias = Variation_1507_Arg
class RuleVariation_1430(RuleVariationContextFree):
    cv_variation = Variation_1507

    @classmethod
    def create(cls, arg : RuleVariation_1430_Arg) -> "RuleVariation_1430":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1507:
        return self.arg # type: ignore

NonSpare_465_Arg: TypeAlias = RuleVariation_1430_Arg
class NonSpare_465(NonSpare):
    cv_name = "290"
    cv_title = "System Track Update Ages"
    cv_rule = RuleVariation_1430

    @classmethod
    def create(cls, arg : NonSpare_465_Arg) -> "NonSpare_465":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1430:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1507:
        return self.rule.variation

class UapItem_465(UapItem):
    cv_non_spare = NonSpare_465

Content_67_Arg: TypeAlias = int
class Content_67(ContentTable):
    cv_values = {0: "Constant course", 1: "Right turn", 2: "Left turn", 3: "Undetermined"}

RuleContent_67_Arg: TypeAlias = Content_67_Arg
class RuleContent_67(RuleContentContextFree):
    cv_content = Content_67

    @property
    def content(self) -> Content_67:
        return self._get_content() # type: ignore

Variation_100_Arg: TypeAlias = RuleContent_67_Arg
class Variation_100(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_67

    @classmethod
    def create(cls, arg : Variation_100_Arg) -> "Variation_100":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_67:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_67:
        return self.rule.content

RuleVariation_100_Arg: TypeAlias = Variation_100_Arg
class RuleVariation_100(RuleVariationContextFree):
    cv_variation = Variation_100

    @classmethod
    def create(cls, arg : RuleVariation_100_Arg) -> "RuleVariation_100":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_100:
        return self.arg # type: ignore

NonSpare_1898_Arg: TypeAlias = RuleVariation_100_Arg
class NonSpare_1898(NonSpare):
    cv_name = "TRANS"
    cv_title = "Transversal Acceleration"
    cv_rule = RuleVariation_100

    @classmethod
    def create(cls, arg : NonSpare_1898_Arg) -> "NonSpare_1898":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_100:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_100:
        return self.rule.variation

Item_1027_Arg: TypeAlias = NonSpare_1898_Arg
class Item_1027(Item):
    cv_non_spare = NonSpare_1898

    @classmethod
    def create(cls, arg : Item_1027_Arg) -> "Item_1027":
        return cls._create(arg) # type: ignore

Content_68_Arg: TypeAlias = int
class Content_68(ContentTable):
    cv_values = {0: "Constant groundspeed", 1: "Increasing groundspeed", 2: "Decreasing groundspeed", 3: "Undetermined"}

RuleContent_68_Arg: TypeAlias = Content_68_Arg
class RuleContent_68(RuleContentContextFree):
    cv_content = Content_68

    @property
    def content(self) -> Content_68:
        return self._get_content() # type: ignore

Variation_587_Arg: TypeAlias = RuleContent_68_Arg
class Variation_587(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_68

    @classmethod
    def create(cls, arg : Variation_587_Arg) -> "Variation_587":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_68:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_68:
        return self.rule.content

RuleVariation_576_Arg: TypeAlias = Variation_587_Arg
class RuleVariation_576(RuleVariationContextFree):
    cv_variation = Variation_587

    @classmethod
    def create(cls, arg : RuleVariation_576_Arg) -> "RuleVariation_576":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_587:
        return self.arg # type: ignore

NonSpare_1182_Arg: TypeAlias = RuleVariation_576_Arg
class NonSpare_1182(NonSpare):
    cv_name = "LONG"
    cv_title = "Longitudinal Acceleration"
    cv_rule = RuleVariation_576

    @classmethod
    def create(cls, arg : NonSpare_1182_Arg) -> "NonSpare_1182":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_576:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_587:
        return self.rule.variation

Item_498_Arg: TypeAlias = NonSpare_1182_Arg
class Item_498(Item):
    cv_non_spare = NonSpare_1182

    @classmethod
    def create(cls, arg : Item_498_Arg) -> "Item_498":
        return cls._create(arg) # type: ignore

Content_254_Arg: TypeAlias = int
class Content_254(ContentTable):
    cv_values = {0: "Level", 1: "Climb", 2: "Descent", 3: "Undetermined"}

RuleContent_254_Arg: TypeAlias = Content_254_Arg
class RuleContent_254(RuleContentContextFree):
    cv_content = Content_254

    @property
    def content(self) -> Content_254:
        return self._get_content() # type: ignore

Variation_762_Arg: TypeAlias = RuleContent_254_Arg
class Variation_762(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_254

    @classmethod
    def create(cls, arg : Variation_762_Arg) -> "Variation_762":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_254:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_254:
        return self.rule.content

RuleVariation_751_Arg: TypeAlias = Variation_762_Arg
class RuleVariation_751(RuleVariationContextFree):
    cv_variation = Variation_762

    @classmethod
    def create(cls, arg : RuleVariation_751_Arg) -> "RuleVariation_751":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_762:
        return self.arg # type: ignore

NonSpare_2023_Arg: TypeAlias = RuleVariation_751_Arg
class NonSpare_2023(NonSpare):
    cv_name = "VERT"
    cv_title = "Transversal Acceleration"
    cv_rule = RuleVariation_751

    @classmethod
    def create(cls, arg : NonSpare_2023_Arg) -> "NonSpare_2023":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_751:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_762:
        return self.rule.variation

Item_1138_Arg: TypeAlias = NonSpare_2023_Arg
class Item_1138(Item):
    cv_non_spare = NonSpare_2023

    @classmethod
    def create(cls, arg : Item_1138_Arg) -> "Item_1138":
        return cls._create(arg) # type: ignore

Content_323_Arg: TypeAlias = int
class Content_323(ContentTable):
    cv_values = {0: "No altitude discrepancy", 1: "Altitude discrepancy"}

RuleContent_323_Arg: TypeAlias = Content_323_Arg
class RuleContent_323(RuleContentContextFree):
    cv_content = Content_323

    @property
    def content(self) -> Content_323:
        return self._get_content() # type: ignore

Variation_938_Arg: TypeAlias = RuleContent_323_Arg
class Variation_938(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_323

    @classmethod
    def create(cls, arg : Variation_938_Arg) -> "Variation_938":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_323:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_323:
        return self.rule.content

RuleVariation_908_Arg: TypeAlias = Variation_938_Arg
class RuleVariation_908(RuleVariationContextFree):
    cv_variation = Variation_938

    @classmethod
    def create(cls, arg : RuleVariation_908_Arg) -> "RuleVariation_908":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_938:
        return self.arg # type: ignore

NonSpare_565_Arg: TypeAlias = RuleVariation_908_Arg
class NonSpare_565(NonSpare):
    cv_name = "ADF"
    cv_title = "Altitude Discrepancy Flag"
    cv_rule = RuleVariation_908

    @classmethod
    def create(cls, arg : NonSpare_565_Arg) -> "NonSpare_565":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_908:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_938:
        return self.rule.variation

Item_44_Arg: TypeAlias = NonSpare_565_Arg
class Item_44(Item):
    cv_non_spare = NonSpare_565

    @classmethod
    def create(cls, arg : Item_44_Arg) -> "Item_44":
        return cls._create(arg) # type: ignore

Variation_1222_Arg_Group = Tuple[Union[RuleVariation_100_Arg, Tuple[Literal["TRANS"], RuleVariation_100_Arg]], Union[RuleVariation_576_Arg, Tuple[Literal["LONG"], RuleVariation_576_Arg]], Union[RuleVariation_751_Arg, Tuple[Literal["VERT"], RuleVariation_751_Arg]], Union[RuleVariation_908_Arg, Tuple[Literal["ADF"], RuleVariation_908_Arg]], int]
Variation_1222_Arg: TypeAlias = Union[int, Variation_1222_Arg_Group]
class Variation_1222(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1027, 2), (Item_498, 2), (Item_1138, 2), (Item_44, 1), (Item_29, 1)]
    cv_items_dict = {"TRANS": RuleVariation_100, "LONG": RuleVariation_576, "VERT": RuleVariation_751, "ADF": RuleVariation_908}

    @overload
    @classmethod
    def spec(cls, key : Literal["TRANS"]) -> RuleVariation_100:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LONG"]) -> RuleVariation_576:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VERT"]) -> RuleVariation_751:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADF"]) -> RuleVariation_908:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TRANS"], Literal["LONG"], Literal["VERT"], Literal["ADF"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TRANS"]) -> RuleVariation_100:
        ...
    @overload
    def get_item(self, key : Literal["LONG"]) -> RuleVariation_576:
        ...
    @overload
    def get_item(self, key : Literal["VERT"]) -> RuleVariation_751:
        ...
    @overload
    def get_item(self, key : Literal["ADF"]) -> RuleVariation_908:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1222_Arg) -> 'Variation_1222':
        return cls._create(arg) # type: ignore

RuleVariation_1161_Arg: TypeAlias = Variation_1222_Arg
class RuleVariation_1161(RuleVariationContextFree):
    cv_variation = Variation_1222

    @classmethod
    def create(cls, arg : RuleVariation_1161_Arg) -> "RuleVariation_1161":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1222:
        return self.arg # type: ignore

NonSpare_389_Arg: TypeAlias = RuleVariation_1161_Arg
class NonSpare_389(NonSpare):
    cv_name = "200"
    cv_title = "Mode of Movement"
    cv_rule = RuleVariation_1161

    @classmethod
    def create(cls, arg : NonSpare_389_Arg) -> "NonSpare_389":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1161:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1222:
        return self.rule.variation

class UapItem_389(UapItem):
    cv_non_spare = NonSpare_389

NonSpare_1266_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1266(NonSpare):
    cv_name = "MFL"
    cv_title = "Measured Flight Level Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1266_Arg) -> "NonSpare_1266":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1232_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1232(NonSpare):
    cv_name = "MD1"
    cv_title = "Mode 1 Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1232_Arg) -> "NonSpare_1232":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1235_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1235(NonSpare):
    cv_name = "MD2"
    cv_title = "Mode 2 Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1235_Arg) -> "NonSpare_1235":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1244_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1244(NonSpare):
    cv_name = "MDA"
    cv_title = "Mode 3/A Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1244_Arg) -> "NonSpare_1244":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1237_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1237(NonSpare):
    cv_name = "MD4"
    cv_title = "Mode 4 Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1237_Arg) -> "NonSpare_1237":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1239_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1239(NonSpare):
    cv_name = "MD5"
    cv_title = "Mode 5 Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1239_Arg) -> "NonSpare_1239":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1271_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1271(NonSpare):
    cv_name = "MHG"
    cv_title = "Magnetic Heading Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1271_Arg) -> "NonSpare_1271":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1095_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1095(NonSpare):
    cv_name = "IAS"
    cv_title = "Indicated Airspeed / Mach Nb Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1095_Arg) -> "NonSpare_1095":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1824_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1824(NonSpare):
    cv_name = "TAS"
    cv_title = "True Airspeed Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1824_Arg) -> "NonSpare_1824":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1650_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1650(NonSpare):
    cv_name = "SAL"
    cv_title = "Selected Altitude Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1650_Arg) -> "NonSpare_1650":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_995_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_995(NonSpare):
    cv_name = "FSS"
    cv_title = "Final State Selected Altitude Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_995_Arg) -> "NonSpare_995":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1857_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1857(NonSpare):
    cv_name = "TID"
    cv_title = "Trajectory Intent Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1857_Arg) -> "NonSpare_1857":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_776_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_776(NonSpare):
    cv_name = "COM"
    cv_title = "Communication/ACAS Capability and Flight Status Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_776_Arg) -> "NonSpare_776":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1643_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1643(NonSpare):
    cv_name = "SAB"
    cv_title = "Status Reported by ADS-B Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1643_Arg) -> "NonSpare_1643":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_560_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_560(NonSpare):
    cv_name = "ACS"
    cv_title = "ACAS Resolution Advisory Report Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_560_Arg) -> "NonSpare_560":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_693_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_693(NonSpare):
    cv_name = "BVR"
    cv_title = "Barometric Vertical Rate Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_693_Arg) -> "NonSpare_693":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1044_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1044(NonSpare):
    cv_name = "GVR"
    cv_title = "Geometrical Vertical Rate Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1044_Arg) -> "NonSpare_1044":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1539_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1539(NonSpare):
    cv_name = "RAN"
    cv_title = "Roll Angle Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1539_Arg) -> "NonSpare_1539":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1820_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1820(NonSpare):
    cv_name = "TAR"
    cv_title = "Track Angle Rate Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1820_Arg) -> "NonSpare_1820":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1814_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1814(NonSpare):
    cv_name = "TAN"
    cv_title = "Track Angle Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1814_Arg) -> "NonSpare_1814":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1035_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1035(NonSpare):
    cv_name = "GSP"
    cv_title = "Ground Speed Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1035_Arg) -> "NonSpare_1035":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_2036_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_2036(NonSpare):
    cv_name = "VUN"
    cv_title = "Velocity Uncertainty Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_2036_Arg) -> "NonSpare_2036":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1263_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1263(NonSpare):
    cv_name = "MET"
    cv_title = "Meteorological Data Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1263_Arg) -> "NonSpare_1263":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_922_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_922(NonSpare):
    cv_name = "EMC"
    cv_title = "Emitter Category Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_922_Arg) -> "NonSpare_922":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1440_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1440(NonSpare):
    cv_name = "POS"
    cv_title = "Position Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1440_Arg) -> "NonSpare_1440":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1012_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1012(NonSpare):
    cv_name = "GAL"
    cv_title = "Geometric Altitude Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1012_Arg) -> "NonSpare_1012":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1476_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1476(NonSpare):
    cv_name = "PUN"
    cv_title = "Position Uncertainty Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1476_Arg) -> "NonSpare_1476":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1223_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1223(NonSpare):
    cv_name = "MB"
    cv_title = "Mode S MB Data Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1223_Arg) -> "NonSpare_1223":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1093_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1093(NonSpare):
    cv_name = "IAR"
    cv_title = "Indicated Airspeed Data Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1093_Arg) -> "NonSpare_1093":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_1213_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_1213(NonSpare):
    cv_name = "MAC"
    cv_title = "Mach Number Data Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_1213_Arg) -> "NonSpare_1213":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

NonSpare_689_Arg: TypeAlias = RuleVariation_227_Arg
class NonSpare_689(NonSpare):
    cv_name = "BPS"
    cv_title = "Barometric Pressure Setting Data Age"
    cv_rule = RuleVariation_227

    @classmethod
    def create(cls, arg : NonSpare_689_Arg) -> "NonSpare_689":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

Variation_1486_Arg = TypedDict('Variation_1486_Arg', {
    "MFL": NonSpare_1266_Arg,
    "MD1": NonSpare_1232_Arg,
    "MD2": NonSpare_1235_Arg,
    "MDA": NonSpare_1244_Arg,
    "MD4": NonSpare_1237_Arg,
    "MD5": NonSpare_1239_Arg,
    "MHG": NonSpare_1271_Arg,
    "IAS": NonSpare_1095_Arg,
    "TAS": NonSpare_1824_Arg,
    "SAL": NonSpare_1650_Arg,
    "FSS": NonSpare_995_Arg,
    "TID": NonSpare_1857_Arg,
    "COM": NonSpare_776_Arg,
    "SAB": NonSpare_1643_Arg,
    "ACS": NonSpare_560_Arg,
    "BVR": NonSpare_693_Arg,
    "GVR": NonSpare_1044_Arg,
    "RAN": NonSpare_1539_Arg,
    "TAR": NonSpare_1820_Arg,
    "TAN": NonSpare_1814_Arg,
    "GSP": NonSpare_1035_Arg,
    "VUN": NonSpare_2036_Arg,
    "MET": NonSpare_1263_Arg,
    "EMC": NonSpare_922_Arg,
    "POS": NonSpare_1440_Arg,
    "GAL": NonSpare_1012_Arg,
    "PUN": NonSpare_1476_Arg,
    "MB": NonSpare_1223_Arg,
    "IAR": NonSpare_1093_Arg,
    "MAC": NonSpare_1213_Arg,
    "BPS": NonSpare_689_Arg,
}, total=False)
class Variation_1486(Compound):
    cv_fspec_max_bytes = 5
    cv_items_list = [NonSpare_1266, NonSpare_1232, NonSpare_1235, NonSpare_1244, NonSpare_1237, NonSpare_1239, NonSpare_1271, NonSpare_1095, NonSpare_1824, NonSpare_1650, NonSpare_995, NonSpare_1857, NonSpare_776, NonSpare_1643, NonSpare_560, NonSpare_693, NonSpare_1044, NonSpare_1539, NonSpare_1820, NonSpare_1814, NonSpare_1035, NonSpare_2036, NonSpare_1263, NonSpare_922, NonSpare_1440, NonSpare_1012, NonSpare_1476, NonSpare_1223, NonSpare_1093, NonSpare_1213, NonSpare_689]
    cv_items_dict = {"MFL": NonSpare_1266, "MD1": NonSpare_1232, "MD2": NonSpare_1235, "MDA": NonSpare_1244, "MD4": NonSpare_1237, "MD5": NonSpare_1239, "MHG": NonSpare_1271, "IAS": NonSpare_1095, "TAS": NonSpare_1824, "SAL": NonSpare_1650, "FSS": NonSpare_995, "TID": NonSpare_1857, "COM": NonSpare_776, "SAB": NonSpare_1643, "ACS": NonSpare_560, "BVR": NonSpare_693, "GVR": NonSpare_1044, "RAN": NonSpare_1539, "TAR": NonSpare_1820, "TAN": NonSpare_1814, "GSP": NonSpare_1035, "VUN": NonSpare_2036, "MET": NonSpare_1263, "EMC": NonSpare_922, "POS": NonSpare_1440, "GAL": NonSpare_1012, "PUN": NonSpare_1476, "MB": NonSpare_1223, "IAR": NonSpare_1093, "MAC": NonSpare_1213, "BPS": NonSpare_689}

    @overload
    @classmethod
    def spec(cls, key : Literal["MFL"]) -> NonSpare_1266:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MD1"]) -> NonSpare_1232:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MD2"]) -> NonSpare_1235:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDA"]) -> NonSpare_1244:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MD4"]) -> NonSpare_1237:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MD5"]) -> NonSpare_1239:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MHG"]) -> NonSpare_1271:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAS"]) -> NonSpare_1095:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAS"]) -> NonSpare_1824:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAL"]) -> NonSpare_1650:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FSS"]) -> NonSpare_995:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> NonSpare_1857:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> NonSpare_776:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAB"]) -> NonSpare_1643:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ACS"]) -> NonSpare_560:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BVR"]) -> NonSpare_693:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GVR"]) -> NonSpare_1044:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAN"]) -> NonSpare_1539:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAR"]) -> NonSpare_1820:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAN"]) -> NonSpare_1814:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GSP"]) -> NonSpare_1035:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VUN"]) -> NonSpare_2036:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MET"]) -> NonSpare_1263:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EMC"]) -> NonSpare_922:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1440:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GAL"]) -> NonSpare_1012:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PUN"]) -> NonSpare_1476:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MB"]) -> NonSpare_1223:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAR"]) -> NonSpare_1093:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MAC"]) -> NonSpare_1213:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BPS"]) -> NonSpare_689:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MFL"], Literal["MD1"], Literal["MD2"], Literal["MDA"], Literal["MD4"], Literal["MD5"], Literal["MHG"], Literal["IAS"], Literal["TAS"], Literal["SAL"], Literal["FSS"], Literal["TID"], Literal["COM"], Literal["SAB"], Literal["ACS"], Literal["BVR"], Literal["GVR"], Literal["RAN"], Literal["TAR"], Literal["TAN"], Literal["GSP"], Literal["VUN"], Literal["MET"], Literal["EMC"], Literal["POS"], Literal["GAL"], Literal["PUN"], Literal["MB"], Literal["IAR"], Literal["MAC"], Literal["BPS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MFL"]) -> Optional[NonSpare_1266]:
        ...
    @overload
    def get_item(self, key : Literal["MD1"]) -> Optional[NonSpare_1232]:
        ...
    @overload
    def get_item(self, key : Literal["MD2"]) -> Optional[NonSpare_1235]:
        ...
    @overload
    def get_item(self, key : Literal["MDA"]) -> Optional[NonSpare_1244]:
        ...
    @overload
    def get_item(self, key : Literal["MD4"]) -> Optional[NonSpare_1237]:
        ...
    @overload
    def get_item(self, key : Literal["MD5"]) -> Optional[NonSpare_1239]:
        ...
    @overload
    def get_item(self, key : Literal["MHG"]) -> Optional[NonSpare_1271]:
        ...
    @overload
    def get_item(self, key : Literal["IAS"]) -> Optional[NonSpare_1095]:
        ...
    @overload
    def get_item(self, key : Literal["TAS"]) -> Optional[NonSpare_1824]:
        ...
    @overload
    def get_item(self, key : Literal["SAL"]) -> Optional[NonSpare_1650]:
        ...
    @overload
    def get_item(self, key : Literal["FSS"]) -> Optional[NonSpare_995]:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> Optional[NonSpare_1857]:
        ...
    @overload
    def get_item(self, key : Literal["COM"]) -> Optional[NonSpare_776]:
        ...
    @overload
    def get_item(self, key : Literal["SAB"]) -> Optional[NonSpare_1643]:
        ...
    @overload
    def get_item(self, key : Literal["ACS"]) -> Optional[NonSpare_560]:
        ...
    @overload
    def get_item(self, key : Literal["BVR"]) -> Optional[NonSpare_693]:
        ...
    @overload
    def get_item(self, key : Literal["GVR"]) -> Optional[NonSpare_1044]:
        ...
    @overload
    def get_item(self, key : Literal["RAN"]) -> Optional[NonSpare_1539]:
        ...
    @overload
    def get_item(self, key : Literal["TAR"]) -> Optional[NonSpare_1820]:
        ...
    @overload
    def get_item(self, key : Literal["TAN"]) -> Optional[NonSpare_1814]:
        ...
    @overload
    def get_item(self, key : Literal["GSP"]) -> Optional[NonSpare_1035]:
        ...
    @overload
    def get_item(self, key : Literal["VUN"]) -> Optional[NonSpare_2036]:
        ...
    @overload
    def get_item(self, key : Literal["MET"]) -> Optional[NonSpare_1263]:
        ...
    @overload
    def get_item(self, key : Literal["EMC"]) -> Optional[NonSpare_922]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1440]:
        ...
    @overload
    def get_item(self, key : Literal["GAL"]) -> Optional[NonSpare_1012]:
        ...
    @overload
    def get_item(self, key : Literal["PUN"]) -> Optional[NonSpare_1476]:
        ...
    @overload
    def get_item(self, key : Literal["MB"]) -> Optional[NonSpare_1223]:
        ...
    @overload
    def get_item(self, key : Literal["IAR"]) -> Optional[NonSpare_1093]:
        ...
    @overload
    def get_item(self, key : Literal["MAC"]) -> Optional[NonSpare_1213]:
        ...
    @overload
    def get_item(self, key : Literal["BPS"]) -> Optional[NonSpare_689]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["MFL"], val : NonSpare_1266_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["MD1"], val : NonSpare_1232_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["MD2"], val : NonSpare_1235_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["MDA"], val : NonSpare_1244_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["MD4"], val : NonSpare_1237_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["MD5"], val : NonSpare_1239_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["MHG"], val : NonSpare_1271_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["IAS"], val : NonSpare_1095_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["TAS"], val : NonSpare_1824_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["SAL"], val : NonSpare_1650_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["FSS"], val : NonSpare_995_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["TID"], val : NonSpare_1857_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["COM"], val : NonSpare_776_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["SAB"], val : NonSpare_1643_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["ACS"], val : NonSpare_560_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["BVR"], val : NonSpare_693_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["GVR"], val : NonSpare_1044_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["RAN"], val : NonSpare_1539_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["TAR"], val : NonSpare_1820_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["TAN"], val : NonSpare_1814_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["GSP"], val : NonSpare_1035_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["VUN"], val : NonSpare_2036_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["MET"], val : NonSpare_1263_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["EMC"], val : NonSpare_922_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1440_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["GAL"], val : NonSpare_1012_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["PUN"], val : NonSpare_1476_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["MB"], val : NonSpare_1223_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["IAR"], val : NonSpare_1093_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["MAC"], val : NonSpare_1213_Arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["BPS"], val : NonSpare_689_Arg) -> "Variation_1486":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["MFL"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["MD1"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["MD2"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["MDA"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["MD4"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["MD5"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["MHG"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["IAS"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["TAS"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["SAL"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["FSS"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["TID"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["COM"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["SAB"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["ACS"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["BVR"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["GVR"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["RAN"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["TAR"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["TAN"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["GSP"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["VUN"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["MET"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["EMC"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["GAL"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["PUN"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["MB"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["IAR"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["MAC"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["BPS"]) -> "Variation_1486":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1486_Arg) -> 'Variation_1486':
        return cls._create(arg) # type: ignore

RuleVariation_1409_Arg: TypeAlias = Variation_1486_Arg
class RuleVariation_1409(RuleVariationContextFree):
    cv_variation = Variation_1486

    @classmethod
    def create(cls, arg : RuleVariation_1409_Arg) -> "RuleVariation_1409":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1486:
        return self.arg # type: ignore

NonSpare_468_Arg: TypeAlias = RuleVariation_1409_Arg
class NonSpare_468(NonSpare):
    cv_name = "295"
    cv_title = "Track Data Ages"
    cv_rule = RuleVariation_1409

    @classmethod
    def create(cls, arg : NonSpare_468_Arg) -> "NonSpare_468":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1409:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1486:
        return self.rule.variation

class UapItem_468(UapItem):
    cv_non_spare = NonSpare_468

Variation_271_Arg: TypeAlias = RuleContent_652_Arg
class Variation_271(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_652

    @classmethod
    def create(cls, arg : Variation_271_Arg) -> "Variation_271":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_652:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_652:
        return self.rule.content

RuleVariation_264_Arg: TypeAlias = Variation_271_Arg
class RuleVariation_264(RuleVariationContextFree):
    cv_variation = Variation_271

    @classmethod
    def create(cls, arg : RuleVariation_264_Arg) -> "RuleVariation_264":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_271:
        return self.arg # type: ignore

NonSpare_315_Arg: TypeAlias = RuleVariation_264_Arg
class NonSpare_315(NonSpare):
    cv_name = "136"
    cv_title = "Measured Flight Level"
    cv_rule = RuleVariation_264

    @classmethod
    def create(cls, arg : NonSpare_315_Arg) -> "NonSpare_315":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_264:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_271:
        return self.rule.variation

class UapItem_315(UapItem):
    cv_non_spare = NonSpare_315

NonSpare_301_Arg: TypeAlias = RuleVariation_283_Arg
class NonSpare_301(NonSpare):
    cv_name = "130"
    cv_title = "Calculated Track Geometric Altitude"
    cv_rule = RuleVariation_283

    @classmethod
    def create(cls, arg : NonSpare_301_Arg) -> "NonSpare_301":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_283:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_290:
        return self.rule.variation

class UapItem_301(UapItem):
    cv_non_spare = NonSpare_301

NonSpare_1518_Arg: TypeAlias = RuleVariation_58_Arg
class NonSpare_1518(NonSpare):
    cv_name = "QNH"
    cv_title = ""
    cv_rule = RuleVariation_58

    @classmethod
    def create(cls, arg : NonSpare_1518_Arg) -> "NonSpare_1518":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_58:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_58:
        return self.rule.variation

Item_756_Arg: TypeAlias = NonSpare_1518_Arg
class Item_756(Item):
    cv_non_spare = NonSpare_1518

    @classmethod
    def create(cls, arg : Item_756_Arg) -> "Item_756":
        return cls._create(arg) # type: ignore

NonSpare_839_Arg: TypeAlias = RuleVariation_486_Arg
class NonSpare_839(NonSpare):
    cv_name = "CTB"
    cv_title = "Calculated Track Barometric Altitude"
    cv_rule = RuleVariation_486

    @classmethod
    def create(cls, arg : NonSpare_839_Arg) -> "NonSpare_839":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_486:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_497:
        return self.rule.variation

Item_227_Arg: TypeAlias = NonSpare_839_Arg
class Item_227(Item):
    cv_non_spare = NonSpare_839

    @classmethod
    def create(cls, arg : Item_227_Arg) -> "Item_227":
        return cls._create(arg) # type: ignore

Variation_1160_Arg_Group = Tuple[Union[RuleVariation_58_Arg, Tuple[Literal["QNH"], RuleVariation_58_Arg]], Union[RuleVariation_486_Arg, Tuple[Literal["CTB"], RuleVariation_486_Arg]]]
Variation_1160_Arg: TypeAlias = Union[int, Variation_1160_Arg_Group]
class Variation_1160(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_756, 1), (Item_227, 15)]
    cv_items_dict = {"QNH": RuleVariation_58, "CTB": RuleVariation_486}

    @overload
    @classmethod
    def spec(cls, key : Literal["QNH"]) -> RuleVariation_58:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CTB"]) -> RuleVariation_486:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["QNH"], Literal["CTB"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["QNH"]) -> RuleVariation_58:
        ...
    @overload
    def get_item(self, key : Literal["CTB"]) -> RuleVariation_486:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1160_Arg) -> 'Variation_1160':
        return cls._create(arg) # type: ignore

RuleVariation_1112_Arg: TypeAlias = Variation_1160_Arg
class RuleVariation_1112(RuleVariationContextFree):
    cv_variation = Variation_1160

    @classmethod
    def create(cls, arg : RuleVariation_1112_Arg) -> "RuleVariation_1112":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1160:
        return self.arg # type: ignore

NonSpare_314_Arg: TypeAlias = RuleVariation_1112_Arg
class NonSpare_314(NonSpare):
    cv_name = "135"
    cv_title = "Calculated Track Barometric Altitude"
    cv_rule = RuleVariation_1112

    @classmethod
    def create(cls, arg : NonSpare_314_Arg) -> "NonSpare_314":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1112:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1160:
        return self.rule.variation

class UapItem_314(UapItem):
    cv_non_spare = NonSpare_314

NonSpare_417_Arg: TypeAlias = RuleVariation_284_Arg
class NonSpare_417(NonSpare):
    cv_name = "220"
    cv_title = "Calculated Rate of Climb/Descent"
    cv_rule = RuleVariation_284

    @classmethod
    def create(cls, arg : NonSpare_417_Arg) -> "NonSpare_417":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_284:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_291:
        return self.rule.variation

class UapItem_417(UapItem):
    cv_non_spare = NonSpare_417

NonSpare_1812_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_1812(NonSpare):
    cv_name = "TAG"
    cv_title = "FPPS Identification Tag"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_1812_Arg) -> "NonSpare_1812":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

NonSpare_824_Arg: TypeAlias = RuleVariation_383_Arg
class NonSpare_824(NonSpare):
    cv_name = "CS"
    cv_title = "Callsign"
    cv_rule = RuleVariation_383

    @classmethod
    def create(cls, arg : NonSpare_824_Arg) -> "NonSpare_824":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

NonSpare_1345_Arg: TypeAlias = RuleVariation_864_Arg
class NonSpare_1345(NonSpare):
    cv_name = "NBR"
    cv_title = "Number from 0 to 99 999 999"
    cv_rule = RuleVariation_864

    @classmethod
    def create(cls, arg : NonSpare_1345_Arg) -> "NonSpare_1345":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_864:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_894:
        return self.rule.variation

Item_611_Arg: TypeAlias = NonSpare_1345_Arg
class Item_611(Item):
    cv_non_spare = NonSpare_1345

    @classmethod
    def create(cls, arg : Item_611_Arg) -> "Item_611":
        return cls._create(arg) # type: ignore

Variation_1227_Arg_Group = Tuple[Union[RuleVariation_110_Arg, Tuple[Literal["TYP"], RuleVariation_110_Arg]], int, Union[RuleVariation_864_Arg, Tuple[Literal["NBR"], RuleVariation_864_Arg]]]
Variation_1227_Arg: TypeAlias = Union[int, Variation_1227_Arg_Group]
class Variation_1227(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1069, 2), (Item_13, 3), (Item_611, 27)]
    cv_items_dict = {"TYP": RuleVariation_110, "NBR": RuleVariation_864}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_110:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NBR"]) -> RuleVariation_864:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["NBR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_110:
        ...
    @overload
    def get_item(self, key : Literal["NBR"]) -> RuleVariation_864:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1227_Arg) -> 'Variation_1227':
        return cls._create(arg) # type: ignore

RuleVariation_1166_Arg: TypeAlias = Variation_1227_Arg
class RuleVariation_1166(RuleVariationContextFree):
    cv_variation = Variation_1227

    @classmethod
    def create(cls, arg : RuleVariation_1166_Arg) -> "RuleVariation_1166":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1227:
        return self.arg # type: ignore

NonSpare_1109_Arg: TypeAlias = RuleVariation_1166_Arg
class NonSpare_1109(NonSpare):
    cv_name = "IFI"
    cv_title = "IFPS_FLIGHT_ID"
    cv_rule = RuleVariation_1166

    @classmethod
    def create(cls, arg : NonSpare_1109_Arg) -> "NonSpare_1109":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1166:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1227:
        return self.rule.variation

NonSpare_984_Arg: TypeAlias = RuleVariation_577_Arg
class NonSpare_984(NonSpare):
    cv_name = "FR1FR2"
    cv_title = ""
    cv_rule = RuleVariation_577

    @classmethod
    def create(cls, arg : NonSpare_984_Arg) -> "NonSpare_984":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_577:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_588:
        return self.rule.variation

Item_339_Arg: TypeAlias = NonSpare_984_Arg
class Item_339(Item):
    cv_non_spare = NonSpare_984

    @classmethod
    def create(cls, arg : Item_339_Arg) -> "Item_339":
        return cls._create(arg) # type: ignore

Variation_1104_Arg_Group = Tuple[Union[RuleVariation_115_Arg, Tuple[Literal["GATOAT"], RuleVariation_115_Arg]], Union[RuleVariation_577_Arg, Tuple[Literal["FR1FR2"], RuleVariation_577_Arg]], Union[RuleVariation_755_Arg, Tuple[Literal["RVSM"], RuleVariation_755_Arg]], Union[RuleVariation_909_Arg, Tuple[Literal["HPR"], RuleVariation_909_Arg]], int]
Variation_1104_Arg: TypeAlias = Union[int, Variation_1104_Arg_Group]
class Variation_1104(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_360, 2), (Item_339, 2), (Item_839, 2), (Item_399, 1), (Item_29, 1)]
    cv_items_dict = {"GATOAT": RuleVariation_115, "FR1FR2": RuleVariation_577, "RVSM": RuleVariation_755, "HPR": RuleVariation_909}

    @overload
    @classmethod
    def spec(cls, key : Literal["GATOAT"]) -> RuleVariation_115:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FR1FR2"]) -> RuleVariation_577:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RVSM"]) -> RuleVariation_755:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HPR"]) -> RuleVariation_909:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GATOAT"], Literal["FR1FR2"], Literal["RVSM"], Literal["HPR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GATOAT"]) -> RuleVariation_115:
        ...
    @overload
    def get_item(self, key : Literal["FR1FR2"]) -> RuleVariation_577:
        ...
    @overload
    def get_item(self, key : Literal["RVSM"]) -> RuleVariation_755:
        ...
    @overload
    def get_item(self, key : Literal["HPR"]) -> RuleVariation_909:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1104_Arg) -> 'Variation_1104':
        return cls._create(arg) # type: ignore

RuleVariation_1062_Arg: TypeAlias = Variation_1104_Arg
class RuleVariation_1062(RuleVariationContextFree):
    cv_variation = Variation_1104

    @classmethod
    def create(cls, arg : RuleVariation_1062_Arg) -> "RuleVariation_1062":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1104:
        return self.arg # type: ignore

NonSpare_962_Arg: TypeAlias = RuleVariation_1062_Arg
class NonSpare_962(NonSpare):
    cv_name = "FCT"
    cv_title = "Flight Category"
    cv_rule = RuleVariation_1062

    @classmethod
    def create(cls, arg : NonSpare_962_Arg) -> "NonSpare_962":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1062:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1104:
        return self.rule.variation

NonSpare_1811_Arg: TypeAlias = RuleVariation_365_Arg
class NonSpare_1811(NonSpare):
    cv_name = "TAC"
    cv_title = "Type of Aircraft"
    cv_rule = RuleVariation_365

    @classmethod
    def create(cls, arg : NonSpare_1811_Arg) -> "NonSpare_1811":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_365:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_372:
        return self.rule.variation

NonSpare_2060_Arg: TypeAlias = RuleVariation_194_Arg
class NonSpare_2060(NonSpare):
    cv_name = "WTC"
    cv_title = "Wake Turbulence Category"
    cv_rule = RuleVariation_194

    @classmethod
    def create(cls, arg : NonSpare_2060_Arg) -> "NonSpare_2060":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_194:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_201:
        return self.rule.variation

NonSpare_871_Arg: TypeAlias = RuleVariation_365_Arg
class NonSpare_871(NonSpare):
    cv_name = "DEP"
    cv_title = "Departure Airport"
    cv_rule = RuleVariation_365

    @classmethod
    def create(cls, arg : NonSpare_871_Arg) -> "NonSpare_871":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_365:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_372:
        return self.rule.variation

NonSpare_896_Arg: TypeAlias = RuleVariation_365_Arg
class NonSpare_896(NonSpare):
    cv_name = "DST"
    cv_title = "Destination Airport"
    cv_rule = RuleVariation_365

    @classmethod
    def create(cls, arg : NonSpare_896_Arg) -> "NonSpare_896":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_365:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_372:
        return self.rule.variation

NonSpare_841_Arg: TypeAlias = RuleVariation_1027_Arg
class NonSpare_841(NonSpare):
    cv_name = "CTL"
    cv_title = "Current Control Position"
    cv_rule = RuleVariation_1027

    @classmethod
    def create(cls, arg : NonSpare_841_Arg) -> "NonSpare_841":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1027:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1065:
        return self.rule.variation

NonSpare_1953_Arg: TypeAlias = RuleVariation_144_Arg
class NonSpare_1953(NonSpare):
    cv_name = "TYP"
    cv_title = ""
    cv_rule = RuleVariation_144

    @classmethod
    def create(cls, arg : NonSpare_1953_Arg) -> "NonSpare_1953":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_144:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_144:
        return self.rule.variation

Item_1073_Arg: TypeAlias = NonSpare_1953_Arg
class Item_1073(Item):
    cv_non_spare = NonSpare_1953

    @classmethod
    def create(cls, arg : Item_1073_Arg) -> "Item_1073":
        return cls._create(arg) # type: ignore

NonSpare_1066_Arg: TypeAlias = RuleVariation_682_Arg
class NonSpare_1066(NonSpare):
    cv_name = "HOR"
    cv_title = "Hours"
    cv_rule = RuleVariation_682

    @classmethod
    def create(cls, arg : NonSpare_1066_Arg) -> "NonSpare_1066":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_682:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_693:
        return self.rule.variation

Item_397_Arg: TypeAlias = NonSpare_1066_Arg
class Item_397(Item):
    cv_non_spare = NonSpare_1066

    @classmethod
    def create(cls, arg : Item_397_Arg) -> "Item_397":
        return cls._create(arg) # type: ignore

NonSpare_1279_Arg: TypeAlias = RuleVariation_589_Arg
class NonSpare_1279(NonSpare):
    cv_name = "MIN"
    cv_title = "Minutes"
    cv_rule = RuleVariation_589

    @classmethod
    def create(cls, arg : NonSpare_1279_Arg) -> "NonSpare_1279":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_589:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_600:
        return self.rule.variation

Item_552_Arg: TypeAlias = NonSpare_1279_Arg
class Item_552(Item):
    cv_non_spare = NonSpare_1279

    @classmethod
    def create(cls, arg : Item_552_Arg) -> "Item_552":
        return cls._create(arg) # type: ignore

NonSpare_647_Arg: TypeAlias = RuleVariation_74_Arg
class NonSpare_647(NonSpare):
    cv_name = "AVS"
    cv_title = "Seconds Available Flag"
    cv_rule = RuleVariation_74

    @classmethod
    def create(cls, arg : NonSpare_647_Arg) -> "NonSpare_647":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_74:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_74:
        return self.rule.variation

Item_96_Arg: TypeAlias = NonSpare_647_Arg
class Item_96(Item):
    cv_non_spare = NonSpare_647

    @classmethod
    def create(cls, arg : Item_96_Arg) -> "Item_96":
        return cls._create(arg) # type: ignore

NonSpare_1690_Arg: TypeAlias = RuleVariation_589_Arg
class NonSpare_1690(NonSpare):
    cv_name = "SEC"
    cv_title = "Seconds"
    cv_rule = RuleVariation_589

    @classmethod
    def create(cls, arg : NonSpare_1690_Arg) -> "NonSpare_1690":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_589:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_600:
        return self.rule.variation

Item_875_Arg: TypeAlias = NonSpare_1690_Arg
class Item_875(Item):
    cv_non_spare = NonSpare_1690

    @classmethod
    def create(cls, arg : Item_875_Arg) -> "Item_875":
        return cls._create(arg) # type: ignore

Variation_1229_Arg_Group = Tuple[Union[RuleVariation_144_Arg, Tuple[Literal["TYP"], RuleVariation_144_Arg]], Union[RuleVariation_852_Arg, Tuple[Literal["DAY"], RuleVariation_852_Arg]], int, Union[RuleVariation_682_Arg, Tuple[Literal["HOR"], RuleVariation_682_Arg]], int, Union[RuleVariation_589_Arg, Tuple[Literal["MIN"], RuleVariation_589_Arg]], Union[RuleVariation_74_Arg, Tuple[Literal["AVS"], RuleVariation_74_Arg]], int, Union[RuleVariation_589_Arg, Tuple[Literal["SEC"], RuleVariation_589_Arg]]]
Variation_1229_Arg: TypeAlias = Union[int, Variation_1229_Arg_Group]
class Variation_1229(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1073, 5), (Item_239, 2), (Item_30, 4), (Item_397, 5), (Item_1, 2), (Item_552, 6), (Item_96, 1), (Item_7, 1), (Item_875, 6)]
    cv_items_dict = {"TYP": RuleVariation_144, "DAY": RuleVariation_852, "HOR": RuleVariation_682, "MIN": RuleVariation_589, "AVS": RuleVariation_74, "SEC": RuleVariation_589}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_144:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DAY"]) -> RuleVariation_852:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HOR"]) -> RuleVariation_682:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MIN"]) -> RuleVariation_589:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AVS"]) -> RuleVariation_74:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SEC"]) -> RuleVariation_589:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["DAY"], Literal["HOR"], Literal["MIN"], Literal["AVS"], Literal["SEC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_144:
        ...
    @overload
    def get_item(self, key : Literal["DAY"]) -> RuleVariation_852:
        ...
    @overload
    def get_item(self, key : Literal["HOR"]) -> RuleVariation_682:
        ...
    @overload
    def get_item(self, key : Literal["MIN"]) -> RuleVariation_589:
        ...
    @overload
    def get_item(self, key : Literal["AVS"]) -> RuleVariation_74:
        ...
    @overload
    def get_item(self, key : Literal["SEC"]) -> RuleVariation_589:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1229_Arg) -> 'Variation_1229':
        return cls._create(arg) # type: ignore

Variation_1433_Arg: TypeAlias = List[Variation_1229_Arg]
class Variation_1433(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1229

    @classmethod
    def create(cls, arg : Variation_1433_Arg) -> 'Variation_1433':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1229]:
        return self._get_list() # type: ignore

RuleVariation_1356_Arg: TypeAlias = Variation_1433_Arg
class RuleVariation_1356(RuleVariationContextFree):
    cv_variation = Variation_1433

    @classmethod
    def create(cls, arg : RuleVariation_1356_Arg) -> "RuleVariation_1356":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1433:
        return self.arg # type: ignore

NonSpare_1875_Arg: TypeAlias = RuleVariation_1356_Arg
class NonSpare_1875(NonSpare):
    cv_name = "TOD"
    cv_title = "Time of Departure / Arrival"
    cv_rule = RuleVariation_1356

    @classmethod
    def create(cls, arg : NonSpare_1875_Arg) -> "NonSpare_1875":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1356:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1433:
        return self.rule.variation

NonSpare_1779_Arg: TypeAlias = RuleVariation_383_Arg
class NonSpare_1779(NonSpare):
    cv_name = "STD"
    cv_title = "Standard Instrument Departure"
    cv_rule = RuleVariation_383

    @classmethod
    def create(cls, arg : NonSpare_1779_Arg) -> "NonSpare_1779":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

NonSpare_1762_Arg: TypeAlias = RuleVariation_383_Arg
class NonSpare_1762(NonSpare):
    cv_name = "STA"
    cv_title = "Standard Instrument Arrival"
    cv_rule = RuleVariation_383

    @classmethod
    def create(cls, arg : NonSpare_1762_Arg) -> "NonSpare_1762":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

Content_374_Arg: TypeAlias = int
class Content_374(ContentTable):
    cv_values = {0: "No valid Mode 3/A available", 1: "Valid Mode 3/A available"}

RuleContent_374_Arg: TypeAlias = Content_374_Arg
class RuleContent_374(RuleContentContextFree):
    cv_content = Content_374

    @property
    def content(self) -> Content_374:
        return self._get_content() # type: ignore

Variation_652_Arg: TypeAlias = RuleContent_374_Arg
class Variation_652(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_374

    @classmethod
    def create(cls, arg : Variation_652_Arg) -> "Variation_652":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_374:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_374:
        return self.rule.content

RuleVariation_641_Arg: TypeAlias = Variation_652_Arg
class RuleVariation_641(RuleVariationContextFree):
    cv_variation = Variation_652

    @classmethod
    def create(cls, arg : RuleVariation_641_Arg) -> "RuleVariation_641":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_652:
        return self.arg # type: ignore

NonSpare_1984_Arg: TypeAlias = RuleVariation_641_Arg
class NonSpare_1984(NonSpare):
    cv_name = "VA"
    cv_title = ""
    cv_rule = RuleVariation_641

    @classmethod
    def create(cls, arg : NonSpare_1984_Arg) -> "NonSpare_1984":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_641:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_652:
        return self.rule.variation

Item_1101_Arg: TypeAlias = NonSpare_1984_Arg
class Item_1101(Item):
    cv_non_spare = NonSpare_1984

    @classmethod
    def create(cls, arg : Item_1101_Arg) -> "Item_1101":
        return cls._create(arg) # type: ignore

Variation_1014_Arg_Group = Tuple[int, Union[RuleVariation_641_Arg, Tuple[Literal["VA"], RuleVariation_641_Arg]], Union[RuleVariation_776_Arg, Tuple[Literal["MODE3A"], RuleVariation_776_Arg]]]
Variation_1014_Arg: TypeAlias = Union[int, Variation_1014_Arg_Group]
class Variation_1014(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_2, 3), (Item_1101, 1), (Item_572, 12)]
    cv_items_dict = {"VA": RuleVariation_641, "MODE3A": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["VA"]) -> RuleVariation_641:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VA"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VA"]) -> RuleVariation_641:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1014_Arg) -> 'Variation_1014':
        return cls._create(arg) # type: ignore

RuleVariation_984_Arg: TypeAlias = Variation_1014_Arg
class RuleVariation_984(RuleVariationContextFree):
    cv_variation = Variation_1014

    @classmethod
    def create(cls, arg : RuleVariation_984_Arg) -> "RuleVariation_984":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1014:
        return self.arg # type: ignore

NonSpare_1416_Arg: TypeAlias = RuleVariation_984_Arg
class NonSpare_1416(NonSpare):
    cv_name = "PEM"
    cv_title = "Pre-Emergency Mode 3/A"
    cv_rule = RuleVariation_984

    @classmethod
    def create(cls, arg : NonSpare_1416_Arg) -> "NonSpare_1416":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_984:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1014:
        return self.rule.variation

NonSpare_1415_Arg: TypeAlias = RuleVariation_383_Arg
class NonSpare_1415(NonSpare):
    cv_name = "PEC"
    cv_title = "Pre-Emergency Callsign"
    cv_rule = RuleVariation_383

    @classmethod
    def create(cls, arg : NonSpare_1415_Arg) -> "NonSpare_1415":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

Variation_1503_Arg = TypedDict('Variation_1503_Arg', {
    "TAG": NonSpare_1812_Arg,
    "CS": NonSpare_824_Arg,
    "IFI": NonSpare_1109_Arg,
    "FCT": NonSpare_962_Arg,
    "TAC": NonSpare_1811_Arg,
    "WTC": NonSpare_2060_Arg,
    "DEP": NonSpare_871_Arg,
    "DST": NonSpare_896_Arg,
    "RDS": NonSpare_1554_Arg,
    "CFL": NonSpare_720_Arg,
    "CTL": NonSpare_841_Arg,
    "TOD": NonSpare_1875_Arg,
    "AST": NonSpare_633_Arg,
    "STS": NonSpare_1790_Arg,
    "STD": NonSpare_1779_Arg,
    "STA": NonSpare_1762_Arg,
    "PEM": NonSpare_1416_Arg,
    "PEC": NonSpare_1415_Arg,
}, total=False)
class Variation_1503(Compound):
    cv_fspec_max_bytes = 3
    cv_items_list = [NonSpare_1812, NonSpare_824, NonSpare_1109, NonSpare_962, NonSpare_1811, NonSpare_2060, NonSpare_871, NonSpare_896, NonSpare_1554, NonSpare_720, NonSpare_841, NonSpare_1875, NonSpare_633, NonSpare_1790, NonSpare_1779, NonSpare_1762, NonSpare_1416, NonSpare_1415]
    cv_items_dict = {"TAG": NonSpare_1812, "CS": NonSpare_824, "IFI": NonSpare_1109, "FCT": NonSpare_962, "TAC": NonSpare_1811, "WTC": NonSpare_2060, "DEP": NonSpare_871, "DST": NonSpare_896, "RDS": NonSpare_1554, "CFL": NonSpare_720, "CTL": NonSpare_841, "TOD": NonSpare_1875, "AST": NonSpare_633, "STS": NonSpare_1790, "STD": NonSpare_1779, "STA": NonSpare_1762, "PEM": NonSpare_1416, "PEC": NonSpare_1415}

    @overload
    @classmethod
    def spec(cls, key : Literal["TAG"]) -> NonSpare_1812:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CS"]) -> NonSpare_824:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IFI"]) -> NonSpare_1109:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FCT"]) -> NonSpare_962:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAC"]) -> NonSpare_1811:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WTC"]) -> NonSpare_2060:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DEP"]) -> NonSpare_871:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DST"]) -> NonSpare_896:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RDS"]) -> NonSpare_1554:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CFL"]) -> NonSpare_720:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CTL"]) -> NonSpare_841:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOD"]) -> NonSpare_1875:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AST"]) -> NonSpare_633:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STS"]) -> NonSpare_1790:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STD"]) -> NonSpare_1779:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STA"]) -> NonSpare_1762:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PEM"]) -> NonSpare_1416:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PEC"]) -> NonSpare_1415:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TAG"], Literal["CS"], Literal["IFI"], Literal["FCT"], Literal["TAC"], Literal["WTC"], Literal["DEP"], Literal["DST"], Literal["RDS"], Literal["CFL"], Literal["CTL"], Literal["TOD"], Literal["AST"], Literal["STS"], Literal["STD"], Literal["STA"], Literal["PEM"], Literal["PEC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TAG"]) -> Optional[NonSpare_1812]:
        ...
    @overload
    def get_item(self, key : Literal["CS"]) -> Optional[NonSpare_824]:
        ...
    @overload
    def get_item(self, key : Literal["IFI"]) -> Optional[NonSpare_1109]:
        ...
    @overload
    def get_item(self, key : Literal["FCT"]) -> Optional[NonSpare_962]:
        ...
    @overload
    def get_item(self, key : Literal["TAC"]) -> Optional[NonSpare_1811]:
        ...
    @overload
    def get_item(self, key : Literal["WTC"]) -> Optional[NonSpare_2060]:
        ...
    @overload
    def get_item(self, key : Literal["DEP"]) -> Optional[NonSpare_871]:
        ...
    @overload
    def get_item(self, key : Literal["DST"]) -> Optional[NonSpare_896]:
        ...
    @overload
    def get_item(self, key : Literal["RDS"]) -> Optional[NonSpare_1554]:
        ...
    @overload
    def get_item(self, key : Literal["CFL"]) -> Optional[NonSpare_720]:
        ...
    @overload
    def get_item(self, key : Literal["CTL"]) -> Optional[NonSpare_841]:
        ...
    @overload
    def get_item(self, key : Literal["TOD"]) -> Optional[NonSpare_1875]:
        ...
    @overload
    def get_item(self, key : Literal["AST"]) -> Optional[NonSpare_633]:
        ...
    @overload
    def get_item(self, key : Literal["STS"]) -> Optional[NonSpare_1790]:
        ...
    @overload
    def get_item(self, key : Literal["STD"]) -> Optional[NonSpare_1779]:
        ...
    @overload
    def get_item(self, key : Literal["STA"]) -> Optional[NonSpare_1762]:
        ...
    @overload
    def get_item(self, key : Literal["PEM"]) -> Optional[NonSpare_1416]:
        ...
    @overload
    def get_item(self, key : Literal["PEC"]) -> Optional[NonSpare_1415]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["TAG"], val : NonSpare_1812_Arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["CS"], val : NonSpare_824_Arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["IFI"], val : NonSpare_1109_Arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["FCT"], val : NonSpare_962_Arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["TAC"], val : NonSpare_1811_Arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["WTC"], val : NonSpare_2060_Arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["DEP"], val : NonSpare_871_Arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["DST"], val : NonSpare_896_Arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["RDS"], val : NonSpare_1554_Arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["CFL"], val : NonSpare_720_Arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["CTL"], val : NonSpare_841_Arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["TOD"], val : NonSpare_1875_Arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["AST"], val : NonSpare_633_Arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["STS"], val : NonSpare_1790_Arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["STD"], val : NonSpare_1779_Arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["STA"], val : NonSpare_1762_Arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["PEM"], val : NonSpare_1416_Arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["PEC"], val : NonSpare_1415_Arg) -> "Variation_1503":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["TAG"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["CS"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["IFI"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["FCT"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["TAC"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["WTC"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["DEP"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["DST"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["RDS"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["CFL"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["CTL"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["TOD"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["AST"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["STS"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["STD"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["STA"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["PEM"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["PEC"]) -> "Variation_1503":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1503_Arg) -> 'Variation_1503':
        return cls._create(arg) # type: ignore

RuleVariation_1426_Arg: TypeAlias = Variation_1503_Arg
class RuleVariation_1426(RuleVariationContextFree):
    cv_variation = Variation_1503

    @classmethod
    def create(cls, arg : RuleVariation_1426_Arg) -> "RuleVariation_1426":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1503:
        return self.arg # type: ignore

NonSpare_488_Arg: TypeAlias = RuleVariation_1426_Arg
class NonSpare_488(NonSpare):
    cv_name = "390"
    cv_title = "Flight Plan Related Data"
    cv_rule = RuleVariation_1426

    @classmethod
    def create(cls, arg : NonSpare_488_Arg) -> "NonSpare_488":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1426:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1503:
        return self.rule.variation

class UapItem_488(UapItem):
    cv_non_spare = NonSpare_488

NonSpare_457_Arg: TypeAlias = RuleVariation_1278_Arg
class NonSpare_457(NonSpare):
    cv_name = "270"
    cv_title = "Target Size and Orientation"
    cv_rule = RuleVariation_1278

    @classmethod
    def create(cls, arg : NonSpare_457_Arg) -> "NonSpare_457":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1278:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1355:
        return self.rule.variation

class UapItem_457(UapItem):
    cv_non_spare = NonSpare_457

Content_326_Arg: TypeAlias = int
class Content_326(ContentTable):
    cv_values = {0: "No authenticated Mode 5 ID reply", 1: "Authenticated Mode 5 ID reply"}

RuleContent_326_Arg: TypeAlias = Content_326_Arg
class RuleContent_326(RuleContentContextFree):
    cv_content = Content_326

    @property
    def content(self) -> Content_326:
        return self._get_content() # type: ignore

Variation_439_Arg: TypeAlias = RuleContent_326_Arg
class Variation_439(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_326

    @classmethod
    def create(cls, arg : Variation_439_Arg) -> "Variation_439":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_326:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_326:
        return self.rule.content

RuleVariation_428_Arg: TypeAlias = Variation_439_Arg
class RuleVariation_428(RuleVariationContextFree):
    cv_variation = Variation_439

    @classmethod
    def create(cls, arg : RuleVariation_428_Arg) -> "RuleVariation_428":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_439:
        return self.arg # type: ignore

NonSpare_1101_Arg: TypeAlias = RuleVariation_428_Arg
class NonSpare_1101(NonSpare):
    cv_name = "ID"
    cv_title = ""
    cv_rule = RuleVariation_428

    @classmethod
    def create(cls, arg : NonSpare_1101_Arg) -> "NonSpare_1101":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_428:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_439:
        return self.rule.variation

Item_425_Arg: TypeAlias = NonSpare_1101_Arg
class Item_425(Item):
    cv_non_spare = NonSpare_1101

    @classmethod
    def create(cls, arg : Item_425_Arg) -> "Item_425":
        return cls._create(arg) # type: ignore

Content_271_Arg: TypeAlias = int
class Content_271(ContentTable):
    cv_values = {0: "Mode 1 code not present or not from Mode 5 reply", 1: "Mode 1 code from Mode 5 reply"}

RuleContent_271_Arg: TypeAlias = Content_271_Arg
class RuleContent_271(RuleContentContextFree):
    cv_content = Content_271

    @property
    def content(self) -> Content_271:
        return self._get_content() # type: ignore

Variation_643_Arg: TypeAlias = RuleContent_271_Arg
class Variation_643(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_271

    @classmethod
    def create(cls, arg : Variation_643_Arg) -> "Variation_643":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_271:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_271:
        return self.rule.content

RuleVariation_632_Arg: TypeAlias = Variation_643_Arg
class RuleVariation_632(RuleVariationContextFree):
    cv_variation = Variation_643

    @classmethod
    def create(cls, arg : RuleVariation_632_Arg) -> "RuleVariation_632":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_643:
        return self.arg # type: ignore

NonSpare_1196_Arg: TypeAlias = RuleVariation_632_Arg
class NonSpare_1196(NonSpare):
    cv_name = "M1"
    cv_title = ""
    cv_rule = RuleVariation_632

    @classmethod
    def create(cls, arg : NonSpare_1196_Arg) -> "NonSpare_1196":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_632:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_643:
        return self.rule.variation

Item_510_Arg: TypeAlias = NonSpare_1196_Arg
class Item_510(Item):
    cv_non_spare = NonSpare_1196

    @classmethod
    def create(cls, arg : Item_510_Arg) -> "Item_510":
        return cls._create(arg) # type: ignore

Content_273_Arg: TypeAlias = int
class Content_273(ContentTable):
    cv_values = {0: "Mode 2 code not present or not from Mode 5 reply", 1: "Mode 2 code from Mode 5 reply"}

RuleContent_273_Arg: TypeAlias = Content_273_Arg
class RuleContent_273(RuleContentContextFree):
    cv_content = Content_273

    @property
    def content(self) -> Content_273:
        return self._get_content() # type: ignore

Variation_730_Arg: TypeAlias = RuleContent_273_Arg
class Variation_730(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_273

    @classmethod
    def create(cls, arg : Variation_730_Arg) -> "Variation_730":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_273:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_273:
        return self.rule.content

RuleVariation_719_Arg: TypeAlias = Variation_730_Arg
class RuleVariation_719(RuleVariationContextFree):
    cv_variation = Variation_730

    @classmethod
    def create(cls, arg : RuleVariation_719_Arg) -> "RuleVariation_719":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_730:
        return self.arg # type: ignore

NonSpare_1198_Arg: TypeAlias = RuleVariation_719_Arg
class NonSpare_1198(NonSpare):
    cv_name = "M2"
    cv_title = ""
    cv_rule = RuleVariation_719

    @classmethod
    def create(cls, arg : NonSpare_1198_Arg) -> "NonSpare_1198":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_719:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_730:
        return self.rule.variation

Item_512_Arg: TypeAlias = NonSpare_1198_Arg
class Item_512(Item):
    cv_non_spare = NonSpare_1198

    @classmethod
    def create(cls, arg : Item_512_Arg) -> "Item_512":
        return cls._create(arg) # type: ignore

Content_275_Arg: TypeAlias = int
class Content_275(ContentTable):
    cv_values = {0: "Mode 3 code not present or not from Mode 5 reply", 1: "Mode 3 code from Mode 5 reply"}

RuleContent_275_Arg: TypeAlias = Content_275_Arg
class RuleContent_275(RuleContentContextFree):
    cv_content = Content_275

    @property
    def content(self) -> Content_275:
        return self._get_content() # type: ignore

Variation_857_Arg: TypeAlias = RuleContent_275_Arg
class Variation_857(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_275

    @classmethod
    def create(cls, arg : Variation_857_Arg) -> "Variation_857":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_275:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_275:
        return self.rule.content

RuleVariation_827_Arg: TypeAlias = Variation_857_Arg
class RuleVariation_827(RuleVariationContextFree):
    cv_variation = Variation_857

    @classmethod
    def create(cls, arg : RuleVariation_827_Arg) -> "RuleVariation_827":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_857:
        return self.arg # type: ignore

NonSpare_1202_Arg: TypeAlias = RuleVariation_827_Arg
class NonSpare_1202(NonSpare):
    cv_name = "M3"
    cv_title = ""
    cv_rule = RuleVariation_827

    @classmethod
    def create(cls, arg : NonSpare_1202_Arg) -> "NonSpare_1202":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_827:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_857:
        return self.rule.variation

Item_515_Arg: TypeAlias = NonSpare_1202_Arg
class Item_515(Item):
    cv_non_spare = NonSpare_1202

    @classmethod
    def create(cls, arg : Item_515_Arg) -> "Item_515":
        return cls._create(arg) # type: ignore

Content_278_Arg: TypeAlias = int
class Content_278(ContentTable):
    cv_values = {0: "Mode C altitude code not present or not from Mode 5 reply", 1: "Mode C altitude from Mode 5 reply"}

RuleContent_278_Arg: TypeAlias = Content_278_Arg
class RuleContent_278(RuleContentContextFree):
    cv_content = Content_278

    @property
    def content(self) -> Content_278:
        return self._get_content() # type: ignore

Variation_935_Arg: TypeAlias = RuleContent_278_Arg
class Variation_935(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_278

    @classmethod
    def create(cls, arg : Variation_935_Arg) -> "Variation_935":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_278:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_278:
        return self.rule.content

RuleVariation_905_Arg: TypeAlias = Variation_935_Arg
class RuleVariation_905(RuleVariationContextFree):
    cv_variation = Variation_935

    @classmethod
    def create(cls, arg : RuleVariation_905_Arg) -> "RuleVariation_905":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_935:
        return self.arg # type: ignore

NonSpare_1229_Arg: TypeAlias = RuleVariation_905_Arg
class NonSpare_1229(NonSpare):
    cv_name = "MC"
    cv_title = ""
    cv_rule = RuleVariation_905

    @classmethod
    def create(cls, arg : NonSpare_1229_Arg) -> "NonSpare_1229":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_905:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_935:
        return self.rule.variation

Item_531_Arg: TypeAlias = NonSpare_1229_Arg
class Item_531(Item):
    cv_non_spare = NonSpare_1229

    @classmethod
    def create(cls, arg : Item_531_Arg) -> "Item_531":
        return cls._create(arg) # type: ignore

Content_567_Arg: TypeAlias = int
class Content_567(ContentTable):
    cv_values = {0: "X-pulse set to zero or no authenticated Data reply or Report received", 1: "X-pulse set to one"}

RuleContent_567_Arg: TypeAlias = Content_567_Arg
class RuleContent_567(RuleContentContextFree):
    cv_content = Content_567

    @property
    def content(self) -> Content_567:
        return self._get_content() # type: ignore

Variation_988_Arg: TypeAlias = RuleContent_567_Arg
class Variation_988(Element):
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_567

    @classmethod
    def create(cls, arg : Variation_988_Arg) -> "Variation_988":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_567:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_567:
        return self.rule.content

RuleVariation_958_Arg: TypeAlias = Variation_988_Arg
class RuleVariation_958(RuleVariationContextFree):
    cv_variation = Variation_988

    @classmethod
    def create(cls, arg : RuleVariation_958_Arg) -> "RuleVariation_958":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_988:
        return self.arg # type: ignore

NonSpare_2093_Arg: TypeAlias = RuleVariation_958_Arg
class NonSpare_2093(NonSpare):
    cv_name = "X"
    cv_title = "X-pulse from Mode 5 Data Reply or Report"
    cv_rule = RuleVariation_958

    @classmethod
    def create(cls, arg : NonSpare_2093_Arg) -> "NonSpare_2093":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_958:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_988:
        return self.rule.variation

Item_1200_Arg: TypeAlias = NonSpare_2093_Arg
class Item_1200(Item):
    cv_non_spare = NonSpare_2093

    @classmethod
    def create(cls, arg : Item_1200_Arg) -> "Item_1200":
        return cls._create(arg) # type: ignore

Variation_1133_Arg_Group = Tuple[Union[RuleVariation_56_Arg, Tuple[Literal["M5"], RuleVariation_56_Arg]], Union[RuleVariation_428_Arg, Tuple[Literal["ID"], RuleVariation_428_Arg]], Union[RuleVariation_546_Arg, Tuple[Literal["DA"], RuleVariation_546_Arg]], Union[RuleVariation_632_Arg, Tuple[Literal["M1"], RuleVariation_632_Arg]], Union[RuleVariation_719_Arg, Tuple[Literal["M2"], RuleVariation_719_Arg]], Union[RuleVariation_827_Arg, Tuple[Literal["M3"], RuleVariation_827_Arg]], Union[RuleVariation_905_Arg, Tuple[Literal["MC"], RuleVariation_905_Arg]], Union[RuleVariation_958_Arg, Tuple[Literal["X"], RuleVariation_958_Arg]]]
Variation_1133_Arg: TypeAlias = Union[int, Variation_1133_Arg_Group]
class Variation_1133(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_518, 1), (Item_425, 1), (Item_235, 1), (Item_510, 1), (Item_512, 1), (Item_515, 1), (Item_531, 1), (Item_1200, 1)]
    cv_items_dict = {"M5": RuleVariation_56, "ID": RuleVariation_428, "DA": RuleVariation_546, "M1": RuleVariation_632, "M2": RuleVariation_719, "M3": RuleVariation_827, "MC": RuleVariation_905, "X": RuleVariation_958}

    @overload
    @classmethod
    def spec(cls, key : Literal["M5"]) -> RuleVariation_56:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ID"]) -> RuleVariation_428:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DA"]) -> RuleVariation_546:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M1"]) -> RuleVariation_632:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M2"]) -> RuleVariation_719:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M3"]) -> RuleVariation_827:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MC"]) -> RuleVariation_905:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_958:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["M5"], Literal["ID"], Literal["DA"], Literal["M1"], Literal["M2"], Literal["M3"], Literal["MC"], Literal["X"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["M5"]) -> RuleVariation_56:
        ...
    @overload
    def get_item(self, key : Literal["ID"]) -> RuleVariation_428:
        ...
    @overload
    def get_item(self, key : Literal["DA"]) -> RuleVariation_546:
        ...
    @overload
    def get_item(self, key : Literal["M1"]) -> RuleVariation_632:
        ...
    @overload
    def get_item(self, key : Literal["M2"]) -> RuleVariation_719:
        ...
    @overload
    def get_item(self, key : Literal["M3"]) -> RuleVariation_827:
        ...
    @overload
    def get_item(self, key : Literal["MC"]) -> RuleVariation_905:
        ...
    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_958:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1133_Arg) -> 'Variation_1133':
        return cls._create(arg) # type: ignore

RuleVariation_1090_Arg: TypeAlias = Variation_1133_Arg
class RuleVariation_1090(RuleVariationContextFree):
    cv_variation = Variation_1133

    @classmethod
    def create(cls, arg : RuleVariation_1090_Arg) -> "RuleVariation_1090":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1133:
        return self.arg # type: ignore

NonSpare_1800_Arg: TypeAlias = RuleVariation_1090_Arg
class NonSpare_1800(NonSpare):
    cv_name = "SUM"
    cv_title = "Mode 5 Summary"
    cv_rule = RuleVariation_1090

    @classmethod
    def create(cls, arg : NonSpare_1800_Arg) -> "NonSpare_1800":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1090:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1133:
        return self.rule.variation

Variation_1003_Arg_Group = Tuple[int, Union[RuleVariation_590_Arg, Tuple[Literal["PIN"], RuleVariation_590_Arg]], int, Union[RuleVariation_681_Arg, Tuple[Literal["NAT"], RuleVariation_681_Arg]], int, Union[RuleVariation_588_Arg, Tuple[Literal["MIS"], RuleVariation_588_Arg]]]
Variation_1003_Arg: TypeAlias = Union[int, Variation_1003_Arg_Group]
class Variation_1003(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1, 2), (Item_681, 14), (Item_2, 3), (Item_602, 5), (Item_1, 2), (Item_554, 6)]
    cv_items_dict = {"PIN": RuleVariation_590, "NAT": RuleVariation_681, "MIS": RuleVariation_588}

    @overload
    @classmethod
    def spec(cls, key : Literal["PIN"]) -> RuleVariation_590:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NAT"]) -> RuleVariation_681:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MIS"]) -> RuleVariation_588:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PIN"], Literal["NAT"], Literal["MIS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PIN"]) -> RuleVariation_590:
        ...
    @overload
    def get_item(self, key : Literal["NAT"]) -> RuleVariation_681:
        ...
    @overload
    def get_item(self, key : Literal["MIS"]) -> RuleVariation_588:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1003_Arg) -> 'Variation_1003':
        return cls._create(arg) # type: ignore

RuleVariation_973_Arg: TypeAlias = Variation_1003_Arg
class RuleVariation_973(RuleVariationContextFree):
    cv_variation = Variation_1003

    @classmethod
    def create(cls, arg : RuleVariation_973_Arg) -> "RuleVariation_973":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1003:
        return self.arg # type: ignore

NonSpare_1424_Arg: TypeAlias = RuleVariation_973_Arg
class NonSpare_1424(NonSpare):
    cv_name = "PMN"
    cv_title = "Mode 5 PIN/ National Origin/Mission Code"
    cv_rule = RuleVariation_973

    @classmethod
    def create(cls, arg : NonSpare_1424_Arg) -> "NonSpare_1424":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_973:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1003:
        return self.rule.variation

NonSpare_1435_Arg: TypeAlias = RuleVariation_1078_Arg
class NonSpare_1435(NonSpare):
    cv_name = "POS"
    cv_title = "Mode 5 Reported Position"
    cv_rule = RuleVariation_1078

    @classmethod
    def create(cls, arg : NonSpare_1435_Arg) -> "NonSpare_1435":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1078:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1121:
        return self.rule.variation

NonSpare_1575_Arg: TypeAlias = RuleVariation_414_Arg
class NonSpare_1575(NonSpare):
    cv_name = "RES"
    cv_title = "Resolution with which the GNSS-derived Altitude (GA) is Reported"
    cv_rule = RuleVariation_414

    @classmethod
    def create(cls, arg : NonSpare_1575_Arg) -> "NonSpare_1575":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_414:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_425:
        return self.rule.variation

Item_806_Arg: TypeAlias = NonSpare_1575_Arg
class Item_806(Item):
    cv_non_spare = NonSpare_1575

    @classmethod
    def create(cls, arg : Item_806_Arg) -> "Item_806":
        return cls._create(arg) # type: ignore

NonSpare_1007_Arg: TypeAlias = RuleVariation_593_Arg
class NonSpare_1007(NonSpare):
    cv_name = "GA"
    cv_title = "GNSS-derived Altitude of Target, Expressed as Height Above WGS 84 Ellipsoid"
    cv_rule = RuleVariation_593

    @classmethod
    def create(cls, arg : NonSpare_1007_Arg) -> "NonSpare_1007":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_593:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_604:
        return self.rule.variation

Item_358_Arg: TypeAlias = NonSpare_1007_Arg
class Item_358(Item):
    cv_non_spare = NonSpare_1007

    @classmethod
    def create(cls, arg : Item_358_Arg) -> "Item_358":
        return cls._create(arg) # type: ignore

Variation_998_Arg_Group = Tuple[int, Union[RuleVariation_414_Arg, Tuple[Literal["RES"], RuleVariation_414_Arg]], Union[RuleVariation_593_Arg, Tuple[Literal["GA"], RuleVariation_593_Arg]]]
Variation_998_Arg: TypeAlias = Union[int, Variation_998_Arg_Group]
class Variation_998(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_0, 1), (Item_806, 1), (Item_358, 14)]
    cv_items_dict = {"RES": RuleVariation_414, "GA": RuleVariation_593}

    @overload
    @classmethod
    def spec(cls, key : Literal["RES"]) -> RuleVariation_414:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GA"]) -> RuleVariation_593:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RES"], Literal["GA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RES"]) -> RuleVariation_414:
        ...
    @overload
    def get_item(self, key : Literal["GA"]) -> RuleVariation_593:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_998_Arg) -> 'Variation_998':
        return cls._create(arg) # type: ignore

RuleVariation_968_Arg: TypeAlias = Variation_998_Arg
class RuleVariation_968(RuleVariationContextFree):
    cv_variation = Variation_998

    @classmethod
    def create(cls, arg : RuleVariation_968_Arg) -> "RuleVariation_968":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_998:
        return self.arg # type: ignore

NonSpare_1010_Arg: TypeAlias = RuleVariation_968_Arg
class NonSpare_1010(NonSpare):
    cv_name = "GA"
    cv_title = "Mode 5 GNSS-derived Altitude"
    cv_rule = RuleVariation_968

    @classmethod
    def create(cls, arg : NonSpare_1010_Arg) -> "NonSpare_1010":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_968:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_998:
        return self.rule.variation

NonSpare_920_Arg: TypeAlias = RuleVariation_776_Arg
class NonSpare_920(NonSpare):
    cv_name = "EM1"
    cv_title = "Extended Mode 1 Reply in Octal Representation"
    cv_rule = RuleVariation_776

    @classmethod
    def create(cls, arg : NonSpare_920_Arg) -> "NonSpare_920":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_776:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_806:
        return self.rule.variation

Item_289_Arg: TypeAlias = NonSpare_920_Arg
class Item_289(Item):
    cv_non_spare = NonSpare_920

    @classmethod
    def create(cls, arg : Item_289_Arg) -> "Item_289":
        return cls._create(arg) # type: ignore

Variation_1018_Arg_Group = Tuple[int, Union[RuleVariation_776_Arg, Tuple[Literal["EM1"], RuleVariation_776_Arg]]]
Variation_1018_Arg: TypeAlias = Union[int, Variation_1018_Arg_Group]
class Variation_1018(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_289, 12)]
    cv_items_dict = {"EM1": RuleVariation_776}

    @classmethod
    def spec(cls, key : Literal["EM1"]) -> RuleVariation_776:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["EM1"]) -> RuleVariation_776:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1018_Arg) -> 'Variation_1018':
        return cls._create(arg) # type: ignore

RuleVariation_988_Arg: TypeAlias = Variation_1018_Arg
class RuleVariation_988(RuleVariationContextFree):
    cv_variation = Variation_1018

    @classmethod
    def create(cls, arg : RuleVariation_988_Arg) -> "RuleVariation_988":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1018:
        return self.arg # type: ignore

NonSpare_917_Arg: TypeAlias = RuleVariation_988_Arg
class NonSpare_917(NonSpare):
    cv_name = "EM1"
    cv_title = "Extended Mode 1 Code in Octal Representation"
    cv_rule = RuleVariation_988

    @classmethod
    def create(cls, arg : NonSpare_917_Arg) -> "NonSpare_917":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_988:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1018:
        return self.rule.variation

Content_676_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
class Content_676(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 7.8125e-3
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

RuleContent_676_Arg: TypeAlias = Content_676_Arg
class RuleContent_676(RuleContentContextFree):
    cv_content = Content_676

    @property
    def content(self) -> Content_676:
        return self._get_content() # type: ignore

Variation_214_Arg: TypeAlias = RuleContent_676_Arg
class Variation_214(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_676

    @classmethod
    def create(cls, arg : Variation_214_Arg) -> "Variation_214":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_676:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_676:
        return self.rule.content

RuleVariation_207_Arg: TypeAlias = Variation_214_Arg
class RuleVariation_207(RuleVariationContextFree):
    cv_variation = Variation_214

    @classmethod
    def create(cls, arg : RuleVariation_207_Arg) -> "RuleVariation_207":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_214:
        return self.arg # type: ignore

NonSpare_1878_Arg: TypeAlias = RuleVariation_207_Arg
class NonSpare_1878(NonSpare):
    cv_name = "TOS"
    cv_title = "Time Offset for POS and GA"
    cv_rule = RuleVariation_207

    @classmethod
    def create(cls, arg : NonSpare_1878_Arg) -> "NonSpare_1878":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

Variation_1015_Arg_Group = Tuple[int, Union[RuleVariation_660_Arg, Tuple[Literal["X5"], RuleVariation_660_Arg]], Union[RuleVariation_748_Arg, Tuple[Literal["XC"], RuleVariation_748_Arg]], Union[RuleVariation_843_Arg, Tuple[Literal["X3"], RuleVariation_843_Arg]], Union[RuleVariation_926_Arg, Tuple[Literal["X2"], RuleVariation_926_Arg]], Union[RuleVariation_957_Arg, Tuple[Literal["X1"], RuleVariation_957_Arg]]]
Variation_1015_Arg: TypeAlias = Union[int, Variation_1015_Arg_Group]
class Variation_1015(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_2, 3), (Item_1209, 1), (Item_1212, 1), (Item_1208, 1), (Item_1206, 1), (Item_1202, 1)]
    cv_items_dict = {"X5": RuleVariation_660, "XC": RuleVariation_748, "X3": RuleVariation_843, "X2": RuleVariation_926, "X1": RuleVariation_957}

    @overload
    @classmethod
    def spec(cls, key : Literal["X5"]) -> RuleVariation_660:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XC"]) -> RuleVariation_748:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X3"]) -> RuleVariation_843:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X2"]) -> RuleVariation_926:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X1"]) -> RuleVariation_957:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X5"], Literal["XC"], Literal["X3"], Literal["X2"], Literal["X1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X5"]) -> RuleVariation_660:
        ...
    @overload
    def get_item(self, key : Literal["XC"]) -> RuleVariation_748:
        ...
    @overload
    def get_item(self, key : Literal["X3"]) -> RuleVariation_843:
        ...
    @overload
    def get_item(self, key : Literal["X2"]) -> RuleVariation_926:
        ...
    @overload
    def get_item(self, key : Literal["X1"]) -> RuleVariation_957:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1015_Arg) -> 'Variation_1015':
        return cls._create(arg) # type: ignore

RuleVariation_985_Arg: TypeAlias = Variation_1015_Arg
class RuleVariation_985(RuleVariationContextFree):
    cv_variation = Variation_1015

    @classmethod
    def create(cls, arg : RuleVariation_985_Arg) -> "RuleVariation_985":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1015:
        return self.arg # type: ignore

NonSpare_2108_Arg: TypeAlias = RuleVariation_985_Arg
class NonSpare_2108(NonSpare):
    cv_name = "XP"
    cv_title = "X Pulse Presence"
    cv_rule = RuleVariation_985

    @classmethod
    def create(cls, arg : NonSpare_2108_Arg) -> "NonSpare_2108":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_985:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1015:
        return self.rule.variation

Variation_1499_Arg = TypedDict('Variation_1499_Arg', {
    "SUM": NonSpare_1800_Arg,
    "PMN": NonSpare_1424_Arg,
    "POS": NonSpare_1435_Arg,
    "GA": NonSpare_1010_Arg,
    "EM1": NonSpare_917_Arg,
    "TOS": NonSpare_1878_Arg,
    "XP": NonSpare_2108_Arg,
}, total=False)
class Variation_1499(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1800, NonSpare_1424, NonSpare_1435, NonSpare_1010, NonSpare_917, NonSpare_1878, NonSpare_2108]
    cv_items_dict = {"SUM": NonSpare_1800, "PMN": NonSpare_1424, "POS": NonSpare_1435, "GA": NonSpare_1010, "EM1": NonSpare_917, "TOS": NonSpare_1878, "XP": NonSpare_2108}

    @overload
    @classmethod
    def spec(cls, key : Literal["SUM"]) -> NonSpare_1800:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PMN"]) -> NonSpare_1424:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1435:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GA"]) -> NonSpare_1010:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EM1"]) -> NonSpare_917:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOS"]) -> NonSpare_1878:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XP"]) -> NonSpare_2108:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SUM"], Literal["PMN"], Literal["POS"], Literal["GA"], Literal["EM1"], Literal["TOS"], Literal["XP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SUM"]) -> Optional[NonSpare_1800]:
        ...
    @overload
    def get_item(self, key : Literal["PMN"]) -> Optional[NonSpare_1424]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1435]:
        ...
    @overload
    def get_item(self, key : Literal["GA"]) -> Optional[NonSpare_1010]:
        ...
    @overload
    def get_item(self, key : Literal["EM1"]) -> Optional[NonSpare_917]:
        ...
    @overload
    def get_item(self, key : Literal["TOS"]) -> Optional[NonSpare_1878]:
        ...
    @overload
    def get_item(self, key : Literal["XP"]) -> Optional[NonSpare_2108]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["SUM"], val : NonSpare_1800_Arg) -> "Variation_1499":
        ...
    @overload
    def set_item(self, key : Literal["PMN"], val : NonSpare_1424_Arg) -> "Variation_1499":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1435_Arg) -> "Variation_1499":
        ...
    @overload
    def set_item(self, key : Literal["GA"], val : NonSpare_1010_Arg) -> "Variation_1499":
        ...
    @overload
    def set_item(self, key : Literal["EM1"], val : NonSpare_917_Arg) -> "Variation_1499":
        ...
    @overload
    def set_item(self, key : Literal["TOS"], val : NonSpare_1878_Arg) -> "Variation_1499":
        ...
    @overload
    def set_item(self, key : Literal["XP"], val : NonSpare_2108_Arg) -> "Variation_1499":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["SUM"]) -> "Variation_1499":
        ...
    @overload
    def del_item(self, key : Literal["PMN"]) -> "Variation_1499":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1499":
        ...
    @overload
    def del_item(self, key : Literal["GA"]) -> "Variation_1499":
        ...
    @overload
    def del_item(self, key : Literal["EM1"]) -> "Variation_1499":
        ...
    @overload
    def del_item(self, key : Literal["TOS"]) -> "Variation_1499":
        ...
    @overload
    def del_item(self, key : Literal["XP"]) -> "Variation_1499":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1499_Arg) -> 'Variation_1499':
        return cls._create(arg) # type: ignore

RuleVariation_1422_Arg: TypeAlias = Variation_1499_Arg
class RuleVariation_1422(RuleVariationContextFree):
    cv_variation = Variation_1499

    @classmethod
    def create(cls, arg : RuleVariation_1422_Arg) -> "RuleVariation_1422":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1499:
        return self.arg # type: ignore

NonSpare_285_Arg: TypeAlias = RuleVariation_1422_Arg
class NonSpare_285(NonSpare):
    cv_name = "110"
    cv_title = "Mode 5 Data Reports and Extended Mode 1 Code"
    cv_rule = RuleVariation_1422

    @classmethod
    def create(cls, arg : NonSpare_285_Arg) -> "NonSpare_285":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1422:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1499:
        return self.rule.variation

class UapItem_285(UapItem):
    cv_non_spare = NonSpare_285

Variation_1022_Arg_Group = Tuple[int, Union[RuleVariation_776_Arg, Tuple[Literal["MODE2"], RuleVariation_776_Arg]]]
Variation_1022_Arg: TypeAlias = Union[int, Variation_1022_Arg_Group]
class Variation_1022(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_566, 12)]
    cv_items_dict = {"MODE2": RuleVariation_776}

    @classmethod
    def spec(cls, key : Literal["MODE2"]) -> RuleVariation_776:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["MODE2"]) -> RuleVariation_776:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg : Variation_1022_Arg) -> 'Variation_1022':
        return cls._create(arg) # type: ignore

RuleVariation_991_Arg: TypeAlias = Variation_1022_Arg
class RuleVariation_991(RuleVariationContextFree):
    cv_variation = Variation_1022

    @classmethod
    def create(cls, arg : RuleVariation_991_Arg) -> "RuleVariation_991":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1022:
        return self.arg # type: ignore

NonSpare_300_Arg: TypeAlias = RuleVariation_991_Arg
class NonSpare_300(NonSpare):
    cv_name = "120"
    cv_title = "Track Mode 2 Code"
    cv_rule = RuleVariation_991

    @classmethod
    def create(cls, arg : NonSpare_300_Arg) -> "NonSpare_300":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_991:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1022:
        return self.rule.variation

class UapItem_300(UapItem):
    cv_non_spare = NonSpare_300

NonSpare_1277_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_1277(NonSpare):
    cv_name = "MIDENT"
    cv_title = "Master System Unit Identification"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_1277_Arg) -> "NonSpare_1277":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_550_Arg: TypeAlias = NonSpare_1277_Arg
class Item_550(Item):
    cv_non_spare = NonSpare_1277

    @classmethod
    def create(cls, arg : Item_550_Arg) -> "Item_550":
        return cls._create(arg) # type: ignore

NonSpare_1326_Arg: TypeAlias = RuleVariation_242_Arg
class NonSpare_1326(NonSpare):
    cv_name = "MTRACK"
    cv_title = "Master System Track Number"
    cv_rule = RuleVariation_242

    @classmethod
    def create(cls, arg : NonSpare_1326_Arg) -> "NonSpare_1326":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_242:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_249:
        return self.rule.variation

Item_596_Arg: TypeAlias = NonSpare_1326_Arg
class Item_596(Item):
    cv_non_spare = NonSpare_1326

    @classmethod
    def create(cls, arg : Item_596_Arg) -> "Item_596":
        return cls._create(arg) # type: ignore

NonSpare_1706_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_1706(NonSpare):
    cv_name = "SIDENT"
    cv_title = "Slave System Unit Identification"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_1706_Arg) -> "NonSpare_1706":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_887_Arg: TypeAlias = NonSpare_1706_Arg
class Item_887(Item):
    cv_non_spare = NonSpare_1706

    @classmethod
    def create(cls, arg : Item_887_Arg) -> "Item_887":
        return cls._create(arg) # type: ignore

NonSpare_1789_Arg: TypeAlias = RuleVariation_242_Arg
class NonSpare_1789(NonSpare):
    cv_name = "STRACK"
    cv_title = "Slave System Track Number"
    cv_rule = RuleVariation_242

    @classmethod
    def create(cls, arg : NonSpare_1789_Arg) -> "NonSpare_1789":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_242:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_249:
        return self.rule.variation

Item_955_Arg: TypeAlias = NonSpare_1789_Arg
class Item_955(Item):
    cv_non_spare = NonSpare_1789

    @classmethod
    def create(cls, arg : Item_955_Arg) -> "Item_955":
        return cls._create(arg) # type: ignore

Variation_1357_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_158_Arg, Tuple[Literal["MIDENT"], RuleVariation_158_Arg]], Union[RuleVariation_242_Arg, Tuple[Literal["MTRACK"], RuleVariation_242_Arg]], None]]
Variation_1357_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_158_Arg, Tuple[Literal["SIDENT"], RuleVariation_158_Arg]], Union[RuleVariation_242_Arg, Tuple[Literal["STRACK"], RuleVariation_242_Arg]], None]]
Variation_1357_Arg: TypeAlias = Union[
    Tuple[Variation_1357_Arg_Group_1],
    Tuple[Variation_1357_Arg_Group_1, Variation_1357_Arg_Group_2],
]
class Variation_1357(Extended):
    cv_items_list = [[(Item_550, 8), (Item_596, 15), None], [(Item_887, 8), (Item_955, 15), None]]

    @classmethod
    def create(cls, arg : Variation_1357_Arg) -> 'Variation_1357':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MIDENT"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["MTRACK"]) -> RuleVariation_242:
        ...
    @overload
    def get_item(self, key : Literal["SIDENT"]) -> Optional[RuleVariation_158]:
        ...
    @overload
    def get_item(self, key : Literal["STRACK"]) -> Optional[RuleVariation_242]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1280_Arg: TypeAlias = Variation_1357_Arg
class RuleVariation_1280(RuleVariationContextFree):
    cv_variation = Variation_1357

    @classmethod
    def create(cls, arg : RuleVariation_1280_Arg) -> "RuleVariation_1280":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1357:
        return self.arg # type: ignore

NonSpare_515_Arg: TypeAlias = RuleVariation_1280_Arg
class NonSpare_515(NonSpare):
    cv_name = "510"
    cv_title = "Composed Track Number"
    cv_rule = RuleVariation_1280

    @classmethod
    def create(cls, arg : NonSpare_515_Arg) -> "NonSpare_515":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1280:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1357:
        return self.rule.variation

class UapItem_514(UapItem):
    cv_non_spare = NonSpare_515

NonSpare_2076_Arg: TypeAlias = RuleVariation_302_Arg
class NonSpare_2076(NonSpare):
    cv_name = "X"
    cv_title = "APC (X-Component)"
    cv_rule = RuleVariation_302

    @classmethod
    def create(cls, arg : NonSpare_2076_Arg) -> "NonSpare_2076":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_302:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_309:
        return self.rule.variation

Item_1183_Arg: TypeAlias = NonSpare_2076_Arg
class Item_1183(Item):
    cv_non_spare = NonSpare_2076

    @classmethod
    def create(cls, arg : Item_1183_Arg) -> "Item_1183":
        return cls._create(arg) # type: ignore

NonSpare_2129_Arg: TypeAlias = RuleVariation_302_Arg
class NonSpare_2129(NonSpare):
    cv_name = "Y"
    cv_title = "APC (Y-Component)"
    cv_rule = RuleVariation_302

    @classmethod
    def create(cls, arg : NonSpare_2129_Arg) -> "NonSpare_2129":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_302:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_309:
        return self.rule.variation

Item_1233_Arg: TypeAlias = NonSpare_2129_Arg
class Item_1233(Item):
    cv_non_spare = NonSpare_2129

    @classmethod
    def create(cls, arg : Item_1233_Arg) -> "Item_1233":
        return cls._create(arg) # type: ignore

Variation_1293_Arg_Group = Tuple[Union[RuleVariation_302_Arg, Tuple[Literal["X"], RuleVariation_302_Arg]], Union[RuleVariation_302_Arg, Tuple[Literal["Y"], RuleVariation_302_Arg]]]
Variation_1293_Arg: TypeAlias = Union[int, Variation_1293_Arg_Group]
class Variation_1293(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1183, 16), (Item_1233, 16)]
    cv_items_dict = {"X": RuleVariation_302, "Y": RuleVariation_302}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_302:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_302:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_302:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_302:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1293_Arg) -> 'Variation_1293':
        return cls._create(arg) # type: ignore

RuleVariation_1223_Arg: TypeAlias = Variation_1293_Arg
class RuleVariation_1223(RuleVariationContextFree):
    cv_variation = Variation_1293

    @classmethod
    def create(cls, arg : RuleVariation_1223_Arg) -> "RuleVariation_1223":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1293:
        return self.arg # type: ignore

NonSpare_610_Arg: TypeAlias = RuleVariation_1223_Arg
class NonSpare_610(NonSpare):
    cv_name = "APC"
    cv_title = "Estimated Accuracy Of Track Position (Cartesian)"
    cv_rule = RuleVariation_1223

    @classmethod
    def create(cls, arg : NonSpare_610_Arg) -> "NonSpare_610":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1223:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1293:
        return self.rule.variation

NonSpare_795_Arg: TypeAlias = RuleVariation_256_Arg
class NonSpare_795(NonSpare):
    cv_name = "COV"
    cv_title = "XY Covariance Component"
    cv_rule = RuleVariation_256

    @classmethod
    def create(cls, arg : NonSpare_795_Arg) -> "NonSpare_795":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_256:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_263:
        return self.rule.variation

Content_785_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_785(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 5.364418029785156e-6
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_784_Arg: TypeAlias = Content_785_Arg
class RuleContent_784(RuleContentContextFree):
    cv_content = Content_785

    @property
    def content(self) -> Content_785:
        return self._get_content() # type: ignore

Variation_340_Arg: TypeAlias = RuleContent_784_Arg
class Variation_340(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_784

    @classmethod
    def create(cls, arg : Variation_340_Arg) -> "Variation_340":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_784:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_785:
        return self.rule.content

RuleVariation_333_Arg: TypeAlias = Variation_340_Arg
class RuleVariation_333(RuleVariationContextFree):
    cv_variation = Variation_340

    @classmethod
    def create(cls, arg : RuleVariation_333_Arg) -> "RuleVariation_333":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_340:
        return self.arg # type: ignore

NonSpare_1138_Arg: TypeAlias = RuleVariation_333_Arg
class NonSpare_1138(NonSpare):
    cv_name = "LAT"
    cv_title = "APW (Latitude Component)"
    cv_rule = RuleVariation_333

    @classmethod
    def create(cls, arg : NonSpare_1138_Arg) -> "NonSpare_1138":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_333:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_340:
        return self.rule.variation

Item_456_Arg: TypeAlias = NonSpare_1138_Arg
class Item_456(Item):
    cv_non_spare = NonSpare_1138

    @classmethod
    def create(cls, arg : Item_456_Arg) -> "Item_456":
        return cls._create(arg) # type: ignore

NonSpare_1166_Arg: TypeAlias = RuleVariation_333_Arg
class NonSpare_1166(NonSpare):
    cv_name = "LON"
    cv_title = "APW (Longitude Component)"
    cv_rule = RuleVariation_333

    @classmethod
    def create(cls, arg : NonSpare_1166_Arg) -> "NonSpare_1166":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_333:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_340:
        return self.rule.variation

Item_482_Arg: TypeAlias = NonSpare_1166_Arg
class Item_482(Item):
    cv_non_spare = NonSpare_1166

    @classmethod
    def create(cls, arg : Item_482_Arg) -> "Item_482":
        return cls._create(arg) # type: ignore

Variation_1118_Arg_Group = Tuple[Union[RuleVariation_333_Arg, Tuple[Literal["LAT"], RuleVariation_333_Arg]], Union[RuleVariation_333_Arg, Tuple[Literal["LON"], RuleVariation_333_Arg]]]
Variation_1118_Arg: TypeAlias = Union[int, Variation_1118_Arg_Group]
class Variation_1118(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_456, 16), (Item_482, 16)]
    cv_items_dict = {"LAT": RuleVariation_333, "LON": RuleVariation_333}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_333:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_333:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_333:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_333:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1118_Arg) -> 'Variation_1118':
        return cls._create(arg) # type: ignore

RuleVariation_1075_Arg: TypeAlias = Variation_1118_Arg
class RuleVariation_1075(RuleVariationContextFree):
    cv_variation = Variation_1118

    @classmethod
    def create(cls, arg : RuleVariation_1075_Arg) -> "RuleVariation_1075":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1118:
        return self.arg # type: ignore

NonSpare_615_Arg: TypeAlias = RuleVariation_1075_Arg
class NonSpare_615(NonSpare):
    cv_name = "APW"
    cv_title = "Estimated Accuracy Of Track Position (WGS-84)"
    cv_rule = RuleVariation_1075

    @classmethod
    def create(cls, arg : NonSpare_615_Arg) -> "NonSpare_615":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1075:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1118:
        return self.rule.variation

Content_779_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
class Content_779(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 6.25
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

RuleContent_778_Arg: TypeAlias = Content_779_Arg
class RuleContent_778(RuleContentContextFree):
    cv_content = Content_779

    @property
    def content(self) -> Content_779:
        return self._get_content() # type: ignore

Variation_239_Arg: TypeAlias = RuleContent_778_Arg
class Variation_239(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_778

    @classmethod
    def create(cls, arg : Variation_239_Arg) -> "Variation_239":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_778:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_779:
        return self.rule.content

RuleVariation_232_Arg: TypeAlias = Variation_239_Arg
class RuleVariation_232(RuleVariationContextFree):
    cv_variation = Variation_239

    @classmethod
    def create(cls, arg : RuleVariation_232_Arg) -> "RuleVariation_232":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_239:
        return self.arg # type: ignore

NonSpare_576_Arg: TypeAlias = RuleVariation_232_Arg
class NonSpare_576(NonSpare):
    cv_name = "AGA"
    cv_title = "Estimated Accuracy Of Calculated Track Geometric Altitude"
    cv_rule = RuleVariation_232

    @classmethod
    def create(cls, arg : NonSpare_576_Arg) -> "NonSpare_576":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_232:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_239:
        return self.rule.variation

Variation_229_Arg: TypeAlias = RuleContent_748_Arg
class Variation_229(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_748

    @classmethod
    def create(cls, arg : Variation_229_Arg) -> "Variation_229":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_748:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_749:
        return self.rule.content

RuleVariation_222_Arg: TypeAlias = Variation_229_Arg
class RuleVariation_222(RuleVariationContextFree):
    cv_variation = Variation_229

    @classmethod
    def create(cls, arg : RuleVariation_222_Arg) -> "RuleVariation_222":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_229:
        return self.arg # type: ignore

NonSpare_548_Arg: TypeAlias = RuleVariation_222_Arg
class NonSpare_548(NonSpare):
    cv_name = "ABA"
    cv_title = "Estimated Accuracy Of Calculated Track Barometric Altitude"
    cv_rule = RuleVariation_222

    @classmethod
    def create(cls, arg : NonSpare_548_Arg) -> "NonSpare_548":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

Content_754_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
class Content_754(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.25
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

RuleContent_753_Arg: TypeAlias = Content_754_Arg
class RuleContent_753(RuleContentContextFree):
    cv_content = Content_754

    @property
    def content(self) -> Content_754:
        return self._get_content() # type: ignore

Variation_231_Arg: TypeAlias = RuleContent_753_Arg
class Variation_231(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_753

    @classmethod
    def create(cls, arg : Variation_231_Arg) -> "Variation_231":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_753:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_754:
        return self.rule.content

RuleVariation_224_Arg: TypeAlias = Variation_231_Arg
class RuleVariation_224(RuleVariationContextFree):
    cv_variation = Variation_231

    @classmethod
    def create(cls, arg : RuleVariation_224_Arg) -> "RuleVariation_224":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_231:
        return self.arg # type: ignore

NonSpare_2077_Arg: TypeAlias = RuleVariation_224_Arg
class NonSpare_2077(NonSpare):
    cv_name = "X"
    cv_title = "ATV (X-Component)"
    cv_rule = RuleVariation_224

    @classmethod
    def create(cls, arg : NonSpare_2077_Arg) -> "NonSpare_2077":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_224:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_231:
        return self.rule.variation

Item_1184_Arg: TypeAlias = NonSpare_2077_Arg
class Item_1184(Item):
    cv_non_spare = NonSpare_2077

    @classmethod
    def create(cls, arg : Item_1184_Arg) -> "Item_1184":
        return cls._create(arg) # type: ignore

NonSpare_2130_Arg: TypeAlias = RuleVariation_224_Arg
class NonSpare_2130(NonSpare):
    cv_name = "Y"
    cv_title = "ATV (Y-Component)"
    cv_rule = RuleVariation_224

    @classmethod
    def create(cls, arg : NonSpare_2130_Arg) -> "NonSpare_2130":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_224:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_231:
        return self.rule.variation

Item_1234_Arg: TypeAlias = NonSpare_2130_Arg
class Item_1234(Item):
    cv_non_spare = NonSpare_2130

    @classmethod
    def create(cls, arg : Item_1234_Arg) -> "Item_1234":
        return cls._create(arg) # type: ignore

Variation_1294_Arg_Group = Tuple[Union[RuleVariation_224_Arg, Tuple[Literal["X"], RuleVariation_224_Arg]], Union[RuleVariation_224_Arg, Tuple[Literal["Y"], RuleVariation_224_Arg]]]
Variation_1294_Arg: TypeAlias = Union[int, Variation_1294_Arg_Group]
class Variation_1294(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1184, 8), (Item_1234, 8)]
    cv_items_dict = {"X": RuleVariation_224, "Y": RuleVariation_224}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_224:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_224:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_224:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_224:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1294_Arg) -> 'Variation_1294':
        return cls._create(arg) # type: ignore

RuleVariation_1224_Arg: TypeAlias = Variation_1294_Arg
class RuleVariation_1224(RuleVariationContextFree):
    cv_variation = Variation_1294

    @classmethod
    def create(cls, arg : RuleVariation_1224_Arg) -> "RuleVariation_1224":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1294:
        return self.arg # type: ignore

NonSpare_640_Arg: TypeAlias = RuleVariation_1224_Arg
class NonSpare_640(NonSpare):
    cv_name = "ATV"
    cv_title = "Estimated Accuracy Of Track Velocity (Cartesian)"
    cv_rule = RuleVariation_1224

    @classmethod
    def create(cls, arg : NonSpare_640_Arg) -> "NonSpare_640":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1224:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1294:
        return self.rule.variation

Content_755_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
class Content_755(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.25
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

RuleContent_754_Arg: TypeAlias = Content_755_Arg
class RuleContent_754(RuleContentContextFree):
    cv_content = Content_755

    @property
    def content(self) -> Content_755:
        return self._get_content() # type: ignore

Variation_232_Arg: TypeAlias = RuleContent_754_Arg
class Variation_232(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_754

    @classmethod
    def create(cls, arg : Variation_232_Arg) -> "Variation_232":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_754:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_755:
        return self.rule.content

RuleVariation_225_Arg: TypeAlias = Variation_232_Arg
class RuleVariation_225(RuleVariationContextFree):
    cv_variation = Variation_232

    @classmethod
    def create(cls, arg : RuleVariation_225_Arg) -> "RuleVariation_225":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_232:
        return self.arg # type: ignore

NonSpare_2075_Arg: TypeAlias = RuleVariation_225_Arg
class NonSpare_2075(NonSpare):
    cv_name = "X"
    cv_title = "AA (X-Component)"
    cv_rule = RuleVariation_225

    @classmethod
    def create(cls, arg : NonSpare_2075_Arg) -> "NonSpare_2075":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_225:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_232:
        return self.rule.variation

Item_1182_Arg: TypeAlias = NonSpare_2075_Arg
class Item_1182(Item):
    cv_non_spare = NonSpare_2075

    @classmethod
    def create(cls, arg : Item_1182_Arg) -> "Item_1182":
        return cls._create(arg) # type: ignore

NonSpare_2128_Arg: TypeAlias = RuleVariation_225_Arg
class NonSpare_2128(NonSpare):
    cv_name = "Y"
    cv_title = "AA (Y-Component)"
    cv_rule = RuleVariation_225

    @classmethod
    def create(cls, arg : NonSpare_2128_Arg) -> "NonSpare_2128":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_225:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_232:
        return self.rule.variation

Item_1232_Arg: TypeAlias = NonSpare_2128_Arg
class Item_1232(Item):
    cv_non_spare = NonSpare_2128

    @classmethod
    def create(cls, arg : Item_1232_Arg) -> "Item_1232":
        return cls._create(arg) # type: ignore

Variation_1292_Arg_Group = Tuple[Union[RuleVariation_225_Arg, Tuple[Literal["X"], RuleVariation_225_Arg]], Union[RuleVariation_225_Arg, Tuple[Literal["Y"], RuleVariation_225_Arg]]]
Variation_1292_Arg: TypeAlias = Union[int, Variation_1292_Arg_Group]
class Variation_1292(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1182, 8), (Item_1232, 8)]
    cv_items_dict = {"X": RuleVariation_225, "Y": RuleVariation_225}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_225:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_225:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_225:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_225:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1292_Arg) -> 'Variation_1292':
        return cls._create(arg) # type: ignore

RuleVariation_1222_Arg: TypeAlias = Variation_1292_Arg
class RuleVariation_1222(RuleVariationContextFree):
    cv_variation = Variation_1292

    @classmethod
    def create(cls, arg : RuleVariation_1222_Arg) -> "RuleVariation_1222":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1292:
        return self.arg # type: ignore

NonSpare_544_Arg: TypeAlias = RuleVariation_1222_Arg
class NonSpare_544(NonSpare):
    cv_name = "AA"
    cv_title = "Estimated Accuracy Of Acceleration (Cartesian)"
    cv_rule = RuleVariation_1222

    @classmethod
    def create(cls, arg : NonSpare_544_Arg) -> "NonSpare_544":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1292:
        return self.rule.variation

Content_780_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft/min"]]]
class Content_780(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 6.25
    cv_unit = "ft/min"

    def as_quantity(self, cv_unit : Optional[Literal["ft/min"]] = None) -> float:
        return self._as_quantity()

RuleContent_779_Arg: TypeAlias = Content_780_Arg
class RuleContent_779(RuleContentContextFree):
    cv_content = Content_780

    @property
    def content(self) -> Content_780:
        return self._get_content() # type: ignore

Variation_240_Arg: TypeAlias = RuleContent_779_Arg
class Variation_240(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_779

    @classmethod
    def create(cls, arg : Variation_240_Arg) -> "Variation_240":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_779:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_780:
        return self.rule.content

RuleVariation_233_Arg: TypeAlias = Variation_240_Arg
class RuleVariation_233(RuleVariationContextFree):
    cv_variation = Variation_240

    @classmethod
    def create(cls, arg : RuleVariation_233_Arg) -> "RuleVariation_233":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_240:
        return self.arg # type: ignore

NonSpare_625_Arg: TypeAlias = RuleVariation_233_Arg
class NonSpare_625(NonSpare):
    cv_name = "ARC"
    cv_title = "Estimated Accuracy Of Rate Of Climb/Descent"
    cv_rule = RuleVariation_233

    @classmethod
    def create(cls, arg : NonSpare_625_Arg) -> "NonSpare_625":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_233:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_240:
        return self.rule.variation

Variation_1466_Arg = TypedDict('Variation_1466_Arg', {
    "APC": NonSpare_610_Arg,
    "COV": NonSpare_795_Arg,
    "APW": NonSpare_615_Arg,
    "AGA": NonSpare_576_Arg,
    "ABA": NonSpare_548_Arg,
    "ATV": NonSpare_640_Arg,
    "AA": NonSpare_544_Arg,
    "ARC": NonSpare_625_Arg,
}, total=False)
class Variation_1466(Compound):
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_610, NonSpare_795, NonSpare_615, NonSpare_576, NonSpare_548, NonSpare_640, NonSpare_544, NonSpare_625]
    cv_items_dict = {"APC": NonSpare_610, "COV": NonSpare_795, "APW": NonSpare_615, "AGA": NonSpare_576, "ABA": NonSpare_548, "ATV": NonSpare_640, "AA": NonSpare_544, "ARC": NonSpare_625}

    @overload
    @classmethod
    def spec(cls, key : Literal["APC"]) -> NonSpare_610:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COV"]) -> NonSpare_795:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["APW"]) -> NonSpare_615:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AGA"]) -> NonSpare_576:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ABA"]) -> NonSpare_548:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ATV"]) -> NonSpare_640:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AA"]) -> NonSpare_544:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> NonSpare_625:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["APC"], Literal["COV"], Literal["APW"], Literal["AGA"], Literal["ABA"], Literal["ATV"], Literal["AA"], Literal["ARC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["APC"]) -> Optional[NonSpare_610]:
        ...
    @overload
    def get_item(self, key : Literal["COV"]) -> Optional[NonSpare_795]:
        ...
    @overload
    def get_item(self, key : Literal["APW"]) -> Optional[NonSpare_615]:
        ...
    @overload
    def get_item(self, key : Literal["AGA"]) -> Optional[NonSpare_576]:
        ...
    @overload
    def get_item(self, key : Literal["ABA"]) -> Optional[NonSpare_548]:
        ...
    @overload
    def get_item(self, key : Literal["ATV"]) -> Optional[NonSpare_640]:
        ...
    @overload
    def get_item(self, key : Literal["AA"]) -> Optional[NonSpare_544]:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> Optional[NonSpare_625]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["APC"], val : NonSpare_610_Arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["COV"], val : NonSpare_795_Arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["APW"], val : NonSpare_615_Arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["AGA"], val : NonSpare_576_Arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["ABA"], val : NonSpare_548_Arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["ATV"], val : NonSpare_640_Arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["AA"], val : NonSpare_544_Arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["ARC"], val : NonSpare_625_Arg) -> "Variation_1466":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["APC"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["COV"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["APW"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["AGA"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["ABA"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["ATV"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["AA"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["ARC"]) -> "Variation_1466":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1466_Arg) -> 'Variation_1466':
        return cls._create(arg) # type: ignore

RuleVariation_1389_Arg: TypeAlias = Variation_1466_Arg
class RuleVariation_1389(RuleVariationContextFree):
    cv_variation = Variation_1466

    @classmethod
    def create(cls, arg : RuleVariation_1389_Arg) -> "RuleVariation_1389":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1466:
        return self.arg # type: ignore

NonSpare_510_Arg: TypeAlias = RuleVariation_1389_Arg
class NonSpare_510(NonSpare):
    cv_name = "500"
    cv_title = "Estimated Accuracies"
    cv_rule = RuleVariation_1389

    @classmethod
    def create(cls, arg : NonSpare_510_Arg) -> "NonSpare_510":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1389:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1466:
        return self.rule.variation

class UapItem_509(UapItem):
    cv_non_spare = NonSpare_510

NonSpare_1703_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_1703(NonSpare):
    cv_name = "SID"
    cv_title = "Sensor Identification"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_1703_Arg) -> "NonSpare_1703":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

NonSpare_1581_Arg: TypeAlias = RuleVariation_327_Arg
class NonSpare_1581(NonSpare):
    cv_name = "RHO"
    cv_title = "Measured Distance"
    cv_rule = RuleVariation_327

    @classmethod
    def create(cls, arg : NonSpare_1581_Arg) -> "NonSpare_1581":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_327:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_334:
        return self.rule.variation

Item_812_Arg: TypeAlias = NonSpare_1581_Arg
class Item_812(Item):
    cv_non_spare = NonSpare_1581

    @classmethod
    def create(cls, arg : Item_812_Arg) -> "Item_812":
        return cls._create(arg) # type: ignore

NonSpare_1848_Arg: TypeAlias = RuleVariation_334_Arg
class NonSpare_1848(NonSpare):
    cv_name = "THETA"
    cv_title = "Measured Azimuth"
    cv_rule = RuleVariation_334

    @classmethod
    def create(cls, arg : NonSpare_1848_Arg) -> "NonSpare_1848":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

Item_992_Arg: TypeAlias = NonSpare_1848_Arg
class Item_992(Item):
    cv_non_spare = NonSpare_1848

    @classmethod
    def create(cls, arg : Item_992_Arg) -> "Item_992":
        return cls._create(arg) # type: ignore

Variation_1174_Arg_Group = Tuple[Union[RuleVariation_327_Arg, Tuple[Literal["RHO"], RuleVariation_327_Arg]], Union[RuleVariation_334_Arg, Tuple[Literal["THETA"], RuleVariation_334_Arg]]]
Variation_1174_Arg: TypeAlias = Union[int, Variation_1174_Arg_Group]
class Variation_1174(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_812, 16), (Item_992, 16)]
    cv_items_dict = {"RHO": RuleVariation_327, "THETA": RuleVariation_334}

    @overload
    @classmethod
    def spec(cls, key : Literal["RHO"]) -> RuleVariation_327:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["THETA"]) -> RuleVariation_334:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RHO"], Literal["THETA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RHO"]) -> RuleVariation_327:
        ...
    @overload
    def get_item(self, key : Literal["THETA"]) -> RuleVariation_334:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1174_Arg) -> 'Variation_1174':
        return cls._create(arg) # type: ignore

RuleVariation_1126_Arg: TypeAlias = Variation_1174_Arg
class RuleVariation_1126(RuleVariationContextFree):
    cv_variation = Variation_1174

    @classmethod
    def create(cls, arg : RuleVariation_1126_Arg) -> "RuleVariation_1126":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1174:
        return self.arg # type: ignore

NonSpare_1434_Arg: TypeAlias = RuleVariation_1126_Arg
class NonSpare_1434(NonSpare):
    cv_name = "POS"
    cv_title = "Measured Position"
    cv_rule = RuleVariation_1126

    @classmethod
    def create(cls, arg : NonSpare_1434_Arg) -> "NonSpare_1434":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1126:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1174:
        return self.rule.variation

NonSpare_1056_Arg: TypeAlias = RuleVariation_301_Arg
class NonSpare_1056(NonSpare):
    cv_name = "HEIGHT"
    cv_title = "Measured 3-D Height"
    cv_rule = RuleVariation_301

    @classmethod
    def create(cls, arg : NonSpare_1056_Arg) -> "NonSpare_1056":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_301:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_308:
        return self.rule.variation

Content_653_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["FL"]]]
class Content_653(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 0.25
    cv_unit = "FL"

    def as_quantity(self, cv_unit : Optional[Literal["FL"]] = None) -> float:
        return self._as_quantity()

RuleContent_653_Arg: TypeAlias = Content_653_Arg
class RuleContent_653(RuleContentContextFree):
    cv_content = Content_653

    @property
    def content(self) -> Content_653:
        return self._get_content() # type: ignore

Variation_607_Arg: TypeAlias = RuleContent_653_Arg
class Variation_607(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_653

    @classmethod
    def create(cls, arg : Variation_607_Arg) -> "Variation_607":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_653:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_653:
        return self.rule.content

RuleVariation_596_Arg: TypeAlias = Variation_607_Arg
class RuleVariation_596(RuleVariationContextFree):
    cv_variation = Variation_607

    @classmethod
    def create(cls, arg : RuleVariation_596_Arg) -> "RuleVariation_596":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_607:
        return self.arg # type: ignore

NonSpare_1162_Arg: TypeAlias = RuleVariation_596_Arg
class NonSpare_1162(NonSpare):
    cv_name = "LMC"
    cv_title = "Last Measured Mode C Code"
    cv_rule = RuleVariation_596

    @classmethod
    def create(cls, arg : NonSpare_1162_Arg) -> "NonSpare_1162":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_596:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_607:
        return self.rule.variation

Item_478_Arg: TypeAlias = NonSpare_1162_Arg
class Item_478(Item):
    cv_non_spare = NonSpare_1162

    @classmethod
    def create(cls, arg : Item_478_Arg) -> "Item_478":
        return cls._create(arg) # type: ignore

Variation_1270_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_596_Arg, Tuple[Literal["LMC"], RuleVariation_596_Arg]]]
Variation_1270_Arg: TypeAlias = Union[int, Variation_1270_Arg_Group]
class Variation_1270(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1100, 1), (Item_355, 1), (Item_478, 14)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "LMC": RuleVariation_596}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LMC"]) -> RuleVariation_596:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["LMC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["LMC"]) -> RuleVariation_596:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1270_Arg) -> 'Variation_1270':
        return cls._create(arg) # type: ignore

RuleVariation_1200_Arg: TypeAlias = Variation_1270_Arg
class RuleVariation_1200(RuleVariationContextFree):
    cv_variation = Variation_1270

    @classmethod
    def create(cls, arg : RuleVariation_1200_Arg) -> "RuleVariation_1200":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1270:
        return self.arg # type: ignore

NonSpare_1245_Arg: TypeAlias = RuleVariation_1200_Arg
class NonSpare_1245(NonSpare):
    cv_name = "MDC"
    cv_title = ""
    cv_rule = RuleVariation_1200

    @classmethod
    def create(cls, arg : NonSpare_1245_Arg) -> "NonSpare_1245":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1200:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1270:
        return self.rule.variation

Content_277_Arg: TypeAlias = int
class Content_277(ContentTable):
    cv_values = {0: "Mode 3/A code as derived from the reply of the transponder", 1: "Mode 3/A code as provided by a sensor local tracker"}

RuleContent_277_Arg: TypeAlias = Content_277_Arg
class RuleContent_277(RuleContentContextFree):
    cv_content = Content_277

    @property
    def content(self) -> Content_277:
        return self._get_content() # type: ignore

Variation_542_Arg: TypeAlias = RuleContent_277_Arg
class Variation_542(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_277

    @classmethod
    def create(cls, arg : Variation_542_Arg) -> "Variation_542":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_277:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_277:
        return self.rule.content

RuleVariation_531_Arg: TypeAlias = Variation_542_Arg
class RuleVariation_531(RuleVariationContextFree):
    cv_variation = Variation_542

    @classmethod
    def create(cls, arg : RuleVariation_531_Arg) -> "RuleVariation_531":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_542:
        return self.arg # type: ignore

NonSpare_1124_Arg: TypeAlias = RuleVariation_531_Arg
class NonSpare_1124(NonSpare):
    cv_name = "L"
    cv_title = ""
    cv_rule = RuleVariation_531

    @classmethod
    def create(cls, arg : NonSpare_1124_Arg) -> "NonSpare_1124":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_531:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_542:
        return self.rule.variation

Item_442_Arg: TypeAlias = NonSpare_1124_Arg
class Item_442(Item):
    cv_non_spare = NonSpare_1124

    @classmethod
    def create(cls, arg : Item_442_Arg) -> "Item_442":
        return cls._create(arg) # type: ignore

Variation_1265_Arg_Group = Tuple[Union[RuleVariation_15_Arg, Tuple[Literal["V"], RuleVariation_15_Arg]], Union[RuleVariation_394_Arg, Tuple[Literal["G"], RuleVariation_394_Arg]], Union[RuleVariation_531_Arg, Tuple[Literal["L"], RuleVariation_531_Arg]], int, Union[RuleVariation_776_Arg, Tuple[Literal["MODE3A"], RuleVariation_776_Arg]]]
Variation_1265_Arg: TypeAlias = Union[int, Variation_1265_Arg_Group]
class Variation_1265(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1100, 1), (Item_355, 1), (Item_442, 1), (Item_16, 1), (Item_572, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_394, "L": RuleVariation_531, "MODE3A": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_531:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_531:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1265_Arg) -> 'Variation_1265':
        return cls._create(arg) # type: ignore

RuleVariation_1195_Arg: TypeAlias = Variation_1265_Arg
class RuleVariation_1195(RuleVariationContextFree):
    cv_variation = Variation_1265

    @classmethod
    def create(cls, arg : RuleVariation_1195_Arg) -> "RuleVariation_1195":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1265:
        return self.arg # type: ignore

NonSpare_1241_Arg: TypeAlias = RuleVariation_1195_Arg
class NonSpare_1241(NonSpare):
    cv_name = "MDA"
    cv_title = ""
    cv_rule = RuleVariation_1195

    @classmethod
    def create(cls, arg : NonSpare_1241_Arg) -> "NonSpare_1241":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1195:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1265:
        return self.rule.variation

Content_343_Arg: TypeAlias = int
class Content_343(ContentTable):
    cv_values = {0: "No detection", 1: "Single PSR detection", 2: "Single SSR detection", 3: "SSR + PSR detection", 4: "Single ModeS All-Call", 5: "Single ModeS Roll-Call", 6: "ModeS All-Call + PSR", 7: "ModeS Roll-Call + PSR"}

RuleContent_343_Arg: TypeAlias = Content_343_Arg
class RuleContent_343(RuleContentContextFree):
    cv_content = Content_343

    @property
    def content(self) -> Content_343:
        return self._get_content() # type: ignore

Variation_125_Arg: TypeAlias = RuleContent_343_Arg
class Variation_125(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_343

    @classmethod
    def create(cls, arg : Variation_125_Arg) -> "Variation_125":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_343:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_343:
        return self.rule.content

RuleVariation_125_Arg: TypeAlias = Variation_125_Arg
class RuleVariation_125(RuleVariationContextFree):
    cv_variation = Variation_125

    @classmethod
    def create(cls, arg : RuleVariation_125_Arg) -> "RuleVariation_125":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_125:
        return self.arg # type: ignore

NonSpare_1958_Arg: TypeAlias = RuleVariation_125_Arg
class NonSpare_1958(NonSpare):
    cv_name = "TYP"
    cv_title = "Report Type"
    cv_rule = RuleVariation_125

    @classmethod
    def create(cls, arg : NonSpare_1958_Arg) -> "NonSpare_1958":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_125:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_125:
        return self.rule.variation

Item_1077_Arg: TypeAlias = NonSpare_1958_Arg
class Item_1077(Item):
    cv_non_spare = NonSpare_1958

    @classmethod
    def create(cls, arg : Item_1077_Arg) -> "Item_1077":
        return cls._create(arg) # type: ignore

Content_441_Arg: TypeAlias = int
class Content_441(ContentTable):
    cv_values = {0: "Report from target transponder", 1: "Report from field monitor (item transponder)"}

RuleContent_441_Arg: TypeAlias = Content_441_Arg
class RuleContent_441(RuleContentContextFree):
    cv_content = Content_441

    @property
    def content(self) -> Content_441:
        return self._get_content() # type: ignore

Variation_747_Arg: TypeAlias = RuleContent_441_Arg
class Variation_747(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_441

    @classmethod
    def create(cls, arg : Variation_747_Arg) -> "Variation_747":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_441:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_441:
        return self.rule.content

RuleVariation_736_Arg: TypeAlias = Variation_747_Arg
class RuleVariation_736(RuleVariationContextFree):
    cv_variation = Variation_747

    @classmethod
    def create(cls, arg : RuleVariation_736_Arg) -> "RuleVariation_736":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_747:
        return self.arg # type: ignore

NonSpare_1528_Arg: TypeAlias = RuleVariation_736_Arg
class NonSpare_1528(NonSpare):
    cv_name = "RAB"
    cv_title = ""
    cv_rule = RuleVariation_736

    @classmethod
    def create(cls, arg : NonSpare_1528_Arg) -> "NonSpare_1528":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_736:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_747:
        return self.rule.variation

Item_764_Arg: TypeAlias = NonSpare_1528_Arg
class Item_764(Item):
    cv_non_spare = NonSpare_1528

    @classmethod
    def create(cls, arg : Item_764_Arg) -> "Item_764":
        return cls._create(arg) # type: ignore

Variation_867_Arg: TypeAlias = RuleContent_435_Arg
class Variation_867(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_435

    @classmethod
    def create(cls, arg : Variation_867_Arg) -> "Variation_867":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_435:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_435:
        return self.rule.content

RuleVariation_837_Arg: TypeAlias = Variation_867_Arg
class RuleVariation_837(RuleVariationContextFree):
    cv_variation = Variation_867

    @classmethod
    def create(cls, arg : RuleVariation_837_Arg) -> "RuleVariation_837":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_867:
        return self.arg # type: ignore

NonSpare_1928_Arg: TypeAlias = RuleVariation_837_Arg
class NonSpare_1928(NonSpare):
    cv_name = "TST"
    cv_title = ""
    cv_rule = RuleVariation_837

    @classmethod
    def create(cls, arg : NonSpare_1928_Arg) -> "NonSpare_1928":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_837:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_867:
        return self.rule.variation

Item_1051_Arg: TypeAlias = NonSpare_1928_Arg
class Item_1051(Item):
    cv_non_spare = NonSpare_1928

    @classmethod
    def create(cls, arg : Item_1051_Arg) -> "Item_1051":
        return cls._create(arg) # type: ignore

Variation_1232_Arg_Group = Tuple[Union[RuleVariation_125_Arg, Tuple[Literal["TYP"], RuleVariation_125_Arg]], Union[RuleVariation_601_Arg, Tuple[Literal["SIM"], RuleVariation_601_Arg]], Union[RuleVariation_736_Arg, Tuple[Literal["RAB"], RuleVariation_736_Arg]], Union[RuleVariation_837_Arg, Tuple[Literal["TST"], RuleVariation_837_Arg]], int]
Variation_1232_Arg: TypeAlias = Union[int, Variation_1232_Arg_Group]
class Variation_1232(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1077, 3), (Item_898, 1), (Item_764, 1), (Item_1051, 1), (Item_27, 2)]
    cv_items_dict = {"TYP": RuleVariation_125, "SIM": RuleVariation_601, "RAB": RuleVariation_736, "TST": RuleVariation_837}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_125:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIM"]) -> RuleVariation_601:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAB"]) -> RuleVariation_736:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TST"]) -> RuleVariation_837:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["SIM"], Literal["RAB"], Literal["TST"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_125:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> RuleVariation_601:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_736:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> RuleVariation_837:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1232_Arg) -> 'Variation_1232':
        return cls._create(arg) # type: ignore

RuleVariation_1169_Arg: TypeAlias = Variation_1232_Arg
class RuleVariation_1169(RuleVariationContextFree):
    cv_variation = Variation_1232

    @classmethod
    def create(cls, arg : RuleVariation_1169_Arg) -> "RuleVariation_1169":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1232:
        return self.arg # type: ignore

NonSpare_1955_Arg: TypeAlias = RuleVariation_1169_Arg
class NonSpare_1955(NonSpare):
    cv_name = "TYP"
    cv_title = ""
    cv_rule = RuleVariation_1169

    @classmethod
    def create(cls, arg : NonSpare_1955_Arg) -> "NonSpare_1955":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1169:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1232:
        return self.rule.variation

Variation_1497_Arg = TypedDict('Variation_1497_Arg', {
    "SID": NonSpare_1703_Arg,
    "POS": NonSpare_1434_Arg,
    "HEIGHT": NonSpare_1056_Arg,
    "MDC": NonSpare_1245_Arg,
    "MDA": NonSpare_1241_Arg,
    "TYP": NonSpare_1955_Arg,
}, total=False)
class Variation_1497(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1703, NonSpare_1434, NonSpare_1056, NonSpare_1245, NonSpare_1241, NonSpare_1955]
    cv_items_dict = {"SID": NonSpare_1703, "POS": NonSpare_1434, "HEIGHT": NonSpare_1056, "MDC": NonSpare_1245, "MDA": NonSpare_1241, "TYP": NonSpare_1955}

    @overload
    @classmethod
    def spec(cls, key : Literal["SID"]) -> NonSpare_1703:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1434:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HEIGHT"]) -> NonSpare_1056:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDC"]) -> NonSpare_1245:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDA"]) -> NonSpare_1241:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> NonSpare_1955:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SID"], Literal["POS"], Literal["HEIGHT"], Literal["MDC"], Literal["MDA"], Literal["TYP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SID"]) -> Optional[NonSpare_1703]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1434]:
        ...
    @overload
    def get_item(self, key : Literal["HEIGHT"]) -> Optional[NonSpare_1056]:
        ...
    @overload
    def get_item(self, key : Literal["MDC"]) -> Optional[NonSpare_1245]:
        ...
    @overload
    def get_item(self, key : Literal["MDA"]) -> Optional[NonSpare_1241]:
        ...
    @overload
    def get_item(self, key : Literal["TYP"]) -> Optional[NonSpare_1955]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["SID"], val : NonSpare_1703_Arg) -> "Variation_1497":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1434_Arg) -> "Variation_1497":
        ...
    @overload
    def set_item(self, key : Literal["HEIGHT"], val : NonSpare_1056_Arg) -> "Variation_1497":
        ...
    @overload
    def set_item(self, key : Literal["MDC"], val : NonSpare_1245_Arg) -> "Variation_1497":
        ...
    @overload
    def set_item(self, key : Literal["MDA"], val : NonSpare_1241_Arg) -> "Variation_1497":
        ...
    @overload
    def set_item(self, key : Literal["TYP"], val : NonSpare_1955_Arg) -> "Variation_1497":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["SID"]) -> "Variation_1497":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1497":
        ...
    @overload
    def del_item(self, key : Literal["HEIGHT"]) -> "Variation_1497":
        ...
    @overload
    def del_item(self, key : Literal["MDC"]) -> "Variation_1497":
        ...
    @overload
    def del_item(self, key : Literal["MDA"]) -> "Variation_1497":
        ...
    @overload
    def del_item(self, key : Literal["TYP"]) -> "Variation_1497":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1497_Arg) -> 'Variation_1497':
        return cls._create(arg) # type: ignore

RuleVariation_1420_Arg: TypeAlias = Variation_1497_Arg
class RuleVariation_1420(RuleVariationContextFree):
    cv_variation = Variation_1497

    @classmethod
    def create(cls, arg : RuleVariation_1420_Arg) -> "RuleVariation_1420":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1497:
        return self.arg # type: ignore

NonSpare_477_Arg: TypeAlias = RuleVariation_1420_Arg
class NonSpare_477(NonSpare):
    cv_name = "340"
    cv_title = "Measured Information"
    cv_rule = RuleVariation_1420

    @classmethod
    def create(cls, arg : NonSpare_477_Arg) -> "NonSpare_477":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1420:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1497:
        return self.rule.variation

class UapItem_477(UapItem):
    cv_non_spare = NonSpare_477

Record_41_Arg = TypedDict('Record_41_Arg', {
    "010": NonSpare_45_Arg,
    "015": NonSpare_58_Arg,
    "070": NonSpare_213_Arg,
    "105": NonSpare_277_Arg,
    "100": NonSpare_264_Arg,
    "185": NonSpare_381_Arg,
    "210": NonSpare_405_Arg,
    "060": NonSpare_198_Arg,
    "245": NonSpare_435_Arg,
    "380": NonSpare_480_Arg,
    "040": NonSpare_147_Arg,
    "080": NonSpare_235_Arg,
    "290": NonSpare_465_Arg,
    "200": NonSpare_389_Arg,
    "295": NonSpare_468_Arg,
    "136": NonSpare_315_Arg,
    "130": NonSpare_301_Arg,
    "135": NonSpare_314_Arg,
    "220": NonSpare_417_Arg,
    "390": NonSpare_488_Arg,
    "270": NonSpare_457_Arg,
    "300": NonSpare_472_Arg,
    "110": NonSpare_285_Arg,
    "120": NonSpare_300_Arg,
    "510": NonSpare_515_Arg,
    "500": NonSpare_510_Arg,
    "340": NonSpare_477_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_41(Record):
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_45, UapItem_544, UapItem_58, UapItem_213, UapItem_277, UapItem_264, UapItem_381, UapItem_405, UapItem_198, UapItem_435, UapItem_480, UapItem_147, UapItem_235, UapItem_465, UapItem_389, UapItem_468, UapItem_315, UapItem_301, UapItem_314, UapItem_417, UapItem_488, UapItem_457, UapItem_472, UapItem_285, UapItem_300, UapItem_514, UapItem_509, UapItem_477, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_45, "015": NonSpare_58, "070": NonSpare_213, "105": NonSpare_277, "100": NonSpare_264, "185": NonSpare_381, "210": NonSpare_405, "060": NonSpare_198, "245": NonSpare_435, "380": NonSpare_480, "040": NonSpare_147, "080": NonSpare_235, "290": NonSpare_465, "200": NonSpare_389, "295": NonSpare_468, "136": NonSpare_315, "130": NonSpare_301, "135": NonSpare_314, "220": NonSpare_417, "390": NonSpare_488, "270": NonSpare_457, "300": NonSpare_472, "110": NonSpare_285, "120": NonSpare_300, "510": NonSpare_515, "500": NonSpare_510, "340": NonSpare_477, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_45:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_58:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_213:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["105"]) -> NonSpare_277:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_264:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["185"]) -> NonSpare_381:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_405:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_198:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_435:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["380"]) -> NonSpare_480:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_147:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_235:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["290"]) -> NonSpare_465:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_389:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_468:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["136"]) -> NonSpare_315:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_301:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["135"]) -> NonSpare_314:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_417:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["390"]) -> NonSpare_488:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["270"]) -> NonSpare_457:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_472:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_285:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_300:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["510"]) -> NonSpare_515:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_510:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["340"]) -> NonSpare_477:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["070"], Literal["105"], Literal["100"], Literal["185"], Literal["210"], Literal["060"], Literal["245"], Literal["380"], Literal["040"], Literal["080"], Literal["290"], Literal["200"], Literal["295"], Literal["136"], Literal["130"], Literal["135"], Literal["220"], Literal["390"], Literal["270"], Literal["300"], Literal["110"], Literal["120"], Literal["510"], Literal["500"], Literal["340"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_45]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_58]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_213]:
        ...
    @overload
    def get_item(self, key : Literal["105"]) -> Optional[NonSpare_277]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_264]:
        ...
    @overload
    def get_item(self, key : Literal["185"]) -> Optional[NonSpare_381]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_405]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_198]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_435]:
        ...
    @overload
    def get_item(self, key : Literal["380"]) -> Optional[NonSpare_480]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_147]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_235]:
        ...
    @overload
    def get_item(self, key : Literal["290"]) -> Optional[NonSpare_465]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_389]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_468]:
        ...
    @overload
    def get_item(self, key : Literal["136"]) -> Optional[NonSpare_315]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_301]:
        ...
    @overload
    def get_item(self, key : Literal["135"]) -> Optional[NonSpare_314]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_417]:
        ...
    @overload
    def get_item(self, key : Literal["390"]) -> Optional[NonSpare_488]:
        ...
    @overload
    def get_item(self, key : Literal["270"]) -> Optional[NonSpare_457]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_472]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_285]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_300]:
        ...
    @overload
    def get_item(self, key : Literal["510"]) -> Optional[NonSpare_515]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_510]:
        ...
    @overload
    def get_item(self, key : Literal["340"]) -> Optional[NonSpare_477]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_45_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_58_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_213_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["105"], val : NonSpare_277_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_264_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["185"], val : NonSpare_381_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_405_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_198_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_435_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["380"], val : NonSpare_480_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_147_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_235_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["290"], val : NonSpare_465_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_389_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_468_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["136"], val : NonSpare_315_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_301_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["135"], val : NonSpare_314_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_417_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["390"], val : NonSpare_488_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["270"], val : NonSpare_457_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_472_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_285_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_300_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["510"], val : NonSpare_515_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_510_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["340"], val : NonSpare_477_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_41':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["105"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["185"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["380"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["290"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["136"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["135"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["390"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["270"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["510"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["340"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_41':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_41_Arg) -> 'Record_41':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_41", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_37_Arg: TypeAlias = Record_41
class Uap_37(UapSingle):
    cv_record = Record_41

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_41]]:
        return cls._parse(bs)

class Asterix_51(AstCat):
    cv_category = 62
    cv_edition = (1, 17)
    cv_uap = Uap_37

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_37_Arg]) -> "Asterix_51":
        return cls._create(records) # type: ignore

Content_321_Arg: TypeAlias = int
class Content_321(ContentTable):
    cv_values = {0: "No alert, no SPI, aircraft airborne", 1: "No alert, no SPI, aircraft on ground", 2: "Alert, no SPI, aircraft airborne", 3: "Alert, no SPI, aircraft on ground", 4: "Alert, SPI, aircraft airborne or on ground", 5: "No alert, SPI, aircraft airborne or on ground", 6: "Not defined", 7: "Unknown or not yet extracted"}

RuleContent_321_Arg: TypeAlias = Content_321_Arg
class RuleContent_321(RuleContentContextFree):
    cv_content = Content_321

    @property
    def content(self) -> Content_321:
        return self._get_content() # type: ignore

Variation_683_Arg: TypeAlias = RuleContent_321_Arg
class Variation_683(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 3
    cv_rule = RuleContent_321

    @classmethod
    def create(cls, arg : Variation_683_Arg) -> "Variation_683":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_321:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_321:
        return self.rule.content

RuleVariation_672_Arg: TypeAlias = Variation_683_Arg
class RuleVariation_672(RuleVariationContextFree):
    cv_variation = Variation_683

    @classmethod
    def create(cls, arg : RuleVariation_672_Arg) -> "RuleVariation_672":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_683:
        return self.arg # type: ignore

NonSpare_1768_Arg: TypeAlias = RuleVariation_672_Arg
class NonSpare_1768(NonSpare):
    cv_name = "STAT"
    cv_title = "Flight Status"
    cv_rule = RuleVariation_672

    @classmethod
    def create(cls, arg : NonSpare_1768_Arg) -> "NonSpare_1768":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_672:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_683:
        return self.rule.variation

Item_935_Arg: TypeAlias = NonSpare_1768_Arg
class Item_935(Item):
    cv_non_spare = NonSpare_1768

    @classmethod
    def create(cls, arg : Item_935_Arg) -> "Item_935":
        return cls._create(arg) # type: ignore

Variation_1074_Arg_Group = Tuple[Union[RuleVariation_123_Arg, Tuple[Literal["COM"], RuleVariation_123_Arg]], Union[RuleVariation_672_Arg, Tuple[Literal["STAT"], RuleVariation_672_Arg]], int, Union[RuleVariation_55_Arg, Tuple[Literal["SSC"], RuleVariation_55_Arg]], Union[RuleVariation_388_Arg, Tuple[Literal["ARC"], RuleVariation_388_Arg]], Union[RuleVariation_544_Arg, Tuple[Literal["AIC"], RuleVariation_544_Arg]], Union[RuleVariation_600_Arg, Tuple[Literal["B1A"], RuleVariation_600_Arg]], Union[RuleVariation_766_Arg, Tuple[Literal["B1B"], RuleVariation_766_Arg]]]
Variation_1074_Arg: TypeAlias = Union[int, Variation_1074_Arg_Group]
class Variation_1074(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_187, 3), (Item_935, 3), (Item_27, 2), (Item_923, 1), (Item_81, 1), (Item_55, 1), (Item_108, 1), (Item_111, 4)]
    cv_items_dict = {"COM": RuleVariation_123, "STAT": RuleVariation_672, "SSC": RuleVariation_55, "ARC": RuleVariation_388, "AIC": RuleVariation_544, "B1A": RuleVariation_600, "B1B": RuleVariation_766}

    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> RuleVariation_123:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_672:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSC"]) -> RuleVariation_55:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> RuleVariation_388:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AIC"]) -> RuleVariation_544:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1A"]) -> RuleVariation_600:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1B"]) -> RuleVariation_766:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COM"], Literal["STAT"], Literal["SSC"], Literal["ARC"], Literal["AIC"], Literal["B1A"], Literal["B1B"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COM"]) -> RuleVariation_123:
        ...
    @overload
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_672:
        ...
    @overload
    def get_item(self, key : Literal["SSC"]) -> RuleVariation_55:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_388:
        ...
    @overload
    def get_item(self, key : Literal["AIC"]) -> RuleVariation_544:
        ...
    @overload
    def get_item(self, key : Literal["B1A"]) -> RuleVariation_600:
        ...
    @overload
    def get_item(self, key : Literal["B1B"]) -> RuleVariation_766:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1074_Arg) -> 'Variation_1074':
        return cls._create(arg) # type: ignore

RuleVariation_1034_Arg: TypeAlias = Variation_1074_Arg
class RuleVariation_1034(RuleVariationContextFree):
    cv_variation = Variation_1074

    @classmethod
    def create(cls, arg : RuleVariation_1034_Arg) -> "RuleVariation_1034":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1074:
        return self.arg # type: ignore

NonSpare_781_Arg: TypeAlias = RuleVariation_1034_Arg
class NonSpare_781(NonSpare):
    cv_name = "COM"
    cv_title = "Communications/ACAS Capability and Flight Status"
    cv_rule = RuleVariation_1034

    @classmethod
    def create(cls, arg : NonSpare_781_Arg) -> "NonSpare_781":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1034:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1074:
        return self.rule.variation

Variation_1459_Arg = TypedDict('Variation_1459_Arg', {
    "ADR": NonSpare_567_Arg,
    "ID": NonSpare_1103_Arg,
    "MHG": NonSpare_1270_Arg,
    "IAS": NonSpare_1096_Arg,
    "TAS": NonSpare_1823_Arg,
    "SAL": NonSpare_1648_Arg,
    "FSS": NonSpare_994_Arg,
    "TIS": NonSpare_1864_Arg,
    "TID": NonSpare_1859_Arg,
    "COM": NonSpare_781_Arg,
    "SAB": NonSpare_1642_Arg,
    "ACS": NonSpare_559_Arg,
    "BVR": NonSpare_690_Arg,
    "GVR": NonSpare_1041_Arg,
    "RAN": NonSpare_1538_Arg,
    "TAR": NonSpare_1818_Arg,
    "TAN": NonSpare_1813_Arg,
    "GS": NonSpare_1030_Arg,
    "VUN": NonSpare_2035_Arg,
    "MET": NonSpare_1262_Arg,
    "EMC": NonSpare_921_Arg,
    "POS": NonSpare_1439_Arg,
    "GAL": NonSpare_1011_Arg,
    "PUN": NonSpare_1475_Arg,
    "MB": NonSpare_1222_Arg,
    "IAR": NonSpare_1092_Arg,
    "MAC": NonSpare_1212_Arg,
    "BPS": NonSpare_688_Arg,
}, total=False)
class Variation_1459(Compound):
    cv_fspec_max_bytes = 4
    cv_items_list = [NonSpare_567, NonSpare_1103, NonSpare_1270, NonSpare_1096, NonSpare_1823, NonSpare_1648, NonSpare_994, NonSpare_1864, NonSpare_1859, NonSpare_781, NonSpare_1642, NonSpare_559, NonSpare_690, NonSpare_1041, NonSpare_1538, NonSpare_1818, NonSpare_1813, NonSpare_1030, NonSpare_2035, NonSpare_1262, NonSpare_921, NonSpare_1439, NonSpare_1011, NonSpare_1475, NonSpare_1222, NonSpare_1092, NonSpare_1212, NonSpare_688]
    cv_items_dict = {"ADR": NonSpare_567, "ID": NonSpare_1103, "MHG": NonSpare_1270, "IAS": NonSpare_1096, "TAS": NonSpare_1823, "SAL": NonSpare_1648, "FSS": NonSpare_994, "TIS": NonSpare_1864, "TID": NonSpare_1859, "COM": NonSpare_781, "SAB": NonSpare_1642, "ACS": NonSpare_559, "BVR": NonSpare_690, "GVR": NonSpare_1041, "RAN": NonSpare_1538, "TAR": NonSpare_1818, "TAN": NonSpare_1813, "GS": NonSpare_1030, "VUN": NonSpare_2035, "MET": NonSpare_1262, "EMC": NonSpare_921, "POS": NonSpare_1439, "GAL": NonSpare_1011, "PUN": NonSpare_1475, "MB": NonSpare_1222, "IAR": NonSpare_1092, "MAC": NonSpare_1212, "BPS": NonSpare_688}

    @overload
    @classmethod
    def spec(cls, key : Literal["ADR"]) -> NonSpare_567:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ID"]) -> NonSpare_1103:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MHG"]) -> NonSpare_1270:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAS"]) -> NonSpare_1096:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAS"]) -> NonSpare_1823:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAL"]) -> NonSpare_1648:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FSS"]) -> NonSpare_994:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TIS"]) -> NonSpare_1864:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> NonSpare_1859:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> NonSpare_781:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAB"]) -> NonSpare_1642:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ACS"]) -> NonSpare_559:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BVR"]) -> NonSpare_690:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GVR"]) -> NonSpare_1041:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAN"]) -> NonSpare_1538:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAR"]) -> NonSpare_1818:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAN"]) -> NonSpare_1813:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GS"]) -> NonSpare_1030:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VUN"]) -> NonSpare_2035:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MET"]) -> NonSpare_1262:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EMC"]) -> NonSpare_921:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1439:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GAL"]) -> NonSpare_1011:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PUN"]) -> NonSpare_1475:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MB"]) -> NonSpare_1222:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAR"]) -> NonSpare_1092:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MAC"]) -> NonSpare_1212:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BPS"]) -> NonSpare_688:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ADR"], Literal["ID"], Literal["MHG"], Literal["IAS"], Literal["TAS"], Literal["SAL"], Literal["FSS"], Literal["TIS"], Literal["TID"], Literal["COM"], Literal["SAB"], Literal["ACS"], Literal["BVR"], Literal["GVR"], Literal["RAN"], Literal["TAR"], Literal["TAN"], Literal["GS"], Literal["VUN"], Literal["MET"], Literal["EMC"], Literal["POS"], Literal["GAL"], Literal["PUN"], Literal["MB"], Literal["IAR"], Literal["MAC"], Literal["BPS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ADR"]) -> Optional[NonSpare_567]:
        ...
    @overload
    def get_item(self, key : Literal["ID"]) -> Optional[NonSpare_1103]:
        ...
    @overload
    def get_item(self, key : Literal["MHG"]) -> Optional[NonSpare_1270]:
        ...
    @overload
    def get_item(self, key : Literal["IAS"]) -> Optional[NonSpare_1096]:
        ...
    @overload
    def get_item(self, key : Literal["TAS"]) -> Optional[NonSpare_1823]:
        ...
    @overload
    def get_item(self, key : Literal["SAL"]) -> Optional[NonSpare_1648]:
        ...
    @overload
    def get_item(self, key : Literal["FSS"]) -> Optional[NonSpare_994]:
        ...
    @overload
    def get_item(self, key : Literal["TIS"]) -> Optional[NonSpare_1864]:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> Optional[NonSpare_1859]:
        ...
    @overload
    def get_item(self, key : Literal["COM"]) -> Optional[NonSpare_781]:
        ...
    @overload
    def get_item(self, key : Literal["SAB"]) -> Optional[NonSpare_1642]:
        ...
    @overload
    def get_item(self, key : Literal["ACS"]) -> Optional[NonSpare_559]:
        ...
    @overload
    def get_item(self, key : Literal["BVR"]) -> Optional[NonSpare_690]:
        ...
    @overload
    def get_item(self, key : Literal["GVR"]) -> Optional[NonSpare_1041]:
        ...
    @overload
    def get_item(self, key : Literal["RAN"]) -> Optional[NonSpare_1538]:
        ...
    @overload
    def get_item(self, key : Literal["TAR"]) -> Optional[NonSpare_1818]:
        ...
    @overload
    def get_item(self, key : Literal["TAN"]) -> Optional[NonSpare_1813]:
        ...
    @overload
    def get_item(self, key : Literal["GS"]) -> Optional[NonSpare_1030]:
        ...
    @overload
    def get_item(self, key : Literal["VUN"]) -> Optional[NonSpare_2035]:
        ...
    @overload
    def get_item(self, key : Literal["MET"]) -> Optional[NonSpare_1262]:
        ...
    @overload
    def get_item(self, key : Literal["EMC"]) -> Optional[NonSpare_921]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1439]:
        ...
    @overload
    def get_item(self, key : Literal["GAL"]) -> Optional[NonSpare_1011]:
        ...
    @overload
    def get_item(self, key : Literal["PUN"]) -> Optional[NonSpare_1475]:
        ...
    @overload
    def get_item(self, key : Literal["MB"]) -> Optional[NonSpare_1222]:
        ...
    @overload
    def get_item(self, key : Literal["IAR"]) -> Optional[NonSpare_1092]:
        ...
    @overload
    def get_item(self, key : Literal["MAC"]) -> Optional[NonSpare_1212]:
        ...
    @overload
    def get_item(self, key : Literal["BPS"]) -> Optional[NonSpare_688]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["ADR"], val : NonSpare_567_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["ID"], val : NonSpare_1103_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["MHG"], val : NonSpare_1270_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["IAS"], val : NonSpare_1096_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["TAS"], val : NonSpare_1823_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["SAL"], val : NonSpare_1648_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["FSS"], val : NonSpare_994_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["TIS"], val : NonSpare_1864_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["TID"], val : NonSpare_1859_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["COM"], val : NonSpare_781_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["SAB"], val : NonSpare_1642_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["ACS"], val : NonSpare_559_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["BVR"], val : NonSpare_690_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["GVR"], val : NonSpare_1041_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["RAN"], val : NonSpare_1538_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["TAR"], val : NonSpare_1818_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["TAN"], val : NonSpare_1813_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["GS"], val : NonSpare_1030_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["VUN"], val : NonSpare_2035_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["MET"], val : NonSpare_1262_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["EMC"], val : NonSpare_921_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1439_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["GAL"], val : NonSpare_1011_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["PUN"], val : NonSpare_1475_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["MB"], val : NonSpare_1222_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["IAR"], val : NonSpare_1092_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["MAC"], val : NonSpare_1212_Arg) -> "Variation_1459":
        ...
    @overload
    def set_item(self, key : Literal["BPS"], val : NonSpare_688_Arg) -> "Variation_1459":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["ADR"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["ID"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["MHG"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["IAS"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["TAS"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["SAL"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["FSS"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["TIS"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["TID"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["COM"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["SAB"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["ACS"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["BVR"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["GVR"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["RAN"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["TAR"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["TAN"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["GS"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["VUN"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["MET"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["EMC"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["GAL"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["PUN"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["MB"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["IAR"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["MAC"]) -> "Variation_1459":
        ...
    @overload
    def del_item(self, key : Literal["BPS"]) -> "Variation_1459":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1459_Arg) -> 'Variation_1459':
        return cls._create(arg) # type: ignore

RuleVariation_1382_Arg: TypeAlias = Variation_1459_Arg
class RuleVariation_1382(RuleVariationContextFree):
    cv_variation = Variation_1459

    @classmethod
    def create(cls, arg : RuleVariation_1382_Arg) -> "RuleVariation_1382":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1459:
        return self.arg # type: ignore

NonSpare_483_Arg: TypeAlias = RuleVariation_1382_Arg
class NonSpare_483(NonSpare):
    cv_name = "380"
    cv_title = "Aircraft Derived Data"
    cv_rule = RuleVariation_1382

    @classmethod
    def create(cls, arg : NonSpare_483_Arg) -> "NonSpare_483":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1382:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1459:
        return self.rule.variation

class UapItem_483(UapItem):
    cv_non_spare = NonSpare_483

Content_192_Arg: TypeAlias = int
class Content_192(ContentTable):
    cv_values = {0: "Default value", 1: "Surface target"}

RuleContent_192_Arg: TypeAlias = Content_192_Arg
class RuleContent_192(RuleContentContextFree):
    cv_content = Content_192

    @property
    def content(self) -> Content_192:
        return self._get_content() # type: ignore

Variation_634_Arg: TypeAlias = RuleContent_192_Arg
class Variation_634(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_192

    @classmethod
    def create(cls, arg : Variation_634_Arg) -> "Variation_634":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_192:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_192:
        return self.rule.content

RuleVariation_623_Arg: TypeAlias = Variation_634_Arg
class RuleVariation_623(RuleVariationContextFree):
    cv_variation = Variation_634

    @classmethod
    def create(cls, arg : RuleVariation_623_Arg) -> "RuleVariation_623":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_634:
        return self.arg # type: ignore

Content_361_Arg: TypeAlias = int
class Content_361(ContentTable):
    cv_values = {0: "No indication", 1: "Duplicate Flight-ID"}

RuleContent_361_Arg: TypeAlias = Content_361_Arg
class RuleContent_361(RuleContentContextFree):
    cv_content = Content_361

    @property
    def content(self) -> Content_361:
        return self._get_content() # type: ignore

Variation_737_Arg: TypeAlias = RuleContent_361_Arg
class Variation_737(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_361

    @classmethod
    def create(cls, arg : Variation_737_Arg) -> "Variation_737":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_361:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_361:
        return self.rule.content

RuleVariation_726_Arg: TypeAlias = Variation_737_Arg
class RuleVariation_726(RuleVariationContextFree):
    cv_variation = Variation_737

    @classmethod
    def create(cls, arg : RuleVariation_726_Arg) -> "RuleVariation_726":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_737:
        return self.arg # type: ignore

Content_185_Arg: TypeAlias = int
class Content_185(ContentTable):
    cv_values = {0: "Default value", 1: "Inconsistent Emergency Code"}

RuleContent_185_Arg: TypeAlias = Content_185_Arg
class RuleContent_185(RuleContentContextFree):
    cv_content = Content_185

    @property
    def content(self) -> Content_185:
        return self._get_content() # type: ignore

Variation_841_Arg: TypeAlias = RuleContent_185_Arg
class Variation_841(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_185

    @classmethod
    def create(cls, arg : Variation_841_Arg) -> "Variation_841":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_185:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_185:
        return self.rule.content

RuleVariation_811_Arg: TypeAlias = Variation_841_Arg
class RuleVariation_811(RuleVariationContextFree):
    cv_variation = Variation_841

    @classmethod
    def create(cls, arg : RuleVariation_811_Arg) -> "RuleVariation_811":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_841:
        return self.arg # type: ignore

NonSpare_1693_Arg: TypeAlias = RuleVariation_623_Arg
class NonSpare_1693(NonSpare):
    cv_name = "SFC"
    cv_title = ""
    cv_rule = RuleVariation_623

    @classmethod
    def create(cls, arg : NonSpare_1693_Arg) -> "NonSpare_1693":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_623:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_634:
        return self.rule.variation

Item_878_Arg: TypeAlias = NonSpare_1693_Arg
class Item_878(Item):
    cv_non_spare = NonSpare_1693

    @classmethod
    def create(cls, arg : Item_878_Arg) -> "Item_878":
        return cls._create(arg) # type: ignore

NonSpare_1104_Arg: TypeAlias = RuleVariation_726_Arg
class NonSpare_1104(NonSpare):
    cv_name = "IDD"
    cv_title = ""
    cv_rule = RuleVariation_726

    @classmethod
    def create(cls, arg : NonSpare_1104_Arg) -> "NonSpare_1104":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_726:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_737:
        return self.rule.variation

Item_427_Arg: TypeAlias = NonSpare_1104_Arg
class Item_427(Item):
    cv_non_spare = NonSpare_1104

    @classmethod
    def create(cls, arg : Item_427_Arg) -> "Item_427":
        return cls._create(arg) # type: ignore

NonSpare_1107_Arg: TypeAlias = RuleVariation_811_Arg
class NonSpare_1107(NonSpare):
    cv_name = "IEC"
    cv_title = ""
    cv_rule = RuleVariation_811

    @classmethod
    def create(cls, arg : NonSpare_1107_Arg) -> "NonSpare_1107":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_811:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_841:
        return self.rule.variation

Item_430_Arg: TypeAlias = NonSpare_1107_Arg
class Item_430(Item):
    cv_non_spare = NonSpare_1107

    @classmethod
    def create(cls, arg : Item_430_Arg) -> "Item_430":
        return cls._create(arg) # type: ignore

Variation_1362_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_54_Arg, Tuple[Literal["MON"], RuleVariation_54_Arg]], Union[RuleVariation_410_Arg, Tuple[Literal["SPI"], RuleVariation_410_Arg]], Union[RuleVariation_497_Arg, Tuple[Literal["MRH"], RuleVariation_497_Arg]], Union[RuleVariation_675_Arg, Tuple[Literal["SRC"], RuleVariation_675_Arg]], Union[RuleVariation_874_Arg, Tuple[Literal["CNF"], RuleVariation_874_Arg]], None]]
Variation_1362_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_6_Arg, Tuple[Literal["SIM"], RuleVariation_6_Arg]], Union[RuleVariation_409_Arg, Tuple[Literal["TSE"], RuleVariation_409_Arg]], Union[RuleVariation_517_Arg, Tuple[Literal["TSB"], RuleVariation_517_Arg]], Union[RuleVariation_644_Arg, Tuple[Literal["FPC"], RuleVariation_644_Arg]], Union[RuleVariation_702_Arg, Tuple[Literal["AFF"], RuleVariation_702_Arg]], Union[RuleVariation_813_Arg, Tuple[Literal["STP"], RuleVariation_813_Arg]], Union[RuleVariation_872_Arg, Tuple[Literal["KOS"], RuleVariation_872_Arg]], None]]
Variation_1362_Arg_Group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_89_Arg, Tuple[Literal["AMA"], RuleVariation_89_Arg]], Union[RuleVariation_456_Arg, Tuple[Literal["MD4"], RuleVariation_456_Arg]], Union[RuleVariation_622_Arg, Tuple[Literal["ME"], RuleVariation_622_Arg]], Union[RuleVariation_705_Arg, Tuple[Literal["MI"], RuleVariation_705_Arg]], Union[RuleVariation_849_Arg, Tuple[Literal["MD5"], RuleVariation_849_Arg]], None]]
Variation_1362_Arg_Group_4: TypeAlias = Union[int, Tuple[Union[RuleVariation_37_Arg, Tuple[Literal["CST"], RuleVariation_37_Arg]], Union[RuleVariation_407_Arg, Tuple[Literal["PSR"], RuleVariation_407_Arg]], Union[RuleVariation_514_Arg, Tuple[Literal["SSR"], RuleVariation_514_Arg]], Union[RuleVariation_621_Arg, Tuple[Literal["MDS"], RuleVariation_621_Arg]], Union[RuleVariation_704_Arg, Tuple[Literal["ADS"], RuleVariation_704_Arg]], Union[RuleVariation_814_Arg, Tuple[Literal["SUC"], RuleVariation_814_Arg]], Union[RuleVariation_890_Arg, Tuple[Literal["AAC"], RuleVariation_890_Arg]], None]]
Variation_1362_Arg_Group_5: TypeAlias = Union[int, Tuple[Union[RuleVariation_99_Arg, Tuple[Literal["SDS"], RuleVariation_99_Arg]], Union[RuleVariation_587_Arg, Tuple[Literal["EMS"], RuleVariation_587_Arg]], Union[RuleVariation_830_Arg, Tuple[Literal["PFT"], RuleVariation_830_Arg]], Union[RuleVariation_892_Arg, Tuple[Literal["FPLT"], RuleVariation_892_Arg]], None]]
Variation_1362_Arg_Group_6: TypeAlias = Union[int, Tuple[Union[RuleVariation_38_Arg, Tuple[Literal["DUPT"], RuleVariation_38_Arg]], Union[RuleVariation_408_Arg, Tuple[Literal["DUPF"], RuleVariation_408_Arg]], Union[RuleVariation_516_Arg, Tuple[Literal["DUPM"], RuleVariation_516_Arg]], Union[RuleVariation_623_Arg, Tuple[Literal["SFC"], RuleVariation_623_Arg]], Union[RuleVariation_726_Arg, Tuple[Literal["IDD"], RuleVariation_726_Arg]], Union[RuleVariation_811_Arg, Tuple[Literal["IEC"], RuleVariation_811_Arg]], int, None]]
Variation_1362_Arg: TypeAlias = Union[
    Tuple[Variation_1362_Arg_Group_1],
    Tuple[Variation_1362_Arg_Group_1, Variation_1362_Arg_Group_2],
    Tuple[Variation_1362_Arg_Group_1, Variation_1362_Arg_Group_2, Variation_1362_Arg_Group_3],
    Tuple[Variation_1362_Arg_Group_1, Variation_1362_Arg_Group_2, Variation_1362_Arg_Group_3, Variation_1362_Arg_Group_4],
    Tuple[Variation_1362_Arg_Group_1, Variation_1362_Arg_Group_2, Variation_1362_Arg_Group_3, Variation_1362_Arg_Group_4, Variation_1362_Arg_Group_5],
    Tuple[Variation_1362_Arg_Group_1, Variation_1362_Arg_Group_2, Variation_1362_Arg_Group_3, Variation_1362_Arg_Group_4, Variation_1362_Arg_Group_5, Variation_1362_Arg_Group_6],
]
class Variation_1362(Extended):
    cv_items_list = [[(Item_576, 1), (Item_908, 1), (Item_579, 1), (Item_920, 3), (Item_166, 1), None], [(Item_896, 1), (Item_1043, 1), (Item_1041, 1), (Item_336, 1), (Item_50, 1), (Item_953, 1), (Item_439, 1), None], [(Item_71, 1), (Item_533, 2), (Item_540, 1), (Item_547, 1), (Item_534, 2), None], [(Item_219, 1), (Item_709, 1), (Item_925, 1), (Item_535, 1), (Item_46, 1), (Item_960, 1), (Item_34, 1), None], [(Item_871, 2), (Item_292, 3), (Item_677, 1), (Item_337, 1), None], [(Item_281, 1), (Item_279, 1), (Item_280, 1), (Item_878, 1), (Item_427, 1), (Item_430, 1), (Item_26, 1), None]]

    @classmethod
    def create(cls, arg : Variation_1362_Arg) -> 'Variation_1362':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MON"]) -> RuleVariation_54:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> RuleVariation_410:
        ...
    @overload
    def get_item(self, key : Literal["MRH"]) -> RuleVariation_497:
        ...
    @overload
    def get_item(self, key : Literal["SRC"]) -> RuleVariation_675:
        ...
    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_874:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_6]:
        ...
    @overload
    def get_item(self, key : Literal["TSE"]) -> Optional[RuleVariation_409]:
        ...
    @overload
    def get_item(self, key : Literal["TSB"]) -> Optional[RuleVariation_517]:
        ...
    @overload
    def get_item(self, key : Literal["FPC"]) -> Optional[RuleVariation_644]:
        ...
    @overload
    def get_item(self, key : Literal["AFF"]) -> Optional[RuleVariation_702]:
        ...
    @overload
    def get_item(self, key : Literal["STP"]) -> Optional[RuleVariation_813]:
        ...
    @overload
    def get_item(self, key : Literal["KOS"]) -> Optional[RuleVariation_872]:
        ...
    @overload
    def get_item(self, key : Literal["AMA"]) -> Optional[RuleVariation_89]:
        ...
    @overload
    def get_item(self, key : Literal["MD4"]) -> Optional[RuleVariation_456]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_622]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_705]:
        ...
    @overload
    def get_item(self, key : Literal["MD5"]) -> Optional[RuleVariation_849]:
        ...
    @overload
    def get_item(self, key : Literal["CST"]) -> Optional[RuleVariation_37]:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[RuleVariation_407]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[RuleVariation_514]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[RuleVariation_621]:
        ...
    @overload
    def get_item(self, key : Literal["ADS"]) -> Optional[RuleVariation_704]:
        ...
    @overload
    def get_item(self, key : Literal["SUC"]) -> Optional[RuleVariation_814]:
        ...
    @overload
    def get_item(self, key : Literal["AAC"]) -> Optional[RuleVariation_890]:
        ...
    @overload
    def get_item(self, key : Literal["SDS"]) -> Optional[RuleVariation_99]:
        ...
    @overload
    def get_item(self, key : Literal["EMS"]) -> Optional[RuleVariation_587]:
        ...
    @overload
    def get_item(self, key : Literal["PFT"]) -> Optional[RuleVariation_830]:
        ...
    @overload
    def get_item(self, key : Literal["FPLT"]) -> Optional[RuleVariation_892]:
        ...
    @overload
    def get_item(self, key : Literal["DUPT"]) -> Optional[RuleVariation_38]:
        ...
    @overload
    def get_item(self, key : Literal["DUPF"]) -> Optional[RuleVariation_408]:
        ...
    @overload
    def get_item(self, key : Literal["DUPM"]) -> Optional[RuleVariation_516]:
        ...
    @overload
    def get_item(self, key : Literal["SFC"]) -> Optional[RuleVariation_623]:
        ...
    @overload
    def get_item(self, key : Literal["IDD"]) -> Optional[RuleVariation_726]:
        ...
    @overload
    def get_item(self, key : Literal["IEC"]) -> Optional[RuleVariation_811]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1285_Arg: TypeAlias = Variation_1362_Arg
class RuleVariation_1285(RuleVariationContextFree):
    cv_variation = Variation_1362

    @classmethod
    def create(cls, arg : RuleVariation_1285_Arg) -> "RuleVariation_1285":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1362:
        return self.arg # type: ignore

NonSpare_236_Arg: TypeAlias = RuleVariation_1285_Arg
class NonSpare_236(NonSpare):
    cv_name = "080"
    cv_title = "Track Status"
    cv_rule = RuleVariation_1285

    @classmethod
    def create(cls, arg : NonSpare_236_Arg) -> "NonSpare_236":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1285:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1362:
        return self.rule.variation

class UapItem_236(UapItem):
    cv_non_spare = NonSpare_236

Record_44_Arg = TypedDict('Record_44_Arg', {
    "010": NonSpare_45_Arg,
    "015": NonSpare_58_Arg,
    "070": NonSpare_213_Arg,
    "105": NonSpare_277_Arg,
    "100": NonSpare_264_Arg,
    "185": NonSpare_381_Arg,
    "210": NonSpare_405_Arg,
    "060": NonSpare_198_Arg,
    "245": NonSpare_435_Arg,
    "380": NonSpare_483_Arg,
    "040": NonSpare_147_Arg,
    "080": NonSpare_236_Arg,
    "290": NonSpare_465_Arg,
    "200": NonSpare_389_Arg,
    "295": NonSpare_468_Arg,
    "136": NonSpare_315_Arg,
    "130": NonSpare_301_Arg,
    "135": NonSpare_314_Arg,
    "220": NonSpare_417_Arg,
    "390": NonSpare_488_Arg,
    "270": NonSpare_457_Arg,
    "300": NonSpare_472_Arg,
    "110": NonSpare_285_Arg,
    "120": NonSpare_300_Arg,
    "510": NonSpare_515_Arg,
    "500": NonSpare_510_Arg,
    "340": NonSpare_477_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_44(Record):
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_45, UapItem_544, UapItem_58, UapItem_213, UapItem_277, UapItem_264, UapItem_381, UapItem_405, UapItem_198, UapItem_435, UapItem_483, UapItem_147, UapItem_236, UapItem_465, UapItem_389, UapItem_468, UapItem_315, UapItem_301, UapItem_314, UapItem_417, UapItem_488, UapItem_457, UapItem_472, UapItem_285, UapItem_300, UapItem_514, UapItem_509, UapItem_477, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_45, "015": NonSpare_58, "070": NonSpare_213, "105": NonSpare_277, "100": NonSpare_264, "185": NonSpare_381, "210": NonSpare_405, "060": NonSpare_198, "245": NonSpare_435, "380": NonSpare_483, "040": NonSpare_147, "080": NonSpare_236, "290": NonSpare_465, "200": NonSpare_389, "295": NonSpare_468, "136": NonSpare_315, "130": NonSpare_301, "135": NonSpare_314, "220": NonSpare_417, "390": NonSpare_488, "270": NonSpare_457, "300": NonSpare_472, "110": NonSpare_285, "120": NonSpare_300, "510": NonSpare_515, "500": NonSpare_510, "340": NonSpare_477, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_45:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_58:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_213:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["105"]) -> NonSpare_277:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_264:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["185"]) -> NonSpare_381:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_405:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_198:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_435:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["380"]) -> NonSpare_483:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_147:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_236:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["290"]) -> NonSpare_465:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_389:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_468:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["136"]) -> NonSpare_315:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_301:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["135"]) -> NonSpare_314:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_417:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["390"]) -> NonSpare_488:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["270"]) -> NonSpare_457:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_472:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_285:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_300:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["510"]) -> NonSpare_515:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_510:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["340"]) -> NonSpare_477:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["070"], Literal["105"], Literal["100"], Literal["185"], Literal["210"], Literal["060"], Literal["245"], Literal["380"], Literal["040"], Literal["080"], Literal["290"], Literal["200"], Literal["295"], Literal["136"], Literal["130"], Literal["135"], Literal["220"], Literal["390"], Literal["270"], Literal["300"], Literal["110"], Literal["120"], Literal["510"], Literal["500"], Literal["340"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_45]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_58]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_213]:
        ...
    @overload
    def get_item(self, key : Literal["105"]) -> Optional[NonSpare_277]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_264]:
        ...
    @overload
    def get_item(self, key : Literal["185"]) -> Optional[NonSpare_381]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_405]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_198]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_435]:
        ...
    @overload
    def get_item(self, key : Literal["380"]) -> Optional[NonSpare_483]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_147]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_236]:
        ...
    @overload
    def get_item(self, key : Literal["290"]) -> Optional[NonSpare_465]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_389]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_468]:
        ...
    @overload
    def get_item(self, key : Literal["136"]) -> Optional[NonSpare_315]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_301]:
        ...
    @overload
    def get_item(self, key : Literal["135"]) -> Optional[NonSpare_314]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_417]:
        ...
    @overload
    def get_item(self, key : Literal["390"]) -> Optional[NonSpare_488]:
        ...
    @overload
    def get_item(self, key : Literal["270"]) -> Optional[NonSpare_457]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_472]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_285]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_300]:
        ...
    @overload
    def get_item(self, key : Literal["510"]) -> Optional[NonSpare_515]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_510]:
        ...
    @overload
    def get_item(self, key : Literal["340"]) -> Optional[NonSpare_477]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_45_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_58_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_213_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["105"], val : NonSpare_277_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_264_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["185"], val : NonSpare_381_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_405_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_198_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_435_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["380"], val : NonSpare_483_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_147_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_236_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["290"], val : NonSpare_465_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_389_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_468_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["136"], val : NonSpare_315_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_301_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["135"], val : NonSpare_314_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_417_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["390"], val : NonSpare_488_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["270"], val : NonSpare_457_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_472_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_285_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_300_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["510"], val : NonSpare_515_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_510_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["340"], val : NonSpare_477_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_44':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["105"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["185"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["380"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["290"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["136"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["135"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["390"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["270"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["510"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["340"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_44':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_44_Arg) -> 'Record_44':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_44", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_40_Arg: TypeAlias = Record_44
class Uap_40(UapSingle):
    cv_record = Record_44

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_44]]:
        return cls._parse(bs)

class Asterix_52(AstCat):
    cv_category = 62
    cv_edition = (1, 18)
    cv_uap = Uap_40

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_40_Arg]) -> "Asterix_52":
        return cls._create(records) # type: ignore

NonSpare_686_Arg: TypeAlias = RuleVariation_986_Arg
class NonSpare_686(NonSpare):
    cv_name = "BPS"
    cv_title = "Barometric Pressure Setting"
    cv_rule = RuleVariation_986

    @classmethod
    def create(cls, arg : NonSpare_686_Arg) -> "NonSpare_686":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_986:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1016:
        return self.rule.variation

Variation_1458_Arg = TypedDict('Variation_1458_Arg', {
    "ADR": NonSpare_567_Arg,
    "ID": NonSpare_1103_Arg,
    "MHG": NonSpare_1270_Arg,
    "IAS": NonSpare_1096_Arg,
    "TAS": NonSpare_1823_Arg,
    "SAL": NonSpare_1648_Arg,
    "FSS": NonSpare_994_Arg,
    "TIS": NonSpare_1864_Arg,
    "TID": NonSpare_1859_Arg,
    "COM": NonSpare_781_Arg,
    "SAB": NonSpare_1642_Arg,
    "ACS": NonSpare_559_Arg,
    "BVR": NonSpare_690_Arg,
    "GVR": NonSpare_1041_Arg,
    "RAN": NonSpare_1538_Arg,
    "TAR": NonSpare_1818_Arg,
    "TAN": NonSpare_1813_Arg,
    "GS": NonSpare_1030_Arg,
    "VUN": NonSpare_2035_Arg,
    "MET": NonSpare_1262_Arg,
    "EMC": NonSpare_921_Arg,
    "POS": NonSpare_1439_Arg,
    "GAL": NonSpare_1011_Arg,
    "PUN": NonSpare_1475_Arg,
    "MB": NonSpare_1222_Arg,
    "IAR": NonSpare_1092_Arg,
    "MAC": NonSpare_1212_Arg,
    "BPS": NonSpare_686_Arg,
}, total=False)
class Variation_1458(Compound):
    cv_fspec_max_bytes = 4
    cv_items_list = [NonSpare_567, NonSpare_1103, NonSpare_1270, NonSpare_1096, NonSpare_1823, NonSpare_1648, NonSpare_994, NonSpare_1864, NonSpare_1859, NonSpare_781, NonSpare_1642, NonSpare_559, NonSpare_690, NonSpare_1041, NonSpare_1538, NonSpare_1818, NonSpare_1813, NonSpare_1030, NonSpare_2035, NonSpare_1262, NonSpare_921, NonSpare_1439, NonSpare_1011, NonSpare_1475, NonSpare_1222, NonSpare_1092, NonSpare_1212, NonSpare_686]
    cv_items_dict = {"ADR": NonSpare_567, "ID": NonSpare_1103, "MHG": NonSpare_1270, "IAS": NonSpare_1096, "TAS": NonSpare_1823, "SAL": NonSpare_1648, "FSS": NonSpare_994, "TIS": NonSpare_1864, "TID": NonSpare_1859, "COM": NonSpare_781, "SAB": NonSpare_1642, "ACS": NonSpare_559, "BVR": NonSpare_690, "GVR": NonSpare_1041, "RAN": NonSpare_1538, "TAR": NonSpare_1818, "TAN": NonSpare_1813, "GS": NonSpare_1030, "VUN": NonSpare_2035, "MET": NonSpare_1262, "EMC": NonSpare_921, "POS": NonSpare_1439, "GAL": NonSpare_1011, "PUN": NonSpare_1475, "MB": NonSpare_1222, "IAR": NonSpare_1092, "MAC": NonSpare_1212, "BPS": NonSpare_686}

    @overload
    @classmethod
    def spec(cls, key : Literal["ADR"]) -> NonSpare_567:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ID"]) -> NonSpare_1103:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MHG"]) -> NonSpare_1270:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAS"]) -> NonSpare_1096:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAS"]) -> NonSpare_1823:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAL"]) -> NonSpare_1648:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FSS"]) -> NonSpare_994:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TIS"]) -> NonSpare_1864:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> NonSpare_1859:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> NonSpare_781:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAB"]) -> NonSpare_1642:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ACS"]) -> NonSpare_559:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BVR"]) -> NonSpare_690:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GVR"]) -> NonSpare_1041:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAN"]) -> NonSpare_1538:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAR"]) -> NonSpare_1818:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAN"]) -> NonSpare_1813:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GS"]) -> NonSpare_1030:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VUN"]) -> NonSpare_2035:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MET"]) -> NonSpare_1262:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EMC"]) -> NonSpare_921:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1439:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GAL"]) -> NonSpare_1011:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PUN"]) -> NonSpare_1475:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MB"]) -> NonSpare_1222:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAR"]) -> NonSpare_1092:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MAC"]) -> NonSpare_1212:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BPS"]) -> NonSpare_686:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ADR"], Literal["ID"], Literal["MHG"], Literal["IAS"], Literal["TAS"], Literal["SAL"], Literal["FSS"], Literal["TIS"], Literal["TID"], Literal["COM"], Literal["SAB"], Literal["ACS"], Literal["BVR"], Literal["GVR"], Literal["RAN"], Literal["TAR"], Literal["TAN"], Literal["GS"], Literal["VUN"], Literal["MET"], Literal["EMC"], Literal["POS"], Literal["GAL"], Literal["PUN"], Literal["MB"], Literal["IAR"], Literal["MAC"], Literal["BPS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ADR"]) -> Optional[NonSpare_567]:
        ...
    @overload
    def get_item(self, key : Literal["ID"]) -> Optional[NonSpare_1103]:
        ...
    @overload
    def get_item(self, key : Literal["MHG"]) -> Optional[NonSpare_1270]:
        ...
    @overload
    def get_item(self, key : Literal["IAS"]) -> Optional[NonSpare_1096]:
        ...
    @overload
    def get_item(self, key : Literal["TAS"]) -> Optional[NonSpare_1823]:
        ...
    @overload
    def get_item(self, key : Literal["SAL"]) -> Optional[NonSpare_1648]:
        ...
    @overload
    def get_item(self, key : Literal["FSS"]) -> Optional[NonSpare_994]:
        ...
    @overload
    def get_item(self, key : Literal["TIS"]) -> Optional[NonSpare_1864]:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> Optional[NonSpare_1859]:
        ...
    @overload
    def get_item(self, key : Literal["COM"]) -> Optional[NonSpare_781]:
        ...
    @overload
    def get_item(self, key : Literal["SAB"]) -> Optional[NonSpare_1642]:
        ...
    @overload
    def get_item(self, key : Literal["ACS"]) -> Optional[NonSpare_559]:
        ...
    @overload
    def get_item(self, key : Literal["BVR"]) -> Optional[NonSpare_690]:
        ...
    @overload
    def get_item(self, key : Literal["GVR"]) -> Optional[NonSpare_1041]:
        ...
    @overload
    def get_item(self, key : Literal["RAN"]) -> Optional[NonSpare_1538]:
        ...
    @overload
    def get_item(self, key : Literal["TAR"]) -> Optional[NonSpare_1818]:
        ...
    @overload
    def get_item(self, key : Literal["TAN"]) -> Optional[NonSpare_1813]:
        ...
    @overload
    def get_item(self, key : Literal["GS"]) -> Optional[NonSpare_1030]:
        ...
    @overload
    def get_item(self, key : Literal["VUN"]) -> Optional[NonSpare_2035]:
        ...
    @overload
    def get_item(self, key : Literal["MET"]) -> Optional[NonSpare_1262]:
        ...
    @overload
    def get_item(self, key : Literal["EMC"]) -> Optional[NonSpare_921]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1439]:
        ...
    @overload
    def get_item(self, key : Literal["GAL"]) -> Optional[NonSpare_1011]:
        ...
    @overload
    def get_item(self, key : Literal["PUN"]) -> Optional[NonSpare_1475]:
        ...
    @overload
    def get_item(self, key : Literal["MB"]) -> Optional[NonSpare_1222]:
        ...
    @overload
    def get_item(self, key : Literal["IAR"]) -> Optional[NonSpare_1092]:
        ...
    @overload
    def get_item(self, key : Literal["MAC"]) -> Optional[NonSpare_1212]:
        ...
    @overload
    def get_item(self, key : Literal["BPS"]) -> Optional[NonSpare_686]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["ADR"], val : NonSpare_567_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["ID"], val : NonSpare_1103_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["MHG"], val : NonSpare_1270_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["IAS"], val : NonSpare_1096_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["TAS"], val : NonSpare_1823_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["SAL"], val : NonSpare_1648_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["FSS"], val : NonSpare_994_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["TIS"], val : NonSpare_1864_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["TID"], val : NonSpare_1859_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["COM"], val : NonSpare_781_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["SAB"], val : NonSpare_1642_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["ACS"], val : NonSpare_559_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["BVR"], val : NonSpare_690_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["GVR"], val : NonSpare_1041_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["RAN"], val : NonSpare_1538_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["TAR"], val : NonSpare_1818_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["TAN"], val : NonSpare_1813_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["GS"], val : NonSpare_1030_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["VUN"], val : NonSpare_2035_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["MET"], val : NonSpare_1262_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["EMC"], val : NonSpare_921_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1439_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["GAL"], val : NonSpare_1011_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["PUN"], val : NonSpare_1475_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["MB"], val : NonSpare_1222_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["IAR"], val : NonSpare_1092_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["MAC"], val : NonSpare_1212_Arg) -> "Variation_1458":
        ...
    @overload
    def set_item(self, key : Literal["BPS"], val : NonSpare_686_Arg) -> "Variation_1458":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["ADR"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["ID"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["MHG"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["IAS"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["TAS"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["SAL"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["FSS"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["TIS"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["TID"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["COM"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["SAB"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["ACS"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["BVR"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["GVR"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["RAN"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["TAR"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["TAN"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["GS"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["VUN"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["MET"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["EMC"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["GAL"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["PUN"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["MB"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["IAR"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["MAC"]) -> "Variation_1458":
        ...
    @overload
    def del_item(self, key : Literal["BPS"]) -> "Variation_1458":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1458_Arg) -> 'Variation_1458':
        return cls._create(arg) # type: ignore

RuleVariation_1381_Arg: TypeAlias = Variation_1458_Arg
class RuleVariation_1381(RuleVariationContextFree):
    cv_variation = Variation_1458

    @classmethod
    def create(cls, arg : RuleVariation_1381_Arg) -> "RuleVariation_1381":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1458:
        return self.arg # type: ignore

NonSpare_482_Arg: TypeAlias = RuleVariation_1381_Arg
class NonSpare_482(NonSpare):
    cv_name = "380"
    cv_title = "Aircraft Derived Data"
    cv_rule = RuleVariation_1381

    @classmethod
    def create(cls, arg : NonSpare_482_Arg) -> "NonSpare_482":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1381:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1458:
        return self.rule.variation

class UapItem_482(UapItem):
    cv_non_spare = NonSpare_482

Content_751_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["FL"]]]
class Content_751(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 0.25
    cv_unit = "FL"

    def as_quantity(self, cv_unit : Optional[Literal["FL"]] = None) -> float:
        return self._as_quantity()

RuleContent_750_Arg: TypeAlias = Content_751_Arg
class RuleContent_750(RuleContentContextFree):
    cv_content = Content_751

    @property
    def content(self) -> Content_751:
        return self._get_content() # type: ignore

Variation_321_Arg: TypeAlias = RuleContent_750_Arg
class Variation_321(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_750

    @classmethod
    def create(cls, arg : Variation_321_Arg) -> "Variation_321":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_750:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_751:
        return self.rule.content

RuleVariation_314_Arg: TypeAlias = Variation_321_Arg
class RuleVariation_314(RuleVariationContextFree):
    cv_variation = Variation_321

    @classmethod
    def create(cls, arg : RuleVariation_314_Arg) -> "RuleVariation_314":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_321:
        return self.arg # type: ignore

NonSpare_721_Arg: TypeAlias = RuleVariation_314_Arg
class NonSpare_721(NonSpare):
    cv_name = "CFL"
    cv_title = "Current Cleared Flight Level"
    cv_rule = RuleVariation_314

    @classmethod
    def create(cls, arg : NonSpare_721_Arg) -> "NonSpare_721":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_314:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_321:
        return self.rule.variation

Variation_1504_Arg = TypedDict('Variation_1504_Arg', {
    "TAG": NonSpare_1812_Arg,
    "CS": NonSpare_824_Arg,
    "IFI": NonSpare_1109_Arg,
    "FCT": NonSpare_962_Arg,
    "TAC": NonSpare_1811_Arg,
    "WTC": NonSpare_2060_Arg,
    "DEP": NonSpare_871_Arg,
    "DST": NonSpare_896_Arg,
    "RDS": NonSpare_1554_Arg,
    "CFL": NonSpare_721_Arg,
    "CTL": NonSpare_841_Arg,
    "TOD": NonSpare_1875_Arg,
    "AST": NonSpare_633_Arg,
    "STS": NonSpare_1790_Arg,
    "STD": NonSpare_1779_Arg,
    "STA": NonSpare_1762_Arg,
    "PEM": NonSpare_1416_Arg,
    "PEC": NonSpare_1415_Arg,
}, total=False)
class Variation_1504(Compound):
    cv_fspec_max_bytes = 3
    cv_items_list = [NonSpare_1812, NonSpare_824, NonSpare_1109, NonSpare_962, NonSpare_1811, NonSpare_2060, NonSpare_871, NonSpare_896, NonSpare_1554, NonSpare_721, NonSpare_841, NonSpare_1875, NonSpare_633, NonSpare_1790, NonSpare_1779, NonSpare_1762, NonSpare_1416, NonSpare_1415]
    cv_items_dict = {"TAG": NonSpare_1812, "CS": NonSpare_824, "IFI": NonSpare_1109, "FCT": NonSpare_962, "TAC": NonSpare_1811, "WTC": NonSpare_2060, "DEP": NonSpare_871, "DST": NonSpare_896, "RDS": NonSpare_1554, "CFL": NonSpare_721, "CTL": NonSpare_841, "TOD": NonSpare_1875, "AST": NonSpare_633, "STS": NonSpare_1790, "STD": NonSpare_1779, "STA": NonSpare_1762, "PEM": NonSpare_1416, "PEC": NonSpare_1415}

    @overload
    @classmethod
    def spec(cls, key : Literal["TAG"]) -> NonSpare_1812:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CS"]) -> NonSpare_824:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IFI"]) -> NonSpare_1109:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FCT"]) -> NonSpare_962:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAC"]) -> NonSpare_1811:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WTC"]) -> NonSpare_2060:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DEP"]) -> NonSpare_871:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DST"]) -> NonSpare_896:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RDS"]) -> NonSpare_1554:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CFL"]) -> NonSpare_721:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CTL"]) -> NonSpare_841:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOD"]) -> NonSpare_1875:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AST"]) -> NonSpare_633:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STS"]) -> NonSpare_1790:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STD"]) -> NonSpare_1779:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STA"]) -> NonSpare_1762:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PEM"]) -> NonSpare_1416:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PEC"]) -> NonSpare_1415:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TAG"], Literal["CS"], Literal["IFI"], Literal["FCT"], Literal["TAC"], Literal["WTC"], Literal["DEP"], Literal["DST"], Literal["RDS"], Literal["CFL"], Literal["CTL"], Literal["TOD"], Literal["AST"], Literal["STS"], Literal["STD"], Literal["STA"], Literal["PEM"], Literal["PEC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TAG"]) -> Optional[NonSpare_1812]:
        ...
    @overload
    def get_item(self, key : Literal["CS"]) -> Optional[NonSpare_824]:
        ...
    @overload
    def get_item(self, key : Literal["IFI"]) -> Optional[NonSpare_1109]:
        ...
    @overload
    def get_item(self, key : Literal["FCT"]) -> Optional[NonSpare_962]:
        ...
    @overload
    def get_item(self, key : Literal["TAC"]) -> Optional[NonSpare_1811]:
        ...
    @overload
    def get_item(self, key : Literal["WTC"]) -> Optional[NonSpare_2060]:
        ...
    @overload
    def get_item(self, key : Literal["DEP"]) -> Optional[NonSpare_871]:
        ...
    @overload
    def get_item(self, key : Literal["DST"]) -> Optional[NonSpare_896]:
        ...
    @overload
    def get_item(self, key : Literal["RDS"]) -> Optional[NonSpare_1554]:
        ...
    @overload
    def get_item(self, key : Literal["CFL"]) -> Optional[NonSpare_721]:
        ...
    @overload
    def get_item(self, key : Literal["CTL"]) -> Optional[NonSpare_841]:
        ...
    @overload
    def get_item(self, key : Literal["TOD"]) -> Optional[NonSpare_1875]:
        ...
    @overload
    def get_item(self, key : Literal["AST"]) -> Optional[NonSpare_633]:
        ...
    @overload
    def get_item(self, key : Literal["STS"]) -> Optional[NonSpare_1790]:
        ...
    @overload
    def get_item(self, key : Literal["STD"]) -> Optional[NonSpare_1779]:
        ...
    @overload
    def get_item(self, key : Literal["STA"]) -> Optional[NonSpare_1762]:
        ...
    @overload
    def get_item(self, key : Literal["PEM"]) -> Optional[NonSpare_1416]:
        ...
    @overload
    def get_item(self, key : Literal["PEC"]) -> Optional[NonSpare_1415]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["TAG"], val : NonSpare_1812_Arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["CS"], val : NonSpare_824_Arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["IFI"], val : NonSpare_1109_Arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["FCT"], val : NonSpare_962_Arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["TAC"], val : NonSpare_1811_Arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["WTC"], val : NonSpare_2060_Arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["DEP"], val : NonSpare_871_Arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["DST"], val : NonSpare_896_Arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["RDS"], val : NonSpare_1554_Arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["CFL"], val : NonSpare_721_Arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["CTL"], val : NonSpare_841_Arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["TOD"], val : NonSpare_1875_Arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["AST"], val : NonSpare_633_Arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["STS"], val : NonSpare_1790_Arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["STD"], val : NonSpare_1779_Arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["STA"], val : NonSpare_1762_Arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["PEM"], val : NonSpare_1416_Arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["PEC"], val : NonSpare_1415_Arg) -> "Variation_1504":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["TAG"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["CS"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["IFI"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["FCT"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["TAC"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["WTC"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["DEP"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["DST"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["RDS"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["CFL"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["CTL"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["TOD"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["AST"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["STS"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["STD"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["STA"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["PEM"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["PEC"]) -> "Variation_1504":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1504_Arg) -> 'Variation_1504':
        return cls._create(arg) # type: ignore

RuleVariation_1427_Arg: TypeAlias = Variation_1504_Arg
class RuleVariation_1427(RuleVariationContextFree):
    cv_variation = Variation_1504

    @classmethod
    def create(cls, arg : RuleVariation_1427_Arg) -> "RuleVariation_1427":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1504:
        return self.arg # type: ignore

NonSpare_489_Arg: TypeAlias = RuleVariation_1427_Arg
class NonSpare_489(NonSpare):
    cv_name = "390"
    cv_title = "Flight Plan Related Data"
    cv_rule = RuleVariation_1427

    @classmethod
    def create(cls, arg : NonSpare_489_Arg) -> "NonSpare_489":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1427:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1504:
        return self.rule.variation

class UapItem_489(UapItem):
    cv_non_spare = NonSpare_489

NonSpare_1055_Arg: TypeAlias = RuleVariation_253_Arg
class NonSpare_1055(NonSpare):
    cv_name = "HEIGHT"
    cv_title = "Measured 3-D Height"
    cv_rule = RuleVariation_253

    @classmethod
    def create(cls, arg : NonSpare_1055_Arg) -> "NonSpare_1055":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_253:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_260:
        return self.rule.variation

Variation_1496_Arg = TypedDict('Variation_1496_Arg', {
    "SID": NonSpare_1703_Arg,
    "POS": NonSpare_1434_Arg,
    "HEIGHT": NonSpare_1055_Arg,
    "MDC": NonSpare_1245_Arg,
    "MDA": NonSpare_1241_Arg,
    "TYP": NonSpare_1955_Arg,
}, total=False)
class Variation_1496(Compound):
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1703, NonSpare_1434, NonSpare_1055, NonSpare_1245, NonSpare_1241, NonSpare_1955]
    cv_items_dict = {"SID": NonSpare_1703, "POS": NonSpare_1434, "HEIGHT": NonSpare_1055, "MDC": NonSpare_1245, "MDA": NonSpare_1241, "TYP": NonSpare_1955}

    @overload
    @classmethod
    def spec(cls, key : Literal["SID"]) -> NonSpare_1703:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1434:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HEIGHT"]) -> NonSpare_1055:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDC"]) -> NonSpare_1245:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDA"]) -> NonSpare_1241:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> NonSpare_1955:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SID"], Literal["POS"], Literal["HEIGHT"], Literal["MDC"], Literal["MDA"], Literal["TYP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SID"]) -> Optional[NonSpare_1703]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1434]:
        ...
    @overload
    def get_item(self, key : Literal["HEIGHT"]) -> Optional[NonSpare_1055]:
        ...
    @overload
    def get_item(self, key : Literal["MDC"]) -> Optional[NonSpare_1245]:
        ...
    @overload
    def get_item(self, key : Literal["MDA"]) -> Optional[NonSpare_1241]:
        ...
    @overload
    def get_item(self, key : Literal["TYP"]) -> Optional[NonSpare_1955]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["SID"], val : NonSpare_1703_Arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1434_Arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["HEIGHT"], val : NonSpare_1055_Arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["MDC"], val : NonSpare_1245_Arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["MDA"], val : NonSpare_1241_Arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["TYP"], val : NonSpare_1955_Arg) -> "Variation_1496":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["SID"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["HEIGHT"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["MDC"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["MDA"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["TYP"]) -> "Variation_1496":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1496_Arg) -> 'Variation_1496':
        return cls._create(arg) # type: ignore

RuleVariation_1419_Arg: TypeAlias = Variation_1496_Arg
class RuleVariation_1419(RuleVariationContextFree):
    cv_variation = Variation_1496

    @classmethod
    def create(cls, arg : RuleVariation_1419_Arg) -> "RuleVariation_1419":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1496:
        return self.arg # type: ignore

NonSpare_476_Arg: TypeAlias = RuleVariation_1419_Arg
class NonSpare_476(NonSpare):
    cv_name = "340"
    cv_title = "Measured Information"
    cv_rule = RuleVariation_1419

    @classmethod
    def create(cls, arg : NonSpare_476_Arg) -> "NonSpare_476":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1419:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1496:
        return self.rule.variation

class UapItem_476(UapItem):
    cv_non_spare = NonSpare_476

Record_43_Arg = TypedDict('Record_43_Arg', {
    "010": NonSpare_45_Arg,
    "015": NonSpare_58_Arg,
    "070": NonSpare_213_Arg,
    "105": NonSpare_277_Arg,
    "100": NonSpare_264_Arg,
    "185": NonSpare_381_Arg,
    "210": NonSpare_405_Arg,
    "060": NonSpare_198_Arg,
    "245": NonSpare_435_Arg,
    "380": NonSpare_482_Arg,
    "040": NonSpare_147_Arg,
    "080": NonSpare_236_Arg,
    "290": NonSpare_465_Arg,
    "200": NonSpare_389_Arg,
    "295": NonSpare_468_Arg,
    "136": NonSpare_315_Arg,
    "130": NonSpare_301_Arg,
    "135": NonSpare_314_Arg,
    "220": NonSpare_417_Arg,
    "390": NonSpare_489_Arg,
    "270": NonSpare_457_Arg,
    "300": NonSpare_472_Arg,
    "110": NonSpare_285_Arg,
    "120": NonSpare_300_Arg,
    "510": NonSpare_515_Arg,
    "500": NonSpare_510_Arg,
    "340": NonSpare_476_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_43(Record):
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_45, UapItem_544, UapItem_58, UapItem_213, UapItem_277, UapItem_264, UapItem_381, UapItem_405, UapItem_198, UapItem_435, UapItem_482, UapItem_147, UapItem_236, UapItem_465, UapItem_389, UapItem_468, UapItem_315, UapItem_301, UapItem_314, UapItem_417, UapItem_489, UapItem_457, UapItem_472, UapItem_285, UapItem_300, UapItem_514, UapItem_509, UapItem_476, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_45, "015": NonSpare_58, "070": NonSpare_213, "105": NonSpare_277, "100": NonSpare_264, "185": NonSpare_381, "210": NonSpare_405, "060": NonSpare_198, "245": NonSpare_435, "380": NonSpare_482, "040": NonSpare_147, "080": NonSpare_236, "290": NonSpare_465, "200": NonSpare_389, "295": NonSpare_468, "136": NonSpare_315, "130": NonSpare_301, "135": NonSpare_314, "220": NonSpare_417, "390": NonSpare_489, "270": NonSpare_457, "300": NonSpare_472, "110": NonSpare_285, "120": NonSpare_300, "510": NonSpare_515, "500": NonSpare_510, "340": NonSpare_476, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_45:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_58:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_213:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["105"]) -> NonSpare_277:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_264:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["185"]) -> NonSpare_381:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_405:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_198:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_435:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["380"]) -> NonSpare_482:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_147:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_236:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["290"]) -> NonSpare_465:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_389:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_468:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["136"]) -> NonSpare_315:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_301:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["135"]) -> NonSpare_314:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_417:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["390"]) -> NonSpare_489:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["270"]) -> NonSpare_457:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_472:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_285:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_300:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["510"]) -> NonSpare_515:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_510:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["340"]) -> NonSpare_476:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["070"], Literal["105"], Literal["100"], Literal["185"], Literal["210"], Literal["060"], Literal["245"], Literal["380"], Literal["040"], Literal["080"], Literal["290"], Literal["200"], Literal["295"], Literal["136"], Literal["130"], Literal["135"], Literal["220"], Literal["390"], Literal["270"], Literal["300"], Literal["110"], Literal["120"], Literal["510"], Literal["500"], Literal["340"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_45]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_58]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_213]:
        ...
    @overload
    def get_item(self, key : Literal["105"]) -> Optional[NonSpare_277]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_264]:
        ...
    @overload
    def get_item(self, key : Literal["185"]) -> Optional[NonSpare_381]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_405]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_198]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_435]:
        ...
    @overload
    def get_item(self, key : Literal["380"]) -> Optional[NonSpare_482]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_147]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_236]:
        ...
    @overload
    def get_item(self, key : Literal["290"]) -> Optional[NonSpare_465]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_389]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_468]:
        ...
    @overload
    def get_item(self, key : Literal["136"]) -> Optional[NonSpare_315]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_301]:
        ...
    @overload
    def get_item(self, key : Literal["135"]) -> Optional[NonSpare_314]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_417]:
        ...
    @overload
    def get_item(self, key : Literal["390"]) -> Optional[NonSpare_489]:
        ...
    @overload
    def get_item(self, key : Literal["270"]) -> Optional[NonSpare_457]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_472]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_285]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_300]:
        ...
    @overload
    def get_item(self, key : Literal["510"]) -> Optional[NonSpare_515]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_510]:
        ...
    @overload
    def get_item(self, key : Literal["340"]) -> Optional[NonSpare_476]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_45_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_58_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_213_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["105"], val : NonSpare_277_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_264_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["185"], val : NonSpare_381_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_405_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_198_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_435_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["380"], val : NonSpare_482_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_147_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_236_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["290"], val : NonSpare_465_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_389_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_468_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["136"], val : NonSpare_315_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_301_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["135"], val : NonSpare_314_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_417_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["390"], val : NonSpare_489_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["270"], val : NonSpare_457_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_472_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_285_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_300_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["510"], val : NonSpare_515_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_510_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["340"], val : NonSpare_476_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_43':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["105"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["185"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["380"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["290"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["136"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["135"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["390"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["270"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["510"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["340"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_43':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_43_Arg) -> 'Record_43':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_43", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_39_Arg: TypeAlias = Record_43
class Uap_39(UapSingle):
    cv_record = Record_43

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_43]]:
        return cls._parse(bs)

class Asterix_53(AstCat):
    cv_category = 62
    cv_edition = (1, 19)
    cv_uap = Uap_39

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_39_Arg]) -> "Asterix_53":
        return cls._create(records) # type: ignore

NonSpare_673_Arg: TypeAlias = RuleVariation_1319_Arg
class NonSpare_673(NonSpare):
    cv_name = "BDSDATA"
    cv_title = "BDS Register DATA"
    cv_rule = RuleVariation_1319

    @classmethod
    def create(cls, arg : NonSpare_673_Arg) -> "NonSpare_673":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1319:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1396:
        return self.rule.variation

Variation_1457_Arg = TypedDict('Variation_1457_Arg', {
    "ADR": NonSpare_567_Arg,
    "ID": NonSpare_1103_Arg,
    "MHG": NonSpare_1270_Arg,
    "IAS": NonSpare_1096_Arg,
    "TAS": NonSpare_1823_Arg,
    "SAL": NonSpare_1648_Arg,
    "FSS": NonSpare_994_Arg,
    "TIS": NonSpare_1864_Arg,
    "TID": NonSpare_1859_Arg,
    "COM": NonSpare_781_Arg,
    "SAB": NonSpare_1642_Arg,
    "ACS": NonSpare_559_Arg,
    "BVR": NonSpare_690_Arg,
    "GVR": NonSpare_1041_Arg,
    "RAN": NonSpare_1538_Arg,
    "TAR": NonSpare_1818_Arg,
    "TAN": NonSpare_1813_Arg,
    "GS": NonSpare_1030_Arg,
    "VUN": NonSpare_2035_Arg,
    "MET": NonSpare_1262_Arg,
    "EMC": NonSpare_921_Arg,
    "POS": NonSpare_1439_Arg,
    "GAL": NonSpare_1011_Arg,
    "PUN": NonSpare_1475_Arg,
    "BDSDATA": NonSpare_673_Arg,
    "IAR": NonSpare_1092_Arg,
    "MAC": NonSpare_1212_Arg,
    "BPS": NonSpare_686_Arg,
}, total=False)
class Variation_1457(Compound):
    cv_fspec_max_bytes = 4
    cv_items_list = [NonSpare_567, NonSpare_1103, NonSpare_1270, NonSpare_1096, NonSpare_1823, NonSpare_1648, NonSpare_994, NonSpare_1864, NonSpare_1859, NonSpare_781, NonSpare_1642, NonSpare_559, NonSpare_690, NonSpare_1041, NonSpare_1538, NonSpare_1818, NonSpare_1813, NonSpare_1030, NonSpare_2035, NonSpare_1262, NonSpare_921, NonSpare_1439, NonSpare_1011, NonSpare_1475, NonSpare_673, NonSpare_1092, NonSpare_1212, NonSpare_686]
    cv_items_dict = {"ADR": NonSpare_567, "ID": NonSpare_1103, "MHG": NonSpare_1270, "IAS": NonSpare_1096, "TAS": NonSpare_1823, "SAL": NonSpare_1648, "FSS": NonSpare_994, "TIS": NonSpare_1864, "TID": NonSpare_1859, "COM": NonSpare_781, "SAB": NonSpare_1642, "ACS": NonSpare_559, "BVR": NonSpare_690, "GVR": NonSpare_1041, "RAN": NonSpare_1538, "TAR": NonSpare_1818, "TAN": NonSpare_1813, "GS": NonSpare_1030, "VUN": NonSpare_2035, "MET": NonSpare_1262, "EMC": NonSpare_921, "POS": NonSpare_1439, "GAL": NonSpare_1011, "PUN": NonSpare_1475, "BDSDATA": NonSpare_673, "IAR": NonSpare_1092, "MAC": NonSpare_1212, "BPS": NonSpare_686}

    @overload
    @classmethod
    def spec(cls, key : Literal["ADR"]) -> NonSpare_567:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ID"]) -> NonSpare_1103:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MHG"]) -> NonSpare_1270:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAS"]) -> NonSpare_1096:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAS"]) -> NonSpare_1823:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAL"]) -> NonSpare_1648:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FSS"]) -> NonSpare_994:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TIS"]) -> NonSpare_1864:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> NonSpare_1859:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> NonSpare_781:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAB"]) -> NonSpare_1642:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ACS"]) -> NonSpare_559:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BVR"]) -> NonSpare_690:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GVR"]) -> NonSpare_1041:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAN"]) -> NonSpare_1538:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAR"]) -> NonSpare_1818:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAN"]) -> NonSpare_1813:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GS"]) -> NonSpare_1030:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VUN"]) -> NonSpare_2035:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MET"]) -> NonSpare_1262:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EMC"]) -> NonSpare_921:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1439:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GAL"]) -> NonSpare_1011:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PUN"]) -> NonSpare_1475:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BDSDATA"]) -> NonSpare_673:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAR"]) -> NonSpare_1092:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MAC"]) -> NonSpare_1212:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BPS"]) -> NonSpare_686:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ADR"], Literal["ID"], Literal["MHG"], Literal["IAS"], Literal["TAS"], Literal["SAL"], Literal["FSS"], Literal["TIS"], Literal["TID"], Literal["COM"], Literal["SAB"], Literal["ACS"], Literal["BVR"], Literal["GVR"], Literal["RAN"], Literal["TAR"], Literal["TAN"], Literal["GS"], Literal["VUN"], Literal["MET"], Literal["EMC"], Literal["POS"], Literal["GAL"], Literal["PUN"], Literal["BDSDATA"], Literal["IAR"], Literal["MAC"], Literal["BPS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ADR"]) -> Optional[NonSpare_567]:
        ...
    @overload
    def get_item(self, key : Literal["ID"]) -> Optional[NonSpare_1103]:
        ...
    @overload
    def get_item(self, key : Literal["MHG"]) -> Optional[NonSpare_1270]:
        ...
    @overload
    def get_item(self, key : Literal["IAS"]) -> Optional[NonSpare_1096]:
        ...
    @overload
    def get_item(self, key : Literal["TAS"]) -> Optional[NonSpare_1823]:
        ...
    @overload
    def get_item(self, key : Literal["SAL"]) -> Optional[NonSpare_1648]:
        ...
    @overload
    def get_item(self, key : Literal["FSS"]) -> Optional[NonSpare_994]:
        ...
    @overload
    def get_item(self, key : Literal["TIS"]) -> Optional[NonSpare_1864]:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> Optional[NonSpare_1859]:
        ...
    @overload
    def get_item(self, key : Literal["COM"]) -> Optional[NonSpare_781]:
        ...
    @overload
    def get_item(self, key : Literal["SAB"]) -> Optional[NonSpare_1642]:
        ...
    @overload
    def get_item(self, key : Literal["ACS"]) -> Optional[NonSpare_559]:
        ...
    @overload
    def get_item(self, key : Literal["BVR"]) -> Optional[NonSpare_690]:
        ...
    @overload
    def get_item(self, key : Literal["GVR"]) -> Optional[NonSpare_1041]:
        ...
    @overload
    def get_item(self, key : Literal["RAN"]) -> Optional[NonSpare_1538]:
        ...
    @overload
    def get_item(self, key : Literal["TAR"]) -> Optional[NonSpare_1818]:
        ...
    @overload
    def get_item(self, key : Literal["TAN"]) -> Optional[NonSpare_1813]:
        ...
    @overload
    def get_item(self, key : Literal["GS"]) -> Optional[NonSpare_1030]:
        ...
    @overload
    def get_item(self, key : Literal["VUN"]) -> Optional[NonSpare_2035]:
        ...
    @overload
    def get_item(self, key : Literal["MET"]) -> Optional[NonSpare_1262]:
        ...
    @overload
    def get_item(self, key : Literal["EMC"]) -> Optional[NonSpare_921]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1439]:
        ...
    @overload
    def get_item(self, key : Literal["GAL"]) -> Optional[NonSpare_1011]:
        ...
    @overload
    def get_item(self, key : Literal["PUN"]) -> Optional[NonSpare_1475]:
        ...
    @overload
    def get_item(self, key : Literal["BDSDATA"]) -> Optional[NonSpare_673]:
        ...
    @overload
    def get_item(self, key : Literal["IAR"]) -> Optional[NonSpare_1092]:
        ...
    @overload
    def get_item(self, key : Literal["MAC"]) -> Optional[NonSpare_1212]:
        ...
    @overload
    def get_item(self, key : Literal["BPS"]) -> Optional[NonSpare_686]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["ADR"], val : NonSpare_567_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["ID"], val : NonSpare_1103_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["MHG"], val : NonSpare_1270_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["IAS"], val : NonSpare_1096_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["TAS"], val : NonSpare_1823_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["SAL"], val : NonSpare_1648_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["FSS"], val : NonSpare_994_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["TIS"], val : NonSpare_1864_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["TID"], val : NonSpare_1859_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["COM"], val : NonSpare_781_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["SAB"], val : NonSpare_1642_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["ACS"], val : NonSpare_559_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["BVR"], val : NonSpare_690_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["GVR"], val : NonSpare_1041_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["RAN"], val : NonSpare_1538_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["TAR"], val : NonSpare_1818_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["TAN"], val : NonSpare_1813_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["GS"], val : NonSpare_1030_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["VUN"], val : NonSpare_2035_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["MET"], val : NonSpare_1262_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["EMC"], val : NonSpare_921_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1439_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["GAL"], val : NonSpare_1011_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["PUN"], val : NonSpare_1475_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["BDSDATA"], val : NonSpare_673_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["IAR"], val : NonSpare_1092_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["MAC"], val : NonSpare_1212_Arg) -> "Variation_1457":
        ...
    @overload
    def set_item(self, key : Literal["BPS"], val : NonSpare_686_Arg) -> "Variation_1457":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["ADR"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["ID"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["MHG"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["IAS"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["TAS"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["SAL"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["FSS"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["TIS"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["TID"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["COM"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["SAB"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["ACS"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["BVR"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["GVR"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["RAN"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["TAR"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["TAN"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["GS"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["VUN"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["MET"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["EMC"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["GAL"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["PUN"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["BDSDATA"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["IAR"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["MAC"]) -> "Variation_1457":
        ...
    @overload
    def del_item(self, key : Literal["BPS"]) -> "Variation_1457":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Variation_1457_Arg) -> 'Variation_1457':
        return cls._create(arg) # type: ignore

RuleVariation_1380_Arg: TypeAlias = Variation_1457_Arg
class RuleVariation_1380(RuleVariationContextFree):
    cv_variation = Variation_1457

    @classmethod
    def create(cls, arg : RuleVariation_1380_Arg) -> "RuleVariation_1380":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1457:
        return self.arg # type: ignore

NonSpare_481_Arg: TypeAlias = RuleVariation_1380_Arg
class NonSpare_481(NonSpare):
    cv_name = "380"
    cv_title = "Aircraft Derived Data"
    cv_rule = RuleVariation_1380

    @classmethod
    def create(cls, arg : NonSpare_481_Arg) -> "NonSpare_481":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1380:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1457:
        return self.rule.variation

class UapItem_481(UapItem):
    cv_non_spare = NonSpare_481

Content_174_Arg: TypeAlias = int
class Content_174(ContentTable):
    cv_values = {0: "Default value", 1: "Age of the last received MLAT track updateis higher than system dependent threshold"}

RuleContent_174_Arg: TypeAlias = Content_174_Arg
class RuleContent_174(RuleContentContextFree):
    cv_content = Content_174

    @property
    def content(self) -> Content_174:
        return self._get_content() # type: ignore

Variation_919_Arg: TypeAlias = RuleContent_174_Arg
class Variation_919(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_174

    @classmethod
    def create(cls, arg : Variation_919_Arg) -> "Variation_919":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_174:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_174:
        return self.rule.content

RuleVariation_889_Arg: TypeAlias = Variation_919_Arg
class RuleVariation_889(RuleVariationContextFree):
    cv_variation = Variation_919

    @classmethod
    def create(cls, arg : RuleVariation_889_Arg) -> "RuleVariation_889":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_919:
        return self.arg # type: ignore

NonSpare_1282_Arg: TypeAlias = RuleVariation_889_Arg
class NonSpare_1282(NonSpare):
    cv_name = "MLAT"
    cv_title = ""
    cv_rule = RuleVariation_889

    @classmethod
    def create(cls, arg : NonSpare_1282_Arg) -> "NonSpare_1282":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_889:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_919:
        return self.rule.variation

Item_555_Arg: TypeAlias = NonSpare_1282_Arg
class Item_555(Item):
    cv_non_spare = NonSpare_1282

    @classmethod
    def create(cls, arg : Item_555_Arg) -> "Item_555":
        return cls._create(arg) # type: ignore

Variation_1363_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_54_Arg, Tuple[Literal["MON"], RuleVariation_54_Arg]], Union[RuleVariation_410_Arg, Tuple[Literal["SPI"], RuleVariation_410_Arg]], Union[RuleVariation_497_Arg, Tuple[Literal["MRH"], RuleVariation_497_Arg]], Union[RuleVariation_675_Arg, Tuple[Literal["SRC"], RuleVariation_675_Arg]], Union[RuleVariation_874_Arg, Tuple[Literal["CNF"], RuleVariation_874_Arg]], None]]
Variation_1363_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_6_Arg, Tuple[Literal["SIM"], RuleVariation_6_Arg]], Union[RuleVariation_409_Arg, Tuple[Literal["TSE"], RuleVariation_409_Arg]], Union[RuleVariation_517_Arg, Tuple[Literal["TSB"], RuleVariation_517_Arg]], Union[RuleVariation_644_Arg, Tuple[Literal["FPC"], RuleVariation_644_Arg]], Union[RuleVariation_702_Arg, Tuple[Literal["AFF"], RuleVariation_702_Arg]], Union[RuleVariation_813_Arg, Tuple[Literal["STP"], RuleVariation_813_Arg]], Union[RuleVariation_872_Arg, Tuple[Literal["KOS"], RuleVariation_872_Arg]], None]]
Variation_1363_Arg_Group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_89_Arg, Tuple[Literal["AMA"], RuleVariation_89_Arg]], Union[RuleVariation_456_Arg, Tuple[Literal["MD4"], RuleVariation_456_Arg]], Union[RuleVariation_622_Arg, Tuple[Literal["ME"], RuleVariation_622_Arg]], Union[RuleVariation_705_Arg, Tuple[Literal["MI"], RuleVariation_705_Arg]], Union[RuleVariation_849_Arg, Tuple[Literal["MD5"], RuleVariation_849_Arg]], None]]
Variation_1363_Arg_Group_4: TypeAlias = Union[int, Tuple[Union[RuleVariation_37_Arg, Tuple[Literal["CST"], RuleVariation_37_Arg]], Union[RuleVariation_407_Arg, Tuple[Literal["PSR"], RuleVariation_407_Arg]], Union[RuleVariation_514_Arg, Tuple[Literal["SSR"], RuleVariation_514_Arg]], Union[RuleVariation_621_Arg, Tuple[Literal["MDS"], RuleVariation_621_Arg]], Union[RuleVariation_704_Arg, Tuple[Literal["ADS"], RuleVariation_704_Arg]], Union[RuleVariation_814_Arg, Tuple[Literal["SUC"], RuleVariation_814_Arg]], Union[RuleVariation_890_Arg, Tuple[Literal["AAC"], RuleVariation_890_Arg]], None]]
Variation_1363_Arg_Group_5: TypeAlias = Union[int, Tuple[Union[RuleVariation_99_Arg, Tuple[Literal["SDS"], RuleVariation_99_Arg]], Union[RuleVariation_587_Arg, Tuple[Literal["EMS"], RuleVariation_587_Arg]], Union[RuleVariation_830_Arg, Tuple[Literal["PFT"], RuleVariation_830_Arg]], Union[RuleVariation_892_Arg, Tuple[Literal["FPLT"], RuleVariation_892_Arg]], None]]
Variation_1363_Arg_Group_6: TypeAlias = Union[int, Tuple[Union[RuleVariation_38_Arg, Tuple[Literal["DUPT"], RuleVariation_38_Arg]], Union[RuleVariation_408_Arg, Tuple[Literal["DUPF"], RuleVariation_408_Arg]], Union[RuleVariation_516_Arg, Tuple[Literal["DUPM"], RuleVariation_516_Arg]], Union[RuleVariation_623_Arg, Tuple[Literal["SFC"], RuleVariation_623_Arg]], Union[RuleVariation_726_Arg, Tuple[Literal["IDD"], RuleVariation_726_Arg]], Union[RuleVariation_811_Arg, Tuple[Literal["IEC"], RuleVariation_811_Arg]], Union[RuleVariation_889_Arg, Tuple[Literal["MLAT"], RuleVariation_889_Arg]], None]]
Variation_1363_Arg: TypeAlias = Union[
    Tuple[Variation_1363_Arg_Group_1],
    Tuple[Variation_1363_Arg_Group_1, Variation_1363_Arg_Group_2],
    Tuple[Variation_1363_Arg_Group_1, Variation_1363_Arg_Group_2, Variation_1363_Arg_Group_3],
    Tuple[Variation_1363_Arg_Group_1, Variation_1363_Arg_Group_2, Variation_1363_Arg_Group_3, Variation_1363_Arg_Group_4],
    Tuple[Variation_1363_Arg_Group_1, Variation_1363_Arg_Group_2, Variation_1363_Arg_Group_3, Variation_1363_Arg_Group_4, Variation_1363_Arg_Group_5],
    Tuple[Variation_1363_Arg_Group_1, Variation_1363_Arg_Group_2, Variation_1363_Arg_Group_3, Variation_1363_Arg_Group_4, Variation_1363_Arg_Group_5, Variation_1363_Arg_Group_6],
]
class Variation_1363(Extended):
    cv_items_list = [[(Item_576, 1), (Item_908, 1), (Item_579, 1), (Item_920, 3), (Item_166, 1), None], [(Item_896, 1), (Item_1043, 1), (Item_1041, 1), (Item_336, 1), (Item_50, 1), (Item_953, 1), (Item_439, 1), None], [(Item_71, 1), (Item_533, 2), (Item_540, 1), (Item_547, 1), (Item_534, 2), None], [(Item_219, 1), (Item_709, 1), (Item_925, 1), (Item_535, 1), (Item_46, 1), (Item_960, 1), (Item_34, 1), None], [(Item_871, 2), (Item_292, 3), (Item_677, 1), (Item_337, 1), None], [(Item_281, 1), (Item_279, 1), (Item_280, 1), (Item_878, 1), (Item_427, 1), (Item_430, 1), (Item_555, 1), None]]

    @classmethod
    def create(cls, arg : Variation_1363_Arg) -> 'Variation_1363':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MON"]) -> RuleVariation_54:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> RuleVariation_410:
        ...
    @overload
    def get_item(self, key : Literal["MRH"]) -> RuleVariation_497:
        ...
    @overload
    def get_item(self, key : Literal["SRC"]) -> RuleVariation_675:
        ...
    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_874:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_6]:
        ...
    @overload
    def get_item(self, key : Literal["TSE"]) -> Optional[RuleVariation_409]:
        ...
    @overload
    def get_item(self, key : Literal["TSB"]) -> Optional[RuleVariation_517]:
        ...
    @overload
    def get_item(self, key : Literal["FPC"]) -> Optional[RuleVariation_644]:
        ...
    @overload
    def get_item(self, key : Literal["AFF"]) -> Optional[RuleVariation_702]:
        ...
    @overload
    def get_item(self, key : Literal["STP"]) -> Optional[RuleVariation_813]:
        ...
    @overload
    def get_item(self, key : Literal["KOS"]) -> Optional[RuleVariation_872]:
        ...
    @overload
    def get_item(self, key : Literal["AMA"]) -> Optional[RuleVariation_89]:
        ...
    @overload
    def get_item(self, key : Literal["MD4"]) -> Optional[RuleVariation_456]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_622]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_705]:
        ...
    @overload
    def get_item(self, key : Literal["MD5"]) -> Optional[RuleVariation_849]:
        ...
    @overload
    def get_item(self, key : Literal["CST"]) -> Optional[RuleVariation_37]:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[RuleVariation_407]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[RuleVariation_514]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[RuleVariation_621]:
        ...
    @overload
    def get_item(self, key : Literal["ADS"]) -> Optional[RuleVariation_704]:
        ...
    @overload
    def get_item(self, key : Literal["SUC"]) -> Optional[RuleVariation_814]:
        ...
    @overload
    def get_item(self, key : Literal["AAC"]) -> Optional[RuleVariation_890]:
        ...
    @overload
    def get_item(self, key : Literal["SDS"]) -> Optional[RuleVariation_99]:
        ...
    @overload
    def get_item(self, key : Literal["EMS"]) -> Optional[RuleVariation_587]:
        ...
    @overload
    def get_item(self, key : Literal["PFT"]) -> Optional[RuleVariation_830]:
        ...
    @overload
    def get_item(self, key : Literal["FPLT"]) -> Optional[RuleVariation_892]:
        ...
    @overload
    def get_item(self, key : Literal["DUPT"]) -> Optional[RuleVariation_38]:
        ...
    @overload
    def get_item(self, key : Literal["DUPF"]) -> Optional[RuleVariation_408]:
        ...
    @overload
    def get_item(self, key : Literal["DUPM"]) -> Optional[RuleVariation_516]:
        ...
    @overload
    def get_item(self, key : Literal["SFC"]) -> Optional[RuleVariation_623]:
        ...
    @overload
    def get_item(self, key : Literal["IDD"]) -> Optional[RuleVariation_726]:
        ...
    @overload
    def get_item(self, key : Literal["IEC"]) -> Optional[RuleVariation_811]:
        ...
    @overload
    def get_item(self, key : Literal["MLAT"]) -> Optional[RuleVariation_889]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1286_Arg: TypeAlias = Variation_1363_Arg
class RuleVariation_1286(RuleVariationContextFree):
    cv_variation = Variation_1363

    @classmethod
    def create(cls, arg : RuleVariation_1286_Arg) -> "RuleVariation_1286":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1363:
        return self.arg # type: ignore

NonSpare_237_Arg: TypeAlias = RuleVariation_1286_Arg
class NonSpare_237(NonSpare):
    cv_name = "080"
    cv_title = "Track Status"
    cv_rule = RuleVariation_1286

    @classmethod
    def create(cls, arg : NonSpare_237_Arg) -> "NonSpare_237":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1286:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1363:
        return self.rule.variation

class UapItem_237(UapItem):
    cv_non_spare = NonSpare_237

Record_42_Arg = TypedDict('Record_42_Arg', {
    "010": NonSpare_45_Arg,
    "015": NonSpare_58_Arg,
    "070": NonSpare_213_Arg,
    "105": NonSpare_277_Arg,
    "100": NonSpare_264_Arg,
    "185": NonSpare_381_Arg,
    "210": NonSpare_405_Arg,
    "060": NonSpare_198_Arg,
    "245": NonSpare_435_Arg,
    "380": NonSpare_481_Arg,
    "040": NonSpare_147_Arg,
    "080": NonSpare_237_Arg,
    "290": NonSpare_465_Arg,
    "200": NonSpare_389_Arg,
    "295": NonSpare_468_Arg,
    "136": NonSpare_315_Arg,
    "130": NonSpare_301_Arg,
    "135": NonSpare_314_Arg,
    "220": NonSpare_417_Arg,
    "390": NonSpare_489_Arg,
    "270": NonSpare_457_Arg,
    "300": NonSpare_472_Arg,
    "110": NonSpare_285_Arg,
    "120": NonSpare_300_Arg,
    "510": NonSpare_515_Arg,
    "500": NonSpare_510_Arg,
    "340": NonSpare_476_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_42(Record):
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_45, UapItem_544, UapItem_58, UapItem_213, UapItem_277, UapItem_264, UapItem_381, UapItem_405, UapItem_198, UapItem_435, UapItem_481, UapItem_147, UapItem_237, UapItem_465, UapItem_389, UapItem_468, UapItem_315, UapItem_301, UapItem_314, UapItem_417, UapItem_489, UapItem_457, UapItem_472, UapItem_285, UapItem_300, UapItem_514, UapItem_509, UapItem_476, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_45, "015": NonSpare_58, "070": NonSpare_213, "105": NonSpare_277, "100": NonSpare_264, "185": NonSpare_381, "210": NonSpare_405, "060": NonSpare_198, "245": NonSpare_435, "380": NonSpare_481, "040": NonSpare_147, "080": NonSpare_237, "290": NonSpare_465, "200": NonSpare_389, "295": NonSpare_468, "136": NonSpare_315, "130": NonSpare_301, "135": NonSpare_314, "220": NonSpare_417, "390": NonSpare_489, "270": NonSpare_457, "300": NonSpare_472, "110": NonSpare_285, "120": NonSpare_300, "510": NonSpare_515, "500": NonSpare_510, "340": NonSpare_476, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_45:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_58:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_213:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["105"]) -> NonSpare_277:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_264:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["185"]) -> NonSpare_381:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_405:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_198:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_435:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["380"]) -> NonSpare_481:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_147:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_237:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["290"]) -> NonSpare_465:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_389:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_468:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["136"]) -> NonSpare_315:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_301:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["135"]) -> NonSpare_314:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_417:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["390"]) -> NonSpare_489:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["270"]) -> NonSpare_457:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_472:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_285:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_300:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["510"]) -> NonSpare_515:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_510:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["340"]) -> NonSpare_476:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["070"], Literal["105"], Literal["100"], Literal["185"], Literal["210"], Literal["060"], Literal["245"], Literal["380"], Literal["040"], Literal["080"], Literal["290"], Literal["200"], Literal["295"], Literal["136"], Literal["130"], Literal["135"], Literal["220"], Literal["390"], Literal["270"], Literal["300"], Literal["110"], Literal["120"], Literal["510"], Literal["500"], Literal["340"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_45]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_58]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_213]:
        ...
    @overload
    def get_item(self, key : Literal["105"]) -> Optional[NonSpare_277]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_264]:
        ...
    @overload
    def get_item(self, key : Literal["185"]) -> Optional[NonSpare_381]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_405]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_198]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_435]:
        ...
    @overload
    def get_item(self, key : Literal["380"]) -> Optional[NonSpare_481]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_147]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_237]:
        ...
    @overload
    def get_item(self, key : Literal["290"]) -> Optional[NonSpare_465]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_389]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_468]:
        ...
    @overload
    def get_item(self, key : Literal["136"]) -> Optional[NonSpare_315]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_301]:
        ...
    @overload
    def get_item(self, key : Literal["135"]) -> Optional[NonSpare_314]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_417]:
        ...
    @overload
    def get_item(self, key : Literal["390"]) -> Optional[NonSpare_489]:
        ...
    @overload
    def get_item(self, key : Literal["270"]) -> Optional[NonSpare_457]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_472]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_285]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_300]:
        ...
    @overload
    def get_item(self, key : Literal["510"]) -> Optional[NonSpare_515]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_510]:
        ...
    @overload
    def get_item(self, key : Literal["340"]) -> Optional[NonSpare_476]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_45_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_58_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_213_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["105"], val : NonSpare_277_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_264_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["185"], val : NonSpare_381_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_405_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_198_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_435_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["380"], val : NonSpare_481_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_147_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_237_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["290"], val : NonSpare_465_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_389_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_468_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["136"], val : NonSpare_315_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_301_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["135"], val : NonSpare_314_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_417_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["390"], val : NonSpare_489_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["270"], val : NonSpare_457_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_472_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_285_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_300_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["510"], val : NonSpare_515_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_510_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["340"], val : NonSpare_476_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_42':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["105"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["185"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["380"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["290"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["136"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["135"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["390"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["270"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["510"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["340"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_42':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_42_Arg) -> 'Record_42':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_42", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_38_Arg: TypeAlias = Record_42
class Uap_38(UapSingle):
    cv_record = Record_42

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_42]]:
        return cls._parse(bs)

class Asterix_54(AstCat):
    cv_category = 62
    cv_edition = (1, 20)
    cv_uap = Uap_38

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_38_Arg]) -> "Asterix_54":
        return cls._create(records) # type: ignore

NonSpare_64_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_64(NonSpare):
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_64_Arg) -> "NonSpare_64":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_64(UapItem):
    cv_non_spare = NonSpare_64

NonSpare_111_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_111(NonSpare):
    cv_name = "030"
    cv_title = "Time of Message"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_111_Arg) -> "NonSpare_111":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_111(UapItem):
    cv_non_spare = NonSpare_111

NonSpare_174_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_174(NonSpare):
    cv_name = "050"
    cv_title = "Sensor Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_174_Arg) -> "NonSpare_174":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_174(UapItem):
    cv_non_spare = NonSpare_174

Content_408_Arg: TypeAlias = int
class Content_408(ContentTable):
    cv_values = {0: "Operational", 1: "Degraded", 2: "Initialization", 3: "Not currently connected"}

RuleContent_408_Arg: TypeAlias = Content_408_Arg
class RuleContent_408(RuleContentContextFree):
    cv_content = Content_408

    @property
    def content(self) -> Content_408:
        return self._get_content() # type: ignore

Variation_106_Arg: TypeAlias = RuleContent_408_Arg
class Variation_106(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_408

    @classmethod
    def create(cls, arg : Variation_106_Arg) -> "Variation_106":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_408:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_408:
        return self.rule.content

RuleVariation_106_Arg: TypeAlias = Variation_106_Arg
class RuleVariation_106(RuleVariationContextFree):
    cv_variation = Variation_106

    @classmethod
    def create(cls, arg : RuleVariation_106_Arg) -> "RuleVariation_106":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_106:
        return self.arg # type: ignore

Content_422_Arg: TypeAlias = int
class Content_422(ContentTable):
    cv_values = {0: "PSR GO", 1: "PSR NOGO"}

RuleContent_422_Arg: TypeAlias = Content_422_Arg
class RuleContent_422(RuleContentContextFree):
    cv_content = Content_422

    @property
    def content(self) -> Content_422:
        return self._get_content() # type: ignore

Variation_569_Arg: TypeAlias = RuleContent_422_Arg
class Variation_569(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_422

    @classmethod
    def create(cls, arg : Variation_569_Arg) -> "Variation_569":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_422:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_422:
        return self.rule.content

RuleVariation_558_Arg: TypeAlias = Variation_569_Arg
class RuleVariation_558(RuleVariationContextFree):
    cv_variation = Variation_569

    @classmethod
    def create(cls, arg : RuleVariation_558_Arg) -> "RuleVariation_558":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_569:
        return self.arg # type: ignore

Content_448_Arg: TypeAlias = int
class Content_448(ContentTable):
    cv_values = {0: "SSR GO", 1: "SSR NOGO"}

RuleContent_448_Arg: TypeAlias = Content_448_Arg
class RuleContent_448(RuleContentContextFree):
    cv_content = Content_448

    @property
    def content(self) -> Content_448:
        return self._get_content() # type: ignore

Variation_658_Arg: TypeAlias = RuleContent_448_Arg
class Variation_658(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_448

    @classmethod
    def create(cls, arg : Variation_658_Arg) -> "Variation_658":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_448:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_448:
        return self.rule.content

RuleVariation_647_Arg: TypeAlias = Variation_658_Arg
class RuleVariation_647(RuleVariationContextFree):
    cv_variation = Variation_658

    @classmethod
    def create(cls, arg : RuleVariation_647_Arg) -> "RuleVariation_647":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_658:
        return self.arg # type: ignore

Content_259_Arg: TypeAlias = int
class Content_259(ContentTable):
    cv_values = {0: "MDS GO", 1: "MDS NOGO"}

RuleContent_259_Arg: TypeAlias = Content_259_Arg
class RuleContent_259(RuleContentContextFree):
    cv_content = Content_259

    @property
    def content(self) -> Content_259:
        return self._get_content() # type: ignore

Variation_727_Arg: TypeAlias = RuleContent_259_Arg
class Variation_727(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_259

    @classmethod
    def create(cls, arg : Variation_727_Arg) -> "Variation_727":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_259:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_259:
        return self.rule.content

RuleVariation_716_Arg: TypeAlias = Variation_727_Arg
class RuleVariation_716(RuleVariationContextFree):
    cv_variation = Variation_727

    @classmethod
    def create(cls, arg : RuleVariation_716_Arg) -> "RuleVariation_716":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_727:
        return self.arg # type: ignore

Content_9_Arg: TypeAlias = int
class Content_9(ContentTable):
    cv_values = {0: "ADS GO", 1: "ADS NOGO"}

RuleContent_9_Arg: TypeAlias = Content_9_Arg
class RuleContent_9(RuleContentContextFree):
    cv_content = Content_9

    @property
    def content(self) -> Content_9:
        return self._get_content() # type: ignore

Variation_815_Arg: TypeAlias = RuleContent_9_Arg
class Variation_815(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_9

    @classmethod
    def create(cls, arg : Variation_815_Arg) -> "Variation_815":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_9:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_9:
        return self.rule.content

RuleVariation_785_Arg: TypeAlias = Variation_815_Arg
class RuleVariation_785(RuleVariationContextFree):
    cv_variation = Variation_815

    @classmethod
    def create(cls, arg : RuleVariation_785_Arg) -> "RuleVariation_785":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_815:
        return self.arg # type: ignore

Content_260_Arg: TypeAlias = int
class Content_260(ContentTable):
    cv_values = {0: "MLT GO", 1: "MLT NOGO"}

RuleContent_260_Arg: TypeAlias = Content_260_Arg
class RuleContent_260(RuleContentContextFree):
    cv_content = Content_260

    @property
    def content(self) -> Content_260:
        return self._get_content() # type: ignore

Variation_933_Arg: TypeAlias = RuleContent_260_Arg
class Variation_933(Element):
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_260

    @classmethod
    def create(cls, arg : Variation_933_Arg) -> "Variation_933":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_260:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_260:
        return self.rule.content

RuleVariation_903_Arg: TypeAlias = Variation_933_Arg
class RuleVariation_903(RuleVariationContextFree):
    cv_variation = Variation_933

    @classmethod
    def create(cls, arg : RuleVariation_903_Arg) -> "RuleVariation_903":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_933:
        return self.arg # type: ignore

Content_459_Arg: TypeAlias = int
class Content_459(ContentTable):
    cv_values = {0: "System is released for operational use", 1: "Operational use of System is inhibited"}

RuleContent_459_Arg: TypeAlias = Content_459_Arg
class RuleContent_459(RuleContentContextFree):
    cv_content = Content_459

    @property
    def content(self) -> Content_459:
        return self._get_content() # type: ignore

Variation_76_Arg: TypeAlias = RuleContent_459_Arg
class Variation_76(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_459

    @classmethod
    def create(cls, arg : Variation_76_Arg) -> "Variation_76":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_459:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_459:
        return self.rule.content

RuleVariation_76_Arg: TypeAlias = Variation_76_Arg
class RuleVariation_76(RuleVariationContextFree):
    cv_variation = Variation_76

    @classmethod
    def create(cls, arg : RuleVariation_76_Arg) -> "RuleVariation_76":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_76:
        return self.arg # type: ignore

Variation_645_Arg: TypeAlias = RuleContent_293_Arg
class Variation_645(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_293

    @classmethod
    def create(cls, arg : Variation_645_Arg) -> "Variation_645":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_293:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_293:
        return self.rule.content

RuleVariation_634_Arg: TypeAlias = Variation_645_Arg
class RuleVariation_634(RuleVariationContextFree):
    cv_variation = Variation_645

    @classmethod
    def create(cls, arg : RuleVariation_634_Arg) -> "RuleVariation_634":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_645:
        return self.arg # type: ignore

Content_168_Arg: TypeAlias = int
class Content_168(ContentTable):
    cv_values = {0: "Default (no meaning)", 1: "No plots being received"}

RuleContent_168_Arg: TypeAlias = Content_168_Arg
class RuleContent_168(RuleContentContextFree):
    cv_content = Content_168

    @property
    def content(self) -> Content_168:
        return self._get_content() # type: ignore

Variation_840_Arg: TypeAlias = RuleContent_168_Arg
class Variation_840(Element):
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_168

    @classmethod
    def create(cls, arg : Variation_840_Arg) -> "Variation_840":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_168:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_168:
        return self.rule.content

RuleVariation_810_Arg: TypeAlias = Variation_840_Arg
class RuleVariation_810(RuleVariationContextFree):
    cv_variation = Variation_840

    @classmethod
    def create(cls, arg : RuleVariation_810_Arg) -> "RuleVariation_810":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_840:
        return self.arg # type: ignore

NonSpare_785_Arg: TypeAlias = RuleVariation_106_Arg
class NonSpare_785(NonSpare):
    cv_name = "CON"
    cv_title = ""
    cv_rule = RuleVariation_106

    @classmethod
    def create(cls, arg : NonSpare_785_Arg) -> "NonSpare_785":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_106:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_106:
        return self.rule.variation

Item_190_Arg: TypeAlias = NonSpare_785_Arg
class Item_190(Item):
    cv_non_spare = NonSpare_785

    @classmethod
    def create(cls, arg : Item_190_Arg) -> "Item_190":
        return cls._create(arg) # type: ignore

NonSpare_1463_Arg: TypeAlias = RuleVariation_558_Arg
class NonSpare_1463(NonSpare):
    cv_name = "PSR"
    cv_title = ""
    cv_rule = RuleVariation_558

    @classmethod
    def create(cls, arg : NonSpare_1463_Arg) -> "NonSpare_1463":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_558:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_569:
        return self.rule.variation

Item_710_Arg: TypeAlias = NonSpare_1463_Arg
class Item_710(Item):
    cv_non_spare = NonSpare_1463

    @classmethod
    def create(cls, arg : Item_710_Arg) -> "Item_710":
        return cls._create(arg) # type: ignore

NonSpare_1750_Arg: TypeAlias = RuleVariation_647_Arg
class NonSpare_1750(NonSpare):
    cv_name = "SSR"
    cv_title = ""
    cv_rule = RuleVariation_647

    @classmethod
    def create(cls, arg : NonSpare_1750_Arg) -> "NonSpare_1750":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_647:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_658:
        return self.rule.variation

Item_926_Arg: TypeAlias = NonSpare_1750_Arg
class Item_926(Item):
    cv_non_spare = NonSpare_1750

    @classmethod
    def create(cls, arg : Item_926_Arg) -> "Item_926":
        return cls._create(arg) # type: ignore

NonSpare_1247_Arg: TypeAlias = RuleVariation_716_Arg
class NonSpare_1247(NonSpare):
    cv_name = "MDS"
    cv_title = ""
    cv_rule = RuleVariation_716

    @classmethod
    def create(cls, arg : NonSpare_1247_Arg) -> "NonSpare_1247":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_716:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_727:
        return self.rule.variation

Item_536_Arg: TypeAlias = NonSpare_1247_Arg
class Item_536(Item):
    cv_non_spare = NonSpare_1247

    @classmethod
    def create(cls, arg : Item_536_Arg) -> "Item_536":
        return cls._create(arg) # type: ignore

NonSpare_570_Arg: TypeAlias = RuleVariation_785_Arg
class NonSpare_570(NonSpare):
    cv_name = "ADS"
    cv_title = ""
    cv_rule = RuleVariation_785

    @classmethod
    def create(cls, arg : NonSpare_570_Arg) -> "NonSpare_570":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_785:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_815:
        return self.rule.variation

Item_47_Arg: TypeAlias = NonSpare_570_Arg
class Item_47(Item):
    cv_non_spare = NonSpare_570

    @classmethod
    def create(cls, arg : Item_47_Arg) -> "Item_47":
        return cls._create(arg) # type: ignore

NonSpare_1283_Arg: TypeAlias = RuleVariation_903_Arg
class NonSpare_1283(NonSpare):
    cv_name = "MLT"
    cv_title = ""
    cv_rule = RuleVariation_903

    @classmethod
    def create(cls, arg : NonSpare_1283_Arg) -> "NonSpare_1283":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_903:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_933:
        return self.rule.variation

Item_556_Arg: TypeAlias = NonSpare_1283_Arg
class Item_556(Item):
    cv_non_spare = NonSpare_1283

    @classmethod
    def create(cls, arg : Item_556_Arg) -> "Item_556":
        return cls._create(arg) # type: ignore

NonSpare_1391_Arg: TypeAlias = RuleVariation_76_Arg
class NonSpare_1391(NonSpare):
    cv_name = "OPS"
    cv_title = "Operational Release Status of the System"
    cv_rule = RuleVariation_76

    @classmethod
    def create(cls, arg : NonSpare_1391_Arg) -> "NonSpare_1391":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_76:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_76:
        return self.rule.variation

Item_656_Arg: TypeAlias = NonSpare_1391_Arg
class Item_656(Item):
    cv_non_spare = NonSpare_1391

    @classmethod
    def create(cls, arg : Item_656_Arg) -> "Item_656":
        return cls._create(arg) # type: ignore

NonSpare_1407_Arg: TypeAlias = RuleVariation_519_Arg
class NonSpare_1407(NonSpare):
    cv_name = "OXT"
    cv_title = "Transmission Subsystem Overload Status"
    cv_rule = RuleVariation_519

    @classmethod
    def create(cls, arg : NonSpare_1407_Arg) -> "NonSpare_1407":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_519:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_530:
        return self.rule.variation

Item_671_Arg: TypeAlias = NonSpare_1407_Arg
class Item_671(Item):
    cv_non_spare = NonSpare_1407

    @classmethod
    def create(cls, arg : Item_671_Arg) -> "Item_671":
        return cls._create(arg) # type: ignore

NonSpare_1315_Arg: TypeAlias = RuleVariation_634_Arg
class NonSpare_1315(NonSpare):
    cv_name = "MSC"
    cv_title = "Monitoring System Connected Status"
    cv_rule = RuleVariation_634

    @classmethod
    def create(cls, arg : NonSpare_1315_Arg) -> "NonSpare_1315":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_634:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_645:
        return self.rule.variation

Item_585_Arg: TypeAlias = NonSpare_1315_Arg
class Item_585(Item):
    cv_non_spare = NonSpare_1315

    @classmethod
    def create(cls, arg : Item_585_Arg) -> "Item_585":
        return cls._create(arg) # type: ignore

NonSpare_1371_Arg: TypeAlias = RuleVariation_810_Arg
class NonSpare_1371(NonSpare):
    cv_name = "NPW"
    cv_title = "No Plot Warning"
    cv_rule = RuleVariation_810

    @classmethod
    def create(cls, arg : NonSpare_1371_Arg) -> "NonSpare_1371":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_810:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_840:
        return self.rule.variation

Item_636_Arg: TypeAlias = NonSpare_1371_Arg
class Item_636(Item):
    cv_non_spare = NonSpare_1371

    @classmethod
    def create(cls, arg : Item_636_Arg) -> "Item_636":
        return cls._create(arg) # type: ignore

Variation_1348_Arg_Group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_106_Arg, Tuple[Literal["CON"], RuleVariation_106_Arg]], Union[RuleVariation_558_Arg, Tuple[Literal["PSR"], RuleVariation_558_Arg]], Union[RuleVariation_647_Arg, Tuple[Literal["SSR"], RuleVariation_647_Arg]], Union[RuleVariation_716_Arg, Tuple[Literal["MDS"], RuleVariation_716_Arg]], Union[RuleVariation_785_Arg, Tuple[Literal["ADS"], RuleVariation_785_Arg]], Union[RuleVariation_903_Arg, Tuple[Literal["MLT"], RuleVariation_903_Arg]], None]]
Variation_1348_Arg_Group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_76_Arg, Tuple[Literal["OPS"], RuleVariation_76_Arg]], Union[RuleVariation_412_Arg, Tuple[Literal["ODP"], RuleVariation_412_Arg]], Union[RuleVariation_519_Arg, Tuple[Literal["OXT"], RuleVariation_519_Arg]], Union[RuleVariation_634_Arg, Tuple[Literal["MSC"], RuleVariation_634_Arg]], Union[RuleVariation_746_Arg, Tuple[Literal["TSV"], RuleVariation_746_Arg]], Union[RuleVariation_810_Arg, Tuple[Literal["NPW"], RuleVariation_810_Arg]], int, None]]
Variation_1348_Arg: TypeAlias = Union[
    Tuple[Variation_1348_Arg_Group_1],
    Tuple[Variation_1348_Arg_Group_1, Variation_1348_Arg_Group_2],
]
class Variation_1348(Extended):
    cv_items_list = [[(Item_190, 2), (Item_710, 1), (Item_926, 1), (Item_536, 1), (Item_47, 1), (Item_556, 1), None], [(Item_656, 1), (Item_650, 1), (Item_671, 1), (Item_585, 1), (Item_1056, 1), (Item_636, 1), (Item_26, 1), None]]

    @classmethod
    def create(cls, arg : Variation_1348_Arg) -> 'Variation_1348':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["CON"]) -> RuleVariation_106:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> RuleVariation_558:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> RuleVariation_647:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> RuleVariation_716:
        ...
    @overload
    def get_item(self, key : Literal["ADS"]) -> RuleVariation_785:
        ...
    @overload
    def get_item(self, key : Literal["MLT"]) -> RuleVariation_903:
        ...
    @overload
    def get_item(self, key : Literal["OPS"]) -> Optional[RuleVariation_76]:
        ...
    @overload
    def get_item(self, key : Literal["ODP"]) -> Optional[RuleVariation_412]:
        ...
    @overload
    def get_item(self, key : Literal["OXT"]) -> Optional[RuleVariation_519]:
        ...
    @overload
    def get_item(self, key : Literal["MSC"]) -> Optional[RuleVariation_634]:
        ...
    @overload
    def get_item(self, key : Literal["TSV"]) -> Optional[RuleVariation_746]:
        ...
    @overload
    def get_item(self, key : Literal["NPW"]) -> Optional[RuleVariation_810]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

RuleVariation_1271_Arg: TypeAlias = Variation_1348_Arg
class RuleVariation_1271(RuleVariationContextFree):
    cv_variation = Variation_1348

    @classmethod
    def create(cls, arg : RuleVariation_1271_Arg) -> "RuleVariation_1271":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1348:
        return self.arg # type: ignore

NonSpare_193_Arg: TypeAlias = RuleVariation_1271_Arg
class NonSpare_193(NonSpare):
    cv_name = "060"
    cv_title = "Sensor Configuration and Status"
    cv_rule = RuleVariation_1271

    @classmethod
    def create(cls, arg : NonSpare_193_Arg) -> "NonSpare_193":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1271:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1348:
        return self.rule.variation

class UapItem_193(UapItem):
    cv_non_spare = NonSpare_193

Content_627_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["ms"]]]
class Content_627(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.0
    cv_unit = "ms"

    def as_quantity(self, cv_unit : Optional[Literal["ms"]] = None) -> float:
        return self._as_quantity()

RuleContent_627_Arg: TypeAlias = Content_627_Arg
class RuleContent_627(RuleContentContextFree):
    cv_content = Content_627

    @property
    def content(self) -> Content_627:
        return self._get_content() # type: ignore

Variation_258_Arg: TypeAlias = RuleContent_627_Arg
class Variation_258(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_627

    @classmethod
    def create(cls, arg : Variation_258_Arg) -> "Variation_258":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_627:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_627:
        return self.rule.content

RuleVariation_251_Arg: TypeAlias = Variation_258_Arg
class RuleVariation_251(RuleVariationContextFree):
    cv_variation = Variation_258

    @classmethod
    def create(cls, arg : RuleVariation_251_Arg) -> "RuleVariation_251":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_258:
        return self.arg # type: ignore

NonSpare_214_Arg: TypeAlias = RuleVariation_251_Arg
class NonSpare_214(NonSpare):
    cv_name = "070"
    cv_title = "Time Stamping Bias"
    cv_rule = RuleVariation_251

    @classmethod
    def create(cls, arg : NonSpare_214_Arg) -> "NonSpare_214":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_251:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_258:
        return self.rule.variation

class UapItem_214(UapItem):
    cv_non_spare = NonSpare_214

Content_648_Arg: TypeAlias = Union[int, float, Tuple[float, Literal[""]]]
class Content_648(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.0e-5
    cv_unit = ""

    def as_quantity(self, cv_unit : Optional[Literal[""]] = None) -> float:
        return self._as_quantity()

RuleContent_648_Arg: TypeAlias = Content_648_Arg
class RuleContent_648(RuleContentContextFree):
    cv_content = Content_648

    @property
    def content(self) -> Content_648:
        return self._get_content() # type: ignore

Variation_269_Arg: TypeAlias = RuleContent_648_Arg
class Variation_269(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_648

    @classmethod
    def create(cls, arg : Variation_269_Arg) -> "Variation_269":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_648:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_648:
        return self.rule.content

RuleVariation_262_Arg: TypeAlias = Variation_269_Arg
class RuleVariation_262(RuleVariationContextFree):
    cv_variation = Variation_269

    @classmethod
    def create(cls, arg : RuleVariation_262_Arg) -> "RuleVariation_262":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_269:
        return self.arg # type: ignore

NonSpare_1743_Arg: TypeAlias = RuleVariation_262_Arg
class NonSpare_1743(NonSpare):
    cv_name = "SRG"
    cv_title = "Mode S Range Gain"
    cv_rule = RuleVariation_262

    @classmethod
    def create(cls, arg : NonSpare_1743_Arg) -> "NonSpare_1743":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_262:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_269:
        return self.rule.variation

Item_921_Arg: TypeAlias = NonSpare_1743_Arg
class Item_921(Item):
    cv_non_spare = NonSpare_1743

    @classmethod
    def create(cls, arg : Item_921_Arg) -> "Item_921":
        return cls._create(arg) # type: ignore

Variation_284_Arg: TypeAlias = RuleContent_674_Arg
class Variation_284(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_674

    @classmethod
    def create(cls, arg : Variation_284_Arg) -> "Variation_284":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_674:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_674:
        return self.rule.content

RuleVariation_277_Arg: TypeAlias = Variation_284_Arg
class RuleVariation_277(RuleVariationContextFree):
    cv_variation = Variation_284

    @classmethod
    def create(cls, arg : RuleVariation_277_Arg) -> "RuleVariation_277":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_284:
        return self.arg # type: ignore

NonSpare_1737_Arg: TypeAlias = RuleVariation_277_Arg
class NonSpare_1737(NonSpare):
    cv_name = "SRB"
    cv_title = "Mode S Range Bias"
    cv_rule = RuleVariation_277

    @classmethod
    def create(cls, arg : NonSpare_1737_Arg) -> "NonSpare_1737":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_277:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_284:
        return self.rule.variation

Item_916_Arg: TypeAlias = NonSpare_1737_Arg
class Item_916(Item):
    cv_non_spare = NonSpare_1737

    @classmethod
    def create(cls, arg : Item_916_Arg) -> "Item_916":
        return cls._create(arg) # type: ignore

Variation_1206_Arg_Group = Tuple[Union[RuleVariation_262_Arg, Tuple[Literal["SRG"], RuleVariation_262_Arg]], Union[RuleVariation_277_Arg, Tuple[Literal["SRB"], RuleVariation_277_Arg]]]
Variation_1206_Arg: TypeAlias = Union[int, Variation_1206_Arg_Group]
class Variation_1206(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_921, 16), (Item_916, 16)]
    cv_items_dict = {"SRG": RuleVariation_262, "SRB": RuleVariation_277}

    @overload
    @classmethod
    def spec(cls, key : Literal["SRG"]) -> RuleVariation_262:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SRB"]) -> RuleVariation_277:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SRG"], Literal["SRB"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SRG"]) -> RuleVariation_262:
        ...
    @overload
    def get_item(self, key : Literal["SRB"]) -> RuleVariation_277:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1206_Arg) -> 'Variation_1206':
        return cls._create(arg) # type: ignore

RuleVariation_1151_Arg: TypeAlias = Variation_1206_Arg
class RuleVariation_1151(RuleVariationContextFree):
    cv_variation = Variation_1206

    @classmethod
    def create(cls, arg : RuleVariation_1151_Arg) -> "RuleVariation_1151":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1206:
        return self.arg # type: ignore

NonSpare_231_Arg: TypeAlias = RuleVariation_1151_Arg
class NonSpare_231(NonSpare):
    cv_name = "080"
    cv_title = "SSR / Mode S Range Gain and Bias"
    cv_rule = RuleVariation_1151

    @classmethod
    def create(cls, arg : NonSpare_231_Arg) -> "NonSpare_231":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1151:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1206:
        return self.rule.variation

class UapItem_231(UapItem):
    cv_non_spare = NonSpare_231

Content_706_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_706(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 5.4931640625e-3
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_706_Arg: TypeAlias = Content_706_Arg
class RuleContent_706(RuleContentContextFree):
    cv_content = Content_706

    @property
    def content(self) -> Content_706:
        return self._get_content() # type: ignore

Variation_297_Arg: TypeAlias = RuleContent_706_Arg
class Variation_297(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_706

    @classmethod
    def create(cls, arg : Variation_297_Arg) -> "Variation_297":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_706:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_706:
        return self.rule.content

RuleVariation_290_Arg: TypeAlias = Variation_297_Arg
class RuleVariation_290(RuleVariationContextFree):
    cv_variation = Variation_297

    @classmethod
    def create(cls, arg : RuleVariation_290_Arg) -> "RuleVariation_290":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_297:
        return self.arg # type: ignore

NonSpare_239_Arg: TypeAlias = RuleVariation_290_Arg
class NonSpare_239(NonSpare):
    cv_name = "081"
    cv_title = "SSR Mode S Azimuth Bias"
    cv_rule = RuleVariation_290

    @classmethod
    def create(cls, arg : NonSpare_239_Arg) -> "NonSpare_239":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_290:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_297:
        return self.rule.variation

class UapItem_239(UapItem):
    cv_non_spare = NonSpare_239

NonSpare_1454_Arg: TypeAlias = RuleVariation_262_Arg
class NonSpare_1454(NonSpare):
    cv_name = "PRG"
    cv_title = "PSR Range Gain"
    cv_rule = RuleVariation_262

    @classmethod
    def create(cls, arg : NonSpare_1454_Arg) -> "NonSpare_1454":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_262:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_269:
        return self.rule.variation

Item_703_Arg: TypeAlias = NonSpare_1454_Arg
class Item_703(Item):
    cv_non_spare = NonSpare_1454

    @classmethod
    def create(cls, arg : Item_703_Arg) -> "Item_703":
        return cls._create(arg) # type: ignore

NonSpare_1447_Arg: TypeAlias = RuleVariation_277_Arg
class NonSpare_1447(NonSpare):
    cv_name = "PRB"
    cv_title = "PSR Range Bias"
    cv_rule = RuleVariation_277

    @classmethod
    def create(cls, arg : NonSpare_1447_Arg) -> "NonSpare_1447":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_277:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_284:
        return self.rule.variation

Item_696_Arg: TypeAlias = NonSpare_1447_Arg
class Item_696(Item):
    cv_non_spare = NonSpare_1447

    @classmethod
    def create(cls, arg : Item_696_Arg) -> "Item_696":
        return cls._create(arg) # type: ignore

Variation_1157_Arg_Group = Tuple[Union[RuleVariation_262_Arg, Tuple[Literal["PRG"], RuleVariation_262_Arg]], Union[RuleVariation_277_Arg, Tuple[Literal["PRB"], RuleVariation_277_Arg]]]
Variation_1157_Arg: TypeAlias = Union[int, Variation_1157_Arg_Group]
class Variation_1157(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_703, 16), (Item_696, 16)]
    cv_items_dict = {"PRG": RuleVariation_262, "PRB": RuleVariation_277}

    @overload
    @classmethod
    def spec(cls, key : Literal["PRG"]) -> RuleVariation_262:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PRB"]) -> RuleVariation_277:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PRG"], Literal["PRB"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PRG"]) -> RuleVariation_262:
        ...
    @overload
    def get_item(self, key : Literal["PRB"]) -> RuleVariation_277:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1157_Arg) -> 'Variation_1157':
        return cls._create(arg) # type: ignore

RuleVariation_1109_Arg: TypeAlias = Variation_1157_Arg
class RuleVariation_1109(RuleVariationContextFree):
    cv_variation = Variation_1157

    @classmethod
    def create(cls, arg : RuleVariation_1109_Arg) -> "RuleVariation_1109":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1157:
        return self.arg # type: ignore

NonSpare_250_Arg: TypeAlias = RuleVariation_1109_Arg
class NonSpare_250(NonSpare):
    cv_name = "090"
    cv_title = "PSR Range Gain and Bias"
    cv_rule = RuleVariation_1109

    @classmethod
    def create(cls, arg : NonSpare_250_Arg) -> "NonSpare_250":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1109:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1157:
        return self.rule.variation

class UapItem_250(UapItem):
    cv_non_spare = NonSpare_250

NonSpare_257_Arg: TypeAlias = RuleVariation_290_Arg
class NonSpare_257(NonSpare):
    cv_name = "091"
    cv_title = "PSR Azimuth Bias"
    cv_rule = RuleVariation_290

    @classmethod
    def create(cls, arg : NonSpare_257_Arg) -> "NonSpare_257":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_290:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_297:
        return self.rule.variation

class UapItem_257(UapItem):
    cv_non_spare = NonSpare_257

NonSpare_259_Arg: TypeAlias = RuleVariation_290_Arg
class NonSpare_259(NonSpare):
    cv_name = "092"
    cv_title = "PSR Elevation Bias"
    cv_rule = RuleVariation_290

    @classmethod
    def create(cls, arg : NonSpare_259_Arg) -> "NonSpare_259":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_290:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_297:
        return self.rule.variation

class UapItem_259(UapItem):
    cv_non_spare = NonSpare_259

Record_21_Arg = TypedDict('Record_21_Arg', {
    "010": NonSpare_36_Arg,
    "015": NonSpare_64_Arg,
    "030": NonSpare_111_Arg,
    "050": NonSpare_174_Arg,
    "060": NonSpare_193_Arg,
    "070": NonSpare_214_Arg,
    "080": NonSpare_231_Arg,
    "081": NonSpare_239_Arg,
    "090": NonSpare_250_Arg,
    "091": NonSpare_257_Arg,
    "092": NonSpare_259_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_21(Record):
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_36, UapItem_64, UapItem_111, UapItem_174, UapItem_193, UapItem_214, UapItem_231, UapItem_239, UapItem_250, UapItem_257, UapItem_259, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_36, "015": NonSpare_64, "030": NonSpare_111, "050": NonSpare_174, "060": NonSpare_193, "070": NonSpare_214, "080": NonSpare_231, "081": NonSpare_239, "090": NonSpare_250, "091": NonSpare_257, "092": NonSpare_259, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_36:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_64:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_111:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_174:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_193:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_214:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_231:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["081"]) -> NonSpare_239:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_250:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["091"]) -> NonSpare_257:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["092"]) -> NonSpare_259:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["030"], Literal["050"], Literal["060"], Literal["070"], Literal["080"], Literal["081"], Literal["090"], Literal["091"], Literal["092"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_36]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_64]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_111]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_174]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_193]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_214]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_231]:
        ...
    @overload
    def get_item(self, key : Literal["081"]) -> Optional[NonSpare_239]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_250]:
        ...
    @overload
    def get_item(self, key : Literal["091"]) -> Optional[NonSpare_257]:
        ...
    @overload
    def get_item(self, key : Literal["092"]) -> Optional[NonSpare_259]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_36_Arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_64_Arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_111_Arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_174_Arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_193_Arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_214_Arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_231_Arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["081"], val : NonSpare_239_Arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_250_Arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["091"], val : NonSpare_257_Arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["092"], val : NonSpare_259_Arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_21':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["081"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["091"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["092"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_21':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_21_Arg) -> 'Record_21':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_21", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_19_Arg: TypeAlias = Record_21
class Uap_19(UapSingle):
    cv_record = Record_21

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_21]]:
        return cls._parse(bs)

class Asterix_55(AstCat):
    cv_category = 63
    cv_edition = (1, 6)
    cv_uap = Uap_19

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_19_Arg]) -> "Asterix_55":
        return cls._create(records) # type: ignore

Content_590_Arg: TypeAlias = int
class Content_590(ContentTable):
    cv_values = {1: "SDPS Status", 2: "End of Batch", 3: "Service Status Report"}

RuleContent_590_Arg: TypeAlias = Content_590_Arg
class RuleContent_590(RuleContentContextFree):
    cv_content = Content_590

    @property
    def content(self) -> Content_590:
        return self._get_content() # type: ignore

Variation_191_Arg: TypeAlias = RuleContent_590_Arg
class Variation_191(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_590

    @classmethod
    def create(cls, arg : Variation_191_Arg) -> "Variation_191":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_590:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_590:
        return self.rule.content

RuleVariation_184_Arg: TypeAlias = Variation_191_Arg
class RuleVariation_184(RuleVariationContextFree):
    cv_variation = Variation_191

    @classmethod
    def create(cls, arg : RuleVariation_184_Arg) -> "RuleVariation_184":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_191:
        return self.arg # type: ignore

NonSpare_8_Arg: TypeAlias = RuleVariation_184_Arg
class NonSpare_8(NonSpare):
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule = RuleVariation_184

    @classmethod
    def create(cls, arg : NonSpare_8_Arg) -> "NonSpare_8":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_184:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_191:
        return self.rule.variation

class UapItem_8(UapItem):
    cv_non_spare = NonSpare_8

NonSpare_60_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_60(NonSpare):
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_60_Arg) -> "NonSpare_60":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_60(UapItem):
    cv_non_spare = NonSpare_60

NonSpare_110_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_110(NonSpare):
    cv_name = "030"
    cv_title = "Time of Message"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_110_Arg) -> "NonSpare_110":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_110(UapItem):
    cv_non_spare = NonSpare_110

NonSpare_76_Arg: TypeAlias = RuleVariation_196_Arg
class NonSpare_76(NonSpare):
    cv_name = "020"
    cv_title = "Batch Number"
    cv_rule = RuleVariation_196

    @classmethod
    def create(cls, arg : NonSpare_76_Arg) -> "NonSpare_76":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_203:
        return self.rule.variation

class UapItem_76(UapItem):
    cv_non_spare = NonSpare_76

Content_411_Arg: TypeAlias = int
class Content_411(ContentTable):
    cv_values = {0: "Operational", 1: "Degraded", 2: "Not currently connected", 3: "Unknown"}

RuleContent_411_Arg: TypeAlias = Content_411_Arg
class RuleContent_411(RuleContentContextFree):
    cv_content = Content_411

    @property
    def content(self) -> Content_411:
        return self._get_content() # type: ignore

Variation_109_Arg: TypeAlias = RuleContent_411_Arg
class Variation_109(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_411

    @classmethod
    def create(cls, arg : Variation_109_Arg) -> "Variation_109":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_411:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_411:
        return self.rule.content

RuleVariation_109_Arg: TypeAlias = Variation_109_Arg
class RuleVariation_109(RuleVariationContextFree):
    cv_variation = Variation_109

    @classmethod
    def create(cls, arg : RuleVariation_109_Arg) -> "RuleVariation_109":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_109:
        return self.arg # type: ignore

NonSpare_1356_Arg: TypeAlias = RuleVariation_109_Arg
class NonSpare_1356(NonSpare):
    cv_name = "NOGO"
    cv_title = ""
    cv_rule = RuleVariation_109

    @classmethod
    def create(cls, arg : NonSpare_1356_Arg) -> "NonSpare_1356":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_109:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_109:
        return self.rule.variation

Item_622_Arg: TypeAlias = NonSpare_1356_Arg
class Item_622(Item):
    cv_non_spare = NonSpare_1356

    @classmethod
    def create(cls, arg : Item_622_Arg) -> "Item_622":
        return cls._create(arg) # type: ignore

Content_136_Arg: TypeAlias = int
class Content_136(ContentTable):
    cv_values = {0: "Default", 1: "Overload"}

RuleContent_136_Arg: TypeAlias = Content_136_Arg
class RuleContent_136(RuleContentContextFree):
    cv_content = Content_136

    @property
    def content(self) -> Content_136:
        return self._get_content() # type: ignore

Variation_520_Arg: TypeAlias = RuleContent_136_Arg
class Variation_520(Element):
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_136

    @classmethod
    def create(cls, arg : Variation_520_Arg) -> "Variation_520":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_136:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_136:
        return self.rule.content

RuleVariation_509_Arg: TypeAlias = Variation_520_Arg
class RuleVariation_509(RuleVariationContextFree):
    cv_variation = Variation_520

    @classmethod
    def create(cls, arg : RuleVariation_509_Arg) -> "RuleVariation_509":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_520:
        return self.arg # type: ignore

NonSpare_1398_Arg: TypeAlias = RuleVariation_509_Arg
class NonSpare_1398(NonSpare):
    cv_name = "OVL"
    cv_title = ""
    cv_rule = RuleVariation_509

    @classmethod
    def create(cls, arg : NonSpare_1398_Arg) -> "NonSpare_1398":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_509:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_520:
        return self.rule.variation

Item_662_Arg: TypeAlias = NonSpare_1398_Arg
class Item_662(Item):
    cv_non_spare = NonSpare_1398

    @classmethod
    def create(cls, arg : Item_662_Arg) -> "Item_662":
        return cls._create(arg) # type: ignore

Content_110_Arg: TypeAlias = int
class Content_110(ContentTable):
    cv_values = {0: "Default", 1: "Invalid Time Source"}

RuleContent_110_Arg: TypeAlias = Content_110_Arg
class RuleContent_110(RuleContentContextFree):
    cv_content = Content_110

    @property
    def content(self) -> Content_110:
        return self._get_content() # type: ignore

Variation_621_Arg: TypeAlias = RuleContent_110_Arg
class Variation_621(Element):
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_110

    @classmethod
    def create(cls, arg : Variation_621_Arg) -> "Variation_621":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_110:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_110:
        return self.rule.content

RuleVariation_610_Arg: TypeAlias = Variation_621_Arg
class RuleVariation_610(RuleVariationContextFree):
    cv_variation = Variation_621

    @classmethod
    def create(cls, arg : RuleVariation_610_Arg) -> "RuleVariation_610":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_621:
        return self.arg # type: ignore

NonSpare_1931_Arg: TypeAlias = RuleVariation_610_Arg
class NonSpare_1931(NonSpare):
    cv_name = "TSV"
    cv_title = ""
    cv_rule = RuleVariation_610

    @classmethod
    def create(cls, arg : NonSpare_1931_Arg) -> "NonSpare_1931":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_610:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_621:
        return self.rule.variation

Item_1054_Arg: TypeAlias = NonSpare_1931_Arg
class Item_1054(Item):
    cv_non_spare = NonSpare_1931

    @classmethod
    def create(cls, arg : Item_1054_Arg) -> "Item_1054":
        return cls._create(arg) # type: ignore

Content_388_Arg: TypeAlias = int
class Content_388(ContentTable):
    cv_values = {0: "Not applicable", 1: "SDPS-1 selected", 2: "SDPS-2 selected", 3: "SDPS-3 selected"}

RuleContent_388_Arg: TypeAlias = Content_388_Arg
class RuleContent_388(RuleContentContextFree):
    cv_content = Content_388

    @property
    def content(self) -> Content_388:
        return self._get_content() # type: ignore

Variation_764_Arg: TypeAlias = RuleContent_388_Arg
class Variation_764(Element):
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_388

    @classmethod
    def create(cls, arg : Variation_764_Arg) -> "Variation_764":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_388:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_388:
        return self.rule.content

RuleVariation_753_Arg: TypeAlias = Variation_764_Arg
class RuleVariation_753(RuleVariationContextFree):
    cv_variation = Variation_764

    @classmethod
    def create(cls, arg : RuleVariation_753_Arg) -> "RuleVariation_753":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_764:
        return self.arg # type: ignore

NonSpare_1470_Arg: TypeAlias = RuleVariation_753_Arg
class NonSpare_1470(NonSpare):
    cv_name = "PSS"
    cv_title = "Processing System Status"
    cv_rule = RuleVariation_753

    @classmethod
    def create(cls, arg : NonSpare_1470_Arg) -> "NonSpare_1470":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_753:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_764:
        return self.rule.variation

Item_712_Arg: TypeAlias = NonSpare_1470_Arg
class Item_712(Item):
    cv_non_spare = NonSpare_1470

    @classmethod
    def create(cls, arg : Item_712_Arg) -> "Item_712":
        return cls._create(arg) # type: ignore

NonSpare_1794_Arg: TypeAlias = RuleVariation_866_Arg
class NonSpare_1794(NonSpare):
    cv_name = "STTN"
    cv_title = "Track Re-numbering Indication"
    cv_rule = RuleVariation_866

    @classmethod
    def create(cls, arg : NonSpare_1794_Arg) -> "NonSpare_1794":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_866:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_896:
        return self.rule.variation

Item_956_Arg: TypeAlias = NonSpare_1794_Arg
class Item_956(Item):
    cv_non_spare = NonSpare_1794

    @classmethod
    def create(cls, arg : Item_956_Arg) -> "Item_956":
        return cls._create(arg) # type: ignore

Variation_1145_Arg_Group = Tuple[Union[RuleVariation_109_Arg, Tuple[Literal["NOGO"], RuleVariation_109_Arg]], Union[RuleVariation_509_Arg, Tuple[Literal["OVL"], RuleVariation_509_Arg]], Union[RuleVariation_610_Arg, Tuple[Literal["TSV"], RuleVariation_610_Arg]], Union[RuleVariation_753_Arg, Tuple[Literal["PSS"], RuleVariation_753_Arg]], Union[RuleVariation_866_Arg, Tuple[Literal["STTN"], RuleVariation_866_Arg]], int]
Variation_1145_Arg: TypeAlias = Union[int, Variation_1145_Arg_Group]
class Variation_1145(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_622, 2), (Item_662, 1), (Item_1054, 1), (Item_712, 2), (Item_956, 1), (Item_29, 1)]
    cv_items_dict = {"NOGO": RuleVariation_109, "OVL": RuleVariation_509, "TSV": RuleVariation_610, "PSS": RuleVariation_753, "STTN": RuleVariation_866}

    @overload
    @classmethod
    def spec(cls, key : Literal["NOGO"]) -> RuleVariation_109:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVL"]) -> RuleVariation_509:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TSV"]) -> RuleVariation_610:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PSS"]) -> RuleVariation_753:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STTN"]) -> RuleVariation_866:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["NOGO"], Literal["OVL"], Literal["TSV"], Literal["PSS"], Literal["STTN"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["NOGO"]) -> RuleVariation_109:
        ...
    @overload
    def get_item(self, key : Literal["OVL"]) -> RuleVariation_509:
        ...
    @overload
    def get_item(self, key : Literal["TSV"]) -> RuleVariation_610:
        ...
    @overload
    def get_item(self, key : Literal["PSS"]) -> RuleVariation_753:
        ...
    @overload
    def get_item(self, key : Literal["STTN"]) -> RuleVariation_866:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1145_Arg) -> 'Variation_1145':
        return cls._create(arg) # type: ignore

RuleVariation_1099_Arg: TypeAlias = Variation_1145_Arg
class RuleVariation_1099(RuleVariationContextFree):
    cv_variation = Variation_1145

    @classmethod
    def create(cls, arg : RuleVariation_1099_Arg) -> "RuleVariation_1099":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1145:
        return self.arg # type: ignore

NonSpare_141_Arg: TypeAlias = RuleVariation_1099_Arg
class NonSpare_141(NonSpare):
    cv_name = "040"
    cv_title = "SDPS Configuration and Status"
    cv_rule = RuleVariation_1099

    @classmethod
    def create(cls, arg : NonSpare_141_Arg) -> "NonSpare_141":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1099:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1145:
        return self.rule.variation

class UapItem_141(UapItem):
    cv_non_spare = NonSpare_141

Content_591_Arg: TypeAlias = int
class Content_591(ContentTable):
    cv_values = {1: "Service degradation", 2: "Service degradation ended", 3: "Main radar out of service", 4: "Service interrupted by the operator", 5: "Service interrupted due to contingency", 6: "Ready for service restart after contingency", 7: "Service ended by the operator", 8: "Failure of user main radar", 9: "Service restarted by the operator", 10: "Main radar becoming operational", 11: "Main radar becoming degraded", 12: "Service continuity interrupted due to disconnection with adjacent unit", 13: "Service continuity restarted", 14: "Service synchronised on backup radar", 15: "Service synchronised on main radar", 16: "Main and backup radar, if any, failed"}

RuleContent_591_Arg: TypeAlias = Content_591_Arg
class RuleContent_591(RuleContentContextFree):
    cv_content = Content_591

    @property
    def content(self) -> Content_591:
        return self._get_content() # type: ignore

Variation_192_Arg: TypeAlias = RuleContent_591_Arg
class Variation_192(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_591

    @classmethod
    def create(cls, arg : Variation_192_Arg) -> "Variation_192":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_591:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_591:
        return self.rule.content

RuleVariation_185_Arg: TypeAlias = Variation_192_Arg
class RuleVariation_185(RuleVariationContextFree):
    cv_variation = Variation_192

    @classmethod
    def create(cls, arg : RuleVariation_185_Arg) -> "RuleVariation_185":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_192:
        return self.arg # type: ignore

NonSpare_176_Arg: TypeAlias = RuleVariation_185_Arg
class NonSpare_176(NonSpare):
    cv_name = "050"
    cv_title = "Service Status Report"
    cv_rule = RuleVariation_185

    @classmethod
    def create(cls, arg : NonSpare_176_Arg) -> "NonSpare_176":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_185:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_192:
        return self.rule.variation

class UapItem_176(UapItem):
    cv_non_spare = NonSpare_176

Record_40_Arg = TypedDict('Record_40_Arg', {
    "010": NonSpare_45_Arg,
    "000": NonSpare_8_Arg,
    "015": NonSpare_60_Arg,
    "030": NonSpare_110_Arg,
    "020": NonSpare_76_Arg,
    "040": NonSpare_141_Arg,
    "050": NonSpare_176_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_40(Record):
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_45, UapItem_8, UapItem_60, UapItem_110, UapItem_76, UapItem_141, UapItem_176, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_544, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_45, "000": NonSpare_8, "015": NonSpare_60, "030": NonSpare_110, "020": NonSpare_76, "040": NonSpare_141, "050": NonSpare_176, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_45:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_8:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_60:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_110:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_76:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_141:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_176:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["015"], Literal["030"], Literal["020"], Literal["040"], Literal["050"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_45]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_8]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_60]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_110]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_76]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_141]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_176]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_45_Arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_8_Arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_60_Arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_110_Arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_76_Arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_141_Arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_176_Arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_40':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_40':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_40_Arg) -> 'Record_40':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_40", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_36_Arg: TypeAlias = Record_40
class Uap_36(UapSingle):
    cv_record = Record_40

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_40]]:
        return cls._parse(bs)

class Asterix_56(AstCat):
    cv_category = 65
    cv_edition = (1, 4)
    cv_uap = Uap_36

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_36_Arg]) -> "Asterix_56":
        return cls._create(records) # type: ignore

class Asterix_57(AstCat):
    cv_category = 65
    cv_edition = (1, 5)
    cv_uap = Uap_36

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_36_Arg]) -> "Asterix_57":
        return cls._create(records) # type: ignore

class Asterix_58(AstCat):
    cv_category = 65
    cv_edition = (1, 6)
    cv_uap = Uap_36

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_36_Arg]) -> "Asterix_58":
        return cls._create(records) # type: ignore

NonSpare_716_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_716(NonSpare):
    cv_name = "CEN"
    cv_title = "Centre Identifier"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_716_Arg) -> "NonSpare_716":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_148_Arg: TypeAlias = NonSpare_716_Arg
class Item_148(Item):
    cv_non_spare = NonSpare_716

    @classmethod
    def create(cls, arg : Item_148_Arg) -> "Item_148":
        return cls._create(arg) # type: ignore

NonSpare_1441_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_1441(NonSpare):
    cv_name = "POS"
    cv_title = "Workstation Identifier"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_1441_Arg) -> "NonSpare_1441":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

Item_690_Arg: TypeAlias = NonSpare_1441_Arg
class Item_690(Item):
    cv_non_spare = NonSpare_1441

    @classmethod
    def create(cls, arg : Item_690_Arg) -> "Item_690":
        return cls._create(arg) # type: ignore

Variation_1064_Arg_Group = Tuple[Union[RuleVariation_158_Arg, Tuple[Literal["CEN"], RuleVariation_158_Arg]], Union[RuleVariation_158_Arg, Tuple[Literal["POS"], RuleVariation_158_Arg]]]
Variation_1064_Arg: TypeAlias = Union[int, Variation_1064_Arg_Group]
class Variation_1064(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_148, 8), (Item_690, 8)]
    cv_items_dict = {"CEN": RuleVariation_158, "POS": RuleVariation_158}

    @overload
    @classmethod
    def spec(cls, key : Literal["CEN"]) -> RuleVariation_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> RuleVariation_158:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CEN"], Literal["POS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CEN"]) -> RuleVariation_158:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> RuleVariation_158:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1064_Arg) -> 'Variation_1064':
        return cls._create(arg) # type: ignore

RuleVariation_1026_Arg: TypeAlias = Variation_1064_Arg
class RuleVariation_1026(RuleVariationContextFree):
    cv_variation = Variation_1064

    @classmethod
    def create(cls, arg : RuleVariation_1026_Arg) -> "RuleVariation_1026":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1064:
        return self.arg # type: ignore

NonSpare_48_Arg: TypeAlias = RuleVariation_1026_Arg
class NonSpare_48(NonSpare):
    cv_name = "010"
    cv_title = "Destination ID"
    cv_rule = RuleVariation_1026

    @classmethod
    def create(cls, arg : NonSpare_48_Arg) -> "NonSpare_48":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1026:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1064:
        return self.rule.variation

class UapItem_48(UapItem):
    cv_non_spare = NonSpare_48

NonSpare_83_Arg: TypeAlias = RuleVariation_1026_Arg
class NonSpare_83(NonSpare):
    cv_name = "020"
    cv_title = "Source ID"
    cv_rule = RuleVariation_1026

    @classmethod
    def create(cls, arg : NonSpare_83_Arg) -> "NonSpare_83":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1026:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1064:
        return self.rule.variation

class UapItem_83(UapItem):
    cv_non_spare = NonSpare_83

Content_575_Arg: TypeAlias = int
class Content_575(ContentTable):
    cv_values = {1: "Flight plan creation", 2: "Flight plan modification", 3: "Flight plan repetition", 4: "Manual flight plan deletion", 5: "Automatic flight plan deletion", 6: "Flight is beyond extraction area boundary", 251: "Short term conflict alert", 252: "Correlations", 253: "Decorrelations", 254: "Start of background loop", 255: "End of background loop"}

RuleContent_575_Arg: TypeAlias = Content_575_Arg
class RuleContent_575(RuleContentContextFree):
    cv_content = Content_575

    @property
    def content(self) -> Content_575:
        return self._get_content() # type: ignore

Variation_179_Arg: TypeAlias = RuleContent_575_Arg
class Variation_179(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_575

    @classmethod
    def create(cls, arg : Variation_179_Arg) -> "Variation_179":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_575:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_575:
        return self.rule.content

RuleVariation_172_Arg: TypeAlias = Variation_179_Arg
class RuleVariation_172(RuleVariationContextFree):
    cv_variation = Variation_179

    @classmethod
    def create(cls, arg : RuleVariation_172_Arg) -> "RuleVariation_172":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_179:
        return self.arg # type: ignore

NonSpare_104_Arg: TypeAlias = RuleVariation_172_Arg
class NonSpare_104(NonSpare):
    cv_name = "030"
    cv_title = "Message Type"
    cv_rule = RuleVariation_172

    @classmethod
    def create(cls, arg : NonSpare_104_Arg) -> "NonSpare_104":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_172:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_179:
        return self.rule.variation

class UapItem_104(UapItem):
    cv_non_spare = NonSpare_104

NonSpare_139_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_139(NonSpare):
    cv_name = "040"
    cv_title = "Plan Reference Number"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_139_Arg) -> "NonSpare_139":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

class UapItem_139(UapItem):
    cv_non_spare = NonSpare_139

NonSpare_165_Arg: TypeAlias = RuleVariation_383_Arg
class NonSpare_165(NonSpare):
    cv_name = "050"
    cv_title = "Callsign"
    cv_rule = RuleVariation_383

    @classmethod
    def create(cls, arg : NonSpare_165_Arg) -> "NonSpare_165":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

class UapItem_165(UapItem):
    cv_non_spare = NonSpare_165

NonSpare_191_Arg: TypeAlias = RuleVariation_365_Arg
class NonSpare_191(NonSpare):
    cv_name = "060"
    cv_title = "Present Mode 3A"
    cv_rule = RuleVariation_365

    @classmethod
    def create(cls, arg : NonSpare_191_Arg) -> "NonSpare_191":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_365:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_372:
        return self.rule.variation

class UapItem_191(UapItem):
    cv_non_spare = NonSpare_191

NonSpare_211_Arg: TypeAlias = RuleVariation_365_Arg
class NonSpare_211(NonSpare):
    cv_name = "070"
    cv_title = "Next Mode 3A"
    cv_rule = RuleVariation_365

    @classmethod
    def create(cls, arg : NonSpare_211_Arg) -> "NonSpare_211":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_365:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_372:
        return self.rule.variation

class UapItem_211(UapItem):
    cv_non_spare = NonSpare_211

NonSpare_228_Arg: TypeAlias = RuleVariation_365_Arg
class NonSpare_228(NonSpare):
    cv_name = "080"
    cv_title = "Departure Aerodrome"
    cv_rule = RuleVariation_365

    @classmethod
    def create(cls, arg : NonSpare_228_Arg) -> "NonSpare_228":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_365:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_372:
        return self.rule.variation

class UapItem_228(UapItem):
    cv_non_spare = NonSpare_228

NonSpare_242_Arg: TypeAlias = RuleVariation_365_Arg
class NonSpare_242(NonSpare):
    cv_name = "090"
    cv_title = "Destination Aerodrome"
    cv_rule = RuleVariation_365

    @classmethod
    def create(cls, arg : NonSpare_242_Arg) -> "NonSpare_242":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_365:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_372:
        return self.rule.variation

class UapItem_242(UapItem):
    cv_non_spare = NonSpare_242

NonSpare_1015_Arg: TypeAlias = RuleVariation_0_Arg
class NonSpare_1015(NonSpare):
    cv_name = "GAT"
    cv_title = "General Air Traffic"
    cv_rule = RuleVariation_0

    @classmethod
    def create(cls, arg : NonSpare_1015_Arg) -> "NonSpare_1015":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_0:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_0:
        return self.rule.variation

Item_359_Arg: TypeAlias = NonSpare_1015_Arg
class Item_359(Item):
    cv_non_spare = NonSpare_1015

    @classmethod
    def create(cls, arg : Item_359_Arg) -> "Item_359":
        return cls._create(arg) # type: ignore

Variation_398_Arg: TypeAlias = RuleContent_0_Arg
class Variation_398(Element):
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_398_Arg) -> "Variation_398":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

RuleVariation_387_Arg: TypeAlias = Variation_398_Arg
class RuleVariation_387(RuleVariationContextFree):
    cv_variation = Variation_398

    @classmethod
    def create(cls, arg : RuleVariation_387_Arg) -> "RuleVariation_387":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_398:
        return self.arg # type: ignore

NonSpare_1379_Arg: TypeAlias = RuleVariation_387_Arg
class NonSpare_1379(NonSpare):
    cv_name = "OAT"
    cv_title = "Operational Air Traffic"
    cv_rule = RuleVariation_387

    @classmethod
    def create(cls, arg : NonSpare_1379_Arg) -> "NonSpare_1379":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_387:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_398:
        return self.rule.variation

Item_644_Arg: TypeAlias = NonSpare_1379_Arg
class Item_644(Item):
    cv_non_spare = NonSpare_1379

    @classmethod
    def create(cls, arg : Item_644_Arg) -> "Item_644":
        return cls._create(arg) # type: ignore

NonSpare_813_Arg: TypeAlias = RuleVariation_784_Arg
class NonSpare_813(NonSpare):
    cv_name = "CPL"
    cv_title = "Complete Flight Plan"
    cv_rule = RuleVariation_784

    @classmethod
    def create(cls, arg : NonSpare_813_Arg) -> "NonSpare_813":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_784:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_814:
        return self.rule.variation

Item_208_Arg: TypeAlias = NonSpare_813_Arg
class Item_208(Item):
    cv_non_spare = NonSpare_813

    @classmethod
    def create(cls, arg : Item_208_Arg) -> "Item_208":
        return cls._create(arg) # type: ignore

NonSpare_1733_Arg: TypeAlias = RuleVariation_866_Arg
class NonSpare_1733(NonSpare):
    cv_name = "SPN"
    cv_title = "Short Flight Plan"
    cv_rule = RuleVariation_866

    @classmethod
    def create(cls, arg : NonSpare_1733_Arg) -> "NonSpare_1733":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_866:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_896:
        return self.rule.variation

Item_912_Arg: TypeAlias = NonSpare_1733_Arg
class Item_912(Item):
    cv_non_spare = NonSpare_1733

    @classmethod
    def create(cls, arg : Item_912_Arg) -> "Item_912":
        return cls._create(arg) # type: ignore

Variation_1103_Arg_Group = Tuple[Union[RuleVariation_0_Arg, Tuple[Literal["GAT"], RuleVariation_0_Arg]], Union[RuleVariation_387_Arg, Tuple[Literal["OAT"], RuleVariation_387_Arg]], int, Union[RuleVariation_784_Arg, Tuple[Literal["CPL"], RuleVariation_784_Arg]], Union[RuleVariation_866_Arg, Tuple[Literal["SPN"], RuleVariation_866_Arg]], int]
Variation_1103_Arg: TypeAlias = Union[int, Variation_1103_Arg_Group]
class Variation_1103(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_359, 1), (Item_644, 1), (Item_13, 3), (Item_208, 1), (Item_912, 1), (Item_29, 1)]
    cv_items_dict = {"GAT": RuleVariation_0, "OAT": RuleVariation_387, "CPL": RuleVariation_784, "SPN": RuleVariation_866}

    @overload
    @classmethod
    def spec(cls, key : Literal["GAT"]) -> RuleVariation_0:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OAT"]) -> RuleVariation_387:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPL"]) -> RuleVariation_784:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SPN"]) -> RuleVariation_866:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GAT"], Literal["OAT"], Literal["CPL"], Literal["SPN"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GAT"]) -> RuleVariation_0:
        ...
    @overload
    def get_item(self, key : Literal["OAT"]) -> RuleVariation_387:
        ...
    @overload
    def get_item(self, key : Literal["CPL"]) -> RuleVariation_784:
        ...
    @overload
    def get_item(self, key : Literal["SPN"]) -> RuleVariation_866:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1103_Arg) -> 'Variation_1103':
        return cls._create(arg) # type: ignore

RuleVariation_1061_Arg: TypeAlias = Variation_1103_Arg
class RuleVariation_1061(RuleVariationContextFree):
    cv_variation = Variation_1103

    @classmethod
    def create(cls, arg : RuleVariation_1061_Arg) -> "RuleVariation_1061":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1103:
        return self.arg # type: ignore

NonSpare_274_Arg: TypeAlias = RuleVariation_1061_Arg
class NonSpare_274(NonSpare):
    cv_name = "100"
    cv_title = "Type Flags"
    cv_rule = RuleVariation_1061

    @classmethod
    def create(cls, arg : NonSpare_274_Arg) -> "NonSpare_274":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1061:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1103:
        return self.rule.variation

class UapItem_274(UapItem):
    cv_non_spare = NonSpare_274

NonSpare_1064_Arg: TypeAlias = RuleVariation_387_Arg
class NonSpare_1064(NonSpare):
    cv_name = "HLD"
    cv_title = "Aircraft is in Hold State"
    cv_rule = RuleVariation_387

    @classmethod
    def create(cls, arg : NonSpare_1064_Arg) -> "NonSpare_1064":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_387:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_398:
        return self.rule.variation

Item_395_Arg: TypeAlias = NonSpare_1064_Arg
class Item_395(Item):
    cv_non_spare = NonSpare_1064

    @classmethod
    def create(cls, arg : Item_395_Arg) -> "Item_395":
        return cls._create(arg) # type: ignore

NonSpare_1627_Arg: TypeAlias = RuleVariation_493_Arg
class NonSpare_1627(NonSpare):
    cv_name = "RVQ"
    cv_title = "Aircraft is RVSM Equipped"
    cv_rule = RuleVariation_493

    @classmethod
    def create(cls, arg : NonSpare_1627_Arg) -> "NonSpare_1627":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_493:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_504:
        return self.rule.variation

Item_838_Arg: TypeAlias = NonSpare_1627_Arg
class Item_838(Item):
    cv_non_spare = NonSpare_1627

    @classmethod
    def create(cls, arg : Item_838_Arg) -> "Item_838":
        return cls._create(arg) # type: ignore

NonSpare_1625_Arg: TypeAlias = RuleVariation_600_Arg
class NonSpare_1625(NonSpare):
    cv_name = "RVC"
    cv_title = "Aircraft is RVSM Capable"
    cv_rule = RuleVariation_600

    @classmethod
    def create(cls, arg : NonSpare_1625_Arg) -> "NonSpare_1625":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_600:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_611:
        return self.rule.variation

Item_837_Arg: TypeAlias = NonSpare_1625_Arg
class Item_837(Item):
    cv_non_spare = NonSpare_1625

    @classmethod
    def create(cls, arg : Item_837_Arg) -> "Item_837":
        return cls._create(arg) # type: ignore

NonSpare_1631_Arg: TypeAlias = RuleVariation_685_Arg
class NonSpare_1631(NonSpare):
    cv_name = "RVX"
    cv_title = "Aircraft is RVSM Exempted"
    cv_rule = RuleVariation_685

    @classmethod
    def create(cls, arg : NonSpare_1631_Arg) -> "NonSpare_1631":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_685:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_696:
        return self.rule.variation

Item_842_Arg: TypeAlias = NonSpare_1631_Arg
class Item_842(Item):
    cv_non_spare = NonSpare_1631

    @classmethod
    def create(cls, arg : Item_842_Arg) -> "Item_842":
        return cls._create(arg) # type: ignore

Variation_993_Arg_Group = Tuple[int, Union[RuleVariation_387_Arg, Tuple[Literal["HLD"], RuleVariation_387_Arg]], Union[RuleVariation_493_Arg, Tuple[Literal["RVQ"], RuleVariation_493_Arg]], Union[RuleVariation_600_Arg, Tuple[Literal["RVC"], RuleVariation_600_Arg]], Union[RuleVariation_685_Arg, Tuple[Literal["RVX"], RuleVariation_685_Arg]], int]
Variation_993_Arg: TypeAlias = Union[int, Variation_993_Arg_Group]
class Variation_993(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_0, 1), (Item_395, 1), (Item_838, 1), (Item_837, 1), (Item_842, 1), (Item_25, 3)]
    cv_items_dict = {"HLD": RuleVariation_387, "RVQ": RuleVariation_493, "RVC": RuleVariation_600, "RVX": RuleVariation_685}

    @overload
    @classmethod
    def spec(cls, key : Literal["HLD"]) -> RuleVariation_387:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RVQ"]) -> RuleVariation_493:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RVC"]) -> RuleVariation_600:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RVX"]) -> RuleVariation_685:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["HLD"], Literal["RVQ"], Literal["RVC"], Literal["RVX"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["HLD"]) -> RuleVariation_387:
        ...
    @overload
    def get_item(self, key : Literal["RVQ"]) -> RuleVariation_493:
        ...
    @overload
    def get_item(self, key : Literal["RVC"]) -> RuleVariation_600:
        ...
    @overload
    def get_item(self, key : Literal["RVX"]) -> RuleVariation_685:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_993_Arg) -> 'Variation_993':
        return cls._create(arg) # type: ignore

RuleVariation_963_Arg: TypeAlias = Variation_993_Arg
class RuleVariation_963(RuleVariationContextFree):
    cv_variation = Variation_993

    @classmethod
    def create(cls, arg : RuleVariation_963_Arg) -> "RuleVariation_963":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_993:
        return self.arg # type: ignore

NonSpare_288_Arg: TypeAlias = RuleVariation_963_Arg
class NonSpare_288(NonSpare):
    cv_name = "110"
    cv_title = "Status Flags"
    cv_rule = RuleVariation_963

    @classmethod
    def create(cls, arg : NonSpare_288_Arg) -> "NonSpare_288":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_963:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_993:
        return self.rule.variation

class UapItem_288(UapItem):
    cv_non_spare = NonSpare_288

Variation_252_Arg: TypeAlias = RuleContent_606_Arg
class Variation_252(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_606

    @classmethod
    def create(cls, arg : Variation_252_Arg) -> "Variation_252":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_606:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_606:
        return self.rule.content

RuleVariation_245_Arg: TypeAlias = Variation_252_Arg
class RuleVariation_245(RuleVariationContextFree):
    cv_variation = Variation_252

    @classmethod
    def create(cls, arg : RuleVariation_245_Arg) -> "RuleVariation_245":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_252:
        return self.arg # type: ignore

NonSpare_1353_Arg: TypeAlias = RuleVariation_245_Arg
class NonSpare_1353(NonSpare):
    cv_name = "NOA"
    cv_title = "Number of Aircraft"
    cv_rule = RuleVariation_245

    @classmethod
    def create(cls, arg : NonSpare_1353_Arg) -> "NonSpare_1353":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_245:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_252:
        return self.rule.variation

Item_619_Arg: TypeAlias = NonSpare_1353_Arg
class Item_619(Item):
    cv_non_spare = NonSpare_1353

    @classmethod
    def create(cls, arg : Item_619_Arg) -> "Item_619":
        return cls._create(arg) # type: ignore

Item_1006_Arg: TypeAlias = NonSpare_1872_Arg
class Item_1006(Item):
    cv_non_spare = NonSpare_1872

    @classmethod
    def create(cls, arg : Item_1006_Arg) -> "Item_1006":
        return cls._create(arg) # type: ignore

NonSpare_2058_Arg: TypeAlias = RuleVariation_194_Arg
class NonSpare_2058(NonSpare):
    cv_name = "WT"
    cv_title = "Wake Turbulence"
    cv_rule = RuleVariation_194

    @classmethod
    def create(cls, arg : NonSpare_2058_Arg) -> "NonSpare_2058":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_194:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_201:
        return self.rule.variation

Item_1167_Arg: TypeAlias = NonSpare_2058_Arg
class Item_1167(Item):
    cv_non_spare = NonSpare_2058

    @classmethod
    def create(cls, arg : Item_1167_Arg) -> "Item_1167":
        return cls._create(arg) # type: ignore

Variation_1144_Arg_Group = Tuple[Union[RuleVariation_245_Arg, Tuple[Literal["NOA"], RuleVariation_245_Arg]], Union[RuleVariation_365_Arg, Tuple[Literal["TOA"], RuleVariation_365_Arg]], Union[RuleVariation_194_Arg, Tuple[Literal["WT"], RuleVariation_194_Arg]]]
Variation_1144_Arg: TypeAlias = Union[int, Variation_1144_Arg_Group]
class Variation_1144(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_items_list = [(Item_619, 16), (Item_1006, 32), (Item_1167, 8)]
    cv_items_dict = {"NOA": RuleVariation_245, "TOA": RuleVariation_365, "WT": RuleVariation_194}

    @overload
    @classmethod
    def spec(cls, key : Literal["NOA"]) -> RuleVariation_245:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOA"]) -> RuleVariation_365:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WT"]) -> RuleVariation_194:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["NOA"], Literal["TOA"], Literal["WT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["NOA"]) -> RuleVariation_245:
        ...
    @overload
    def get_item(self, key : Literal["TOA"]) -> RuleVariation_365:
        ...
    @overload
    def get_item(self, key : Literal["WT"]) -> RuleVariation_194:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1144_Arg) -> 'Variation_1144':
        return cls._create(arg) # type: ignore

RuleVariation_1098_Arg: TypeAlias = Variation_1144_Arg
class RuleVariation_1098(RuleVariationContextFree):
    cv_variation = Variation_1144

    @classmethod
    def create(cls, arg : RuleVariation_1098_Arg) -> "RuleVariation_1098":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1144:
        return self.arg # type: ignore

NonSpare_291_Arg: TypeAlias = RuleVariation_1098_Arg
class NonSpare_291(NonSpare):
    cv_name = "120"
    cv_title = "Aircraft Type"
    cv_rule = RuleVariation_1098

    @classmethod
    def create(cls, arg : NonSpare_291_Arg) -> "NonSpare_291":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1098:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1144:
        return self.rule.variation

class UapItem_291(UapItem):
    cv_non_spare = NonSpare_291

NonSpare_302_Arg: TypeAlias = RuleVariation_341_Arg
class NonSpare_302(NonSpare):
    cv_name = "130"
    cv_title = "Cleared Flight Level"
    cv_rule = RuleVariation_341

    @classmethod
    def create(cls, arg : NonSpare_302_Arg) -> "NonSpare_302":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_341:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_348:
        return self.rule.variation

class UapItem_302(UapItem):
    cv_non_spare = NonSpare_302

Content_588_Arg: TypeAlias = int
class Content_588(ContentTable):
    cv_values = {1: "P, point", 2: "B, point with bearing and distance", 3: "LS, latitude/longitude position short format", 4: "LL, latitude/longitude position long format", 5: "X, x/y co-ordinate position", 6: "G, georeference position", 14: "E, airport"}

RuleContent_588_Arg: TypeAlias = Content_588_Arg
class RuleContent_588(RuleContentContextFree):
    cv_content = Content_588

    @property
    def content(self) -> Content_588:
        return self._get_content() # type: ignore

Variation_189_Arg: TypeAlias = RuleContent_588_Arg
class Variation_189(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_588

    @classmethod
    def create(cls, arg : Variation_189_Arg) -> "Variation_189":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_588:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_588:
        return self.rule.content

RuleVariation_182_Arg: TypeAlias = Variation_189_Arg
class RuleVariation_182(RuleVariationContextFree):
    cv_variation = Variation_189

    @classmethod
    def create(cls, arg : RuleVariation_182_Arg) -> "RuleVariation_182":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_189:
        return self.arg # type: ignore

NonSpare_1808_Arg: TypeAlias = RuleVariation_182_Arg
class NonSpare_1808(NonSpare):
    cv_name = "T"
    cv_title = "Route Point Type"
    cv_rule = RuleVariation_182

    @classmethod
    def create(cls, arg : NonSpare_1808_Arg) -> "NonSpare_1808":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_182:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_189:
        return self.rule.variation

Item_966_Arg: TypeAlias = NonSpare_1808_Arg
class Item_966(Item):
    cv_non_spare = NonSpare_1808

    @classmethod
    def create(cls, arg : Item_966_Arg) -> "Item_966":
        return cls._create(arg) # type: ignore

Variation_395_Arg: TypeAlias = RuleContent_606_Arg
class Variation_395(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 88
    cv_rule = RuleContent_606

    @classmethod
    def create(cls, arg : Variation_395_Arg) -> "Variation_395":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_606:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_606:
        return self.rule.content

RuleVariation_386_Arg: TypeAlias = Variation_395_Arg
class RuleVariation_386(RuleVariationContextFree):
    cv_variation = Variation_395

    @classmethod
    def create(cls, arg : RuleVariation_386_Arg) -> "RuleVariation_386":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_395:
        return self.arg # type: ignore

NonSpare_910_Arg: TypeAlias = RuleVariation_386_Arg
class NonSpare_910(NonSpare):
    cv_name = "E"
    cv_title = "Route Point Description Element"
    cv_rule = RuleVariation_386

    @classmethod
    def create(cls, arg : NonSpare_910_Arg) -> "NonSpare_910":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_386:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_395:
        return self.rule.variation

Item_285_Arg: TypeAlias = NonSpare_910_Arg
class Item_285(Item):
    cv_non_spare = NonSpare_910

    @classmethod
    def create(cls, arg : Item_285_Arg) -> "Item_285":
        return cls._create(arg) # type: ignore

Variation_1214_Arg_Group = Tuple[Union[RuleVariation_182_Arg, Tuple[Literal["T"], RuleVariation_182_Arg]], Union[RuleVariation_386_Arg, Tuple[Literal["E"], RuleVariation_386_Arg]]]
Variation_1214_Arg: TypeAlias = Union[int, Variation_1214_Arg_Group]
class Variation_1214(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 96
    cv_items_list = [(Item_966, 8), (Item_285, 88)]
    cv_items_dict = {"T": RuleVariation_182, "E": RuleVariation_386}

    @overload
    @classmethod
    def spec(cls, key : Literal["T"]) -> RuleVariation_182:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["E"]) -> RuleVariation_386:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["T"], Literal["E"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["T"]) -> RuleVariation_182:
        ...
    @overload
    def get_item(self, key : Literal["E"]) -> RuleVariation_386:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1214_Arg) -> 'Variation_1214':
        return cls._create(arg) # type: ignore

Variation_1427_Arg: TypeAlias = List[Variation_1214_Arg]
class Variation_1427(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1214

    @classmethod
    def create(cls, arg : Variation_1427_Arg) -> 'Variation_1427':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1214]:
        return self._get_list() # type: ignore

RuleVariation_1350_Arg: TypeAlias = Variation_1427_Arg
class RuleVariation_1350(RuleVariationContextFree):
    cv_variation = Variation_1427

    @classmethod
    def create(cls, arg : RuleVariation_1350_Arg) -> "RuleVariation_1350":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1427:
        return self.arg # type: ignore

NonSpare_320_Arg: TypeAlias = RuleVariation_1350_Arg
class NonSpare_320(NonSpare):
    cv_name = "140"
    cv_title = "Route Points, Description"
    cv_rule = RuleVariation_1350

    @classmethod
    def create(cls, arg : NonSpare_320_Arg) -> "NonSpare_320":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1350:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1427:
        return self.rule.variation

class UapItem_320(UapItem):
    cv_non_spare = NonSpare_320

Content_670_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
class Content_670(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.5625e-2
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

RuleContent_670_Arg: TypeAlias = Content_670_Arg
class RuleContent_670(RuleContentContextFree):
    cv_content = Content_670

    @property
    def content(self) -> Content_670:
        return self._get_content() # type: ignore

Variation_281_Arg: TypeAlias = RuleContent_670_Arg
class Variation_281(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_670

    @classmethod
    def create(cls, arg : Variation_281_Arg) -> "Variation_281":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_670:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_670:
        return self.rule.content

RuleVariation_274_Arg: TypeAlias = Variation_281_Arg
class RuleVariation_274(RuleVariationContextFree):
    cv_variation = Variation_281

    @classmethod
    def create(cls, arg : RuleVariation_274_Arg) -> "RuleVariation_274":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_281:
        return self.arg # type: ignore

NonSpare_2084_Arg: TypeAlias = RuleVariation_274_Arg
class NonSpare_2084(NonSpare):
    cv_name = "X"
    cv_title = "X Co-ordinate"
    cv_rule = RuleVariation_274

    @classmethod
    def create(cls, arg : NonSpare_2084_Arg) -> "NonSpare_2084":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_274:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_281:
        return self.rule.variation

Item_1191_Arg: TypeAlias = NonSpare_2084_Arg
class Item_1191(Item):
    cv_non_spare = NonSpare_2084

    @classmethod
    def create(cls, arg : Item_1191_Arg) -> "Item_1191":
        return cls._create(arg) # type: ignore

NonSpare_2138_Arg: TypeAlias = RuleVariation_274_Arg
class NonSpare_2138(NonSpare):
    cv_name = "Y"
    cv_title = "Y Co-ordinate"
    cv_rule = RuleVariation_274

    @classmethod
    def create(cls, arg : NonSpare_2138_Arg) -> "NonSpare_2138":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_274:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_281:
        return self.rule.variation

Item_1242_Arg: TypeAlias = NonSpare_2138_Arg
class Item_1242(Item):
    cv_non_spare = NonSpare_2138

    @classmethod
    def create(cls, arg : Item_1242_Arg) -> "Item_1242":
        return cls._create(arg) # type: ignore

Variation_1301_Arg_Group = Tuple[Union[RuleVariation_274_Arg, Tuple[Literal["X"], RuleVariation_274_Arg]], Union[RuleVariation_274_Arg, Tuple[Literal["Y"], RuleVariation_274_Arg]]]
Variation_1301_Arg: TypeAlias = Union[int, Variation_1301_Arg_Group]
class Variation_1301(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1191, 16), (Item_1242, 16)]
    cv_items_dict = {"X": RuleVariation_274, "Y": RuleVariation_274}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_274:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_274:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_274:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_274:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1301_Arg) -> 'Variation_1301':
        return cls._create(arg) # type: ignore

Variation_1441_Arg: TypeAlias = List[Variation_1301_Arg]
class Variation_1441(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1301

    @classmethod
    def create(cls, arg : Variation_1441_Arg) -> 'Variation_1441':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1301]:
        return self._get_list() # type: ignore

RuleVariation_1364_Arg: TypeAlias = Variation_1441_Arg
class RuleVariation_1364(RuleVariationContextFree):
    cv_variation = Variation_1441

    @classmethod
    def create(cls, arg : RuleVariation_1364_Arg) -> "RuleVariation_1364":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1441:
        return self.arg # type: ignore

NonSpare_342_Arg: TypeAlias = RuleVariation_1364_Arg
class NonSpare_342(NonSpare):
    cv_name = "150"
    cv_title = "Route Points, Coordinates"
    cv_rule = RuleVariation_1364

    @classmethod
    def create(cls, arg : NonSpare_342_Arg) -> "NonSpare_342":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1364:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1441:
        return self.rule.variation

class UapItem_342(UapItem):
    cv_non_spare = NonSpare_342

NonSpare_1063_Arg: TypeAlias = RuleVariation_245_Arg
class NonSpare_1063(NonSpare):
    cv_name = "HH"
    cv_title = "Hours"
    cv_rule = RuleVariation_245

    @classmethod
    def create(cls, arg : NonSpare_1063_Arg) -> "NonSpare_1063":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_245:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_252:
        return self.rule.variation

Item_394_Arg: TypeAlias = NonSpare_1063_Arg
class Item_394(Item):
    cv_non_spare = NonSpare_1063

    @classmethod
    def create(cls, arg : Item_394_Arg) -> "Item_394":
        return cls._create(arg) # type: ignore

NonSpare_1285_Arg: TypeAlias = RuleVariation_245_Arg
class NonSpare_1285(NonSpare):
    cv_name = "MM"
    cv_title = "Minutes"
    cv_rule = RuleVariation_245

    @classmethod
    def create(cls, arg : NonSpare_1285_Arg) -> "NonSpare_1285":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_245:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_252:
        return self.rule.variation

Item_557_Arg: TypeAlias = NonSpare_1285_Arg
class Item_557(Item):
    cv_non_spare = NonSpare_1285

    @classmethod
    def create(cls, arg : Item_557_Arg) -> "Item_557":
        return cls._create(arg) # type: ignore

Variation_1112_Arg_Group = Tuple[Union[RuleVariation_245_Arg, Tuple[Literal["HH"], RuleVariation_245_Arg]], Union[RuleVariation_245_Arg, Tuple[Literal["MM"], RuleVariation_245_Arg]]]
Variation_1112_Arg: TypeAlias = Union[int, Variation_1112_Arg_Group]
class Variation_1112(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_394, 16), (Item_557, 16)]
    cv_items_dict = {"HH": RuleVariation_245, "MM": RuleVariation_245}

    @overload
    @classmethod
    def spec(cls, key : Literal["HH"]) -> RuleVariation_245:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MM"]) -> RuleVariation_245:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["HH"], Literal["MM"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["HH"]) -> RuleVariation_245:
        ...
    @overload
    def get_item(self, key : Literal["MM"]) -> RuleVariation_245:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1112_Arg) -> 'Variation_1112':
        return cls._create(arg) # type: ignore

Variation_1411_Arg: TypeAlias = List[Variation_1112_Arg]
class Variation_1411(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1112

    @classmethod
    def create(cls, arg : Variation_1411_Arg) -> 'Variation_1411':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1112]:
        return self._get_list() # type: ignore

RuleVariation_1334_Arg: TypeAlias = Variation_1411_Arg
class RuleVariation_1334(RuleVariationContextFree):
    cv_variation = Variation_1411

    @classmethod
    def create(cls, arg : RuleVariation_1334_Arg) -> "RuleVariation_1334":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1411:
        return self.arg # type: ignore

NonSpare_354_Arg: TypeAlias = RuleVariation_1334_Arg
class NonSpare_354(NonSpare):
    cv_name = "160"
    cv_title = "Route Points, Time"
    cv_rule = RuleVariation_1334

    @classmethod
    def create(cls, arg : NonSpare_354_Arg) -> "NonSpare_354":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1411:
        return self.rule.variation

class UapItem_354(UapItem):
    cv_non_spare = NonSpare_354

Variation_1391_Arg: TypeAlias = List[Variation_348_Arg]
class Variation_1391(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_348

    @classmethod
    def create(cls, arg : Variation_1391_Arg) -> 'Variation_1391':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_348]:
        return self._get_list() # type: ignore

RuleVariation_1314_Arg: TypeAlias = Variation_1391_Arg
class RuleVariation_1314(RuleVariationContextFree):
    cv_variation = Variation_1391

    @classmethod
    def create(cls, arg : RuleVariation_1314_Arg) -> "RuleVariation_1314":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1391:
        return self.arg # type: ignore

NonSpare_366_Arg: TypeAlias = RuleVariation_1314_Arg
class NonSpare_366(NonSpare):
    cv_name = "170"
    cv_title = "Route Points, Flight Level"
    cv_rule = RuleVariation_1314

    @classmethod
    def create(cls, arg : NonSpare_366_Arg) -> "NonSpare_366":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1314:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1391:
        return self.rule.variation

class UapItem_366(UapItem):
    cv_non_spare = NonSpare_366

Variation_1393_Arg: TypeAlias = List[Variation_372_Arg]
class Variation_1393(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_372

    @classmethod
    def create(cls, arg : Variation_1393_Arg) -> 'Variation_1393':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_372]:
        return self._get_list() # type: ignore

RuleVariation_1316_Arg: TypeAlias = Variation_1393_Arg
class RuleVariation_1316(RuleVariationContextFree):
    cv_variation = Variation_1393

    @classmethod
    def create(cls, arg : RuleVariation_1316_Arg) -> "RuleVariation_1316":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1393:
        return self.arg # type: ignore

NonSpare_379_Arg: TypeAlias = RuleVariation_1316_Arg
class NonSpare_379(NonSpare):
    cv_name = "180"
    cv_title = "Route Points, Speed"
    cv_rule = RuleVariation_1316

    @classmethod
    def create(cls, arg : NonSpare_379_Arg) -> "NonSpare_379":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1316:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1393:
        return self.rule.variation

class UapItem_379(UapItem):
    cv_non_spare = NonSpare_379

NonSpare_382_Arg: TypeAlias = RuleVariation_245_Arg
class NonSpare_382(NonSpare):
    cv_name = "190"
    cv_title = "Controller ID"
    cv_rule = RuleVariation_245

    @classmethod
    def create(cls, arg : NonSpare_382_Arg) -> "NonSpare_382":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_245:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_252:
        return self.rule.variation

class UapItem_382(UapItem):
    cv_non_spare = NonSpare_382

Variation_1388_Arg: TypeAlias = List[Variation_201_Arg]
class Variation_1388(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_201

    @classmethod
    def create(cls, arg : Variation_1388_Arg) -> 'Variation_1388':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_201]:
        return self._get_list() # type: ignore

RuleVariation_1311_Arg: TypeAlias = Variation_1388_Arg
class RuleVariation_1311(RuleVariationContextFree):
    cv_variation = Variation_1388

    @classmethod
    def create(cls, arg : RuleVariation_1311_Arg) -> "RuleVariation_1311":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1388:
        return self.arg # type: ignore

NonSpare_387_Arg: TypeAlias = RuleVariation_1311_Arg
class NonSpare_387(NonSpare):
    cv_name = "200"
    cv_title = "Field 18"
    cv_rule = RuleVariation_1311

    @classmethod
    def create(cls, arg : NonSpare_387_Arg) -> "NonSpare_387":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1311:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1388:
        return self.rule.variation

class UapItem_387(UapItem):
    cv_non_spare = NonSpare_387

NonSpare_406_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_406(NonSpare):
    cv_name = "210"
    cv_title = "Correlated Track Number"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_406_Arg) -> "NonSpare_406":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

class UapItem_406(UapItem):
    cv_non_spare = NonSpare_406

NonSpare_418_Arg: TypeAlias = RuleVariation_247_Arg
class NonSpare_418(NonSpare):
    cv_name = "220"
    cv_title = "Maximum Plan Count"
    cv_rule = RuleVariation_247

    @classmethod
    def create(cls, arg : NonSpare_418_Arg) -> "NonSpare_418":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_247:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_254:
        return self.rule.variation

class UapItem_418(UapItem):
    cv_non_spare = NonSpare_418

NonSpare_427_Arg: TypeAlias = RuleVariation_247_Arg
class NonSpare_427(NonSpare):
    cv_name = "230"
    cv_title = "Number of Plans"
    cv_rule = RuleVariation_247

    @classmethod
    def create(cls, arg : NonSpare_427_Arg) -> "NonSpare_427":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_247:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_254:
        return self.rule.variation

class UapItem_427(UapItem):
    cv_non_spare = NonSpare_427

NonSpare_1422_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_1422(NonSpare):
    cv_name = "PLAN"
    cv_title = "Plan Number"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_1422_Arg) -> "NonSpare_1422":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

Item_682_Arg: TypeAlias = NonSpare_1422_Arg
class Item_682(Item):
    cv_non_spare = NonSpare_1422

    @classmethod
    def create(cls, arg : Item_682_Arg) -> "Item_682":
        return cls._create(arg) # type: ignore

NonSpare_1895_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_1895(NonSpare):
    cv_name = "TRACK"
    cv_title = "Track Number"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_1895_Arg) -> "NonSpare_1895":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

Item_1024_Arg: TypeAlias = NonSpare_1895_Arg
class Item_1024(Item):
    cv_non_spare = NonSpare_1895

    @classmethod
    def create(cls, arg : Item_1024_Arg) -> "Item_1024":
        return cls._create(arg) # type: ignore

Variation_1153_Arg_Group = Tuple[Union[RuleVariation_244_Arg, Tuple[Literal["PLAN"], RuleVariation_244_Arg]], Union[RuleVariation_244_Arg, Tuple[Literal["TRACK"], RuleVariation_244_Arg]]]
Variation_1153_Arg: TypeAlias = Union[int, Variation_1153_Arg_Group]
class Variation_1153(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_682, 16), (Item_1024, 16)]
    cv_items_dict = {"PLAN": RuleVariation_244, "TRACK": RuleVariation_244}

    @overload
    @classmethod
    def spec(cls, key : Literal["PLAN"]) -> RuleVariation_244:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRACK"]) -> RuleVariation_244:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PLAN"], Literal["TRACK"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PLAN"]) -> RuleVariation_244:
        ...
    @overload
    def get_item(self, key : Literal["TRACK"]) -> RuleVariation_244:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1153_Arg) -> 'Variation_1153':
        return cls._create(arg) # type: ignore

Variation_1417_Arg: TypeAlias = List[Variation_1153_Arg]
class Variation_1417(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1153

    @classmethod
    def create(cls, arg : Variation_1417_Arg) -> 'Variation_1417':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1153]:
        return self._get_list() # type: ignore

RuleVariation_1340_Arg: TypeAlias = Variation_1417_Arg
class RuleVariation_1340(RuleVariationContextFree):
    cv_variation = Variation_1417

    @classmethod
    def create(cls, arg : RuleVariation_1340_Arg) -> "RuleVariation_1340":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1417:
        return self.arg # type: ignore

NonSpare_433_Arg: TypeAlias = RuleVariation_1340_Arg
class NonSpare_433(NonSpare):
    cv_name = "240"
    cv_title = "Newly Correlated Plans"
    cv_rule = RuleVariation_1340

    @classmethod
    def create(cls, arg : NonSpare_433_Arg) -> "NonSpare_433":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1340:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1417:
        return self.rule.variation

class UapItem_433(UapItem):
    cv_non_spare = NonSpare_433

NonSpare_446_Arg: TypeAlias = RuleVariation_1312_Arg
class NonSpare_446(NonSpare):
    cv_name = "250"
    cv_title = "Newly De-correlated Plans"
    cv_rule = RuleVariation_1312

    @classmethod
    def create(cls, arg : NonSpare_446_Arg) -> "NonSpare_446":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1312:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1389:
        return self.rule.variation

class UapItem_446(UapItem):
    cv_non_spare = NonSpare_446

NonSpare_1896_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_1896(NonSpare):
    cv_name = "TRACK1"
    cv_title = "Track Number 1"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_1896_Arg) -> "NonSpare_1896":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

Item_1025_Arg: TypeAlias = NonSpare_1896_Arg
class Item_1025(Item):
    cv_non_spare = NonSpare_1896

    @classmethod
    def create(cls, arg : Item_1025_Arg) -> "Item_1025":
        return cls._create(arg) # type: ignore

NonSpare_1897_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_1897(NonSpare):
    cv_name = "TRACK2"
    cv_title = "Track Number 2"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_1897_Arg) -> "NonSpare_1897":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

Item_1026_Arg: TypeAlias = NonSpare_1897_Arg
class Item_1026(Item):
    cv_non_spare = NonSpare_1897

    @classmethod
    def create(cls, arg : Item_1026_Arg) -> "Item_1026":
        return cls._create(arg) # type: ignore

Variation_1221_Arg_Group = Tuple[Union[RuleVariation_244_Arg, Tuple[Literal["TRACK1"], RuleVariation_244_Arg]], Union[RuleVariation_244_Arg, Tuple[Literal["TRACK2"], RuleVariation_244_Arg]]]
Variation_1221_Arg: TypeAlias = Union[int, Variation_1221_Arg_Group]
class Variation_1221(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1025, 16), (Item_1026, 16)]
    cv_items_dict = {"TRACK1": RuleVariation_244, "TRACK2": RuleVariation_244}

    @overload
    @classmethod
    def spec(cls, key : Literal["TRACK1"]) -> RuleVariation_244:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRACK2"]) -> RuleVariation_244:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TRACK1"], Literal["TRACK2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TRACK1"]) -> RuleVariation_244:
        ...
    @overload
    def get_item(self, key : Literal["TRACK2"]) -> RuleVariation_244:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1221_Arg) -> 'Variation_1221':
        return cls._create(arg) # type: ignore

Variation_1431_Arg: TypeAlias = List[Variation_1221_Arg]
class Variation_1431(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1221

    @classmethod
    def create(cls, arg : Variation_1431_Arg) -> 'Variation_1431':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1221]:
        return self._get_list() # type: ignore

RuleVariation_1354_Arg: TypeAlias = Variation_1431_Arg
class RuleVariation_1354(RuleVariationContextFree):
    cv_variation = Variation_1431

    @classmethod
    def create(cls, arg : RuleVariation_1354_Arg) -> "RuleVariation_1354":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1431:
        return self.arg # type: ignore

NonSpare_447_Arg: TypeAlias = RuleVariation_1354_Arg
class NonSpare_447(NonSpare):
    cv_name = "251"
    cv_title = "Tracks in Conflict"
    cv_rule = RuleVariation_1354

    @classmethod
    def create(cls, arg : NonSpare_447_Arg) -> "NonSpare_447":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1354:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1431:
        return self.rule.variation

class UapItem_447(UapItem):
    cv_non_spare = NonSpare_447

NonSpare_378_Arg: TypeAlias = RuleVariation_1314_Arg
class NonSpare_378(NonSpare):
    cv_name = "171"
    cv_title = "Route Points, Requested Flight Level"
    cv_rule = RuleVariation_1314

    @classmethod
    def create(cls, arg : NonSpare_378_Arg) -> "NonSpare_378":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1314:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1391:
        return self.rule.variation

class UapItem_378(UapItem):
    cv_non_spare = NonSpare_378

Variation_1412_Arg: TypeAlias = List[Variation_1130_Arg]
class Variation_1412(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1130

    @classmethod
    def create(cls, arg : Variation_1412_Arg) -> 'Variation_1412':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1130]:
        return self._get_list() # type: ignore

RuleVariation_1335_Arg: TypeAlias = Variation_1412_Arg
class RuleVariation_1335(RuleVariationContextFree):
    cv_variation = Variation_1412

    @classmethod
    def create(cls, arg : RuleVariation_1335_Arg) -> "RuleVariation_1335":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1412:
        return self.arg # type: ignore

NonSpare_343_Arg: TypeAlias = RuleVariation_1335_Arg
class NonSpare_343(NonSpare):
    cv_name = "151"
    cv_title = "Route Points, Geographic Position"
    cv_rule = RuleVariation_1335

    @classmethod
    def create(cls, arg : NonSpare_343_Arg) -> "NonSpare_343":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1335:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1412:
        return self.rule.variation

class UapItem_343(UapItem):
    cv_non_spare = NonSpare_343

Record_48_Arg = TypedDict('Record_48_Arg', {
    "010": NonSpare_48_Arg,
    "020": NonSpare_83_Arg,
    "030": NonSpare_104_Arg,
    "040": NonSpare_139_Arg,
    "050": NonSpare_165_Arg,
    "060": NonSpare_191_Arg,
    "070": NonSpare_211_Arg,
    "080": NonSpare_228_Arg,
    "090": NonSpare_242_Arg,
    "100": NonSpare_274_Arg,
    "110": NonSpare_288_Arg,
    "120": NonSpare_291_Arg,
    "130": NonSpare_302_Arg,
    "140": NonSpare_320_Arg,
    "150": NonSpare_342_Arg,
    "160": NonSpare_354_Arg,
    "170": NonSpare_366_Arg,
    "180": NonSpare_379_Arg,
    "190": NonSpare_382_Arg,
    "200": NonSpare_387_Arg,
    "210": NonSpare_406_Arg,
    "220": NonSpare_418_Arg,
    "230": NonSpare_427_Arg,
    "240": NonSpare_433_Arg,
    "250": NonSpare_446_Arg,
    "251": NonSpare_447_Arg,
    "171": NonSpare_378_Arg,
    "151": NonSpare_343_Arg,
}, total=False)
class Record_48(Record):
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_48, UapItem_83, UapItem_104, UapItem_139, UapItem_165, UapItem_191, UapItem_211, UapItem_228, UapItem_242, UapItem_274, UapItem_288, UapItem_291, UapItem_302, UapItem_320, UapItem_342, UapItem_354, UapItem_366, UapItem_379, UapItem_382, UapItem_387, UapItem_406, UapItem_418, UapItem_427, UapItem_433, UapItem_446, UapItem_447, UapItem_378, UapItem_343]
    cv_items_dict = {"010": NonSpare_48, "020": NonSpare_83, "030": NonSpare_104, "040": NonSpare_139, "050": NonSpare_165, "060": NonSpare_191, "070": NonSpare_211, "080": NonSpare_228, "090": NonSpare_242, "100": NonSpare_274, "110": NonSpare_288, "120": NonSpare_291, "130": NonSpare_302, "140": NonSpare_320, "150": NonSpare_342, "160": NonSpare_354, "170": NonSpare_366, "180": NonSpare_379, "190": NonSpare_382, "200": NonSpare_387, "210": NonSpare_406, "220": NonSpare_418, "230": NonSpare_427, "240": NonSpare_433, "250": NonSpare_446, "251": NonSpare_447, "171": NonSpare_378, "151": NonSpare_343}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_48:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_83:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_104:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_139:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_165:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_191:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_211:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_228:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_242:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_274:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_288:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_291:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_302:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_320:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_342:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_354:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_366:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["180"]) -> NonSpare_379:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["190"]) -> NonSpare_382:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_387:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_406:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_418:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_427:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["240"]) -> NonSpare_433:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_446:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["251"]) -> NonSpare_447:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["171"]) -> NonSpare_378:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_343:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["020"], Literal["030"], Literal["040"], Literal["050"], Literal["060"], Literal["070"], Literal["080"], Literal["090"], Literal["100"], Literal["110"], Literal["120"], Literal["130"], Literal["140"], Literal["150"], Literal["160"], Literal["170"], Literal["180"], Literal["190"], Literal["200"], Literal["210"], Literal["220"], Literal["230"], Literal["240"], Literal["250"], Literal["251"], Literal["171"], Literal["151"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_48]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_83]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_104]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_139]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_165]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_191]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_211]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_228]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_242]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_274]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_288]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_291]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_302]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_320]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_342]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_354]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_366]:
        ...
    @overload
    def get_item(self, key : Literal["180"]) -> Optional[NonSpare_379]:
        ...
    @overload
    def get_item(self, key : Literal["190"]) -> Optional[NonSpare_382]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_387]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_406]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_418]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_427]:
        ...
    @overload
    def get_item(self, key : Literal["240"]) -> Optional[NonSpare_433]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_446]:
        ...
    @overload
    def get_item(self, key : Literal["251"]) -> Optional[NonSpare_447]:
        ...
    @overload
    def get_item(self, key : Literal["171"]) -> Optional[NonSpare_378]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_343]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_48_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_83_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_104_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_139_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_165_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_191_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_211_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_228_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_242_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_274_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_288_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_291_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_302_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_320_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_342_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_354_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_366_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["180"], val : NonSpare_379_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["190"], val : NonSpare_382_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_387_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_406_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_418_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_427_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["240"], val : NonSpare_433_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_446_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["251"], val : NonSpare_447_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["171"], val : NonSpare_378_Arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_343_Arg) -> 'Record_48':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["180"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["190"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["240"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["251"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["171"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_48':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_48_Arg) -> 'Record_48':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_48", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_44_Arg: TypeAlias = Record_48
class Uap_44(UapSingle):
    cv_record = Record_48

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_48]]:
        return cls._parse(bs)

class Asterix_59(AstCat):
    cv_category = 150
    cv_edition = (3, 0)
    cv_uap = Uap_44

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_44_Arg]) -> "Asterix_59":
        return cls._create(records) # type: ignore

NonSpare_32_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_32(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_32_Arg) -> "NonSpare_32":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_32(UapItem):
    cv_non_spare = NonSpare_32

NonSpare_62_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_62(NonSpare):
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_62_Arg) -> "NonSpare_62":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_62(UapItem):
    cv_non_spare = NonSpare_62

Content_595_Arg: TypeAlias = int
class Content_595(ContentTable):
    cv_values = {1: "System Position Report", 2: "System Bearing Report", 3: "System Position Report of conflicting transmission", 4: "System Detection End Report", 5: "Sensor Data Report"}

RuleContent_595_Arg: TypeAlias = Content_595_Arg
class RuleContent_595(RuleContentContextFree):
    cv_content = Content_595

    @property
    def content(self) -> Content_595:
        return self._get_content() # type: ignore

Variation_195_Arg: TypeAlias = RuleContent_595_Arg
class Variation_195(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_595

    @classmethod
    def create(cls, arg : Variation_195_Arg) -> "Variation_195":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_595:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_595:
        return self.rule.content

RuleVariation_188_Arg: TypeAlias = Variation_195_Arg
class RuleVariation_188(RuleVariationContextFree):
    cv_variation = Variation_195

    @classmethod
    def create(cls, arg : RuleVariation_188_Arg) -> "RuleVariation_188":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_195:
        return self.arg # type: ignore

NonSpare_11_Arg: TypeAlias = RuleVariation_188_Arg
class NonSpare_11(NonSpare):
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule = RuleVariation_188

    @classmethod
    def create(cls, arg : NonSpare_11_Arg) -> "NonSpare_11":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_188:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_195:
        return self.rule.variation

class UapItem_11(UapItem):
    cv_non_spare = NonSpare_11

NonSpare_109_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_109(NonSpare):
    cv_name = "030"
    cv_title = "Time of Day"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_109_Arg) -> "NonSpare_109":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_109(UapItem):
    cv_non_spare = NonSpare_109

NonSpare_140_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_140(NonSpare):
    cv_name = "040"
    cv_title = "Report Number"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_140_Arg) -> "NonSpare_140":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_140(UapItem):
    cv_non_spare = NonSpare_140

NonSpare_254_Arg: TypeAlias = RuleVariation_383_Arg
class NonSpare_254(NonSpare):
    cv_name = "090"
    cv_title = "Radio Channel Name"
    cv_rule = RuleVariation_383

    @classmethod
    def create(cls, arg : NonSpare_254_Arg) -> "NonSpare_254":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

class UapItem_254(UapItem):
    cv_non_spare = NonSpare_254

NonSpare_1149_Arg: TypeAlias = RuleVariation_369_Arg
class NonSpare_1149(NonSpare):
    cv_name = "LAT"
    cv_title = "Latitude in WGS-84"
    cv_rule = RuleVariation_369

    @classmethod
    def create(cls, arg : NonSpare_1149_Arg) -> "NonSpare_1149":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_369:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_376:
        return self.rule.variation

Item_467_Arg: TypeAlias = NonSpare_1149_Arg
class Item_467(Item):
    cv_non_spare = NonSpare_1149

    @classmethod
    def create(cls, arg : Item_467_Arg) -> "Item_467":
        return cls._create(arg) # type: ignore

NonSpare_1178_Arg: TypeAlias = RuleVariation_368_Arg
class NonSpare_1178(NonSpare):
    cv_name = "LON"
    cv_title = "Longitude in WGS-84"
    cv_rule = RuleVariation_368

    @classmethod
    def create(cls, arg : NonSpare_1178_Arg) -> "NonSpare_1178":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_368:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_375:
        return self.rule.variation

Item_494_Arg: TypeAlias = NonSpare_1178_Arg
class Item_494(Item):
    cv_non_spare = NonSpare_1178

    @classmethod
    def create(cls, arg : Item_494_Arg) -> "Item_494":
        return cls._create(arg) # type: ignore

Variation_1128_Arg_Group = Tuple[Union[RuleVariation_369_Arg, Tuple[Literal["LAT"], RuleVariation_369_Arg]], Union[RuleVariation_368_Arg, Tuple[Literal["LON"], RuleVariation_368_Arg]]]
Variation_1128_Arg: TypeAlias = Union[int, Variation_1128_Arg_Group]
class Variation_1128(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_467, 32), (Item_494, 32)]
    cv_items_dict = {"LAT": RuleVariation_369, "LON": RuleVariation_368}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_369:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_368:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_369:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_368:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1128_Arg) -> 'Variation_1128':
        return cls._create(arg) # type: ignore

RuleVariation_1085_Arg: TypeAlias = Variation_1128_Arg
class RuleVariation_1085(RuleVariationContextFree):
    cv_variation = Variation_1128

    @classmethod
    def create(cls, arg : RuleVariation_1085_Arg) -> "RuleVariation_1085":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1128:
        return self.arg # type: ignore

NonSpare_173_Arg: TypeAlias = RuleVariation_1085_Arg
class NonSpare_173(NonSpare):
    cv_name = "050"
    cv_title = "Position in WGS-84 Coordinates"
    cv_rule = RuleVariation_1085

    @classmethod
    def create(cls, arg : NonSpare_173_Arg) -> "NonSpare_173":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1085:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1128:
        return self.rule.variation

class UapItem_173(UapItem):
    cv_non_spare = NonSpare_173

NonSpare_190_Arg: TypeAlias = RuleVariation_1237_Arg
class NonSpare_190(NonSpare):
    cv_name = "060"
    cv_title = "Position in Cartesian Coordinates"
    cv_rule = RuleVariation_1237

    @classmethod
    def create(cls, arg : NonSpare_190_Arg) -> "NonSpare_190":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1237:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1310:
        return self.rule.variation

class UapItem_190(UapItem):
    cv_non_spare = NonSpare_190

Content_745_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_745(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0e-2
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_745_Arg: TypeAlias = Content_745_Arg
class RuleContent_745(RuleContentContextFree):
    cv_content = Content_745

    @property
    def content(self) -> Content_745:
        return self._get_content() # type: ignore

Variation_316_Arg: TypeAlias = RuleContent_745_Arg
class Variation_316(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_745

    @classmethod
    def create(cls, arg : Variation_316_Arg) -> "Variation_316":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_745:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_745:
        return self.rule.content

RuleVariation_309_Arg: TypeAlias = Variation_316_Arg
class RuleVariation_309(RuleVariationContextFree):
    cv_variation = Variation_316

    @classmethod
    def create(cls, arg : RuleVariation_309_Arg) -> "RuleVariation_309":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_316:
        return self.arg # type: ignore

NonSpare_201_Arg: TypeAlias = RuleVariation_309_Arg
class NonSpare_201(NonSpare):
    cv_name = "070"
    cv_title = "Local Bearing"
    cv_rule = RuleVariation_309

    @classmethod
    def create(cls, arg : NonSpare_201_Arg) -> "NonSpare_201":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_309:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_316:
        return self.rule.variation

class UapItem_201(UapItem):
    cv_non_spare = NonSpare_201

NonSpare_232_Arg: TypeAlias = RuleVariation_309_Arg
class NonSpare_232(NonSpare):
    cv_name = "080"
    cv_title = "System Bearing"
    cv_rule = RuleVariation_309

    @classmethod
    def create(cls, arg : NonSpare_232_Arg) -> "NonSpare_232":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_309:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_316:
        return self.rule.variation

class UapItem_232(UapItem):
    cv_non_spare = NonSpare_232

NonSpare_272_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_272(NonSpare):
    cv_name = "100"
    cv_title = "Quality of Measurement"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_272_Arg) -> "NonSpare_272":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_272(UapItem):
    cv_non_spare = NonSpare_272

Content_727_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
class Content_727(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 100.0
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

RuleContent_727_Arg: TypeAlias = Content_727_Arg
class RuleContent_727(RuleContentContextFree):
    cv_content = Content_727

    @property
    def content(self) -> Content_727:
        return self._get_content() # type: ignore

Variation_223_Arg: TypeAlias = RuleContent_727_Arg
class Variation_223(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_727

    @classmethod
    def create(cls, arg : Variation_223_Arg) -> "Variation_223":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_727:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_727:
        return self.rule.content

RuleVariation_216_Arg: TypeAlias = Variation_223_Arg
class RuleVariation_216(RuleVariationContextFree):
    cv_variation = Variation_223

    @classmethod
    def create(cls, arg : RuleVariation_216_Arg) -> "RuleVariation_216":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_223:
        return self.arg # type: ignore

NonSpare_281_Arg: TypeAlias = RuleVariation_216_Arg
class NonSpare_281(NonSpare):
    cv_name = "110"
    cv_title = "Estimated Uncertainty"
    cv_rule = RuleVariation_216

    @classmethod
    def create(cls, arg : NonSpare_281_Arg) -> "NonSpare_281":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_216:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_223:
        return self.rule.variation

class UapItem_281(UapItem):
    cv_non_spare = NonSpare_281

Variation_1386_Arg: TypeAlias = List[Variation_164_Arg]
class Variation_1386(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_164

    @classmethod
    def create(cls, arg : Variation_1386_Arg) -> 'Variation_1386':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_164]:
        return self._get_list() # type: ignore

RuleVariation_1309_Arg: TypeAlias = Variation_1386_Arg
class RuleVariation_1309(RuleVariationContextFree):
    cv_variation = Variation_1386

    @classmethod
    def create(cls, arg : RuleVariation_1309_Arg) -> "RuleVariation_1309":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1386:
        return self.arg # type: ignore

NonSpare_294_Arg: TypeAlias = RuleVariation_1309_Arg
class NonSpare_294(NonSpare):
    cv_name = "120"
    cv_title = "Contributing Sensors"
    cv_rule = RuleVariation_1309

    @classmethod
    def create(cls, arg : NonSpare_294_Arg) -> "NonSpare_294":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1309:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1386:
        return self.rule.variation

class UapItem_294(UapItem):
    cv_non_spare = NonSpare_294

NonSpare_303_Arg: TypeAlias = RuleVariation_1085_Arg
class NonSpare_303(NonSpare):
    cv_name = "130"
    cv_title = "Conflicting Transmitter Position in WGS-84 Coordinates"
    cv_rule = RuleVariation_1085

    @classmethod
    def create(cls, arg : NonSpare_303_Arg) -> "NonSpare_303":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1085:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1128:
        return self.rule.variation

class UapItem_303(UapItem):
    cv_non_spare = NonSpare_303

NonSpare_316_Arg: TypeAlias = RuleVariation_1237_Arg
class NonSpare_316(NonSpare):
    cv_name = "140"
    cv_title = "Conflicting Transmitter Position in Cartesian Coordinates"
    cv_rule = RuleVariation_1237

    @classmethod
    def create(cls, arg : NonSpare_316_Arg) -> "NonSpare_316":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1237:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1310:
        return self.rule.variation

class UapItem_316(UapItem):
    cv_non_spare = NonSpare_316

NonSpare_340_Arg: TypeAlias = RuleVariation_216_Arg
class NonSpare_340(NonSpare):
    cv_name = "150"
    cv_title = "Conflicting Transmitter Estimated Uncertainty"
    cv_rule = RuleVariation_216

    @classmethod
    def create(cls, arg : NonSpare_340_Arg) -> "NonSpare_340":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_216:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_223:
        return self.rule.variation

class UapItem_340(UapItem):
    cv_non_spare = NonSpare_340

NonSpare_355_Arg: TypeAlias = RuleVariation_244_Arg
class NonSpare_355(NonSpare):
    cv_name = "160"
    cv_title = "Track Number"
    cv_rule = RuleVariation_244

    @classmethod
    def create(cls, arg : NonSpare_355_Arg) -> "NonSpare_355":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

class UapItem_355(UapItem):
    cv_non_spare = NonSpare_355

NonSpare_367_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_367(NonSpare):
    cv_name = "170"
    cv_title = "Sensor Identification"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_367_Arg) -> "NonSpare_367":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_367(UapItem):
    cv_non_spare = NonSpare_367

Content_641_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["dBµV"]]]
class Content_641(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.0e-2
    cv_unit = "dBµV"

    def as_quantity(self, cv_unit : Optional[Literal["dBµV"]] = None) -> float:
        return self._as_quantity()

RuleContent_641_Arg: TypeAlias = Content_641_Arg
class RuleContent_641(RuleContentContextFree):
    cv_content = Content_641

    @property
    def content(self) -> Content_641:
        return self._get_content() # type: ignore

Variation_265_Arg: TypeAlias = RuleContent_641_Arg
class Variation_265(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_641

    @classmethod
    def create(cls, arg : Variation_265_Arg) -> "Variation_265":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_641:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_641:
        return self.rule.content

RuleVariation_258_Arg: TypeAlias = Variation_265_Arg
class RuleVariation_258(RuleVariationContextFree):
    cv_variation = Variation_265

    @classmethod
    def create(cls, arg : RuleVariation_258_Arg) -> "RuleVariation_258":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_265:
        return self.arg # type: ignore

NonSpare_380_Arg: TypeAlias = RuleVariation_258_Arg
class NonSpare_380(NonSpare):
    cv_name = "180"
    cv_title = "Signal Level"
    cv_rule = RuleVariation_258

    @classmethod
    def create(cls, arg : NonSpare_380_Arg) -> "NonSpare_380":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_258:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_265:
        return self.rule.variation

class UapItem_380(UapItem):
    cv_non_spare = NonSpare_380

NonSpare_383_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_383(NonSpare):
    cv_name = "190"
    cv_title = "Signal Quality"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_383_Arg) -> "NonSpare_383":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_383(UapItem):
    cv_non_spare = NonSpare_383

Content_647_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_647(ContentQuantity):
    cv_signedness = Signed
    cv_lsb = 1.0e-2
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_647_Arg: TypeAlias = Content_647_Arg
class RuleContent_647(RuleContentContextFree):
    cv_content = Content_647

    @property
    def content(self) -> Content_647:
        return self._get_content() # type: ignore

Variation_268_Arg: TypeAlias = RuleContent_647_Arg
class Variation_268(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_647

    @classmethod
    def create(cls, arg : Variation_268_Arg) -> "Variation_268":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_647:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_647:
        return self.rule.content

RuleVariation_261_Arg: TypeAlias = Variation_268_Arg
class RuleVariation_261(RuleVariationContextFree):
    cv_variation = Variation_268

    @classmethod
    def create(cls, arg : RuleVariation_261_Arg) -> "RuleVariation_261":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_268:
        return self.arg # type: ignore

NonSpare_391_Arg: TypeAlias = RuleVariation_261_Arg
class NonSpare_391(NonSpare):
    cv_name = "200"
    cv_title = "Signal Elevation"
    cv_rule = RuleVariation_261

    @classmethod
    def create(cls, arg : NonSpare_391_Arg) -> "NonSpare_391":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_261:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_268:
        return self.rule.variation

class UapItem_391(UapItem):
    cv_non_spare = NonSpare_391

Record_12_Arg = TypedDict('Record_12_Arg', {
    "010": NonSpare_32_Arg,
    "015": NonSpare_62_Arg,
    "000": NonSpare_11_Arg,
    "030": NonSpare_109_Arg,
    "040": NonSpare_140_Arg,
    "090": NonSpare_254_Arg,
    "050": NonSpare_173_Arg,
    "060": NonSpare_190_Arg,
    "070": NonSpare_201_Arg,
    "080": NonSpare_232_Arg,
    "100": NonSpare_272_Arg,
    "110": NonSpare_281_Arg,
    "120": NonSpare_294_Arg,
    "130": NonSpare_303_Arg,
    "140": NonSpare_316_Arg,
    "150": NonSpare_340_Arg,
    "160": NonSpare_355_Arg,
    "170": NonSpare_367_Arg,
    "180": NonSpare_380_Arg,
    "190": NonSpare_383_Arg,
    "200": NonSpare_391_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_12(Record):
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_32, UapItem_62, UapItem_11, UapItem_109, UapItem_140, UapItem_254, UapItem_173, UapItem_190, UapItem_201, UapItem_232, UapItem_272, UapItem_281, UapItem_294, UapItem_303, UapItem_316, UapItem_340, UapItem_355, UapItem_367, UapItem_380, UapItem_383, UapItem_391, UapItem_543]
    cv_items_dict = {"010": NonSpare_32, "015": NonSpare_62, "000": NonSpare_11, "030": NonSpare_109, "040": NonSpare_140, "090": NonSpare_254, "050": NonSpare_173, "060": NonSpare_190, "070": NonSpare_201, "080": NonSpare_232, "100": NonSpare_272, "110": NonSpare_281, "120": NonSpare_294, "130": NonSpare_303, "140": NonSpare_316, "150": NonSpare_340, "160": NonSpare_355, "170": NonSpare_367, "180": NonSpare_380, "190": NonSpare_383, "200": NonSpare_391, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_32:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_62:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_11:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_109:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_140:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_254:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_173:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_190:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_201:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_232:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_272:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_281:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_294:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_303:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_316:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_340:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_355:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_367:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["180"]) -> NonSpare_380:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["190"]) -> NonSpare_383:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_391:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["000"], Literal["030"], Literal["040"], Literal["090"], Literal["050"], Literal["060"], Literal["070"], Literal["080"], Literal["100"], Literal["110"], Literal["120"], Literal["130"], Literal["140"], Literal["150"], Literal["160"], Literal["170"], Literal["180"], Literal["190"], Literal["200"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_32]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_62]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_11]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_109]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_140]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_254]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_173]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_190]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_201]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_232]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_272]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_281]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_294]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_303]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_316]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_340]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_355]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_367]:
        ...
    @overload
    def get_item(self, key : Literal["180"]) -> Optional[NonSpare_380]:
        ...
    @overload
    def get_item(self, key : Literal["190"]) -> Optional[NonSpare_383]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_391]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_32_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_62_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_11_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_109_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_140_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_254_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_173_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_190_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_201_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_232_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_272_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_281_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_294_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_303_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_316_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_340_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_355_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_367_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["180"], val : NonSpare_380_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["190"], val : NonSpare_383_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_391_Arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_12':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["180"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["190"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_12':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_12_Arg) -> 'Record_12':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_12", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_12_Arg: TypeAlias = Record_12
class Uap_12(UapSingle):
    cv_record = Record_12

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_12]]:
        return cls._parse(bs)

class Asterix_60(AstCat):
    cv_category = 205
    cv_edition = (1, 0)
    cv_uap = Uap_12

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_12_Arg]) -> "Asterix_60":
        return cls._create(records) # type: ignore

NonSpare_43_Arg: TypeAlias = RuleVariation_1135_Arg
class NonSpare_43(NonSpare):
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule = RuleVariation_1135

    @classmethod
    def create(cls, arg : NonSpare_43_Arg) -> "NonSpare_43":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class UapItem_43(UapItem):
    cv_non_spare = NonSpare_43

Content_600_Arg: TypeAlias = int
class Content_600(ContentTable):
    cv_values = {1: "Video Summary message", 2: "Video message"}

RuleContent_600_Arg: TypeAlias = Content_600_Arg
class RuleContent_600(RuleContentContextFree):
    cv_content = Content_600

    @property
    def content(self) -> Content_600:
        return self._get_content() # type: ignore

Variation_198_Arg: TypeAlias = RuleContent_600_Arg
class Variation_198(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_600

    @classmethod
    def create(cls, arg : Variation_198_Arg) -> "Variation_198":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_600:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_600:
        return self.rule.content

RuleVariation_191_Arg: TypeAlias = Variation_198_Arg
class RuleVariation_191(RuleVariationContextFree):
    cv_variation = Variation_198

    @classmethod
    def create(cls, arg : RuleVariation_191_Arg) -> "RuleVariation_191":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_198:
        return self.arg # type: ignore

NonSpare_14_Arg: TypeAlias = RuleVariation_191_Arg
class NonSpare_14(NonSpare):
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule = RuleVariation_191

    @classmethod
    def create(cls, arg : NonSpare_14_Arg) -> "NonSpare_14":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_191:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_198:
        return self.rule.variation

class UapItem_14(UapItem):
    cv_non_spare = NonSpare_14

NonSpare_95_Arg: TypeAlias = RuleVariation_366_Arg
class NonSpare_95(NonSpare):
    cv_name = "020"
    cv_title = "Video Record Header"
    cv_rule = RuleVariation_366

    @classmethod
    def create(cls, arg : NonSpare_95_Arg) -> "NonSpare_95":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_366:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_373:
        return self.rule.variation

class UapItem_95(UapItem):
    cv_non_spare = NonSpare_95

NonSpare_113_Arg: TypeAlias = RuleVariation_1311_Arg
class NonSpare_113(NonSpare):
    cv_name = "030"
    cv_title = "Video Summary"
    cv_rule = RuleVariation_1311

    @classmethod
    def create(cls, arg : NonSpare_113_Arg) -> "NonSpare_113":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1311:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1388:
        return self.rule.variation

class UapItem_113(UapItem):
    cv_non_spare = NonSpare_113

Content_791_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
class Content_791(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 5.4931640625e-3
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

RuleContent_790_Arg: TypeAlias = Content_791_Arg
class RuleContent_790(RuleContentContextFree):
    cv_content = Content_791

    @property
    def content(self) -> Content_791:
        return self._get_content() # type: ignore

Variation_342_Arg: TypeAlias = RuleContent_790_Arg
class Variation_342(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_790

    @classmethod
    def create(cls, arg : Variation_342_Arg) -> "Variation_342":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_790:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_791:
        return self.rule.content

RuleVariation_335_Arg: TypeAlias = Variation_342_Arg
class RuleVariation_335(RuleVariationContextFree):
    cv_variation = Variation_342

    @classmethod
    def create(cls, arg : RuleVariation_335_Arg) -> "RuleVariation_335":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_342:
        return self.arg # type: ignore

NonSpare_1764_Arg: TypeAlias = RuleVariation_335_Arg
class NonSpare_1764(NonSpare):
    cv_name = "STARTAZ"
    cv_title = "Start Azimuth of the Cells Group"
    cv_rule = RuleVariation_335

    @classmethod
    def create(cls, arg : NonSpare_1764_Arg) -> "NonSpare_1764":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_335:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_342:
        return self.rule.variation

Item_931_Arg: TypeAlias = NonSpare_1764_Arg
class Item_931(Item):
    cv_non_spare = NonSpare_1764

    @classmethod
    def create(cls, arg : Item_931_Arg) -> "Item_931":
        return cls._create(arg) # type: ignore

NonSpare_926_Arg: TypeAlias = RuleVariation_335_Arg
class NonSpare_926(NonSpare):
    cv_name = "ENDAZ"
    cv_title = "End Azimuth of the Cells Group"
    cv_rule = RuleVariation_335

    @classmethod
    def create(cls, arg : NonSpare_926_Arg) -> "NonSpare_926":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_335:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_342:
        return self.rule.variation

Item_293_Arg: TypeAlias = NonSpare_926_Arg
class Item_293(Item):
    cv_non_spare = NonSpare_926

    @classmethod
    def create(cls, arg : Item_293_Arg) -> "Item_293":
        return cls._create(arg) # type: ignore

NonSpare_1765_Arg: TypeAlias = RuleVariation_366_Arg
class NonSpare_1765(NonSpare):
    cv_name = "STARTRG"
    cv_title = "Starting Range of the Cells Group, Expressed in Number of Cells"
    cv_rule = RuleVariation_366

    @classmethod
    def create(cls, arg : NonSpare_1765_Arg) -> "NonSpare_1765":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_366:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_373:
        return self.rule.variation

Item_932_Arg: TypeAlias = NonSpare_1765_Arg
class Item_932(Item):
    cv_non_spare = NonSpare_1765

    @classmethod
    def create(cls, arg : Item_932_Arg) -> "Item_932":
        return cls._create(arg) # type: ignore

Variation_385_Arg: TypeAlias = RuleContent_720_Arg
class Variation_385(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_720

    @classmethod
    def create(cls, arg : Variation_385_Arg) -> "Variation_385":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_720:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_720:
        return self.rule.content

RuleVariation_378_Arg: TypeAlias = Variation_385_Arg
class RuleVariation_378(RuleVariationContextFree):
    cv_variation = Variation_385

    @classmethod
    def create(cls, arg : RuleVariation_378_Arg) -> "RuleVariation_378":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_385:
        return self.arg # type: ignore

NonSpare_713_Arg: TypeAlias = RuleVariation_378_Arg
class NonSpare_713(NonSpare):
    cv_name = "CELLDUR"
    cv_title = "Video Cell Duration in Nano-seconds"
    cv_rule = RuleVariation_378

    @classmethod
    def create(cls, arg : NonSpare_713_Arg) -> "NonSpare_713":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_378:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_385:
        return self.rule.variation

Item_145_Arg: TypeAlias = NonSpare_713_Arg
class Item_145(Item):
    cv_non_spare = NonSpare_713

    @classmethod
    def create(cls, arg : Item_145_Arg) -> "Item_145":
        return cls._create(arg) # type: ignore

Variation_1208_Arg_Group = Tuple[Union[RuleVariation_335_Arg, Tuple[Literal["STARTAZ"], RuleVariation_335_Arg]], Union[RuleVariation_335_Arg, Tuple[Literal["ENDAZ"], RuleVariation_335_Arg]], Union[RuleVariation_366_Arg, Tuple[Literal["STARTRG"], RuleVariation_366_Arg]], Union[RuleVariation_378_Arg, Tuple[Literal["CELLDUR"], RuleVariation_378_Arg]]]
Variation_1208_Arg: TypeAlias = Union[int, Variation_1208_Arg_Group]
class Variation_1208(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 96
    cv_items_list = [(Item_931, 16), (Item_293, 16), (Item_932, 32), (Item_145, 32)]
    cv_items_dict = {"STARTAZ": RuleVariation_335, "ENDAZ": RuleVariation_335, "STARTRG": RuleVariation_366, "CELLDUR": RuleVariation_378}

    @overload
    @classmethod
    def spec(cls, key : Literal["STARTAZ"]) -> RuleVariation_335:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ENDAZ"]) -> RuleVariation_335:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STARTRG"]) -> RuleVariation_366:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CELLDUR"]) -> RuleVariation_378:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["STARTAZ"], Literal["ENDAZ"], Literal["STARTRG"], Literal["CELLDUR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["STARTAZ"]) -> RuleVariation_335:
        ...
    @overload
    def get_item(self, key : Literal["ENDAZ"]) -> RuleVariation_335:
        ...
    @overload
    def get_item(self, key : Literal["STARTRG"]) -> RuleVariation_366:
        ...
    @overload
    def get_item(self, key : Literal["CELLDUR"]) -> RuleVariation_378:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1208_Arg) -> 'Variation_1208':
        return cls._create(arg) # type: ignore

RuleVariation_1153_Arg: TypeAlias = Variation_1208_Arg
class RuleVariation_1153(RuleVariationContextFree):
    cv_variation = Variation_1208

    @classmethod
    def create(cls, arg : RuleVariation_1153_Arg) -> "RuleVariation_1153":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1208:
        return self.arg # type: ignore

NonSpare_149_Arg: TypeAlias = RuleVariation_1153_Arg
class NonSpare_149(NonSpare):
    cv_name = "040"
    cv_title = "Video Header Nano"
    cv_rule = RuleVariation_1153

    @classmethod
    def create(cls, arg : NonSpare_149_Arg) -> "NonSpare_149":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1153:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1208:
        return self.rule.variation

class UapItem_149(UapItem):
    cv_non_spare = NonSpare_149

Content_711_Arg: TypeAlias = Union[int, float, Tuple[float, Literal["fs"]]]
class Content_711(ContentQuantity):
    cv_signedness = Unsigned
    cv_lsb = 1.0
    cv_unit = "fs"

    def as_quantity(self, cv_unit : Optional[Literal["fs"]] = None) -> float:
        return self._as_quantity()

RuleContent_711_Arg: TypeAlias = Content_711_Arg
class RuleContent_711(RuleContentContextFree):
    cv_content = Content_711

    @property
    def content(self) -> Content_711:
        return self._get_content() # type: ignore

Variation_384_Arg: TypeAlias = RuleContent_711_Arg
class Variation_384(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_711

    @classmethod
    def create(cls, arg : Variation_384_Arg) -> "Variation_384":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_711:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_711:
        return self.rule.content

RuleVariation_377_Arg: TypeAlias = Variation_384_Arg
class RuleVariation_377(RuleVariationContextFree):
    cv_variation = Variation_384

    @classmethod
    def create(cls, arg : RuleVariation_377_Arg) -> "RuleVariation_377":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_384:
        return self.arg # type: ignore

NonSpare_712_Arg: TypeAlias = RuleVariation_377_Arg
class NonSpare_712(NonSpare):
    cv_name = "CELLDUR"
    cv_title = "Video Cell Duration in Femto-seconds"
    cv_rule = RuleVariation_377

    @classmethod
    def create(cls, arg : NonSpare_712_Arg) -> "NonSpare_712":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_377:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_384:
        return self.rule.variation

Item_144_Arg: TypeAlias = NonSpare_712_Arg
class Item_144(Item):
    cv_non_spare = NonSpare_712

    @classmethod
    def create(cls, arg : Item_144_Arg) -> "Item_144":
        return cls._create(arg) # type: ignore

Variation_1207_Arg_Group = Tuple[Union[RuleVariation_335_Arg, Tuple[Literal["STARTAZ"], RuleVariation_335_Arg]], Union[RuleVariation_335_Arg, Tuple[Literal["ENDAZ"], RuleVariation_335_Arg]], Union[RuleVariation_366_Arg, Tuple[Literal["STARTRG"], RuleVariation_366_Arg]], Union[RuleVariation_377_Arg, Tuple[Literal["CELLDUR"], RuleVariation_377_Arg]]]
Variation_1207_Arg: TypeAlias = Union[int, Variation_1207_Arg_Group]
class Variation_1207(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 96
    cv_items_list = [(Item_931, 16), (Item_293, 16), (Item_932, 32), (Item_144, 32)]
    cv_items_dict = {"STARTAZ": RuleVariation_335, "ENDAZ": RuleVariation_335, "STARTRG": RuleVariation_366, "CELLDUR": RuleVariation_377}

    @overload
    @classmethod
    def spec(cls, key : Literal["STARTAZ"]) -> RuleVariation_335:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ENDAZ"]) -> RuleVariation_335:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STARTRG"]) -> RuleVariation_366:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CELLDUR"]) -> RuleVariation_377:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["STARTAZ"], Literal["ENDAZ"], Literal["STARTRG"], Literal["CELLDUR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["STARTAZ"]) -> RuleVariation_335:
        ...
    @overload
    def get_item(self, key : Literal["ENDAZ"]) -> RuleVariation_335:
        ...
    @overload
    def get_item(self, key : Literal["STARTRG"]) -> RuleVariation_366:
        ...
    @overload
    def get_item(self, key : Literal["CELLDUR"]) -> RuleVariation_377:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1207_Arg) -> 'Variation_1207':
        return cls._create(arg) # type: ignore

RuleVariation_1152_Arg: TypeAlias = Variation_1207_Arg
class RuleVariation_1152(RuleVariationContextFree):
    cv_variation = Variation_1207

    @classmethod
    def create(cls, arg : RuleVariation_1152_Arg) -> "RuleVariation_1152":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1207:
        return self.arg # type: ignore

NonSpare_155_Arg: TypeAlias = RuleVariation_1152_Arg
class NonSpare_155(NonSpare):
    cv_name = "041"
    cv_title = "Video Header Femto"
    cv_rule = RuleVariation_1152

    @classmethod
    def create(cls, arg : NonSpare_155_Arg) -> "NonSpare_155":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1152:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1207:
        return self.rule.variation

class UapItem_155(UapItem):
    cv_non_spare = NonSpare_155

Content_339_Arg: TypeAlias = int
class Content_339(ContentTable):
    cv_values = {0: "No compression applied", 1: "Compression applied"}

RuleContent_339_Arg: TypeAlias = Content_339_Arg
class RuleContent_339(RuleContentContextFree):
    cv_content = Content_339

    @property
    def content(self) -> Content_339:
        return self._get_content() # type: ignore

Variation_59_Arg: TypeAlias = RuleContent_339_Arg
class Variation_59(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_339

    @classmethod
    def create(cls, arg : Variation_59_Arg) -> "Variation_59":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_339:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_339:
        return self.rule.content

RuleVariation_59_Arg: TypeAlias = Variation_59_Arg
class RuleVariation_59(RuleVariationContextFree):
    cv_variation = Variation_59

    @classmethod
    def create(cls, arg : RuleVariation_59_Arg) -> "RuleVariation_59":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_59:
        return self.arg # type: ignore

NonSpare_694_Arg: TypeAlias = RuleVariation_59_Arg
class NonSpare_694(NonSpare):
    cv_name = "C"
    cv_title = "Data Compression Indicator"
    cv_rule = RuleVariation_59

    @classmethod
    def create(cls, arg : NonSpare_694_Arg) -> "NonSpare_694":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_59:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_59:
        return self.rule.variation

Item_131_Arg: TypeAlias = NonSpare_694_Arg
class Item_131(Item):
    cv_non_spare = NonSpare_694

    @classmethod
    def create(cls, arg : Item_131_Arg) -> "Item_131":
        return cls._create(arg) # type: ignore

Content_583_Arg: TypeAlias = int
class Content_583(ContentTable):
    cv_values = {1: "Monobit Resolution (1 bit)", 2: "Low Resolution (2 bits)", 3: "Medium Resolution (4 bits)", 4: "High Resolution (8 bits)", 5: "Very High Resolution (16 bits)", 6: "Ultra High Resolution (32 bits)"}

RuleContent_583_Arg: TypeAlias = Content_583_Arg
class RuleContent_583(RuleContentContextFree):
    cv_content = Content_583

    @property
    def content(self) -> Content_583:
        return self._get_content() # type: ignore

Variation_184_Arg: TypeAlias = RuleContent_583_Arg
class Variation_184(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_583

    @classmethod
    def create(cls, arg : Variation_184_Arg) -> "Variation_184":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_583:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_583:
        return self.rule.content

RuleVariation_177_Arg: TypeAlias = Variation_184_Arg
class RuleVariation_177(RuleVariationContextFree):
    cv_variation = Variation_184

    @classmethod
    def create(cls, arg : RuleVariation_177_Arg) -> "RuleVariation_177":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_184:
        return self.arg # type: ignore

NonSpare_1574_Arg: TypeAlias = RuleVariation_177_Arg
class NonSpare_1574(NonSpare):
    cv_name = "RES"
    cv_title = "Bit Resolution"
    cv_rule = RuleVariation_177

    @classmethod
    def create(cls, arg : NonSpare_1574_Arg) -> "NonSpare_1574":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_177:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_184:
        return self.rule.variation

Item_805_Arg: TypeAlias = NonSpare_1574_Arg
class Item_805(Item):
    cv_non_spare = NonSpare_1574

    @classmethod
    def create(cls, arg : Item_805_Arg) -> "Item_805":
        return cls._create(arg) # type: ignore

Variation_1058_Arg_Group = Tuple[Union[RuleVariation_59_Arg, Tuple[Literal["C"], RuleVariation_59_Arg]], int, Union[RuleVariation_177_Arg, Tuple[Literal["RES"], RuleVariation_177_Arg]]]
Variation_1058_Arg: TypeAlias = Union[int, Variation_1058_Arg_Group]
class Variation_1058(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_131, 1), (Item_10, 7), (Item_805, 8)]
    cv_items_dict = {"C": RuleVariation_59, "RES": RuleVariation_177}

    @overload
    @classmethod
    def spec(cls, key : Literal["C"]) -> RuleVariation_59:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RES"]) -> RuleVariation_177:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["C"], Literal["RES"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["C"]) -> RuleVariation_59:
        ...
    @overload
    def get_item(self, key : Literal["RES"]) -> RuleVariation_177:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1058_Arg) -> 'Variation_1058':
        return cls._create(arg) # type: ignore

RuleVariation_1022_Arg: TypeAlias = Variation_1058_Arg
class RuleVariation_1022(RuleVariationContextFree):
    cv_variation = Variation_1058

    @classmethod
    def create(cls, arg : RuleVariation_1022_Arg) -> "RuleVariation_1022":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1058:
        return self.arg # type: ignore

NonSpare_163_Arg: TypeAlias = RuleVariation_1022_Arg
class NonSpare_163(NonSpare):
    cv_name = "048"
    cv_title = "Video Cells Resolution & Data Compression Indicator"
    cv_rule = RuleVariation_1022

    @classmethod
    def create(cls, arg : NonSpare_163_Arg) -> "NonSpare_163":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1022:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1058:
        return self.rule.variation

class UapItem_163(UapItem):
    cv_non_spare = NonSpare_163

NonSpare_1346_Arg: TypeAlias = RuleVariation_247_Arg
class NonSpare_1346(NonSpare):
    cv_name = "NBVB"
    cv_title = "Number of 'valid' Octets"
    cv_rule = RuleVariation_247

    @classmethod
    def create(cls, arg : NonSpare_1346_Arg) -> "NonSpare_1346":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_247:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_254:
        return self.rule.variation

Item_612_Arg: TypeAlias = NonSpare_1346_Arg
class Item_612(Item):
    cv_non_spare = NonSpare_1346

    @classmethod
    def create(cls, arg : Item_612_Arg) -> "Item_612":
        return cls._create(arg) # type: ignore

NonSpare_1341_Arg: TypeAlias = RuleVariation_342_Arg
class NonSpare_1341(NonSpare):
    cv_name = "NBCELLS"
    cv_title = "Number of 'valid' Cells"
    cv_rule = RuleVariation_342

    @classmethod
    def create(cls, arg : NonSpare_1341_Arg) -> "NonSpare_1341":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_342:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_349:
        return self.rule.variation

Item_607_Arg: TypeAlias = NonSpare_1341_Arg
class Item_607(Item):
    cv_non_spare = NonSpare_1341

    @classmethod
    def create(cls, arg : Item_607_Arg) -> "Item_607":
        return cls._create(arg) # type: ignore

Variation_1143_Arg_Group = Tuple[Union[RuleVariation_247_Arg, Tuple[Literal["NBVB"], RuleVariation_247_Arg]], Union[RuleVariation_342_Arg, Tuple[Literal["NBCELLS"], RuleVariation_342_Arg]]]
Variation_1143_Arg: TypeAlias = Union[int, Variation_1143_Arg_Group]
class Variation_1143(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_items_list = [(Item_612, 16), (Item_607, 24)]
    cv_items_dict = {"NBVB": RuleVariation_247, "NBCELLS": RuleVariation_342}

    @overload
    @classmethod
    def spec(cls, key : Literal["NBVB"]) -> RuleVariation_247:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NBCELLS"]) -> RuleVariation_342:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["NBVB"], Literal["NBCELLS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["NBVB"]) -> RuleVariation_247:
        ...
    @overload
    def get_item(self, key : Literal["NBCELLS"]) -> RuleVariation_342:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1143_Arg) -> 'Variation_1143':
        return cls._create(arg) # type: ignore

RuleVariation_1097_Arg: TypeAlias = Variation_1143_Arg
class RuleVariation_1097(RuleVariationContextFree):
    cv_variation = Variation_1143

    @classmethod
    def create(cls, arg : RuleVariation_1097_Arg) -> "RuleVariation_1097":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1143:
        return self.arg # type: ignore

NonSpare_164_Arg: TypeAlias = RuleVariation_1097_Arg
class NonSpare_164(NonSpare):
    cv_name = "049"
    cv_title = "Video Octets & Video Cells Counters"
    cv_rule = RuleVariation_1097

    @classmethod
    def create(cls, arg : NonSpare_164_Arg) -> "NonSpare_164":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1097:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1143:
        return self.rule.variation

class UapItem_164(UapItem):
    cv_non_spare = NonSpare_164

Variation_1392_Arg: TypeAlias = List[Variation_371_Arg]
class Variation_1392(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_371

    @classmethod
    def create(cls, arg : Variation_1392_Arg) -> 'Variation_1392':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_371]:
        return self._get_list() # type: ignore

RuleVariation_1315_Arg: TypeAlias = Variation_1392_Arg
class RuleVariation_1315(RuleVariationContextFree):
    cv_variation = Variation_1392

    @classmethod
    def create(cls, arg : RuleVariation_1315_Arg) -> "RuleVariation_1315":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1392:
        return self.arg # type: ignore

NonSpare_180_Arg: TypeAlias = RuleVariation_1315_Arg
class NonSpare_180(NonSpare):
    cv_name = "050"
    cv_title = "Video Block Low Data Volume"
    cv_rule = RuleVariation_1315

    @classmethod
    def create(cls, arg : NonSpare_180_Arg) -> "NonSpare_180":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1315:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1392:
        return self.rule.variation

class UapItem_180(UapItem):
    cv_non_spare = NonSpare_180

Variation_396_Arg: TypeAlias = RuleContent_0_Arg
class Variation_396(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 512
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_396_Arg) -> "Variation_396":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

Variation_1397_Arg: TypeAlias = List[Variation_396_Arg]
class Variation_1397(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_396

    @classmethod
    def create(cls, arg : Variation_1397_Arg) -> 'Variation_1397':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_396]:
        return self._get_list() # type: ignore

RuleVariation_1320_Arg: TypeAlias = Variation_1397_Arg
class RuleVariation_1320(RuleVariationContextFree):
    cv_variation = Variation_1397

    @classmethod
    def create(cls, arg : RuleVariation_1320_Arg) -> "RuleVariation_1320":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1397:
        return self.arg # type: ignore

NonSpare_181_Arg: TypeAlias = RuleVariation_1320_Arg
class NonSpare_181(NonSpare):
    cv_name = "051"
    cv_title = "Video Block Medium Data Volume"
    cv_rule = RuleVariation_1320

    @classmethod
    def create(cls, arg : NonSpare_181_Arg) -> "NonSpare_181":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1320:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1397:
        return self.rule.variation

class UapItem_181(UapItem):
    cv_non_spare = NonSpare_181

Variation_397_Arg: TypeAlias = RuleContent_0_Arg
class Variation_397(Element):
    cv_bit_offset8 = 0
    cv_bit_size = 2048
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg : Variation_397_Arg) -> "Variation_397":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut to content
    @property
    def content(self) -> Content_0:
        return self.rule.content

Variation_1398_Arg: TypeAlias = List[Variation_397_Arg]
class Variation_1398(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_397

    @classmethod
    def create(cls, arg : Variation_1398_Arg) -> 'Variation_1398':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_397]:
        return self._get_list() # type: ignore

RuleVariation_1321_Arg: TypeAlias = Variation_1398_Arg
class RuleVariation_1321(RuleVariationContextFree):
    cv_variation = Variation_1398

    @classmethod
    def create(cls, arg : RuleVariation_1321_Arg) -> "RuleVariation_1321":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1398:
        return self.arg # type: ignore

NonSpare_182_Arg: TypeAlias = RuleVariation_1321_Arg
class NonSpare_182(NonSpare):
    cv_name = "052"
    cv_title = "Video Block High Data Volume"
    cv_rule = RuleVariation_1321

    @classmethod
    def create(cls, arg : NonSpare_182_Arg) -> "NonSpare_182":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1321:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1398:
        return self.rule.variation

class UapItem_182(UapItem):
    cv_non_spare = NonSpare_182

NonSpare_325_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_325(NonSpare):
    cv_name = "140"
    cv_title = "Time of Day"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_325_Arg) -> "NonSpare_325":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_325(UapItem):
    cv_non_spare = NonSpare_325

Record_38_Arg = TypedDict('Record_38_Arg', {
    "010": NonSpare_43_Arg,
    "000": NonSpare_14_Arg,
    "020": NonSpare_95_Arg,
    "030": NonSpare_113_Arg,
    "040": NonSpare_149_Arg,
    "041": NonSpare_155_Arg,
    "048": NonSpare_163_Arg,
    "049": NonSpare_164_Arg,
    "050": NonSpare_180_Arg,
    "051": NonSpare_181_Arg,
    "052": NonSpare_182_Arg,
    "140": NonSpare_325_Arg,
    "RE": NonSpare_1558_Arg,
    "SP": NonSpare_1723_Arg,
}, total=False)
class Record_38(Record):
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_43, UapItem_14, UapItem_95, UapItem_113, UapItem_149, UapItem_155, UapItem_163, UapItem_164, UapItem_180, UapItem_181, UapItem_182, UapItem_325, UapItem_542, UapItem_543]
    cv_items_dict = {"010": NonSpare_43, "000": NonSpare_14, "020": NonSpare_95, "030": NonSpare_113, "040": NonSpare_149, "041": NonSpare_155, "048": NonSpare_163, "049": NonSpare_164, "050": NonSpare_180, "051": NonSpare_181, "052": NonSpare_182, "140": NonSpare_325, "RE": NonSpare_1558, "SP": NonSpare_1723}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_43:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_14:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_95:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_113:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_149:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_155:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["048"]) -> NonSpare_163:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["049"]) -> NonSpare_164:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_180:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["051"]) -> NonSpare_181:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["052"]) -> NonSpare_182:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_325:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["020"], Literal["030"], Literal["040"], Literal["041"], Literal["048"], Literal["049"], Literal["050"], Literal["051"], Literal["052"], Literal["140"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_43]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_14]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_95]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_113]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_149]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_155]:
        ...
    @overload
    def get_item(self, key : Literal["048"]) -> Optional[NonSpare_163]:
        ...
    @overload
    def get_item(self, key : Literal["049"]) -> Optional[NonSpare_164]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_180]:
        ...
    @overload
    def get_item(self, key : Literal["051"]) -> Optional[NonSpare_181]:
        ...
    @overload
    def get_item(self, key : Literal["052"]) -> Optional[NonSpare_182]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_325]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_43_Arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_14_Arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_95_Arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_113_Arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_149_Arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_155_Arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["048"], val : NonSpare_163_Arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["049"], val : NonSpare_164_Arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_180_Arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["051"], val : NonSpare_181_Arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["052"], val : NonSpare_182_Arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_325_Arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_38':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["048"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["049"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["051"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["052"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_38':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_38_Arg) -> 'Record_38':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_38", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_34_Arg: TypeAlias = Record_38
class Uap_34(UapSingle):
    cv_record = Record_38

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_38]]:
        return cls._parse(bs)

class Asterix_61(AstCat):
    cv_category = 240
    cv_edition = (1, 3)
    cv_uap = Uap_34

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_34_Arg]) -> "Asterix_61":
        return cls._create(records) # type: ignore

NonSpare_65_Arg: TypeAlias = RuleVariation_158_Arg
class NonSpare_65(NonSpare):
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule = RuleVariation_158

    @classmethod
    def create(cls, arg : NonSpare_65_Arg) -> "NonSpare_65":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class UapItem_65(UapItem):
    cv_non_spare = NonSpare_65

NonSpare_327_Arg: TypeAlias = RuleVariation_361_Arg
class NonSpare_327(NonSpare):
    cv_name = "140"
    cv_title = "Time of Day"
    cv_rule = RuleVariation_361

    @classmethod
    def create(cls, arg : NonSpare_327_Arg) -> "NonSpare_327":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class UapItem_327(UapItem):
    cv_non_spare = NonSpare_327

NonSpare_700_Arg: TypeAlias = RuleVariation_196_Arg
class NonSpare_700(NonSpare):
    cv_name = "CAT"
    cv_title = "Category"
    cv_rule = RuleVariation_196

    @classmethod
    def create(cls, arg : NonSpare_700_Arg) -> "NonSpare_700":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_203:
        return self.rule.variation

Item_135_Arg: TypeAlias = NonSpare_700_Arg
class Item_135(Item):
    cv_non_spare = NonSpare_700

    @classmethod
    def create(cls, arg : Item_135_Arg) -> "Item_135":
        return cls._create(arg) # type: ignore

NonSpare_1217_Arg: TypeAlias = RuleVariation_196_Arg
class NonSpare_1217(NonSpare):
    cv_name = "MAIN"
    cv_title = "Main Version Number"
    cv_rule = RuleVariation_196

    @classmethod
    def create(cls, arg : NonSpare_1217_Arg) -> "NonSpare_1217":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_203:
        return self.rule.variation

Item_523_Arg: TypeAlias = NonSpare_1217_Arg
class Item_523(Item):
    cv_non_spare = NonSpare_1217

    @classmethod
    def create(cls, arg : Item_523_Arg) -> "Item_523":
        return cls._create(arg) # type: ignore

NonSpare_1797_Arg: TypeAlias = RuleVariation_196_Arg
class NonSpare_1797(NonSpare):
    cv_name = "SUB"
    cv_title = "Sub Version Number"
    cv_rule = RuleVariation_196

    @classmethod
    def create(cls, arg : NonSpare_1797_Arg) -> "NonSpare_1797":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_203:
        return self.rule.variation

Item_959_Arg: TypeAlias = NonSpare_1797_Arg
class Item_959(Item):
    cv_non_spare = NonSpare_1797

    @classmethod
    def create(cls, arg : Item_959_Arg) -> "Item_959":
        return cls._create(arg) # type: ignore

Variation_1060_Arg_Group = Tuple[Union[RuleVariation_196_Arg, Tuple[Literal["CAT"], RuleVariation_196_Arg]], Union[RuleVariation_196_Arg, Tuple[Literal["MAIN"], RuleVariation_196_Arg]], Union[RuleVariation_196_Arg, Tuple[Literal["SUB"], RuleVariation_196_Arg]]]
Variation_1060_Arg: TypeAlias = Union[int, Variation_1060_Arg_Group]
class Variation_1060(Group):
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_135, 8), (Item_523, 8), (Item_959, 8)]
    cv_items_dict = {"CAT": RuleVariation_196, "MAIN": RuleVariation_196, "SUB": RuleVariation_196}

    @overload
    @classmethod
    def spec(cls, key : Literal["CAT"]) -> RuleVariation_196:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MAIN"]) -> RuleVariation_196:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SUB"]) -> RuleVariation_196:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CAT"], Literal["MAIN"], Literal["SUB"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CAT"]) -> RuleVariation_196:
        ...
    @overload
    def get_item(self, key : Literal["MAIN"]) -> RuleVariation_196:
        ...
    @overload
    def get_item(self, key : Literal["SUB"]) -> RuleVariation_196:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg : Variation_1060_Arg) -> 'Variation_1060':
        return cls._create(arg) # type: ignore

Variation_1405_Arg: TypeAlias = List[Variation_1060_Arg]
class Variation_1405(Repetitive):
    cv_rep_bytes = 1
    cv_variation = Variation_1060

    @classmethod
    def create(cls, arg : Variation_1405_Arg) -> 'Variation_1405':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1060]:
        return self._get_list() # type: ignore

RuleVariation_1328_Arg: TypeAlias = Variation_1405_Arg
class RuleVariation_1328(RuleVariationContextFree):
    cv_variation = Variation_1405

    @classmethod
    def create(cls, arg : RuleVariation_1328_Arg) -> "RuleVariation_1328":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1405:
        return self.arg # type: ignore

NonSpare_516_Arg: TypeAlias = RuleVariation_1328_Arg
class NonSpare_516(NonSpare):
    cv_name = "550"
    cv_title = "Category Version Number Report"
    cv_rule = RuleVariation_1328

    @classmethod
    def create(cls, arg : NonSpare_516_Arg) -> "NonSpare_516":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1328:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1405:
        return self.rule.variation

class UapItem_515(UapItem):
    cv_non_spare = NonSpare_516

Record_22_Arg = TypedDict('Record_22_Arg', {
    "010": NonSpare_36_Arg,
    "015": NonSpare_65_Arg,
    "140": NonSpare_327_Arg,
    "550": NonSpare_516_Arg,
    "SP": NonSpare_1723_Arg,
    "RE": NonSpare_1558_Arg,
}, total=False)
class Record_22(Record):
    cv_fspec_max_bytes = 1
    cv_items_list = [UapItem_36, UapItem_65, UapItem_327, UapItem_515, UapItem_544, UapItem_543, UapItem_542]
    cv_items_dict = {"010": NonSpare_36, "015": NonSpare_65, "140": NonSpare_327, "550": NonSpare_516, "SP": NonSpare_1723, "RE": NonSpare_1558}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_36:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_65:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_327:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["550"]) -> NonSpare_516:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["140"], Literal["550"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_36]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_65]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_327]:
        ...
    @overload
    def get_item(self, key : Literal["550"]) -> Optional[NonSpare_516]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_36_Arg) -> 'Record_22':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_65_Arg) -> 'Record_22':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_327_Arg) -> 'Record_22':
        ...
    @overload
    def set_item(self, key : Literal["550"], val : NonSpare_516_Arg) -> 'Record_22':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_22':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_22':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_22':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_22':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_22':
        ...
    @overload
    def del_item(self, key : Literal["550"]) -> 'Record_22':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_22':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_22':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_22_Arg) -> 'Record_22':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_22", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_20_Arg: TypeAlias = Record_22
class Uap_20(UapSingle):
    cv_record = Record_22

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_22]]:
        return cls._parse(bs)

class Asterix_62(AstCat):
    cv_category = 247
    cv_edition = (1, 2)
    cv_uap = Uap_20

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_20_Arg]) -> "Asterix_62":
        return cls._create(records) # type: ignore

NonSpare_517_Arg: TypeAlias = RuleVariation_1328_Arg
class NonSpare_517(NonSpare):
    cv_name = "550"
    cv_title = "Category Version Number Report"
    cv_rule = RuleVariation_1328

    @classmethod
    def create(cls, arg : NonSpare_517_Arg) -> "NonSpare_517":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1328:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1405:
        return self.rule.variation

class UapItem_516(UapItem):
    cv_non_spare = NonSpare_517

Record_23_Arg = TypedDict('Record_23_Arg', {
    "010": NonSpare_36_Arg,
    "015": NonSpare_65_Arg,
    "140": NonSpare_327_Arg,
    "550": NonSpare_517_Arg,
    "SP": NonSpare_1723_Arg,
    "RE": NonSpare_1558_Arg,
}, total=False)
class Record_23(Record):
    cv_fspec_max_bytes = 1
    cv_items_list = [UapItem_36, UapItem_65, UapItem_327, UapItem_516, UapItem_544, UapItem_543, UapItem_542]
    cv_items_dict = {"010": NonSpare_36, "015": NonSpare_65, "140": NonSpare_327, "550": NonSpare_517, "SP": NonSpare_1723, "RE": NonSpare_1558}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_36:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_65:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_327:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["550"]) -> NonSpare_517:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1723:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1558:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["140"], Literal["550"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_36]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_65]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_327]:
        ...
    @overload
    def get_item(self, key : Literal["550"]) -> Optional[NonSpare_517]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1723]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1558]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_36_Arg) -> 'Record_23':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_65_Arg) -> 'Record_23':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_327_Arg) -> 'Record_23':
        ...
    @overload
    def set_item(self, key : Literal["550"], val : NonSpare_517_Arg) -> 'Record_23':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1723_Arg) -> 'Record_23':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1558_Arg) -> 'Record_23':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_23':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_23':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_23':
        ...
    @overload
    def del_item(self, key : Literal["550"]) -> 'Record_23':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_23':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_23':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg : Record_23_Arg) -> 'Record_23':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Record_23", Bits]]:
        return cls._parse(bs) # type: ignore

Uap_21_Arg: TypeAlias = Record_23
class Uap_21(UapSingle):
    cv_record = Record_23

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_23]]:
        return cls._parse(bs)

class Asterix_63(AstCat):
    cv_category = 247
    cv_edition = (1, 3)
    cv_uap = Uap_21

    # shortcut to record
    cv_record = cv_uap.cv_record

    @classmethod
    def create(cls, records : List[Uap_21_Arg]) -> "Asterix_63":
        return cls._create(records) # type: ignore

# Aliases

Cat_001_1_2: TypeAlias = Asterix_0
Cat_001_1_3: TypeAlias = Asterix_1
Cat_001_1_4: TypeAlias = Asterix_2
Cat_002_1_0: TypeAlias = Asterix_3
Cat_002_1_1: TypeAlias = Asterix_4
Cat_004_1_12: TypeAlias = Asterix_5
Cat_008_1_2: TypeAlias = Asterix_6
Cat_008_1_3: TypeAlias = Asterix_7
Cat_009_2_1: TypeAlias = Asterix_8
Cat_010_1_1: TypeAlias = Asterix_9
Cat_011_1_2: TypeAlias = Asterix_10
Cat_011_1_3: TypeAlias = Asterix_11
Cat_015_1_0: TypeAlias = Asterix_12
Cat_015_1_1: TypeAlias = Asterix_13
Cat_015_1_2: TypeAlias = Asterix_14
Cat_016_1_0: TypeAlias = Asterix_15
Cat_017_1_3: TypeAlias = Asterix_16
Cat_018_1_7: TypeAlias = Asterix_17
Cat_018_1_8: TypeAlias = Asterix_18
Cat_019_1_3: TypeAlias = Asterix_19
Cat_020_1_9: TypeAlias = Asterix_20
Cat_020_1_10: TypeAlias = Asterix_21
Cat_021_0_23: TypeAlias = Asterix_22
Cat_021_0_24: TypeAlias = Asterix_23
Cat_021_0_25: TypeAlias = Asterix_24
Cat_021_0_26: TypeAlias = Asterix_25
Ref_021_1_4: TypeAlias = Asterix_26
Ref_021_1_5: TypeAlias = Asterix_27
Cat_021_2_1: TypeAlias = Asterix_28
Cat_021_2_2: TypeAlias = Asterix_29
Cat_021_2_3: TypeAlias = Asterix_30
Cat_021_2_4: TypeAlias = Asterix_31
Cat_021_2_5: TypeAlias = Asterix_32
Cat_021_2_6: TypeAlias = Asterix_33
Cat_023_1_2: TypeAlias = Asterix_34
Cat_023_1_3: TypeAlias = Asterix_35
Cat_025_1_5: TypeAlias = Asterix_36
Cat_032_1_1: TypeAlias = Asterix_37
Cat_034_1_27: TypeAlias = Asterix_38
Cat_034_1_28: TypeAlias = Asterix_39
Cat_034_1_29: TypeAlias = Asterix_40
Ref_048_1_11: TypeAlias = Asterix_41
Ref_048_1_12: TypeAlias = Asterix_42
Cat_048_1_27: TypeAlias = Asterix_43
Cat_048_1_28: TypeAlias = Asterix_44
Cat_048_1_29: TypeAlias = Asterix_45
Cat_048_1_30: TypeAlias = Asterix_46
Cat_048_1_31: TypeAlias = Asterix_47
Cat_048_1_32: TypeAlias = Asterix_48
Ref_062_1_2: TypeAlias = Asterix_49
Ref_062_1_3: TypeAlias = Asterix_50
Cat_062_1_17: TypeAlias = Asterix_51
Cat_062_1_18: TypeAlias = Asterix_52
Cat_062_1_19: TypeAlias = Asterix_53
Cat_062_1_20: TypeAlias = Asterix_54
Cat_063_1_6: TypeAlias = Asterix_55
Cat_065_1_4: TypeAlias = Asterix_56
Cat_065_1_5: TypeAlias = Asterix_57
Cat_065_1_6: TypeAlias = Asterix_58
Cat_150_3_0: TypeAlias = Asterix_59
Cat_205_1_0: TypeAlias = Asterix_60
Cat_240_1_3: TypeAlias = Asterix_61
Cat_247_1_2: TypeAlias = Asterix_62
Cat_247_1_3: TypeAlias = Asterix_63

# Manifest

manifest = {
    'CATS': {
        1: {
            '1.2': Cat_001_1_2,
            '1.3': Cat_001_1_3,
            '1.4': Cat_001_1_4,
        },
        2: {
            '1.0': Cat_002_1_0,
            '1.1': Cat_002_1_1,
        },
        4: {
            '1.12': Cat_004_1_12,
        },
        8: {
            '1.2': Cat_008_1_2,
            '1.3': Cat_008_1_3,
        },
        9: {
            '2.1': Cat_009_2_1,
        },
        10: {
            '1.1': Cat_010_1_1,
        },
        11: {
            '1.2': Cat_011_1_2,
            '1.3': Cat_011_1_3,
        },
        15: {
            '1.0': Cat_015_1_0,
            '1.1': Cat_015_1_1,
            '1.2': Cat_015_1_2,
        },
        16: {
            '1.0': Cat_016_1_0,
        },
        17: {
            '1.3': Cat_017_1_3,
        },
        18: {
            '1.7': Cat_018_1_7,
            '1.8': Cat_018_1_8,
        },
        19: {
            '1.3': Cat_019_1_3,
        },
        20: {
            '1.9': Cat_020_1_9,
            '1.10': Cat_020_1_10,
        },
        21: {
            '0.23': Cat_021_0_23,
            '0.24': Cat_021_0_24,
            '0.25': Cat_021_0_25,
            '0.26': Cat_021_0_26,
            '2.1': Cat_021_2_1,
            '2.2': Cat_021_2_2,
            '2.3': Cat_021_2_3,
            '2.4': Cat_021_2_4,
            '2.5': Cat_021_2_5,
            '2.6': Cat_021_2_6,
        },
        23: {
            '1.2': Cat_023_1_2,
            '1.3': Cat_023_1_3,
        },
        25: {
            '1.5': Cat_025_1_5,
        },
        32: {
            '1.1': Cat_032_1_1,
        },
        34: {
            '1.27': Cat_034_1_27,
            '1.28': Cat_034_1_28,
            '1.29': Cat_034_1_29,
        },
        48: {
            '1.27': Cat_048_1_27,
            '1.28': Cat_048_1_28,
            '1.29': Cat_048_1_29,
            '1.30': Cat_048_1_30,
            '1.31': Cat_048_1_31,
            '1.32': Cat_048_1_32,
        },
        62: {
            '1.17': Cat_062_1_17,
            '1.18': Cat_062_1_18,
            '1.19': Cat_062_1_19,
            '1.20': Cat_062_1_20,
        },
        63: {
            '1.6': Cat_063_1_6,
        },
        65: {
            '1.4': Cat_065_1_4,
            '1.5': Cat_065_1_5,
            '1.6': Cat_065_1_6,
        },
        150: {
            '3.0': Cat_150_3_0,
        },
        205: {
            '1.0': Cat_205_1_0,
        },
        240: {
            '1.3': Cat_240_1_3,
        },
        247: {
            '1.2': Cat_247_1_2,
            '1.3': Cat_247_1_3,
        },
    },
    'REFS': {
        21: {
            '1.4': Ref_021_1_4,
            '1.5': Ref_021_1_5,
        },
        48: {
            '1.11': Ref_048_1_11,
            '1.12': Ref_048_1_12,
        },
        62: {
            '1.2': Ref_062_1_2,
            '1.3': Ref_062_1_3,
        },
    },
}
